function timezone_transitions_get(dtzObj, begin, end) {
  // http://kevin.vanzonneveld.net
  // +   original by: Brett Zamir (http://brett-zamir.me)
  // *     example 1: var list = timezone_transitions_get(timezone_open('Africa/Accra')); // See timezone_open()
  // *     example 1: list[1].abbr;
  // *     return 1: 'GHST'
  var obj = {
    'Africa/Abidjan':
        {
          0:
              {
                'ts': -1830383032,
                'time': '1912-01-01T00:16:08+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Accra':
        {
          0:
              {
                'ts': -1640995148,
                'time': '1918-01-01T00:00:52+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          1:
              {
                'ts': -1051920000,
                'time': '1936-09-01T00:00:00+0000',
                'offset': 1200,
                'isdst': true,
                'abbr': 'GHST'
              },
          2:
              {
                'ts': -1041466800,
                'time': '1936-12-30T23:40:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          3:
              {
                'ts': -1020384000,
                'time': '1937-09-01T00:00:00+0000',
                'offset': 1200,
                'isdst': true,
                'abbr': 'GHST'
              },
          4:
              {
                'ts': -1009930800,
                'time': '1937-12-30T23:40:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          5:
              {
                'ts': -988848000,
                'time': '1938-09-01T00:00:00+0000',
                'offset': 1200,
                'isdst': true,
                'abbr': 'GHST'
              },
          6:
              {
                'ts': -978394800,
                'time': '1938-12-30T23:40:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          7:
              {
                'ts': -957312000,
                'time': '1939-09-01T00:00:00+0000',
                'offset': 1200,
                'isdst': true,
                'abbr': 'GHST'
              },
          8:
              {
                'ts': -946858800,
                'time': '1939-12-30T23:40:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          9:
              {
                'ts': -925689600,
                'time': '1940-09-01T00:00:00+0000',
                'offset': 1200,
                'isdst': true,
                'abbr': 'GHST'
              },
          10:
              {
                'ts': -915236400,
                'time': '1940-12-30T23:40:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          11:
              {
                'ts': -894153600,
                'time': '1941-09-01T00:00:00+0000',
                'offset': 1200,
                'isdst': true,
                'abbr': 'GHST'
              },
          12:
              {
                'ts': -883700400,
                'time': '1941-12-30T23:40:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          13:
              {
                'ts': -862617600,
                'time': '1942-09-01T00:00:00+0000',
                'offset': 1200,
                'isdst': true,
                'abbr': 'GHST'
              },
          14:
              {
                'ts': -852164400,
                'time': '1942-12-30T23:40:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Addis_Ababa':
        {
          0:
              {
                'ts': -1062210920,
                'time': '1936-05-04T21:24:40+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              }
        },
    'Africa/Algiers':
        {
          0:
              {
                'ts': -1855958961,
                'time': '1911-03-10T23:50:39+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          1:
              {
                'ts': -1689814800,
                'time': '1916-06-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          2:
              {
                'ts': -1680397200,
                'time': '1916-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          3:
              {
                'ts': -1665363600,
                'time': '1917-03-24T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          4:
              {
                'ts': -1648342800,
                'time': '1917-10-07T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          5:
              {
                'ts': -1635123600,
                'time': '1918-03-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          6:
              {
                'ts': -1616893200,
                'time': '1918-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          7:
              {
                'ts': -1604278800,
                'time': '1919-03-01T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          8:
              {
                'ts': -1585443600,
                'time': '1919-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          9:
              {
                'ts': -1574038800,
                'time': '1920-02-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          10:
              {
                'ts': -1552266000,
                'time': '1920-10-23T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          11:
              {
                'ts': -1539997200,
                'time': '1921-03-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          12:
              {
                'ts': -1531443600,
                'time': '1921-06-21T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          13:
              {
                'ts': -956365200,
                'time': '1939-09-11T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          14:
              {
                'ts': -950486400,
                'time': '1939-11-19T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          15:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          17:
              {
                'ts': -796262400,
                'time': '1944-10-08T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': -766630800,
                'time': '1945-09-15T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          20:
              {
                'ts': -733280400,
                'time': '1946-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          21:
              {
                'ts': -439430400,
                'time': '1956-01-29T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': -212029200,
                'time': '1963-04-13T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          23:
              {
                'ts': 41468400,
                'time': '1971-04-25T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          24:
              {
                'ts': 54774000,
                'time': '1971-09-26T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          25:
              {
                'ts': 231724800,
                'time': '1977-05-06T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          26:
              {
                'ts': 246236400,
                'time': '1977-10-20T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 259545600,
                'time': '1978-03-24T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 275274000,
                'time': '1978-09-22T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 309740400,
                'time': '1979-10-25T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          30:
              {
                'ts': 325468800,
                'time': '1980-04-25T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          31:
              {
                'ts': 341802000,
                'time': '1980-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          32:
              {
                'ts': 357523200,
                'time': '1981-05-01T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Africa/Asmara':
        {
          0:
              {
                'ts': -1062210920,
                'time': '1936-05-04T21:24:40+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              }
        },
    'Africa/Asmera':
        {
          0:
              {
                'ts': -1062210920,
                'time': '1936-05-04T21:24:40+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              }
        },
    'Africa/Bamako':
        {
          0:
              {
                'ts': -1830382080,
                'time': '1912-01-01T00:32:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          1:
              {
                'ts': -1131235200,
                'time': '1934-02-26T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          2:
              {
                'ts': -300841200,
                'time': '1960-06-20T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Bangui':
        {
          0:
              {
                'ts': -1830388460,
                'time': '1911-12-31T22:45:40+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              }
        },
    'Africa/Banjul':
        {
          0:
              {
                'ts': -1830380004,
                'time': '1912-01-01T01:06:36+0000',
                'offset': -3996,
                'isdst': false,
                'abbr': 'BMT'
              },
          1:
              {
                'ts': -1104533604,
                'time': '1935-01-01T01:06:36+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          2:
              {
                'ts': -189385200,
                'time': '1964-01-01T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Bissau':
        {
          0:
              {
                'ts': -1849388260,
                'time': '1911-05-26T01:02:20+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          1:
              {
                'ts': 157770000,
                'time': '1975-01-01T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Blantyre':
        {
          0:
              {
                'ts': -2109291600,
                'time': '1903-02-28T21:40:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              }
        },
    'Africa/Brazzaville':
        {
          0:
              {
                'ts': -1830387668,
                'time': '1911-12-31T22:58:52+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              }
        },
    'Africa/Bujumbura':
        {
        },
    'Africa/Cairo':
        {
          0:
              {
                'ts': -929844000,
                'time': '1940-07-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          1:
              {
                'ts': -923108400,
                'time': '1940-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          2:
              {
                'ts': -906170400,
                'time': '1941-04-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          3:
              {
                'ts': -892868400,
                'time': '1941-09-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          4:
              {
                'ts': -875844000,
                'time': '1942-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          5:
              {
                'ts': -857790000,
                'time': '1942-10-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          6:
              {
                'ts': -844308000,
                'time': '1943-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          7:
              {
                'ts': -825822000,
                'time': '1943-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          8:
              {
                'ts': -812685600,
                'time': '1944-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          9:
              {
                'ts': -794199600,
                'time': '1944-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          10:
              {
                'ts': -779853600,
                'time': '1945-04-15T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          11:
              {
                'ts': -762663600,
                'time': '1945-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          12:
              {
                'ts': -399088800,
                'time': '1957-05-09T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          13:
              {
                'ts': -386650800,
                'time': '1957-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          14:
              {
                'ts': -368330400,
                'time': '1958-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          15:
              {
                'ts': -355114800,
                'time': '1958-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          16:
              {
                'ts': -336790800,
                'time': '1959-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          17:
              {
                'ts': -323654400,
                'time': '1959-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          18:
              {
                'ts': -305168400,
                'time': '1960-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          19:
              {
                'ts': -292032000,
                'time': '1960-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          20:
              {
                'ts': -273632400,
                'time': '1961-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          21:
              {
                'ts': -260496000,
                'time': '1961-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          22:
              {
                'ts': -242096400,
                'time': '1962-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          23:
              {
                'ts': -228960000,
                'time': '1962-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          24:
              {
                'ts': -210560400,
                'time': '1963-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          25:
              {
                'ts': -197424000,
                'time': '1963-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          26:
              {
                'ts': -178938000,
                'time': '1964-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          27:
              {
                'ts': -165801600,
                'time': '1964-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          28:
              {
                'ts': -147402000,
                'time': '1965-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          29:
              {
                'ts': -134265600,
                'time': '1965-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          30:
              {
                'ts': -115866000,
                'time': '1966-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          31:
              {
                'ts': -102643200,
                'time': '1966-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          32:
              {
                'ts': -84330000,
                'time': '1967-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          33:
              {
                'ts': -71107200,
                'time': '1967-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          34:
              {
                'ts': -52707600,
                'time': '1968-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          35:
              {
                'ts': -39484800,
                'time': '1968-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          36:
              {
                'ts': -21171600,
                'time': '1969-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          37:
              {
                'ts': -7948800,
                'time': '1969-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          38:
              {
                'ts': 10364400,
                'time': '1970-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          39:
              {
                'ts': 23587200,
                'time': '1970-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          40:
              {
                'ts': 41900400,
                'time': '1971-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          41:
              {
                'ts': 55123200,
                'time': '1971-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          42:
              {
                'ts': 73522800,
                'time': '1972-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          43:
              {
                'ts': 86745600,
                'time': '1972-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          44:
              {
                'ts': 105058800,
                'time': '1973-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          45:
              {
                'ts': 118281600,
                'time': '1973-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          46:
              {
                'ts': 136594800,
                'time': '1974-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          47:
              {
                'ts': 149817600,
                'time': '1974-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          48:
              {
                'ts': 168130800,
                'time': '1975-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          49:
              {
                'ts': 181353600,
                'time': '1975-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          50:
              {
                'ts': 199753200,
                'time': '1976-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          51:
              {
                'ts': 212976000,
                'time': '1976-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          52:
              {
                'ts': 231289200,
                'time': '1977-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          53:
              {
                'ts': 244512000,
                'time': '1977-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          54:
              {
                'ts': 262825200,
                'time': '1978-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          55:
              {
                'ts': 276048000,
                'time': '1978-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          56:
              {
                'ts': 294361200,
                'time': '1979-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          57:
              {
                'ts': 307584000,
                'time': '1979-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          58:
              {
                'ts': 325983600,
                'time': '1980-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          59:
              {
                'ts': 339206400,
                'time': '1980-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          60:
              {
                'ts': 357519600,
                'time': '1981-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          61:
              {
                'ts': 370742400,
                'time': '1981-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          62:
              {
                'ts': 396399600,
                'time': '1982-07-24T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          63:
              {
                'ts': 402278400,
                'time': '1982-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          64:
              {
                'ts': 426812400,
                'time': '1983-07-11T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          65:
              {
                'ts': 433814400,
                'time': '1983-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          66:
              {
                'ts': 452214000,
                'time': '1984-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          67:
              {
                'ts': 465436800,
                'time': '1984-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          68:
              {
                'ts': 483750000,
                'time': '1985-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          69:
              {
                'ts': 496972800,
                'time': '1985-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          70:
              {
                'ts': 515286000,
                'time': '1986-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          71:
              {
                'ts': 528508800,
                'time': '1986-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          72:
              {
                'ts': 546822000,
                'time': '1987-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          73:
              {
                'ts': 560044800,
                'time': '1987-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          74:
              {
                'ts': 578444400,
                'time': '1988-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          75:
              {
                'ts': 591667200,
                'time': '1988-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          76:
              {
                'ts': 610412400,
                'time': '1989-05-05T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          77:
              {
                'ts': 623203200,
                'time': '1989-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          78:
              {
                'ts': 641516400,
                'time': '1990-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          79:
              {
                'ts': 654739200,
                'time': '1990-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          80:
              {
                'ts': 673052400,
                'time': '1991-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          81:
              {
                'ts': 686275200,
                'time': '1991-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          82:
              {
                'ts': 704674800,
                'time': '1992-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          83:
              {
                'ts': 717897600,
                'time': '1992-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          84:
              {
                'ts': 736210800,
                'time': '1993-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          85:
              {
                'ts': 749433600,
                'time': '1993-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          86:
              {
                'ts': 767746800,
                'time': '1994-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          87:
              {
                'ts': 780969600,
                'time': '1994-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          88:
              {
                'ts': 799020000,
                'time': '1995-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          89:
              {
                'ts': 812322000,
                'time': '1995-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          90:
              {
                'ts': 830469600,
                'time': '1996-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          91:
              {
                'ts': 843771600,
                'time': '1996-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          92:
              {
                'ts': 861919200,
                'time': '1997-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          93:
              {
                'ts': 875221200,
                'time': '1997-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          94:
              {
                'ts': 893368800,
                'time': '1998-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          95:
              {
                'ts': 906670800,
                'time': '1998-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          96:
              {
                'ts': 925423200,
                'time': '1999-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          97:
              {
                'ts': 938725200,
                'time': '1999-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          98:
              {
                'ts': 956872800,
                'time': '2000-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          99:
              {
                'ts': 970174800,
                'time': '2000-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          100:
              {
                'ts': 988322400,
                'time': '2001-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          101:
              {
                'ts': 1001624400,
                'time': '2001-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          102:
              {
                'ts': 1019772000,
                'time': '2002-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          103:
              {
                'ts': 1033074000,
                'time': '2002-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          104:
              {
                'ts': 1051221600,
                'time': '2003-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          105:
              {
                'ts': 1064523600,
                'time': '2003-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          106:
              {
                'ts': 1083276000,
                'time': '2004-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          107:
              {
                'ts': 1096578000,
                'time': '2004-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          108:
              {
                'ts': 1114725600,
                'time': '2005-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          109:
              {
                'ts': 1128027600,
                'time': '2005-09-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          110:
              {
                'ts': 1146175200,
                'time': '2006-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          111:
              {
                'ts': 1158872400,
                'time': '2006-09-21T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          112:
              {
                'ts': 1177624800,
                'time': '2007-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          113:
              {
                'ts': 1189112400,
                'time': '2007-09-06T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          114:
              {
                'ts': 1209074400,
                'time': '2008-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          115:
              {
                'ts': 1219957200,
                'time': '2008-08-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          116:
              {
                'ts': 1240524000,
                'time': '2009-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          117:
              {
                'ts': 1251406800,
                'time': '2009-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          118:
              {
                'ts': 1272578400,
                'time': '2010-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          119:
              {
                'ts': 1282856400,
                'time': '2010-08-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          120:
              {
                'ts': 1304028000,
                'time': '2011-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          121:
              {
                'ts': 1314306000,
                'time': '2011-08-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          122:
              {
                'ts': 1335477600,
                'time': '2012-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          123:
              {
                'ts': 1346360400,
                'time': '2012-08-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          124:
              {
                'ts': 1366927200,
                'time': '2013-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          125:
              {
                'ts': 1377810000,
                'time': '2013-08-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          126:
              {
                'ts': 1398376800,
                'time': '2014-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          127:
              {
                'ts': 1409259600,
                'time': '2014-08-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          128:
              {
                'ts': 1429826400,
                'time': '2015-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          129:
              {
                'ts': 1440709200,
                'time': '2015-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          130:
              {
                'ts': 1461880800,
                'time': '2016-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          131:
              {
                'ts': 1472158800,
                'time': '2016-08-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          132:
              {
                'ts': 1493330400,
                'time': '2017-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          133:
              {
                'ts': 1504213200,
                'time': '2017-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          134:
              {
                'ts': 1524780000,
                'time': '2018-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          135:
              {
                'ts': 1535662800,
                'time': '2018-08-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          136:
              {
                'ts': 1556229600,
                'time': '2019-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          137:
              {
                'ts': 1567112400,
                'time': '2019-08-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          138:
              {
                'ts': 1587679200,
                'time': '2020-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          139:
              {
                'ts': 1598562000,
                'time': '2020-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          140:
              {
                'ts': 1619733600,
                'time': '2021-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          141:
              {
                'ts': 1630011600,
                'time': '2021-08-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          142:
              {
                'ts': 1651183200,
                'time': '2022-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          143:
              {
                'ts': 1661461200,
                'time': '2022-08-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          144:
              {
                'ts': 1682632800,
                'time': '2023-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          145:
              {
                'ts': 1693515600,
                'time': '2023-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          146:
              {
                'ts': 1714082400,
                'time': '2024-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          147:
              {
                'ts': 1724965200,
                'time': '2024-08-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          148:
              {
                'ts': 1745532000,
                'time': '2025-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          149:
              {
                'ts': 1756414800,
                'time': '2025-08-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          150:
              {
                'ts': 1776981600,
                'time': '2026-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          151:
              {
                'ts': 1787864400,
                'time': '2026-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          152:
              {
                'ts': 1809036000,
                'time': '2027-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          153:
              {
                'ts': 1819314000,
                'time': '2027-08-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          154:
              {
                'ts': 1840485600,
                'time': '2028-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          155:
              {
                'ts': 1851368400,
                'time': '2028-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          156:
              {
                'ts': 1871935200,
                'time': '2029-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          157:
              {
                'ts': 1882818000,
                'time': '2029-08-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          158:
              {
                'ts': 1903384800,
                'time': '2030-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          159:
              {
                'ts': 1914267600,
                'time': '2030-08-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          160:
              {
                'ts': 1934834400,
                'time': '2031-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          161:
              {
                'ts': 1945717200,
                'time': '2031-08-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          162:
              {
                'ts': 1966888800,
                'time': '2032-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          163:
              {
                'ts': 1977166800,
                'time': '2032-08-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          164:
              {
                'ts': 1998338400,
                'time': '2033-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          165:
              {
                'ts': 2008616400,
                'time': '2033-08-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          166:
              {
                'ts': 2029788000,
                'time': '2034-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          167:
              {
                'ts': 2040670800,
                'time': '2034-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          168:
              {
                'ts': 2061237600,
                'time': '2035-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          169:
              {
                'ts': 2072120400,
                'time': '2035-08-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          170:
              {
                'ts': 2092687200,
                'time': '2036-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          171:
              {
                'ts': 2103570000,
                'time': '2036-08-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          172:
              {
                'ts': 2124136800,
                'time': '2037-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          173:
              {
                'ts': 2135019600,
                'time': '2037-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Africa/Casablanca':
        {
          0:
              {
                'ts': -1773012580,
                'time': '1913-10-26T00:30:20+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          1:
              {
                'ts': -956361600,
                'time': '1939-09-12T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          2:
              {
                'ts': -950490000,
                'time': '1939-11-18T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          3:
              {
                'ts': -942019200,
                'time': '1940-02-25T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          4:
              {
                'ts': -761187600,
                'time': '1945-11-17T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          5:
              {
                'ts': -617241600,
                'time': '1950-06-11T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          6:
              {
                'ts': -605149200,
                'time': '1950-10-28T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          7:
              {
                'ts': -81432000,
                'time': '1967-06-03T12:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          8:
              {
                'ts': -71110800,
                'time': '1967-09-30T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          9:
              {
                'ts': 141264000,
                'time': '1974-06-24T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          10:
              {
                'ts': 147222000,
                'time': '1974-08-31T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          11:
              {
                'ts': 199756800,
                'time': '1976-05-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          12:
              {
                'ts': 207702000,
                'time': '1976-07-31T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          13:
              {
                'ts': 231292800,
                'time': '1977-05-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          14:
              {
                'ts': 244249200,
                'time': '1977-09-27T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          15:
              {
                'ts': 265507200,
                'time': '1978-06-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          16:
              {
                'ts': 271033200,
                'time': '1978-08-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          17:
              {
                'ts': 448243200,
                'time': '1984-03-16T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': 504918000,
                'time': '1985-12-31T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              }
        },
    'Africa/Ceuta':
        {
          0:
              {
                'ts': -1630112400,
                'time': '1918-05-06T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          1:
              {
                'ts': -1616810400,
                'time': '1918-10-07T22:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          2:
              {
                'ts': -1442451600,
                'time': '1924-04-16T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          3:
              {
                'ts': -1427677200,
                'time': '1924-10-04T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          4:
              {
                'ts': -1379293200,
                'time': '1926-04-17T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          5:
              {
                'ts': -1364778000,
                'time': '1926-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          6:
              {
                'ts': -1348448400,
                'time': '1927-04-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          7:
              {
                'ts': -1333328400,
                'time': '1927-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          8:
              {
                'ts': -1316394000,
                'time': '1928-04-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          9:
              {
                'ts': -1301274000,
                'time': '1928-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          10:
              {
                'ts': -1293840000,
                'time': '1929-01-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          11:
              {
                'ts': -81432000,
                'time': '1967-06-03T12:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          12:
              {
                'ts': -71110800,
                'time': '1967-09-30T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          13:
              {
                'ts': 141264000,
                'time': '1974-06-24T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          14:
              {
                'ts': 147222000,
                'time': '1974-08-31T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          15:
              {
                'ts': 199756800,
                'time': '1976-05-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          16:
              {
                'ts': 207702000,
                'time': '1976-07-31T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          17:
              {
                'ts': 231292800,
                'time': '1977-05-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          18:
              {
                'ts': 244249200,
                'time': '1977-09-27T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          19:
              {
                'ts': 265507200,
                'time': '1978-06-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          20:
              {
                'ts': 271033200,
                'time': '1978-08-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          21:
              {
                'ts': 448243200,
                'time': '1984-03-16T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          23:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          24:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          25:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          26:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          27:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          28:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          29:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          30:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          31:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          32:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          33:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          34:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          35:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          36:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          37:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          38:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          39:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          40:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          41:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          42:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          43:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          44:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          45:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          46:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          47:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          48:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          49:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          50:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          51:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          52:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          53:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          56:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          57:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          67:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          68:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          69:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          70:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          71:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          72:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          73:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          74:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          75:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          76:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          77:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          78:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          79:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          80:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          81:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          82:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          83:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          84:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          85:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          86:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          87:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          88:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          89:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          90:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          91:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          92:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          93:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          94:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          95:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          96:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          97:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          99:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          100:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          101:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          102:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          103:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          104:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          105:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          106:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          107:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          108:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          109:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          110:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          111:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          112:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          113:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          114:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          115:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          116:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          117:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          118:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          119:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          120:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          121:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          122:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          123:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          124:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          125:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Africa/Conakry':
        {
          0:
              {
                'ts': -1830380708,
                'time': '1912-01-01T00:54:52+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          1:
              {
                'ts': -1131235200,
                'time': '1934-02-26T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          2:
              {
                'ts': -315615600,
                'time': '1960-01-01T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Dakar':
        {
          0:
              {
                'ts': -1830379816,
                'time': '1912-01-01T01:09:44+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          1:
              {
                'ts': -902098800,
                'time': '1941-06-01T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Dar_es_Salaam':
        {
          0:
              {
                'ts': -1230777428,
                'time': '1930-12-31T21:22:52+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              },
          1:
              {
                'ts': -694321200,
                'time': '1947-12-31T21:00:00+0000',
                'offset': 9885,
                'isdst': false,
                'abbr': 'BEAUT'
              },
          2:
              {
                'ts': -284006685,
                'time': '1960-12-31T21:15:15+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              }
        },
    'Africa/Djibouti':
        {
          0:
              {
                'ts': -1846291956,
                'time': '1911-06-30T21:07:24+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              }
        },
    'Africa/Douala':
        {
          0:
              {
                'ts': -1830386328,
                'time': '1911-12-31T23:21:12+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              }
        },
    'Africa/El_Aaiun':
        {
          0:
              {
                'ts': -1136070432,
                'time': '1934-01-01T00:52:48+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          1:
              {
                'ts': 198291600,
                'time': '1976-04-14T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              }
        },
    'Africa/Freetown':
        {
          0:
              {
                'ts': -1785712020,
                'time': '1913-06-01T00:53:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          1:
              {
                'ts': -1091487600,
                'time': '1935-06-01T01:00:00+0000',
                'offset': -1200,
                'isdst': true,
                'abbr': 'SLST'
              },
          2:
              {
                'ts': -1080949200,
                'time': '1935-10-01T00:20:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          3:
              {
                'ts': -1059865200,
                'time': '1936-06-01T01:00:00+0000',
                'offset': -1200,
                'isdst': true,
                'abbr': 'SLST'
              },
          4:
              {
                'ts': -1049326800,
                'time': '1936-10-01T00:20:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          5:
              {
                'ts': -1028329200,
                'time': '1937-06-01T01:00:00+0000',
                'offset': -1200,
                'isdst': true,
                'abbr': 'SLST'
              },
          6:
              {
                'ts': -1017790800,
                'time': '1937-10-01T00:20:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          7:
              {
                'ts': -996793200,
                'time': '1938-06-01T01:00:00+0000',
                'offset': -1200,
                'isdst': true,
                'abbr': 'SLST'
              },
          8:
              {
                'ts': -986254800,
                'time': '1938-10-01T00:20:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          9:
              {
                'ts': -965257200,
                'time': '1939-06-01T01:00:00+0000',
                'offset': -1200,
                'isdst': true,
                'abbr': 'SLST'
              },
          10:
              {
                'ts': -954718800,
                'time': '1939-10-01T00:20:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          11:
              {
                'ts': -933634800,
                'time': '1940-06-01T01:00:00+0000',
                'offset': -1200,
                'isdst': true,
                'abbr': 'SLST'
              },
          12:
              {
                'ts': -923096400,
                'time': '1940-10-01T00:20:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          13:
              {
                'ts': -902098800,
                'time': '1941-06-01T01:00:00+0000',
                'offset': -1200,
                'isdst': true,
                'abbr': 'SLST'
              },
          14:
              {
                'ts': -891560400,
                'time': '1941-10-01T00:20:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          15:
              {
                'ts': -870562800,
                'time': '1942-06-01T01:00:00+0000',
                'offset': -1200,
                'isdst': true,
                'abbr': 'SLST'
              },
          16:
              {
                'ts': -860024400,
                'time': '1942-10-01T00:20:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          17:
              {
                'ts': -410223600,
                'time': '1957-01-01T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WAT'
              },
          18:
              {
                'ts': -397180800,
                'time': '1957-06-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'SLST'
              },
          19:
              {
                'ts': -389235600,
                'time': '1957-08-31T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          20:
              {
                'ts': -365644800,
                'time': '1958-06-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'SLST'
              },
          21:
              {
                'ts': -357699600,
                'time': '1958-08-31T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          22:
              {
                'ts': -334108800,
                'time': '1959-06-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'SLST'
              },
          23:
              {
                'ts': -326163600,
                'time': '1959-08-31T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          24:
              {
                'ts': -302486400,
                'time': '1960-06-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'SLST'
              },
          25:
              {
                'ts': -294541200,
                'time': '1960-08-31T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          26:
              {
                'ts': -270950400,
                'time': '1961-06-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'SLST'
              },
          27:
              {
                'ts': -263005200,
                'time': '1961-08-31T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          28:
              {
                'ts': -239414400,
                'time': '1962-06-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'SLST'
              },
          29:
              {
                'ts': -231469200,
                'time': '1962-08-31T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Gaborone':
        {
          0:
              {
                'ts': -829526400,
                'time': '1943-09-19T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          1:
              {
                'ts': -813805200,
                'time': '1944-03-18T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              }
        },
    'Africa/Harare':
        {
          0:
              {
                'ts': -2109290652,
                'time': '1903-02-28T21:55:48+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              }
        },
    'Africa/Johannesburg':
        {
          0:
              {
                'ts': -2109288600,
                'time': '1903-02-28T22:30:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'SAST'
              },
          1:
              {
                'ts': -860976000,
                'time': '1942-09-20T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'SAST'
              },
          2:
              {
                'ts': -845254800,
                'time': '1943-03-20T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'SAST'
              },
          3:
              {
                'ts': -829526400,
                'time': '1943-09-19T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'SAST'
              },
          4:
              {
                'ts': -813805200,
                'time': '1944-03-18T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'SAST'
              }
        },
    'Africa/Kampala':
        {
          0:
              {
                'ts': -1309745380,
                'time': '1928-06-30T21:50:20+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              },
          1:
              {
                'ts': -1262314800,
                'time': '1929-12-31T21:00:00+0000',
                'offset': 9000,
                'isdst': false,
                'abbr': 'BEAT'
              },
          2:
              {
                'ts': -694319400,
                'time': '1947-12-31T21:30:00+0000',
                'offset': 9885,
                'isdst': false,
                'abbr': 'BEAUT'
              },
          3:
              {
                'ts': -410237085,
                'time': '1956-12-31T21:15:15+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              }
        },
    'Africa/Khartoum':
        {
          0:
              {
                'ts': -1230775808,
                'time': '1930-12-31T21:49:52+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          1:
              {
                'ts': 10360800,
                'time': '1970-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          2:
              {
                'ts': 24786000,
                'time': '1970-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          3:
              {
                'ts': 41810400,
                'time': '1971-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          4:
              {
                'ts': 56322000,
                'time': '1971-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          5:
              {
                'ts': 73432800,
                'time': '1972-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          6:
              {
                'ts': 87944400,
                'time': '1972-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          7:
              {
                'ts': 104882400,
                'time': '1973-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          8:
              {
                'ts': 119480400,
                'time': '1973-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          9:
              {
                'ts': 136332000,
                'time': '1974-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          10:
              {
                'ts': 151016400,
                'time': '1974-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          11:
              {
                'ts': 167781600,
                'time': '1975-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          12:
              {
                'ts': 182552400,
                'time': '1975-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          13:
              {
                'ts': 199231200,
                'time': '1976-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          14:
              {
                'ts': 214174800,
                'time': '1976-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          15:
              {
                'ts': 230680800,
                'time': '1977-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          16:
              {
                'ts': 245710800,
                'time': '1977-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          17:
              {
                'ts': 262735200,
                'time': '1978-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          18:
              {
                'ts': 277246800,
                'time': '1978-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          19:
              {
                'ts': 294184800,
                'time': '1979-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          20:
              {
                'ts': 308782800,
                'time': '1979-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          21:
              {
                'ts': 325634400,
                'time': '1980-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          22:
              {
                'ts': 340405200,
                'time': '1980-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          23:
              {
                'ts': 357084000,
                'time': '1981-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          24:
              {
                'ts': 371941200,
                'time': '1981-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          25:
              {
                'ts': 388533600,
                'time': '1982-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          26:
              {
                'ts': 403477200,
                'time': '1982-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          27:
              {
                'ts': 419983200,
                'time': '1983-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          28:
              {
                'ts': 435013200,
                'time': '1983-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          29:
              {
                'ts': 452037600,
                'time': '1984-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          30:
              {
                'ts': 466635600,
                'time': '1984-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          31:
              {
                'ts': 483487200,
                'time': '1985-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CAST'
              },
          32:
              {
                'ts': 498171600,
                'time': '1985-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          33:
              {
                'ts': 947930400,
                'time': '2000-01-15T10:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              }
        },
    'Africa/Kigali':
        {
          0:
              {
                'ts': -1091498416,
                'time': '1935-05-31T21:59:44+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              }
        },
    'Africa/Kinshasa':
        {
        },
    'Africa/Lagos':
        {
          0:
              {
                'ts': -1588464816,
                'time': '1919-08-31T23:46:24+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              }
        },
    'Africa/Libreville':
        {
          0:
              {
                'ts': -1830386268,
                'time': '1911-12-31T23:22:12+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              }
        },
    'Africa/Lome':
        {
        },
    'Africa/Luanda':
        {
          0:
              {
                'ts': -1849395124,
                'time': '1911-05-25T23:07:56+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              }
        },
    'Africa/Lubumbashi':
        {
        },
    'Africa/Lusaka':
        {
          0:
              {
                'ts': -2109289988,
                'time': '1903-02-28T22:06:52+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              }
        },
    'Africa/Malabo':
        {
          0:
              {
                'ts': -1830386108,
                'time': '1911-12-31T23:24:52+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          1:
              {
                'ts': -190857600,
                'time': '1963-12-15T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              }
        },
    'Africa/Maputo':
        {
          0:
              {
                'ts': -2109291020,
                'time': '1903-02-28T21:49:40+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              }
        },
    'Africa/Maseru':
        {
          0:
              {
                'ts': -2109289800,
                'time': '1903-02-28T22:10:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'SAST'
              },
          1:
              {
                'ts': -829526400,
                'time': '1943-09-19T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'SAST'
              },
          2:
              {
                'ts': -813805200,
                'time': '1944-03-18T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'SAST'
              }
        },
    'Africa/Mbabane':
        {
          0:
              {
                'ts': -2109290664,
                'time': '1903-02-28T21:55:36+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'SAST'
              }
        },
    'Africa/Mogadishu':
        {
          0:
              {
                'ts': -1230778800,
                'time': '1930-12-31T21:00:00+0000',
                'offset': 9000,
                'isdst': false,
                'abbr': 'BEAT'
              },
          1:
              {
                'ts': -410236200,
                'time': '1956-12-31T21:30:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              }
        },
    'Africa/Monrovia':
        {
          0:
              {
                'ts': -1604359012,
                'time': '1919-03-01T00:43:08+0000',
                'offset': -2670,
                'isdst': false,
                'abbr': 'LRT'
              },
          1:
              {
                'ts': 73529070,
                'time': '1972-05-01T00:44:30+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Nairobi':
        {
          0:
              {
                'ts': -1309746436,
                'time': '1928-06-30T21:32:44+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              },
          1:
              {
                'ts': -1262314800,
                'time': '1929-12-31T21:00:00+0000',
                'offset': 9000,
                'isdst': false,
                'abbr': 'BEAT'
              },
          2:
              {
                'ts': -946780200,
                'time': '1939-12-31T21:30:00+0000',
                'offset': 9885,
                'isdst': false,
                'abbr': 'BEAUT'
              },
          3:
              {
                'ts': -315629085,
                'time': '1959-12-31T21:15:15+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              }
        },
    'Africa/Ndjamena':
        {
          0:
              {
                'ts': -1830387612,
                'time': '1911-12-31T22:59:48+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          1:
              {
                'ts': 308703600,
                'time': '1979-10-13T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          2:
              {
                'ts': 321314400,
                'time': '1980-03-07T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              }
        },
    'Africa/Niamey':
        {
          0:
              {
                'ts': -1830384508,
                'time': '1911-12-31T23:51:32+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          1:
              {
                'ts': -1131231600,
                'time': '1934-02-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          2:
              {
                'ts': -315619200,
                'time': '1960-01-01T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              }
        },
    'Africa/Nouakchott':
        {
          0:
              {
                'ts': -1830380172,
                'time': '1912-01-01T01:03:48+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          1:
              {
                'ts': -1131235200,
                'time': '1934-02-26T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          2:
              {
                'ts': -286930800,
                'time': '1960-11-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Ouagadougou':
        {
          0:
              {
                'ts': -1830383636,
                'time': '1912-01-01T00:06:04+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Porto-Novo':
        {
          0:
              {
                'ts': -1830384628,
                'time': '1911-12-31T23:49:32+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          1:
              {
                'ts': -1131235200,
                'time': '1934-02-26T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              }
        },
    'Africa/Sao_Tome':
        {
          0:
              {
                'ts': -1830381808,
                'time': '1912-01-01T00:36:32+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Timbuktu':
        {
          0:
              {
                'ts': -1830382080,
                'time': '1912-01-01T00:32:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          1:
              {
                'ts': -1131235200,
                'time': '1934-02-26T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          2:
              {
                'ts': -300841200,
                'time': '1960-06-20T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Africa/Tripoli':
        {
          0:
              {
                'ts': -1577926364,
                'time': '1919-12-31T23:07:16+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          1:
              {
                'ts': -574902000,
                'time': '1951-10-14T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          2:
              {
                'ts': -568087200,
                'time': '1951-12-31T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          3:
              {
                'ts': -512175600,
                'time': '1953-10-09T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          4:
              {
                'ts': -504928800,
                'time': '1953-12-31T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          5:
              {
                'ts': -449888400,
                'time': '1955-09-29T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          6:
              {
                'ts': -441856800,
                'time': '1955-12-31T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          7:
              {
                'ts': -347158800,
                'time': '1958-12-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          8:
              {
                'ts': 378684000,
                'time': '1981-12-31T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': 386463600,
                'time': '1982-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': 402271200,
                'time': '1982-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': 417999600,
                'time': '1983-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': 433807200,
                'time': '1983-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': 449622000,
                'time': '1984-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': 465429600,
                'time': '1984-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': 481590000,
                'time': '1985-04-05T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': 496965600,
                'time': '1985-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': 512953200,
                'time': '1986-04-03T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': 528674400,
                'time': '1986-10-02T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': 544230000,
                'time': '1987-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': 560037600,
                'time': '1987-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': 575852400,
                'time': '1988-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': 591660000,
                'time': '1988-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 607388400,
                'time': '1989-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 623196000,
                'time': '1989-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 641775600,
                'time': '1990-05-03T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          26:
              {
                'ts': 844034400,
                'time': '1996-09-29T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 860108400,
                'time': '1997-04-03T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 875916000,
                'time': '1997-10-03T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Africa/Tunis':
        {
          0:
              {
                'ts': -1855958961,
                'time': '1911-03-10T23:50:39+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          1:
              {
                'ts': -969242400,
                'time': '1939-04-15T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          2:
              {
                'ts': -950493600,
                'time': '1939-11-18T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          3:
              {
                'ts': -941940000,
                'time': '1940-02-25T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          4:
              {
                'ts': -891136800,
                'time': '1941-10-05T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          5:
              {
                'ts': -877827600,
                'time': '1942-03-08T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          6:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          7:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          8:
              {
                'ts': -842918400,
                'time': '1943-04-17T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': -842223600,
                'time': '1943-04-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': -828230400,
                'time': '1943-10-04T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': -796269600,
                'time': '1944-10-07T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': -766634400,
                'time': '1945-09-15T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': 231202800,
                'time': '1977-04-29T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': 243903600,
                'time': '1977-09-23T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': 262825200,
                'time': '1978-04-30T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': 276044400,
                'time': '1978-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': 581122800,
                'time': '1988-05-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 641516400,
                'time': '1990-04-30T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 654649200,
                'time': '1990-09-29T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 1114902000,
                'time': '2005-04-30T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 1128038400,
                'time': '2005-09-30T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Africa/Windhoek':
        {
          0:
              {
                'ts': -2109288600,
                'time': '1903-02-28T22:30:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'SAST'
              },
          1:
              {
                'ts': -860976000,
                'time': '1942-09-20T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'SAST'
              },
          2:
              {
                'ts': -845254800,
                'time': '1943-03-20T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'SAST'
              },
          3:
              {
                'ts': 637970400,
                'time': '1990-03-20T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CAT'
              },
          4:
              {
                'ts': 765324000,
                'time': '1994-04-02T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          5:
              {
                'ts': 778640400,
                'time': '1994-09-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          6:
              {
                'ts': 796780800,
                'time': '1995-04-02T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          7:
              {
                'ts': 810090000,
                'time': '1995-09-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          8:
              {
                'ts': 828835200,
                'time': '1996-04-07T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          9:
              {
                'ts': 841539600,
                'time': '1996-09-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          10:
              {
                'ts': 860284800,
                'time': '1997-04-06T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          11:
              {
                'ts': 873594000,
                'time': '1997-09-07T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          12:
              {
                'ts': 891734400,
                'time': '1998-04-05T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          13:
              {
                'ts': 905043600,
                'time': '1998-09-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          14:
              {
                'ts': 923184000,
                'time': '1999-04-04T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          15:
              {
                'ts': 936493200,
                'time': '1999-09-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          16:
              {
                'ts': 954633600,
                'time': '2000-04-02T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          17:
              {
                'ts': 967942800,
                'time': '2000-09-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          18:
              {
                'ts': 986083200,
                'time': '2001-04-01T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          19:
              {
                'ts': 999392400,
                'time': '2001-09-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          20:
              {
                'ts': 1018137600,
                'time': '2002-04-07T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          21:
              {
                'ts': 1030842000,
                'time': '2002-09-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          22:
              {
                'ts': 1049587200,
                'time': '2003-04-06T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          23:
              {
                'ts': 1062896400,
                'time': '2003-09-07T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          24:
              {
                'ts': 1081036800,
                'time': '2004-04-04T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          25:
              {
                'ts': 1094346000,
                'time': '2004-09-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          26:
              {
                'ts': 1112486400,
                'time': '2005-04-03T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          27:
              {
                'ts': 1125795600,
                'time': '2005-09-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          28:
              {
                'ts': 1143936000,
                'time': '2006-04-02T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          29:
              {
                'ts': 1157245200,
                'time': '2006-09-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          30:
              {
                'ts': 1175385600,
                'time': '2007-04-01T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          31:
              {
                'ts': 1188694800,
                'time': '2007-09-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          32:
              {
                'ts': 1207440000,
                'time': '2008-04-06T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          33:
              {
                'ts': 1220749200,
                'time': '2008-09-07T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          34:
              {
                'ts': 1238889600,
                'time': '2009-04-05T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          35:
              {
                'ts': 1252198800,
                'time': '2009-09-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          36:
              {
                'ts': 1270339200,
                'time': '2010-04-04T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          37:
              {
                'ts': 1283648400,
                'time': '2010-09-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          38:
              {
                'ts': 1301788800,
                'time': '2011-04-03T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          39:
              {
                'ts': 1315098000,
                'time': '2011-09-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          40:
              {
                'ts': 1333238400,
                'time': '2012-04-01T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          41:
              {
                'ts': 1346547600,
                'time': '2012-09-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          42:
              {
                'ts': 1365292800,
                'time': '2013-04-07T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          43:
              {
                'ts': 1377997200,
                'time': '2013-09-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          44:
              {
                'ts': 1396742400,
                'time': '2014-04-06T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          45:
              {
                'ts': 1410051600,
                'time': '2014-09-07T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          46:
              {
                'ts': 1428192000,
                'time': '2015-04-05T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          47:
              {
                'ts': 1441501200,
                'time': '2015-09-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          48:
              {
                'ts': 1459641600,
                'time': '2016-04-03T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          49:
              {
                'ts': 1472950800,
                'time': '2016-09-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          50:
              {
                'ts': 1491091200,
                'time': '2017-04-02T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          51:
              {
                'ts': 1504400400,
                'time': '2017-09-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          52:
              {
                'ts': 1522540800,
                'time': '2018-04-01T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          53:
              {
                'ts': 1535850000,
                'time': '2018-09-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          54:
              {
                'ts': 1554595200,
                'time': '2019-04-07T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          55:
              {
                'ts': 1567299600,
                'time': '2019-09-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          56:
              {
                'ts': 1586044800,
                'time': '2020-04-05T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          57:
              {
                'ts': 1599354000,
                'time': '2020-09-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          58:
              {
                'ts': 1617494400,
                'time': '2021-04-04T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          59:
              {
                'ts': 1630803600,
                'time': '2021-09-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          60:
              {
                'ts': 1648944000,
                'time': '2022-04-03T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          61:
              {
                'ts': 1662253200,
                'time': '2022-09-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          62:
              {
                'ts': 1680393600,
                'time': '2023-04-02T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          63:
              {
                'ts': 1693702800,
                'time': '2023-09-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          64:
              {
                'ts': 1712448000,
                'time': '2024-04-07T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          65:
              {
                'ts': 1725152400,
                'time': '2024-09-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          66:
              {
                'ts': 1743897600,
                'time': '2025-04-06T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          67:
              {
                'ts': 1757206800,
                'time': '2025-09-07T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          68:
              {
                'ts': 1775347200,
                'time': '2026-04-05T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          69:
              {
                'ts': 1788656400,
                'time': '2026-09-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          70:
              {
                'ts': 1806796800,
                'time': '2027-04-04T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          71:
              {
                'ts': 1820106000,
                'time': '2027-09-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          72:
              {
                'ts': 1838246400,
                'time': '2028-04-02T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          73:
              {
                'ts': 1851555600,
                'time': '2028-09-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          74:
              {
                'ts': 1869696000,
                'time': '2029-04-01T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          75:
              {
                'ts': 1883005200,
                'time': '2029-09-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          76:
              {
                'ts': 1901750400,
                'time': '2030-04-07T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          77:
              {
                'ts': 1914454800,
                'time': '2030-09-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          78:
              {
                'ts': 1933200000,
                'time': '2031-04-06T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          79:
              {
                'ts': 1946509200,
                'time': '2031-09-07T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          80:
              {
                'ts': 1964649600,
                'time': '2032-04-04T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          81:
              {
                'ts': 1977958800,
                'time': '2032-09-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          82:
              {
                'ts': 1996099200,
                'time': '2033-04-03T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          83:
              {
                'ts': 2009408400,
                'time': '2033-09-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          84:
              {
                'ts': 2027548800,
                'time': '2034-04-02T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          85:
              {
                'ts': 2040858000,
                'time': '2034-09-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          86:
              {
                'ts': 2058998400,
                'time': '2035-04-01T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          87:
              {
                'ts': 2072307600,
                'time': '2035-09-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          88:
              {
                'ts': 2091052800,
                'time': '2036-04-06T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          89:
              {
                'ts': 2104362000,
                'time': '2036-09-07T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              },
          90:
              {
                'ts': 2122502400,
                'time': '2037-04-05T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WAT'
              },
          91:
              {
                'ts': 2135811600,
                'time': '2037-09-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WAST'
              }
        },
    'America/Adak':
        {
          0:
              {
                'ts': -880196400,
                'time': '1942-02-09T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'NWT'
              },
          1:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'NPT'
              },
          2:
              {
                'ts': -765374400,
                'time': '1945-09-30T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'NST'
              },
          3:
              {
                'ts': -86878800,
                'time': '1967-04-01T11:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          4:
              {
                'ts': -21466800,
                'time': '1969-04-27T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          5:
              {
                'ts': -5745600,
                'time': '1969-10-26T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          6:
              {
                'ts': 9982800,
                'time': '1970-04-26T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          7:
              {
                'ts': 25704000,
                'time': '1970-10-25T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          8:
              {
                'ts': 41432400,
                'time': '1971-04-25T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          9:
              {
                'ts': 57758400,
                'time': '1971-10-31T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          10:
              {
                'ts': 73486800,
                'time': '1972-04-30T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          11:
              {
                'ts': 89208000,
                'time': '1972-10-29T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          12:
              {
                'ts': 104936400,
                'time': '1973-04-29T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          13:
              {
                'ts': 120657600,
                'time': '1973-10-28T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          14:
              {
                'ts': 126709200,
                'time': '1974-01-06T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          15:
              {
                'ts': 152107200,
                'time': '1974-10-27T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          16:
              {
                'ts': 162392400,
                'time': '1975-02-23T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          17:
              {
                'ts': 183556800,
                'time': '1975-10-26T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          18:
              {
                'ts': 199285200,
                'time': '1976-04-25T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          19:
              {
                'ts': 215611200,
                'time': '1976-10-31T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          20:
              {
                'ts': 230734800,
                'time': '1977-04-24T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          21:
              {
                'ts': 247060800,
                'time': '1977-10-30T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          22:
              {
                'ts': 262789200,
                'time': '1978-04-30T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          23:
              {
                'ts': 278510400,
                'time': '1978-10-29T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          24:
              {
                'ts': 294238800,
                'time': '1979-04-29T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          25:
              {
                'ts': 309960000,
                'time': '1979-10-28T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          26:
              {
                'ts': 325688400,
                'time': '1980-04-27T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          27:
              {
                'ts': 341409600,
                'time': '1980-10-26T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          28:
              {
                'ts': 357138000,
                'time': '1981-04-26T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          29:
              {
                'ts': 372859200,
                'time': '1981-10-25T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          30:
              {
                'ts': 388587600,
                'time': '1982-04-25T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          31:
              {
                'ts': 404913600,
                'time': '1982-10-31T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          32:
              {
                'ts': 420037200,
                'time': '1983-04-24T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          33:
              {
                'ts': 436363200,
                'time': '1983-10-30T12:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          34:
              {
                'ts': 439034400,
                'time': '1983-11-30T10:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          35:
              {
                'ts': 452088000,
                'time': '1984-04-29T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          36:
              {
                'ts': 467809200,
                'time': '1984-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          37:
              {
                'ts': 483537600,
                'time': '1985-04-28T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          38:
              {
                'ts': 499258800,
                'time': '1985-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          39:
              {
                'ts': 514987200,
                'time': '1986-04-27T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          40:
              {
                'ts': 530708400,
                'time': '1986-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          41:
              {
                'ts': 544622400,
                'time': '1987-04-05T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          42:
              {
                'ts': 562158000,
                'time': '1987-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          43:
              {
                'ts': 576072000,
                'time': '1988-04-03T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          44:
              {
                'ts': 594212400,
                'time': '1988-10-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          45:
              {
                'ts': 607521600,
                'time': '1989-04-02T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          46:
              {
                'ts': 625662000,
                'time': '1989-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          47:
              {
                'ts': 638971200,
                'time': '1990-04-01T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          48:
              {
                'ts': 657111600,
                'time': '1990-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          49:
              {
                'ts': 671025600,
                'time': '1991-04-07T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          50:
              {
                'ts': 688561200,
                'time': '1991-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          51:
              {
                'ts': 702475200,
                'time': '1992-04-05T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          52:
              {
                'ts': 720010800,
                'time': '1992-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          53:
              {
                'ts': 733924800,
                'time': '1993-04-04T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          54:
              {
                'ts': 752065200,
                'time': '1993-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          55:
              {
                'ts': 765374400,
                'time': '1994-04-03T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          56:
              {
                'ts': 783514800,
                'time': '1994-10-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          57:
              {
                'ts': 796824000,
                'time': '1995-04-02T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          58:
              {
                'ts': 814964400,
                'time': '1995-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          59:
              {
                'ts': 828878400,
                'time': '1996-04-07T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          60:
              {
                'ts': 846414000,
                'time': '1996-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          61:
              {
                'ts': 860328000,
                'time': '1997-04-06T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          62:
              {
                'ts': 877863600,
                'time': '1997-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          63:
              {
                'ts': 891777600,
                'time': '1998-04-05T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          64:
              {
                'ts': 909313200,
                'time': '1998-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          65:
              {
                'ts': 923227200,
                'time': '1999-04-04T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          66:
              {
                'ts': 941367600,
                'time': '1999-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          67:
              {
                'ts': 954676800,
                'time': '2000-04-02T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          68:
              {
                'ts': 972817200,
                'time': '2000-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          69:
              {
                'ts': 986126400,
                'time': '2001-04-01T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          70:
              {
                'ts': 1004266800,
                'time': '2001-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          71:
              {
                'ts': 1018180800,
                'time': '2002-04-07T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          72:
              {
                'ts': 1035716400,
                'time': '2002-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          73:
              {
                'ts': 1049630400,
                'time': '2003-04-06T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          74:
              {
                'ts': 1067166000,
                'time': '2003-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          75:
              {
                'ts': 1081080000,
                'time': '2004-04-04T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          76:
              {
                'ts': 1099220400,
                'time': '2004-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          77:
              {
                'ts': 1112529600,
                'time': '2005-04-03T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          78:
              {
                'ts': 1130670000,
                'time': '2005-10-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          79:
              {
                'ts': 1143979200,
                'time': '2006-04-02T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          80:
              {
                'ts': 1162119600,
                'time': '2006-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          81:
              {
                'ts': 1173614400,
                'time': '2007-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          82:
              {
                'ts': 1194174000,
                'time': '2007-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          83:
              {
                'ts': 1205064000,
                'time': '2008-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          84:
              {
                'ts': 1225623600,
                'time': '2008-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          85:
              {
                'ts': 1236513600,
                'time': '2009-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          86:
              {
                'ts': 1257073200,
                'time': '2009-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          87:
              {
                'ts': 1268568000,
                'time': '2010-03-14T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          88:
              {
                'ts': 1289127600,
                'time': '2010-11-07T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          89:
              {
                'ts': 1300017600,
                'time': '2011-03-13T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          90:
              {
                'ts': 1320577200,
                'time': '2011-11-06T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          91:
              {
                'ts': 1331467200,
                'time': '2012-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          92:
              {
                'ts': 1352026800,
                'time': '2012-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          93:
              {
                'ts': 1362916800,
                'time': '2013-03-10T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          94:
              {
                'ts': 1383476400,
                'time': '2013-11-03T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          95:
              {
                'ts': 1394366400,
                'time': '2014-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          96:
              {
                'ts': 1414926000,
                'time': '2014-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          97:
              {
                'ts': 1425816000,
                'time': '2015-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          98:
              {
                'ts': 1446375600,
                'time': '2015-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          99:
              {
                'ts': 1457870400,
                'time': '2016-03-13T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          100:
              {
                'ts': 1478430000,
                'time': '2016-11-06T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          101:
              {
                'ts': 1489320000,
                'time': '2017-03-12T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          102:
              {
                'ts': 1509879600,
                'time': '2017-11-05T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          103:
              {
                'ts': 1520769600,
                'time': '2018-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          104:
              {
                'ts': 1541329200,
                'time': '2018-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          105:
              {
                'ts': 1552219200,
                'time': '2019-03-10T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          106:
              {
                'ts': 1572778800,
                'time': '2019-11-03T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          107:
              {
                'ts': 1583668800,
                'time': '2020-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          108:
              {
                'ts': 1604228400,
                'time': '2020-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          109:
              {
                'ts': 1615723200,
                'time': '2021-03-14T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          110:
              {
                'ts': 1636282800,
                'time': '2021-11-07T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          111:
              {
                'ts': 1647172800,
                'time': '2022-03-13T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          112:
              {
                'ts': 1667732400,
                'time': '2022-11-06T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          113:
              {
                'ts': 1678622400,
                'time': '2023-03-12T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          114:
              {
                'ts': 1699182000,
                'time': '2023-11-05T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          115:
              {
                'ts': 1710072000,
                'time': '2024-03-10T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          116:
              {
                'ts': 1730631600,
                'time': '2024-11-03T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          117:
              {
                'ts': 1741521600,
                'time': '2025-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          118:
              {
                'ts': 1762081200,
                'time': '2025-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          119:
              {
                'ts': 1772971200,
                'time': '2026-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          120:
              {
                'ts': 1793530800,
                'time': '2026-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          121:
              {
                'ts': 1805025600,
                'time': '2027-03-14T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          122:
              {
                'ts': 1825585200,
                'time': '2027-11-07T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          123:
              {
                'ts': 1836475200,
                'time': '2028-03-12T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          124:
              {
                'ts': 1857034800,
                'time': '2028-11-05T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          125:
              {
                'ts': 1867924800,
                'time': '2029-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          126:
              {
                'ts': 1888484400,
                'time': '2029-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          127:
              {
                'ts': 1899374400,
                'time': '2030-03-10T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          128:
              {
                'ts': 1919934000,
                'time': '2030-11-03T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          129:
              {
                'ts': 1930824000,
                'time': '2031-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          130:
              {
                'ts': 1951383600,
                'time': '2031-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          131:
              {
                'ts': 1962878400,
                'time': '2032-03-14T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          132:
              {
                'ts': 1983438000,
                'time': '2032-11-07T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          133:
              {
                'ts': 1994328000,
                'time': '2033-03-13T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          134:
              {
                'ts': 2014887600,
                'time': '2033-11-06T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          135:
              {
                'ts': 2025777600,
                'time': '2034-03-12T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          136:
              {
                'ts': 2046337200,
                'time': '2034-11-05T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          137:
              {
                'ts': 2057227200,
                'time': '2035-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          138:
              {
                'ts': 2077786800,
                'time': '2035-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          139:
              {
                'ts': 2088676800,
                'time': '2036-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          140:
              {
                'ts': 2109236400,
                'time': '2036-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          141:
              {
                'ts': 2120126400,
                'time': '2037-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          142:
              {
                'ts': 2140686000,
                'time': '2037-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              }
        },
    'America/Anchorage':
        {
          0:
              {
                'ts': -880200000,
                'time': '1942-02-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'CAWT'
              },
          1:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'CAPT'
              },
          2:
              {
                'ts': -765378000,
                'time': '1945-09-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CAT'
              },
          3:
              {
                'ts': -86882400,
                'time': '1967-04-01T10:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          4:
              {
                'ts': -21470400,
                'time': '1969-04-27T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          5:
              {
                'ts': -5749200,
                'time': '1969-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          6:
              {
                'ts': 9979200,
                'time': '1970-04-26T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          7:
              {
                'ts': 25700400,
                'time': '1970-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          8:
              {
                'ts': 41428800,
                'time': '1971-04-25T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          9:
              {
                'ts': 57754800,
                'time': '1971-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          10:
              {
                'ts': 73483200,
                'time': '1972-04-30T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          11:
              {
                'ts': 89204400,
                'time': '1972-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          12:
              {
                'ts': 104932800,
                'time': '1973-04-29T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          13:
              {
                'ts': 120654000,
                'time': '1973-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          14:
              {
                'ts': 126705600,
                'time': '1974-01-06T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          15:
              {
                'ts': 152103600,
                'time': '1974-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          16:
              {
                'ts': 162388800,
                'time': '1975-02-23T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          17:
              {
                'ts': 183553200,
                'time': '1975-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          18:
              {
                'ts': 199281600,
                'time': '1976-04-25T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          19:
              {
                'ts': 215607600,
                'time': '1976-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          20:
              {
                'ts': 230731200,
                'time': '1977-04-24T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          21:
              {
                'ts': 247057200,
                'time': '1977-10-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          22:
              {
                'ts': 262785600,
                'time': '1978-04-30T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          23:
              {
                'ts': 278506800,
                'time': '1978-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          24:
              {
                'ts': 294235200,
                'time': '1979-04-29T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          25:
              {
                'ts': 309956400,
                'time': '1979-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          26:
              {
                'ts': 325684800,
                'time': '1980-04-27T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          27:
              {
                'ts': 341406000,
                'time': '1980-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          28:
              {
                'ts': 357134400,
                'time': '1981-04-26T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          29:
              {
                'ts': 372855600,
                'time': '1981-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          30:
              {
                'ts': 388584000,
                'time': '1982-04-25T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          31:
              {
                'ts': 404910000,
                'time': '1982-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          32:
              {
                'ts': 420033600,
                'time': '1983-04-24T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          33:
              {
                'ts': 436359600,
                'time': '1983-10-30T11:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          34:
              {
                'ts': 439030800,
                'time': '1983-11-30T09:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          35:
              {
                'ts': 452084400,
                'time': '1984-04-29T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          36:
              {
                'ts': 467805600,
                'time': '1984-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          37:
              {
                'ts': 483534000,
                'time': '1985-04-28T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          38:
              {
                'ts': 499255200,
                'time': '1985-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          39:
              {
                'ts': 514983600,
                'time': '1986-04-27T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          40:
              {
                'ts': 530704800,
                'time': '1986-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          41:
              {
                'ts': 544618800,
                'time': '1987-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          42:
              {
                'ts': 562154400,
                'time': '1987-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          43:
              {
                'ts': 576068400,
                'time': '1988-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          44:
              {
                'ts': 594208800,
                'time': '1988-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          45:
              {
                'ts': 607518000,
                'time': '1989-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          46:
              {
                'ts': 625658400,
                'time': '1989-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          47:
              {
                'ts': 638967600,
                'time': '1990-04-01T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          48:
              {
                'ts': 657108000,
                'time': '1990-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          49:
              {
                'ts': 671022000,
                'time': '1991-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          50:
              {
                'ts': 688557600,
                'time': '1991-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          51:
              {
                'ts': 702471600,
                'time': '1992-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          52:
              {
                'ts': 720007200,
                'time': '1992-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          53:
              {
                'ts': 733921200,
                'time': '1993-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          54:
              {
                'ts': 752061600,
                'time': '1993-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          55:
              {
                'ts': 765370800,
                'time': '1994-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          56:
              {
                'ts': 783511200,
                'time': '1994-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          57:
              {
                'ts': 796820400,
                'time': '1995-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          58:
              {
                'ts': 814960800,
                'time': '1995-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          59:
              {
                'ts': 828874800,
                'time': '1996-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          60:
              {
                'ts': 846410400,
                'time': '1996-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          61:
              {
                'ts': 860324400,
                'time': '1997-04-06T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          62:
              {
                'ts': 877860000,
                'time': '1997-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          63:
              {
                'ts': 891774000,
                'time': '1998-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          64:
              {
                'ts': 909309600,
                'time': '1998-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          65:
              {
                'ts': 923223600,
                'time': '1999-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          66:
              {
                'ts': 941364000,
                'time': '1999-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          67:
              {
                'ts': 954673200,
                'time': '2000-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          68:
              {
                'ts': 972813600,
                'time': '2000-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          69:
              {
                'ts': 986122800,
                'time': '2001-04-01T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          70:
              {
                'ts': 1004263200,
                'time': '2001-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          71:
              {
                'ts': 1018177200,
                'time': '2002-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          72:
              {
                'ts': 1035712800,
                'time': '2002-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          73:
              {
                'ts': 1049626800,
                'time': '2003-04-06T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          74:
              {
                'ts': 1067162400,
                'time': '2003-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          75:
              {
                'ts': 1081076400,
                'time': '2004-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          76:
              {
                'ts': 1099216800,
                'time': '2004-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          77:
              {
                'ts': 1112526000,
                'time': '2005-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          78:
              {
                'ts': 1130666400,
                'time': '2005-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          79:
              {
                'ts': 1143975600,
                'time': '2006-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          80:
              {
                'ts': 1162116000,
                'time': '2006-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          81:
              {
                'ts': 1173610800,
                'time': '2007-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          82:
              {
                'ts': 1194170400,
                'time': '2007-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          83:
              {
                'ts': 1205060400,
                'time': '2008-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          84:
              {
                'ts': 1225620000,
                'time': '2008-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          85:
              {
                'ts': 1236510000,
                'time': '2009-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          86:
              {
                'ts': 1257069600,
                'time': '2009-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          87:
              {
                'ts': 1268564400,
                'time': '2010-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          88:
              {
                'ts': 1289124000,
                'time': '2010-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          89:
              {
                'ts': 1300014000,
                'time': '2011-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          90:
              {
                'ts': 1320573600,
                'time': '2011-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          91:
              {
                'ts': 1331463600,
                'time': '2012-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          92:
              {
                'ts': 1352023200,
                'time': '2012-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          93:
              {
                'ts': 1362913200,
                'time': '2013-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          94:
              {
                'ts': 1383472800,
                'time': '2013-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          95:
              {
                'ts': 1394362800,
                'time': '2014-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          96:
              {
                'ts': 1414922400,
                'time': '2014-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          97:
              {
                'ts': 1425812400,
                'time': '2015-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          98:
              {
                'ts': 1446372000,
                'time': '2015-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          99:
              {
                'ts': 1457866800,
                'time': '2016-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          100:
              {
                'ts': 1478426400,
                'time': '2016-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          101:
              {
                'ts': 1489316400,
                'time': '2017-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          102:
              {
                'ts': 1509876000,
                'time': '2017-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          103:
              {
                'ts': 1520766000,
                'time': '2018-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          104:
              {
                'ts': 1541325600,
                'time': '2018-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          105:
              {
                'ts': 1552215600,
                'time': '2019-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          106:
              {
                'ts': 1572775200,
                'time': '2019-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          107:
              {
                'ts': 1583665200,
                'time': '2020-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          108:
              {
                'ts': 1604224800,
                'time': '2020-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          109:
              {
                'ts': 1615719600,
                'time': '2021-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          110:
              {
                'ts': 1636279200,
                'time': '2021-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          111:
              {
                'ts': 1647169200,
                'time': '2022-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          112:
              {
                'ts': 1667728800,
                'time': '2022-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          113:
              {
                'ts': 1678618800,
                'time': '2023-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          114:
              {
                'ts': 1699178400,
                'time': '2023-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          115:
              {
                'ts': 1710068400,
                'time': '2024-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          116:
              {
                'ts': 1730628000,
                'time': '2024-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          117:
              {
                'ts': 1741518000,
                'time': '2025-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          118:
              {
                'ts': 1762077600,
                'time': '2025-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          119:
              {
                'ts': 1772967600,
                'time': '2026-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          120:
              {
                'ts': 1793527200,
                'time': '2026-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          121:
              {
                'ts': 1805022000,
                'time': '2027-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          122:
              {
                'ts': 1825581600,
                'time': '2027-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          123:
              {
                'ts': 1836471600,
                'time': '2028-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          124:
              {
                'ts': 1857031200,
                'time': '2028-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          125:
              {
                'ts': 1867921200,
                'time': '2029-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          126:
              {
                'ts': 1888480800,
                'time': '2029-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          127:
              {
                'ts': 1899370800,
                'time': '2030-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          128:
              {
                'ts': 1919930400,
                'time': '2030-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          129:
              {
                'ts': 1930820400,
                'time': '2031-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          130:
              {
                'ts': 1951380000,
                'time': '2031-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          131:
              {
                'ts': 1962874800,
                'time': '2032-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          132:
              {
                'ts': 1983434400,
                'time': '2032-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          133:
              {
                'ts': 1994324400,
                'time': '2033-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          134:
              {
                'ts': 2014884000,
                'time': '2033-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          135:
              {
                'ts': 2025774000,
                'time': '2034-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          136:
              {
                'ts': 2046333600,
                'time': '2034-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          137:
              {
                'ts': 2057223600,
                'time': '2035-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          138:
              {
                'ts': 2077783200,
                'time': '2035-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          139:
              {
                'ts': 2088673200,
                'time': '2036-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          140:
              {
                'ts': 2109232800,
                'time': '2036-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          141:
              {
                'ts': 2120122800,
                'time': '2037-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          142:
              {
                'ts': 2140682400,
                'time': '2037-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              }
        },
    'America/Anguilla':
        {
          0:
              {
                'ts': -1825098464,
                'time': '1912-03-02T04:12:16+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Antigua':
        {
          0:
              {
                'ts': -1825098768,
                'time': '1912-03-02T04:07:12+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -599598000,
                'time': '1951-01-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Araguaina':
        {
          0:
              {
                'ts': -1767214032,
                'time': '1914-01-01T03:12:48+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          1:
              {
                'ts': -1206957600,
                'time': '1931-10-03T14:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          2:
              {
                'ts': -1191362400,
                'time': '1932-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          3:
              {
                'ts': -1175374800,
                'time': '1932-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          4:
              {
                'ts': -1159826400,
                'time': '1933-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          5:
              {
                'ts': -633819600,
                'time': '1949-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          6:
              {
                'ts': -622069200,
                'time': '1950-04-16T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          7:
              {
                'ts': -602283600,
                'time': '1950-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          8:
              {
                'ts': -591832800,
                'time': '1951-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          9:
              {
                'ts': -570747600,
                'time': '1951-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          10:
              {
                'ts': -560210400,
                'time': '1952-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          11:
              {
                'ts': -539125200,
                'time': '1952-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          12:
              {
                'ts': -531352800,
                'time': '1953-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          13:
              {
                'ts': -191365200,
                'time': '1963-12-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          14:
              {
                'ts': -184197600,
                'time': '1964-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          15:
              {
                'ts': -155163600,
                'time': '1965-01-31T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          16:
              {
                'ts': -150069600,
                'time': '1965-03-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          17:
              {
                'ts': -128898000,
                'time': '1965-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          18:
              {
                'ts': -121125600,
                'time': '1966-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          19:
              {
                'ts': -99954000,
                'time': '1966-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          20:
              {
                'ts': -89589600,
                'time': '1967-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          21:
              {
                'ts': -68418000,
                'time': '1967-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          22:
              {
                'ts': -57967200,
                'time': '1968-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          23:
              {
                'ts': 499748400,
                'time': '1985-11-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          24:
              {
                'ts': 511236000,
                'time': '1986-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          25:
              {
                'ts': 530593200,
                'time': '1986-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          26:
              {
                'ts': 540266400,
                'time': '1987-02-14T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          27:
              {
                'ts': 562129200,
                'time': '1987-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          28:
              {
                'ts': 571197600,
                'time': '1988-02-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          29:
              {
                'ts': 592974000,
                'time': '1988-10-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          30:
              {
                'ts': 602042400,
                'time': '1989-01-29T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          31:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          32:
              {
                'ts': 634701600,
                'time': '1990-02-11T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          33:
              {
                'ts': 813726000,
                'time': '1995-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          34:
              {
                'ts': 824004000,
                'time': '1996-02-11T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          35:
              {
                'ts': 844570800,
                'time': '1996-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          36:
              {
                'ts': 856058400,
                'time': '1997-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          37:
              {
                'ts': 876106800,
                'time': '1997-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          38:
              {
                'ts': 888717600,
                'time': '1998-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          39:
              {
                'ts': 908074800,
                'time': '1998-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          40:
              {
                'ts': 919562400,
                'time': '1999-02-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          41:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          42:
              {
                'ts': 951616800,
                'time': '2000-02-27T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          43:
              {
                'ts': 970974000,
                'time': '2000-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          44:
              {
                'ts': 982461600,
                'time': '2001-02-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          45:
              {
                'ts': 1003028400,
                'time': '2001-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          46:
              {
                'ts': 1013911200,
                'time': '2002-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          47:
              {
                'ts': 1036292400,
                'time': '2002-11-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          48:
              {
                'ts': 1045360800,
                'time': '2003-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              }
        },
    'America/Argentina/Buenos_Aires':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667965600,
                'time': '1991-03-03T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          50:
              {
                'ts': 687927600,
                'time': '1991-10-20T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          57:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Argentina/Catamarca':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667965600,
                'time': '1991-03-03T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 687931200,
                'time': '1991-10-20T04:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1086058800,
                'time': '2004-06-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          57:
              {
                'ts': 1087704000,
                'time': '2004-06-20T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          117:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          118:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Argentina/ComodRivadavia':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667965600,
                'time': '1991-03-03T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 687931200,
                'time': '1991-10-20T04:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1086058800,
                'time': '2004-06-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          57:
              {
                'ts': 1087704000,
                'time': '2004-06-20T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          117:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          118:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Argentina/Cordoba':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667965600,
                'time': '1991-03-03T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 687931200,
                'time': '1991-10-20T04:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          57:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Argentina/Jujuy':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          48:
              {
                'ts': 657086400,
                'time': '1990-10-28T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'WARST'
              },
          49:
              {
                'ts': 669178800,
                'time': '1991-03-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 686721600,
                'time': '1991-10-06T04:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          57:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Argentina/La_Rioja':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667792800,
                'time': '1991-03-01T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 673588800,
                'time': '1991-05-07T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          51:
              {
                'ts': 687927600,
                'time': '1991-10-20T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          52:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          53:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          54:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          55:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          56:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          57:
              {
                'ts': 1086058800,
                'time': '2004-06-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          58:
              {
                'ts': 1087704000,
                'time': '2004-06-20T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          59:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          60:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          61:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          62:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          63:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          64:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          65:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          66:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          67:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          68:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          69:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          70:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          71:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          72:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          73:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          74:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          75:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          76:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          77:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          78:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          79:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          80:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          81:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          82:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          83:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          84:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          85:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          86:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          87:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          88:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          89:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          90:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          91:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          92:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          93:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          94:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          95:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          96:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          97:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          98:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          99:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          100:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          101:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          102:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          103:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          104:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          105:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          106:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          107:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          108:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          109:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          110:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          111:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          112:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          113:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          114:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          115:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          116:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          117:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          118:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          119:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Argentina/Mendoza':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          48:
              {
                'ts': 655963200,
                'time': '1990-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'WARST'
              },
          49:
              {
                'ts': 667796400,
                'time': '1991-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 687499200,
                'time': '1991-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'WARST'
              },
          51:
              {
                'ts': 699418800,
                'time': '1992-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          52:
              {
                'ts': 719380800,
                'time': '1992-10-18T04:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1085281200,
                'time': '2004-05-23T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          57:
              {
                'ts': 1096171200,
                'time': '2004-09-26T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          117:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          118:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Argentina/Rio_Gallegos':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667965600,
                'time': '1991-03-03T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          50:
              {
                'ts': 687927600,
                'time': '1991-10-20T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1086058800,
                'time': '2004-06-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          57:
              {
                'ts': 1087704000,
                'time': '2004-06-20T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          117:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          118:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Argentina/San_Juan':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667792800,
                'time': '1991-03-01T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 673588800,
                'time': '1991-05-07T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          51:
              {
                'ts': 687927600,
                'time': '1991-10-20T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          52:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          53:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          54:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          55:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          56:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          57:
              {
                'ts': 1085972400,
                'time': '2004-05-31T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          58:
              {
                'ts': 1090728000,
                'time': '2004-07-25T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          59:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          60:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          61:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          62:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          63:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          64:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          65:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          66:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          67:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          68:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          69:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          70:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          71:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          72:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          73:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          74:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          75:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          76:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          77:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          78:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          79:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          80:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          81:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          82:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          83:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          84:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          85:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          86:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          87:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          88:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          89:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          90:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          91:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          92:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          93:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          94:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          95:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          96:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          97:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          98:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          99:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          100:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          101:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          102:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          103:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          104:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          105:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          106:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          107:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          108:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          109:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          110:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          111:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          112:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          113:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          114:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          115:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          116:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          117:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          118:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          119:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Argentina/San_Luis':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667792800,
                'time': '1991-03-01T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 673588800,
                'time': '1991-05-07T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          51:
              {
                'ts': 687927600,
                'time': '1991-10-20T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          52:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          53:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          54:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          55:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          56:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          57:
              {
                'ts': 1085972400,
                'time': '2004-05-31T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          58:
              {
                'ts': 1090728000,
                'time': '2004-07-25T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          59:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          60:
              {
                'ts': 1200880800,
                'time': '2008-01-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              }
        },
    'America/Argentina/Tucuman':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667965600,
                'time': '1991-03-03T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 687931200,
                'time': '1991-10-20T04:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1086058800,
                'time': '2004-06-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          57:
              {
                'ts': 1087099200,
                'time': '2004-06-13T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          117:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          118:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Argentina/Ushuaia':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667965600,
                'time': '1991-03-03T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          50:
              {
                'ts': 687927600,
                'time': '1991-10-20T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1085886000,
                'time': '2004-05-30T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          57:
              {
                'ts': 1087704000,
                'time': '2004-06-20T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          117:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          118:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Aruba':
        {
          0:
              {
                'ts': -1826738376,
                'time': '1912-02-12T04:40:24+0000',
                'offset': -16200,
                'isdst': false,
                'abbr': 'ANT'
              },
          1:
              {
                'ts': -157750200,
                'time': '1965-01-01T04:30:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Asuncion':
        {
          0:
              {
                'ts': -1206389360,
                'time': '1931-10-10T03:50:40+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          1:
              {
                'ts': 86760000,
                'time': '1972-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PYT'
              },
          2:
              {
                'ts': 134017200,
                'time': '1974-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          3:
              {
                'ts': 181368000,
                'time': '1975-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          4:
              {
                'ts': 194497200,
                'time': '1976-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          5:
              {
                'ts': 212990400,
                'time': '1976-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          6:
              {
                'ts': 226033200,
                'time': '1977-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          7:
              {
                'ts': 244526400,
                'time': '1977-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          8:
              {
                'ts': 257569200,
                'time': '1978-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          9:
              {
                'ts': 276062400,
                'time': '1978-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          10:
              {
                'ts': 291783600,
                'time': '1979-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          11:
              {
                'ts': 307598400,
                'time': '1979-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          12:
              {
                'ts': 323406000,
                'time': '1980-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          13:
              {
                'ts': 339220800,
                'time': '1980-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          14:
              {
                'ts': 354942000,
                'time': '1981-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          15:
              {
                'ts': 370756800,
                'time': '1981-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          16:
              {
                'ts': 386478000,
                'time': '1982-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          17:
              {
                'ts': 402292800,
                'time': '1982-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          18:
              {
                'ts': 418014000,
                'time': '1983-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          19:
              {
                'ts': 433828800,
                'time': '1983-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          20:
              {
                'ts': 449636400,
                'time': '1984-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          21:
              {
                'ts': 465451200,
                'time': '1984-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          22:
              {
                'ts': 481172400,
                'time': '1985-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          23:
              {
                'ts': 496987200,
                'time': '1985-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          24:
              {
                'ts': 512708400,
                'time': '1986-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          25:
              {
                'ts': 528523200,
                'time': '1986-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          26:
              {
                'ts': 544244400,
                'time': '1987-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          27:
              {
                'ts': 560059200,
                'time': '1987-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          28:
              {
                'ts': 575866800,
                'time': '1988-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          29:
              {
                'ts': 591681600,
                'time': '1988-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          30:
              {
                'ts': 607402800,
                'time': '1989-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          31:
              {
                'ts': 625032000,
                'time': '1989-10-22T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          32:
              {
                'ts': 638938800,
                'time': '1990-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          33:
              {
                'ts': 654753600,
                'time': '1990-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          34:
              {
                'ts': 670474800,
                'time': '1991-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          35:
              {
                'ts': 686721600,
                'time': '1991-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          36:
              {
                'ts': 699418800,
                'time': '1992-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          37:
              {
                'ts': 718257600,
                'time': '1992-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          38:
              {
                'ts': 733546800,
                'time': '1993-03-31T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          39:
              {
                'ts': 749448000,
                'time': '1993-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          40:
              {
                'ts': 762318000,
                'time': '1994-02-27T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          41:
              {
                'ts': 780984000,
                'time': '1994-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          42:
              {
                'ts': 793767600,
                'time': '1995-02-26T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          43:
              {
                'ts': 812520000,
                'time': '1995-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          44:
              {
                'ts': 825649200,
                'time': '1996-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          45:
              {
                'ts': 844574400,
                'time': '1996-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          46:
              {
                'ts': 856666800,
                'time': '1997-02-23T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          47:
              {
                'ts': 876024000,
                'time': '1997-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          48:
              {
                'ts': 888721200,
                'time': '1998-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          49:
              {
                'ts': 907473600,
                'time': '1998-10-04T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          50:
              {
                'ts': 920775600,
                'time': '1999-03-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          51:
              {
                'ts': 938923200,
                'time': '1999-10-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          52:
              {
                'ts': 952225200,
                'time': '2000-03-05T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          53:
              {
                'ts': 970372800,
                'time': '2000-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          54:
              {
                'ts': 983674800,
                'time': '2001-03-04T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          55:
              {
                'ts': 1002427200,
                'time': '2001-10-07T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          56:
              {
                'ts': 1018148400,
                'time': '2002-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          57:
              {
                'ts': 1030852800,
                'time': '2002-09-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          58:
              {
                'ts': 1049598000,
                'time': '2003-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          59:
              {
                'ts': 1062907200,
                'time': '2003-09-07T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          60:
              {
                'ts': 1081047600,
                'time': '2004-04-04T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          61:
              {
                'ts': 1097985600,
                'time': '2004-10-17T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          62:
              {
                'ts': 1110682800,
                'time': '2005-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          63:
              {
                'ts': 1129435200,
                'time': '2005-10-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          64:
              {
                'ts': 1142132400,
                'time': '2006-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          65:
              {
                'ts': 1160884800,
                'time': '2006-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          66:
              {
                'ts': 1173582000,
                'time': '2007-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          67:
              {
                'ts': 1192939200,
                'time': '2007-10-21T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          68:
              {
                'ts': 1205031600,
                'time': '2008-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          69:
              {
                'ts': 1224388800,
                'time': '2008-10-19T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          70:
              {
                'ts': 1236481200,
                'time': '2009-03-08T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          71:
              {
                'ts': 1255838400,
                'time': '2009-10-18T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          72:
              {
                'ts': 1268535600,
                'time': '2010-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          73:
              {
                'ts': 1287288000,
                'time': '2010-10-17T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          74:
              {
                'ts': 1299985200,
                'time': '2011-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          75:
              {
                'ts': 1318737600,
                'time': '2011-10-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          76:
              {
                'ts': 1331434800,
                'time': '2012-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          77:
              {
                'ts': 1350792000,
                'time': '2012-10-21T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          78:
              {
                'ts': 1362884400,
                'time': '2013-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          79:
              {
                'ts': 1382241600,
                'time': '2013-10-20T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          80:
              {
                'ts': 1394334000,
                'time': '2014-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          81:
              {
                'ts': 1413691200,
                'time': '2014-10-19T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          82:
              {
                'ts': 1425783600,
                'time': '2015-03-08T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          83:
              {
                'ts': 1445140800,
                'time': '2015-10-18T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          84:
              {
                'ts': 1457838000,
                'time': '2016-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          85:
              {
                'ts': 1476590400,
                'time': '2016-10-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          86:
              {
                'ts': 1489287600,
                'time': '2017-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          87:
              {
                'ts': 1508040000,
                'time': '2017-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          88:
              {
                'ts': 1520737200,
                'time': '2018-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          89:
              {
                'ts': 1540094400,
                'time': '2018-10-21T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          90:
              {
                'ts': 1552186800,
                'time': '2019-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          91:
              {
                'ts': 1571544000,
                'time': '2019-10-20T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          92:
              {
                'ts': 1583636400,
                'time': '2020-03-08T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          93:
              {
                'ts': 1602993600,
                'time': '2020-10-18T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          94:
              {
                'ts': 1615690800,
                'time': '2021-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          95:
              {
                'ts': 1634443200,
                'time': '2021-10-17T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          96:
              {
                'ts': 1647140400,
                'time': '2022-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          97:
              {
                'ts': 1665892800,
                'time': '2022-10-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          98:
              {
                'ts': 1678590000,
                'time': '2023-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          99:
              {
                'ts': 1697342400,
                'time': '2023-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          100:
              {
                'ts': 1710039600,
                'time': '2024-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          101:
              {
                'ts': 1729396800,
                'time': '2024-10-20T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          102:
              {
                'ts': 1741489200,
                'time': '2025-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          103:
              {
                'ts': 1760846400,
                'time': '2025-10-19T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          104:
              {
                'ts': 1772938800,
                'time': '2026-03-08T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          105:
              {
                'ts': 1792296000,
                'time': '2026-10-18T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          106:
              {
                'ts': 1804993200,
                'time': '2027-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          107:
              {
                'ts': 1823745600,
                'time': '2027-10-17T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          108:
              {
                'ts': 1836442800,
                'time': '2028-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          109:
              {
                'ts': 1855195200,
                'time': '2028-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          110:
              {
                'ts': 1867892400,
                'time': '2029-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          111:
              {
                'ts': 1887249600,
                'time': '2029-10-21T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          112:
              {
                'ts': 1899342000,
                'time': '2030-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          113:
              {
                'ts': 1918699200,
                'time': '2030-10-20T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          114:
              {
                'ts': 1930791600,
                'time': '2031-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          115:
              {
                'ts': 1950148800,
                'time': '2031-10-19T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          116:
              {
                'ts': 1962846000,
                'time': '2032-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          117:
              {
                'ts': 1981598400,
                'time': '2032-10-17T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          118:
              {
                'ts': 1994295600,
                'time': '2033-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          119:
              {
                'ts': 2013048000,
                'time': '2033-10-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          120:
              {
                'ts': 2025745200,
                'time': '2034-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          121:
              {
                'ts': 2044497600,
                'time': '2034-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          122:
              {
                'ts': 2057194800,
                'time': '2035-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          123:
              {
                'ts': 2076552000,
                'time': '2035-10-21T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          124:
              {
                'ts': 2088644400,
                'time': '2036-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          125:
              {
                'ts': 2108001600,
                'time': '2036-10-19T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              },
          126:
              {
                'ts': 2120094000,
                'time': '2037-03-08T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'PYT'
              },
          127:
              {
                'ts': 2139451200,
                'time': '2037-10-18T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'PYST'
              }
        },
    'America/Atikokan':
        {
          0:
              {
                'ts': -1632067200,
                'time': '1918-04-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1614790800,
                'time': '1918-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -923248800,
                'time': '1940-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          4:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          5:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Atka':
        {
          0:
              {
                'ts': -880196400,
                'time': '1942-02-09T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'NWT'
              },
          1:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'NPT'
              },
          2:
              {
                'ts': -765374400,
                'time': '1945-09-30T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'NST'
              },
          3:
              {
                'ts': -86878800,
                'time': '1967-04-01T11:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          4:
              {
                'ts': -21466800,
                'time': '1969-04-27T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          5:
              {
                'ts': -5745600,
                'time': '1969-10-26T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          6:
              {
                'ts': 9982800,
                'time': '1970-04-26T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          7:
              {
                'ts': 25704000,
                'time': '1970-10-25T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          8:
              {
                'ts': 41432400,
                'time': '1971-04-25T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          9:
              {
                'ts': 57758400,
                'time': '1971-10-31T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          10:
              {
                'ts': 73486800,
                'time': '1972-04-30T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          11:
              {
                'ts': 89208000,
                'time': '1972-10-29T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          12:
              {
                'ts': 104936400,
                'time': '1973-04-29T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          13:
              {
                'ts': 120657600,
                'time': '1973-10-28T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          14:
              {
                'ts': 126709200,
                'time': '1974-01-06T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          15:
              {
                'ts': 152107200,
                'time': '1974-10-27T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          16:
              {
                'ts': 162392400,
                'time': '1975-02-23T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          17:
              {
                'ts': 183556800,
                'time': '1975-10-26T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          18:
              {
                'ts': 199285200,
                'time': '1976-04-25T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          19:
              {
                'ts': 215611200,
                'time': '1976-10-31T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          20:
              {
                'ts': 230734800,
                'time': '1977-04-24T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          21:
              {
                'ts': 247060800,
                'time': '1977-10-30T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          22:
              {
                'ts': 262789200,
                'time': '1978-04-30T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          23:
              {
                'ts': 278510400,
                'time': '1978-10-29T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          24:
              {
                'ts': 294238800,
                'time': '1979-04-29T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          25:
              {
                'ts': 309960000,
                'time': '1979-10-28T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          26:
              {
                'ts': 325688400,
                'time': '1980-04-27T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          27:
              {
                'ts': 341409600,
                'time': '1980-10-26T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          28:
              {
                'ts': 357138000,
                'time': '1981-04-26T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          29:
              {
                'ts': 372859200,
                'time': '1981-10-25T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          30:
              {
                'ts': 388587600,
                'time': '1982-04-25T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          31:
              {
                'ts': 404913600,
                'time': '1982-10-31T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          32:
              {
                'ts': 420037200,
                'time': '1983-04-24T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          33:
              {
                'ts': 436363200,
                'time': '1983-10-30T12:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          34:
              {
                'ts': 439034400,
                'time': '1983-11-30T10:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          35:
              {
                'ts': 452088000,
                'time': '1984-04-29T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          36:
              {
                'ts': 467809200,
                'time': '1984-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          37:
              {
                'ts': 483537600,
                'time': '1985-04-28T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          38:
              {
                'ts': 499258800,
                'time': '1985-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          39:
              {
                'ts': 514987200,
                'time': '1986-04-27T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          40:
              {
                'ts': 530708400,
                'time': '1986-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          41:
              {
                'ts': 544622400,
                'time': '1987-04-05T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          42:
              {
                'ts': 562158000,
                'time': '1987-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          43:
              {
                'ts': 576072000,
                'time': '1988-04-03T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          44:
              {
                'ts': 594212400,
                'time': '1988-10-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          45:
              {
                'ts': 607521600,
                'time': '1989-04-02T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          46:
              {
                'ts': 625662000,
                'time': '1989-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          47:
              {
                'ts': 638971200,
                'time': '1990-04-01T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          48:
              {
                'ts': 657111600,
                'time': '1990-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          49:
              {
                'ts': 671025600,
                'time': '1991-04-07T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          50:
              {
                'ts': 688561200,
                'time': '1991-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          51:
              {
                'ts': 702475200,
                'time': '1992-04-05T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          52:
              {
                'ts': 720010800,
                'time': '1992-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          53:
              {
                'ts': 733924800,
                'time': '1993-04-04T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          54:
              {
                'ts': 752065200,
                'time': '1993-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          55:
              {
                'ts': 765374400,
                'time': '1994-04-03T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          56:
              {
                'ts': 783514800,
                'time': '1994-10-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          57:
              {
                'ts': 796824000,
                'time': '1995-04-02T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          58:
              {
                'ts': 814964400,
                'time': '1995-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          59:
              {
                'ts': 828878400,
                'time': '1996-04-07T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          60:
              {
                'ts': 846414000,
                'time': '1996-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          61:
              {
                'ts': 860328000,
                'time': '1997-04-06T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          62:
              {
                'ts': 877863600,
                'time': '1997-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          63:
              {
                'ts': 891777600,
                'time': '1998-04-05T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          64:
              {
                'ts': 909313200,
                'time': '1998-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          65:
              {
                'ts': 923227200,
                'time': '1999-04-04T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          66:
              {
                'ts': 941367600,
                'time': '1999-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          67:
              {
                'ts': 954676800,
                'time': '2000-04-02T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          68:
              {
                'ts': 972817200,
                'time': '2000-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          69:
              {
                'ts': 986126400,
                'time': '2001-04-01T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          70:
              {
                'ts': 1004266800,
                'time': '2001-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          71:
              {
                'ts': 1018180800,
                'time': '2002-04-07T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          72:
              {
                'ts': 1035716400,
                'time': '2002-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          73:
              {
                'ts': 1049630400,
                'time': '2003-04-06T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          74:
              {
                'ts': 1067166000,
                'time': '2003-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          75:
              {
                'ts': 1081080000,
                'time': '2004-04-04T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          76:
              {
                'ts': 1099220400,
                'time': '2004-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          77:
              {
                'ts': 1112529600,
                'time': '2005-04-03T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          78:
              {
                'ts': 1130670000,
                'time': '2005-10-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          79:
              {
                'ts': 1143979200,
                'time': '2006-04-02T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          80:
              {
                'ts': 1162119600,
                'time': '2006-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          81:
              {
                'ts': 1173614400,
                'time': '2007-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          82:
              {
                'ts': 1194174000,
                'time': '2007-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          83:
              {
                'ts': 1205064000,
                'time': '2008-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          84:
              {
                'ts': 1225623600,
                'time': '2008-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          85:
              {
                'ts': 1236513600,
                'time': '2009-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          86:
              {
                'ts': 1257073200,
                'time': '2009-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          87:
              {
                'ts': 1268568000,
                'time': '2010-03-14T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          88:
              {
                'ts': 1289127600,
                'time': '2010-11-07T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          89:
              {
                'ts': 1300017600,
                'time': '2011-03-13T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          90:
              {
                'ts': 1320577200,
                'time': '2011-11-06T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          91:
              {
                'ts': 1331467200,
                'time': '2012-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          92:
              {
                'ts': 1352026800,
                'time': '2012-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          93:
              {
                'ts': 1362916800,
                'time': '2013-03-10T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          94:
              {
                'ts': 1383476400,
                'time': '2013-11-03T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          95:
              {
                'ts': 1394366400,
                'time': '2014-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          96:
              {
                'ts': 1414926000,
                'time': '2014-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          97:
              {
                'ts': 1425816000,
                'time': '2015-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          98:
              {
                'ts': 1446375600,
                'time': '2015-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          99:
              {
                'ts': 1457870400,
                'time': '2016-03-13T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          100:
              {
                'ts': 1478430000,
                'time': '2016-11-06T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          101:
              {
                'ts': 1489320000,
                'time': '2017-03-12T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          102:
              {
                'ts': 1509879600,
                'time': '2017-11-05T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          103:
              {
                'ts': 1520769600,
                'time': '2018-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          104:
              {
                'ts': 1541329200,
                'time': '2018-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          105:
              {
                'ts': 1552219200,
                'time': '2019-03-10T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          106:
              {
                'ts': 1572778800,
                'time': '2019-11-03T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          107:
              {
                'ts': 1583668800,
                'time': '2020-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          108:
              {
                'ts': 1604228400,
                'time': '2020-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          109:
              {
                'ts': 1615723200,
                'time': '2021-03-14T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          110:
              {
                'ts': 1636282800,
                'time': '2021-11-07T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          111:
              {
                'ts': 1647172800,
                'time': '2022-03-13T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          112:
              {
                'ts': 1667732400,
                'time': '2022-11-06T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          113:
              {
                'ts': 1678622400,
                'time': '2023-03-12T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          114:
              {
                'ts': 1699182000,
                'time': '2023-11-05T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          115:
              {
                'ts': 1710072000,
                'time': '2024-03-10T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          116:
              {
                'ts': 1730631600,
                'time': '2024-11-03T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          117:
              {
                'ts': 1741521600,
                'time': '2025-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          118:
              {
                'ts': 1762081200,
                'time': '2025-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          119:
              {
                'ts': 1772971200,
                'time': '2026-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          120:
              {
                'ts': 1793530800,
                'time': '2026-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          121:
              {
                'ts': 1805025600,
                'time': '2027-03-14T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          122:
              {
                'ts': 1825585200,
                'time': '2027-11-07T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          123:
              {
                'ts': 1836475200,
                'time': '2028-03-12T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          124:
              {
                'ts': 1857034800,
                'time': '2028-11-05T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          125:
              {
                'ts': 1867924800,
                'time': '2029-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          126:
              {
                'ts': 1888484400,
                'time': '2029-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          127:
              {
                'ts': 1899374400,
                'time': '2030-03-10T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          128:
              {
                'ts': 1919934000,
                'time': '2030-11-03T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          129:
              {
                'ts': 1930824000,
                'time': '2031-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          130:
              {
                'ts': 1951383600,
                'time': '2031-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          131:
              {
                'ts': 1962878400,
                'time': '2032-03-14T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          132:
              {
                'ts': 1983438000,
                'time': '2032-11-07T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          133:
              {
                'ts': 1994328000,
                'time': '2033-03-13T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          134:
              {
                'ts': 2014887600,
                'time': '2033-11-06T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          135:
              {
                'ts': 2025777600,
                'time': '2034-03-12T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          136:
              {
                'ts': 2046337200,
                'time': '2034-11-05T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          137:
              {
                'ts': 2057227200,
                'time': '2035-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          138:
              {
                'ts': 2077786800,
                'time': '2035-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          139:
              {
                'ts': 2088676800,
                'time': '2036-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          140:
              {
                'ts': 2109236400,
                'time': '2036-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          141:
              {
                'ts': 2120126400,
                'time': '2037-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          142:
              {
                'ts': 2140686000,
                'time': '2037-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              }
        },
    'America/Bahia':
        {
          0:
              {
                'ts': -1767216356,
                'time': '1914-01-01T02:34:04+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          1:
              {
                'ts': -1206957600,
                'time': '1931-10-03T14:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          2:
              {
                'ts': -1191362400,
                'time': '1932-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          3:
              {
                'ts': -1175374800,
                'time': '1932-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          4:
              {
                'ts': -1159826400,
                'time': '1933-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          5:
              {
                'ts': -633819600,
                'time': '1949-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          6:
              {
                'ts': -622069200,
                'time': '1950-04-16T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          7:
              {
                'ts': -602283600,
                'time': '1950-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          8:
              {
                'ts': -591832800,
                'time': '1951-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          9:
              {
                'ts': -570747600,
                'time': '1951-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          10:
              {
                'ts': -560210400,
                'time': '1952-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          11:
              {
                'ts': -539125200,
                'time': '1952-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          12:
              {
                'ts': -531352800,
                'time': '1953-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          13:
              {
                'ts': -191365200,
                'time': '1963-12-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          14:
              {
                'ts': -184197600,
                'time': '1964-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          15:
              {
                'ts': -155163600,
                'time': '1965-01-31T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          16:
              {
                'ts': -150069600,
                'time': '1965-03-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          17:
              {
                'ts': -128898000,
                'time': '1965-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          18:
              {
                'ts': -121125600,
                'time': '1966-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          19:
              {
                'ts': -99954000,
                'time': '1966-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          20:
              {
                'ts': -89589600,
                'time': '1967-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          21:
              {
                'ts': -68418000,
                'time': '1967-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          22:
              {
                'ts': -57967200,
                'time': '1968-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          23:
              {
                'ts': 499748400,
                'time': '1985-11-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          24:
              {
                'ts': 511236000,
                'time': '1986-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          25:
              {
                'ts': 530593200,
                'time': '1986-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          26:
              {
                'ts': 540266400,
                'time': '1987-02-14T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          27:
              {
                'ts': 562129200,
                'time': '1987-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          28:
              {
                'ts': 571197600,
                'time': '1988-02-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          29:
              {
                'ts': 592974000,
                'time': '1988-10-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          30:
              {
                'ts': 602042400,
                'time': '1989-01-29T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          31:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          32:
              {
                'ts': 634701600,
                'time': '1990-02-11T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          33:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          34:
              {
                'ts': 666756000,
                'time': '1991-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          35:
              {
                'ts': 687927600,
                'time': '1991-10-20T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          36:
              {
                'ts': 697600800,
                'time': '1992-02-09T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          37:
              {
                'ts': 719982000,
                'time': '1992-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          38:
              {
                'ts': 728445600,
                'time': '1993-01-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          39:
              {
                'ts': 750826800,
                'time': '1993-10-17T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          40:
              {
                'ts': 761709600,
                'time': '1994-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          41:
              {
                'ts': 782276400,
                'time': '1994-10-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          42:
              {
                'ts': 793159200,
                'time': '1995-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          43:
              {
                'ts': 813726000,
                'time': '1995-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          44:
              {
                'ts': 824004000,
                'time': '1996-02-11T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          45:
              {
                'ts': 844570800,
                'time': '1996-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          46:
              {
                'ts': 856058400,
                'time': '1997-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          47:
              {
                'ts': 876106800,
                'time': '1997-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          48:
              {
                'ts': 888717600,
                'time': '1998-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          49:
              {
                'ts': 908074800,
                'time': '1998-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          50:
              {
                'ts': 919562400,
                'time': '1999-02-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          51:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          52:
              {
                'ts': 951616800,
                'time': '2000-02-27T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          53:
              {
                'ts': 970974000,
                'time': '2000-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          54:
              {
                'ts': 982461600,
                'time': '2001-02-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          55:
              {
                'ts': 1003028400,
                'time': '2001-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          56:
              {
                'ts': 1013911200,
                'time': '2002-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          57:
              {
                'ts': 1036292400,
                'time': '2002-11-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          58:
              {
                'ts': 1045360800,
                'time': '2003-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              }
        },
    'America/Barbados':
        {
          0:
              {
                'ts': -1451678492,
                'time': '1924-01-01T03:58:28+0000',
                'offset': -14308,
                'isdst': false,
                'abbr': 'BMT'
              },
          1:
              {
                'ts': -1199217692,
                'time': '1932-01-01T03:58:28+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          2:
              {
                'ts': 234943200,
                'time': '1977-06-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          3:
              {
                'ts': 244616400,
                'time': '1977-10-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          4:
              {
                'ts': 261554400,
                'time': '1978-04-16T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          5:
              {
                'ts': 276066000,
                'time': '1978-10-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          6:
              {
                'ts': 293004000,
                'time': '1979-04-15T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          7:
              {
                'ts': 307515600,
                'time': '1979-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          8:
              {
                'ts': 325058400,
                'time': '1980-04-20T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          9:
              {
                'ts': 338706000,
                'time': '1980-09-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Belem':
        {
          0:
              {
                'ts': -1767213964,
                'time': '1914-01-01T03:13:56+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          1:
              {
                'ts': -1206957600,
                'time': '1931-10-03T14:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          2:
              {
                'ts': -1191362400,
                'time': '1932-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          3:
              {
                'ts': -1175374800,
                'time': '1932-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          4:
              {
                'ts': -1159826400,
                'time': '1933-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          5:
              {
                'ts': -633819600,
                'time': '1949-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          6:
              {
                'ts': -622069200,
                'time': '1950-04-16T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          7:
              {
                'ts': -602283600,
                'time': '1950-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          8:
              {
                'ts': -591832800,
                'time': '1951-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          9:
              {
                'ts': -570747600,
                'time': '1951-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          10:
              {
                'ts': -560210400,
                'time': '1952-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          11:
              {
                'ts': -539125200,
                'time': '1952-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          12:
              {
                'ts': -531352800,
                'time': '1953-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          13:
              {
                'ts': -191365200,
                'time': '1963-12-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          14:
              {
                'ts': -184197600,
                'time': '1964-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          15:
              {
                'ts': -155163600,
                'time': '1965-01-31T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          16:
              {
                'ts': -150069600,
                'time': '1965-03-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          17:
              {
                'ts': -128898000,
                'time': '1965-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          18:
              {
                'ts': -121125600,
                'time': '1966-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          19:
              {
                'ts': -99954000,
                'time': '1966-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          20:
              {
                'ts': -89589600,
                'time': '1967-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          21:
              {
                'ts': -68418000,
                'time': '1967-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          22:
              {
                'ts': -57967200,
                'time': '1968-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          23:
              {
                'ts': 499748400,
                'time': '1985-11-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          24:
              {
                'ts': 511236000,
                'time': '1986-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          25:
              {
                'ts': 530593200,
                'time': '1986-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          26:
              {
                'ts': 540266400,
                'time': '1987-02-14T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          27:
              {
                'ts': 562129200,
                'time': '1987-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          28:
              {
                'ts': 571197600,
                'time': '1988-02-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              }
        },
    'America/Belize':
        {
          0:
              {
                'ts': -1822500432,
                'time': '1912-04-01T05:52:48+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -1616954400,
                'time': '1918-10-06T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          2:
              {
                'ts': -1606069800,
                'time': '1919-02-09T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': -1585504800,
                'time': '1919-10-05T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          4:
              {
                'ts': -1574015400,
                'time': '1920-02-15T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': -1554055200,
                'time': '1920-10-03T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          6:
              {
                'ts': -1542565800,
                'time': '1921-02-13T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -1522605600,
                'time': '1921-10-02T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          8:
              {
                'ts': -1511116200,
                'time': '1922-02-12T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -1490551200,
                'time': '1922-10-08T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          10:
              {
                'ts': -1479666600,
                'time': '1923-02-11T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -1459101600,
                'time': '1923-10-07T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          12:
              {
                'ts': -1448217000,
                'time': '1924-02-10T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -1427652000,
                'time': '1924-10-05T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          14:
              {
                'ts': -1416162600,
                'time': '1925-02-15T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -1396202400,
                'time': '1925-10-04T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          16:
              {
                'ts': -1384713000,
                'time': '1926-02-14T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -1364752800,
                'time': '1926-10-03T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          18:
              {
                'ts': -1353263400,
                'time': '1927-02-13T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -1333303200,
                'time': '1927-10-02T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          20:
              {
                'ts': -1321813800,
                'time': '1928-02-12T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -1301248800,
                'time': '1928-10-07T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          22:
              {
                'ts': -1290364200,
                'time': '1929-02-10T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -1269799200,
                'time': '1929-10-06T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          24:
              {
                'ts': -1258914600,
                'time': '1930-02-09T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -1238349600,
                'time': '1930-10-05T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          26:
              {
                'ts': -1226860200,
                'time': '1931-02-15T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -1206900000,
                'time': '1931-10-04T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          28:
              {
                'ts': -1195410600,
                'time': '1932-02-14T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -1175450400,
                'time': '1932-10-02T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          30:
              {
                'ts': -1163961000,
                'time': '1933-02-12T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': -1143396000,
                'time': '1933-10-08T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          32:
              {
                'ts': -1132511400,
                'time': '1934-02-11T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': -1111946400,
                'time': '1934-10-07T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          34:
              {
                'ts': -1101061800,
                'time': '1935-02-10T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': -1080496800,
                'time': '1935-10-06T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          36:
              {
                'ts': -1069612200,
                'time': '1936-02-09T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': -1049047200,
                'time': '1936-10-04T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          38:
              {
                'ts': -1037557800,
                'time': '1937-02-14T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': -1017597600,
                'time': '1937-10-03T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          40:
              {
                'ts': -1006108200,
                'time': '1938-02-13T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': -986148000,
                'time': '1938-10-02T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          42:
              {
                'ts': -974658600,
                'time': '1939-02-12T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': -954093600,
                'time': '1939-10-08T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          44:
              {
                'ts': -943209000,
                'time': '1940-02-11T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': -922644000,
                'time': '1940-10-06T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          46:
              {
                'ts': -911759400,
                'time': '1941-02-09T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': -891194400,
                'time': '1941-10-05T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          48:
              {
                'ts': -879705000,
                'time': '1942-02-15T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': -859744800,
                'time': '1942-10-04T06:00:00+0000',
                'offset': -19800,
                'isdst': true,
                'abbr': 'CHDT'
              },
          50:
              {
                'ts': -848255400,
                'time': '1943-02-14T05:30:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 123919200,
                'time': '1973-12-05T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 129618000,
                'time': '1974-02-09T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 409039200,
                'time': '1982-12-18T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 413874000,
                'time': '1983-02-12T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Blanc-Sablon':
        {
          0:
              {
                'ts': -1632074400,
                'time': '1918-04-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          1:
              {
                'ts': -1614798000,
                'time': '1918-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          2:
              {
                'ts': -880221600,
                'time': '1942-02-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AWT'
              },
          3:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'APT'
              },
          4:
              {
                'ts': -765399600,
                'time': '1945-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Boa_Vista':
        {
          0:
              {
                'ts': -1767211040,
                'time': '1914-01-01T04:02:40+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          1:
              {
                'ts': -1206954000,
                'time': '1931-10-03T15:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          2:
              {
                'ts': -1191358800,
                'time': '1932-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          3:
              {
                'ts': -1175371200,
                'time': '1932-10-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          4:
              {
                'ts': -1159822800,
                'time': '1933-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          5:
              {
                'ts': -633816000,
                'time': '1949-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          6:
              {
                'ts': -622065600,
                'time': '1950-04-16T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          7:
              {
                'ts': -602280000,
                'time': '1950-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          8:
              {
                'ts': -591829200,
                'time': '1951-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          9:
              {
                'ts': -570744000,
                'time': '1951-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          10:
              {
                'ts': -560206800,
                'time': '1952-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          11:
              {
                'ts': -539121600,
                'time': '1952-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          12:
              {
                'ts': -531349200,
                'time': '1953-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          13:
              {
                'ts': -191361600,
                'time': '1963-12-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          14:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          15:
              {
                'ts': -155160000,
                'time': '1965-01-31T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          16:
              {
                'ts': -150066000,
                'time': '1965-03-31T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          17:
              {
                'ts': -128894400,
                'time': '1965-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          18:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          19:
              {
                'ts': -99950400,
                'time': '1966-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          20:
              {
                'ts': -89586000,
                'time': '1967-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          21:
              {
                'ts': -68414400,
                'time': '1967-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          22:
              {
                'ts': -57963600,
                'time': '1968-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          23:
              {
                'ts': 499752000,
                'time': '1985-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          24:
              {
                'ts': 511239600,
                'time': '1986-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          25:
              {
                'ts': 530596800,
                'time': '1986-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          26:
              {
                'ts': 540270000,
                'time': '1987-02-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          27:
              {
                'ts': 562132800,
                'time': '1987-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          28:
              {
                'ts': 571201200,
                'time': '1988-02-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          29:
              {
                'ts': 938923200,
                'time': '1999-10-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          30:
              {
                'ts': 951620400,
                'time': '2000-02-27T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          31:
              {
                'ts': 970977600,
                'time': '2000-10-08T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          32:
              {
                'ts': 971578800,
                'time': '2000-10-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              }
        },
    'America/Bogota':
        {
          0:
              {
                'ts': -1739041420,
                'time': '1914-11-23T04:56:20+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'COT'
              },
          1:
              {
                'ts': 704869200,
                'time': '1992-05-03T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'COST'
              },
          2:
              {
                'ts': 733896000,
                'time': '1993-04-04T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'COT'
              }
        },
    'America/Boise':
        {
          0:
              {
                'ts': -1633269600,
                'time': '1918-03-31T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          1:
              {
                'ts': -1615129200,
                'time': '1918-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          2:
              {
                'ts': -1601820000,
                'time': '1919-03-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          3:
              {
                'ts': -1583679600,
                'time': '1919-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          4:
              {
                'ts': -1471788000,
                'time': '1923-05-13T10:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          6:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          7:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          8:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          9:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          10:
              {
                'ts': -52930800,
                'time': '1968-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          11:
              {
                'ts': -37209600,
                'time': '1968-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          12:
              {
                'ts': -21481200,
                'time': '1969-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          13:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          14:
              {
                'ts': 9968400,
                'time': '1970-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          15:
              {
                'ts': 25689600,
                'time': '1970-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          16:
              {
                'ts': 41418000,
                'time': '1971-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          17:
              {
                'ts': 57744000,
                'time': '1971-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          18:
              {
                'ts': 73472400,
                'time': '1972-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          19:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          20:
              {
                'ts': 104922000,
                'time': '1973-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          21:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          22:
              {
                'ts': 129114000,
                'time': '1974-02-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          23:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          24:
              {
                'ts': 162378000,
                'time': '1975-02-23T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          25:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          26:
              {
                'ts': 199270800,
                'time': '1976-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          27:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          28:
              {
                'ts': 230720400,
                'time': '1977-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          29:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          30:
              {
                'ts': 262774800,
                'time': '1978-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          31:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          32:
              {
                'ts': 294224400,
                'time': '1979-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          33:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          34:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          35:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          36:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          37:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          38:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          39:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          40:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          41:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          42:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          43:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          44:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          45:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          46:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          47:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          48:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          49:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          50:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          51:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          52:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          53:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          54:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          55:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          56:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          57:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          58:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          59:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          60:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          61:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          62:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          63:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          64:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          65:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          66:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          67:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          68:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          69:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          70:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          71:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          72:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          73:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          74:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          75:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          76:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          77:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          78:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          79:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          80:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          81:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          82:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          83:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          84:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          85:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          86:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          87:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          88:
              {
                'ts': 1173603600,
                'time': '2007-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          89:
              {
                'ts': 1194163200,
                'time': '2007-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          90:
              {
                'ts': 1205053200,
                'time': '2008-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          91:
              {
                'ts': 1225612800,
                'time': '2008-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          92:
              {
                'ts': 1236502800,
                'time': '2009-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          93:
              {
                'ts': 1257062400,
                'time': '2009-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          94:
              {
                'ts': 1268557200,
                'time': '2010-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          95:
              {
                'ts': 1289116800,
                'time': '2010-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          96:
              {
                'ts': 1300006800,
                'time': '2011-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          97:
              {
                'ts': 1320566400,
                'time': '2011-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          98:
              {
                'ts': 1331456400,
                'time': '2012-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          99:
              {
                'ts': 1352016000,
                'time': '2012-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          100:
              {
                'ts': 1362906000,
                'time': '2013-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          101:
              {
                'ts': 1383465600,
                'time': '2013-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          102:
              {
                'ts': 1394355600,
                'time': '2014-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          103:
              {
                'ts': 1414915200,
                'time': '2014-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          104:
              {
                'ts': 1425805200,
                'time': '2015-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          105:
              {
                'ts': 1446364800,
                'time': '2015-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          106:
              {
                'ts': 1457859600,
                'time': '2016-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          107:
              {
                'ts': 1478419200,
                'time': '2016-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          108:
              {
                'ts': 1489309200,
                'time': '2017-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          109:
              {
                'ts': 1509868800,
                'time': '2017-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          110:
              {
                'ts': 1520758800,
                'time': '2018-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          111:
              {
                'ts': 1541318400,
                'time': '2018-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          112:
              {
                'ts': 1552208400,
                'time': '2019-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          113:
              {
                'ts': 1572768000,
                'time': '2019-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          114:
              {
                'ts': 1583658000,
                'time': '2020-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          115:
              {
                'ts': 1604217600,
                'time': '2020-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          116:
              {
                'ts': 1615712400,
                'time': '2021-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          117:
              {
                'ts': 1636272000,
                'time': '2021-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          118:
              {
                'ts': 1647162000,
                'time': '2022-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          119:
              {
                'ts': 1667721600,
                'time': '2022-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          120:
              {
                'ts': 1678611600,
                'time': '2023-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          121:
              {
                'ts': 1699171200,
                'time': '2023-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          122:
              {
                'ts': 1710061200,
                'time': '2024-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          123:
              {
                'ts': 1730620800,
                'time': '2024-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          124:
              {
                'ts': 1741510800,
                'time': '2025-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          125:
              {
                'ts': 1762070400,
                'time': '2025-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          126:
              {
                'ts': 1772960400,
                'time': '2026-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          127:
              {
                'ts': 1793520000,
                'time': '2026-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          128:
              {
                'ts': 1805014800,
                'time': '2027-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          129:
              {
                'ts': 1825574400,
                'time': '2027-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          130:
              {
                'ts': 1836464400,
                'time': '2028-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          131:
              {
                'ts': 1857024000,
                'time': '2028-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          132:
              {
                'ts': 1867914000,
                'time': '2029-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          133:
              {
                'ts': 1888473600,
                'time': '2029-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          134:
              {
                'ts': 1899363600,
                'time': '2030-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          135:
              {
                'ts': 1919923200,
                'time': '2030-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          136:
              {
                'ts': 1930813200,
                'time': '2031-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          137:
              {
                'ts': 1951372800,
                'time': '2031-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          138:
              {
                'ts': 1962867600,
                'time': '2032-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          139:
              {
                'ts': 1983427200,
                'time': '2032-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          140:
              {
                'ts': 1994317200,
                'time': '2033-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          141:
              {
                'ts': 2014876800,
                'time': '2033-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          142:
              {
                'ts': 2025766800,
                'time': '2034-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          143:
              {
                'ts': 2046326400,
                'time': '2034-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          144:
              {
                'ts': 2057216400,
                'time': '2035-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          145:
              {
                'ts': 2077776000,
                'time': '2035-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          146:
              {
                'ts': 2088666000,
                'time': '2036-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          147:
              {
                'ts': 2109225600,
                'time': '2036-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          148:
              {
                'ts': 2120115600,
                'time': '2037-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          149:
              {
                'ts': 2140675200,
                'time': '2037-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'America/Buenos_Aires':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667965600,
                'time': '1991-03-03T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          50:
              {
                'ts': 687927600,
                'time': '1991-10-20T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          57:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Cambridge_Bay':
        {
          0:
              {
                'ts': -1577923200,
                'time': '1920-01-01T00:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          2:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          3:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': -147891600,
                'time': '1965-04-25T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'MDDT'
              },
          5:
              {
                'ts': -131562000,
                'time': '1965-10-31T07:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          6:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          7:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          8:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          9:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          10:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          11:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          12:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          13:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          14:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          15:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          16:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          17:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          18:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          19:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          20:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          21:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          22:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          23:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          24:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          25:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          26:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          27:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          28:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          29:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          30:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          31:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          32:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          33:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          34:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          35:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          36:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          37:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          38:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          39:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          40:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          41:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          42:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          43:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          44:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          45:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          47:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 973400400,
                'time': '2000-11-05T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          50:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          51:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          52:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          53:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          54:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          55:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          56:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          57:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          58:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          59:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          60:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          61:
              {
                'ts': 1173603600,
                'time': '2007-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          62:
              {
                'ts': 1194163200,
                'time': '2007-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          63:
              {
                'ts': 1205053200,
                'time': '2008-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          64:
              {
                'ts': 1225612800,
                'time': '2008-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          65:
              {
                'ts': 1236502800,
                'time': '2009-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          66:
              {
                'ts': 1257062400,
                'time': '2009-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          67:
              {
                'ts': 1268557200,
                'time': '2010-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          68:
              {
                'ts': 1289116800,
                'time': '2010-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          69:
              {
                'ts': 1300006800,
                'time': '2011-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          70:
              {
                'ts': 1320566400,
                'time': '2011-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          71:
              {
                'ts': 1331456400,
                'time': '2012-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          72:
              {
                'ts': 1352016000,
                'time': '2012-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          73:
              {
                'ts': 1362906000,
                'time': '2013-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          74:
              {
                'ts': 1383465600,
                'time': '2013-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          75:
              {
                'ts': 1394355600,
                'time': '2014-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          76:
              {
                'ts': 1414915200,
                'time': '2014-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          77:
              {
                'ts': 1425805200,
                'time': '2015-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          78:
              {
                'ts': 1446364800,
                'time': '2015-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          79:
              {
                'ts': 1457859600,
                'time': '2016-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          80:
              {
                'ts': 1478419200,
                'time': '2016-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          81:
              {
                'ts': 1489309200,
                'time': '2017-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          82:
              {
                'ts': 1509868800,
                'time': '2017-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          83:
              {
                'ts': 1520758800,
                'time': '2018-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          84:
              {
                'ts': 1541318400,
                'time': '2018-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          85:
              {
                'ts': 1552208400,
                'time': '2019-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          86:
              {
                'ts': 1572768000,
                'time': '2019-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          87:
              {
                'ts': 1583658000,
                'time': '2020-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          88:
              {
                'ts': 1604217600,
                'time': '2020-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          89:
              {
                'ts': 1615712400,
                'time': '2021-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          90:
              {
                'ts': 1636272000,
                'time': '2021-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          91:
              {
                'ts': 1647162000,
                'time': '2022-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          92:
              {
                'ts': 1667721600,
                'time': '2022-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          93:
              {
                'ts': 1678611600,
                'time': '2023-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          94:
              {
                'ts': 1699171200,
                'time': '2023-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          95:
              {
                'ts': 1710061200,
                'time': '2024-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          96:
              {
                'ts': 1730620800,
                'time': '2024-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          97:
              {
                'ts': 1741510800,
                'time': '2025-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          98:
              {
                'ts': 1762070400,
                'time': '2025-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          99:
              {
                'ts': 1772960400,
                'time': '2026-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          100:
              {
                'ts': 1793520000,
                'time': '2026-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          101:
              {
                'ts': 1805014800,
                'time': '2027-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          102:
              {
                'ts': 1825574400,
                'time': '2027-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          103:
              {
                'ts': 1836464400,
                'time': '2028-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          104:
              {
                'ts': 1857024000,
                'time': '2028-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          105:
              {
                'ts': 1867914000,
                'time': '2029-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          106:
              {
                'ts': 1888473600,
                'time': '2029-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          107:
              {
                'ts': 1899363600,
                'time': '2030-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          108:
              {
                'ts': 1919923200,
                'time': '2030-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          109:
              {
                'ts': 1930813200,
                'time': '2031-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          110:
              {
                'ts': 1951372800,
                'time': '2031-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          111:
              {
                'ts': 1962867600,
                'time': '2032-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          112:
              {
                'ts': 1983427200,
                'time': '2032-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          113:
              {
                'ts': 1994317200,
                'time': '2033-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          114:
              {
                'ts': 2014876800,
                'time': '2033-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          115:
              {
                'ts': 2025766800,
                'time': '2034-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          116:
              {
                'ts': 2046326400,
                'time': '2034-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          117:
              {
                'ts': 2057216400,
                'time': '2035-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          118:
              {
                'ts': 2077776000,
                'time': '2035-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          119:
              {
                'ts': 2088666000,
                'time': '2036-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          120:
              {
                'ts': 2109225600,
                'time': '2036-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          121:
              {
                'ts': 2120115600,
                'time': '2037-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          122:
              {
                'ts': 2140675200,
                'time': '2037-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'America/Campo_Grande':
        {
          0:
              {
                'ts': -1767212492,
                'time': '1914-01-01T03:38:28+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          1:
              {
                'ts': -1206954000,
                'time': '1931-10-03T15:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          2:
              {
                'ts': -1191358800,
                'time': '1932-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          3:
              {
                'ts': -1175371200,
                'time': '1932-10-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          4:
              {
                'ts': -1159822800,
                'time': '1933-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          5:
              {
                'ts': -633816000,
                'time': '1949-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          6:
              {
                'ts': -622065600,
                'time': '1950-04-16T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          7:
              {
                'ts': -602280000,
                'time': '1950-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          8:
              {
                'ts': -591829200,
                'time': '1951-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          9:
              {
                'ts': -570744000,
                'time': '1951-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          10:
              {
                'ts': -560206800,
                'time': '1952-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          11:
              {
                'ts': -539121600,
                'time': '1952-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          12:
              {
                'ts': -531349200,
                'time': '1953-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          13:
              {
                'ts': -191361600,
                'time': '1963-12-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          14:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          15:
              {
                'ts': -155160000,
                'time': '1965-01-31T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          16:
              {
                'ts': -150066000,
                'time': '1965-03-31T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          17:
              {
                'ts': -128894400,
                'time': '1965-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          18:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          19:
              {
                'ts': -99950400,
                'time': '1966-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          20:
              {
                'ts': -89586000,
                'time': '1967-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          21:
              {
                'ts': -68414400,
                'time': '1967-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          22:
              {
                'ts': -57963600,
                'time': '1968-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          23:
              {
                'ts': 499752000,
                'time': '1985-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          24:
              {
                'ts': 511239600,
                'time': '1986-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          25:
              {
                'ts': 530596800,
                'time': '1986-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          26:
              {
                'ts': 540270000,
                'time': '1987-02-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          27:
              {
                'ts': 562132800,
                'time': '1987-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          28:
              {
                'ts': 571201200,
                'time': '1988-02-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          29:
              {
                'ts': 592977600,
                'time': '1988-10-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          30:
              {
                'ts': 602046000,
                'time': '1989-01-29T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          31:
              {
                'ts': 624427200,
                'time': '1989-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          32:
              {
                'ts': 634705200,
                'time': '1990-02-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          33:
              {
                'ts': 656481600,
                'time': '1990-10-21T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          34:
              {
                'ts': 666759600,
                'time': '1991-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          35:
              {
                'ts': 687931200,
                'time': '1991-10-20T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          36:
              {
                'ts': 697604400,
                'time': '1992-02-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          37:
              {
                'ts': 719985600,
                'time': '1992-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          38:
              {
                'ts': 728449200,
                'time': '1993-01-31T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          39:
              {
                'ts': 750830400,
                'time': '1993-10-17T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          40:
              {
                'ts': 761713200,
                'time': '1994-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          41:
              {
                'ts': 782280000,
                'time': '1994-10-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          42:
              {
                'ts': 793162800,
                'time': '1995-02-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          43:
              {
                'ts': 813729600,
                'time': '1995-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          44:
              {
                'ts': 824007600,
                'time': '1996-02-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          45:
              {
                'ts': 844574400,
                'time': '1996-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          46:
              {
                'ts': 856062000,
                'time': '1997-02-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          47:
              {
                'ts': 876110400,
                'time': '1997-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          48:
              {
                'ts': 888721200,
                'time': '1998-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          49:
              {
                'ts': 908078400,
                'time': '1998-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          50:
              {
                'ts': 919566000,
                'time': '1999-02-21T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          51:
              {
                'ts': 938923200,
                'time': '1999-10-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          52:
              {
                'ts': 951620400,
                'time': '2000-02-27T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          53:
              {
                'ts': 970977600,
                'time': '2000-10-08T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          54:
              {
                'ts': 982465200,
                'time': '2001-02-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          55:
              {
                'ts': 1003032000,
                'time': '2001-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          56:
              {
                'ts': 1013914800,
                'time': '2002-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          57:
              {
                'ts': 1036296000,
                'time': '2002-11-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          58:
              {
                'ts': 1045364400,
                'time': '2003-02-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          59:
              {
                'ts': 1066536000,
                'time': '2003-10-19T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          60:
              {
                'ts': 1076814000,
                'time': '2004-02-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          61:
              {
                'ts': 1099368000,
                'time': '2004-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          62:
              {
                'ts': 1108868400,
                'time': '2005-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          63:
              {
                'ts': 1129435200,
                'time': '2005-10-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          64:
              {
                'ts': 1140318000,
                'time': '2006-02-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          65:
              {
                'ts': 1162699200,
                'time': '2006-11-05T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          66:
              {
                'ts': 1172372400,
                'time': '2007-02-25T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          67:
              {
                'ts': 1192334400,
                'time': '2007-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          68:
              {
                'ts': 1203217200,
                'time': '2008-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          69:
              {
                'ts': 1223784000,
                'time': '2008-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          70:
              {
                'ts': 1234666800,
                'time': '2009-02-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          71:
              {
                'ts': 1255233600,
                'time': '2009-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          72:
              {
                'ts': 1266721200,
                'time': '2010-02-21T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          73:
              {
                'ts': 1286683200,
                'time': '2010-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          74:
              {
                'ts': 1298170800,
                'time': '2011-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          75:
              {
                'ts': 1318132800,
                'time': '2011-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          76:
              {
                'ts': 1329620400,
                'time': '2012-02-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          77:
              {
                'ts': 1350187200,
                'time': '2012-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          78:
              {
                'ts': 1361070000,
                'time': '2013-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          79:
              {
                'ts': 1381636800,
                'time': '2013-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          80:
              {
                'ts': 1392519600,
                'time': '2014-02-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          81:
              {
                'ts': 1413086400,
                'time': '2014-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          82:
              {
                'ts': 1423969200,
                'time': '2015-02-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          83:
              {
                'ts': 1444536000,
                'time': '2015-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          84:
              {
                'ts': 1456023600,
                'time': '2016-02-21T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          85:
              {
                'ts': 1475985600,
                'time': '2016-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          86:
              {
                'ts': 1487473200,
                'time': '2017-02-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          87:
              {
                'ts': 1507435200,
                'time': '2017-10-08T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          88:
              {
                'ts': 1518922800,
                'time': '2018-02-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          89:
              {
                'ts': 1539489600,
                'time': '2018-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          90:
              {
                'ts': 1550372400,
                'time': '2019-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          91:
              {
                'ts': 1570939200,
                'time': '2019-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          92:
              {
                'ts': 1581822000,
                'time': '2020-02-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          93:
              {
                'ts': 1602388800,
                'time': '2020-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          94:
              {
                'ts': 1613876400,
                'time': '2021-02-21T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          95:
              {
                'ts': 1633838400,
                'time': '2021-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          96:
              {
                'ts': 1645326000,
                'time': '2022-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          97:
              {
                'ts': 1665288000,
                'time': '2022-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          98:
              {
                'ts': 1676775600,
                'time': '2023-02-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          99:
              {
                'ts': 1696737600,
                'time': '2023-10-08T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          100:
              {
                'ts': 1708225200,
                'time': '2024-02-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          101:
              {
                'ts': 1728792000,
                'time': '2024-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          102:
              {
                'ts': 1739674800,
                'time': '2025-02-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          103:
              {
                'ts': 1760241600,
                'time': '2025-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          104:
              {
                'ts': 1771124400,
                'time': '2026-02-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          105:
              {
                'ts': 1791691200,
                'time': '2026-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          106:
              {
                'ts': 1803178800,
                'time': '2027-02-21T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          107:
              {
                'ts': 1823140800,
                'time': '2027-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          108:
              {
                'ts': 1834628400,
                'time': '2028-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          109:
              {
                'ts': 1854590400,
                'time': '2028-10-08T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          110:
              {
                'ts': 1866078000,
                'time': '2029-02-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          111:
              {
                'ts': 1886644800,
                'time': '2029-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          112:
              {
                'ts': 1897527600,
                'time': '2030-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          113:
              {
                'ts': 1918094400,
                'time': '2030-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          114:
              {
                'ts': 1928977200,
                'time': '2031-02-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          115:
              {
                'ts': 1949544000,
                'time': '2031-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          116:
              {
                'ts': 1960426800,
                'time': '2032-02-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          117:
              {
                'ts': 1980993600,
                'time': '2032-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          118:
              {
                'ts': 1992481200,
                'time': '2033-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          119:
              {
                'ts': 2012443200,
                'time': '2033-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          120:
              {
                'ts': 2023930800,
                'time': '2034-02-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          121:
              {
                'ts': 2043892800,
                'time': '2034-10-08T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          122:
              {
                'ts': 2055380400,
                'time': '2035-02-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          123:
              {
                'ts': 2075947200,
                'time': '2035-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          124:
              {
                'ts': 2086830000,
                'time': '2036-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          125:
              {
                'ts': 2107396800,
                'time': '2036-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          126:
              {
                'ts': 2118279600,
                'time': '2037-02-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          127:
              {
                'ts': 2138846400,
                'time': '2037-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              }
        },
    'America/Cancun':
        {
          0:
              {
                'ts': -1514743200,
                'time': '1922-01-01T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': 377935200,
                'time': '1981-12-23T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          3:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          5:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          7:
              {
                'ts': 902037600,
                'time': '1998-08-02T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 989136000,
                'time': '2001-05-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': 1001833200,
                'time': '2001-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 1175414400,
                'time': '2007-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': 1193554800,
                'time': '2007-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 1207468800,
                'time': '2008-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': 1225004400,
                'time': '2008-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 1238918400,
                'time': '2009-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': 1256454000,
                'time': '2009-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 1270368000,
                'time': '2010-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': 1288508400,
                'time': '2010-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 1301817600,
                'time': '2011-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': 1319958000,
                'time': '2011-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 1333267200,
                'time': '2012-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': 1351407600,
                'time': '2012-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 1365321600,
                'time': '2013-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          38:
              {
                'ts': 1382857200,
                'time': '2013-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 1396771200,
                'time': '2014-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': 1414306800,
                'time': '2014-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 1428220800,
                'time': '2015-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': 1445756400,
                'time': '2015-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 1459670400,
                'time': '2016-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': 1477810800,
                'time': '2016-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 1491120000,
                'time': '2017-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 1509260400,
                'time': '2017-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 1522569600,
                'time': '2018-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 1540710000,
                'time': '2018-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 1554624000,
                'time': '2019-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 1572159600,
                'time': '2019-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 1586073600,
                'time': '2020-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 1603609200,
                'time': '2020-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 1617523200,
                'time': '2021-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 1635663600,
                'time': '2021-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 1648972800,
                'time': '2022-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 1667113200,
                'time': '2022-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 1680422400,
                'time': '2023-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 1698562800,
                'time': '2023-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 1712476800,
                'time': '2024-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 1730012400,
                'time': '2024-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 1743926400,
                'time': '2025-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 1761462000,
                'time': '2025-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 1775376000,
                'time': '2026-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 1792911600,
                'time': '2026-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 1806825600,
                'time': '2027-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 1824966000,
                'time': '2027-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 1838275200,
                'time': '2028-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 1856415600,
                'time': '2028-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 1869724800,
                'time': '2029-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 1887865200,
                'time': '2029-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 1901779200,
                'time': '2030-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 1919314800,
                'time': '2030-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 1933228800,
                'time': '2031-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 1950764400,
                'time': '2031-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 1964678400,
                'time': '2032-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 1982818800,
                'time': '2032-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 1996128000,
                'time': '2033-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 2014268400,
                'time': '2033-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 2027577600,
                'time': '2034-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 2045718000,
                'time': '2034-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 2059027200,
                'time': '2035-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 2077167600,
                'time': '2035-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 2091081600,
                'time': '2036-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 2108617200,
                'time': '2036-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 2122531200,
                'time': '2037-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 2140066800,
                'time': '2037-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Caracas':
        {
          0:
              {
                'ts': -1826739140,
                'time': '1912-02-12T04:27:40+0000',
                'offset': -16200,
                'isdst': false,
                'abbr': 'VET'
              },
          1:
              {
                'ts': -157750200,
                'time': '1965-01-01T04:30:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'VET'
              },
          2:
              {
                'ts': 1197183600,
                'time': '2007-12-09T07:00:00+0000',
                'offset': -16200,
                'isdst': false,
                'abbr': 'VET'
              }
        },
    'America/Catamarca':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667965600,
                'time': '1991-03-03T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 687931200,
                'time': '1991-10-20T04:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1086058800,
                'time': '2004-06-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          57:
              {
                'ts': 1087704000,
                'time': '2004-06-20T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          117:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          118:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Cayenne':
        {
          0:
              {
                'ts': -1846269040,
                'time': '1911-07-01T03:29:20+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'GFT'
              },
          1:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'GFT'
              }
        },
    'America/Cayman':
        {
          0:
              {
                'ts': -1827687168,
                'time': '1912-02-01T05:07:12+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Chicago':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -1563724800,
                'time': '1920-06-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': -1551632400,
                'time': '1920-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -1538928000,
                'time': '1921-03-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': -1520182800,
                'time': '1921-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': -1504454400,
                'time': '1922-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          9:
              {
                'ts': -1491757200,
                'time': '1922-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': -1473004800,
                'time': '1923-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          11:
              {
                'ts': -1459702800,
                'time': '1923-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': -1441555200,
                'time': '1924-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          13:
              {
                'ts': -1428253200,
                'time': '1924-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          14:
              {
                'ts': -1410105600,
                'time': '1925-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          15:
              {
                'ts': -1396803600,
                'time': '1925-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          16:
              {
                'ts': -1378656000,
                'time': '1926-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          17:
              {
                'ts': -1365354000,
                'time': '1926-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          18:
              {
                'ts': -1347206400,
                'time': '1927-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          19:
              {
                'ts': -1333904400,
                'time': '1927-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          20:
              {
                'ts': -1315152000,
                'time': '1928-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          21:
              {
                'ts': -1301850000,
                'time': '1928-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          22:
              {
                'ts': -1283702400,
                'time': '1929-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          23:
              {
                'ts': -1270400400,
                'time': '1929-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          24:
              {
                'ts': -1252252800,
                'time': '1930-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          25:
              {
                'ts': -1238950800,
                'time': '1930-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          26:
              {
                'ts': -1220803200,
                'time': '1931-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          27:
              {
                'ts': -1207501200,
                'time': '1931-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          28:
              {
                'ts': -1189353600,
                'time': '1932-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          29:
              {
                'ts': -1176051600,
                'time': '1932-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          30:
              {
                'ts': -1157299200,
                'time': '1933-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          31:
              {
                'ts': -1144602000,
                'time': '1933-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          32:
              {
                'ts': -1125849600,
                'time': '1934-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          33:
              {
                'ts': -1112547600,
                'time': '1934-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          34:
              {
                'ts': -1094400000,
                'time': '1935-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          35:
              {
                'ts': -1081098000,
                'time': '1935-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          36:
              {
                'ts': -1067788800,
                'time': '1936-03-01T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          37:
              {
                'ts': -1045414800,
                'time': '1936-11-15T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': -1031500800,
                'time': '1937-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          39:
              {
                'ts': -1018198800,
                'time': '1937-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          40:
              {
                'ts': -1000051200,
                'time': '1938-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          41:
              {
                'ts': -986749200,
                'time': '1938-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          42:
              {
                'ts': -967996800,
                'time': '1939-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          43:
              {
                'ts': -955299600,
                'time': '1939-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          44:
              {
                'ts': -936547200,
                'time': '1940-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          45:
              {
                'ts': -923245200,
                'time': '1940-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': -905097600,
                'time': '1941-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          47:
              {
                'ts': -891795600,
                'time': '1941-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          48:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          49:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          50:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': -747244800,
                'time': '1946-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': -733942800,
                'time': '1946-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': -702493200,
                'time': '1947-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': -684345600,
                'time': '1948-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': -671043600,
                'time': '1948-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': -652896000,
                'time': '1949-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': -639594000,
                'time': '1949-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': -620841600,
                'time': '1950-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': -608144400,
                'time': '1950-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': -447267600,
                'time': '1955-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': -415818000,
                'time': '1956-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': -384368400,
                'time': '1957-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': -352918800,
                'time': '1958-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': -321469200,
                'time': '1959-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': -289414800,
                'time': '1960-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': -273686400,
                'time': '1961-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': -257965200,
                'time': '1961-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': -242236800,
                'time': '1962-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': -226515600,
                'time': '1962-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': -210787200,
                'time': '1963-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': -195066000,
                'time': '1963-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': -179337600,
                'time': '1964-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': -163616400,
                'time': '1964-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          89:
              {
                'ts': -147888000,
                'time': '1965-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': -131562000,
                'time': '1965-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': -116438400,
                'time': '1966-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': -100112400,
                'time': '1966-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': -84384000,
                'time': '1967-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': -68662800,
                'time': '1967-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': -52934400,
                'time': '1968-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': -37213200,
                'time': '1968-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': -21484800,
                'time': '1969-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': -5763600,
                'time': '1969-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 9964800,
                'time': '1970-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 25686000,
                'time': '1970-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 41414400,
                'time': '1971-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 57740400,
                'time': '1971-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 73468800,
                'time': '1972-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 89190000,
                'time': '1972-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 104918400,
                'time': '1973-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 120639600,
                'time': '1973-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 126691200,
                'time': '1974-01-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 162374400,
                'time': '1975-02-23T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 183538800,
                'time': '1975-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 199267200,
                'time': '1976-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 215593200,
                'time': '1976-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 230716800,
                'time': '1977-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 247042800,
                'time': '1977-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 262771200,
                'time': '1978-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 278492400,
                'time': '1978-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 294220800,
                'time': '1979-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 309942000,
                'time': '1979-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          120:
              {
                'ts': 341391600,
                'time': '1980-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          122:
              {
                'ts': 372841200,
                'time': '1981-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          124:
              {
                'ts': 404895600,
                'time': '1982-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          126:
              {
                'ts': 436345200,
                'time': '1983-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          128:
              {
                'ts': 467794800,
                'time': '1984-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          130:
              {
                'ts': 499244400,
                'time': '1985-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          132:
              {
                'ts': 530694000,
                'time': '1986-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          134:
              {
                'ts': 562143600,
                'time': '1987-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          136:
              {
                'ts': 594198000,
                'time': '1988-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          138:
              {
                'ts': 625647600,
                'time': '1989-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          140:
              {
                'ts': 657097200,
                'time': '1990-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          141:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          142:
              {
                'ts': 688546800,
                'time': '1991-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          143:
              {
                'ts': 702460800,
                'time': '1992-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          144:
              {
                'ts': 719996400,
                'time': '1992-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          145:
              {
                'ts': 733910400,
                'time': '1993-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          146:
              {
                'ts': 752050800,
                'time': '1993-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          147:
              {
                'ts': 765360000,
                'time': '1994-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          148:
              {
                'ts': 783500400,
                'time': '1994-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          149:
              {
                'ts': 796809600,
                'time': '1995-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          150:
              {
                'ts': 814950000,
                'time': '1995-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          151:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          152:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          153:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          154:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          155:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          156:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          157:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          158:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          159:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          160:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          161:
              {
                'ts': 986112000,
                'time': '2001-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          162:
              {
                'ts': 1004252400,
                'time': '2001-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          163:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          164:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          165:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          166:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          167:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          168:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          169:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          170:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          171:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          172:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          173:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          174:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          175:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          176:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          177:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          178:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          179:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          180:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          181:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          182:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          183:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          184:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          185:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          186:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          187:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          188:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          189:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          190:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          191:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          192:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          193:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          194:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          195:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          196:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          197:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          198:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          199:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          200:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          201:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          202:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          203:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          204:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          205:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          206:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          207:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          208:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          209:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          210:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          211:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          212:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          213:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          214:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          215:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          216:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          217:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          218:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          219:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          220:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          221:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          222:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          223:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          224:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          225:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          226:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          227:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          228:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          229:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          230:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          231:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          232:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          233:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          234:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Chihuahua':
        {
          0:
              {
                'ts': -1514739600,
                'time': '1922-01-01T07:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1343066400,
                'time': '1927-06-11T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1234807200,
                'time': '1930-11-15T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1220292000,
                'time': '1931-05-02T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -1207159200,
                'time': '1931-10-01T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1191344400,
                'time': '1932-04-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          9:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          11:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          12:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          13:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          14:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          15:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          16:
              {
                'ts': 989139600,
                'time': '2001-05-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          17:
              {
                'ts': 1001836800,
                'time': '2001-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          18:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          19:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          20:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          21:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          22:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          23:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          24:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          25:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          26:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          27:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          28:
              {
                'ts': 1175418000,
                'time': '2007-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          29:
              {
                'ts': 1193558400,
                'time': '2007-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          30:
              {
                'ts': 1207472400,
                'time': '2008-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          31:
              {
                'ts': 1225008000,
                'time': '2008-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          32:
              {
                'ts': 1238922000,
                'time': '2009-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          33:
              {
                'ts': 1256457600,
                'time': '2009-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          34:
              {
                'ts': 1270371600,
                'time': '2010-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          35:
              {
                'ts': 1288512000,
                'time': '2010-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          36:
              {
                'ts': 1301821200,
                'time': '2011-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          37:
              {
                'ts': 1319961600,
                'time': '2011-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          38:
              {
                'ts': 1333270800,
                'time': '2012-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          39:
              {
                'ts': 1351411200,
                'time': '2012-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          40:
              {
                'ts': 1365325200,
                'time': '2013-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          41:
              {
                'ts': 1382860800,
                'time': '2013-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          42:
              {
                'ts': 1396774800,
                'time': '2014-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          43:
              {
                'ts': 1414310400,
                'time': '2014-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          44:
              {
                'ts': 1428224400,
                'time': '2015-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          45:
              {
                'ts': 1445760000,
                'time': '2015-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          46:
              {
                'ts': 1459674000,
                'time': '2016-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          47:
              {
                'ts': 1477814400,
                'time': '2016-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          48:
              {
                'ts': 1491123600,
                'time': '2017-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          49:
              {
                'ts': 1509264000,
                'time': '2017-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          50:
              {
                'ts': 1522573200,
                'time': '2018-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          51:
              {
                'ts': 1540713600,
                'time': '2018-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          52:
              {
                'ts': 1554627600,
                'time': '2019-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          53:
              {
                'ts': 1572163200,
                'time': '2019-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          54:
              {
                'ts': 1586077200,
                'time': '2020-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          55:
              {
                'ts': 1603612800,
                'time': '2020-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          56:
              {
                'ts': 1617526800,
                'time': '2021-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          57:
              {
                'ts': 1635667200,
                'time': '2021-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          58:
              {
                'ts': 1648976400,
                'time': '2022-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          59:
              {
                'ts': 1667116800,
                'time': '2022-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          60:
              {
                'ts': 1680426000,
                'time': '2023-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          61:
              {
                'ts': 1698566400,
                'time': '2023-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          62:
              {
                'ts': 1712480400,
                'time': '2024-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          63:
              {
                'ts': 1730016000,
                'time': '2024-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          64:
              {
                'ts': 1743930000,
                'time': '2025-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          65:
              {
                'ts': 1761465600,
                'time': '2025-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          66:
              {
                'ts': 1775379600,
                'time': '2026-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          67:
              {
                'ts': 1792915200,
                'time': '2026-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          68:
              {
                'ts': 1806829200,
                'time': '2027-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          69:
              {
                'ts': 1824969600,
                'time': '2027-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          70:
              {
                'ts': 1838278800,
                'time': '2028-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          71:
              {
                'ts': 1856419200,
                'time': '2028-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          72:
              {
                'ts': 1869728400,
                'time': '2029-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          73:
              {
                'ts': 1887868800,
                'time': '2029-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          74:
              {
                'ts': 1901782800,
                'time': '2030-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          75:
              {
                'ts': 1919318400,
                'time': '2030-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          76:
              {
                'ts': 1933232400,
                'time': '2031-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          77:
              {
                'ts': 1950768000,
                'time': '2031-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          78:
              {
                'ts': 1964682000,
                'time': '2032-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          79:
              {
                'ts': 1982822400,
                'time': '2032-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          80:
              {
                'ts': 1996131600,
                'time': '2033-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          81:
              {
                'ts': 2014272000,
                'time': '2033-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          82:
              {
                'ts': 2027581200,
                'time': '2034-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          83:
              {
                'ts': 2045721600,
                'time': '2034-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          84:
              {
                'ts': 2059030800,
                'time': '2035-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          85:
              {
                'ts': 2077171200,
                'time': '2035-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          86:
              {
                'ts': 2091085200,
                'time': '2036-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          87:
              {
                'ts': 2108620800,
                'time': '2036-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          88:
              {
                'ts': 2122534800,
                'time': '2037-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          89:
              {
                'ts': 2140070400,
                'time': '2037-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'America/Coral_Harbour':
        {
          0:
              {
                'ts': -1632067200,
                'time': '1918-04-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1614790800,
                'time': '1918-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -923248800,
                'time': '1940-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          4:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          5:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Cordoba':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667965600,
                'time': '1991-03-03T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 687931200,
                'time': '1991-10-20T04:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          57:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Costa_Rica':
        {
          0:
              {
                'ts': -1545071020,
                'time': '1921-01-15T05:36:20+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': 288770400,
                'time': '1979-02-25T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          2:
              {
                'ts': 297234000,
                'time': '1979-06-03T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': 320220000,
                'time': '1980-02-24T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': 328683600,
                'time': '1980-06-01T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': 664264800,
                'time': '1991-01-19T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': 678344400,
                'time': '1991-07-01T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': 695714400,
                'time': '1992-01-18T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': 700635600,
                'time': '1992-03-15T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Cuiaba':
        {
          0:
              {
                'ts': -1767212140,
                'time': '1914-01-01T03:44:20+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          1:
              {
                'ts': -1206954000,
                'time': '1931-10-03T15:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          2:
              {
                'ts': -1191358800,
                'time': '1932-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          3:
              {
                'ts': -1175371200,
                'time': '1932-10-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          4:
              {
                'ts': -1159822800,
                'time': '1933-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          5:
              {
                'ts': -633816000,
                'time': '1949-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          6:
              {
                'ts': -622065600,
                'time': '1950-04-16T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          7:
              {
                'ts': -602280000,
                'time': '1950-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          8:
              {
                'ts': -591829200,
                'time': '1951-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          9:
              {
                'ts': -570744000,
                'time': '1951-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          10:
              {
                'ts': -560206800,
                'time': '1952-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          11:
              {
                'ts': -539121600,
                'time': '1952-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          12:
              {
                'ts': -531349200,
                'time': '1953-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          13:
              {
                'ts': -191361600,
                'time': '1963-12-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          14:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          15:
              {
                'ts': -155160000,
                'time': '1965-01-31T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          16:
              {
                'ts': -150066000,
                'time': '1965-03-31T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          17:
              {
                'ts': -128894400,
                'time': '1965-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          18:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          19:
              {
                'ts': -99950400,
                'time': '1966-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          20:
              {
                'ts': -89586000,
                'time': '1967-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          21:
              {
                'ts': -68414400,
                'time': '1967-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          22:
              {
                'ts': -57963600,
                'time': '1968-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          23:
              {
                'ts': 499752000,
                'time': '1985-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          24:
              {
                'ts': 511239600,
                'time': '1986-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          25:
              {
                'ts': 530596800,
                'time': '1986-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          26:
              {
                'ts': 540270000,
                'time': '1987-02-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          27:
              {
                'ts': 562132800,
                'time': '1987-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          28:
              {
                'ts': 571201200,
                'time': '1988-02-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          29:
              {
                'ts': 592977600,
                'time': '1988-10-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          30:
              {
                'ts': 602046000,
                'time': '1989-01-29T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          31:
              {
                'ts': 624427200,
                'time': '1989-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          32:
              {
                'ts': 634705200,
                'time': '1990-02-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          33:
              {
                'ts': 656481600,
                'time': '1990-10-21T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          34:
              {
                'ts': 666759600,
                'time': '1991-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          35:
              {
                'ts': 687931200,
                'time': '1991-10-20T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          36:
              {
                'ts': 697604400,
                'time': '1992-02-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          37:
              {
                'ts': 719985600,
                'time': '1992-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          38:
              {
                'ts': 728449200,
                'time': '1993-01-31T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          39:
              {
                'ts': 750830400,
                'time': '1993-10-17T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          40:
              {
                'ts': 761713200,
                'time': '1994-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          41:
              {
                'ts': 782280000,
                'time': '1994-10-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          42:
              {
                'ts': 793162800,
                'time': '1995-02-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          43:
              {
                'ts': 813729600,
                'time': '1995-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          44:
              {
                'ts': 824007600,
                'time': '1996-02-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          45:
              {
                'ts': 844574400,
                'time': '1996-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          46:
              {
                'ts': 856062000,
                'time': '1997-02-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          47:
              {
                'ts': 876110400,
                'time': '1997-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          48:
              {
                'ts': 888721200,
                'time': '1998-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          49:
              {
                'ts': 908078400,
                'time': '1998-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          50:
              {
                'ts': 919566000,
                'time': '1999-02-21T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          51:
              {
                'ts': 938923200,
                'time': '1999-10-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          52:
              {
                'ts': 951620400,
                'time': '2000-02-27T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          53:
              {
                'ts': 970977600,
                'time': '2000-10-08T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          54:
              {
                'ts': 982465200,
                'time': '2001-02-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          55:
              {
                'ts': 1003032000,
                'time': '2001-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          56:
              {
                'ts': 1013914800,
                'time': '2002-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          57:
              {
                'ts': 1036296000,
                'time': '2002-11-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          58:
              {
                'ts': 1045364400,
                'time': '2003-02-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          59:
              {
                'ts': 1099368000,
                'time': '2004-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          60:
              {
                'ts': 1108868400,
                'time': '2005-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          61:
              {
                'ts': 1129435200,
                'time': '2005-10-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          62:
              {
                'ts': 1140318000,
                'time': '2006-02-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          63:
              {
                'ts': 1162699200,
                'time': '2006-11-05T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          64:
              {
                'ts': 1172372400,
                'time': '2007-02-25T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          65:
              {
                'ts': 1192334400,
                'time': '2007-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          66:
              {
                'ts': 1203217200,
                'time': '2008-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          67:
              {
                'ts': 1223784000,
                'time': '2008-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          68:
              {
                'ts': 1234666800,
                'time': '2009-02-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          69:
              {
                'ts': 1255233600,
                'time': '2009-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          70:
              {
                'ts': 1266721200,
                'time': '2010-02-21T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          71:
              {
                'ts': 1286683200,
                'time': '2010-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          72:
              {
                'ts': 1298170800,
                'time': '2011-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          73:
              {
                'ts': 1318132800,
                'time': '2011-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          74:
              {
                'ts': 1329620400,
                'time': '2012-02-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          75:
              {
                'ts': 1350187200,
                'time': '2012-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          76:
              {
                'ts': 1361070000,
                'time': '2013-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          77:
              {
                'ts': 1381636800,
                'time': '2013-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          78:
              {
                'ts': 1392519600,
                'time': '2014-02-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          79:
              {
                'ts': 1413086400,
                'time': '2014-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          80:
              {
                'ts': 1423969200,
                'time': '2015-02-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          81:
              {
                'ts': 1444536000,
                'time': '2015-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          82:
              {
                'ts': 1456023600,
                'time': '2016-02-21T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          83:
              {
                'ts': 1475985600,
                'time': '2016-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          84:
              {
                'ts': 1487473200,
                'time': '2017-02-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          85:
              {
                'ts': 1507435200,
                'time': '2017-10-08T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          86:
              {
                'ts': 1518922800,
                'time': '2018-02-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          87:
              {
                'ts': 1539489600,
                'time': '2018-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          88:
              {
                'ts': 1550372400,
                'time': '2019-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          89:
              {
                'ts': 1570939200,
                'time': '2019-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          90:
              {
                'ts': 1581822000,
                'time': '2020-02-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          91:
              {
                'ts': 1602388800,
                'time': '2020-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          92:
              {
                'ts': 1613876400,
                'time': '2021-02-21T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          93:
              {
                'ts': 1633838400,
                'time': '2021-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          94:
              {
                'ts': 1645326000,
                'time': '2022-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          95:
              {
                'ts': 1665288000,
                'time': '2022-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          96:
              {
                'ts': 1676775600,
                'time': '2023-02-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          97:
              {
                'ts': 1696737600,
                'time': '2023-10-08T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          98:
              {
                'ts': 1708225200,
                'time': '2024-02-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          99:
              {
                'ts': 1728792000,
                'time': '2024-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          100:
              {
                'ts': 1739674800,
                'time': '2025-02-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          101:
              {
                'ts': 1760241600,
                'time': '2025-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          102:
              {
                'ts': 1771124400,
                'time': '2026-02-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          103:
              {
                'ts': 1791691200,
                'time': '2026-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          104:
              {
                'ts': 1803178800,
                'time': '2027-02-21T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          105:
              {
                'ts': 1823140800,
                'time': '2027-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          106:
              {
                'ts': 1834628400,
                'time': '2028-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          107:
              {
                'ts': 1854590400,
                'time': '2028-10-08T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          108:
              {
                'ts': 1866078000,
                'time': '2029-02-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          109:
              {
                'ts': 1886644800,
                'time': '2029-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          110:
              {
                'ts': 1897527600,
                'time': '2030-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          111:
              {
                'ts': 1918094400,
                'time': '2030-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          112:
              {
                'ts': 1928977200,
                'time': '2031-02-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          113:
              {
                'ts': 1949544000,
                'time': '2031-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          114:
              {
                'ts': 1960426800,
                'time': '2032-02-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          115:
              {
                'ts': 1980993600,
                'time': '2032-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          116:
              {
                'ts': 1992481200,
                'time': '2033-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          117:
              {
                'ts': 2012443200,
                'time': '2033-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          118:
              {
                'ts': 2023930800,
                'time': '2034-02-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          119:
              {
                'ts': 2043892800,
                'time': '2034-10-08T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          120:
              {
                'ts': 2055380400,
                'time': '2035-02-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          121:
              {
                'ts': 2075947200,
                'time': '2035-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          122:
              {
                'ts': 2086830000,
                'time': '2036-02-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          123:
              {
                'ts': 2107396800,
                'time': '2036-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          124:
              {
                'ts': 2118279600,
                'time': '2037-02-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          125:
              {
                'ts': 2138846400,
                'time': '2037-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              }
        },
    'America/Curacao':
        {
          0:
              {
                'ts': -1826738656,
                'time': '1912-02-12T04:35:44+0000',
                'offset': -16200,
                'isdst': false,
                'abbr': 'ANT'
              },
          1:
              {
                'ts': -157750200,
                'time': '1965-01-01T04:30:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Danmarkshavn':
        {
          0:
              {
                'ts': -1686091520,
                'time': '1916-07-28T01:14:40+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          1:
              {
                'ts': 323845200,
                'time': '1980-04-06T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          2:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          3:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          4:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          5:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          6:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          7:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          8:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          9:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          10:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          11:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          12:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          13:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          14:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          15:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          16:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          17:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          18:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          19:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          20:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          21:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          22:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          23:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          24:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          25:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          26:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          27:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          28:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          29:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          30:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          31:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          32:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          33:
              {
                'ts': 820465200,
                'time': '1996-01-01T03:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'America/Dawson':
        {
          0:
              {
                'ts': -1632056400,
                'time': '1918-04-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          1:
              {
                'ts': -1615125600,
                'time': '1918-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          2:
              {
                'ts': -1596978000,
                'time': '1919-05-25T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          3:
              {
                'ts': -1583164800,
                'time': '1919-11-01T08:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          4:
              {
                'ts': -880203600,
                'time': '1942-02-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YPT'
              },
          6:
              {
                'ts': -765381600,
                'time': '1945-09-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          7:
              {
                'ts': -147884400,
                'time': '1965-04-25T09:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'YDDT'
              },
          8:
              {
                'ts': -131554800,
                'time': '1965-10-31T09:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          9:
              {
                'ts': 120646800,
                'time': '1973-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          10:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          11:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          12:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          13:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          14:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          15:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          16:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          17:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          18:
              {
                'ts': 452080800,
                'time': '1984-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          19:
              {
                'ts': 467802000,
                'time': '1984-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          20:
              {
                'ts': 483530400,
                'time': '1985-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          21:
              {
                'ts': 499251600,
                'time': '1985-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          22:
              {
                'ts': 514980000,
                'time': '1986-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          23:
              {
                'ts': 530701200,
                'time': '1986-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          24:
              {
                'ts': 544615200,
                'time': '1987-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          25:
              {
                'ts': 562150800,
                'time': '1987-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          26:
              {
                'ts': 576064800,
                'time': '1988-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          27:
              {
                'ts': 594205200,
                'time': '1988-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          28:
              {
                'ts': 607514400,
                'time': '1989-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          29:
              {
                'ts': 625654800,
                'time': '1989-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          30:
              {
                'ts': 638964000,
                'time': '1990-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          31:
              {
                'ts': 657104400,
                'time': '1990-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          32:
              {
                'ts': 671018400,
                'time': '1991-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          33:
              {
                'ts': 688554000,
                'time': '1991-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          34:
              {
                'ts': 702468000,
                'time': '1992-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          35:
              {
                'ts': 720003600,
                'time': '1992-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          36:
              {
                'ts': 733917600,
                'time': '1993-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          37:
              {
                'ts': 752058000,
                'time': '1993-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          38:
              {
                'ts': 765367200,
                'time': '1994-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          39:
              {
                'ts': 783507600,
                'time': '1994-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          40:
              {
                'ts': 796816800,
                'time': '1995-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          41:
              {
                'ts': 814957200,
                'time': '1995-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          42:
              {
                'ts': 828871200,
                'time': '1996-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          43:
              {
                'ts': 846406800,
                'time': '1996-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          44:
              {
                'ts': 860320800,
                'time': '1997-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          45:
              {
                'ts': 877856400,
                'time': '1997-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          46:
              {
                'ts': 891770400,
                'time': '1998-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          47:
              {
                'ts': 909306000,
                'time': '1998-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          48:
              {
                'ts': 923220000,
                'time': '1999-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          49:
              {
                'ts': 941360400,
                'time': '1999-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          50:
              {
                'ts': 954669600,
                'time': '2000-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          51:
              {
                'ts': 972810000,
                'time': '2000-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          52:
              {
                'ts': 986119200,
                'time': '2001-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          53:
              {
                'ts': 1004259600,
                'time': '2001-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          54:
              {
                'ts': 1018173600,
                'time': '2002-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          55:
              {
                'ts': 1035709200,
                'time': '2002-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          56:
              {
                'ts': 1049623200,
                'time': '2003-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          57:
              {
                'ts': 1067158800,
                'time': '2003-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          58:
              {
                'ts': 1081072800,
                'time': '2004-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          59:
              {
                'ts': 1099213200,
                'time': '2004-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          60:
              {
                'ts': 1112522400,
                'time': '2005-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          61:
              {
                'ts': 1130662800,
                'time': '2005-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          62:
              {
                'ts': 1143972000,
                'time': '2006-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          63:
              {
                'ts': 1162112400,
                'time': '2006-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          64:
              {
                'ts': 1173607200,
                'time': '2007-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          65:
              {
                'ts': 1194166800,
                'time': '2007-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          66:
              {
                'ts': 1205056800,
                'time': '2008-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          67:
              {
                'ts': 1225616400,
                'time': '2008-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          68:
              {
                'ts': 1236506400,
                'time': '2009-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          69:
              {
                'ts': 1257066000,
                'time': '2009-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          70:
              {
                'ts': 1268560800,
                'time': '2010-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          71:
              {
                'ts': 1289120400,
                'time': '2010-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          72:
              {
                'ts': 1300010400,
                'time': '2011-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          73:
              {
                'ts': 1320570000,
                'time': '2011-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          74:
              {
                'ts': 1331460000,
                'time': '2012-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          75:
              {
                'ts': 1352019600,
                'time': '2012-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          76:
              {
                'ts': 1362909600,
                'time': '2013-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          77:
              {
                'ts': 1383469200,
                'time': '2013-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          78:
              {
                'ts': 1394359200,
                'time': '2014-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          79:
              {
                'ts': 1414918800,
                'time': '2014-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          80:
              {
                'ts': 1425808800,
                'time': '2015-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          81:
              {
                'ts': 1446368400,
                'time': '2015-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          82:
              {
                'ts': 1457863200,
                'time': '2016-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          83:
              {
                'ts': 1478422800,
                'time': '2016-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          84:
              {
                'ts': 1489312800,
                'time': '2017-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          85:
              {
                'ts': 1509872400,
                'time': '2017-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          86:
              {
                'ts': 1520762400,
                'time': '2018-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          87:
              {
                'ts': 1541322000,
                'time': '2018-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          88:
              {
                'ts': 1552212000,
                'time': '2019-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          89:
              {
                'ts': 1572771600,
                'time': '2019-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          90:
              {
                'ts': 1583661600,
                'time': '2020-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          91:
              {
                'ts': 1604221200,
                'time': '2020-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          92:
              {
                'ts': 1615716000,
                'time': '2021-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          93:
              {
                'ts': 1636275600,
                'time': '2021-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          94:
              {
                'ts': 1647165600,
                'time': '2022-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          95:
              {
                'ts': 1667725200,
                'time': '2022-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          96:
              {
                'ts': 1678615200,
                'time': '2023-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          97:
              {
                'ts': 1699174800,
                'time': '2023-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          98:
              {
                'ts': 1710064800,
                'time': '2024-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          99:
              {
                'ts': 1730624400,
                'time': '2024-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          100:
              {
                'ts': 1741514400,
                'time': '2025-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          101:
              {
                'ts': 1762074000,
                'time': '2025-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          102:
              {
                'ts': 1772964000,
                'time': '2026-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          103:
              {
                'ts': 1793523600,
                'time': '2026-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          104:
              {
                'ts': 1805018400,
                'time': '2027-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          105:
              {
                'ts': 1825578000,
                'time': '2027-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          106:
              {
                'ts': 1836468000,
                'time': '2028-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          107:
              {
                'ts': 1857027600,
                'time': '2028-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          108:
              {
                'ts': 1867917600,
                'time': '2029-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          109:
              {
                'ts': 1888477200,
                'time': '2029-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          110:
              {
                'ts': 1899367200,
                'time': '2030-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          111:
              {
                'ts': 1919926800,
                'time': '2030-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          112:
              {
                'ts': 1930816800,
                'time': '2031-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          113:
              {
                'ts': 1951376400,
                'time': '2031-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          114:
              {
                'ts': 1962871200,
                'time': '2032-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          115:
              {
                'ts': 1983430800,
                'time': '2032-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          116:
              {
                'ts': 1994320800,
                'time': '2033-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          117:
              {
                'ts': 2014880400,
                'time': '2033-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          118:
              {
                'ts': 2025770400,
                'time': '2034-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          119:
              {
                'ts': 2046330000,
                'time': '2034-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          120:
              {
                'ts': 2057220000,
                'time': '2035-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          121:
              {
                'ts': 2077779600,
                'time': '2035-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          122:
              {
                'ts': 2088669600,
                'time': '2036-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          123:
              {
                'ts': 2109229200,
                'time': '2036-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          124:
              {
                'ts': 2120119200,
                'time': '2037-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          125:
              {
                'ts': 2140678800,
                'time': '2037-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'America/Dawson_Creek':
        {
          0:
              {
                'ts': -1632060000,
                'time': '1918-04-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          1:
              {
                'ts': -1614783600,
                'time': '1918-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          2:
              {
                'ts': -880207200,
                'time': '1942-02-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PWT'
              },
          3:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PPT'
              },
          4:
              {
                'ts': -765385200,
                'time': '1945-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          5:
              {
                'ts': -715788000,
                'time': '1947-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          6:
              {
                'ts': -702486000,
                'time': '1947-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          7:
              {
                'ts': -684338400,
                'time': '1948-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          8:
              {
                'ts': -671036400,
                'time': '1948-09-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          9:
              {
                'ts': -652888800,
                'time': '1949-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          10:
              {
                'ts': -639586800,
                'time': '1949-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          11:
              {
                'ts': -620834400,
                'time': '1950-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          12:
              {
                'ts': -608137200,
                'time': '1950-09-24T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          13:
              {
                'ts': -589384800,
                'time': '1951-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          14:
              {
                'ts': -576082800,
                'time': '1951-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          15:
              {
                'ts': -557935200,
                'time': '1952-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          16:
              {
                'ts': -544633200,
                'time': '1952-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          17:
              {
                'ts': -526485600,
                'time': '1953-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          18:
              {
                'ts': -513183600,
                'time': '1953-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          19:
              {
                'ts': -495036000,
                'time': '1954-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          20:
              {
                'ts': -481734000,
                'time': '1954-09-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          21:
              {
                'ts': -463586400,
                'time': '1955-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          22:
              {
                'ts': -450284400,
                'time': '1955-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          23:
              {
                'ts': -431532000,
                'time': '1956-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          24:
              {
                'ts': -418230000,
                'time': '1956-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          25:
              {
                'ts': -400082400,
                'time': '1957-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          26:
              {
                'ts': -386780400,
                'time': '1957-09-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          27:
              {
                'ts': -368632800,
                'time': '1958-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          28:
              {
                'ts': -355330800,
                'time': '1958-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          29:
              {
                'ts': -337183200,
                'time': '1959-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          30:
              {
                'ts': -323881200,
                'time': '1959-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          31:
              {
                'ts': -305733600,
                'time': '1960-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          32:
              {
                'ts': -292431600,
                'time': '1960-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          33:
              {
                'ts': -273679200,
                'time': '1961-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          34:
              {
                'ts': -260982000,
                'time': '1961-09-24T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          35:
              {
                'ts': -242229600,
                'time': '1962-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          36:
              {
                'ts': -226508400,
                'time': '1962-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          37:
              {
                'ts': -210780000,
                'time': '1963-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          38:
              {
                'ts': -195058800,
                'time': '1963-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          39:
              {
                'ts': -179330400,
                'time': '1964-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          40:
              {
                'ts': -163609200,
                'time': '1964-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          41:
              {
                'ts': -147880800,
                'time': '1965-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          42:
              {
                'ts': -131554800,
                'time': '1965-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          43:
              {
                'ts': -116431200,
                'time': '1966-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          44:
              {
                'ts': -100105200,
                'time': '1966-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          45:
              {
                'ts': -84376800,
                'time': '1967-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          46:
              {
                'ts': -68655600,
                'time': '1967-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          47:
              {
                'ts': -52927200,
                'time': '1968-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          48:
              {
                'ts': -37206000,
                'time': '1968-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          49:
              {
                'ts': -21477600,
                'time': '1969-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          50:
              {
                'ts': -5756400,
                'time': '1969-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          51:
              {
                'ts': 9972000,
                'time': '1970-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          52:
              {
                'ts': 25693200,
                'time': '1970-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          53:
              {
                'ts': 41421600,
                'time': '1971-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          54:
              {
                'ts': 57747600,
                'time': '1971-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          55:
              {
                'ts': 73476000,
                'time': '1972-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          56:
              {
                'ts': 84013200,
                'time': '1972-08-30T09:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'America/Denver':
        {
          0:
              {
                'ts': -1633273200,
                'time': '1918-03-31T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          1:
              {
                'ts': -1615132800,
                'time': '1918-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          2:
              {
                'ts': -1601823600,
                'time': '1919-03-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          3:
              {
                'ts': -1583683200,
                'time': '1919-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': -1570374000,
                'time': '1920-03-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          5:
              {
                'ts': -1551628800,
                'time': '1920-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          6:
              {
                'ts': -1538924400,
                'time': '1921-03-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          7:
              {
                'ts': -1534089600,
                'time': '1921-05-22T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          8:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          9:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          10:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -147884400,
                'time': '1965-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -131558400,
                'time': '1965-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': -116434800,
                'time': '1966-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': -100108800,
                'time': '1966-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': -52930800,
                'time': '1968-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': -37209600,
                'time': '1968-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': -21481200,
                'time': '1969-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': 9968400,
                'time': '1970-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': 25689600,
                'time': '1970-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': 41418000,
                'time': '1971-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          24:
              {
                'ts': 57744000,
                'time': '1971-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          25:
              {
                'ts': 73472400,
                'time': '1972-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          26:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          27:
              {
                'ts': 104922000,
                'time': '1973-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          28:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          29:
              {
                'ts': 126694800,
                'time': '1974-01-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          30:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          31:
              {
                'ts': 162378000,
                'time': '1975-02-23T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          32:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          33:
              {
                'ts': 199270800,
                'time': '1976-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          34:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          35:
              {
                'ts': 230720400,
                'time': '1977-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          36:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          37:
              {
                'ts': 262774800,
                'time': '1978-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          38:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          39:
              {
                'ts': 294224400,
                'time': '1979-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          40:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          41:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          42:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          43:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          44:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          45:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          46:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          47:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          48:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          49:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          50:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          51:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          52:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          53:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          54:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          55:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          56:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          57:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          58:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          59:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          60:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          61:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          62:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          63:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          64:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          65:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          66:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          67:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          68:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          69:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          70:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          71:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          72:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          73:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          74:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          75:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          76:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          77:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          78:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          79:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          80:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          81:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          82:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          83:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          84:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          85:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          86:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          87:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          88:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          89:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          90:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          91:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          92:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          93:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          94:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          95:
              {
                'ts': 1173603600,
                'time': '2007-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          96:
              {
                'ts': 1194163200,
                'time': '2007-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          97:
              {
                'ts': 1205053200,
                'time': '2008-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          98:
              {
                'ts': 1225612800,
                'time': '2008-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          99:
              {
                'ts': 1236502800,
                'time': '2009-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          100:
              {
                'ts': 1257062400,
                'time': '2009-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          101:
              {
                'ts': 1268557200,
                'time': '2010-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          102:
              {
                'ts': 1289116800,
                'time': '2010-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          103:
              {
                'ts': 1300006800,
                'time': '2011-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          104:
              {
                'ts': 1320566400,
                'time': '2011-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          105:
              {
                'ts': 1331456400,
                'time': '2012-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          106:
              {
                'ts': 1352016000,
                'time': '2012-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          107:
              {
                'ts': 1362906000,
                'time': '2013-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          108:
              {
                'ts': 1383465600,
                'time': '2013-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          109:
              {
                'ts': 1394355600,
                'time': '2014-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          110:
              {
                'ts': 1414915200,
                'time': '2014-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          111:
              {
                'ts': 1425805200,
                'time': '2015-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          112:
              {
                'ts': 1446364800,
                'time': '2015-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          113:

              {
                'ts': 1457859600,
                'time': '2016-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          114:
              {
                'ts': 1478419200,
                'time': '2016-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          115:
              {
                'ts': 1489309200,
                'time': '2017-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          116:
              {
                'ts': 1509868800,
                'time': '2017-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          117:
              {
                'ts': 1520758800,
                'time': '2018-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          118:
              {
                'ts': 1541318400,
                'time': '2018-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          119:
              {
                'ts': 1552208400,
                'time': '2019-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          120:
              {
                'ts': 1572768000,
                'time': '2019-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          121:
              {
                'ts': 1583658000,
                'time': '2020-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          122:
              {
                'ts': 1604217600,
                'time': '2020-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          123:
              {
                'ts': 1615712400,
                'time': '2021-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          124:
              {
                'ts': 1636272000,
                'time': '2021-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          125:
              {
                'ts': 1647162000,
                'time': '2022-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          126:
              {
                'ts': 1667721600,
                'time': '2022-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          127:
              {
                'ts': 1678611600,
                'time': '2023-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          128:
              {
                'ts': 1699171200,
                'time': '2023-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          129:
              {
                'ts': 1710061200,
                'time': '2024-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          130:
              {
                'ts': 1730620800,
                'time': '2024-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          131:
              {
                'ts': 1741510800,
                'time': '2025-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          132:
              {
                'ts': 1762070400,
                'time': '2025-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          133:
              {
                'ts': 1772960400,
                'time': '2026-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          134:
              {
                'ts': 1793520000,
                'time': '2026-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          135:
              {
                'ts': 1805014800,
                'time': '2027-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          136:
              {
                'ts': 1825574400,
                'time': '2027-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          137:
              {
                'ts': 1836464400,
                'time': '2028-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          138:
              {
                'ts': 1857024000,
                'time': '2028-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          139:
              {
                'ts': 1867914000,
                'time': '2029-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          140:
              {
                'ts': 1888473600,
                'time': '2029-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          141:
              {
                'ts': 1899363600,
                'time': '2030-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          142:
              {
                'ts': 1919923200,
                'time': '2030-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          143:
              {
                'ts': 1930813200,
                'time': '2031-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          144:
              {
                'ts': 1951372800,
                'time': '2031-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          145:
              {
                'ts': 1962867600,
                'time': '2032-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          146:
              {
                'ts': 1983427200,
                'time': '2032-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          147:
              {
                'ts': 1994317200,
                'time': '2033-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          148:
              {
                'ts': 2014876800,
                'time': '2033-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          149:
              {
                'ts': 2025766800,
                'time': '2034-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          150:
              {
                'ts': 2046326400,
                'time': '2034-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          151:
              {
                'ts': 2057216400,
                'time': '2035-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          152:
              {
                'ts': 2077776000,
                'time': '2035-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          153:
              {
                'ts': 2088666000,
                'time': '2036-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          154:
              {
                'ts': 2109225600,
                'time': '2036-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          155:
              {
                'ts': 2120115600,
                'time': '2037-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          156:
              {
                'ts': 2140675200,
                'time': '2037-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'America/Detroit':
        {
          0:
              {
                'ts': -2051202469,
                'time': '1905-01-01T05:32:11+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -1724083200,
                'time': '1915-05-15T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -880218000,
                'time': '1942-02-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EWT'
              },
          3:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EPT'
              },
          4:
              {
                'ts': -765396000,
                'time': '1945-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -684349200,
                'time': '1948-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          6:
              {
                'ts': -671047200,
                'time': '1948-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -80499600,
                'time': '1967-06-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          8:
              {
                'ts': -68666400,
                'time': '1967-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          10:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 126687600,
                'time': '1974-01-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          12:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 167814000,
                'time': '1975-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          14:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          16:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          18:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          20:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          22:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          24:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          26:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          28:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          30:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          32:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          34:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          36:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          38:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          40:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          42:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          44:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          46:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          48:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          50:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          52:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          54:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          56:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          58:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          60:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          62:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          64:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          66:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          68:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          70:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          72:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          116:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          118:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          120:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          122:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          124:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          126:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          128:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          130:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          132:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          134:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          136:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          138:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Dominica':
        {
          0:
              {
                'ts': -1846266804,
                'time': '1911-07-01T04:06:36+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Edmonton':
        {
          0:
              {
                'ts': -1998663968,
                'time': '1906-09-01T07:33:52+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1632063600,
                'time': '1918-04-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          2:
              {
                'ts': -1614787200,
                'time': '1918-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1600614000,
                'time': '1919-04-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          4:
              {
                'ts': -1596816000,
                'time': '1919-05-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1567954800,
                'time': '1920-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          6:
              {
                'ts': -1551628800,
                'time': '1920-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          7:
              {
                'ts': -1536505200,
                'time': '1921-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          8:
              {
                'ts': -1523203200,
                'time': '1921-09-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          9:
              {
                'ts': -1504450800,
                'time': '1922-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          10:
              {
                'ts': -1491753600,
                'time': '1922-09-24T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -1473001200,
                'time': '1923-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -1459699200,
                'time': '1923-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          14:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          15:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          16:
              {
                'ts': -715791600,
                'time': '1947-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          17:
              {
                'ts': -702489600,
                'time': '1947-09-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          18:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          19:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          20:
              {
                'ts': -21481200,
                'time': '1969-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          21:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          22:
              {
                'ts': 73472400,
                'time': '1972-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          23:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          24:
              {
                'ts': 104922000,
                'time': '1973-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          25:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          26:
              {
                'ts': 136371600,
                'time': '1974-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          27:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          28:
              {
                'ts': 167821200,
                'time': '1975-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          29:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          30:
              {
                'ts': 199270800,
                'time': '1976-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          31:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          32:
              {
                'ts': 230720400,
                'time': '1977-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          33:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          34:
              {
                'ts': 262774800,
                'time': '1978-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          35:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          36:
              {
                'ts': 294224400,
                'time': '1979-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          37:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          38:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          39:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          40:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          41:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          42:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          43:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          44:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          45:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          46:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          47:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          48:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          49:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          50:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          51:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          52:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          53:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          54:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          55:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          56:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          57:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          58:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          59:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          60:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          61:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          62:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          63:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          64:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          65:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          66:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          67:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          68:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          69:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          70:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          71:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          72:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          73:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          74:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          75:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          76:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          77:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          78:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          79:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          80:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          81:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          82:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          83:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          84:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          85:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          86:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          87:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          88:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          89:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          90:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          91:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          92:
              {
                'ts': 1173603600,
                'time': '2007-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          93:
              {
                'ts': 1194163200,
                'time': '2007-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          94:
              {
                'ts': 1205053200,
                'time': '2008-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          95:
              {
                'ts': 1225612800,
                'time': '2008-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          96:
              {
                'ts': 1236502800,
                'time': '2009-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          97:
              {
                'ts': 1257062400,
                'time': '2009-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          98:
              {
                'ts': 1268557200,
                'time': '2010-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          99:
              {
                'ts': 1289116800,
                'time': '2010-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          100:
              {
                'ts': 1300006800,
                'time': '2011-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          101:
              {
                'ts': 1320566400,
                'time': '2011-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          102:
              {
                'ts': 1331456400,
                'time': '2012-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          103:
              {
                'ts': 1352016000,
                'time': '2012-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          104:
              {
                'ts': 1362906000,
                'time': '2013-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          105:
              {
                'ts': 1383465600,
                'time': '2013-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          106:
              {
                'ts': 1394355600,
                'time': '2014-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          107:
              {
                'ts': 1414915200,
                'time': '2014-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          108:
              {
                'ts': 1425805200,
                'time': '2015-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          109:
              {
                'ts': 1446364800,
                'time': '2015-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          110:
              {
                'ts': 1457859600,
                'time': '2016-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          111:
              {
                'ts': 1478419200,
                'time': '2016-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          112:
              {
                'ts': 1489309200,
                'time': '2017-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          113:
              {
                'ts': 1509868800,
                'time': '2017-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          114:
              {
                'ts': 1520758800,
                'time': '2018-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          115:
              {
                'ts': 1541318400,
                'time': '2018-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          116:
              {
                'ts': 1552208400,
                'time': '2019-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          117:
              {
                'ts': 1572768000,
                'time': '2019-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          118:
              {
                'ts': 1583658000,
                'time': '2020-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          119:
              {
                'ts': 1604217600,
                'time': '2020-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          120:
              {
                'ts': 1615712400,
                'time': '2021-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          121:
              {
                'ts': 1636272000,
                'time': '2021-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          122:
              {
                'ts': 1647162000,
                'time': '2022-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          123:
              {
                'ts': 1667721600,
                'time': '2022-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          124:
              {
                'ts': 1678611600,
                'time': '2023-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          125:
              {
                'ts': 1699171200,
                'time': '2023-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          126:
              {
                'ts': 1710061200,
                'time': '2024-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          127:
              {
                'ts': 1730620800,
                'time': '2024-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          128:
              {
                'ts': 1741510800,
                'time': '2025-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          129:
              {
                'ts': 1762070400,
                'time': '2025-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          130:
              {
                'ts': 1772960400,
                'time': '2026-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          131:
              {
                'ts': 1793520000,
                'time': '2026-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          132:
              {
                'ts': 1805014800,
                'time': '2027-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          133:
              {
                'ts': 1825574400,
                'time': '2027-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          134:
              {
                'ts': 1836464400,
                'time': '2028-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          135:
              {
                'ts': 1857024000,
                'time': '2028-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          136:
              {
                'ts': 1867914000,
                'time': '2029-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          137:
              {
                'ts': 1888473600,
                'time': '2029-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          138:
              {
                'ts': 1899363600,
                'time': '2030-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          139:
              {
                'ts': 1919923200,
                'time': '2030-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          140:
              {
                'ts': 1930813200,
                'time': '2031-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          141:
              {
                'ts': 1951372800,
                'time': '2031-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          142:
              {
                'ts': 1962867600,
                'time': '2032-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          143:
              {
                'ts': 1983427200,
                'time': '2032-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          144:
              {
                'ts': 1994317200,
                'time': '2033-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          145:
              {
                'ts': 2014876800,
                'time': '2033-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          146:
              {
                'ts': 2025766800,
                'time': '2034-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          147:
              {
                'ts': 2046326400,
                'time': '2034-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          148:
              {
                'ts': 2057216400,
                'time': '2035-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          149:
              {
                'ts': 2077776000,
                'time': '2035-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          150:
              {
                'ts': 2088666000,
                'time': '2036-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          151:
              {
                'ts': 2109225600,
                'time': '2036-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          152:
              {
                'ts': 2120115600,
                'time': '2037-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          153:
              {
                'ts': 2140675200,
                'time': '2037-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'America/Eirunepe':
        {
          0:
              {
                'ts': -1767208832,
                'time': '1914-01-01T04:39:28+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          1:
              {
                'ts': -1206950400,
                'time': '1931-10-03T16:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          2:
              {
                'ts': -1191355200,
                'time': '1932-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          3:
              {
                'ts': -1175367600,
                'time': '1932-10-03T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          4:
              {
                'ts': -1159819200,
                'time': '1933-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          5:
              {
                'ts': -633812400,
                'time': '1949-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          6:
              {
                'ts': -622062000,
                'time': '1950-04-16T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          7:
              {
                'ts': -602276400,
                'time': '1950-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          8:
              {
                'ts': -591825600,
                'time': '1951-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          9:
              {
                'ts': -570740400,
                'time': '1951-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          10:
              {
                'ts': -560203200,
                'time': '1952-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          11:
              {
                'ts': -539118000,
                'time': '1952-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          12:
              {
                'ts': -531345600,
                'time': '1953-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          13:
              {
                'ts': -191358000,
                'time': '1963-12-09T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          14:
              {
                'ts': -184190400,
                'time': '1964-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          15:
              {
                'ts': -155156400,
                'time': '1965-01-31T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          16:
              {
                'ts': -150062400,
                'time': '1965-03-31T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          17:
              {
                'ts': -128890800,
                'time': '1965-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          18:
              {
                'ts': -121118400,
                'time': '1966-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          19:
              {
                'ts': -99946800,
                'time': '1966-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          20:
              {
                'ts': -89582400,
                'time': '1967-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          21:
              {
                'ts': -68410800,
                'time': '1967-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          22:
              {
                'ts': -57960000,
                'time': '1968-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          23:
              {
                'ts': 499755600,
                'time': '1985-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          24:
              {
                'ts': 511243200,
                'time': '1986-03-15T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          25:
              {
                'ts': 530600400,
                'time': '1986-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          26:
              {
                'ts': 540273600,
                'time': '1987-02-14T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          27:
              {
                'ts': 562136400,
                'time': '1987-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          28:
              {
                'ts': 571204800,
                'time': '1988-02-07T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          29:
              {
                'ts': 750834000,
                'time': '1993-10-17T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          30:
              {
                'ts': 761716800,
                'time': '1994-02-20T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              }
        },
    'America/El_Salvador':
        {
          0:
              {
                'ts': -1546279392,
                'time': '1921-01-01T05:56:48+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': 547020000,
                'time': '1987-05-03T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          2:
              {
                'ts': 559717200,
                'time': '1987-09-27T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': 578469600,
                'time': '1988-05-01T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': 591166800,
                'time': '1988-09-25T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Ensenada':
        {
          0:
              {
                'ts': -1514736000,
                'time': '1922-01-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1451667600,
                'time': '1924-01-01T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          2:
              {
                'ts': -1343062800,
                'time': '1927-06-11T07:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1234803600,
                'time': '1930-11-15T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          4:
              {
                'ts': -1222963200,
                'time': '1931-04-01T08:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          5:
              {
                'ts': -1207242000,
                'time': '1931-09-30T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          6:
              {
                'ts': -873820800,
                'time': '1942-04-24T08:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PWT'
              },
          7:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PPT'
              },
          8:
              {
                'ts': -761677200,
                'time': '1945-11-12T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          9:
              {
                'ts': -686073600,
                'time': '1948-04-05T08:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          10:
              {
                'ts': -661539600,
                'time': '1949-01-14T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          11:
              {
                'ts': -495036000,
                'time': '1954-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          12:
              {
                'ts': -481734000,
                'time': '1954-09-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          13:
              {
                'ts': -463586400,
                'time': '1955-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          14:
              {
                'ts': -450284400,
                'time': '1955-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          15:
              {
                'ts': -431532000,
                'time': '1956-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          16:
              {
                'ts': -418230000,
                'time': '1956-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          17:
              {
                'ts': -400082400,
                'time': '1957-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          18:
              {
                'ts': -386780400,
                'time': '1957-09-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          19:
              {
                'ts': -368632800,
                'time': '1958-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          20:
              {
                'ts': -355330800,
                'time': '1958-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          21:
              {
                'ts': -337183200,
                'time': '1959-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          22:
              {
                'ts': -323881200,
                'time': '1959-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          23:
              {
                'ts': -305733600,
                'time': '1960-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          24:
              {
                'ts': -292431600,
                'time': '1960-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          25:
              {
                'ts': 199274400,
                'time': '1976-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          26:
              {
                'ts': 215600400,
                'time': '1976-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          27:
              {
                'ts': 230724000,
                'time': '1977-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          28:
              {
                'ts': 247050000,
                'time': '1977-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          29:
              {
                'ts': 262778400,
                'time': '1978-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          30:
              {
                'ts': 278499600,
                'time': '1978-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          31:
              {
                'ts': 294228000,
                'time': '1979-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          32:
              {
                'ts': 309949200,
                'time': '1979-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          33:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          34:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          35:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          36:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          37:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          38:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          39:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          40:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          41:
              {
                'ts': 452080800,
                'time': '1984-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          42:
              {
                'ts': 467802000,
                'time': '1984-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          43:
              {
                'ts': 483530400,
                'time': '1985-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          44:
              {
                'ts': 499251600,
                'time': '1985-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          45:
              {
                'ts': 514980000,
                'time': '1986-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          46:
              {
                'ts': 530701200,
                'time': '1986-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          47:
              {
                'ts': 544615200,
                'time': '1987-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          48:
              {
                'ts': 562150800,
                'time': '1987-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          49:
              {
                'ts': 576064800,
                'time': '1988-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          50:
              {
                'ts': 594205200,
                'time': '1988-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          51:
              {
                'ts': 607514400,
                'time': '1989-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          52:
              {
                'ts': 625654800,
                'time': '1989-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          53:
              {
                'ts': 638964000,
                'time': '1990-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          54:
              {
                'ts': 657104400,
                'time': '1990-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          55:
              {
                'ts': 671018400,
                'time': '1991-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          56:
              {
                'ts': 688554000,
                'time': '1991-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          57:
              {
                'ts': 702468000,
                'time': '1992-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          58:
              {
                'ts': 720003600,
                'time': '1992-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          59:
              {
                'ts': 733917600,
                'time': '1993-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          60:
              {
                'ts': 752058000,
                'time': '1993-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          61:
              {
                'ts': 765367200,
                'time': '1994-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          62:
              {
                'ts': 783507600,
                'time': '1994-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          63:
              {
                'ts': 796816800,
                'time': '1995-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          64:
              {
                'ts': 814957200,
                'time': '1995-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          65:
              {
                'ts': 828871200,
                'time': '1996-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          66:
              {
                'ts': 846406800,
                'time': '1996-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          67:
              {
                'ts': 860320800,
                'time': '1997-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          68:
              {
                'ts': 877856400,
                'time': '1997-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          69:
              {
                'ts': 891770400,
                'time': '1998-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          70:
              {
                'ts': 909306000,
                'time': '1998-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          71:
              {
                'ts': 923220000,
                'time': '1999-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          72:
              {
                'ts': 941360400,
                'time': '1999-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          73:
              {
                'ts': 954669600,
                'time': '2000-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          74:
              {
                'ts': 972810000,
                'time': '2000-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          75:
              {
                'ts': 986119200,
                'time': '2001-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          76:
              {
                'ts': 1004259600,
                'time': '2001-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          77:
              {
                'ts': 1018173600,
                'time': '2002-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          78:
              {
                'ts': 1035709200,
                'time': '2002-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          79:
              {
                'ts': 1049623200,
                'time': '2003-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          80:
              {
                'ts': 1067158800,
                'time': '2003-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          81:
              {
                'ts': 1081072800,
                'time': '2004-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          82:
              {
                'ts': 1099213200,
                'time': '2004-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          83:
              {
                'ts': 1112522400,
                'time': '2005-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          84:
              {
                'ts': 1130662800,
                'time': '2005-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          85:
              {
                'ts': 1143972000,
                'time': '2006-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          86:
              {
                'ts': 1162112400,
                'time': '2006-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          87:
              {
                'ts': 1175421600,
                'time': '2007-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          88:
              {
                'ts': 1193562000,
                'time': '2007-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          89:
              {
                'ts': 1207476000,
                'time': '2008-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          90:
              {
                'ts': 1225011600,
                'time': '2008-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          91:
              {
                'ts': 1238925600,
                'time': '2009-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          92:
              {
                'ts': 1256461200,
                'time': '2009-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          93:
              {
                'ts': 1270375200,
                'time': '2010-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          94:
              {
                'ts': 1288515600,
                'time': '2010-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          95:
              {
                'ts': 1301824800,
                'time': '2011-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          96:
              {
                'ts': 1319965200,
                'time': '2011-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          97:
              {
                'ts': 1333274400,
                'time': '2012-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          98:
              {
                'ts': 1351414800,
                'time': '2012-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          99:
              {
                'ts': 1365328800,
                'time': '2013-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          100:
              {
                'ts': 1382864400,
                'time': '2013-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          101:
              {
                'ts': 1396778400,
                'time': '2014-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          102:
              {
                'ts': 1414314000,
                'time': '2014-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          103:
              {
                'ts': 1428228000,
                'time': '2015-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          104:
              {
                'ts': 1445763600,
                'time': '2015-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          105:
              {
                'ts': 1459677600,
                'time': '2016-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          106:
              {
                'ts': 1477818000,
                'time': '2016-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          107:
              {
                'ts': 1491127200,
                'time': '2017-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          108:
              {
                'ts': 1509267600,
                'time': '2017-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          109:
              {
                'ts': 1522576800,
                'time': '2018-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          110:
              {
                'ts': 1540717200,
                'time': '2018-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          111:
              {
                'ts': 1554631200,
                'time': '2019-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          112:
              {
                'ts': 1572166800,
                'time': '2019-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          113:
              {
                'ts': 1586080800,
                'time': '2020-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          114:
              {
                'ts': 1603616400,
                'time': '2020-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          115:
              {
                'ts': 1617530400,
                'time': '2021-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          116:
              {
                'ts': 1635670800,
                'time': '2021-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          117:
              {
                'ts': 1648980000,
                'time': '2022-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          118:
              {
                'ts': 1667120400,
                'time': '2022-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          119:
              {
                'ts': 1680429600,
                'time': '2023-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          120:
              {
                'ts': 1698570000,
                'time': '2023-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          121:
              {
                'ts': 1712484000,
                'time': '2024-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          122:
              {
                'ts': 1730019600,
                'time': '2024-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          123:
              {
                'ts': 1743933600,
                'time': '2025-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          124:
              {
                'ts': 1761469200,
                'time': '2025-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          125:
              {
                'ts': 1775383200,
                'time': '2026-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          126:
              {
                'ts': 1792918800,
                'time': '2026-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          127:
              {
                'ts': 1806832800,
                'time': '2027-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          128:
              {
                'ts': 1824973200,
                'time': '2027-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          129:
              {
                'ts': 1838282400,
                'time': '2028-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          130:
              {
                'ts': 1856422800,
                'time': '2028-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          131:
              {
                'ts': 1869732000,
                'time': '2029-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          132:
              {
                'ts': 1887872400,
                'time': '2029-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          133:
              {
                'ts': 1901786400,
                'time': '2030-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          134:
              {
                'ts': 1919322000,
                'time': '2030-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          135:
              {
                'ts': 1933236000,
                'time': '2031-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          136:
              {
                'ts': 1950771600,
                'time': '2031-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          137:
              {
                'ts': 1964685600,
                'time': '2032-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          138:
              {
                'ts': 1982826000,
                'time': '2032-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          139:
              {
                'ts': 1996135200,
                'time': '2033-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          140:
              {
                'ts': 2014275600,
                'time': '2033-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          141:
              {
                'ts': 2027584800,
                'time': '2034-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          142:
              {
                'ts': 2045725200,
                'time': '2034-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          143:
              {
                'ts': 2059034400,
                'time': '2035-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          144:
              {
                'ts': 2077174800,
                'time': '2035-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          145:
              {
                'ts': 2091088800,
                'time': '2036-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          146:
              {
                'ts': 2108624400,
                'time': '2036-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          147:
              {
                'ts': 2122538400,
                'time': '2037-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          148:
              {
                'ts': 2140074000,
                'time': '2037-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'America/Fort_Wayne':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -900259200,
                'time': '1941-06-22T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': -891795600,
                'time': '1941-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          7:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          8:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -747244800,
                'time': '1946-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -733942800,
                'time': '1946-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -702493200,
                'time': '1947-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -684345600,
                'time': '1948-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -671043600,
                'time': '1948-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -652896000,
                'time': '1949-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -639594000,
                'time': '1949-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -620841600,
                'time': '1950-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -608144400,
                'time': '1950-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Fortaleza':
        {
          0:
              {
                'ts': -1767216360,
                'time': '1914-01-01T02:34:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          1:
              {
                'ts': -1206957600,
                'time': '1931-10-03T14:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          2:
              {
                'ts': -1191362400,
                'time': '1932-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          3:
              {
                'ts': -1175374800,
                'time': '1932-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          4:
              {
                'ts': -1159826400,
                'time': '1933-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          5:
              {
                'ts': -633819600,
                'time': '1949-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          6:
              {
                'ts': -622069200,
                'time': '1950-04-16T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          7:
              {
                'ts': -602283600,
                'time': '1950-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          8:
              {
                'ts': -591832800,
                'time': '1951-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          9:
              {
                'ts': -570747600,
                'time': '1951-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          10:
              {
                'ts': -560210400,
                'time': '1952-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          11:
              {
                'ts': -539125200,
                'time': '1952-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          12:
              {
                'ts': -531352800,
                'time': '1953-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          13:
              {
                'ts': -191365200,
                'time': '1963-12-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          14:
              {
                'ts': -184197600,
                'time': '1964-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          15:
              {
                'ts': -155163600,
                'time': '1965-01-31T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          16:
              {
                'ts': -150069600,
                'time': '1965-03-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          17:
              {
                'ts': -128898000,
                'time': '1965-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          18:
              {
                'ts': -121125600,
                'time': '1966-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          19:
              {
                'ts': -99954000,
                'time': '1966-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          20:
              {
                'ts': -89589600,
                'time': '1967-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          21:
              {
                'ts': -68418000,
                'time': '1967-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          22:
              {
                'ts': -57967200,
                'time': '1968-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          23:
              {
                'ts': 499748400,
                'time': '1985-11-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          24:
              {
                'ts': 511236000,
                'time': '1986-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          25:
              {
                'ts': 530593200,
                'time': '1986-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          26:
              {
                'ts': 540266400,
                'time': '1987-02-14T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          27:
              {
                'ts': 562129200,
                'time': '1987-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          28:
              {
                'ts': 571197600,
                'time': '1988-02-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          29:
              {
                'ts': 592974000,
                'time': '1988-10-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          30:
              {
                'ts': 602042400,
                'time': '1989-01-29T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          31:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          32:
              {
                'ts': 634701600,
                'time': '1990-02-11T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          33:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          34:
              {
                'ts': 951616800,
                'time': '2000-02-27T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          35:
              {
                'ts': 970974000,
                'time': '2000-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          36:
              {
                'ts': 972180000,
                'time': '2000-10-22T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          37:
              {
                'ts': 1003028400,
                'time': '2001-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          38:
              {
                'ts': 1013911200,
                'time': '2002-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              }
        },
    'America/Glace_Bay':
        {
          0:
              {
                'ts': -2131646412,
                'time': '1902-06-15T03:59:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          1:
              {
                'ts': -1632074400,
                'time': '1918-04-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          2:
              {
                'ts': -1614798000,
                'time': '1918-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          3:
              {
                'ts': -880221600,
                'time': '1942-02-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AWT'
              },
          4:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'APT'
              },
          5:
              {
                'ts': -765399600,
                'time': '1945-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          6:
              {
                'ts': -526500000,
                'time': '1953-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          7:
              {
                'ts': -513198000,
                'time': '1953-09-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          8:
              {
                'ts': 73461600,
                'time': '1972-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          9:
              {
                'ts': 89182800,
                'time': '1972-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          10:
              {
                'ts': 104911200,
                'time': '1973-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          11:
              {
                'ts': 120632400,
                'time': '1973-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          12:
              {
                'ts': 136360800,
                'time': '1974-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          13:
              {
                'ts': 152082000,
                'time': '1974-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          14:
              {
                'ts': 167810400,
                'time': '1975-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          15:
              {
                'ts': 183531600,
                'time': '1975-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          16:
              {
                'ts': 199260000,
                'time': '1976-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          17:
              {
                'ts': 215586000,
                'time': '1976-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          18:
              {
                'ts': 230709600,
                'time': '1977-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          19:
              {
                'ts': 247035600,
                'time': '1977-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          20:
              {
                'ts': 262764000,
                'time': '1978-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          21:
              {
                'ts': 278485200,
                'time': '1978-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          22:
              {
                'ts': 294213600,
                'time': '1979-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          23:
              {
                'ts': 309934800,
                'time': '1979-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          24:
              {
                'ts': 325663200,
                'time': '1980-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          25:
              {
                'ts': 341384400,
                'time': '1980-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          26:
              {
                'ts': 357112800,
                'time': '1981-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          27:
              {
                'ts': 372834000,
                'time': '1981-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          28:
              {
                'ts': 388562400,
                'time': '1982-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          29:
              {
                'ts': 404888400,
                'time': '1982-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          30:
              {
                'ts': 420012000,
                'time': '1983-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          31:
              {
                'ts': 436338000,
                'time': '1983-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          32:
              {
                'ts': 452066400,
                'time': '1984-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          33:
              {
                'ts': 467787600,
                'time': '1984-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          34:
              {
                'ts': 483516000,
                'time': '1985-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          35:
              {
                'ts': 499237200,
                'time': '1985-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          36:
              {
                'ts': 514965600,
                'time': '1986-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          37:
              {
                'ts': 530686800,
                'time': '1986-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          38:
              {
                'ts': 544600800,
                'time': '1987-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          39:
              {
                'ts': 562136400,
                'time': '1987-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          40:
              {
                'ts': 576050400,
                'time': '1988-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          41:
              {
                'ts': 594190800,
                'time': '1988-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          42:
              {
                'ts': 607500000,
                'time': '1989-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          43:
              {
                'ts': 625640400,
                'time': '1989-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          44:
              {
                'ts': 638949600,
                'time': '1990-04-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          45:
              {
                'ts': 657090000,
                'time': '1990-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          46:
              {
                'ts': 671004000,
                'time': '1991-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          47:
              {
                'ts': 688539600,
                'time': '1991-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          48:
              {
                'ts': 702453600,
                'time': '1992-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          49:
              {
                'ts': 719989200,
                'time': '1992-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          50:
              {
                'ts': 733903200,
                'time': '1993-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          51:
              {
                'ts': 752043600,
                'time': '1993-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          52:
              {
                'ts': 765352800,
                'time': '1994-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          53:
              {
                'ts': 783493200,
                'time': '1994-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          54:
              {
                'ts': 796802400,
                'time': '1995-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          55:
              {
                'ts': 814942800,
                'time': '1995-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          56:
              {
                'ts': 828856800,
                'time': '1996-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          57:
              {
                'ts': 846392400,
                'time': '1996-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          58:
              {
                'ts': 860306400,
                'time': '1997-04-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          59:
              {
                'ts': 877842000,
                'time': '1997-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          60:
              {
                'ts': 891756000,
                'time': '1998-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          61:
              {
                'ts': 909291600,
                'time': '1998-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          62:
              {
                'ts': 923205600,
                'time': '1999-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          63:
              {
                'ts': 941346000,
                'time': '1999-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          64:
              {
                'ts': 954655200,
                'time': '2000-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          65:
              {
                'ts': 972795600,
                'time': '2000-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          66:
              {
                'ts': 986104800,
                'time': '2001-04-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          67:
              {
                'ts': 1004245200,
                'time': '2001-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          68:
              {
                'ts': 1018159200,
                'time': '2002-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          69:
              {
                'ts': 1035694800,
                'time': '2002-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          70:
              {
                'ts': 1049608800,
                'time': '2003-04-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          71:
              {
                'ts': 1067144400,
                'time': '2003-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          72:
              {
                'ts': 1081058400,
                'time': '2004-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          73:
              {
                'ts': 1099198800,
                'time': '2004-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          74:
              {
                'ts': 1112508000,
                'time': '2005-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          75:
              {
                'ts': 1130648400,
                'time': '2005-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          76:
              {
                'ts': 1143957600,
                'time': '2006-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          77:
              {
                'ts': 1162098000,
                'time': '2006-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          78:
              {
                'ts': 1173592800,
                'time': '2007-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          79:
              {
                'ts': 1194152400,
                'time': '2007-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          80:
              {
                'ts': 1205042400,
                'time': '2008-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          81:
              {
                'ts': 1225602000,
                'time': '2008-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          82:
              {
                'ts': 1236492000,
                'time': '2009-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          83:
              {
                'ts': 1257051600,
                'time': '2009-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          84:
              {
                'ts': 1268546400,
                'time': '2010-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          85:
              {
                'ts': 1289106000,
                'time': '2010-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          86:
              {
                'ts': 1299996000,
                'time': '2011-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          87:
              {
                'ts': 1320555600,
                'time': '2011-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          88:
              {
                'ts': 1331445600,
                'time': '2012-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          89:
              {
                'ts': 1352005200,
                'time': '2012-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          90:
              {
                'ts': 1362895200,
                'time': '2013-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          91:
              {
                'ts': 1383454800,
                'time': '2013-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          92:
              {
                'ts': 1394344800,
                'time': '2014-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          93:
              {
                'ts': 1414904400,
                'time': '2014-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          94:
              {
                'ts': 1425794400,
                'time': '2015-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          95:
              {
                'ts': 1446354000,
                'time': '2015-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          96:
              {
                'ts': 1457848800,
                'time': '2016-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          97:
              {
                'ts': 1478408400,
                'time': '2016-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          98:
              {
                'ts': 1489298400,
                'time': '2017-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          99:
              {
                'ts': 1509858000,
                'time': '2017-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          100:
              {
                'ts': 1520748000,
                'time': '2018-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          101:
              {
                'ts': 1541307600,
                'time': '2018-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          102:
              {
                'ts': 1552197600,
                'time': '2019-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          103:
              {
                'ts': 1572757200,
                'time': '2019-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          104:
              {
                'ts': 1583647200,
                'time': '2020-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          105:
              {
                'ts': 1604206800,
                'time': '2020-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          106:
              {
                'ts': 1615701600,
                'time': '2021-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          107:
              {
                'ts': 1636261200,
                'time': '2021-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          108:
              {
                'ts': 1647151200,
                'time': '2022-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          109:
              {
                'ts': 1667710800,
                'time': '2022-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          110:
              {
                'ts': 1678600800,
                'time': '2023-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          111:
              {
                'ts': 1699160400,
                'time': '2023-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          112:
              {
                'ts': 1710050400,
                'time': '2024-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          113:
              {
                'ts': 1730610000,
                'time': '2024-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          114:
              {
                'ts': 1741500000,
                'time': '2025-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          115:
              {
                'ts': 1762059600,
                'time': '2025-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          116:
              {
                'ts': 1772949600,
                'time': '2026-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          117:
              {
                'ts': 1793509200,
                'time': '2026-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          118:
              {
                'ts': 1805004000,
                'time': '2027-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          119:
              {
                'ts': 1825563600,
                'time': '2027-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          120:
              {
                'ts': 1836453600,
                'time': '2028-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          121:
              {
                'ts': 1857013200,
                'time': '2028-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          122:
              {
                'ts': 1867903200,
                'time': '2029-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          123:
              {
                'ts': 1888462800,
                'time': '2029-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          124:
              {
                'ts': 1899352800,
                'time': '2030-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          125:
              {
                'ts': 1919912400,
                'time': '2030-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          126:
              {
                'ts': 1930802400,
                'time': '2031-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          127:
              {
                'ts': 1951362000,
                'time': '2031-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          128:
              {
                'ts': 1962856800,
                'time': '2032-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          129:
              {
                'ts': 1983416400,
                'time': '2032-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          130:
              {
                'ts': 1994306400,
                'time': '2033-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          131:
              {
                'ts': 2014866000,
                'time': '2033-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          132:
              {
                'ts': 2025756000,
                'time': '2034-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          133:
              {
                'ts': 2046315600,
                'time': '2034-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          134:
              {
                'ts': 2057205600,
                'time': '2035-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          135:
              {
                'ts': 2077765200,
                'time': '2035-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          136:
              {
                'ts': 2088655200,
                'time': '2036-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          137:
              {
                'ts': 2109214800,
                'time': '2036-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          138:
              {
                'ts': 2120104800,
                'time': '2037-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          139:
              {
                'ts': 2140664400,
                'time': '2037-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Godthab':
        {
          0:
              {
                'ts': -1686083584,
                'time': '1916-07-28T03:26:56+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          1:
              {
                'ts': 323845200,
                'time': '1980-04-06T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          2:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          3:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          4:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          5:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          6:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          7:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          8:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          9:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          10:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          11:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          12:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          13:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          14:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          15:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          16:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          17:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          18:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          19:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          20:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          21:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          22:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          23:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          24:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          25:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          26:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          27:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          28:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          29:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          30:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          31:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          32:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          33:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          34:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          35:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          36:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          37:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          38:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          39:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          40:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          41:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          42:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          43:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          44:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          45:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          46:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          47:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          48:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          49:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          50:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          51:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          52:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          53:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          54:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          55:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          56:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          57:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          58:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          59:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          60:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          61:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          62:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          63:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          64:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          65:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          66:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          67:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          68:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          69:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          70:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          71:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          72:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          73:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          74:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          75:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          76:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          77:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          78:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          79:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          80:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          81:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          82:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          83:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          84:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          85:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          86:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          87:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          88:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          89:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          90:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          91:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          92:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          93:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          94:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          95:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          96:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          97:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          98:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          99:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          100:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          101:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          102:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          103:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          104:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          105:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          106:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          107:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          108:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          109:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          110:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          111:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          112:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          113:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          114:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              },
          115:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'WGST'
              },
          116:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'WGT'
              }
        },
    'America/Goose_Bay':
        {
          0:
              {
                'ts': -1632076148,
                'time': '1918-04-14T05:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          1:
              {
                'ts': -1614799748,
                'time': '1918-10-31T04:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          2:
              {
                'ts': -1096921748,
                'time': '1935-03-30T03:30:52+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          3:
              {
                'ts': -1061670600,
                'time': '1936-05-11T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          4:
              {
                'ts': -1048973400,
                'time': '1936-10-05T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          5:
              {
                'ts': -1030221000,
                'time': '1937-05-10T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          6:
              {
                'ts': -1017523800,
                'time': '1937-10-04T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          7:
              {
                'ts': -998771400,
                'time': '1938-05-09T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          8:
              {
                'ts': -986074200,
                'time': '1938-10-03T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          9:
              {
                'ts': -966717000,
                'time': '1939-05-15T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          10:
              {
                'ts': -954624600,
                'time': '1939-10-02T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          11:
              {
                'ts': -935267400,
                'time': '1940-05-13T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          12:
              {
                'ts': -922570200,
                'time': '1940-10-07T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          13:
              {
                'ts': -903817800,
                'time': '1941-05-12T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          14:
              {
                'ts': -891120600,
                'time': '1941-10-06T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          15:
              {
                'ts': -872368200,
                'time': '1942-05-11T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NWT'
              },
          16:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NPT'
              },
          17:
              {
                'ts': -765401400,
                'time': '1945-09-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          18:
              {
                'ts': -746044200,
                'time': '1946-05-12T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          19:
              {
                'ts': -733347000,
                'time': '1946-10-06T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          20:
              {
                'ts': -714594600,
                'time': '1947-05-11T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          21:
              {
                'ts': -701897400,
                'time': '1947-10-05T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          22:
              {
                'ts': -683145000,
                'time': '1948-05-09T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          23:
              {
                'ts': -670447800,
                'time': '1948-10-03T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          24:
              {
                'ts': -651695400,
                'time': '1949-05-08T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          25:
              {
                'ts': -638998200,
                'time': '1949-10-02T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          26:
              {
                'ts': -619641000,
                'time': '1950-05-14T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          27:
              {
                'ts': -606943800,
                'time': '1950-10-08T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          28:
              {
                'ts': -589401000,
                'time': '1951-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          29:
              {
                'ts': -576099000,
                'time': '1951-09-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          30:
              {
                'ts': -557951400,
                'time': '1952-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          31:
              {
                'ts': -544649400,
                'time': '1952-09-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          32:
              {
                'ts': -526501800,
                'time': '1953-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          33:
              {
                'ts': -513199800,
                'time': '1953-09-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          34:
              {
                'ts': -495052200,
                'time': '1954-04-25T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          35:
              {
                'ts': -481750200,
                'time': '1954-09-26T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          36:
              {
                'ts': -463602600,
                'time': '1955-04-24T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          37:
              {
                'ts': -450300600,
                'time': '1955-09-25T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          38:
              {
                'ts': -431548200,
                'time': '1956-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          39:
              {
                'ts': -418246200,
                'time': '1956-09-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          40:
              {
                'ts': -400098600,
                'time': '1957-04-28T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          41:
              {
                'ts': -386796600,
                'time': '1957-09-29T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          42:
              {
                'ts': -368649000,
                'time': '1958-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          43:
              {
                'ts': -355347000,
                'time': '1958-09-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          44:
              {
                'ts': -337199400,
                'time': '1959-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          45:
              {
                'ts': -323897400,
                'time': '1959-09-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          46:
              {
                'ts': -305749800,
                'time': '1960-04-24T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          47:
              {
                'ts': -289423800,
                'time': '1960-10-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          48:
              {
                'ts': -273695400,
                'time': '1961-04-30T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          49:
              {
                'ts': -257974200,
                'time': '1961-10-29T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          50:
              {
                'ts': -242245800,
                'time': '1962-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          51:
              {
                'ts': -226524600,
                'time': '1962-10-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          52:
              {
                'ts': -210796200,
                'time': '1963-04-28T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          53:
              {
                'ts': -195075000,
                'time': '1963-10-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          54:
              {
                'ts': -179346600,
                'time': '1964-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          55:
              {
                'ts': -163625400,
                'time': '1964-10-25T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          56:
              {
                'ts': -147897000,
                'time': '1965-04-25T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          57:
              {
                'ts': -131571000,
                'time': '1965-10-31T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          58:
              {
                'ts': -119903400,
                'time': '1966-03-15T05:30:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          59:
              {
                'ts': -116445600,
                'time': '1966-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          60:
              {
                'ts': -100119600,
                'time': '1966-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          61:
              {
                'ts': -84391200,
                'time': '1967-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          62:
              {
                'ts': -68670000,
                'time': '1967-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          63:
              {
                'ts': -52941600,
                'time': '1968-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          64:
              {
                'ts': -37220400,
                'time': '1968-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          65:
              {
                'ts': -21492000,
                'time': '1969-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          66:
              {
                'ts': -5770800,
                'time': '1969-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          67:
              {
                'ts': 9957600,
                'time': '1970-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          68:
              {
                'ts': 25678800,
                'time': '1970-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          69:
              {
                'ts': 41407200,
                'time': '1971-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          70:
              {
                'ts': 57733200,
                'time': '1971-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          71:
              {
                'ts': 73461600,
                'time': '1972-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          72:
              {
                'ts': 89182800,
                'time': '1972-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          73:
              {
                'ts': 104911200,
                'time': '1973-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          74:
              {
                'ts': 120632400,
                'time': '1973-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          75:
              {
                'ts': 136360800,
                'time': '1974-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          76:
              {
                'ts': 152082000,
                'time': '1974-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          77:
              {
                'ts': 167810400,
                'time': '1975-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          78:
              {
                'ts': 183531600,
                'time': '1975-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          79:
              {
                'ts': 199260000,
                'time': '1976-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          80:
              {
                'ts': 215586000,
                'time': '1976-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          81:
              {
                'ts': 230709600,
                'time': '1977-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          82:
              {
                'ts': 247035600,
                'time': '1977-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          83:
              {
                'ts': 262764000,
                'time': '1978-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          84:
              {
                'ts': 278485200,
                'time': '1978-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          85:
              {
                'ts': 294213600,
                'time': '1979-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          86:
              {
                'ts': 309934800,
                'time': '1979-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          87:
              {
                'ts': 325663200,
                'time': '1980-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          88:
              {
                'ts': 341384400,
                'time': '1980-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          89:
              {
                'ts': 357112800,
                'time': '1981-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          90:
              {
                'ts': 372834000,
                'time': '1981-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          91:
              {
                'ts': 388562400,
                'time': '1982-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          92:
              {
                'ts': 404888400,
                'time': '1982-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          93:
              {
                'ts': 420012000,
                'time': '1983-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          94:
              {
                'ts': 436338000,
                'time': '1983-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          95:
              {
                'ts': 452066400,
                'time': '1984-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          96:
              {
                'ts': 467787600,
                'time': '1984-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          97:
              {
                'ts': 483516000,
                'time': '1985-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          98:
              {
                'ts': 499237200,
                'time': '1985-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          99:
              {
                'ts': 514965600,
                'time': '1986-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          100:
              {
                'ts': 530686800,
                'time': '1986-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          101:
              {
                'ts': 544593660,
                'time': '1987-04-05T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          102:
              {
                'ts': 562129260,
                'time': '1987-10-25T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          103:
              {
                'ts': 576043260,
                'time': '1988-04-03T04:01:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ADDT'
              },
          104:
              {
                'ts': 594180060,
                'time': '1988-10-30T02:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          105:
              {
                'ts': 607492860,
                'time': '1989-04-02T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          106:
              {
                'ts': 625633260,
                'time': '1989-10-29T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          107:
              {
                'ts': 638942460,
                'time': '1990-04-01T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          108:
              {
                'ts': 657082860,
                'time': '1990-10-28T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          109:
              {
                'ts': 670996860,
                'time': '1991-04-07T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          110:
              {
                'ts': 688532460,
                'time': '1991-10-27T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          111:
              {
                'ts': 702446460,
                'time': '1992-04-05T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          112:
              {
                'ts': 719982060,
                'time': '1992-10-25T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          113:
              {
                'ts': 733896060,
                'time': '1993-04-04T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          114:
              {
                'ts': 752036460,
                'time': '1993-10-31T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          115:
              {
                'ts': 765345660,
                'time': '1994-04-03T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          116:
              {
                'ts': 783486060,
                'time': '1994-10-30T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          117:
              {
                'ts': 796795260,
                'time': '1995-04-02T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          118:
              {
                'ts': 814935660,
                'time': '1995-10-29T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          119:
              {
                'ts': 828849660,
                'time': '1996-04-07T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          120:
              {
                'ts': 846385260,
                'time': '1996-10-27T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          121:
              {
                'ts': 860299260,
                'time': '1997-04-06T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          122:
              {
                'ts': 877834860,
                'time': '1997-10-26T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          123:
              {
                'ts': 891748860,
                'time': '1998-04-05T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          124:
              {
                'ts': 909284460,
                'time': '1998-10-25T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          125:
              {
                'ts': 923198460,
                'time': '1999-04-04T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          126:
              {
                'ts': 941338860,
                'time': '1999-10-31T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          127:
              {
                'ts': 954648060,
                'time': '2000-04-02T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          128:
              {
                'ts': 972788460,
                'time': '2000-10-29T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          129:
              {
                'ts': 986097660,
                'time': '2001-04-01T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          130:
              {
                'ts': 1004238060,
                'time': '2001-10-28T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          131:
              {
                'ts': 1018152060,
                'time': '2002-04-07T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          132:
              {
                'ts': 1035687660,
                'time': '2002-10-27T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          133:
              {
                'ts': 1049601660,
                'time': '2003-04-06T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          134:
              {
                'ts': 1067137260,
                'time': '2003-10-26T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          135:
              {
                'ts': 1081051260,
                'time': '2004-04-04T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          136:
              {
                'ts': 1099191660,
                'time': '2004-10-31T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          137:
              {
                'ts': 1112500860,
                'time': '2005-04-03T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          138:
              {
                'ts': 1130641260,
                'time': '2005-10-30T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          139:
              {
                'ts': 1143950460,
                'time': '2006-04-02T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          140:
              {
                'ts': 1162090860,
                'time': '2006-10-29T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          141:
              {
                'ts': 1173585660,
                'time': '2007-03-11T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          142:
              {
                'ts': 1194145260,
                'time': '2007-11-04T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          143:
              {
                'ts': 1205035260,
                'time': '2008-03-09T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          144:
              {
                'ts': 1225594860,
                'time': '2008-11-02T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          145:
              {
                'ts': 1236484860,
                'time': '2009-03-08T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          146:
              {
                'ts': 1257044460,
                'time': '2009-11-01T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          147:
              {
                'ts': 1268539260,
                'time': '2010-03-14T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          148:
              {
                'ts': 1289098860,
                'time': '2010-11-07T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          149:
              {
                'ts': 1299988860,
                'time': '2011-03-13T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          150:
              {
                'ts': 1320548460,
                'time': '2011-11-06T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          151:
              {
                'ts': 1331438460,
                'time': '2012-03-11T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          152:
              {
                'ts': 1351998060,
                'time': '2012-11-04T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          153:
              {
                'ts': 1362888060,
                'time': '2013-03-10T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          154:
              {
                'ts': 1383447660,
                'time': '2013-11-03T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          155:
              {
                'ts': 1394337660,
                'time': '2014-03-09T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          156:
              {
                'ts': 1414897260,
                'time': '2014-11-02T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          157:
              {
                'ts': 1425787260,
                'time': '2015-03-08T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          158:
              {
                'ts': 1446346860,
                'time': '2015-11-01T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          159:
              {
                'ts': 1457841660,
                'time': '2016-03-13T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          160:
              {
                'ts': 1478401260,
                'time': '2016-11-06T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          161:
              {
                'ts': 1489291260,
                'time': '2017-03-12T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          162:
              {
                'ts': 1509850860,
                'time': '2017-11-05T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          163:
              {
                'ts': 1520740860,
                'time': '2018-03-11T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          164:
              {
                'ts': 1541300460,
                'time': '2018-11-04T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          165:
              {
                'ts': 1552190460,
                'time': '2019-03-10T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          166:
              {
                'ts': 1572750060,
                'time': '2019-11-03T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          167:
              {
                'ts': 1583640060,
                'time': '2020-03-08T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          168:
              {
                'ts': 1604199660,
                'time': '2020-11-01T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          169:
              {
                'ts': 1615694460,
                'time': '2021-03-14T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          170:
              {
                'ts': 1636254060,
                'time': '2021-11-07T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          171:
              {
                'ts': 1647144060,
                'time': '2022-03-13T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          172:
              {
                'ts': 1667703660,
                'time': '2022-11-06T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          173:
              {
                'ts': 1678593660,
                'time': '2023-03-12T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          174:
              {
                'ts': 1699153260,
                'time': '2023-11-05T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          175:
              {
                'ts': 1710043260,
                'time': '2024-03-10T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          176:
              {
                'ts': 1730602860,
                'time': '2024-11-03T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          177:
              {
                'ts': 1741492860,
                'time': '2025-03-09T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          178:
              {
                'ts': 1762052460,
                'time': '2025-11-02T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          179:
              {
                'ts': 1772942460,
                'time': '2026-03-08T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          180:
              {
                'ts': 1793502060,
                'time': '2026-11-01T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          181:
              {
                'ts': 1804996860,
                'time': '2027-03-14T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          182:
              {
                'ts': 1825556460,
                'time': '2027-11-07T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          183:
              {
                'ts': 1836446460,
                'time': '2028-03-12T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          184:
              {
                'ts': 1857006060,
                'time': '2028-11-05T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          185:
              {
                'ts': 1867896060,
                'time': '2029-03-11T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          186:
              {
                'ts': 1888455660,
                'time': '2029-11-04T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          187:
              {
                'ts': 1899345660,
                'time': '2030-03-10T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          188:
              {
                'ts': 1919905260,
                'time': '2030-11-03T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          189:
              {
                'ts': 1930795260,
                'time': '2031-03-09T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          190:
              {
                'ts': 1951354860,
                'time': '2031-11-02T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          191:
              {
                'ts': 1962849660,
                'time': '2032-03-14T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          192:
              {
                'ts': 1983409260,
                'time': '2032-11-07T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          193:
              {
                'ts': 1994299260,
                'time': '2033-03-13T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          194:
              {
                'ts': 2014858860,
                'time': '2033-11-06T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          195:
              {
                'ts': 2025748860,
                'time': '2034-03-12T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          196:
              {
                'ts': 2046308460,
                'time': '2034-11-05T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          197:
              {
                'ts': 2057198460,
                'time': '2035-03-11T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          198:
              {
                'ts': 2077758060,
                'time': '2035-11-04T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          199:
              {
                'ts': 2088648060,
                'time': '2036-03-09T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          200:
              {
                'ts': 2109207660,
                'time': '2036-11-02T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          201:
              {
                'ts': 2120097660,
                'time': '2037-03-08T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          202:
              {
                'ts': 2140657260,
                'time': '2037-11-01T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Grand_Turk':
        {
          0:
              {
                'ts': -1827687168,
                'time': '1912-02-01T05:07:12+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          1:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          2:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          3:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          4:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          5:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          6:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          7:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          8:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          10:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          12:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          14:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          16:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          18:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          20:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          22:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          24:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          26:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          28:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          30:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          32:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          34:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          36:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          38:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          40:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          42:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          44:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          46:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          48:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          50:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          52:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          54:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          56:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          58:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          60:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          62:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          64:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          66:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          68:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          70:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          72:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          116:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          118:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Grenada':
        {
          0:
              {
                'ts': -1846266780,
                'time': '1911-07-01T04:07:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Guadeloupe':
        {
          0:
              {
                'ts': -1848254032,
                'time': '1911-06-08T04:06:08+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Guatemala':
        {
          0:
              {
                'ts': -1617040676,
                'time': '1918-10-05T06:02:04+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': 123055200,
                'time': '1973-11-25T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          2:
              {
                'ts': 130914000,
                'time': '1974-02-24T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': 422344800,
                'time': '1983-05-21T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': 433054800,
                'time': '1983-09-22T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': 669708000,
                'time': '1991-03-23T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': 684219600,
                'time': '1991-09-07T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': 1146376800,
                'time': '2006-04-30T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': 1159678800,
                'time': '2006-10-01T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Guayaquil':
        {
          0:
              {
                'ts': -1230749160,
                'time': '1931-01-01T05:14:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ECT'
              }
        },
    'America/Guyana':
        {
          0:
              {
                'ts': -1730578040,
                'time': '1915-03-01T03:52:40+0000',
                'offset': -13500,
                'isdst': false,
                'abbr': 'GBGT'
              },
          1:
              {
                'ts': -113688900,
                'time': '1966-05-26T03:45:00+0000',
                'offset': -13500,
                'isdst': false,
                'abbr': 'GYT'
              },
          2:
              {
                'ts': 176010300,
                'time': '1975-07-31T03:45:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'GYT'
              },
          3:
              {
                'ts': 662698800,
                'time': '1991-01-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'GYT'
              }
        },
    'America/Halifax':
        {
          0:
              {
                'ts': -2131645536,
                'time': '1902-06-15T04:14:24+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          1:
              {
                'ts': -1696276800,
                'time': '1916-04-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          2:
              {
                'ts': -1680469200,
                'time': '1916-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          3:
              {
                'ts': -1632074400,
                'time': '1918-04-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          4:
              {
                'ts': -1614798000,
                'time': '1918-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          5:
              {
                'ts': -1566763200,
                'time': '1920-05-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          6:
              {
                'ts': -1557090000,
                'time': '1920-08-29T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          7:
              {
                'ts': -1535486400,
                'time': '1921-05-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          8:
              {
                'ts': -1524949200,
                'time': '1921-09-05T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          9:
              {
                'ts': -1504468800,
                'time': '1922-04-30T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          10:
              {
                'ts': -1493413200,
                'time': '1922-09-05T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          11:
              {
                'ts': -1472414400,
                'time': '1923-05-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          12:
              {
                'ts': -1461963600,
                'time': '1923-09-04T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          13:
              {
                'ts': -1440964800,
                'time': '1924-05-04T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          14:
              {
                'ts': -1429390800,
                'time': '1924-09-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          15:
              {
                'ts': -1409515200,
                'time': '1925-05-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          16:
              {
                'ts': -1396731600,
                'time': '1925-09-28T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          17:
              {
                'ts': -1376856000,
                'time': '1926-05-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          18:
              {
                'ts': -1366491600,
                'time': '1926-09-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          19:
              {
                'ts': -1346616000,
                'time': '1927-05-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          20:
              {
                'ts': -1333832400,
                'time': '1927-09-26T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          21:
              {
                'ts': -1313956800,
                'time': '1928-05-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          22:
              {
                'ts': -1303678800,
                'time': '1928-09-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          23:
              {
                'ts': -1282507200,
                'time': '1929-05-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          24:
              {
                'ts': -1272661200,
                'time': '1929-09-03T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          25:
              {
                'ts': -1251057600,
                'time': '1930-05-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          26:
              {
                'ts': -1240088400,
                'time': '1930-09-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          27:
              {
                'ts': -1219608000,
                'time': '1931-05-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          28:
              {
                'ts': -1207429200,
                'time': '1931-09-28T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          29:
              {
                'ts': -1188763200,
                'time': '1932-05-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          30:
              {
                'ts': -1175979600,
                'time': '1932-09-26T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          31:
              {
                'ts': -1157313600,
                'time': '1933-04-30T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          32:
              {
                'ts': -1143925200,
                'time': '1933-10-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          33:
              {
                'ts': -1124049600,
                'time': '1934-05-20T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          34:
              {
                'ts': -1113771600,
                'time': '1934-09-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          35:
              {
                'ts': -1091390400,
                'time': '1935-06-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          36:
              {
                'ts': -1081026000,
                'time': '1935-09-30T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          37:
              {
                'ts': -1059854400,
                'time': '1936-06-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          38:
              {
                'ts': -1050786000,
                'time': '1936-09-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          39:
              {
                'ts': -1030910400,
                'time': '1937-05-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          40:
              {
                'ts': -1018126800,
                'time': '1937-09-27T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          41:
              {
                'ts': -999460800,
                'time': '1938-05-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          42:
              {
                'ts': -986677200,
                'time': '1938-09-26T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          43:
              {
                'ts': -965592000,
                'time': '1939-05-28T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          44:
              {
                'ts': -955227600,
                'time': '1939-09-25T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          45:
              {
                'ts': -935956800,
                'time': '1940-05-05T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          46:
              {
                'ts': -923173200,
                'time': '1940-09-30T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          47:
              {
                'ts': -904507200,
                'time': '1941-05-04T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          48:
              {
                'ts': -891723600,
                'time': '1941-09-29T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          49:
              {
                'ts': -880221600,
                'time': '1942-02-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AWT'
              },
          50:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'APT'
              },
          51:
              {
                'ts': -765399600,
                'time': '1945-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          52:
              {
                'ts': -747252000,
                'time': '1946-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          53:
              {
                'ts': -733950000,
                'time': '1946-09-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          54:
              {
                'ts': -715802400,
                'time': '1947-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          55:
              {
                'ts': -702500400,
                'time': '1947-09-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          56:
              {
                'ts': -684352800,
                'time': '1948-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          57:
              {
                'ts': -671050800,
                'time': '1948-09-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          58:
              {
                'ts': -652903200,
                'time': '1949-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          59:
              {
                'ts': -639601200,
                'time': '1949-09-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          60:
              {
                'ts': -589399200,
                'time': '1951-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          61:
              {
                'ts': -576097200,
                'time': '1951-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          62:
              {
                'ts': -557949600,
                'time': '1952-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          63:
              {
                'ts': -544647600,
                'time': '1952-09-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          64:
              {
                'ts': -526500000,
                'time': '1953-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          65:
              {
                'ts': -513198000,
                'time': '1953-09-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          66:
              {
                'ts': -495050400,
                'time': '1954-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          67:
              {
                'ts': -481748400,
                'time': '1954-09-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          68:
              {
                'ts': -431546400,
                'time': '1956-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          69:
              {
                'ts': -418244400,
                'time': '1956-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          70:
              {
                'ts': -400096800,
                'time': '1957-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          71:
              {
                'ts': -386794800,
                'time': '1957-09-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          72:
              {
                'ts': -368647200,
                'time': '1958-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          73:
              {
                'ts': -355345200,
                'time': '1958-09-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          74:
              {
                'ts': -337197600,
                'time': '1959-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          75:
              {
                'ts': -323895600,
                'time': '1959-09-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          76:
              {
                'ts': -242244000,
                'time': '1962-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          77:
              {
                'ts': -226522800,
                'time': '1962-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          78:
              {
                'ts': -210794400,
                'time': '1963-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          79:
              {
                'ts': -195073200,
                'time': '1963-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          80:
              {
                'ts': -179344800,
                'time': '1964-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          81:
              {
                'ts': -163623600,
                'time': '1964-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          82:
              {
                'ts': -147895200,
                'time': '1965-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          83:
              {
                'ts': -131569200,
                'time': '1965-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          84:
              {
                'ts': -116445600,
                'time': '1966-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          85:
              {
                'ts': -100119600,
                'time': '1966-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          86:
              {
                'ts': -84391200,
                'time': '1967-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          87:
              {
                'ts': -68670000,
                'time': '1967-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          88:
              {
                'ts': -52941600,
                'time': '1968-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          89:
              {
                'ts': -37220400,
                'time': '1968-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          90:
              {
                'ts': -21492000,
                'time': '1969-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          91:
              {
                'ts': -5770800,
                'time': '1969-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          92:
              {
                'ts': 9957600,
                'time': '1970-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          93:
              {
                'ts': 25678800,
                'time': '1970-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          94:
              {
                'ts': 41407200,
                'time': '1971-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          95:
              {
                'ts': 57733200,
                'time': '1971-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          96:
              {
                'ts': 73461600,
                'time': '1972-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          97:
              {
                'ts': 89182800,
                'time': '1972-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          98:
              {
                'ts': 104911200,
                'time': '1973-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          99:
              {
                'ts': 120632400,
                'time': '1973-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          100:
              {
                'ts': 136360800,
                'time': '1974-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          101:
              {
                'ts': 152082000,
                'time': '1974-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          102:
              {
                'ts': 167810400,
                'time': '1975-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          103:
              {
                'ts': 183531600,
                'time': '1975-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          104:
              {
                'ts': 199260000,
                'time': '1976-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          105:
              {
                'ts': 215586000,
                'time': '1976-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          106:
              {
                'ts': 230709600,
                'time': '1977-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          107:
              {
                'ts': 247035600,
                'time': '1977-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          108:
              {
                'ts': 262764000,
                'time': '1978-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          109:
              {
                'ts': 278485200,
                'time': '1978-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          110:
              {
                'ts': 294213600,
                'time': '1979-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          111:
              {
                'ts': 309934800,
                'time': '1979-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          112:
              {
                'ts': 325663200,
                'time': '1980-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          113:
              {
                'ts': 341384400,
                'time': '1980-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          114:
              {
                'ts': 357112800,
                'time': '1981-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          115:
              {
                'ts': 372834000,
                'time': '1981-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          116:
              {
                'ts': 388562400,
                'time': '1982-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          117:
              {
                'ts': 404888400,
                'time': '1982-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          118:
              {
                'ts': 420012000,
                'time': '1983-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          119:
              {
                'ts': 436338000,
                'time': '1983-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          120:
              {
                'ts': 452066400,
                'time': '1984-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          121:
              {
                'ts': 467787600,
                'time': '1984-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          122:
              {
                'ts': 483516000,
                'time': '1985-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          123:
              {
                'ts': 499237200,
                'time': '1985-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          124:
              {
                'ts': 514965600,
                'time': '1986-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          125:
              {
                'ts': 530686800,
                'time': '1986-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          126:
              {
                'ts': 544600800,
                'time': '1987-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          127:
              {
                'ts': 562136400,
                'time': '1987-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          128:
              {
                'ts': 576050400,
                'time': '1988-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          129:
              {
                'ts': 594190800,
                'time': '1988-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          130:
              {
                'ts': 607500000,
                'time': '1989-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          131:
              {
                'ts': 625640400,
                'time': '1989-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          132:
              {
                'ts': 638949600,
                'time': '1990-04-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          133:
              {
                'ts': 657090000,
                'time': '1990-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          134:
              {
                'ts': 671004000,
                'time': '1991-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          135:
              {
                'ts': 688539600,
                'time': '1991-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          136:
              {
                'ts': 702453600,
                'time': '1992-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          137:
              {
                'ts': 719989200,
                'time': '1992-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          138:
              {
                'ts': 733903200,
                'time': '1993-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          139:
              {
                'ts': 752043600,
                'time': '1993-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          140:
              {
                'ts': 765352800,
                'time': '1994-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          141:
              {
                'ts': 783493200,
                'time': '1994-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          142:
              {
                'ts': 796802400,
                'time': '1995-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          143:
              {
                'ts': 814942800,
                'time': '1995-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          144:
              {
                'ts': 828856800,
                'time': '1996-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          145:
              {
                'ts': 846392400,
                'time': '1996-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          146:
              {
                'ts': 860306400,
                'time': '1997-04-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          147:
              {
                'ts': 877842000,
                'time': '1997-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          148:
              {
                'ts': 891756000,
                'time': '1998-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          149:
              {
                'ts': 909291600,
                'time': '1998-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          150:
              {
                'ts': 923205600,
                'time': '1999-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          151:
              {
                'ts': 941346000,
                'time': '1999-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          152:
              {
                'ts': 954655200,
                'time': '2000-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          153:
              {
                'ts': 972795600,
                'time': '2000-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          154:
              {
                'ts': 986104800,
                'time': '2001-04-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          155:
              {
                'ts': 1004245200,
                'time': '2001-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          156:
              {
                'ts': 1018159200,
                'time': '2002-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          157:
              {
                'ts': 1035694800,
                'time': '2002-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          158:
              {
                'ts': 1049608800,
                'time': '2003-04-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          159:
              {
                'ts': 1067144400,
                'time': '2003-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          160:
              {
                'ts': 1081058400,
                'time': '2004-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          161:
              {
                'ts': 1099198800,
                'time': '2004-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          162:
              {
                'ts': 1112508000,
                'time': '2005-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          163:
              {
                'ts': 1130648400,
                'time': '2005-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          164:
              {
                'ts': 1143957600,
                'time': '2006-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          165:
              {
                'ts': 1162098000,
                'time': '2006-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          166:
              {
                'ts': 1173592800,
                'time': '2007-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          167:
              {
                'ts': 1194152400,
                'time': '2007-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          168:
              {
                'ts': 1205042400,
                'time': '2008-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          169:
              {
                'ts': 1225602000,
                'time': '2008-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          170:
              {
                'ts': 1236492000,
                'time': '2009-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          171:
              {
                'ts': 1257051600,
                'time': '2009-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          172:
              {
                'ts': 1268546400,
                'time': '2010-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          173:
              {
                'ts': 1289106000,
                'time': '2010-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          174:
              {
                'ts': 1299996000,
                'time': '2011-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          175:
              {
                'ts': 1320555600,
                'time': '2011-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          176:
              {
                'ts': 1331445600,
                'time': '2012-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          177:
              {
                'ts': 1352005200,
                'time': '2012-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          178:
              {
                'ts': 1362895200,
                'time': '2013-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          179:
              {
                'ts': 1383454800,
                'time': '2013-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          180:
              {
                'ts': 1394344800,
                'time': '2014-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          181:
              {
                'ts': 1414904400,
                'time': '2014-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          182:
              {
                'ts': 1425794400,
                'time': '2015-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          183:
              {
                'ts': 1446354000,
                'time': '2015-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          184:
              {
                'ts': 1457848800,
                'time': '2016-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          185:
              {
                'ts': 1478408400,
                'time': '2016-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          186:
              {
                'ts': 1489298400,
                'time': '2017-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          187:
              {
                'ts': 1509858000,
                'time': '2017-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          188:
              {
                'ts': 1520748000,
                'time': '2018-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          189:
              {
                'ts': 1541307600,
                'time': '2018-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          190:
              {
                'ts': 1552197600,
                'time': '2019-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          191:
              {
                'ts': 1572757200,
                'time': '2019-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          192:
              {
                'ts': 1583647200,
                'time': '2020-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          193:
              {
                'ts': 1604206800,
                'time': '2020-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          194:
              {
                'ts': 1615701600,
                'time': '2021-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          195:
              {
                'ts': 1636261200,
                'time': '2021-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          196:
              {
                'ts': 1647151200,
                'time': '2022-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          197:
              {
                'ts': 1667710800,
                'time': '2022-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          198:
              {
                'ts': 1678600800,
                'time': '2023-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          199:
              {
                'ts': 1699160400,
                'time': '2023-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          200:
              {
                'ts': 1710050400,
                'time': '2024-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          201:
              {
                'ts': 1730610000,
                'time': '2024-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          202:
              {
                'ts': 1741500000,
                'time': '2025-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          203:
              {
                'ts': 1762059600,
                'time': '2025-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          204:
              {
                'ts': 1772949600,
                'time': '2026-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          205:
              {
                'ts': 1793509200,
                'time': '2026-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          206:
              {
                'ts': 1805004000,
                'time': '2027-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          207:
              {
                'ts': 1825563600,
                'time': '2027-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          208:
              {
                'ts': 1836453600,
                'time': '2028-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          209:
              {
                'ts': 1857013200,
                'time': '2028-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          210:
              {
                'ts': 1867903200,
                'time': '2029-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          211:
              {
                'ts': 1888462800,
                'time': '2029-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          212:
              {
                'ts': 1899352800,
                'time': '2030-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          213:
              {
                'ts': 1919912400,
                'time': '2030-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          214:
              {
                'ts': 1930802400,
                'time': '2031-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          215:
              {
                'ts': 1951362000,
                'time': '2031-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          216:
              {
                'ts': 1962856800,
                'time': '2032-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          217:
              {
                'ts': 1983416400,
                'time': '2032-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          218:
              {
                'ts': 1994306400,
                'time': '2033-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          219:
              {
                'ts': 2014866000,
                'time': '2033-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          220:
              {
                'ts': 2025756000,
                'time': '2034-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          221:
              {
                'ts': 2046315600,
                'time': '2034-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          222:
              {
                'ts': 2057205600,
                'time': '2035-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          223:
              {
                'ts': 2077765200,
                'time': '2035-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          224:
              {
                'ts': 2088655200,
                'time': '2036-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          225:
              {
                'ts': 2109214800,
                'time': '2036-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          226:
              {
                'ts': 2120104800,
                'time': '2037-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          227:
              {
                'ts': 2140664400,
                'time': '2037-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Havana':
        {
          0:
              {
                'ts': -1402813824,
                'time': '1925-07-19T17:29:36+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -1311534000,
                'time': '1928-06-10T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          2:
              {
                'ts': -1300996800,
                'time': '1928-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': -933534000,
                'time': '1940-06-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': -925675200,
                'time': '1940-09-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': -902084400,
                'time': '1941-06-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': -893620800,
                'time': '1941-09-07T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -870030000,
                'time': '1942-06-07T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -862171200,
                'time': '1942-09-06T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -775681200,
                'time': '1945-06-03T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -767822400,
                'time': '1945-09-02T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -744231600,
                'time': '1946-06-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -736372800,
                'time': '1946-09-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -144702000,
                'time': '1965-06-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -134251200,
                'time': '1965-09-30T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -113425200,
                'time': '1966-05-29T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -102542400,
                'time': '1966-10-02T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -86295600,
                'time': '1967-04-08T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -72907200,
                'time': '1967-09-10T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -54154800,
                'time': '1968-04-14T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -41457600,
                'time': '1968-09-08T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -21495600,
                'time': '1969-04-27T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -5774400,
                'time': '1969-10-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 9954000,
                'time': '1970-04-26T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': 25675200,
                'time': '1970-10-25T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 41403600,
                'time': '1971-04-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': 57729600,
                'time': '1971-10-31T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 73458000,
                'time': '1972-04-30T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': 87364800,
                'time': '1972-10-08T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 104907600,
                'time': '1973-04-29T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': 118900800,
                'time': '1973-10-08T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 136357200,
                'time': '1974-04-28T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': 150436800,
                'time': '1974-10-08T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 167806800,
                'time': '1975-04-27T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': 183528000,
                'time': '1975-10-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 199256400,
                'time': '1976-04-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': 215582400,
                'time': '1976-10-31T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 230706000,
                'time': '1977-04-24T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          38:
              {
                'ts': 247032000,
                'time': '1977-10-30T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 263365200,
                'time': '1978-05-07T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': 276667200,
                'time': '1978-10-08T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 290581200,
                'time': '1979-03-18T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': 308721600,
                'time': '1979-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 322030800,
                'time': '1980-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': 340171200,
                'time': '1980-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 358318800,
                'time': '1981-05-10T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 371620800,
                'time': '1981-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 389768400,
                'time': '1982-05-09T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 403070400,
                'time': '1982-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 421218000,
                'time': '1983-05-08T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 434520000,
                'time': '1983-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 452667600,
                'time': '1984-05-06T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 466574400,
                'time': '1984-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 484117200,
                'time': '1985-05-05T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 498024000,
                'time': '1985-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 511333200,
                'time': '1986-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 529473600,
                'time': '1986-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 542782800,
                'time': '1987-03-15T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 560923200,
                'time': '1987-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 574837200,
                'time': '1988-03-20T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 592372800,
                'time': '1988-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 606286800,
                'time': '1989-03-19T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 623822400,
                'time': '1989-10-08T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 638946000,
                'time': '1990-04-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 655876800,
                'time': '1990-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 671000400,
                'time': '1991-04-07T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 687330000,
                'time': '1991-10-13T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 702450000,
                'time': '1992-04-05T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 718779600,
                'time': '1992-10-11T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 733899600,
                'time': '1993-04-04T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 750229200,
                'time': '1993-10-10T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 765349200,
                'time': '1994-04-03T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 781678800,
                'time': '1994-10-09T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 796798800,
                'time': '1995-04-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 813128400,
                'time': '1995-10-08T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 828853200,
                'time': '1996-04-07T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 844578000,
                'time': '1996-10-06T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 860302800,
                'time': '1997-04-06T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 876632400,
                'time': '1997-10-12T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 891147600,
                'time': '1998-03-29T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 909291600,
                'time': '1998-10-25T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 922597200,
                'time': '1999-03-28T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 941346000,
                'time': '1999-10-31T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 954651600,
                'time': '2000-04-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 972795600,
                'time': '2000-10-29T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 986101200,
                'time': '2001-04-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 1004245200,
                'time': '2001-10-28T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 1018155600,
                'time': '2002-04-07T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': 1035694800,
                'time': '2002-10-27T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          89:
              {
                'ts': 1049605200,
                'time': '2003-04-06T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': 1067144400,
                'time': '2003-10-26T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1081054800,
                'time': '2004-04-04T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': 1162098000,
                'time': '2006-10-29T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1173589200,
                'time': '2007-03-11T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': 1193547600,
                'time': '2007-10-28T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1205643600,
                'time': '2008-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': 1224997200,
                'time': '2008-10-26T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1237093200,
                'time': '2009-03-15T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': 1256446800,
                'time': '2009-10-25T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1269147600,
                'time': '2010-03-21T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 1288501200,
                'time': '2010-10-31T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1300597200,
                'time': '2011-03-20T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 1319950800,
                'time': '2011-10-30T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1332046800,
                'time': '2012-03-18T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 1351400400,
                'time': '2012-10-28T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1363496400,
                'time': '2013-03-17T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 1382850000,
                'time': '2013-10-27T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1394946000,
                'time': '2014-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 1414299600,
                'time': '2014-10-26T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1426395600,
                'time': '2015-03-15T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 1445749200,
                'time': '2015-10-25T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 1458450000,
                'time': '2016-03-20T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 1477803600,
                'time': '2016-10-30T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1489899600,
                'time': '2017-03-19T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 1509253200,
                'time': '2017-10-29T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1521349200,
                'time': '2018-03-18T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 1540702800,
                'time': '2018-10-28T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1552798800,
                'time': '2019-03-17T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 1572152400,
                'time': '2019-10-27T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1584248400,
                'time': '2020-03-15T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          120:
              {
                'ts': 1603602000,
                'time': '2020-10-25T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1616302800,
                'time': '2021-03-21T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          122:
              {
                'ts': 1635656400,
                'time': '2021-10-31T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 1647752400,
                'time': '2022-03-20T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          124:
              {
                'ts': 1667106000,
                'time': '2022-10-30T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 1679202000,
                'time': '2023-03-19T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          126:
              {
                'ts': 1698555600,
                'time': '2023-10-29T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 1710651600,
                'time': '2024-03-17T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          128:
              {
                'ts': 1730005200,
                'time': '2024-10-27T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 1742101200,
                'time': '2025-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          130:
              {
                'ts': 1761454800,
                'time': '2025-10-26T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 1773550800,
                'time': '2026-03-15T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          132:
              {
                'ts': 1792904400,
                'time': '2026-10-25T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 1805605200,
                'time': '2027-03-21T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          134:
              {
                'ts': 1824958800,
                'time': '2027-10-31T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 1837054800,
                'time': '2028-03-19T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          136:
              {
                'ts': 1856408400,
                'time': '2028-10-29T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 1868504400,
                'time': '2029-03-18T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          138:
              {
                'ts': 1887858000,
                'time': '2029-10-28T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 1899954000,
                'time': '2030-03-17T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          140:
              {
                'ts': 1919307600,
                'time': '2030-10-27T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          141:
              {
                'ts': 1931403600,
                'time': '2031-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          142:
              {
                'ts': 1950757200,
                'time': '2031-10-26T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          143:
              {
                'ts': 1963458000,
                'time': '2032-03-21T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          144:
              {
                'ts': 1982811600,
                'time': '2032-10-31T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          145:
              {
                'ts': 1994907600,
                'time': '2033-03-20T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          146:
              {
                'ts': 2014261200,
                'time': '2033-10-30T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          147:
              {
                'ts': 2026357200,
                'time': '2034-03-19T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          148:
              {
                'ts': 2045710800,
                'time': '2034-10-29T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          149:
              {
                'ts': 2057806800,
                'time': '2035-03-18T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          150:
              {
                'ts': 2077160400,
                'time': '2035-10-28T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          151:
              {
                'ts': 2089256400,
                'time': '2036-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          152:
              {
                'ts': 2108610000,
                'time': '2036-10-26T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          153:
              {
                'ts': 2120706000,
                'time': '2037-03-15T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          154:
              {
                'ts': 2140059600,
                'time': '2037-10-25T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Hermosillo':
        {
          0:
              {
                'ts': -1514739600,
                'time': '1922-01-01T07:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1343066400,
                'time': '1927-06-11T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1234807200,
                'time': '1930-11-15T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1220292000,
                'time': '1931-05-02T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -1207159200,
                'time': '1931-10-01T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1191344400,
                'time': '1932-04-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -873828000,
                'time': '1942-04-24T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          7:
              {
                'ts': -661539600,
                'time': '1949-01-14T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          8:
              {
                'ts': 28800,
                'time': '1970-01-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          9:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          10:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'America/Indiana/Indianapolis':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -900259200,
                'time': '1941-06-22T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': -891795600,
                'time': '1941-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          7:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          8:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -747244800,
                'time': '1946-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -733942800,
                'time': '1946-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -702493200,
                'time': '1947-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -684345600,
                'time': '1948-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -671043600,
                'time': '1948-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -652896000,
                'time': '1949-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -639594000,
                'time': '1949-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -620841600,
                'time': '1950-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -608144400,
                'time': '1950-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Indiana/Knox':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          6:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -702493200,
                'time': '1947-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -684345600,
                'time': '1948-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -671043600,
                'time': '1948-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -652896000,
                'time': '1949-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -639594000,
                'time': '1949-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -620841600,
                'time': '1950-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -608144400,
                'time': '1950-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -447267600,
                'time': '1955-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -415818000,
                'time': '1956-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': -355338000,
                'time': '1958-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': -321469200,
                'time': '1959-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': -289414800,
                'time': '1960-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': -273686400,
                'time': '1961-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': -257965200,
                'time': '1961-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': -242236800,
                'time': '1962-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': -195066000,
                'time': '1963-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': -84384000,
                'time': '1967-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': -68662800,
                'time': '1967-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': -52934400,
                'time': '1968-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': -37213200,
                'time': '1968-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': -21484800,
                'time': '1969-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': -5763600,
                'time': '1969-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 9964800,
                'time': '1970-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 25686000,
                'time': '1970-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 41414400,
                'time': '1971-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 57740400,
                'time': '1971-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 73468800,
                'time': '1972-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 89190000,
                'time': '1972-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 104918400,
                'time': '1973-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 120639600,
                'time': '1973-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 126691200,
                'time': '1974-01-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 162374400,
                'time': '1975-02-23T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 183538800,
                'time': '1975-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 199267200,
                'time': '1976-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 215593200,
                'time': '1976-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 230716800,
                'time': '1977-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 247042800,
                'time': '1977-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 262771200,
                'time': '1978-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 278492400,
                'time': '1978-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 294220800,
                'time': '1979-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 309942000,
                'time': '1979-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 341391600,
                'time': '1980-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 372841200,
                'time': '1981-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 404895600,
                'time': '1982-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 436345200,
                'time': '1983-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 467794800,
                'time': '1984-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 499244400,
                'time': '1985-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 530694000,
                'time': '1986-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 562143600,
                'time': '1987-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 594198000,
                'time': '1988-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 625647600,
                'time': '1989-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 657097200,
                'time': '1990-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': 688546800,
                'time': '1991-10-27T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          120:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          122:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          124:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          126:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          128:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          130:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          132:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          134:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          136:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          138:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          140:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          141:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          142:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          143:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          144:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          145:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          146:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          147:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          148:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          149:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          150:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          151:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          152:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Indiana/Marengo':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          6:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -450291600,
                'time': '1955-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -418237200,
                'time': '1956-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -355338000,
                'time': '1958-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -323888400,
                'time': '1959-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -292438800,
                'time': '1960-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -273686400,
                'time': '1961-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          25:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          27:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          29:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 126687600,
                'time': '1974-01-06T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          35:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 162370800,
                'time': '1975-02-23T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          99:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          101:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Indiana/Petersburg':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          6:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -462996000,
                'time': '1955-05-01T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -450291600,
                'time': '1955-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -418237200,
                'time': '1956-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -355338000,
                'time': '1958-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -323888400,
                'time': '1959-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -292438800,
                'time': '1960-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -273686400,
                'time': '1961-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -257965200,
                'time': '1961-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -242236800,
                'time': '1962-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -226515600,
                'time': '1962-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -210787200,
                'time': '1963-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -195066000,
                'time': '1963-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -179337600,
                'time': '1964-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -163616400,
                'time': '1964-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -147888000,
                'time': '1965-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': -100112400,
                'time': '1966-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -84384000,
                'time': '1967-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': -68662800,
                'time': '1967-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': -52934400,
                'time': '1968-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': -37213200,
                'time': '1968-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': -21484800,
                'time': '1969-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': -5763600,
                'time': '1969-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 9964800,
                'time': '1970-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': 25686000,
                'time': '1970-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 41414400,
                'time': '1971-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          38:
              {
                'ts': 57740400,
                'time': '1971-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 73468800,
                'time': '1972-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': 89190000,
                'time': '1972-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 104918400,
                'time': '1973-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': 120639600,
                'time': '1973-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 126691200,
                'time': '1974-01-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 162374400,
                'time': '1975-02-23T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 183538800,
                'time': '1975-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 199267200,
                'time': '1976-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 215593200,
                'time': '1976-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 230716800,
                'time': '1977-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 247042800,
                'time': '1977-10-30T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          56:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          58:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          60:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          62:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          64:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          66:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          68:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          70:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          72:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Indiana/Tell_City':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          6:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -747244800,
                'time': '1946-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -733942800,
                'time': '1946-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -462996000,
                'time': '1955-05-01T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -450291600,
                'time': '1955-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -418237200,
                'time': '1956-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -355338000,
                'time': '1958-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -323888400,
                'time': '1959-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -289414800,
                'time': '1960-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -273686400,
                'time': '1961-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -260989200,
                'time': '1961-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -242236800,
                'time': '1962-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': -226515600,
                'time': '1962-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -210787200,
                'time': '1963-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': -195066000,
                'time': '1963-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': -179337600,
                'time': '1964-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          37:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          39:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          40:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          41:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          42:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          43:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          44:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          45:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          47:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          48:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          49:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          50:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          51:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          52:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          53:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          54:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          55:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          56:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          57:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          58:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          59:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          60:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          61:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          62:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          63:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          64:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          65:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          66:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          67:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          68:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          69:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          70:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          71:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          72:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          73:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          74:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          75:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          76:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          77:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          78:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          79:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          80:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          81:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          82:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          83:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          84:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          85:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          86:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          87:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          88:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          89:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          90:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          91:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          92:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          93:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          94:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          95:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          96:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          97:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          98:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          99:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Indiana/Vevay':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          6:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          9:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          11:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          13:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          15:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          17:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          19:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          21:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          23:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          25:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          27:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          29:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Indiana/Vincennes':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          6:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -747244800,
                'time': '1946-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -733942800,
                'time': '1946-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -462996000,
                'time': '1955-05-01T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -450291600,
                'time': '1955-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -418237200,
                'time': '1956-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -355338000,
                'time': '1958-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -323888400,
                'time': '1959-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -289414800,
                'time': '1960-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -273686400,
                'time': '1961-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -260989200,
                'time': '1961-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -242236800,
                'time': '1962-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': -226515600,
                'time': '1962-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -210787200,
                'time': '1963-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': -195066000,
                'time': '1963-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': -179337600,
                'time': '1964-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          37:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          39:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          99:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Indiana/Winamac':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          6:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -747244800,
                'time': '1946-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -733942800,
                'time': '1946-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -702493200,
                'time': '1947-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -684345600,
                'time': '1948-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -671043600,
                'time': '1948-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -652896000,
                'time': '1949-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -639594000,
                'time': '1949-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -620841600,
                'time': '1950-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -608144400,
                'time': '1950-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -447267600,
                'time': '1955-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': -415818000,
                'time': '1956-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': -355338000,
                'time': '1958-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': -323888400,
                'time': '1959-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': -292438800,
                'time': '1960-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': -273686400,
                'time': '1961-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          43:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          44:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          99:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          101:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          103:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          105:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Indianapolis':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -900259200,
                'time': '1941-06-22T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': -891795600,
                'time': '1941-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          7:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          8:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -747244800,
                'time': '1946-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -733942800,
                'time': '1946-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -702493200,
                'time': '1947-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -684345600,
                'time': '1948-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -671043600,
                'time': '1948-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -652896000,
                'time': '1949-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -639594000,
                'time': '1949-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -620841600,
                'time': '1950-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -608144400,
                'time': '1950-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Inuvik':
        {
          0:
              {
                'ts': -536457600,
                'time': '1953-01-01T00:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          1:
              {
                'ts': -147888000,
                'time': '1965-04-25T08:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'PDDT'
              },
          2:
              {
                'ts': -131558400,
                'time': '1965-10-31T08:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          3:
              {
                'ts': 294228000,
                'time': '1979-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          5:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          6:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          7:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          8:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          9:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          10:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          11:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          12:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          13:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          14:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          15:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          16:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          17:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          18:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          19:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          20:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          21:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          22:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          23:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          24:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          25:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          26:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          27:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          28:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          29:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          30:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          31:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          32:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          33:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          34:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          35:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          36:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          37:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          38:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          39:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          40:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          41:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          42:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          43:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          44:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          45:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          46:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          47:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          48:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          49:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          50:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          51:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          52:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          53:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          54:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          55:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          56:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          57:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          58:
              {
                'ts': 1173603600,
                'time': '2007-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          59:
              {
                'ts': 1194163200,
                'time': '2007-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          60:
              {
                'ts': 1205053200,
                'time': '2008-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          61:
              {
                'ts': 1225612800,
                'time': '2008-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          62:
              {
                'ts': 1236502800,
                'time': '2009-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          63:
              {
                'ts': 1257062400,
                'time': '2009-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          64:
              {
                'ts': 1268557200,
                'time': '2010-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          65:
              {
                'ts': 1289116800,
                'time': '2010-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          66:
              {
                'ts': 1300006800,
                'time': '2011-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          67:
              {
                'ts': 1320566400,
                'time': '2011-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          68:
              {
                'ts': 1331456400,
                'time': '2012-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          69:
              {
                'ts': 1352016000,
                'time': '2012-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          70:
              {
                'ts': 1362906000,
                'time': '2013-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          71:
              {
                'ts': 1383465600,
                'time': '2013-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          72:
              {
                'ts': 1394355600,
                'time': '2014-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          73:
              {
                'ts': 1414915200,
                'time': '2014-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          74:
              {
                'ts': 1425805200,
                'time': '2015-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          75:
              {
                'ts': 1446364800,
                'time': '2015-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          76:
              {
                'ts': 1457859600,
                'time': '2016-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          77:
              {
                'ts': 1478419200,
                'time': '2016-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          78:
              {
                'ts': 1489309200,
                'time': '2017-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          79:
              {
                'ts': 1509868800,
                'time': '2017-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          80:
              {
                'ts': 1520758800,
                'time': '2018-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          81:
              {
                'ts': 1541318400,
                'time': '2018-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          82:
              {
                'ts': 1552208400,
                'time': '2019-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          83:
              {
                'ts': 1572768000,
                'time': '2019-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          84:
              {
                'ts': 1583658000,
                'time': '2020-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          85:
              {
                'ts': 1604217600,
                'time': '2020-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          86:
              {
                'ts': 1615712400,
                'time': '2021-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          87:
              {
                'ts': 1636272000,
                'time': '2021-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          88:
              {
                'ts': 1647162000,
                'time': '2022-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          89:
              {
                'ts': 1667721600,
                'time': '2022-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          90:
              {
                'ts': 1678611600,
                'time': '2023-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          91:
              {
                'ts': 1699171200,
                'time': '2023-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          92:
              {
                'ts': 1710061200,
                'time': '2024-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          93:
              {
                'ts': 1730620800,
                'time': '2024-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          94:
              {
                'ts': 1741510800,
                'time': '2025-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          95:
              {
                'ts': 1762070400,
                'time': '2025-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          96:
              {
                'ts': 1772960400,
                'time': '2026-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          97:
              {
                'ts': 1793520000,
                'time': '2026-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          98:
              {
                'ts': 1805014800,
                'time': '2027-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          99:
              {
                'ts': 1825574400,
                'time': '2027-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          100:
              {
                'ts': 1836464400,
                'time': '2028-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          101:
              {
                'ts': 1857024000,
                'time': '2028-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          102:
              {
                'ts': 1867914000,
                'time': '2029-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          103:
              {
                'ts': 1888473600,
                'time': '2029-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          104:
              {
                'ts': 1899363600,
                'time': '2030-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          105:
              {
                'ts': 1919923200,
                'time': '2030-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          106:
              {
                'ts': 1930813200,
                'time': '2031-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          107:
              {
                'ts': 1951372800,
                'time': '2031-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          108:
              {
                'ts': 1962867600,
                'time': '2032-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          109:
              {
                'ts': 1983427200,
                'time': '2032-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          110:
              {
                'ts': 1994317200,
                'time': '2033-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          111:
              {
                'ts': 2014876800,
                'time': '2033-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          112:
              {
                'ts': 2025766800,
                'time': '2034-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          113:
              {
                'ts': 2046326400,
                'time': '2034-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          114:
              {
                'ts': 2057216400,
                'time': '2035-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          115:
              {
                'ts': 2077776000,
                'time': '2035-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          116:
              {
                'ts': 2088666000,
                'time': '2036-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          117:
              {
                'ts': 2109225600,
                'time': '2036-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          118:
              {
                'ts': 2120115600,
                'time': '2037-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          119:
              {
                'ts': 2140675200,
                'time': '2037-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'America/Iqaluit':
        {
          0:
              {
                'ts': -865296000,
                'time': '1942-08-01T00:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EWT'
              },
          1:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EPT'
              },
          2:
              {
                'ts': -765396000,
                'time': '1945-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -147898800,
                'time': '1965-04-25T05:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'EDDT'
              },
          4:
              {
                'ts': -131569200,
                'time': '1965-10-31T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          5:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          6:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          7:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          8:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          10:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          12:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          14:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          16:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          18:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          20:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          22:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          24:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          26:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          28:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          30:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          32:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          34:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          36:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          38:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          40:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          42:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          44:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          48:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          50:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          52:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          54:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          56:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          58:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          60:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          62:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          64:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          66:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          68:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          70:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          72:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          116:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          118:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          120:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Jamaica':
        {
          0:
              {
                'ts': -1827687168,
                'time': '1912-02-01T05:07:12+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          1:
              {
                'ts': 136364400,
                'time': '1974-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          2:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          3:
              {
                'ts': 162370800,
                'time': '1975-02-23T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          4:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          5:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          6:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          7:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          8:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          10:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          12:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          14:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          16:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          18:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          20:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Jujuy':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          48:
              {
                'ts': 657086400,
                'time': '1990-10-28T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'WARST'
              },
          49:
              {
                'ts': 669178800,
                'time': '1991-03-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 686721600,
                'time': '1991-10-06T04:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          57:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Juneau':
        {
          0:
              {
                'ts': -880207200,
                'time': '1942-02-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PWT'
              },
          1:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PPT'
              },
          2:
              {
                'ts': -765385200,
                'time': '1945-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          3:
              {
                'ts': -21477600,
                'time': '1969-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          4:
              {
                'ts': -5756400,
                'time': '1969-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          5:
              {
                'ts': 9972000,
                'time': '1970-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          6:
              {
                'ts': 25693200,
                'time': '1970-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          7:
              {
                'ts': 41421600,
                'time': '1971-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          8:
              {
                'ts': 57747600,
                'time': '1971-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          9:
              {
                'ts': 73476000,
                'time': '1972-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          10:
              {
                'ts': 89197200,
                'time': '1972-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          11:
              {
                'ts': 104925600,
                'time': '1973-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          12:
              {
                'ts': 120646800,
                'time': '1973-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          13:
              {
                'ts': 126698400,
                'time': '1974-01-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          14:
              {
                'ts': 152096400,
                'time': '1974-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          15:
              {
                'ts': 162381600,
                'time': '1975-02-23T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          16:
              {
                'ts': 183546000,
                'time': '1975-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          17:
              {
                'ts': 199274400,
                'time': '1976-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          18:
              {
                'ts': 215600400,
                'time': '1976-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          19:
              {
                'ts': 230724000,
                'time': '1977-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          20:
              {
                'ts': 247050000,
                'time': '1977-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          21:
              {
                'ts': 262778400,
                'time': '1978-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          22:
              {
                'ts': 278499600,
                'time': '1978-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          23:
              {
                'ts': 294228000,
                'time': '1979-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          24:
              {
                'ts': 309949200,
                'time': '1979-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          25:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          26:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          27:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          28:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          29:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          30:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          31:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          32:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          33:
              {
                'ts': 439030800,
                'time': '1983-11-30T09:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          34:
              {
                'ts': 452084400,
                'time': '1984-04-29T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          35:
              {
                'ts': 467805600,
                'time': '1984-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          36:
              {
                'ts': 483534000,
                'time': '1985-04-28T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          37:
              {
                'ts': 499255200,
                'time': '1985-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          38:
              {
                'ts': 514983600,
                'time': '1986-04-27T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          39:
              {
                'ts': 530704800,
                'time': '1986-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          40:
              {
                'ts': 544618800,
                'time': '1987-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          41:
              {
                'ts': 562154400,
                'time': '1987-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          42:
              {
                'ts': 576068400,
                'time': '1988-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          43:
              {
                'ts': 594208800,
                'time': '1988-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          44:
              {
                'ts': 607518000,
                'time': '1989-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          45:
              {
                'ts': 625658400,
                'time': '1989-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          46:
              {
                'ts': 638967600,
                'time': '1990-04-01T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          47:
              {
                'ts': 657108000,
                'time': '1990-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          48:
              {
                'ts': 671022000,
                'time': '1991-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          49:
              {
                'ts': 688557600,
                'time': '1991-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          50:
              {
                'ts': 702471600,
                'time': '1992-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          51:
              {
                'ts': 720007200,
                'time': '1992-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          52:
              {
                'ts': 733921200,
                'time': '1993-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          53:
              {
                'ts': 752061600,
                'time': '1993-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          54:
              {
                'ts': 765370800,
                'time': '1994-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          55:
              {
                'ts': 783511200,
                'time': '1994-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          56:
              {
                'ts': 796820400,
                'time': '1995-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          57:
              {
                'ts': 814960800,
                'time': '1995-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          58:
              {
                'ts': 828874800,
                'time': '1996-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          59:
              {
                'ts': 846410400,
                'time': '1996-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          60:
              {
                'ts': 860324400,
                'time': '1997-04-06T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          61:
              {
                'ts': 877860000,
                'time': '1997-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          62:
              {
                'ts': 891774000,
                'time': '1998-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          63:
              {
                'ts': 909309600,
                'time': '1998-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          64:
              {
                'ts': 923223600,
                'time': '1999-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          65:
              {
                'ts': 941364000,
                'time': '1999-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          66:
              {
                'ts': 954673200,
                'time': '2000-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          67:
              {
                'ts': 972813600,
                'time': '2000-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          68:
              {
                'ts': 986122800,
                'time': '2001-04-01T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          69:
              {
                'ts': 1004263200,
                'time': '2001-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          70:
              {
                'ts': 1018177200,
                'time': '2002-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          71:
              {
                'ts': 1035712800,
                'time': '2002-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          72:
              {
                'ts': 1049626800,
                'time': '2003-04-06T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          73:
              {
                'ts': 1067162400,
                'time': '2003-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          74:
              {
                'ts': 1081076400,
                'time': '2004-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          75:
              {
                'ts': 1099216800,
                'time': '2004-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          76:
              {
                'ts': 1112526000,
                'time': '2005-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          77:
              {
                'ts': 1130666400,
                'time': '2005-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          78:
              {
                'ts': 1143975600,
                'time': '2006-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          79:
              {
                'ts': 1162116000,
                'time': '2006-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          80:
              {
                'ts': 1173610800,
                'time': '2007-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          81:
              {
                'ts': 1194170400,
                'time': '2007-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          82:
              {
                'ts': 1205060400,
                'time': '2008-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          83:
              {
                'ts': 1225620000,
                'time': '2008-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          84:
              {
                'ts': 1236510000,
                'time': '2009-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          85:
              {
                'ts': 1257069600,
                'time': '2009-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          86:
              {
                'ts': 1268564400,
                'time': '2010-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          87:
              {
                'ts': 1289124000,
                'time': '2010-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          88:
              {
                'ts': 1300014000,
                'time': '2011-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          89:
              {
                'ts': 1320573600,
                'time': '2011-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          90:
              {
                'ts': 1331463600,
                'time': '2012-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          91:
              {
                'ts': 1352023200,
                'time': '2012-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          92:
              {
                'ts': 1362913200,
                'time': '2013-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          93:
              {
                'ts': 1383472800,
                'time': '2013-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          94:
              {
                'ts': 1394362800,
                'time': '2014-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          95:
              {
                'ts': 1414922400,
                'time': '2014-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          96:
              {
                'ts': 1425812400,
                'time': '2015-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          97:
              {
                'ts': 1446372000,
                'time': '2015-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          98:
              {
                'ts': 1457866800,
                'time': '2016-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          99:
              {
                'ts': 1478426400,
                'time': '2016-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          100:
              {
                'ts': 1489316400,
                'time': '2017-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          101:
              {
                'ts': 1509876000,
                'time': '2017-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          102:
              {
                'ts': 1520766000,
                'time': '2018-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          103:
              {
                'ts': 1541325600,
                'time': '2018-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          104:
              {
                'ts': 1552215600,
                'time': '2019-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          105:
              {
                'ts': 1572775200,
                'time': '2019-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          106:
              {
                'ts': 1583665200,
                'time': '2020-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          107:
              {
                'ts': 1604224800,
                'time': '2020-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          108:
              {
                'ts': 1615719600,
                'time': '2021-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          109:
              {
                'ts': 1636279200,
                'time': '2021-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          110:
              {
                'ts': 1647169200,
                'time': '2022-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          111:
              {
                'ts': 1667728800,
                'time': '2022-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          112:
              {
                'ts': 1678618800,
                'time': '2023-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          113:
              {
                'ts': 1699178400,
                'time': '2023-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          114:
              {
                'ts': 1710068400,
                'time': '2024-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          115:
              {
                'ts': 1730628000,
                'time': '2024-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          116:
              {
                'ts': 1741518000,
                'time': '2025-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          117:
              {
                'ts': 1762077600,
                'time': '2025-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          118:
              {
                'ts': 1772967600,
                'time': '2026-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          119:
              {
                'ts': 1793527200,
                'time': '2026-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          120:
              {
                'ts': 1805022000,
                'time': '2027-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          121:
              {
                'ts': 1825581600,
                'time': '2027-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          122:
              {
                'ts': 1836471600,
                'time': '2028-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          123:
              {
                'ts': 1857031200,
                'time': '2028-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          124:
              {
                'ts': 1867921200,
                'time': '2029-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          125:
              {
                'ts': 1888480800,
                'time': '2029-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          126:
              {
                'ts': 1899370800,
                'time': '2030-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          127:
              {
                'ts': 1919930400,
                'time': '2030-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          128:
              {
                'ts': 1930820400,
                'time': '2031-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          129:
              {
                'ts': 1951380000,
                'time': '2031-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          130:
              {
                'ts': 1962874800,
                'time': '2032-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          131:
              {
                'ts': 1983434400,
                'time': '2032-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          132:
              {
                'ts': 1994324400,
                'time': '2033-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          133:
              {
                'ts': 2014884000,
                'time': '2033-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          134:
              {
                'ts': 2025774000,
                'time': '2034-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          135:
              {
                'ts': 2046333600,
                'time': '2034-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          136:
              {
                'ts': 2057223600,
                'time': '2035-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          137:
              {
                'ts': 2077783200,
                'time': '2035-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          138:
              {
                'ts': 2088673200,
                'time': '2036-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          139:
              {
                'ts': 2109232800,
                'time': '2036-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          140:
              {
                'ts': 2120122800,
                'time': '2037-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          141:
              {
                'ts': 2140682400,
                'time': '2037-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              }
        },
    'America/Kentucky/Louisville':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -1535904000,
                'time': '1921-05-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': -1525280400,
                'time': '1921-09-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -905097600,
                'time': '1941-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': -891795600,
                'time': '1941-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          9:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          10:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -757360800,
                'time': '1946-01-01T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -744224400,
                'time': '1946-06-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -608144400,
                'time': '1950-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -450291600,
                'time': '1955-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -415818000,
                'time': '1956-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': -384368400,
                'time': '1957-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': -352918800,
                'time': '1958-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': -321469200,
                'time': '1959-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': -289414800,
                'time': '1960-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': -273686400,
                'time': '1961-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': -266432400,
                'time': '1961-07-23T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          37:
              {
                'ts': -52938000,
                'time': '1968-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          38:
              {
                'ts': -37216800,
                'time': '1968-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          39:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          40:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          42:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          44:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          46:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          48:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 126687600,
                'time': '1974-01-06T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 162370800,
                'time': '1975-02-23T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          52:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          54:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          56:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          58:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          60:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          62:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          64:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          66:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          68:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          70:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          72:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          116:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          118:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          120:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          122:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          124:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          126:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          128:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          130:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          132:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          134:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          136:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          138:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          140:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          141:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          142:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          143:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          144:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          145:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          146:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          147:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          148:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          149:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          150:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          151:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          152:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          153:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          154:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          155:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          156:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          157:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          158:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          159:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          160:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          161:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          162:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          163:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          164:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          165:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          166:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          167:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          168:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          169:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          170:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          171:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          172:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          173:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          174:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          175:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          176:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Kentucky/Monticello':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          6:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -52934400,
                'time': '1968-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -37213200,
                'time': '1968-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -21484800,
                'time': '1969-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -5763600,
                'time': '1969-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 9964800,
                'time': '1970-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': 25686000,
                'time': '1970-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 41414400,
                'time': '1971-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': 57740400,
                'time': '1971-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 73468800,
                'time': '1972-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': 89190000,
                'time': '1972-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': 104918400,
                'time': '1973-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': 120639600,
                'time': '1973-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': 126691200,
                'time': '1974-01-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': 162374400,
                'time': '1975-02-23T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': 183538800,
                'time': '1975-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 199267200,
                'time': '1976-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': 215593200,
                'time': '1976-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 230716800,
                'time': '1977-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': 247042800,
                'time': '1977-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 262771200,
                'time': '1978-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': 278492400,
                'time': '1978-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 294220800,
                'time': '1979-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': 309942000,
                'time': '1979-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': 341391600,
                'time': '1980-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': 372841200,
                'time': '1981-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': 404895600,
                'time': '1982-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          38:
              {
                'ts': 436345200,
                'time': '1983-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': 467794800,
                'time': '1984-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': 499244400,
                'time': '1985-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': 530694000,
                'time': '1986-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 562143600,
                'time': '1987-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 594198000,
                'time': '1988-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 625647600,
                'time': '1989-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 657097200,
                'time': '1990-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 688546800,
                'time': '1991-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 702460800,
                'time': '1992-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 719996400,
                'time': '1992-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 733910400,
                'time': '1993-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 752050800,
                'time': '1993-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 765360000,
                'time': '1994-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 783500400,
                'time': '1994-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 796809600,
                'time': '1995-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 814950000,
                'time': '1995-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          116:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          118:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          120:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          122:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          124:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          126:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          128:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          130:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          132:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          134:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          136:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          138:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          140:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          141:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          142:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          143:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          144:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          145:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          146:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Knox_IN':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          6:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -702493200,
                'time': '1947-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -684345600,
                'time': '1948-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -671043600,
                'time': '1948-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -652896000,
                'time': '1949-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -639594000,
                'time': '1949-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -620841600,
                'time': '1950-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -608144400,
                'time': '1950-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -447267600,
                'time': '1955-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -415818000,
                'time': '1956-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': -355338000,
                'time': '1958-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': -321469200,
                'time': '1959-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': -289414800,
                'time': '1960-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': -273686400,
                'time': '1961-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': -257965200,
                'time': '1961-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': -242236800,
                'time': '1962-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': -195066000,
                'time': '1963-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': -84384000,
                'time': '1967-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': -68662800,
                'time': '1967-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': -52934400,
                'time': '1968-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': -37213200,
                'time': '1968-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': -21484800,
                'time': '1969-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': -5763600,
                'time': '1969-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 9964800,
                'time': '1970-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 25686000,
                'time': '1970-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 41414400,
                'time': '1971-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 57740400,
                'time': '1971-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 73468800,
                'time': '1972-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 89190000,
                'time': '1972-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 104918400,
                'time': '1973-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 120639600,
                'time': '1973-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 126691200,
                'time': '1974-01-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 162374400,
                'time': '1975-02-23T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 183538800,
                'time': '1975-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 199267200,
                'time': '1976-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 215593200,
                'time': '1976-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 230716800,
                'time': '1977-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 247042800,
                'time': '1977-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 262771200,
                'time': '1978-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 278492400,
                'time': '1978-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 294220800,
                'time': '1979-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 309942000,
                'time': '1979-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 341391600,
                'time': '1980-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 372841200,
                'time': '1981-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 404895600,
                'time': '1982-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 436345200,
                'time': '1983-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 467794800,
                'time': '1984-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 499244400,
                'time': '1985-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 530694000,
                'time': '1986-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 562143600,
                'time': '1987-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 594198000,
                'time': '1988-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 625647600,
                'time': '1989-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 657097200,
                'time': '1990-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': 688546800,
                'time': '1991-10-27T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          120:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          122:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          124:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          126:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          128:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          130:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          132:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          134:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          136:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          138:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          140:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          141:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          142:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          143:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          144:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          145:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          146:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          147:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          148:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          149:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          150:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          151:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          152:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/La_Paz':
        {
          0:
              {
                'ts': -1205954844,
                'time': '1931-10-15T04:32:36+0000',
                'offset': -12756,
                'isdst': true,
                'abbr': 'BOST'
              },
          1:
              {
                'ts': -1192307244,
                'time': '1932-03-21T03:32:36+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'BOT'
              }
        },
    'America/Lima':
        {
          0:
              {
                'ts': -1938538284,
                'time': '1908-07-28T05:08:36+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'PET'
              },
          1:
              {
                'ts': -1009825200,
                'time': '1938-01-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'PEST'
              },
          2:
              {
                'ts': -1002052800,
                'time': '1938-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'PET'
              },
          3:
              {
                'ts': -986756400,
                'time': '1938-09-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'PEST'
              },
          4:
              {
                'ts': -971035200,
                'time': '1939-03-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'PET'
              },
          5:
              {
                'ts': -955306800,
                'time': '1939-09-24T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'PEST'
              },
          6:
              {
                'ts': -939585600,
                'time': '1940-03-24T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'PET'
              },
          7:
              {
                'ts': 504939600,
                'time': '1986-01-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'PEST'
              },
          8:
              {
                'ts': 512712000,
                'time': '1986-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'PET'
              },
          9:
              {
                'ts': 536475600,
                'time': '1987-01-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'PEST'
              },
          10:
              {
                'ts': 544248000,
                'time': '1987-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'PET'
              },
          11:
              {
                'ts': 631170000,
                'time': '1990-01-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'PEST'
              },
          12:
              {
                'ts': 638942400,
                'time': '1990-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'PET'
              },
          13:
              {
                'ts': 757400400,
                'time': '1994-01-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'PEST'
              },
          14:
              {
                'ts': 765172800,
                'time': '1994-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'PET'
              }
        },
    'America/Los_Angeles':
        {
          0:
              {
                'ts': -1633269600,
                'time': '1918-03-31T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          1:
              {
                'ts': -1615129200,
                'time': '1918-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          2:
              {
                'ts': -1601820000,
                'time': '1919-03-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          3:
              {
                'ts': -1583679600,
                'time': '1919-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          4:
              {
                'ts': -880207200,
                'time': '1942-02-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PPT'
              },
          6:
              {
                'ts': -765385200,
                'time': '1945-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          7:
              {
                'ts': -687967200,
                'time': '1948-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          8:
              {
                'ts': -662655600,
                'time': '1949-01-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          9:
              {
                'ts': -620834400,
                'time': '1950-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          10:
              {
                'ts': -608137200,
                'time': '1950-09-24T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          11:
              {
                'ts': -589384800,
                'time': '1951-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          12:
              {
                'ts': -576082800,
                'time': '1951-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          13:
              {
                'ts': -557935200,
                'time': '1952-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          14:
              {
                'ts': -544633200,
                'time': '1952-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          15:
              {
                'ts': -526485600,
                'time': '1953-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          16:
              {
                'ts': -513183600,
                'time': '1953-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          17:
              {
                'ts': -495036000,
                'time': '1954-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          18:
              {
                'ts': -481734000,
                'time': '1954-09-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          19:
              {
                'ts': -463586400,
                'time': '1955-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          20:
              {
                'ts': -450284400,
                'time': '1955-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          21:
              {
                'ts': -431532000,
                'time': '1956-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          22:
              {
                'ts': -418230000,
                'time': '1956-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          23:
              {
                'ts': -400082400,
                'time': '1957-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          24:
              {
                'ts': -386780400,
                'time': '1957-09-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          25:
              {
                'ts': -368632800,
                'time': '1958-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          26:
              {
                'ts': -355330800,
                'time': '1958-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          27:
              {
                'ts': -337183200,
                'time': '1959-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          28:
              {
                'ts': -323881200,
                'time': '1959-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          29:
              {
                'ts': -305733600,
                'time': '1960-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          30:
              {
                'ts': -292431600,
                'time': '1960-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          31:
              {
                'ts': -273679200,
                'time': '1961-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          32:
              {
                'ts': -260982000,
                'time': '1961-09-24T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          33:
              {
                'ts': -242229600,
                'time': '1962-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          34:
              {
                'ts': -226508400,
                'time': '1962-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          35:
              {
                'ts': -210780000,
                'time': '1963-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          36:
              {
                'ts': -195058800,
                'time': '1963-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          37:
              {
                'ts': -179330400,
                'time': '1964-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          38:
              {
                'ts': -163609200,
                'time': '1964-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          39:
              {
                'ts': -147880800,
                'time': '1965-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          40:
              {
                'ts': -131554800,
                'time': '1965-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          41:
              {
                'ts': -116431200,
                'time': '1966-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          42:
              {
                'ts': -100105200,
                'time': '1966-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          43:
              {
                'ts': -84376800,
                'time': '1967-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          44:
              {
                'ts': -68655600,
                'time': '1967-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          45:
              {
                'ts': -52927200,
                'time': '1968-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          46:
              {
                'ts': -37206000,
                'time': '1968-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          47:
              {
                'ts': -21477600,
                'time': '1969-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          48:
              {
                'ts': -5756400,
                'time': '1969-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          49:
              {
                'ts': 9972000,
                'time': '1970-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          50:
              {
                'ts': 25693200,
                'time': '1970-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          51:
              {
                'ts': 41421600,
                'time': '1971-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          52:
              {
                'ts': 57747600,
                'time': '1971-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          53:
              {
                'ts': 73476000,
                'time': '1972-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          54:
              {
                'ts': 89197200,
                'time': '1972-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          55:
              {
                'ts': 104925600,
                'time': '1973-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          56:
              {
                'ts': 120646800,
                'time': '1973-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          57:
              {
                'ts': 126698400,
                'time': '1974-01-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          58:
              {
                'ts': 152096400,
                'time': '1974-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          59:
              {
                'ts': 162381600,
                'time': '1975-02-23T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          60:
              {
                'ts': 183546000,
                'time': '1975-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          61:
              {
                'ts': 199274400,
                'time': '1976-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          62:
              {
                'ts': 215600400,
                'time': '1976-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          63:
              {
                'ts': 230724000,
                'time': '1977-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          64:
              {
                'ts': 247050000,
                'time': '1977-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          65:
              {
                'ts': 262778400,
                'time': '1978-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          66:
              {
                'ts': 278499600,
                'time': '1978-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          67:
              {
                'ts': 294228000,
                'time': '1979-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          68:
              {
                'ts': 309949200,
                'time': '1979-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          69:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          70:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          71:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          72:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          73:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          74:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          75:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          76:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          77:
              {
                'ts': 452080800,
                'time': '1984-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          78:
              {
                'ts': 467802000,
                'time': '1984-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          79:
              {
                'ts': 483530400,
                'time': '1985-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          80:
              {
                'ts': 499251600,
                'time': '1985-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          81:
              {
                'ts': 514980000,
                'time': '1986-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          82:
              {
                'ts': 530701200,
                'time': '1986-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          83:
              {
                'ts': 544615200,
                'time': '1987-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          84:
              {
                'ts': 562150800,
                'time': '1987-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          85:
              {
                'ts': 576064800,
                'time': '1988-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          86:
              {
                'ts': 594205200,
                'time': '1988-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          87:
              {
                'ts': 607514400,
                'time': '1989-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          88:
              {
                'ts': 625654800,
                'time': '1989-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          89:
              {
                'ts': 638964000,
                'time': '1990-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          90:
              {
                'ts': 657104400,
                'time': '1990-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          91:
              {
                'ts': 671018400,
                'time': '1991-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          92:
              {
                'ts': 688554000,
                'time': '1991-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          93:
              {
                'ts': 702468000,
                'time': '1992-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          94:
              {
                'ts': 720003600,
                'time': '1992-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          95:
              {
                'ts': 733917600,
                'time': '1993-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          96:
              {
                'ts': 752058000,
                'time': '1993-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          97:
              {
                'ts': 765367200,
                'time': '1994-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          98:
              {
                'ts': 783507600,
                'time': '1994-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          99:
              {
                'ts': 796816800,
                'time': '1995-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          100:
              {
                'ts': 814957200,
                'time': '1995-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          101:
              {
                'ts': 828871200,
                'time': '1996-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          102:
              {
                'ts': 846406800,
                'time': '1996-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          103:
              {
                'ts': 860320800,
                'time': '1997-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          104:
              {
                'ts': 877856400,
                'time': '1997-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          105:
              {
                'ts': 891770400,
                'time': '1998-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          106:
              {
                'ts': 909306000,
                'time': '1998-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          107:
              {
                'ts': 923220000,
                'time': '1999-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          108:
              {
                'ts': 941360400,
                'time': '1999-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          109:
              {
                'ts': 954669600,
                'time': '2000-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          110:
              {
                'ts': 972810000,
                'time': '2000-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          111:
              {
                'ts': 986119200,
                'time': '2001-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          112:
              {
                'ts': 1004259600,
                'time': '2001-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          113:
              {
                'ts': 1018173600,
                'time': '2002-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          114:
              {
                'ts': 1035709200,
                'time': '2002-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          115:
              {
                'ts': 1049623200,
                'time': '2003-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          116:
              {
                'ts': 1067158800,
                'time': '2003-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          117:
              {
                'ts': 1081072800,
                'time': '2004-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          118:
              {
                'ts': 1099213200,
                'time': '2004-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          119:
              {
                'ts': 1112522400,
                'time': '2005-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          120:
              {
                'ts': 1130662800,
                'time': '2005-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          121:
              {
                'ts': 1143972000,
                'time': '2006-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          122:
              {
                'ts': 1162112400,
                'time': '2006-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          123:
              {
                'ts': 1173607200,
                'time': '2007-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          124:
              {
                'ts': 1194166800,
                'time': '2007-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          125:
              {
                'ts': 1205056800,
                'time': '2008-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          126:
              {
                'ts': 1225616400,
                'time': '2008-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          127:
              {
                'ts': 1236506400,
                'time': '2009-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          128:
              {
                'ts': 1257066000,
                'time': '2009-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          129:
              {
                'ts': 1268560800,
                'time': '2010-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          130:
              {
                'ts': 1289120400,
                'time': '2010-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          131:
              {
                'ts': 1300010400,
                'time': '2011-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          132:
              {
                'ts': 1320570000,
                'time': '2011-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          133:
              {
                'ts': 1331460000,
                'time': '2012-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          134:
              {
                'ts': 1352019600,
                'time': '2012-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          135:
              {
                'ts': 1362909600,
                'time': '2013-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          136:
              {
                'ts': 1383469200,
                'time': '2013-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          137:
              {
                'ts': 1394359200,
                'time': '2014-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          138:
              {
                'ts': 1414918800,
                'time': '2014-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          139:
              {
                'ts': 1425808800,
                'time': '2015-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          140:
              {
                'ts': 1446368400,
                'time': '2015-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          141:
              {
                'ts': 1457863200,
                'time': '2016-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          142:
              {
                'ts': 1478422800,
                'time': '2016-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          143:
              {
                'ts': 1489312800,
                'time': '2017-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          144:
              {
                'ts': 1509872400,
                'time': '2017-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          145:
              {
                'ts': 1520762400,
                'time': '2018-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          146:
              {
                'ts': 1541322000,
                'time': '2018-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          147:
              {
                'ts': 1552212000,
                'time': '2019-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          148:
              {
                'ts': 1572771600,
                'time': '2019-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          149:
              {
                'ts': 1583661600,
                'time': '2020-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          150:
              {
                'ts': 1604221200,
                'time': '2020-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          151:
              {
                'ts': 1615716000,
                'time': '2021-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          152:
              {
                'ts': 1636275600,
                'time': '2021-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          153:
              {
                'ts': 1647165600,
                'time': '2022-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          154:
              {
                'ts': 1667725200,
                'time': '2022-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          155:
              {
                'ts': 1678615200,
                'time': '2023-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          156:
              {
                'ts': 1699174800,
                'time': '2023-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          157:
              {
                'ts': 1710064800,
                'time': '2024-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          158:
              {
                'ts': 1730624400,
                'time': '2024-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          159:
              {
                'ts': 1741514400,
                'time': '2025-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          160:
              {
                'ts': 1762074000,
                'time': '2025-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          161:
              {
                'ts': 1772964000,
                'time': '2026-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          162:
              {
                'ts': 1793523600,
                'time': '2026-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          163:
              {
                'ts': 1805018400,
                'time': '2027-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          164:
              {
                'ts': 1825578000,
                'time': '2027-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          165:
              {
                'ts': 1836468000,
                'time': '2028-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          166:
              {
                'ts': 1857027600,
                'time': '2028-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          167:
              {
                'ts': 1867917600,
                'time': '2029-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          168:
              {
                'ts': 1888477200,
                'time': '2029-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          169:
              {
                'ts': 1899367200,
                'time': '2030-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          170:
              {
                'ts': 1919926800,
                'time': '2030-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          171:
              {
                'ts': 1930816800,
                'time': '2031-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          172:
              {
                'ts': 1951376400,
                'time': '2031-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          173:
              {
                'ts': 1962871200,
                'time': '2032-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          174:
              {
                'ts': 1983430800,
                'time': '2032-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          175:
              {
                'ts': 1994320800,
                'time': '2033-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          176:
              {
                'ts': 2014880400,
                'time': '2033-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          177:
              {
                'ts': 2025770400,
                'time': '2034-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          178:
              {
                'ts': 2046330000,
                'time': '2034-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          179:
              {
                'ts': 2057220000,
                'time': '2035-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          180:
              {
                'ts': 2077779600,
                'time': '2035-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          181:
              {
                'ts': 2088669600,
                'time': '2036-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          182:
              {
                'ts': 2109229200,
                'time': '2036-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          183:
              {
                'ts': 2120119200,
                'time': '2037-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          184:
              {
                'ts': 2140678800,
                'time': '2037-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'America/Louisville':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -1535904000,
                'time': '1921-05-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': -1525280400,
                'time': '1921-09-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -905097600,
                'time': '1941-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': -891795600,
                'time': '1941-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          9:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          10:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -757360800,
                'time': '1946-01-01T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -744224400,
                'time': '1946-06-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -608144400,
                'time': '1950-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -450291600,
                'time': '1955-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -415818000,
                'time': '1956-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': -384368400,
                'time': '1957-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': -352918800,
                'time': '1958-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': -321469200,
                'time': '1959-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': -289414800,
                'time': '1960-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': -273686400,
                'time': '1961-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': -266432400,
                'time': '1961-07-23T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          37:
              {
                'ts': -52938000,
                'time': '1968-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          38:
              {
                'ts': -37216800,
                'time': '1968-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          39:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          40:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          42:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          44:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          46:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          48:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 126687600,
                'time': '1974-01-06T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 162370800,
                'time': '1975-02-23T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          52:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          54:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          56:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          58:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          60:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          62:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          64:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          66:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          68:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          70:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          72:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          116:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          118:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          120:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          122:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          124:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          126:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          128:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          130:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          132:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          134:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          136:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          138:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          140:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          141:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          142:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          143:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          144:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          145:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          146:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          147:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          148:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          149:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          150:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          151:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          152:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          153:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          154:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          155:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          156:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          157:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          158:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          159:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          160:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          161:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          162:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          163:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          164:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          165:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          166:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          167:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          168:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          169:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          170:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          171:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          172:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          173:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          174:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          175:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          176:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Maceio':
        {
          0:
              {
                'ts': -1767217028,
                'time': '1914-01-01T02:22:52+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          1:
              {
                'ts': -1206957600,
                'time': '1931-10-03T14:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          2:
              {
                'ts': -1191362400,
                'time': '1932-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          3:
              {
                'ts': -1175374800,
                'time': '1932-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          4:
              {
                'ts': -1159826400,
                'time': '1933-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          5:
              {
                'ts': -633819600,
                'time': '1949-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          6:
              {
                'ts': -622069200,
                'time': '1950-04-16T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          7:
              {
                'ts': -602283600,
                'time': '1950-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          8:
              {
                'ts': -591832800,
                'time': '1951-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          9:
              {
                'ts': -570747600,
                'time': '1951-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          10:
              {
                'ts': -560210400,
                'time': '1952-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          11:
              {
                'ts': -539125200,
                'time': '1952-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          12:
              {
                'ts': -531352800,
                'time': '1953-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          13:
              {
                'ts': -191365200,
                'time': '1963-12-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          14:
              {
                'ts': -184197600,
                'time': '1964-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          15:
              {
                'ts': -155163600,
                'time': '1965-01-31T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          16:
              {
                'ts': -150069600,
                'time': '1965-03-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          17:
              {
                'ts': -128898000,
                'time': '1965-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          18:
              {
                'ts': -121125600,
                'time': '1966-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          19:
              {
                'ts': -99954000,
                'time': '1966-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          20:
              {
                'ts': -89589600,
                'time': '1967-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          21:
              {
                'ts': -68418000,
                'time': '1967-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          22:
              {
                'ts': -57967200,
                'time': '1968-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          23:
              {
                'ts': 499748400,
                'time': '1985-11-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          24:
              {
                'ts': 511236000,
                'time': '1986-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          25:
              {
                'ts': 530593200,
                'time': '1986-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          26:
              {
                'ts': 540266400,
                'time': '1987-02-14T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          27:
              {
                'ts': 562129200,
                'time': '1987-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          28:
              {
                'ts': 571197600,
                'time': '1988-02-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          29:
              {
                'ts': 592974000,
                'time': '1988-10-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          30:
              {
                'ts': 602042400,
                'time': '1989-01-29T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          31:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          32:
              {
                'ts': 634701600,
                'time': '1990-02-11T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          33:
              {
                'ts': 813726000,
                'time': '1995-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          34:
              {
                'ts': 824004000,
                'time': '1996-02-11T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          35:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          36:
              {
                'ts': 951616800,
                'time': '2000-02-27T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          37:
              {
                'ts': 970974000,
                'time': '2000-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          38:
              {
                'ts': 972180000,
                'time': '2000-10-22T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          39:
              {
                'ts': 1003028400,
                'time': '2001-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          40:
              {
                'ts': 1013911200,
                'time': '2002-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              }
        },
    'America/Managua':
        {
          0:
              {
                'ts': -1121105688,
                'time': '1934-06-23T05:45:12+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': 105084000,
                'time': '1973-05-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': 161758800,
                'time': '1975-02-16T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': 290584800,
                'time': '1979-03-18T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': 299134800,
                'time': '1979-06-25T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': 322034400,
                'time': '1980-03-16T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': 330584400,
                'time': '1980-06-23T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': 694260000,
                'time': '1992-01-01T10:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 717310800,
                'time': '1992-09-24T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 725868000,
                'time': '1993-01-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 852094800,
                'time': '1997-01-01T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 1113112800,
                'time': '2005-04-10T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': 1128229200,
                'time': '2005-10-02T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 1146384000,
                'time': '2006-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': 1159682400,
                'time': '2006-10-01T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Manaus':
        {
          0:
              {
                'ts': -1767211196,
                'time': '1914-01-01T04:00:04+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          1:
              {
                'ts': -1206954000,
                'time': '1931-10-03T15:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          2:
              {
                'ts': -1191358800,
                'time': '1932-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          3:
              {
                'ts': -1175371200,
                'time': '1932-10-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          4:
              {
                'ts': -1159822800,
                'time': '1933-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          5:
              {
                'ts': -633816000,
                'time': '1949-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          6:
              {
                'ts': -622065600,
                'time': '1950-04-16T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          7:
              {
                'ts': -602280000,
                'time': '1950-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          8:
              {
                'ts': -591829200,
                'time': '1951-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          9:
              {
                'ts': -570744000,
                'time': '1951-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          10:
              {
                'ts': -560206800,
                'time': '1952-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          11:
              {
                'ts': -539121600,
                'time': '1952-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          12:
              {
                'ts': -531349200,
                'time': '1953-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          13:
              {
                'ts': -191361600,
                'time': '1963-12-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          14:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          15:
              {
                'ts': -155160000,
                'time': '1965-01-31T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          16:
              {
                'ts': -150066000,
                'time': '1965-03-31T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          17:
              {
                'ts': -128894400,
                'time': '1965-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          18:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          19:
              {
                'ts': -99950400,
                'time': '1966-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          20:
              {
                'ts': -89586000,
                'time': '1967-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          21:
              {
                'ts': -68414400,
                'time': '1967-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          22:
              {
                'ts': -57963600,
                'time': '1968-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          23:
              {
                'ts': 499752000,
                'time': '1985-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          24:
              {
                'ts': 511239600,
                'time': '1986-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          25:
              {
                'ts': 530596800,
                'time': '1986-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          26:
              {
                'ts': 540270000,
                'time': '1987-02-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          27:
              {
                'ts': 562132800,
                'time': '1987-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          28:
              {
                'ts': 571201200,
                'time': '1988-02-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          29:
              {
                'ts': 750830400,
                'time': '1993-10-17T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          30:
              {
                'ts': 761713200,
                'time': '1994-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              }
        },
    'America/Marigot':
        {
          0:
              {
                'ts': -1848254032,
                'time': '1911-06-08T04:06:08+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Martinique':
        {
          0:
              {
                'ts': -1851537340,
                'time': '1911-05-01T04:04:20+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          1:
              {
                'ts': 323841600,
                'time': '1980-04-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          2:
              {
                'ts': 338958000,
                'time': '1980-09-28T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Mazatlan':
        {
          0:
              {
                'ts': -1514739600,
                'time': '1922-01-01T07:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1343066400,
                'time': '1927-06-11T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1234807200,
                'time': '1930-11-15T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1220292000,
                'time': '1931-05-02T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -1207159200,
                'time': '1931-10-01T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1191344400,
                'time': '1932-04-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -873828000,
                'time': '1942-04-24T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          7:
              {
                'ts': -661539600,
                'time': '1949-01-14T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          8:
              {
                'ts': 28800,
                'time': '1970-01-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          9:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          10:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': 989139600,
                'time': '2001-05-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': 1001836800,
                'time': '2001-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          24:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          25:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          26:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          27:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          28:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          29:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          30:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          31:
              {
                'ts': 1175418000,
                'time': '2007-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          32:
              {
                'ts': 1193558400,
                'time': '2007-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          33:
              {
                'ts': 1207472400,
                'time': '2008-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          34:
              {
                'ts': 1225008000,
                'time': '2008-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          35:
              {
                'ts': 1238922000,
                'time': '2009-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          36:
              {
                'ts': 1256457600,
                'time': '2009-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          37:
              {
                'ts': 1270371600,
                'time': '2010-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          38:
              {
                'ts': 1288512000,
                'time': '2010-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          39:
              {
                'ts': 1301821200,
                'time': '2011-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          40:
              {
                'ts': 1319961600,
                'time': '2011-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          41:
              {
                'ts': 1333270800,
                'time': '2012-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          42:
              {
                'ts': 1351411200,
                'time': '2012-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          43:
              {
                'ts': 1365325200,
                'time': '2013-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          44:
              {
                'ts': 1382860800,
                'time': '2013-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          45:
              {
                'ts': 1396774800,
                'time': '2014-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          46:
              {
                'ts': 1414310400,
                'time': '2014-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          47:
              {
                'ts': 1428224400,
                'time': '2015-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          48:
              {
                'ts': 1445760000,
                'time': '2015-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          49:
              {
                'ts': 1459674000,
                'time': '2016-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          50:
              {
                'ts': 1477814400,
                'time': '2016-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          51:
              {
                'ts': 1491123600,
                'time': '2017-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          52:
              {
                'ts': 1509264000,
                'time': '2017-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          53:
              {
                'ts': 1522573200,
                'time': '2018-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          54:
              {
                'ts': 1540713600,
                'time': '2018-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          55:
              {
                'ts': 1554627600,
                'time': '2019-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          56:
              {
                'ts': 1572163200,
                'time': '2019-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          57:
              {
                'ts': 1586077200,
                'time': '2020-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          58:
              {
                'ts': 1603612800,
                'time': '2020-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          59:
              {
                'ts': 1617526800,
                'time': '2021-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          60:
              {
                'ts': 1635667200,
                'time': '2021-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          61:
              {
                'ts': 1648976400,
                'time': '2022-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          62:
              {
                'ts': 1667116800,
                'time': '2022-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          63:
              {
                'ts': 1680426000,
                'time': '2023-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          64:
              {
                'ts': 1698566400,
                'time': '2023-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          65:
              {
                'ts': 1712480400,
                'time': '2024-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          66:
              {
                'ts': 1730016000,
                'time': '2024-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          67:
              {
                'ts': 1743930000,
                'time': '2025-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          68:
              {
                'ts': 1761465600,
                'time': '2025-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          69:
              {
                'ts': 1775379600,
                'time': '2026-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          70:
              {
                'ts': 1792915200,
                'time': '2026-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          71:
              {
                'ts': 1806829200,
                'time': '2027-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          72:
              {
                'ts': 1824969600,
                'time': '2027-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          73:
              {
                'ts': 1838278800,
                'time': '2028-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          74:
              {
                'ts': 1856419200,
                'time': '2028-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          75:
              {
                'ts': 1869728400,
                'time': '2029-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          76:
              {
                'ts': 1887868800,
                'time': '2029-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          77:
              {
                'ts': 1901782800,
                'time': '2030-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          78:
              {
                'ts': 1919318400,
                'time': '2030-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          79:
              {
                'ts': 1933232400,
                'time': '2031-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          80:
              {
                'ts': 1950768000,
                'time': '2031-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          81:
              {
                'ts': 1964682000,
                'time': '2032-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          82:
              {
                'ts': 1982822400,
                'time': '2032-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          83:
              {
                'ts': 1996131600,
                'time': '2033-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          84:
              {
                'ts': 2014272000,
                'time': '2033-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          85:
              {
                'ts': 2027581200,
                'time': '2034-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          86:
              {
                'ts': 2045721600,
                'time': '2034-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          87:
              {
                'ts': 2059030800,
                'time': '2035-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          88:
              {
                'ts': 2077171200,
                'time': '2035-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          89:
              {
                'ts': 2091085200,
                'time': '2036-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          90:
              {
                'ts': 2108620800,
                'time': '2036-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          91:
              {
                'ts': 2122534800,
                'time': '2037-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          92:
              {
                'ts': 2140070400,
                'time': '2037-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'America/Mendoza':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          48:
              {
                'ts': 655963200,
                'time': '1990-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'WARST'
              },
          49:
              {
                'ts': 667796400,
                'time': '1991-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 687499200,
                'time': '1991-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'WARST'
              },
          51:
              {
                'ts': 699418800,
                'time': '1992-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          52:
              {
                'ts': 719380800,
                'time': '1992-10-18T04:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1085281200,
                'time': '2004-05-23T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          57:
              {
                'ts': 1096171200,
                'time': '2004-09-26T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          117:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          118:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Menominee':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          6:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -747244800,
                'time': '1946-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -733942800,
                'time': '1946-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -116438400,
                'time': '1966-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -100112400,
                'time': '1966-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -21484800,
                'time': '1969-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          13:
              {
                'ts': 120639600,
                'time': '1973-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          14:
              {
                'ts': 126691200,
                'time': '1974-01-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          15:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          16:
              {
                'ts': 162374400,
                'time': '1975-02-23T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          17:
              {
                'ts': 183538800,
                'time': '1975-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          18:
              {
                'ts': 199267200,
                'time': '1976-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          19:
              {
                'ts': 215593200,
                'time': '1976-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          20:
              {
                'ts': 230716800,
                'time': '1977-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          21:
              {
                'ts': 247042800,
                'time': '1977-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          22:
              {
                'ts': 262771200,
                'time': '1978-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          23:
              {
                'ts': 278492400,
                'time': '1978-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          24:
              {
                'ts': 294220800,
                'time': '1979-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          25:
              {
                'ts': 309942000,
                'time': '1979-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          26:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          27:
              {
                'ts': 341391600,
                'time': '1980-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          28:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          29:
              {
                'ts': 372841200,
                'time': '1981-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          30:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          31:
              {
                'ts': 404895600,
                'time': '1982-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          32:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          33:
              {
                'ts': 436345200,
                'time': '1983-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          34:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          35:
              {
                'ts': 467794800,
                'time': '1984-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          36:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          37:
              {
                'ts': 499244400,
                'time': '1985-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          39:
              {
                'ts': 530694000,
                'time': '1986-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          40:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          41:
              {
                'ts': 562143600,
                'time': '1987-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          42:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          43:
              {
                'ts': 594198000,
                'time': '1988-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          44:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          45:
              {
                'ts': 625647600,
                'time': '1989-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          47:
              {
                'ts': 657097200,
                'time': '1990-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          48:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          49:
              {
                'ts': 688546800,
                'time': '1991-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          50:
              {
                'ts': 702460800,
                'time': '1992-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          51:
              {
                'ts': 719996400,
                'time': '1992-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          52:
              {
                'ts': 733910400,
                'time': '1993-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          53:
              {
                'ts': 752050800,
                'time': '1993-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          54:
              {
                'ts': 765360000,
                'time': '1994-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          55:
              {
                'ts': 783500400,
                'time': '1994-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          56:
              {
                'ts': 796809600,
                'time': '1995-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          57:
              {
                'ts': 814950000,
                'time': '1995-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          58:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          59:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          60:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          61:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          62:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          63:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          64:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          65:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          66:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          67:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          68:
              {
                'ts': 986112000,
                'time': '2001-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          69:
              {
                'ts': 1004252400,
                'time': '2001-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          70:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          71:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          72:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          73:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          74:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          75:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          76:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          77:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          78:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          79:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          80:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          81:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          82:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          83:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          84:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          85:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          86:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          87:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          88:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          89:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          90:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          91:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          92:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          93:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          94:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          95:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          96:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          97:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          98:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          99:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          100:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          101:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          102:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          103:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          104:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          105:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          106:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          107:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          108:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          109:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          110:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          111:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          112:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          113:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          114:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          115:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          116:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          117:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          118:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          119:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          120:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          121:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          122:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          123:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          124:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          125:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          126:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          127:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          128:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          129:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          130:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          131:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          132:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          133:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          134:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          135:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          136:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          137:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          138:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          139:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          140:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          141:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Merida':
        {
          0:
              {
                'ts': -1514743200,
                'time': '1922-01-01T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': 377935200,
                'time': '1981-12-23T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': 407653200,
                'time': '1982-12-02T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 989136000,
                'time': '2001-05-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': 1001833200,
                'time': '2001-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 1175414400,
                'time': '2007-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': 1193554800,
                'time': '2007-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 1207468800,
                'time': '2008-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': 1225004400,
                'time': '2008-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 1238918400,
                'time': '2009-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': 1256454000,
                'time': '2009-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 1270368000,
                'time': '2010-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': 1288508400,
                'time': '2010-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 1301817600,
                'time': '2011-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': 1319958000,
                'time': '2011-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 1333267200,
                'time': '2012-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': 1351407600,
                'time': '2012-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 1365321600,
                'time': '2013-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          38:
              {
                'ts': 1382857200,
                'time': '2013-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 1396771200,
                'time': '2014-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': 1414306800,
                'time': '2014-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 1428220800,
                'time': '2015-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': 1445756400,
                'time': '2015-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 1459670400,
                'time': '2016-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': 1477810800,
                'time': '2016-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 1491120000,
                'time': '2017-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 1509260400,
                'time': '2017-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 1522569600,
                'time': '2018-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 1540710000,
                'time': '2018-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 1554624000,
                'time': '2019-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 1572159600,
                'time': '2019-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 1586073600,
                'time': '2020-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 1603609200,
                'time': '2020-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 1617523200,
                'time': '2021-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 1635663600,
                'time': '2021-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 1648972800,
                'time': '2022-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 1667113200,
                'time': '2022-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 1680422400,
                'time': '2023-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 1698562800,
                'time': '2023-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 1712476800,
                'time': '2024-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 1730012400,
                'time': '2024-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 1743926400,
                'time': '2025-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 1761462000,
                'time': '2025-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 1775376000,
                'time': '2026-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 1792911600,
                'time': '2026-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 1806825600,
                'time': '2027-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 1824966000,
                'time': '2027-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 1838275200,
                'time': '2028-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 1856415600,
                'time': '2028-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 1869724800,
                'time': '2029-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 1887865200,
                'time': '2029-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 1901779200,
                'time': '2030-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 1919314800,
                'time': '2030-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 1933228800,
                'time': '2031-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 1950764400,
                'time': '2031-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 1964678400,
                'time': '2032-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 1982818800,
                'time': '2032-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 1996128000,
                'time': '2033-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 2014268400,
                'time': '2033-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 2027577600,
                'time': '2034-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 2045718000,
                'time': '2034-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 2059027200,
                'time': '2035-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 2077167600,
                'time': '2035-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 2091081600,
                'time': '2036-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 2108617200,
                'time': '2036-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 2122531200,
                'time': '2037-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 2140066800,
                'time': '2037-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Mexico_City':
        {
          0:
              {
                'ts': -1514739600,
                'time': '1922-01-01T07:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1343066400,
                'time': '1927-06-11T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1234807200,
                'time': '1930-11-15T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1220292000,
                'time': '1931-05-02T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -1207159200,
                'time': '1931-10-01T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1191344400,
                'time': '1932-04-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -975261600,
                'time': '1939-02-05T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': -963169200,
                'time': '1939-06-25T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': -917114400,
                'time': '1940-12-09T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          9:
              {
                'ts': -907354800,
                'time': '1941-04-01T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': -821901600,
                'time': '1943-12-16T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          11:
              {
                'ts': -810068400,
                'time': '1944-05-01T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': -627501600,
                'time': '1950-02-12T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          13:
              {
                'ts': -612990000,
                'time': '1950-07-30T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          14:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          15:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          16:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          17:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          18:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          19:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          20:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          21:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          22:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          23:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          24:
              {
                'ts': 989136000,
                'time': '2001-05-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          25:
              {
                'ts': 1001833200,
                'time': '2001-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          26:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          27:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          28:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          29:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          30:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          31:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          32:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          33:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          34:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          35:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          36:
              {
                'ts': 1175414400,
                'time': '2007-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          37:
              {
                'ts': 1193554800,
                'time': '2007-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': 1207468800,
                'time': '2008-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          39:
              {
                'ts': 1225004400,
                'time': '2008-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          40:
              {
                'ts': 1238918400,
                'time': '2009-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          41:
              {
                'ts': 1256454000,
                'time': '2009-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          42:
              {
                'ts': 1270368000,
                'time': '2010-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          43:
              {
                'ts': 1288508400,
                'time': '2010-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          44:
              {
                'ts': 1301817600,
                'time': '2011-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          45:
              {
                'ts': 1319958000,
                'time': '2011-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': 1333267200,
                'time': '2012-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          47:
              {
                'ts': 1351407600,
                'time': '2012-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          48:
              {
                'ts': 1365321600,
                'time': '2013-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          49:
              {
                'ts': 1382857200,
                'time': '2013-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          50:
              {
                'ts': 1396771200,
                'time': '2014-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          51:
              {
                'ts': 1414306800,
                'time': '2014-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          52:
              {
                'ts': 1428220800,
                'time': '2015-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          53:
              {
                'ts': 1445756400,
                'time': '2015-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          54:
              {
                'ts': 1459670400,
                'time': '2016-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          55:
              {
                'ts': 1477810800,
                'time': '2016-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          56:
              {
                'ts': 1491120000,
                'time': '2017-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          57:
              {
                'ts': 1509260400,
                'time': '2017-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          58:
              {
                'ts': 1522569600,
                'time': '2018-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          59:
              {
                'ts': 1540710000,
                'time': '2018-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          60:
              {
                'ts': 1554624000,
                'time': '2019-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          61:
              {
                'ts': 1572159600,
                'time': '2019-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          62:
              {
                'ts': 1586073600,
                'time': '2020-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          63:
              {
                'ts': 1603609200,
                'time': '2020-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          64:
              {
                'ts': 1617523200,
                'time': '2021-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          65:
              {
                'ts': 1635663600,
                'time': '2021-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          66:
              {
                'ts': 1648972800,
                'time': '2022-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          67:
              {
                'ts': 1667113200,
                'time': '2022-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          68:
              {
                'ts': 1680422400,
                'time': '2023-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          69:
              {
                'ts': 1698562800,
                'time': '2023-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          70:
              {
                'ts': 1712476800,
                'time': '2024-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          71:
              {
                'ts': 1730012400,
                'time': '2024-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          72:
              {
                'ts': 1743926400,
                'time': '2025-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          73:
              {
                'ts': 1761462000,
                'time': '2025-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          74:
              {
                'ts': 1775376000,
                'time': '2026-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          75:
              {
                'ts': 1792911600,
                'time': '2026-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          76:
              {
                'ts': 1806825600,
                'time': '2027-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          77:
              {
                'ts': 1824966000,
                'time': '2027-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          78:
              {
                'ts': 1838275200,
                'time': '2028-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          79:
              {
                'ts': 1856415600,
                'time': '2028-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          80:
              {
                'ts': 1869724800,
                'time': '2029-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          81:
              {
                'ts': 1887865200,
                'time': '2029-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          82:
              {
                'ts': 1901779200,
                'time': '2030-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          83:
              {
                'ts': 1919314800,
                'time': '2030-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          84:
              {
                'ts': 1933228800,
                'time': '2031-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          85:
              {
                'ts': 1950764400,
                'time': '2031-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          86:
              {
                'ts': 1964678400,
                'time': '2032-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          87:
              {
                'ts': 1982818800,
                'time': '2032-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          88:
              {
                'ts': 1996128000,
                'time': '2033-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          89:
              {
                'ts': 2014268400,
                'time': '2033-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          90:
              {
                'ts': 2027577600,
                'time': '2034-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          91:
              {
                'ts': 2045718000,
                'time': '2034-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          92:
              {
                'ts': 2059027200,
                'time': '2035-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          93:
              {
                'ts': 2077167600,
                'time': '2035-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          94:
              {
                'ts': 2091081600,
                'time': '2036-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          95:
              {
                'ts': 2108617200,
                'time': '2036-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          96:
              {
                'ts': 2122531200,
                'time': '2037-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          97:
              {
                'ts': 2140066800,
                'time': '2037-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Miquelon':
        {
          0:
              {
                'ts': -1850328920,
                'time': '1911-05-15T03:44:40+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          1:
              {
                'ts': 326001600,
                'time': '1980-05-01T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          2:
              {
                'ts': 544597200,
                'time': '1987-04-05T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          3:
              {
                'ts': 562132800,
                'time': '1987-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          4:
              {
                'ts': 576046800,
                'time': '1988-04-03T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          5:
              {
                'ts': 594187200,
                'time': '1988-10-30T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          6:
              {
                'ts': 607496400,
                'time': '1989-04-02T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          7:
              {
                'ts': 625636800,
                'time': '1989-10-29T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          8:
              {
                'ts': 638946000,
                'time': '1990-04-01T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          9:
              {
                'ts': 657086400,
                'time': '1990-10-28T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          10:
              {
                'ts': 671000400,
                'time': '1991-04-07T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          11:
              {
                'ts': 688536000,
                'time': '1991-10-27T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          12:
              {
                'ts': 702450000,
                'time': '1992-04-05T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          13:
              {
                'ts': 719985600,
                'time': '1992-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          14:
              {
                'ts': 733899600,
                'time': '1993-04-04T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          15:
              {
                'ts': 752040000,
                'time': '1993-10-31T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          16:
              {
                'ts': 765349200,
                'time': '1994-04-03T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          17:
              {
                'ts': 783489600,
                'time': '1994-10-30T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          18:
              {
                'ts': 796798800,
                'time': '1995-04-02T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          19:
              {
                'ts': 814939200,
                'time': '1995-10-29T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          20:
              {
                'ts': 828853200,
                'time': '1996-04-07T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          21:
              {
                'ts': 846388800,
                'time': '1996-10-27T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          22:
              {
                'ts': 860302800,
                'time': '1997-04-06T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          23:
              {
                'ts': 877838400,
                'time': '1997-10-26T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          24:
              {
                'ts': 891752400,
                'time': '1998-04-05T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          25:
              {
                'ts': 909288000,
                'time': '1998-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          26:
              {
                'ts': 923202000,
                'time': '1999-04-04T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          27:
              {
                'ts': 941342400,
                'time': '1999-10-31T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          28:
              {
                'ts': 954651600,
                'time': '2000-04-02T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          29:
              {
                'ts': 972792000,
                'time': '2000-10-29T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          30:
              {
                'ts': 986101200,
                'time': '2001-04-01T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          31:
              {
                'ts': 1004241600,
                'time': '2001-10-28T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          32:
              {
                'ts': 1018155600,
                'time': '2002-04-07T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          33:
              {
                'ts': 1035691200,
                'time': '2002-10-27T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          34:
              {
                'ts': 1049605200,
                'time': '2003-04-06T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          35:
              {
                'ts': 1067140800,
                'time': '2003-10-26T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          36:
              {
                'ts': 1081054800,
                'time': '2004-04-04T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          37:
              {
                'ts': 1099195200,
                'time': '2004-10-31T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          38:
              {
                'ts': 1112504400,
                'time': '2005-04-03T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          39:
              {
                'ts': 1130644800,
                'time': '2005-10-30T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          40:
              {
                'ts': 1143954000,
                'time': '2006-04-02T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          41:
              {
                'ts': 1162094400,
                'time': '2006-10-29T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          42:
              {
                'ts': 1173589200,
                'time': '2007-03-11T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          43:
              {
                'ts': 1194148800,
                'time': '2007-11-04T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          44:
              {
                'ts': 1205038800,
                'time': '2008-03-09T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          45:
              {
                'ts': 1225598400,
                'time': '2008-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          46:
              {
                'ts': 1236488400,
                'time': '2009-03-08T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          47:
              {
                'ts': 1257048000,
                'time': '2009-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          48:
              {
                'ts': 1268542800,
                'time': '2010-03-14T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          49:
              {
                'ts': 1289102400,
                'time': '2010-11-07T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          50:
              {
                'ts': 1299992400,
                'time': '2011-03-13T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          51:
              {
                'ts': 1320552000,
                'time': '2011-11-06T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          52:
              {
                'ts': 1331442000,
                'time': '2012-03-11T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          53:
              {
                'ts': 1352001600,
                'time': '2012-11-04T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          54:
              {
                'ts': 1362891600,
                'time': '2013-03-10T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          55:
              {
                'ts': 1383451200,
                'time': '2013-11-03T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          56:
              {
                'ts': 1394341200,
                'time': '2014-03-09T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          57:
              {
                'ts': 1414900800,
                'time': '2014-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          58:
              {
                'ts': 1425790800,
                'time': '2015-03-08T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          59:
              {
                'ts': 1446350400,
                'time': '2015-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          60:
              {
                'ts': 1457845200,
                'time': '2016-03-13T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          61:
              {
                'ts': 1478404800,
                'time': '2016-11-06T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          62:
              {
                'ts': 1489294800,
                'time': '2017-03-12T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          63:
              {
                'ts': 1509854400,
                'time': '2017-11-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          64:
              {
                'ts': 1520744400,
                'time': '2018-03-11T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          65:
              {
                'ts': 1541304000,
                'time': '2018-11-04T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          66:
              {
                'ts': 1552194000,
                'time': '2019-03-10T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          67:
              {
                'ts': 1572753600,
                'time': '2019-11-03T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          68:
              {
                'ts': 1583643600,
                'time': '2020-03-08T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          69:
              {
                'ts': 1604203200,
                'time': '2020-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          70:
              {
                'ts': 1615698000,
                'time': '2021-03-14T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          71:
              {
                'ts': 1636257600,
                'time': '2021-11-07T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          72:
              {
                'ts': 1647147600,
                'time': '2022-03-13T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          73:
              {
                'ts': 1667707200,
                'time': '2022-11-06T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          74:
              {
                'ts': 1678597200,
                'time': '2023-03-12T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          75:
              {
                'ts': 1699156800,
                'time': '2023-11-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          76:
              {
                'ts': 1710046800,
                'time': '2024-03-10T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          77:
              {
                'ts': 1730606400,
                'time': '2024-11-03T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          78:
              {
                'ts': 1741496400,
                'time': '2025-03-09T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          79:
              {
                'ts': 1762056000,
                'time': '2025-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          80:
              {
                'ts': 1772946000,
                'time': '2026-03-08T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          81:
              {
                'ts': 1793505600,
                'time': '2026-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          82:
              {
                'ts': 1805000400,
                'time': '2027-03-14T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          83:
              {
                'ts': 1825560000,
                'time': '2027-11-07T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          84:
              {
                'ts': 1836450000,
                'time': '2028-03-12T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          85:
              {
                'ts': 1857009600,
                'time': '2028-11-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          86:
              {
                'ts': 1867899600,
                'time': '2029-03-11T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          87:
              {
                'ts': 1888459200,
                'time': '2029-11-04T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          88:
              {
                'ts': 1899349200,
                'time': '2030-03-10T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          89:
              {
                'ts': 1919908800,
                'time': '2030-11-03T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          90:
              {
                'ts': 1930798800,
                'time': '2031-03-09T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          91:
              {
                'ts': 1951358400,
                'time': '2031-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          92:
              {
                'ts': 1962853200,
                'time': '2032-03-14T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          93:
              {
                'ts': 1983412800,
                'time': '2032-11-07T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          94:
              {
                'ts': 1994302800,
                'time': '2033-03-13T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          95:
              {
                'ts': 2014862400,
                'time': '2033-11-06T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          96:
              {
                'ts': 2025752400,
                'time': '2034-03-12T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          97:
              {
                'ts': 2046312000,
                'time': '2034-11-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          98:
              {
                'ts': 2057202000,
                'time': '2035-03-11T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          99:
              {
                'ts': 2077761600,
                'time': '2035-11-04T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          100:
              {
                'ts': 2088651600,
                'time': '2036-03-09T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          101:
              {
                'ts': 2109211200,
                'time': '2036-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              },
          102:
              {
                'ts': 2120101200,
                'time': '2037-03-08T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'PMDT'
              },
          103:
              {
                'ts': 2140660800,
                'time': '2037-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'PMST'
              }
        },
    'America/Moncton':
        {
          0:
              {
                'ts': -2131642800,
                'time': '1902-06-15T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          1:
              {
                'ts': -1632074400,
                'time': '1918-04-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          2:
              {
                'ts': -1614798000,
                'time': '1918-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          3:
              {
                'ts': -1153681200,
                'time': '1933-06-11T05:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          4:
              {
                'ts': -1145822400,
                'time': '1933-09-10T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          5:
              {
                'ts': -1122231600,
                'time': '1934-06-10T05:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          6:
              {
                'ts': -1114372800,
                'time': '1934-09-09T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          7:
              {
                'ts': -1090782000,
                'time': '1935-06-09T05:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          8:
              {
                'ts': -1082923200,
                'time': '1935-09-08T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          9:
              {
                'ts': -1059332400,
                'time': '1936-06-07T05:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          10:
              {
                'ts': -1051473600,
                'time': '1936-09-06T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          11:
              {
                'ts': -1027882800,
                'time': '1937-06-06T05:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          12:
              {
                'ts': -1020024000,
                'time': '1937-09-05T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          13:
              {
                'ts': -996433200,
                'time': '1938-06-05T05:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          14:
              {
                'ts': -988574400,
                'time': '1938-09-04T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          15:
              {
                'ts': -965674800,
                'time': '1939-05-27T05:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          16:
              {
                'ts': -955396800,
                'time': '1939-09-23T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          17:
              {
                'ts': -934743600,
                'time': '1940-05-19T05:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          18:
              {
                'ts': -923947200,
                'time': '1940-09-21T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          19:
              {
                'ts': -904503600,
                'time': '1941-05-04T05:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          20:
              {
                'ts': -891892800,
                'time': '1941-09-27T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          21:
              {
                'ts': -880221600,
                'time': '1942-02-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AWT'
              },
          22:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'APT'
              },
          23:
              {
                'ts': -765399600,
                'time': '1945-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          24:
              {
                'ts': -747252000,
                'time': '1946-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          25:
              {
                'ts': -733950000,
                'time': '1946-09-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          26:
              {
                'ts': -715802400,
                'time': '1947-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          27:
              {
                'ts': -702500400,
                'time': '1947-09-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          28:
              {
                'ts': -684352800,
                'time': '1948-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          29:
              {
                'ts': -671050800,
                'time': '1948-09-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          30:
              {
                'ts': -652903200,
                'time': '1949-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          31:
              {
                'ts': -639601200,
                'time': '1949-09-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          32:
              {
                'ts': -620848800,
                'time': '1950-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          33:
              {
                'ts': -608151600,
                'time': '1950-09-24T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          34:
              {
                'ts': -589399200,
                'time': '1951-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          35:
              {
                'ts': -576097200,
                'time': '1951-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          36:
              {
                'ts': -557949600,
                'time': '1952-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          37:
              {
                'ts': -544647600,
                'time': '1952-09-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          38:
              {
                'ts': -526500000,
                'time': '1953-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          39:
              {
                'ts': -513198000,
                'time': '1953-09-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          40:
              {
                'ts': -495050400,
                'time': '1954-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          41:
              {
                'ts': -481748400,
                'time': '1954-09-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          42:
              {
                'ts': -463600800,
                'time': '1955-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          43:
              {
                'ts': -450298800,
                'time': '1955-09-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          44:
              {
                'ts': -431546400,
                'time': '1956-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          45:
              {
                'ts': -418244400,
                'time': '1956-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          46:
              {
                'ts': -400096800,
                'time': '1957-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          47:
              {
                'ts': -384375600,
                'time': '1957-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          48:
              {
                'ts': -368647200,
                'time': '1958-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          49:
              {
                'ts': -352926000,
                'time': '1958-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          50:
              {
                'ts': -337197600,
                'time': '1959-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          51:
              {
                'ts': -321476400,
                'time': '1959-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          52:
              {
                'ts': -305748000,
                'time': '1960-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          53:
              {
                'ts': -289422000,
                'time': '1960-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          54:
              {
                'ts': -273693600,
                'time': '1961-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          55:
              {
                'ts': -257972400,
                'time': '1961-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          56:
              {
                'ts': -242244000,
                'time': '1962-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          57:
              {
                'ts': -226522800,
                'time': '1962-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          58:
              {
                'ts': -210794400,
                'time': '1963-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          59:
              {
                'ts': -195073200,
                'time': '1963-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          60:
              {
                'ts': -179344800,
                'time': '1964-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          61:
              {
                'ts': -163623600,
                'time': '1964-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          62:
              {
                'ts': -147895200,
                'time': '1965-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          63:
              {
                'ts': -131569200,
                'time': '1965-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          64:
              {
                'ts': -116445600,
                'time': '1966-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          65:
              {
                'ts': -100119600,
                'time': '1966-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          66:
              {
                'ts': -84391200,
                'time': '1967-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          67:
              {
                'ts': -68670000,
                'time': '1967-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          68:
              {
                'ts': -52941600,
                'time': '1968-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          69:
              {
                'ts': -37220400,
                'time': '1968-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          70:
              {
                'ts': -21492000,
                'time': '1969-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          71:
              {
                'ts': -5770800,
                'time': '1969-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          72:
              {
                'ts': 9957600,
                'time': '1970-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          73:
              {
                'ts': 25678800,
                'time': '1970-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          74:
              {
                'ts': 41407200,
                'time': '1971-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          75:
              {
                'ts': 57733200,
                'time': '1971-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          76:
              {
                'ts': 73461600,
                'time': '1972-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          77:
              {
                'ts': 89182800,
                'time': '1972-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          78:
              {
                'ts': 136360800,
                'time': '1974-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          79:
              {
                'ts': 152082000,
                'time': '1974-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          80:
              {
                'ts': 167810400,
                'time': '1975-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          81:
              {
                'ts': 183531600,
                'time': '1975-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          82:
              {
                'ts': 199260000,
                'time': '1976-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          83:
              {
                'ts': 215586000,
                'time': '1976-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          84:
              {
                'ts': 230709600,
                'time': '1977-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          85:
              {
                'ts': 247035600,
                'time': '1977-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          86:
              {
                'ts': 262764000,
                'time': '1978-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          87:
              {
                'ts': 278485200,
                'time': '1978-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          88:
              {
                'ts': 294213600,
                'time': '1979-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          89:
              {
                'ts': 309934800,
                'time': '1979-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          90:
              {
                'ts': 325663200,
                'time': '1980-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          91:
              {
                'ts': 341384400,
                'time': '1980-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          92:
              {
                'ts': 357112800,
                'time': '1981-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          93:
              {
                'ts': 372834000,
                'time': '1981-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          94:
              {
                'ts': 388562400,
                'time': '1982-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          95:
              {
                'ts': 404888400,
                'time': '1982-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          96:
              {
                'ts': 420012000,
                'time': '1983-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          97:
              {
                'ts': 436338000,
                'time': '1983-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          98:
              {
                'ts': 452066400,
                'time': '1984-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          99:
              {
                'ts': 467787600,
                'time': '1984-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          100:
              {
                'ts': 483516000,
                'time': '1985-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          101:
              {
                'ts': 499237200,
                'time': '1985-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          102:
              {
                'ts': 514965600,
                'time': '1986-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          103:
              {
                'ts': 530686800,
                'time': '1986-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          104:
              {
                'ts': 544600800,
                'time': '1987-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          105:
              {
                'ts': 562136400,
                'time': '1987-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          106:
              {
                'ts': 576050400,
                'time': '1988-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          107:
              {
                'ts': 594190800,
                'time': '1988-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          108:
              {
                'ts': 607500000,
                'time': '1989-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          109:
              {
                'ts': 625640400,
                'time': '1989-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          110:
              {
                'ts': 638949600,
                'time': '1990-04-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          111:
              {
                'ts': 657090000,
                'time': '1990-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          112:
              {
                'ts': 671004000,
                'time': '1991-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          113:
              {
                'ts': 688539600,
                'time': '1991-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          114:
              {
                'ts': 702453600,
                'time': '1992-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          115:
              {
                'ts': 719989200,
                'time': '1992-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          116:
              {
                'ts': 733896060,
                'time': '1993-04-04T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          117:
              {
                'ts': 752036460,
                'time': '1993-10-31T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          118:
              {
                'ts': 765345660,
                'time': '1994-04-03T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          119:
              {
                'ts': 783486060,
                'time': '1994-10-30T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          120:
              {
                'ts': 796795260,
                'time': '1995-04-02T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          121:
              {
                'ts': 814935660,
                'time': '1995-10-29T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          122:
              {
                'ts': 828849660,
                'time': '1996-04-07T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          123:
              {
                'ts': 846385260,
                'time': '1996-10-27T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          124:
              {
                'ts': 860299260,
                'time': '1997-04-06T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          125:
              {
                'ts': 877834860,
                'time': '1997-10-26T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          126:
              {
                'ts': 891748860,
                'time': '1998-04-05T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          127:
              {
                'ts': 909284460,
                'time': '1998-10-25T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          128:
              {
                'ts': 923198460,
                'time': '1999-04-04T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          129:
              {
                'ts': 941338860,
                'time': '1999-10-31T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          130:
              {
                'ts': 954648060,
                'time': '2000-04-02T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          131:
              {
                'ts': 972788460,
                'time': '2000-10-29T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          132:
              {
                'ts': 986097660,
                'time': '2001-04-01T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          133:
              {
                'ts': 1004238060,
                'time': '2001-10-28T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          134:
              {
                'ts': 1018152060,
                'time': '2002-04-07T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          135:
              {
                'ts': 1035687660,
                'time': '2002-10-27T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          136:
              {
                'ts': 1049601660,
                'time': '2003-04-06T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          137:
              {
                'ts': 1067137260,
                'time': '2003-10-26T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          138:
              {
                'ts': 1081051260,
                'time': '2004-04-04T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          139:
              {
                'ts': 1099191660,
                'time': '2004-10-31T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          140:
              {
                'ts': 1112500860,
                'time': '2005-04-03T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          141:
              {
                'ts': 1130641260,
                'time': '2005-10-30T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          142:
              {
                'ts': 1143950460,
                'time': '2006-04-02T04:01:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          143:
              {
                'ts': 1162090860,
                'time': '2006-10-29T03:01:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          144:
              {
                'ts': 1173592800,
                'time': '2007-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          145:
              {
                'ts': 1194152400,
                'time': '2007-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          146:
              {
                'ts': 1205042400,
                'time': '2008-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          147:
              {
                'ts': 1225602000,
                'time': '2008-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          148:
              {
                'ts': 1236492000,
                'time': '2009-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          149:
              {
                'ts': 1257051600,
                'time': '2009-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          150:
              {
                'ts': 1268546400,
                'time': '2010-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          151:
              {
                'ts': 1289106000,
                'time': '2010-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          152:
              {
                'ts': 1299996000,
                'time': '2011-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          153:
              {
                'ts': 1320555600,
                'time': '2011-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          154:
              {
                'ts': 1331445600,
                'time': '2012-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          155:
              {
                'ts': 1352005200,
                'time': '2012-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          156:
              {
                'ts': 1362895200,
                'time': '2013-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          157:
              {
                'ts': 1383454800,
                'time': '2013-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          158:
              {
                'ts': 1394344800,
                'time': '2014-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          159:
              {
                'ts': 1414904400,
                'time': '2014-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          160:
              {
                'ts': 1425794400,
                'time': '2015-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          161:
              {
                'ts': 1446354000,
                'time': '2015-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          162:
              {
                'ts': 1457848800,
                'time': '2016-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          163:
              {
                'ts': 1478408400,
                'time': '2016-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          164:
              {
                'ts': 1489298400,
                'time': '2017-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          165:
              {
                'ts': 1509858000,
                'time': '2017-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          166:
              {
                'ts': 1520748000,
                'time': '2018-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          167:
              {
                'ts': 1541307600,
                'time': '2018-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          168:
              {
                'ts': 1552197600,
                'time': '2019-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          169:
              {
                'ts': 1572757200,
                'time': '2019-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          170:
              {
                'ts': 1583647200,
                'time': '2020-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          171:
              {
                'ts': 1604206800,
                'time': '2020-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          172:
              {
                'ts': 1615701600,
                'time': '2021-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          173:
              {
                'ts': 1636261200,
                'time': '2021-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          174:
              {
                'ts': 1647151200,
                'time': '2022-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          175:
              {
                'ts': 1667710800,
                'time': '2022-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          176:
              {
                'ts': 1678600800,
                'time': '2023-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          177:
              {
                'ts': 1699160400,
                'time': '2023-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          178:
              {
                'ts': 1710050400,
                'time': '2024-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          179:
              {
                'ts': 1730610000,
                'time': '2024-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          180:
              {
                'ts': 1741500000,
                'time': '2025-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          181:
              {
                'ts': 1762059600,
                'time': '2025-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          182:
              {
                'ts': 1772949600,
                'time': '2026-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          183:
              {
                'ts': 1793509200,
                'time': '2026-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          184:
              {
                'ts': 1805004000,
                'time': '2027-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          185:
              {
                'ts': 1825563600,
                'time': '2027-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          186:
              {
                'ts': 1836453600,
                'time': '2028-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          187:
              {
                'ts': 1857013200,
                'time': '2028-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          188:
              {
                'ts': 1867903200,
                'time': '2029-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          189:
              {
                'ts': 1888462800,
                'time': '2029-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          190:
              {
                'ts': 1899352800,
                'time': '2030-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          191:
              {
                'ts': 1919912400,
                'time': '2030-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          192:
              {
                'ts': 1930802400,
                'time': '2031-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          193:
              {
                'ts': 1951362000,
                'time': '2031-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          194:
              {
                'ts': 1962856800,
                'time': '2032-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          195:
              {
                'ts': 1983416400,
                'time': '2032-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          196:
              {
                'ts': 1994306400,
                'time': '2033-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          197:
              {
                'ts': 2014866000,
                'time': '2033-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          198:
              {
                'ts': 2025756000,
                'time': '2034-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          199:
              {
                'ts': 2046315600,
                'time': '2034-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          200:
              {
                'ts': 2057205600,
                'time': '2035-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          201:
              {
                'ts': 2077765200,
                'time': '2035-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          202:
              {
                'ts': 2088655200,
                'time': '2036-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          203:
              {
                'ts': 2109214800,
                'time': '2036-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          204:
              {
                'ts': 2120104800,
                'time': '2037-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          205:
              {
                'ts': 2140664400,
                'time': '2037-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Monterrey':
        {
          0:
              {
                'ts': -1514743200,
                'time': '1922-01-01T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          2:
              {
                'ts': 594198000,
                'time': '1988-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 989136000,
                'time': '2001-05-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': 1001833200,
                'time': '2001-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 1175414400,
                'time': '2007-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': 1193554800,
                'time': '2007-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 1207468800,
                'time': '2008-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': 1225004400,
                'time': '2008-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 1238918400,
                'time': '2009-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': 1256454000,
                'time': '2009-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 1270368000,
                'time': '2010-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': 1288508400,
                'time': '2010-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 1301817600,
                'time': '2011-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': 1319958000,
                'time': '2011-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 1333267200,
                'time': '2012-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': 1351407600,
                'time': '2012-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 1365321600,
                'time': '2013-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          38:
              {
                'ts': 1382857200,
                'time': '2013-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 1396771200,
                'time': '2014-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': 1414306800,
                'time': '2014-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 1428220800,
                'time': '2015-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': 1445756400,
                'time': '2015-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 1459670400,
                'time': '2016-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': 1477810800,
                'time': '2016-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 1491120000,
                'time': '2017-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 1509260400,
                'time': '2017-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 1522569600,
                'time': '2018-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 1540710000,
                'time': '2018-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 1554624000,
                'time': '2019-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 1572159600,
                'time': '2019-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 1586073600,
                'time': '2020-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 1603609200,
                'time': '2020-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 1617523200,
                'time': '2021-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 1635663600,
                'time': '2021-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 1648972800,
                'time': '2022-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 1667113200,
                'time': '2022-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 1680422400,
                'time': '2023-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 1698562800,
                'time': '2023-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 1712476800,
                'time': '2024-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 1730012400,
                'time': '2024-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 1743926400,
                'time': '2025-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 1761462000,
                'time': '2025-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 1775376000,
                'time': '2026-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 1792911600,
                'time': '2026-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 1806825600,
                'time': '2027-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 1824966000,
                'time': '2027-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 1838275200,
                'time': '2028-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 1856415600,
                'time': '2028-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 1869724800,
                'time': '2029-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 1887865200,
                'time': '2029-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 1901779200,
                'time': '2030-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 1919314800,
                'time': '2030-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 1933228800,
                'time': '2031-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 1950764400,
                'time': '2031-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 1964678400,
                'time': '2032-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 1982818800,
                'time': '2032-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 1996128000,
                'time': '2033-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 2014268400,
                'time': '2033-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 2027577600,
                'time': '2034-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 2045718000,
                'time': '2034-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 2059027200,
                'time': '2035-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 2077167600,
                'time': '2035-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 2091081600,
                'time': '2036-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 2108617200,
                'time': '2036-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 2122531200,
                'time': '2037-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 2140066800,
                'time': '2037-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Montevideo':
        {
          0:
              {
                'ts': -1567455316,
                'time': '1920-05-01T03:44:44+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          1:
              {
                'ts': -1459542600,
                'time': '1923-10-02T03:30:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'UYHST'
              },
          2:
              {
                'ts': -1443819600,
                'time': '1924-04-01T03:00:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          3:
              {
                'ts': -1428006600,
                'time': '1924-10-01T03:30:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'UYHST'
              },
          4:
              {
                'ts': -1412283600,
                'time': '1925-04-01T03:00:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          5:
              {
                'ts': -1396470600,
                'time': '1925-10-01T03:30:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'UYHST'
              },
          6:
              {
                'ts': -1380747600,
                'time': '1926-04-01T03:00:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          7:
              {
                'ts': -1141590600,
                'time': '1933-10-29T03:30:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'UYHST'
              },
          8:
              {
                'ts': -1128286800,
                'time': '1934-04-01T03:00:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          9:
              {
                'ts': -1110141000,
                'time': '1934-10-28T03:30:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'UYHST'
              },
          10:
              {
                'ts': -1096837200,
                'time': '1935-03-31T03:00:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          11:
              {
                'ts': -1078691400,
                'time': '1935-10-27T03:30:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'UYHST'
              },
          12:
              {
                'ts': -1065387600,
                'time': '1936-03-29T03:00:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          13:
              {
                'ts': -1046637000,
                'time': '1936-11-01T03:30:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'UYHST'
              },
          14:
              {
                'ts': -1033938000,
                'time': '1937-03-28T03:00:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          15:
              {
                'ts': -1015187400,
                'time': '1937-10-31T03:30:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'UYHST'
              },
          16:
              {
                'ts': -1002488400,
                'time': '1938-03-27T03:00:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          17:
              {
                'ts': -983737800,
                'time': '1938-10-30T03:30:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'UYHST'
              },
          18:
              {
                'ts': -971038800,
                'time': '1939-03-26T03:00:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          19:
              {
                'ts': -952288200,
                'time': '1939-10-29T03:30:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'UYHST'
              },
          20:
              {
                'ts': -938984400,
                'time': '1940-03-31T03:00:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          21:
              {
                'ts': -920838600,
                'time': '1940-10-27T03:30:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'UYHST'
              },
          22:
              {
                'ts': -907534800,
                'time': '1941-03-30T03:00:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          23:
              {
                'ts': -896819400,
                'time': '1941-08-01T03:30:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'UYHST'
              },
          24:
              {
                'ts': -883602000,
                'time': '1942-01-01T03:00:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'UYT'
              },
          25:
              {
                'ts': -853619400,
                'time': '1942-12-14T03:30:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          26:
              {
                'ts': -845848800,
                'time': '1943-03-14T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          27:
              {
                'ts': -334789200,
                'time': '1959-05-24T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          28:
              {
                'ts': -319672800,
                'time': '1959-11-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          29:
              {
                'ts': -314226000,
                'time': '1960-01-17T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          30:
              {
                'ts': -309996000,
                'time': '1960-03-06T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          31:
              {
                'ts': -149720400,
                'time': '1965-04-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          32:
              {
                'ts': -134604000,
                'time': '1965-09-26T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          33:
              {
                'ts': -118270800,
                'time': '1966-04-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          34:
              {
                'ts': -100044000,
                'time': '1966-10-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          35:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          36:
              {
                'ts': -68508000,
                'time': '1967-10-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          37:
              {
                'ts': -50446800,
                'time': '1968-05-27T03:00:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'UYHST'
              },
          38:
              {
                'ts': -34119000,
                'time': '1968-12-02T02:30:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          39:
              {
                'ts': -18910800,
                'time': '1969-05-27T03:00:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'UYHST'
              },
          40:
              {
                'ts': -2583000,
                'time': '1969-12-02T02:30:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          41:
              {
                'ts': 12625200,
                'time': '1970-05-27T03:00:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'UYHST'
              },
          42:
              {
                'ts': 28953000,
                'time': '1970-12-02T02:30:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          43:
              {
                'ts': 72932400,
                'time': '1972-04-24T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          44:
              {
                'ts': 82692000,
                'time': '1972-08-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          45:
              {
                'ts': 132116400,
                'time': '1974-03-10T03:00:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'UYHST'
              },
          46:
              {
                'ts': 156911400,
                'time': '1974-12-22T02:30:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          47:
              {
                'ts': 212983200,
                'time': '1976-10-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          48:
              {
                'ts': 250052400,
                'time': '1977-12-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          49:
              {
                'ts': 260244000,
                'time': '1978-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          50:
              {
                'ts': 307594800,
                'time': '1979-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          51:
              {
                'ts': 325994400,
                'time': '1980-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          52:
              {
                'ts': 566449200,
                'time': '1987-12-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          53:
              {
                'ts': 574308000,
                'time': '1988-03-14T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          54:
              {
                'ts': 597812400,
                'time': '1988-12-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          55:
              {
                'ts': 605671200,
                'time': '1989-03-12T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          56:
              {
                'ts': 625633200,
                'time': '1989-10-29T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          57:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          58:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          59:
              {
                'ts': 667965600,
                'time': '1991-03-03T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          60:
              {
                'ts': 688532400,
                'time': '1991-10-27T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          61:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          62:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          63:
              {
                'ts': 730864800,
                'time': '1993-02-28T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          64:
              {
                'ts': 1095562800,
                'time': '2004-09-19T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          65:
              {
                'ts': 1111896000,
                'time': '2005-03-27T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          66:
              {
                'ts': 1128834000,
                'time': '2005-10-09T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          67:
              {
                'ts': 1142136000,
                'time': '2006-03-12T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          68:
              {
                'ts': 1159678800,
                'time': '2006-10-01T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          69:
              {
                'ts': 1173585600,
                'time': '2007-03-11T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          70:
              {
                'ts': 1191733200,
                'time': '2007-10-07T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          71:
              {
                'ts': 1205035200,
                'time': '2008-03-09T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          72:
              {
                'ts': 1223182800,
                'time': '2008-10-05T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          73:
              {
                'ts': 1236484800,
                'time': '2009-03-08T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          74:
              {
                'ts': 1254632400,
                'time': '2009-10-04T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          75:
              {
                'ts': 1268539200,
                'time': '2010-03-14T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          76:
              {
                'ts': 1286082000,
                'time': '2010-10-03T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          77:
              {
                'ts': 1299988800,
                'time': '2011-03-13T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          78:
              {
                'ts': 1317531600,
                'time': '2011-10-02T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          79:
              {
                'ts': 1331438400,
                'time': '2012-03-11T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          80:
              {
                'ts': 1349586000,
                'time': '2012-10-07T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          81:
              {
                'ts': 1362888000,
                'time': '2013-03-10T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          82:
              {
                'ts': 1381035600,
                'time': '2013-10-06T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          83:
              {
                'ts': 1394337600,
                'time': '2014-03-09T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          84:
              {
                'ts': 1412485200,
                'time': '2014-10-05T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          85:
              {
                'ts': 1425787200,
                'time': '2015-03-08T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          86:
              {
                'ts': 1443934800,
                'time': '2015-10-04T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          87:
              {
                'ts': 1457841600,
                'time': '2016-03-13T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          88:
              {
                'ts': 1475384400,
                'time': '2016-10-02T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          89:
              {
                'ts': 1489291200,
                'time': '2017-03-12T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          90:
              {
                'ts': 1506834000,
                'time': '2017-10-01T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          91:
              {
                'ts': 1520740800,
                'time': '2018-03-11T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          92:
              {
                'ts': 1538888400,
                'time': '2018-10-07T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          93:
              {
                'ts': 1552190400,
                'time': '2019-03-10T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          94:
              {
                'ts': 1570338000,
                'time': '2019-10-06T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          95:
              {
                'ts': 1583640000,
                'time': '2020-03-08T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          96:
              {
                'ts': 1601787600,
                'time': '2020-10-04T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          97:
              {
                'ts': 1615694400,
                'time': '2021-03-14T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          98:
              {
                'ts': 1633237200,
                'time': '2021-10-03T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          99:
              {
                'ts': 1647144000,
                'time': '2022-03-13T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          100:
              {
                'ts': 1664686800,
                'time': '2022-10-02T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          101:
              {
                'ts': 1678593600,
                'time': '2023-03-12T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          102:
              {
                'ts': 1696136400,
                'time': '2023-10-01T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          103:
              {
                'ts': 1710043200,
                'time': '2024-03-10T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          104:
              {
                'ts': 1728190800,
                'time': '2024-10-06T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          105:
              {
                'ts': 1741492800,
                'time': '2025-03-09T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          106:
              {
                'ts': 1759640400,
                'time': '2025-10-05T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          107:
              {
                'ts': 1772942400,
                'time': '2026-03-08T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          108:
              {
                'ts': 1791090000,
                'time': '2026-10-04T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          109:
              {
                'ts': 1804996800,
                'time': '2027-03-14T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          110:
              {
                'ts': 1822539600,
                'time': '2027-10-03T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          111:
              {
                'ts': 1836446400,
                'time': '2028-03-12T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          112:
              {
                'ts': 1853989200,
                'time': '2028-10-01T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          113:
              {
                'ts': 1867896000,
                'time': '2029-03-11T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          114:
              {
                'ts': 1886043600,
                'time': '2029-10-07T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          115:
              {
                'ts': 1899345600,
                'time': '2030-03-10T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          116:
              {
                'ts': 1917493200,
                'time': '2030-10-06T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          117:
              {
                'ts': 1930795200,
                'time': '2031-03-09T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          118:
              {
                'ts': 1948942800,
                'time': '2031-10-05T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          119:
              {
                'ts': 1962849600,
                'time': '2032-03-14T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          120:
              {
                'ts': 1980392400,
                'time': '2032-10-03T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          121:
              {
                'ts': 1994299200,
                'time': '2033-03-13T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          122:
              {
                'ts': 2011842000,
                'time': '2033-10-02T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          123:
              {
                'ts': 2025748800,
                'time': '2034-03-12T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          124:
              {
                'ts': 2043291600,
                'time': '2034-10-01T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          125:
              {
                'ts': 2057198400,
                'time': '2035-03-11T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          126:
              {
                'ts': 2075346000,
                'time': '2035-10-07T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          127:
              {
                'ts': 2088648000,
                'time': '2036-03-09T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          128:
              {
                'ts': 2106795600,
                'time': '2036-10-05T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              },
          129:
              {
                'ts': 2120097600,
                'time': '2037-03-08T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'UYT'
              },
          130:
              {
                'ts': 2138245200,
                'time': '2037-10-04T05:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'UYST'
              }
        },
    'America/Montreal':
        {
          0:
              {
                'ts': -1665334800,
                'time': '1917-03-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          1:
              {
                'ts': -1662753600,
                'time': '1917-04-24T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -1632070800,
                'time': '1918-04-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          3:
              {
                'ts': -1614794400,
                'time': '1918-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -1601742600,
                'time': '1919-03-31T07:30:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          5:
              {
                'ts': -1583775000,
                'time': '1919-10-25T06:30:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -1567355400,
                'time': '1920-05-02T07:30:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          7:
              {
                'ts': -1554053400,
                'time': '1920-10-03T06:30:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': -1535907600,
                'time': '1921-05-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          9:
              {
                'ts': -1522603800,
                'time': '1921-10-02T06:30:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': -1504458000,
                'time': '1922-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          11:
              {
                'ts': -1491154200,
                'time': '1922-10-01T06:30:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': -1439830800,
                'time': '1924-05-17T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          13:
              {
                'ts': -1428255000,
                'time': '1924-09-28T06:30:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': -1409504400,
                'time': '1925-05-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          15:
              {
                'ts': -1396805400,
                'time': '1925-09-27T06:30:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': -1378054800,
                'time': '1926-05-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          17:
              {
                'ts': -1365355800,
                'time': '1926-09-26T06:30:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': -1346612400,
                'time': '1927-05-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          19:
              {
                'ts': -1333915200,
                'time': '1927-09-25T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': -1315162800,
                'time': '1928-04-29T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          21:
              {
                'ts': -1301860800,
                'time': '1928-09-30T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': -1283713200,
                'time': '1929-04-28T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          23:
              {
                'ts': -1270411200,
                'time': '1929-09-29T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': -1252263600,
                'time': '1930-04-27T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          25:
              {
                'ts': -1238961600,
                'time': '1930-09-28T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': -1220814000,
                'time': '1931-04-26T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          27:
              {
                'ts': -1207512000,
                'time': '1931-09-27T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': -1188759600,
                'time': '1932-05-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          29:
              {
                'ts': -1176062400,
                'time': '1932-09-25T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': -1157310000,
                'time': '1933-04-30T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': -1144008000,
                'time': '1933-10-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': -1125860400,
                'time': '1934-04-29T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': -1112558400,
                'time': '1934-09-30T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': -1094410800,
                'time': '1935-04-28T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': -1081108800,
                'time': '1935-09-29T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': -1062961200,
                'time': '1936-04-26T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': -1049659200,
                'time': '1936-09-27T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': -1031511600,
                'time': '1937-04-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': -1018209600,
                'time': '1937-09-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': -1000062000,
                'time': '1938-04-24T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': -986760000,
                'time': '1938-09-25T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': -968007600,
                'time': '1939-04-30T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': -955310400,
                'time': '1939-09-24T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': -936558000,
                'time': '1940-04-28T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': -880218000,
                'time': '1942-02-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EWT'
              },
          46:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EPT'
              },
          47:
              {
                'ts': -765396000,
                'time': '1945-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': -747248400,
                'time': '1946-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': -733946400,
                'time': '1946-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': -715798800,
                'time': '1947-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': -702496800,
                'time': '1947-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': -684349200,
                'time': '1948-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': -671047200,
                'time': '1948-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': -652899600,
                'time': '1949-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': -636573600,
                'time': '1949-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': -620845200,
                'time': '1950-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': -605124000,
                'time': '1950-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': -589395600,
                'time': '1951-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': -576093600,
                'time': '1951-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': -557946000,
                'time': '1952-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': -544644000,
                'time': '1952-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': -526496400,
                'time': '1953-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': -513194400,
                'time': '1953-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': -495046800,
                'time': '1954-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': -481744800,
                'time': '1954-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': -463597200,
                'time': '1955-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': -450295200,
                'time': '1955-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': -431542800,
                'time': '1956-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': -418240800,
                'time': '1956-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': -400093200,
                'time': '1957-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': -384372000,
                'time': '1957-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': -368643600,
                'time': '1958-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': -352922400,
                'time': '1958-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': -337194000,
                'time': '1959-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': -321472800,
                'time': '1959-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': -305744400,
                'time': '1960-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': -289418400,
                'time': '1960-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': -273690000,
                'time': '1961-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': -257968800,
                'time': '1961-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': -242240400,
                'time': '1962-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': -226519200,
                'time': '1962-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': -210790800,
                'time': '1963-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': -195069600,
                'time': '1963-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': -179341200,
                'time': '1964-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': -163620000,
                'time': '1964-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': -147891600,
                'time': '1965-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': -131565600,
                'time': '1965-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': -116442000,
                'time': '1966-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': -100116000,
                'time': '1966-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': -84387600,
                'time': '1967-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': -68666400,
                'time': '1967-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': -52938000,
                'time': '1968-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': -37216800,
                'time': '1968-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          99:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          101:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          103:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 136364400,
                'time': '1974-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          105:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 167814000,
                'time': '1975-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          107:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          109:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          111:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          113:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          115:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          117:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          119:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          121:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          123:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          125:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          127:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          129:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          131:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          133:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          135:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          137:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          138:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          139:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          140:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          141:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          142:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          143:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          144:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          145:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          146:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          147:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          148:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          149:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          150:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          151:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          152:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          153:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          154:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          155:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          156:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          157:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          158:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          159:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          160:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          161:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          162:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          163:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          164:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          165:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          166:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          167:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          168:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          169:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          170:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          171:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          172:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          173:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          174:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          175:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          176:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          177:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          178:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          179:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          180:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          181:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          182:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          183:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          184:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          185:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          186:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          187:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          188:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          189:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          190:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          191:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          192:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          193:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          194:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          195:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          196:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          197:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          198:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          199:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          200:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          201:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          202:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          203:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          204:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          205:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          206:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          207:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          208:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          209:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          210:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          211:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          212:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          213:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          214:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          215:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          216:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          217:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          218:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          219:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          220:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          221:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          222:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          223:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          224:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          225:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          226:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          227:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          228:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          229:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          230:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          231:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Montserrat':
        {
          0:
              {
                'ts': -1846266608,
                'time': '1911-07-01T04:09:52+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Nassau':
        {
          0:
              {
                'ts': -1825095036,
                'time': '1912-03-02T05:09:24+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -179341200,
                'time': '1964-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          2:
              {
                'ts': -163620000,
                'time': '1964-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -147891600,
                'time': '1965-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          4:
              {
                'ts': -131565600,
                'time': '1965-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -116442000,
                'time': '1966-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          6:
              {
                'ts': -100116000,
                'time': '1966-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -84387600,
                'time': '1967-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          8:
              {
                'ts': -68666400,
                'time': '1967-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          9:
              {
                'ts': -52938000,
                'time': '1968-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          10:
              {
                'ts': -37216800,
                'time': '1968-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          11:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          12:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          14:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          16:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          18:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          20:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 136364400,
                'time': '1974-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          22:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 167814000,
                'time': '1975-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          24:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          26:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          28:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          30:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          32:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          34:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          36:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          38:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          40:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          42:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          44:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          46:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          48:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          50:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          52:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          54:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          56:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          58:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          60:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          62:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          64:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          66:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          68:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          70:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          72:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          116:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          118:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          120:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          122:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          124:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          126:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          128:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          130:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          132:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          134:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          136:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          138:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          140:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          141:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          142:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          143:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          144:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          145:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          146:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          147:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          148:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/New_York':
        {
          0:
              {
                'ts': -1633280400,
                'time': '1918-03-31T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          1:
              {
                'ts': -1615140000,
                'time': '1918-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -1601830800,
                'time': '1919-03-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          3:
              {
                'ts': -1583690400,
                'time': '1919-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -1570381200,
                'time': '1920-03-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          5:
              {
                'ts': -1551636000,
                'time': '1920-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -1536512400,
                'time': '1921-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          7:
              {
                'ts': -1523210400,
                'time': '1921-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': -1504458000,
                'time': '1922-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          9:
              {
                'ts': -1491760800,
                'time': '1922-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': -1473008400,
                'time': '1923-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          11:
              {
                'ts': -1459706400,
                'time': '1923-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': -1441558800,
                'time': '1924-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          13:
              {
                'ts': -1428256800,
                'time': '1924-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': -1410109200,
                'time': '1925-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          15:
              {
                'ts': -1396807200,
                'time': '1925-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': -1378659600,
                'time': '1926-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          17:
              {
                'ts': -1365357600,
                'time': '1926-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': -1347210000,
                'time': '1927-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          19:
              {
                'ts': -1333908000,
                'time': '1927-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': -1315155600,
                'time': '1928-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          21:
              {
                'ts': -1301853600,
                'time': '1928-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': -1283706000,
                'time': '1929-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          23:
              {
                'ts': -1270404000,
                'time': '1929-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': -1252256400,
                'time': '1930-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          25:
              {
                'ts': -1238954400,
                'time': '1930-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': -1220806800,
                'time': '1931-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          27:
              {
                'ts': -1207504800,
                'time': '1931-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': -1189357200,
                'time': '1932-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          29:
              {
                'ts': -1176055200,
                'time': '1932-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': -1157302800,
                'time': '1933-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': -1144605600,
                'time': '1933-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': -1125853200,
                'time': '1934-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': -1112551200,
                'time': '1934-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': -1094403600,
                'time': '1935-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': -1081101600,
                'time': '1935-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': -1062954000,
                'time': '1936-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': -1049652000,
                'time': '1936-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': -1031504400,
                'time': '1937-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': -1018202400,
                'time': '1937-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': -1000054800,
                'time': '1938-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': -986752800,
                'time': '1938-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': -968000400,
                'time': '1939-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': -955303200,
                'time': '1939-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': -936550800,
                'time': '1940-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': -923248800,
                'time': '1940-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': -905101200,
                'time': '1941-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': -891799200,
                'time': '1941-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': -880218000,
                'time': '1942-02-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EWT'
              },
          49:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EPT'
              },
          50:
              {
                'ts': -765396000,
                'time': '1945-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          51:
              {
                'ts': -747248400,
                'time': '1946-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          52:
              {
                'ts': -733946400,
                'time': '1946-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          53:
              {
                'ts': -715798800,
                'time': '1947-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          54:
              {
                'ts': -702496800,
                'time': '1947-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          55:
              {
                'ts': -684349200,
                'time': '1948-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          56:
              {
                'ts': -671047200,
                'time': '1948-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          57:
              {
                'ts': -652899600,
                'time': '1949-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          58:
              {
                'ts': -639597600,
                'time': '1949-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          59:
              {
                'ts': -620845200,
                'time': '1950-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          60:
              {
                'ts': -608148000,
                'time': '1950-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          61:
              {
                'ts': -589395600,
                'time': '1951-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          62:
              {
                'ts': -576093600,
                'time': '1951-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          63:
              {
                'ts': -557946000,
                'time': '1952-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          64:
              {
                'ts': -544644000,
                'time': '1952-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          65:
              {
                'ts': -526496400,
                'time': '1953-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          66:
              {
                'ts': -513194400,
                'time': '1953-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          67:
              {
                'ts': -495046800,
                'time': '1954-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          68:
              {
                'ts': -481744800,
                'time': '1954-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          69:
              {
                'ts': -463597200,
                'time': '1955-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          70:
              {
                'ts': -447271200,
                'time': '1955-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          71:
              {
                'ts': -431542800,
                'time': '1956-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          72:
              {
                'ts': -415821600,
                'time': '1956-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': -400093200,
                'time': '1957-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': -384372000,
                'time': '1957-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': -368643600,
                'time': '1958-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': -352922400,
                'time': '1958-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': -337194000,
                'time': '1959-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': -321472800,
                'time': '1959-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': -305744400,
                'time': '1960-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': -289418400,
                'time': '1960-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': -273690000,
                'time': '1961-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': -257968800,
                'time': '1961-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': -242240400,
                'time': '1962-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': -226519200,
                'time': '1962-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': -210790800,
                'time': '1963-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': -195069600,
                'time': '1963-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': -179341200,
                'time': '1964-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': -163620000,
                'time': '1964-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': -147891600,
                'time': '1965-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': -131565600,
                'time': '1965-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': -116442000,
                'time': '1966-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': -100116000,
                'time': '1966-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': -84387600,
                'time': '1967-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': -68666400,
                'time': '1967-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': -52938000,
                'time': '1968-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': -37216800,
                'time': '1968-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 126687600,
                'time': '1974-01-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 162370800,
                'time': '1975-02-23T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          116:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          118:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          120:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          122:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          124:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          126:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          128:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          130:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          132:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          134:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          136:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          138:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          140:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          141:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          142:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          143:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          144:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          145:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          146:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          147:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          148:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          149:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          150:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          151:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          152:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          153:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          154:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          155:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          156:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          157:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          158:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          159:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          160:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          161:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          162:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          163:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          164:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          165:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          166:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          167:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          168:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          169:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          170:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          171:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          172:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          173:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          174:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          175:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          176:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          177:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          178:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          179:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          180:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          181:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          182:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          183:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          184:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          185:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          186:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          187:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          188:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          189:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          190:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          191:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          192:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          193:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          194:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          195:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          196:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          197:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          198:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          199:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          200:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          201:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          202:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          203:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          204:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          205:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          206:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          207:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          208:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          209:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          210:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          211:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          212:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          213:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          214:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          215:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          216:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          217:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          218:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          219:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          220:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          221:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          222:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          223:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          224:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          225:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          226:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          227:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          228:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          229:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          230:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          231:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          232:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          233:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          234:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Nipigon':
        {
          0:
              {
                'ts': -1632070800,
                'time': '1918-04-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          1:
              {
                'ts': -1614794400,
                'time': '1918-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -923252400,
                'time': '1940-09-29T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          3:
              {
                'ts': -880218000,
                'time': '1942-02-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EWT'
              },
          4:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EPT'
              },
          5:
              {
                'ts': -765396000,
                'time': '1945-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': 136364400,
                'time': '1974-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          7:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 167814000,
                'time': '1975-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          9:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          11:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          13:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          15:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          17:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          19:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          21:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          23:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          25:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          27:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          29:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          99:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          101:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          103:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          105:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          107:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          109:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          111:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          113:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          115:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          117:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          119:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          121:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          123:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          125:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          127:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          129:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          131:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          133:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Nome':
        {
          0:
              {
                'ts': -880196400,
                'time': '1942-02-09T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'NWT'
              },
          1:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'NPT'
              },
          2:
              {
                'ts': -765374400,
                'time': '1945-09-30T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'NST'
              },
          3:
              {
                'ts': -86878800,
                'time': '1967-04-01T11:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          4:
              {
                'ts': -21466800,
                'time': '1969-04-27T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          5:
              {
                'ts': -5745600,
                'time': '1969-10-26T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          6:
              {
                'ts': 9982800,
                'time': '1970-04-26T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          7:
              {
                'ts': 25704000,
                'time': '1970-10-25T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          8:
              {
                'ts': 41432400,
                'time': '1971-04-25T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          9:
              {
                'ts': 57758400,
                'time': '1971-10-31T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          10:
              {
                'ts': 73486800,
                'time': '1972-04-30T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          11:
              {
                'ts': 89208000,
                'time': '1972-10-29T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          12:
              {
                'ts': 104936400,
                'time': '1973-04-29T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          13:
              {
                'ts': 120657600,
                'time': '1973-10-28T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          14:
              {
                'ts': 126709200,
                'time': '1974-01-06T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          15:
              {
                'ts': 152107200,
                'time': '1974-10-27T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          16:
              {
                'ts': 162392400,
                'time': '1975-02-23T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          17:
              {
                'ts': 183556800,
                'time': '1975-10-26T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          18:
              {
                'ts': 199285200,
                'time': '1976-04-25T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          19:
              {
                'ts': 215611200,
                'time': '1976-10-31T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          20:
              {
                'ts': 230734800,
                'time': '1977-04-24T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          21:
              {
                'ts': 247060800,
                'time': '1977-10-30T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          22:
              {
                'ts': 262789200,
                'time': '1978-04-30T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          23:
              {
                'ts': 278510400,
                'time': '1978-10-29T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          24:
              {
                'ts': 294238800,
                'time': '1979-04-29T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          25:
              {
                'ts': 309960000,
                'time': '1979-10-28T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          26:
              {
                'ts': 325688400,
                'time': '1980-04-27T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          27:
              {
                'ts': 341409600,
                'time': '1980-10-26T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          28:
              {
                'ts': 357138000,
                'time': '1981-04-26T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          29:
              {
                'ts': 372859200,
                'time': '1981-10-25T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          30:
              {
                'ts': 388587600,
                'time': '1982-04-25T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          31:
              {
                'ts': 404913600,
                'time': '1982-10-31T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          32:
              {
                'ts': 420037200,
                'time': '1983-04-24T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          33:
              {
                'ts': 436363200,
                'time': '1983-10-30T12:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          34:
              {
                'ts': 439030800,
                'time': '1983-11-30T09:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          35:
              {
                'ts': 452084400,
                'time': '1984-04-29T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          36:
              {
                'ts': 467805600,
                'time': '1984-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          37:
              {
                'ts': 483534000,
                'time': '1985-04-28T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          38:
              {
                'ts': 499255200,
                'time': '1985-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          39:
              {
                'ts': 514983600,
                'time': '1986-04-27T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          40:
              {
                'ts': 530704800,
                'time': '1986-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          41:
              {
                'ts': 544618800,
                'time': '1987-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          42:
              {
                'ts': 562154400,
                'time': '1987-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          43:
              {
                'ts': 576068400,
                'time': '1988-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          44:
              {
                'ts': 594208800,
                'time': '1988-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          45:
              {
                'ts': 607518000,
                'time': '1989-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          46:
              {
                'ts': 625658400,
                'time': '1989-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          47:
              {
                'ts': 638967600,
                'time': '1990-04-01T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          48:
              {
                'ts': 657108000,
                'time': '1990-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          49:
              {
                'ts': 671022000,
                'time': '1991-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          50:
              {
                'ts': 688557600,
                'time': '1991-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          51:
              {
                'ts': 702471600,
                'time': '1992-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          52:
              {
                'ts': 720007200,
                'time': '1992-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          53:
              {
                'ts': 733921200,
                'time': '1993-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          54:
              {
                'ts': 752061600,
                'time': '1993-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          55:
              {
                'ts': 765370800,
                'time': '1994-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          56:
              {
                'ts': 783511200,
                'time': '1994-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          57:
              {
                'ts': 796820400,
                'time': '1995-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          58:
              {
                'ts': 814960800,
                'time': '1995-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          59:
              {
                'ts': 828874800,
                'time': '1996-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          60:
              {
                'ts': 846410400,
                'time': '1996-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          61:
              {
                'ts': 860324400,
                'time': '1997-04-06T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          62:
              {
                'ts': 877860000,
                'time': '1997-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          63:
              {
                'ts': 891774000,
                'time': '1998-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          64:
              {
                'ts': 909309600,
                'time': '1998-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          65:
              {
                'ts': 923223600,
                'time': '1999-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          66:
              {
                'ts': 941364000,
                'time': '1999-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          67:
              {
                'ts': 954673200,
                'time': '2000-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          68:
              {
                'ts': 972813600,
                'time': '2000-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          69:
              {
                'ts': 986122800,
                'time': '2001-04-01T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          70:
              {
                'ts': 1004263200,
                'time': '2001-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          71:
              {
                'ts': 1018177200,
                'time': '2002-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          72:
              {
                'ts': 1035712800,
                'time': '2002-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          73:
              {
                'ts': 1049626800,
                'time': '2003-04-06T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          74:
              {
                'ts': 1067162400,
                'time': '2003-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          75:
              {
                'ts': 1081076400,
                'time': '2004-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          76:
              {
                'ts': 1099216800,
                'time': '2004-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          77:
              {
                'ts': 1112526000,
                'time': '2005-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          78:
              {
                'ts': 1130666400,
                'time': '2005-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          79:
              {
                'ts': 1143975600,
                'time': '2006-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          80:
              {
                'ts': 1162116000,
                'time': '2006-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          81:
              {
                'ts': 1173610800,
                'time': '2007-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          82:
              {
                'ts': 1194170400,
                'time': '2007-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          83:
              {
                'ts': 1205060400,
                'time': '2008-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          84:
              {
                'ts': 1225620000,
                'time': '2008-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          85:
              {
                'ts': 1236510000,
                'time': '2009-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          86:
              {
                'ts': 1257069600,
                'time': '2009-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          87:
              {
                'ts': 1268564400,
                'time': '2010-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          88:
              {
                'ts': 1289124000,
                'time': '2010-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          89:
              {
                'ts': 1300014000,
                'time': '2011-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          90:
              {
                'ts': 1320573600,
                'time': '2011-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          91:
              {
                'ts': 1331463600,
                'time': '2012-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          92:
              {
                'ts': 1352023200,
                'time': '2012-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          93:
              {
                'ts': 1362913200,
                'time': '2013-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          94:
              {
                'ts': 1383472800,
                'time': '2013-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          95:
              {
                'ts': 1394362800,
                'time': '2014-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          96:
              {
                'ts': 1414922400,
                'time': '2014-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          97:
              {
                'ts': 1425812400,
                'time': '2015-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          98:
              {
                'ts': 1446372000,
                'time': '2015-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          99:
              {
                'ts': 1457866800,
                'time': '2016-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          100:
              {
                'ts': 1478426400,
                'time': '2016-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          101:
              {
                'ts': 1489316400,
                'time': '2017-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          102:
              {
                'ts': 1509876000,
                'time': '2017-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          103:
              {
                'ts': 1520766000,
                'time': '2018-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          104:
              {
                'ts': 1541325600,
                'time': '2018-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          105:
              {
                'ts': 1552215600,
                'time': '2019-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          106:
              {
                'ts': 1572775200,
                'time': '2019-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          107:
              {
                'ts': 1583665200,
                'time': '2020-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          108:
              {
                'ts': 1604224800,
                'time': '2020-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          109:
              {
                'ts': 1615719600,
                'time': '2021-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          110:
              {
                'ts': 1636279200,
                'time': '2021-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          111:
              {
                'ts': 1647169200,
                'time': '2022-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          112:
              {
                'ts': 1667728800,
                'time': '2022-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          113:
              {
                'ts': 1678618800,
                'time': '2023-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          114:
              {
                'ts': 1699178400,
                'time': '2023-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          115:
              {
                'ts': 1710068400,
                'time': '2024-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          116:
              {
                'ts': 1730628000,
                'time': '2024-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          117:
              {
                'ts': 1741518000,
                'time': '2025-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          118:
              {
                'ts': 1762077600,
                'time': '2025-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          119:
              {
                'ts': 1772967600,
                'time': '2026-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          120:
              {
                'ts': 1793527200,
                'time': '2026-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          121:
              {
                'ts': 1805022000,
                'time': '2027-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          122:
              {
                'ts': 1825581600,
                'time': '2027-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          123:
              {
                'ts': 1836471600,
                'time': '2028-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          124:
              {
                'ts': 1857031200,
                'time': '2028-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          125:
              {
                'ts': 1867921200,
                'time': '2029-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          126:
              {
                'ts': 1888480800,
                'time': '2029-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          127:
              {
                'ts': 1899370800,
                'time': '2030-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          128:
              {
                'ts': 1919930400,
                'time': '2030-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          129:
              {
                'ts': 1930820400,
                'time': '2031-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          130:
              {
                'ts': 1951380000,
                'time': '2031-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          131:
              {
                'ts': 1962874800,
                'time': '2032-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          132:
              {
                'ts': 1983434400,
                'time': '2032-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          133:
              {
                'ts': 1994324400,
                'time': '2033-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          134:
              {
                'ts': 2014884000,
                'time': '2033-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          135:
              {
                'ts': 2025774000,
                'time': '2034-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          136:
              {
                'ts': 2046333600,
                'time': '2034-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          137:
              {
                'ts': 2057223600,
                'time': '2035-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          138:
              {
                'ts': 2077783200,
                'time': '2035-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          139:
              {
                'ts': 2088673200,
                'time': '2036-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          140:
              {
                'ts': 2109232800,
                'time': '2036-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          141:
              {
                'ts': 2120122800,
                'time': '2037-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          142:
              {
                'ts': 2140682400,
                'time': '2037-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              }
        },
    'America/Noronha':
        {
          0:
              {
                'ts': -1767217820,
                'time': '1914-01-01T02:09:40+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          1:
              {
                'ts': -1206961200,
                'time': '1931-10-03T13:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          2:
              {
                'ts': -1191366000,
                'time': '1932-04-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          3:
              {
                'ts': -1175378400,
                'time': '1932-10-03T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          4:
              {
                'ts': -1159830000,
                'time': '1933-04-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          5:
              {
                'ts': -633823200,
                'time': '1949-12-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          6:
              {
                'ts': -622072800,
                'time': '1950-04-16T02:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          7:
              {
                'ts': -602287200,
                'time': '1950-12-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          8:
              {
                'ts': -591836400,
                'time': '1951-04-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          9:
              {
                'ts': -570751200,
                'time': '1951-12-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          10:
              {
                'ts': -560214000,
                'time': '1952-04-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          11:
              {
                'ts': -539128800,
                'time': '1952-12-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          12:
              {
                'ts': -531356400,
                'time': '1953-03-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          13:
              {
                'ts': -191368800,
                'time': '1963-12-09T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          14:
              {
                'ts': -184201200,
                'time': '1964-03-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          15:
              {
                'ts': -155167200,
                'time': '1965-01-31T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          16:
              {
                'ts': -150073200,
                'time': '1965-03-31T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          17:
              {
                'ts': -128901600,
                'time': '1965-12-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          18:
              {
                'ts': -121129200,
                'time': '1966-03-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          19:
              {
                'ts': -99957600,
                'time': '1966-11-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          20:
              {
                'ts': -89593200,
                'time': '1967-03-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          21:
              {
                'ts': -68421600,
                'time': '1967-11-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          22:
              {
                'ts': -57970800,
                'time': '1968-03-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          23:
              {
                'ts': 499744800,
                'time': '1985-11-02T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          24:
              {
                'ts': 511232400,
                'time': '1986-03-15T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          25:
              {
                'ts': 530589600,
                'time': '1986-10-25T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          26:
              {
                'ts': 540262800,
                'time': '1987-02-14T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          27:
              {
                'ts': 562125600,
                'time': '1987-10-25T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          28:
              {
                'ts': 571194000,
                'time': '1988-02-07T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          29:
              {
                'ts': 592970400,
                'time': '1988-10-16T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          30:
              {
                'ts': 602038800,
                'time': '1989-01-29T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          31:
              {
                'ts': 624420000,
                'time': '1989-10-15T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          32:
              {
                'ts': 634698000,
                'time': '1990-02-11T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          33:
              {
                'ts': 938916000,
                'time': '1999-10-03T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          34:
              {
                'ts': 951613200,
                'time': '2000-02-27T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          35:
              {
                'ts': 970970400,
                'time': '2000-10-08T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          36:
              {
                'ts': 971571600,
                'time': '2000-10-15T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          37:
              {
                'ts': 1003024800,
                'time': '2001-10-14T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          38:
              {
                'ts': 1013907600,
                'time': '2002-02-17T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              }
        },
    'America/North_Dakota/Center':
        {
          0:
              {
                'ts': -1633273200,
                'time': '1918-03-31T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          1:
              {
                'ts': -1615132800,
                'time': '1918-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          2:
              {
                'ts': -1601823600,
                'time': '1919-03-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          3:
              {
                'ts': -1583683200,
                'time': '1919-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          6:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          7:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          8:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          9:
              {
                'ts': -52930800,
                'time': '1968-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          10:
              {
                'ts': -37209600,
                'time': '1968-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -21481200,
                'time': '1969-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': 9968400,
                'time': '1970-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': 25689600,
                'time': '1970-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': 41418000,
                'time': '1971-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': 57744000,
                'time': '1971-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': 73472400,
                'time': '1972-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': 104922000,
                'time': '1973-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': 126694800,
                'time': '1974-01-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': 162378000,
                'time': '1975-02-23T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          24:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          25:
              {
                'ts': 199270800,
                'time': '1976-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          26:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          27:
              {
                'ts': 230720400,
                'time': '1977-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          28:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          29:
              {
                'ts': 262774800,
                'time': '1978-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          30:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          31:
              {
                'ts': 294224400,
                'time': '1979-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          32:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          33:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          34:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          35:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          36:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          37:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          38:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          39:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          40:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          41:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          42:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          43:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          44:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          45:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          46:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          47:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          48:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          49:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          50:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          51:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          52:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          53:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          54:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          55:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          56:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          57:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          58:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 733910400,
                'time': '1993-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 752050800,
                'time': '1993-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 765360000,
                'time': '1994-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 783500400,
                'time': '1994-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 796809600,
                'time': '1995-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 814950000,
                'time': '1995-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 986112000,
                'time': '2001-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 1004252400,
                'time': '2001-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          89:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          120:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          122:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          124:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          126:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          128:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          130:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          132:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          134:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          136:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          138:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          140:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          141:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          142:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          143:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          144:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          145:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          146:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          147:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          148:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/North_Dakota/New_Salem':
        {
          0:
              {
                'ts': -1633273200,
                'time': '1918-03-31T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          1:
              {
                'ts': -1615132800,
                'time': '1918-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          2:
              {
                'ts': -1601823600,
                'time': '1919-03-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          3:
              {
                'ts': -1583683200,
                'time': '1919-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          6:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          7:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          8:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          9:
              {
                'ts': -52930800,
                'time': '1968-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          10:
              {
                'ts': -37209600,
                'time': '1968-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -21481200,
                'time': '1969-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': 9968400,
                'time': '1970-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': 25689600,
                'time': '1970-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': 41418000,
                'time': '1971-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': 57744000,
                'time': '1971-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': 73472400,
                'time': '1972-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': 104922000,
                'time': '1973-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': 126694800,
                'time': '1974-01-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': 162378000,
                'time': '1975-02-23T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          24:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          25:
              {
                'ts': 199270800,
                'time': '1976-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          26:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          27:
              {
                'ts': 230720400,
                'time': '1977-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          28:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          29:
              {
                'ts': 262774800,
                'time': '1978-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          30:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          31:
              {
                'ts': 294224400,
                'time': '1979-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          32:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          33:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          34:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          35:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          36:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          37:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          38:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          39:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          40:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          41:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          42:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          43:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          44:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          45:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          46:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          47:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          48:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          49:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          50:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          51:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          52:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          53:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          54:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          55:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          56:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          57:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          58:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          59:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          60:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          61:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          62:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          63:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          64:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          65:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          66:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          67:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          68:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          69:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          70:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          71:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          72:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          73:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          74:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          75:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          76:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          77:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          78:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          79:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          80:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          89:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          120:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          122:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          124:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          126:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          128:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          130:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          132:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          134:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          136:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          138:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          140:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          141:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          142:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          143:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          144:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          145:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          146:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          147:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          148:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Panama':
        {
          0:
              {
                'ts': -1946918424,
                'time': '1908-04-22T05:19:36+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Pangnirtung':
        {
          0:
              {
                'ts': -1546300800,
                'time': '1921-01-01T00:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          1:
              {
                'ts': -880221600,
                'time': '1942-02-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AWT'
              },
          2:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'APT'
              },
          3:
              {
                'ts': -765399600,
                'time': '1945-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          4:
              {
                'ts': -147902400,
                'time': '1965-04-25T04:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ADDT'
              },
          5:
              {
                'ts': -131572800,
                'time': '1965-10-31T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          6:
              {
                'ts': 325663200,
                'time': '1980-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          7:
              {
                'ts': 341384400,
                'time': '1980-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          8:
              {
                'ts': 357112800,
                'time': '1981-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          9:
              {
                'ts': 372834000,
                'time': '1981-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          10:
              {
                'ts': 388562400,
                'time': '1982-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          11:
              {
                'ts': 404888400,
                'time': '1982-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          12:
              {
                'ts': 420012000,
                'time': '1983-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          13:
              {
                'ts': 436338000,
                'time': '1983-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          14:
              {
                'ts': 452066400,
                'time': '1984-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          15:
              {
                'ts': 467787600,
                'time': '1984-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          16:
              {
                'ts': 483516000,
                'time': '1985-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          17:
              {
                'ts': 499237200,
                'time': '1985-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          18:
              {
                'ts': 514965600,
                'time': '1986-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          19:
              {
                'ts': 530686800,
                'time': '1986-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          20:
              {
                'ts': 544600800,
                'time': '1987-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          21:
              {
                'ts': 562136400,
                'time': '1987-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          22:
              {
                'ts': 576050400,
                'time': '1988-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          23:
              {
                'ts': 594190800,
                'time': '1988-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          24:
              {
                'ts': 607500000,
                'time': '1989-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          25:
              {
                'ts': 625640400,
                'time': '1989-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          26:
              {
                'ts': 638949600,
                'time': '1990-04-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          27:
              {
                'ts': 657090000,
                'time': '1990-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          28:
              {
                'ts': 671004000,
                'time': '1991-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          29:
              {
                'ts': 688539600,
                'time': '1991-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          30:
              {
                'ts': 702453600,
                'time': '1992-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          31:
              {
                'ts': 719989200,
                'time': '1992-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          32:
              {
                'ts': 733903200,
                'time': '1993-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          33:
              {
                'ts': 752043600,
                'time': '1993-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          34:
              {
                'ts': 765352800,
                'time': '1994-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          35:
              {
                'ts': 783493200,
                'time': '1994-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          36:
              {
                'ts': 796802400,
                'time': '1995-04-02T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          47:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          99:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          101:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          103:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          105:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          107:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          109:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          111:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          113:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          115:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          117:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          119:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          121:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Paramaribo':
        {
          0:
              {
                'ts': -1861906760,
                'time': '1911-01-01T03:40:40+0000',
                'offset': -13252,
                'isdst': false,
                'abbr': 'PMT'
              },
          1:
              {
                'ts': -1104524348,
                'time': '1935-01-01T03:40:52+0000',
                'offset': -13236,
                'isdst': false,
                'abbr': 'PMT'
              },
          2:
              {
                'ts': -765317964,
                'time': '1945-10-01T03:40:36+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NEGT'
              },
          3:
              {
                'ts': 185686200,
                'time': '1975-11-20T03:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'SRT'
              },
          4:
              {
                'ts': 465449400,
                'time': '1984-10-01T03:30:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'SRT'
              }
        },
    'America/Phoenix':
        {
          0:
              {
                'ts': -1633273200,
                'time': '1918-03-31T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          1:
              {
                'ts': -1615132800,
                'time': '1918-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          2:
              {
                'ts': -1601823600,
                'time': '1919-03-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          3:
              {
                'ts': -1583683200,
                'time': '1919-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          5:
              {
                'ts': -820519140,
                'time': '1944-01-01T06:01:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          6:
              {
                'ts': -812653140,
                'time': '1944-04-01T07:01:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          7:
              {
                'ts': -796845540,
                'time': '1944-10-01T06:01:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          8:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          9:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'America/Port-au-Prince':
        {
          0:
              {
                'ts': -1670483460,
                'time': '1917-01-24T16:49:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          1:
              {
                'ts': 421218000,
                'time': '1983-05-08T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          2:
              {
                'ts': 436334400,
                'time': '1983-10-30T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          3:
              {
                'ts': 452062800,
                'time': '1984-04-29T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          4:
              {
                'ts': 467784000,
                'time': '1984-10-28T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          5:
              {
                'ts': 483512400,
                'time': '1985-04-28T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          6:
              {
                'ts': 499233600,
                'time': '1985-10-27T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          7:
              {
                'ts': 514962000,
                'time': '1986-04-27T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          8:
              {
                'ts': 530683200,
                'time': '1986-10-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 546411600,
                'time': '1987-04-26T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          10:
              {
                'ts': 562132800,
                'time': '1987-10-25T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 576050400,
                'time': '1988-04-03T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          12:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 607500000,
                'time': '1989-04-02T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          14:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 638949600,
                'time': '1990-04-01T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          16:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 671004000,
                'time': '1991-04-07T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          18:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 702453600,
                'time': '1992-04-05T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          20:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 733903200,
                'time': '1993-04-04T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          22:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 765352800,
                'time': '1994-04-03T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          24:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 796802400,
                'time': '1995-04-02T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          26:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 828856800,
                'time': '1996-04-07T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          28:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 860306400,
                'time': '1997-04-06T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          30:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 1112504400,
                'time': '2005-04-03T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          32:
              {
                'ts': 1130644800,
                'time': '2005-10-30T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 1143954000,
                'time': '2006-04-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          34:
              {
                'ts': 1162094400,
                'time': '2006-10-29T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Port_of_Spain':
        {
          0:
              {
                'ts': -1825098836,
                'time': '1912-03-02T04:06:04+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Porto_Acre':
        {
          0:
              {
                'ts': -1767209328,
                'time': '1914-01-01T04:31:12+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          1:
              {
                'ts': -1206950400,
                'time': '1931-10-03T16:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          2:
              {
                'ts': -1191355200,
                'time': '1932-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          3:
              {
                'ts': -1175367600,
                'time': '1932-10-03T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          4:
              {
                'ts': -1159819200,
                'time': '1933-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          5:
              {
                'ts': -633812400,
                'time': '1949-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          6:
              {
                'ts': -622062000,
                'time': '1950-04-16T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          7:
              {
                'ts': -602276400,
                'time': '1950-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          8:
              {
                'ts': -591825600,
                'time': '1951-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          9:
              {
                'ts': -570740400,
                'time': '1951-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          10:
              {
                'ts': -560203200,
                'time': '1952-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          11:
              {
                'ts': -539118000,
                'time': '1952-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          12:
              {
                'ts': -531345600,
                'time': '1953-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          13:
              {
                'ts': -191358000,
                'time': '1963-12-09T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          14:
              {
                'ts': -184190400,
                'time': '1964-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          15:
              {
                'ts': -155156400,
                'time': '1965-01-31T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          16:
              {
                'ts': -150062400,
                'time': '1965-03-31T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          17:
              {
                'ts': -128890800,
                'time': '1965-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          18:
              {
                'ts': -121118400,
                'time': '1966-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          19:
              {
                'ts': -99946800,
                'time': '1966-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          20:
              {
                'ts': -89582400,
                'time': '1967-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          21:
              {
                'ts': -68410800,
                'time': '1967-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          22:
              {
                'ts': -57960000,
                'time': '1968-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          23:
              {
                'ts': 499755600,
                'time': '1985-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          24:
              {
                'ts': 511243200,
                'time': '1986-03-15T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          25:
              {
                'ts': 530600400,
                'time': '1986-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          26:
              {
                'ts': 540273600,
                'time': '1987-02-14T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          27:
              {
                'ts': 562136400,
                'time': '1987-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          28:
              {
                'ts': 571204800,
                'time': '1988-02-07T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              }
        },
    'America/Porto_Velho':
        {
          0:
              {
                'ts': -1767210264,
                'time': '1914-01-01T04:15:36+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          1:
              {
                'ts': -1206954000,
                'time': '1931-10-03T15:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          2:
              {
                'ts': -1191358800,
                'time': '1932-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          3:
              {
                'ts': -1175371200,
                'time': '1932-10-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          4:
              {
                'ts': -1159822800,
                'time': '1933-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          5:
              {
                'ts': -633816000,
                'time': '1949-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          6:
              {
                'ts': -622065600,
                'time': '1950-04-16T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          7:
              {
                'ts': -602280000,
                'time': '1950-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          8:
              {
                'ts': -591829200,
                'time': '1951-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          9:
              {
                'ts': -570744000,
                'time': '1951-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          10:
              {
                'ts': -560206800,
                'time': '1952-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          11:
              {
                'ts': -539121600,
                'time': '1952-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          12:
              {
                'ts': -531349200,
                'time': '1953-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          13:
              {
                'ts': -191361600,
                'time': '1963-12-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          14:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          15:
              {
                'ts': -155160000,
                'time': '1965-01-31T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          16:
              {
                'ts': -150066000,
                'time': '1965-03-31T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          17:
              {
                'ts': -128894400,
                'time': '1965-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          18:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          19:
              {
                'ts': -99950400,
                'time': '1966-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          20:
              {
                'ts': -89586000,
                'time': '1967-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          21:
              {
                'ts': -68414400,
                'time': '1967-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          22:
              {
                'ts': -57963600,
                'time': '1968-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          23:
              {
                'ts': 499752000,
                'time': '1985-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          24:
              {
                'ts': 511239600,
                'time': '1986-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          25:
              {
                'ts': 530596800,
                'time': '1986-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          26:
              {
                'ts': 540270000,
                'time': '1987-02-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          27:
              {
                'ts': 562132800,
                'time': '1987-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          28:
              {
                'ts': 571201200,
                'time': '1988-02-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              }
        },
    'America/Puerto_Rico':
        {
          0:
              {
                'ts': -873057600,
                'time': '1942-05-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AWT'
              },
          1:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'APT'
              },
          2:
              {
                'ts': -765399600,
                'time': '1945-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Rainy_River':
        {
          0:
              {
                'ts': -1632067200,
                'time': '1918-04-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1614790800,
                'time': '1918-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -923248800,
                'time': '1940-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          4:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          5:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': 136368000,
                'time': '1974-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': 167817600,
                'time': '1975-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          9:
              {
                'ts': 183538800,
                'time': '1975-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': 199267200,
                'time': '1976-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          11:
              {
                'ts': 215593200,
                'time': '1976-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': 230716800,
                'time': '1977-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          13:
              {
                'ts': 247042800,
                'time': '1977-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          14:
              {
                'ts': 262771200,
                'time': '1978-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          15:
              {
                'ts': 278492400,
                'time': '1978-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          16:
              {
                'ts': 294220800,
                'time': '1979-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          17:
              {
                'ts': 309942000,
                'time': '1979-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          18:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          19:
              {
                'ts': 341391600,
                'time': '1980-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          20:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          21:
              {
                'ts': 372841200,
                'time': '1981-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          22:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          23:
              {
                'ts': 404895600,
                'time': '1982-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          24:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          25:
              {
                'ts': 436345200,
                'time': '1983-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          26:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          27:
              {
                'ts': 467794800,
                'time': '1984-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          28:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          29:
              {
                'ts': 499244400,
                'time': '1985-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          30:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          31:
              {
                'ts': 530694000,
                'time': '1986-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          32:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          33:
              {
                'ts': 562143600,
                'time': '1987-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          34:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          35:
              {
                'ts': 594198000,
                'time': '1988-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          36:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          37:
              {
                'ts': 625647600,
                'time': '1989-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          39:
              {
                'ts': 657097200,
                'time': '1990-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          40:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          41:
              {
                'ts': 688546800,
                'time': '1991-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          42:
              {
                'ts': 702460800,
                'time': '1992-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          43:
              {
                'ts': 719996400,
                'time': '1992-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          44:
              {
                'ts': 733910400,
                'time': '1993-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          45:
              {
                'ts': 752050800,
                'time': '1993-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': 765360000,
                'time': '1994-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          47:
              {
                'ts': 783500400,
                'time': '1994-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          48:
              {
                'ts': 796809600,
                'time': '1995-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          49:
              {
                'ts': 814950000,
                'time': '1995-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          50:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          51:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          52:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          53:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          54:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          55:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          56:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          57:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          58:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          59:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          60:
              {
                'ts': 986112000,
                'time': '2001-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          61:
              {
                'ts': 1004252400,
                'time': '2001-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          62:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          63:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          64:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          65:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          66:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          67:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          68:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          69:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          70:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          71:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          72:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          73:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          74:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          75:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          76:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          77:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          78:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          79:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          80:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          81:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          82:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          83:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          84:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          85:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          86:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          87:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          88:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          89:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          90:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          91:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          92:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          93:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          94:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          95:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          96:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          97:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          98:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          99:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          100:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          101:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          102:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          103:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          104:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          105:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          106:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          107:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          108:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          109:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          110:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          111:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          112:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          113:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          114:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          115:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          116:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          117:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          118:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          119:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          120:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          121:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          122:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          123:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          124:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          125:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          126:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          127:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          128:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          129:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          130:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          131:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          132:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          133:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Rankin_Inlet':
        {
          0:
              {
                'ts': -410227200,
                'time': '1957-01-01T00:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -147895200,
                'time': '1965-04-25T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDDT'
              },
          2:
              {
                'ts': -131565600,
                'time': '1965-10-31T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': 341391600,
                'time': '1980-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': 372841200,
                'time': '1981-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': 404895600,
                'time': '1982-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': 436345200,
                'time': '1983-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': 467794800,
                'time': '1984-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': 499244400,
                'time': '1985-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': 530694000,
                'time': '1986-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': 562143600,
                'time': '1987-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': 594198000,
                'time': '1988-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': 625647600,
                'time': '1989-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': 657097200,
                'time': '1990-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': 688546800,
                'time': '1991-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 702460800,
                'time': '1992-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': 719996400,
                'time': '1992-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 733910400,
                'time': '1993-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': 752050800,
                'time': '1993-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 765360000,
                'time': '1994-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': 783500400,
                'time': '1994-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 796809600,
                'time': '1995-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': 814950000,
                'time': '1995-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          38:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 986112000,
                'time': '2001-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 1004252400,
                'time': '2001-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          89:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Recife':
        {
          0:
              {
                'ts': -1767217224,
                'time': '1914-01-01T02:19:36+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          1:
              {
                'ts': -1206957600,
                'time': '1931-10-03T14:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          2:
              {
                'ts': -1191362400,
                'time': '1932-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          3:
              {
                'ts': -1175374800,
                'time': '1932-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          4:
              {
                'ts': -1159826400,
                'time': '1933-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          5:
              {
                'ts': -633819600,
                'time': '1949-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          6:
              {
                'ts': -622069200,
                'time': '1950-04-16T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          7:
              {
                'ts': -602283600,
                'time': '1950-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          8:
              {
                'ts': -591832800,
                'time': '1951-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          9:
              {
                'ts': -570747600,
                'time': '1951-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          10:
              {
                'ts': -560210400,
                'time': '1952-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          11:
              {
                'ts': -539125200,
                'time': '1952-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          12:
              {
                'ts': -531352800,
                'time': '1953-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          13:
              {
                'ts': -191365200,
                'time': '1963-12-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          14:
              {
                'ts': -184197600,
                'time': '1964-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          15:
              {
                'ts': -155163600,
                'time': '1965-01-31T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          16:
              {
                'ts': -150069600,
                'time': '1965-03-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          17:
              {
                'ts': -128898000,
                'time': '1965-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          18:
              {
                'ts': -121125600,
                'time': '1966-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          19:
              {
                'ts': -99954000,
                'time': '1966-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          20:
              {
                'ts': -89589600,
                'time': '1967-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          21:
              {
                'ts': -68418000,
                'time': '1967-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          22:
              {
                'ts': -57967200,
                'time': '1968-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          23:
              {
                'ts': 499748400,
                'time': '1985-11-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          24:
              {
                'ts': 511236000,
                'time': '1986-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          25:
              {
                'ts': 530593200,
                'time': '1986-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          26:
              {
                'ts': 540266400,
                'time': '1987-02-14T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          27:
              {
                'ts': 562129200,
                'time': '1987-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          28:
              {
                'ts': 571197600,
                'time': '1988-02-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          29:
              {
                'ts': 592974000,
                'time': '1988-10-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          30:
              {
                'ts': 602042400,
                'time': '1989-01-29T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          31:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          32:
              {
                'ts': 634701600,
                'time': '1990-02-11T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          33:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          34:
              {
                'ts': 951616800,
                'time': '2000-02-27T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          35:
              {
                'ts': 970974000,
                'time': '2000-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          36:
              {
                'ts': 971575200,
                'time': '2000-10-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          37:
              {
                'ts': 1003028400,
                'time': '2001-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          38:
              {
                'ts': 1013911200,
                'time': '2002-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              }
        },
    'America/Regina':
        {
          0:
              {
                'ts': -2030202084,
                'time': '1905-09-01T06:58:36+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1632063600,
                'time': '1918-04-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          2:
              {
                'ts': -1614787200,
                'time': '1918-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1251651600,
                'time': '1930-05-04T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          4:
              {
                'ts': -1238349600,
                'time': '1930-10-05T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1220202000,
                'time': '1931-05-03T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          6:
              {
                'ts': -1206900000,
                'time': '1931-10-04T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          7:
              {
                'ts': -1188752400,
                'time': '1932-05-01T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          8:
              {
                'ts': -1175450400,
                'time': '1932-10-02T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          9:
              {
                'ts': -1156698000,
                'time': '1933-05-07T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          10:
              {
                'ts': -1144000800,
                'time': '1933-10-01T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -1125248400,
                'time': '1934-05-06T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -1111946400,
                'time': '1934-10-07T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': -1032714000,
                'time': '1937-04-11T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': -1016992800,
                'time': '1937-10-10T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': -1001264400,
                'time': '1938-04-10T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': -986148000,
                'time': '1938-10-02T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': -969814800,
                'time': '1939-04-09T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': -954093600,
                'time': '1939-10-08T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': -937760400,
                'time': '1940-04-14T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': -922039200,
                'time': '1940-10-13T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': -906310800,
                'time': '1941-04-13T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': -890589600,
                'time': '1941-10-12T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          24:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          25:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          26:
              {
                'ts': -748450800,
                'time': '1946-04-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          27:
              {
                'ts': -732729600,
                'time': '1946-10-13T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          28:
              {
                'ts': -715791600,
                'time': '1947-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          29:
              {
                'ts': -702489600,
                'time': '1947-09-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          30:
              {
                'ts': -684342000,
                'time': '1948-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          31:
              {
                'ts': -671040000,
                'time': '1948-09-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          32:
              {
                'ts': -652892400,
                'time': '1949-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          33:
              {
                'ts': -639590400,
                'time': '1949-09-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          34:
              {
                'ts': -620838000,
                'time': '1950-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          35:
              {
                'ts': -608140800,
                'time': '1950-09-24T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          36:
              {
                'ts': -589388400,
                'time': '1951-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          37:
              {
                'ts': -576086400,
                'time': '1951-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          38:
              {
                'ts': -557938800,
                'time': '1952-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          39:
              {
                'ts': -544636800,
                'time': '1952-09-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          40:
              {
                'ts': -526489200,
                'time': '1953-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          41:
              {
                'ts': -513187200,
                'time': '1953-09-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          42:
              {
                'ts': -495039600,
                'time': '1954-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          43:
              {
                'ts': -481737600,
                'time': '1954-09-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          44:
              {
                'ts': -463590000,
                'time': '1955-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          45:
              {
                'ts': -450288000,
                'time': '1955-09-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          46:
              {
                'ts': -431535600,
                'time': '1956-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          47:
              {
                'ts': -418233600,
                'time': '1956-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          48:
              {
                'ts': -400086000,
                'time': '1957-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          49:
              {
                'ts': -386784000,
                'time': '1957-09-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          50:
              {
                'ts': -337186800,
                'time': '1959-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          51:
              {
                'ts': -321465600,
                'time': '1959-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          52:
              {
                'ts': -305737200,
                'time': '1960-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Resolute':
        {
          0:
              {
                'ts': -704937600,
                'time': '1947-08-31T00:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -147895200,
                'time': '1965-04-25T06:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDDT'
              },
          2:
              {
                'ts': -131565600,
                'time': '1965-10-31T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': 341391600,
                'time': '1980-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': 372841200,
                'time': '1981-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': 404895600,
                'time': '1982-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': 436345200,
                'time': '1983-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': 467794800,
                'time': '1984-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': 499244400,
                'time': '1985-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': 530694000,
                'time': '1986-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': 562143600,
                'time': '1987-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': 594198000,
                'time': '1988-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': 625647600,
                'time': '1989-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': 657097200,
                'time': '1990-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': 688546800,
                'time': '1991-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 702460800,
                'time': '1992-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': 719996400,
                'time': '1992-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 733910400,
                'time': '1993-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': 752050800,
                'time': '1993-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 765360000,
                'time': '1994-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': 783500400,
                'time': '1994-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 796809600,
                'time': '1995-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': 814950000,
                'time': '1995-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          38:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 986112000,
                'time': '2001-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 1004252400,
                'time': '2001-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Rio_Branco':
        {
          0:
              {
                'ts': -1767209328,
                'time': '1914-01-01T04:31:12+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          1:
              {
                'ts': -1206950400,
                'time': '1931-10-03T16:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          2:
              {
                'ts': -1191355200,
                'time': '1932-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          3:
              {
                'ts': -1175367600,
                'time': '1932-10-03T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          4:
              {
                'ts': -1159819200,
                'time': '1933-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          5:
              {
                'ts': -633812400,
                'time': '1949-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          6:
              {
                'ts': -622062000,
                'time': '1950-04-16T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          7:
              {
                'ts': -602276400,
                'time': '1950-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          8:
              {
                'ts': -591825600,
                'time': '1951-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          9:
              {
                'ts': -570740400,
                'time': '1951-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          10:
              {
                'ts': -560203200,
                'time': '1952-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          11:
              {
                'ts': -539118000,
                'time': '1952-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          12:
              {
                'ts': -531345600,
                'time': '1953-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          13:
              {
                'ts': -191358000,
                'time': '1963-12-09T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          14:
              {
                'ts': -184190400,
                'time': '1964-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          15:
              {
                'ts': -155156400,
                'time': '1965-01-31T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          16:
              {
                'ts': -150062400,
                'time': '1965-03-31T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          17:
              {
                'ts': -128890800,
                'time': '1965-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          18:
              {
                'ts': -121118400,
                'time': '1966-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          19:
              {
                'ts': -99946800,
                'time': '1966-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          20:
              {
                'ts': -89582400,
                'time': '1967-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          21:
              {
                'ts': -68410800,
                'time': '1967-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          22:
              {
                'ts': -57960000,
                'time': '1968-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          23:
              {
                'ts': 499755600,
                'time': '1985-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          24:
              {
                'ts': 511243200,
                'time': '1986-03-15T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          25:
              {
                'ts': 530600400,
                'time': '1986-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          26:
              {
                'ts': 540273600,
                'time': '1987-02-14T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          27:
              {
                'ts': 562136400,
                'time': '1987-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          28:
              {
                'ts': 571204800,
                'time': '1988-02-07T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              }
        },
    'America/Rosario':
        {
          0:
              {
                'ts': -1567453392,
                'time': '1920-05-01T04:16:48+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          1:
              {
                'ts': -1233432000,
                'time': '1930-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          2:
              {
                'ts': -1222981200,
                'time': '1931-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          3:
              {
                'ts': -1205956800,
                'time': '1931-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          4:
              {
                'ts': -1194037200,
                'time': '1932-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          5:
              {
                'ts': -1172865600,
                'time': '1932-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          6:
              {
                'ts': -1162501200,
                'time': '1933-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          7:
              {
                'ts': -1141329600,
                'time': '1933-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          8:
              {
                'ts': -1130965200,
                'time': '1934-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          9:
              {
                'ts': -1109793600,
                'time': '1934-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          10:
              {
                'ts': -1099429200,
                'time': '1935-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': -1078257600,
                'time': '1935-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': -1067806800,
                'time': '1936-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': -1046635200,
                'time': '1936-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          14:
              {
                'ts': -1036270800,
                'time': '1937-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          15:
              {
                'ts': -1015099200,
                'time': '1937-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          16:
              {
                'ts': -1004734800,
                'time': '1938-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          17:
              {
                'ts': -983563200,
                'time': '1938-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          18:
              {
                'ts': -973198800,
                'time': '1939-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          19:
              {
                'ts': -952027200,
                'time': '1939-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          20:
              {
                'ts': -941576400,
                'time': '1940-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          21:
              {
                'ts': -931032000,
                'time': '1940-07-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          22:
              {
                'ts': -900882000,
                'time': '1941-06-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          23:
              {
                'ts': -890337600,
                'time': '1941-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          24:
              {
                'ts': -833749200,
                'time': '1943-08-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          25:
              {
                'ts': -827265600,
                'time': '1943-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          26:
              {
                'ts': -752274000,
                'time': '1946-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          27:
              {
                'ts': -733780800,
                'time': '1946-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          28:
              {
                'ts': -197326800,
                'time': '1963-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          29:
              {
                'ts': -190843200,
                'time': '1963-12-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          30:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          31:
              {
                'ts': -164491200,
                'time': '1964-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          32:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          33:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          34:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          35:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          36:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          37:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          38:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          39:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          40:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          41:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          42:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          43:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          44:
              {
                'ts': 596948400,
                'time': '1988-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          45:
              {
                'ts': 605066400,
                'time': '1989-03-05T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          46:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          47:
              {
                'ts': 636516000,
                'time': '1990-03-04T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          48:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          49:
              {
                'ts': 667965600,
                'time': '1991-03-03T02:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'WART'
              },
          50:
              {
                'ts': 687931200,
                'time': '1991-10-20T04:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          51:
              {
                'ts': 699415200,
                'time': '1992-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          52:
              {
                'ts': 719377200,
                'time': '1992-10-18T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          53:
              {
                'ts': 731469600,
                'time': '1993-03-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          54:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          55:
              {
                'ts': 952052400,
                'time': '2000-03-03T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          56:
              {
                'ts': 1198983600,
                'time': '2007-12-30T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          57:
              {
                'ts': 1205632800,
                'time': '2008-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          58:
              {
                'ts': 1223175600,
                'time': '2008-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          59:
              {
                'ts': 1237082400,
                'time': '2009-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          60:
              {
                'ts': 1254625200,
                'time': '2009-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          61:
              {
                'ts': 1269136800,
                'time': '2010-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          62:
              {
                'ts': 1286074800,
                'time': '2010-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          63:
              {
                'ts': 1300586400,
                'time': '2011-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          64:
              {
                'ts': 1317524400,
                'time': '2011-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          65:
              {
                'ts': 1332036000,
                'time': '2012-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          66:
              {
                'ts': 1349578800,
                'time': '2012-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          67:
              {
                'ts': 1363485600,
                'time': '2013-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          68:
              {
                'ts': 1381028400,
                'time': '2013-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          69:
              {
                'ts': 1394935200,
                'time': '2014-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          70:
              {
                'ts': 1412478000,
                'time': '2014-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          71:
              {
                'ts': 1426384800,
                'time': '2015-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          72:
              {
                'ts': 1443927600,
                'time': '2015-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          73:
              {
                'ts': 1458439200,
                'time': '2016-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          74:
              {
                'ts': 1475377200,
                'time': '2016-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          75:
              {
                'ts': 1489888800,
                'time': '2017-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          76:
              {
                'ts': 1506826800,
                'time': '2017-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          77:
              {
                'ts': 1521338400,
                'time': '2018-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          78:
              {
                'ts': 1538881200,
                'time': '2018-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          79:
              {
                'ts': 1552788000,
                'time': '2019-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          80:
              {
                'ts': 1570330800,
                'time': '2019-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          81:
              {
                'ts': 1584237600,
                'time': '2020-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          82:
              {
                'ts': 1601780400,
                'time': '2020-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          83:
              {
                'ts': 1616292000,
                'time': '2021-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          84:
              {
                'ts': 1633230000,
                'time': '2021-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          85:
              {
                'ts': 1647741600,
                'time': '2022-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          86:
              {
                'ts': 1664679600,
                'time': '2022-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          87:
              {
                'ts': 1679191200,
                'time': '2023-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          88:
              {
                'ts': 1696129200,
                'time': '2023-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          89:
              {
                'ts': 1710640800,
                'time': '2024-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          90:
              {
                'ts': 1728183600,
                'time': '2024-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          91:
              {
                'ts': 1742090400,
                'time': '2025-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          92:
              {
                'ts': 1759633200,
                'time': '2025-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          93:
              {
                'ts': 1773540000,
                'time': '2026-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          94:
              {
                'ts': 1791082800,
                'time': '2026-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          95:
              {
                'ts': 1805594400,
                'time': '2027-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          96:
              {
                'ts': 1822532400,
                'time': '2027-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          97:
              {
                'ts': 1837044000,
                'time': '2028-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          98:
              {
                'ts': 1853982000,
                'time': '2028-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          99:
              {
                'ts': 1868493600,
                'time': '2029-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          100:
              {
                'ts': 1886036400,
                'time': '2029-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          101:
              {
                'ts': 1899943200,
                'time': '2030-03-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          102:
              {
                'ts': 1917486000,
                'time': '2030-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          103:
              {
                'ts': 1931392800,
                'time': '2031-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          104:
              {
                'ts': 1948935600,
                'time': '2031-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          105:
              {
                'ts': 1963447200,
                'time': '2032-03-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          106:
              {
                'ts': 1980385200,
                'time': '2032-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          107:
              {
                'ts': 1994896800,
                'time': '2033-03-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          108:
              {
                'ts': 2011834800,
                'time': '2033-10-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          109:
              {
                'ts': 2026346400,
                'time': '2034-03-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          110:
              {
                'ts': 2043284400,
                'time': '2034-10-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          111:
              {
                'ts': 2057796000,
                'time': '2035-03-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          112:
              {
                'ts': 2075338800,
                'time': '2035-10-07T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          113:
              {
                'ts': 2089245600,
                'time': '2036-03-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          114:
              {
                'ts': 2106788400,
                'time': '2036-10-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          115:
              {
                'ts': 2120695200,
                'time': '2037-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          116:
              {
                'ts': 2138238000,
                'time': '2037-10-04T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              }
        },
    'America/Santiago':
        {
          0:
              {
                'ts': -1893439034,
                'time': '1910-01-01T04:42:46+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          1:
              {
                'ts': -1688410800,
                'time': '1916-07-01T05:00:00+0000',
                'offset': -16966,
                'isdst': false,
                'abbr': 'SMT'
              },
          2:
              {
                'ts': -1619983034,
                'time': '1918-09-01T04:42:46+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          3:
              {
                'ts': -1593806400,
                'time': '1919-07-01T04:00:00+0000',
                'offset': -16966,
                'isdst': false,
                'abbr': 'SMT'
              },
          4:
              {
                'ts': -1335986234,
                'time': '1927-09-01T04:42:46+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          5:
              {
                'ts': -1317585600,
                'time': '1928-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          6:
              {
                'ts': -1304362800,
                'time': '1928-09-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          7:
              {
                'ts': -1286049600,
                'time': '1929-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          8:
              {
                'ts': -1272826800,
                'time': '1929-09-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          9:
              {
                'ts': -1254513600,
                'time': '1930-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          10:
              {
                'ts': -1241290800,
                'time': '1930-09-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          11:
              {
                'ts': -1222977600,
                'time': '1931-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          12:
              {
                'ts': -1209754800,
                'time': '1931-09-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          13:
              {
                'ts': -1191355200,
                'time': '1932-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          14:
              {
                'ts': -1178132400,
                'time': '1932-09-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          15:
              {
                'ts': -870552000,
                'time': '1942-06-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          16:
              {
                'ts': -865278000,
                'time': '1942-08-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          17:
              {
                'ts': -736376400,
                'time': '1946-09-01T03:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          18:
              {
                'ts': -713646000,
                'time': '1947-05-22T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          19:
              {
                'ts': -36619200,
                'time': '1968-11-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          20:
              {
                'ts': -23922000,
                'time': '1969-03-30T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          21:
              {
                'ts': -3355200,
                'time': '1969-11-23T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          22:
              {
                'ts': 7527600,
                'time': '1970-03-29T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          23:
              {
                'ts': 24465600,
                'time': '1970-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          24:
              {
                'ts': 37767600,
                'time': '1971-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          25:
              {
                'ts': 55915200,
                'time': '1971-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          26:
              {
                'ts': 69217200,
                'time': '1972-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          27:
              {
                'ts': 87969600,
                'time': '1972-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          28:
              {
                'ts': 100666800,
                'time': '1973-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          29:
              {
                'ts': 118209600,
                'time': '1973-09-30T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          30:
              {
                'ts': 132116400,
                'time': '1974-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          31:
              {
                'ts': 150868800,
                'time': '1974-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          32:
              {
                'ts': 163566000,
                'time': '1975-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          33:
              {
                'ts': 182318400,
                'time': '1975-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          34:
              {
                'ts': 195620400,
                'time': '1976-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          35:
              {
                'ts': 213768000,
                'time': '1976-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          36:
              {
                'ts': 227070000,
                'time': '1977-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          37:
              {
                'ts': 245217600,
                'time': '1977-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          38:
              {
                'ts': 258519600,
                'time': '1978-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          39:
              {
                'ts': 277272000,
                'time': '1978-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          40:
              {
                'ts': 289969200,
                'time': '1979-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          41:
              {
                'ts': 308721600,
                'time': '1979-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          42:
              {
                'ts': 321418800,
                'time': '1980-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          43:
              {
                'ts': 340171200,
                'time': '1980-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          44:
              {
                'ts': 353473200,
                'time': '1981-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          45:
              {
                'ts': 371620800,
                'time': '1981-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          46:
              {
                'ts': 384922800,
                'time': '1982-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          47:
              {
                'ts': 403070400,
                'time': '1982-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          48:
              {
                'ts': 416372400,
                'time': '1983-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          49:
              {
                'ts': 434520000,
                'time': '1983-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          50:
              {
                'ts': 447822000,
                'time': '1984-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          51:
              {
                'ts': 466574400,
                'time': '1984-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          52:
              {
                'ts': 479271600,
                'time': '1985-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          53:
              {
                'ts': 498024000,
                'time': '1985-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          54:
              {
                'ts': 510721200,
                'time': '1986-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          55:
              {
                'ts': 529473600,
                'time': '1986-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          56:
              {
                'ts': 545194800,
                'time': '1987-04-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          57:
              {
                'ts': 560923200,
                'time': '1987-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          58:
              {
                'ts': 574225200,
                'time': '1988-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          59:
              {
                'ts': 591768000,
                'time': '1988-10-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          60:
              {
                'ts': 605674800,
                'time': '1989-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          61:
              {
                'ts': 624427200,
                'time': '1989-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          62:
              {
                'ts': 637729200,
                'time': '1990-03-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          63:
              {
                'ts': 653457600,
                'time': '1990-09-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          64:
              {
                'ts': 668574000,
                'time': '1991-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          65:
              {
                'ts': 687326400,
                'time': '1991-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          66:
              {
                'ts': 700628400,
                'time': '1992-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          67:
              {
                'ts': 718776000,
                'time': '1992-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          68:
              {
                'ts': 732078000,
                'time': '1993-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          69:
              {
                'ts': 750225600,
                'time': '1993-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          70:
              {
                'ts': 763527600,
                'time': '1994-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          71:
              {
                'ts': 781675200,
                'time': '1994-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          72:
              {
                'ts': 794977200,
                'time': '1995-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          73:
              {
                'ts': 813729600,
                'time': '1995-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          74:
              {
                'ts': 826426800,
                'time': '1996-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          75:
              {
                'ts': 845179200,
                'time': '1996-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          76:
              {
                'ts': 859690800,
                'time': '1997-03-30T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          77:
              {
                'ts': 876628800,
                'time': '1997-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          78:
              {
                'ts': 889930800,
                'time': '1998-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          79:
              {
                'ts': 906868800,
                'time': '1998-09-27T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          80:
              {
                'ts': 923194800,
                'time': '1999-04-04T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          81:
              {
                'ts': 939528000,
                'time': '1999-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          82:
              {
                'ts': 952830000,
                'time': '2000-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          83:
              {
                'ts': 971582400,
                'time': '2000-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          84:
              {
                'ts': 984279600,
                'time': '2001-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          85:
              {
                'ts': 1003032000,
                'time': '2001-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          86:
              {
                'ts': 1015729200,
                'time': '2002-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          87:
              {
                'ts': 1034481600,
                'time': '2002-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          88:
              {
                'ts': 1047178800,
                'time': '2003-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          89:
              {
                'ts': 1065931200,
                'time': '2003-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          90:
              {
                'ts': 1079233200,
                'time': '2004-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          91:
              {
                'ts': 1097380800,
                'time': '2004-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          92:
              {
                'ts': 1110682800,
                'time': '2005-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          93:
              {
                'ts': 1128830400,
                'time': '2005-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          94:
              {
                'ts': 1142132400,
                'time': '2006-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          95:
              {
                'ts': 1160884800,
                'time': '2006-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          96:
              {
                'ts': 1173582000,
                'time': '2007-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          97:
              {
                'ts': 1192334400,
                'time': '2007-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          98:
              {
                'ts': 1206846000,
                'time': '2008-03-30T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          99:
              {
                'ts': 1223784000,
                'time': '2008-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          100:
              {
                'ts': 1237086000,
                'time': '2009-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          101:
              {
                'ts': 1255233600,
                'time': '2009-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          102:
              {
                'ts': 1268535600,
                'time': '2010-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          103:
              {
                'ts': 1286683200,
                'time': '2010-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          104:
              {
                'ts': 1299985200,
                'time': '2011-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          105:
              {
                'ts': 1318132800,
                'time': '2011-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          106:
              {
                'ts': 1331434800,
                'time': '2012-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          107:
              {
                'ts': 1350187200,
                'time': '2012-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          108:
              {
                'ts': 1362884400,
                'time': '2013-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          109:
              {
                'ts': 1381636800,
                'time': '2013-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          110:
              {
                'ts': 1394334000,
                'time': '2014-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          111:
              {
                'ts': 1413086400,
                'time': '2014-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          112:
              {
                'ts': 1426388400,
                'time': '2015-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          113:
              {
                'ts': 1444536000,
                'time': '2015-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          114:
              {
                'ts': 1457838000,
                'time': '2016-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          115:
              {
                'ts': 1475985600,
                'time': '2016-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          116:
              {
                'ts': 1489287600,
                'time': '2017-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          117:
              {
                'ts': 1508040000,
                'time': '2017-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          118:
              {
                'ts': 1520737200,
                'time': '2018-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          119:
              {
                'ts': 1539489600,
                'time': '2018-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          120:
              {
                'ts': 1552186800,
                'time': '2019-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          121:
              {
                'ts': 1570939200,
                'time': '2019-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          122:
              {
                'ts': 1584241200,
                'time': '2020-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          123:
              {
                'ts': 1602388800,
                'time': '2020-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          124:
              {
                'ts': 1615690800,
                'time': '2021-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          125:
              {
                'ts': 1633838400,
                'time': '2021-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          126:
              {
                'ts': 1647140400,
                'time': '2022-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          127:
              {
                'ts': 1665288000,
                'time': '2022-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          128:
              {
                'ts': 1678590000,
                'time': '2023-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          129:
              {
                'ts': 1697342400,
                'time': '2023-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          130:
              {
                'ts': 1710039600,
                'time': '2024-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          131:
              {
                'ts': 1728792000,
                'time': '2024-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          132:
              {
                'ts': 1741489200,
                'time': '2025-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          133:
              {
                'ts': 1760241600,
                'time': '2025-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          134:
              {
                'ts': 1773543600,
                'time': '2026-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          135:
              {
                'ts': 1791691200,
                'time': '2026-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          136:
              {
                'ts': 1804993200,
                'time': '2027-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          137:
              {
                'ts': 1823140800,
                'time': '2027-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          138:
              {
                'ts': 1836442800,
                'time': '2028-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          139:
              {
                'ts': 1855195200,
                'time': '2028-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          140:
              {
                'ts': 1867892400,
                'time': '2029-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          141:
              {
                'ts': 1886644800,
                'time': '2029-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          142:
              {
                'ts': 1899342000,
                'time': '2030-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          143:
              {
                'ts': 1918094400,
                'time': '2030-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          144:
              {
                'ts': 1930791600,
                'time': '2031-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          145:
              {
                'ts': 1949544000,
                'time': '2031-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          146:
              {
                'ts': 1962846000,
                'time': '2032-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          147:
              {
                'ts': 1980993600,
                'time': '2032-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          148:
              {
                'ts': 1994295600,
                'time': '2033-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          149:
              {
                'ts': 2012443200,
                'time': '2033-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          150:
              {
                'ts': 2025745200,
                'time': '2034-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          151:
              {
                'ts': 2044497600,
                'time': '2034-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          152:
              {
                'ts': 2057194800,
                'time': '2035-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          153:
              {
                'ts': 2075947200,
                'time': '2035-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          154:
              {
                'ts': 2088644400,
                'time': '2036-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          155:
              {
                'ts': 2107396800,
                'time': '2036-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          156:
              {
                'ts': 2120698800,
                'time': '2037-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          157:
              {
                'ts': 2138846400,
                'time': '2037-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              }
        },
    'America/Santo_Domingo':
        {
          0:
              {
                'ts': -1159773600,
                'time': '1933-04-01T16:40:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -100119600,
                'time': '1966-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          2:
              {
                'ts': -89668800,
                'time': '1967-02-28T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -5770800,
                'time': '1969-10-26T05:00:00+0000',
                'offset': -16200,
                'isdst': true,
                'abbr': 'EHDT'
              },
          4:
              {
                'ts': 4422600,
                'time': '1970-02-21T04:30:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          5:
              {
                'ts': 25678800,
                'time': '1970-10-25T05:00:00+0000',
                'offset': -16200,
                'isdst': true,
                'abbr': 'EHDT'
              },
          6:
              {
                'ts': 33193800,
                'time': '1971-01-20T04:30:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          7:
              {
                'ts': 57733200,
                'time': '1971-10-31T05:00:00+0000',
                'offset': -16200,
                'isdst': true,
                'abbr': 'EHDT'
              },
          8:
              {
                'ts': 64816200,
                'time': '1972-01-21T04:30:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 89182800,
                'time': '1972-10-29T05:00:00+0000',
                'offset': -16200,
                'isdst': true,
                'abbr': 'EHDT'
              },
          10:
              {
                'ts': 96438600,
                'time': '1973-01-21T04:30:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 120632400,
                'time': '1973-10-28T05:00:00+0000',
                'offset': -16200,
                'isdst': true,
                'abbr': 'EHDT'
              },
          12:
              {
                'ts': 127974600,
                'time': '1974-01-21T04:30:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 152082000,
                'time': '1974-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          14:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 975823200,
                'time': '2000-12-03T06:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Sao_Paulo':
        {
          0:
              {
                'ts': -1767214412,
                'time': '1914-01-01T03:06:28+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          1:
              {
                'ts': -1206957600,
                'time': '1931-10-03T14:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          2:
              {
                'ts': -1191362400,
                'time': '1932-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          3:
              {
                'ts': -1175374800,
                'time': '1932-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          4:
              {
                'ts': -1159826400,
                'time': '1933-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          5:
              {
                'ts': -633819600,
                'time': '1949-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          6:
              {
                'ts': -622069200,
                'time': '1950-04-16T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          7:
              {
                'ts': -602283600,
                'time': '1950-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          8:
              {
                'ts': -591832800,
                'time': '1951-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          9:
              {
                'ts': -570747600,
                'time': '1951-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          10:
              {
                'ts': -560210400,
                'time': '1952-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          11:
              {
                'ts': -539125200,
                'time': '1952-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          12:
              {
                'ts': -531352800,
                'time': '1953-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          13:
              {
                'ts': -195426000,
                'time': '1963-10-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          14:
              {
                'ts': -184197600,
                'time': '1964-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          15:
              {
                'ts': -155163600,
                'time': '1965-01-31T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          16:
              {
                'ts': -150069600,
                'time': '1965-03-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          17:
              {
                'ts': -128898000,
                'time': '1965-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          18:
              {
                'ts': -121125600,
                'time': '1966-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          19:
              {
                'ts': -99954000,
                'time': '1966-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          20:
              {
                'ts': -89589600,
                'time': '1967-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          21:
              {
                'ts': -68418000,
                'time': '1967-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          22:
              {
                'ts': -57967200,
                'time': '1968-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          23:
              {
                'ts': 499748400,
                'time': '1985-11-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          24:
              {
                'ts': 511236000,
                'time': '1986-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          25:
              {
                'ts': 530593200,
                'time': '1986-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          26:
              {
                'ts': 540266400,
                'time': '1987-02-14T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          27:
              {
                'ts': 562129200,
                'time': '1987-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          28:
              {
                'ts': 571197600,
                'time': '1988-02-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          29:
              {
                'ts': 592974000,
                'time': '1988-10-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          30:
              {
                'ts': 602042400,
                'time': '1989-01-29T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          31:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          32:
              {
                'ts': 634701600,
                'time': '1990-02-11T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          33:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          34:
              {
                'ts': 666756000,
                'time': '1991-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          35:
              {
                'ts': 687927600,
                'time': '1991-10-20T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          36:
              {
                'ts': 697600800,
                'time': '1992-02-09T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          37:
              {
                'ts': 719982000,
                'time': '1992-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          38:
              {
                'ts': 728445600,
                'time': '1993-01-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          39:
              {
                'ts': 750826800,
                'time': '1993-10-17T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          40:
              {
                'ts': 761709600,
                'time': '1994-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          41:
              {
                'ts': 782276400,
                'time': '1994-10-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          42:
              {
                'ts': 793159200,
                'time': '1995-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          43:
              {
                'ts': 813726000,
                'time': '1995-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          44:
              {
                'ts': 824004000,
                'time': '1996-02-11T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          45:
              {
                'ts': 844570800,
                'time': '1996-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          46:
              {
                'ts': 856058400,
                'time': '1997-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          47:
              {
                'ts': 876106800,
                'time': '1997-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          48:
              {
                'ts': 888717600,
                'time': '1998-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          49:
              {
                'ts': 908074800,
                'time': '1998-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          50:
              {
                'ts': 919562400,
                'time': '1999-02-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          51:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          52:
              {
                'ts': 951616800,
                'time': '2000-02-27T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          53:
              {
                'ts': 970974000,
                'time': '2000-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          54:
              {
                'ts': 982461600,
                'time': '2001-02-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          55:
              {
                'ts': 1003028400,
                'time': '2001-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          56:
              {
                'ts': 1013911200,
                'time': '2002-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          57:
              {
                'ts': 1036292400,
                'time': '2002-11-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          58:
              {
                'ts': 1045360800,
                'time': '2003-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          59:
              {
                'ts': 1066532400,
                'time': '2003-10-19T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          60:
              {
                'ts': 1076810400,
                'time': '2004-02-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          61:
              {
                'ts': 1099364400,
                'time': '2004-11-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          62:
              {
                'ts': 1108864800,
                'time': '2005-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          63:
              {
                'ts': 1129431600,
                'time': '2005-10-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          64:
              {
                'ts': 1140314400,
                'time': '2006-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          65:
              {
                'ts': 1162695600,
                'time': '2006-11-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          66:
              {
                'ts': 1172368800,
                'time': '2007-02-25T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          67:
              {
                'ts': 1192330800,
                'time': '2007-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          68:
              {
                'ts': 1203213600,
                'time': '2008-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          69:
              {
                'ts': 1223780400,
                'time': '2008-10-12T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          70:
              {
                'ts': 1234663200,
                'time': '2009-02-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          71:
              {
                'ts': 1255230000,
                'time': '2009-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          72:
              {
                'ts': 1266717600,
                'time': '2010-02-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          73:
              {
                'ts': 1286679600,
                'time': '2010-10-10T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          74:
              {
                'ts': 1298167200,
                'time': '2011-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          75:
              {
                'ts': 1318129200,
                'time': '2011-10-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          76:
              {
                'ts': 1329616800,
                'time': '2012-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          77:
              {
                'ts': 1350183600,
                'time': '2012-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          78:
              {
                'ts': 1361066400,
                'time': '2013-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          79:
              {
                'ts': 1381633200,
                'time': '2013-10-13T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          80:
              {
                'ts': 1392516000,
                'time': '2014-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          81:
              {
                'ts': 1413082800,
                'time': '2014-10-12T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          82:
              {
                'ts': 1423965600,
                'time': '2015-02-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          83:
              {
                'ts': 1444532400,
                'time': '2015-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          84:
              {
                'ts': 1456020000,
                'time': '2016-02-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          85:
              {
                'ts': 1475982000,
                'time': '2016-10-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          86:
              {
                'ts': 1487469600,
                'time': '2017-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          87:
              {
                'ts': 1507431600,
                'time': '2017-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          88:
              {
                'ts': 1518919200,
                'time': '2018-02-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          89:
              {
                'ts': 1539486000,
                'time': '2018-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          90:
              {
                'ts': 1550368800,
                'time': '2019-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          91:
              {
                'ts': 1570935600,
                'time': '2019-10-13T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          92:
              {
                'ts': 1581818400,
                'time': '2020-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          93:
              {
                'ts': 1602385200,
                'time': '2020-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          94:
              {
                'ts': 1613872800,
                'time': '2021-02-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          95:
              {
                'ts': 1633834800,
                'time': '2021-10-10T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          96:
              {
                'ts': 1645322400,
                'time': '2022-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          97:
              {
                'ts': 1665284400,
                'time': '2022-10-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          98:
              {
                'ts': 1676772000,
                'time': '2023-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          99:
              {
                'ts': 1696734000,
                'time': '2023-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          100:
              {
                'ts': 1708221600,
                'time': '2024-02-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          101:
              {
                'ts': 1728788400,
                'time': '2024-10-13T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          102:
              {
                'ts': 1739671200,
                'time': '2025-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          103:
              {
                'ts': 1760238000,
                'time': '2025-10-12T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          104:
              {
                'ts': 1771120800,
                'time': '2026-02-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          105:
              {
                'ts': 1791687600,
                'time': '2026-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          106:
              {
                'ts': 1803175200,
                'time': '2027-02-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          107:
              {
                'ts': 1823137200,
                'time': '2027-10-10T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          108:
              {
                'ts': 1834624800,
                'time': '2028-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          109:
              {
                'ts': 1854586800,
                'time': '2028-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          110:
              {
                'ts': 1866074400,
                'time': '2029-02-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          111:
              {
                'ts': 1886641200,
                'time': '2029-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          112:
              {
                'ts': 1897524000,
                'time': '2030-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          113:
              {
                'ts': 1918090800,
                'time': '2030-10-13T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          114:
              {
                'ts': 1928973600,
                'time': '2031-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          115:
              {
                'ts': 1949540400,
                'time': '2031-10-12T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          116:
              {
                'ts': 1960423200,
                'time': '2032-02-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          117:
              {
                'ts': 1980990000,
                'time': '2032-10-10T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          118:
              {
                'ts': 1992477600,
                'time': '2033-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          119:
              {
                'ts': 2012439600,
                'time': '2033-10-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          120:
              {
                'ts': 2023927200,
                'time': '2034-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          121:
              {
                'ts': 2043889200,
                'time': '2034-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          122:
              {
                'ts': 2055376800,
                'time': '2035-02-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          123:
              {
                'ts': 2075943600,
                'time': '2035-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          124:
              {
                'ts': 2086826400,
                'time': '2036-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          125:
              {
                'ts': 2107393200,
                'time': '2036-10-12T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          126:
              {
                'ts': 2118276000,
                'time': '2037-02-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          127:
              {
                'ts': 2138842800,
                'time': '2037-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              }
        },
    'America/Scoresbysund':
        {
          0:
              {
                'ts': -1686090728,
                'time': '1916-07-28T01:27:52+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'CGT'
              },
          1:
              {
                'ts': 323841600,
                'time': '1980-04-06T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'CGST'
              },
          2:
              {
                'ts': 338961600,
                'time': '1980-09-28T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'CGT'
              },
          3:
              {
                'ts': 354679200,
                'time': '1981-03-29T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          4:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          5:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          6:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          7:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          8:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          9:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          10:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          11:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          12:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          13:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          14:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          15:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          16:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          17:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          18:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          19:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          20:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          21:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          22:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          23:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          24:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          25:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          26:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          27:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          28:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          29:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          30:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          31:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          32:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          33:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          34:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          35:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          36:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          37:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          38:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          39:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          40:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          41:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          42:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          43:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          44:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          45:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          46:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          47:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          48:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          49:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          50:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          51:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          52:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          53:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          54:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          55:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          56:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          57:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          58:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          59:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          60:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          61:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          62:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          63:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          64:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          65:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          66:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          67:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          68:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          69:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          70:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          71:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          72:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          73:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          74:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          75:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          76:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          77:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          78:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          79:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          80:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          81:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          82:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          83:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          84:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          85:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          86:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          87:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          88:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          89:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          90:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          91:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          92:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          93:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          94:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          95:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          96:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          97:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          98:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          99:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          100:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          101:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          102:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          103:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          104:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          105:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          106:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          107:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          108:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          109:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          110:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          111:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          112:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          113:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          114:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              },
          115:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'EGST'
              },
          116:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'EGT'
              }
        },
    'America/Shiprock':
        {
          0:
              {
                'ts': -1633273200,
                'time': '1918-03-31T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          1:
              {
                'ts': -1615132800,
                'time': '1918-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          2:
              {
                'ts': -1601823600,
                'time': '1919-03-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          3:
              {
                'ts': -1583683200,
                'time': '1919-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': -1570374000,
                'time': '1920-03-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          5:
              {
                'ts': -1551628800,
                'time': '1920-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          6:
              {
                'ts': -1538924400,
                'time': '1921-03-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          7:
              {
                'ts': -1534089600,
                'time': '1921-05-22T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          8:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          9:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          10:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -147884400,
                'time': '1965-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -131558400,
                'time': '1965-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': -116434800,
                'time': '1966-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': -100108800,
                'time': '1966-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': -52930800,
                'time': '1968-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': -37209600,
                'time': '1968-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': -21481200,
                'time': '1969-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': 9968400,
                'time': '1970-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': 25689600,
                'time': '1970-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': 41418000,
                'time': '1971-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          24:
              {
                'ts': 57744000,
                'time': '1971-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          25:
              {
                'ts': 73472400,
                'time': '1972-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          26:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          27:
              {
                'ts': 104922000,
                'time': '1973-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          28:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          29:
              {
                'ts': 126694800,
                'time': '1974-01-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          30:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          31:
              {
                'ts': 162378000,
                'time': '1975-02-23T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          32:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          33:
              {
                'ts': 199270800,
                'time': '1976-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          34:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          35:
              {
                'ts': 230720400,
                'time': '1977-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          36:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          37:
              {
                'ts': 262774800,
                'time': '1978-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          38:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          39:
              {
                'ts': 294224400,
                'time': '1979-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          40:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          41:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          42:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          43:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          44:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          45:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          46:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          47:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          48:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          49:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          50:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          51:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          52:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          53:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          54:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          55:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          56:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          57:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          58:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          59:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          60:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          61:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          62:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          63:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          64:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          65:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          66:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          67:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          68:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          69:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          70:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          71:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          72:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          73:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          74:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          75:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          76:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          77:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          78:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          79:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          80:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          81:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          82:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          83:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          84:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          85:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          86:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          87:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          88:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          89:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          90:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          91:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          92:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          93:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          94:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          95:
              {
                'ts': 1173603600,
                'time': '2007-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          96:
              {
                'ts': 1194163200,
                'time': '2007-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          97:
              {
                'ts': 1205053200,
                'time': '2008-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          98:
              {
                'ts': 1225612800,
                'time': '2008-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          99:
              {
                'ts': 1236502800,
                'time': '2009-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          100:
              {
                'ts': 1257062400,
                'time': '2009-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          101:
              {
                'ts': 1268557200,
                'time': '2010-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          102:
              {
                'ts': 1289116800,
                'time': '2010-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          103:
              {
                'ts': 1300006800,
                'time': '2011-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          104:
              {
                'ts': 1320566400,
                'time': '2011-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          105:
              {
                'ts': 1331456400,
                'time': '2012-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          106:
              {
                'ts': 1352016000,
                'time': '2012-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          107:
              {
                'ts': 1362906000,
                'time': '2013-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          108:
              {
                'ts': 1383465600,
                'time': '2013-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          109:
              {
                'ts': 1394355600,
                'time': '2014-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          110:
              {
                'ts': 1414915200,
                'time': '2014-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          111:
              {
                'ts': 1425805200,
                'time': '2015-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          112:
              {
                'ts': 1446364800,
                'time': '2015-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          113:
              {
                'ts': 1457859600,
                'time': '2016-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          114:
              {
                'ts': 1478419200,
                'time': '2016-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          115:
              {
                'ts': 1489309200,
                'time': '2017-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          116:
              {
                'ts': 1509868800,
                'time': '2017-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          117:
              {
                'ts': 1520758800,
                'time': '2018-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          118:
              {
                'ts': 1541318400,
                'time': '2018-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          119:
              {
                'ts': 1552208400,
                'time': '2019-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          120:
              {
                'ts': 1572768000,
                'time': '2019-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          121:
              {
                'ts': 1583658000,
                'time': '2020-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          122:
              {
                'ts': 1604217600,
                'time': '2020-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          123:
              {
                'ts': 1615712400,
                'time': '2021-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          124:
              {
                'ts': 1636272000,
                'time': '2021-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          125:
              {
                'ts': 1647162000,
                'time': '2022-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          126:
              {
                'ts': 1667721600,
                'time': '2022-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          127:
              {
                'ts': 1678611600,
                'time': '2023-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          128:
              {
                'ts': 1699171200,
                'time': '2023-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          129:
              {
                'ts': 1710061200,
                'time': '2024-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          130:
              {
                'ts': 1730620800,
                'time': '2024-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          131:
              {
                'ts': 1741510800,
                'time': '2025-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          132:
              {
                'ts': 1762070400,
                'time': '2025-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          133:
              {
                'ts': 1772960400,
                'time': '2026-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          134:
              {
                'ts': 1793520000,
                'time': '2026-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          135:
              {
                'ts': 1805014800,
                'time': '2027-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          136:
              {
                'ts': 1825574400,
                'time': '2027-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          137:
              {
                'ts': 1836464400,
                'time': '2028-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          138:
              {
                'ts': 1857024000,
                'time': '2028-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          139:
              {
                'ts': 1867914000,
                'time': '2029-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          140:
              {
                'ts': 1888473600,
                'time': '2029-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          141:
              {
                'ts': 1899363600,
                'time': '2030-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          142:
              {
                'ts': 1919923200,
                'time': '2030-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          143:
              {
                'ts': 1930813200,
                'time': '2031-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          144:
              {
                'ts': 1951372800,
                'time': '2031-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          145:
              {
                'ts': 1962867600,
                'time': '2032-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          146:
              {
                'ts': 1983427200,
                'time': '2032-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          147:
              {
                'ts': 1994317200,
                'time': '2033-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          148:
              {
                'ts': 2014876800,
                'time': '2033-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          149:
              {
                'ts': 2025766800,
                'time': '2034-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          150:
              {
                'ts': 2046326400,
                'time': '2034-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          151:
              {
                'ts': 2057216400,
                'time': '2035-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          152:
              {
                'ts': 2077776000,
                'time': '2035-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          153:
              {
                'ts': 2088666000,
                'time': '2036-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          154:
              {
                'ts': 2109225600,
                'time': '2036-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          155:
              {
                'ts': 2120115600,
                'time': '2037-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          156:
              {
                'ts': 2140675200,
                'time': '2037-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'America/St_Barthelemy':
        {
          0:
              {
                'ts': -1848254032,
                'time': '1911-06-08T04:06:08+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/St_Johns':
        {
          0:
              {
                'ts': -1664130548,
                'time': '1917-04-08T05:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          1:
              {
                'ts': -1650137348,
                'time': '1917-09-17T04:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          2:
              {
                'ts': -1632076148,
                'time': '1918-04-14T05:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          3:
              {
                'ts': -1614799748,
                'time': '1918-10-31T04:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          4:
              {
                'ts': -1598650148,
                'time': '1919-05-06T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          5:
              {
                'ts': -1590100148,
                'time': '1919-08-13T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          6:
              {
                'ts': -1567286948,
                'time': '1920-05-03T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          7:
              {
                'ts': -1551565748,
                'time': '1920-11-01T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          8:
              {
                'ts': -1535837348,
                'time': '1921-05-02T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          9:
              {
                'ts': -1520116148,
                'time': '1921-10-31T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          10:
              {
                'ts': -1503782948,
                'time': '1922-05-08T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          11:
              {
                'ts': -1488666548,
                'time': '1922-10-30T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          12:
              {
                'ts': -1472333348,
                'time': '1923-05-07T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          13:
              {
                'ts': -1457216948,
                'time': '1923-10-29T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          14:
              {
                'ts': -1440883748,
                'time': '1924-05-05T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          15:
              {
                'ts': -1425767348,
                'time': '1924-10-27T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          16:
              {
                'ts': -1409434148,
                'time': '1925-05-04T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          17:
              {
                'ts': -1394317748,
                'time': '1925-10-26T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          18:
              {
                'ts': -1377984548,
                'time': '1926-05-03T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          19:
              {
                'ts': -1362263348,
                'time': '1926-11-01T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          20:
              {
                'ts': -1346534948,
                'time': '1927-05-02T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          21:
              {
                'ts': -1330813748,
                'time': '1927-10-31T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          22:
              {
                'ts': -1314480548,
                'time': '1928-05-07T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          23:
              {
                'ts': -1299364148,
                'time': '1928-10-29T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          24:
              {
                'ts': -1283030948,
                'time': '1929-05-06T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          25:
              {
                'ts': -1267914548,
                'time': '1929-10-28T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          26:
              {
                'ts': -1251581348,
                'time': '1930-05-05T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          27:
              {
                'ts': -1236464948,
                'time': '1930-10-27T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          28:
              {
                'ts': -1220131748,
                'time': '1931-05-04T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          29:
              {
                'ts': -1205015348,
                'time': '1931-10-26T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          30:
              {
                'ts': -1188682148,
                'time': '1932-05-02T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          31:
              {
                'ts': -1172960948,
                'time': '1932-10-31T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          32:
              {
                'ts': -1156627748,
                'time': '1933-05-08T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          33:
              {
                'ts': -1141511348,
                'time': '1933-10-30T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          34:
              {
                'ts': -1125178148,
                'time': '1934-05-07T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          35:
              {
                'ts': -1110061748,
                'time': '1934-10-29T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          36:
              {
                'ts': -1096921748,
                'time': '1935-03-30T03:30:52+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          37:
              {
                'ts': -1093728600,
                'time': '1935-05-06T02:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          38:
              {
                'ts': -1078612200,
                'time': '1935-10-28T01:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          39:
              {
                'ts': -1061670600,
                'time': '1936-05-11T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          40:
              {
                'ts': -1048973400,
                'time': '1936-10-05T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          41:
              {
                'ts': -1030221000,
                'time': '1937-05-10T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          42:
              {
                'ts': -1017523800,
                'time': '1937-10-04T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          43:
              {
                'ts': -998771400,
                'time': '1938-05-09T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          44:
              {
                'ts': -986074200,
                'time': '1938-10-03T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          45:
              {
                'ts': -966717000,
                'time': '1939-05-15T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          46:
              {
                'ts': -954624600,
                'time': '1939-10-02T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          47:
              {
                'ts': -935267400,
                'time': '1940-05-13T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          48:
              {
                'ts': -922570200,
                'time': '1940-10-07T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          49:
              {
                'ts': -903817800,
                'time': '1941-05-12T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          50:
              {
                'ts': -891120600,
                'time': '1941-10-06T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          51:
              {
                'ts': -872368200,
                'time': '1942-05-11T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NWT'
              },
          52:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NPT'
              },
          53:
              {
                'ts': -765401400,
                'time': '1945-09-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          54:
              {
                'ts': -746044200,
                'time': '1946-05-12T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          55:
              {
                'ts': -733347000,
                'time': '1946-10-06T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          56:
              {
                'ts': -714594600,
                'time': '1947-05-11T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          57:
              {
                'ts': -701897400,
                'time': '1947-10-05T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          58:
              {
                'ts': -683145000,
                'time': '1948-05-09T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          59:
              {
                'ts': -670447800,
                'time': '1948-10-03T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          60:
              {
                'ts': -651695400,
                'time': '1949-05-08T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          61:
              {
                'ts': -638998200,
                'time': '1949-10-02T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          62:
              {
                'ts': -619641000,
                'time': '1950-05-14T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          63:
              {
                'ts': -606943800,
                'time': '1950-10-08T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          64:
              {
                'ts': -589401000,
                'time': '1951-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          65:
              {
                'ts': -576099000,
                'time': '1951-09-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          66:
              {
                'ts': -557951400,
                'time': '1952-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          67:
              {
                'ts': -544649400,
                'time': '1952-09-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          68:
              {
                'ts': -526501800,
                'time': '1953-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          69:
              {
                'ts': -513199800,
                'time': '1953-09-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          70:
              {
                'ts': -495052200,
                'time': '1954-04-25T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          71:
              {
                'ts': -481750200,
                'time': '1954-09-26T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          72:
              {
                'ts': -463602600,
                'time': '1955-04-24T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          73:
              {
                'ts': -450300600,
                'time': '1955-09-25T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          74:
              {
                'ts': -431548200,
                'time': '1956-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          75:
              {
                'ts': -418246200,
                'time': '1956-09-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          76:
              {
                'ts': -400098600,
                'time': '1957-04-28T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          77:
              {
                'ts': -386796600,
                'time': '1957-09-29T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          78:
              {
                'ts': -368649000,
                'time': '1958-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          79:
              {
                'ts': -355347000,
                'time': '1958-09-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          80:
              {
                'ts': -337199400,
                'time': '1959-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          81:
              {
                'ts': -323897400,
                'time': '1959-09-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          82:
              {
                'ts': -305749800,
                'time': '1960-04-24T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          83:
              {
                'ts': -289423800,
                'time': '1960-10-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          84:
              {
                'ts': -273695400,
                'time': '1961-04-30T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          85:
              {
                'ts': -257974200,
                'time': '1961-10-29T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          86:
              {
                'ts': -242245800,
                'time': '1962-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          87:
              {
                'ts': -226524600,
                'time': '1962-10-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          88:
              {
                'ts': -210796200,
                'time': '1963-04-28T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          89:
              {
                'ts': -195075000,
                'time': '1963-10-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          90:
              {
                'ts': -179346600,
                'time': '1964-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          91:
              {
                'ts': -163625400,
                'time': '1964-10-25T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          92:
              {
                'ts': -147897000,
                'time': '1965-04-25T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          93:
              {
                'ts': -131571000,
                'time': '1965-10-31T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          94:
              {
                'ts': -116447400,
                'time': '1966-04-24T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          95:
              {
                'ts': -100121400,
                'time': '1966-10-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          96:
              {
                'ts': -84393000,
                'time': '1967-04-30T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          97:
              {
                'ts': -68671800,
                'time': '1967-10-29T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          98:
              {
                'ts': -52943400,
                'time': '1968-04-28T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          99:
              {
                'ts': -37222200,
                'time': '1968-10-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          100:
              {
                'ts': -21493800,
                'time': '1969-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          101:
              {
                'ts': -5772600,
                'time': '1969-10-26T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          102:
              {
                'ts': 9955800,
                'time': '1970-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          103:
              {
                'ts': 25677000,
                'time': '1970-10-25T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          104:
              {
                'ts': 41405400,
                'time': '1971-04-25T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          105:
              {
                'ts': 57731400,
                'time': '1971-10-31T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          106:
              {
                'ts': 73459800,
                'time': '1972-04-30T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          107:
              {
                'ts': 89181000,
                'time': '1972-10-29T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          108:
              {
                'ts': 104909400,
                'time': '1973-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          109:
              {
                'ts': 120630600,
                'time': '1973-10-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          110:
              {
                'ts': 136359000,
                'time': '1974-04-28T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          111:
              {
                'ts': 152080200,
                'time': '1974-10-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          112:
              {
                'ts': 167808600,
                'time': '1975-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          113:
              {
                'ts': 183529800,
                'time': '1975-10-26T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          114:
              {
                'ts': 199258200,
                'time': '1976-04-25T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          115:
              {
                'ts': 215584200,
                'time': '1976-10-31T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          116:
              {
                'ts': 230707800,
                'time': '1977-04-24T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          117:
              {
                'ts': 247033800,
                'time': '1977-10-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          118:
              {
                'ts': 262762200,
                'time': '1978-04-30T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          119:
              {
                'ts': 278483400,
                'time': '1978-10-29T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          120:
              {
                'ts': 294211800,
                'time': '1979-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          121:
              {
                'ts': 309933000,
                'time': '1979-10-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          122:
              {
                'ts': 325661400,
                'time': '1980-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          123:
              {
                'ts': 341382600,
                'time': '1980-10-26T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          124:
              {
                'ts': 357111000,
                'time': '1981-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          125:
              {
                'ts': 372832200,
                'time': '1981-10-25T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          126:
              {
                'ts': 388560600,
                'time': '1982-04-25T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          127:
              {
                'ts': 404886600,
                'time': '1982-10-31T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          128:
              {
                'ts': 420010200,
                'time': '1983-04-24T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          129:
              {
                'ts': 436336200,
                'time': '1983-10-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          130:
              {
                'ts': 452064600,
                'time': '1984-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          131:
              {
                'ts': 467785800,
                'time': '1984-10-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          132:
              {
                'ts': 483514200,
                'time': '1985-04-28T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          133:
              {
                'ts': 499235400,
                'time': '1985-10-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          134:
              {
                'ts': 514963800,
                'time': '1986-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          135:
              {
                'ts': 530685000,
                'time': '1986-10-26T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          136:
              {
                'ts': 544591860,
                'time': '1987-04-05T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          137:
              {
                'ts': 562127460,
                'time': '1987-10-25T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          138:
              {
                'ts': 576041460,
                'time': '1988-04-03T03:31:00+0000',
                'offset': -5400,
                'isdst': true,
                'abbr': 'NDDT'
              },
          139:
              {
                'ts': 594178260,
                'time': '1988-10-30T01:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          140:
              {
                'ts': 607491060,
                'time': '1989-04-02T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          141:
              {
                'ts': 625631460,
                'time': '1989-10-29T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          142:
              {
                'ts': 638940660,
                'time': '1990-04-01T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          143:
              {
                'ts': 657081060,
                'time': '1990-10-28T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          144:
              {
                'ts': 670995060,
                'time': '1991-04-07T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          145:
              {
                'ts': 688530660,
                'time': '1991-10-27T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          146:
              {
                'ts': 702444660,
                'time': '1992-04-05T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          147:
              {
                'ts': 719980260,
                'time': '1992-10-25T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          148:
              {
                'ts': 733894260,
                'time': '1993-04-04T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          149:
              {
                'ts': 752034660,
                'time': '1993-10-31T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          150:
              {
                'ts': 765343860,
                'time': '1994-04-03T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          151:
              {
                'ts': 783484260,
                'time': '1994-10-30T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          152:
              {
                'ts': 796793460,
                'time': '1995-04-02T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          153:
              {
                'ts': 814933860,
                'time': '1995-10-29T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          154:
              {
                'ts': 828847860,
                'time': '1996-04-07T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          155:
              {
                'ts': 846383460,
                'time': '1996-10-27T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          156:
              {
                'ts': 860297460,
                'time': '1997-04-06T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          157:
              {
                'ts': 877833060,
                'time': '1997-10-26T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          158:
              {
                'ts': 891747060,
                'time': '1998-04-05T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          159:
              {
                'ts': 909282660,
                'time': '1998-10-25T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          160:
              {
                'ts': 923196660,
                'time': '1999-04-04T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          161:
              {
                'ts': 941337060,
                'time': '1999-10-31T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          162:
              {
                'ts': 954646260,
                'time': '2000-04-02T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          163:
              {
                'ts': 972786660,
                'time': '2000-10-29T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          164:
              {
                'ts': 986095860,
                'time': '2001-04-01T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          165:
              {
                'ts': 1004236260,
                'time': '2001-10-28T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          166:
              {
                'ts': 1018150260,
                'time': '2002-04-07T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          167:
              {
                'ts': 1035685860,
                'time': '2002-10-27T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          168:
              {
                'ts': 1049599860,
                'time': '2003-04-06T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          169:
              {
                'ts': 1067135460,
                'time': '2003-10-26T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          170:
              {
                'ts': 1081049460,
                'time': '2004-04-04T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          171:
              {
                'ts': 1099189860,
                'time': '2004-10-31T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          172:
              {
                'ts': 1112499060,
                'time': '2005-04-03T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          173:
              {
                'ts': 1130639460,
                'time': '2005-10-30T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          174:
              {
                'ts': 1143948660,
                'time': '2006-04-02T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          175:
              {
                'ts': 1162089060,
                'time': '2006-10-29T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          176:
              {
                'ts': 1173583860,
                'time': '2007-03-11T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          177:
              {
                'ts': 1194143460,
                'time': '2007-11-04T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          178:
              {
                'ts': 1205033460,
                'time': '2008-03-09T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          179:
              {
                'ts': 1225593060,
                'time': '2008-11-02T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          180:
              {
                'ts': 1236483060,
                'time': '2009-03-08T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          181:
              {
                'ts': 1257042660,
                'time': '2009-11-01T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          182:
              {
                'ts': 1268537460,
                'time': '2010-03-14T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          183:
              {
                'ts': 1289097060,
                'time': '2010-11-07T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          184:
              {
                'ts': 1299987060,
                'time': '2011-03-13T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          185:
              {
                'ts': 1320546660,
                'time': '2011-11-06T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          186:
              {
                'ts': 1331436660,
                'time': '2012-03-11T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          187:
              {
                'ts': 1351996260,
                'time': '2012-11-04T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          188:
              {
                'ts': 1362886260,
                'time': '2013-03-10T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          189:
              {
                'ts': 1383445860,
                'time': '2013-11-03T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          190:
              {
                'ts': 1394335860,
                'time': '2014-03-09T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          191:
              {
                'ts': 1414895460,
                'time': '2014-11-02T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          192:
              {
                'ts': 1425785460,
                'time': '2015-03-08T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          193:
              {
                'ts': 1446345060,
                'time': '2015-11-01T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          194:
              {
                'ts': 1457839860,
                'time': '2016-03-13T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          195:
              {
                'ts': 1478399460,
                'time': '2016-11-06T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          196:
              {
                'ts': 1489289460,
                'time': '2017-03-12T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          197:
              {
                'ts': 1509849060,
                'time': '2017-11-05T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          198:
              {
                'ts': 1520739060,
                'time': '2018-03-11T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          199:
              {
                'ts': 1541298660,
                'time': '2018-11-04T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          200:
              {
                'ts': 1552188660,
                'time': '2019-03-10T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          201:
              {
                'ts': 1572748260,
                'time': '2019-11-03T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          202:
              {
                'ts': 1583638260,
                'time': '2020-03-08T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          203:
              {
                'ts': 1604197860,
                'time': '2020-11-01T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          204:
              {
                'ts': 1615692660,
                'time': '2021-03-14T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          205:
              {
                'ts': 1636252260,
                'time': '2021-11-07T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          206:
              {
                'ts': 1647142260,
                'time': '2022-03-13T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          207:
              {
                'ts': 1667701860,
                'time': '2022-11-06T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          208:
              {
                'ts': 1678591860,
                'time': '2023-03-12T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          209:
              {
                'ts': 1699151460,
                'time': '2023-11-05T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          210:
              {
                'ts': 1710041460,
                'time': '2024-03-10T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          211:
              {
                'ts': 1730601060,
                'time': '2024-11-03T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          212:
              {
                'ts': 1741491060,
                'time': '2025-03-09T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          213:
              {
                'ts': 1762050660,
                'time': '2025-11-02T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          214:
              {
                'ts': 1772940660,
                'time': '2026-03-08T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          215:
              {
                'ts': 1793500260,
                'time': '2026-11-01T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          216:
              {
                'ts': 1804995060,
                'time': '2027-03-14T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          217:
              {
                'ts': 1825554660,
                'time': '2027-11-07T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          218:
              {
                'ts': 1836444660,
                'time': '2028-03-12T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          219:
              {
                'ts': 1857004260,
                'time': '2028-11-05T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          220:
              {
                'ts': 1867894260,
                'time': '2029-03-11T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          221:
              {
                'ts': 1888453860,
                'time': '2029-11-04T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          222:
              {
                'ts': 1899343860,
                'time': '2030-03-10T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          223:
              {
                'ts': 1919903460,
                'time': '2030-11-03T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          224:
              {
                'ts': 1930793460,
                'time': '2031-03-09T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          225:
              {
                'ts': 1951353060,
                'time': '2031-11-02T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          226:
              {
                'ts': 1962847860,
                'time': '2032-03-14T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          227:
              {
                'ts': 1983407460,
                'time': '2032-11-07T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          228:
              {
                'ts': 1994297460,
                'time': '2033-03-13T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          229:
              {
                'ts': 2014857060,
                'time': '2033-11-06T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          230:
              {
                'ts': 2025747060,
                'time': '2034-03-12T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          231:
              {
                'ts': 2046306660,
                'time': '2034-11-05T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          232:
              {
                'ts': 2057196660,
                'time': '2035-03-11T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          233:
              {
                'ts': 2077756260,
                'time': '2035-11-04T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          234:
              {
                'ts': 2088646260,
                'time': '2036-03-09T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          235:
              {
                'ts': 2109205860,
                'time': '2036-11-02T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          236:
              {
                'ts': 2120095860,
                'time': '2037-03-08T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          237:
              {
                'ts': 2140655460,
                'time': '2037-11-01T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              }
        },
    'America/St_Kitts':
        {
          0:
              {
                'ts': -1825098548,
                'time': '1912-03-02T04:10:52+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/St_Lucia':
        {
          0:
              {
                'ts': -1830369360,
                'time': '1912-01-01T04:04:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/St_Thomas':
        {
          0:
              {
                'ts': -1846266016,
                'time': '1911-07-01T04:19:44+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/St_Vincent':
        {
          0:
              {
                'ts': -1830369304,
                'time': '1912-01-01T04:04:56+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Swift_Current':
        {
          0:
              {
                'ts': -2030201320,
                'time': '1905-09-01T07:11:20+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1632063600,
                'time': '1918-04-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          2:
              {
                'ts': -1614787200,
                'time': '1918-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          4:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          5:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          6:
              {
                'ts': -747241200,
                'time': '1946-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          7:
              {
                'ts': -732729600,
                'time': '1946-10-13T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          8:
              {
                'ts': -715791600,
                'time': '1947-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          9:
              {
                'ts': -702489600,
                'time': '1947-09-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          10:
              {
                'ts': -684342000,
                'time': '1948-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          11:
              {
                'ts': -671040000,
                'time': '1948-09-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          12:
              {
                'ts': -652892400,
                'time': '1949-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          13:
              {
                'ts': -639590400,
                'time': '1949-09-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          14:
              {
                'ts': -400086000,
                'time': '1957-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          15:
              {
                'ts': -384364800,
                'time': '1957-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          16:
              {
                'ts': -337186800,
                'time': '1959-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          17:
              {
                'ts': -321465600,
                'time': '1959-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          18:
              {
                'ts': -305737200,
                'time': '1960-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          19:
              {
                'ts': -292435200,
                'time': '1960-09-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          20:
              {
                'ts': -273682800,
                'time': '1961-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          21:
              {
                'ts': -260985600,
                'time': '1961-09-24T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          22:
              {
                'ts': 73472400,
                'time': '1972-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Tegucigalpa':
        {
          0:
              {
                'ts': -1538503868,
                'time': '1921-04-01T05:48:52+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': 547020000,
                'time': '1987-05-03T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          2:
              {
                'ts': 559717200,
                'time': '1987-09-27T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': 578469600,
                'time': '1988-05-01T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': 591166800,
                'time': '1988-09-25T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': 1146981600,
                'time': '2006-05-07T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': 1154926800,
                'time': '2006-08-07T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Thule':
        {
          0:
              {
                'ts': -1686079492,
                'time': '1916-07-28T04:35:08+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          1:
              {
                'ts': 670399200,
                'time': '1991-03-31T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          2:
              {
                'ts': 686120400,
                'time': '1991-09-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          3:
              {
                'ts': 701848800,
                'time': '1992-03-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          4:
              {
                'ts': 717570000,
                'time': '1992-09-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          5:
              {
                'ts': 733903200,
                'time': '1993-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          6:
              {
                'ts': 752043600,
                'time': '1993-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          7:
              {
                'ts': 765352800,
                'time': '1994-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          8:
              {
                'ts': 783493200,
                'time': '1994-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          9:
              {
                'ts': 796802400,
                'time': '1995-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          10:
              {
                'ts': 814942800,
                'time': '1995-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          11:
              {
                'ts': 828856800,
                'time': '1996-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          12:
              {
                'ts': 846392400,
                'time': '1996-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          13:
              {
                'ts': 860306400,
                'time': '1997-04-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          14:
              {
                'ts': 877842000,
                'time': '1997-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          15:
              {
                'ts': 891756000,
                'time': '1998-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          16:
              {
                'ts': 909291600,
                'time': '1998-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          17:
              {
                'ts': 923205600,
                'time': '1999-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          18:
              {
                'ts': 941346000,
                'time': '1999-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          19:
              {
                'ts': 954655200,
                'time': '2000-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          20:
              {
                'ts': 972795600,
                'time': '2000-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          21:
              {
                'ts': 986104800,
                'time': '2001-04-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          22:
              {
                'ts': 1004245200,
                'time': '2001-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          23:
              {
                'ts': 1018159200,
                'time': '2002-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          24:
              {
                'ts': 1035694800,
                'time': '2002-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          25:
              {
                'ts': 1049608800,
                'time': '2003-04-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          26:
              {
                'ts': 1067144400,
                'time': '2003-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          27:
              {
                'ts': 1081058400,
                'time': '2004-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          28:
              {
                'ts': 1099198800,
                'time': '2004-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          29:
              {
                'ts': 1112508000,
                'time': '2005-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          30:
              {
                'ts': 1130648400,
                'time': '2005-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          31:
              {
                'ts': 1143957600,
                'time': '2006-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          32:
              {
                'ts': 1162098000,
                'time': '2006-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          33:
              {
                'ts': 1173592800,
                'time': '2007-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          34:
              {
                'ts': 1194152400,
                'time': '2007-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          35:
              {
                'ts': 1205042400,
                'time': '2008-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          36:
              {
                'ts': 1225602000,
                'time': '2008-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          37:
              {
                'ts': 1236492000,
                'time': '2009-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          38:
              {
                'ts': 1257051600,
                'time': '2009-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          39:
              {
                'ts': 1268546400,
                'time': '2010-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          40:
              {
                'ts': 1289106000,
                'time': '2010-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          41:
              {
                'ts': 1299996000,
                'time': '2011-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          42:
              {
                'ts': 1320555600,
                'time': '2011-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          43:
              {
                'ts': 1331445600,
                'time': '2012-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          44:
              {
                'ts': 1352005200,
                'time': '2012-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          45:
              {
                'ts': 1362895200,
                'time': '2013-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          46:
              {
                'ts': 1383454800,
                'time': '2013-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          47:
              {
                'ts': 1394344800,
                'time': '2014-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          48:
              {
                'ts': 1414904400,
                'time': '2014-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          49:
              {
                'ts': 1425794400,
                'time': '2015-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          50:
              {
                'ts': 1446354000,
                'time': '2015-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          51:
              {
                'ts': 1457848800,
                'time': '2016-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          52:
              {
                'ts': 1478408400,
                'time': '2016-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          53:
              {
                'ts': 1489298400,
                'time': '2017-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          54:
              {
                'ts': 1509858000,
                'time': '2017-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          55:
              {
                'ts': 1520748000,
                'time': '2018-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          56:
              {
                'ts': 1541307600,
                'time': '2018-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          57:
              {
                'ts': 1552197600,
                'time': '2019-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          58:
              {
                'ts': 1572757200,
                'time': '2019-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          59:
              {
                'ts': 1583647200,
                'time': '2020-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          60:
              {
                'ts': 1604206800,
                'time': '2020-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          61:
              {
                'ts': 1615701600,
                'time': '2021-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          62:
              {
                'ts': 1636261200,
                'time': '2021-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          63:
              {
                'ts': 1647151200,
                'time': '2022-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          64:
              {
                'ts': 1667710800,
                'time': '2022-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          65:
              {
                'ts': 1678600800,
                'time': '2023-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          66:
              {
                'ts': 1699160400,
                'time': '2023-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          67:
              {
                'ts': 1710050400,
                'time': '2024-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          68:
              {
                'ts': 1730610000,
                'time': '2024-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          69:
              {
                'ts': 1741500000,
                'time': '2025-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          70:
              {
                'ts': 1762059600,
                'time': '2025-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          71:
              {
                'ts': 1772949600,
                'time': '2026-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          72:
              {
                'ts': 1793509200,
                'time': '2026-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          73:
              {
                'ts': 1805004000,
                'time': '2027-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          74:
              {
                'ts': 1825563600,
                'time': '2027-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          75:
              {
                'ts': 1836453600,
                'time': '2028-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          76:
              {
                'ts': 1857013200,
                'time': '2028-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          77:
              {
                'ts': 1867903200,
                'time': '2029-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          78:
              {
                'ts': 1888462800,
                'time': '2029-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          79:
              {
                'ts': 1899352800,
                'time': '2030-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          80:
              {
                'ts': 1919912400,
                'time': '2030-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          81:
              {
                'ts': 1930802400,
                'time': '2031-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          82:
              {
                'ts': 1951362000,
                'time': '2031-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          83:
              {
                'ts': 1962856800,
                'time': '2032-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          84:
              {
                'ts': 1983416400,
                'time': '2032-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          85:
              {
                'ts': 1994306400,
                'time': '2033-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          86:
              {
                'ts': 2014866000,
                'time': '2033-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          87:
              {
                'ts': 2025756000,
                'time': '2034-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          88:
              {
                'ts': 2046315600,
                'time': '2034-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          89:
              {
                'ts': 2057205600,
                'time': '2035-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          90:
              {
                'ts': 2077765200,
                'time': '2035-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          91:
              {
                'ts': 2088655200,
                'time': '2036-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          92:
              {
                'ts': 2109214800,
                'time': '2036-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          93:
              {
                'ts': 2120104800,
                'time': '2037-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          94:
              {
                'ts': 2140664400,
                'time': '2037-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Thunder_Bay':
        {
          0:
              {
                'ts': -1893434400,
                'time': '1910-01-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -880218000,
                'time': '1942-02-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EWT'
              },
          2:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EPT'
              },
          3:
              {
                'ts': -765396000,
                'time': '1945-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          5:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          7:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          9:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 136364400,
                'time': '1974-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          11:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 167814000,
                'time': '1975-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          13:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          15:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          17:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          19:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          21:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          23:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          25:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          27:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          29:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          99:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          101:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          103:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          105:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          107:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          109:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          111:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          113:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          115:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          117:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          119:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          121:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          123:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          125:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          127:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          129:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          131:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          133:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          135:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          137:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Tijuana':
        {
          0:
              {
                'ts': -1514736000,
                'time': '1922-01-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1451667600,
                'time': '1924-01-01T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          2:
              {
                'ts': -1343062800,
                'time': '1927-06-11T07:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1234803600,
                'time': '1930-11-15T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          4:
              {
                'ts': -1222963200,
                'time': '1931-04-01T08:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          5:
              {
                'ts': -1207242000,
                'time': '1931-09-30T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          6:
              {
                'ts': -873820800,
                'time': '1942-04-24T08:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PWT'
              },
          7:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PPT'
              },
          8:
              {
                'ts': -761677200,
                'time': '1945-11-12T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          9:
              {
                'ts': -686073600,
                'time': '1948-04-05T08:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          10:
              {
                'ts': -661539600,
                'time': '1949-01-14T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          11:
              {
                'ts': -495036000,
                'time': '1954-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          12:
              {
                'ts': -481734000,
                'time': '1954-09-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          13:
              {
                'ts': -463586400,
                'time': '1955-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          14:
              {
                'ts': -450284400,
                'time': '1955-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          15:
              {
                'ts': -431532000,
                'time': '1956-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          16:
              {
                'ts': -418230000,
                'time': '1956-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          17:
              {
                'ts': -400082400,
                'time': '1957-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          18:
              {
                'ts': -386780400,
                'time': '1957-09-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          19:
              {
                'ts': -368632800,
                'time': '1958-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          20:
              {
                'ts': -355330800,
                'time': '1958-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          21:
              {
                'ts': -337183200,
                'time': '1959-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          22:
              {
                'ts': -323881200,
                'time': '1959-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          23:
              {
                'ts': -305733600,
                'time': '1960-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          24:
              {
                'ts': -292431600,
                'time': '1960-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          25:
              {
                'ts': 199274400,
                'time': '1976-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          26:
              {
                'ts': 215600400,
                'time': '1976-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          27:
              {
                'ts': 230724000,
                'time': '1977-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          28:
              {
                'ts': 247050000,
                'time': '1977-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          29:
              {
                'ts': 262778400,
                'time': '1978-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          30:
              {
                'ts': 278499600,
                'time': '1978-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          31:
              {
                'ts': 294228000,
                'time': '1979-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          32:
              {
                'ts': 309949200,
                'time': '1979-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          33:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          34:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          35:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          36:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          37:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          38:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          39:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          40:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          41:
              {
                'ts': 452080800,
                'time': '1984-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          42:
              {
                'ts': 467802000,
                'time': '1984-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          43:
              {
                'ts': 483530400,
                'time': '1985-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          44:
              {
                'ts': 499251600,
                'time': '1985-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          45:
              {
                'ts': 514980000,
                'time': '1986-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          46:
              {
                'ts': 530701200,
                'time': '1986-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          47:
              {
                'ts': 544615200,
                'time': '1987-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          48:
              {
                'ts': 562150800,
                'time': '1987-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          49:
              {
                'ts': 576064800,
                'time': '1988-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          50:
              {
                'ts': 594205200,
                'time': '1988-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          51:
              {
                'ts': 607514400,
                'time': '1989-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          52:
              {
                'ts': 625654800,
                'time': '1989-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          53:
              {
                'ts': 638964000,
                'time': '1990-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          54:
              {
                'ts': 657104400,
                'time': '1990-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          55:
              {
                'ts': 671018400,
                'time': '1991-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          56:
              {
                'ts': 688554000,
                'time': '1991-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          57:
              {
                'ts': 702468000,
                'time': '1992-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          58:
              {
                'ts': 720003600,
                'time': '1992-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          59:
              {
                'ts': 733917600,
                'time': '1993-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          60:
              {
                'ts': 752058000,
                'time': '1993-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          61:
              {
                'ts': 765367200,
                'time': '1994-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          62:
              {
                'ts': 783507600,
                'time': '1994-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          63:
              {
                'ts': 796816800,
                'time': '1995-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          64:
              {
                'ts': 814957200,
                'time': '1995-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          65:
              {
                'ts': 828871200,
                'time': '1996-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          66:
              {
                'ts': 846406800,
                'time': '1996-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          67:
              {
                'ts': 860320800,
                'time': '1997-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          68:
              {
                'ts': 877856400,
                'time': '1997-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          69:
              {
                'ts': 891770400,
                'time': '1998-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          70:
              {
                'ts': 909306000,
                'time': '1998-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          71:
              {
                'ts': 923220000,
                'time': '1999-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          72:
              {
                'ts': 941360400,
                'time': '1999-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          73:
              {
                'ts': 954669600,
                'time': '2000-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          74:
              {
                'ts': 972810000,
                'time': '2000-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          75:
              {
                'ts': 986119200,
                'time': '2001-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          76:
              {
                'ts': 1004259600,
                'time': '2001-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          77:
              {
                'ts': 1018173600,
                'time': '2002-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          78:
              {
                'ts': 1035709200,
                'time': '2002-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          79:
              {
                'ts': 1049623200,
                'time': '2003-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          80:
              {
                'ts': 1067158800,
                'time': '2003-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          81:
              {
                'ts': 1081072800,
                'time': '2004-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          82:
              {
                'ts': 1099213200,
                'time': '2004-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          83:
              {
                'ts': 1112522400,
                'time': '2005-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          84:
              {
                'ts': 1130662800,
                'time': '2005-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          85:
              {
                'ts': 1143972000,
                'time': '2006-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          86:
              {
                'ts': 1162112400,
                'time': '2006-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          87:
              {
                'ts': 1175421600,
                'time': '2007-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          88:
              {
                'ts': 1193562000,
                'time': '2007-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          89:
              {
                'ts': 1207476000,
                'time': '2008-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          90:
              {
                'ts': 1225011600,
                'time': '2008-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          91:
              {
                'ts': 1238925600,
                'time': '2009-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          92:
              {
                'ts': 1256461200,
                'time': '2009-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          93:
              {
                'ts': 1270375200,
                'time': '2010-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          94:
              {
                'ts': 1288515600,
                'time': '2010-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          95:
              {
                'ts': 1301824800,
                'time': '2011-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          96:
              {
                'ts': 1319965200,
                'time': '2011-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          97:
              {
                'ts': 1333274400,
                'time': '2012-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          98:
              {
                'ts': 1351414800,
                'time': '2012-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          99:
              {
                'ts': 1365328800,
                'time': '2013-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          100:
              {
                'ts': 1382864400,
                'time': '2013-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          101:
              {
                'ts': 1396778400,
                'time': '2014-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          102:
              {
                'ts': 1414314000,
                'time': '2014-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          103:
              {
                'ts': 1428228000,
                'time': '2015-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          104:
              {
                'ts': 1445763600,
                'time': '2015-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          105:
              {
                'ts': 1459677600,
                'time': '2016-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          106:
              {
                'ts': 1477818000,
                'time': '2016-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          107:
              {
                'ts': 1491127200,
                'time': '2017-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          108:
              {
                'ts': 1509267600,
                'time': '2017-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          109:
              {
                'ts': 1522576800,
                'time': '2018-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          110:
              {
                'ts': 1540717200,
                'time': '2018-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          111:
              {
                'ts': 1554631200,
                'time': '2019-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          112:
              {
                'ts': 1572166800,
                'time': '2019-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          113:
              {
                'ts': 1586080800,
                'time': '2020-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          114:
              {
                'ts': 1603616400,
                'time': '2020-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          115:
              {
                'ts': 1617530400,
                'time': '2021-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          116:
              {
                'ts': 1635670800,
                'time': '2021-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          117:
              {
                'ts': 1648980000,
                'time': '2022-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          118:
              {
                'ts': 1667120400,
                'time': '2022-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          119:
              {
                'ts': 1680429600,
                'time': '2023-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          120:
              {
                'ts': 1698570000,
                'time': '2023-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          121:
              {
                'ts': 1712484000,
                'time': '2024-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          122:
              {
                'ts': 1730019600,
                'time': '2024-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          123:
              {
                'ts': 1743933600,
                'time': '2025-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          124:
              {
                'ts': 1761469200,
                'time': '2025-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          125:
              {
                'ts': 1775383200,
                'time': '2026-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          126:
              {
                'ts': 1792918800,
                'time': '2026-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          127:
              {
                'ts': 1806832800,
                'time': '2027-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          128:
              {
                'ts': 1824973200,
                'time': '2027-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          129:
              {
                'ts': 1838282400,
                'time': '2028-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          130:
              {
                'ts': 1856422800,
                'time': '2028-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          131:
              {
                'ts': 1869732000,
                'time': '2029-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          132:
              {
                'ts': 1887872400,
                'time': '2029-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          133:
              {
                'ts': 1901786400,
                'time': '2030-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          134:
              {
                'ts': 1919322000,
                'time': '2030-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          135:
              {
                'ts': 1933236000,
                'time': '2031-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          136:
              {
                'ts': 1950771600,
                'time': '2031-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          137:
              {
                'ts': 1964685600,
                'time': '2032-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          138:
              {
                'ts': 1982826000,
                'time': '2032-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          139:
              {
                'ts': 1996135200,
                'time': '2033-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          140:
              {
                'ts': 2014275600,
                'time': '2033-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          141:
              {
                'ts': 2027584800,
                'time': '2034-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          142:
              {
                'ts': 2045725200,
                'time': '2034-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          143:
              {
                'ts': 2059034400,
                'time': '2035-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          144:
              {
                'ts': 2077174800,
                'time': '2035-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          145:
              {
                'ts': 2091088800,
                'time': '2036-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          146:
              {
                'ts': 2108624400,
                'time': '2036-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          147:
              {
                'ts': 2122538400,
                'time': '2037-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          148:
              {
                'ts': 2140074000,
                'time': '2037-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'America/Toronto':
        {
          0:
              {
                'ts': -1632070800,
                'time': '1918-04-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          1:
              {
                'ts': -1614794400,
                'time': '1918-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -1601753400,
                'time': '1919-03-31T04:30:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          3:
              {
                'ts': -1583697600,
                'time': '1919-10-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -1567357200,
                'time': '1920-05-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          5:
              {
                'ts': -1554667200,
                'time': '1920-09-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -1534698000,
                'time': '1921-05-15T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          7:
              {
                'ts': -1524074400,
                'time': '1921-09-15T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': -1503248400,
                'time': '1922-05-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          9:
              {
                'ts': -1492365600,
                'time': '1922-09-17T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': -1471798800,
                'time': '1923-05-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          11:
              {
                'ts': -1460916000,
                'time': '1923-09-16T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': -1440954000,
                'time': '1924-05-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          13:
              {
                'ts': -1428861600,
                'time': '1924-09-21T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': -1409504400,
                'time': '1925-05-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          15:
              {
                'ts': -1397412000,
                'time': '1925-09-20T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': -1378054800,
                'time': '1926-05-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          17:
              {
                'ts': -1365962400,
                'time': '1926-09-19T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': -1346605200,
                'time': '1927-05-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          19:
              {
                'ts': -1333908000,
                'time': '1927-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': -1315155600,
                'time': '1928-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          21:
              {
                'ts': -1301853600,
                'time': '1928-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': -1283706000,
                'time': '1929-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          23:
              {
                'ts': -1270404000,
                'time': '1929-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': -1252256400,
                'time': '1930-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          25:
              {
                'ts': -1238954400,
                'time': '1930-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': -1220806800,
                'time': '1931-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          27:
              {
                'ts': -1207504800,
                'time': '1931-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': -1188752400,
                'time': '1932-05-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          29:
              {
                'ts': -1176055200,
                'time': '1932-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': -1157302800,
                'time': '1933-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': -1144000800,
                'time': '1933-10-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': -1125853200,
                'time': '1934-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': -1112551200,
                'time': '1934-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': -1094403600,
                'time': '1935-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': -1081101600,
                'time': '1935-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': -1062954000,
                'time': '1936-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': -1049652000,
                'time': '1936-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': -1031504400,
                'time': '1937-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': -1018202400,
                'time': '1937-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': -1000054800,
                'time': '1938-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': -986752800,
                'time': '1938-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': -968000400,
                'time': '1939-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': -955303200,
                'time': '1939-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': -936550800,
                'time': '1940-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': -880218000,
                'time': '1942-02-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EWT'
              },
          46:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EPT'
              },
          47:
              {
                'ts': -765396000,
                'time': '1945-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': -747248400,
                'time': '1946-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': -733946400,
                'time': '1946-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': -715806000,
                'time': '1947-04-27T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': -702504000,
                'time': '1947-09-28T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': -684356400,
                'time': '1948-04-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': -671054400,
                'time': '1948-09-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': -652906800,
                'time': '1949-04-24T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': -634161600,
                'time': '1949-11-27T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': -620845200,
                'time': '1950-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': -602704800,
                'time': '1950-11-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': -589395600,
                'time': '1951-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': -576093600,
                'time': '1951-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': -557946000,
                'time': '1952-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': -544644000,
                'time': '1952-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': -526496400,
                'time': '1953-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': -513194400,
                'time': '1953-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': -495046800,
                'time': '1954-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': -481744800,
                'time': '1954-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': -463597200,
                'time': '1955-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': -450295200,
                'time': '1955-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': -431542800,
                'time': '1956-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': -418240800,
                'time': '1956-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': -400093200,
                'time': '1957-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': -384372000,
                'time': '1957-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': -368643600,
                'time': '1958-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': -352922400,
                'time': '1958-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': -337194000,
                'time': '1959-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': -321472800,
                'time': '1959-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': -305744400,
                'time': '1960-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': -289418400,
                'time': '1960-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': -273690000,
                'time': '1961-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': -257968800,
                'time': '1961-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': -242240400,
                'time': '1962-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': -226519200,
                'time': '1962-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': -210790800,
                'time': '1963-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': -195069600,
                'time': '1963-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': -179341200,
                'time': '1964-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': -163620000,
                'time': '1964-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': -147891600,
                'time': '1965-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': -131565600,
                'time': '1965-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': -116442000,
                'time': '1966-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': -100116000,
                'time': '1966-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': -84387600,
                'time': '1967-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': -68666400,
                'time': '1967-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': -52938000,
                'time': '1968-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': -37216800,
                'time': '1968-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          99:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          101:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          103:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 136364400,
                'time': '1974-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          105:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 167814000,
                'time': '1975-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          107:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          109:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          111:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          113:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          115:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          117:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          119:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          121:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          123:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          125:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          127:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          129:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          131:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          133:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          135:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          137:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          138:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          139:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          140:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          141:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          142:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          143:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          144:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          145:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          146:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          147:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          148:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          149:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          150:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          151:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          152:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          153:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          154:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          155:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          156:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          157:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          158:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          159:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          160:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          161:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          162:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          163:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          164:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          165:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          166:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          167:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          168:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          169:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          170:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          171:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          172:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          173:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          174:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          175:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          176:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          177:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          178:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          179:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          180:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          181:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          182:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          183:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          184:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          185:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          186:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          187:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          188:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          189:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          190:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          191:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          192:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          193:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          194:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          195:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          196:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          197:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          198:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          199:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          200:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          201:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          202:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          203:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          204:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          205:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          206:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          207:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          208:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          209:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          210:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          211:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          212:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          213:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          214:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          215:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          216:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          217:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          218:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          219:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          220:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          221:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          222:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          223:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          224:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          225:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          226:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          227:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          228:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          229:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          230:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          231:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'America/Tortola':
        {
          0:
              {
                'ts': -1846266092,
                'time': '1911-07-01T04:18:28+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Vancouver':
        {
          0:
              {
                'ts': -1632060000,
                'time': '1918-04-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          1:
              {
                'ts': -1614783600,
                'time': '1918-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          2:
              {
                'ts': -880207200,
                'time': '1942-02-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PWT'
              },
          3:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PPT'
              },
          4:
              {
                'ts': -765385200,
                'time': '1945-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          5:
              {
                'ts': -747237600,
                'time': '1946-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          6:
              {
                'ts': -732726000,
                'time': '1946-10-13T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          7:
              {
                'ts': -715788000,
                'time': '1947-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          8:
              {
                'ts': -702486000,
                'time': '1947-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          9:
              {
                'ts': -684338400,
                'time': '1948-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          10:
              {
                'ts': -671036400,
                'time': '1948-09-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          11:
              {
                'ts': -652888800,
                'time': '1949-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          12:
              {
                'ts': -639586800,
                'time': '1949-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          13:
              {
                'ts': -620834400,
                'time': '1950-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          14:
              {
                'ts': -608137200,
                'time': '1950-09-24T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          15:
              {
                'ts': -589384800,
                'time': '1951-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          16:
              {
                'ts': -576082800,
                'time': '1951-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          17:
              {
                'ts': -557935200,
                'time': '1952-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          18:
              {
                'ts': -544633200,
                'time': '1952-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          19:
              {
                'ts': -526485600,
                'time': '1953-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          20:
              {
                'ts': -513183600,
                'time': '1953-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          21:
              {
                'ts': -495036000,
                'time': '1954-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          22:
              {
                'ts': -481734000,
                'time': '1954-09-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          23:
              {
                'ts': -463586400,
                'time': '1955-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          24:
              {
                'ts': -450284400,
                'time': '1955-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          25:
              {
                'ts': -431532000,
                'time': '1956-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          26:
              {
                'ts': -418230000,
                'time': '1956-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          27:
              {
                'ts': -400082400,
                'time': '1957-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          28:
              {
                'ts': -386780400,
                'time': '1957-09-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          29:
              {
                'ts': -368632800,
                'time': '1958-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          30:
              {
                'ts': -355330800,
                'time': '1958-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          31:
              {
                'ts': -337183200,
                'time': '1959-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          32:
              {
                'ts': -323881200,
                'time': '1959-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          33:
              {
                'ts': -305733600,
                'time': '1960-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          34:
              {
                'ts': -292431600,
                'time': '1960-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          35:
              {
                'ts': -273679200,
                'time': '1961-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          36:
              {
                'ts': -260982000,
                'time': '1961-09-24T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          37:
              {
                'ts': -242229600,
                'time': '1962-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          38:
              {
                'ts': -226508400,
                'time': '1962-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          39:
              {
                'ts': -210780000,
                'time': '1963-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          40:
              {
                'ts': -195058800,
                'time': '1963-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          41:
              {
                'ts': -179330400,
                'time': '1964-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          42:
              {
                'ts': -163609200,
                'time': '1964-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          43:
              {
                'ts': -147880800,
                'time': '1965-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          44:
              {
                'ts': -131554800,
                'time': '1965-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          45:
              {
                'ts': -116431200,
                'time': '1966-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          46:
              {
                'ts': -100105200,
                'time': '1966-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          47:
              {
                'ts': -84376800,
                'time': '1967-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          48:
              {
                'ts': -68655600,
                'time': '1967-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          49:
              {
                'ts': -52927200,
                'time': '1968-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          50:
              {
                'ts': -37206000,
                'time': '1968-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          51:
              {
                'ts': -21477600,
                'time': '1969-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          52:
              {
                'ts': -5756400,
                'time': '1969-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          53:
              {
                'ts': 9972000,
                'time': '1970-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          54:
              {
                'ts': 25693200,
                'time': '1970-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          55:
              {
                'ts': 41421600,
                'time': '1971-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          56:
              {
                'ts': 57747600,
                'time': '1971-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          57:
              {
                'ts': 73476000,
                'time': '1972-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          58:
              {
                'ts': 89197200,
                'time': '1972-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          59:
              {
                'ts': 104925600,
                'time': '1973-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          60:
              {
                'ts': 120646800,
                'time': '1973-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          61:
              {
                'ts': 136375200,
                'time': '1974-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          62:
              {
                'ts': 152096400,
                'time': '1974-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          63:
              {
                'ts': 167824800,
                'time': '1975-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          64:
              {
                'ts': 183546000,
                'time': '1975-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          65:
              {
                'ts': 199274400,
                'time': '1976-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          66:
              {
                'ts': 215600400,
                'time': '1976-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          67:
              {
                'ts': 230724000,
                'time': '1977-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          68:
              {
                'ts': 247050000,
                'time': '1977-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          69:
              {
                'ts': 262778400,
                'time': '1978-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          70:
              {
                'ts': 278499600,
                'time': '1978-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          71:
              {
                'ts': 294228000,
                'time': '1979-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          72:
              {
                'ts': 309949200,
                'time': '1979-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          73:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          74:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          75:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          76:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          77:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          78:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          79:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          80:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          81:
              {
                'ts': 452080800,
                'time': '1984-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          82:
              {
                'ts': 467802000,
                'time': '1984-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          83:
              {
                'ts': 483530400,
                'time': '1985-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          84:
              {
                'ts': 499251600,
                'time': '1985-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          85:
              {
                'ts': 514980000,
                'time': '1986-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          86:
              {
                'ts': 530701200,
                'time': '1986-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          87:
              {
                'ts': 544615200,
                'time': '1987-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          88:
              {
                'ts': 562150800,
                'time': '1987-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          89:
              {
                'ts': 576064800,
                'time': '1988-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          90:
              {
                'ts': 594205200,
                'time': '1988-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          91:
              {
                'ts': 607514400,
                'time': '1989-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          92:
              {
                'ts': 625654800,
                'time': '1989-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          93:
              {
                'ts': 638964000,
                'time': '1990-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          94:
              {
                'ts': 657104400,
                'time': '1990-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          95:
              {
                'ts': 671018400,
                'time': '1991-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          96:
              {
                'ts': 688554000,
                'time': '1991-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          97:
              {
                'ts': 702468000,
                'time': '1992-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          98:
              {
                'ts': 720003600,
                'time': '1992-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          99:
              {
                'ts': 733917600,
                'time': '1993-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          100:
              {
                'ts': 752058000,
                'time': '1993-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          101:
              {
                'ts': 765367200,
                'time': '1994-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          102:
              {
                'ts': 783507600,
                'time': '1994-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          103:
              {
                'ts': 796816800,
                'time': '1995-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          104:
              {
                'ts': 814957200,
                'time': '1995-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          105:
              {
                'ts': 828871200,
                'time': '1996-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          106:
              {
                'ts': 846406800,
                'time': '1996-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          107:
              {
                'ts': 860320800,
                'time': '1997-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          108:
              {
                'ts': 877856400,
                'time': '1997-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          109:
              {
                'ts': 891770400,
                'time': '1998-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          110:
              {
                'ts': 909306000,
                'time': '1998-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          111:
              {
                'ts': 923220000,
                'time': '1999-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          112:
              {
                'ts': 941360400,
                'time': '1999-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          113:
              {
                'ts': 954669600,
                'time': '2000-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          114:
              {
                'ts': 972810000,
                'time': '2000-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          115:
              {
                'ts': 986119200,
                'time': '2001-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          116:
              {
                'ts': 1004259600,
                'time': '2001-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          117:
              {
                'ts': 1018173600,
                'time': '2002-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          118:
              {
                'ts': 1035709200,
                'time': '2002-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          119:
              {
                'ts': 1049623200,
                'time': '2003-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          120:
              {
                'ts': 1067158800,
                'time': '2003-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          121:
              {
                'ts': 1081072800,
                'time': '2004-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          122:
              {
                'ts': 1099213200,
                'time': '2004-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          123:
              {
                'ts': 1112522400,
                'time': '2005-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          124:
              {
                'ts': 1130662800,
                'time': '2005-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          125:
              {
                'ts': 1143972000,
                'time': '2006-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          126:
              {
                'ts': 1162112400,
                'time': '2006-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          127:
              {
                'ts': 1173607200,
                'time': '2007-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          128:
              {
                'ts': 1194166800,
                'time': '2007-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          129:
              {
                'ts': 1205056800,
                'time': '2008-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          130:
              {
                'ts': 1225616400,
                'time': '2008-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          131:
              {
                'ts': 1236506400,
                'time': '2009-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          132:
              {
                'ts': 1257066000,
                'time': '2009-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          133:
              {
                'ts': 1268560800,
                'time': '2010-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          134:
              {
                'ts': 1289120400,
                'time': '2010-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          135:
              {
                'ts': 1300010400,
                'time': '2011-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          136:
              {
                'ts': 1320570000,
                'time': '2011-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          137:
              {
                'ts': 1331460000,
                'time': '2012-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          138:
              {
                'ts': 1352019600,
                'time': '2012-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          139:
              {
                'ts': 1362909600,
                'time': '2013-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          140:
              {
                'ts': 1383469200,
                'time': '2013-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          141:
              {
                'ts': 1394359200,
                'time': '2014-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          142:
              {
                'ts': 1414918800,
                'time': '2014-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          143:
              {
                'ts': 1425808800,
                'time': '2015-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          144:
              {
                'ts': 1446368400,
                'time': '2015-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          145:
              {
                'ts': 1457863200,
                'time': '2016-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          146:
              {
                'ts': 1478422800,
                'time': '2016-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          147:
              {
                'ts': 1489312800,
                'time': '2017-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          148:
              {
                'ts': 1509872400,
                'time': '2017-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          149:
              {
                'ts': 1520762400,
                'time': '2018-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          150:
              {
                'ts': 1541322000,
                'time': '2018-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          151:
              {
                'ts': 1552212000,
                'time': '2019-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          152:
              {
                'ts': 1572771600,
                'time': '2019-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          153:
              {
                'ts': 1583661600,
                'time': '2020-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          154:
              {
                'ts': 1604221200,
                'time': '2020-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          155:
              {
                'ts': 1615716000,
                'time': '2021-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          156:
              {
                'ts': 1636275600,
                'time': '2021-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          157:
              {
                'ts': 1647165600,
                'time': '2022-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          158:
              {
                'ts': 1667725200,
                'time': '2022-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          159:
              {
                'ts': 1678615200,
                'time': '2023-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          160:
              {
                'ts': 1699174800,
                'time': '2023-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          161:
              {
                'ts': 1710064800,
                'time': '2024-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          162:
              {
                'ts': 1730624400,
                'time': '2024-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          163:
              {
                'ts': 1741514400,
                'time': '2025-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          164:
              {
                'ts': 1762074000,
                'time': '2025-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          165:
              {
                'ts': 1772964000,
                'time': '2026-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          166:
              {
                'ts': 1793523600,
                'time': '2026-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          167:
              {
                'ts': 1805018400,
                'time': '2027-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          168:
              {
                'ts': 1825578000,
                'time': '2027-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          169:
              {
                'ts': 1836468000,
                'time': '2028-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          170:
              {
                'ts': 1857027600,
                'time': '2028-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          171:
              {
                'ts': 1867917600,
                'time': '2029-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          172:
              {
                'ts': 1888477200,
                'time': '2029-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          173:
              {
                'ts': 1899367200,
                'time': '2030-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          174:
              {
                'ts': 1919926800,
                'time': '2030-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          175:
              {
                'ts': 1930816800,
                'time': '2031-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          176:
              {
                'ts': 1951376400,
                'time': '2031-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          177:
              {
                'ts': 1962871200,
                'time': '2032-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          178:
              {
                'ts': 1983430800,
                'time': '2032-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          179:
              {
                'ts': 1994320800,
                'time': '2033-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          180:
              {
                'ts': 2014880400,
                'time': '2033-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          181:
              {
                'ts': 2025770400,
                'time': '2034-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          182:
              {
                'ts': 2046330000,
                'time': '2034-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          183:
              {
                'ts': 2057220000,
                'time': '2035-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          184:
              {
                'ts': 2077779600,
                'time': '2035-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          185:
              {
                'ts': 2088669600,
                'time': '2036-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          186:
              {
                'ts': 2109229200,
                'time': '2036-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          187:
              {
                'ts': 2120119200,
                'time': '2037-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          188:
              {
                'ts': 2140678800,
                'time': '2037-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'America/Virgin':
        {
          0:
              {
                'ts': -1846266016,
                'time': '1911-07-01T04:19:44+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'America/Whitehorse':
        {
          0:
              {
                'ts': -1632056400,
                'time': '1918-04-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          1:
              {
                'ts': -1615125600,
                'time': '1918-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          2:
              {
                'ts': -1596978000,
                'time': '1919-05-25T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          3:
              {
                'ts': -1583164800,
                'time': '1919-11-01T08:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          4:
              {
                'ts': -880203600,
                'time': '1942-02-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YPT'
              },
          6:
              {
                'ts': -765381600,
                'time': '1945-09-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          7:
              {
                'ts': -147884400,
                'time': '1965-04-25T09:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'YDDT'
              },
          8:
              {
                'ts': -131554800,
                'time': '1965-10-31T09:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          9:
              {
                'ts': -110552400,
                'time': '1966-07-01T11:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          10:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          11:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          12:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          13:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          14:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          15:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          16:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          17:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          18:
              {
                'ts': 452080800,
                'time': '1984-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          19:
              {
                'ts': 467802000,
                'time': '1984-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          20:
              {
                'ts': 483530400,
                'time': '1985-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          21:
              {
                'ts': 499251600,
                'time': '1985-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          22:
              {
                'ts': 514980000,
                'time': '1986-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          23:
              {
                'ts': 530701200,
                'time': '1986-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          24:
              {
                'ts': 544615200,
                'time': '1987-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          25:
              {
                'ts': 562150800,
                'time': '1987-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          26:
              {
                'ts': 576064800,
                'time': '1988-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          27:
              {
                'ts': 594205200,
                'time': '1988-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          28:
              {
                'ts': 607514400,
                'time': '1989-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          29:
              {
                'ts': 625654800,
                'time': '1989-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          30:
              {
                'ts': 638964000,
                'time': '1990-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          31:
              {
                'ts': 657104400,
                'time': '1990-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          32:
              {
                'ts': 671018400,
                'time': '1991-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          33:
              {
                'ts': 688554000,
                'time': '1991-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          34:
              {
                'ts': 702468000,
                'time': '1992-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          35:
              {
                'ts': 720003600,
                'time': '1992-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          36:
              {
                'ts': 733917600,
                'time': '1993-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          37:
              {
                'ts': 752058000,
                'time': '1993-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          38:
              {
                'ts': 765367200,
                'time': '1994-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          39:
              {
                'ts': 783507600,
                'time': '1994-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          40:
              {
                'ts': 796816800,
                'time': '1995-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          41:
              {
                'ts': 814957200,
                'time': '1995-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          42:
              {
                'ts': 828871200,
                'time': '1996-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          43:
              {
                'ts': 846406800,
                'time': '1996-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          44:
              {
                'ts': 860320800,
                'time': '1997-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          45:
              {
                'ts': 877856400,
                'time': '1997-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          46:
              {
                'ts': 891770400,
                'time': '1998-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          47:
              {
                'ts': 909306000,
                'time': '1998-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          48:
              {
                'ts': 923220000,
                'time': '1999-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          49:
              {
                'ts': 941360400,
                'time': '1999-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          50:
              {
                'ts': 954669600,
                'time': '2000-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          51:
              {
                'ts': 972810000,
                'time': '2000-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          52:
              {
                'ts': 986119200,
                'time': '2001-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          53:
              {
                'ts': 1004259600,
                'time': '2001-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          54:
              {
                'ts': 1018173600,
                'time': '2002-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          55:
              {
                'ts': 1035709200,
                'time': '2002-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          56:
              {
                'ts': 1049623200,
                'time': '2003-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          57:
              {
                'ts': 1067158800,
                'time': '2003-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          58:
              {
                'ts': 1081072800,
                'time': '2004-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          59:
              {
                'ts': 1099213200,
                'time': '2004-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          60:
              {
                'ts': 1112522400,
                'time': '2005-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          61:
              {
                'ts': 1130662800,
                'time': '2005-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          62:
              {
                'ts': 1143972000,
                'time': '2006-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          63:
              {
                'ts': 1162112400,
                'time': '2006-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          64:
              {
                'ts': 1173607200,
                'time': '2007-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          65:
              {
                'ts': 1194166800,
                'time': '2007-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          66:
              {
                'ts': 1205056800,
                'time': '2008-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          67:
              {
                'ts': 1225616400,
                'time': '2008-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          68:
              {
                'ts': 1236506400,
                'time': '2009-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          69:
              {
                'ts': 1257066000,
                'time': '2009-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          70:
              {
                'ts': 1268560800,
                'time': '2010-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          71:
              {
                'ts': 1289120400,
                'time': '2010-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          72:
              {
                'ts': 1300010400,
                'time': '2011-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          73:
              {
                'ts': 1320570000,
                'time': '2011-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          74:
              {
                'ts': 1331460000,
                'time': '2012-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          75:
              {
                'ts': 1352019600,
                'time': '2012-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          76:
              {
                'ts': 1362909600,
                'time': '2013-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          77:
              {
                'ts': 1383469200,
                'time': '2013-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          78:
              {
                'ts': 1394359200,
                'time': '2014-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          79:
              {
                'ts': 1414918800,
                'time': '2014-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          80:
              {
                'ts': 1425808800,
                'time': '2015-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          81:
              {
                'ts': 1446368400,
                'time': '2015-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          82:
              {
                'ts': 1457863200,
                'time': '2016-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          83:
              {
                'ts': 1478422800,
                'time': '2016-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          84:
              {
                'ts': 1489312800,
                'time': '2017-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          85:
              {
                'ts': 1509872400,
                'time': '2017-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          86:
              {
                'ts': 1520762400,
                'time': '2018-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          87:
              {
                'ts': 1541322000,
                'time': '2018-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          88:
              {
                'ts': 1552212000,
                'time': '2019-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          89:
              {
                'ts': 1572771600,
                'time': '2019-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          90:
              {
                'ts': 1583661600,
                'time': '2020-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          91:
              {
                'ts': 1604221200,
                'time': '2020-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          92:
              {
                'ts': 1615716000,
                'time': '2021-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          93:
              {
                'ts': 1636275600,
                'time': '2021-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          94:
              {
                'ts': 1647165600,
                'time': '2022-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          95:
              {
                'ts': 1667725200,
                'time': '2022-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          96:
              {
                'ts': 1678615200,
                'time': '2023-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          97:
              {
                'ts': 1699174800,
                'time': '2023-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          98:
              {
                'ts': 1710064800,
                'time': '2024-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          99:
              {
                'ts': 1730624400,
                'time': '2024-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          100:
              {
                'ts': 1741514400,
                'time': '2025-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          101:
              {
                'ts': 1762074000,
                'time': '2025-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          102:
              {
                'ts': 1772964000,
                'time': '2026-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          103:
              {
                'ts': 1793523600,
                'time': '2026-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          104:
              {
                'ts': 1805018400,
                'time': '2027-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          105:
              {
                'ts': 1825578000,
                'time': '2027-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          106:
              {
                'ts': 1836468000,
                'time': '2028-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          107:
              {
                'ts': 1857027600,
                'time': '2028-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          108:
              {
                'ts': 1867917600,
                'time': '2029-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          109:
              {
                'ts': 1888477200,
                'time': '2029-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          110:
              {
                'ts': 1899367200,
                'time': '2030-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          111:
              {
                'ts': 1919926800,
                'time': '2030-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          112:
              {
                'ts': 1930816800,
                'time': '2031-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          113:
              {
                'ts': 1951376400,
                'time': '2031-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          114:
              {
                'ts': 1962871200,
                'time': '2032-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          115:
              {
                'ts': 1983430800,
                'time': '2032-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          116:
              {
                'ts': 1994320800,
                'time': '2033-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          117:
              {
                'ts': 2014880400,
                'time': '2033-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          118:
              {
                'ts': 2025770400,
                'time': '2034-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          119:
              {
                'ts': 2046330000,
                'time': '2034-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          120:
              {
                'ts': 2057220000,
                'time': '2035-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          121:
              {
                'ts': 2077779600,
                'time': '2035-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          122:
              {
                'ts': 2088669600,
                'time': '2036-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          123:
              {
                'ts': 2109229200,
                'time': '2036-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          124:
              {
                'ts': 2120119200,
                'time': '2037-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          125:
              {
                'ts': 2140678800,
                'time': '2037-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'America/Winnipeg':
        {
          0:
              {
                'ts': -1694368800,
                'time': '1916-04-23T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1681671600,
                'time': '1916-09-17T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1632067200,
                'time': '1918-04-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1614790800,
                'time': '1918-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -1029686400,
                'time': '1937-05-16T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': -1018198800,
                'time': '1937-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          7:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          8:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -746035200,
                'time': '1946-05-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -732733200,
                'time': '1946-10-13T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -702493200,
                'time': '1947-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -684345600,
                'time': '1948-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -671043600,
                'time': '1948-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -652896000,
                'time': '1949-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -639594000,
                'time': '1949-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -620755200,
                'time': '1950-05-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -607626000,
                'time': '1950-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': -450291600,
                'time': '1955-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': -418237200,
                'time': '1956-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': -355338000,
                'time': '1958-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': -321469200,
                'time': '1959-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          38:
              {
                'ts': -292438800,
                'time': '1960-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': -210787200,
                'time': '1963-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': -198090000,
                'time': '1963-09-22T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': -116438400,
                'time': '1966-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': -100108800,
                'time': '1966-10-30T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': -84384000,
                'time': '1967-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': -52934400,
                'time': '1968-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': -37209600,
                'time': '1968-10-27T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': -21484800,
                'time': '1969-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 9964800,
                'time': '1970-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 25689600,
                'time': '1970-10-25T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 41414400,
                'time': '1971-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 57744000,
                'time': '1971-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 73468800,
                'time': '1972-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 104918400,
                'time': '1973-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 136368000,
                'time': '1974-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 167817600,
                'time': '1975-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 199267200,
                'time': '1976-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 230716800,
                'time': '1977-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 262771200,
                'time': '1978-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 294220800,
                'time': '1979-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          89:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 702460800,
                'time': '1992-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 733910400,
                'time': '1993-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 765360000,
                'time': '1994-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 796809600,
                'time': '1995-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 986112000,
                'time': '2001-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          120:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1136095200,
                'time': '2006-01-01T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          122:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          123:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          124:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          125:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          126:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          127:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          128:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          129:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          130:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          131:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          132:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          133:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          134:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          135:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          136:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          137:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          138:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          139:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          140:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          141:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          142:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          143:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          144:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          145:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          146:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          147:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          148:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          149:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          150:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          151:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          152:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          153:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          154:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          155:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          156:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          157:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          158:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          159:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          160:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          161:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          162:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          163:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          164:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          165:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          166:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          167:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          168:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          169:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          170:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          171:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          172:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          173:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          174:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          175:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          176:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          177:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          178:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          179:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          180:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          181:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          182:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          183:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          184:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          185:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'America/Yakutat':
        {
          0:
              {
                'ts': -880203600,
                'time': '1942-02-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YWT'
              },
          1:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YPT'
              },
          2:
              {
                'ts': -765381600,
                'time': '1945-09-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          3:
              {
                'ts': -21474000,
                'time': '1969-04-27T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          4:
              {
                'ts': -5752800,
                'time': '1969-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          5:
              {
                'ts': 9975600,
                'time': '1970-04-26T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          6:
              {
                'ts': 25696800,
                'time': '1970-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          7:
              {
                'ts': 41425200,
                'time': '1971-04-25T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          8:
              {
                'ts': 57751200,
                'time': '1971-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          9:
              {
                'ts': 73479600,
                'time': '1972-04-30T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          10:
              {
                'ts': 89200800,
                'time': '1972-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          11:
              {
                'ts': 104929200,
                'time': '1973-04-29T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          12:
              {
                'ts': 120650400,
                'time': '1973-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          13:
              {
                'ts': 126702000,
                'time': '1974-01-06T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          14:
              {
                'ts': 152100000,
                'time': '1974-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          15:
              {
                'ts': 162385200,
                'time': '1975-02-23T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          16:
              {
                'ts': 183549600,
                'time': '1975-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          17:
              {
                'ts': 199278000,
                'time': '1976-04-25T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          18:
              {
                'ts': 215604000,
                'time': '1976-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          19:
              {
                'ts': 230727600,
                'time': '1977-04-24T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          20:
              {
                'ts': 247053600,
                'time': '1977-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          21:
              {
                'ts': 262782000,
                'time': '1978-04-30T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          22:
              {
                'ts': 278503200,
                'time': '1978-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          23:
              {
                'ts': 294231600,
                'time': '1979-04-29T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          24:
              {
                'ts': 309952800,
                'time': '1979-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          25:
              {
                'ts': 325681200,
                'time': '1980-04-27T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          26:
              {
                'ts': 341402400,
                'time': '1980-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          27:
              {
                'ts': 357130800,
                'time': '1981-04-26T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          28:
              {
                'ts': 372852000,
                'time': '1981-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          29:
              {
                'ts': 388580400,
                'time': '1982-04-25T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          30:
              {
                'ts': 404906400,
                'time': '1982-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          31:
              {
                'ts': 420030000,
                'time': '1983-04-24T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          32:
              {
                'ts': 436356000,
                'time': '1983-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          33:
              {
                'ts': 439030800,
                'time': '1983-11-30T09:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          34:
              {
                'ts': 452084400,
                'time': '1984-04-29T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          35:
              {
                'ts': 467805600,
                'time': '1984-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          36:
              {
                'ts': 483534000,
                'time': '1985-04-28T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          37:
              {
                'ts': 499255200,
                'time': '1985-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          38:
              {
                'ts': 514983600,
                'time': '1986-04-27T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          39:
              {
                'ts': 530704800,
                'time': '1986-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          40:
              {
                'ts': 544618800,
                'time': '1987-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          41:
              {
                'ts': 562154400,
                'time': '1987-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          42:
              {
                'ts': 576068400,
                'time': '1988-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          43:
              {
                'ts': 594208800,
                'time': '1988-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          44:
              {
                'ts': 607518000,
                'time': '1989-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          45:
              {
                'ts': 625658400,
                'time': '1989-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          46:
              {
                'ts': 638967600,
                'time': '1990-04-01T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          47:
              {
                'ts': 657108000,
                'time': '1990-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          48:
              {
                'ts': 671022000,
                'time': '1991-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          49:
              {
                'ts': 688557600,
                'time': '1991-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          50:
              {
                'ts': 702471600,
                'time': '1992-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          51:
              {
                'ts': 720007200,
                'time': '1992-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          52:
              {
                'ts': 733921200,
                'time': '1993-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          53:
              {
                'ts': 752061600,
                'time': '1993-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          54:
              {
                'ts': 765370800,
                'time': '1994-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          55:
              {
                'ts': 783511200,
                'time': '1994-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          56:
              {
                'ts': 796820400,
                'time': '1995-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          57:
              {
                'ts': 814960800,
                'time': '1995-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          58:
              {
                'ts': 828874800,
                'time': '1996-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          59:
              {
                'ts': 846410400,
                'time': '1996-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          60:
              {
                'ts': 860324400,
                'time': '1997-04-06T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          61:
              {
                'ts': 877860000,
                'time': '1997-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          62:
              {
                'ts': 891774000,
                'time': '1998-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          63:
              {
                'ts': 909309600,
                'time': '1998-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          64:
              {
                'ts': 923223600,
                'time': '1999-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          65:
              {
                'ts': 941364000,
                'time': '1999-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          66:
              {
                'ts': 954673200,
                'time': '2000-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          67:
              {
                'ts': 972813600,
                'time': '2000-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          68:
              {
                'ts': 986122800,
                'time': '2001-04-01T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          69:
              {
                'ts': 1004263200,
                'time': '2001-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          70:
              {
                'ts': 1018177200,
                'time': '2002-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          71:
              {
                'ts': 1035712800,
                'time': '2002-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          72:
              {
                'ts': 1049626800,
                'time': '2003-04-06T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          73:
              {
                'ts': 1067162400,
                'time': '2003-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          74:
              {
                'ts': 1081076400,
                'time': '2004-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          75:
              {
                'ts': 1099216800,
                'time': '2004-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          76:
              {
                'ts': 1112526000,
                'time': '2005-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          77:
              {
                'ts': 1130666400,
                'time': '2005-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          78:
              {
                'ts': 1143975600,
                'time': '2006-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          79:
              {
                'ts': 1162116000,
                'time': '2006-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          80:
              {
                'ts': 1173610800,
                'time': '2007-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          81:
              {
                'ts': 1194170400,
                'time': '2007-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          82:
              {
                'ts': 1205060400,
                'time': '2008-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          83:
              {
                'ts': 1225620000,
                'time': '2008-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          84:
              {
                'ts': 1236510000,
                'time': '2009-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          85:
              {
                'ts': 1257069600,
                'time': '2009-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          86:
              {
                'ts': 1268564400,
                'time': '2010-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          87:
              {
                'ts': 1289124000,
                'time': '2010-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          88:
              {
                'ts': 1300014000,
                'time': '2011-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          89:
              {
                'ts': 1320573600,
                'time': '2011-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          90:
              {
                'ts': 1331463600,
                'time': '2012-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          91:
              {
                'ts': 1352023200,
                'time': '2012-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          92:
              {
                'ts': 1362913200,
                'time': '2013-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          93:
              {
                'ts': 1383472800,
                'time': '2013-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          94:
              {
                'ts': 1394362800,
                'time': '2014-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          95:
              {
                'ts': 1414922400,
                'time': '2014-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          96:
              {
                'ts': 1425812400,
                'time': '2015-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          97:
              {
                'ts': 1446372000,
                'time': '2015-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          98:
              {
                'ts': 1457866800,
                'time': '2016-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          99:
              {
                'ts': 1478426400,
                'time': '2016-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          100:
              {
                'ts': 1489316400,
                'time': '2017-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          101:
              {
                'ts': 1509876000,
                'time': '2017-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          102:
              {
                'ts': 1520766000,
                'time': '2018-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          103:
              {
                'ts': 1541325600,
                'time': '2018-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          104:
              {
                'ts': 1552215600,
                'time': '2019-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          105:
              {
                'ts': 1572775200,
                'time': '2019-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          106:
              {
                'ts': 1583665200,
                'time': '2020-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          107:
              {
                'ts': 1604224800,
                'time': '2020-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          108:
              {
                'ts': 1615719600,
                'time': '2021-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          109:
              {
                'ts': 1636279200,
                'time': '2021-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          110:
              {
                'ts': 1647169200,
                'time': '2022-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          111:
              {
                'ts': 1667728800,
                'time': '2022-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          112:
              {
                'ts': 1678618800,
                'time': '2023-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          113:
              {
                'ts': 1699178400,
                'time': '2023-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          114:
              {
                'ts': 1710068400,
                'time': '2024-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          115:
              {
                'ts': 1730628000,
                'time': '2024-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          116:
              {
                'ts': 1741518000,
                'time': '2025-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          117:
              {
                'ts': 1762077600,
                'time': '2025-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          118:
              {
                'ts': 1772967600,
                'time': '2026-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          119:
              {
                'ts': 1793527200,
                'time': '2026-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          120:
              {
                'ts': 1805022000,
                'time': '2027-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          121:
              {
                'ts': 1825581600,
                'time': '2027-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          122:
              {
                'ts': 1836471600,
                'time': '2028-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          123:
              {
                'ts': 1857031200,
                'time': '2028-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          124:
              {
                'ts': 1867921200,
                'time': '2029-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          125:
              {
                'ts': 1888480800,
                'time': '2029-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          126:
              {
                'ts': 1899370800,
                'time': '2030-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          127:
              {
                'ts': 1919930400,
                'time': '2030-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          128:
              {
                'ts': 1930820400,
                'time': '2031-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          129:
              {
                'ts': 1951380000,
                'time': '2031-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          130:
              {
                'ts': 1962874800,
                'time': '2032-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          131:
              {
                'ts': 1983434400,
                'time': '2032-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          132:
              {
                'ts': 1994324400,
                'time': '2033-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          133:
              {
                'ts': 2014884000,
                'time': '2033-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          134:
              {
                'ts': 2025774000,
                'time': '2034-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          135:
              {
                'ts': 2046333600,
                'time': '2034-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          136:
              {
                'ts': 2057223600,
                'time': '2035-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          137:
              {
                'ts': 2077783200,
                'time': '2035-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          138:
              {
                'ts': 2088673200,
                'time': '2036-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          139:
              {
                'ts': 2109232800,
                'time': '2036-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          140:
              {
                'ts': 2120122800,
                'time': '2037-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          141:
              {
                'ts': 2140682400,
                'time': '2037-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              }
        },
    'America/Yellowknife':
        {
          0:
              {
                'ts': -1104537600,
                'time': '1935-01-01T00:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          2:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          3:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': -147891600,
                'time': '1965-04-25T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'MDDT'
              },
          5:
              {
                'ts': -131562000,
                'time': '1965-10-31T07:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          6:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          7:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          8:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          9:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          10:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          11:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          12:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          13:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          14:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          15:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          16:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          17:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          18:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          19:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          20:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          21:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          22:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          23:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          24:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          25:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          26:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          27:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          28:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          29:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          30:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          31:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          32:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          33:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          34:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          35:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          36:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          37:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          38:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          39:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          40:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          41:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          42:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          43:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          44:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          45:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          46:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          47:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          48:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          49:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          50:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          51:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          52:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          53:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          54:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          55:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          56:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          57:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          58:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          59:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          60:
              {
                'ts': 1173603600,
                'time': '2007-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          61:
              {
                'ts': 1194163200,
                'time': '2007-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          62:
              {
                'ts': 1205053200,
                'time': '2008-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          63:
              {
                'ts': 1225612800,
                'time': '2008-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          64:
              {
                'ts': 1236502800,
                'time': '2009-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          65:
              {
                'ts': 1257062400,
                'time': '2009-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          66:
              {
                'ts': 1268557200,
                'time': '2010-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          67:
              {
                'ts': 1289116800,
                'time': '2010-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          68:
              {
                'ts': 1300006800,
                'time': '2011-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          69:
              {
                'ts': 1320566400,
                'time': '2011-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          70:
              {
                'ts': 1331456400,
                'time': '2012-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          71:
              {
                'ts': 1352016000,
                'time': '2012-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          72:
              {
                'ts': 1362906000,
                'time': '2013-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          73:
              {
                'ts': 1383465600,
                'time': '2013-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          74:
              {
                'ts': 1394355600,
                'time': '2014-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          75:
              {
                'ts': 1414915200,
                'time': '2014-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          76:
              {
                'ts': 1425805200,
                'time': '2015-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          77:
              {
                'ts': 1446364800,
                'time': '2015-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          78:
              {
                'ts': 1457859600,
                'time': '2016-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          79:
              {
                'ts': 1478419200,
                'time': '2016-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          80:
              {
                'ts': 1489309200,
                'time': '2017-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          81:
              {
                'ts': 1509868800,
                'time': '2017-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          82:
              {
                'ts': 1520758800,
                'time': '2018-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          83:
              {
                'ts': 1541318400,
                'time': '2018-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          84:
              {
                'ts': 1552208400,
                'time': '2019-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          85:
              {
                'ts': 1572768000,
                'time': '2019-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          86:
              {
                'ts': 1583658000,
                'time': '2020-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          87:
              {
                'ts': 1604217600,
                'time': '2020-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          88:
              {
                'ts': 1615712400,
                'time': '2021-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          89:
              {
                'ts': 1636272000,
                'time': '2021-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          90:
              {
                'ts': 1647162000,
                'time': '2022-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          91:
              {
                'ts': 1667721600,
                'time': '2022-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          92:
              {
                'ts': 1678611600,
                'time': '2023-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          93:
              {
                'ts': 1699171200,
                'time': '2023-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          94:
              {
                'ts': 1710061200,
                'time': '2024-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          95:
              {
                'ts': 1730620800,
                'time': '2024-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          96:
              {
                'ts': 1741510800,
                'time': '2025-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          97:
              {
                'ts': 1762070400,
                'time': '2025-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          98:
              {
                'ts': 1772960400,
                'time': '2026-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          99:
              {
                'ts': 1793520000,
                'time': '2026-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          100:
              {
                'ts': 1805014800,
                'time': '2027-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          101:
              {
                'ts': 1825574400,
                'time': '2027-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          102:
              {
                'ts': 1836464400,
                'time': '2028-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          103:
              {
                'ts': 1857024000,
                'time': '2028-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          104:
              {
                'ts': 1867914000,
                'time': '2029-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          105:
              {
                'ts': 1888473600,
                'time': '2029-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          106:
              {
                'ts': 1899363600,
                'time': '2030-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          107:
              {
                'ts': 1919923200,
                'time': '2030-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          108:
              {
                'ts': 1930813200,
                'time': '2031-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          109:
              {
                'ts': 1951372800,
                'time': '2031-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          110:
              {
                'ts': 1962867600,
                'time': '2032-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          111:
              {
                'ts': 1983427200,
                'time': '2032-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          112:
              {
                'ts': 1994317200,
                'time': '2033-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          113:
              {
                'ts': 2014876800,
                'time': '2033-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          114:
              {
                'ts': 2025766800,
                'time': '2034-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          115:
              {
                'ts': 2046326400,
                'time': '2034-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          116:
              {
                'ts': 2057216400,
                'time': '2035-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          117:
              {
                'ts': 2077776000,
                'time': '2035-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          118:
              {
                'ts': 2088666000,
                'time': '2036-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          119:
              {
                'ts': 2109225600,
                'time': '2036-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          120:
              {
                'ts': 2120115600,
                'time': '2037-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          121:
              {
                'ts': 2140675200,
                'time': '2037-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'Antarctica/Casey':
        {
          0:
              {
                'ts': -31536000,
                'time': '1969-01-01T00:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              }
        },
    'Antarctica/Davis':
        {
          0:
              {
                'ts': -409190400,
                'time': '1957-01-13T00:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'DAVT'
              },
          1:
              {
                'ts': -163062000,
                'time': '1964-10-31T17:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'zzz'
              },
          2:
              {
                'ts': -28857600,
                'time': '1969-02-01T00:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'DAVT'
              }
        },
    'Antarctica/DumontDUrville':
        {
          0:
              {
                'ts': -725846400,
                'time': '1947-01-01T00:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'PMT'
              },
          1:
              {
                'ts': -566992800,
                'time': '1952-01-13T14:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'zzz'
              },
          2:
              {
                'ts': -415497600,
                'time': '1956-11-01T00:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'DDUT'
              }
        },
    'Antarctica/Mawson':
        {
          0:
              {
                'ts': -501206400,
                'time': '1954-02-13T00:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'MAWT'
              }
        },
    'Antarctica/McMurdo':
        {
          0:
              {
                'ts': -441849600,
                'time': '1956-01-01T00:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          1:
              {
                'ts': 152632800,
                'time': '1974-11-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          2:
              {
                'ts': 162309600,
                'time': '1975-02-22T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          3:
              {
                'ts': 183477600,
                'time': '1975-10-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          4:
              {
                'ts': 194968800,
                'time': '1976-03-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          5:
              {
                'ts': 215532000,
                'time': '1976-10-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          6:
              {
                'ts': 226418400,
                'time': '1977-03-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          7:
              {
                'ts': 246981600,
                'time': '1977-10-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          8:
              {
                'ts': 257868000,
                'time': '1978-03-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          9:
              {
                'ts': 278431200,
                'time': '1978-10-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          10:
              {
                'ts': 289317600,
                'time': '1979-03-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          11:
              {
                'ts': 309880800,
                'time': '1979-10-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          12:
              {
                'ts': 320767200,
                'time': '1980-03-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          13:
              {
                'ts': 341330400,
                'time': '1980-10-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          14:
              {
                'ts': 352216800,
                'time': '1981-02-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          15:
              {
                'ts': 372780000,
                'time': '1981-10-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          16:
              {
                'ts': 384271200,
                'time': '1982-03-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          17:
              {
                'ts': 404834400,
                'time': '1982-10-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          18:
              {
                'ts': 415720800,
                'time': '1983-03-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          19:
              {
                'ts': 436284000,
                'time': '1983-10-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          20:
              {
                'ts': 447170400,
                'time': '1984-03-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          21:
              {
                'ts': 467733600,
                'time': '1984-10-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          22:
              {
                'ts': 478620000,
                'time': '1985-03-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          23:
              {
                'ts': 499183200,
                'time': '1985-10-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          24:
              {
                'ts': 510069600,
                'time': '1986-03-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          25:
              {
                'ts': 530632800,
                'time': '1986-10-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          26:
              {
                'ts': 541519200,
                'time': '1987-02-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          27:
              {
                'ts': 562082400,
                'time': '1987-10-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          28:
              {
                'ts': 573573600,
                'time': '1988-03-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          29:
              {
                'ts': 594136800,
                'time': '1988-10-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          30:
              {
                'ts': 605023200,
                'time': '1989-03-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          31:
              {
                'ts': 623772000,
                'time': '1989-10-07T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          32:
              {
                'ts': 637682400,
                'time': '1990-03-17T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          33:
              {
                'ts': 655221600,
                'time': '1990-10-06T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          34:
              {
                'ts': 669132000,
                'time': '1991-03-16T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          35:
              {
                'ts': 686671200,
                'time': '1991-10-05T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          36:
              {
                'ts': 700581600,
                'time': '1992-03-14T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          37:
              {
                'ts': 718120800,
                'time': '1992-10-03T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          38:
              {
                'ts': 732636000,
                'time': '1993-03-20T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          39:
              {
                'ts': 749570400,
                'time': '1993-10-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          40:
              {
                'ts': 764085600,
                'time': '1994-03-19T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          41:
              {
                'ts': 781020000,
                'time': '1994-10-01T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          42:
              {
                'ts': 795535200,
                'time': '1995-03-18T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          43:
              {
                'ts': 812469600,
                'time': '1995-09-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          44:
              {
                'ts': 826984800,
                'time': '1996-03-16T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          45:
              {
                'ts': 844524000,
                'time': '1996-10-05T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          46:
              {
                'ts': 858434400,
                'time': '1997-03-15T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          47:
              {
                'ts': 875973600,
                'time': '1997-10-04T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          48:
              {
                'ts': 889884000,
                'time': '1998-03-14T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          49:
              {
                'ts': 907423200,
                'time': '1998-10-03T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          50:
              {
                'ts': 921938400,
                'time': '1999-03-20T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          51:
              {
                'ts': 938872800,
                'time': '1999-10-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          52:
              {
                'ts': 953388000,
                'time': '2000-03-18T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          53:
              {
                'ts': 970322400,
                'time': '2000-09-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          54:
              {
                'ts': 984837600,
                'time': '2001-03-17T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          55:
              {
                'ts': 1002376800,
                'time': '2001-10-06T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          56:
              {
                'ts': 1016287200,
                'time': '2002-03-16T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          57:
              {
                'ts': 1033826400,
                'time': '2002-10-05T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          58:
              {
                'ts': 1047736800,
                'time': '2003-03-15T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          59:
              {
                'ts': 1065276000,
                'time': '2003-10-04T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          60:
              {
                'ts': 1079791200,
                'time': '2004-03-20T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          61:
              {
                'ts': 1096725600,
                'time': '2004-10-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          62:
              {
                'ts': 1111240800,
                'time': '2005-03-19T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          63:
              {
                'ts': 1128175200,
                'time': '2005-10-01T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          64:
              {
                'ts': 1142690400,
                'time': '2006-03-18T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          65:
              {
                'ts': 1159624800,
                'time': '2006-09-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          66:
              {
                'ts': 1174140000,
                'time': '2007-03-17T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          67:
              {
                'ts': 1191074400,
                'time': '2007-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          68:
              {
                'ts': 1207404000,
                'time': '2008-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          69:
              {
                'ts': 1222524000,
                'time': '2008-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          70:
              {
                'ts': 1238853600,
                'time': '2009-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          71:
              {
                'ts': 1253973600,
                'time': '2009-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          72:
              {
                'ts': 1270303200,
                'time': '2010-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          73:
              {
                'ts': 1285423200,
                'time': '2010-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          74:
              {
                'ts': 1301752800,
                'time': '2011-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          75:
              {
                'ts': 1316872800,
                'time': '2011-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          76:
              {
                'ts': 1333202400,
                'time': '2012-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          77:
              {
                'ts': 1348927200,
                'time': '2012-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          78:
              {
                'ts': 1365256800,
                'time': '2013-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          79:
              {
                'ts': 1380376800,
                'time': '2013-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          80:
              {
                'ts': 1396706400,
                'time': '2014-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          81:
              {
                'ts': 1411826400,
                'time': '2014-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          82:
              {
                'ts': 1428156000,
                'time': '2015-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          83:
              {
                'ts': 1443276000,
                'time': '2015-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          84:
              {
                'ts': 1459605600,
                'time': '2016-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          85:
              {
                'ts': 1474725600,
                'time': '2016-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          86:
              {
                'ts': 1491055200,
                'time': '2017-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          87:
              {
                'ts': 1506175200,
                'time': '2017-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          88:
              {
                'ts': 1522504800,
                'time': '2018-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          89:
              {
                'ts': 1538229600,
                'time': '2018-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          90:
              {
                'ts': 1554559200,
                'time': '2019-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          91:
              {
                'ts': 1569679200,
                'time': '2019-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          92:
              {
                'ts': 1586008800,
                'time': '2020-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          93:
              {
                'ts': 1601128800,
                'time': '2020-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          94:
              {
                'ts': 1617458400,
                'time': '2021-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          95:
              {
                'ts': 1632578400,
                'time': '2021-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          96:
              {
                'ts': 1648908000,
                'time': '2022-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          97:
              {
                'ts': 1664028000,
                'time': '2022-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          98:
              {
                'ts': 1680357600,
                'time': '2023-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          99:
              {
                'ts': 1695477600,
                'time': '2023-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          100:
              {
                'ts': 1712412000,
                'time': '2024-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          101:
              {
                'ts': 1727532000,
                'time': '2024-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          102:
              {
                'ts': 1743861600,
                'time': '2025-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          103:
              {
                'ts': 1758981600,
                'time': '2025-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          104:
              {
                'ts': 1775311200,
                'time': '2026-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          105:
              {
                'ts': 1790431200,
                'time': '2026-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          106:
              {
                'ts': 1806760800,
                'time': '2027-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          107:
              {
                'ts': 1821880800,
                'time': '2027-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          108:
              {
                'ts': 1838210400,
                'time': '2028-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          109:
              {
                'ts': 1853330400,
                'time': '2028-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          110:
              {
                'ts': 1869660000,
                'time': '2029-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          111:
              {
                'ts': 1885384800,
                'time': '2029-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          112:
              {
                'ts': 1901714400,
                'time': '2030-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          113:
              {
                'ts': 1916834400,
                'time': '2030-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          114:
              {
                'ts': 1933164000,
                'time': '2031-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          115:
              {
                'ts': 1948284000,
                'time': '2031-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          116:
              {
                'ts': 1964613600,
                'time': '2032-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          117:
              {
                'ts': 1979733600,
                'time': '2032-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          118:
              {
                'ts': 1996063200,
                'time': '2033-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          119:
              {
                'ts': 2011183200,
                'time': '2033-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          120:
              {
                'ts': 2027512800,
                'time': '2034-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          121:
              {
                'ts': 2042632800,
                'time': '2034-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          122:
              {
                'ts': 2058962400,
                'time': '2035-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          123:
              {
                'ts': 2074687200,
                'time': '2035-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          124:
              {
                'ts': 2091016800,
                'time': '2036-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          125:
              {
                'ts': 2106136800,
                'time': '2036-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          126:
              {
                'ts': 2122466400,
                'time': '2037-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          127:
              {
                'ts': 2137586400,
                'time': '2037-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              }
        },
    'Antarctica/Palmer':
        {
          0:
              {
                'ts': -157766400,
                'time': '1965-01-01T00:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          1:
              {
                'ts': -152658000,
                'time': '1965-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          2:
              {
                'ts': -132955200,
                'time': '1965-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          3:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          4:
              {
                'ts': -101419200,
                'time': '1966-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          5:
              {
                'ts': -86821200,
                'time': '1967-04-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          6:
              {
                'ts': -71092800,
                'time': '1967-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          7:
              {
                'ts': -54766800,
                'time': '1968-04-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          8:
              {
                'ts': -39038400,
                'time': '1968-10-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ARST'
              },
          9:
              {
                'ts': -23317200,
                'time': '1969-04-06T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'ART'
              },
          10:
              {
                'ts': -7588800,
                'time': '1969-10-05T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          11:
              {
                'ts': 128142000,
                'time': '1974-01-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'ARST'
              },
          12:
              {
                'ts': 136605600,
                'time': '1974-05-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ART'
              },
          13:
              {
                'ts': 389070000,
                'time': '1982-05-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          14:
              {
                'ts': 403070400,
                'time': '1982-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          15:
              {
                'ts': 416372400,
                'time': '1983-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          16:
              {
                'ts': 434520000,
                'time': '1983-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          17:
              {
                'ts': 447822000,
                'time': '1984-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          18:
              {
                'ts': 466574400,
                'time': '1984-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          19:
              {
                'ts': 479271600,
                'time': '1985-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          20:
              {
                'ts': 498024000,
                'time': '1985-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          21:
              {
                'ts': 510721200,
                'time': '1986-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          22:
              {
                'ts': 529473600,
                'time': '1986-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          23:
              {
                'ts': 545194800,
                'time': '1987-04-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          24:
              {
                'ts': 560923200,
                'time': '1987-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          25:
              {
                'ts': 574225200,
                'time': '1988-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          26:
              {
                'ts': 591768000,
                'time': '1988-10-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          27:
              {
                'ts': 605674800,
                'time': '1989-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          28:
              {
                'ts': 624427200,
                'time': '1989-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          29:
              {
                'ts': 637729200,
                'time': '1990-03-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          30:
              {
                'ts': 653457600,
                'time': '1990-09-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          31:
              {
                'ts': 668574000,
                'time': '1991-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          32:
              {
                'ts': 687326400,
                'time': '1991-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          33:
              {
                'ts': 700628400,
                'time': '1992-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          34:
              {
                'ts': 718776000,
                'time': '1992-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          35:
              {
                'ts': 732078000,
                'time': '1993-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          36:
              {
                'ts': 750225600,
                'time': '1993-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          37:
              {
                'ts': 763527600,
                'time': '1994-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          38:
              {
                'ts': 781675200,
                'time': '1994-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          39:
              {
                'ts': 794977200,
                'time': '1995-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          40:
              {
                'ts': 813729600,
                'time': '1995-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          41:
              {
                'ts': 826426800,
                'time': '1996-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          42:
              {
                'ts': 845179200,
                'time': '1996-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          43:
              {
                'ts': 859690800,
                'time': '1997-03-30T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          44:
              {
                'ts': 876628800,
                'time': '1997-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          45:
              {
                'ts': 889930800,
                'time': '1998-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          46:
              {
                'ts': 906868800,
                'time': '1998-09-27T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          47:
              {
                'ts': 923194800,
                'time': '1999-04-04T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          48:
              {
                'ts': 939528000,
                'time': '1999-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          49:
              {
                'ts': 952830000,
                'time': '2000-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          50:
              {
                'ts': 971582400,
                'time': '2000-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          51:
              {
                'ts': 984279600,
                'time': '2001-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          52:
              {
                'ts': 1003032000,
                'time': '2001-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          53:
              {
                'ts': 1015729200,
                'time': '2002-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          54:
              {
                'ts': 1034481600,
                'time': '2002-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          55:
              {
                'ts': 1047178800,
                'time': '2003-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          56:
              {
                'ts': 1065931200,
                'time': '2003-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          57:
              {
                'ts': 1079233200,
                'time': '2004-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          58:
              {
                'ts': 1097380800,
                'time': '2004-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          59:
              {
                'ts': 1110682800,
                'time': '2005-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          60:
              {
                'ts': 1128830400,
                'time': '2005-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          61:
              {
                'ts': 1142132400,
                'time': '2006-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          62:
              {
                'ts': 1160884800,
                'time': '2006-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          63:
              {
                'ts': 1173582000,
                'time': '2007-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          64:
              {
                'ts': 1192334400,
                'time': '2007-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          65:
              {
                'ts': 1205031600,
                'time': '2008-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          66:
              {
                'ts': 1223784000,
                'time': '2008-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          67:
              {
                'ts': 1237086000,
                'time': '2009-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          68:
              {
                'ts': 1255233600,
                'time': '2009-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          69:
              {
                'ts': 1268535600,
                'time': '2010-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          70:
              {
                'ts': 1286683200,
                'time': '2010-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          71:
              {
                'ts': 1299985200,
                'time': '2011-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          72:
              {
                'ts': 1318132800,
                'time': '2011-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          73:
              {
                'ts': 1331434800,
                'time': '2012-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          74:
              {
                'ts': 1350187200,
                'time': '2012-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          75:
              {
                'ts': 1362884400,
                'time': '2013-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          76:
              {
                'ts': 1381636800,
                'time': '2013-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          77:
              {
                'ts': 1394334000,
                'time': '2014-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          78:
              {
                'ts': 1413086400,
                'time': '2014-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          79:
              {
                'ts': 1426388400,
                'time': '2015-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          80:
              {
                'ts': 1444536000,
                'time': '2015-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          81:
              {
                'ts': 1457838000,
                'time': '2016-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          82:
              {
                'ts': 1475985600,
                'time': '2016-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          83:
              {
                'ts': 1489287600,
                'time': '2017-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          84:
              {
                'ts': 1508040000,
                'time': '2017-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          85:
              {
                'ts': 1520737200,
                'time': '2018-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          86:
              {
                'ts': 1539489600,
                'time': '2018-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          87:
              {
                'ts': 1552186800,
                'time': '2019-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          88:
              {
                'ts': 1570939200,
                'time': '2019-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          89:
              {
                'ts': 1584241200,
                'time': '2020-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          90:
              {
                'ts': 1602388800,
                'time': '2020-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          91:
              {
                'ts': 1615690800,
                'time': '2021-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          92:
              {
                'ts': 1633838400,
                'time': '2021-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          93:
              {
                'ts': 1647140400,
                'time': '2022-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          94:
              {
                'ts': 1665288000,
                'time': '2022-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          95:
              {
                'ts': 1678590000,
                'time': '2023-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          96:
              {
                'ts': 1697342400,
                'time': '2023-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          97:
              {
                'ts': 1710039600,
                'time': '2024-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          98:
              {
                'ts': 1728792000,
                'time': '2024-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          99:
              {
                'ts': 1741489200,
                'time': '2025-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          100:
              {
                'ts': 1760241600,
                'time': '2025-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          101:
              {
                'ts': 1773543600,
                'time': '2026-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          102:
              {
                'ts': 1791691200,
                'time': '2026-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          103:
              {
                'ts': 1804993200,
                'time': '2027-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          104:
              {
                'ts': 1823140800,
                'time': '2027-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          105:
              {
                'ts': 1836442800,
                'time': '2028-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          106:
              {
                'ts': 1855195200,
                'time': '2028-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          107:
              {
                'ts': 1867892400,
                'time': '2029-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          108:
              {
                'ts': 1886644800,
                'time': '2029-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          109:
              {
                'ts': 1899342000,
                'time': '2030-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          110:
              {
                'ts': 1918094400,
                'time': '2030-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          111:
              {
                'ts': 1930791600,
                'time': '2031-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          112:
              {
                'ts': 1949544000,
                'time': '2031-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          113:
              {
                'ts': 1962846000,
                'time': '2032-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          114:
              {
                'ts': 1980993600,
                'time': '2032-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          115:
              {
                'ts': 1994295600,
                'time': '2033-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          116:
              {
                'ts': 2012443200,
                'time': '2033-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          117:
              {
                'ts': 2025745200,
                'time': '2034-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          118:
              {
                'ts': 2044497600,
                'time': '2034-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          119:
              {
                'ts': 2057194800,
                'time': '2035-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          120:
              {
                'ts': 2075947200,
                'time': '2035-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          121:
              {
                'ts': 2088644400,
                'time': '2036-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          122:
              {
                'ts': 2107396800,
                'time': '2036-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          123:
              {
                'ts': 2120698800,
                'time': '2037-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          124:
              {
                'ts': 2138846400,
                'time': '2037-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              }
        },
    'Antarctica/Rothera':
        {
          0:
              {
                'ts': 218246400,
                'time': '1976-12-01T00:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'ROTT'
              }
        },
    'Antarctica/South_Pole':
        {
          0:
              {
                'ts': -441849600,
                'time': '1956-01-01T00:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          1:
              {
                'ts': 152632800,
                'time': '1974-11-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          2:
              {
                'ts': 162309600,
                'time': '1975-02-22T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          3:
              {
                'ts': 183477600,
                'time': '1975-10-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          4:
              {
                'ts': 194968800,
                'time': '1976-03-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          5:
              {
                'ts': 215532000,
                'time': '1976-10-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          6:
              {
                'ts': 226418400,
                'time': '1977-03-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          7:
              {
                'ts': 246981600,
                'time': '1977-10-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          8:
              {
                'ts': 257868000,
                'time': '1978-03-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          9:
              {
                'ts': 278431200,
                'time': '1978-10-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          10:
              {
                'ts': 289317600,
                'time': '1979-03-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          11:
              {
                'ts': 309880800,
                'time': '1979-10-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          12:
              {
                'ts': 320767200,
                'time': '1980-03-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          13:
              {
                'ts': 341330400,
                'time': '1980-10-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          14:
              {
                'ts': 352216800,
                'time': '1981-02-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          15:
              {
                'ts': 372780000,
                'time': '1981-10-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          16:
              {
                'ts': 384271200,
                'time': '1982-03-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          17:
              {
                'ts': 404834400,
                'time': '1982-10-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          18:
              {
                'ts': 415720800,
                'time': '1983-03-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          19:
              {
                'ts': 436284000,
                'time': '1983-10-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          20:
              {
                'ts': 447170400,
                'time': '1984-03-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          21:
              {
                'ts': 467733600,
                'time': '1984-10-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          22:
              {
                'ts': 478620000,
                'time': '1985-03-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          23:
              {
                'ts': 499183200,
                'time': '1985-10-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          24:
              {
                'ts': 510069600,
                'time': '1986-03-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          25:
              {
                'ts': 530632800,
                'time': '1986-10-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          26:
              {
                'ts': 541519200,
                'time': '1987-02-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          27:
              {
                'ts': 562082400,
                'time': '1987-10-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          28:
              {
                'ts': 573573600,
                'time': '1988-03-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          29:
              {
                'ts': 594136800,
                'time': '1988-10-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          30:
              {
                'ts': 605023200,
                'time': '1989-03-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          31:
              {
                'ts': 623772000,
                'time': '1989-10-07T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          32:
              {
                'ts': 637682400,
                'time': '1990-03-17T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          33:
              {
                'ts': 655221600,
                'time': '1990-10-06T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          34:
              {
                'ts': 669132000,
                'time': '1991-03-16T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          35:
              {
                'ts': 686671200,
                'time': '1991-10-05T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          36:
              {
                'ts': 700581600,
                'time': '1992-03-14T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          37:
              {
                'ts': 718120800,
                'time': '1992-10-03T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          38:
              {
                'ts': 732636000,
                'time': '1993-03-20T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          39:
              {
                'ts': 749570400,
                'time': '1993-10-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          40:
              {
                'ts': 764085600,
                'time': '1994-03-19T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          41:
              {
                'ts': 781020000,
                'time': '1994-10-01T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          42:
              {
                'ts': 795535200,
                'time': '1995-03-18T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          43:
              {
                'ts': 812469600,
                'time': '1995-09-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          44:
              {
                'ts': 826984800,
                'time': '1996-03-16T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          45:
              {
                'ts': 844524000,
                'time': '1996-10-05T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          46:
              {
                'ts': 858434400,
                'time': '1997-03-15T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          47:
              {
                'ts': 875973600,
                'time': '1997-10-04T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          48:
              {
                'ts': 889884000,
                'time': '1998-03-14T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          49:
              {
                'ts': 907423200,
                'time': '1998-10-03T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          50:
              {
                'ts': 921938400,
                'time': '1999-03-20T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          51:
              {
                'ts': 938872800,
                'time': '1999-10-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          52:
              {
                'ts': 953388000,
                'time': '2000-03-18T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          53:
              {
                'ts': 970322400,
                'time': '2000-09-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          54:
              {
                'ts': 984837600,
                'time': '2001-03-17T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          55:
              {
                'ts': 1002376800,
                'time': '2001-10-06T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          56:
              {
                'ts': 1016287200,
                'time': '2002-03-16T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          57:
              {
                'ts': 1033826400,
                'time': '2002-10-05T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          58:
              {
                'ts': 1047736800,
                'time': '2003-03-15T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          59:
              {
                'ts': 1065276000,
                'time': '2003-10-04T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          60:
              {
                'ts': 1079791200,
                'time': '2004-03-20T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          61:
              {
                'ts': 1096725600,
                'time': '2004-10-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          62:
              {
                'ts': 1111240800,
                'time': '2005-03-19T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          63:
              {
                'ts': 1128175200,
                'time': '2005-10-01T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          64:
              {
                'ts': 1142690400,
                'time': '2006-03-18T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          65:
              {
                'ts': 1159624800,
                'time': '2006-09-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          66:
              {
                'ts': 1174140000,
                'time': '2007-03-17T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          67:
              {
                'ts': 1191074400,
                'time': '2007-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          68:
              {
                'ts': 1207404000,
                'time': '2008-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          69:
              {
                'ts': 1222524000,
                'time': '2008-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          70:
              {
                'ts': 1238853600,
                'time': '2009-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          71:
              {
                'ts': 1253973600,
                'time': '2009-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          72:
              {
                'ts': 1270303200,
                'time': '2010-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          73:
              {
                'ts': 1285423200,
                'time': '2010-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          74:
              {
                'ts': 1301752800,
                'time': '2011-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          75:
              {
                'ts': 1316872800,
                'time': '2011-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          76:
              {
                'ts': 1333202400,
                'time': '2012-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          77:
              {
                'ts': 1348927200,
                'time': '2012-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          78:
              {
                'ts': 1365256800,
                'time': '2013-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          79:
              {
                'ts': 1380376800,
                'time': '2013-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          80:
              {
                'ts': 1396706400,
                'time': '2014-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          81:
              {
                'ts': 1411826400,
                'time': '2014-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          82:
              {
                'ts': 1428156000,
                'time': '2015-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          83:
              {
                'ts': 1443276000,
                'time': '2015-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          84:
              {
                'ts': 1459605600,
                'time': '2016-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          85:
              {
                'ts': 1474725600,
                'time': '2016-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          86:
              {
                'ts': 1491055200,
                'time': '2017-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          87:
              {
                'ts': 1506175200,
                'time': '2017-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          88:
              {
                'ts': 1522504800,
                'time': '2018-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          89:
              {
                'ts': 1538229600,
                'time': '2018-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          90:
              {
                'ts': 1554559200,
                'time': '2019-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          91:
              {
                'ts': 1569679200,
                'time': '2019-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          92:
              {
                'ts': 1586008800,
                'time': '2020-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          93:
              {
                'ts': 1601128800,
                'time': '2020-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          94:
              {
                'ts': 1617458400,
                'time': '2021-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          95:
              {
                'ts': 1632578400,
                'time': '2021-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          96:
              {
                'ts': 1648908000,
                'time': '2022-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          97:
              {
                'ts': 1664028000,
                'time': '2022-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          98:
              {
                'ts': 1680357600,
                'time': '2023-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          99:
              {
                'ts': 1695477600,
                'time': '2023-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          100:
              {
                'ts': 1712412000,
                'time': '2024-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          101:
              {
                'ts': 1727532000,
                'time': '2024-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          102:
              {
                'ts': 1743861600,
                'time': '2025-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          103:
              {
                'ts': 1758981600,
                'time': '2025-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          104:
              {
                'ts': 1775311200,
                'time': '2026-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          105:
              {
                'ts': 1790431200,
                'time': '2026-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          106:
              {
                'ts': 1806760800,
                'time': '2027-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          107:
              {
                'ts': 1821880800,
                'time': '2027-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          108:
              {
                'ts': 1838210400,
                'time': '2028-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          109:
              {
                'ts': 1853330400,
                'time': '2028-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          110:
              {
                'ts': 1869660000,
                'time': '2029-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          111:
              {
                'ts': 1885384800,
                'time': '2029-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          112:
              {
                'ts': 1901714400,
                'time': '2030-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          113:
              {
                'ts': 1916834400,
                'time': '2030-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          114:
              {
                'ts': 1933164000,
                'time': '2031-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          115:
              {
                'ts': 1948284000,
                'time': '2031-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          116:
              {
                'ts': 1964613600,
                'time': '2032-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          117:
              {
                'ts': 1979733600,
                'time': '2032-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          118:
              {
                'ts': 1996063200,
                'time': '2033-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          119:
              {
                'ts': 2011183200,
                'time': '2033-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          120:
              {
                'ts': 2027512800,
                'time': '2034-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          121:
              {
                'ts': 2042632800,
                'time': '2034-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          122:
              {
                'ts': 2058962400,
                'time': '2035-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          123:
              {
                'ts': 2074687200,
                'time': '2035-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          124:
              {
                'ts': 2091016800,
                'time': '2036-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          125:
              {
                'ts': 2106136800,
                'time': '2036-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          126:
              {
                'ts': 2122466400,
                'time': '2037-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          127:
              {
                'ts': 2137586400,
                'time': '2037-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              }
        },
    'Antarctica/Syowa':
        {
          0:
              {
                'ts': -407808000,
                'time': '1957-01-29T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'SYOT'
              }
        },
    'Antarctica/Vostok':
        {
          0:
              {
                'ts': -380073600,
                'time': '1957-12-16T00:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'VOST'
              }
        },
    'Arctic/Longyearbyen':
        {
          0:
              {
                'ts': -1691884800,
                'time': '1916-05-22T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680573600,
                'time': '1916-09-29T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -927511200,
                'time': '1940-08-10T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -765327600,
                'time': '1945-10-01T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -340844400,
                'time': '1959-03-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -324514800,
                'time': '1959-09-20T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -308790000,
                'time': '1960-03-20T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -293065200,
                'time': '1960-09-18T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': -277340400,
                'time': '1961-03-19T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -261615600,
                'time': '1961-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': -245890800,
                'time': '1962-03-18T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          17:
              {
                'ts': -230166000,
                'time': '1962-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': -214441200,
                'time': '1963-03-17T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': -198716400,
                'time': '1963-09-15T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          20:
              {
                'ts': -182991600,
                'time': '1964-03-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          21:
              {
                'ts': -166662000,
                'time': '1964-09-20T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': -147913200,
                'time': '1965-04-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          23:
              {
                'ts': -135212400,
                'time': '1965-09-19T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          24:
              {
                'ts': 315529200,
                'time': '1979-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Asia/Aden':
        {
          0:
              {
                'ts': -631162848,
                'time': '1949-12-31T20:59:12+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'Asia/Almaty':
        {
          0:
              {
                'ts': -1441170468,
                'time': '1924-05-01T18:52:12+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ALMT'
              },
          1:
              {
                'ts': -1247547600,
                'time': '1930-06-20T19:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          2:
              {
                'ts': 354909600,
                'time': '1981-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          3:
              {
                'ts': 370717200,
                'time': '1981-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          4:
              {
                'ts': 386445600,
                'time': '1982-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          5:
              {
                'ts': 402253200,
                'time': '1982-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          6:
              {
                'ts': 417981600,
                'time': '1983-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          7:
              {
                'ts': 433789200,
                'time': '1983-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          8:
              {
                'ts': 449604000,
                'time': '1984-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          9:
              {
                'ts': 465336000,
                'time': '1984-09-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          10:
              {
                'ts': 481060800,
                'time': '1985-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          11:
              {
                'ts': 496785600,
                'time': '1985-09-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          12:
              {
                'ts': 512510400,
                'time': '1986-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          13:
              {
                'ts': 528235200,
                'time': '1986-09-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          14:
              {
                'ts': 543960000,
                'time': '1987-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          15:
              {
                'ts': 559684800,
                'time': '1987-09-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          16:
              {
                'ts': 575409600,
                'time': '1988-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          17:
              {
                'ts': 591134400,
                'time': '1988-09-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          18:
              {
                'ts': 606859200,
                'time': '1989-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          19:
              {
                'ts': 622584000,
                'time': '1989-09-23T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          20:
              {
                'ts': 638308800,
                'time': '1990-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          21:
              {
                'ts': 654638400,
                'time': '1990-09-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          22:
              {
                'ts': 662666400,
                'time': '1990-12-31T18:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          23:
              {
                'ts': 701802000,
                'time': '1992-03-28T17:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          24:
              {
                'ts': 717523200,
                'time': '1992-09-26T16:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          25:
              {
                'ts': 733262400,
                'time': '1993-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          26:
              {
                'ts': 748987200,
                'time': '1993-09-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          27:
              {
                'ts': 764712000,
                'time': '1994-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          28:
              {
                'ts': 780436800,
                'time': '1994-09-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          29:
              {
                'ts': 796161600,
                'time': '1995-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          30:
              {
                'ts': 811886400,
                'time': '1995-09-23T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          31:
              {
                'ts': 828216000,
                'time': '1996-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          32:
              {
                'ts': 846360000,
                'time': '1996-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          33:
              {
                'ts': 859665600,
                'time': '1997-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          34:
              {
                'ts': 877809600,
                'time': '1997-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          35:
              {
                'ts': 891115200,
                'time': '1998-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          36:
              {
                'ts': 909259200,
                'time': '1998-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          37:
              {
                'ts': 922564800,
                'time': '1999-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          38:
              {
                'ts': 941313600,
                'time': '1999-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          39:
              {
                'ts': 954014400,
                'time': '2000-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          40:
              {
                'ts': 972763200,
                'time': '2000-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          41:
              {
                'ts': 985464000,
                'time': '2001-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          42:
              {
                'ts': 1004212800,
                'time': '2001-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          43:
              {
                'ts': 1017518400,
                'time': '2002-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          44:
              {
                'ts': 1035662400,
                'time': '2002-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          45:
              {
                'ts': 1048968000,
                'time': '2003-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          46:
              {
                'ts': 1067112000,
                'time': '2003-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          47:
              {
                'ts': 1080417600,
                'time': '2004-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'ALMST'
              },
          48:
              {
                'ts': 1099166400,
                'time': '2004-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              },
          49:
              {
                'ts': 1110823200,
                'time': '2005-03-14T18:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'ALMT'
              }
        },
    'Asia/Amman':
        {
          0:
              {
                'ts': -1230776624,
                'time': '1930-12-31T21:36:16+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': 108165600,
                'time': '1973-06-05T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          2:
              {
                'ts': 118270800,
                'time': '1973-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': 136591200,
                'time': '1974-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          4:
              {
                'ts': 149806800,
                'time': '1974-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': 168127200,
                'time': '1975-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          6:
              {
                'ts': 181342800,
                'time': '1975-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': 199749600,
                'time': '1976-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': 215643600,
                'time': '1976-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': 231285600,
                'time': '1977-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          10:
              {
                'ts': 244501200,
                'time': '1977-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          11:
              {
                'ts': 262735200,
                'time': '1978-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          12:
              {
                'ts': 275950800,
                'time': '1978-09-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': 481154400,
                'time': '1985-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          14:
              {
                'ts': 496962000,
                'time': '1985-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          15:
              {
                'ts': 512949600,
                'time': '1986-04-03T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          16:
              {
                'ts': 528670800,
                'time': '1986-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          17:
              {
                'ts': 544399200,
                'time': '1987-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          18:
              {
                'ts': 560120400,
                'time': '1987-10-01T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          19:
              {
                'ts': 575848800,
                'time': '1988-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          20:
              {
                'ts': 592174800,
                'time': '1988-10-06T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          21:
              {
                'ts': 610581600,
                'time': '1989-05-07T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          22:
              {
                'ts': 623624400,
                'time': '1989-10-05T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          23:
              {
                'ts': 641167200,
                'time': '1990-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          24:
              {
                'ts': 655074000,
                'time': '1990-10-04T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          25:
              {
                'ts': 671839200,
                'time': '1991-04-16T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          26:
              {
                'ts': 685918800,
                'time': '1991-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': 702856800,
                'time': '1992-04-09T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': 717973200,
                'time': '1992-10-01T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 733701600,
                'time': '1993-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 749422800,
                'time': '1993-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 765151200,
                'time': '1994-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 779662800,
                'time': '1994-09-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 797205600,
                'time': '1995-04-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 811116000,
                'time': '1995-09-14T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 828655200,
                'time': '1996-04-04T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 843170400,
                'time': '1996-09-19T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 860104800,
                'time': '1997-04-03T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 874620000,
                'time': '1997-09-18T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 891554400,
                'time': '1998-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 906069600,
                'time': '1998-09-17T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 930780000,
                'time': '1999-06-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 938642400,
                'time': '1999-09-29T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 954367200,
                'time': '2000-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 970092000,
                'time': '2000-09-27T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 985816800,
                'time': '2001-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 1001541600,
                'time': '2001-09-26T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 1017266400,
                'time': '2002-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 1032991200,
                'time': '2002-09-25T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 1048716000,
                'time': '2003-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 1066946400,
                'time': '2003-10-23T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 1080165600,
                'time': '2004-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 1097791200,
                'time': '2004-10-14T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 1112220000,
                'time': '2005-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1128031200,
                'time': '2005-09-29T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1143669600,
                'time': '2006-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1161900000,
                'time': '2006-10-26T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1175119200,
                'time': '2007-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1193349600,
                'time': '2007-10-25T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1206568800,
                'time': '2008-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1225404000,
                'time': '2008-10-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1238018400,
                'time': '2009-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1256853600,
                'time': '2009-10-29T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1269468000,
                'time': '2010-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1288303200,
                'time': '2010-10-28T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1301522400,
                'time': '2011-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1319752800,
                'time': '2011-10-27T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1332972000,
                'time': '2012-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1351202400,
                'time': '2012-10-25T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1364421600,
                'time': '2013-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1382652000,
                'time': '2013-10-24T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1395871200,
                'time': '2014-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1414706400,
                'time': '2014-10-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1427320800,
                'time': '2015-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1446156000,
                'time': '2015-10-29T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1459375200,
                'time': '2016-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1477605600,
                'time': '2016-10-27T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1490824800,
                'time': '2017-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1509055200,
                'time': '2017-10-26T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1522274400,
                'time': '2018-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1540504800,
                'time': '2018-10-25T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1553724000,
                'time': '2019-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1571954400,
                'time': '2019-10-24T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1585173600,
                'time': '2020-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1604008800,
                'time': '2020-10-29T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1616623200,
                'time': '2021-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1635458400,
                'time': '2021-10-28T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1648677600,
                'time': '2022-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1666908000,
                'time': '2022-10-27T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1680127200,
                'time': '2023-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1698357600,
                'time': '2023-10-26T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1711576800,
                'time': '2024-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1729807200,
                'time': '2024-10-24T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1743026400,
                'time': '2025-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1761861600,
                'time': '2025-10-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1774476000,
                'time': '2026-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1793311200,
                'time': '2026-10-29T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1805925600,
                'time': '2027-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1824760800,
                'time': '2027-10-28T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1837980000,
                'time': '2028-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1856210400,
                'time': '2028-10-26T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1869429600,
                'time': '2029-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1887660000,
                'time': '2029-10-25T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1900879200,
                'time': '2030-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1919109600,
                'time': '2030-10-24T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1932328800,
                'time': '2031-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1951164000,
                'time': '2031-10-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1963778400,
                'time': '2032-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1982613600,
                'time': '2032-10-28T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1995832800,
                'time': '2033-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 2014063200,
                'time': '2033-10-27T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 2027282400,
                'time': '2034-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 2045512800,
                'time': '2034-10-26T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 2058732000,
                'time': '2035-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 2076962400,
                'time': '2035-10-25T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 2090181600,
                'time': '2036-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 2109016800,
                'time': '2036-10-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 2121631200,
                'time': '2037-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 2140466400,
                'time': '2037-10-29T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Asia/Anadyr':
        {
          0:
              {
                'ts': -1441194596,
                'time': '1924-05-01T12:10:04+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          1:
              {
                'ts': -1247572800,
                'time': '1930-06-20T12:00:00+0000',
                'offset': 46800,
                'isdst': false,
                'abbr': 'ANAT'
              },
          2:
              {
                'ts': 354884400,
                'time': '1981-03-31T11:00:00+0000',
                'offset': 50400,
                'isdst': true,
                'abbr': 'ANAST'
              },
          3:
              {
                'ts': 370692000,
                'time': '1981-09-30T10:00:00+0000',
                'offset': 46800,
                'isdst': false,
                'abbr': 'ANAT'
              },
          4:
              {
                'ts': 386420400,
                'time': '1982-03-31T11:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          5:
              {
                'ts': 402231600,
                'time': '1982-09-30T11:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          6:
              {
                'ts': 417960000,
                'time': '1983-03-31T12:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          7:
              {
                'ts': 433767600,
                'time': '1983-09-30T11:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          8:
              {
                'ts': 449582400,
                'time': '1984-03-31T12:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          9:
              {
                'ts': 465314400,
                'time': '1984-09-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          10:
              {
                'ts': 481039200,
                'time': '1985-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          11:
              {
                'ts': 496764000,
                'time': '1985-09-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          12:
              {
                'ts': 512488800,
                'time': '1986-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          13:
              {
                'ts': 528213600,
                'time': '1986-09-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          14:
              {
                'ts': 543938400,
                'time': '1987-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          15:
              {
                'ts': 559663200,
                'time': '1987-09-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          16:
              {
                'ts': 575388000,
                'time': '1988-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          17:
              {
                'ts': 591112800,
                'time': '1988-09-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          18:
              {
                'ts': 606837600,
                'time': '1989-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          19:
              {
                'ts': 622562400,
                'time': '1989-09-23T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          20:
              {
                'ts': 638287200,
                'time': '1990-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          21:
              {
                'ts': 654616800,
                'time': '1990-09-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          22:
              {
                'ts': 670341600,
                'time': '1991-03-30T14:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'ANAST'
              },
          23:
              {
                'ts': 686070000,
                'time': '1991-09-28T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'ANAT'
              },
          24:
              {
                'ts': 695746800,
                'time': '1992-01-18T15:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          25:
              {
                'ts': 701780400,
                'time': '1992-03-28T11:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          26:
              {
                'ts': 717501600,
                'time': '1992-09-26T10:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          27:
              {
                'ts': 733240800,
                'time': '1993-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          28:
              {
                'ts': 748965600,
                'time': '1993-09-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          29:
              {
                'ts': 764690400,
                'time': '1994-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          30:
              {
                'ts': 780415200,
                'time': '1994-09-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          31:
              {
                'ts': 796140000,
                'time': '1995-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          32:
              {
                'ts': 811864800,
                'time': '1995-09-23T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          33:
              {
                'ts': 828194400,
                'time': '1996-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          34:
              {
                'ts': 846338400,
                'time': '1996-10-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          35:
              {
                'ts': 859644000,
                'time': '1997-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          36:
              {
                'ts': 877788000,
                'time': '1997-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          37:
              {
                'ts': 891093600,
                'time': '1998-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          38:
              {
                'ts': 909237600,
                'time': '1998-10-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          39:
              {
                'ts': 922543200,
                'time': '1999-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          40:
              {
                'ts': 941292000,
                'time': '1999-10-30T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          41:
              {
                'ts': 953992800,
                'time': '2000-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          42:
              {
                'ts': 972741600,
                'time': '2000-10-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          43:
              {
                'ts': 985442400,
                'time': '2001-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          44:
              {
                'ts': 1004191200,
                'time': '2001-10-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          45:
              {
                'ts': 1017496800,
                'time': '2002-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          46:
              {
                'ts': 1035640800,
                'time': '2002-10-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          47:
              {
                'ts': 1048946400,
                'time': '2003-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          48:
              {
                'ts': 1067090400,
                'time': '2003-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          49:
              {
                'ts': 1080396000,
                'time': '2004-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          50:
              {
                'ts': 1099144800,
                'time': '2004-10-30T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          51:
              {
                'ts': 1111845600,
                'time': '2005-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          52:
              {
                'ts': 1130594400,
                'time': '2005-10-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          53:
              {
                'ts': 1143295200,
                'time': '2006-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          54:
              {
                'ts': 1162044000,
                'time': '2006-10-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          55:
              {
                'ts': 1174744800,
                'time': '2007-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          56:
              {
                'ts': 1193493600,
                'time': '2007-10-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          57:
              {
                'ts': 1206799200,
                'time': '2008-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          58:
              {
                'ts': 1224943200,
                'time': '2008-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          59:
              {
                'ts': 1238248800,
                'time': '2009-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          60:
              {
                'ts': 1256392800,
                'time': '2009-10-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          61:
              {
                'ts': 1269698400,
                'time': '2010-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          62:
              {
                'ts': 1288447200,
                'time': '2010-10-30T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          63:
              {
                'ts': 1301148000,
                'time': '2011-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          64:
              {
                'ts': 1319896800,
                'time': '2011-10-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          65:
              {
                'ts': 1332597600,
                'time': '2012-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          66:
              {
                'ts': 1351346400,
                'time': '2012-10-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          67:
              {
                'ts': 1364652000,
                'time': '2013-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          68:
              {
                'ts': 1382796000,
                'time': '2013-10-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          69:
              {
                'ts': 1396101600,
                'time': '2014-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          70:
              {
                'ts': 1414245600,
                'time': '2014-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          71:
              {
                'ts': 1427551200,
                'time': '2015-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          72:
              {
                'ts': 1445695200,
                'time': '2015-10-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          73:
              {
                'ts': 1459000800,
                'time': '2016-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          74:
              {
                'ts': 1477749600,
                'time': '2016-10-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          75:
              {
                'ts': 1490450400,
                'time': '2017-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          76:
              {
                'ts': 1509199200,
                'time': '2017-10-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          77:
              {
                'ts': 1521900000,
                'time': '2018-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          78:
              {
                'ts': 1540648800,
                'time': '2018-10-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          79:
              {
                'ts': 1553954400,
                'time': '2019-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          80:
              {
                'ts': 1572098400,
                'time': '2019-10-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          81:
              {
                'ts': 1585404000,
                'time': '2020-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          82:
              {
                'ts': 1603548000,
                'time': '2020-10-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          83:
              {
                'ts': 1616853600,
                'time': '2021-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          84:
              {
                'ts': 1635602400,
                'time': '2021-10-30T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          85:
              {
                'ts': 1648303200,
                'time': '2022-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          86:
              {
                'ts': 1667052000,
                'time': '2022-10-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          87:
              {
                'ts': 1679752800,
                'time': '2023-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          88:
              {
                'ts': 1698501600,
                'time': '2023-10-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          89:
              {
                'ts': 1711807200,
                'time': '2024-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          90:
              {
                'ts': 1729951200,
                'time': '2024-10-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          91:
              {
                'ts': 1743256800,
                'time': '2025-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          92:
              {
                'ts': 1761400800,
                'time': '2025-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          93:
              {
                'ts': 1774706400,
                'time': '2026-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          94:
              {
                'ts': 1792850400,
                'time': '2026-10-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          95:
              {
                'ts': 1806156000,
                'time': '2027-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          96:
              {
                'ts': 1824904800,
                'time': '2027-10-30T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          97:
              {
                'ts': 1837605600,
                'time': '2028-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          98:
              {
                'ts': 1856354400,
                'time': '2028-10-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          99:
              {
                'ts': 1869055200,
                'time': '2029-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          100:
              {
                'ts': 1887804000,
                'time': '2029-10-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          101:
              {
                'ts': 1901109600,
                'time': '2030-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          102:
              {
                'ts': 1919253600,
                'time': '2030-10-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          103:
              {
                'ts': 1932559200,
                'time': '2031-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          104:
              {
                'ts': 1950703200,
                'time': '2031-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          105:
              {
                'ts': 1964008800,
                'time': '2032-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          106:
              {
                'ts': 1982757600,
                'time': '2032-10-30T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          107:
              {
                'ts': 1995458400,
                'time': '2033-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          108:
              {
                'ts': 2014207200,
                'time': '2033-10-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          109:
              {
                'ts': 2026908000,
                'time': '2034-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          110:
              {
                'ts': 2045656800,
                'time': '2034-10-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          111:
              {
                'ts': 2058357600,
                'time': '2035-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          112:
              {
                'ts': 2077106400,
                'time': '2035-10-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          113:
              {
                'ts': 2090412000,
                'time': '2036-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          114:
              {
                'ts': 2108556000,
                'time': '2036-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              },
          115:
              {
                'ts': 2121861600,
                'time': '2037-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'ANAST'
              },
          116:
              {
                'ts': 2140005600,
                'time': '2037-10-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'ANAT'
              }
        },
    'Asia/Aqtau':
        {
          0:
              {
                'ts': -1441164064,
                'time': '1924-05-01T20:38:56+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'FORT'
              },
          1:
              {
                'ts': -1247544000,
                'time': '1930-06-20T20:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'FORT'
              },
          2:
              {
                'ts': -220942800,
                'time': '1962-12-31T19:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SHET'
              },
          3:
              {
                'ts': 370724400,
                'time': '1981-09-30T19:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'SHET'
              },
          4:
              {
                'ts': 386445600,
                'time': '1982-03-31T18:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SHEST'
              },
          5:
              {
                'ts': 402256800,
                'time': '1982-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SHET'
              },
          6:
              {
                'ts': 417985200,
                'time': '1983-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SHEST'
              },
          7:
              {
                'ts': 433792800,
                'time': '1983-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SHET'
              },
          8:
              {
                'ts': 449607600,
                'time': '1984-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SHEST'
              },
          9:
              {
                'ts': 465339600,
                'time': '1984-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SHET'
              },
          10:
              {
                'ts': 481064400,
                'time': '1985-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SHEST'
              },
          11:
              {
                'ts': 496789200,
                'time': '1985-09-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SHET'
              },
          12:
              {
                'ts': 512514000,
                'time': '1986-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SHEST'
              },
          13:
              {
                'ts': 528238800,
                'time': '1986-09-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SHET'
              },
          14:
              {
                'ts': 543963600,
                'time': '1987-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SHEST'
              },
          15:
              {
                'ts': 559688400,
                'time': '1987-09-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SHET'
              },
          16:
              {
                'ts': 575413200,
                'time': '1988-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SHEST'
              },
          17:
              {
                'ts': 591138000,
                'time': '1988-09-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SHET'
              },
          18:
              {
                'ts': 606862800,
                'time': '1989-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SHEST'
              },
          19:
              {
                'ts': 622587600,
                'time': '1989-09-23T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SHET'
              },
          20:
              {
                'ts': 638312400,
                'time': '1990-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SHEST'
              },
          21:
              {
                'ts': 654642000,
                'time': '1990-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SHET'
              },
          22:
              {
                'ts': 662670000,
                'time': '1990-12-31T19:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SHET'
              },
          23:
              {
                'ts': 692823600,
                'time': '1991-12-15T19:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          24:
              {
                'ts': 701805600,
                'time': '1992-03-28T18:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          25:
              {
                'ts': 717526800,
                'time': '1992-09-26T17:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          26:
              {
                'ts': 733266000,
                'time': '1993-03-27T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          27:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          28:
              {
                'ts': 764715600,
                'time': '1994-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          29:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          30:
              {
                'ts': 796165200,
                'time': '1995-03-25T21:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AQTST'
              },
          31:
              {
                'ts': 811893600,
                'time': '1995-09-23T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AQTT'
              },
          32:
              {
                'ts': 828223200,

                'time': '1996-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AQTST'
              },
          33:
              {
                'ts': 846367200,
                'time': '1996-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AQTT'
              },
          34:
              {
                'ts': 859672800,
                'time': '1997-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AQTST'
              },
          35:
              {
                'ts': 877816800,
                'time': '1997-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AQTT'
              },
          36:
              {
                'ts': 891122400,
                'time': '1998-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AQTST'
              },
          37:
              {
                'ts': 909266400,
                'time': '1998-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AQTT'
              },
          38:
              {
                'ts': 922572000,
                'time': '1999-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AQTST'
              },
          39:
              {
                'ts': 941320800,
                'time': '1999-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AQTT'
              },
          40:
              {
                'ts': 954021600,
                'time': '2000-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AQTST'
              },
          41:
              {
                'ts': 972770400,
                'time': '2000-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AQTT'
              },
          42:
              {
                'ts': 985471200,
                'time': '2001-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AQTST'
              },
          43:
              {
                'ts': 1004220000,
                'time': '2001-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AQTT'
              },
          44:
              {
                'ts': 1017525600,
                'time': '2002-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AQTST'
              },
          45:
              {
                'ts': 1035669600,
                'time': '2002-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AQTT'
              },
          46:
              {
                'ts': 1048975200,
                'time': '2003-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AQTST'
              },
          47:
              {
                'ts': 1067119200,
                'time': '2003-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AQTT'
              },
          48:
              {
                'ts': 1080424800,
                'time': '2004-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AQTST'
              },
          49:
              {
                'ts': 1099173600,
                'time': '2004-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AQTT'
              },
          50:
              {
                'ts': 1110830400,
                'time': '2005-03-14T20:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              }
        },
    'Asia/Aqtobe':
        {
          0:
              {
                'ts': -1441165720,
                'time': '1924-05-01T20:11:20+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AKTT'
              },
          1:
              {
                'ts': -1247544000,
                'time': '1930-06-20T20:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AKTT'
              },
          2:
              {
                'ts': 354913200,
                'time': '1981-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AKTST'
              },
          3:
              {
                'ts': 370720800,
                'time': '1981-09-30T18:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'AKTT'
              },
          4:
              {
                'ts': 386445600,
                'time': '1982-03-31T18:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AKTST'
              },
          5:
              {
                'ts': 402256800,
                'time': '1982-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AKTT'
              },
          6:
              {
                'ts': 417985200,
                'time': '1983-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AKTST'
              },
          7:
              {
                'ts': 433792800,
                'time': '1983-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AKTT'
              },
          8:
              {
                'ts': 449607600,
                'time': '1984-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AKTST'
              },
          9:
              {
                'ts': 465339600,
                'time': '1984-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AKTT'
              },
          10:
              {
                'ts': 481064400,
                'time': '1985-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AKTST'
              },
          11:
              {
                'ts': 496789200,
                'time': '1985-09-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AKTT'
              },
          12:
              {
                'ts': 512514000,
                'time': '1986-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AKTST'
              },
          13:
              {
                'ts': 528238800,
                'time': '1986-09-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AKTT'
              },
          14:
              {
                'ts': 543963600,
                'time': '1987-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AKTST'
              },
          15:
              {
                'ts': 559688400,
                'time': '1987-09-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AKTT'
              },
          16:
              {
                'ts': 575413200,
                'time': '1988-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AKTST'
              },
          17:
              {
                'ts': 591138000,
                'time': '1988-09-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AKTT'
              },
          18:
              {
                'ts': 606862800,
                'time': '1989-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AKTST'
              },
          19:
              {
                'ts': 622587600,
                'time': '1989-09-23T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AKTT'
              },
          20:
              {
                'ts': 638312400,
                'time': '1990-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AKTST'
              },
          21:
              {
                'ts': 654642000,
                'time': '1990-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AKTT'
              },
          22:
              {
                'ts': 662670000,
                'time': '1990-12-31T19:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AKTT'
              },
          23:
              {
                'ts': 692823600,
                'time': '1991-12-15T19:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          24:
              {
                'ts': 701805600,
                'time': '1992-03-28T18:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          25:
              {
                'ts': 717526800,
                'time': '1992-09-26T17:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          26:
              {
                'ts': 733266000,
                'time': '1993-03-27T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          27:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          28:
              {
                'ts': 764715600,
                'time': '1994-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          29:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          30:
              {
                'ts': 796165200,
                'time': '1995-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          31:
              {
                'ts': 811890000,
                'time': '1995-09-23T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          32:
              {
                'ts': 828219600,
                'time': '1996-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          33:
              {
                'ts': 846363600,
                'time': '1996-10-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          34:
              {
                'ts': 859669200,
                'time': '1997-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          35:
              {
                'ts': 877813200,
                'time': '1997-10-25T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          36:
              {
                'ts': 891118800,
                'time': '1998-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          37:
              {
                'ts': 909262800,
                'time': '1998-10-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          38:
              {
                'ts': 922568400,
                'time': '1999-03-27T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          39:
              {
                'ts': 941317200,
                'time': '1999-10-30T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          40:
              {
                'ts': 954018000,
                'time': '2000-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          41:
              {
                'ts': 972766800,
                'time': '2000-10-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          42:
              {
                'ts': 985467600,
                'time': '2001-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          43:
              {
                'ts': 1004216400,
                'time': '2001-10-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          44:
              {
                'ts': 1017522000,
                'time': '2002-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          45:
              {
                'ts': 1035666000,
                'time': '2002-10-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          46:
              {
                'ts': 1048971600,
                'time': '2003-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          47:
              {
                'ts': 1067115600,
                'time': '2003-10-25T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          48:
              {
                'ts': 1080421200,
                'time': '2004-03-27T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'AQTST'
              },
          49:
              {
                'ts': 1099170000,
                'time': '2004-10-30T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              },
          50:
              {
                'ts': 1110826800,
                'time': '2005-03-14T19:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'AQTT'
              }
        },
    'Asia/Ashgabat':
        {
          0:
              {
                'ts': -1441166012,
                'time': '1924-05-01T20:06:28+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ASHT'
              },
          1:
              {
                'ts': -1247544000,
                'time': '1930-06-20T20:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          2:
              {
                'ts': 354913200,
                'time': '1981-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          3:
              {
                'ts': 370720800,
                'time': '1981-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          4:
              {
                'ts': 386449200,
                'time': '1982-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          5:
              {
                'ts': 402256800,
                'time': '1982-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          6:
              {
                'ts': 417985200,
                'time': '1983-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          7:
              {
                'ts': 433792800,
                'time': '1983-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          8:
              {
                'ts': 449607600,
                'time': '1984-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          9:
              {
                'ts': 465339600,
                'time': '1984-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          10:
              {
                'ts': 481064400,
                'time': '1985-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          11:
              {
                'ts': 496789200,
                'time': '1985-09-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          12:
              {
                'ts': 512514000,
                'time': '1986-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          13:
              {
                'ts': 528238800,
                'time': '1986-09-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          14:
              {
                'ts': 543963600,
                'time': '1987-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          15:
              {
                'ts': 559688400,
                'time': '1987-09-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          16:
              {
                'ts': 575413200,
                'time': '1988-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          17:
              {
                'ts': 591138000,
                'time': '1988-09-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          18:
              {
                'ts': 606862800,
                'time': '1989-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          19:
              {
                'ts': 622587600,
                'time': '1989-09-23T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          20:
              {
                'ts': 638312400,
                'time': '1990-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          21:
              {
                'ts': 654642000,
                'time': '1990-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          22:
              {
                'ts': 670366800,
                'time': '1991-03-30T21:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ASHST'
              },
          23:
              {
                'ts': 686095200,
                'time': '1991-09-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ASHT'
              },
          24:
              {
                'ts': 688507200,
                'time': '1991-10-26T20:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TMT'
              },
          25:
              {
                'ts': 695772000,
                'time': '1992-01-18T22:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'TMT'
              }
        },
    'Asia/Ashkhabad':
        {
          0:
              {
                'ts': -1441166012,
                'time': '1924-05-01T20:06:28+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ASHT'
              },
          1:
              {
                'ts': -1247544000,
                'time': '1930-06-20T20:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          2:
              {
                'ts': 354913200,
                'time': '1981-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          3:
              {
                'ts': 370720800,
                'time': '1981-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          4:
              {
                'ts': 386449200,
                'time': '1982-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          5:
              {
                'ts': 402256800,
                'time': '1982-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          6:
              {
                'ts': 417985200,
                'time': '1983-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          7:
              {
                'ts': 433792800,
                'time': '1983-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          8:
              {
                'ts': 449607600,
                'time': '1984-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          9:
              {
                'ts': 465339600,
                'time': '1984-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          10:
              {
                'ts': 481064400,
                'time': '1985-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          11:
              {
                'ts': 496789200,
                'time': '1985-09-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          12:
              {
                'ts': 512514000,
                'time': '1986-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          13:
              {
                'ts': 528238800,
                'time': '1986-09-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          14:
              {
                'ts': 543963600,
                'time': '1987-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          15:
              {
                'ts': 559688400,
                'time': '1987-09-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          16:
              {
                'ts': 575413200,
                'time': '1988-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          17:
              {
                'ts': 591138000,
                'time': '1988-09-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          18:
              {
                'ts': 606862800,
                'time': '1989-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          19:
              {
                'ts': 622587600,
                'time': '1989-09-23T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          20:
              {
                'ts': 638312400,
                'time': '1990-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'ASHST'
              },
          21:
              {
                'ts': 654642000,
                'time': '1990-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ASHT'
              },
          22:
              {
                'ts': 670366800,
                'time': '1991-03-30T21:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ASHST'
              },
          23:
              {
                'ts': 686095200,
                'time': '1991-09-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ASHT'
              },
          24:
              {
                'ts': 688507200,
                'time': '1991-10-26T20:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TMT'
              },
          25:
              {
                'ts': 695772000,
                'time': '1992-01-18T22:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'TMT'
              }
        },
    'Asia/Baghdad':
        {
          0:
              {
                'ts': -1641005856,
                'time': '1917-12-31T21:02:24+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          1:
              {
                'ts': 389048400,
                'time': '1982-04-30T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          2:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          3:
              {
                'ts': 417906000,
                'time': '1983-03-30T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          4:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          5:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          6:
              {
                'ts': 465422400,
                'time': '1984-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          7:
              {
                'ts': 481150800,
                'time': '1985-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          8:
              {
                'ts': 496792800,
                'time': '1985-09-28T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          9:
              {
                'ts': 512517600,
                'time': '1986-03-29T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          10:
              {
                'ts': 528242400,
                'time': '1986-09-27T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          11:
              {
                'ts': 543967200,
                'time': '1987-03-28T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          12:
              {
                'ts': 559692000,
                'time': '1987-09-26T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          13:
              {
                'ts': 575416800,
                'time': '1988-03-26T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          14:
              {
                'ts': 591141600,
                'time': '1988-09-24T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          15:
              {
                'ts': 606866400,
                'time': '1989-03-25T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          16:
              {
                'ts': 622591200,
                'time': '1989-09-23T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          17:
              {
                'ts': 638316000,
                'time': '1990-03-24T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          18:
              {
                'ts': 654645600,
                'time': '1990-09-29T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          19:
              {
                'ts': 670464000,
                'time': '1991-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          20:
              {
                'ts': 686275200,
                'time': '1991-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          21:
              {
                'ts': 702086400,
                'time': '1992-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          22:
              {
                'ts': 717897600,
                'time': '1992-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          23:
              {
                'ts': 733622400,
                'time': '1993-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          24:
              {
                'ts': 749433600,
                'time': '1993-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          25:
              {
                'ts': 765158400,
                'time': '1994-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          26:
              {
                'ts': 780969600,
                'time': '1994-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          27:
              {
                'ts': 796694400,
                'time': '1995-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          28:
              {
                'ts': 812505600,
                'time': '1995-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          29:
              {
                'ts': 828316800,
                'time': '1996-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          30:
              {
                'ts': 844128000,
                'time': '1996-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          31:
              {
                'ts': 859852800,
                'time': '1997-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          32:
              {
                'ts': 875664000,
                'time': '1997-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          33:
              {
                'ts': 891388800,
                'time': '1998-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          34:
              {
                'ts': 907200000,
                'time': '1998-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          35:
              {
                'ts': 922924800,
                'time': '1999-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          36:
              {
                'ts': 938736000,
                'time': '1999-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          37:
              {
                'ts': 954547200,
                'time': '2000-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          38:
              {
                'ts': 970358400,
                'time': '2000-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          39:
              {
                'ts': 986083200,
                'time': '2001-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          40:
              {
                'ts': 1001894400,
                'time': '2001-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          41:
              {
                'ts': 1017619200,
                'time': '2002-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          42:
              {
                'ts': 1033430400,
                'time': '2002-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          43:
              {
                'ts': 1049155200,
                'time': '2003-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          44:
              {
                'ts': 1064966400,
                'time': '2003-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          45:
              {
                'ts': 1080777600,
                'time': '2004-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          46:
              {
                'ts': 1096588800,
                'time': '2004-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          47:
              {
                'ts': 1112313600,
                'time': '2005-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          48:
              {
                'ts': 1128124800,
                'time': '2005-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          49:
              {
                'ts': 1143849600,
                'time': '2006-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          50:
              {
                'ts': 1159660800,
                'time': '2006-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              },
          51:
              {
                'ts': 1175385600,
                'time': '2007-04-01T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'ADT'
              },
          52:
              {
                'ts': 1191196800,
                'time': '2007-10-01T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'Asia/Bahrain':
        {
          0:
              {
                'ts': -1577935340,
                'time': '1919-12-31T20:37:40+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GST'
              },
          1:
              {
                'ts': 76190400,
                'time': '1972-05-31T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'Asia/Baku':
        {
          0:
              {
                'ts': -1441163964,
                'time': '1924-05-01T20:40:36+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'BAKT'
              },
          1:
              {
                'ts': -405140400,
                'time': '1957-02-28T21:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'BAKT'
              },
          2:
              {
                'ts': 354916800,
                'time': '1981-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'BAKST'
              },
          3:
              {
                'ts': 370724400,
                'time': '1981-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'BAKT'
              },
          4:
              {
                'ts': 386452800,
                'time': '1982-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'BAKST'
              },
          5:
              {
                'ts': 402260400,
                'time': '1982-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'BAKT'
              },
          6:
              {
                'ts': 417988800,
                'time': '1983-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'BAKST'
              },
          7:
              {
                'ts': 433796400,
                'time': '1983-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'BAKT'
              },
          8:
              {
                'ts': 449611200,
                'time': '1984-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'BAKST'
              },
          9:
              {
                'ts': 465343200,
                'time': '1984-09-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'BAKT'
              },
          10:
              {
                'ts': 481068000,
                'time': '1985-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'BAKST'
              },
          11:
              {
                'ts': 496792800,
                'time': '1985-09-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'BAKT'
              },
          12:
              {
                'ts': 512517600,
                'time': '1986-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'BAKST'
              },
          13:
              {
                'ts': 528242400,
                'time': '1986-09-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'BAKT'
              },
          14:
              {
                'ts': 543967200,
                'time': '1987-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'BAKST'
              },
          15:
              {
                'ts': 559692000,
                'time': '1987-09-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'BAKT'
              },
          16:
              {
                'ts': 575416800,
                'time': '1988-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'BAKST'
              },
          17:
              {
                'ts': 591141600,
                'time': '1988-09-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'BAKT'
              },
          18:
              {
                'ts': 606866400,
                'time': '1989-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'BAKST'
              },
          19:
              {
                'ts': 622591200,
                'time': '1989-09-23T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'BAKT'
              },
          20:
              {
                'ts': 638316000,
                'time': '1990-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'BAKST'
              },
          21:
              {
                'ts': 654645600,
                'time': '1990-09-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'BAKT'
              },
          22:
              {
                'ts': 670370400,
                'time': '1991-03-30T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'BAKST'
              },
          23:
              {
                'ts': 683496000,
                'time': '1991-08-29T20:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'AZST'
              },
          24:
              {
                'ts': 686098800,
                'time': '1991-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AZT'
              },
          25:
              {
                'ts': 701812800,
                'time': '1992-03-28T20:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'AZST'
              },
          26:
              {
                'ts': 717534000,
                'time': '1992-09-26T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          27:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          28:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          29:
              {
                'ts': 852062400,
                'time': '1996-12-31T20:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          30:
              {
                'ts': 859680000,
                'time': '1997-03-30T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          31:
              {
                'ts': 877824000,
                'time': '1997-10-26T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          32:
              {
                'ts': 891129600,
                'time': '1998-03-29T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          33:
              {
                'ts': 909273600,
                'time': '1998-10-25T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          34:
              {
                'ts': 922579200,
                'time': '1999-03-28T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          35:
              {
                'ts': 941328000,
                'time': '1999-10-31T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          36:
              {
                'ts': 954028800,
                'time': '2000-03-26T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          37:
              {
                'ts': 972777600,
                'time': '2000-10-29T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          38:
              {
                'ts': 985478400,
                'time': '2001-03-25T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          39:
              {
                'ts': 1004227200,
                'time': '2001-10-28T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          40:
              {
                'ts': 1017532800,
                'time': '2002-03-31T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          41:
              {
                'ts': 1035676800,
                'time': '2002-10-27T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          42:
              {
                'ts': 1048982400,
                'time': '2003-03-30T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          43:
              {
                'ts': 1067126400,
                'time': '2003-10-26T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          44:
              {
                'ts': 1080432000,
                'time': '2004-03-28T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          45:
              {
                'ts': 1099180800,
                'time': '2004-10-31T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          46:
              {
                'ts': 1111881600,
                'time': '2005-03-27T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          47:
              {
                'ts': 1130630400,
                'time': '2005-10-30T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          48:
              {
                'ts': 1143331200,
                'time': '2006-03-26T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          49:
              {
                'ts': 1162080000,
                'time': '2006-10-29T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          50:
              {
                'ts': 1174780800,
                'time': '2007-03-25T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          51:
              {
                'ts': 1193529600,
                'time': '2007-10-28T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          52:
              {
                'ts': 1206835200,
                'time': '2008-03-30T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          53:
              {
                'ts': 1224979200,
                'time': '2008-10-26T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          54:
              {
                'ts': 1238284800,
                'time': '2009-03-29T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          55:
              {
                'ts': 1256428800,
                'time': '2009-10-25T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          56:
              {
                'ts': 1269734400,
                'time': '2010-03-28T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          57:
              {
                'ts': 1288483200,
                'time': '2010-10-31T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          58:
              {
                'ts': 1301184000,
                'time': '2011-03-27T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          59:
              {
                'ts': 1319932800,
                'time': '2011-10-30T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          60:
              {
                'ts': 1332633600,
                'time': '2012-03-25T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          61:
              {
                'ts': 1351382400,
                'time': '2012-10-28T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          62:
              {
                'ts': 1364688000,
                'time': '2013-03-31T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          63:
              {
                'ts': 1382832000,
                'time': '2013-10-27T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          64:
              {
                'ts': 1396137600,
                'time': '2014-03-30T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          65:
              {
                'ts': 1414281600,
                'time': '2014-10-26T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          66:
              {
                'ts': 1427587200,
                'time': '2015-03-29T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          67:
              {
                'ts': 1445731200,
                'time': '2015-10-25T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          68:
              {
                'ts': 1459036800,
                'time': '2016-03-27T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          69:
              {
                'ts': 1477785600,
                'time': '2016-10-30T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          70:
              {
                'ts': 1490486400,
                'time': '2017-03-26T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          71:
              {
                'ts': 1509235200,
                'time': '2017-10-29T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          72:
              {
                'ts': 1521936000,
                'time': '2018-03-25T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          73:
              {
                'ts': 1540684800,
                'time': '2018-10-28T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          74:
              {
                'ts': 1553990400,
                'time': '2019-03-31T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          75:
              {
                'ts': 1572134400,
                'time': '2019-10-27T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          76:
              {
                'ts': 1585440000,
                'time': '2020-03-29T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          77:
              {
                'ts': 1603584000,
                'time': '2020-10-25T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          78:
              {
                'ts': 1616889600,
                'time': '2021-03-28T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          79:
              {
                'ts': 1635638400,
                'time': '2021-10-31T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          80:
              {
                'ts': 1648339200,
                'time': '2022-03-27T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          81:
              {
                'ts': 1667088000,
                'time': '2022-10-30T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          82:
              {
                'ts': 1679788800,
                'time': '2023-03-26T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          83:
              {
                'ts': 1698537600,
                'time': '2023-10-29T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          84:
              {
                'ts': 1711843200,
                'time': '2024-03-31T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          85:
              {
                'ts': 1729987200,
                'time': '2024-10-27T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          86:
              {
                'ts': 1743292800,
                'time': '2025-03-30T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          87:
              {
                'ts': 1761436800,
                'time': '2025-10-26T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          88:
              {
                'ts': 1774742400,
                'time': '2026-03-29T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          89:
              {
                'ts': 1792886400,
                'time': '2026-10-25T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          90:
              {
                'ts': 1806192000,
                'time': '2027-03-28T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          91:
              {
                'ts': 1824940800,
                'time': '2027-10-31T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          92:
              {
                'ts': 1837641600,
                'time': '2028-03-26T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          93:
              {
                'ts': 1856390400,
                'time': '2028-10-29T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          94:
              {
                'ts': 1869091200,
                'time': '2029-03-25T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          95:
              {
                'ts': 1887840000,
                'time': '2029-10-28T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          96:
              {
                'ts': 1901145600,
                'time': '2030-03-31T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          97:
              {
                'ts': 1919289600,
                'time': '2030-10-27T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          98:
              {
                'ts': 1932595200,
                'time': '2031-03-30T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          99:
              {
                'ts': 1950739200,
                'time': '2031-10-26T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          100:
              {
                'ts': 1964044800,
                'time': '2032-03-28T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          101:
              {
                'ts': 1982793600,
                'time': '2032-10-31T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          102:
              {
                'ts': 1995494400,
                'time': '2033-03-27T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          103:
              {
                'ts': 2014243200,
                'time': '2033-10-30T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          104:
              {
                'ts': 2026944000,
                'time': '2034-03-26T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          105:
              {
                'ts': 2045692800,
                'time': '2034-10-29T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          106:
              {
                'ts': 2058393600,
                'time': '2035-03-25T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          107:
              {
                'ts': 2077142400,
                'time': '2035-10-28T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          108:
              {
                'ts': 2090448000,
                'time': '2036-03-30T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          109:
              {
                'ts': 2108592000,
                'time': '2036-10-26T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              },
          110:
              {
                'ts': 2121897600,
                'time': '2037-03-29T00:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AZST'
              },
          111:
              {
                'ts': 2140041600,
                'time': '2037-10-25T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AZT'
              }
        },
    'Asia/Bangkok':
        {
          0:
              {
                'ts': -1570084924,
                'time': '1920-03-31T17:17:56+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'ICT'
              }
        },
    'Asia/Beirut':
        {
          0:
              {
                'ts': -1570413600,
                'time': '1920-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          1:
              {
                'ts': -1552186800,
                'time': '1920-10-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          2:
              {
                'ts': -1538359200,
                'time': '1921-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          3:
              {
                'ts': -1522551600,
                'time': '1921-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          4:
              {
                'ts': -1507514400,
                'time': '1922-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          5:
              {
                'ts': -1490583600,
                'time': '1922-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          6:
              {
                'ts': -1473645600,
                'time': '1923-04-21T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          7:
              {
                'ts': -1460948400,
                'time': '1923-09-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          8:
              {
                'ts': -399866400,
                'time': '1957-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          9:
              {
                'ts': -386650800,
                'time': '1957-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          10:
              {
                'ts': -368330400,
                'time': '1958-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          11:
              {
                'ts': -355114800,
                'time': '1958-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          12:
              {
                'ts': -336794400,
                'time': '1959-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          13:
              {
                'ts': -323578800,
                'time': '1959-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          14:
              {
                'ts': -305172000,
                'time': '1960-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          15:
              {
                'ts': -291956400,
                'time': '1960-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          16:
              {
                'ts': -273636000,
                'time': '1961-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          17:
              {
                'ts': -260420400,
                'time': '1961-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          18:
              {
                'ts': 78012000,
                'time': '1972-06-21T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          19:
              {
                'ts': 86734800,
                'time': '1972-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          20:
              {
                'ts': 105055200,
                'time': '1973-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          21:
              {
                'ts': 118270800,
                'time': '1973-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          22:
              {
                'ts': 136591200,
                'time': '1974-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          23:
              {
                'ts': 149806800,
                'time': '1974-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          24:
              {
                'ts': 168127200,
                'time': '1975-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          25:
              {
                'ts': 181342800,
                'time': '1975-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          26:
              {
                'ts': 199749600,
                'time': '1976-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          27:
              {
                'ts': 212965200,
                'time': '1976-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          28:
              {
                'ts': 231285600,
                'time': '1977-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          29:
              {
                'ts': 244501200,
                'time': '1977-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          30:
              {
                'ts': 262735200,
                'time': '1978-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          31:
              {
                'ts': 275950800,
                'time': '1978-09-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          32:
              {
                'ts': 452210400,
                'time': '1984-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          33:
              {
                'ts': 466722000,
                'time': '1984-10-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          34:
              {
                'ts': 483746400,
                'time': '1985-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          35:
              {
                'ts': 498258000,
                'time': '1985-10-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          36:
              {
                'ts': 515282400,
                'time': '1986-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          37:
              {
                'ts': 529794000,
                'time': '1986-10-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          38:
              {
                'ts': 546818400,
                'time': '1987-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          39:
              {
                'ts': 561330000,
                'time': '1987-10-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          40:
              {
                'ts': 581119200,
                'time': '1988-05-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          41:
              {
                'ts': 592952400,
                'time': '1988-10-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          42:
              {
                'ts': 610754400,
                'time': '1989-05-09T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          43:
              {
                'ts': 624488400,
                'time': '1989-10-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          44:
              {
                'ts': 641512800,
                'time': '1990-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          45:
              {
                'ts': 656024400,
                'time': '1990-10-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          46:
              {
                'ts': 673048800,
                'time': '1991-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          47:
              {
                'ts': 687560400,
                'time': '1991-10-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          48:
              {
                'ts': 704671200,
                'time': '1992-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          49:
              {
                'ts': 718146000,
                'time': '1992-10-03T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          50:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          51:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          52:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          53:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          54:
              {
                'ts': 796168800,
                'time': '1995-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          55:
              {
                'ts': 811890000,
                'time': '1995-09-23T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          56:
              {
                'ts': 828223200,
                'time': '1996-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          57:
              {
                'ts': 843944400,
                'time': '1996-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          58:
              {
                'ts': 859672800,
                'time': '1997-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          59:
              {
                'ts': 875394000,
                'time': '1997-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          60:
              {
                'ts': 891122400,
                'time': '1998-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          61:
              {
                'ts': 906843600,
                'time': '1998-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          62:
              {
                'ts': 922572000,
                'time': '1999-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          63:
              {
                'ts': 941317200,
                'time': '1999-10-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          64:
              {
                'ts': 954021600,
                'time': '2000-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          65:
              {
                'ts': 972766800,
                'time': '2000-10-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          66:
              {
                'ts': 985471200,
                'time': '2001-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          67:
              {
                'ts': 1004216400,
                'time': '2001-10-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          68:
              {
                'ts': 1017525600,
                'time': '2002-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          69:
              {
                'ts': 1035666000,
                'time': '2002-10-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          70:
              {
                'ts': 1048975200,
                'time': '2003-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          71:
              {
                'ts': 1067115600,
                'time': '2003-10-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          72:
              {
                'ts': 1080424800,
                'time': '2004-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          73:
              {
                'ts': 1099170000,
                'time': '2004-10-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          74:
              {
                'ts': 1111874400,
                'time': '2005-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          75:
              {
                'ts': 1130619600,
                'time': '2005-10-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          76:
              {
                'ts': 1143324000,
                'time': '2006-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          77:
              {
                'ts': 1162069200,
                'time': '2006-10-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          78:
              {
                'ts': 1174773600,
                'time': '2007-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          79:
              {
                'ts': 1193518800,
                'time': '2007-10-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          80:
              {
                'ts': 1206828000,
                'time': '2008-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          81:
              {
                'ts': 1224968400,
                'time': '2008-10-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          82:
              {
                'ts': 1238277600,
                'time': '2009-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          83:
              {
                'ts': 1256418000,
                'time': '2009-10-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          84:
              {
                'ts': 1269727200,
                'time': '2010-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          85:
              {
                'ts': 1288472400,
                'time': '2010-10-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          86:
              {
                'ts': 1301176800,
                'time': '2011-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          87:
              {
                'ts': 1319922000,
                'time': '2011-10-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          88:
              {
                'ts': 1332626400,
                'time': '2012-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          89:
              {
                'ts': 1351371600,
                'time': '2012-10-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          90:
              {
                'ts': 1364680800,
                'time': '2013-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          91:
              {
                'ts': 1382821200,
                'time': '2013-10-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          92:
              {
                'ts': 1396130400,
                'time': '2014-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          93:
              {
                'ts': 1414270800,
                'time': '2014-10-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          94:
              {
                'ts': 1427580000,
                'time': '2015-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          95:
              {
                'ts': 1445720400,
                'time': '2015-10-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          96:
              {
                'ts': 1459029600,
                'time': '2016-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          97:
              {
                'ts': 1477774800,
                'time': '2016-10-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          98:
              {
                'ts': 1490479200,
                'time': '2017-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          99:
              {
                'ts': 1509224400,
                'time': '2017-10-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          100:
              {
                'ts': 1521928800,
                'time': '2018-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          101:
              {
                'ts': 1540674000,
                'time': '2018-10-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          102:
              {
                'ts': 1553983200,
                'time': '2019-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          103:
              {
                'ts': 1572123600,
                'time': '2019-10-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          104:
              {
                'ts': 1585432800,
                'time': '2020-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          105:
              {
                'ts': 1603573200,
                'time': '2020-10-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          106:
              {
                'ts': 1616882400,
                'time': '2021-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          107:
              {
                'ts': 1635627600,
                'time': '2021-10-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          108:
              {
                'ts': 1648332000,
                'time': '2022-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          109:
              {
                'ts': 1667077200,
                'time': '2022-10-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          110:
              {
                'ts': 1679781600,
                'time': '2023-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          111:
              {
                'ts': 1698526800,
                'time': '2023-10-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          112:
              {
                'ts': 1711836000,
                'time': '2024-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          113:
              {
                'ts': 1729976400,
                'time': '2024-10-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          114:
              {
                'ts': 1743285600,
                'time': '2025-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          115:
              {
                'ts': 1761426000,
                'time': '2025-10-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          116:
              {
                'ts': 1774735200,
                'time': '2026-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          117:
              {
                'ts': 1792875600,
                'time': '2026-10-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          118:
              {
                'ts': 1806184800,
                'time': '2027-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          119:
              {
                'ts': 1824930000,
                'time': '2027-10-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          120:
              {
                'ts': 1837634400,
                'time': '2028-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          121:
              {
                'ts': 1856379600,
                'time': '2028-10-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          122:
              {
                'ts': 1869084000,
                'time': '2029-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          123:
              {
                'ts': 1887829200,
                'time': '2029-10-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          124:
              {
                'ts': 1901138400,
                'time': '2030-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          125:
              {
                'ts': 1919278800,
                'time': '2030-10-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          126:
              {
                'ts': 1932588000,
                'time': '2031-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          127:
              {
                'ts': 1950728400,
                'time': '2031-10-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          128:
              {
                'ts': 1964037600,
                'time': '2032-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          129:
              {
                'ts': 1982782800,
                'time': '2032-10-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          130:
              {
                'ts': 1995487200,
                'time': '2033-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          131:
              {
                'ts': 2014232400,
                'time': '2033-10-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          132:
              {
                'ts': 2026936800,
                'time': '2034-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          133:
              {
                'ts': 2045682000,
                'time': '2034-10-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          134:
              {
                'ts': 2058386400,
                'time': '2035-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          135:
              {
                'ts': 2077131600,
                'time': '2035-10-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          136:
              {
                'ts': 2090440800,
                'time': '2036-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          137:
              {
                'ts': 2108581200,
                'time': '2036-10-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          138:
              {
                'ts': 2121890400,
                'time': '2037-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          139:
              {
                'ts': 2140030800,
                'time': '2037-10-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Asia/Bishkek':
        {
          0:
              {
                'ts': -1441169904,
                'time': '1924-05-01T19:01:36+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'FRUT'
              },
          1:
              {
                'ts': -1247547600,
                'time': '1930-06-20T19:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'FRUT'
              },
          2:
              {
                'ts': 354909600,
                'time': '1981-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'FRUST'
              },
          3:
              {
                'ts': 370717200,
                'time': '1981-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'FRUT'
              },
          4:
              {
                'ts': 386445600,
                'time': '1982-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'FRUST'
              },
          5:
              {
                'ts': 402253200,
                'time': '1982-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'FRUT'
              },
          6:
              {
                'ts': 417981600,
                'time': '1983-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'FRUST'
              },
          7:
              {
                'ts': 433789200,
                'time': '1983-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'FRUT'
              },
          8:
              {
                'ts': 449604000,
                'time': '1984-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'FRUST'
              },
          9:
              {
                'ts': 465336000,
                'time': '1984-09-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'FRUT'
              },
          10:
              {
                'ts': 481060800,
                'time': '1985-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'FRUST'
              },
          11:
              {
                'ts': 496785600,
                'time': '1985-09-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'FRUT'
              },
          12:
              {
                'ts': 512510400,
                'time': '1986-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'FRUST'
              },
          13:
              {
                'ts': 528235200,
                'time': '1986-09-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'FRUT'
              },
          14:
              {
                'ts': 543960000,
                'time': '1987-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'FRUST'
              },
          15:
              {
                'ts': 559684800,
                'time': '1987-09-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'FRUT'
              },
          16:
              {
                'ts': 575409600,
                'time': '1988-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'FRUST'
              },
          17:
              {
                'ts': 591134400,
                'time': '1988-09-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'FRUT'
              },
          18:
              {
                'ts': 606859200,
                'time': '1989-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'FRUST'
              },
          19:
              {
                'ts': 622584000,
                'time': '1989-09-23T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'FRUT'
              },
          20:
              {
                'ts': 638308800,
                'time': '1990-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'FRUST'
              },
          21:
              {
                'ts': 654638400,
                'time': '1990-09-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'FRUT'
              },
          22:
              {
                'ts': 670363200,
                'time': '1991-03-30T20:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'FRUST'
              },
          23:
              {
                'ts': 683582400,
                'time': '1991-08-30T20:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          24:
              {
                'ts': 703018800,
                'time': '1992-04-11T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          25:
              {
                'ts': 717530400,
                'time': '1992-09-26T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          26:
              {
                'ts': 734468400,
                'time': '1993-04-10T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          27:
              {
                'ts': 748980000,
                'time': '1993-09-25T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          28:
              {
                'ts': 765918000,
                'time': '1994-04-09T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          29:
              {
                'ts': 780429600,
                'time': '1994-09-24T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          30:
              {
                'ts': 797367600,
                'time': '1995-04-08T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          31:
              {
                'ts': 811879200,
                'time': '1995-09-23T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          32:
              {
                'ts': 828817200,
                'time': '1996-04-06T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          33:
              {
                'ts': 843933600,
                'time': '1996-09-28T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          34:
              {
                'ts': 859671000,
                'time': '1997-03-29T21:30:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          35:
              {
                'ts': 877811400,
                'time': '1997-10-25T20:30:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          36:
              {
                'ts': 891120600,
                'time': '1998-03-28T21:30:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          37:
              {
                'ts': 909261000,
                'time': '1998-10-24T20:30:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          38:
              {
                'ts': 922570200,
                'time': '1999-03-27T21:30:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          39:
              {
                'ts': 941315400,
                'time': '1999-10-30T20:30:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          40:
              {
                'ts': 954019800,
                'time': '2000-03-25T21:30:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          41:
              {
                'ts': 972765000,
                'time': '2000-10-28T20:30:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          42:
              {
                'ts': 985469400,
                'time': '2001-03-24T21:30:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          43:
              {
                'ts': 1004214600,
                'time': '2001-10-27T20:30:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          44:
              {
                'ts': 1017523800,
                'time': '2002-03-30T21:30:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          45:
              {
                'ts': 1035664200,
                'time': '2002-10-26T20:30:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          46:
              {
                'ts': 1048973400,
                'time': '2003-03-29T21:30:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          47:
              {
                'ts': 1067113800,
                'time': '2003-10-25T20:30:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          48:
              {
                'ts': 1080423000,
                'time': '2004-03-27T21:30:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          49:
              {
                'ts': 1099168200,
                'time': '2004-10-30T20:30:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KGT'
              },
          50:
              {
                'ts': 1111872600,
                'time': '2005-03-26T21:30:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KGST'
              },
          51:
              {
                'ts': 1123783200,
                'time': '2005-08-11T18:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'KGT'
              }
        },
    'Asia/Brunei':
        {
          0:
              {
                'ts': -1383464380,
                'time': '1926-02-28T16:20:20+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'BNT'
              },
          1:
              {
                'ts': -1167636600,
                'time': '1932-12-31T16:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'BNT'
              }
        },
    'Asia/Calcutta':
        {
          0:
              {
                'ts': -891582800,
                'time': '1941-09-30T18:06:40+0000',
                'offset': 23400,
                'isdst': false,
                'abbr': 'BURT'
              },
          1:
              {
                'ts': -872058600,
                'time': '1942-05-14T17:30:00+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              },
          2:
              {
                'ts': -862637400,
                'time': '1942-08-31T18:30:00+0000',
                'offset': 23400,
                'isdst': true,
                'abbr': 'IST'
              },
          3:
              {
                'ts': -764145000,
                'time': '1945-10-14T17:30:00+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              }
        },
    'Asia/Choibalsan':
        {
          0:
              {
                'ts': -2032933080,
                'time': '1905-07-31T16:22:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'ULAT'
              },
          1:
              {
                'ts': 252435600,
                'time': '1977-12-31T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          2:
              {
                'ts': 417974400,
                'time': '1983-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          3:
              {
                'ts': 433778400,
                'time': '1983-09-30T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          4:
              {
                'ts': 449593200,
                'time': '1984-03-31T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          5:
              {
                'ts': 465314400,
                'time': '1984-09-29T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          6:
              {
                'ts': 481042800,
                'time': '1985-03-30T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          7:
              {
                'ts': 496764000,
                'time': '1985-09-28T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          8:
              {
                'ts': 512492400,
                'time': '1986-03-29T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          9:
              {
                'ts': 528213600,
                'time': '1986-09-27T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          10:
              {
                'ts': 543942000,
                'time': '1987-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          11:
              {
                'ts': 559663200,
                'time': '1987-09-26T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          12:
              {
                'ts': 575391600,
                'time': '1988-03-26T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          13:
              {
                'ts': 591112800,
                'time': '1988-09-24T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          14:
              {
                'ts': 606841200,
                'time': '1989-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          15:
              {
                'ts': 622562400,
                'time': '1989-09-23T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          16:
              {
                'ts': 638290800,
                'time': '1990-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          17:
              {
                'ts': 654616800,
                'time': '1990-09-29T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          18:
              {
                'ts': 670345200,
                'time': '1991-03-30T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          19:
              {
                'ts': 686066400,
                'time': '1991-09-28T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          20:
              {
                'ts': 701794800,
                'time': '1992-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          21:
              {
                'ts': 717516000,
                'time': '1992-09-26T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          22:
              {
                'ts': 733244400,
                'time': '1993-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          23:
              {
                'ts': 748965600,
                'time': '1993-09-25T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          24:
              {
                'ts': 764694000,
                'time': '1994-03-26T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          25:
              {
                'ts': 780415200,
                'time': '1994-09-24T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          26:
              {
                'ts': 796143600,
                'time': '1995-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          27:
              {
                'ts': 811864800,
                'time': '1995-09-23T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          28:
              {
                'ts': 828198000,
                'time': '1996-03-30T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          29:
              {
                'ts': 843919200,
                'time': '1996-09-28T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          30:
              {
                'ts': 859647600,
                'time': '1997-03-29T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          31:
              {
                'ts': 875368800,
                'time': '1997-09-27T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          32:
              {
                'ts': 891097200,
                'time': '1998-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          33:
              {
                'ts': 906818400,
                'time': '1998-09-26T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          34:
              {
                'ts': 988390800,
                'time': '2001-04-27T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          35:
              {
                'ts': 1001692800,
                'time': '2001-09-28T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          36:
              {
                'ts': 1017421200,
                'time': '2002-03-29T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          37:
              {
                'ts': 1033142400,
                'time': '2002-09-27T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          38:
              {
                'ts': 1048870800,
                'time': '2003-03-28T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          39:
              {
                'ts': 1064592000,
                'time': '2003-09-26T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          40:
              {
                'ts': 1080320400,
                'time': '2004-03-26T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          41:
              {
                'ts': 1096041600,
                'time': '2004-09-24T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          42:
              {
                'ts': 1111770000,
                'time': '2005-03-25T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          43:
              {
                'ts': 1127491200,
                'time': '2005-09-23T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              },
          44:
              {
                'ts': 1143219600,
                'time': '2006-03-24T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'CHOST'
              },
          45:
              {
                'ts': 1159545600,
                'time': '2006-09-29T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHOT'
              }
        },
    'Asia/Chongqing':
        {
          0:
              {
                'ts': -1325487980,
                'time': '1927-12-31T16:53:40+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'LONT'
              },
          1:
              {
                'ts': 325962000,
                'time': '1980-04-30T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': 515520000,
                'time': '1986-05-03T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': 527007600,
                'time': '1986-09-13T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': 545155200,
                'time': '1987-04-11T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': 558457200,
                'time': '1987-09-12T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': 576604800,
                'time': '1988-04-09T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': 589906800,
                'time': '1988-09-10T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': 608659200,
                'time': '1989-04-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          9:
              {
                'ts': 621961200,
                'time': '1989-09-16T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': 640108800,
                'time': '1990-04-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          11:
              {
                'ts': 653410800,
                'time': '1990-09-15T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': 671558400,
                'time': '1991-04-13T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          13:
              {
                'ts': 684860400,
                'time': '1991-09-14T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Asia/Chungking':
        {
          0:
              {
                'ts': -1325487980,
                'time': '1927-12-31T16:53:40+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'LONT'
              },
          1:
              {
                'ts': 325962000,
                'time': '1980-04-30T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': 515520000,
                'time': '1986-05-03T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': 527007600,
                'time': '1986-09-13T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': 545155200,
                'time': '1987-04-11T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': 558457200,
                'time': '1987-09-12T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': 576604800,
                'time': '1988-04-09T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': 589906800,
                'time': '1988-09-10T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': 608659200,
                'time': '1989-04-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          9:
              {
                'ts': 621961200,
                'time': '1989-09-16T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': 640108800,
                'time': '1990-04-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          11:
              {
                'ts': 653410800,
                'time': '1990-09-15T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': 671558400,
                'time': '1991-04-13T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          13:
              {
                'ts': 684860400,
                'time': '1991-09-14T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Asia/Colombo':
        {
          0:
              {
                'ts': -2019705572,
                'time': '1905-12-31T18:40:28+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              },
          1:
              {
                'ts': -883287000,
                'time': '1942-01-04T18:30:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'IHST'
              },
          2:
              {
                'ts': -862639200,
                'time': '1942-08-31T18:00:00+0000',
                'offset': 23400,
                'isdst': true,
                'abbr': 'IST'
              },
          3:
              {
                'ts': -764051400,
                'time': '1945-10-15T19:30:00+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              },
          4:
              {
                'ts': 832962600,
                'time': '1996-05-24T18:30:00+0000',
                'offset': 23400,
                'isdst': false,
                'abbr': 'LKT'
              },
          5:
              {
                'ts': 846266400,
                'time': '1996-10-25T18:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'LKT'
              },
          6:
              {
                'ts': 1145039400,
                'time': '2006-04-14T18:30:00+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              }
        },
    'Asia/Dacca':
        {
          0:
              {
                'ts': -891582800,
                'time': '1941-09-30T18:06:40+0000',
                'offset': 23400,
                'isdst': false,
                'abbr': 'BURT'
              },
          1:
              {
                'ts': -872058600,
                'time': '1942-05-14T17:30:00+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              },
          2:
              {
                'ts': -862637400,
                'time': '1942-08-31T18:30:00+0000',
                'offset': 23400,
                'isdst': false,
                'abbr': 'BURT'
              },
          3:
              {
                'ts': -576138600,
                'time': '1951-09-29T17:30:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DACT'
              },
          4:
              {
                'ts': 38772000,
                'time': '1971-03-25T18:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'BDT'
              }
        },
    'Asia/Damascus':
        {
          0:
              {
                'ts': -1577931912,
                'time': '1919-12-31T21:34:48+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -1568592000,
                'time': '1920-04-18T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          2:
              {
                'ts': -1554080400,
                'time': '1920-10-02T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': -1537142400,
                'time': '1921-04-17T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          4:
              {
                'ts': -1522630800,
                'time': '1921-10-01T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': -1505692800,
                'time': '1922-04-16T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          6:
              {
                'ts': -1491181200,
                'time': '1922-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': -1474243200,
                'time': '1923-04-15T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': -1459126800,
                'time': '1923-10-06T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': -242265600,
                'time': '1962-04-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          10:
              {
                'ts': -228877200,
                'time': '1962-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          11:
              {
                'ts': -210556800,
                'time': '1963-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          12:
              {
                'ts': -197427600,
                'time': '1963-09-29T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': -178934400,
                'time': '1964-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          14:
              {
                'ts': -165718800,
                'time': '1964-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          15:
              {
                'ts': -147398400,
                'time': '1965-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          16:
              {
                'ts': -134269200,
                'time': '1965-09-29T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          17:
              {
                'ts': -116467200,
                'time': '1966-04-24T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          18:
              {
                'ts': -102646800,
                'time': '1966-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          19:
              {
                'ts': -84326400,
                'time': '1967-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          20:
              {
                'ts': -71110800,
                'time': '1967-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          21:
              {
                'ts': -52704000,
                'time': '1968-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          22:
              {
                'ts': -39488400,
                'time': '1968-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          23:
              {
                'ts': -21168000,
                'time': '1969-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          24:
              {
                'ts': -7952400,
                'time': '1969-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          25:
              {
                'ts': 10368000,
                'time': '1970-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          26:
              {
                'ts': 23583600,
                'time': '1970-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': 41904000,
                'time': '1971-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': 55119600,
                'time': '1971-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 73526400,
                'time': '1972-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 86742000,
                'time': '1972-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 105062400,
                'time': '1973-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 118278000,
                'time': '1973-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 136598400,
                'time': '1974-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 149814000,
                'time': '1974-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 168134400,
                'time': '1975-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 181350000,
                'time': '1975-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 199756800,
                'time': '1976-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 212972400,
                'time': '1976-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 231292800,
                'time': '1977-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 241916400,
                'time': '1977-08-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 262828800,
                'time': '1978-05-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 273452400,
                'time': '1978-08-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 418694400,
                'time': '1983-04-09T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 433810800,
                'time': '1983-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 450316800,
                'time': '1984-04-09T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 465433200,
                'time': '1984-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 508896000,
                'time': '1986-02-16T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 529196400,
                'time': '1986-10-08T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 541555200,
                'time': '1987-03-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 562633200,
                'time': '1987-10-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 574387200,
                'time': '1988-03-15T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 594255600,
                'time': '1988-10-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 607305600,
                'time': '1989-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 623199600,
                'time': '1989-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 638928000,
                'time': '1990-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 654649200,
                'time': '1990-09-29T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 670456800,
                'time': '1991-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 686264400,
                'time': '1991-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 702684000,
                'time': '1992-04-07T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 717886800,
                'time': '1992-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 733096800,
                'time': '1993-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 748904400,
                'time': '1993-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 765151200,
                'time': '1994-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 780958800,
                'time': '1994-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 796687200,
                'time': '1995-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 812494800,
                'time': '1995-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 828309600,
                'time': '1996-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 844117200,
                'time': '1996-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 859759200,
                'time': '1997-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 875653200,
                'time': '1997-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 891208800,
                'time': '1998-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 907189200,
                'time': '1998-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 922917600,
                'time': '1999-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 938725200,
                'time': '1999-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 954540000,
                'time': '2000-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 970347600,
                'time': '2000-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 986076000,
                'time': '2001-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1001883600,
                'time': '2001-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1017612000,
                'time': '2002-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1033419600,
                'time': '2002-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1049148000,
                'time': '2003-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1064955600,
                'time': '2003-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1080770400,
                'time': '2004-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1096578000,
                'time': '2004-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1112306400,
                'time': '2005-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1128114000,
                'time': '2005-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1143842400,
                'time': '2006-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1158872400,
                'time': '2006-09-21T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1175205600,
                'time': '2007-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1193950800,
                'time': '2007-11-01T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1207260000,
                'time': '2008-04-03T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1222808400,
                'time': '2008-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1238709600,
                'time': '2009-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1254344400,
                'time': '2009-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1270159200,
                'time': '2010-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1285880400,
                'time': '2010-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1301608800,
                'time': '2011-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1317416400,
                'time': '2011-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1333663200,
                'time': '2012-04-05T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1349038800,
                'time': '2012-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1365112800,
                'time': '2013-04-04T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1380574800,
                'time': '2013-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1396562400,
                'time': '2014-04-03T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1412110800,
                'time': '2014-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1428012000,
                'time': '2015-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1443646800,
                'time': '2015-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1459461600,
                'time': '2016-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1475269200,
                'time': '2016-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1491516000,
                'time': '2017-04-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1506805200,
                'time': '2017-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1522965600,
                'time': '2018-04-05T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 1538341200,
                'time': '2018-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 1554415200,
                'time': '2019-04-04T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 1569877200,
                'time': '2019-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 1585864800,
                'time': '2020-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 1601499600,
                'time': '2020-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 1617314400,
                'time': '2021-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 1633035600,
                'time': '2021-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 1648764000,
                'time': '2022-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 1664571600,
                'time': '2022-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          121:
              {
                'ts': 1680818400,
                'time': '2023-04-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          122:
              {
                'ts': 1696107600,
                'time': '2023-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          123:
              {
                'ts': 1712268000,
                'time': '2024-04-04T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          124:
              {
                'ts': 1727730000,
                'time': '2024-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          125:
              {
                'ts': 1743717600,
                'time': '2025-04-03T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          126:
              {
                'ts': 1759266000,
                'time': '2025-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          127:
              {
                'ts': 1775167200,
                'time': '2026-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          128:
              {
                'ts': 1790802000,
                'time': '2026-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          129:
              {
                'ts': 1806616800,
                'time': '2027-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          130:
              {
                'ts': 1822338000,
                'time': '2027-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          131:
              {
                'ts': 1838671200,
                'time': '2028-04-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          132:
              {
                'ts': 1853960400,
                'time': '2028-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          133:
              {
                'ts': 1870120800,
                'time': '2029-04-05T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          134:
              {
                'ts': 1885496400,
                'time': '2029-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          135:
              {
                'ts': 1901570400,
                'time': '2030-04-04T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          136:
              {
                'ts': 1917032400,
                'time': '2030-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          137:
              {
                'ts': 1933020000,
                'time': '2031-04-03T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          138:
              {
                'ts': 1948568400,
                'time': '2031-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          139:
              {
                'ts': 1964469600,
                'time': '2032-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          140:
              {
                'ts': 1980190800,
                'time': '2032-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          141:
              {
                'ts': 1995919200,
                'time': '2033-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          142:
              {
                'ts': 2011726800,
                'time': '2033-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          143:
              {
                'ts': 2027973600,
                'time': '2034-04-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          144:
              {
                'ts': 2043262800,
                'time': '2034-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          145:
              {
                'ts': 2059423200,
                'time': '2035-04-05T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          146:
              {
                'ts': 2074798800,
                'time': '2035-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          147:
              {
                'ts': 2090872800,
                'time': '2036-04-03T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          148:
              {
                'ts': 2106421200,
                'time': '2036-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          149:
              {
                'ts': 2122322400,
                'time': '2037-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          150:
              {
                'ts': 2137957200,
                'time': '2037-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Asia/Dhaka':
        {
          0:
              {
                'ts': -891582800,
                'time': '1941-09-30T18:06:40+0000',
                'offset': 23400,
                'isdst': false,
                'abbr': 'BURT'
              },
          1:
              {
                'ts': -872058600,
                'time': '1942-05-14T17:30:00+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              },
          2:
              {
                'ts': -862637400,
                'time': '1942-08-31T18:30:00+0000',
                'offset': 23400,
                'isdst': false,
                'abbr': 'BURT'
              },
          3:
              {
                'ts': -576138600,
                'time': '1951-09-29T17:30:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DACT'
              },
          4:
              {
                'ts': 38772000,
                'time': '1971-03-25T18:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'BDT'
              }
        },
    'Asia/Dili':
        {
          0:
              {
                'ts': -1830414140,
                'time': '1911-12-31T15:37:40+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'TLT'
              },
          1:
              {
                'ts': -879152400,
                'time': '1942-02-21T15:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          2:
              {
                'ts': -766054800,
                'time': '1945-09-22T15:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'TLT'
              },
          3:
              {
                'ts': 199897200,
                'time': '1976-05-02T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CIT'
              },
          4:
              {
                'ts': 969120000,
                'time': '2000-09-16T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'TLT'
              }
        },
    'Asia/Dubai':
        {
          0:
              {
                'ts': -1577936472,
                'time': '1919-12-31T20:18:48+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GST'
              }
        },
    'Asia/Dushanbe':
        {
          0:
              {
                'ts': -1441168512,
                'time': '1924-05-01T19:24:48+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'DUST'
              },
          1:
              {
                'ts': -1247547600,
                'time': '1930-06-20T19:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DUST'
              },
          2:
              {
                'ts': 354909600,
                'time': '1981-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'DUSST'
              },
          3:
              {
                'ts': 370717200,
                'time': '1981-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DUST'
              },
          4:
              {
                'ts': 386445600,
                'time': '1982-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'DUSST'
              },
          5:
              {
                'ts': 402253200,
                'time': '1982-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DUST'
              },
          6:
              {
                'ts': 417981600,
                'time': '1983-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'DUSST'
              },
          7:
              {
                'ts': 433789200,
                'time': '1983-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DUST'
              },
          8:
              {
                'ts': 449604000,
                'time': '1984-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'DUSST'
              },
          9:
              {
                'ts': 465336000,
                'time': '1984-09-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DUST'
              },
          10:
              {
                'ts': 481060800,
                'time': '1985-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'DUSST'
              },
          11:
              {
                'ts': 496785600,
                'time': '1985-09-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DUST'
              },
          12:
              {
                'ts': 512510400,
                'time': '1986-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'DUSST'
              },
          13:
              {
                'ts': 528235200,
                'time': '1986-09-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DUST'
              },
          14:
              {
                'ts': 543960000,
                'time': '1987-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'DUSST'
              },
          15:
              {
                'ts': 559684800,
                'time': '1987-09-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DUST'
              },
          16:
              {
                'ts': 575409600,
                'time': '1988-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'DUSST'
              },
          17:
              {
                'ts': 591134400,
                'time': '1988-09-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DUST'
              },
          18:
              {
                'ts': 606859200,
                'time': '1989-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'DUSST'
              },
          19:
              {
                'ts': 622584000,
                'time': '1989-09-23T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DUST'
              },
          20:
              {
                'ts': 638308800,
                'time': '1990-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'DUSST'
              },
          21:
              {
                'ts': 654638400,
                'time': '1990-09-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'DUST'
              },
          22:
              {
                'ts': 670363200,
                'time': '1991-03-30T20:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'DUSST'
              },
          23:
              {
                'ts': 684363600,
                'time': '1991-09-08T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'TJT'
              }
        },
    'Asia/Gaza':
        {
          0:
              {
                'ts': -933645600,
                'time': '1940-05-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -857358000,
                'time': '1942-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          2:
              {
                'ts': -844300800,
                'time': '1943-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EET'
              },
          3:
              {
                'ts': -825822000,
                'time': '1943-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          4:
              {
                'ts': -812685600,
                'time': '1944-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EET'
              },
          5:
              {
                'ts': -794199600,
                'time': '1944-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          6:
              {
                'ts': -779853600,
                'time': '1945-04-15T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EET'
              },
          7:
              {
                'ts': -762656400,
                'time': '1945-10-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          8:
              {
                'ts': -748310400,
                'time': '1946-04-16T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EET'
              },
          9:
              {
                'ts': -731127600,
                'time': '1946-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          10:
              {
                'ts': -399088800,
                'time': '1957-05-09T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          11:
              {
                'ts': -386650800,
                'time': '1957-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          12:
              {
                'ts': -368330400,
                'time': '1958-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          13:
              {
                'ts': -355114800,
                'time': '1958-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          14:
              {
                'ts': -336790800,
                'time': '1959-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          15:
              {
                'ts': -323654400,
                'time': '1959-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          16:
              {
                'ts': -305168400,
                'time': '1960-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          17:
              {
                'ts': -292032000,
                'time': '1960-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          18:
              {
                'ts': -273632400,
                'time': '1961-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          19:
              {
                'ts': -260496000,
                'time': '1961-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          20:
              {
                'ts': -242096400,
                'time': '1962-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          21:
              {
                'ts': -228960000,
                'time': '1962-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          22:
              {
                'ts': -210560400,
                'time': '1963-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          23:
              {
                'ts': -197424000,
                'time': '1963-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          24:
              {
                'ts': -178938000,
                'time': '1964-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          25:
              {
                'ts': -165801600,
                'time': '1964-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          26:
              {
                'ts': -147402000,
                'time': '1965-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          27:
              {
                'ts': -134265600,
                'time': '1965-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          28:
              {
                'ts': -115866000,
                'time': '1966-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          29:
              {
                'ts': -102643200,
                'time': '1966-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          30:
              {
                'ts': -84330000,
                'time': '1967-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          31:
              {
                'ts': -81313200,
                'time': '1967-06-04T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          32:
              {
                'ts': 142380000,
                'time': '1974-07-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          33:
              {
                'ts': 150843600,
                'time': '1974-10-12T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          34:
              {
                'ts': 167176800,
                'time': '1975-04-19T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          35:
              {
                'ts': 178664400,
                'time': '1975-08-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          36:
              {
                'ts': 482277600,
                'time': '1985-04-13T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          37:
              {
                'ts': 495579600,
                'time': '1985-09-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          38:
              {
                'ts': 516751200,
                'time': '1986-05-17T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          39:
              {
                'ts': 526424400,
                'time': '1986-09-06T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          40:
              {
                'ts': 545436000,
                'time': '1987-04-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          41:
              {
                'ts': 558478800,
                'time': '1987-09-12T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          42:
              {
                'ts': 576540000,
                'time': '1988-04-08T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          43:
              {
                'ts': 589237200,
                'time': '1988-09-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          44:
              {
                'ts': 609890400,
                'time': '1989-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          45:
              {
                'ts': 620773200,
                'time': '1989-09-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          46:
              {
                'ts': 638316000,
                'time': '1990-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          47:
              {
                'ts': 651618000,
                'time': '1990-08-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          48:
              {
                'ts': 669765600,
                'time': '1991-03-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          49:
              {
                'ts': 683672400,
                'time': '1991-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          50:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          51:
              {
                'ts': 715726800,
                'time': '1992-09-05T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          52:
              {
                'ts': 733701600,
                'time': '1993-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          53:
              {
                'ts': 747176400,
                'time': '1993-09-04T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          54:
              {
                'ts': 765151200,
                'time': '1994-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          55:
              {
                'ts': 778021200,
                'time': '1994-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          56:
              {
                'ts': 796600800,
                'time': '1995-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          57:
              {
                'ts': 810075600,
                'time': '1995-09-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          58:
              {
                'ts': 820447200,
                'time': '1995-12-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 828655200,
                'time': '1996-04-04T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 843170400,
                'time': '1996-09-19T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 860104800,
                'time': '1997-04-03T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 874620000,
                'time': '1997-09-18T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 891554400,
                'time': '1998-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 906069600,
                'time': '1998-09-17T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 915141600,
                'time': '1998-12-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          66:
              {
                'ts': 924213600,
                'time': '1999-04-15T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          67:
              {
                'ts': 939934800,
                'time': '1999-10-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          68:
              {
                'ts': 956268000,
                'time': '2000-04-20T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          69:
              {
                'ts': 971989200,
                'time': '2000-10-19T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          70:
              {
                'ts': 987717600,
                'time': '2001-04-19T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          71:
              {
                'ts': 1003438800,
                'time': '2001-10-18T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          72:
              {
                'ts': 1019167200,
                'time': '2002-04-18T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          73:
              {
                'ts': 1034888400,
                'time': '2002-10-17T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          74:
              {
                'ts': 1050616800,
                'time': '2003-04-17T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          75:
              {
                'ts': 1066338000,
                'time': '2003-10-16T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          76:
              {
                'ts': 1082066400,
                'time': '2004-04-15T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          77:
              {
                'ts': 1096581600,
                'time': '2004-09-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          78:
              {
                'ts': 1113516000,
                'time': '2005-04-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          79:
              {
                'ts': 1128380400,
                'time': '2005-10-03T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          80:
              {
                'ts': 1143842400,
                'time': '2006-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          81:
              {
                'ts': 1158872400,
                'time': '2006-09-21T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          82:
              {
                'ts': 1175378400,
                'time': '2007-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          83:
              {
                'ts': 1189638000,
                'time': '2007-09-12T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          84:
              {
                'ts': 1207000800,
                'time': '2008-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          85:
              {
                'ts': 1221087600,
                'time': '2008-09-10T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          86:
              {
                'ts': 1238536800,
                'time': '2009-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          87:
              {
                'ts': 1252537200,
                'time': '2009-09-09T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          88:
              {
                'ts': 1270072800,
                'time': '2010-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          89:
              {
                'ts': 1283986800,
                'time': '2010-09-08T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          90:
              {
                'ts': 1301608800,
                'time': '2011-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          91:
              {
                'ts': 1315436400,
                'time': '2011-09-07T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          92:
              {
                'ts': 1333231200,
                'time': '2012-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          93:
              {
                'ts': 1347490800,
                'time': '2012-09-12T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          94:
              {
                'ts': 1364767200,
                'time': '2013-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          95:
              {
                'ts': 1378940400,
                'time': '2013-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          96:
              {
                'ts': 1396303200,
                'time': '2014-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          97:
              {
                'ts': 1410390000,
                'time': '2014-09-10T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          98:
              {
                'ts': 1427839200,
                'time': '2015-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          99:
              {
                'ts': 1441839600,
                'time': '2015-09-09T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          100:
              {
                'ts': 1459461600,
                'time': '2016-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          101:
              {
                'ts': 1473289200,
                'time': '2016-09-07T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          102:
              {
                'ts': 1490997600,
                'time': '2017-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          103:
              {
                'ts': 1505343600,
                'time': '2017-09-13T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          104:
              {
                'ts': 1522533600,
                'time': '2018-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          105:
              {
                'ts': 1536793200,
                'time': '2018-09-12T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          106:
              {
                'ts': 1554069600,
                'time': '2019-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          107:
              {
                'ts': 1568242800,
                'time': '2019-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          108:
              {
                'ts': 1585692000,
                'time': '2020-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          109:
              {
                'ts': 1599692400,
                'time': '2020-09-09T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          110:
              {
                'ts': 1617228000,
                'time': '2021-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          111:
              {
                'ts': 1631142000,
                'time': '2021-09-08T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          112:
              {
                'ts': 1648764000,
                'time': '2022-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          113:
              {
                'ts': 1662591600,
                'time': '2022-09-07T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          114:
              {
                'ts': 1680300000,
                'time': '2023-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          115:
              {
                'ts': 1694646000,
                'time': '2023-09-13T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          116:
              {
                'ts': 1711922400,
                'time': '2024-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          117:
              {
                'ts': 1726095600,
                'time': '2024-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          118:
              {
                'ts': 1743458400,
                'time': '2025-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          119:
              {
                'ts': 1757545200,
                'time': '2025-09-10T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          120:
              {
                'ts': 1774994400,
                'time': '2026-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          121:
              {
                'ts': 1788994800,
                'time': '2026-09-09T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          122:
              {
                'ts': 1806530400,
                'time': '2027-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          123:
              {
                'ts': 1820444400,
                'time': '2027-09-08T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          124:
              {
                'ts': 1838152800,
                'time': '2028-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          125:
              {
                'ts': 1852498800,
                'time': '2028-09-13T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          126:
              {
                'ts': 1869688800,
                'time': '2029-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          127:
              {
                'ts': 1883948400,
                'time': '2029-09-12T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          128:
              {
                'ts': 1901224800,
                'time': '2030-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          129:
              {
                'ts': 1915398000,
                'time': '2030-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          130:
              {
                'ts': 1932760800,
                'time': '2031-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          131:
              {
                'ts': 1946847600,
                'time': '2031-09-10T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          132:
              {
                'ts': 1964383200,
                'time': '2032-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          133:
              {
                'ts': 1978297200,
                'time': '2032-09-08T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          134:
              {
                'ts': 1995919200,
                'time': '2033-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          135:
              {
                'ts': 2009746800,
                'time': '2033-09-07T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          136:
              {
                'ts': 2027455200,
                'time': '2034-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          137:
              {
                'ts': 2041801200,
                'time': '2034-09-13T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          138:
              {
                'ts': 2058991200,
                'time': '2035-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          139:
              {
                'ts': 2073250800,
                'time': '2035-09-12T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          140:
              {
                'ts': 2090613600,
                'time': '2036-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          141:
              {
                'ts': 2104700400,
                'time': '2036-09-10T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          142:
              {
                'ts': 2122149600,
                'time': '2037-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          143:
              {
                'ts': 2136150000,
                'time': '2037-09-09T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Asia/Harbin':
        {
          0:
              {
                'ts': -1325492804,
                'time': '1927-12-31T15:33:16+0000',
                'offset': 30600,
                'isdst': false,
                'abbr': 'CHAT'
              },
          1:
              {
                'ts': -1194078600,
                'time': '1932-02-29T15:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -946800000,
                'time': '1939-12-31T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CHAT'
              },
          3:
              {
                'ts': -115894800,
                'time': '1966-04-30T15:00:00+0000',
                'offset': 30600,
                'isdst': false,
                'abbr': 'CHAT'
              },
          4:
              {
                'ts': 325956600,
                'time': '1980-04-30T15:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': 515520000,
                'time': '1986-05-03T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': 527007600,
                'time': '1986-09-13T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': 545155200,
                'time': '1987-04-11T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': 558457200,
                'time': '1987-09-12T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 576604800,
                'time': '1988-04-09T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': 589906800,
                'time': '1988-09-10T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 608659200,
                'time': '1989-04-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': 621961200,
                'time': '1989-09-16T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 640108800,
                'time': '1990-04-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': 653410800,
                'time': '1990-09-15T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 671558400,
                'time': '1991-04-13T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': 684860400,
                'time': '1991-09-14T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Asia/Ho_Chi_Minh':
        {
          0:
              {
                'ts': -2005974400,
                'time': '1906-06-08T16:53:20+0000',
                'offset': 25580,
                'isdst': false,
                'abbr': 'SMT'
              },
          1:
              {
                'ts': -1855983920,
                'time': '1911-03-10T16:54:40+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'ICT'
              },
          2:
              {
                'ts': -1819954800,
                'time': '1912-04-30T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ICT'
              },
          3:
              {
                'ts': -1220428800,
                'time': '1931-04-30T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'ICT'
              }
        },
    'Asia/Hong_Kong':
        {
          0:
              {
                'ts': -2056692996,
                'time': '1904-10-29T16:23:24+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          1:
              {
                'ts': -747981000,
                'time': '1946-04-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          2:
              {
                'ts': -728544600,
                'time': '1946-11-30T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          3:
              {
                'ts': -717049800,
                'time': '1947-04-12T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          4:
              {
                'ts': -694503000,
                'time': '1947-12-29T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          5:
              {
                'ts': -683785800,
                'time': '1948-05-01T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          6:
              {
                'ts': -668064600,
                'time': '1948-10-30T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          7:
              {
                'ts': -654755400,
                'time': '1949-04-02T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          8:
              {
                'ts': -636615000,
                'time': '1949-10-29T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          9:
              {
                'ts': -623305800,
                'time': '1950-04-01T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          10:
              {
                'ts': -605165400,
                'time': '1950-10-28T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          11:
              {
                'ts': -591856200,
                'time': '1951-03-31T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          12:
              {
                'ts': -573715800,
                'time': '1951-10-27T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          13:
              {
                'ts': -559801800,
                'time': '1952-04-05T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          14:
              {
                'ts': -542266200,
                'time': '1952-10-25T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          15:
              {
                'ts': -528352200,
                'time': '1953-04-04T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          16:
              {
                'ts': -510211800,
                'time': '1953-10-31T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          17:
              {
                'ts': -498112200,
                'time': '1954-03-20T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          18:
              {
                'ts': -478762200,
                'time': '1954-10-30T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          19:
              {
                'ts': -466662600,
                'time': '1955-03-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          20:
              {
                'ts': -446707800,
                'time': '1955-11-05T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          21:
              {
                'ts': -435213000,
                'time': '1956-03-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          22:
              {
                'ts': -415258200,
                'time': '1956-11-03T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          23:
              {
                'ts': -403158600,
                'time': '1957-03-23T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          24:
              {
                'ts': -383808600,
                'time': '1957-11-02T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          25:
              {
                'ts': -371709000,
                'time': '1958-03-22T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          26:
              {
                'ts': -352359000,
                'time': '1958-11-01T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          27:
              {
                'ts': -340259400,
                'time': '1959-03-21T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          28:
              {
                'ts': -320909400,
                'time': '1959-10-31T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          29:
              {
                'ts': -308809800,
                'time': '1960-03-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          30:
              {
                'ts': -288855000,
                'time': '1960-11-05T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          31:
              {
                'ts': -277360200,
                'time': '1961-03-18T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          32:
              {
                'ts': -257405400,
                'time': '1961-11-04T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          33:
              {
                'ts': -245910600,
                'time': '1962-03-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          34:
              {
                'ts': -225955800,
                'time': '1962-11-03T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          35:
              {
                'ts': -213856200,
                'time': '1963-03-23T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          36:
              {
                'ts': -194506200,
                'time': '1963-11-02T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          37:
              {
                'ts': -182406600,
                'time': '1964-03-21T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          38:
              {
                'ts': -163056600,
                'time': '1964-10-31T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          39:
              {
                'ts': -148537800,
                'time': '1965-04-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          40:
              {
                'ts': -132816600,
                'time': '1965-10-16T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          41:
              {
                'ts': -117088200,
                'time': '1966-04-16T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          42:
              {
                'ts': -101367000,
                'time': '1966-10-15T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          43:
              {
                'ts': -85638600,
                'time': '1967-04-15T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          44:
              {
                'ts': -69312600,
                'time': '1967-10-21T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          45:
              {
                'ts': -53584200,
                'time': '1968-04-20T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          46:
              {
                'ts': -37863000,
                'time': '1968-10-19T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          47:
              {
                'ts': -22134600,
                'time': '1969-04-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          48:
              {
                'ts': -6413400,
                'time': '1969-10-18T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          49:
              {
                'ts': 9315000,
                'time': '1970-04-18T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          50:
              {
                'ts': 25036200,
                'time': '1970-10-17T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          51:
              {
                'ts': 40764600,
                'time': '1971-04-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          52:
              {
                'ts': 56485800,
                'time': '1971-10-16T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          53:
              {
                'ts': 72214200,
                'time': '1972-04-15T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          54:
              {
                'ts': 88540200,
                'time': '1972-10-21T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          55:
              {
                'ts': 104268600,
                'time': '1973-04-21T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          56:
              {
                'ts': 119989800,
                'time': '1973-10-20T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          57:
              {
                'ts': 135718200,
                'time': '1974-04-20T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          58:
              {
                'ts': 151439400,
                'time': '1974-10-19T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          59:
              {
                'ts': 167167800,
                'time': '1975-04-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          60:
              {
                'ts': 182889000,
                'time': '1975-10-18T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          61:
              {
                'ts': 198617400,
                'time': '1976-04-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          62:
              {
                'ts': 214338600,
                'time': '1976-10-16T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          63:
              {
                'ts': 230067000,
                'time': '1977-04-16T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          64:
              {
                'ts': 245788200,
                'time': '1977-10-15T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          65:
              {
                'ts': 295385400,
                'time': '1979-05-12T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          66:
              {
                'ts': 309292200,
                'time': '1979-10-20T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          67:
              {
                'ts': 326835000,
                'time': '1980-05-10T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          68:
              {
                'ts': 340741800,
                'time': '1980-10-18T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              }
        },
    'Asia/Hovd':
        {
          0:
              {
                'ts': -2032927596,
                'time': '1905-07-31T17:53:24+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'HOVT'
              },
          1:
              {
                'ts': 252439200,
                'time': '1977-12-31T18:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          2:
              {
                'ts': 417978000,
                'time': '1983-03-31T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          3:
              {
                'ts': 433785600,
                'time': '1983-09-30T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          4:
              {
                'ts': 449600400,
                'time': '1984-03-31T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          5:
              {
                'ts': 465321600,
                'time': '1984-09-29T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          6:
              {
                'ts': 481050000,
                'time': '1985-03-30T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          7:
              {
                'ts': 496771200,
                'time': '1985-09-28T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          8:
              {
                'ts': 512499600,
                'time': '1986-03-29T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          9:
              {
                'ts': 528220800,
                'time': '1986-09-27T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          10:
              {
                'ts': 543949200,
                'time': '1987-03-28T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          11:
              {
                'ts': 559670400,
                'time': '1987-09-26T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          12:
              {
                'ts': 575398800,
                'time': '1988-03-26T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          13:
              {
                'ts': 591120000,
                'time': '1988-09-24T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          14:
              {
                'ts': 606848400,
                'time': '1989-03-25T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          15:
              {
                'ts': 622569600,
                'time': '1989-09-23T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          16:
              {
                'ts': 638298000,
                'time': '1990-03-24T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          17:
              {
                'ts': 654624000,
                'time': '1990-09-29T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          18:
              {
                'ts': 670352400,
                'time': '1991-03-30T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          19:
              {
                'ts': 686073600,
                'time': '1991-09-28T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          20:
              {
                'ts': 701802000,
                'time': '1992-03-28T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          21:
              {
                'ts': 717523200,
                'time': '1992-09-26T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          22:
              {
                'ts': 733251600,
                'time': '1993-03-27T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          23:
              {
                'ts': 748972800,
                'time': '1993-09-25T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          24:
              {
                'ts': 764701200,
                'time': '1994-03-26T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          25:
              {
                'ts': 780422400,
                'time': '1994-09-24T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          26:
              {
                'ts': 796150800,
                'time': '1995-03-25T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          27:
              {
                'ts': 811872000,
                'time': '1995-09-23T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          28:
              {
                'ts': 828205200,
                'time': '1996-03-30T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          29:
              {
                'ts': 843926400,
                'time': '1996-09-28T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          30:
              {
                'ts': 859654800,
                'time': '1997-03-29T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          31:
              {
                'ts': 875376000,
                'time': '1997-09-27T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          32:
              {
                'ts': 891104400,
                'time': '1998-03-28T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          33:
              {
                'ts': 906825600,
                'time': '1998-09-26T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          34:
              {
                'ts': 988398000,
                'time': '2001-04-27T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          35:
              {
                'ts': 1001700000,
                'time': '2001-09-28T18:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          36:
              {
                'ts': 1017428400,
                'time': '2002-03-29T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          37:
              {
                'ts': 1033149600,
                'time': '2002-09-27T18:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          38:
              {
                'ts': 1048878000,
                'time': '2003-03-28T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          39:
              {
                'ts': 1064599200,
                'time': '2003-09-26T18:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          40:
              {
                'ts': 1080327600,
                'time': '2004-03-26T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          41:
              {
                'ts': 1096048800,
                'time': '2004-09-24T18:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          42:
              {
                'ts': 1111777200,
                'time': '2005-03-25T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          43:
              {
                'ts': 1127498400,
                'time': '2005-09-23T18:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              },
          44:
              {
                'ts': 1143226800,
                'time': '2006-03-24T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'HOVST'
              },
          45:
              {
                'ts': 1159552800,
                'time': '2006-09-29T18:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'HOVT'
              }
        },
    'Asia/Irkutsk':
        {
          0:
              {
                'ts': -1575874640,
                'time': '1920-01-24T17:02:40+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'IRKT'
              },
          1:
              {
                'ts': -1247554800,
                'time': '1930-06-20T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          2:
              {
                'ts': 354902400,
                'time': '1981-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          3:
              {
                'ts': 370710000,
                'time': '1981-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          4:
              {
                'ts': 386438400,
                'time': '1982-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          5:
              {
                'ts': 402246000,
                'time': '1982-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          6:
              {
                'ts': 417974400,
                'time': '1983-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          7:
              {
                'ts': 433782000,
                'time': '1983-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          8:
              {
                'ts': 449596800,
                'time': '1984-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          9:
              {
                'ts': 465328800,
                'time': '1984-09-29T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          10:
              {
                'ts': 481053600,
                'time': '1985-03-30T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          11:
              {
                'ts': 496778400,
                'time': '1985-09-28T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          12:
              {
                'ts': 512503200,
                'time': '1986-03-29T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          13:
              {
                'ts': 528228000,
                'time': '1986-09-27T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          14:
              {
                'ts': 543952800,
                'time': '1987-03-28T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          15:
              {
                'ts': 559677600,
                'time': '1987-09-26T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          16:
              {
                'ts': 575402400,
                'time': '1988-03-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          17:
              {
                'ts': 591127200,
                'time': '1988-09-24T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          18:
              {
                'ts': 606852000,
                'time': '1989-03-25T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          19:
              {
                'ts': 622576800,
                'time': '1989-09-23T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          20:
              {
                'ts': 638301600,
                'time': '1990-03-24T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          21:
              {
                'ts': 654631200,
                'time': '1990-09-29T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          22:
              {
                'ts': 670356000,
                'time': '1991-03-30T18:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'IRKST'
              },
          23:
              {
                'ts': 686084400,
                'time': '1991-09-28T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'IRKT'
              },
          24:
              {
                'ts': 695761200,
                'time': '1992-01-18T19:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          25:
              {
                'ts': 701794800,
                'time': '1992-03-28T15:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          26:
              {
                'ts': 717516000,
                'time': '1992-09-26T14:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          27:
              {
                'ts': 733255200,
                'time': '1993-03-27T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          28:
              {
                'ts': 748980000,
                'time': '1993-09-25T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          29:
              {
                'ts': 764704800,
                'time': '1994-03-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          30:
              {
                'ts': 780429600,
                'time': '1994-09-24T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          31:
              {
                'ts': 796154400,
                'time': '1995-03-25T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          32:
              {
                'ts': 811879200,
                'time': '1995-09-23T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          33:
              {
                'ts': 828208800,
                'time': '1996-03-30T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          34:
              {
                'ts': 846352800,
                'time': '1996-10-26T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          35:
              {
                'ts': 859658400,
                'time': '1997-03-29T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          36:
              {
                'ts': 877802400,
                'time': '1997-10-25T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          37:
              {
                'ts': 891108000,
                'time': '1998-03-28T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          38:
              {
                'ts': 909252000,
                'time': '1998-10-24T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          39:
              {
                'ts': 922557600,
                'time': '1999-03-27T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          40:
              {
                'ts': 941306400,
                'time': '1999-10-30T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          41:
              {
                'ts': 954007200,
                'time': '2000-03-25T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          42:
              {
                'ts': 972756000,
                'time': '2000-10-28T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          43:
              {
                'ts': 985456800,
                'time': '2001-03-24T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          44:
              {
                'ts': 1004205600,
                'time': '2001-10-27T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          45:
              {
                'ts': 1017511200,
                'time': '2002-03-30T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          46:
              {
                'ts': 1035655200,
                'time': '2002-10-26T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          47:
              {
                'ts': 1048960800,
                'time': '2003-03-29T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          48:
              {
                'ts': 1067104800,
                'time': '2003-10-25T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          49:
              {
                'ts': 1080410400,
                'time': '2004-03-27T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          50:
              {
                'ts': 1099159200,
                'time': '2004-10-30T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          51:
              {
                'ts': 1111860000,
                'time': '2005-03-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          52:
              {
                'ts': 1130608800,
                'time': '2005-10-29T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          53:
              {
                'ts': 1143309600,
                'time': '2006-03-25T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          54:
              {
                'ts': 1162058400,
                'time': '2006-10-28T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          55:
              {
                'ts': 1174759200,
                'time': '2007-03-24T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          56:
              {
                'ts': 1193508000,
                'time': '2007-10-27T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          57:
              {
                'ts': 1206813600,
                'time': '2008-03-29T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          58:
              {
                'ts': 1224957600,
                'time': '2008-10-25T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          59:
              {
                'ts': 1238263200,
                'time': '2009-03-28T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          60:
              {
                'ts': 1256407200,
                'time': '2009-10-24T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          61:
              {
                'ts': 1269712800,
                'time': '2010-03-27T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          62:
              {
                'ts': 1288461600,
                'time': '2010-10-30T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          63:
              {
                'ts': 1301162400,
                'time': '2011-03-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          64:
              {
                'ts': 1319911200,
                'time': '2011-10-29T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          65:
              {
                'ts': 1332612000,
                'time': '2012-03-24T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          66:
              {
                'ts': 1351360800,
                'time': '2012-10-27T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          67:
              {
                'ts': 1364666400,
                'time': '2013-03-30T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          68:
              {
                'ts': 1382810400,
                'time': '2013-10-26T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          69:
              {
                'ts': 1396116000,
                'time': '2014-03-29T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          70:
              {
                'ts': 1414260000,
                'time': '2014-10-25T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          71:
              {
                'ts': 1427565600,
                'time': '2015-03-28T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          72:
              {
                'ts': 1445709600,
                'time': '2015-10-24T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          73:
              {
                'ts': 1459015200,
                'time': '2016-03-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          74:
              {
                'ts': 1477764000,
                'time': '2016-10-29T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          75:
              {
                'ts': 1490464800,
                'time': '2017-03-25T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          76:
              {
                'ts': 1509213600,
                'time': '2017-10-28T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          77:
              {
                'ts': 1521914400,
                'time': '2018-03-24T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          78:
              {
                'ts': 1540663200,
                'time': '2018-10-27T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          79:
              {
                'ts': 1553968800,
                'time': '2019-03-30T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          80:
              {
                'ts': 1572112800,
                'time': '2019-10-26T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          81:
              {
                'ts': 1585418400,
                'time': '2020-03-28T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          82:
              {
                'ts': 1603562400,
                'time': '2020-10-24T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          83:
              {
                'ts': 1616868000,
                'time': '2021-03-27T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          84:
              {
                'ts': 1635616800,
                'time': '2021-10-30T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          85:
              {
                'ts': 1648317600,
                'time': '2022-03-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          86:
              {
                'ts': 1667066400,
                'time': '2022-10-29T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          87:
              {
                'ts': 1679767200,
                'time': '2023-03-25T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          88:
              {
                'ts': 1698516000,
                'time': '2023-10-28T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          89:
              {
                'ts': 1711821600,
                'time': '2024-03-30T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          90:
              {
                'ts': 1729965600,
                'time': '2024-10-26T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          91:
              {
                'ts': 1743271200,
                'time': '2025-03-29T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          92:
              {
                'ts': 1761415200,
                'time': '2025-10-25T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          93:
              {
                'ts': 1774720800,
                'time': '2026-03-28T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          94:
              {
                'ts': 1792864800,
                'time': '2026-10-24T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          95:
              {
                'ts': 1806170400,
                'time': '2027-03-27T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          96:
              {
                'ts': 1824919200,
                'time': '2027-10-30T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          97:
              {
                'ts': 1837620000,
                'time': '2028-03-25T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          98:
              {
                'ts': 1856368800,
                'time': '2028-10-28T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          99:
              {
                'ts': 1869069600,
                'time': '2029-03-24T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          100:
              {
                'ts': 1887818400,
                'time': '2029-10-27T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          101:
              {
                'ts': 1901124000,
                'time': '2030-03-30T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          102:
              {
                'ts': 1919268000,
                'time': '2030-10-26T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          103:
              {
                'ts': 1932573600,
                'time': '2031-03-29T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          104:
              {
                'ts': 1950717600,
                'time': '2031-10-25T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          105:
              {
                'ts': 1964023200,
                'time': '2032-03-27T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          106:
              {
                'ts': 1982772000,
                'time': '2032-10-30T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          107:
              {
                'ts': 1995472800,
                'time': '2033-03-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          108:
              {
                'ts': 2014221600,
                'time': '2033-10-29T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          109:
              {
                'ts': 2026922400,
                'time': '2034-03-25T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          110:
              {
                'ts': 2045671200,
                'time': '2034-10-28T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          111:
              {
                'ts': 2058372000,
                'time': '2035-03-24T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          112:
              {
                'ts': 2077120800,
                'time': '2035-10-27T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          113:
              {
                'ts': 2090426400,
                'time': '2036-03-29T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          114:
              {
                'ts': 2108570400,
                'time': '2036-10-25T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              },
          115:
              {
                'ts': 2121876000,
                'time': '2037-03-28T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'IRKST'
              },
          116:
              {
                'ts': 2140020000,
                'time': '2037-10-24T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'IRKT'
              }
        },
    'Asia/Istanbul':
        {
          0:
              {
                'ts': -1869875816,
                'time': '1910-09-30T22:03:04+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          2:
              {
                'ts': -1680490800,
                'time': '1916-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': -1570413600,
                'time': '1920-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          4:
              {
                'ts': -1552186800,
                'time': '1920-10-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': -1538359200,
                'time': '1921-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          6:
              {
                'ts': -1522551600,
                'time': '1921-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': -1507514400,
                'time': '1922-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': -1490583600,
                'time': '1922-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': -1440208800,
                'time': '1924-05-12T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          10:
              {
                'ts': -1428030000,
                'time': '1924-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          11:
              {
                'ts': -1409709600,
                'time': '1925-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          12:
              {
                'ts': -1396494000,
                'time': '1925-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': -931140000,
                'time': '1940-06-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          14:
              {
                'ts': -922762800,
                'time': '1940-10-04T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          15:
              {
                'ts': -917834400,
                'time': '1940-11-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          16:
              {
                'ts': -892436400,
                'time': '1941-09-20T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          17:
              {
                'ts': -875844000,
                'time': '1942-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          18:
              {
                'ts': -857358000,
                'time': '1942-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          19:
              {
                'ts': -781063200,
                'time': '1945-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          20:
              {
                'ts': -764737200,
                'time': '1945-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          21:
              {
                'ts': -744343200,
                'time': '1946-05-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          22:
              {
                'ts': -733806000,
                'time': '1946-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          23:
              {
                'ts': -716436000,
                'time': '1947-04-19T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          24:
              {
                'ts': -701924400,
                'time': '1947-10-04T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          25:
              {
                'ts': -684986400,
                'time': '1948-04-17T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          26:
              {
                'ts': -670474800,
                'time': '1948-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': -654141600,
                'time': '1949-04-09T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': -639025200,
                'time': '1949-10-01T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': -621828000,
                'time': '1950-04-18T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': -606970800,
                'time': '1950-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': -590032800,
                'time': '1951-04-21T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': -575434800,
                'time': '1951-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': -235620000,
                'time': '1962-07-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': -228279600,
                'time': '1962-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': -177732000,
                'time': '1964-05-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': -165726000,
                'time': '1964-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 10533600,
                'time': '1970-05-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 23835600,
                'time': '1970-10-03T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 41983200,
                'time': '1971-05-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 55285200,
                'time': '1971-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 74037600,
                'time': '1972-05-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 87339600,
                'time': '1972-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 107910000,
                'time': '1973-06-02T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 121219200,
                'time': '1973-11-04T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 133920000,
                'time': '1974-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 152676000,
                'time': '1974-11-03T02:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 165362400,
                'time': '1975-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 183502800,
                'time': '1975-10-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 202428000,
                'time': '1976-05-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 215557200,
                'time': '1976-10-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 228866400,
                'time': '1977-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 245797200,
                'time': '1977-10-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 260316000,
                'time': '1978-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 277246800,
                'time': '1978-10-14T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          55:
              {
                'ts': 308779200,
                'time': '1979-10-14T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          56:
              {
                'ts': 323827200,
                'time': '1980-04-06T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          57:
              {
                'ts': 340228800,
                'time': '1980-10-12T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          58:
              {
                'ts': 354672000,
                'time': '1981-03-29T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          59:
              {
                'ts': 371678400,
                'time': '1981-10-11T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          60:
              {
                'ts': 386121600,
                'time': '1982-03-28T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          61:
              {
                'ts': 403128000,
                'time': '1982-10-10T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          62:
              {
                'ts': 428446800,
                'time': '1983-07-30T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          63:
              {
                'ts': 433886400,
                'time': '1983-10-01T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          64:
              {
                'ts': 482792400,
                'time': '1985-04-19T21:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          65:
              {
                'ts': 496702800,
                'time': '1985-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          66:
              {
                'ts': 512524800,
                'time': '1986-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          67:
              {
                'ts': 528249600,
                'time': '1986-09-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          68:
              {
                'ts': 543974400,
                'time': '1987-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          69:
              {
                'ts': 559699200,
                'time': '1987-09-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          70:
              {
                'ts': 575424000,
                'time': '1988-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          71:
              {
                'ts': 591148800,
                'time': '1988-09-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          72:
              {
                'ts': 606873600,
                'time': '1989-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          73:
              {
                'ts': 622598400,
                'time': '1989-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          74:
              {
                'ts': 638323200,
                'time': '1990-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          75:
              {
                'ts': 654652800,
                'time': '1990-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          76:
              {
                'ts': 670374000,
                'time': '1991-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          77:
              {
                'ts': 686098800,
                'time': '1991-09-28T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          78:
              {
                'ts': 701823600,
                'time': '1992-03-28T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          79:
              {
                'ts': 717548400,
                'time': '1992-09-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          80:
              {
                'ts': 733273200,
                'time': '1993-03-27T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          81:
              {
                'ts': 748998000,
                'time': '1993-09-25T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          82:
              {
                'ts': 764722800,
                'time': '1994-03-26T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          83:
              {
                'ts': 780447600,
                'time': '1994-09-24T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          84:
              {
                'ts': 796172400,
                'time': '1995-03-25T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          85:
              {
                'ts': 811897200,
                'time': '1995-09-23T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          86:
              {
                'ts': 828226800,
                'time': '1996-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          87:
              {
                'ts': 846370800,
                'time': '1996-10-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          88:
              {
                'ts': 859676400,
                'time': '1997-03-29T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          89:
              {
                'ts': 877820400,
                'time': '1997-10-25T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          90:
              {
                'ts': 891126000,
                'time': '1998-03-28T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          91:
              {
                'ts': 909270000,
                'time': '1998-10-24T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          92:
              {
                'ts': 922575600,
                'time': '1999-03-27T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          93:
              {
                'ts': 941324400,
                'time': '1999-10-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          94:
              {
                'ts': 954025200,
                'time': '2000-03-25T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          95:
              {
                'ts': 972774000,
                'time': '2000-10-28T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          96:
              {
                'ts': 985474800,
                'time': '2001-03-24T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          97:
              {
                'ts': 1004223600,
                'time': '2001-10-27T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          98:
              {
                'ts': 1017529200,
                'time': '2002-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          99:
              {
                'ts': 1035673200,
                'time': '2002-10-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          100:
              {
                'ts': 1048978800,
                'time': '2003-03-29T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          101:
              {
                'ts': 1067122800,
                'time': '2003-10-25T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          102:
              {
                'ts': 1080428400,
                'time': '2004-03-27T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          103:
              {
                'ts': 1099177200,
                'time': '2004-10-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          104:
              {
                'ts': 1111878000,
                'time': '2005-03-26T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          105:
              {
                'ts': 1130626800,
                'time': '2005-10-29T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          106:
              {
                'ts': 1143327600,
                'time': '2006-03-25T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          107:
              {
                'ts': 1162076400,
                'time': '2006-10-28T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          108:
              {
                'ts': 1167602400,
                'time': '2006-12-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          121:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          122:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          123:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          124:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          125:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          126:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          127:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          128:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          129:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          130:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          131:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          132:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          133:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          134:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          135:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          136:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          137:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          138:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          139:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          140:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          141:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          142:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          143:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          144:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          145:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          146:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          147:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          148:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          149:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          150:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          151:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          152:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          153:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          154:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          155:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          156:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          157:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          158:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          159:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          160:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          161:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          162:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          163:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          164:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          165:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          166:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          167:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          168:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          169:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          170:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Asia/Jakarta':
        {
          0:
              {
                'ts': -1451719200,
                'time': '1923-12-31T16:40:00+0000',
                'offset': 26400,
                'isdst': false,
                'abbr': 'JAVT'
              },
          1:
              {
                'ts': -1172906400,
                'time': '1932-10-31T16:40:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'WIT'
              },
          2:
              {
                'ts': -876641400,
                'time': '1942-03-22T16:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          3:
              {
                'ts': -766054800,
                'time': '1945-09-22T15:00:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'WIT'
              },
          4:
              {
                'ts': -683883000,
                'time': '1948-04-30T16:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WIT'
              },
          5:
              {
                'ts': -620812800,
                'time': '1950-04-30T16:00:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'WIT'
              },
          6:
              {
                'ts': -189415800,
                'time': '1963-12-31T16:30:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'WIT'
              }
        },
    'Asia/Jayapura':
        {
          0:
              {
                'ts': -1172913768,
                'time': '1932-10-31T14:37:12+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'EIT'
              },
          1:
              {
                'ts': -799491600,
                'time': '1944-08-31T15:00:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -189423000,
                'time': '1963-12-31T14:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'EIT'
              }
        },
    'Asia/Jerusalem':
        {
          0:
              {
                'ts': -1641003640,
                'time': '1917-12-31T21:39:20+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          1:
              {
                'ts': -933645600,
                'time': '1940-05-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          2:
              {
                'ts': -857358000,
                'time': '1942-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          3:
              {
                'ts': -844300800,
                'time': '1943-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          4:
              {
                'ts': -825822000,
                'time': '1943-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          5:
              {
                'ts': -812685600,
                'time': '1944-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          6:
              {
                'ts': -794199600,
                'time': '1944-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          7:
              {
                'ts': -779853600,
                'time': '1945-04-15T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          8:
              {
                'ts': -762656400,
                'time': '1945-10-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          9:
              {
                'ts': -748310400,
                'time': '1946-04-16T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          10:
              {
                'ts': -731127600,
                'time': '1946-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          11:
              {
                'ts': -681962400,
                'time': '1948-05-22T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'IDDT'
              },
          12:
              {
                'ts': -673243200,
                'time': '1948-08-31T20:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          13:
              {
                'ts': -667962000,
                'time': '1948-10-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          14:
              {
                'ts': -652327200,
                'time': '1949-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          15:
              {
                'ts': -636426000,
                'time': '1949-10-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          16:
              {
                'ts': -622087200,
                'time': '1950-04-15T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          17:
              {
                'ts': -608947200,
                'time': '1950-09-15T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          18:
              {
                'ts': -591847200,
                'time': '1951-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          19:
              {
                'ts': -572486400,
                'time': '1951-11-11T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          20:
              {
                'ts': -558576000,
                'time': '1952-04-20T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          21:
              {
                'ts': -542851200,
                'time': '1952-10-19T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          22:
              {
                'ts': -527731200,
                'time': '1953-04-12T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          23:
              {
                'ts': -514425600,
                'time': '1953-09-13T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          24:
              {
                'ts': -490845600,
                'time': '1954-06-12T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          25:
              {
                'ts': -482986800,
                'time': '1954-09-11T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          26:
              {
                'ts': -459475200,
                'time': '1955-06-11T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          27:
              {
                'ts': -451537200,
                'time': '1955-09-10T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          28:
              {
                'ts': -428551200,
                'time': '1956-06-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          29:
              {
                'ts': -418262400,
                'time': '1956-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          30:
              {
                'ts': -400032000,
                'time': '1957-04-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          31:
              {
                'ts': -387428400,
                'time': '1957-09-21T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          32:
              {
                'ts': 142380000,
                'time': '1974-07-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          33:
              {
                'ts': 150843600,
                'time': '1974-10-12T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          34:
              {
                'ts': 167176800,
                'time': '1975-04-19T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          35:
              {
                'ts': 178664400,
                'time': '1975-08-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          36:
              {
                'ts': 482277600,
                'time': '1985-04-13T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          37:
              {
                'ts': 495579600,
                'time': '1985-09-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          38:
              {
                'ts': 516751200,
                'time': '1986-05-17T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          39:
              {
                'ts': 526424400,
                'time': '1986-09-06T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          40:
              {
                'ts': 545436000,
                'time': '1987-04-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          41:
              {
                'ts': 558478800,
                'time': '1987-09-12T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          42:
              {
                'ts': 576540000,
                'time': '1988-04-08T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          43:
              {
                'ts': 589237200,
                'time': '1988-09-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          44:
              {
                'ts': 609890400,
                'time': '1989-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          45:
              {
                'ts': 620773200,
                'time': '1989-09-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          46:
              {
                'ts': 638316000,
                'time': '1990-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          47:
              {
                'ts': 651618000,
                'time': '1990-08-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          48:
              {
                'ts': 669765600,
                'time': '1991-03-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          49:
              {
                'ts': 683672400,
                'time': '1991-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          50:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          51:
              {
                'ts': 715726800,
                'time': '1992-09-05T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          52:
              {
                'ts': 733701600,
                'time': '1993-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          53:
              {
                'ts': 747176400,
                'time': '1993-09-04T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          54:
              {
                'ts': 765151200,
                'time': '1994-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          55:
              {
                'ts': 778021200,
                'time': '1994-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          56:
              {
                'ts': 796600800,
                'time': '1995-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          57:
              {
                'ts': 810075600,
                'time': '1995-09-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          58:
              {
                'ts': 826840800,
                'time': '1996-03-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          59:
              {
                'ts': 842821200,
                'time': '1996-09-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          60:
              {
                'ts': 858895200,
                'time': '1997-03-20T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          61:
              {
                'ts': 874184400,
                'time': '1997-09-13T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          62:
              {
                'ts': 890344800,
                'time': '1998-03-19T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          63:
              {
                'ts': 905029200,
                'time': '1998-09-05T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          64:
              {
                'ts': 923011200,
                'time': '1999-04-02T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          65:
              {
                'ts': 936313200,
                'time': '1999-09-02T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          66:
              {
                'ts': 955670400,
                'time': '2000-04-14T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          67:
              {
                'ts': 970783200,
                'time': '2000-10-05T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          68:
              {
                'ts': 986770800,
                'time': '2001-04-08T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          69:
              {
                'ts': 1001282400,
                'time': '2001-09-23T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          70:
              {
                'ts': 1017356400,
                'time': '2002-03-28T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          71:
              {
                'ts': 1033941600,
                'time': '2002-10-06T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          72:
              {
                'ts': 1048806000,
                'time': '2003-03-27T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          73:
              {
                'ts': 1065132000,
                'time': '2003-10-02T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          74:
              {
                'ts': 1081292400,
                'time': '2004-04-06T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          75:
              {
                'ts': 1095804000,
                'time': '2004-09-21T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          76:
              {
                'ts': 1112313600,
                'time': '2005-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          77:
              {
                'ts': 1128812400,
                'time': '2005-10-08T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          78:
              {
                'ts': 1143763200,
                'time': '2006-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          79:
              {
                'ts': 1159657200,
                'time': '2006-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          80:
              {
                'ts': 1175212800,
                'time': '2007-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          81:
              {
                'ts': 1189897200,
                'time': '2007-09-15T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          82:
              {
                'ts': 1206662400,
                'time': '2008-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          83:
              {
                'ts': 1223161200,
                'time': '2008-10-04T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          84:
              {
                'ts': 1238112000,
                'time': '2009-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          85:
              {
                'ts': 1254006000,
                'time': '2009-09-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          86:
              {
                'ts': 1269561600,
                'time': '2010-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          87:
              {
                'ts': 1284246000,
                'time': '2010-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          88:
              {
                'ts': 1301616000,
                'time': '2011-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          89:
              {
                'ts': 1317510000,
                'time': '2011-10-01T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          90:
              {
                'ts': 1333065600,
                'time': '2012-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          91:
              {
                'ts': 1348354800,
                'time': '2012-09-22T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          92:
              {
                'ts': 1364515200,
                'time': '2013-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          93:
              {
                'ts': 1378594800,
                'time': '2013-09-07T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          94:
              {
                'ts': 1395964800,
                'time': '2014-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          95:
              {
                'ts': 1411858800,
                'time': '2014-09-27T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          96:
              {
                'ts': 1427414400,
                'time': '2015-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          97:
              {
                'ts': 1442703600,
                'time': '2015-09-19T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          98:
              {
                'ts': 1459468800,
                'time': '2016-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          99:
              {
                'ts': 1475967600,
                'time': '2016-10-08T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          100:
              {
                'ts': 1490918400,
                'time': '2017-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          101:
              {
                'ts': 1506207600,
                'time': '2017-09-23T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          102:
              {
                'ts': 1522368000,
                'time': '2018-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          103:
              {
                'ts': 1537052400,
                'time': '2018-09-15T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          104:
              {
                'ts': 1553817600,
                'time': '2019-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          105:
              {
                'ts': 1570316400,
                'time': '2019-10-05T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          106:
              {
                'ts': 1585267200,
                'time': '2020-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          107:
              {
                'ts': 1601161200,
                'time': '2020-09-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          108:
              {
                'ts': 1616716800,
                'time': '2021-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          109:
              {
                'ts': 1631401200,
                'time': '2021-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          110:
              {
                'ts': 1648771200,
                'time': '2022-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          111:
              {
                'ts': 1664665200,
                'time': '2022-10-01T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          112:
              {
                'ts': 1680220800,
                'time': '2023-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          113:
              {
                'ts': 1695510000,
                'time': '2023-09-23T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          114:
              {
                'ts': 1711670400,
                'time': '2024-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          115:
              {
                'ts': 1728169200,
                'time': '2024-10-05T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          116:
              {
                'ts': 1743120000,
                'time': '2025-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          117:
              {
                'ts': 1759014000,
                'time': '2025-09-27T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          118:
              {
                'ts': 1774569600,
                'time': '2026-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          119:
              {
                'ts': 1789858800,
                'time': '2026-09-19T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          120:
              {
                'ts': 1806019200,
                'time': '2027-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          121:
              {
                'ts': 1823122800,
                'time': '2027-10-09T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          122:
              {
                'ts': 1838073600,
                'time': '2028-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          123:
              {
                'ts': 1853362800,
                'time': '2028-09-23T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          124:
              {
                'ts': 1869523200,
                'time': '2029-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          125:
              {
                'ts': 1884207600,
                'time': '2029-09-15T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          126:
              {
                'ts': 1900972800,
                'time': '2030-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          127:
              {
                'ts': 1917471600,
                'time': '2030-10-05T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          128:
              {
                'ts': 1932422400,
                'time': '2031-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          129:
              {
                'ts': 1947711600,
                'time': '2031-09-20T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          130:
              {
                'ts': 1963872000,
                'time': '2032-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          131:
              {
                'ts': 1978556400,
                'time': '2032-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          132:
              {
                'ts': 1995926400,
                'time': '2033-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          133:
              {
                'ts': 2011820400,
                'time': '2033-10-01T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          134:
              {
                'ts': 2027376000,
                'time': '2034-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          135:
              {
                'ts': 2042060400,
                'time': '2034-09-16T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          136:
              {
                'ts': 2058825600,
                'time': '2035-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          137:
              {
                'ts': 2075324400,
                'time': '2035-10-06T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          138:
              {
                'ts': 2090275200,
                'time': '2036-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          139:
              {
                'ts': 2106169200,
                'time': '2036-09-27T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          140:
              {
                'ts': 2121724800,
                'time': '2037-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          141:
              {
                'ts': 2136409200,
                'time': '2037-09-12T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              }
        },
    'Asia/Kabul':
        {
          0:
              {
                'ts': -788932800,
                'time': '1944-12-31T20:00:00+0000',
                'offset': 16200,
                'isdst': false,
                'abbr': 'AFT'
              }
        },
    'Asia/Kamchatka':
        {
          0:
              {
                'ts': -1487759676,
                'time': '1922-11-09T13:25:24+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'PETT'
              },
          1:
              {
                'ts': -1247569200,
                'time': '1930-06-20T13:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          2:
              {
                'ts': 354888000,
                'time': '1981-03-31T12:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          3:
              {
                'ts': 370695600,
                'time': '1981-09-30T11:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          4:
              {
                'ts': 386424000,
                'time': '1982-03-31T12:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          5:
              {
                'ts': 402231600,
                'time': '1982-09-30T11:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          6:
              {
                'ts': 417960000,
                'time': '1983-03-31T12:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          7:
              {
                'ts': 433767600,
                'time': '1983-09-30T11:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          8:
              {
                'ts': 449582400,
                'time': '1984-03-31T12:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          9:
              {
                'ts': 465314400,
                'time': '1984-09-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          10:
              {
                'ts': 481039200,
                'time': '1985-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          11:
              {
                'ts': 496764000,
                'time': '1985-09-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          12:
              {
                'ts': 512488800,
                'time': '1986-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          13:
              {
                'ts': 528213600,
                'time': '1986-09-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          14:
              {
                'ts': 543938400,
                'time': '1987-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          15:
              {
                'ts': 559663200,
                'time': '1987-09-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          16:
              {
                'ts': 575388000,
                'time': '1988-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          17:
              {
                'ts': 591112800,
                'time': '1988-09-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          18:
              {
                'ts': 606837600,
                'time': '1989-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          19:
              {
                'ts': 622562400,
                'time': '1989-09-23T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          20:
              {
                'ts': 638287200,
                'time': '1990-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          21:
              {
                'ts': 654616800,
                'time': '1990-09-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          22:
              {
                'ts': 670341600,
                'time': '1991-03-30T14:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'PETST'
              },
          23:
              {
                'ts': 686070000,
                'time': '1991-09-28T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'PETT'
              },
          24:
              {
                'ts': 695746800,
                'time': '1992-01-18T15:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          25:
              {
                'ts': 701780400,
                'time': '1992-03-28T11:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          26:
              {
                'ts': 717501600,
                'time': '1992-09-26T10:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          27:
              {
                'ts': 733240800,
                'time': '1993-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          28:
              {
                'ts': 748965600,
                'time': '1993-09-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          29:
              {
                'ts': 764690400,
                'time': '1994-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          30:
              {
                'ts': 780415200,
                'time': '1994-09-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          31:
              {
                'ts': 796140000,
                'time': '1995-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          32:
              {
                'ts': 811864800,
                'time': '1995-09-23T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          33:
              {
                'ts': 828194400,
                'time': '1996-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          34:
              {
                'ts': 846338400,
                'time': '1996-10-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          35:
              {
                'ts': 859644000,
                'time': '1997-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          36:
              {
                'ts': 877788000,
                'time': '1997-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          37:
              {
                'ts': 891093600,
                'time': '1998-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          38:
              {
                'ts': 909237600,
                'time': '1998-10-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          39:
              {
                'ts': 922543200,
                'time': '1999-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          40:
              {
                'ts': 941292000,
                'time': '1999-10-30T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          41:
              {
                'ts': 953992800,
                'time': '2000-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          42:
              {
                'ts': 972741600,
                'time': '2000-10-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          43:
              {
                'ts': 985442400,
                'time': '2001-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          44:
              {
                'ts': 1004191200,
                'time': '2001-10-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          45:
              {
                'ts': 1017496800,
                'time': '2002-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          46:
              {
                'ts': 1035640800,
                'time': '2002-10-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          47:
              {
                'ts': 1048946400,
                'time': '2003-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          48:
              {
                'ts': 1067090400,
                'time': '2003-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          49:
              {
                'ts': 1080396000,
                'time': '2004-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          50:
              {
                'ts': 1099144800,
                'time': '2004-10-30T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          51:
              {
                'ts': 1111845600,
                'time': '2005-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          52:
              {
                'ts': 1130594400,
                'time': '2005-10-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          53:
              {
                'ts': 1143295200,
                'time': '2006-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          54:
              {
                'ts': 1162044000,
                'time': '2006-10-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          55:
              {
                'ts': 1174744800,
                'time': '2007-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          56:
              {
                'ts': 1193493600,
                'time': '2007-10-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          57:
              {
                'ts': 1206799200,
                'time': '2008-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          58:
              {
                'ts': 1224943200,
                'time': '2008-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          59:
              {
                'ts': 1238248800,
                'time': '2009-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          60:
              {
                'ts': 1256392800,
                'time': '2009-10-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          61:
              {
                'ts': 1269698400,
                'time': '2010-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          62:
              {
                'ts': 1288447200,
                'time': '2010-10-30T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          63:
              {
                'ts': 1301148000,
                'time': '2011-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          64:
              {
                'ts': 1319896800,
                'time': '2011-10-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          65:
              {
                'ts': 1332597600,
                'time': '2012-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          66:
              {
                'ts': 1351346400,
                'time': '2012-10-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          67:
              {
                'ts': 1364652000,
                'time': '2013-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          68:
              {
                'ts': 1382796000,
                'time': '2013-10-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          69:
              {
                'ts': 1396101600,
                'time': '2014-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          70:
              {
                'ts': 1414245600,
                'time': '2014-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          71:
              {
                'ts': 1427551200,
                'time': '2015-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          72:
              {
                'ts': 1445695200,
                'time': '2015-10-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          73:
              {
                'ts': 1459000800,
                'time': '2016-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          74:
              {
                'ts': 1477749600,
                'time': '2016-10-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          75:
              {
                'ts': 1490450400,
                'time': '2017-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          76:
              {
                'ts': 1509199200,
                'time': '2017-10-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          77:
              {
                'ts': 1521900000,
                'time': '2018-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          78:
              {
                'ts': 1540648800,
                'time': '2018-10-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          79:
              {
                'ts': 1553954400,
                'time': '2019-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          80:
              {
                'ts': 1572098400,
                'time': '2019-10-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          81:
              {
                'ts': 1585404000,
                'time': '2020-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          82:
              {
                'ts': 1603548000,
                'time': '2020-10-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          83:
              {
                'ts': 1616853600,
                'time': '2021-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          84:
              {
                'ts': 1635602400,
                'time': '2021-10-30T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          85:
              {
                'ts': 1648303200,
                'time': '2022-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          86:
              {
                'ts': 1667052000,
                'time': '2022-10-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          87:
              {
                'ts': 1679752800,
                'time': '2023-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          88:
              {
                'ts': 1698501600,
                'time': '2023-10-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          89:
              {
                'ts': 1711807200,
                'time': '2024-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          90:
              {
                'ts': 1729951200,
                'time': '2024-10-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          91:
              {
                'ts': 1743256800,
                'time': '2025-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          92:
              {
                'ts': 1761400800,
                'time': '2025-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          93:
              {
                'ts': 1774706400,
                'time': '2026-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          94:
              {
                'ts': 1792850400,
                'time': '2026-10-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          95:
              {
                'ts': 1806156000,
                'time': '2027-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          96:
              {
                'ts': 1824904800,
                'time': '2027-10-30T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          97:
              {
                'ts': 1837605600,
                'time': '2028-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          98:
              {
                'ts': 1856354400,
                'time': '2028-10-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          99:
              {
                'ts': 1869055200,
                'time': '2029-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          100:
              {
                'ts': 1887804000,
                'time': '2029-10-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          101:
              {
                'ts': 1901109600,
                'time': '2030-03-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          102:
              {
                'ts': 1919253600,
                'time': '2030-10-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          103:
              {
                'ts': 1932559200,
                'time': '2031-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          104:
              {
                'ts': 1950703200,
                'time': '2031-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          105:
              {
                'ts': 1964008800,
                'time': '2032-03-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          106:
              {
                'ts': 1982757600,
                'time': '2032-10-30T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          107:
              {
                'ts': 1995458400,
                'time': '2033-03-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          108:
              {
                'ts': 2014207200,
                'time': '2033-10-29T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          109:
              {
                'ts': 2026908000,
                'time': '2034-03-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          110:
              {
                'ts': 2045656800,
                'time': '2034-10-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          111:
              {
                'ts': 2058357600,
                'time': '2035-03-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          112:
              {
                'ts': 2077106400,
                'time': '2035-10-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          113:
              {
                'ts': 2090412000,
                'time': '2036-03-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          114:
              {
                'ts': 2108556000,
                'time': '2036-10-25T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              },
          115:
              {
                'ts': 2121861600,
                'time': '2037-03-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'PETST'
              },
          116:
              {
                'ts': 2140005600,
                'time': '2037-10-24T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'PETT'
              }
        },
    'Asia/Karachi':
        {
          0:
              {
                'ts': -1988166492,
                'time': '1906-12-31T19:31:48+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              },
          1:
              {
                'ts': -862637400,
                'time': '1942-08-31T18:30:00+0000',
                'offset': 23400,
                'isdst': true,
                'abbr': 'IST'
              },
          2:
              {
                'ts': -764145000,
                'time': '1945-10-14T17:30:00+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              },
          3:
              {
                'ts': -576135000,
                'time': '1951-09-29T18:30:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KART'
              },
          4:
              {
                'ts': 38775600,
                'time': '1971-03-25T19:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'PKT'
              },
          5:
              {
                'ts': 1018119660,
                'time': '2002-04-06T19:01:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'PKST'
              },
          6:
              {
                'ts': 1033840860,
                'time': '2002-10-05T18:01:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'PKT'
              }
        },
    'Asia/Kashgar':
        {
          0:
              {
                'ts': -1325480636,
                'time': '1927-12-31T18:56:04+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'KAST'
              },
          1:
              {
                'ts': -946791000,
                'time': '1939-12-31T18:30:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KAST'
              },
          2:
              {
                'ts': 325969200,
                'time': '1980-04-30T19:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': 515520000,
                'time': '1986-05-03T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': 527007600,
                'time': '1986-09-13T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': 545155200,
                'time': '1987-04-11T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': 558457200,
                'time': '1987-09-12T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': 576604800,
                'time': '1988-04-09T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': 589906800,
                'time': '1988-09-10T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 608659200,
                'time': '1989-04-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': 621961200,
                'time': '1989-09-16T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 640108800,
                'time': '1990-04-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': 653410800,
                'time': '1990-09-15T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 671558400,
                'time': '1991-04-13T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': 684860400,
                'time': '1991-09-14T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Asia/Katmandu':
        {
          0:
              {
                'ts': -1577943676,
                'time': '1919-12-31T18:18:44+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              },
          1:
              {
                'ts': 504901800,
                'time': '1985-12-31T18:30:00+0000',
                'offset': 20700,
                'isdst': false,
                'abbr': 'NPT'
              }
        },
    'Asia/Kolkata':
        {
          0:
              {
                'ts': -891582800,
                'time': '1941-09-30T18:06:40+0000',
                'offset': 23400,
                'isdst': false,
                'abbr': 'BURT'
              },
          1:
              {
                'ts': -872058600,
                'time': '1942-05-14T17:30:00+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              },
          2:
              {
                'ts': -862637400,
                'time': '1942-08-31T18:30:00+0000',
                'offset': 23400,
                'isdst': true,
                'abbr': 'IST'
              },
          3:
              {
                'ts': -764145000,
                'time': '1945-10-14T17:30:00+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              }
        },
    'Asia/Krasnoyarsk':
        {
          0:
              {
                'ts': -1577513480,
                'time': '1920-01-05T17:48:40+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'KRAT'
              },
          1:
              {
                'ts': -1247551200,
                'time': '1930-06-20T18:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          2:
              {
                'ts': 354906000,
                'time': '1981-03-31T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          3:
              {
                'ts': 370713600,
                'time': '1981-09-30T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          4:
              {
                'ts': 386442000,
                'time': '1982-03-31T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          5:
              {
                'ts': 402249600,
                'time': '1982-09-30T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          6:
              {
                'ts': 417978000,
                'time': '1983-03-31T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          7:
              {
                'ts': 433785600,
                'time': '1983-09-30T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          8:
              {
                'ts': 449600400,
                'time': '1984-03-31T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          9:
              {
                'ts': 465332400,
                'time': '1984-09-29T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          10:
              {
                'ts': 481057200,
                'time': '1985-03-30T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          11:
              {
                'ts': 496782000,
                'time': '1985-09-28T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          12:
              {
                'ts': 512506800,
                'time': '1986-03-29T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          13:
              {
                'ts': 528231600,
                'time': '1986-09-27T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          14:
              {
                'ts': 543956400,
                'time': '1987-03-28T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          15:
              {
                'ts': 559681200,
                'time': '1987-09-26T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          16:
              {
                'ts': 575406000,
                'time': '1988-03-26T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          17:
              {
                'ts': 591130800,
                'time': '1988-09-24T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          18:
              {
                'ts': 606855600,
                'time': '1989-03-25T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          19:
              {
                'ts': 622580400,
                'time': '1989-09-23T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          20:
              {
                'ts': 638305200,
                'time': '1990-03-24T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          21:
              {
                'ts': 654634800,
                'time': '1990-09-29T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          22:
              {
                'ts': 670359600,
                'time': '1991-03-30T19:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'KRAST'
              },
          23:
              {
                'ts': 686088000,
                'time': '1991-09-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'KRAT'
              },
          24:
              {
                'ts': 695764800,
                'time': '1992-01-18T20:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          25:
              {
                'ts': 701798400,
                'time': '1992-03-28T16:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          26:
              {
                'ts': 717519600,
                'time': '1992-09-26T15:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          27:
              {
                'ts': 733258800,
                'time': '1993-03-27T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          28:
              {
                'ts': 748983600,
                'time': '1993-09-25T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          29:
              {
                'ts': 764708400,
                'time': '1994-03-26T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          30:
              {
                'ts': 780433200,
                'time': '1994-09-24T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          31:
              {
                'ts': 796158000,
                'time': '1995-03-25T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          32:
              {
                'ts': 811882800,
                'time': '1995-09-23T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          33:
              {
                'ts': 828212400,
                'time': '1996-03-30T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          34:
              {
                'ts': 846356400,
                'time': '1996-10-26T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          35:
              {
                'ts': 859662000,
                'time': '1997-03-29T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          36:
              {
                'ts': 877806000,
                'time': '1997-10-25T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          37:
              {
                'ts': 891111600,
                'time': '1998-03-28T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          38:
              {
                'ts': 909255600,
                'time': '1998-10-24T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          39:
              {
                'ts': 922561200,
                'time': '1999-03-27T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          40:
              {
                'ts': 941310000,
                'time': '1999-10-30T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          41:
              {
                'ts': 954010800,
                'time': '2000-03-25T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          42:
              {
                'ts': 972759600,
                'time': '2000-10-28T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          43:
              {
                'ts': 985460400,
                'time': '2001-03-24T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          44:
              {
                'ts': 1004209200,
                'time': '2001-10-27T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          45:
              {
                'ts': 1017514800,
                'time': '2002-03-30T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          46:
              {
                'ts': 1035658800,
                'time': '2002-10-26T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          47:
              {
                'ts': 1048964400,
                'time': '2003-03-29T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          48:
              {
                'ts': 1067108400,
                'time': '2003-10-25T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          49:
              {
                'ts': 1080414000,
                'time': '2004-03-27T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          50:
              {
                'ts': 1099162800,
                'time': '2004-10-30T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          51:
              {
                'ts': 1111863600,
                'time': '2005-03-26T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          52:
              {
                'ts': 1130612400,
                'time': '2005-10-29T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          53:
              {
                'ts': 1143313200,
                'time': '2006-03-25T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          54:
              {
                'ts': 1162062000,
                'time': '2006-10-28T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          55:
              {
                'ts': 1174762800,
                'time': '2007-03-24T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          56:
              {
                'ts': 1193511600,
                'time': '2007-10-27T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          57:
              {
                'ts': 1206817200,
                'time': '2008-03-29T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          58:
              {
                'ts': 1224961200,
                'time': '2008-10-25T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          59:
              {
                'ts': 1238266800,
                'time': '2009-03-28T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          60:
              {
                'ts': 1256410800,
                'time': '2009-10-24T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          61:
              {
                'ts': 1269716400,
                'time': '2010-03-27T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          62:
              {
                'ts': 1288465200,
                'time': '2010-10-30T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          63:
              {
                'ts': 1301166000,
                'time': '2011-03-26T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          64:
              {
                'ts': 1319914800,
                'time': '2011-10-29T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          65:
              {
                'ts': 1332615600,
                'time': '2012-03-24T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          66:
              {
                'ts': 1351364400,
                'time': '2012-10-27T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          67:
              {
                'ts': 1364670000,
                'time': '2013-03-30T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          68:
              {
                'ts': 1382814000,
                'time': '2013-10-26T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          69:
              {
                'ts': 1396119600,
                'time': '2014-03-29T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          70:
              {
                'ts': 1414263600,
                'time': '2014-10-25T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          71:
              {
                'ts': 1427569200,
                'time': '2015-03-28T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          72:
              {
                'ts': 1445713200,
                'time': '2015-10-24T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          73:
              {
                'ts': 1459018800,
                'time': '2016-03-26T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          74:
              {
                'ts': 1477767600,
                'time': '2016-10-29T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          75:
              {
                'ts': 1490468400,
                'time': '2017-03-25T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          76:
              {
                'ts': 1509217200,
                'time': '2017-10-28T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          77:
              {
                'ts': 1521918000,
                'time': '2018-03-24T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          78:
              {
                'ts': 1540666800,
                'time': '2018-10-27T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          79:
              {
                'ts': 1553972400,
                'time': '2019-03-30T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          80:
              {
                'ts': 1572116400,
                'time': '2019-10-26T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          81:
              {
                'ts': 1585422000,
                'time': '2020-03-28T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          82:
              {
                'ts': 1603566000,
                'time': '2020-10-24T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          83:
              {
                'ts': 1616871600,
                'time': '2021-03-27T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          84:
              {
                'ts': 1635620400,
                'time': '2021-10-30T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          85:
              {
                'ts': 1648321200,
                'time': '2022-03-26T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          86:
              {
                'ts': 1667070000,
                'time': '2022-10-29T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          87:
              {
                'ts': 1679770800,
                'time': '2023-03-25T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          88:
              {
                'ts': 1698519600,
                'time': '2023-10-28T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          89:
              {
                'ts': 1711825200,
                'time': '2024-03-30T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          90:
              {
                'ts': 1729969200,
                'time': '2024-10-26T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          91:
              {
                'ts': 1743274800,
                'time': '2025-03-29T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          92:
              {
                'ts': 1761418800,
                'time': '2025-10-25T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          93:
              {
                'ts': 1774724400,
                'time': '2026-03-28T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          94:
              {
                'ts': 1792868400,
                'time': '2026-10-24T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          95:
              {
                'ts': 1806174000,
                'time': '2027-03-27T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          96:
              {
                'ts': 1824922800,
                'time': '2027-10-30T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          97:
              {
                'ts': 1837623600,
                'time': '2028-03-25T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          98:
              {
                'ts': 1856372400,
                'time': '2028-10-28T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          99:
              {
                'ts': 1869073200,
                'time': '2029-03-24T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          100:
              {
                'ts': 1887822000,
                'time': '2029-10-27T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          101:
              {
                'ts': 1901127600,
                'time': '2030-03-30T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          102:
              {
                'ts': 1919271600,
                'time': '2030-10-26T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          103:
              {
                'ts': 1932577200,
                'time': '2031-03-29T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          104:
              {
                'ts': 1950721200,
                'time': '2031-10-25T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          105:
              {
                'ts': 1964026800,
                'time': '2032-03-27T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          106:
              {
                'ts': 1982775600,
                'time': '2032-10-30T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          107:
              {
                'ts': 1995476400,
                'time': '2033-03-26T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          108:
              {
                'ts': 2014225200,
                'time': '2033-10-29T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          109:
              {
                'ts': 2026926000,
                'time': '2034-03-25T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          110:
              {
                'ts': 2045674800,
                'time': '2034-10-28T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          111:
              {
                'ts': 2058375600,
                'time': '2035-03-24T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          112:
              {
                'ts': 2077124400,
                'time': '2035-10-27T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          113:
              {
                'ts': 2090430000,
                'time': '2036-03-29T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          114:
              {
                'ts': 2108574000,
                'time': '2036-10-25T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              },
          115:
              {
                'ts': 2121879600,
                'time': '2037-03-28T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'KRAST'
              },
          116:
              {
                'ts': 2140023600,
                'time': '2037-10-24T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'KRAT'
              }
        },
    'Asia/Kuala_Lumpur':
        {
          0:
              {
                'ts': -2038200925,
                'time': '1905-05-31T17:04:35+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'MALT'
              },
          1:
              {
                'ts': -1167634800,
                'time': '1932-12-31T17:00:00+0000',
                'offset': 26400,
                'isdst': true,
                'abbr': 'MALST'
              },
          2:
              {
                'ts': -1073028000,
                'time': '1935-12-31T16:40:00+0000',
                'offset': 26400,
                'isdst': false,
                'abbr': 'MALT'
              },
          3:
              {
                'ts': -894180000,
                'time': '1941-08-31T16:40:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'MALT'
              },
          4:
              {
                'ts': -879665400,
                'time': '1942-02-15T16:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          5:
              {
                'ts': -767005200,
                'time': '1945-09-11T15:00:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'MALT'
              },
          6:
              {
                'ts': 378664200,
                'time': '1981-12-31T16:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MYT'
              }
        },
    'Asia/Kuching':
        {
          0:
              {
                'ts': -1383463280,
                'time': '1926-02-28T16:38:40+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'BORT'
              },
          1:
              {
                'ts': -1167636600,
                'time': '1932-12-31T16:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'BORT'
              },
          2:
              {
                'ts': -1082448000,
                'time': '1935-09-13T16:00:00+0000',
                'offset': 30000,
                'isdst': true,
                'abbr': 'BORTST'
              },
          3:
              {
                'ts': -1074586800,
                'time': '1935-12-13T15:40:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'BORT'
              },
          4:
              {
                'ts': -1050825600,
                'time': '1936-09-13T16:00:00+0000',
                'offset': 30000,
                'isdst': true,
                'abbr': 'BORTST'
              },
          5:
              {
                'ts': -1042964400,
                'time': '1936-12-13T15:40:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'BORT'
              },
          6:
              {
                'ts': -1019289600,
                'time': '1937-09-13T16:00:00+0000',
                'offset': 30000,
                'isdst': true,
                'abbr': 'BORTST'
              },
          7:
              {
                'ts': -1011428400,
                'time': '1937-12-13T15:40:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'BORT'
              },
          8:
              {
                'ts': -987753600,
                'time': '1938-09-13T16:00:00+0000',
                'offset': 30000,
                'isdst': true,
                'abbr': 'BORTST'
              },
          9:
              {
                'ts': -979892400,
                'time': '1938-12-13T15:40:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'BORT'
              },
          10:
              {
                'ts': -956217600,
                'time': '1939-09-13T16:00:00+0000',
                'offset': 30000,
                'isdst': true,
                'abbr': 'BORTST'
              },
          11:
              {
                'ts': -948356400,
                'time': '1939-12-13T15:40:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'BORT'
              },
          12:
              {
                'ts': -924595200,
                'time': '1940-09-13T16:00:00+0000',
                'offset': 30000,
                'isdst': true,
                'abbr': 'BORTST'
              },
          13:
              {
                'ts': -916734000,
                'time': '1940-12-13T15:40:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'BORT'
              },
          14:
              {
                'ts': -893059200,
                'time': '1941-09-13T16:00:00+0000',
                'offset': 30000,
                'isdst': true,
                'abbr': 'BORTST'
              },
          15:
              {
                'ts': -885198000,
                'time': '1941-12-13T15:40:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'BORT'
              },
          16:
              {
                'ts': -879667200,
                'time': '1942-02-15T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          17:
              {
                'ts': -767005200,
                'time': '1945-09-11T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'BORT'
              },
          18:
              {
                'ts': 378662400,
                'time': '1981-12-31T16:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MYT'
              }
        },
    'Asia/Kuwait':
        {
          0:
              {
                'ts': -631163516,
                'time': '1949-12-31T20:48:04+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'Asia/Macao':
        {
          0:
              {
                'ts': -1830411260,
                'time': '1911-12-31T16:25:40+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          1:
              {
                'ts': -277360200,
                'time': '1961-03-18T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          2:
              {
                'ts': -257405400,
                'time': '1961-11-04T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          3:
              {
                'ts': -245910600,
                'time': '1962-03-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          4:
              {
                'ts': -225955800,
                'time': '1962-11-03T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          5:
              {
                'ts': -214473600,
                'time': '1963-03-16T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          6:
              {
                'ts': -194506200,
                'time': '1963-11-02T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          7:
              {
                'ts': -182406600,
                'time': '1964-03-21T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          8:
              {
                'ts': -163056600,
                'time': '1964-10-31T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          9:
              {
                'ts': -150969600,
                'time': '1965-03-20T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          10:
              {
                'ts': -131619600,
                'time': '1965-10-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          11:
              {
                'ts': -117088200,
                'time': '1966-04-16T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          12:
              {
                'ts': -101367000,
                'time': '1966-10-15T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          13:
              {
                'ts': -85638600,
                'time': '1967-04-15T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          14:
              {
                'ts': -69312600,
                'time': '1967-10-21T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          15:
              {
                'ts': -53584200,
                'time': '1968-04-20T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          16:
              {
                'ts': -37863000,
                'time': '1968-10-19T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          17:
              {
                'ts': -22134600,
                'time': '1969-04-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          18:
              {
                'ts': -6413400,
                'time': '1969-10-18T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          19:
              {
                'ts': 9315000,
                'time': '1970-04-18T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          20:
              {
                'ts': 25036200,
                'time': '1970-10-17T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          21:
              {
                'ts': 40764600,
                'time': '1971-04-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          22:
              {
                'ts': 56485800,
                'time': '1971-10-16T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          23:
              {
                'ts': 72201600,
                'time': '1972-04-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          24:
              {
                'ts': 87922800,
                'time': '1972-10-14T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          25:
              {
                'ts': 103651200,
                'time': '1973-04-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          26:
              {
                'ts': 119977200,
                'time': '1973-10-20T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          27:
              {
                'ts': 135705600,
                'time': '1974-04-20T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          28:
              {
                'ts': 151439400,
                'time': '1974-10-19T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          29:
              {
                'ts': 167167800,
                'time': '1975-04-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          30:
              {
                'ts': 182889000,
                'time': '1975-10-18T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          31:
              {
                'ts': 198617400,
                'time': '1976-04-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          32:
              {
                'ts': 214338600,
                'time': '1976-10-16T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          33:
              {
                'ts': 230067000,
                'time': '1977-04-16T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          34:
              {
                'ts': 245788200,
                'time': '1977-10-15T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          35:
              {
                'ts': 261504000,
                'time': '1978-04-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          36:
              {
                'ts': 277225200,
                'time': '1978-10-14T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          37:
              {
                'ts': 292953600,
                'time': '1979-04-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          38:
              {
                'ts': 309279600,
                'time': '1979-10-20T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          39:
              {
                'ts': 325008000,
                'time': '1980-04-19T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          40:
              {
                'ts': 340729200,
                'time': '1980-10-18T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          41:
              {
                'ts': 945619200,
                'time': '1999-12-19T16:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Asia/Macau':
        {
          0:
              {
                'ts': -1830411260,
                'time': '1911-12-31T16:25:40+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          1:
              {
                'ts': -277360200,
                'time': '1961-03-18T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          2:
              {
                'ts': -257405400,
                'time': '1961-11-04T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          3:
              {
                'ts': -245910600,
                'time': '1962-03-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          4:
              {
                'ts': -225955800,
                'time': '1962-11-03T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          5:
              {
                'ts': -214473600,
                'time': '1963-03-16T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          6:
              {
                'ts': -194506200,
                'time': '1963-11-02T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          7:
              {
                'ts': -182406600,
                'time': '1964-03-21T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          8:
              {
                'ts': -163056600,
                'time': '1964-10-31T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          9:
              {
                'ts': -150969600,
                'time': '1965-03-20T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          10:
              {
                'ts': -131619600,
                'time': '1965-10-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          11:
              {
                'ts': -117088200,
                'time': '1966-04-16T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          12:
              {
                'ts': -101367000,
                'time': '1966-10-15T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          13:
              {
                'ts': -85638600,
                'time': '1967-04-15T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          14:
              {
                'ts': -69312600,
                'time': '1967-10-21T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          15:
              {
                'ts': -53584200,
                'time': '1968-04-20T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          16:
              {
                'ts': -37863000,
                'time': '1968-10-19T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          17:
              {
                'ts': -22134600,
                'time': '1969-04-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          18:
              {
                'ts': -6413400,
                'time': '1969-10-18T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          19:
              {
                'ts': 9315000,
                'time': '1970-04-18T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          20:
              {
                'ts': 25036200,
                'time': '1970-10-17T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          21:
              {
                'ts': 40764600,
                'time': '1971-04-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          22:
              {
                'ts': 56485800,
                'time': '1971-10-16T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          23:
              {
                'ts': 72201600,
                'time': '1972-04-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          24:
              {
                'ts': 87922800,
                'time': '1972-10-14T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          25:
              {
                'ts': 103651200,
                'time': '1973-04-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          26:
              {
                'ts': 119977200,
                'time': '1973-10-20T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          27:
              {
                'ts': 135705600,
                'time': '1974-04-20T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          28:
              {
                'ts': 151439400,
                'time': '1974-10-19T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          29:
              {
                'ts': 167167800,
                'time': '1975-04-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          30:
              {
                'ts': 182889000,
                'time': '1975-10-18T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          31:
              {
                'ts': 198617400,
                'time': '1976-04-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          32:
              {
                'ts': 214338600,
                'time': '1976-10-16T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          33:
              {
                'ts': 230067000,
                'time': '1977-04-16T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          34:
              {
                'ts': 245788200,
                'time': '1977-10-15T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          35:
              {
                'ts': 261504000,
                'time': '1978-04-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          36:
              {
                'ts': 277225200,
                'time': '1978-10-14T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          37:
              {
                'ts': 292953600,
                'time': '1979-04-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          38:
              {
                'ts': 309279600,
                'time': '1979-10-20T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          39:
              {
                'ts': 325008000,
                'time': '1980-04-19T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'MOST'
              },
          40:
              {
                'ts': 340729200,
                'time': '1980-10-18T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'MOT'
              },
          41:
              {
                'ts': 945619200,
                'time': '1999-12-19T16:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Asia/Magadan':
        {
          0:
              {
                'ts': -1441188192,
                'time': '1924-05-01T13:56:48+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'MAGT'
              },
          1:
              {
                'ts': -1247565600,
                'time': '1930-06-20T14:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          2:
              {
                'ts': 354891600,
                'time': '1981-03-31T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          3:
              {
                'ts': 370699200,
                'time': '1981-09-30T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          4:
              {
                'ts': 386427600,
                'time': '1982-03-31T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          5:
              {
                'ts': 402235200,
                'time': '1982-09-30T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          6:
              {
                'ts': 417963600,
                'time': '1983-03-31T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          7:
              {
                'ts': 433771200,
                'time': '1983-09-30T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          8:
              {
                'ts': 449586000,
                'time': '1984-03-31T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          9:
              {
                'ts': 465318000,
                'time': '1984-09-29T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          10:
              {
                'ts': 481042800,
                'time': '1985-03-30T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          11:
              {
                'ts': 496767600,
                'time': '1985-09-28T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          12:
              {
                'ts': 512492400,
                'time': '1986-03-29T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          13:
              {
                'ts': 528217200,
                'time': '1986-09-27T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          14:
              {
                'ts': 543942000,
                'time': '1987-03-28T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          15:
              {
                'ts': 559666800,
                'time': '1987-09-26T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          16:
              {
                'ts': 575391600,
                'time': '1988-03-26T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          17:
              {
                'ts': 591116400,
                'time': '1988-09-24T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          18:
              {
                'ts': 606841200,
                'time': '1989-03-25T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          19:
              {
                'ts': 622566000,
                'time': '1989-09-23T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          20:
              {
                'ts': 638290800,
                'time': '1990-03-24T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          21:
              {
                'ts': 654620400,
                'time': '1990-09-29T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          22:
              {
                'ts': 670345200,
                'time': '1991-03-30T15:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'MAGST'
              },
          23:
              {
                'ts': 686073600,
                'time': '1991-09-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'MAGT'
              },
          24:
              {
                'ts': 695750400,
                'time': '1992-01-18T16:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          25:
              {
                'ts': 701784000,
                'time': '1992-03-28T12:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          26:
              {
                'ts': 717505200,
                'time': '1992-09-26T11:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          27:
              {
                'ts': 733244400,
                'time': '1993-03-27T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          28:
              {
                'ts': 748969200,
                'time': '1993-09-25T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          29:
              {
                'ts': 764694000,
                'time': '1994-03-26T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          30:
              {
                'ts': 780418800,
                'time': '1994-09-24T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          31:
              {
                'ts': 796143600,
                'time': '1995-03-25T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          32:
              {
                'ts': 811868400,
                'time': '1995-09-23T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          33:
              {
                'ts': 828198000,
                'time': '1996-03-30T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          34:
              {
                'ts': 846342000,
                'time': '1996-10-26T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          35:
              {
                'ts': 859647600,
                'time': '1997-03-29T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          36:
              {
                'ts': 877791600,
                'time': '1997-10-25T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          37:
              {
                'ts': 891097200,
                'time': '1998-03-28T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          38:
              {
                'ts': 909241200,
                'time': '1998-10-24T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          39:
              {
                'ts': 922546800,
                'time': '1999-03-27T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          40:
              {
                'ts': 941295600,
                'time': '1999-10-30T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          41:
              {
                'ts': 953996400,
                'time': '2000-03-25T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          42:
              {
                'ts': 972745200,
                'time': '2000-10-28T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          43:
              {
                'ts': 985446000,
                'time': '2001-03-24T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          44:
              {
                'ts': 1004194800,
                'time': '2001-10-27T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          45:
              {
                'ts': 1017500400,
                'time': '2002-03-30T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          46:
              {
                'ts': 1035644400,
                'time': '2002-10-26T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          47:
              {
                'ts': 1048950000,
                'time': '2003-03-29T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          48:
              {
                'ts': 1067094000,
                'time': '2003-10-25T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          49:
              {
                'ts': 1080399600,
                'time': '2004-03-27T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          50:
              {
                'ts': 1099148400,
                'time': '2004-10-30T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          51:
              {
                'ts': 1111849200,
                'time': '2005-03-26T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          52:
              {
                'ts': 1130598000,
                'time': '2005-10-29T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          53:
              {
                'ts': 1143298800,
                'time': '2006-03-25T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          54:
              {
                'ts': 1162047600,
                'time': '2006-10-28T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          55:
              {
                'ts': 1174748400,
                'time': '2007-03-24T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          56:
              {
                'ts': 1193497200,
                'time': '2007-10-27T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          57:
              {
                'ts': 1206802800,
                'time': '2008-03-29T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          58:
              {
                'ts': 1224946800,
                'time': '2008-10-25T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          59:
              {
                'ts': 1238252400,
                'time': '2009-03-28T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          60:
              {
                'ts': 1256396400,
                'time': '2009-10-24T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          61:
              {
                'ts': 1269702000,
                'time': '2010-03-27T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          62:
              {
                'ts': 1288450800,
                'time': '2010-10-30T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          63:
              {
                'ts': 1301151600,
                'time': '2011-03-26T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          64:
              {
                'ts': 1319900400,
                'time': '2011-10-29T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          65:
              {
                'ts': 1332601200,
                'time': '2012-03-24T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          66:
              {
                'ts': 1351350000,
                'time': '2012-10-27T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          67:
              {
                'ts': 1364655600,
                'time': '2013-03-30T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          68:
              {
                'ts': 1382799600,
                'time': '2013-10-26T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          69:
              {
                'ts': 1396105200,
                'time': '2014-03-29T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          70:
              {
                'ts': 1414249200,
                'time': '2014-10-25T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          71:
              {
                'ts': 1427554800,
                'time': '2015-03-28T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          72:
              {
                'ts': 1445698800,
                'time': '2015-10-24T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          73:
              {
                'ts': 1459004400,
                'time': '2016-03-26T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          74:
              {
                'ts': 1477753200,
                'time': '2016-10-29T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          75:
              {
                'ts': 1490454000,
                'time': '2017-03-25T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          76:
              {
                'ts': 1509202800,
                'time': '2017-10-28T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          77:
              {
                'ts': 1521903600,
                'time': '2018-03-24T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          78:
              {
                'ts': 1540652400,
                'time': '2018-10-27T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          79:
              {
                'ts': 1553958000,
                'time': '2019-03-30T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          80:
              {
                'ts': 1572102000,
                'time': '2019-10-26T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          81:
              {
                'ts': 1585407600,
                'time': '2020-03-28T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          82:
              {
                'ts': 1603551600,
                'time': '2020-10-24T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          83:
              {
                'ts': 1616857200,
                'time': '2021-03-27T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          84:
              {
                'ts': 1635606000,
                'time': '2021-10-30T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          85:
              {
                'ts': 1648306800,
                'time': '2022-03-26T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          86:
              {
                'ts': 1667055600,
                'time': '2022-10-29T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          87:
              {
                'ts': 1679756400,
                'time': '2023-03-25T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          88:
              {
                'ts': 1698505200,
                'time': '2023-10-28T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          89:
              {
                'ts': 1711810800,
                'time': '2024-03-30T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          90:
              {
                'ts': 1729954800,
                'time': '2024-10-26T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          91:
              {
                'ts': 1743260400,
                'time': '2025-03-29T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          92:
              {
                'ts': 1761404400,
                'time': '2025-10-25T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          93:
              {
                'ts': 1774710000,
                'time': '2026-03-28T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          94:
              {
                'ts': 1792854000,
                'time': '2026-10-24T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          95:
              {
                'ts': 1806159600,
                'time': '2027-03-27T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          96:
              {
                'ts': 1824908400,
                'time': '2027-10-30T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          97:
              {
                'ts': 1837609200,
                'time': '2028-03-25T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          98:
              {
                'ts': 1856358000,
                'time': '2028-10-28T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          99:
              {
                'ts': 1869058800,
                'time': '2029-03-24T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          100:
              {
                'ts': 1887807600,
                'time': '2029-10-27T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          101:
              {
                'ts': 1901113200,
                'time': '2030-03-30T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          102:
              {
                'ts': 1919257200,
                'time': '2030-10-26T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          103:
              {
                'ts': 1932562800,
                'time': '2031-03-29T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          104:
              {
                'ts': 1950706800,
                'time': '2031-10-25T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          105:
              {
                'ts': 1964012400,
                'time': '2032-03-27T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          106:
              {
                'ts': 1982761200,
                'time': '2032-10-30T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          107:
              {
                'ts': 1995462000,
                'time': '2033-03-26T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          108:
              {
                'ts': 2014210800,
                'time': '2033-10-29T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          109:
              {
                'ts': 2026911600,
                'time': '2034-03-25T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          110:
              {
                'ts': 2045660400,
                'time': '2034-10-28T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          111:
              {
                'ts': 2058361200,
                'time': '2035-03-24T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          112:
              {
                'ts': 2077110000,
                'time': '2035-10-27T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          113:
              {
                'ts': 2090415600,
                'time': '2036-03-29T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          114:
              {
                'ts': 2108559600,
                'time': '2036-10-25T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              },
          115:
              {
                'ts': 2121865200,
                'time': '2037-03-28T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'MAGST'
              },
          116:
              {
                'ts': 2140009200,
                'time': '2037-10-24T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'MAGT'
              }
        },
    'Asia/Makassar':
        {
          0:
              {
                'ts': -1577951856,
                'time': '1919-12-31T16:02:24+0000',
                'offset': 28656,
                'isdst': false,
                'abbr': 'MMT'
              },
          1:
              {
                'ts': -1172908656,
                'time': '1932-10-31T16:02:24+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CIT'
              },
          2:
              {
                'ts': -880272000,
                'time': '1942-02-08T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          3:
              {
                'ts': -766054800,
                'time': '1945-09-22T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CIT'
              }
        },
    'Asia/Manila':
        {
          0:
              {
                'ts': -1046678400,
                'time': '1936-10-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'PHST'
              },
          1:
              {
                'ts': -1038733200,
                'time': '1937-01-31T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'PHT'
              },
          2:
              {
                'ts': -873273600,
                'time': '1942-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          3:
              {
                'ts': -794221200,
                'time': '1944-10-31T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'PHT'
              },
          4:
              {
                'ts': -496224000,
                'time': '1954-04-11T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'PHST'
              },
          5:
              {
                'ts': -489315600,
                'time': '1954-06-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'PHT'
              },
          6:
              {
                'ts': 259344000,
                'time': '1978-03-21T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'PHST'
              },
          7:
              {
                'ts': 275151600,
                'time': '1978-09-20T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'PHT'
              }
        },
    'Asia/Muscat':
        {
          0:
              {
                'ts': -1577937260,
                'time': '1919-12-31T20:05:40+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GST'
              }
        },
    'Asia/Nicosia':
        {
          0:
              {
                'ts': -1518920008,
                'time': '1921-11-13T21:46:32+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': 166572000,
                'time': '1975-04-12T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          2:
              {
                'ts': 182293200,
                'time': '1975-10-11T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': 200959200,
                'time': '1976-05-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          4:
              {
                'ts': 213829200,
                'time': '1976-10-10T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': 228866400,
                'time': '1977-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          6:
              {
                'ts': 243982800,
                'time': '1977-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': 260316000,
                'time': '1978-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': 276123600,
                'time': '1978-10-01T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': 291765600,
                'time': '1979-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          10:
              {
                'ts': 307486800,
                'time': '1979-09-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          11:
              {
                'ts': 323820000,
                'time': '1980-04-05T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          12:
              {
                'ts': 338936400,
                'time': '1980-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': 354664800,
                'time': '1981-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          14:
              {
                'ts': 370386000,
                'time': '1981-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          15:
              {
                'ts': 386114400,
                'time': '1982-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          16:
              {
                'ts': 401835600,
                'time': '1982-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          17:
              {
                'ts': 417564000,
                'time': '1983-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          18:
              {
                'ts': 433285200,
                'time': '1983-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          19:
              {
                'ts': 449013600,
                'time': '1984-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          20:
              {
                'ts': 465339600,
                'time': '1984-09-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          21:
              {
                'ts': 481068000,
                'time': '1985-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          22:
              {
                'ts': 496789200,
                'time': '1985-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          23:
              {
                'ts': 512517600,
                'time': '1986-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          24:
              {
                'ts': 528238800,
                'time': '1986-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          25:
              {
                'ts': 543967200,
                'time': '1987-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          26:
              {
                'ts': 559688400,
                'time': '1987-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': 575416800,
                'time': '1988-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': 591138000,
                'time': '1988-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 606866400,
                'time': '1989-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 622587600,
                'time': '1989-09-23T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 638316000,
                'time': '1990-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 654642000,
                'time': '1990-09-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 670370400,
                'time': '1991-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 686091600,
                'time': '1991-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 717541200,
                'time': '1992-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 796168800,
                'time': '1995-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 811890000,
                'time': '1995-09-23T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 828223200,
                'time': '1996-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 843944400,
                'time': '1996-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 859672800,
                'time': '1997-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 875394000,
                'time': '1997-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 891122400,
                'time': '1998-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          121:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          122:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          123:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          124:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          125:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          126:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Asia/Novosibirsk':
        {
          0:
              {
                'ts': -1579476700,
                'time': '1919-12-14T00:28:20+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          1:
              {
                'ts': -1247551200,
                'time': '1930-06-20T18:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          2:
              {
                'ts': 354906000,
                'time': '1981-03-31T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'NOVST'
              },
          3:
              {
                'ts': 370713600,
                'time': '1981-09-30T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          4:
              {
                'ts': 386442000,
                'time': '1982-03-31T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'NOVST'
              },
          5:
              {
                'ts': 402249600,
                'time': '1982-09-30T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          6:
              {
                'ts': 417978000,
                'time': '1983-03-31T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'NOVST'
              },
          7:
              {
                'ts': 433785600,
                'time': '1983-09-30T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          8:
              {
                'ts': 449600400,
                'time': '1984-03-31T17:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'NOVST'
              },
          9:
              {
                'ts': 465332400,
                'time': '1984-09-29T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          10:
              {
                'ts': 481057200,
                'time': '1985-03-30T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'NOVST'
              },
          11:
              {
                'ts': 496782000,
                'time': '1985-09-28T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          12:
              {
                'ts': 512506800,
                'time': '1986-03-29T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'NOVST'
              },
          13:
              {
                'ts': 528231600,
                'time': '1986-09-27T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          14:
              {
                'ts': 543956400,
                'time': '1987-03-28T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'NOVST'
              },
          15:
              {
                'ts': 559681200,
                'time': '1987-09-26T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          16:
              {
                'ts': 575406000,
                'time': '1988-03-26T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'NOVST'
              },
          17:
              {
                'ts': 591130800,
                'time': '1988-09-24T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          18:
              {
                'ts': 606855600,
                'time': '1989-03-25T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'NOVST'
              },
          19:
              {
                'ts': 622580400,
                'time': '1989-09-23T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          20:
              {
                'ts': 638305200,
                'time': '1990-03-24T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'NOVST'
              },
          21:
              {
                'ts': 654634800,
                'time': '1990-09-29T19:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          22:
              {
                'ts': 670359600,
                'time': '1991-03-30T19:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          23:
              {
                'ts': 686088000,
                'time': '1991-09-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          24:
              {
                'ts': 695764800,
                'time': '1992-01-18T20:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          25:
              {
                'ts': 701798400,
                'time': '1992-03-28T16:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'NOVST'
              },
          26:
              {
                'ts': 717519600,
                'time': '1992-09-26T15:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'NOVT'
              },
          27:
              {
                'ts': 733258800,
                'time': '1993-03-27T19:00:00+0000',
                'offset': 28800,
                'isdst': true,
                'abbr': 'NOVST'
              },
          28:
              {
                'ts': 738086400,
                'time': '1993-05-22T16:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          29:
              {
                'ts': 748987200,
                'time': '1993-09-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          30:
              {
                'ts': 764712000,
                'time': '1994-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          31:
              {
                'ts': 780436800,
                'time': '1994-09-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          32:
              {
                'ts': 796161600,
                'time': '1995-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          33:
              {
                'ts': 811886400,
                'time': '1995-09-23T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          34:
              {
                'ts': 828216000,
                'time': '1996-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          35:
              {
                'ts': 846360000,
                'time': '1996-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          36:
              {
                'ts': 859665600,
                'time': '1997-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          37:
              {
                'ts': 877809600,
                'time': '1997-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          38:
              {
                'ts': 891115200,
                'time': '1998-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          39:
              {
                'ts': 909259200,
                'time': '1998-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          40:
              {
                'ts': 922564800,
                'time': '1999-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          41:
              {
                'ts': 941313600,
                'time': '1999-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          42:
              {
                'ts': 954014400,
                'time': '2000-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          43:
              {
                'ts': 972763200,
                'time': '2000-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          44:
              {
                'ts': 985464000,
                'time': '2001-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          45:
              {
                'ts': 1004212800,
                'time': '2001-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          46:
              {
                'ts': 1017518400,
                'time': '2002-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          47:
              {
                'ts': 1035662400,
                'time': '2002-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          48:
              {
                'ts': 1048968000,
                'time': '2003-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          49:
              {
                'ts': 1067112000,
                'time': '2003-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          50:
              {
                'ts': 1080417600,
                'time': '2004-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          51:
              {
                'ts': 1099166400,
                'time': '2004-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          52:
              {
                'ts': 1111867200,
                'time': '2005-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          53:
              {
                'ts': 1130616000,
                'time': '2005-10-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          54:
              {
                'ts': 1143316800,
                'time': '2006-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          55:
              {
                'ts': 1162065600,
                'time': '2006-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          56:
              {
                'ts': 1174766400,
                'time': '2007-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          57:
              {
                'ts': 1193515200,
                'time': '2007-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          58:
              {
                'ts': 1206820800,
                'time': '2008-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          59:
              {
                'ts': 1224964800,
                'time': '2008-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          60:
              {
                'ts': 1238270400,
                'time': '2009-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          61:
              {
                'ts': 1256414400,
                'time': '2009-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          62:
              {
                'ts': 1269720000,
                'time': '2010-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          63:
              {
                'ts': 1288468800,
                'time': '2010-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          64:
              {
                'ts': 1301169600,
                'time': '2011-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          65:
              {
                'ts': 1319918400,
                'time': '2011-10-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          66:
              {
                'ts': 1332619200,
                'time': '2012-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          67:
              {
                'ts': 1351368000,
                'time': '2012-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          68:
              {
                'ts': 1364673600,
                'time': '2013-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          69:
              {
                'ts': 1382817600,
                'time': '2013-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          70:
              {
                'ts': 1396123200,
                'time': '2014-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          71:
              {
                'ts': 1414267200,
                'time': '2014-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          72:
              {
                'ts': 1427572800,
                'time': '2015-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          73:
              {
                'ts': 1445716800,
                'time': '2015-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          74:
              {
                'ts': 1459022400,
                'time': '2016-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          75:
              {
                'ts': 1477771200,
                'time': '2016-10-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          76:
              {
                'ts': 1490472000,
                'time': '2017-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          77:
              {
                'ts': 1509220800,
                'time': '2017-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          78:
              {
                'ts': 1521921600,
                'time': '2018-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          79:
              {
                'ts': 1540670400,
                'time': '2018-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          80:
              {
                'ts': 1553976000,
                'time': '2019-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          81:
              {
                'ts': 1572120000,
                'time': '2019-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          82:
              {
                'ts': 1585425600,
                'time': '2020-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          83:
              {
                'ts': 1603569600,
                'time': '2020-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          84:
              {
                'ts': 1616875200,
                'time': '2021-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          85:
              {
                'ts': 1635624000,
                'time': '2021-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          86:
              {
                'ts': 1648324800,
                'time': '2022-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          87:
              {
                'ts': 1667073600,
                'time': '2022-10-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          88:
              {
                'ts': 1679774400,
                'time': '2023-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          89:
              {
                'ts': 1698523200,
                'time': '2023-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          90:
              {
                'ts': 1711828800,
                'time': '2024-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          91:
              {
                'ts': 1729972800,
                'time': '2024-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          92:
              {
                'ts': 1743278400,
                'time': '2025-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          93:
              {
                'ts': 1761422400,
                'time': '2025-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          94:
              {
                'ts': 1774728000,
                'time': '2026-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          95:
              {
                'ts': 1792872000,
                'time': '2026-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          96:
              {
                'ts': 1806177600,
                'time': '2027-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          97:
              {
                'ts': 1824926400,
                'time': '2027-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          98:
              {
                'ts': 1837627200,
                'time': '2028-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          99:
              {
                'ts': 1856376000,
                'time': '2028-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          100:
              {
                'ts': 1869076800,
                'time': '2029-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          101:
              {
                'ts': 1887825600,
                'time': '2029-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          102:
              {
                'ts': 1901131200,
                'time': '2030-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          103:
              {
                'ts': 1919275200,
                'time': '2030-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          104:
              {
                'ts': 1932580800,
                'time': '2031-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          105:
              {
                'ts': 1950724800,
                'time': '2031-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          106:
              {
                'ts': 1964030400,
                'time': '2032-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          107:
              {
                'ts': 1982779200,
                'time': '2032-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          108:
              {
                'ts': 1995480000,
                'time': '2033-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          109:
              {
                'ts': 2014228800,
                'time': '2033-10-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          110:
              {
                'ts': 2026929600,
                'time': '2034-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          111:
              {
                'ts': 2045678400,
                'time': '2034-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          112:
              {
                'ts': 2058379200,
                'time': '2035-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          113:
              {
                'ts': 2077128000,
                'time': '2035-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          114:
              {
                'ts': 2090433600,
                'time': '2036-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          115:
              {
                'ts': 2108577600,
                'time': '2036-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              },
          116:
              {
                'ts': 2121883200,
                'time': '2037-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'NOVST'
              },
          117:
              {
                'ts': 2140027200,
                'time': '2037-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'NOVT'
              }
        },
    'Asia/Omsk':
        {
          0:
              {
                'ts': -1582088016,
                'time': '1919-11-13T19:06:24+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'OMST'
              },
          1:
              {
                'ts': -1247547600,
                'time': '1930-06-20T19:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          2:
              {
                'ts': 354909600,
                'time': '1981-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          3:
              {
                'ts': 370717200,
                'time': '1981-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          4:
              {
                'ts': 386445600,
                'time': '1982-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          5:
              {
                'ts': 402253200,
                'time': '1982-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          6:
              {
                'ts': 417981600,
                'time': '1983-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          7:
              {
                'ts': 433789200,
                'time': '1983-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          8:
              {
                'ts': 449604000,
                'time': '1984-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          9:
              {
                'ts': 465336000,
                'time': '1984-09-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          10:
              {
                'ts': 481060800,
                'time': '1985-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          11:
              {
                'ts': 496785600,
                'time': '1985-09-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          12:
              {
                'ts': 512510400,
                'time': '1986-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          13:
              {
                'ts': 528235200,
                'time': '1986-09-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          14:
              {
                'ts': 543960000,
                'time': '1987-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          15:
              {
                'ts': 559684800,
                'time': '1987-09-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          16:
              {
                'ts': 575409600,
                'time': '1988-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          17:
              {
                'ts': 591134400,
                'time': '1988-09-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          18:
              {
                'ts': 606859200,
                'time': '1989-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          19:
              {
                'ts': 622584000,
                'time': '1989-09-23T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          20:
              {
                'ts': 638308800,
                'time': '1990-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          21:
              {
                'ts': 654638400,
                'time': '1990-09-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          22:
              {
                'ts': 670363200,
                'time': '1991-03-30T20:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'OMSST'
              },
          23:
              {
                'ts': 686091600,
                'time': '1991-09-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'OMST'
              },
          24:
              {
                'ts': 695768400,
                'time': '1992-01-18T21:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          25:
              {
                'ts': 701802000,
                'time': '1992-03-28T17:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          26:
              {
                'ts': 717523200,
                'time': '1992-09-26T16:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          27:
              {
                'ts': 733262400,
                'time': '1993-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          28:
              {
                'ts': 748987200,
                'time': '1993-09-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          29:
              {
                'ts': 764712000,
                'time': '1994-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          30:
              {
                'ts': 780436800,
                'time': '1994-09-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          31:
              {
                'ts': 796161600,
                'time': '1995-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          32:
              {
                'ts': 811886400,
                'time': '1995-09-23T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          33:
              {
                'ts': 828216000,
                'time': '1996-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          34:
              {
                'ts': 846360000,
                'time': '1996-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          35:
              {
                'ts': 859665600,
                'time': '1997-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          36:
              {
                'ts': 877809600,
                'time': '1997-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          37:
              {
                'ts': 891115200,
                'time': '1998-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          38:
              {
                'ts': 909259200,
                'time': '1998-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          39:
              {
                'ts': 922564800,
                'time': '1999-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          40:
              {
                'ts': 941313600,
                'time': '1999-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          41:
              {
                'ts': 954014400,
                'time': '2000-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          42:
              {
                'ts': 972763200,
                'time': '2000-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          43:
              {
                'ts': 985464000,
                'time': '2001-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          44:
              {
                'ts': 1004212800,
                'time': '2001-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          45:
              {
                'ts': 1017518400,
                'time': '2002-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          46:
              {
                'ts': 1035662400,
                'time': '2002-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          47:
              {
                'ts': 1048968000,
                'time': '2003-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          48:
              {
                'ts': 1067112000,
                'time': '2003-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          49:
              {
                'ts': 1080417600,
                'time': '2004-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          50:
              {
                'ts': 1099166400,
                'time': '2004-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          51:
              {
                'ts': 1111867200,
                'time': '2005-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          52:
              {
                'ts': 1130616000,
                'time': '2005-10-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          53:
              {
                'ts': 1143316800,
                'time': '2006-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          54:
              {
                'ts': 1162065600,
                'time': '2006-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          55:
              {
                'ts': 1174766400,
                'time': '2007-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          56:
              {
                'ts': 1193515200,
                'time': '2007-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          57:
              {
                'ts': 1206820800,
                'time': '2008-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          58:
              {
                'ts': 1224964800,
                'time': '2008-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          59:
              {
                'ts': 1238270400,
                'time': '2009-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          60:
              {
                'ts': 1256414400,
                'time': '2009-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          61:
              {
                'ts': 1269720000,
                'time': '2010-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          62:
              {
                'ts': 1288468800,
                'time': '2010-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          63:
              {
                'ts': 1301169600,
                'time': '2011-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          64:
              {
                'ts': 1319918400,
                'time': '2011-10-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          65:
              {
                'ts': 1332619200,
                'time': '2012-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          66:
              {
                'ts': 1351368000,
                'time': '2012-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          67:
              {
                'ts': 1364673600,
                'time': '2013-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          68:
              {
                'ts': 1382817600,
                'time': '2013-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          69:
              {
                'ts': 1396123200,
                'time': '2014-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          70:
              {
                'ts': 1414267200,
                'time': '2014-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          71:
              {
                'ts': 1427572800,
                'time': '2015-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          72:
              {
                'ts': 1445716800,
                'time': '2015-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          73:
              {
                'ts': 1459022400,
                'time': '2016-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          74:
              {
                'ts': 1477771200,
                'time': '2016-10-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          75:
              {
                'ts': 1490472000,
                'time': '2017-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          76:
              {
                'ts': 1509220800,
                'time': '2017-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          77:
              {
                'ts': 1521921600,
                'time': '2018-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          78:
              {
                'ts': 1540670400,
                'time': '2018-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          79:
              {
                'ts': 1553976000,
                'time': '2019-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          80:
              {
                'ts': 1572120000,
                'time': '2019-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          81:
              {
                'ts': 1585425600,
                'time': '2020-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          82:
              {
                'ts': 1603569600,
                'time': '2020-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          83:
              {
                'ts': 1616875200,
                'time': '2021-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          84:
              {
                'ts': 1635624000,
                'time': '2021-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          85:
              {
                'ts': 1648324800,
                'time': '2022-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          86:
              {
                'ts': 1667073600,
                'time': '2022-10-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          87:
              {
                'ts': 1679774400,
                'time': '2023-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          88:
              {
                'ts': 1698523200,
                'time': '2023-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          89:
              {
                'ts': 1711828800,
                'time': '2024-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          90:
              {
                'ts': 1729972800,
                'time': '2024-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          91:
              {
                'ts': 1743278400,
                'time': '2025-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          92:
              {
                'ts': 1761422400,
                'time': '2025-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          93:
              {
                'ts': 1774728000,
                'time': '2026-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          94:
              {
                'ts': 1792872000,
                'time': '2026-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          95:
              {
                'ts': 1806177600,
                'time': '2027-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          96:
              {
                'ts': 1824926400,
                'time': '2027-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          97:
              {
                'ts': 1837627200,
                'time': '2028-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          98:
              {
                'ts': 1856376000,
                'time': '2028-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          99:
              {
                'ts': 1869076800,
                'time': '2029-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          100:
              {
                'ts': 1887825600,
                'time': '2029-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          101:
              {
                'ts': 1901131200,
                'time': '2030-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          102:
              {
                'ts': 1919275200,
                'time': '2030-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          103:
              {
                'ts': 1932580800,
                'time': '2031-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          104:
              {
                'ts': 1950724800,
                'time': '2031-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          105:
              {
                'ts': 1964030400,
                'time': '2032-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          106:
              {
                'ts': 1982779200,
                'time': '2032-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          107:
              {
                'ts': 1995480000,
                'time': '2033-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          108:
              {
                'ts': 2014228800,
                'time': '2033-10-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          109:
              {
                'ts': 2026929600,
                'time': '2034-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          110:
              {
                'ts': 2045678400,
                'time': '2034-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          111:
              {
                'ts': 2058379200,
                'time': '2035-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          112:
              {
                'ts': 2077128000,
                'time': '2035-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          113:
              {
                'ts': 2090433600,
                'time': '2036-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          114:
              {
                'ts': 2108577600,
                'time': '2036-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              },
          115:
              {
                'ts': 2121883200,
                'time': '2037-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'OMSST'
              },
          116:
              {
                'ts': 2140027200,
                'time': '2037-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'OMST'
              }
        },
    'Asia/Oral':
        {
          0:
              {
                'ts': -1441164324,
                'time': '1924-05-01T20:34:36+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'URAT'
              },
          1:
              {
                'ts': -1247544000,
                'time': '1930-06-20T20:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'URAT'
              },
          2:
              {
                'ts': 354913200,
                'time': '1981-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'URAST'
              },
          3:
              {
                'ts': 370720800,
                'time': '1981-09-30T18:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'URAT'
              },
          4:
              {
                'ts': 386445600,
                'time': '1982-03-31T18:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'URAST'
              },
          5:
              {
                'ts': 402256800,
                'time': '1982-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'URAT'
              },
          6:
              {
                'ts': 417985200,
                'time': '1983-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'URAST'
              },
          7:
              {
                'ts': 433792800,
                'time': '1983-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'URAT'
              },
          8:
              {
                'ts': 449607600,
                'time': '1984-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'URAST'
              },
          9:
              {
                'ts': 465339600,
                'time': '1984-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'URAT'
              },
          10:
              {
                'ts': 481064400,
                'time': '1985-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'URAST'
              },
          11:
              {
                'ts': 496789200,
                'time': '1985-09-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'URAT'
              },
          12:
              {
                'ts': 512514000,
                'time': '1986-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'URAST'
              },
          13:
              {
                'ts': 528238800,
                'time': '1986-09-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'URAT'
              },
          14:
              {
                'ts': 543963600,
                'time': '1987-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'URAST'
              },
          15:
              {
                'ts': 559688400,
                'time': '1987-09-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'URAT'
              },
          16:
              {
                'ts': 575413200,
                'time': '1988-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'URAST'
              },
          17:
              {
                'ts': 591138000,
                'time': '1988-09-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'URAT'
              },
          18:
              {
                'ts': 606862800,
                'time': '1989-03-25T21:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'URAST'
              },
          19:
              {
                'ts': 622591200,
                'time': '1989-09-23T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'URAT'
              },
          20:
              {
                'ts': 638316000,
                'time': '1990-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'URAST'
              },
          21:
              {
                'ts': 654645600,
                'time': '1990-09-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'URAT'
              },
          22:
              {
                'ts': 662673600,
                'time': '1990-12-31T20:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'URAT'
              },
          23:
              {
                'ts': 692827200,
                'time': '1991-12-15T20:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          24:
              {
                'ts': 701809200,
                'time': '1992-03-28T19:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          25:
              {
                'ts': 717530400,
                'time': '1992-09-26T18:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          26:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          27:
              {
                'ts': 748994400,
                'time': '1993-09-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          28:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          29:
              {
                'ts': 780444000,
                'time': '1994-09-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          30:
              {
                'ts': 796168800,
                'time': '1995-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          31:
              {
                'ts': 811893600,
                'time': '1995-09-23T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          32:
              {
                'ts': 828223200,
                'time': '1996-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          33:
              {
                'ts': 846367200,
                'time': '1996-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          34:
              {
                'ts': 859672800,
                'time': '1997-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          35:
              {
                'ts': 877816800,
                'time': '1997-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          36:
              {
                'ts': 891122400,
                'time': '1998-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          37:
              {
                'ts': 909266400,
                'time': '1998-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          38:
              {
                'ts': 922572000,
                'time': '1999-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          39:
              {
                'ts': 941320800,
                'time': '1999-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          40:
              {
                'ts': 954021600,
                'time': '2000-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          41:
              {
                'ts': 972770400,
                'time': '2000-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          42:
              {
                'ts': 985471200,
                'time': '2001-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          43:
              {
                'ts': 1004220000,
                'time': '2001-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          44:
              {
                'ts': 1017525600,
                'time': '2002-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          45:
              {
                'ts': 1035669600,
                'time': '2002-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          46:
              {
                'ts': 1048975200,
                'time': '2003-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          47:
              {
                'ts': 1067119200,
                'time': '2003-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          48:
              {
                'ts': 1080424800,
                'time': '2004-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'ORAST'
              },
          49:
              {
                'ts': 1099173600,
                'time': '2004-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'ORAT'
              },
          50:
              {
                'ts': 1110830400,
                'time': '2005-03-14T20:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'ORAT'
              }
        },
    'Asia/Phnom_Penh':
        {
          0:
              {
                'ts': -2005973980,
                'time': '1906-06-08T17:00:20+0000',
                'offset': 25580,
                'isdst': false,
                'abbr': 'SMT'
              },
          1:
              {
                'ts': -1855983920,
                'time': '1911-03-10T16:54:40+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'ICT'
              },
          2:
              {
                'ts': -1819954800,
                'time': '1912-04-30T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ICT'
              },
          3:
              {
                'ts': -1220428800,
                'time': '1931-04-30T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'ICT'
              }
        },
    'Asia/Pontianak':
        {
          0:
              {
                'ts': -1946186240,
                'time': '1908-04-30T16:42:40+0000',
                'offset': 26240,
                'isdst': false,
                'abbr': 'PMT'
              },
          1:
              {
                'ts': -1172906240,
                'time': '1932-10-31T16:42:40+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'WIT'
              },
          2:
              {
                'ts': -881220600,
                'time': '1942-01-28T16:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          3:
              {
                'ts': -766054800,
                'time': '1945-09-22T15:00:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'WIT'
              },
          4:
              {
                'ts': -683883000,
                'time': '1948-04-30T16:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WIT'
              },
          5:
              {
                'ts': -620812800,
                'time': '1950-04-30T16:00:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'WIT'
              },
          6:
              {
                'ts': -189415800,
                'time': '1963-12-31T16:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CIT'
              },
          7:
              {
                'ts': 567964800,
                'time': '1987-12-31T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'WIT'
              }
        },
    'Asia/Pyongyang':
        {
          0:
              {
                'ts': -2053931400,
                'time': '1904-11-30T15:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              },
          1:
              {
                'ts': -1325494800,
                'time': '1927-12-31T15:00:00+0000',
                'offset': 30600,
                'isdst': false,
                'abbr': 'KST'
              },
          2:
              {
                'ts': -1199262600,
                'time': '1931-12-31T15:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              },
          3:
              {
                'ts': -498128400,
                'time': '1954-03-20T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'KST'
              },
          4:
              {
                'ts': -264931200,
                'time': '1961-08-09T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              }
        },
    'Asia/Qatar':
        {
          0:
              {
                'ts': -1577935568,
                'time': '1919-12-31T20:33:52+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GST'
              },
          1:
              {
                'ts': 76190400,
                'time': '1972-05-31T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'Asia/Qyzylorda':
        {
          0:
              {
                'ts': -1441167712,
                'time': '1924-05-01T19:38:08+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'KIZT'
              },
          1:
              {
                'ts': -1247544000,
                'time': '1930-06-20T20:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KIZT'
              },
          2:
              {
                'ts': 354913200,
                'time': '1981-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KIZST'
              },
          3:
              {
                'ts': 370720800,
                'time': '1981-09-30T18:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'KIZT'
              },
          4:
              {
                'ts': 386445600,
                'time': '1982-03-31T18:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KIZST'
              },
          5:
              {
                'ts': 402256800,
                'time': '1982-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KIZT'
              },
          6:
              {
                'ts': 417985200,
                'time': '1983-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KIZST'
              },
          7:
              {
                'ts': 433792800,
                'time': '1983-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KIZT'
              },
          8:
              {
                'ts': 449607600,
                'time': '1984-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KIZST'
              },
          9:
              {
                'ts': 465339600,
                'time': '1984-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KIZT'
              },
          10:
              {
                'ts': 481064400,
                'time': '1985-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KIZST'
              },
          11:
              {
                'ts': 496789200,
                'time': '1985-09-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KIZT'
              },
          12:
              {
                'ts': 512514000,
                'time': '1986-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KIZST'
              },
          13:
              {
                'ts': 528238800,
                'time': '1986-09-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KIZT'
              },
          14:
              {
                'ts': 543963600,
                'time': '1987-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KIZST'
              },
          15:
              {
                'ts': 559688400,
                'time': '1987-09-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KIZT'
              },
          16:
              {
                'ts': 575413200,
                'time': '1988-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KIZST'
              },
          17:
              {
                'ts': 591138000,
                'time': '1988-09-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KIZT'
              },
          18:
              {
                'ts': 606862800,
                'time': '1989-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KIZST'
              },
          19:
              {
                'ts': 622587600,
                'time': '1989-09-23T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KIZT'
              },
          20:
              {
                'ts': 638312400,
                'time': '1990-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'KIZST'
              },
          21:
              {
                'ts': 654642000,
                'time': '1990-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KIZT'
              },
          22:
              {
                'ts': 662670000,
                'time': '1990-12-31T19:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'KIZT'
              },
          23:
              {
                'ts': 692823600,
                'time': '1991-12-15T19:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'QYZT'
              },
          24:
              {
                'ts': 695768400,
                'time': '1992-01-18T21:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          25:
              {
                'ts': 701802000,
                'time': '1992-03-28T17:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          26:
              {
                'ts': 717523200,
                'time': '1992-09-26T16:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          27:
              {
                'ts': 733262400,
                'time': '1993-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          28:
              {
                'ts': 748987200,
                'time': '1993-09-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          29:
              {
                'ts': 764712000,
                'time': '1994-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          30:
              {
                'ts': 780436800,
                'time': '1994-09-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          31:
              {
                'ts': 796161600,
                'time': '1995-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          32:
              {
                'ts': 811886400,
                'time': '1995-09-23T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          33:
              {
                'ts': 828216000,
                'time': '1996-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          34:
              {
                'ts': 846360000,
                'time': '1996-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          35:
              {
                'ts': 859665600,
                'time': '1997-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          36:
              {
                'ts': 877809600,
                'time': '1997-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          37:
              {
                'ts': 891115200,
                'time': '1998-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          38:
              {
                'ts': 909259200,
                'time': '1998-10-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          39:
              {
                'ts': 922564800,
                'time': '1999-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          40:
              {
                'ts': 941313600,
                'time': '1999-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          41:
              {
                'ts': 954014400,
                'time': '2000-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          42:
              {
                'ts': 972763200,
                'time': '2000-10-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          43:
              {
                'ts': 985464000,
                'time': '2001-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          44:
              {
                'ts': 1004212800,
                'time': '2001-10-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          45:
              {
                'ts': 1017518400,
                'time': '2002-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          46:
              {
                'ts': 1035662400,
                'time': '2002-10-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          47:
              {
                'ts': 1048968000,
                'time': '2003-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          48:
              {
                'ts': 1067112000,
                'time': '2003-10-25T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          49:
              {
                'ts': 1080417600,
                'time': '2004-03-27T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'QYZST'
              },
          50:
              {
                'ts': 1099166400,
                'time': '2004-10-30T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              },
          51:
              {
                'ts': 1110823200,
                'time': '2005-03-14T18:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'QYZT'
              }
        },
    'Asia/Rangoon':
        {
          0:
              {
                'ts': -1577946276,
                'time': '1919-12-31T17:35:24+0000',
                'offset': 23400,
                'isdst': false,
                'abbr': 'BURT'
              },
          1:
              {
                'ts': -873268200,
                'time': '1942-04-30T17:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          2:
              {
                'ts': -778410000,
                'time': '1945-05-02T15:00:00+0000',
                'offset': 23400,
                'isdst': false,
                'abbr': 'MMT'
              }
        },
    'Asia/Riyadh':
        {
          0:
              {
                'ts': -631163212,
                'time': '1949-12-31T20:53:08+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'Asia/Saigon':
        {
          0:
              {
                'ts': -2005974400,
                'time': '1906-06-08T16:53:20+0000',
                'offset': 25580,
                'isdst': false,
                'abbr': 'SMT'
              },
          1:
              {
                'ts': -1855983920,
                'time': '1911-03-10T16:54:40+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'ICT'
              },
          2:
              {
                'ts': -1819954800,
                'time': '1912-04-30T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ICT'
              },
          3:
              {
                'ts': -1220428800,
                'time': '1931-04-30T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'ICT'
              }
        },
    'Asia/Sakhalin':
        {
          0:
              {
                'ts': -2031039048,
                'time': '1905-08-22T14:29:12+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'CJT'
              },
          1:
              {
                'ts': -1009875600,
                'time': '1937-12-31T15:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          2:
              {
                'ts': -768560400,
                'time': '1945-08-24T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          3:
              {
                'ts': 354891600,
                'time': '1981-03-31T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          4:
              {
                'ts': 370699200,
                'time': '1981-09-30T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          5:
              {
                'ts': 386427600,
                'time': '1982-03-31T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          6:
              {
                'ts': 402235200,
                'time': '1982-09-30T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          7:
              {
                'ts': 417963600,
                'time': '1983-03-31T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          8:
              {
                'ts': 433771200,
                'time': '1983-09-30T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          9:
              {
                'ts': 449586000,
                'time': '1984-03-31T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          10:
              {
                'ts': 465318000,
                'time': '1984-09-29T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          11:
              {
                'ts': 481042800,
                'time': '1985-03-30T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          12:
              {
                'ts': 496767600,
                'time': '1985-09-28T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          13:
              {
                'ts': 512492400,
                'time': '1986-03-29T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          14:
              {
                'ts': 528217200,
                'time': '1986-09-27T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          15:
              {
                'ts': 543942000,
                'time': '1987-03-28T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          16:
              {
                'ts': 559666800,
                'time': '1987-09-26T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          17:
              {
                'ts': 575391600,
                'time': '1988-03-26T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          18:
              {
                'ts': 591116400,
                'time': '1988-09-24T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          19:
              {
                'ts': 606841200,
                'time': '1989-03-25T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          20:
              {
                'ts': 622566000,
                'time': '1989-09-23T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          21:
              {
                'ts': 638290800,
                'time': '1990-03-24T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          22:
              {
                'ts': 654620400,
                'time': '1990-09-29T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          23:
              {
                'ts': 670345200,
                'time': '1991-03-30T15:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          24:
              {
                'ts': 686073600,
                'time': '1991-09-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          25:
              {
                'ts': 695750400,
                'time': '1992-01-18T16:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          26:
              {
                'ts': 701784000,
                'time': '1992-03-28T12:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          27:
              {
                'ts': 717505200,
                'time': '1992-09-26T11:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          28:
              {
                'ts': 733244400,
                'time': '1993-03-27T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          29:
              {
                'ts': 748969200,
                'time': '1993-09-25T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          30:
              {
                'ts': 764694000,
                'time': '1994-03-26T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          31:
              {
                'ts': 780418800,
                'time': '1994-09-24T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          32:
              {
                'ts': 796143600,
                'time': '1995-03-25T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          33:
              {
                'ts': 811868400,
                'time': '1995-09-23T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          34:
              {
                'ts': 828198000,
                'time': '1996-03-30T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'SAKST'
              },
          35:
              {
                'ts': 846342000,
                'time': '1996-10-26T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SAKT'
              },
          36:
              {
                'ts': 859647600,
                'time': '1997-03-29T15:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          37:
              {
                'ts': 877795200,
                'time': '1997-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          38:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          39:
              {
                'ts': 909244800,
                'time': '1998-10-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          40:
              {
                'ts': 922550400,
                'time': '1999-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          41:
              {
                'ts': 941299200,
                'time': '1999-10-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          42:
              {
                'ts': 954000000,
                'time': '2000-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          43:
              {
                'ts': 972748800,
                'time': '2000-10-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          44:
              {
                'ts': 985449600,
                'time': '2001-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          45:
              {
                'ts': 1004198400,
                'time': '2001-10-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          46:
              {
                'ts': 1017504000,
                'time': '2002-03-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          47:
              {
                'ts': 1035648000,
                'time': '2002-10-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          48:
              {
                'ts': 1048953600,
                'time': '2003-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          49:
              {
                'ts': 1067097600,
                'time': '2003-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          50:
              {
                'ts': 1080403200,
                'time': '2004-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          51:
              {
                'ts': 1099152000,
                'time': '2004-10-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          52:
              {
                'ts': 1111852800,
                'time': '2005-03-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          53:
              {
                'ts': 1130601600,
                'time': '2005-10-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          54:
              {
                'ts': 1143302400,
                'time': '2006-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          55:
              {
                'ts': 1162051200,
                'time': '2006-10-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          56:
              {
                'ts': 1174752000,
                'time': '2007-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          57:
              {
                'ts': 1193500800,
                'time': '2007-10-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          58:
              {
                'ts': 1206806400,
                'time': '2008-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          59:
              {
                'ts': 1224950400,
                'time': '2008-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          60:
              {
                'ts': 1238256000,
                'time': '2009-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          61:
              {
                'ts': 1256400000,
                'time': '2009-10-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          62:
              {
                'ts': 1269705600,
                'time': '2010-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          63:
              {
                'ts': 1288454400,
                'time': '2010-10-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          64:
              {
                'ts': 1301155200,
                'time': '2011-03-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          65:
              {
                'ts': 1319904000,
                'time': '2011-10-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          66:
              {
                'ts': 1332604800,
                'time': '2012-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          67:
              {
                'ts': 1351353600,
                'time': '2012-10-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          68:
              {
                'ts': 1364659200,
                'time': '2013-03-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          69:
              {
                'ts': 1382803200,
                'time': '2013-10-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          70:
              {
                'ts': 1396108800,
                'time': '2014-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          71:
              {
                'ts': 1414252800,
                'time': '2014-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          72:
              {
                'ts': 1427558400,
                'time': '2015-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          73:
              {
                'ts': 1445702400,
                'time': '2015-10-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          74:
              {
                'ts': 1459008000,
                'time': '2016-03-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          75:
              {
                'ts': 1477756800,
                'time': '2016-10-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          76:
              {
                'ts': 1490457600,
                'time': '2017-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          77:
              {
                'ts': 1509206400,
                'time': '2017-10-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          78:
              {
                'ts': 1521907200,
                'time': '2018-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          79:
              {
                'ts': 1540656000,
                'time': '2018-10-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          80:
              {
                'ts': 1553961600,
                'time': '2019-03-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          81:
              {
                'ts': 1572105600,
                'time': '2019-10-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          82:
              {
                'ts': 1585411200,
                'time': '2020-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          83:
              {
                'ts': 1603555200,
                'time': '2020-10-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          84:
              {
                'ts': 1616860800,
                'time': '2021-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          85:
              {
                'ts': 1635609600,
                'time': '2021-10-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          86:
              {
                'ts': 1648310400,
                'time': '2022-03-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          87:
              {
                'ts': 1667059200,
                'time': '2022-10-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          88:
              {
                'ts': 1679760000,
                'time': '2023-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          89:
              {
                'ts': 1698508800,
                'time': '2023-10-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          90:
              {
                'ts': 1711814400,
                'time': '2024-03-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          91:
              {
                'ts': 1729958400,
                'time': '2024-10-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          92:
              {
                'ts': 1743264000,
                'time': '2025-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          93:
              {
                'ts': 1761408000,
                'time': '2025-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          94:
              {
                'ts': 1774713600,
                'time': '2026-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          95:
              {
                'ts': 1792857600,
                'time': '2026-10-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          96:
              {
                'ts': 1806163200,
                'time': '2027-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          97:
              {
                'ts': 1824912000,
                'time': '2027-10-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          98:
              {
                'ts': 1837612800,
                'time': '2028-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          99:
              {
                'ts': 1856361600,
                'time': '2028-10-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          100:
              {
                'ts': 1869062400,
                'time': '2029-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          101:
              {
                'ts': 1887811200,
                'time': '2029-10-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          102:
              {
                'ts': 1901116800,
                'time': '2030-03-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          103:
              {
                'ts': 1919260800,
                'time': '2030-10-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          104:
              {
                'ts': 1932566400,
                'time': '2031-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          105:
              {
                'ts': 1950710400,
                'time': '2031-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          106:
              {
                'ts': 1964016000,
                'time': '2032-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          107:
              {
                'ts': 1982764800,
                'time': '2032-10-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          108:
              {
                'ts': 1995465600,
                'time': '2033-03-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          109:
              {
                'ts': 2014214400,
                'time': '2033-10-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          110:
              {
                'ts': 2026915200,
                'time': '2034-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          111:
              {
                'ts': 2045664000,
                'time': '2034-10-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          112:
              {
                'ts': 2058364800,
                'time': '2035-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          113:
              {
                'ts': 2077113600,
                'time': '2035-10-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          114:
              {
                'ts': 2090419200,
                'time': '2036-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          115:
              {
                'ts': 2108563200,
                'time': '2036-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              },
          116:
              {
                'ts': 2121868800,
                'time': '2037-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'SAKST'
              },
          117:
              {
                'ts': 2140012800,
                'time': '2037-10-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'SAKT'
              }
        },
    'Asia/Samarkand':
        {
          0:
              {
                'ts': -1441168032,
                'time': '1924-05-01T19:32:48+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          1:
              {
                'ts': -1247544000,
                'time': '1930-06-20T20:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SAMT'
              },
          2:
              {
                'ts': 354913200,
                'time': '1981-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SAMST'
              },
          3:
              {
                'ts': 370720800,
                'time': '1981-09-30T18:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'TAST'
              },
          4:
              {
                'ts': 386445600,
                'time': '1982-03-31T18:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SAMST'
              },
          5:
              {
                'ts': 402256800,
                'time': '1982-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SAMT'
              },
          6:
              {
                'ts': 417985200,
                'time': '1983-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SAMST'
              },
          7:
              {
                'ts': 433792800,
                'time': '1983-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SAMT'
              },
          8:
              {
                'ts': 449607600,
                'time': '1984-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SAMST'
              },
          9:
              {
                'ts': 465339600,
                'time': '1984-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SAMT'
              },
          10:
              {
                'ts': 481064400,
                'time': '1985-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SAMST'
              },
          11:
              {
                'ts': 496789200,
                'time': '1985-09-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SAMT'
              },
          12:
              {
                'ts': 512514000,
                'time': '1986-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SAMST'
              },
          13:
              {
                'ts': 528238800,
                'time': '1986-09-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SAMT'
              },
          14:
              {
                'ts': 543963600,
                'time': '1987-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SAMST'
              },
          15:
              {
                'ts': 559688400,
                'time': '1987-09-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SAMT'
              },
          16:
              {
                'ts': 575413200,
                'time': '1988-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SAMST'
              },
          17:
              {
                'ts': 591138000,
                'time': '1988-09-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SAMT'
              },
          18:
              {
                'ts': 606862800,
                'time': '1989-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SAMST'
              },
          19:
              {
                'ts': 622587600,
                'time': '1989-09-23T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SAMT'
              },
          20:
              {
                'ts': 638312400,
                'time': '1990-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SAMST'
              },
          21:
              {
                'ts': 654642000,
                'time': '1990-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SAMT'
              },
          22:
              {
                'ts': 670366800,
                'time': '1991-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SAMST'
              },
          23:
              {
                'ts': 683661600,
                'time': '1991-08-31T18:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'UZST'
              },
          24:
              {
                'ts': 686091600,
                'time': '1991-09-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'UZT'
              },
          25:
              {
                'ts': 694206000,
                'time': '1991-12-31T19:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'UZT'
              }
        },
    'Asia/Seoul':
        {
          0:
              {
                'ts': -2053931400,
                'time': '1904-11-30T15:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              },
          1:
              {
                'ts': -1325494800,
                'time': '1927-12-31T15:00:00+0000',
                'offset': 30600,
                'isdst': false,
                'abbr': 'KST'
              },
          2:
              {
                'ts': -1199262600,
                'time': '1931-12-31T15:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              },
          3:
              {
                'ts': -498128400,
                'time': '1954-03-20T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'KST'
              },
          4:
              {
                'ts': -303984000,
                'time': '1960-05-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'KDT'
              },
          5:
              {
                'ts': -293533200,
                'time': '1960-09-12T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'KST'
              },
          6:
              {
                'ts': -264931200,
                'time': '1961-08-09T16:00:00+0000',
                'offset': 30600,
                'isdst': false,
                'abbr': 'KST'
              },
          7:
              {
                'ts': -39515400,
                'time': '1968-09-30T15:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              },
          8:
              {
                'ts': 547570800,
                'time': '1987-05-09T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'KDT'
              },
          9:
              {
                'ts': 560872800,
                'time': '1987-10-10T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              },
          10:
              {
                'ts': 579020400,
                'time': '1988-05-07T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'KDT'
              },
          11:
              {
                'ts': 592322400,
                'time': '1988-10-08T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              }
        },
    'Asia/Shanghai':
        {
          0:
              {
                'ts': -1325491552,
                'time': '1927-12-31T15:54:08+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -933494400,
                'time': '1940-06-02T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          2:
              {
                'ts': -923130000,
                'time': '1940-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': -908784000,
                'time': '1941-03-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': -891594000,
                'time': '1941-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': 515520000,
                'time': '1986-05-03T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': 527007600,
                'time': '1986-09-13T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': 545155200,
                'time': '1987-04-11T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': 558457200,
                'time': '1987-09-12T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 576604800,
                'time': '1988-04-09T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': 589906800,
                'time': '1988-09-10T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 608659200,
                'time': '1989-04-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': 621961200,
                'time': '1989-09-16T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 640108800,
                'time': '1990-04-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': 653410800,
                'time': '1990-09-15T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 671558400,
                'time': '1991-04-13T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': 684860400,
                'time': '1991-09-14T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Asia/Singapore':
        {
          0:
              {
                'ts': -2038200925,
                'time': '1905-05-31T17:04:35+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'MALT'
              },
          1:
              {
                'ts': -1167634800,
                'time': '1932-12-31T17:00:00+0000',
                'offset': 26400,
                'isdst': true,
                'abbr': 'MALST'
              },
          2:
              {
                'ts': -1073028000,
                'time': '1935-12-31T16:40:00+0000',
                'offset': 26400,
                'isdst': false,
                'abbr': 'MALT'
              },
          3:
              {
                'ts': -894180000,
                'time': '1941-08-31T16:40:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'MALT'
              },
          4:
              {
                'ts': -879665400,
                'time': '1942-02-15T16:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          5:
              {
                'ts': -767005200,
                'time': '1945-09-11T15:00:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'MALT'
              },
          6:
              {
                'ts': -138785400,
                'time': '1965-08-08T16:30:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'SGT'
              },
          7:
              {
                'ts': 378664200,
                'time': '1981-12-31T16:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'SGT'
              }
        },
    'Asia/Taipei':
        {
          0:
              {
                'ts': -778579200,
                'time': '1945-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -765363600,
                'time': '1945-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -747043200,
                'time': '1946-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -733827600,
                'time': '1946-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -715507200,
                'time': '1947-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': -702291600,
                'time': '1947-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -683884800,
                'time': '1948-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': -670669200,
                'time': '1948-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': -652348800,
                'time': '1949-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          9:
              {
                'ts': -639133200,
                'time': '1949-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': -620812800,
                'time': '1950-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          11:
              {
                'ts': -607597200,
                'time': '1950-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': -589276800,
                'time': '1951-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          13:
              {
                'ts': -576061200,
                'time': '1951-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          14:
              {
                'ts': -562924800,
                'time': '1952-02-29T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          15:
              {
                'ts': -541760400,
                'time': '1952-10-31T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          16:
              {
                'ts': -528710400,
                'time': '1953-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          17:
              {
                'ts': -510224400,
                'time': '1953-10-31T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          18:
              {
                'ts': -497174400,
                'time': '1954-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          19:
              {
                'ts': -478688400,
                'time': '1954-10-31T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          20:
              {
                'ts': -465638400,
                'time': '1955-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          21:
              {
                'ts': -449830800,
                'time': '1955-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          22:
              {
                'ts': -434016000,
                'time': '1956-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          23:
              {
                'ts': -418208400,
                'time': '1956-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          24:
              {
                'ts': -402480000,
                'time': '1957-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          25:
              {
                'ts': -386672400,
                'time': '1957-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          26:
              {
                'ts': -370944000,
                'time': '1958-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          27:
              {
                'ts': -355136400,
                'time': '1958-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          28:
              {
                'ts': -339408000,
                'time': '1959-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          29:
              {
                'ts': -323600400,
                'time': '1959-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          30:
              {
                'ts': -302515200,
                'time': '1960-05-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          31:
              {
                'ts': -291978000,
                'time': '1960-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          32:
              {
                'ts': -270979200,
                'time': '1961-05-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          33:
              {
                'ts': -260442000,
                'time': '1961-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          34:
              {
                'ts': 133977600,
                'time': '1974-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          35:
              {
                'ts': 149785200,
                'time': '1974-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          36:
              {
                'ts': 165513600,
                'time': '1975-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          37:
              {
                'ts': 181321200,
                'time': '1975-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': 331142400,
                'time': '1980-06-29T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          39:
              {
                'ts': 339087600,
                'time': '1980-09-29T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Asia/Tashkent':
        {
          0:
              {
                'ts': -1441168632,
                'time': '1924-05-01T19:22:48+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'TAST'
              },
          1:
              {
                'ts': -1247547600,
                'time': '1930-06-20T19:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'TAST'
              },
          2:
              {
                'ts': 354909600,
                'time': '1981-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'TASST'
              },
          3:
              {
                'ts': 370717200,
                'time': '1981-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'TAST'
              },
          4:
              {
                'ts': 386445600,
                'time': '1982-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'TASST'
              },
          5:
              {
                'ts': 402253200,
                'time': '1982-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'TAST'
              },
          6:
              {
                'ts': 417981600,
                'time': '1983-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'TASST'
              },
          7:
              {
                'ts': 433789200,
                'time': '1983-09-30T17:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'TAST'
              },
          8:
              {
                'ts': 449604000,
                'time': '1984-03-31T18:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'TASST'
              },
          9:
              {
                'ts': 465336000,
                'time': '1984-09-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'TAST'
              },
          10:
              {
                'ts': 481060800,
                'time': '1985-03-30T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'TASST'
              },
          11:
              {
                'ts': 496785600,
                'time': '1985-09-28T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'TAST'
              },
          12:
              {
                'ts': 512510400,
                'time': '1986-03-29T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'TASST'
              },
          13:
              {
                'ts': 528235200,
                'time': '1986-09-27T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'TAST'
              },
          14:
              {
                'ts': 543960000,
                'time': '1987-03-28T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'TASST'
              },
          15:
              {
                'ts': 559684800,
                'time': '1987-09-26T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'TAST'
              },
          16:
              {
                'ts': 575409600,
                'time': '1988-03-26T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'TASST'
              },
          17:
              {
                'ts': 591134400,
                'time': '1988-09-24T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'TAST'
              },
          18:
              {
                'ts': 606859200,
                'time': '1989-03-25T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'TASST'
              },
          19:
              {
                'ts': 622584000,
                'time': '1989-09-23T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'TAST'
              },
          20:
              {
                'ts': 638308800,
                'time': '1990-03-24T20:00:00+0000',
                'offset': 25200,
                'isdst': true,
                'abbr': 'TASST'
              },
          21:
              {
                'ts': 654638400,
                'time': '1990-09-29T20:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'TAST'
              },
          22:
              {
                'ts': 670363200,
                'time': '1991-03-30T20:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'TASST'
              },
          23:
              {
                'ts': 683661600,
                'time': '1991-08-31T18:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'UZST'
              },
          24:
              {
                'ts': 686091600,
                'time': '1991-09-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'UZT'
              },
          25:
              {
                'ts': 694206000,
                'time': '1991-12-31T19:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'UZT'
              }
        },
    'Asia/Tbilisi':
        {
          0:
              {
                'ts': -1441162756,
                'time': '1924-05-01T21:00:44+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TBIT'
              },
          1:
              {
                'ts': -405140400,
                'time': '1957-02-28T21:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TBIT'
              },
          2:
              {
                'ts': 354916800,
                'time': '1981-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'TBIST'
              },
          3:
              {
                'ts': 370724400,
                'time': '1981-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TBIT'
              },
          4:
              {
                'ts': 386452800,
                'time': '1982-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'TBIST'
              },
          5:
              {
                'ts': 402260400,
                'time': '1982-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TBIT'
              },
          6:
              {
                'ts': 417988800,
                'time': '1983-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'TBIST'
              },
          7:
              {
                'ts': 433796400,
                'time': '1983-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TBIT'
              },
          8:
              {
                'ts': 449611200,
                'time': '1984-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'TBIST'
              },
          9:
              {
                'ts': 465343200,
                'time': '1984-09-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TBIT'
              },
          10:
              {
                'ts': 481068000,
                'time': '1985-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'TBIST'
              },
          11:
              {
                'ts': 496792800,
                'time': '1985-09-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TBIT'
              },
          12:
              {
                'ts': 512517600,
                'time': '1986-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'TBIST'
              },
          13:
              {
                'ts': 528242400,
                'time': '1986-09-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TBIT'
              },
          14:
              {
                'ts': 543967200,
                'time': '1987-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'TBIST'
              },
          15:
              {
                'ts': 559692000,
                'time': '1987-09-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TBIT'
              },
          16:
              {
                'ts': 575416800,
                'time': '1988-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'TBIST'
              },
          17:
              {
                'ts': 591141600,
                'time': '1988-09-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TBIT'
              },
          18:
              {
                'ts': 606866400,
                'time': '1989-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'TBIST'
              },
          19:
              {
                'ts': 622591200,
                'time': '1989-09-23T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TBIT'
              },
          20:
              {
                'ts': 638316000,
                'time': '1990-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'TBIST'
              },
          21:
              {
                'ts': 654645600,
                'time': '1990-09-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'TBIT'
              },
          22:
              {
                'ts': 670370400,
                'time': '1991-03-30T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TBIST'
              },
          23:
              {
                'ts': 671140800,
                'time': '1991-04-08T20:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'GEST'
              },
          24:
              {
                'ts': 686098800,
                'time': '1991-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'GET'
              },
          25:
              {
                'ts': 694213200,
                'time': '1991-12-31T21:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'GET'
              },
          26:
              {
                'ts': 701816400,
                'time': '1992-03-28T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'GEST'
              },
          27:
              {
                'ts': 717537600,
                'time': '1992-09-26T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'GET'
              },
          28:
              {
                'ts': 733266000,
                'time': '1993-03-27T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'GEST'
              },
          29:
              {
                'ts': 748987200,
                'time': '1993-09-25T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'GET'
              },
          30:
              {
                'ts': 764715600,
                'time': '1994-03-26T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'GEST'
              },
          31:
              {
                'ts': 780436800,
                'time': '1994-09-24T20:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GET'
              },
          32:
              {
                'ts': 796161600,
                'time': '1995-03-25T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'GEST'
              },
          33:
              {
                'ts': 811882800,
                'time': '1995-09-23T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GET'
              },
          34:
              {
                'ts': 828216000,
                'time': '1996-03-30T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'GEST'
              },
          35:
              {
                'ts': 859662000,
                'time': '1997-03-29T19:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'GEST'
              },
          36:
              {
                'ts': 877806000,
                'time': '1997-10-25T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GET'
              },
          37:
              {
                'ts': 891115200,
                'time': '1998-03-28T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'GEST'
              },
          38:
              {
                'ts': 909255600,
                'time': '1998-10-24T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GET'
              },
          39:
              {
                'ts': 922564800,
                'time': '1999-03-27T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'GEST'
              },
          40:
              {
                'ts': 941310000,
                'time': '1999-10-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GET'
              },
          41:
              {
                'ts': 954014400,
                'time': '2000-03-25T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'GEST'
              },
          42:
              {
                'ts': 972759600,
                'time': '2000-10-28T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GET'
              },
          43:
              {
                'ts': 985464000,
                'time': '2001-03-24T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'GEST'
              },
          44:
              {
                'ts': 1004209200,
                'time': '2001-10-27T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GET'
              },
          45:
              {
                'ts': 1017518400,
                'time': '2002-03-30T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'GEST'
              },
          46:
              {
                'ts': 1035658800,
                'time': '2002-10-26T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GET'
              },
          47:
              {
                'ts': 1048968000,
                'time': '2003-03-29T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'GEST'
              },
          48:
              {
                'ts': 1067108400,
                'time': '2003-10-25T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GET'
              },
          49:
              {
                'ts': 1080417600,
                'time': '2004-03-27T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'GEST'
              },
          50:
              {
                'ts': 1088276400,
                'time': '2004-06-26T19:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'GEST'
              },
          51:
              {
                'ts': 1099177200,
                'time': '2004-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'GET'
              },
          52:
              {
                'ts': 1111878000,
                'time': '2005-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'GET'
              }
        },
    'Asia/Tehran':
        {
          0:
              {
                'ts': -1704165944,
                'time': '1915-12-31T20:34:16+0000',
                'offset': 12344,
                'isdst': false,
                'abbr': 'TMT'
              },
          1:
              {
                'ts': -757394744,
                'time': '1945-12-31T20:34:16+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          2:
              {
                'ts': 247177800,
                'time': '1977-10-31T20:30:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'IRST'
              },
          3:
              {
                'ts': 259272000,
                'time': '1978-03-20T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'IRDT'
              },
          4:
              {
                'ts': 277758000,
                'time': '1978-10-20T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'IRST'
              },
          5:
              {
                'ts': 283982400,
                'time': '1978-12-31T20:00:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          6:
              {
                'ts': 290809800,
                'time': '1979-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          7:
              {
                'ts': 306531000,
                'time': '1979-09-18T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          8:
              {
                'ts': 322432200,
                'time': '1980-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          9:
              {
                'ts': 338499000,
                'time': '1980-09-22T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          10:
              {
                'ts': 673216200,
                'time': '1991-05-02T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          11:
              {
                'ts': 685481400,
                'time': '1991-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          12:
              {
                'ts': 701209800,
                'time': '1992-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          13:
              {
                'ts': 717103800,
                'time': '1992-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          14:
              {
                'ts': 732745800,
                'time': '1993-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          15:
              {
                'ts': 748639800,
                'time': '1993-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          16:
              {
                'ts': 764281800,
                'time': '1994-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          17:
              {
                'ts': 780175800,
                'time': '1994-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          18:
              {
                'ts': 795817800,
                'time': '1995-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          19:
              {
                'ts': 811711800,
                'time': '1995-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          20:
              {
                'ts': 827353800,
                'time': '1996-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          21:
              {
                'ts': 843247800,
                'time': '1996-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          22:
              {
                'ts': 858976200,
                'time': '1997-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          23:
              {
                'ts': 874870200,
                'time': '1997-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          24:
              {
                'ts': 890512200,
                'time': '1998-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          25:
              {
                'ts': 906406200,
                'time': '1998-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          26:
              {
                'ts': 922048200,
                'time': '1999-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          27:
              {
                'ts': 937942200,
                'time': '1999-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          28:
              {
                'ts': 953584200,
                'time': '2000-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          29:
              {
                'ts': 969478200,
                'time': '2000-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          30:
              {
                'ts': 985206600,
                'time': '2001-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          31:
              {
                'ts': 1001100600,
                'time': '2001-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          32:
              {
                'ts': 1016742600,
                'time': '2002-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          33:
              {
                'ts': 1032636600,
                'time': '2002-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          34:
              {
                'ts': 1048278600,
                'time': '2003-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          35:
              {
                'ts': 1064172600,
                'time': '2003-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          36:
              {
                'ts': 1079814600,
                'time': '2004-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          37:
              {
                'ts': 1095708600,
                'time': '2004-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          38:
              {
                'ts': 1111437000,
                'time': '2005-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          39:
              {
                'ts': 1127331000,
                'time': '2005-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          40:
              {
                'ts': 1206045000,
                'time': '2008-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          41:
              {
                'ts': 1221939000,
                'time': '2008-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          42:
              {
                'ts': 1237667400,
                'time': '2009-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          43:
              {
                'ts': 1253561400,
                'time': '2009-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          44:
              {
                'ts': 1269203400,
                'time': '2010-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          45:
              {
                'ts': 1285097400,
                'time': '2010-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          46:
              {
                'ts': 1300739400,
                'time': '2011-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          47:
              {
                'ts': 1316633400,
                'time': '2011-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          48:
              {
                'ts': 1332275400,
                'time': '2012-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          49:
              {
                'ts': 1348169400,
                'time': '2012-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          50:
              {
                'ts': 1363897800,
                'time': '2013-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          51:
              {
                'ts': 1379791800,
                'time': '2013-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          52:
              {
                'ts': 1395433800,
                'time': '2014-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          53:
              {
                'ts': 1411327800,
                'time': '2014-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          54:
              {
                'ts': 1426969800,
                'time': '2015-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          55:
              {
                'ts': 1442863800,
                'time': '2015-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          56:
              {
                'ts': 1458505800,
                'time': '2016-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          57:
              {
                'ts': 1474399800,
                'time': '2016-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          58:
              {
                'ts': 1490128200,
                'time': '2017-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          59:
              {
                'ts': 1506022200,
                'time': '2017-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          60:
              {
                'ts': 1521664200,
                'time': '2018-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          61:
              {
                'ts': 1537558200,
                'time': '2018-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          62:
              {
                'ts': 1553200200,
                'time': '2019-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          63:
              {
                'ts': 1569094200,
                'time': '2019-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          64:
              {
                'ts': 1584736200,
                'time': '2020-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          65:
              {
                'ts': 1600630200,
                'time': '2020-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          66:
              {
                'ts': 1616358600,
                'time': '2021-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          67:
              {
                'ts': 1632252600,
                'time': '2021-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          68:
              {
                'ts': 1647894600,
                'time': '2022-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          69:
              {
                'ts': 1663788600,
                'time': '2022-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          70:
              {
                'ts': 1679430600,
                'time': '2023-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          71:
              {
                'ts': 1695324600,
                'time': '2023-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          72:
              {
                'ts': 1710966600,
                'time': '2024-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          73:
              {
                'ts': 1726860600,
                'time': '2024-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          74:
              {
                'ts': 1742589000,
                'time': '2025-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          75:
              {
                'ts': 1758483000,
                'time': '2025-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          76:
              {
                'ts': 1774125000,
                'time': '2026-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          77:
              {
                'ts': 1790019000,
                'time': '2026-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          78:
              {
                'ts': 1805661000,
                'time': '2027-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          79:
              {
                'ts': 1821555000,
                'time': '2027-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          80:
              {
                'ts': 1837197000,
                'time': '2028-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          81:
              {
                'ts': 1853091000,
                'time': '2028-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          82:
              {
                'ts': 1868733000,
                'time': '2029-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          83:
              {
                'ts': 1884627000,
                'time': '2029-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          84:
              {
                'ts': 1900355400,
                'time': '2030-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          85:
              {
                'ts': 1916249400,
                'time': '2030-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          86:
              {
                'ts': 1931891400,
                'time': '2031-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          87:
              {
                'ts': 1947785400,
                'time': '2031-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          88:
              {
                'ts': 1963427400,
                'time': '2032-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          89:
              {
                'ts': 1979321400,
                'time': '2032-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          90:
              {
                'ts': 1994963400,
                'time': '2033-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          91:
              {
                'ts': 2010857400,
                'time': '2033-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          92:
              {
                'ts': 2026585800,
                'time': '2034-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          93:
              {
                'ts': 2042479800,
                'time': '2034-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          94:
              {
                'ts': 2058121800,
                'time': '2035-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          95:
              {
                'ts': 2074015800,
                'time': '2035-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          96:
              {
                'ts': 2089657800,
                'time': '2036-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          97:
              {
                'ts': 2105551800,
                'time': '2036-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          98:
              {
                'ts': 2121193800,
                'time': '2037-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          99:
              {
                'ts': 2137087800,
                'time': '2037-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              }
        },
    'Asia/Tel_Aviv':
        {
          0:
              {
                'ts': -1641003640,
                'time': '1917-12-31T21:39:20+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          1:
              {
                'ts': -933645600,
                'time': '1940-05-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          2:
              {
                'ts': -857358000,
                'time': '1942-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          3:
              {
                'ts': -844300800,
                'time': '1943-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          4:
              {
                'ts': -825822000,
                'time': '1943-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          5:
              {
                'ts': -812685600,
                'time': '1944-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          6:
              {
                'ts': -794199600,
                'time': '1944-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          7:
              {
                'ts': -779853600,
                'time': '1945-04-15T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          8:
              {
                'ts': -762656400,
                'time': '1945-10-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          9:
              {
                'ts': -748310400,
                'time': '1946-04-16T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          10:
              {
                'ts': -731127600,
                'time': '1946-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          11:
              {
                'ts': -681962400,
                'time': '1948-05-22T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'IDDT'
              },
          12:
              {
                'ts': -673243200,
                'time': '1948-08-31T20:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          13:
              {
                'ts': -667962000,
                'time': '1948-10-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          14:
              {
                'ts': -652327200,
                'time': '1949-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          15:
              {
                'ts': -636426000,
                'time': '1949-10-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          16:
              {
                'ts': -622087200,
                'time': '1950-04-15T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          17:
              {
                'ts': -608947200,
                'time': '1950-09-15T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          18:
              {
                'ts': -591847200,
                'time': '1951-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          19:
              {
                'ts': -572486400,
                'time': '1951-11-11T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          20:
              {
                'ts': -558576000,
                'time': '1952-04-20T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          21:
              {
                'ts': -542851200,
                'time': '1952-10-19T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          22:
              {
                'ts': -527731200,
                'time': '1953-04-12T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          23:
              {
                'ts': -514425600,
                'time': '1953-09-13T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          24:
              {
                'ts': -490845600,
                'time': '1954-06-12T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          25:
              {
                'ts': -482986800,
                'time': '1954-09-11T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          26:
              {
                'ts': -459475200,
                'time': '1955-06-11T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          27:
              {
                'ts': -451537200,
                'time': '1955-09-10T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          28:
              {
                'ts': -428551200,
                'time': '1956-06-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          29:
              {
                'ts': -418262400,
                'time': '1956-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          30:
              {
                'ts': -400032000,
                'time': '1957-04-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          31:
              {
                'ts': -387428400,
                'time': '1957-09-21T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          32:
              {
                'ts': 142380000,
                'time': '1974-07-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          33:
              {
                'ts': 150843600,
                'time': '1974-10-12T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          34:
              {
                'ts': 167176800,
                'time': '1975-04-19T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          35:
              {
                'ts': 178664400,
                'time': '1975-08-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          36:
              {
                'ts': 482277600,
                'time': '1985-04-13T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          37:
              {
                'ts': 495579600,
                'time': '1985-09-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          38:
              {
                'ts': 516751200,
                'time': '1986-05-17T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          39:
              {
                'ts': 526424400,
                'time': '1986-09-06T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          40:
              {
                'ts': 545436000,
                'time': '1987-04-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          41:
              {
                'ts': 558478800,
                'time': '1987-09-12T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          42:
              {
                'ts': 576540000,
                'time': '1988-04-08T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          43:
              {
                'ts': 589237200,
                'time': '1988-09-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          44:
              {
                'ts': 609890400,
                'time': '1989-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          45:
              {
                'ts': 620773200,
                'time': '1989-09-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          46:
              {
                'ts': 638316000,
                'time': '1990-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          47:
              {
                'ts': 651618000,
                'time': '1990-08-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          48:
              {
                'ts': 669765600,
                'time': '1991-03-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          49:
              {
                'ts': 683672400,
                'time': '1991-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          50:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          51:
              {
                'ts': 715726800,
                'time': '1992-09-05T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          52:
              {
                'ts': 733701600,
                'time': '1993-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          53:
              {
                'ts': 747176400,
                'time': '1993-09-04T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          54:
              {
                'ts': 765151200,
                'time': '1994-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          55:
              {
                'ts': 778021200,
                'time': '1994-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          56:
              {
                'ts': 796600800,
                'time': '1995-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          57:
              {
                'ts': 810075600,
                'time': '1995-09-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          58:
              {
                'ts': 826840800,
                'time': '1996-03-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          59:
              {
                'ts': 842821200,
                'time': '1996-09-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          60:
              {
                'ts': 858895200,
                'time': '1997-03-20T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          61:
              {
                'ts': 874184400,
                'time': '1997-09-13T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          62:
              {
                'ts': 890344800,
                'time': '1998-03-19T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          63:
              {
                'ts': 905029200,
                'time': '1998-09-05T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          64:
              {
                'ts': 923011200,
                'time': '1999-04-02T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          65:
              {
                'ts': 936313200,
                'time': '1999-09-02T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          66:
              {
                'ts': 955670400,
                'time': '2000-04-14T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          67:
              {
                'ts': 970783200,
                'time': '2000-10-05T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          68:
              {
                'ts': 986770800,
                'time': '2001-04-08T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          69:
              {
                'ts': 1001282400,
                'time': '2001-09-23T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          70:
              {
                'ts': 1017356400,
                'time': '2002-03-28T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          71:
              {
                'ts': 1033941600,
                'time': '2002-10-06T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          72:
              {
                'ts': 1048806000,
                'time': '2003-03-27T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          73:
              {
                'ts': 1065132000,
                'time': '2003-10-02T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          74:
              {
                'ts': 1081292400,
                'time': '2004-04-06T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          75:
              {
                'ts': 1095804000,
                'time': '2004-09-21T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          76:
              {
                'ts': 1112313600,
                'time': '2005-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          77:
              {
                'ts': 1128812400,
                'time': '2005-10-08T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          78:
              {
                'ts': 1143763200,
                'time': '2006-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          79:
              {
                'ts': 1159657200,
                'time': '2006-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          80:
              {
                'ts': 1175212800,
                'time': '2007-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          81:
              {
                'ts': 1189897200,
                'time': '2007-09-15T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          82:
              {
                'ts': 1206662400,
                'time': '2008-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          83:
              {
                'ts': 1223161200,
                'time': '2008-10-04T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          84:
              {
                'ts': 1238112000,
                'time': '2009-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          85:
              {
                'ts': 1254006000,
                'time': '2009-09-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          86:
              {
                'ts': 1269561600,
                'time': '2010-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          87:
              {
                'ts': 1284246000,
                'time': '2010-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          88:
              {
                'ts': 1301616000,
                'time': '2011-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          89:
              {
                'ts': 1317510000,
                'time': '2011-10-01T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          90:
              {
                'ts': 1333065600,
                'time': '2012-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          91:
              {
                'ts': 1348354800,
                'time': '2012-09-22T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          92:
              {
                'ts': 1364515200,
                'time': '2013-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          93:
              {
                'ts': 1378594800,
                'time': '2013-09-07T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          94:
              {
                'ts': 1395964800,
                'time': '2014-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          95:
              {
                'ts': 1411858800,
                'time': '2014-09-27T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          96:
              {
                'ts': 1427414400,
                'time': '2015-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          97:
              {
                'ts': 1442703600,
                'time': '2015-09-19T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          98:
              {
                'ts': 1459468800,
                'time': '2016-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          99:
              {
                'ts': 1475967600,
                'time': '2016-10-08T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          100:
              {
                'ts': 1490918400,
                'time': '2017-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          101:
              {
                'ts': 1506207600,
                'time': '2017-09-23T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          102:
              {
                'ts': 1522368000,
                'time': '2018-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          103:
              {
                'ts': 1537052400,
                'time': '2018-09-15T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          104:
              {
                'ts': 1553817600,
                'time': '2019-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          105:
              {
                'ts': 1570316400,
                'time': '2019-10-05T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          106:
              {
                'ts': 1585267200,
                'time': '2020-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          107:
              {
                'ts': 1601161200,
                'time': '2020-09-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          108:
              {
                'ts': 1616716800,
                'time': '2021-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          109:
              {
                'ts': 1631401200,
                'time': '2021-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          110:
              {
                'ts': 1648771200,
                'time': '2022-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          111:
              {
                'ts': 1664665200,
                'time': '2022-10-01T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          112:
              {
                'ts': 1680220800,
                'time': '2023-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          113:
              {
                'ts': 1695510000,
                'time': '2023-09-23T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          114:
              {
                'ts': 1711670400,
                'time': '2024-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          115:
              {
                'ts': 1728169200,
                'time': '2024-10-05T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          116:
              {
                'ts': 1743120000,
                'time': '2025-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          117:
              {
                'ts': 1759014000,
                'time': '2025-09-27T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          118:
              {
                'ts': 1774569600,
                'time': '2026-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          119:
              {
                'ts': 1789858800,
                'time': '2026-09-19T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          120:
              {
                'ts': 1806019200,
                'time': '2027-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          121:
              {
                'ts': 1823122800,
                'time': '2027-10-09T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          122:
              {
                'ts': 1838073600,
                'time': '2028-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          123:
              {
                'ts': 1853362800,
                'time': '2028-09-23T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          124:
              {
                'ts': 1869523200,
                'time': '2029-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          125:
              {
                'ts': 1884207600,
                'time': '2029-09-15T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          126:
              {
                'ts': 1900972800,
                'time': '2030-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          127:
              {
                'ts': 1917471600,
                'time': '2030-10-05T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          128:
              {
                'ts': 1932422400,
                'time': '2031-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          129:
              {
                'ts': 1947711600,
                'time': '2031-09-20T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          130:
              {
                'ts': 1963872000,
                'time': '2032-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          131:
              {
                'ts': 1978556400,
                'time': '2032-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          132:
              {
                'ts': 1995926400,
                'time': '2033-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          133:
              {
                'ts': 2011820400,
                'time': '2033-10-01T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          134:
              {
                'ts': 2027376000,
                'time': '2034-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          135:
              {
                'ts': 2042060400,
                'time': '2034-09-16T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          136:
              {
                'ts': 2058825600,
                'time': '2035-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          137:
              {
                'ts': 2075324400,
                'time': '2035-10-06T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          138:
              {
                'ts': 2090275200,
                'time': '2036-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          139:
              {
                'ts': 2106169200,
                'time': '2036-09-27T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          140:
              {
                'ts': 2121724800,
                'time': '2037-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          141:
              {
                'ts': 2136409200,
                'time': '2037-09-12T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              }
        },
    'Asia/Thimbu':
        {
          0:
              {
                'ts': -706341516,
                'time': '1947-08-14T18:01:24+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              },
          1:
              {
                'ts': 560025000,
                'time': '1987-09-30T18:30:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'BTT'
              }
        },
    'Asia/Thimphu':
        {
          0:
              {
                'ts': -706341516,
                'time': '1947-08-14T18:01:24+0000',
                'offset': 19800,
                'isdst': false,
                'abbr': 'IST'
              },
          1:
              {
                'ts': 560025000,
                'time': '1987-09-30T18:30:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'BTT'
              }
        },
    'Asia/Tokyo':
        {
          0:
              {
                'ts': -1009875600,
                'time': '1937-12-31T15:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          1:
              {
                'ts': -683794800,
                'time': '1948-05-01T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'JDT'
              },
          2:
              {
                'ts': -672393600,
                'time': '1948-09-10T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          3:
              {
                'ts': -654764400,
                'time': '1949-04-02T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'JDT'
              },
          4:
              {
                'ts': -640944000,
                'time': '1949-09-09T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          5:
              {
                'ts': -620290800,
                'time': '1950-05-06T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'JDT'
              },
          6:
              {
                'ts': -609494400,
                'time': '1950-09-08T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          7:
              {
                'ts': -588841200,
                'time': '1951-05-05T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'JDT'
              },
          8:
              {
                'ts': -578044800,
                'time': '1951-09-07T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              }
        },
    'Asia/Ujung_Pandang':
        {
          0:
              {
                'ts': -1577951856,
                'time': '1919-12-31T16:02:24+0000',
                'offset': 28656,
                'isdst': false,
                'abbr': 'MMT'
              },
          1:
              {
                'ts': -1172908656,
                'time': '1932-10-31T16:02:24+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CIT'
              },
          2:
              {
                'ts': -880272000,
                'time': '1942-02-08T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          3:
              {
                'ts': -766054800,
                'time': '1945-09-22T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CIT'
              }
        },
    'Asia/Ulaanbaatar':
        {
          0:
              {
                'ts': -2032931252,
                'time': '1905-07-31T16:52:28+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'ULAT'
              },
          1:
              {
                'ts': 252435600,
                'time': '1977-12-31T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          2:
              {
                'ts': 417974400,
                'time': '1983-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          3:
              {
                'ts': 433782000,
                'time': '1983-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          4:
              {
                'ts': 449596800,
                'time': '1984-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          5:
              {
                'ts': 465318000,
                'time': '1984-09-29T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          6:
              {
                'ts': 481046400,
                'time': '1985-03-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          7:
              {
                'ts': 496767600,
                'time': '1985-09-28T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          8:
              {
                'ts': 512496000,
                'time': '1986-03-29T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          9:
              {
                'ts': 528217200,
                'time': '1986-09-27T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          10:
              {
                'ts': 543945600,
                'time': '1987-03-28T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          11:
              {
                'ts': 559666800,
                'time': '1987-09-26T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          12:
              {
                'ts': 575395200,
                'time': '1988-03-26T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          13:
              {
                'ts': 591116400,
                'time': '1988-09-24T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          14:
              {
                'ts': 606844800,
                'time': '1989-03-25T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          15:
              {
                'ts': 622566000,
                'time': '1989-09-23T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          16:
              {
                'ts': 638294400,
                'time': '1990-03-24T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          17:
              {
                'ts': 654620400,
                'time': '1990-09-29T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          18:
              {
                'ts': 670348800,
                'time': '1991-03-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          19:
              {
                'ts': 686070000,
                'time': '1991-09-28T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          20:
              {
                'ts': 701798400,
                'time': '1992-03-28T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          21:
              {
                'ts': 717519600,
                'time': '1992-09-26T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          22:
              {
                'ts': 733248000,
                'time': '1993-03-27T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          23:
              {
                'ts': 748969200,
                'time': '1993-09-25T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          24:
              {
                'ts': 764697600,
                'time': '1994-03-26T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          25:
              {
                'ts': 780418800,
                'time': '1994-09-24T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          26:
              {
                'ts': 796147200,
                'time': '1995-03-25T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          27:
              {
                'ts': 811868400,
                'time': '1995-09-23T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          28:
              {
                'ts': 828201600,
                'time': '1996-03-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          29:
              {
                'ts': 843922800,
                'time': '1996-09-28T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          30:
              {
                'ts': 859651200,
                'time': '1997-03-29T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          31:
              {
                'ts': 875372400,
                'time': '1997-09-27T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          32:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          33:
              {
                'ts': 906822000,
                'time': '1998-09-26T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          34:
              {
                'ts': 988394400,
                'time': '2001-04-27T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          35:
              {
                'ts': 1001696400,
                'time': '2001-09-28T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          36:
              {
                'ts': 1017424800,
                'time': '2002-03-29T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          37:
              {
                'ts': 1033146000,
                'time': '2002-09-27T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          38:
              {
                'ts': 1048874400,
                'time': '2003-03-28T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          39:
              {
                'ts': 1064595600,
                'time': '2003-09-26T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          40:
              {
                'ts': 1080324000,
                'time': '2004-03-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          41:
              {
                'ts': 1096045200,
                'time': '2004-09-24T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          42:
              {
                'ts': 1111773600,
                'time': '2005-03-25T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          43:
              {
                'ts': 1127494800,
                'time': '2005-09-23T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          44:
              {
                'ts': 1143223200,
                'time': '2006-03-24T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          45:
              {
                'ts': 1159549200,
                'time': '2006-09-29T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              }
        },
    'Asia/Ulan_Bator':
        {
          0:
              {
                'ts': -2032931252,
                'time': '1905-07-31T16:52:28+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'ULAT'
              },
          1:
              {
                'ts': 252435600,
                'time': '1977-12-31T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          2:
              {
                'ts': 417974400,
                'time': '1983-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          3:
              {
                'ts': 433782000,
                'time': '1983-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          4:
              {
                'ts': 449596800,
                'time': '1984-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          5:
              {
                'ts': 465318000,
                'time': '1984-09-29T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          6:
              {
                'ts': 481046400,
                'time': '1985-03-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          7:
              {
                'ts': 496767600,
                'time': '1985-09-28T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          8:
              {
                'ts': 512496000,
                'time': '1986-03-29T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          9:
              {
                'ts': 528217200,
                'time': '1986-09-27T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          10:
              {
                'ts': 543945600,
                'time': '1987-03-28T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          11:
              {
                'ts': 559666800,
                'time': '1987-09-26T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          12:
              {
                'ts': 575395200,
                'time': '1988-03-26T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          13:
              {
                'ts': 591116400,
                'time': '1988-09-24T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          14:
              {
                'ts': 606844800,
                'time': '1989-03-25T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          15:
              {
                'ts': 622566000,
                'time': '1989-09-23T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          16:
              {
                'ts': 638294400,
                'time': '1990-03-24T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          17:
              {
                'ts': 654620400,
                'time': '1990-09-29T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          18:
              {
                'ts': 670348800,
                'time': '1991-03-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          19:
              {
                'ts': 686070000,
                'time': '1991-09-28T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          20:
              {
                'ts': 701798400,
                'time': '1992-03-28T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          21:
              {
                'ts': 717519600,
                'time': '1992-09-26T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          22:
              {
                'ts': 733248000,
                'time': '1993-03-27T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          23:
              {
                'ts': 748969200,
                'time': '1993-09-25T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          24:
              {
                'ts': 764697600,
                'time': '1994-03-26T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          25:
              {
                'ts': 780418800,
                'time': '1994-09-24T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          26:
              {
                'ts': 796147200,
                'time': '1995-03-25T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          27:
              {
                'ts': 811868400,
                'time': '1995-09-23T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          28:
              {
                'ts': 828201600,
                'time': '1996-03-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          29:
              {
                'ts': 843922800,
                'time': '1996-09-28T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          30:
              {
                'ts': 859651200,
                'time': '1997-03-29T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          31:
              {
                'ts': 875372400,
                'time': '1997-09-27T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          32:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          33:
              {
                'ts': 906822000,
                'time': '1998-09-26T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          34:
              {
                'ts': 988394400,
                'time': '2001-04-27T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          35:
              {
                'ts': 1001696400,
                'time': '2001-09-28T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          36:
              {
                'ts': 1017424800,
                'time': '2002-03-29T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          37:
              {
                'ts': 1033146000,
                'time': '2002-09-27T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          38:
              {
                'ts': 1048874400,
                'time': '2003-03-28T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          39:
              {
                'ts': 1064595600,
                'time': '2003-09-26T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          40:
              {
                'ts': 1080324000,
                'time': '2004-03-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          41:
              {
                'ts': 1096045200,
                'time': '2004-09-24T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          42:
              {
                'ts': 1111773600,
                'time': '2005-03-25T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          43:
              {
                'ts': 1127494800,
                'time': '2005-09-23T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              },
          44:
              {
                'ts': 1143223200,
                'time': '2006-03-24T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'ULAST'
              },
          45:
              {
                'ts': 1159549200,
                'time': '2006-09-29T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ULAT'
              }
        },
    'Asia/Urumqi':
        {
          0:
              {
                'ts': -1325483420,
                'time': '1927-12-31T18:09:40+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'URUT'
              },
          1:
              {
                'ts': 325965600,
                'time': '1980-04-30T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': 515520000,
                'time': '1986-05-03T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': 527007600,
                'time': '1986-09-13T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': 545155200,
                'time': '1987-04-11T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': 558457200,
                'time': '1987-09-12T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': 576604800,
                'time': '1988-04-09T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': 589906800,
                'time': '1988-09-10T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': 608659200,
                'time': '1989-04-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          9:
              {
                'ts': 621961200,
                'time': '1989-09-16T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': 640108800,
                'time': '1990-04-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          11:
              {
                'ts': 653410800,
                'time': '1990-09-15T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': 671558400,
                'time': '1991-04-13T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          13:
              {
                'ts': 684860400,
                'time': '1991-09-14T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Asia/Vientiane':
        {
          0:
              {
                'ts': -2005973424,
                'time': '1906-06-08T17:09:36+0000',
                'offset': 25580,
                'isdst': false,
                'abbr': 'SMT'
              },
          1:
              {
                'ts': -1855983920,
                'time': '1911-03-10T16:54:40+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'ICT'
              },
          2:
              {
                'ts': -1819954800,
                'time': '1912-04-30T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'ICT'
              },
          3:
              {
                'ts': -1220428800,
                'time': '1931-04-30T16:00:00+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'ICT'
              }
        },
    'Asia/Vladivostok':
        {
          0:
              {
                'ts': -1487321264,
                'time': '1922-11-14T15:12:16+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'VLAT'
              },
          1:
              {
                'ts': -1247562000,
                'time': '1930-06-20T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          2:
              {
                'ts': 354895200,
                'time': '1981-03-31T14:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          3:
              {
                'ts': 370702800,
                'time': '1981-09-30T13:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          4:
              {
                'ts': 386431200,
                'time': '1982-03-31T14:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          5:
              {
                'ts': 402238800,
                'time': '1982-09-30T13:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          6:
              {
                'ts': 417967200,
                'time': '1983-03-31T14:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          7:
              {
                'ts': 433774800,
                'time': '1983-09-30T13:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          8:
              {
                'ts': 449589600,
                'time': '1984-03-31T14:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          9:
              {
                'ts': 465321600,
                'time': '1984-09-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          10:
              {
                'ts': 481046400,
                'time': '1985-03-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          11:
              {
                'ts': 496771200,
                'time': '1985-09-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          12:
              {
                'ts': 512496000,
                'time': '1986-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          13:
              {
                'ts': 528220800,
                'time': '1986-09-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          14:
              {
                'ts': 543945600,
                'time': '1987-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          15:
              {
                'ts': 559670400,
                'time': '1987-09-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          16:
              {
                'ts': 575395200,
                'time': '1988-03-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          17:
              {
                'ts': 591120000,
                'time': '1988-09-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          18:
              {
                'ts': 606844800,
                'time': '1989-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          19:
              {
                'ts': 622569600,
                'time': '1989-09-23T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          20:
              {
                'ts': 638294400,
                'time': '1990-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          21:
              {
                'ts': 654624000,
                'time': '1990-09-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          22:
              {
                'ts': 670348800,
                'time': '1991-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'VLASST'
              },
          23:
              {
                'ts': 686077200,
                'time': '1991-09-28T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'VLAST'
              },
          24:
              {
                'ts': 695754000,
                'time': '1992-01-18T17:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          25:
              {
                'ts': 701787600,
                'time': '1992-03-28T13:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          26:
              {
                'ts': 717508800,
                'time': '1992-09-26T12:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          27:
              {
                'ts': 733248000,
                'time': '1993-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          28:
              {
                'ts': 748972800,
                'time': '1993-09-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          29:
              {
                'ts': 764697600,
                'time': '1994-03-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          30:
              {
                'ts': 780422400,
                'time': '1994-09-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          31:
              {
                'ts': 796147200,
                'time': '1995-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          32:
              {
                'ts': 811872000,
                'time': '1995-09-23T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          33:
              {
                'ts': 828201600,
                'time': '1996-03-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          34:
              {
                'ts': 846345600,
                'time': '1996-10-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          35:
              {
                'ts': 859651200,
                'time': '1997-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          36:
              {
                'ts': 877795200,
                'time': '1997-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          37:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          38:
              {
                'ts': 909244800,
                'time': '1998-10-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          39:
              {
                'ts': 922550400,
                'time': '1999-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          40:
              {
                'ts': 941299200,
                'time': '1999-10-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          41:
              {
                'ts': 954000000,
                'time': '2000-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          42:
              {
                'ts': 972748800,
                'time': '2000-10-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          43:
              {
                'ts': 985449600,
                'time': '2001-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          44:
              {
                'ts': 1004198400,
                'time': '2001-10-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          45:
              {
                'ts': 1017504000,
                'time': '2002-03-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          46:
              {
                'ts': 1035648000,
                'time': '2002-10-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          47:
              {
                'ts': 1048953600,
                'time': '2003-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          48:
              {
                'ts': 1067097600,
                'time': '2003-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          49:
              {
                'ts': 1080403200,
                'time': '2004-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          50:
              {
                'ts': 1099152000,
                'time': '2004-10-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          51:
              {
                'ts': 1111852800,
                'time': '2005-03-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          52:
              {
                'ts': 1130601600,
                'time': '2005-10-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          53:
              {
                'ts': 1143302400,
                'time': '2006-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          54:
              {
                'ts': 1162051200,
                'time': '2006-10-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          55:
              {
                'ts': 1174752000,
                'time': '2007-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          56:
              {
                'ts': 1193500800,
                'time': '2007-10-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          57:
              {
                'ts': 1206806400,
                'time': '2008-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          58:
              {
                'ts': 1224950400,
                'time': '2008-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          59:
              {
                'ts': 1238256000,
                'time': '2009-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          60:
              {
                'ts': 1256400000,
                'time': '2009-10-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          61:
              {
                'ts': 1269705600,
                'time': '2010-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          62:
              {
                'ts': 1288454400,
                'time': '2010-10-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          63:
              {
                'ts': 1301155200,
                'time': '2011-03-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          64:
              {
                'ts': 1319904000,
                'time': '2011-10-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          65:
              {
                'ts': 1332604800,
                'time': '2012-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          66:
              {
                'ts': 1351353600,
                'time': '2012-10-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          67:
              {
                'ts': 1364659200,
                'time': '2013-03-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          68:
              {
                'ts': 1382803200,
                'time': '2013-10-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          69:
              {
                'ts': 1396108800,
                'time': '2014-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          70:
              {
                'ts': 1414252800,
                'time': '2014-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          71:
              {
                'ts': 1427558400,
                'time': '2015-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          72:
              {
                'ts': 1445702400,
                'time': '2015-10-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          73:
              {
                'ts': 1459008000,
                'time': '2016-03-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          74:
              {
                'ts': 1477756800,
                'time': '2016-10-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          75:
              {
                'ts': 1490457600,
                'time': '2017-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          76:
              {
                'ts': 1509206400,
                'time': '2017-10-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          77:
              {
                'ts': 1521907200,
                'time': '2018-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          78:
              {
                'ts': 1540656000,
                'time': '2018-10-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          79:
              {
                'ts': 1553961600,
                'time': '2019-03-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          80:
              {
                'ts': 1572105600,
                'time': '2019-10-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          81:
              {
                'ts': 1585411200,
                'time': '2020-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          82:
              {
                'ts': 1603555200,
                'time': '2020-10-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          83:
              {
                'ts': 1616860800,
                'time': '2021-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          84:
              {
                'ts': 1635609600,
                'time': '2021-10-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          85:
              {
                'ts': 1648310400,
                'time': '2022-03-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          86:
              {
                'ts': 1667059200,
                'time': '2022-10-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          87:
              {
                'ts': 1679760000,
                'time': '2023-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          88:
              {
                'ts': 1698508800,
                'time': '2023-10-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          89:
              {
                'ts': 1711814400,
                'time': '2024-03-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          90:
              {
                'ts': 1729958400,
                'time': '2024-10-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          91:
              {
                'ts': 1743264000,
                'time': '2025-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          92:
              {
                'ts': 1761408000,
                'time': '2025-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          93:
              {
                'ts': 1774713600,
                'time': '2026-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          94:
              {
                'ts': 1792857600,
                'time': '2026-10-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          95:
              {
                'ts': 1806163200,
                'time': '2027-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          96:
              {
                'ts': 1824912000,
                'time': '2027-10-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          97:
              {
                'ts': 1837612800,
                'time': '2028-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          98:
              {
                'ts': 1856361600,
                'time': '2028-10-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          99:
              {
                'ts': 1869062400,
                'time': '2029-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          100:
              {
                'ts': 1887811200,
                'time': '2029-10-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          101:
              {
                'ts': 1901116800,
                'time': '2030-03-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          102:
              {
                'ts': 1919260800,
                'time': '2030-10-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          103:
              {
                'ts': 1932566400,
                'time': '2031-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          104:
              {
                'ts': 1950710400,
                'time': '2031-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          105:
              {
                'ts': 1964016000,
                'time': '2032-03-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          106:
              {
                'ts': 1982764800,
                'time': '2032-10-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          107:
              {
                'ts': 1995465600,
                'time': '2033-03-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          108:
              {
                'ts': 2014214400,
                'time': '2033-10-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          109:
              {
                'ts': 2026915200,
                'time': '2034-03-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          110:
              {
                'ts': 2045664000,
                'time': '2034-10-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          111:
              {
                'ts': 2058364800,
                'time': '2035-03-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          112:
              {
                'ts': 2077113600,
                'time': '2035-10-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          113:
              {
                'ts': 2090419200,
                'time': '2036-03-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          114:
              {
                'ts': 2108563200,
                'time': '2036-10-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              },
          115:
              {
                'ts': 2121868800,
                'time': '2037-03-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'VLAST'
              },
          116:
              {
                'ts': 2140012800,
                'time': '2037-10-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'VLAT'
              }
        },
    'Asia/Yakutsk':
        {
          0:
              {
                'ts': -1579423120,
                'time': '1919-12-14T15:21:20+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'YAKT'
              },
          1:
              {
                'ts': -1247558400,
                'time': '1930-06-20T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          2:
              {
                'ts': 354898800,
                'time': '1981-03-31T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          3:
              {
                'ts': 370706400,
                'time': '1981-09-30T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          4:
              {
                'ts': 386434800,
                'time': '1982-03-31T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          5:
              {
                'ts': 402242400,
                'time': '1982-09-30T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          6:
              {
                'ts': 417970800,
                'time': '1983-03-31T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          7:
              {
                'ts': 433778400,
                'time': '1983-09-30T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          8:
              {
                'ts': 449593200,
                'time': '1984-03-31T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          9:
              {
                'ts': 465325200,
                'time': '1984-09-29T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          10:
              {
                'ts': 481050000,
                'time': '1985-03-30T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          11:
              {
                'ts': 496774800,
                'time': '1985-09-28T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          12:
              {
                'ts': 512499600,
                'time': '1986-03-29T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          13:
              {
                'ts': 528224400,
                'time': '1986-09-27T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          14:
              {
                'ts': 543949200,
                'time': '1987-03-28T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          15:
              {
                'ts': 559674000,
                'time': '1987-09-26T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          16:
              {
                'ts': 575398800,
                'time': '1988-03-26T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          17:
              {
                'ts': 591123600,
                'time': '1988-09-24T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          18:
              {
                'ts': 606848400,
                'time': '1989-03-25T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          19:
              {
                'ts': 622573200,
                'time': '1989-09-23T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          20:
              {
                'ts': 638298000,
                'time': '1990-03-24T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          21:
              {
                'ts': 654627600,
                'time': '1990-09-29T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          22:
              {
                'ts': 670352400,
                'time': '1991-03-30T17:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'YAKST'
              },
          23:
              {
                'ts': 686080800,
                'time': '1991-09-28T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'YAKT'
              },
          24:
              {
                'ts': 695757600,
                'time': '1992-01-18T18:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          25:
              {
                'ts': 701791200,
                'time': '1992-03-28T14:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          26:
              {
                'ts': 717512400,
                'time': '1992-09-26T13:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          27:
              {
                'ts': 733251600,
                'time': '1993-03-27T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          28:
              {
                'ts': 748976400,
                'time': '1993-09-25T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          29:
              {
                'ts': 764701200,
                'time': '1994-03-26T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          30:
              {
                'ts': 780426000,
                'time': '1994-09-24T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          31:
              {
                'ts': 796150800,
                'time': '1995-03-25T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          32:
              {
                'ts': 811875600,
                'time': '1995-09-23T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          33:
              {
                'ts': 828205200,
                'time': '1996-03-30T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          34:
              {
                'ts': 846349200,
                'time': '1996-10-26T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          35:
              {
                'ts': 859654800,
                'time': '1997-03-29T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          36:
              {
                'ts': 877798800,
                'time': '1997-10-25T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          37:
              {
                'ts': 891104400,
                'time': '1998-03-28T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          38:
              {
                'ts': 909248400,
                'time': '1998-10-24T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          39:
              {
                'ts': 922554000,
                'time': '1999-03-27T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          40:
              {
                'ts': 941302800,
                'time': '1999-10-30T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          41:
              {
                'ts': 954003600,
                'time': '2000-03-25T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          42:
              {
                'ts': 972752400,
                'time': '2000-10-28T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          43:
              {
                'ts': 985453200,
                'time': '2001-03-24T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          44:
              {
                'ts': 1004202000,
                'time': '2001-10-27T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          45:
              {
                'ts': 1017507600,
                'time': '2002-03-30T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          46:
              {
                'ts': 1035651600,
                'time': '2002-10-26T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          47:
              {
                'ts': 1048957200,
                'time': '2003-03-29T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          48:
              {
                'ts': 1067101200,
                'time': '2003-10-25T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          49:
              {
                'ts': 1080406800,
                'time': '2004-03-27T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          50:
              {
                'ts': 1099155600,
                'time': '2004-10-30T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          51:
              {
                'ts': 1111856400,
                'time': '2005-03-26T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          52:
              {
                'ts': 1130605200,
                'time': '2005-10-29T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          53:
              {
                'ts': 1143306000,
                'time': '2006-03-25T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          54:
              {
                'ts': 1162054800,
                'time': '2006-10-28T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          55:
              {
                'ts': 1174755600,
                'time': '2007-03-24T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          56:
              {
                'ts': 1193504400,
                'time': '2007-10-27T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          57:
              {
                'ts': 1206810000,
                'time': '2008-03-29T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          58:
              {
                'ts': 1224954000,
                'time': '2008-10-25T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          59:
              {
                'ts': 1238259600,
                'time': '2009-03-28T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          60:
              {
                'ts': 1256403600,
                'time': '2009-10-24T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          61:
              {
                'ts': 1269709200,
                'time': '2010-03-27T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          62:
              {
                'ts': 1288458000,
                'time': '2010-10-30T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          63:
              {
                'ts': 1301158800,
                'time': '2011-03-26T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          64:
              {
                'ts': 1319907600,
                'time': '2011-10-29T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          65:
              {
                'ts': 1332608400,
                'time': '2012-03-24T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          66:
              {
                'ts': 1351357200,
                'time': '2012-10-27T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          67:
              {
                'ts': 1364662800,
                'time': '2013-03-30T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          68:
              {
                'ts': 1382806800,
                'time': '2013-10-26T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          69:
              {
                'ts': 1396112400,
                'time': '2014-03-29T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          70:
              {
                'ts': 1414256400,
                'time': '2014-10-25T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          71:
              {
                'ts': 1427562000,
                'time': '2015-03-28T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          72:
              {
                'ts': 1445706000,
                'time': '2015-10-24T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          73:
              {
                'ts': 1459011600,
                'time': '2016-03-26T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          74:
              {
                'ts': 1477760400,
                'time': '2016-10-29T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          75:
              {
                'ts': 1490461200,
                'time': '2017-03-25T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          76:
              {
                'ts': 1509210000,
                'time': '2017-10-28T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          77:
              {
                'ts': 1521910800,
                'time': '2018-03-24T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          78:
              {
                'ts': 1540659600,
                'time': '2018-10-27T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          79:
              {
                'ts': 1553965200,
                'time': '2019-03-30T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          80:
              {
                'ts': 1572109200,
                'time': '2019-10-26T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          81:
              {
                'ts': 1585414800,
                'time': '2020-03-28T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          82:
              {
                'ts': 1603558800,
                'time': '2020-10-24T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          83:
              {
                'ts': 1616864400,
                'time': '2021-03-27T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          84:
              {
                'ts': 1635613200,
                'time': '2021-10-30T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          85:
              {
                'ts': 1648314000,
                'time': '2022-03-26T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          86:
              {
                'ts': 1667062800,
                'time': '2022-10-29T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          87:
              {
                'ts': 1679763600,
                'time': '2023-03-25T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          88:
              {
                'ts': 1698512400,
                'time': '2023-10-28T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          89:
              {
                'ts': 1711818000,
                'time': '2024-03-30T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          90:
              {
                'ts': 1729962000,
                'time': '2024-10-26T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          91:
              {
                'ts': 1743267600,
                'time': '2025-03-29T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          92:
              {
                'ts': 1761411600,
                'time': '2025-10-25T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          93:
              {
                'ts': 1774717200,
                'time': '2026-03-28T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          94:
              {
                'ts': 1792861200,
                'time': '2026-10-24T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          95:
              {
                'ts': 1806166800,
                'time': '2027-03-27T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          96:
              {
                'ts': 1824915600,
                'time': '2027-10-30T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          97:
              {
                'ts': 1837616400,
                'time': '2028-03-25T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          98:
              {
                'ts': 1856365200,
                'time': '2028-10-28T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          99:
              {
                'ts': 1869066000,
                'time': '2029-03-24T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          100:
              {
                'ts': 1887814800,
                'time': '2029-10-27T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          101:
              {
                'ts': 1901120400,
                'time': '2030-03-30T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          102:
              {
                'ts': 1919264400,
                'time': '2030-10-26T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          103:
              {
                'ts': 1932570000,
                'time': '2031-03-29T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          104:
              {
                'ts': 1950714000,
                'time': '2031-10-25T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          105:
              {
                'ts': 1964019600,
                'time': '2032-03-27T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          106:
              {
                'ts': 1982768400,
                'time': '2032-10-30T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          107:
              {
                'ts': 1995469200,
                'time': '2033-03-26T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          108:
              {
                'ts': 2014218000,
                'time': '2033-10-29T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          109:
              {
                'ts': 2026918800,
                'time': '2034-03-25T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          110:
              {
                'ts': 2045667600,
                'time': '2034-10-28T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          111:
              {
                'ts': 2058368400,
                'time': '2035-03-24T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          112:
              {
                'ts': 2077117200,
                'time': '2035-10-27T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          113:
              {
                'ts': 2090422800,
                'time': '2036-03-29T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          114:
              {
                'ts': 2108566800,
                'time': '2036-10-25T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              },
          115:
              {
                'ts': 2121872400,
                'time': '2037-03-28T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'YAKST'
              },
          116:
              {
                'ts': 2140016400,
                'time': '2037-10-24T17:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'YAKT'
              }
        },
    'Asia/Yekaterinburg':
        {
          0:
              {
                'ts': -1592611344,
                'time': '1919-07-14T23:57:36+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SVET'
              },
          1:
              {
                'ts': -1247544000,
                'time': '1930-06-20T20:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SVET'
              },
          2:
              {
                'ts': 354913200,
                'time': '1981-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SVEST'
              },
          3:
              {
                'ts': 370720800,
                'time': '1981-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SVET'
              },
          4:
              {
                'ts': 386449200,
                'time': '1982-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SVEST'
              },
          5:
              {
                'ts': 402256800,
                'time': '1982-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SVET'
              },
          6:
              {
                'ts': 417985200,
                'time': '1983-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SVEST'
              },
          7:
              {
                'ts': 433792800,
                'time': '1983-09-30T18:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SVET'
              },
          8:
              {
                'ts': 449607600,
                'time': '1984-03-31T19:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SVEST'
              },
          9:
              {
                'ts': 465339600,
                'time': '1984-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SVET'
              },
          10:
              {
                'ts': 481064400,
                'time': '1985-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SVEST'
              },
          11:
              {
                'ts': 496789200,
                'time': '1985-09-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SVET'
              },
          12:
              {
                'ts': 512514000,
                'time': '1986-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SVEST'
              },
          13:
              {
                'ts': 528238800,
                'time': '1986-09-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SVET'
              },
          14:
              {
                'ts': 543963600,
                'time': '1987-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SVEST'
              },
          15:
              {
                'ts': 559688400,
                'time': '1987-09-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SVET'
              },
          16:
              {
                'ts': 575413200,
                'time': '1988-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SVEST'
              },
          17:
              {
                'ts': 591138000,
                'time': '1988-09-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SVET'
              },
          18:
              {
                'ts': 606862800,
                'time': '1989-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SVEST'
              },
          19:
              {
                'ts': 622587600,
                'time': '1989-09-23T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SVET'
              },
          20:
              {
                'ts': 638312400,
                'time': '1990-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'SVEST'
              },
          21:
              {
                'ts': 654642000,
                'time': '1990-09-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'SVET'
              },
          22:
              {
                'ts': 670366800,
                'time': '1991-03-30T21:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SVEST'
              },
          23:
              {
                'ts': 686095200,
                'time': '1991-09-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SVET'
              },
          24:
              {
                'ts': 695772000,
                'time': '1992-01-18T22:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          25:
              {
                'ts': 701805600,
                'time': '1992-03-28T18:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          26:
              {
                'ts': 717526800,
                'time': '1992-09-26T17:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          27:
              {
                'ts': 733266000,
                'time': '1993-03-27T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          28:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          29:
              {
                'ts': 764715600,
                'time': '1994-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          30:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          31:
              {
                'ts': 796165200,
                'time': '1995-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          32:
              {
                'ts': 811890000,
                'time': '1995-09-23T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          33:
              {
                'ts': 828219600,
                'time': '1996-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          34:
              {
                'ts': 846363600,
                'time': '1996-10-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          35:
              {
                'ts': 859669200,
                'time': '1997-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          36:
              {
                'ts': 877813200,
                'time': '1997-10-25T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          37:
              {
                'ts': 891118800,
                'time': '1998-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          38:
              {
                'ts': 909262800,
                'time': '1998-10-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          39:
              {
                'ts': 922568400,
                'time': '1999-03-27T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          40:
              {
                'ts': 941317200,
                'time': '1999-10-30T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          41:
              {
                'ts': 954018000,
                'time': '2000-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          42:
              {
                'ts': 972766800,
                'time': '2000-10-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          43:
              {
                'ts': 985467600,
                'time': '2001-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          44:
              {
                'ts': 1004216400,
                'time': '2001-10-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          45:
              {
                'ts': 1017522000,
                'time': '2002-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          46:
              {
                'ts': 1035666000,
                'time': '2002-10-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          47:
              {
                'ts': 1048971600,
                'time': '2003-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          48:
              {
                'ts': 1067115600,
                'time': '2003-10-25T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          49:
              {
                'ts': 1080421200,
                'time': '2004-03-27T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          50:
              {
                'ts': 1099170000,
                'time': '2004-10-30T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          51:
              {
                'ts': 1111870800,
                'time': '2005-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          52:
              {
                'ts': 1130619600,
                'time': '2005-10-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          53:
              {
                'ts': 1143320400,
                'time': '2006-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          54:
              {
                'ts': 1162069200,
                'time': '2006-10-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          55:
              {
                'ts': 1174770000,
                'time': '2007-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          56:
              {
                'ts': 1193518800,
                'time': '2007-10-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          57:
              {
                'ts': 1206824400,
                'time': '2008-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          58:
              {
                'ts': 1224968400,
                'time': '2008-10-25T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          59:
              {
                'ts': 1238274000,
                'time': '2009-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          60:
              {
                'ts': 1256418000,
                'time': '2009-10-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          61:
              {
                'ts': 1269723600,
                'time': '2010-03-27T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          62:
              {
                'ts': 1288472400,
                'time': '2010-10-30T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          63:
              {
                'ts': 1301173200,
                'time': '2011-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          64:
              {
                'ts': 1319922000,
                'time': '2011-10-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          65:
              {
                'ts': 1332622800,
                'time': '2012-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          66:
              {
                'ts': 1351371600,
                'time': '2012-10-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          67:
              {
                'ts': 1364677200,
                'time': '2013-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          68:
              {
                'ts': 1382821200,
                'time': '2013-10-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          69:
              {
                'ts': 1396126800,
                'time': '2014-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          70:
              {
                'ts': 1414270800,
                'time': '2014-10-25T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          71:
              {
                'ts': 1427576400,
                'time': '2015-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          72:
              {
                'ts': 1445720400,
                'time': '2015-10-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          73:
              {
                'ts': 1459026000,
                'time': '2016-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          74:
              {
                'ts': 1477774800,
                'time': '2016-10-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          75:
              {
                'ts': 1490475600,
                'time': '2017-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          76:
              {
                'ts': 1509224400,
                'time': '2017-10-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          77:
              {
                'ts': 1521925200,
                'time': '2018-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          78:
              {
                'ts': 1540674000,
                'time': '2018-10-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          79:
              {
                'ts': 1553979600,
                'time': '2019-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          80:
              {
                'ts': 1572123600,
                'time': '2019-10-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          81:
              {
                'ts': 1585429200,
                'time': '2020-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          82:
              {
                'ts': 1603573200,
                'time': '2020-10-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          83:
              {
                'ts': 1616878800,
                'time': '2021-03-27T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          84:
              {
                'ts': 1635627600,
                'time': '2021-10-30T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          85:
              {
                'ts': 1648328400,
                'time': '2022-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          86:
              {
                'ts': 1667077200,
                'time': '2022-10-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          87:
              {
                'ts': 1679778000,
                'time': '2023-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          88:
              {
                'ts': 1698526800,
                'time': '2023-10-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          89:
              {
                'ts': 1711832400,
                'time': '2024-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          90:
              {
                'ts': 1729976400,
                'time': '2024-10-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          91:
              {
                'ts': 1743282000,
                'time': '2025-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          92:
              {
                'ts': 1761426000,
                'time': '2025-10-25T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          93:
              {
                'ts': 1774731600,
                'time': '2026-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          94:
              {
                'ts': 1792875600,
                'time': '2026-10-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          95:
              {
                'ts': 1806181200,
                'time': '2027-03-27T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          96:
              {
                'ts': 1824930000,
                'time': '2027-10-30T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          97:
              {
                'ts': 1837630800,
                'time': '2028-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          98:
              {
                'ts': 1856379600,
                'time': '2028-10-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          99:
              {
                'ts': 1869080400,
                'time': '2029-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          100:
              {
                'ts': 1887829200,
                'time': '2029-10-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          101:
              {
                'ts': 1901134800,
                'time': '2030-03-30T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          102:
              {
                'ts': 1919278800,
                'time': '2030-10-26T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          103:
              {
                'ts': 1932584400,
                'time': '2031-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          104:
              {
                'ts': 1950728400,
                'time': '2031-10-25T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          105:
              {
                'ts': 1964034000,
                'time': '2032-03-27T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          106:
              {
                'ts': 1982782800,
                'time': '2032-10-30T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          107:
              {
                'ts': 1995483600,
                'time': '2033-03-26T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          108:
              {
                'ts': 2014232400,
                'time': '2033-10-29T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          109:
              {
                'ts': 2026933200,
                'time': '2034-03-25T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          110:
              {
                'ts': 2045682000,
                'time': '2034-10-28T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          111:
              {
                'ts': 2058382800,
                'time': '2035-03-24T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          112:
              {
                'ts': 2077131600,
                'time': '2035-10-27T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          113:
              {
                'ts': 2090437200,
                'time': '2036-03-29T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          114:
              {
                'ts': 2108581200,
                'time': '2036-10-25T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              },
          115:
              {
                'ts': 2121886800,
                'time': '2037-03-28T21:00:00+0000',
                'offset': 21600,
                'isdst': true,
                'abbr': 'YEKST'
              },
          116:
              {
                'ts': 2140030800,
                'time': '2037-10-24T21:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'YEKT'
              }
        },
    'Asia/Yerevan':
        {
          0:
              {
                'ts': -1441162680,
                'time': '1924-05-01T21:02:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'YERT'
              },
          1:
              {
                'ts': -405140400,
                'time': '1957-02-28T21:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'YERT'
              },
          2:
              {
                'ts': 354916800,
                'time': '1981-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'YERST'
              },
          3:
              {
                'ts': 370724400,
                'time': '1981-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'YERT'
              },
          4:
              {
                'ts': 386452800,
                'time': '1982-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'YERST'
              },
          5:
              {
                'ts': 402260400,
                'time': '1982-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'YERT'
              },
          6:
              {
                'ts': 417988800,
                'time': '1983-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'YERST'
              },
          7:
              {
                'ts': 433796400,
                'time': '1983-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'YERT'
              },
          8:
              {
                'ts': 449611200,
                'time': '1984-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'YERST'
              },
          9:
              {
                'ts': 465343200,
                'time': '1984-09-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'YERT'
              },
          10:
              {
                'ts': 481068000,
                'time': '1985-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'YERST'
              },
          11:
              {
                'ts': 496792800,
                'time': '1985-09-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'YERT'
              },
          12:
              {
                'ts': 512517600,
                'time': '1986-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'YERST'
              },
          13:
              {
                'ts': 528242400,
                'time': '1986-09-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'YERT'
              },
          14:
              {
                'ts': 543967200,
                'time': '1987-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'YERST'
              },
          15:
              {
                'ts': 559692000,
                'time': '1987-09-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'YERT'
              },
          16:
              {
                'ts': 575416800,
                'time': '1988-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'YERST'
              },
          17:
              {
                'ts': 591141600,
                'time': '1988-09-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'YERT'
              },
          18:
              {
                'ts': 606866400,
                'time': '1989-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'YERST'
              },
          19:
              {
                'ts': 622591200,
                'time': '1989-09-23T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'YERT'
              },
          20:
              {
                'ts': 638316000,
                'time': '1990-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'YERST'
              },
          21:
              {
                'ts': 654645600,
                'time': '1990-09-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'YERT'
              },
          22:
              {
                'ts': 670370400,
                'time': '1991-03-30T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'YERST'
              },
          23:
              {
                'ts': 685569600,
                'time': '1991-09-22T20:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'AMST'
              },
          24:
              {
                'ts': 686098800,
                'time': '1991-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AMT'
              },
          25:
              {
                'ts': 701812800,
                'time': '1992-03-28T20:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'AMST'
              },
          26:
              {
                'ts': 717534000,
                'time': '1992-09-26T19:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AMT'
              },
          27:
              {
                'ts': 733273200,
                'time': '1993-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'AMST'
              },
          28:
              {
                'ts': 748998000,
                'time': '1993-09-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AMT'
              },
          29:
              {
                'ts': 764722800,
                'time': '1994-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'AMST'
              },
          30:
              {
                'ts': 780447600,
                'time': '1994-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'AMT'
              },
          31:
              {
                'ts': 796172400,
                'time': '1995-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'AMST'
              },
          32:
              {
                'ts': 811897200,
                'time': '1995-09-23T23:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          33:
              {
                'ts': 852062400,
                'time': '1996-12-31T20:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          34:
              {
                'ts': 859672800,
                'time': '1997-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          35:
              {
                'ts': 877816800,
                'time': '1997-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          36:
              {
                'ts': 891122400,
                'time': '1998-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          37:
              {
                'ts': 909266400,
                'time': '1998-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          38:
              {
                'ts': 922572000,
                'time': '1999-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          39:
              {
                'ts': 941320800,
                'time': '1999-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          40:
              {
                'ts': 954021600,
                'time': '2000-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          41:
              {
                'ts': 972770400,
                'time': '2000-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          42:
              {
                'ts': 985471200,
                'time': '2001-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          43:
              {
                'ts': 1004220000,
                'time': '2001-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          44:
              {
                'ts': 1017525600,
                'time': '2002-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          45:
              {
                'ts': 1035669600,
                'time': '2002-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          46:
              {
                'ts': 1048975200,
                'time': '2003-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          47:
              {
                'ts': 1067119200,
                'time': '2003-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          48:
              {
                'ts': 1080424800,
                'time': '2004-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          49:
              {
                'ts': 1099173600,
                'time': '2004-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          50:
              {
                'ts': 1111874400,
                'time': '2005-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          51:
              {
                'ts': 1130623200,
                'time': '2005-10-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          52:
              {
                'ts': 1143324000,
                'time': '2006-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          53:
              {
                'ts': 1162072800,
                'time': '2006-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          54:
              {
                'ts': 1174773600,
                'time': '2007-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          55:
              {
                'ts': 1193522400,
                'time': '2007-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          56:
              {
                'ts': 1206828000,
                'time': '2008-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          57:
              {
                'ts': 1224972000,
                'time': '2008-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          58:
              {
                'ts': 1238277600,
                'time': '2009-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          59:
              {
                'ts': 1256421600,
                'time': '2009-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          60:
              {
                'ts': 1269727200,
                'time': '2010-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          61:
              {
                'ts': 1288476000,
                'time': '2010-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          62:
              {
                'ts': 1301176800,
                'time': '2011-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          63:
              {
                'ts': 1319925600,
                'time': '2011-10-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          64:
              {
                'ts': 1332626400,
                'time': '2012-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          65:
              {
                'ts': 1351375200,
                'time': '2012-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          66:
              {
                'ts': 1364680800,
                'time': '2013-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          67:
              {
                'ts': 1382824800,
                'time': '2013-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          68:
              {
                'ts': 1396130400,
                'time': '2014-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          69:
              {
                'ts': 1414274400,
                'time': '2014-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          70:
              {
                'ts': 1427580000,
                'time': '2015-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          71:
              {
                'ts': 1445724000,
                'time': '2015-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          72:
              {
                'ts': 1459029600,
                'time': '2016-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          73:
              {
                'ts': 1477778400,
                'time': '2016-10-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          74:
              {
                'ts': 1490479200,
                'time': '2017-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          75:
              {
                'ts': 1509228000,
                'time': '2017-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          76:
              {
                'ts': 1521928800,
                'time': '2018-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          77:
              {
                'ts': 1540677600,
                'time': '2018-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          78:
              {
                'ts': 1553983200,
                'time': '2019-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          79:
              {
                'ts': 1572127200,
                'time': '2019-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          80:
              {
                'ts': 1585432800,
                'time': '2020-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          81:
              {
                'ts': 1603576800,
                'time': '2020-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          82:
              {
                'ts': 1616882400,
                'time': '2021-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          83:
              {
                'ts': 1635631200,
                'time': '2021-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          84:
              {
                'ts': 1648332000,
                'time': '2022-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          85:
              {
                'ts': 1667080800,
                'time': '2022-10-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          86:
              {
                'ts': 1679781600,
                'time': '2023-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          87:
              {
                'ts': 1698530400,
                'time': '2023-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          88:
              {
                'ts': 1711836000,
                'time': '2024-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          89:
              {
                'ts': 1729980000,
                'time': '2024-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          90:
              {
                'ts': 1743285600,
                'time': '2025-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          91:
              {
                'ts': 1761429600,
                'time': '2025-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          92:
              {
                'ts': 1774735200,
                'time': '2026-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          93:
              {
                'ts': 1792879200,
                'time': '2026-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          94:
              {
                'ts': 1806184800,
                'time': '2027-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          95:
              {
                'ts': 1824933600,
                'time': '2027-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          96:
              {
                'ts': 1837634400,
                'time': '2028-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          97:
              {
                'ts': 1856383200,
                'time': '2028-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          98:
              {
                'ts': 1869084000,
                'time': '2029-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          99:
              {
                'ts': 1887832800,
                'time': '2029-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          100:
              {
                'ts': 1901138400,
                'time': '2030-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          101:
              {
                'ts': 1919282400,
                'time': '2030-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          102:
              {
                'ts': 1932588000,
                'time': '2031-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          103:
              {
                'ts': 1950732000,
                'time': '2031-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          104:
              {
                'ts': 1964037600,
                'time': '2032-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          105:
              {
                'ts': 1982786400,
                'time': '2032-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          106:
              {
                'ts': 1995487200,
                'time': '2033-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          107:
              {
                'ts': 2014236000,
                'time': '2033-10-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          108:
              {
                'ts': 2026936800,
                'time': '2034-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          109:
              {
                'ts': 2045685600,
                'time': '2034-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          110:
              {
                'ts': 2058386400,
                'time': '2035-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          111:
              {
                'ts': 2077135200,
                'time': '2035-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          112:
              {
                'ts': 2090440800,
                'time': '2036-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          113:
              {
                'ts': 2108584800,
                'time': '2036-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          114:
              {
                'ts': 2121890400,
                'time': '2037-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'AMST'
              },
          115:
              {
                'ts': 2140034400,
                'time': '2037-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'AMT'
              }
        },
    'Atlantic/Azores':
        {
          0:
              {
                'ts': -1849557928,
                'time': '1911-05-24T01:54:32+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          1:
              {
                'ts': -1689548400,
                'time': '1916-06-18T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          2:
              {
                'ts': -1677794400,
                'time': '1916-11-01T02:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          3:
              {
                'ts': -1667430000,
                'time': '1917-03-01T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          4:
              {
                'ts': -1647730800,
                'time': '1917-10-15T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          5:
              {
                'ts': -1635807600,
                'time': '1918-03-02T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          6:
              {
                'ts': -1616194800,
                'time': '1918-10-15T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          7:
              {
                'ts': -1604358000,
                'time': '1919-03-01T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          8:
              {
                'ts': -1584658800,
                'time': '1919-10-15T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          9:
              {
                'ts': -1572735600,
                'time': '1920-03-01T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          10:
              {
                'ts': -1553036400,
                'time': '1920-10-15T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          11:
              {
                'ts': -1541199600,
                'time': '1921-03-01T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          12:
              {
                'ts': -1521500400,
                'time': '1921-10-15T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          13:
              {
                'ts': -1442444400,
                'time': '1924-04-17T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          14:
              {
                'ts': -1426806000,
                'time': '1924-10-15T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          15:
              {
                'ts': -1379286000,
                'time': '1926-04-18T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          16:
              {
                'ts': -1364770800,
                'time': '1926-10-03T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          17:
              {
                'ts': -1348441200,
                'time': '1927-04-10T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          18:
              {
                'ts': -1333321200,
                'time': '1927-10-02T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          19:
              {
                'ts': -1316386800,
                'time': '1928-04-15T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          20:
              {
                'ts': -1301266800,
                'time': '1928-10-07T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          21:
              {
                'ts': -1284332400,
                'time': '1929-04-21T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          22:
              {
                'ts': -1269817200,
                'time': '1929-10-06T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          23:
              {
                'ts': -1221433200,
                'time': '1931-04-19T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          24:
              {
                'ts': -1206918000,
                'time': '1931-10-04T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          25:
              {
                'ts': -1191193200,
                'time': '1932-04-03T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          26:
              {
                'ts': -1175468400,
                'time': '1932-10-02T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          27:
              {
                'ts': -1127689200,
                'time': '1934-04-08T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          28:
              {
                'ts': -1111964400,
                'time': '1934-10-07T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          29:
              {
                'ts': -1096844400,
                'time': '1935-03-31T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          30:
              {
                'ts': -1080514800,
                'time': '1935-10-06T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          31:
              {
                'ts': -1063580400,
                'time': '1936-04-19T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          32:
              {
                'ts': -1049065200,
                'time': '1936-10-04T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          33:
              {
                'ts': -1033340400,
                'time': '1937-04-04T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          34:
              {
                'ts': -1017615600,
                'time': '1937-10-03T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          35:
              {
                'ts': -1002495600,
                'time': '1938-03-27T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          36:
              {
                'ts': -986166000,
                'time': '1938-10-02T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          37:
              {
                'ts': -969231600,
                'time': '1939-04-16T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          38:
              {
                'ts': -950482800,
                'time': '1939-11-19T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          39:
              {
                'ts': -942015600,
                'time': '1940-02-25T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          40:
              {
                'ts': -922662000,
                'time': '1940-10-06T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          41:
              {
                'ts': -906937200,
                'time': '1941-04-06T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          42:
              {
                'ts': -891126000,
                'time': '1941-10-06T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          43:
              {
                'ts': -877302000,
                'time': '1942-03-15T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          44:
              {
                'ts': -873676800,
                'time': '1942-04-26T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOMT'
              },
          45:
              {
                'ts': -864000000,
                'time': '1942-08-16T00:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          46:
              {
                'ts': -857948400,
                'time': '1942-10-25T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          47:
              {
                'ts': -845852400,
                'time': '1943-03-14T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          48:
              {
                'ts': -842832000,
                'time': '1943-04-18T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOMT'
              },
          49:
              {
                'ts': -831340800,
                'time': '1943-08-29T00:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          50:
              {
                'ts': -825894000,
                'time': '1943-10-31T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          51:
              {
                'ts': -814402800,
                'time': '1944-03-12T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          52:
              {
                'ts': -810777600,
                'time': '1944-04-23T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOMT'
              },
          53:
              {
                'ts': -799891200,
                'time': '1944-08-27T00:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          54:
              {
                'ts': -794444400,
                'time': '1944-10-29T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          55:
              {
                'ts': -782953200,
                'time': '1945-03-11T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          56:
              {
                'ts': -779328000,
                'time': '1945-04-22T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOMT'
              },
          57:
              {
                'ts': -768441600,
                'time': '1945-08-26T00:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          58:
              {
                'ts': -762994800,
                'time': '1945-10-28T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          59:
              {
                'ts': -749084400,
                'time': '1946-04-07T01:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          60:
              {
                'ts': -733359600,
                'time': '1946-10-06T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          61:
              {
                'ts': -717624000,
                'time': '1947-04-06T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          62:
              {
                'ts': -701899200,
                'time': '1947-10-05T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          63:
              {
                'ts': -686174400,
                'time': '1948-04-04T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          64:
              {
                'ts': -670449600,
                'time': '1948-10-03T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          65:
              {
                'ts': -654724800,
                'time': '1949-04-03T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          66:
              {
                'ts': -639000000,
                'time': '1949-10-02T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          67:
              {
                'ts': -591825600,
                'time': '1951-04-01T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          68:
              {
                'ts': -575496000,
                'time': '1951-10-07T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          69:
              {
                'ts': -559771200,
                'time': '1952-04-06T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          70:
              {
                'ts': -544046400,
                'time': '1952-10-05T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          71:
              {
                'ts': -528321600,
                'time': '1953-04-05T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          72:
              {
                'ts': -512596800,
                'time': '1953-10-04T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          73:
              {
                'ts': -496872000,
                'time': '1954-04-04T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          74:
              {
                'ts': -481147200,
                'time': '1954-10-03T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          75:
              {
                'ts': -465422400,
                'time': '1955-04-03T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          76:
              {
                'ts': -449697600,
                'time': '1955-10-02T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          77:
              {
                'ts': -433972800,
                'time': '1956-04-01T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          78:
              {
                'ts': -417643200,
                'time': '1956-10-07T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          79:
              {
                'ts': -401918400,
                'time': '1957-04-07T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          80:
              {
                'ts': -386193600,
                'time': '1957-10-06T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          81:
              {
                'ts': -370468800,
                'time': '1958-04-06T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          82:
              {
                'ts': -354744000,
                'time': '1958-10-05T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          83:
              {
                'ts': -339019200,
                'time': '1959-04-05T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          84:
              {
                'ts': -323294400,
                'time': '1959-10-04T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          85:
              {
                'ts': -307569600,
                'time': '1960-04-03T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          86:
              {
                'ts': -291844800,
                'time': '1960-10-02T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          87:
              {
                'ts': -276120000,
                'time': '1961-04-02T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          88:
              {
                'ts': -260395200,
                'time': '1961-10-01T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          89:
              {
                'ts': -244670400,
                'time': '1962-04-01T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          90:
              {
                'ts': -228340800,
                'time': '1962-10-07T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          91:
              {
                'ts': -212616000,
                'time': '1963-04-07T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          92:
              {
                'ts': -196891200,
                'time': '1963-10-06T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          93:
              {
                'ts': -181166400,
                'time': '1964-04-05T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          94:
              {
                'ts': -165441600,
                'time': '1964-10-04T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          95:
              {
                'ts': -149716800,
                'time': '1965-04-04T04:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'AZOST'
              },
          96:
              {
                'ts': -133992000,
                'time': '1965-10-03T04:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'AZOT'
              },
          97:
              {
                'ts': -118267200,
                'time': '1966-04-03T04:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          98:
              {
                'ts': 228272400,
                'time': '1977-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          99:
              {
                'ts': 243997200,
                'time': '1977-09-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          100:
              {
                'ts': 260326800,
                'time': '1978-04-02T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          101:
              {
                'ts': 276051600,
                'time': '1978-10-01T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          102:
              {
                'ts': 291776400,
                'time': '1979-04-01T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          103:
              {
                'ts': 307504800,
                'time': '1979-09-30T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          104:
              {
                'ts': 323226000,
                'time': '1980-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          105:
              {
                'ts': 338954400,
                'time': '1980-09-28T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          106:
              {
                'ts': 354679200,
                'time': '1981-03-29T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          107:
              {
                'ts': 370404000,
                'time': '1981-09-27T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          108:
              {
                'ts': 386128800,
                'time': '1982-03-28T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          109:
              {
                'ts': 401853600,
                'time': '1982-09-26T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          110:
              {
                'ts': 417582000,
                'time': '1983-03-27T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          111:
              {
                'ts': 433303200,
                'time': '1983-09-25T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          112:
              {
                'ts': 449028000,
                'time': '1984-03-25T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          113:
              {
                'ts': 465357600,
                'time': '1984-09-30T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          114:
              {
                'ts': 481082400,
                'time': '1985-03-31T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          115:
              {
                'ts': 496807200,
                'time': '1985-09-29T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          116:
              {
                'ts': 512532000,
                'time': '1986-03-30T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          117:
              {
                'ts': 528256800,
                'time': '1986-09-28T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          118:
              {
                'ts': 543981600,
                'time': '1987-03-29T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          119:
              {
                'ts': 559706400,
                'time': '1987-09-27T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          120:
              {
                'ts': 575431200,
                'time': '1988-03-27T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          121:
              {
                'ts': 591156000,
                'time': '1988-09-25T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          122:
              {
                'ts': 606880800,
                'time': '1989-03-26T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          123:
              {
                'ts': 622605600,
                'time': '1989-09-24T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          124:
              {
                'ts': 638330400,
                'time': '1990-03-25T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          125:
              {
                'ts': 654660000,
                'time': '1990-09-30T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          126:
              {
                'ts': 670384800,
                'time': '1991-03-31T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          127:
              {
                'ts': 686109600,
                'time': '1991-09-29T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          128:
              {
                'ts': 701834400,
                'time': '1992-03-29T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          129:
              {
                'ts': 717559200,
                'time': '1992-09-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          130:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          131:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          132:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          133:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          134:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          135:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          136:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          137:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          138:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          139:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          140:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          141:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          142:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          143:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          144:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          145:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          146:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          147:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          148:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          149:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          150:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          151:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          152:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          153:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          154:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          155:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          156:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          157:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          158:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          159:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          160:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          161:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          162:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          163:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          164:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          165:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          166:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          167:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          168:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          169:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          170:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          171:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          172:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          173:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          174:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          175:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          176:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          177:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          178:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          179:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          180:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          181:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          182:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          183:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          184:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          185:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          186:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          187:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          188:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          189:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          190:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          191:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          192:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          193:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          194:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          195:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          196:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          197:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          198:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          199:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          200:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          201:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          202:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          203:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          204:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          205:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          206:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          207:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          208:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          209:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          210:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          211:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          212:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          213:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          214:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          215:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          216:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          217:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              },
          218:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'AZOST'
              },
          219:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'AZOT'
              }
        },
    'Atlantic/Bermuda':
        {
          0:
              {
                'ts': -1262281256,
                'time': '1930-01-01T06:19:04+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          1:
              {
                'ts': 136360800,
                'time': '1974-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          2:
              {
                'ts': 152082000,
                'time': '1974-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          3:
              {
                'ts': 167810400,
                'time': '1975-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          4:
              {
                'ts': 183531600,
                'time': '1975-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          5:
              {
                'ts': 199260000,
                'time': '1976-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          6:
              {
                'ts': 215586000,
                'time': '1976-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          7:
              {
                'ts': 230709600,
                'time': '1977-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          8:
              {
                'ts': 247035600,
                'time': '1977-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          9:
              {
                'ts': 262764000,
                'time': '1978-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          10:
              {
                'ts': 278485200,
                'time': '1978-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          11:
              {
                'ts': 294213600,
                'time': '1979-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          12:
              {
                'ts': 309934800,
                'time': '1979-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          13:
              {
                'ts': 325663200,
                'time': '1980-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          14:
              {
                'ts': 341384400,
                'time': '1980-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          15:
              {
                'ts': 357112800,
                'time': '1981-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          16:
              {
                'ts': 372834000,
                'time': '1981-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          17:
              {
                'ts': 388562400,
                'time': '1982-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          18:
              {
                'ts': 404888400,
                'time': '1982-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          19:
              {
                'ts': 420012000,
                'time': '1983-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          20:
              {
                'ts': 436338000,
                'time': '1983-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          21:
              {
                'ts': 452066400,
                'time': '1984-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          22:
              {
                'ts': 467787600,
                'time': '1984-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          23:
              {
                'ts': 483516000,
                'time': '1985-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          24:
              {
                'ts': 499237200,
                'time': '1985-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          25:
              {
                'ts': 514965600,
                'time': '1986-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          26:
              {
                'ts': 530686800,
                'time': '1986-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          27:
              {
                'ts': 544600800,
                'time': '1987-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          28:
              {
                'ts': 562136400,
                'time': '1987-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          29:
              {
                'ts': 576050400,
                'time': '1988-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          30:
              {
                'ts': 594190800,
                'time': '1988-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          31:
              {
                'ts': 607500000,
                'time': '1989-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          32:
              {
                'ts': 625640400,
                'time': '1989-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          33:
              {
                'ts': 638949600,
                'time': '1990-04-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          34:
              {
                'ts': 657090000,
                'time': '1990-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          35:
              {
                'ts': 671004000,
                'time': '1991-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          36:
              {
                'ts': 688539600,
                'time': '1991-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          37:
              {
                'ts': 702453600,
                'time': '1992-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          38:
              {
                'ts': 719989200,
                'time': '1992-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          39:
              {
                'ts': 733903200,
                'time': '1993-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          40:
              {
                'ts': 752043600,
                'time': '1993-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          41:
              {
                'ts': 765352800,
                'time': '1994-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          42:
              {
                'ts': 783493200,
                'time': '1994-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          43:
              {
                'ts': 796802400,
                'time': '1995-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          44:
              {
                'ts': 814942800,
                'time': '1995-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          45:
              {
                'ts': 828856800,
                'time': '1996-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          46:
              {
                'ts': 846392400,
                'time': '1996-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          47:
              {
                'ts': 860306400,
                'time': '1997-04-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          48:
              {
                'ts': 877842000,
                'time': '1997-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          49:
              {
                'ts': 891756000,
                'time': '1998-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          50:
              {
                'ts': 909291600,
                'time': '1998-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          51:
              {
                'ts': 923205600,
                'time': '1999-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          52:
              {
                'ts': 941346000,
                'time': '1999-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          53:
              {
                'ts': 954655200,
                'time': '2000-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          54:
              {
                'ts': 972795600,
                'time': '2000-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          55:
              {
                'ts': 986104800,
                'time': '2001-04-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          56:
              {
                'ts': 1004245200,
                'time': '2001-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          57:
              {
                'ts': 1018159200,
                'time': '2002-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          58:
              {
                'ts': 1035694800,
                'time': '2002-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          59:
              {
                'ts': 1049608800,
                'time': '2003-04-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          60:
              {
                'ts': 1067144400,
                'time': '2003-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          61:
              {
                'ts': 1081058400,
                'time': '2004-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          62:
              {
                'ts': 1099198800,
                'time': '2004-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          63:
              {
                'ts': 1112508000,
                'time': '2005-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          64:
              {
                'ts': 1130648400,
                'time': '2005-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          65:
              {
                'ts': 1143957600,
                'time': '2006-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          66:
              {
                'ts': 1162098000,
                'time': '2006-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          67:
              {
                'ts': 1173592800,
                'time': '2007-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          68:
              {
                'ts': 1194152400,
                'time': '2007-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          69:
              {
                'ts': 1205042400,
                'time': '2008-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          70:
              {
                'ts': 1225602000,
                'time': '2008-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          71:
              {
                'ts': 1236492000,
                'time': '2009-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          72:
              {
                'ts': 1257051600,
                'time': '2009-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          73:
              {
                'ts': 1268546400,
                'time': '2010-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          74:
              {
                'ts': 1289106000,
                'time': '2010-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          75:
              {
                'ts': 1299996000,
                'time': '2011-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          76:
              {
                'ts': 1320555600,
                'time': '2011-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          77:
              {
                'ts': 1331445600,
                'time': '2012-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          78:
              {
                'ts': 1352005200,
                'time': '2012-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          79:
              {
                'ts': 1362895200,
                'time': '2013-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          80:
              {
                'ts': 1383454800,
                'time': '2013-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          81:
              {
                'ts': 1394344800,
                'time': '2014-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          82:
              {
                'ts': 1414904400,
                'time': '2014-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          83:
              {
                'ts': 1425794400,
                'time': '2015-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          84:
              {
                'ts': 1446354000,
                'time': '2015-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          85:
              {
                'ts': 1457848800,
                'time': '2016-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          86:
              {
                'ts': 1478408400,
                'time': '2016-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          87:
              {
                'ts': 1489298400,
                'time': '2017-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          88:
              {
                'ts': 1509858000,
                'time': '2017-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          89:
              {
                'ts': 1520748000,
                'time': '2018-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          90:
              {
                'ts': 1541307600,
                'time': '2018-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          91:
              {
                'ts': 1552197600,
                'time': '2019-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          92:
              {
                'ts': 1572757200,
                'time': '2019-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          93:
              {
                'ts': 1583647200,
                'time': '2020-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          94:
              {
                'ts': 1604206800,
                'time': '2020-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          95:
              {
                'ts': 1615701600,
                'time': '2021-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          96:
              {
                'ts': 1636261200,
                'time': '2021-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          97:
              {
                'ts': 1647151200,
                'time': '2022-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          98:
              {
                'ts': 1667710800,
                'time': '2022-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          99:
              {
                'ts': 1678600800,
                'time': '2023-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          100:
              {
                'ts': 1699160400,
                'time': '2023-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          101:
              {
                'ts': 1710050400,
                'time': '2024-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          102:
              {
                'ts': 1730610000,
                'time': '2024-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          103:
              {
                'ts': 1741500000,
                'time': '2025-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          104:
              {
                'ts': 1762059600,
                'time': '2025-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          105:
              {
                'ts': 1772949600,
                'time': '2026-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          106:
              {
                'ts': 1793509200,
                'time': '2026-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          107:
              {
                'ts': 1805004000,
                'time': '2027-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          108:
              {
                'ts': 1825563600,
                'time': '2027-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          109:
              {
                'ts': 1836453600,
                'time': '2028-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          110:
              {
                'ts': 1857013200,
                'time': '2028-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          111:
              {
                'ts': 1867903200,
                'time': '2029-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          112:
              {
                'ts': 1888462800,
                'time': '2029-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          113:
              {
                'ts': 1899352800,
                'time': '2030-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          114:
              {
                'ts': 1919912400,
                'time': '2030-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          115:
              {
                'ts': 1930802400,
                'time': '2031-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          116:
              {
                'ts': 1951362000,
                'time': '2031-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          117:
              {
                'ts': 1962856800,
                'time': '2032-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          118:
              {
                'ts': 1983416400,
                'time': '2032-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          119:
              {
                'ts': 1994306400,
                'time': '2033-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          120:
              {
                'ts': 2014866000,
                'time': '2033-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          121:
              {
                'ts': 2025756000,
                'time': '2034-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          122:
              {
                'ts': 2046315600,
                'time': '2034-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          123:
              {
                'ts': 2057205600,
                'time': '2035-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          124:
              {
                'ts': 2077765200,
                'time': '2035-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          125:
              {
                'ts': 2088655200,
                'time': '2036-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          126:
              {
                'ts': 2109214800,
                'time': '2036-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          127:
              {
                'ts': 2120104800,
                'time': '2037-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          128:
              {
                'ts': 2140664400,
                'time': '2037-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'Atlantic/Canary':
        {
          0:
              {
                'ts': -1509663504,
                'time': '1922-03-01T01:01:36+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'CANT'
              },
          1:
              {
                'ts': -733874400,
                'time': '1946-09-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          2:
              {
                'ts': 323827200,
                'time': '1980-04-06T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          3:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          4:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          5:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          6:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          7:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          8:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          9:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          10:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          11:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          12:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          13:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          14:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          15:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          16:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          17:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          18:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          19:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          20:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          21:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          22:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          23:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          24:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          25:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          26:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          27:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          28:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          29:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          30:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          31:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          32:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          33:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          34:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          35:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          36:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          37:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          38:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          39:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          40:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          41:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          42:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          43:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          44:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          45:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          46:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          47:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          48:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          49:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          50:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          51:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          52:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          53:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          54:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          55:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          56:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          57:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          58:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          59:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          60:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          61:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          62:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          63:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          64:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          65:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          66:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          67:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          68:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          69:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          70:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          71:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          72:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          73:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          74:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          75:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          76:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          77:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          78:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          79:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          80:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          81:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          82:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          83:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          84:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          85:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          86:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          87:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          88:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          89:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          90:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          91:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          92:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          93:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          94:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          95:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          96:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          97:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          98:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          99:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          100:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          101:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          102:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          103:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          104:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          105:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          106:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          107:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          108:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          109:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          110:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          111:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          112:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          113:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          114:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          115:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          116:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          117:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              }
        },
    'Atlantic/Cape_Verde':
        {
          0:
              {
                'ts': -1988144756,
                'time': '1907-01-01T01:34:04+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'CVT'
              },
          1:
              {
                'ts': -862610400,
                'time': '1942-09-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'CVST'
              },
          2:
              {
                'ts': -764118000,
                'time': '1945-10-15T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'CVT'
              },
          3:
              {
                'ts': 186120000,
                'time': '1975-11-25T04:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'CVT'
              }
        },
    'Atlantic/Faeroe':
        {
          0:
              {
                'ts': -1955748776,
                'time': '1908-01-11T00:27:04+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          1:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          2:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          3:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          4:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          5:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          6:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          7:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          8:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          9:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          10:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          11:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          12:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          13:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          14:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          15:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          16:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          17:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          18:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          19:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          20:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          21:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          22:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          23:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          24:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          25:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          26:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          27:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          28:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          29:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          30:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          31:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          32:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          33:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          34:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          35:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          36:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          37:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          38:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          39:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          40:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          41:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          42:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          43:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          44:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          45:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          46:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          47:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          48:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          49:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          50:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          51:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          52:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          53:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          54:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          55:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          56:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          57:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          58:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          59:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          60:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          61:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          62:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          63:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          64:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          65:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          66:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          67:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          68:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          69:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          70:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          71:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          72:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          73:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          74:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          75:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          76:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          77:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          78:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          79:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          80:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          81:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          82:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          83:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          84:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          85:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          86:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          87:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          88:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          89:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          90:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          91:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          92:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          93:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          94:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          95:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          96:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          97:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          98:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          99:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          100:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          101:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          102:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          103:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          104:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          105:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          106:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          107:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          108:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          109:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          110:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          111:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          112:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          113:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          114:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              }
        },
    'Atlantic/Faroe':
        {
          0:
              {
                'ts': -1955748776,
                'time': '1908-01-11T00:27:04+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          1:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          2:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          3:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          4:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          5:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          6:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          7:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          8:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          9:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          10:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          11:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          12:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          13:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          14:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          15:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          16:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          17:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          18:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          19:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          20:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          21:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          22:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          23:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          24:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          25:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          26:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          27:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          28:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          29:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          30:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          31:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          32:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          33:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          34:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          35:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          36:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          37:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          38:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          39:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          40:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          41:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          42:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          43:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          44:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          45:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          46:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          47:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          48:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          49:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          50:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          51:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          52:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          53:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          54:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          55:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          56:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          57:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          58:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          59:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          60:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          61:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          62:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          63:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          64:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          65:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          66:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          67:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          68:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          69:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          70:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          71:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          72:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          73:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          74:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          75:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          76:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          77:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          78:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          79:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          80:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          81:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          82:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          83:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          84:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          85:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          86:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          87:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          88:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          89:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          90:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          91:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          92:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          93:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          94:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          95:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          96:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          97:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          98:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          99:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          100:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          101:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          102:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          103:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          104:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          105:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          106:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          107:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          108:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          109:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          110:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          111:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          112:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          113:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          114:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              }
        },
    'Atlantic/Jan_Mayen':
        {
          0:
              {
                'ts': -1691884800,
                'time': '1916-05-22T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680573600,
                'time': '1916-09-29T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -927511200,
                'time': '1940-08-10T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -765327600,
                'time': '1945-10-01T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -340844400,
                'time': '1959-03-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -324514800,
                'time': '1959-09-20T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -308790000,
                'time': '1960-03-20T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -293065200,
                'time': '1960-09-18T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': -277340400,
                'time': '1961-03-19T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -261615600,
                'time': '1961-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': -245890800,
                'time': '1962-03-18T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          17:
              {
                'ts': -230166000,
                'time': '1962-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': -214441200,
                'time': '1963-03-17T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': -198716400,
                'time': '1963-09-15T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          20:
              {
                'ts': -182991600,
                'time': '1964-03-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          21:
              {
                'ts': -166662000,
                'time': '1964-09-20T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': -147913200,
                'time': '1965-04-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          23:
              {
                'ts': -135212400,
                'time': '1965-09-19T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          24:
              {
                'ts': 315529200,
                'time': '1979-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Atlantic/Madeira':
        {
          0:
              {
                'ts': -1849560744,
                'time': '1911-05-24T01:07:36+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          1:
              {
                'ts': -1689552000,
                'time': '1916-06-18T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          2:
              {
                'ts': -1677798000,
                'time': '1916-11-01T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          3:
              {
                'ts': -1667433600,
                'time': '1917-03-01T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          4:
              {
                'ts': -1647734400,
                'time': '1917-10-15T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          5:
              {
                'ts': -1635811200,
                'time': '1918-03-02T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          6:
              {
                'ts': -1616198400,
                'time': '1918-10-15T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          7:
              {
                'ts': -1604361600,
                'time': '1919-03-01T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          8:
              {
                'ts': -1584662400,
                'time': '1919-10-15T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          9:
              {
                'ts': -1572739200,
                'time': '1920-03-01T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          10:
              {
                'ts': -1553040000,
                'time': '1920-10-15T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          11:
              {
                'ts': -1541203200,
                'time': '1921-03-01T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          12:
              {
                'ts': -1521504000,
                'time': '1921-10-15T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          13:
              {
                'ts': -1442448000,
                'time': '1924-04-17T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          14:
              {
                'ts': -1426809600,
                'time': '1924-10-15T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          15:
              {
                'ts': -1379289600,
                'time': '1926-04-18T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          16:
              {
                'ts': -1364774400,
                'time': '1926-10-03T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          17:
              {
                'ts': -1348444800,
                'time': '1927-04-10T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          18:
              {
                'ts': -1333324800,
                'time': '1927-10-02T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          19:
              {
                'ts': -1316390400,
                'time': '1928-04-15T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          20:
              {
                'ts': -1301270400,
                'time': '1928-10-07T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          21:
              {
                'ts': -1284336000,
                'time': '1929-04-21T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          22:
              {
                'ts': -1269820800,
                'time': '1929-10-06T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          23:
              {
                'ts': -1221436800,
                'time': '1931-04-19T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          24:
              {
                'ts': -1206921600,
                'time': '1931-10-04T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          25:
              {
                'ts': -1191196800,
                'time': '1932-04-03T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          26:
              {
                'ts': -1175472000,
                'time': '1932-10-02T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          27:
              {
                'ts': -1127692800,
                'time': '1934-04-08T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          28:
              {
                'ts': -1111968000,
                'time': '1934-10-07T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          29:
              {
                'ts': -1096848000,
                'time': '1935-03-31T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          30:
              {
                'ts': -1080518400,
                'time': '1935-10-06T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          31:
              {
                'ts': -1063584000,
                'time': '1936-04-19T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          32:
              {
                'ts': -1049068800,
                'time': '1936-10-04T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          33:
              {
                'ts': -1033344000,
                'time': '1937-04-04T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          34:
              {
                'ts': -1017619200,
                'time': '1937-10-03T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          35:
              {
                'ts': -1002499200,
                'time': '1938-03-27T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          36:
              {
                'ts': -986169600,
                'time': '1938-10-02T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          37:
              {
                'ts': -969235200,
                'time': '1939-04-16T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          38:
              {
                'ts': -950486400,
                'time': '1939-11-19T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          39:
              {
                'ts': -942019200,
                'time': '1940-02-25T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          40:
              {
                'ts': -922665600,
                'time': '1940-10-06T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          41:
              {
                'ts': -906940800,
                'time': '1941-04-06T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          42:
              {
                'ts': -891129600,
                'time': '1941-10-06T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          43:
              {
                'ts': -877305600,
                'time': '1942-03-15T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          44:
              {
                'ts': -873680400,
                'time': '1942-04-25T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'MADMT'
              },
          45:
              {
                'ts': -864003600,
                'time': '1942-08-15T23:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          46:
              {
                'ts': -857952000,
                'time': '1942-10-25T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          47:
              {
                'ts': -845856000,
                'time': '1943-03-14T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          48:
              {
                'ts': -842835600,
                'time': '1943-04-17T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'MADMT'
              },
          49:
              {
                'ts': -831344400,
                'time': '1943-08-28T23:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          50:
              {
                'ts': -825897600,
                'time': '1943-10-31T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          51:
              {
                'ts': -814406400,
                'time': '1944-03-12T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          52:
              {
                'ts': -810781200,
                'time': '1944-04-22T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'MADMT'
              },
          53:
              {
                'ts': -799894800,
                'time': '1944-08-26T23:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          54:
              {
                'ts': -794448000,
                'time': '1944-10-29T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          55:
              {
                'ts': -782956800,
                'time': '1945-03-11T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          56:
              {
                'ts': -779331600,
                'time': '1945-04-21T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'MADMT'
              },
          57:
              {
                'ts': -768445200,
                'time': '1945-08-25T23:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          58:
              {
                'ts': -762998400,
                'time': '1945-10-28T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          59:
              {
                'ts': -749088000,
                'time': '1946-04-07T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          60:
              {
                'ts': -733363200,
                'time': '1946-10-06T00:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          61:
              {
                'ts': -717627600,
                'time': '1947-04-06T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          62:
              {
                'ts': -701902800,
                'time': '1947-10-05T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          63:
              {
                'ts': -686178000,
                'time': '1948-04-04T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          64:
              {
                'ts': -670453200,
                'time': '1948-10-03T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          65:
              {
                'ts': -654728400,
                'time': '1949-04-03T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          66:
              {
                'ts': -639003600,
                'time': '1949-10-02T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          67:
              {
                'ts': -591829200,
                'time': '1951-04-01T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          68:
              {
                'ts': -575499600,
                'time': '1951-10-07T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          69:
              {
                'ts': -559774800,
                'time': '1952-04-06T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          70:
              {
                'ts': -544050000,
                'time': '1952-10-05T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          71:
              {
                'ts': -528325200,
                'time': '1953-04-05T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          72:
              {
                'ts': -512600400,
                'time': '1953-10-04T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          73:
              {
                'ts': -496875600,
                'time': '1954-04-04T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          74:
              {
                'ts': -481150800,
                'time': '1954-10-03T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          75:
              {
                'ts': -465426000,
                'time': '1955-04-03T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          76:
              {
                'ts': -449701200,
                'time': '1955-10-02T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          77:
              {
                'ts': -433976400,
                'time': '1956-04-01T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          78:
              {
                'ts': -417646800,
                'time': '1956-10-07T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          79:
              {
                'ts': -401922000,
                'time': '1957-04-07T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          80:
              {
                'ts': -386197200,
                'time': '1957-10-06T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          81:
              {
                'ts': -370472400,
                'time': '1958-04-06T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          82:
              {
                'ts': -354747600,
                'time': '1958-10-05T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          83:
              {
                'ts': -339022800,
                'time': '1959-04-05T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          84:
              {
                'ts': -323298000,
                'time': '1959-10-04T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          85:
              {
                'ts': -307573200,
                'time': '1960-04-03T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          86:
              {
                'ts': -291848400,
                'time': '1960-10-02T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          87:
              {
                'ts': -276123600,
                'time': '1961-04-02T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          88:
              {
                'ts': -260398800,
                'time': '1961-10-01T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          89:
              {
                'ts': -244674000,
                'time': '1962-04-01T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          90:
              {
                'ts': -228344400,
                'time': '1962-10-07T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          91:
              {
                'ts': -212619600,
                'time': '1963-04-07T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          92:
              {
                'ts': -196894800,
                'time': '1963-10-06T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          93:
              {
                'ts': -181170000,
                'time': '1964-04-05T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          94:
              {
                'ts': -165445200,
                'time': '1964-10-04T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          95:
              {
                'ts': -149720400,
                'time': '1965-04-04T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'MADST'
              },
          96:
              {
                'ts': -133995600,
                'time': '1965-10-03T03:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'MADT'
              },
          97:
              {
                'ts': -118270800,
                'time': '1966-04-03T03:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          98:
              {
                'ts': 228268800,
                'time': '1977-03-27T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          99:
              {
                'ts': 243993600,
                'time': '1977-09-25T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          100:
              {
                'ts': 260323200,
                'time': '1978-04-02T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          101:
              {
                'ts': 276048000,
                'time': '1978-10-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          102:
              {
                'ts': 291772800,
                'time': '1979-04-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          103:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          104:
              {
                'ts': 323222400,
                'time': '1980-03-30T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          105:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          106:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          107:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          108:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          109:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          110:
              {
                'ts': 417578400,
                'time': '1983-03-27T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          111:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          112:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          113:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          114:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          115:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          116:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          117:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          118:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          119:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          120:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          121:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          122:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          123:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          124:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          125:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          126:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          127:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          128:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          129:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          130:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          131:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          132:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          133:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          134:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          135:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          136:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          137:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          138:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          139:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          140:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          141:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          142:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          143:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          144:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          145:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          146:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          147:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          148:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          149:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          150:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          151:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          152:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          153:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          154:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          155:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          156:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          157:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          158:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          159:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          160:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          161:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          162:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          163:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          164:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          165:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          166:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          167:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          168:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          169:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          170:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          171:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          172:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          173:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          174:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          175:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          176:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          177:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          178:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          179:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          180:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          181:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          182:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          183:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          184:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          185:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          186:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          187:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          188:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          189:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          190:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          191:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          192:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          193:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          194:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          195:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          196:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          197:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          198:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          199:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          200:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          201:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          202:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          203:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          204:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          205:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          206:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          207:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          208:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          209:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          210:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          211:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          212:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          213:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          214:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          215:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          216:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          217:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          218:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          219:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              }
        },
    'Atlantic/Reykjavik':
        {
          0:
              {
                'ts': -1956609132,
                'time': '1908-01-01T01:27:48+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          1:
              {
                'ts': -1668211200,
                'time': '1917-02-20T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          2:
              {
                'ts': -1647212400,
                'time': '1917-10-21T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          3:
              {
                'ts': -1636675200,
                'time': '1918-02-20T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          4:
              {
                'ts': -1613430000,
                'time': '1918-11-16T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          5:
              {
                'ts': -968025600,
                'time': '1939-04-30T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          6:
              {
                'ts': -949615200,
                'time': '1939-11-29T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          7:
              {
                'ts': -942008400,
                'time': '1940-02-25T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          8:
              {
                'ts': -920239200,
                'time': '1940-11-03T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          9:
              {
                'ts': -909957600,
                'time': '1941-03-02T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          10:
              {
                'ts': -888789600,
                'time': '1941-11-02T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          11:
              {
                'ts': -877903200,
                'time': '1942-03-08T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          12:
              {
                'ts': -857944800,
                'time': '1942-10-25T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          13:
              {
                'ts': -846453600,
                'time': '1943-03-07T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          14:
              {
                'ts': -826495200,
                'time': '1943-10-24T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          15:
              {
                'ts': -815004000,
                'time': '1944-03-05T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          16:
              {
                'ts': -795045600,
                'time': '1944-10-22T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          17:
              {
                'ts': -783554400,
                'time': '1945-03-04T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          18:
              {
                'ts': -762991200,
                'time': '1945-10-28T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          19:
              {
                'ts': -752104800,
                'time': '1946-03-03T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          20:
              {
                'ts': -731541600,
                'time': '1946-10-27T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          21:
              {
                'ts': -717631200,
                'time': '1947-04-06T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          22:
              {
                'ts': -700092000,
                'time': '1947-10-26T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          23:
              {
                'ts': -686181600,
                'time': '1948-04-04T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          24:
              {
                'ts': -668642400,
                'time': '1948-10-24T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          25:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          26:
              {
                'ts': -636588000,
                'time': '1949-10-30T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          27:
              {
                'ts': -623282400,
                'time': '1950-04-02T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          28:
              {
                'ts': -605743200,
                'time': '1950-10-22T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          29:
              {
                'ts': -591832800,
                'time': '1951-04-01T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          30:
              {
                'ts': -573688800,
                'time': '1951-10-28T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          31:
              {
                'ts': -559778400,
                'time': '1952-04-06T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          32:
              {
                'ts': -542239200,
                'time': '1952-10-26T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          33:
              {
                'ts': -528328800,
                'time': '1953-04-05T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          34:
              {
                'ts': -510789600,
                'time': '1953-10-25T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          35:
              {
                'ts': -496879200,
                'time': '1954-04-04T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          36:
              {
                'ts': -479340000,
                'time': '1954-10-24T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          37:
              {
                'ts': -465429600,
                'time': '1955-04-03T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          38:
              {
                'ts': -447890400,
                'time': '1955-10-23T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          39:
              {
                'ts': -433980000,
                'time': '1956-04-01T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          40:
              {
                'ts': -415836000,
                'time': '1956-10-28T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          41:
              {
                'ts': -401925600,
                'time': '1957-04-07T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          42:
              {
                'ts': -384386400,
                'time': '1957-10-27T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          43:
              {
                'ts': -370476000,
                'time': '1958-04-06T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          44:
              {
                'ts': -352936800,
                'time': '1958-10-26T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          45:
              {
                'ts': -339026400,
                'time': '1959-04-05T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          46:
              {
                'ts': -321487200,
                'time': '1959-10-25T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          47:
              {
                'ts': -307576800,
                'time': '1960-04-03T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          48:
              {
                'ts': -290037600,
                'time': '1960-10-23T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          49:
              {
                'ts': -276127200,
                'time': '1961-04-02T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          50:
              {
                'ts': -258588000,
                'time': '1961-10-22T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          51:
              {
                'ts': -244677600,
                'time': '1962-04-01T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          52:
              {
                'ts': -226533600,
                'time': '1962-10-28T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          53:
              {
                'ts': -212623200,
                'time': '1963-04-07T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          54:
              {
                'ts': -195084000,
                'time': '1963-10-27T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          55:
              {
                'ts': -181173600,
                'time': '1964-04-05T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          56:
              {
                'ts': -163634400,
                'time': '1964-10-25T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          57:
              {
                'ts': -149724000,
                'time': '1965-04-04T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          58:
              {
                'ts': -132184800,
                'time': '1965-10-24T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          59:
              {
                'ts': -118274400,
                'time': '1966-04-03T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          60:
              {
                'ts': -100735200,
                'time': '1966-10-23T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          61:
              {
                'ts': -86824800,
                'time': '1967-04-02T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          62:
              {
                'ts': -68680800,
                'time': '1967-10-29T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          63:
              {
                'ts': -54770400,
                'time': '1968-04-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Atlantic/South_Georgia':
        {
        },
    'Atlantic/St_Helena':
        {
          0:
              {
                'ts': -599614632,
                'time': '1951-01-01T00:22:48+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Atlantic/Stanley':
        {
          0:
              {
                'ts': -1824235716,
                'time': '1912-03-12T03:51:24+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          1:
              {
                'ts': -1018209600,
                'time': '1937-09-26T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          2:
              {
                'ts': -1003093200,
                'time': '1938-03-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          3:
              {
                'ts': -986760000,
                'time': '1938-09-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          4:
              {
                'ts': -971643600,
                'time': '1939-03-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          5:
              {
                'ts': -954705600,
                'time': '1939-10-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          6:
              {
                'ts': -939589200,
                'time': '1940-03-24T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          7:
              {
                'ts': -923256000,
                'time': '1940-09-29T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          8:
              {
                'ts': -908139600,
                'time': '1941-03-23T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          9:
              {
                'ts': -891806400,
                'time': '1941-09-28T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          10:
              {
                'ts': -876690000,
                'time': '1942-03-22T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          11:
              {
                'ts': -860356800,
                'time': '1942-09-27T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          12:
              {
                'ts': -852066000,
                'time': '1943-01-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          13:
              {
                'ts': 420609600,
                'time': '1983-05-01T04:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'FKT'
              },
          14:
              {
                'ts': 433306800,
                'time': '1983-09-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'FKST'
              },
          15:
              {
                'ts': 452052000,
                'time': '1984-04-29T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'FKT'
              },
          16:
              {
                'ts': 464151600,
                'time': '1984-09-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'FKST'
              },
          17:
              {
                'ts': 483501600,
                'time': '1985-04-28T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'FKT'
              },
          18:
              {
                'ts': 495601200,
                'time': '1985-09-15T03:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          19:
              {
                'ts': 514350000,
                'time': '1986-04-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          20:
              {
                'ts': 527054400,
                'time': '1986-09-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          21:
              {
                'ts': 545799600,
                'time': '1987-04-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          22:
              {
                'ts': 558504000,
                'time': '1987-09-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          23:
              {
                'ts': 577249200,
                'time': '1988-04-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          24:
              {
                'ts': 589953600,
                'time': '1988-09-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          25:
              {
                'ts': 608698800,
                'time': '1989-04-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          26:
              {
                'ts': 621403200,
                'time': '1989-09-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          27:
              {
                'ts': 640753200,
                'time': '1990-04-22T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          28:
              {
                'ts': 652852800,
                'time': '1990-09-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          29:
              {
                'ts': 672202800,
                'time': '1991-04-21T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          30:
              {
                'ts': 684907200,
                'time': '1991-09-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          31:
              {
                'ts': 703652400,
                'time': '1992-04-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          32:
              {
                'ts': 716356800,
                'time': '1992-09-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          33:
              {
                'ts': 735102000,
                'time': '1993-04-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          34:
              {
                'ts': 747806400,
                'time': '1993-09-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          35:
              {
                'ts': 766551600,
                'time': '1994-04-17T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          36:
              {
                'ts': 779256000,
                'time': '1994-09-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          37:
              {
                'ts': 798001200,
                'time': '1995-04-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          38:
              {
                'ts': 810705600,
                'time': '1995-09-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          39:
              {
                'ts': 830055600,
                'time': '1996-04-21T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          40:
              {
                'ts': 842760000,
                'time': '1996-09-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          41:
              {
                'ts': 861505200,
                'time': '1997-04-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          42:
              {
                'ts': 874209600,
                'time': '1997-09-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          43:
              {
                'ts': 892954800,
                'time': '1998-04-19T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          44:
              {
                'ts': 905659200,
                'time': '1998-09-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          45:
              {
                'ts': 924404400,
                'time': '1999-04-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          46:
              {
                'ts': 937108800,
                'time': '1999-09-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          47:
              {
                'ts': 955854000,
                'time': '2000-04-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          48:
              {
                'ts': 968558400,
                'time': '2000-09-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          49:
              {
                'ts': 987310800,
                'time': '2001-04-15T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          50:
              {
                'ts': 999410400,
                'time': '2001-09-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          51:
              {
                'ts': 1019365200,
                'time': '2002-04-21T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          52:
              {
                'ts': 1030860000,
                'time': '2002-09-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          53:
              {
                'ts': 1050814800,
                'time': '2003-04-20T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          54:
              {
                'ts': 1062914400,
                'time': '2003-09-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          55:
              {
                'ts': 1082264400,
                'time': '2004-04-18T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          56:
              {
                'ts': 1094364000,
                'time': '2004-09-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          57:
              {
                'ts': 1113714000,
                'time': '2005-04-17T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          58:
              {
                'ts': 1125813600,
                'time': '2005-09-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          59:
              {
                'ts': 1145163600,
                'time': '2006-04-16T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          60:
              {
                'ts': 1157263200,
                'time': '2006-09-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          61:
              {
                'ts': 1176613200,
                'time': '2007-04-15T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          62:
              {
                'ts': 1188712800,
                'time': '2007-09-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          63:
              {
                'ts': 1208667600,
                'time': '2008-04-20T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          64:
              {
                'ts': 1220767200,
                'time': '2008-09-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          65:
              {
                'ts': 1240117200,
                'time': '2009-04-19T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          66:
              {
                'ts': 1252216800,
                'time': '2009-09-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          67:
              {
                'ts': 1271566800,
                'time': '2010-04-18T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          68:
              {
                'ts': 1283666400,
                'time': '2010-09-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          69:
              {
                'ts': 1303016400,
                'time': '2011-04-17T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          70:
              {
                'ts': 1315116000,
                'time': '2011-09-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          71:
              {
                'ts': 1334466000,
                'time': '2012-04-15T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          72:
              {
                'ts': 1346565600,
                'time': '2012-09-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          73:
              {
                'ts': 1366520400,
                'time': '2013-04-21T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          74:
              {
                'ts': 1378015200,
                'time': '2013-09-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          75:
              {
                'ts': 1397970000,
                'time': '2014-04-20T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          76:
              {
                'ts': 1410069600,
                'time': '2014-09-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          77:
              {
                'ts': 1429419600,
                'time': '2015-04-19T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          78:
              {
                'ts': 1441519200,
                'time': '2015-09-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          79:
              {
                'ts': 1460869200,
                'time': '2016-04-17T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          80:
              {
                'ts': 1472968800,
                'time': '2016-09-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          81:
              {
                'ts': 1492318800,
                'time': '2017-04-16T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          82:
              {
                'ts': 1504418400,
                'time': '2017-09-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          83:
              {
                'ts': 1523768400,
                'time': '2018-04-15T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          84:
              {
                'ts': 1535868000,
                'time': '2018-09-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          85:
              {
                'ts': 1555822800,
                'time': '2019-04-21T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          86:
              {
                'ts': 1567317600,
                'time': '2019-09-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          87:
              {
                'ts': 1587272400,
                'time': '2020-04-19T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          88:
              {
                'ts': 1599372000,
                'time': '2020-09-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          89:
              {
                'ts': 1618722000,
                'time': '2021-04-18T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          90:
              {
                'ts': 1630821600,
                'time': '2021-09-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          91:
              {
                'ts': 1650171600,
                'time': '2022-04-17T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          92:
              {
                'ts': 1662271200,
                'time': '2022-09-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          93:
              {
                'ts': 1681621200,
                'time': '2023-04-16T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          94:
              {
                'ts': 1693720800,
                'time': '2023-09-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          95:
              {
                'ts': 1713675600,
                'time': '2024-04-21T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          96:
              {
                'ts': 1725170400,
                'time': '2024-09-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          97:
              {
                'ts': 1745125200,
                'time': '2025-04-20T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          98:
              {
                'ts': 1757224800,
                'time': '2025-09-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          99:
              {
                'ts': 1776574800,
                'time': '2026-04-19T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          100:
              {
                'ts': 1788674400,
                'time': '2026-09-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          101:
              {
                'ts': 1808024400,
                'time': '2027-04-18T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          102:
              {
                'ts': 1820124000,
                'time': '2027-09-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          103:
              {
                'ts': 1839474000,
                'time': '2028-04-16T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          104:
              {
                'ts': 1851573600,
                'time': '2028-09-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          105:
              {
                'ts': 1870923600,
                'time': '2029-04-15T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          106:
              {
                'ts': 1883023200,
                'time': '2029-09-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          107:
              {
                'ts': 1902978000,
                'time': '2030-04-21T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          108:
              {
                'ts': 1914472800,
                'time': '2030-09-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          109:
              {
                'ts': 1934427600,
                'time': '2031-04-20T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          110:
              {
                'ts': 1946527200,
                'time': '2031-09-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          111:
              {
                'ts': 1965877200,
                'time': '2032-04-18T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          112:
              {
                'ts': 1977976800,
                'time': '2032-09-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          113:
              {
                'ts': 1997326800,
                'time': '2033-04-17T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          114:
              {
                'ts': 2009426400,
                'time': '2033-09-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          115:
              {
                'ts': 2028776400,
                'time': '2034-04-16T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          116:
              {
                'ts': 2040876000,
                'time': '2034-09-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          117:
              {
                'ts': 2060226000,
                'time': '2035-04-15T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          118:
              {
                'ts': 2072325600,
                'time': '2035-09-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          119:
              {
                'ts': 2092280400,
                'time': '2036-04-20T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          120:
              {
                'ts': 2104380000,
                'time': '2036-09-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              },
          121:
              {
                'ts': 2123730000,
                'time': '2037-04-19T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'FKT'
              },
          122:
              {
                'ts': 2135829600,
                'time': '2037-09-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'FKST'
              }
        },
    'Australia/ACT':
        {
          0:
              {
                'ts': -1672567140,
                'time': '1916-12-31T14:01:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -1665392400,
                'time': '1917-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -883641600,
                'time': '1941-12-31T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -876128400,
                'time': '1942-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -860400000,
                'time': '1942-09-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -844678800,
                'time': '1943-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -828345600,
                'time': '1943-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -813229200,
                'time': '1944-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 57686400,
                'time': '1971-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 67968000,
                'time': '1972-02-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 89136000,
                'time': '1972-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 100022400,
                'time': '1973-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 120585600,
                'time': '1973-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 131472000,
                'time': '1974-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 152035200,
                'time': '1974-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 162921600,
                'time': '1975-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 183484800,
                'time': '1975-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 194976000,
                'time': '1976-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 215539200,
                'time': '1976-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 226425600,
                'time': '1977-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 246988800,
                'time': '1977-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 257875200,
                'time': '1978-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': 278438400,
                'time': '1978-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 289324800,
                'time': '1979-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': 309888000,
                'time': '1979-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 320774400,
                'time': '1980-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 341337600,
                'time': '1980-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 352224000,
                'time': '1981-02-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 372787200,
                'time': '1981-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 386697600,
                'time': '1982-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 404841600,
                'time': '1982-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 415728000,
                'time': '1983-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 436291200,
                'time': '1983-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 447177600,
                'time': '1984-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 467740800,
                'time': '1984-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 478627200,
                'time': '1985-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 499190400,
                'time': '1985-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 511286400,
                'time': '1986-03-15T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 530035200,
                'time': '1986-10-18T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 542736000,
                'time': '1987-03-14T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 562089600,
                'time': '1987-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 574790400,
                'time': '1988-03-19T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 594144000,
                'time': '1988-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 606240000,
                'time': '1989-03-18T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 625593600,
                'time': '1989-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 636480000,
                'time': '1990-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 657043200,
                'time': '1990-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 667929600,
                'time': '1991-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 688492800,
                'time': '1991-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 699379200,
                'time': '1992-02-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 719942400,
                'time': '1992-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 731433600,
                'time': '1993-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 751996800,
                'time': '1993-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 762883200,
                'time': '1994-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 783446400,
                'time': '1994-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 794332800,
                'time': '1995-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 814896000,
                'time': '1995-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 828201600,
                'time': '1996-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 846345600,
                'time': '1996-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 859651200,
                'time': '1997-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 877795200,
                'time': '1997-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 909244800,
                'time': '1998-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 922550400,
                'time': '1999-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 941299200,
                'time': '1999-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 954000000,
                'time': '2000-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 967305600,
                'time': '2000-08-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 985449600,
                'time': '2001-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1004198400,
                'time': '2001-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 1017504000,
                'time': '2002-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1035648000,
                'time': '2002-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 1048953600,
                'time': '2003-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1067097600,
                'time': '2003-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 1080403200,
                'time': '2004-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1099152000,
                'time': '2004-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1111852800,
                'time': '2005-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1130601600,
                'time': '2005-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1143907200,
                'time': '2006-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1162051200,
                'time': '2006-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1174752000,
                'time': '2007-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1193500800,
                'time': '2007-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1207411200,
                'time': '2008-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1223136000,
                'time': '2008-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1238860800,
                'time': '2009-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1254585600,
                'time': '2009-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1270310400,
                'time': '2010-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1286035200,
                'time': '2010-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1301760000,
                'time': '2011-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1317484800,
                'time': '2011-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1333209600,
                'time': '2012-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1349539200,
                'time': '2012-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1365264000,
                'time': '2013-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1380988800,
                'time': '2013-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1396713600,
                'time': '2014-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1412438400,
                'time': '2014-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1428163200,
                'time': '2015-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1443888000,
                'time': '2015-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1459612800,
                'time': '2016-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 1475337600,
                'time': '2016-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1491062400,
                'time': '2017-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 1506787200,
                'time': '2017-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1522512000,
                'time': '2018-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 1538841600,
                'time': '2018-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1554566400,
                'time': '2019-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 1570291200,
                'time': '2019-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1586016000,
                'time': '2020-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 1601740800,
                'time': '2020-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1617465600,
                'time': '2021-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 1633190400,
                'time': '2021-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1648915200,
                'time': '2022-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 1664640000,
                'time': '2022-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1680364800,
                'time': '2023-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 1696089600,
                'time': '2023-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1712419200,
                'time': '2024-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 1728144000,
                'time': '2024-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1743868800,
                'time': '2025-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 1759593600,
                'time': '2025-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1775318400,
                'time': '2026-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 1791043200,
                'time': '2026-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1806768000,
                'time': '2027-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 1822492800,
                'time': '2027-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1838217600,
                'time': '2028-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 1853942400,
                'time': '2028-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1869667200,
                'time': '2029-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 1885996800,
                'time': '2029-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1901721600,
                'time': '2030-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 1917446400,
                'time': '2030-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1933171200,
                'time': '2031-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 1948896000,
                'time': '2031-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1964620800,
                'time': '2032-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 1980345600,
                'time': '2032-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1996070400,
                'time': '2033-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 2011795200,
                'time': '2033-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 2027520000,
                'time': '2034-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 2043244800,
                'time': '2034-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 2058969600,
                'time': '2035-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 2075299200,
                'time': '2035-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 2091024000,
                'time': '2036-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          138:
              {
                'ts': 2106748800,
                'time': '2036-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 2122473600,
                'time': '2037-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          140:
              {
                'ts': 2138198400,
                'time': '2037-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              }
        },
    'Australia/Adelaide':
        {
          0:
              {
                'ts': -1672565340,
                'time': '1916-12-31T14:31:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -1665390600,
                'time': '1917-03-24T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -883639800,
                'time': '1941-12-31T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          3:
              {
                'ts': -876126600,
                'time': '1942-03-28T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -860398200,
                'time': '1942-09-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          5:
              {
                'ts': -844677000,
                'time': '1943-03-27T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -828343800,
                'time': '1943-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -813227400,
                'time': '1944-03-25T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': 57688200,
                'time': '1971-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 67969800,
                'time': '1972-02-26T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': 89137800,
                'time': '1972-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 100024200,
                'time': '1973-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': 120587400,
                'time': '1973-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 131473800,
                'time': '1974-03-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          14:
              {
                'ts': 152037000,
                'time': '1974-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 162923400,
                'time': '1975-03-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          16:
              {
                'ts': 183486600,
                'time': '1975-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          17:
              {
                'ts': 194977800,
                'time': '1976-03-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          18:
              {
                'ts': 215541000,
                'time': '1976-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          19:
              {
                'ts': 226427400,
                'time': '1977-03-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          20:
              {
                'ts': 246990600,
                'time': '1977-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          21:
              {
                'ts': 257877000,
                'time': '1978-03-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          22:
              {
                'ts': 278440200,
                'time': '1978-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 289326600,
                'time': '1979-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          24:
              {
                'ts': 309889800,
                'time': '1979-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 320776200,
                'time': '1980-03-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          26:
              {
                'ts': 341339400,
                'time': '1980-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 352225800,
                'time': '1981-02-28T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          28:
              {
                'ts': 372789000,
                'time': '1981-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 384280200,
                'time': '1982-03-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          30:
              {
                'ts': 404843400,
                'time': '1982-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 415729800,
                'time': '1983-03-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          32:
              {
                'ts': 436293000,
                'time': '1983-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 447179400,
                'time': '1984-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          34:
              {
                'ts': 467742600,
                'time': '1984-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 478629000,
                'time': '1985-03-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          36:
              {
                'ts': 499192200,
                'time': '1985-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 511288200,
                'time': '1986-03-15T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': 530037000,
                'time': '1986-10-18T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 542737800,
                'time': '1987-03-14T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          40:
              {
                'ts': 562091400,
                'time': '1987-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 574792200,
                'time': '1988-03-19T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          42:
              {
                'ts': 594145800,
                'time': '1988-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 606241800,
                'time': '1989-03-18T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          44:
              {
                'ts': 625595400,
                'time': '1989-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 637691400,
                'time': '1990-03-17T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': 657045000,
                'time': '1990-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 667931400,
                'time': '1991-03-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          48:
              {
                'ts': 688494600,
                'time': '1991-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 701195400,
                'time': '1992-03-21T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          50:
              {
                'ts': 719944200,
                'time': '1992-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 731435400,
                'time': '1993-03-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          52:
              {
                'ts': 751998600,
                'time': '1993-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 764094600,
                'time': '1994-03-19T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          54:
              {
                'ts': 783448200,
                'time': '1994-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 796149000,
                'time': '1995-03-25T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          56:
              {
                'ts': 814897800,
                'time': '1995-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 828203400,
                'time': '1996-03-30T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          58:
              {
                'ts': 846347400,
                'time': '1996-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 859653000,
                'time': '1997-03-29T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          60:
              {
                'ts': 877797000,
                'time': '1997-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 891102600,
                'time': '1998-03-28T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          62:
              {
                'ts': 909246600,
                'time': '1998-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 922552200,
                'time': '1999-03-27T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          64:
              {
                'ts': 941301000,
                'time': '1999-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 954001800,
                'time': '2000-03-25T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          66:
              {
                'ts': 972750600,
                'time': '2000-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 985451400,
                'time': '2001-03-24T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          68:
              {
                'ts': 1004200200,
                'time': '2001-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 1017505800,
                'time': '2002-03-30T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          70:
              {
                'ts': 1035649800,
                'time': '2002-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 1048955400,
                'time': '2003-03-29T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          72:
              {
                'ts': 1067099400,
                'time': '2003-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 1080405000,
                'time': '2004-03-27T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          74:
              {
                'ts': 1099153800,
                'time': '2004-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 1111854600,
                'time': '2005-03-26T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          76:
              {
                'ts': 1130603400,
                'time': '2005-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 1143909000,
                'time': '2006-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          78:
              {
                'ts': 1162053000,
                'time': '2006-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 1174753800,
                'time': '2007-03-24T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          80:
              {
                'ts': 1193502600,
                'time': '2007-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 1207413000,
                'time': '2008-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          82:
              {
                'ts': 1223137800,
                'time': '2008-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 1238862600,
                'time': '2009-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          84:
              {
                'ts': 1254587400,
                'time': '2009-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 1270312200,
                'time': '2010-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          86:
              {
                'ts': 1286037000,
                'time': '2010-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 1301761800,
                'time': '2011-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          88:
              {
                'ts': 1317486600,
                'time': '2011-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          89:
              {
                'ts': 1333211400,
                'time': '2012-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          90:
              {
                'ts': 1349541000,
                'time': '2012-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1365265800,
                'time': '2013-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          92:
              {
                'ts': 1380990600,
                'time': '2013-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1396715400,
                'time': '2014-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          94:
              {
                'ts': 1412440200,
                'time': '2014-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1428165000,
                'time': '2015-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          96:
              {
                'ts': 1443889800,
                'time': '2015-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1459614600,
                'time': '2016-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          98:
              {
                'ts': 1475339400,
                'time': '2016-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1491064200,
                'time': '2017-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          100:
              {
                'ts': 1506789000,
                'time': '2017-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1522513800,
                'time': '2018-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          102:
              {
                'ts': 1538843400,
                'time': '2018-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1554568200,
                'time': '2019-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          104:
              {
                'ts': 1570293000,
                'time': '2019-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1586017800,
                'time': '2020-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          106:
              {
                'ts': 1601742600,
                'time': '2020-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1617467400,
                'time': '2021-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          108:
              {
                'ts': 1633192200,
                'time': '2021-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1648917000,
                'time': '2022-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          110:
              {
                'ts': 1664641800,
                'time': '2022-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 1680366600,
                'time': '2023-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          112:
              {
                'ts': 1696091400,
                'time': '2023-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1712421000,
                'time': '2024-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          114:
              {
                'ts': 1728145800,
                'time': '2024-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1743870600,
                'time': '2025-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          116:
              {
                'ts': 1759595400,
                'time': '2025-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1775320200,
                'time': '2026-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          118:
              {
                'ts': 1791045000,
                'time': '2026-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1806769800,
                'time': '2027-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          120:
              {
                'ts': 1822494600,
                'time': '2027-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1838219400,
                'time': '2028-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          122:
              {
                'ts': 1853944200,
                'time': '2028-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 1869669000,
                'time': '2029-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          124:
              {
                'ts': 1885998600,
                'time': '2029-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 1901723400,
                'time': '2030-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          126:
              {
                'ts': 1917448200,
                'time': '2030-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 1933173000,
                'time': '2031-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          128:
              {
                'ts': 1948897800,
                'time': '2031-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 1964622600,
                'time': '2032-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          130:
              {
                'ts': 1980347400,
                'time': '2032-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 1996072200,
                'time': '2033-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          132:
              {
                'ts': 2011797000,
                'time': '2033-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 2027521800,
                'time': '2034-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          134:
              {
                'ts': 2043246600,
                'time': '2034-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 2058971400,
                'time': '2035-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          136:
              {
                'ts': 2075301000,
                'time': '2035-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 2091025800,
                'time': '2036-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          138:
              {
                'ts': 2106750600,
                'time': '2036-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 2122475400,
                'time': '2037-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          140:
              {
                'ts': 2138200200,
                'time': '2037-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              }
        },
    'Australia/Brisbane':
        {
          0:
              {
                'ts': -1672567140,
                'time': '1916-12-31T14:01:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -1665392400,
                'time': '1917-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -883641600,
                'time': '1941-12-31T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -876128400,
                'time': '1942-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -860400000,
                'time': '1942-09-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -844678800,
                'time': '1943-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -828345600,
                'time': '1943-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -813229200,
                'time': '1944-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 57686400,
                'time': '1971-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 67968000,
                'time': '1972-02-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 625593600,
                'time': '1989-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 636480000,
                'time': '1990-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 657043200,
                'time': '1990-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 667929600,
                'time': '1991-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 688492800,
                'time': '1991-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 699379200,
                'time': '1992-02-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'Australia/Broken_Hill':
        {
          0:
              {
                'ts': -1672565340,
                'time': '1916-12-31T14:31:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -1665390600,
                'time': '1917-03-24T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -883639800,
                'time': '1941-12-31T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          3:
              {
                'ts': -876126600,
                'time': '1942-03-28T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -860398200,
                'time': '1942-09-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          5:
              {
                'ts': -844677000,
                'time': '1943-03-27T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -828343800,
                'time': '1943-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -813227400,
                'time': '1944-03-25T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': 57688200,
                'time': '1971-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 67969800,
                'time': '1972-02-26T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': 89137800,
                'time': '1972-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 100024200,
                'time': '1973-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': 120587400,
                'time': '1973-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 131473800,
                'time': '1974-03-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          14:
              {
                'ts': 152037000,
                'time': '1974-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 162923400,
                'time': '1975-03-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          16:
              {
                'ts': 183486600,
                'time': '1975-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          17:
              {
                'ts': 194977800,
                'time': '1976-03-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          18:
              {
                'ts': 215541000,
                'time': '1976-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          19:
              {
                'ts': 226427400,
                'time': '1977-03-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          20:
              {
                'ts': 246990600,
                'time': '1977-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          21:
              {
                'ts': 257877000,
                'time': '1978-03-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          22:
              {
                'ts': 278440200,
                'time': '1978-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 289326600,
                'time': '1979-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          24:
              {
                'ts': 309889800,
                'time': '1979-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 320776200,
                'time': '1980-03-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          26:
              {
                'ts': 341339400,
                'time': '1980-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 352225800,
                'time': '1981-02-28T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          28:
              {
                'ts': 372789000,
                'time': '1981-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 386699400,
                'time': '1982-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          30:
              {
                'ts': 404843400,
                'time': '1982-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 415729800,
                'time': '1983-03-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          32:
              {
                'ts': 436293000,
                'time': '1983-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 447179400,
                'time': '1984-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          34:
              {
                'ts': 467742600,
                'time': '1984-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 478629000,
                'time': '1985-03-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          36:
              {
                'ts': 499192200,
                'time': '1985-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 511288200,
                'time': '1986-03-15T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': 530037000,
                'time': '1986-10-18T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 542737800,
                'time': '1987-03-14T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          40:
              {
                'ts': 562091400,
                'time': '1987-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 574792200,
                'time': '1988-03-19T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          42:
              {
                'ts': 594145800,
                'time': '1988-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 606241800,
                'time': '1989-03-18T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          44:
              {
                'ts': 625595400,
                'time': '1989-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 636481800,
                'time': '1990-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': 657045000,
                'time': '1990-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 667931400,
                'time': '1991-03-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          48:
              {
                'ts': 688494600,
                'time': '1991-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 699381000,
                'time': '1992-02-29T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          50:
              {
                'ts': 719944200,
                'time': '1992-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 731435400,
                'time': '1993-03-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          52:
              {
                'ts': 751998600,
                'time': '1993-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 762885000,
                'time': '1994-03-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          54:
              {
                'ts': 783448200,
                'time': '1994-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 794334600,
                'time': '1995-03-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          56:
              {
                'ts': 814897800,
                'time': '1995-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 828203400,
                'time': '1996-03-30T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          58:
              {
                'ts': 846347400,
                'time': '1996-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 859653000,
                'time': '1997-03-29T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          60:
              {
                'ts': 877797000,
                'time': '1997-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 891102600,
                'time': '1998-03-28T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          62:
              {
                'ts': 909246600,
                'time': '1998-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 922552200,
                'time': '1999-03-27T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          64:
              {
                'ts': 941301000,
                'time': '1999-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 946647000,
                'time': '1999-12-31T13:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          66:
              {
                'ts': 954001800,
                'time': '2000-03-25T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 972750600,
                'time': '2000-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          68:
              {
                'ts': 985451400,
                'time': '2001-03-24T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 1004200200,
                'time': '2001-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          70:
              {
                'ts': 1017505800,
                'time': '2002-03-30T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 1035649800,
                'time': '2002-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          72:
              {
                'ts': 1048955400,
                'time': '2003-03-29T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 1067099400,
                'time': '2003-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          74:
              {
                'ts': 1080405000,
                'time': '2004-03-27T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 1099153800,
                'time': '2004-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          76:
              {
                'ts': 1111854600,
                'time': '2005-03-26T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 1130603400,
                'time': '2005-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          78:
              {
                'ts': 1143909000,
                'time': '2006-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 1162053000,
                'time': '2006-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          80:
              {
                'ts': 1174753800,
                'time': '2007-03-24T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 1193502600,
                'time': '2007-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          82:
              {
                'ts': 1207413000,
                'time': '2008-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 1223137800,
                'time': '2008-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          84:
              {
                'ts': 1238862600,
                'time': '2009-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 1254587400,
                'time': '2009-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          86:
              {
                'ts': 1270312200,
                'time': '2010-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 1286037000,
                'time': '2010-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          88:
              {
                'ts': 1301761800,
                'time': '2011-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          89:
              {
                'ts': 1317486600,
                'time': '2011-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          90:
              {
                'ts': 1333211400,
                'time': '2012-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1349541000,
                'time': '2012-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          92:
              {
                'ts': 1365265800,
                'time': '2013-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1380990600,
                'time': '2013-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          94:
              {
                'ts': 1396715400,
                'time': '2014-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1412440200,
                'time': '2014-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          96:
              {
                'ts': 1428165000,
                'time': '2015-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1443889800,
                'time': '2015-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          98:
              {
                'ts': 1459614600,
                'time': '2016-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1475339400,
                'time': '2016-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          100:
              {
                'ts': 1491064200,
                'time': '2017-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1506789000,
                'time': '2017-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          102:
              {
                'ts': 1522513800,
                'time': '2018-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1538843400,
                'time': '2018-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          104:
              {
                'ts': 1554568200,
                'time': '2019-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1570293000,
                'time': '2019-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          106:
              {
                'ts': 1586017800,
                'time': '2020-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1601742600,
                'time': '2020-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          108:
              {
                'ts': 1617467400,
                'time': '2021-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1633192200,
                'time': '2021-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          110:
              {
                'ts': 1648917000,
                'time': '2022-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 1664641800,
                'time': '2022-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          112:
              {
                'ts': 1680366600,
                'time': '2023-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1696091400,
                'time': '2023-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          114:
              {
                'ts': 1712421000,
                'time': '2024-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1728145800,
                'time': '2024-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          116:
              {
                'ts': 1743870600,
                'time': '2025-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1759595400,
                'time': '2025-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          118:
              {
                'ts': 1775320200,
                'time': '2026-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1791045000,
                'time': '2026-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          120:
              {
                'ts': 1806769800,
                'time': '2027-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1822494600,
                'time': '2027-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          122:
              {
                'ts': 1838219400,
                'time': '2028-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 1853944200,
                'time': '2028-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          124:
              {
                'ts': 1869669000,
                'time': '2029-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 1885998600,
                'time': '2029-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          126:
              {
                'ts': 1901723400,
                'time': '2030-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 1917448200,
                'time': '2030-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          128:
              {
                'ts': 1933173000,
                'time': '2031-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 1948897800,
                'time': '2031-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          130:
              {
                'ts': 1964622600,
                'time': '2032-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 1980347400,
                'time': '2032-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          132:
              {
                'ts': 1996072200,
                'time': '2033-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 2011797000,
                'time': '2033-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          134:
              {
                'ts': 2027521800,
                'time': '2034-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 2043246600,
                'time': '2034-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          136:
              {
                'ts': 2058971400,
                'time': '2035-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 2075301000,
                'time': '2035-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          138:
              {
                'ts': 2091025800,
                'time': '2036-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 2106750600,
                'time': '2036-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          140:
              {
                'ts': 2122475400,
                'time': '2037-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          141:
              {
                'ts': 2138200200,
                'time': '2037-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              }
        },
    'Australia/Canberra':
        {
          0:
              {
                'ts': -1672567140,
                'time': '1916-12-31T14:01:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -1665392400,
                'time': '1917-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -883641600,
                'time': '1941-12-31T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -876128400,
                'time': '1942-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -860400000,
                'time': '1942-09-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -844678800,
                'time': '1943-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -828345600,
                'time': '1943-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -813229200,
                'time': '1944-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 57686400,
                'time': '1971-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 67968000,
                'time': '1972-02-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 89136000,
                'time': '1972-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 100022400,
                'time': '1973-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 120585600,
                'time': '1973-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 131472000,
                'time': '1974-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 152035200,
                'time': '1974-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 162921600,
                'time': '1975-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 183484800,
                'time': '1975-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 194976000,
                'time': '1976-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 215539200,
                'time': '1976-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 226425600,
                'time': '1977-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 246988800,
                'time': '1977-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 257875200,
                'time': '1978-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': 278438400,
                'time': '1978-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 289324800,
                'time': '1979-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': 309888000,
                'time': '1979-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 320774400,
                'time': '1980-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 341337600,
                'time': '1980-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 352224000,
                'time': '1981-02-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 372787200,
                'time': '1981-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 386697600,
                'time': '1982-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 404841600,
                'time': '1982-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 415728000,
                'time': '1983-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 436291200,
                'time': '1983-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 447177600,
                'time': '1984-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 467740800,
                'time': '1984-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 478627200,
                'time': '1985-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 499190400,
                'time': '1985-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 511286400,
                'time': '1986-03-15T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 530035200,
                'time': '1986-10-18T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 542736000,
                'time': '1987-03-14T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 562089600,
                'time': '1987-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 574790400,
                'time': '1988-03-19T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 594144000,
                'time': '1988-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 606240000,
                'time': '1989-03-18T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 625593600,
                'time': '1989-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 636480000,
                'time': '1990-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 657043200,
                'time': '1990-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 667929600,
                'time': '1991-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 688492800,
                'time': '1991-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 699379200,
                'time': '1992-02-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 719942400,
                'time': '1992-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 731433600,
                'time': '1993-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 751996800,
                'time': '1993-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 762883200,
                'time': '1994-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 783446400,
                'time': '1994-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 794332800,
                'time': '1995-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 814896000,
                'time': '1995-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 828201600,
                'time': '1996-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 846345600,
                'time': '1996-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 859651200,
                'time': '1997-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 877795200,
                'time': '1997-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 909244800,
                'time': '1998-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 922550400,
                'time': '1999-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 941299200,
                'time': '1999-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 954000000,
                'time': '2000-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 967305600,
                'time': '2000-08-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 985449600,
                'time': '2001-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1004198400,
                'time': '2001-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 1017504000,
                'time': '2002-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1035648000,
                'time': '2002-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 1048953600,
                'time': '2003-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1067097600,
                'time': '2003-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 1080403200,
                'time': '2004-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1099152000,
                'time': '2004-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1111852800,
                'time': '2005-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1130601600,
                'time': '2005-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1143907200,
                'time': '2006-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1162051200,
                'time': '2006-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1174752000,
                'time': '2007-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1193500800,
                'time': '2007-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1207411200,
                'time': '2008-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1223136000,
                'time': '2008-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1238860800,
                'time': '2009-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1254585600,
                'time': '2009-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1270310400,
                'time': '2010-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1286035200,
                'time': '2010-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1301760000,
                'time': '2011-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1317484800,
                'time': '2011-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1333209600,
                'time': '2012-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1349539200,
                'time': '2012-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1365264000,
                'time': '2013-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1380988800,
                'time': '2013-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1396713600,
                'time': '2014-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1412438400,
                'time': '2014-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1428163200,
                'time': '2015-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1443888000,
                'time': '2015-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1459612800,
                'time': '2016-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 1475337600,
                'time': '2016-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1491062400,
                'time': '2017-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 1506787200,
                'time': '2017-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1522512000,
                'time': '2018-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 1538841600,
                'time': '2018-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1554566400,
                'time': '2019-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 1570291200,
                'time': '2019-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1586016000,
                'time': '2020-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 1601740800,
                'time': '2020-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1617465600,
                'time': '2021-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 1633190400,
                'time': '2021-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1648915200,
                'time': '2022-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 1664640000,
                'time': '2022-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1680364800,
                'time': '2023-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 1696089600,
                'time': '2023-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1712419200,
                'time': '2024-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 1728144000,
                'time': '2024-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1743868800,
                'time': '2025-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 1759593600,
                'time': '2025-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1775318400,
                'time': '2026-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 1791043200,
                'time': '2026-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1806768000,
                'time': '2027-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 1822492800,
                'time': '2027-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1838217600,
                'time': '2028-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 1853942400,
                'time': '2028-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1869667200,
                'time': '2029-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 1885996800,
                'time': '2029-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1901721600,
                'time': '2030-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 1917446400,
                'time': '2030-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1933171200,
                'time': '2031-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 1948896000,
                'time': '2031-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1964620800,
                'time': '2032-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 1980345600,
                'time': '2032-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1996070400,
                'time': '2033-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 2011795200,
                'time': '2033-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 2027520000,
                'time': '2034-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 2043244800,
                'time': '2034-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 2058969600,
                'time': '2035-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 2075299200,
                'time': '2035-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 2091024000,
                'time': '2036-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          138:
              {
                'ts': 2106748800,
                'time': '2036-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 2122473600,
                'time': '2037-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          140:
              {
                'ts': 2138198400,
                'time': '2037-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              }
        },
    'Australia/Currie':
        {
          0:
              {
                'ts': -1680508800,
                'time': '1916-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -1665392400,
                'time': '1917-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -883641600,
                'time': '1941-12-31T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -876128400,
                'time': '1942-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -860400000,
                'time': '1942-09-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -844678800,
                'time': '1943-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -828345600,
                'time': '1943-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -813229200,
                'time': '1944-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 57686400,
                'time': '1971-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 67968000,
                'time': '1972-02-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 89136000,
                'time': '1972-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 100022400,
                'time': '1973-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 120585600,
                'time': '1973-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 131472000,
                'time': '1974-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 152035200,
                'time': '1974-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 162921600,
                'time': '1975-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 183484800,
                'time': '1975-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 194976000,
                'time': '1976-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 215539200,
                'time': '1976-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 226425600,
                'time': '1977-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 246988800,
                'time': '1977-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 257875200,
                'time': '1978-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': 278438400,
                'time': '1978-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 289324800,
                'time': '1979-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': 309888000,
                'time': '1979-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 320774400,
                'time': '1980-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 341337600,
                'time': '1980-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 352224000,
                'time': '1981-02-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 372787200,
                'time': '1981-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 386092800,
                'time': '1982-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 404841600,
                'time': '1982-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 417542400,
                'time': '1983-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 436291200,
                'time': '1983-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 447177600,
                'time': '1984-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 467740800,
                'time': '1984-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 478627200,
                'time': '1985-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 499190400,
                'time': '1985-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 510076800,
                'time': '1986-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 530035200,
                'time': '1986-10-18T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 542736000,
                'time': '1987-03-14T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 562089600,
                'time': '1987-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 574790400,
                'time': '1988-03-19T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 594144000,
                'time': '1988-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 606240000,
                'time': '1989-03-18T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 625593600,
                'time': '1989-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 637689600,
                'time': '1990-03-17T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 657043200,
                'time': '1990-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 670348800,
                'time': '1991-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 686678400,
                'time': '1991-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 701798400,
                'time': '1992-03-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 718128000,
                'time': '1992-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 733248000,
                'time': '1993-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 749577600,
                'time': '1993-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 764697600,
                'time': '1994-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 781027200,
                'time': '1994-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 796147200,
                'time': '1995-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 812476800,
                'time': '1995-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 828201600,
                'time': '1996-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 844531200,
                'time': '1996-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 859651200,
                'time': '1997-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 875980800,
                'time': '1997-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 907430400,
                'time': '1998-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 922550400,
                'time': '1999-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 938880000,
                'time': '1999-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 954000000,
                'time': '2000-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 967305600,
                'time': '2000-08-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 985449600,
                'time': '2001-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1002384000,
                'time': '2001-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 1017504000,
                'time': '2002-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1033833600,
                'time': '2002-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 1048953600,
                'time': '2003-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1065283200,
                'time': '2003-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 1080403200,
                'time': '2004-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1096732800,
                'time': '2004-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1111852800,
                'time': '2005-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1128182400,
                'time': '2005-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1143907200,
                'time': '2006-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1159632000,
                'time': '2006-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1174752000,
                'time': '2007-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1191686400,
                'time': '2007-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1207411200,
                'time': '2008-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1223136000,
                'time': '2008-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1238860800,
                'time': '2009-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1254585600,
                'time': '2009-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1270310400,
                'time': '2010-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1286035200,
                'time': '2010-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1301760000,
                'time': '2011-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1317484800,
                'time': '2011-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1333209600,
                'time': '2012-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1349539200,
                'time': '2012-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1365264000,
                'time': '2013-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1380988800,
                'time': '2013-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1396713600,
                'time': '2014-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1412438400,
                'time': '2014-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1428163200,
                'time': '2015-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1443888000,
                'time': '2015-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1459612800,
                'time': '2016-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 1475337600,
                'time': '2016-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1491062400,
                'time': '2017-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 1506787200,
                'time': '2017-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1522512000,
                'time': '2018-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 1538841600,
                'time': '2018-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1554566400,
                'time': '2019-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 1570291200,
                'time': '2019-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1586016000,
                'time': '2020-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 1601740800,
                'time': '2020-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1617465600,
                'time': '2021-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 1633190400,
                'time': '2021-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1648915200,
                'time': '2022-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 1664640000,
                'time': '2022-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1680364800,
                'time': '2023-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 1696089600,
                'time': '2023-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1712419200,
                'time': '2024-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 1728144000,
                'time': '2024-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1743868800,
                'time': '2025-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 1759593600,
                'time': '2025-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1775318400,
                'time': '2026-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 1791043200,
                'time': '2026-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1806768000,
                'time': '2027-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 1822492800,
                'time': '2027-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1838217600,
                'time': '2028-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 1853942400,
                'time': '2028-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1869667200,
                'time': '2029-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 1885996800,
                'time': '2029-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1901721600,
                'time': '2030-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 1917446400,
                'time': '2030-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1933171200,
                'time': '2031-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 1948896000,
                'time': '2031-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1964620800,
                'time': '2032-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 1980345600,
                'time': '2032-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1996070400,
                'time': '2033-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 2011795200,
                'time': '2033-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 2027520000,
                'time': '2034-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 2043244800,
                'time': '2034-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 2058969600,
                'time': '2035-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 2075299200,
                'time': '2035-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 2091024000,
                'time': '2036-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          138:
              {
                'ts': 2106748800,
                'time': '2036-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 2122473600,
                'time': '2037-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          140:
              {
                'ts': 2138198400,
                'time': '2037-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              }
        },
    'Australia/Darwin':
        {
          0:
              {
                'ts': -1672565340,
                'time': '1916-12-31T14:31:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -1665390600,
                'time': '1917-03-24T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -883639800,
                'time': '1941-12-31T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          3:
              {
                'ts': -876126600,
                'time': '1942-03-28T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -860398200,
                'time': '1942-09-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          5:
              {
                'ts': -844677000,
                'time': '1943-03-27T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -828343800,
                'time': '1943-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -813227400,
                'time': '1944-03-25T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Australia/Eucla':
        {
          0:
              {
                'ts': -1672562640,
                'time': '1916-12-31T15:16:00+0000',
                'offset': 35100,
                'isdst': true,
                'abbr': 'CWST'
              },
          1:
              {
                'ts': -1665387900,
                'time': '1917-03-24T16:15:00+0000',
                'offset': 31500,
                'isdst': false,
                'abbr': 'CWST'
              },
          2:
              {
                'ts': -883637100,
                'time': '1941-12-31T17:15:00+0000',
                'offset': 35100,
                'isdst': true,
                'abbr': 'CWST'
              },
          3:
              {
                'ts': -876123900,
                'time': '1942-03-28T16:15:00+0000',
                'offset': 31500,
                'isdst': false,
                'abbr': 'CWST'
              },
          4:
              {
                'ts': -860395500,
                'time': '1942-09-26T17:15:00+0000',
                'offset': 35100,
                'isdst': true,
                'abbr': 'CWST'
              },
          5:
              {
                'ts': -844674300,
                'time': '1943-03-27T16:15:00+0000',
                'offset': 31500,
                'isdst': false,
                'abbr': 'CWST'
              },
          6:
              {
                'ts': 152039700,
                'time': '1974-10-26T17:15:00+0000',
                'offset': 35100,
                'isdst': true,
                'abbr': 'CWST'
              },
          7:
              {
                'ts': 162926100,
                'time': '1975-03-01T17:15:00+0000',
                'offset': 31500,
                'isdst': false,
                'abbr': 'CWST'
              },
          8:
              {
                'ts': 436295700,
                'time': '1983-10-29T17:15:00+0000',
                'offset': 35100,
                'isdst': true,
                'abbr': 'CWST'
              },
          9:
              {
                'ts': 447182100,
                'time': '1984-03-03T17:15:00+0000',
                'offset': 31500,
                'isdst': false,
                'abbr': 'CWST'
              },
          10:
              {
                'ts': 690311700,
                'time': '1991-11-16T17:15:00+0000',
                'offset': 35100,
                'isdst': true,
                'abbr': 'CWST'
              },
          11:
              {
                'ts': 699383700,
                'time': '1992-02-29T17:15:00+0000',
                'offset': 31500,
                'isdst': false,
                'abbr': 'CWST'
              },
          12:
              {
                'ts': 1165079700,
                'time': '2006-12-02T17:15:00+0000',
                'offset': 35100,
                'isdst': true,
                'abbr': 'CWST'
              },
          13:
              {
                'ts': 1174756500,
                'time': '2007-03-24T17:15:00+0000',
                'offset': 31500,
                'isdst': false,
                'abbr': 'CWST'
              },
          14:
              {
                'ts': 1193505300,
                'time': '2007-10-27T17:15:00+0000',
                'offset': 35100,
                'isdst': true,
                'abbr': 'CWST'
              },
          15:
              {
                'ts': 1206810900,
                'time': '2008-03-29T17:15:00+0000',
                'offset': 31500,
                'isdst': false,
                'abbr': 'CWST'
              },
          16:
              {
                'ts': 1224954900,
                'time': '2008-10-25T17:15:00+0000',
                'offset': 35100,
                'isdst': true,
                'abbr': 'CWST'
              },
          17:
              {
                'ts': 1238260500,
                'time': '2009-03-28T17:15:00+0000',
                'offset': 31500,
                'isdst': false,
                'abbr': 'CWST'
              }
        },
    'Australia/Hobart':
        {
          0:
              {
                'ts': -1680508800,
                'time': '1916-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -1665392400,
                'time': '1917-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -883641600,
                'time': '1941-12-31T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -876128400,
                'time': '1942-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -860400000,
                'time': '1942-09-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -844678800,
                'time': '1943-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -828345600,
                'time': '1943-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -813229200,
                'time': '1944-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': -71136000,
                'time': '1967-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          9:
              {
                'ts': -55411200,
                'time': '1968-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': -37267200,
                'time': '1968-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          11:
              {
                'ts': -25776000,
                'time': '1969-03-08T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': -5817600,
                'time': '1969-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 5673600,
                'time': '1970-03-07T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 25632000,
                'time': '1970-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 37728000,
                'time': '1971-03-13T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 57686400,
                'time': '1971-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 67968000,
                'time': '1972-02-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 89136000,
                'time': '1972-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 100022400,
                'time': '1973-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 120585600,
                'time': '1973-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 131472000,
                'time': '1974-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': 152035200,
                'time': '1974-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 162921600,
                'time': '1975-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': 183484800,
                'time': '1975-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 194976000,
                'time': '1976-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 215539200,
                'time': '1976-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 226425600,
                'time': '1977-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 246988800,
                'time': '1977-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 257875200,
                'time': '1978-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 278438400,
                'time': '1978-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 289324800,
                'time': '1979-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 309888000,
                'time': '1979-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 320774400,
                'time': '1980-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 341337600,
                'time': '1980-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 352224000,
                'time': '1981-02-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 372787200,
                'time': '1981-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 386092800,
                'time': '1982-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 404841600,
                'time': '1982-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 417542400,
                'time': '1983-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 436291200,
                'time': '1983-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 447177600,
                'time': '1984-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 467740800,
                'time': '1984-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 478627200,
                'time': '1985-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 499190400,
                'time': '1985-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 510076800,
                'time': '1986-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 530035200,
                'time': '1986-10-18T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 542736000,
                'time': '1987-03-14T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 562089600,
                'time': '1987-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 574790400,
                'time': '1988-03-19T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 594144000,
                'time': '1988-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 606240000,
                'time': '1989-03-18T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 625593600,
                'time': '1989-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 637689600,
                'time': '1990-03-17T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 657043200,
                'time': '1990-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 670348800,
                'time': '1991-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 686678400,
                'time': '1991-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 701798400,
                'time': '1992-03-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 718128000,
                'time': '1992-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 733248000,
                'time': '1993-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 749577600,
                'time': '1993-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 764697600,
                'time': '1994-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 781027200,
                'time': '1994-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 796147200,
                'time': '1995-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 812476800,
                'time': '1995-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 828201600,
                'time': '1996-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 844531200,
                'time': '1996-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 859651200,
                'time': '1997-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 875980800,
                'time': '1997-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 907430400,
                'time': '1998-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 922550400,
                'time': '1999-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 938880000,
                'time': '1999-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 954000000,
                'time': '2000-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 967305600,
                'time': '2000-08-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 985449600,
                'time': '2001-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1002384000,
                'time': '2001-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1017504000,
                'time': '2002-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1033833600,
                'time': '2002-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1048953600,
                'time': '2003-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1065283200,
                'time': '2003-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1080403200,
                'time': '2004-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1096732800,
                'time': '2004-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1111852800,
                'time': '2005-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1128182400,
                'time': '2005-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1143907200,
                'time': '2006-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1159632000,
                'time': '2006-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1174752000,
                'time': '2007-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1191686400,
                'time': '2007-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1207411200,
                'time': '2008-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1223136000,
                'time': '2008-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1238860800,
                'time': '2009-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1254585600,
                'time': '2009-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1270310400,
                'time': '2010-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1286035200,
                'time': '2010-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1301760000,
                'time': '2011-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1317484800,
                'time': '2011-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1333209600,
                'time': '2012-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 1349539200,
                'time': '2012-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1365264000,
                'time': '2013-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 1380988800,
                'time': '2013-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1396713600,
                'time': '2014-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 1412438400,
                'time': '2014-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1428163200,
                'time': '2015-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 1443888000,
                'time': '2015-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1459612800,
                'time': '2016-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 1475337600,
                'time': '2016-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1491062400,
                'time': '2017-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 1506787200,
                'time': '2017-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1522512000,
                'time': '2018-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 1538841600,
                'time': '2018-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1554566400,
                'time': '2019-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 1570291200,
                'time': '2019-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1586016000,
                'time': '2020-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 1601740800,
                'time': '2020-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1617465600,
                'time': '2021-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 1633190400,
                'time': '2021-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1648915200,
                'time': '2022-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 1664640000,
                'time': '2022-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1680364800,
                'time': '2023-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 1696089600,
                'time': '2023-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1712419200,
                'time': '2024-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 1728144000,
                'time': '2024-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1743868800,
                'time': '2025-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 1759593600,
                'time': '2025-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1775318400,
                'time': '2026-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 1791043200,
                'time': '2026-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1806768000,
                'time': '2027-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 1822492800,
                'time': '2027-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1838217600,
                'time': '2028-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 1853942400,
                'time': '2028-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1869667200,
                'time': '2029-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 1885996800,
                'time': '2029-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 1901721600,
                'time': '2030-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 1917446400,
                'time': '2030-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 1933171200,
                'time': '2031-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 1948896000,
                'time': '2031-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 1964620800,
                'time': '2032-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          138:
              {
                'ts': 1980345600,
                'time': '2032-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 1996070400,
                'time': '2033-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          140:
              {
                'ts': 2011795200,
                'time': '2033-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          141:
              {
                'ts': 2027520000,
                'time': '2034-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          142:
              {
                'ts': 2043244800,
                'time': '2034-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          143:
              {
                'ts': 2058969600,
                'time': '2035-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          144:
              {
                'ts': 2075299200,
                'time': '2035-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          145:
              {
                'ts': 2091024000,
                'time': '2036-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          146:
              {
                'ts': 2106748800,
                'time': '2036-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          147:
              {
                'ts': 2122473600,
                'time': '2037-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          148:
              {
                'ts': 2138198400,
                'time': '2037-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              }
        },
    'Australia/LHI':
        {
          0:
              {
                'ts': 352216800,
                'time': '1981-02-28T14:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          1:
              {
                'ts': 372785400,
                'time': '1981-10-24T15:30:00+0000',
                'offset': 41400,
                'isdst': true,
                'abbr': 'LHST'
              },
          2:
              {
                'ts': 384273000,
                'time': '1982-03-06T14:30:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          3:
              {
                'ts': 404839800,
                'time': '1982-10-30T15:30:00+0000',
                'offset': 41400,
                'isdst': true,
                'abbr': 'LHST'
              },
          4:
              {
                'ts': 415722600,
                'time': '1983-03-05T14:30:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          5:
              {
                'ts': 436289400,
                'time': '1983-10-29T15:30:00+0000',
                'offset': 41400,
                'isdst': true,
                'abbr': 'LHST'
              },
          6:
              {
                'ts': 447172200,
                'time': '1984-03-03T14:30:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          7:
              {
                'ts': 467739000,
                'time': '1984-10-27T15:30:00+0000',
                'offset': 41400,
                'isdst': true,
                'abbr': 'LHST'
              },
          8:
              {
                'ts': 478621800,
                'time': '1985-03-02T14:30:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          9:
              {
                'ts': 499188600,
                'time': '1985-10-26T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          10:
              {
                'ts': 511282800,
                'time': '1986-03-15T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          11:
              {
                'ts': 530033400,
                'time': '1986-10-18T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          12:
              {
                'ts': 542732400,
                'time': '1987-03-14T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          13:
              {
                'ts': 562087800,
                'time': '1987-10-24T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          14:
              {
                'ts': 574786800,
                'time': '1988-03-19T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          15:
              {
                'ts': 594142200,
                'time': '1988-10-29T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          16:
              {
                'ts': 606236400,
                'time': '1989-03-18T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          17:
              {
                'ts': 625591800,
                'time': '1989-10-28T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          18:
              {
                'ts': 636476400,
                'time': '1990-03-03T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          19:
              {
                'ts': 657041400,
                'time': '1990-10-27T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          20:
              {
                'ts': 667926000,
                'time': '1991-03-02T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          21:
              {
                'ts': 688491000,
                'time': '1991-10-26T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          22:
              {
                'ts': 699375600,
                'time': '1992-02-29T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          23:
              {
                'ts': 719940600,
                'time': '1992-10-24T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          24:
              {
                'ts': 731430000,
                'time': '1993-03-06T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          25:
              {
                'ts': 751995000,
                'time': '1993-10-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          26:
              {
                'ts': 762879600,
                'time': '1994-03-05T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          27:
              {
                'ts': 783444600,
                'time': '1994-10-29T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          28:
              {
                'ts': 794329200,
                'time': '1995-03-04T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          29:
              {
                'ts': 814894200,
                'time': '1995-10-28T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          30:
              {
                'ts': 828198000,
                'time': '1996-03-30T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          31:
              {
                'ts': 846343800,
                'time': '1996-10-26T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          32:
              {
                'ts': 859647600,
                'time': '1997-03-29T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          33:
              {
                'ts': 877793400,
                'time': '1997-10-25T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          34:
              {
                'ts': 891097200,
                'time': '1998-03-28T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          35:
              {
                'ts': 909243000,
                'time': '1998-10-24T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          36:
              {
                'ts': 922546800,
                'time': '1999-03-27T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          37:
              {
                'ts': 941297400,
                'time': '1999-10-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          38:
              {
                'ts': 953996400,
                'time': '2000-03-25T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          39:
              {
                'ts': 967303800,
                'time': '2000-08-26T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          40:
              {
                'ts': 985446000,
                'time': '2001-03-24T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          41:
              {
                'ts': 1004196600,
                'time': '2001-10-27T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          42:
              {
                'ts': 1017500400,
                'time': '2002-03-30T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          43:
              {
                'ts': 1035646200,
                'time': '2002-10-26T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          44:
              {
                'ts': 1048950000,
                'time': '2003-03-29T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          45:
              {
                'ts': 1067095800,
                'time': '2003-10-25T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          46:
              {
                'ts': 1080399600,
                'time': '2004-03-27T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          47:
              {
                'ts': 1099150200,
                'time': '2004-10-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          48:
              {
                'ts': 1111849200,
                'time': '2005-03-26T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          49:
              {
                'ts': 1130599800,
                'time': '2005-10-29T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          50:
              {
                'ts': 1143903600,
                'time': '2006-04-01T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          51:
              {
                'ts': 1162049400,
                'time': '2006-10-28T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          52:
              {
                'ts': 1174748400,
                'time': '2007-03-24T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          53:
              {
                'ts': 1193499000,
                'time': '2007-10-27T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          54:
              {
                'ts': 1207407600,
                'time': '2008-04-05T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          55:
              {
                'ts': 1223134200,
                'time': '2008-10-04T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          56:
              {
                'ts': 1238857200,
                'time': '2009-04-04T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          57:
              {
                'ts': 1254583800,
                'time': '2009-10-03T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          58:
              {
                'ts': 1270306800,
                'time': '2010-04-03T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          59:
              {
                'ts': 1286033400,
                'time': '2010-10-02T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          60:
              {
                'ts': 1301756400,
                'time': '2011-04-02T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          61:
              {
                'ts': 1317483000,
                'time': '2011-10-01T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          62:
              {
                'ts': 1333206000,
                'time': '2012-03-31T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          63:
              {
                'ts': 1349537400,
                'time': '2012-10-06T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          64:
              {
                'ts': 1365260400,
                'time': '2013-04-06T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          65:
              {
                'ts': 1380987000,
                'time': '2013-10-05T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          66:
              {
                'ts': 1396710000,
                'time': '2014-04-05T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          67:
              {
                'ts': 1412436600,
                'time': '2014-10-04T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          68:
              {
                'ts': 1428159600,
                'time': '2015-04-04T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          69:
              {
                'ts': 1443886200,
                'time': '2015-10-03T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          70:
              {
                'ts': 1459609200,
                'time': '2016-04-02T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          71:
              {
                'ts': 1475335800,
                'time': '2016-10-01T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          72:
              {
                'ts': 1491058800,
                'time': '2017-04-01T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          73:
              {
                'ts': 1506785400,
                'time': '2017-09-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          74:
              {
                'ts': 1522508400,
                'time': '2018-03-31T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          75:
              {
                'ts': 1538839800,
                'time': '2018-10-06T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          76:
              {
                'ts': 1554562800,
                'time': '2019-04-06T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          77:
              {
                'ts': 1570289400,
                'time': '2019-10-05T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          78:
              {
                'ts': 1586012400,
                'time': '2020-04-04T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          79:
              {
                'ts': 1601739000,
                'time': '2020-10-03T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          80:
              {
                'ts': 1617462000,
                'time': '2021-04-03T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          81:
              {
                'ts': 1633188600,
                'time': '2021-10-02T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          82:
              {
                'ts': 1648911600,
                'time': '2022-04-02T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          83:
              {
                'ts': 1664638200,
                'time': '2022-10-01T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          84:
              {
                'ts': 1680361200,
                'time': '2023-04-01T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          85:
              {
                'ts': 1696087800,
                'time': '2023-09-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          86:
              {
                'ts': 1712415600,
                'time': '2024-04-06T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          87:
              {
                'ts': 1728142200,
                'time': '2024-10-05T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          88:
              {
                'ts': 1743865200,
                'time': '2025-04-05T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          89:
              {
                'ts': 1759591800,
                'time': '2025-10-04T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          90:
              {
                'ts': 1775314800,
                'time': '2026-04-04T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          91:
              {
                'ts': 1791041400,
                'time': '2026-10-03T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          92:
              {
                'ts': 1806764400,
                'time': '2027-04-03T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          93:
              {
                'ts': 1822491000,
                'time': '2027-10-02T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          94:
              {
                'ts': 1838214000,
                'time': '2028-04-01T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          95:
              {
                'ts': 1853940600,
                'time': '2028-09-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          96:
              {
                'ts': 1869663600,
                'time': '2029-03-31T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          97:
              {
                'ts': 1885995000,
                'time': '2029-10-06T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          98:
              {
                'ts': 1901718000,
                'time': '2030-04-06T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          99:
              {
                'ts': 1917444600,
                'time': '2030-10-05T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          100:
              {
                'ts': 1933167600,
                'time': '2031-04-05T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          101:
              {
                'ts': 1948894200,
                'time': '2031-10-04T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          102:
              {
                'ts': 1964617200,
                'time': '2032-04-03T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          103:
              {
                'ts': 1980343800,
                'time': '2032-10-02T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          104:
              {
                'ts': 1996066800,
                'time': '2033-04-02T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          105:
              {
                'ts': 2011793400,
                'time': '2033-10-01T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          106:
              {
                'ts': 2027516400,
                'time': '2034-04-01T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          107:
              {
                'ts': 2043243000,
                'time': '2034-09-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          108:
              {
                'ts': 2058966000,
                'time': '2035-03-31T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          109:
              {
                'ts': 2075297400,
                'time': '2035-10-06T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          110:
              {
                'ts': 2091020400,
                'time': '2036-04-05T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          111:
              {
                'ts': 2106747000,
                'time': '2036-10-04T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          112:
              {
                'ts': 2122470000,
                'time': '2037-04-04T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          113:
              {
                'ts': 2138196600,
                'time': '2037-10-03T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              }
        },
    'Australia/Lindeman':
        {
          0:
              {
                'ts': -1672567140,
                'time': '1916-12-31T14:01:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -1665392400,
                'time': '1917-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -883641600,
                'time': '1941-12-31T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -876128400,
                'time': '1942-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -860400000,
                'time': '1942-09-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -844678800,
                'time': '1943-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -828345600,
                'time': '1943-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -813229200,
                'time': '1944-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 57686400,
                'time': '1971-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 67968000,
                'time': '1972-02-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 625593600,
                'time': '1989-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 636480000,
                'time': '1990-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 657043200,
                'time': '1990-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 667929600,
                'time': '1991-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 688492800,
                'time': '1991-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 699379200,
                'time': '1992-02-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 709912800,
                'time': '1992-06-30T14:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 719942400,
                'time': '1992-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 731433600,
                'time': '1993-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 751996800,
                'time': '1993-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 762883200,
                'time': '1994-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'Australia/Lord_Howe':
        {
          0:
              {
                'ts': 352216800,
                'time': '1981-02-28T14:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          1:
              {
                'ts': 372785400,
                'time': '1981-10-24T15:30:00+0000',
                'offset': 41400,
                'isdst': true,
                'abbr': 'LHST'
              },
          2:
              {
                'ts': 384273000,
                'time': '1982-03-06T14:30:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          3:
              {
                'ts': 404839800,
                'time': '1982-10-30T15:30:00+0000',
                'offset': 41400,
                'isdst': true,
                'abbr': 'LHST'
              },
          4:
              {
                'ts': 415722600,
                'time': '1983-03-05T14:30:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          5:
              {
                'ts': 436289400,
                'time': '1983-10-29T15:30:00+0000',
                'offset': 41400,
                'isdst': true,
                'abbr': 'LHST'
              },
          6:
              {
                'ts': 447172200,
                'time': '1984-03-03T14:30:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          7:
              {
                'ts': 467739000,
                'time': '1984-10-27T15:30:00+0000',
                'offset': 41400,
                'isdst': true,
                'abbr': 'LHST'
              },
          8:
              {
                'ts': 478621800,
                'time': '1985-03-02T14:30:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          9:
              {
                'ts': 499188600,
                'time': '1985-10-26T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          10:
              {
                'ts': 511282800,
                'time': '1986-03-15T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          11:
              {
                'ts': 530033400,
                'time': '1986-10-18T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          12:
              {
                'ts': 542732400,
                'time': '1987-03-14T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          13:
              {
                'ts': 562087800,
                'time': '1987-10-24T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          14:
              {
                'ts': 574786800,
                'time': '1988-03-19T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          15:
              {
                'ts': 594142200,
                'time': '1988-10-29T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          16:
              {
                'ts': 606236400,
                'time': '1989-03-18T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          17:
              {
                'ts': 625591800,
                'time': '1989-10-28T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          18:
              {
                'ts': 636476400,
                'time': '1990-03-03T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          19:
              {
                'ts': 657041400,
                'time': '1990-10-27T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          20:
              {
                'ts': 667926000,
                'time': '1991-03-02T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          21:
              {
                'ts': 688491000,
                'time': '1991-10-26T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          22:
              {
                'ts': 699375600,
                'time': '1992-02-29T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          23:
              {
                'ts': 719940600,
                'time': '1992-10-24T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          24:
              {
                'ts': 731430000,
                'time': '1993-03-06T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          25:
              {
                'ts': 751995000,
                'time': '1993-10-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          26:
              {
                'ts': 762879600,
                'time': '1994-03-05T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          27:
              {
                'ts': 783444600,
                'time': '1994-10-29T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          28:
              {
                'ts': 794329200,
                'time': '1995-03-04T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          29:
              {
                'ts': 814894200,
                'time': '1995-10-28T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          30:
              {
                'ts': 828198000,
                'time': '1996-03-30T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          31:
              {
                'ts': 846343800,
                'time': '1996-10-26T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          32:
              {
                'ts': 859647600,
                'time': '1997-03-29T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          33:
              {
                'ts': 877793400,
                'time': '1997-10-25T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          34:
              {
                'ts': 891097200,
                'time': '1998-03-28T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          35:
              {
                'ts': 909243000,
                'time': '1998-10-24T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          36:
              {
                'ts': 922546800,
                'time': '1999-03-27T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          37:
              {
                'ts': 941297400,
                'time': '1999-10-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          38:
              {
                'ts': 953996400,
                'time': '2000-03-25T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          39:
              {
                'ts': 967303800,
                'time': '2000-08-26T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          40:
              {
                'ts': 985446000,
                'time': '2001-03-24T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          41:
              {
                'ts': 1004196600,
                'time': '2001-10-27T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          42:
              {
                'ts': 1017500400,
                'time': '2002-03-30T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          43:
              {
                'ts': 1035646200,
                'time': '2002-10-26T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          44:
              {
                'ts': 1048950000,
                'time': '2003-03-29T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          45:
              {
                'ts': 1067095800,
                'time': '2003-10-25T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          46:
              {
                'ts': 1080399600,
                'time': '2004-03-27T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          47:
              {
                'ts': 1099150200,
                'time': '2004-10-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          48:
              {
                'ts': 1111849200,
                'time': '2005-03-26T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          49:
              {
                'ts': 1130599800,
                'time': '2005-10-29T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          50:
              {
                'ts': 1143903600,
                'time': '2006-04-01T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          51:
              {
                'ts': 1162049400,
                'time': '2006-10-28T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          52:
              {
                'ts': 1174748400,
                'time': '2007-03-24T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          53:
              {
                'ts': 1193499000,
                'time': '2007-10-27T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          54:
              {
                'ts': 1207407600,
                'time': '2008-04-05T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          55:
              {
                'ts': 1223134200,
                'time': '2008-10-04T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          56:
              {
                'ts': 1238857200,
                'time': '2009-04-04T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          57:
              {
                'ts': 1254583800,
                'time': '2009-10-03T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          58:
              {
                'ts': 1270306800,
                'time': '2010-04-03T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          59:
              {
                'ts': 1286033400,
                'time': '2010-10-02T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          60:
              {
                'ts': 1301756400,
                'time': '2011-04-02T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          61:
              {
                'ts': 1317483000,
                'time': '2011-10-01T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          62:
              {
                'ts': 1333206000,
                'time': '2012-03-31T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          63:
              {
                'ts': 1349537400,
                'time': '2012-10-06T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          64:
              {
                'ts': 1365260400,
                'time': '2013-04-06T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          65:
              {
                'ts': 1380987000,
                'time': '2013-10-05T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          66:
              {
                'ts': 1396710000,
                'time': '2014-04-05T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          67:
              {
                'ts': 1412436600,
                'time': '2014-10-04T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          68:
              {
                'ts': 1428159600,
                'time': '2015-04-04T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          69:
              {
                'ts': 1443886200,
                'time': '2015-10-03T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          70:
              {
                'ts': 1459609200,
                'time': '2016-04-02T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          71:
              {
                'ts': 1475335800,
                'time': '2016-10-01T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          72:
              {
                'ts': 1491058800,
                'time': '2017-04-01T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          73:
              {
                'ts': 1506785400,
                'time': '2017-09-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          74:
              {
                'ts': 1522508400,
                'time': '2018-03-31T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          75:
              {
                'ts': 1538839800,
                'time': '2018-10-06T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          76:
              {
                'ts': 1554562800,
                'time': '2019-04-06T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          77:
              {
                'ts': 1570289400,
                'time': '2019-10-05T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          78:
              {
                'ts': 1586012400,
                'time': '2020-04-04T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          79:
              {
                'ts': 1601739000,
                'time': '2020-10-03T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          80:
              {
                'ts': 1617462000,
                'time': '2021-04-03T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          81:
              {
                'ts': 1633188600,
                'time': '2021-10-02T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          82:
              {
                'ts': 1648911600,
                'time': '2022-04-02T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          83:
              {
                'ts': 1664638200,
                'time': '2022-10-01T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          84:
              {
                'ts': 1680361200,
                'time': '2023-04-01T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          85:
              {
                'ts': 1696087800,
                'time': '2023-09-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          86:
              {
                'ts': 1712415600,
                'time': '2024-04-06T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          87:
              {
                'ts': 1728142200,
                'time': '2024-10-05T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          88:
              {
                'ts': 1743865200,
                'time': '2025-04-05T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          89:
              {
                'ts': 1759591800,
                'time': '2025-10-04T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          90:
              {
                'ts': 1775314800,
                'time': '2026-04-04T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          91:
              {
                'ts': 1791041400,
                'time': '2026-10-03T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          92:
              {
                'ts': 1806764400,
                'time': '2027-04-03T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          93:
              {
                'ts': 1822491000,
                'time': '2027-10-02T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          94:
              {
                'ts': 1838214000,
                'time': '2028-04-01T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          95:
              {
                'ts': 1853940600,
                'time': '2028-09-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          96:
              {
                'ts': 1869663600,
                'time': '2029-03-31T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          97:
              {
                'ts': 1885995000,
                'time': '2029-10-06T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          98:
              {
                'ts': 1901718000,
                'time': '2030-04-06T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          99:
              {
                'ts': 1917444600,
                'time': '2030-10-05T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          100:
              {
                'ts': 1933167600,
                'time': '2031-04-05T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          101:
              {
                'ts': 1948894200,
                'time': '2031-10-04T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          102:
              {
                'ts': 1964617200,
                'time': '2032-04-03T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          103:
              {
                'ts': 1980343800,
                'time': '2032-10-02T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          104:
              {
                'ts': 1996066800,
                'time': '2033-04-02T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          105:
              {
                'ts': 2011793400,
                'time': '2033-10-01T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          106:
              {
                'ts': 2027516400,
                'time': '2034-04-01T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          107:
              {
                'ts': 2043243000,
                'time': '2034-09-30T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          108:
              {
                'ts': 2058966000,
                'time': '2035-03-31T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          109:
              {
                'ts': 2075297400,
                'time': '2035-10-06T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          110:
              {
                'ts': 2091020400,
                'time': '2036-04-05T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          111:
              {
                'ts': 2106747000,
                'time': '2036-10-04T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              },
          112:
              {
                'ts': 2122470000,
                'time': '2037-04-04T15:00:00+0000',
                'offset': 37800,
                'isdst': false,
                'abbr': 'LHST'
              },
          113:
              {
                'ts': 2138196600,
                'time': '2037-10-03T15:30:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'LHST'
              }
        },
    'Australia/Melbourne':
        {
          0:
              {
                'ts': -1672567140,
                'time': '1916-12-31T14:01:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -1665392400,
                'time': '1917-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -883641600,
                'time': '1941-12-31T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -876128400,
                'time': '1942-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -860400000,
                'time': '1942-09-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -844678800,
                'time': '1943-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -828345600,
                'time': '1943-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -813229200,
                'time': '1944-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 57686400,
                'time': '1971-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 67968000,
                'time': '1972-02-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 89136000,
                'time': '1972-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 100022400,
                'time': '1973-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 120585600,
                'time': '1973-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 131472000,
                'time': '1974-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 152035200,
                'time': '1974-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 162921600,
                'time': '1975-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 183484800,
                'time': '1975-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 194976000,
                'time': '1976-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 215539200,
                'time': '1976-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 226425600,
                'time': '1977-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 246988800,
                'time': '1977-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 257875200,
                'time': '1978-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': 278438400,
                'time': '1978-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 289324800,
                'time': '1979-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': 309888000,
                'time': '1979-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 320774400,
                'time': '1980-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 341337600,
                'time': '1980-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 352224000,
                'time': '1981-02-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 372787200,
                'time': '1981-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 384278400,
                'time': '1982-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 404841600,
                'time': '1982-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 415728000,
                'time': '1983-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 436291200,
                'time': '1983-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 447177600,
                'time': '1984-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 467740800,
                'time': '1984-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 478627200,
                'time': '1985-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 499190400,
                'time': '1985-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 511286400,
                'time': '1986-03-15T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 530035200,
                'time': '1986-10-18T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 542736000,
                'time': '1987-03-14T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 561484800,
                'time': '1987-10-17T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 574790400,
                'time': '1988-03-19T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 594144000,
                'time': '1988-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 606240000,
                'time': '1989-03-18T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 625593600,
                'time': '1989-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 637689600,
                'time': '1990-03-17T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 657043200,
                'time': '1990-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 667929600,
                'time': '1991-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 688492800,
                'time': '1991-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 699379200,
                'time': '1992-02-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 719942400,
                'time': '1992-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 731433600,
                'time': '1993-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 751996800,
                'time': '1993-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 762883200,
                'time': '1994-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 783446400,
                'time': '1994-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 796147200,
                'time': '1995-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 814896000,
                'time': '1995-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 828201600,
                'time': '1996-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 846345600,
                'time': '1996-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 859651200,
                'time': '1997-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 877795200,
                'time': '1997-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 909244800,
                'time': '1998-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 922550400,
                'time': '1999-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 941299200,
                'time': '1999-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 954000000,
                'time': '2000-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 967305600,
                'time': '2000-08-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 985449600,
                'time': '2001-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1004198400,
                'time': '2001-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 1017504000,
                'time': '2002-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1035648000,
                'time': '2002-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 1048953600,
                'time': '2003-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1067097600,
                'time': '2003-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 1080403200,
                'time': '2004-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1099152000,
                'time': '2004-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1111852800,
                'time': '2005-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1130601600,
                'time': '2005-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1143907200,
                'time': '2006-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1162051200,
                'time': '2006-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1174752000,
                'time': '2007-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1193500800,
                'time': '2007-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1207411200,
                'time': '2008-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1223136000,
                'time': '2008-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1238860800,
                'time': '2009-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1254585600,
                'time': '2009-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1270310400,
                'time': '2010-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1286035200,
                'time': '2010-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1301760000,
                'time': '2011-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1317484800,
                'time': '2011-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1333209600,
                'time': '2012-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1349539200,
                'time': '2012-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1365264000,
                'time': '2013-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1380988800,
                'time': '2013-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1396713600,
                'time': '2014-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1412438400,
                'time': '2014-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1428163200,
                'time': '2015-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1443888000,
                'time': '2015-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1459612800,
                'time': '2016-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 1475337600,
                'time': '2016-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1491062400,
                'time': '2017-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 1506787200,
                'time': '2017-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1522512000,
                'time': '2018-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 1538841600,
                'time': '2018-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1554566400,
                'time': '2019-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 1570291200,
                'time': '2019-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1586016000,
                'time': '2020-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 1601740800,
                'time': '2020-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1617465600,
                'time': '2021-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 1633190400,
                'time': '2021-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1648915200,
                'time': '2022-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 1664640000,
                'time': '2022-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1680364800,
                'time': '2023-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 1696089600,
                'time': '2023-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1712419200,
                'time': '2024-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 1728144000,
                'time': '2024-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1743868800,
                'time': '2025-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 1759593600,
                'time': '2025-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1775318400,
                'time': '2026-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 1791043200,
                'time': '2026-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1806768000,
                'time': '2027-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 1822492800,
                'time': '2027-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1838217600,
                'time': '2028-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 1853942400,
                'time': '2028-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1869667200,
                'time': '2029-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 1885996800,
                'time': '2029-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1901721600,
                'time': '2030-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 1917446400,
                'time': '2030-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1933171200,
                'time': '2031-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 1948896000,
                'time': '2031-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1964620800,
                'time': '2032-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 1980345600,
                'time': '2032-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1996070400,
                'time': '2033-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 2011795200,
                'time': '2033-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 2027520000,
                'time': '2034-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 2043244800,
                'time': '2034-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 2058969600,
                'time': '2035-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 2075299200,
                'time': '2035-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 2091024000,
                'time': '2036-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          138:
              {
                'ts': 2106748800,
                'time': '2036-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 2122473600,
                'time': '2037-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          140:
              {
                'ts': 2138198400,
                'time': '2037-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              }
        },
    'Australia/North':
        {
          0:
              {
                'ts': -1672565340,
                'time': '1916-12-31T14:31:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -1665390600,
                'time': '1917-03-24T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -883639800,
                'time': '1941-12-31T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          3:
              {
                'ts': -876126600,
                'time': '1942-03-28T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -860398200,
                'time': '1942-09-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          5:
              {
                'ts': -844677000,
                'time': '1943-03-27T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -828343800,
                'time': '1943-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -813227400,
                'time': '1944-03-25T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Australia/NSW':
        {
          0:
              {
                'ts': -1672567140,
                'time': '1916-12-31T14:01:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -1665392400,
                'time': '1917-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -883641600,
                'time': '1941-12-31T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -876128400,
                'time': '1942-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -860400000,
                'time': '1942-09-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -844678800,
                'time': '1943-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -828345600,
                'time': '1943-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -813229200,
                'time': '1944-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 57686400,
                'time': '1971-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 67968000,
                'time': '1972-02-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 89136000,
                'time': '1972-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 100022400,
                'time': '1973-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 120585600,
                'time': '1973-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 131472000,
                'time': '1974-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 152035200,
                'time': '1974-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 162921600,
                'time': '1975-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 183484800,
                'time': '1975-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 194976000,
                'time': '1976-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 215539200,
                'time': '1976-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 226425600,
                'time': '1977-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 246988800,
                'time': '1977-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 257875200,
                'time': '1978-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': 278438400,
                'time': '1978-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 289324800,
                'time': '1979-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': 309888000,
                'time': '1979-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 320774400,
                'time': '1980-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 341337600,
                'time': '1980-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 352224000,
                'time': '1981-02-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 372787200,
                'time': '1981-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 386697600,
                'time': '1982-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 404841600,
                'time': '1982-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 415728000,
                'time': '1983-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 436291200,
                'time': '1983-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 447177600,
                'time': '1984-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 467740800,
                'time': '1984-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 478627200,
                'time': '1985-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 499190400,
                'time': '1985-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 511286400,
                'time': '1986-03-15T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 530035200,
                'time': '1986-10-18T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 542736000,
                'time': '1987-03-14T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 562089600,
                'time': '1987-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 574790400,
                'time': '1988-03-19T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 594144000,
                'time': '1988-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 606240000,
                'time': '1989-03-18T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 625593600,
                'time': '1989-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 636480000,
                'time': '1990-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 657043200,
                'time': '1990-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 667929600,
                'time': '1991-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 688492800,
                'time': '1991-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 699379200,
                'time': '1992-02-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 719942400,
                'time': '1992-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 731433600,
                'time': '1993-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 751996800,
                'time': '1993-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 762883200,
                'time': '1994-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 783446400,
                'time': '1994-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 794332800,
                'time': '1995-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 814896000,
                'time': '1995-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 828201600,
                'time': '1996-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 846345600,
                'time': '1996-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 859651200,
                'time': '1997-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 877795200,
                'time': '1997-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 909244800,
                'time': '1998-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 922550400,
                'time': '1999-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 941299200,
                'time': '1999-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 954000000,
                'time': '2000-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 967305600,
                'time': '2000-08-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 985449600,
                'time': '2001-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1004198400,
                'time': '2001-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 1017504000,
                'time': '2002-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1035648000,
                'time': '2002-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 1048953600,
                'time': '2003-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1067097600,
                'time': '2003-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 1080403200,
                'time': '2004-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1099152000,
                'time': '2004-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1111852800,
                'time': '2005-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1130601600,
                'time': '2005-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1143907200,
                'time': '2006-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1162051200,
                'time': '2006-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1174752000,
                'time': '2007-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1193500800,
                'time': '2007-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1207411200,
                'time': '2008-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1223136000,
                'time': '2008-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1238860800,
                'time': '2009-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1254585600,
                'time': '2009-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1270310400,
                'time': '2010-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1286035200,
                'time': '2010-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1301760000,
                'time': '2011-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1317484800,
                'time': '2011-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1333209600,
                'time': '2012-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1349539200,
                'time': '2012-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1365264000,
                'time': '2013-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1380988800,
                'time': '2013-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1396713600,
                'time': '2014-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1412438400,
                'time': '2014-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1428163200,
                'time': '2015-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1443888000,
                'time': '2015-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1459612800,
                'time': '2016-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 1475337600,
                'time': '2016-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1491062400,
                'time': '2017-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 1506787200,
                'time': '2017-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1522512000,
                'time': '2018-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 1538841600,
                'time': '2018-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1554566400,
                'time': '2019-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 1570291200,
                'time': '2019-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1586016000,
                'time': '2020-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 1601740800,
                'time': '2020-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1617465600,
                'time': '2021-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 1633190400,
                'time': '2021-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1648915200,
                'time': '2022-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 1664640000,
                'time': '2022-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1680364800,
                'time': '2023-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 1696089600,
                'time': '2023-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1712419200,
                'time': '2024-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 1728144000,
                'time': '2024-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1743868800,
                'time': '2025-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 1759593600,
                'time': '2025-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1775318400,
                'time': '2026-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 1791043200,
                'time': '2026-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1806768000,
                'time': '2027-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 1822492800,
                'time': '2027-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1838217600,
                'time': '2028-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 1853942400,
                'time': '2028-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1869667200,
                'time': '2029-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 1885996800,
                'time': '2029-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1901721600,
                'time': '2030-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 1917446400,
                'time': '2030-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1933171200,
                'time': '2031-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 1948896000,
                'time': '2031-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1964620800,
                'time': '2032-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 1980345600,
                'time': '2032-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1996070400,
                'time': '2033-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 2011795200,
                'time': '2033-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 2027520000,
                'time': '2034-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 2043244800,
                'time': '2034-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 2058969600,
                'time': '2035-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 2075299200,
                'time': '2035-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 2091024000,
                'time': '2036-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          138:
              {
                'ts': 2106748800,
                'time': '2036-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 2122473600,
                'time': '2037-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          140:
              {
                'ts': 2138198400,
                'time': '2037-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              }
        },
    'Australia/Perth':
        {
          0:
              {
                'ts': -1672559940,
                'time': '1916-12-31T16:01:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          1:
              {
                'ts': -1665385200,
                'time': '1917-03-24T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          2:
              {
                'ts': -883634400,
                'time': '1941-12-31T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          3:
              {
                'ts': -876121200,
                'time': '1942-03-28T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          4:
              {
                'ts': -860392800,
                'time': '1942-09-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          5:
              {
                'ts': -844671600,
                'time': '1943-03-27T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          6:
              {
                'ts': 152042400,
                'time': '1974-10-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          7:
              {
                'ts': 162928800,
                'time': '1975-03-01T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          8:
              {
                'ts': 436298400,
                'time': '1983-10-29T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          9:
              {
                'ts': 447184800,
                'time': '1984-03-03T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          10:
              {
                'ts': 690314400,
                'time': '1991-11-16T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          11:
              {
                'ts': 699386400,
                'time': '1992-02-29T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          12:
              {
                'ts': 1165082400,
                'time': '2006-12-02T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          13:
              {
                'ts': 1174759200,
                'time': '2007-03-24T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          14:
              {
                'ts': 1193508000,
                'time': '2007-10-27T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          15:
              {
                'ts': 1206813600,
                'time': '2008-03-29T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          16:
              {
                'ts': 1224957600,
                'time': '2008-10-25T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          17:
              {
                'ts': 1238263200,
                'time': '2009-03-28T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              }
        },
    'Australia/Queensland':
        {
          0:
              {
                'ts': -1672567140,
                'time': '1916-12-31T14:01:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -1665392400,
                'time': '1917-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -883641600,
                'time': '1941-12-31T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -876128400,
                'time': '1942-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -860400000,
                'time': '1942-09-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -844678800,
                'time': '1943-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -828345600,
                'time': '1943-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -813229200,
                'time': '1944-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 57686400,
                'time': '1971-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 67968000,
                'time': '1972-02-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 625593600,
                'time': '1989-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 636480000,
                'time': '1990-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 657043200,
                'time': '1990-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 667929600,
                'time': '1991-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 688492800,
                'time': '1991-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 699379200,
                'time': '1992-02-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'Australia/South':
        {
          0:
              {
                'ts': -1672565340,
                'time': '1916-12-31T14:31:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -1665390600,
                'time': '1917-03-24T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -883639800,
                'time': '1941-12-31T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          3:
              {
                'ts': -876126600,
                'time': '1942-03-28T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -860398200,
                'time': '1942-09-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          5:
              {
                'ts': -844677000,
                'time': '1943-03-27T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -828343800,
                'time': '1943-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -813227400,
                'time': '1944-03-25T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': 57688200,
                'time': '1971-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 67969800,
                'time': '1972-02-26T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': 89137800,
                'time': '1972-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 100024200,
                'time': '1973-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': 120587400,
                'time': '1973-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 131473800,
                'time': '1974-03-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          14:
              {
                'ts': 152037000,
                'time': '1974-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 162923400,
                'time': '1975-03-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          16:
              {
                'ts': 183486600,
                'time': '1975-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          17:
              {
                'ts': 194977800,
                'time': '1976-03-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          18:
              {
                'ts': 215541000,
                'time': '1976-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          19:
              {
                'ts': 226427400,
                'time': '1977-03-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          20:
              {
                'ts': 246990600,
                'time': '1977-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          21:
              {
                'ts': 257877000,
                'time': '1978-03-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          22:
              {
                'ts': 278440200,
                'time': '1978-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 289326600,
                'time': '1979-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          24:
              {
                'ts': 309889800,
                'time': '1979-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 320776200,
                'time': '1980-03-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          26:
              {
                'ts': 341339400,
                'time': '1980-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 352225800,
                'time': '1981-02-28T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          28:
              {
                'ts': 372789000,
                'time': '1981-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 384280200,
                'time': '1982-03-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          30:
              {
                'ts': 404843400,
                'time': '1982-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 415729800,
                'time': '1983-03-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          32:
              {
                'ts': 436293000,
                'time': '1983-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 447179400,
                'time': '1984-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          34:
              {
                'ts': 467742600,
                'time': '1984-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 478629000,
                'time': '1985-03-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          36:
              {
                'ts': 499192200,
                'time': '1985-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 511288200,
                'time': '1986-03-15T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': 530037000,
                'time': '1986-10-18T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 542737800,
                'time': '1987-03-14T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          40:
              {
                'ts': 562091400,
                'time': '1987-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 574792200,
                'time': '1988-03-19T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          42:
              {
                'ts': 594145800,
                'time': '1988-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 606241800,
                'time': '1989-03-18T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          44:
              {
                'ts': 625595400,
                'time': '1989-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 637691400,
                'time': '1990-03-17T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': 657045000,
                'time': '1990-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 667931400,
                'time': '1991-03-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          48:
              {
                'ts': 688494600,
                'time': '1991-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 701195400,
                'time': '1992-03-21T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          50:
              {
                'ts': 719944200,
                'time': '1992-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 731435400,
                'time': '1993-03-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          52:
              {
                'ts': 751998600,
                'time': '1993-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 764094600,
                'time': '1994-03-19T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          54:
              {
                'ts': 783448200,
                'time': '1994-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 796149000,
                'time': '1995-03-25T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          56:
              {
                'ts': 814897800,
                'time': '1995-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 828203400,
                'time': '1996-03-30T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          58:
              {
                'ts': 846347400,
                'time': '1996-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 859653000,
                'time': '1997-03-29T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          60:
              {
                'ts': 877797000,
                'time': '1997-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 891102600,
                'time': '1998-03-28T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          62:
              {
                'ts': 909246600,
                'time': '1998-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 922552200,
                'time': '1999-03-27T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          64:
              {
                'ts': 941301000,
                'time': '1999-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 954001800,
                'time': '2000-03-25T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          66:
              {
                'ts': 972750600,
                'time': '2000-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 985451400,
                'time': '2001-03-24T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          68:
              {
                'ts': 1004200200,
                'time': '2001-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 1017505800,
                'time': '2002-03-30T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          70:
              {
                'ts': 1035649800,
                'time': '2002-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 1048955400,
                'time': '2003-03-29T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          72:
              {
                'ts': 1067099400,
                'time': '2003-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 1080405000,
                'time': '2004-03-27T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          74:
              {
                'ts': 1099153800,
                'time': '2004-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 1111854600,
                'time': '2005-03-26T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          76:
              {
                'ts': 1130603400,
                'time': '2005-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 1143909000,
                'time': '2006-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          78:
              {
                'ts': 1162053000,
                'time': '2006-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 1174753800,
                'time': '2007-03-24T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          80:
              {
                'ts': 1193502600,
                'time': '2007-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 1207413000,
                'time': '2008-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          82:
              {
                'ts': 1223137800,
                'time': '2008-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 1238862600,
                'time': '2009-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          84:
              {
                'ts': 1254587400,
                'time': '2009-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 1270312200,
                'time': '2010-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          86:
              {
                'ts': 1286037000,
                'time': '2010-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 1301761800,
                'time': '2011-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          88:
              {
                'ts': 1317486600,
                'time': '2011-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          89:
              {
                'ts': 1333211400,
                'time': '2012-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          90:
              {
                'ts': 1349541000,
                'time': '2012-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1365265800,
                'time': '2013-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          92:
              {
                'ts': 1380990600,
                'time': '2013-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1396715400,
                'time': '2014-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          94:
              {
                'ts': 1412440200,
                'time': '2014-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1428165000,
                'time': '2015-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          96:
              {
                'ts': 1443889800,
                'time': '2015-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1459614600,
                'time': '2016-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          98:
              {
                'ts': 1475339400,
                'time': '2016-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1491064200,
                'time': '2017-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          100:
              {
                'ts': 1506789000,
                'time': '2017-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1522513800,
                'time': '2018-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          102:
              {
                'ts': 1538843400,
                'time': '2018-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1554568200,
                'time': '2019-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          104:
              {
                'ts': 1570293000,
                'time': '2019-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1586017800,
                'time': '2020-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          106:
              {
                'ts': 1601742600,
                'time': '2020-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1617467400,
                'time': '2021-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          108:
              {
                'ts': 1633192200,
                'time': '2021-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1648917000,
                'time': '2022-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          110:
              {
                'ts': 1664641800,
                'time': '2022-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 1680366600,
                'time': '2023-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          112:
              {
                'ts': 1696091400,
                'time': '2023-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1712421000,
                'time': '2024-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          114:
              {
                'ts': 1728145800,
                'time': '2024-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1743870600,
                'time': '2025-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          116:
              {
                'ts': 1759595400,
                'time': '2025-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1775320200,
                'time': '2026-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          118:
              {
                'ts': 1791045000,
                'time': '2026-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1806769800,
                'time': '2027-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          120:
              {
                'ts': 1822494600,
                'time': '2027-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1838219400,
                'time': '2028-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          122:
              {
                'ts': 1853944200,
                'time': '2028-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 1869669000,
                'time': '2029-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          124:
              {
                'ts': 1885998600,
                'time': '2029-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 1901723400,
                'time': '2030-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          126:
              {
                'ts': 1917448200,
                'time': '2030-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 1933173000,
                'time': '2031-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          128:
              {
                'ts': 1948897800,
                'time': '2031-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 1964622600,
                'time': '2032-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          130:
              {
                'ts': 1980347400,
                'time': '2032-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 1996072200,
                'time': '2033-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          132:
              {
                'ts': 2011797000,
                'time': '2033-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 2027521800,
                'time': '2034-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          134:
              {
                'ts': 2043246600,
                'time': '2034-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 2058971400,
                'time': '2035-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          136:
              {
                'ts': 2075301000,
                'time': '2035-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 2091025800,
                'time': '2036-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          138:
              {
                'ts': 2106750600,
                'time': '2036-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 2122475400,
                'time': '2037-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          140:
              {
                'ts': 2138200200,
                'time': '2037-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              }
        },
    'Australia/Sydney':
        {
          0:
              {
                'ts': -1672567140,
                'time': '1916-12-31T14:01:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -1665392400,
                'time': '1917-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -883641600,
                'time': '1941-12-31T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -876128400,
                'time': '1942-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -860400000,
                'time': '1942-09-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -844678800,
                'time': '1943-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -828345600,
                'time': '1943-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -813229200,
                'time': '1944-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 57686400,
                'time': '1971-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 67968000,
                'time': '1972-02-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 89136000,
                'time': '1972-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 100022400,
                'time': '1973-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 120585600,
                'time': '1973-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 131472000,
                'time': '1974-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 152035200,
                'time': '1974-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 162921600,
                'time': '1975-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 183484800,
                'time': '1975-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 194976000,
                'time': '1976-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 215539200,
                'time': '1976-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 226425600,
                'time': '1977-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 246988800,
                'time': '1977-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 257875200,
                'time': '1978-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': 278438400,
                'time': '1978-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 289324800,
                'time': '1979-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': 309888000,
                'time': '1979-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 320774400,
                'time': '1980-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 341337600,
                'time': '1980-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 352224000,
                'time': '1981-02-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 372787200,
                'time': '1981-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 386697600,
                'time': '1982-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 404841600,
                'time': '1982-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 415728000,
                'time': '1983-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 436291200,
                'time': '1983-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 447177600,
                'time': '1984-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 467740800,
                'time': '1984-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 478627200,
                'time': '1985-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 499190400,
                'time': '1985-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 511286400,
                'time': '1986-03-15T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 530035200,
                'time': '1986-10-18T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 542736000,
                'time': '1987-03-14T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 562089600,
                'time': '1987-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 574790400,
                'time': '1988-03-19T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 594144000,
                'time': '1988-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 606240000,
                'time': '1989-03-18T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 625593600,
                'time': '1989-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 636480000,
                'time': '1990-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 657043200,
                'time': '1990-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 667929600,
                'time': '1991-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 688492800,
                'time': '1991-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 699379200,
                'time': '1992-02-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 719942400,
                'time': '1992-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 731433600,
                'time': '1993-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 751996800,
                'time': '1993-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 762883200,
                'time': '1994-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 783446400,
                'time': '1994-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 794332800,
                'time': '1995-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 814896000,
                'time': '1995-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 828201600,
                'time': '1996-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 846345600,
                'time': '1996-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 859651200,
                'time': '1997-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 877795200,
                'time': '1997-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 909244800,
                'time': '1998-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 922550400,
                'time': '1999-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 941299200,
                'time': '1999-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 954000000,
                'time': '2000-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 967305600,
                'time': '2000-08-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 985449600,
                'time': '2001-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1004198400,
                'time': '2001-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 1017504000,
                'time': '2002-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1035648000,
                'time': '2002-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 1048953600,
                'time': '2003-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1067097600,
                'time': '2003-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 1080403200,
                'time': '2004-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1099152000,
                'time': '2004-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1111852800,
                'time': '2005-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1130601600,
                'time': '2005-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1143907200,
                'time': '2006-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1162051200,
                'time': '2006-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1174752000,
                'time': '2007-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1193500800,
                'time': '2007-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1207411200,
                'time': '2008-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1223136000,
                'time': '2008-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1238860800,
                'time': '2009-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1254585600,
                'time': '2009-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1270310400,
                'time': '2010-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1286035200,
                'time': '2010-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1301760000,
                'time': '2011-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1317484800,
                'time': '2011-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1333209600,
                'time': '2012-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1349539200,
                'time': '2012-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1365264000,
                'time': '2013-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1380988800,
                'time': '2013-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1396713600,
                'time': '2014-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1412438400,
                'time': '2014-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1428163200,
                'time': '2015-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1443888000,
                'time': '2015-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1459612800,
                'time': '2016-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 1475337600,
                'time': '2016-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1491062400,
                'time': '2017-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 1506787200,
                'time': '2017-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1522512000,
                'time': '2018-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 1538841600,
                'time': '2018-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1554566400,
                'time': '2019-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 1570291200,
                'time': '2019-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1586016000,
                'time': '2020-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 1601740800,
                'time': '2020-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1617465600,
                'time': '2021-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 1633190400,
                'time': '2021-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1648915200,
                'time': '2022-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 1664640000,
                'time': '2022-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1680364800,
                'time': '2023-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 1696089600,
                'time': '2023-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1712419200,
                'time': '2024-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 1728144000,
                'time': '2024-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1743868800,
                'time': '2025-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 1759593600,
                'time': '2025-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1775318400,
                'time': '2026-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 1791043200,
                'time': '2026-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1806768000,
                'time': '2027-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 1822492800,
                'time': '2027-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1838217600,
                'time': '2028-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 1853942400,
                'time': '2028-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1869667200,
                'time': '2029-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 1885996800,
                'time': '2029-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1901721600,
                'time': '2030-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 1917446400,
                'time': '2030-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1933171200,
                'time': '2031-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 1948896000,
                'time': '2031-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1964620800,
                'time': '2032-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 1980345600,
                'time': '2032-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1996070400,
                'time': '2033-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 2011795200,
                'time': '2033-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 2027520000,
                'time': '2034-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 2043244800,
                'time': '2034-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 2058969600,
                'time': '2035-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 2075299200,
                'time': '2035-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 2091024000,
                'time': '2036-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          138:
              {
                'ts': 2106748800,
                'time': '2036-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 2122473600,
                'time': '2037-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          140:
              {
                'ts': 2138198400,
                'time': '2037-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              }
        },
    'Australia/Tasmania':
        {
          0:
              {
                'ts': -1680508800,
                'time': '1916-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -1665392400,
                'time': '1917-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -883641600,
                'time': '1941-12-31T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -876128400,
                'time': '1942-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -860400000,
                'time': '1942-09-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -844678800,
                'time': '1943-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -828345600,
                'time': '1943-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -813229200,
                'time': '1944-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': -71136000,
                'time': '1967-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          9:
              {
                'ts': -55411200,
                'time': '1968-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': -37267200,
                'time': '1968-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          11:
              {
                'ts': -25776000,
                'time': '1969-03-08T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': -5817600,
                'time': '1969-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 5673600,
                'time': '1970-03-07T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 25632000,
                'time': '1970-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 37728000,
                'time': '1971-03-13T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 57686400,
                'time': '1971-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 67968000,
                'time': '1972-02-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 89136000,
                'time': '1972-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 100022400,
                'time': '1973-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 120585600,
                'time': '1973-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 131472000,
                'time': '1974-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': 152035200,
                'time': '1974-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 162921600,
                'time': '1975-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': 183484800,
                'time': '1975-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 194976000,
                'time': '1976-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 215539200,
                'time': '1976-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 226425600,
                'time': '1977-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 246988800,
                'time': '1977-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 257875200,
                'time': '1978-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 278438400,
                'time': '1978-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 289324800,
                'time': '1979-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 309888000,
                'time': '1979-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 320774400,
                'time': '1980-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 341337600,
                'time': '1980-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 352224000,
                'time': '1981-02-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 372787200,
                'time': '1981-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 386092800,
                'time': '1982-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 404841600,
                'time': '1982-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 417542400,
                'time': '1983-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 436291200,
                'time': '1983-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 447177600,
                'time': '1984-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 467740800,
                'time': '1984-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 478627200,
                'time': '1985-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 499190400,
                'time': '1985-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 510076800,
                'time': '1986-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 530035200,
                'time': '1986-10-18T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 542736000,
                'time': '1987-03-14T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 562089600,
                'time': '1987-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 574790400,
                'time': '1988-03-19T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 594144000,
                'time': '1988-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 606240000,
                'time': '1989-03-18T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 625593600,
                'time': '1989-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 637689600,
                'time': '1990-03-17T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 657043200,
                'time': '1990-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 670348800,
                'time': '1991-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 686678400,
                'time': '1991-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 701798400,
                'time': '1992-03-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 718128000,
                'time': '1992-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 733248000,
                'time': '1993-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 749577600,
                'time': '1993-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 764697600,
                'time': '1994-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 781027200,
                'time': '1994-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 796147200,
                'time': '1995-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 812476800,
                'time': '1995-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 828201600,
                'time': '1996-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 844531200,
                'time': '1996-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 859651200,
                'time': '1997-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 875980800,
                'time': '1997-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 907430400,
                'time': '1998-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 922550400,
                'time': '1999-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 938880000,
                'time': '1999-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 954000000,
                'time': '2000-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 967305600,
                'time': '2000-08-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 985449600,
                'time': '2001-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1002384000,
                'time': '2001-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1017504000,
                'time': '2002-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1033833600,
                'time': '2002-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1048953600,
                'time': '2003-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1065283200,
                'time': '2003-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1080403200,
                'time': '2004-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1096732800,
                'time': '2004-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1111852800,
                'time': '2005-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1128182400,
                'time': '2005-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1143907200,
                'time': '2006-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1159632000,
                'time': '2006-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1174752000,
                'time': '2007-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1191686400,
                'time': '2007-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1207411200,
                'time': '2008-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1223136000,
                'time': '2008-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1238860800,
                'time': '2009-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1254585600,
                'time': '2009-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1270310400,
                'time': '2010-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1286035200,
                'time': '2010-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1301760000,
                'time': '2011-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1317484800,
                'time': '2011-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1333209600,
                'time': '2012-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 1349539200,
                'time': '2012-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1365264000,
                'time': '2013-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 1380988800,
                'time': '2013-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1396713600,
                'time': '2014-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 1412438400,
                'time': '2014-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1428163200,
                'time': '2015-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 1443888000,
                'time': '2015-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1459612800,
                'time': '2016-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 1475337600,
                'time': '2016-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1491062400,
                'time': '2017-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 1506787200,
                'time': '2017-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1522512000,
                'time': '2018-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 1538841600,
                'time': '2018-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1554566400,
                'time': '2019-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 1570291200,
                'time': '2019-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1586016000,
                'time': '2020-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 1601740800,
                'time': '2020-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1617465600,
                'time': '2021-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 1633190400,
                'time': '2021-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1648915200,
                'time': '2022-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 1664640000,
                'time': '2022-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1680364800,
                'time': '2023-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 1696089600,
                'time': '2023-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1712419200,
                'time': '2024-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 1728144000,
                'time': '2024-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1743868800,
                'time': '2025-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 1759593600,
                'time': '2025-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1775318400,
                'time': '2026-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 1791043200,
                'time': '2026-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1806768000,
                'time': '2027-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 1822492800,
                'time': '2027-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1838217600,
                'time': '2028-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 1853942400,
                'time': '2028-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1869667200,
                'time': '2029-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 1885996800,
                'time': '2029-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 1901721600,
                'time': '2030-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 1917446400,
                'time': '2030-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 1933171200,
                'time': '2031-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 1948896000,
                'time': '2031-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 1964620800,
                'time': '2032-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          138:
              {
                'ts': 1980345600,
                'time': '2032-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 1996070400,
                'time': '2033-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          140:
              {
                'ts': 2011795200,
                'time': '2033-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          141:
              {
                'ts': 2027520000,
                'time': '2034-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          142:
              {
                'ts': 2043244800,
                'time': '2034-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          143:
              {
                'ts': 2058969600,
                'time': '2035-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          144:
              {
                'ts': 2075299200,
                'time': '2035-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          145:
              {
                'ts': 2091024000,
                'time': '2036-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          146:
              {
                'ts': 2106748800,
                'time': '2036-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          147:
              {
                'ts': 2122473600,
                'time': '2037-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          148:
              {
                'ts': 2138198400,
                'time': '2037-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              }
        },
    'Australia/Victoria':
        {
          0:
              {
                'ts': -1672567140,
                'time': '1916-12-31T14:01:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          1:
              {
                'ts': -1665392400,
                'time': '1917-03-24T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -883641600,
                'time': '1941-12-31T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          3:
              {
                'ts': -876128400,
                'time': '1942-03-28T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -860400000,
                'time': '1942-09-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -844678800,
                'time': '1943-03-27T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -828345600,
                'time': '1943-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -813229200,
                'time': '1944-03-25T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': 57686400,
                'time': '1971-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 67968000,
                'time': '1972-02-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': 89136000,
                'time': '1972-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 100022400,
                'time': '1973-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': 120585600,
                'time': '1973-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 131472000,
                'time': '1974-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': 152035200,
                'time': '1974-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 162921600,
                'time': '1975-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': 183484800,
                'time': '1975-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 194976000,
                'time': '1976-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': 215539200,
                'time': '1976-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 226425600,
                'time': '1977-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': 246988800,
                'time': '1977-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 257875200,
                'time': '1978-03-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': 278438400,
                'time': '1978-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 289324800,
                'time': '1979-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': 309888000,
                'time': '1979-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 320774400,
                'time': '1980-03-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': 341337600,
                'time': '1980-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 352224000,
                'time': '1981-02-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': 372787200,
                'time': '1981-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 384278400,
                'time': '1982-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': 404841600,
                'time': '1982-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 415728000,
                'time': '1983-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 436291200,
                'time': '1983-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 447177600,
                'time': '1984-03-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 467740800,
                'time': '1984-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 478627200,
                'time': '1985-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 499190400,
                'time': '1985-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 511286400,
                'time': '1986-03-15T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 530035200,
                'time': '1986-10-18T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 542736000,
                'time': '1987-03-14T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 561484800,
                'time': '1987-10-17T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 574790400,
                'time': '1988-03-19T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 594144000,
                'time': '1988-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 606240000,
                'time': '1989-03-18T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 625593600,
                'time': '1989-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 637689600,
                'time': '1990-03-17T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 657043200,
                'time': '1990-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 667929600,
                'time': '1991-03-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 688492800,
                'time': '1991-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 699379200,
                'time': '1992-02-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 719942400,
                'time': '1992-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 731433600,
                'time': '1993-03-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 751996800,
                'time': '1993-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 762883200,
                'time': '1994-03-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 783446400,
                'time': '1994-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 796147200,
                'time': '1995-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 814896000,
                'time': '1995-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 828201600,
                'time': '1996-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 846345600,
                'time': '1996-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 859651200,
                'time': '1997-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 877795200,
                'time': '1997-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 891100800,
                'time': '1998-03-28T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 909244800,
                'time': '1998-10-24T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 922550400,
                'time': '1999-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 941299200,
                'time': '1999-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 954000000,
                'time': '2000-03-25T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 967305600,
                'time': '2000-08-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 985449600,
                'time': '2001-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1004198400,
                'time': '2001-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 1017504000,
                'time': '2002-03-30T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1035648000,
                'time': '2002-10-26T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 1048953600,
                'time': '2003-03-29T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1067097600,
                'time': '2003-10-25T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 1080403200,
                'time': '2004-03-27T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1099152000,
                'time': '2004-10-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1111852800,
                'time': '2005-03-26T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1130601600,
                'time': '2005-10-29T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1143907200,
                'time': '2006-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1162051200,
                'time': '2006-10-28T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1174752000,
                'time': '2007-03-24T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1193500800,
                'time': '2007-10-27T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1207411200,
                'time': '2008-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1223136000,
                'time': '2008-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1238860800,
                'time': '2009-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1254585600,
                'time': '2009-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1270310400,
                'time': '2010-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1286035200,
                'time': '2010-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1301760000,
                'time': '2011-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1317484800,
                'time': '2011-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1333209600,
                'time': '2012-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 1349539200,
                'time': '2012-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1365264000,
                'time': '2013-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 1380988800,
                'time': '2013-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1396713600,
                'time': '2014-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 1412438400,
                'time': '2014-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1428163200,
                'time': '2015-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 1443888000,
                'time': '2015-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1459612800,
                'time': '2016-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 1475337600,
                'time': '2016-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1491062400,
                'time': '2017-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 1506787200,
                'time': '2017-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1522512000,
                'time': '2018-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 1538841600,
                'time': '2018-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1554566400,
                'time': '2019-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 1570291200,
                'time': '2019-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1586016000,
                'time': '2020-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 1601740800,
                'time': '2020-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1617465600,
                'time': '2021-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 1633190400,
                'time': '2021-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1648915200,
                'time': '2022-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 1664640000,
                'time': '2022-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1680364800,
                'time': '2023-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 1696089600,
                'time': '2023-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1712419200,
                'time': '2024-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 1728144000,
                'time': '2024-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1743868800,
                'time': '2025-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 1759593600,
                'time': '2025-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1775318400,
                'time': '2026-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 1791043200,
                'time': '2026-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1806768000,
                'time': '2027-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 1822492800,
                'time': '2027-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1838217600,
                'time': '2028-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 1853942400,
                'time': '2028-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1869667200,
                'time': '2029-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 1885996800,
                'time': '2029-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1901721600,
                'time': '2030-04-06T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 1917446400,
                'time': '2030-10-05T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1933171200,
                'time': '2031-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 1948896000,
                'time': '2031-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1964620800,
                'time': '2032-04-03T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 1980345600,
                'time': '2032-10-02T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1996070400,
                'time': '2033-04-02T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 2011795200,
                'time': '2033-10-01T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 2027520000,
                'time': '2034-04-01T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 2043244800,
                'time': '2034-09-30T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 2058969600,
                'time': '2035-03-31T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 2075299200,
                'time': '2035-10-06T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 2091024000,
                'time': '2036-04-05T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          138:
              {
                'ts': 2106748800,
                'time': '2036-10-04T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 2122473600,
                'time': '2037-04-04T16:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'EST'
              },
          140:
              {
                'ts': 2138198400,
                'time': '2037-10-03T16:00:00+0000',
                'offset': 39600,
                'isdst': true,
                'abbr': 'EST'
              }
        },
    'Australia/West':
        {
          0:
              {
                'ts': -1672559940,
                'time': '1916-12-31T16:01:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          1:
              {
                'ts': -1665385200,
                'time': '1917-03-24T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          2:
              {
                'ts': -883634400,
                'time': '1941-12-31T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          3:
              {
                'ts': -876121200,
                'time': '1942-03-28T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          4:
              {
                'ts': -860392800,
                'time': '1942-09-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          5:
              {
                'ts': -844671600,
                'time': '1943-03-27T17:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          6:
              {
                'ts': 152042400,
                'time': '1974-10-26T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          7:
              {
                'ts': 162928800,
                'time': '1975-03-01T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          8:
              {
                'ts': 436298400,
                'time': '1983-10-29T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          9:
              {
                'ts': 447184800,
                'time': '1984-03-03T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          10:
              {
                'ts': 690314400,
                'time': '1991-11-16T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          11:
              {
                'ts': 699386400,
                'time': '1992-02-29T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          12:
              {
                'ts': 1165082400,
                'time': '2006-12-02T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          13:
              {
                'ts': 1174759200,
                'time': '2007-03-24T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          14:
              {
                'ts': 1193508000,
                'time': '2007-10-27T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          15:
              {
                'ts': 1206813600,
                'time': '2008-03-29T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              },
          16:
              {
                'ts': 1224957600,
                'time': '2008-10-25T18:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'WST'
              },
          17:
              {
                'ts': 1238263200,
                'time': '2009-03-28T18:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'WST'
              }
        },
    'Australia/Yancowinna':
        {
          0:
              {
                'ts': -1672565340,
                'time': '1916-12-31T14:31:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -1665390600,
                'time': '1917-03-24T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -883639800,
                'time': '1941-12-31T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          3:
              {
                'ts': -876126600,
                'time': '1942-03-28T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -860398200,
                'time': '1942-09-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          5:
              {
                'ts': -844677000,
                'time': '1943-03-27T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -828343800,
                'time': '1943-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -813227400,
                'time': '1944-03-25T15:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': 57688200,
                'time': '1971-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 67969800,
                'time': '1972-02-26T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': 89137800,
                'time': '1972-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 100024200,
                'time': '1973-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': 120587400,
                'time': '1973-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 131473800,
                'time': '1974-03-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          14:
              {
                'ts': 152037000,
                'time': '1974-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 162923400,
                'time': '1975-03-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          16:
              {
                'ts': 183486600,
                'time': '1975-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          17:
              {
                'ts': 194977800,
                'time': '1976-03-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          18:
              {
                'ts': 215541000,
                'time': '1976-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          19:
              {
                'ts': 226427400,
                'time': '1977-03-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          20:
              {
                'ts': 246990600,
                'time': '1977-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          21:
              {
                'ts': 257877000,
                'time': '1978-03-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          22:
              {
                'ts': 278440200,
                'time': '1978-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 289326600,
                'time': '1979-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          24:
              {
                'ts': 309889800,
                'time': '1979-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 320776200,
                'time': '1980-03-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          26:
              {
                'ts': 341339400,
                'time': '1980-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 352225800,
                'time': '1981-02-28T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          28:
              {
                'ts': 372789000,
                'time': '1981-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 386699400,
                'time': '1982-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          30:
              {
                'ts': 404843400,
                'time': '1982-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 415729800,
                'time': '1983-03-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          32:
              {
                'ts': 436293000,
                'time': '1983-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 447179400,
                'time': '1984-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          34:
              {
                'ts': 467742600,
                'time': '1984-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 478629000,
                'time': '1985-03-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          36:
              {
                'ts': 499192200,
                'time': '1985-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 511288200,
                'time': '1986-03-15T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': 530037000,
                'time': '1986-10-18T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 542737800,
                'time': '1987-03-14T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          40:
              {
                'ts': 562091400,
                'time': '1987-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 574792200,
                'time': '1988-03-19T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          42:
              {
                'ts': 594145800,
                'time': '1988-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 606241800,
                'time': '1989-03-18T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          44:
              {
                'ts': 625595400,
                'time': '1989-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 636481800,
                'time': '1990-03-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': 657045000,
                'time': '1990-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 667931400,
                'time': '1991-03-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          48:
              {
                'ts': 688494600,
                'time': '1991-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 699381000,
                'time': '1992-02-29T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          50:
              {
                'ts': 719944200,
                'time': '1992-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 731435400,
                'time': '1993-03-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          52:
              {
                'ts': 751998600,
                'time': '1993-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 762885000,
                'time': '1994-03-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          54:
              {
                'ts': 783448200,
                'time': '1994-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 794334600,
                'time': '1995-03-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          56:
              {
                'ts': 814897800,
                'time': '1995-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 828203400,
                'time': '1996-03-30T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          58:
              {
                'ts': 846347400,
                'time': '1996-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 859653000,
                'time': '1997-03-29T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          60:
              {
                'ts': 877797000,
                'time': '1997-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 891102600,
                'time': '1998-03-28T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          62:
              {
                'ts': 909246600,
                'time': '1998-10-24T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 922552200,
                'time': '1999-03-27T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          64:
              {
                'ts': 941301000,
                'time': '1999-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 946647000,
                'time': '1999-12-31T13:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          66:
              {
                'ts': 954001800,
                'time': '2000-03-25T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 972750600,
                'time': '2000-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          68:
              {
                'ts': 985451400,
                'time': '2001-03-24T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 1004200200,
                'time': '2001-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          70:
              {
                'ts': 1017505800,
                'time': '2002-03-30T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 1035649800,
                'time': '2002-10-26T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          72:
              {
                'ts': 1048955400,
                'time': '2003-03-29T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 1067099400,
                'time': '2003-10-25T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          74:
              {
                'ts': 1080405000,
                'time': '2004-03-27T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 1099153800,
                'time': '2004-10-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          76:
              {
                'ts': 1111854600,
                'time': '2005-03-26T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 1130603400,
                'time': '2005-10-29T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          78:
              {
                'ts': 1143909000,
                'time': '2006-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 1162053000,
                'time': '2006-10-28T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          80:
              {
                'ts': 1174753800,
                'time': '2007-03-24T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 1193502600,
                'time': '2007-10-27T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          82:
              {
                'ts': 1207413000,
                'time': '2008-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 1223137800,
                'time': '2008-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          84:
              {
                'ts': 1238862600,
                'time': '2009-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 1254587400,
                'time': '2009-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          86:
              {
                'ts': 1270312200,
                'time': '2010-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 1286037000,
                'time': '2010-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          88:
              {
                'ts': 1301761800,
                'time': '2011-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          89:
              {
                'ts': 1317486600,
                'time': '2011-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          90:
              {
                'ts': 1333211400,
                'time': '2012-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1349541000,
                'time': '2012-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          92:
              {
                'ts': 1365265800,
                'time': '2013-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1380990600,
                'time': '2013-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          94:
              {
                'ts': 1396715400,
                'time': '2014-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1412440200,
                'time': '2014-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          96:
              {
                'ts': 1428165000,
                'time': '2015-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1443889800,
                'time': '2015-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          98:
              {
                'ts': 1459614600,
                'time': '2016-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1475339400,
                'time': '2016-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          100:
              {
                'ts': 1491064200,
                'time': '2017-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1506789000,
                'time': '2017-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          102:
              {
                'ts': 1522513800,
                'time': '2018-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1538843400,
                'time': '2018-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          104:
              {
                'ts': 1554568200,
                'time': '2019-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1570293000,
                'time': '2019-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          106:
              {
                'ts': 1586017800,
                'time': '2020-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1601742600,
                'time': '2020-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          108:
              {
                'ts': 1617467400,
                'time': '2021-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1633192200,
                'time': '2021-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          110:
              {
                'ts': 1648917000,
                'time': '2022-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 1664641800,
                'time': '2022-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          112:
              {
                'ts': 1680366600,
                'time': '2023-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1696091400,
                'time': '2023-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          114:
              {
                'ts': 1712421000,
                'time': '2024-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1728145800,
                'time': '2024-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          116:
              {
                'ts': 1743870600,
                'time': '2025-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1759595400,
                'time': '2025-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          118:
              {
                'ts': 1775320200,
                'time': '2026-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1791045000,
                'time': '2026-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          120:
              {
                'ts': 1806769800,
                'time': '2027-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1822494600,
                'time': '2027-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          122:
              {
                'ts': 1838219400,
                'time': '2028-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 1853944200,
                'time': '2028-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          124:
              {
                'ts': 1869669000,
                'time': '2029-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 1885998600,
                'time': '2029-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          126:
              {
                'ts': 1901723400,
                'time': '2030-04-06T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 1917448200,
                'time': '2030-10-05T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          128:
              {
                'ts': 1933173000,
                'time': '2031-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 1948897800,
                'time': '2031-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          130:
              {
                'ts': 1964622600,
                'time': '2032-04-03T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 1980347400,
                'time': '2032-10-02T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          132:
              {
                'ts': 1996072200,
                'time': '2033-04-02T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 2011797000,
                'time': '2033-10-01T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          134:
              {
                'ts': 2027521800,
                'time': '2034-04-01T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 2043246600,
                'time': '2034-09-30T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          136:
              {
                'ts': 2058971400,
                'time': '2035-03-31T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 2075301000,
                'time': '2035-10-06T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          138:
              {
                'ts': 2091025800,
                'time': '2036-04-05T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 2106750600,
                'time': '2036-10-04T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              },
          140:
              {
                'ts': 2122475400,
                'time': '2037-04-04T16:30:00+0000',
                'offset': 34200,
                'isdst': false,
                'abbr': 'CST'
              },
          141:
              {
                'ts': 2138200200,
                'time': '2037-10-03T16:30:00+0000',
                'offset': 37800,
                'isdst': true,
                'abbr': 'CST'
              }
        },
    'Brazil/Acre':
        {
          0:
              {
                'ts': -1767209328,
                'time': '1914-01-01T04:31:12+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          1:
              {
                'ts': -1206950400,
                'time': '1931-10-03T16:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          2:
              {
                'ts': -1191355200,
                'time': '1932-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          3:
              {
                'ts': -1175367600,
                'time': '1932-10-03T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          4:
              {
                'ts': -1159819200,
                'time': '1933-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          5:
              {
                'ts': -633812400,
                'time': '1949-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          6:
              {
                'ts': -622062000,
                'time': '1950-04-16T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          7:
              {
                'ts': -602276400,
                'time': '1950-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          8:
              {
                'ts': -591825600,
                'time': '1951-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          9:
              {
                'ts': -570740400,
                'time': '1951-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          10:
              {
                'ts': -560203200,
                'time': '1952-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          11:
              {
                'ts': -539118000,
                'time': '1952-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          12:
              {
                'ts': -531345600,
                'time': '1953-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          13:
              {
                'ts': -191358000,
                'time': '1963-12-09T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          14:
              {
                'ts': -184190400,
                'time': '1964-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          15:
              {
                'ts': -155156400,
                'time': '1965-01-31T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          16:
              {
                'ts': -150062400,
                'time': '1965-03-31T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          17:
              {
                'ts': -128890800,
                'time': '1965-12-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          18:
              {
                'ts': -121118400,
                'time': '1966-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          19:
              {
                'ts': -99946800,
                'time': '1966-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          20:
              {
                'ts': -89582400,
                'time': '1967-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          21:
              {
                'ts': -68410800,
                'time': '1967-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          22:
              {
                'ts': -57960000,
                'time': '1968-03-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          23:
              {
                'ts': 499755600,
                'time': '1985-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          24:
              {
                'ts': 511243200,
                'time': '1986-03-15T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          25:
              {
                'ts': 530600400,
                'time': '1986-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          26:
              {
                'ts': 540273600,
                'time': '1987-02-14T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              },
          27:
              {
                'ts': 562136400,
                'time': '1987-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'ACST'
              },
          28:
              {
                'ts': 571204800,
                'time': '1988-02-07T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ACT'
              }
        },
    'Brazil/DeNoronha':
        {
          0:
              {
                'ts': -1767217820,
                'time': '1914-01-01T02:09:40+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          1:
              {
                'ts': -1206961200,
                'time': '1931-10-03T13:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          2:
              {
                'ts': -1191366000,
                'time': '1932-04-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          3:
              {
                'ts': -1175378400,
                'time': '1932-10-03T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          4:
              {
                'ts': -1159830000,
                'time': '1933-04-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          5:
              {
                'ts': -633823200,
                'time': '1949-12-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          6:
              {
                'ts': -622072800,
                'time': '1950-04-16T02:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          7:
              {
                'ts': -602287200,
                'time': '1950-12-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          8:
              {
                'ts': -591836400,
                'time': '1951-04-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          9:
              {
                'ts': -570751200,
                'time': '1951-12-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          10:
              {
                'ts': -560214000,
                'time': '1952-04-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          11:
              {
                'ts': -539128800,
                'time': '1952-12-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          12:
              {
                'ts': -531356400,
                'time': '1953-03-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          13:
              {
                'ts': -191368800,
                'time': '1963-12-09T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          14:
              {
                'ts': -184201200,
                'time': '1964-03-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          15:
              {
                'ts': -155167200,
                'time': '1965-01-31T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          16:
              {
                'ts': -150073200,
                'time': '1965-03-31T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          17:
              {
                'ts': -128901600,
                'time': '1965-12-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          18:
              {
                'ts': -121129200,
                'time': '1966-03-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          19:
              {
                'ts': -99957600,
                'time': '1966-11-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          20:
              {
                'ts': -89593200,
                'time': '1967-03-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          21:
              {
                'ts': -68421600,
                'time': '1967-11-01T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          22:
              {
                'ts': -57970800,
                'time': '1968-03-01T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          23:
              {
                'ts': 499744800,
                'time': '1985-11-02T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          24:
              {
                'ts': 511232400,
                'time': '1986-03-15T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          25:
              {
                'ts': 530589600,
                'time': '1986-10-25T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          26:
              {
                'ts': 540262800,
                'time': '1987-02-14T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          27:
              {
                'ts': 562125600,
                'time': '1987-10-25T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          28:
              {
                'ts': 571194000,
                'time': '1988-02-07T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          29:
              {
                'ts': 592970400,
                'time': '1988-10-16T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          30:
              {
                'ts': 602038800,
                'time': '1989-01-29T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          31:
              {
                'ts': 624420000,
                'time': '1989-10-15T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          32:
              {
                'ts': 634698000,
                'time': '1990-02-11T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          33:
              {
                'ts': 938916000,
                'time': '1999-10-03T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          34:
              {
                'ts': 951613200,
                'time': '2000-02-27T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          35:
              {
                'ts': 970970400,
                'time': '2000-10-08T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          36:
              {
                'ts': 971571600,
                'time': '2000-10-15T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              },
          37:
              {
                'ts': 1003024800,
                'time': '2001-10-14T02:00:00+0000',
                'offset': -3600,
                'isdst': true,
                'abbr': 'FNST'
              },
          38:
              {
                'ts': 1013907600,
                'time': '2002-02-17T01:00:00+0000',
                'offset': -7200,
                'isdst': false,
                'abbr': 'FNT'
              }
        },
    'Brazil/East':
        {
          0:
              {
                'ts': -1767214412,
                'time': '1914-01-01T03:06:28+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          1:
              {
                'ts': -1206957600,
                'time': '1931-10-03T14:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          2:
              {
                'ts': -1191362400,
                'time': '1932-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          3:
              {
                'ts': -1175374800,
                'time': '1932-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          4:
              {
                'ts': -1159826400,
                'time': '1933-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          5:
              {
                'ts': -633819600,
                'time': '1949-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          6:
              {
                'ts': -622069200,
                'time': '1950-04-16T03:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          7:
              {
                'ts': -602283600,
                'time': '1950-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          8:
              {
                'ts': -591832800,
                'time': '1951-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          9:
              {
                'ts': -570747600,
                'time': '1951-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          10:
              {
                'ts': -560210400,
                'time': '1952-04-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          11:
              {
                'ts': -539125200,
                'time': '1952-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          12:
              {
                'ts': -531352800,
                'time': '1953-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          13:
              {
                'ts': -195426000,
                'time': '1963-10-23T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          14:
              {
                'ts': -184197600,
                'time': '1964-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          15:
              {
                'ts': -155163600,
                'time': '1965-01-31T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          16:
              {
                'ts': -150069600,
                'time': '1965-03-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          17:
              {
                'ts': -128898000,
                'time': '1965-12-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          18:
              {
                'ts': -121125600,
                'time': '1966-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          19:
              {
                'ts': -99954000,
                'time': '1966-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          20:
              {
                'ts': -89589600,
                'time': '1967-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          21:
              {
                'ts': -68418000,
                'time': '1967-11-01T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          22:
              {
                'ts': -57967200,
                'time': '1968-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          23:
              {
                'ts': 499748400,
                'time': '1985-11-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          24:
              {
                'ts': 511236000,
                'time': '1986-03-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          25:
              {
                'ts': 530593200,
                'time': '1986-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          26:
              {
                'ts': 540266400,
                'time': '1987-02-14T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          27:
              {
                'ts': 562129200,
                'time': '1987-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          28:
              {
                'ts': 571197600,
                'time': '1988-02-07T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          29:
              {
                'ts': 592974000,
                'time': '1988-10-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          30:
              {
                'ts': 602042400,
                'time': '1989-01-29T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          31:
              {
                'ts': 624423600,
                'time': '1989-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          32:
              {
                'ts': 634701600,
                'time': '1990-02-11T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          33:
              {
                'ts': 656478000,
                'time': '1990-10-21T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          34:
              {
                'ts': 666756000,
                'time': '1991-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          35:
              {
                'ts': 687927600,
                'time': '1991-10-20T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          36:
              {
                'ts': 697600800,
                'time': '1992-02-09T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          37:
              {
                'ts': 719982000,
                'time': '1992-10-25T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          38:
              {
                'ts': 728445600,
                'time': '1993-01-31T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          39:
              {
                'ts': 750826800,
                'time': '1993-10-17T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          40:
              {
                'ts': 761709600,
                'time': '1994-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          41:
              {
                'ts': 782276400,
                'time': '1994-10-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          42:
              {
                'ts': 793159200,
                'time': '1995-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          43:
              {
                'ts': 813726000,
                'time': '1995-10-15T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          44:
              {
                'ts': 824004000,
                'time': '1996-02-11T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          45:
              {
                'ts': 844570800,
                'time': '1996-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          46:
              {
                'ts': 856058400,
                'time': '1997-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          47:
              {
                'ts': 876106800,
                'time': '1997-10-06T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          48:
              {
                'ts': 888717600,
                'time': '1998-03-01T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          49:
              {
                'ts': 908074800,
                'time': '1998-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          50:
              {
                'ts': 919562400,
                'time': '1999-02-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          51:
              {
                'ts': 938919600,
                'time': '1999-10-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          52:
              {
                'ts': 951616800,
                'time': '2000-02-27T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          53:
              {
                'ts': 970974000,
                'time': '2000-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          54:
              {
                'ts': 982461600,
                'time': '2001-02-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          55:
              {
                'ts': 1003028400,
                'time': '2001-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          56:
              {
                'ts': 1013911200,
                'time': '2002-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          57:
              {
                'ts': 1036292400,
                'time': '2002-11-03T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          58:
              {
                'ts': 1045360800,
                'time': '2003-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          59:
              {
                'ts': 1066532400,
                'time': '2003-10-19T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          60:
              {
                'ts': 1076810400,
                'time': '2004-02-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          61:
              {
                'ts': 1099364400,
                'time': '2004-11-02T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          62:
              {
                'ts': 1108864800,
                'time': '2005-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          63:
              {
                'ts': 1129431600,
                'time': '2005-10-16T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          64:
              {
                'ts': 1140314400,
                'time': '2006-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          65:
              {
                'ts': 1162695600,
                'time': '2006-11-05T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          66:
              {
                'ts': 1172368800,
                'time': '2007-02-25T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          67:
              {
                'ts': 1192330800,
                'time': '2007-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          68:
              {
                'ts': 1203213600,
                'time': '2008-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          69:
              {
                'ts': 1223780400,
                'time': '2008-10-12T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          70:
              {
                'ts': 1234663200,
                'time': '2009-02-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          71:
              {
                'ts': 1255230000,
                'time': '2009-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          72:
              {
                'ts': 1266717600,
                'time': '2010-02-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          73:
              {
                'ts': 1286679600,
                'time': '2010-10-10T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          74:
              {
                'ts': 1298167200,
                'time': '2011-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          75:
              {
                'ts': 1318129200,
                'time': '2011-10-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          76:
              {
                'ts': 1329616800,
                'time': '2012-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          77:
              {
                'ts': 1350183600,
                'time': '2012-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          78:
              {
                'ts': 1361066400,
                'time': '2013-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          79:
              {
                'ts': 1381633200,
                'time': '2013-10-13T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          80:
              {
                'ts': 1392516000,
                'time': '2014-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          81:
              {
                'ts': 1413082800,
                'time': '2014-10-12T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          82:
              {
                'ts': 1423965600,
                'time': '2015-02-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          83:
              {
                'ts': 1444532400,
                'time': '2015-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          84:
              {
                'ts': 1456020000,
                'time': '2016-02-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          85:
              {
                'ts': 1475982000,
                'time': '2016-10-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          86:
              {
                'ts': 1487469600,
                'time': '2017-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          87:
              {
                'ts': 1507431600,
                'time': '2017-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          88:
              {
                'ts': 1518919200,
                'time': '2018-02-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          89:
              {
                'ts': 1539486000,
                'time': '2018-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          90:
              {
                'ts': 1550368800,
                'time': '2019-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          91:
              {
                'ts': 1570935600,
                'time': '2019-10-13T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          92:
              {
                'ts': 1581818400,
                'time': '2020-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          93:
              {
                'ts': 1602385200,
                'time': '2020-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          94:
              {
                'ts': 1613872800,
                'time': '2021-02-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          95:
              {
                'ts': 1633834800,
                'time': '2021-10-10T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          96:
              {
                'ts': 1645322400,
                'time': '2022-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          97:
              {
                'ts': 1665284400,
                'time': '2022-10-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          98:
              {
                'ts': 1676772000,
                'time': '2023-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          99:
              {
                'ts': 1696734000,
                'time': '2023-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          100:
              {
                'ts': 1708221600,
                'time': '2024-02-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          101:
              {
                'ts': 1728788400,
                'time': '2024-10-13T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          102:
              {
                'ts': 1739671200,
                'time': '2025-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          103:
              {
                'ts': 1760238000,
                'time': '2025-10-12T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          104:
              {
                'ts': 1771120800,
                'time': '2026-02-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          105:
              {
                'ts': 1791687600,
                'time': '2026-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          106:
              {
                'ts': 1803175200,
                'time': '2027-02-21T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          107:
              {
                'ts': 1823137200,
                'time': '2027-10-10T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          108:
              {
                'ts': 1834624800,
                'time': '2028-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          109:
              {
                'ts': 1854586800,
                'time': '2028-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          110:
              {
                'ts': 1866074400,
                'time': '2029-02-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          111:
              {
                'ts': 1886641200,
                'time': '2029-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          112:
              {
                'ts': 1897524000,
                'time': '2030-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          113:
              {
                'ts': 1918090800,
                'time': '2030-10-13T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          114:
              {
                'ts': 1928973600,
                'time': '2031-02-16T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          115:
              {
                'ts': 1949540400,
                'time': '2031-10-12T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          116:
              {
                'ts': 1960423200,
                'time': '2032-02-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          117:
              {
                'ts': 1980990000,
                'time': '2032-10-10T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          118:
              {
                'ts': 1992477600,
                'time': '2033-02-20T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          119:
              {
                'ts': 2012439600,
                'time': '2033-10-09T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          120:
              {
                'ts': 2023927200,
                'time': '2034-02-19T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          121:
              {
                'ts': 2043889200,
                'time': '2034-10-08T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          122:
              {
                'ts': 2055376800,
                'time': '2035-02-18T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          123:
              {
                'ts': 2075943600,
                'time': '2035-10-14T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          124:
              {
                'ts': 2086826400,
                'time': '2036-02-17T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          125:
              {
                'ts': 2107393200,
                'time': '2036-10-12T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              },
          126:
              {
                'ts': 2118276000,
                'time': '2037-02-15T02:00:00+0000',
                'offset': -10800,
                'isdst': false,
                'abbr': 'BRT'
              },
          127:
              {
                'ts': 2138842800,
                'time': '2037-10-11T03:00:00+0000',
                'offset': -7200,
                'isdst': true,
                'abbr': 'BRST'
              }
        },
    'Brazil/West':
        {
          0:
              {
                'ts': -1767211196,
                'time': '1914-01-01T04:00:04+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          1:
              {
                'ts': -1206954000,
                'time': '1931-10-03T15:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          2:
              {
                'ts': -1191358800,
                'time': '1932-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          3:
              {
                'ts': -1175371200,
                'time': '1932-10-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          4:
              {
                'ts': -1159822800,
                'time': '1933-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          5:
              {
                'ts': -633816000,
                'time': '1949-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          6:
              {
                'ts': -622065600,
                'time': '1950-04-16T04:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          7:
              {
                'ts': -602280000,
                'time': '1950-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          8:
              {
                'ts': -591829200,
                'time': '1951-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          9:
              {
                'ts': -570744000,
                'time': '1951-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          10:
              {
                'ts': -560206800,
                'time': '1952-04-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          11:
              {
                'ts': -539121600,
                'time': '1952-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          12:
              {
                'ts': -531349200,
                'time': '1953-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          13:
              {
                'ts': -191361600,
                'time': '1963-12-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          14:
              {
                'ts': -184194000,
                'time': '1964-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          15:
              {
                'ts': -155160000,
                'time': '1965-01-31T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          16:
              {
                'ts': -150066000,
                'time': '1965-03-31T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          17:
              {
                'ts': -128894400,
                'time': '1965-12-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          18:
              {
                'ts': -121122000,
                'time': '1966-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          19:
              {
                'ts': -99950400,
                'time': '1966-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          20:
              {
                'ts': -89586000,
                'time': '1967-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          21:
              {
                'ts': -68414400,
                'time': '1967-11-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          22:
              {
                'ts': -57963600,
                'time': '1968-03-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          23:
              {
                'ts': 499752000,
                'time': '1985-11-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          24:
              {
                'ts': 511239600,
                'time': '1986-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          25:
              {
                'ts': 530596800,
                'time': '1986-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          26:
              {
                'ts': 540270000,
                'time': '1987-02-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          27:
              {
                'ts': 562132800,
                'time': '1987-10-25T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          28:
              {
                'ts': 571201200,
                'time': '1988-02-07T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              },
          29:
              {
                'ts': 750830400,
                'time': '1993-10-17T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AMST'
              },
          30:
              {
                'ts': 761713200,
                'time': '1994-02-20T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AMT'
              }
        },
    'Canada/Atlantic':
        {
          0:
              {
                'ts': -2131645536,
                'time': '1902-06-15T04:14:24+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          1:
              {
                'ts': -1696276800,
                'time': '1916-04-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          2:
              {
                'ts': -1680469200,
                'time': '1916-10-01T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          3:
              {
                'ts': -1632074400,
                'time': '1918-04-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          4:
              {
                'ts': -1614798000,
                'time': '1918-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          5:
              {
                'ts': -1566763200,
                'time': '1920-05-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          6:
              {
                'ts': -1557090000,
                'time': '1920-08-29T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          7:
              {
                'ts': -1535486400,
                'time': '1921-05-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          8:
              {
                'ts': -1524949200,
                'time': '1921-09-05T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          9:
              {
                'ts': -1504468800,
                'time': '1922-04-30T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          10:
              {
                'ts': -1493413200,
                'time': '1922-09-05T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          11:
              {
                'ts': -1472414400,
                'time': '1923-05-06T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          12:
              {
                'ts': -1461963600,
                'time': '1923-09-04T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          13:
              {
                'ts': -1440964800,
                'time': '1924-05-04T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          14:
              {
                'ts': -1429390800,
                'time': '1924-09-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          15:
              {
                'ts': -1409515200,
                'time': '1925-05-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          16:
              {
                'ts': -1396731600,
                'time': '1925-09-28T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          17:
              {
                'ts': -1376856000,
                'time': '1926-05-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          18:
              {
                'ts': -1366491600,
                'time': '1926-09-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          19:
              {
                'ts': -1346616000,
                'time': '1927-05-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          20:
              {
                'ts': -1333832400,
                'time': '1927-09-26T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          21:
              {
                'ts': -1313956800,
                'time': '1928-05-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          22:
              {
                'ts': -1303678800,
                'time': '1928-09-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          23:
              {
                'ts': -1282507200,
                'time': '1929-05-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          24:
              {
                'ts': -1272661200,
                'time': '1929-09-03T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          25:
              {
                'ts': -1251057600,
                'time': '1930-05-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          26:
              {
                'ts': -1240088400,
                'time': '1930-09-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          27:
              {
                'ts': -1219608000,
                'time': '1931-05-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          28:
              {
                'ts': -1207429200,
                'time': '1931-09-28T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          29:
              {
                'ts': -1188763200,
                'time': '1932-05-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          30:
              {
                'ts': -1175979600,
                'time': '1932-09-26T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          31:
              {
                'ts': -1157313600,
                'time': '1933-04-30T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          32:
              {
                'ts': -1143925200,
                'time': '1933-10-02T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          33:
              {
                'ts': -1124049600,
                'time': '1934-05-20T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          34:
              {
                'ts': -1113771600,
                'time': '1934-09-16T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          35:
              {
                'ts': -1091390400,
                'time': '1935-06-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          36:
              {
                'ts': -1081026000,
                'time': '1935-09-30T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          37:
              {
                'ts': -1059854400,
                'time': '1936-06-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          38:
              {
                'ts': -1050786000,
                'time': '1936-09-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          39:
              {
                'ts': -1030910400,
                'time': '1937-05-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          40:
              {
                'ts': -1018126800,
                'time': '1937-09-27T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          41:
              {
                'ts': -999460800,
                'time': '1938-05-01T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          42:
              {
                'ts': -986677200,
                'time': '1938-09-26T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          43:
              {
                'ts': -965592000,
                'time': '1939-05-28T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          44:
              {
                'ts': -955227600,
                'time': '1939-09-25T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          45:
              {
                'ts': -935956800,
                'time': '1940-05-05T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          46:
              {
                'ts': -923173200,
                'time': '1940-09-30T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          47:
              {
                'ts': -904507200,
                'time': '1941-05-04T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          48:
              {
                'ts': -891723600,
                'time': '1941-09-29T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          49:
              {
                'ts': -880221600,
                'time': '1942-02-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'AWT'
              },
          50:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'APT'
              },
          51:
              {
                'ts': -765399600,
                'time': '1945-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          52:
              {
                'ts': -747252000,
                'time': '1946-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          53:
              {
                'ts': -733950000,
                'time': '1946-09-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          54:
              {
                'ts': -715802400,
                'time': '1947-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          55:
              {
                'ts': -702500400,
                'time': '1947-09-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          56:
              {
                'ts': -684352800,
                'time': '1948-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          57:
              {
                'ts': -671050800,
                'time': '1948-09-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          58:
              {
                'ts': -652903200,
                'time': '1949-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          59:
              {
                'ts': -639601200,
                'time': '1949-09-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          60:
              {
                'ts': -589399200,
                'time': '1951-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          61:
              {
                'ts': -576097200,
                'time': '1951-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          62:
              {
                'ts': -557949600,
                'time': '1952-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          63:
              {
                'ts': -544647600,
                'time': '1952-09-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          64:
              {
                'ts': -526500000,
                'time': '1953-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          65:
              {
                'ts': -513198000,
                'time': '1953-09-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          66:
              {
                'ts': -495050400,
                'time': '1954-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          67:
              {
                'ts': -481748400,
                'time': '1954-09-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          68:
              {
                'ts': -431546400,
                'time': '1956-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          69:
              {
                'ts': -418244400,
                'time': '1956-09-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          70:
              {
                'ts': -400096800,
                'time': '1957-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          71:
              {
                'ts': -386794800,
                'time': '1957-09-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          72:
              {
                'ts': -368647200,
                'time': '1958-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          73:
              {
                'ts': -355345200,
                'time': '1958-09-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          74:
              {
                'ts': -337197600,
                'time': '1959-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          75:
              {
                'ts': -323895600,
                'time': '1959-09-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          76:
              {
                'ts': -242244000,
                'time': '1962-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          77:
              {
                'ts': -226522800,
                'time': '1962-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          78:
              {
                'ts': -210794400,
                'time': '1963-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          79:
              {
                'ts': -195073200,
                'time': '1963-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          80:
              {
                'ts': -179344800,
                'time': '1964-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          81:
              {
                'ts': -163623600,
                'time': '1964-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          82:
              {
                'ts': -147895200,
                'time': '1965-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          83:
              {
                'ts': -131569200,
                'time': '1965-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          84:
              {
                'ts': -116445600,
                'time': '1966-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          85:
              {
                'ts': -100119600,
                'time': '1966-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          86:
              {
                'ts': -84391200,
                'time': '1967-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          87:
              {
                'ts': -68670000,
                'time': '1967-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          88:
              {
                'ts': -52941600,
                'time': '1968-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          89:
              {
                'ts': -37220400,
                'time': '1968-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          90:
              {
                'ts': -21492000,
                'time': '1969-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          91:
              {
                'ts': -5770800,
                'time': '1969-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          92:
              {
                'ts': 9957600,
                'time': '1970-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          93:
              {
                'ts': 25678800,
                'time': '1970-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          94:
              {
                'ts': 41407200,
                'time': '1971-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          95:
              {
                'ts': 57733200,
                'time': '1971-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          96:
              {
                'ts': 73461600,
                'time': '1972-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          97:
              {
                'ts': 89182800,
                'time': '1972-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          98:
              {
                'ts': 104911200,
                'time': '1973-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          99:
              {
                'ts': 120632400,
                'time': '1973-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          100:
              {
                'ts': 136360800,
                'time': '1974-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          101:
              {
                'ts': 152082000,
                'time': '1974-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          102:
              {
                'ts': 167810400,
                'time': '1975-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          103:
              {
                'ts': 183531600,
                'time': '1975-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          104:
              {
                'ts': 199260000,
                'time': '1976-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          105:
              {
                'ts': 215586000,
                'time': '1976-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          106:
              {
                'ts': 230709600,
                'time': '1977-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          107:
              {
                'ts': 247035600,
                'time': '1977-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          108:
              {
                'ts': 262764000,
                'time': '1978-04-30T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          109:
              {
                'ts': 278485200,
                'time': '1978-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          110:
              {
                'ts': 294213600,
                'time': '1979-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          111:
              {
                'ts': 309934800,
                'time': '1979-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          112:
              {
                'ts': 325663200,
                'time': '1980-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          113:
              {
                'ts': 341384400,
                'time': '1980-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          114:
              {
                'ts': 357112800,
                'time': '1981-04-26T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          115:
              {
                'ts': 372834000,
                'time': '1981-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          116:
              {
                'ts': 388562400,
                'time': '1982-04-25T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          117:
              {
                'ts': 404888400,
                'time': '1982-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          118:
              {
                'ts': 420012000,
                'time': '1983-04-24T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          119:
              {
                'ts': 436338000,
                'time': '1983-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          120:
              {
                'ts': 452066400,
                'time': '1984-04-29T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          121:
              {
                'ts': 467787600,
                'time': '1984-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          122:
              {
                'ts': 483516000,
                'time': '1985-04-28T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          123:
              {
                'ts': 499237200,
                'time': '1985-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          124:
              {
                'ts': 514965600,
                'time': '1986-04-27T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          125:
              {
                'ts': 530686800,
                'time': '1986-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          126:
              {
                'ts': 544600800,
                'time': '1987-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          127:
              {
                'ts': 562136400,
                'time': '1987-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          128:
              {
                'ts': 576050400,
                'time': '1988-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          129:
              {
                'ts': 594190800,
                'time': '1988-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          130:
              {
                'ts': 607500000,
                'time': '1989-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          131:
              {
                'ts': 625640400,
                'time': '1989-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          132:
              {
                'ts': 638949600,
                'time': '1990-04-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          133:
              {
                'ts': 657090000,
                'time': '1990-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          134:
              {
                'ts': 671004000,
                'time': '1991-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          135:
              {
                'ts': 688539600,
                'time': '1991-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          136:
              {
                'ts': 702453600,
                'time': '1992-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          137:
              {
                'ts': 719989200,
                'time': '1992-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          138:
              {
                'ts': 733903200,
                'time': '1993-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          139:
              {
                'ts': 752043600,
                'time': '1993-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          140:
              {
                'ts': 765352800,
                'time': '1994-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          141:
              {
                'ts': 783493200,
                'time': '1994-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          142:
              {
                'ts': 796802400,
                'time': '1995-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          143:
              {
                'ts': 814942800,
                'time': '1995-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          144:
              {
                'ts': 828856800,
                'time': '1996-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          145:
              {
                'ts': 846392400,
                'time': '1996-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          146:
              {
                'ts': 860306400,
                'time': '1997-04-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          147:
              {
                'ts': 877842000,
                'time': '1997-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          148:
              {
                'ts': 891756000,
                'time': '1998-04-05T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          149:
              {
                'ts': 909291600,
                'time': '1998-10-25T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          150:
              {
                'ts': 923205600,
                'time': '1999-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          151:
              {
                'ts': 941346000,
                'time': '1999-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          152:
              {
                'ts': 954655200,
                'time': '2000-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          153:
              {
                'ts': 972795600,
                'time': '2000-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          154:
              {
                'ts': 986104800,
                'time': '2001-04-01T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          155:
              {
                'ts': 1004245200,
                'time': '2001-10-28T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          156:
              {
                'ts': 1018159200,
                'time': '2002-04-07T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          157:
              {
                'ts': 1035694800,
                'time': '2002-10-27T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          158:
              {
                'ts': 1049608800,
                'time': '2003-04-06T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          159:
              {
                'ts': 1067144400,
                'time': '2003-10-26T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          160:
              {
                'ts': 1081058400,
                'time': '2004-04-04T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          161:
              {
                'ts': 1099198800,
                'time': '2004-10-31T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          162:
              {
                'ts': 1112508000,
                'time': '2005-04-03T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          163:
              {
                'ts': 1130648400,
                'time': '2005-10-30T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          164:
              {
                'ts': 1143957600,
                'time': '2006-04-02T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          165:
              {
                'ts': 1162098000,
                'time': '2006-10-29T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          166:
              {
                'ts': 1173592800,
                'time': '2007-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          167:
              {
                'ts': 1194152400,
                'time': '2007-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          168:
              {
                'ts': 1205042400,
                'time': '2008-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          169:
              {
                'ts': 1225602000,
                'time': '2008-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          170:
              {
                'ts': 1236492000,
                'time': '2009-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          171:
              {
                'ts': 1257051600,
                'time': '2009-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          172:
              {
                'ts': 1268546400,
                'time': '2010-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          173:
              {
                'ts': 1289106000,
                'time': '2010-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          174:
              {
                'ts': 1299996000,
                'time': '2011-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          175:
              {
                'ts': 1320555600,
                'time': '2011-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          176:
              {
                'ts': 1331445600,
                'time': '2012-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          177:
              {
                'ts': 1352005200,
                'time': '2012-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          178:
              {
                'ts': 1362895200,
                'time': '2013-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          179:
              {
                'ts': 1383454800,
                'time': '2013-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          180:
              {
                'ts': 1394344800,
                'time': '2014-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          181:
              {
                'ts': 1414904400,
                'time': '2014-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          182:
              {
                'ts': 1425794400,
                'time': '2015-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          183:
              {
                'ts': 1446354000,
                'time': '2015-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          184:
              {
                'ts': 1457848800,
                'time': '2016-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          185:
              {
                'ts': 1478408400,
                'time': '2016-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          186:
              {
                'ts': 1489298400,
                'time': '2017-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          187:
              {
                'ts': 1509858000,
                'time': '2017-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          188:
              {
                'ts': 1520748000,
                'time': '2018-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          189:
              {
                'ts': 1541307600,
                'time': '2018-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          190:
              {
                'ts': 1552197600,
                'time': '2019-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          191:
              {
                'ts': 1572757200,
                'time': '2019-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          192:
              {
                'ts': 1583647200,
                'time': '2020-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          193:
              {
                'ts': 1604206800,
                'time': '2020-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          194:
              {
                'ts': 1615701600,
                'time': '2021-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          195:
              {
                'ts': 1636261200,
                'time': '2021-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          196:
              {
                'ts': 1647151200,
                'time': '2022-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          197:
              {
                'ts': 1667710800,
                'time': '2022-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          198:
              {
                'ts': 1678600800,
                'time': '2023-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          199:
              {
                'ts': 1699160400,
                'time': '2023-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          200:
              {
                'ts': 1710050400,
                'time': '2024-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          201:
              {
                'ts': 1730610000,
                'time': '2024-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          202:
              {
                'ts': 1741500000,
                'time': '2025-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          203:
              {
                'ts': 1762059600,
                'time': '2025-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          204:
              {
                'ts': 1772949600,
                'time': '2026-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          205:
              {
                'ts': 1793509200,
                'time': '2026-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          206:
              {
                'ts': 1805004000,
                'time': '2027-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          207:
              {
                'ts': 1825563600,
                'time': '2027-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          208:
              {
                'ts': 1836453600,
                'time': '2028-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          209:
              {
                'ts': 1857013200,
                'time': '2028-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          210:
              {
                'ts': 1867903200,
                'time': '2029-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          211:
              {
                'ts': 1888462800,
                'time': '2029-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          212:
              {
                'ts': 1899352800,
                'time': '2030-03-10T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          213:
              {
                'ts': 1919912400,
                'time': '2030-11-03T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          214:
              {
                'ts': 1930802400,
                'time': '2031-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          215:
              {
                'ts': 1951362000,
                'time': '2031-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          216:
              {
                'ts': 1962856800,
                'time': '2032-03-14T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          217:
              {
                'ts': 1983416400,
                'time': '2032-11-07T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          218:
              {
                'ts': 1994306400,
                'time': '2033-03-13T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          219:
              {
                'ts': 2014866000,
                'time': '2033-11-06T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          220:
              {
                'ts': 2025756000,
                'time': '2034-03-12T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          221:
              {
                'ts': 2046315600,
                'time': '2034-11-05T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          222:
              {
                'ts': 2057205600,
                'time': '2035-03-11T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          223:
              {
                'ts': 2077765200,
                'time': '2035-11-04T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          224:
              {
                'ts': 2088655200,
                'time': '2036-03-09T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          225:
              {
                'ts': 2109214800,
                'time': '2036-11-02T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              },
          226:
              {
                'ts': 2120104800,
                'time': '2037-03-08T06:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'ADT'
              },
          227:
              {
                'ts': 2140664400,
                'time': '2037-11-01T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'AST'
              }
        },
    'Canada/Central':
        {
          0:
              {
                'ts': -1694368800,
                'time': '1916-04-23T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1681671600,
                'time': '1916-09-17T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1632067200,
                'time': '1918-04-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1614790800,
                'time': '1918-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -1029686400,
                'time': '1937-05-16T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': -1018198800,
                'time': '1937-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          7:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          8:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -746035200,
                'time': '1946-05-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -732733200,
                'time': '1946-10-13T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -702493200,
                'time': '1947-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -684345600,
                'time': '1948-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -671043600,
                'time': '1948-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -652896000,
                'time': '1949-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -639594000,
                'time': '1949-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -620755200,
                'time': '1950-05-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -607626000,
                'time': '1950-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': -450291600,
                'time': '1955-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': -418237200,
                'time': '1956-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': -355338000,
                'time': '1958-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': -321469200,
                'time': '1959-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          38:
              {
                'ts': -292438800,
                'time': '1960-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': -210787200,
                'time': '1963-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': -198090000,
                'time': '1963-09-22T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': -116438400,
                'time': '1966-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': -100108800,
                'time': '1966-10-30T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': -84384000,
                'time': '1967-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': -52934400,
                'time': '1968-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': -37209600,
                'time': '1968-10-27T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': -21484800,
                'time': '1969-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 9964800,
                'time': '1970-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 25689600,
                'time': '1970-10-25T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 41414400,
                'time': '1971-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 57744000,
                'time': '1971-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 73468800,
                'time': '1972-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 104918400,
                'time': '1973-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 136368000,
                'time': '1974-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 167817600,
                'time': '1975-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 199267200,
                'time': '1976-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 230716800,
                'time': '1977-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 262771200,
                'time': '1978-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 294220800,
                'time': '1979-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          89:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 702460800,
                'time': '1992-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 733910400,
                'time': '1993-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 765360000,
                'time': '1994-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 796809600,
                'time': '1995-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 986112000,
                'time': '2001-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          120:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1136095200,
                'time': '2006-01-01T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          122:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          123:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          124:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          125:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          126:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          127:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          128:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          129:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          130:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          131:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          132:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          133:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          134:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          135:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          136:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          137:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          138:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          139:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          140:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          141:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          142:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          143:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          144:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          145:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          146:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          147:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          148:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          149:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          150:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          151:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          152:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          153:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          154:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          155:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          156:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          157:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          158:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          159:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          160:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          161:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          162:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          163:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          164:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          165:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          166:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          167:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          168:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          169:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          170:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          171:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          172:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          173:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          174:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          175:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          176:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          177:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          178:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          179:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          180:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          181:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          182:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          183:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          184:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          185:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Canada/East-Saskatchewan':
        {
          0:
              {
                'ts': -2030202084,
                'time': '1905-09-01T06:58:36+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1632063600,
                'time': '1918-04-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          2:
              {
                'ts': -1614787200,
                'time': '1918-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1251651600,
                'time': '1930-05-04T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          4:
              {
                'ts': -1238349600,
                'time': '1930-10-05T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1220202000,
                'time': '1931-05-03T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          6:
              {
                'ts': -1206900000,
                'time': '1931-10-04T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          7:
              {
                'ts': -1188752400,
                'time': '1932-05-01T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          8:
              {
                'ts': -1175450400,
                'time': '1932-10-02T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          9:
              {
                'ts': -1156698000,
                'time': '1933-05-07T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          10:
              {
                'ts': -1144000800,
                'time': '1933-10-01T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -1125248400,
                'time': '1934-05-06T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -1111946400,
                'time': '1934-10-07T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': -1032714000,
                'time': '1937-04-11T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': -1016992800,
                'time': '1937-10-10T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': -1001264400,
                'time': '1938-04-10T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': -986148000,
                'time': '1938-10-02T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': -969814800,
                'time': '1939-04-09T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': -954093600,
                'time': '1939-10-08T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': -937760400,
                'time': '1940-04-14T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': -922039200,
                'time': '1940-10-13T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': -906310800,
                'time': '1941-04-13T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': -890589600,
                'time': '1941-10-12T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          24:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          25:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          26:
              {
                'ts': -748450800,
                'time': '1946-04-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          27:
              {
                'ts': -732729600,
                'time': '1946-10-13T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          28:
              {
                'ts': -715791600,
                'time': '1947-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          29:
              {
                'ts': -702489600,
                'time': '1947-09-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          30:
              {
                'ts': -684342000,
                'time': '1948-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          31:
              {
                'ts': -671040000,
                'time': '1948-09-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          32:
              {
                'ts': -652892400,
                'time': '1949-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          33:
              {
                'ts': -639590400,
                'time': '1949-09-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          34:
              {
                'ts': -620838000,
                'time': '1950-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          35:
              {
                'ts': -608140800,
                'time': '1950-09-24T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          36:
              {
                'ts': -589388400,
                'time': '1951-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          37:
              {
                'ts': -576086400,
                'time': '1951-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          38:
              {
                'ts': -557938800,
                'time': '1952-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          39:
              {
                'ts': -544636800,
                'time': '1952-09-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          40:
              {
                'ts': -526489200,
                'time': '1953-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          41:
              {
                'ts': -513187200,
                'time': '1953-09-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          42:
              {
                'ts': -495039600,
                'time': '1954-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          43:
              {
                'ts': -481737600,
                'time': '1954-09-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          44:
              {
                'ts': -463590000,
                'time': '1955-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          45:
              {
                'ts': -450288000,
                'time': '1955-09-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          46:
              {
                'ts': -431535600,
                'time': '1956-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          47:
              {
                'ts': -418233600,
                'time': '1956-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          48:
              {
                'ts': -400086000,
                'time': '1957-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          49:
              {
                'ts': -386784000,
                'time': '1957-09-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          50:
              {
                'ts': -337186800,
                'time': '1959-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          51:
              {
                'ts': -321465600,
                'time': '1959-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          52:
              {
                'ts': -305737200,
                'time': '1960-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Canada/Eastern':
        {
          0:
              {
                'ts': -1632070800,
                'time': '1918-04-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          1:
              {
                'ts': -1614794400,
                'time': '1918-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -1601753400,
                'time': '1919-03-31T04:30:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          3:
              {
                'ts': -1583697600,
                'time': '1919-10-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -1567357200,
                'time': '1920-05-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          5:
              {
                'ts': -1554667200,
                'time': '1920-09-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -1534698000,
                'time': '1921-05-15T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          7:
              {
                'ts': -1524074400,
                'time': '1921-09-15T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': -1503248400,
                'time': '1922-05-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          9:
              {
                'ts': -1492365600,
                'time': '1922-09-17T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': -1471798800,
                'time': '1923-05-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          11:
              {
                'ts': -1460916000,
                'time': '1923-09-16T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': -1440954000,
                'time': '1924-05-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          13:
              {
                'ts': -1428861600,
                'time': '1924-09-21T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': -1409504400,
                'time': '1925-05-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          15:
              {
                'ts': -1397412000,
                'time': '1925-09-20T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': -1378054800,
                'time': '1926-05-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          17:
              {
                'ts': -1365962400,
                'time': '1926-09-19T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': -1346605200,
                'time': '1927-05-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          19:
              {
                'ts': -1333908000,
                'time': '1927-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': -1315155600,
                'time': '1928-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          21:
              {
                'ts': -1301853600,
                'time': '1928-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': -1283706000,
                'time': '1929-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          23:
              {
                'ts': -1270404000,
                'time': '1929-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': -1252256400,
                'time': '1930-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          25:
              {
                'ts': -1238954400,
                'time': '1930-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': -1220806800,
                'time': '1931-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          27:
              {
                'ts': -1207504800,
                'time': '1931-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': -1188752400,
                'time': '1932-05-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          29:
              {
                'ts': -1176055200,
                'time': '1932-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': -1157302800,
                'time': '1933-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': -1144000800,
                'time': '1933-10-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': -1125853200,
                'time': '1934-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': -1112551200,
                'time': '1934-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': -1094403600,
                'time': '1935-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': -1081101600,
                'time': '1935-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': -1062954000,
                'time': '1936-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': -1049652000,
                'time': '1936-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': -1031504400,
                'time': '1937-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': -1018202400,
                'time': '1937-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': -1000054800,
                'time': '1938-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': -986752800,
                'time': '1938-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': -968000400,
                'time': '1939-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': -955303200,
                'time': '1939-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': -936550800,
                'time': '1940-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': -880218000,
                'time': '1942-02-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EWT'
              },
          46:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EPT'
              },
          47:
              {
                'ts': -765396000,
                'time': '1945-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': -747248400,
                'time': '1946-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': -733946400,
                'time': '1946-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': -715806000,
                'time': '1947-04-27T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': -702504000,
                'time': '1947-09-28T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': -684356400,
                'time': '1948-04-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': -671054400,
                'time': '1948-09-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': -652906800,
                'time': '1949-04-24T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': -634161600,
                'time': '1949-11-27T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': -620845200,
                'time': '1950-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': -602704800,
                'time': '1950-11-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': -589395600,
                'time': '1951-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': -576093600,
                'time': '1951-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': -557946000,
                'time': '1952-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': -544644000,
                'time': '1952-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': -526496400,
                'time': '1953-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': -513194400,
                'time': '1953-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': -495046800,
                'time': '1954-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': -481744800,
                'time': '1954-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': -463597200,
                'time': '1955-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': -450295200,
                'time': '1955-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': -431542800,
                'time': '1956-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': -418240800,
                'time': '1956-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': -400093200,
                'time': '1957-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': -384372000,
                'time': '1957-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': -368643600,
                'time': '1958-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': -352922400,
                'time': '1958-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': -337194000,
                'time': '1959-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': -321472800,
                'time': '1959-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': -305744400,
                'time': '1960-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': -289418400,
                'time': '1960-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': -273690000,
                'time': '1961-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': -257968800,
                'time': '1961-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': -242240400,
                'time': '1962-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': -226519200,
                'time': '1962-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': -210790800,
                'time': '1963-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': -195069600,
                'time': '1963-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': -179341200,
                'time': '1964-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': -163620000,
                'time': '1964-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': -147891600,
                'time': '1965-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': -131565600,
                'time': '1965-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': -116442000,
                'time': '1966-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': -100116000,
                'time': '1966-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': -84387600,
                'time': '1967-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': -68666400,
                'time': '1967-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': -52938000,
                'time': '1968-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': -37216800,
                'time': '1968-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          98:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          99:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          100:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          101:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          102:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          103:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          104:
              {
                'ts': 136364400,
                'time': '1974-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          105:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          106:
              {
                'ts': 167814000,
                'time': '1975-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          107:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          108:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          109:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          110:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          111:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          112:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          113:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          114:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          115:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          116:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          117:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          118:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          119:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          120:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          121:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          122:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          123:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          124:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          125:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          126:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          127:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          128:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          129:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          130:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          131:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          132:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          133:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          134:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          135:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          136:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          137:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          138:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          139:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          140:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          141:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          142:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          143:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          144:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          145:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          146:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          147:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          148:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          149:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          150:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          151:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          152:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          153:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          154:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          155:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          156:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          157:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          158:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          159:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          160:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          161:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          162:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          163:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          164:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          165:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          166:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          167:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          168:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          169:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          170:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          171:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          172:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          173:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          174:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          175:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          176:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          177:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          178:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          179:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          180:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          181:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          182:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          183:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          184:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          185:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          186:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          187:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          188:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          189:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          190:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          191:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          192:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          193:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          194:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          195:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          196:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          197:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          198:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          199:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          200:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          201:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          202:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          203:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          204:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          205:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          206:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          207:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          208:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          209:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          210:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          211:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          212:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          213:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          214:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          215:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          216:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          217:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          218:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          219:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          220:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          221:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          222:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          223:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          224:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          225:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          226:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          227:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          228:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          229:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          230:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          231:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'Canada/Mountain':
        {
          0:
              {
                'ts': -1998663968,
                'time': '1906-09-01T07:33:52+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1632063600,
                'time': '1918-04-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          2:
              {
                'ts': -1614787200,
                'time': '1918-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1600614000,
                'time': '1919-04-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          4:
              {
                'ts': -1596816000,
                'time': '1919-05-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1567954800,
                'time': '1920-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          6:
              {
                'ts': -1551628800,
                'time': '1920-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          7:
              {
                'ts': -1536505200,
                'time': '1921-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          8:
              {
                'ts': -1523203200,
                'time': '1921-09-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          9:
              {
                'ts': -1504450800,
                'time': '1922-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          10:
              {
                'ts': -1491753600,
                'time': '1922-09-24T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -1473001200,
                'time': '1923-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -1459699200,
                'time': '1923-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          14:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          15:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          16:
              {
                'ts': -715791600,
                'time': '1947-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          17:
              {
                'ts': -702489600,
                'time': '1947-09-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          18:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          19:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          20:
              {
                'ts': -21481200,
                'time': '1969-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          21:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          22:
              {
                'ts': 73472400,
                'time': '1972-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          23:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          24:
              {
                'ts': 104922000,
                'time': '1973-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          25:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          26:
              {
                'ts': 136371600,
                'time': '1974-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          27:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          28:
              {
                'ts': 167821200,
                'time': '1975-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          29:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          30:
              {
                'ts': 199270800,
                'time': '1976-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          31:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          32:
              {
                'ts': 230720400,
                'time': '1977-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          33:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          34:
              {
                'ts': 262774800,
                'time': '1978-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          35:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          36:
              {
                'ts': 294224400,
                'time': '1979-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          37:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          38:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          39:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          40:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          41:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          42:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          43:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          44:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          45:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          46:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          47:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          48:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          49:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          50:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          51:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          52:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          53:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          54:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          55:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          56:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          57:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          58:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          59:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          60:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          61:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          62:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          63:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          64:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          65:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          66:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          67:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          68:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          69:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          70:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          71:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          72:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          73:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          74:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          75:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          76:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          77:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          78:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          79:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          80:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          81:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          82:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          83:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          84:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          85:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          86:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          87:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          88:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          89:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          90:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          91:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          92:
              {
                'ts': 1173603600,
                'time': '2007-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          93:
              {
                'ts': 1194163200,
                'time': '2007-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          94:
              {
                'ts': 1205053200,
                'time': '2008-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          95:
              {
                'ts': 1225612800,
                'time': '2008-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          96:
              {
                'ts': 1236502800,
                'time': '2009-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          97:
              {
                'ts': 1257062400,
                'time': '2009-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          98:
              {
                'ts': 1268557200,
                'time': '2010-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          99:
              {
                'ts': 1289116800,
                'time': '2010-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          100:
              {
                'ts': 1300006800,
                'time': '2011-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          101:
              {
                'ts': 1320566400,
                'time': '2011-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          102:
              {
                'ts': 1331456400,
                'time': '2012-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          103:
              {
                'ts': 1352016000,
                'time': '2012-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          104:
              {
                'ts': 1362906000,
                'time': '2013-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          105:
              {
                'ts': 1383465600,
                'time': '2013-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          106:
              {
                'ts': 1394355600,
                'time': '2014-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          107:
              {
                'ts': 1414915200,
                'time': '2014-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          108:
              {
                'ts': 1425805200,
                'time': '2015-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          109:
              {
                'ts': 1446364800,
                'time': '2015-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          110:
              {
                'ts': 1457859600,
                'time': '2016-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          111:
              {
                'ts': 1478419200,
                'time': '2016-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          112:
              {
                'ts': 1489309200,
                'time': '2017-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          113:
              {
                'ts': 1509868800,
                'time': '2017-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          114:
              {
                'ts': 1520758800,
                'time': '2018-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          115:
              {
                'ts': 1541318400,
                'time': '2018-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          116:
              {
                'ts': 1552208400,
                'time': '2019-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          117:
              {
                'ts': 1572768000,
                'time': '2019-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          118:
              {
                'ts': 1583658000,
                'time': '2020-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          119:
              {
                'ts': 1604217600,
                'time': '2020-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          120:
              {
                'ts': 1615712400,
                'time': '2021-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          121:
              {
                'ts': 1636272000,
                'time': '2021-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          122:
              {
                'ts': 1647162000,
                'time': '2022-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          123:
              {
                'ts': 1667721600,
                'time': '2022-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          124:
              {
                'ts': 1678611600,
                'time': '2023-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          125:
              {
                'ts': 1699171200,
                'time': '2023-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          126:
              {
                'ts': 1710061200,
                'time': '2024-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          127:
              {
                'ts': 1730620800,
                'time': '2024-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          128:
              {
                'ts': 1741510800,
                'time': '2025-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          129:
              {
                'ts': 1762070400,
                'time': '2025-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          130:
              {
                'ts': 1772960400,
                'time': '2026-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          131:
              {
                'ts': 1793520000,
                'time': '2026-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          132:
              {
                'ts': 1805014800,
                'time': '2027-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          133:
              {
                'ts': 1825574400,
                'time': '2027-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          134:
              {
                'ts': 1836464400,
                'time': '2028-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          135:
              {
                'ts': 1857024000,
                'time': '2028-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          136:
              {
                'ts': 1867914000,
                'time': '2029-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          137:
              {
                'ts': 1888473600,
                'time': '2029-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          138:
              {
                'ts': 1899363600,
                'time': '2030-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          139:
              {
                'ts': 1919923200,
                'time': '2030-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          140:
              {
                'ts': 1930813200,
                'time': '2031-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          141:
              {
                'ts': 1951372800,
                'time': '2031-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          142:
              {
                'ts': 1962867600,
                'time': '2032-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          143:
              {
                'ts': 1983427200,
                'time': '2032-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          144:
              {
                'ts': 1994317200,
                'time': '2033-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          145:
              {
                'ts': 2014876800,
                'time': '2033-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          146:
              {
                'ts': 2025766800,
                'time': '2034-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          147:
              {
                'ts': 2046326400,
                'time': '2034-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          148:
              {
                'ts': 2057216400,
                'time': '2035-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          149:
              {
                'ts': 2077776000,
                'time': '2035-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          150:
              {
                'ts': 2088666000,
                'time': '2036-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          151:
              {
                'ts': 2109225600,
                'time': '2036-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          152:
              {
                'ts': 2120115600,
                'time': '2037-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          153:
              {
                'ts': 2140675200,
                'time': '2037-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'Canada/Newfoundland':
        {
          0:
              {
                'ts': -1664130548,
                'time': '1917-04-08T05:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          1:
              {
                'ts': -1650137348,
                'time': '1917-09-17T04:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          2:
              {
                'ts': -1632076148,
                'time': '1918-04-14T05:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          3:
              {
                'ts': -1614799748,
                'time': '1918-10-31T04:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          4:
              {
                'ts': -1598650148,
                'time': '1919-05-06T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          5:
              {
                'ts': -1590100148,
                'time': '1919-08-13T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          6:
              {
                'ts': -1567286948,
                'time': '1920-05-03T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          7:
              {
                'ts': -1551565748,
                'time': '1920-11-01T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          8:
              {
                'ts': -1535837348,
                'time': '1921-05-02T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          9:
              {
                'ts': -1520116148,
                'time': '1921-10-31T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          10:
              {
                'ts': -1503782948,
                'time': '1922-05-08T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          11:
              {
                'ts': -1488666548,
                'time': '1922-10-30T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          12:
              {
                'ts': -1472333348,
                'time': '1923-05-07T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          13:
              {
                'ts': -1457216948,
                'time': '1923-10-29T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          14:
              {
                'ts': -1440883748,
                'time': '1924-05-05T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          15:
              {
                'ts': -1425767348,
                'time': '1924-10-27T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          16:
              {
                'ts': -1409434148,
                'time': '1925-05-04T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          17:
              {
                'ts': -1394317748,
                'time': '1925-10-26T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          18:
              {
                'ts': -1377984548,
                'time': '1926-05-03T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          19:
              {
                'ts': -1362263348,
                'time': '1926-11-01T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          20:
              {
                'ts': -1346534948,
                'time': '1927-05-02T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          21:
              {
                'ts': -1330813748,
                'time': '1927-10-31T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          22:
              {
                'ts': -1314480548,
                'time': '1928-05-07T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          23:
              {
                'ts': -1299364148,
                'time': '1928-10-29T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          24:
              {
                'ts': -1283030948,
                'time': '1929-05-06T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          25:
              {
                'ts': -1267914548,
                'time': '1929-10-28T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          26:
              {
                'ts': -1251581348,
                'time': '1930-05-05T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          27:
              {
                'ts': -1236464948,
                'time': '1930-10-27T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          28:
              {
                'ts': -1220131748,
                'time': '1931-05-04T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          29:
              {
                'ts': -1205015348,
                'time': '1931-10-26T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          30:
              {
                'ts': -1188682148,
                'time': '1932-05-02T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          31:
              {
                'ts': -1172960948,
                'time': '1932-10-31T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          32:
              {
                'ts': -1156627748,
                'time': '1933-05-08T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          33:
              {
                'ts': -1141511348,
                'time': '1933-10-30T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          34:
              {
                'ts': -1125178148,
                'time': '1934-05-07T02:30:52+0000',
                'offset': -9052,
                'isdst': true,
                'abbr': 'NDT'
              },
          35:
              {
                'ts': -1110061748,
                'time': '1934-10-29T01:30:52+0000',
                'offset': -12652,
                'isdst': false,
                'abbr': 'NST'
              },
          36:
              {
                'ts': -1096921748,
                'time': '1935-03-30T03:30:52+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          37:
              {
                'ts': -1093728600,
                'time': '1935-05-06T02:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          38:
              {
                'ts': -1078612200,
                'time': '1935-10-28T01:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          39:
              {
                'ts': -1061670600,
                'time': '1936-05-11T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          40:
              {
                'ts': -1048973400,
                'time': '1936-10-05T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          41:
              {
                'ts': -1030221000,
                'time': '1937-05-10T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          42:
              {
                'ts': -1017523800,
                'time': '1937-10-04T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          43:
              {
                'ts': -998771400,
                'time': '1938-05-09T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          44:
              {
                'ts': -986074200,
                'time': '1938-10-03T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          45:
              {
                'ts': -966717000,
                'time': '1939-05-15T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          46:
              {
                'ts': -954624600,
                'time': '1939-10-02T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          47:
              {
                'ts': -935267400,
                'time': '1940-05-13T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          48:
              {
                'ts': -922570200,
                'time': '1940-10-07T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          49:
              {
                'ts': -903817800,
                'time': '1941-05-12T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          50:
              {
                'ts': -891120600,
                'time': '1941-10-06T02:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          51:
              {
                'ts': -872368200,
                'time': '1942-05-11T03:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NWT'
              },
          52:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NPT'
              },
          53:
              {
                'ts': -765401400,
                'time': '1945-09-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          54:
              {
                'ts': -746044200,
                'time': '1946-05-12T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          55:
              {
                'ts': -733347000,
                'time': '1946-10-06T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          56:
              {
                'ts': -714594600,
                'time': '1947-05-11T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          57:
              {
                'ts': -701897400,
                'time': '1947-10-05T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          58:
              {
                'ts': -683145000,
                'time': '1948-05-09T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          59:
              {
                'ts': -670447800,
                'time': '1948-10-03T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          60:
              {
                'ts': -651695400,
                'time': '1949-05-08T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          61:
              {
                'ts': -638998200,
                'time': '1949-10-02T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          62:
              {
                'ts': -619641000,
                'time': '1950-05-14T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          63:
              {
                'ts': -606943800,
                'time': '1950-10-08T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          64:
              {
                'ts': -589401000,
                'time': '1951-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          65:
              {
                'ts': -576099000,
                'time': '1951-09-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          66:
              {
                'ts': -557951400,
                'time': '1952-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          67:
              {
                'ts': -544649400,
                'time': '1952-09-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          68:
              {
                'ts': -526501800,
                'time': '1953-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          69:
              {
                'ts': -513199800,
                'time': '1953-09-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          70:
              {
                'ts': -495052200,
                'time': '1954-04-25T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          71:
              {
                'ts': -481750200,
                'time': '1954-09-26T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          72:
              {
                'ts': -463602600,
                'time': '1955-04-24T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          73:
              {
                'ts': -450300600,
                'time': '1955-09-25T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          74:
              {
                'ts': -431548200,
                'time': '1956-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          75:
              {
                'ts': -418246200,
                'time': '1956-09-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          76:
              {
                'ts': -400098600,
                'time': '1957-04-28T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          77:
              {
                'ts': -386796600,
                'time': '1957-09-29T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          78:
              {
                'ts': -368649000,
                'time': '1958-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          79:
              {
                'ts': -355347000,
                'time': '1958-09-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          80:
              {
                'ts': -337199400,
                'time': '1959-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          81:
              {
                'ts': -323897400,
                'time': '1959-09-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          82:
              {
                'ts': -305749800,
                'time': '1960-04-24T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          83:
              {
                'ts': -289423800,
                'time': '1960-10-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          84:
              {
                'ts': -273695400,
                'time': '1961-04-30T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          85:
              {
                'ts': -257974200,
                'time': '1961-10-29T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          86:
              {
                'ts': -242245800,
                'time': '1962-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          87:
              {
                'ts': -226524600,
                'time': '1962-10-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          88:
              {
                'ts': -210796200,
                'time': '1963-04-28T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          89:
              {
                'ts': -195075000,
                'time': '1963-10-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          90:
              {
                'ts': -179346600,
                'time': '1964-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          91:
              {
                'ts': -163625400,
                'time': '1964-10-25T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          92:
              {
                'ts': -147897000,
                'time': '1965-04-25T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          93:
              {
                'ts': -131571000,
                'time': '1965-10-31T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          94:
              {
                'ts': -116447400,
                'time': '1966-04-24T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          95:
              {
                'ts': -100121400,
                'time': '1966-10-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          96:
              {
                'ts': -84393000,
                'time': '1967-04-30T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          97:
              {
                'ts': -68671800,
                'time': '1967-10-29T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          98:
              {
                'ts': -52943400,
                'time': '1968-04-28T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          99:
              {
                'ts': -37222200,
                'time': '1968-10-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          100:
              {
                'ts': -21493800,
                'time': '1969-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          101:
              {
                'ts': -5772600,
                'time': '1969-10-26T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          102:
              {
                'ts': 9955800,
                'time': '1970-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          103:
              {
                'ts': 25677000,
                'time': '1970-10-25T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          104:
              {
                'ts': 41405400,
                'time': '1971-04-25T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          105:
              {
                'ts': 57731400,
                'time': '1971-10-31T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          106:
              {
                'ts': 73459800,
                'time': '1972-04-30T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          107:
              {
                'ts': 89181000,
                'time': '1972-10-29T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          108:
              {
                'ts': 104909400,
                'time': '1973-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          109:
              {
                'ts': 120630600,
                'time': '1973-10-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          110:
              {
                'ts': 136359000,
                'time': '1974-04-28T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          111:
              {
                'ts': 152080200,
                'time': '1974-10-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          112:
              {
                'ts': 167808600,
                'time': '1975-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          113:
              {
                'ts': 183529800,
                'time': '1975-10-26T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          114:
              {
                'ts': 199258200,
                'time': '1976-04-25T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          115:
              {
                'ts': 215584200,
                'time': '1976-10-31T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          116:
              {
                'ts': 230707800,
                'time': '1977-04-24T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          117:
              {
                'ts': 247033800,
                'time': '1977-10-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          118:
              {
                'ts': 262762200,
                'time': '1978-04-30T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          119:
              {
                'ts': 278483400,
                'time': '1978-10-29T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          120:
              {
                'ts': 294211800,
                'time': '1979-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          121:
              {
                'ts': 309933000,
                'time': '1979-10-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          122:
              {
                'ts': 325661400,
                'time': '1980-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          123:
              {
                'ts': 341382600,
                'time': '1980-10-26T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          124:
              {
                'ts': 357111000,
                'time': '1981-04-26T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          125:
              {
                'ts': 372832200,
                'time': '1981-10-25T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          126:
              {
                'ts': 388560600,
                'time': '1982-04-25T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          127:
              {
                'ts': 404886600,
                'time': '1982-10-31T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          128:
              {
                'ts': 420010200,
                'time': '1983-04-24T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          129:
              {
                'ts': 436336200,
                'time': '1983-10-30T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          130:
              {
                'ts': 452064600,
                'time': '1984-04-29T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          131:
              {
                'ts': 467785800,
                'time': '1984-10-28T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          132:
              {
                'ts': 483514200,
                'time': '1985-04-28T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          133:
              {
                'ts': 499235400,
                'time': '1985-10-27T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          134:
              {
                'ts': 514963800,
                'time': '1986-04-27T05:30:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          135:
              {
                'ts': 530685000,
                'time': '1986-10-26T04:30:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          136:
              {
                'ts': 544591860,
                'time': '1987-04-05T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          137:
              {
                'ts': 562127460,
                'time': '1987-10-25T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          138:
              {
                'ts': 576041460,
                'time': '1988-04-03T03:31:00+0000',
                'offset': -5400,
                'isdst': true,
                'abbr': 'NDDT'
              },
          139:
              {
                'ts': 594178260,
                'time': '1988-10-30T01:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          140:
              {
                'ts': 607491060,
                'time': '1989-04-02T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          141:
              {
                'ts': 625631460,
                'time': '1989-10-29T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          142:
              {
                'ts': 638940660,
                'time': '1990-04-01T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          143:
              {
                'ts': 657081060,
                'time': '1990-10-28T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          144:
              {
                'ts': 670995060,
                'time': '1991-04-07T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          145:
              {
                'ts': 688530660,
                'time': '1991-10-27T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          146:
              {
                'ts': 702444660,
                'time': '1992-04-05T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          147:
              {
                'ts': 719980260,
                'time': '1992-10-25T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          148:
              {
                'ts': 733894260,
                'time': '1993-04-04T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          149:
              {
                'ts': 752034660,
                'time': '1993-10-31T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          150:
              {
                'ts': 765343860,
                'time': '1994-04-03T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          151:
              {
                'ts': 783484260,
                'time': '1994-10-30T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          152:
              {
                'ts': 796793460,
                'time': '1995-04-02T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          153:
              {
                'ts': 814933860,
                'time': '1995-10-29T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          154:
              {
                'ts': 828847860,
                'time': '1996-04-07T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          155:
              {
                'ts': 846383460,
                'time': '1996-10-27T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          156:
              {
                'ts': 860297460,
                'time': '1997-04-06T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          157:
              {
                'ts': 877833060,
                'time': '1997-10-26T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          158:
              {
                'ts': 891747060,
                'time': '1998-04-05T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          159:
              {
                'ts': 909282660,
                'time': '1998-10-25T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          160:
              {
                'ts': 923196660,
                'time': '1999-04-04T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          161:
              {
                'ts': 941337060,
                'time': '1999-10-31T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          162:
              {
                'ts': 954646260,
                'time': '2000-04-02T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          163:
              {
                'ts': 972786660,
                'time': '2000-10-29T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          164:
              {
                'ts': 986095860,
                'time': '2001-04-01T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          165:
              {
                'ts': 1004236260,
                'time': '2001-10-28T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          166:
              {
                'ts': 1018150260,
                'time': '2002-04-07T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          167:
              {
                'ts': 1035685860,
                'time': '2002-10-27T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          168:
              {
                'ts': 1049599860,
                'time': '2003-04-06T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          169:
              {
                'ts': 1067135460,
                'time': '2003-10-26T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          170:
              {
                'ts': 1081049460,
                'time': '2004-04-04T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          171:
              {
                'ts': 1099189860,
                'time': '2004-10-31T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          172:
              {
                'ts': 1112499060,
                'time': '2005-04-03T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          173:
              {
                'ts': 1130639460,
                'time': '2005-10-30T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          174:
              {
                'ts': 1143948660,
                'time': '2006-04-02T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          175:
              {
                'ts': 1162089060,
                'time': '2006-10-29T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          176:
              {
                'ts': 1173583860,
                'time': '2007-03-11T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          177:
              {
                'ts': 1194143460,
                'time': '2007-11-04T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          178:
              {
                'ts': 1205033460,
                'time': '2008-03-09T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          179:
              {
                'ts': 1225593060,
                'time': '2008-11-02T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          180:
              {
                'ts': 1236483060,
                'time': '2009-03-08T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          181:
              {
                'ts': 1257042660,
                'time': '2009-11-01T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          182:
              {
                'ts': 1268537460,
                'time': '2010-03-14T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          183:
              {
                'ts': 1289097060,
                'time': '2010-11-07T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          184:
              {
                'ts': 1299987060,
                'time': '2011-03-13T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          185:
              {
                'ts': 1320546660,
                'time': '2011-11-06T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          186:
              {
                'ts': 1331436660,
                'time': '2012-03-11T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          187:
              {
                'ts': 1351996260,
                'time': '2012-11-04T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          188:
              {
                'ts': 1362886260,
                'time': '2013-03-10T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          189:
              {
                'ts': 1383445860,
                'time': '2013-11-03T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          190:
              {
                'ts': 1394335860,
                'time': '2014-03-09T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          191:
              {
                'ts': 1414895460,
                'time': '2014-11-02T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          192:
              {
                'ts': 1425785460,
                'time': '2015-03-08T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          193:
              {
                'ts': 1446345060,
                'time': '2015-11-01T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          194:
              {
                'ts': 1457839860,
                'time': '2016-03-13T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          195:
              {
                'ts': 1478399460,
                'time': '2016-11-06T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          196:
              {
                'ts': 1489289460,
                'time': '2017-03-12T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          197:
              {
                'ts': 1509849060,
                'time': '2017-11-05T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          198:
              {
                'ts': 1520739060,
                'time': '2018-03-11T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          199:
              {
                'ts': 1541298660,
                'time': '2018-11-04T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          200:
              {
                'ts': 1552188660,
                'time': '2019-03-10T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          201:
              {
                'ts': 1572748260,
                'time': '2019-11-03T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          202:
              {
                'ts': 1583638260,
                'time': '2020-03-08T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          203:
              {
                'ts': 1604197860,
                'time': '2020-11-01T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          204:
              {
                'ts': 1615692660,
                'time': '2021-03-14T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          205:
              {
                'ts': 1636252260,
                'time': '2021-11-07T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          206:
              {
                'ts': 1647142260,
                'time': '2022-03-13T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          207:
              {
                'ts': 1667701860,
                'time': '2022-11-06T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          208:
              {
                'ts': 1678591860,
                'time': '2023-03-12T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          209:
              {
                'ts': 1699151460,
                'time': '2023-11-05T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          210:
              {
                'ts': 1710041460,
                'time': '2024-03-10T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          211:
              {
                'ts': 1730601060,
                'time': '2024-11-03T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          212:
              {
                'ts': 1741491060,
                'time': '2025-03-09T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          213:
              {
                'ts': 1762050660,
                'time': '2025-11-02T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          214:
              {
                'ts': 1772940660,
                'time': '2026-03-08T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          215:
              {
                'ts': 1793500260,
                'time': '2026-11-01T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          216:
              {
                'ts': 1804995060,
                'time': '2027-03-14T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          217:
              {
                'ts': 1825554660,
                'time': '2027-11-07T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          218:
              {
                'ts': 1836444660,
                'time': '2028-03-12T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          219:
              {
                'ts': 1857004260,
                'time': '2028-11-05T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          220:
              {
                'ts': 1867894260,
                'time': '2029-03-11T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          221:
              {
                'ts': 1888453860,
                'time': '2029-11-04T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          222:
              {
                'ts': 1899343860,
                'time': '2030-03-10T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          223:
              {
                'ts': 1919903460,
                'time': '2030-11-03T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          224:
              {
                'ts': 1930793460,
                'time': '2031-03-09T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          225:
              {
                'ts': 1951353060,
                'time': '2031-11-02T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          226:
              {
                'ts': 1962847860,
                'time': '2032-03-14T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          227:
              {
                'ts': 1983407460,
                'time': '2032-11-07T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          228:
              {
                'ts': 1994297460,
                'time': '2033-03-13T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          229:
              {
                'ts': 2014857060,
                'time': '2033-11-06T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          230:
              {
                'ts': 2025747060,
                'time': '2034-03-12T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          231:
              {
                'ts': 2046306660,
                'time': '2034-11-05T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          232:
              {
                'ts': 2057196660,
                'time': '2035-03-11T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          233:
              {
                'ts': 2077756260,
                'time': '2035-11-04T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          234:
              {
                'ts': 2088646260,
                'time': '2036-03-09T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          235:
              {
                'ts': 2109205860,
                'time': '2036-11-02T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              },
          236:
              {
                'ts': 2120095860,
                'time': '2037-03-08T03:31:00+0000',
                'offset': -9000,
                'isdst': true,
                'abbr': 'NDT'
              },
          237:
              {
                'ts': 2140655460,
                'time': '2037-11-01T02:31:00+0000',
                'offset': -12600,
                'isdst': false,
                'abbr': 'NST'
              }
        },
    'Canada/Pacific':
        {
          0:
              {
                'ts': -1632060000,
                'time': '1918-04-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          1:
              {
                'ts': -1614783600,
                'time': '1918-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          2:
              {
                'ts': -880207200,
                'time': '1942-02-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PWT'
              },
          3:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PPT'
              },
          4:
              {
                'ts': -765385200,
                'time': '1945-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          5:
              {
                'ts': -747237600,
                'time': '1946-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          6:
              {
                'ts': -732726000,
                'time': '1946-10-13T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          7:
              {
                'ts': -715788000,
                'time': '1947-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          8:
              {
                'ts': -702486000,
                'time': '1947-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          9:
              {
                'ts': -684338400,
                'time': '1948-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          10:
              {
                'ts': -671036400,
                'time': '1948-09-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          11:
              {
                'ts': -652888800,
                'time': '1949-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          12:
              {
                'ts': -639586800,
                'time': '1949-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          13:
              {
                'ts': -620834400,
                'time': '1950-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          14:
              {
                'ts': -608137200,
                'time': '1950-09-24T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          15:
              {
                'ts': -589384800,
                'time': '1951-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          16:
              {
                'ts': -576082800,
                'time': '1951-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          17:
              {
                'ts': -557935200,
                'time': '1952-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          18:
              {
                'ts': -544633200,
                'time': '1952-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          19:
              {
                'ts': -526485600,
                'time': '1953-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          20:
              {
                'ts': -513183600,
                'time': '1953-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          21:
              {
                'ts': -495036000,
                'time': '1954-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          22:
              {
                'ts': -481734000,
                'time': '1954-09-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          23:
              {
                'ts': -463586400,
                'time': '1955-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          24:
              {
                'ts': -450284400,
                'time': '1955-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          25:
              {
                'ts': -431532000,
                'time': '1956-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          26:
              {
                'ts': -418230000,
                'time': '1956-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          27:
              {
                'ts': -400082400,
                'time': '1957-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          28:
              {
                'ts': -386780400,
                'time': '1957-09-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          29:
              {
                'ts': -368632800,
                'time': '1958-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          30:
              {
                'ts': -355330800,
                'time': '1958-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          31:
              {
                'ts': -337183200,
                'time': '1959-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          32:
              {
                'ts': -323881200,
                'time': '1959-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          33:
              {
                'ts': -305733600,
                'time': '1960-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          34:
              {
                'ts': -292431600,
                'time': '1960-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          35:
              {
                'ts': -273679200,
                'time': '1961-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          36:
              {
                'ts': -260982000,
                'time': '1961-09-24T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          37:
              {
                'ts': -242229600,
                'time': '1962-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          38:
              {
                'ts': -226508400,
                'time': '1962-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          39:
              {
                'ts': -210780000,
                'time': '1963-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          40:
              {
                'ts': -195058800,
                'time': '1963-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          41:
              {
                'ts': -179330400,
                'time': '1964-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          42:
              {
                'ts': -163609200,
                'time': '1964-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          43:
              {
                'ts': -147880800,
                'time': '1965-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          44:
              {
                'ts': -131554800,
                'time': '1965-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          45:
              {
                'ts': -116431200,
                'time': '1966-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          46:
              {
                'ts': -100105200,
                'time': '1966-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          47:
              {
                'ts': -84376800,
                'time': '1967-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          48:
              {
                'ts': -68655600,
                'time': '1967-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          49:
              {
                'ts': -52927200,
                'time': '1968-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          50:
              {
                'ts': -37206000,
                'time': '1968-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          51:
              {
                'ts': -21477600,
                'time': '1969-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          52:
              {
                'ts': -5756400,
                'time': '1969-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          53:
              {
                'ts': 9972000,
                'time': '1970-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          54:
              {
                'ts': 25693200,
                'time': '1970-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          55:
              {
                'ts': 41421600,
                'time': '1971-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          56:
              {
                'ts': 57747600,
                'time': '1971-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          57:
              {
                'ts': 73476000,
                'time': '1972-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          58:
              {
                'ts': 89197200,
                'time': '1972-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          59:
              {
                'ts': 104925600,
                'time': '1973-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          60:
              {
                'ts': 120646800,
                'time': '1973-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          61:
              {
                'ts': 136375200,
                'time': '1974-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          62:
              {
                'ts': 152096400,
                'time': '1974-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          63:
              {
                'ts': 167824800,
                'time': '1975-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          64:
              {
                'ts': 183546000,
                'time': '1975-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          65:
              {
                'ts': 199274400,
                'time': '1976-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          66:
              {
                'ts': 215600400,
                'time': '1976-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          67:
              {
                'ts': 230724000,
                'time': '1977-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          68:
              {
                'ts': 247050000,
                'time': '1977-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          69:
              {
                'ts': 262778400,
                'time': '1978-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          70:
              {
                'ts': 278499600,
                'time': '1978-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          71:
              {
                'ts': 294228000,
                'time': '1979-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          72:
              {
                'ts': 309949200,
                'time': '1979-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          73:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          74:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          75:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          76:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          77:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          78:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          79:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          80:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          81:
              {
                'ts': 452080800,
                'time': '1984-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          82:
              {
                'ts': 467802000,
                'time': '1984-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          83:
              {
                'ts': 483530400,
                'time': '1985-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          84:
              {
                'ts': 499251600,
                'time': '1985-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          85:
              {
                'ts': 514980000,
                'time': '1986-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          86:
              {
                'ts': 530701200,
                'time': '1986-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          87:
              {
                'ts': 544615200,
                'time': '1987-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          88:
              {
                'ts': 562150800,
                'time': '1987-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          89:
              {
                'ts': 576064800,
                'time': '1988-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          90:
              {
                'ts': 594205200,
                'time': '1988-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          91:
              {
                'ts': 607514400,
                'time': '1989-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          92:
              {
                'ts': 625654800,
                'time': '1989-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          93:
              {
                'ts': 638964000,
                'time': '1990-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          94:
              {
                'ts': 657104400,
                'time': '1990-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          95:
              {
                'ts': 671018400,
                'time': '1991-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          96:
              {
                'ts': 688554000,
                'time': '1991-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          97:
              {
                'ts': 702468000,
                'time': '1992-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          98:
              {
                'ts': 720003600,
                'time': '1992-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          99:
              {
                'ts': 733917600,
                'time': '1993-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          100:
              {
                'ts': 752058000,
                'time': '1993-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          101:
              {
                'ts': 765367200,
                'time': '1994-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          102:
              {
                'ts': 783507600,
                'time': '1994-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          103:
              {
                'ts': 796816800,
                'time': '1995-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          104:
              {
                'ts': 814957200,
                'time': '1995-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          105:
              {
                'ts': 828871200,
                'time': '1996-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          106:
              {
                'ts': 846406800,
                'time': '1996-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          107:
              {
                'ts': 860320800,
                'time': '1997-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          108:
              {
                'ts': 877856400,
                'time': '1997-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          109:
              {
                'ts': 891770400,
                'time': '1998-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          110:
              {
                'ts': 909306000,
                'time': '1998-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          111:
              {
                'ts': 923220000,
                'time': '1999-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          112:
              {
                'ts': 941360400,
                'time': '1999-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          113:
              {
                'ts': 954669600,
                'time': '2000-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          114:
              {
                'ts': 972810000,
                'time': '2000-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          115:
              {
                'ts': 986119200,
                'time': '2001-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          116:
              {
                'ts': 1004259600,
                'time': '2001-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          117:
              {
                'ts': 1018173600,
                'time': '2002-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          118:
              {
                'ts': 1035709200,
                'time': '2002-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          119:
              {
                'ts': 1049623200,
                'time': '2003-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          120:
              {
                'ts': 1067158800,
                'time': '2003-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          121:
              {
                'ts': 1081072800,
                'time': '2004-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          122:
              {
                'ts': 1099213200,
                'time': '2004-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          123:
              {
                'ts': 1112522400,
                'time': '2005-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          124:
              {
                'ts': 1130662800,
                'time': '2005-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          125:
              {
                'ts': 1143972000,
                'time': '2006-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          126:
              {
                'ts': 1162112400,
                'time': '2006-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          127:
              {
                'ts': 1173607200,
                'time': '2007-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          128:
              {
                'ts': 1194166800,
                'time': '2007-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          129:
              {
                'ts': 1205056800,
                'time': '2008-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          130:
              {
                'ts': 1225616400,
                'time': '2008-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          131:
              {
                'ts': 1236506400,
                'time': '2009-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          132:
              {
                'ts': 1257066000,
                'time': '2009-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          133:
              {
                'ts': 1268560800,
                'time': '2010-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          134:
              {
                'ts': 1289120400,
                'time': '2010-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          135:
              {
                'ts': 1300010400,
                'time': '2011-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          136:
              {
                'ts': 1320570000,
                'time': '2011-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          137:
              {
                'ts': 1331460000,
                'time': '2012-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          138:
              {
                'ts': 1352019600,
                'time': '2012-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          139:
              {
                'ts': 1362909600,
                'time': '2013-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          140:
              {
                'ts': 1383469200,
                'time': '2013-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          141:
              {
                'ts': 1394359200,
                'time': '2014-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          142:
              {
                'ts': 1414918800,
                'time': '2014-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          143:
              {
                'ts': 1425808800,
                'time': '2015-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          144:
              {
                'ts': 1446368400,
                'time': '2015-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          145:
              {
                'ts': 1457863200,
                'time': '2016-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          146:
              {
                'ts': 1478422800,
                'time': '2016-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          147:
              {
                'ts': 1489312800,
                'time': '2017-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          148:
              {
                'ts': 1509872400,
                'time': '2017-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          149:
              {
                'ts': 1520762400,
                'time': '2018-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          150:
              {
                'ts': 1541322000,
                'time': '2018-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          151:
              {
                'ts': 1552212000,
                'time': '2019-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          152:
              {
                'ts': 1572771600,
                'time': '2019-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          153:
              {
                'ts': 1583661600,
                'time': '2020-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          154:
              {
                'ts': 1604221200,
                'time': '2020-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          155:
              {
                'ts': 1615716000,
                'time': '2021-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          156:
              {
                'ts': 1636275600,
                'time': '2021-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          157:
              {
                'ts': 1647165600,
                'time': '2022-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          158:
              {
                'ts': 1667725200,
                'time': '2022-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          159:
              {
                'ts': 1678615200,
                'time': '2023-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          160:
              {
                'ts': 1699174800,
                'time': '2023-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          161:
              {
                'ts': 1710064800,
                'time': '2024-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          162:
              {
                'ts': 1730624400,
                'time': '2024-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          163:
              {
                'ts': 1741514400,
                'time': '2025-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          164:
              {
                'ts': 1762074000,
                'time': '2025-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          165:
              {
                'ts': 1772964000,
                'time': '2026-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          166:
              {
                'ts': 1793523600,
                'time': '2026-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          167:
              {
                'ts': 1805018400,
                'time': '2027-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          168:
              {
                'ts': 1825578000,
                'time': '2027-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          169:
              {
                'ts': 1836468000,
                'time': '2028-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          170:
              {
                'ts': 1857027600,
                'time': '2028-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          171:
              {
                'ts': 1867917600,
                'time': '2029-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          172:
              {
                'ts': 1888477200,
                'time': '2029-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          173:
              {
                'ts': 1899367200,
                'time': '2030-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          174:
              {
                'ts': 1919926800,
                'time': '2030-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          175:
              {
                'ts': 1930816800,
                'time': '2031-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          176:
              {
                'ts': 1951376400,
                'time': '2031-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          177:
              {
                'ts': 1962871200,
                'time': '2032-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          178:
              {
                'ts': 1983430800,
                'time': '2032-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          179:
              {
                'ts': 1994320800,
                'time': '2033-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          180:
              {
                'ts': 2014880400,
                'time': '2033-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          181:
              {
                'ts': 2025770400,
                'time': '2034-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          182:
              {
                'ts': 2046330000,
                'time': '2034-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          183:
              {
                'ts': 2057220000,
                'time': '2035-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          184:
              {
                'ts': 2077779600,
                'time': '2035-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          185:
              {
                'ts': 2088669600,
                'time': '2036-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          186:
              {
                'ts': 2109229200,
                'time': '2036-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          187:
              {
                'ts': 2120119200,
                'time': '2037-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          188:
              {
                'ts': 2140678800,
                'time': '2037-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'Canada/Saskatchewan':
        {
          0:
              {
                'ts': -2030202084,
                'time': '1905-09-01T06:58:36+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1632063600,
                'time': '1918-04-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          2:
              {
                'ts': -1614787200,
                'time': '1918-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1251651600,
                'time': '1930-05-04T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          4:
              {
                'ts': -1238349600,
                'time': '1930-10-05T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1220202000,
                'time': '1931-05-03T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          6:
              {
                'ts': -1206900000,
                'time': '1931-10-04T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          7:
              {
                'ts': -1188752400,
                'time': '1932-05-01T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          8:
              {
                'ts': -1175450400,
                'time': '1932-10-02T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          9:
              {
                'ts': -1156698000,
                'time': '1933-05-07T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          10:
              {
                'ts': -1144000800,
                'time': '1933-10-01T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -1125248400,
                'time': '1934-05-06T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -1111946400,
                'time': '1934-10-07T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': -1032714000,
                'time': '1937-04-11T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': -1016992800,
                'time': '1937-10-10T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': -1001264400,
                'time': '1938-04-10T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': -986148000,
                'time': '1938-10-02T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': -969814800,
                'time': '1939-04-09T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': -954093600,
                'time': '1939-10-08T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': -937760400,
                'time': '1940-04-14T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': -922039200,
                'time': '1940-10-13T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': -906310800,
                'time': '1941-04-13T07:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': -890589600,
                'time': '1941-10-12T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          24:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          25:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          26:
              {
                'ts': -748450800,
                'time': '1946-04-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          27:
              {
                'ts': -732729600,
                'time': '1946-10-13T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          28:
              {
                'ts': -715791600,
                'time': '1947-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          29:
              {
                'ts': -702489600,
                'time': '1947-09-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          30:
              {
                'ts': -684342000,
                'time': '1948-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          31:
              {
                'ts': -671040000,
                'time': '1948-09-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          32:
              {
                'ts': -652892400,
                'time': '1949-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          33:
              {
                'ts': -639590400,
                'time': '1949-09-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          34:
              {
                'ts': -620838000,
                'time': '1950-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          35:
              {
                'ts': -608140800,
                'time': '1950-09-24T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          36:
              {
                'ts': -589388400,
                'time': '1951-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          37:
              {
                'ts': -576086400,
                'time': '1951-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          38:
              {
                'ts': -557938800,
                'time': '1952-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          39:
              {
                'ts': -544636800,
                'time': '1952-09-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          40:
              {
                'ts': -526489200,
                'time': '1953-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          41:
              {
                'ts': -513187200,
                'time': '1953-09-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          42:
              {
                'ts': -495039600,
                'time': '1954-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          43:
              {
                'ts': -481737600,
                'time': '1954-09-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          44:
              {
                'ts': -463590000,
                'time': '1955-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          45:
              {
                'ts': -450288000,
                'time': '1955-09-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          46:
              {
                'ts': -431535600,
                'time': '1956-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          47:
              {
                'ts': -418233600,
                'time': '1956-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          48:
              {
                'ts': -400086000,
                'time': '1957-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          49:
              {
                'ts': -386784000,
                'time': '1957-09-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          50:
              {
                'ts': -337186800,
                'time': '1959-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          51:
              {
                'ts': -321465600,
                'time': '1959-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          52:
              {
                'ts': -305737200,
                'time': '1960-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Canada/Yukon':
        {
          0:
              {
                'ts': -1632056400,
                'time': '1918-04-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          1:
              {
                'ts': -1615125600,
                'time': '1918-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          2:
              {
                'ts': -1596978000,
                'time': '1919-05-25T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YDT'
              },
          3:
              {
                'ts': -1583164800,
                'time': '1919-11-01T08:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          4:
              {
                'ts': -880203600,
                'time': '1942-02-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'YPT'
              },
          6:
              {
                'ts': -765381600,
                'time': '1945-09-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          7:
              {
                'ts': -147884400,
                'time': '1965-04-25T09:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'YDDT'
              },
          8:
              {
                'ts': -131554800,
                'time': '1965-10-31T09:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          9:
              {
                'ts': -110552400,
                'time': '1966-07-01T11:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          10:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          11:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          12:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          13:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          14:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          15:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          16:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          17:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          18:
              {
                'ts': 452080800,
                'time': '1984-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          19:
              {
                'ts': 467802000,
                'time': '1984-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          20:
              {
                'ts': 483530400,
                'time': '1985-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          21:
              {
                'ts': 499251600,
                'time': '1985-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          22:
              {
                'ts': 514980000,
                'time': '1986-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          23:
              {
                'ts': 530701200,
                'time': '1986-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          24:
              {
                'ts': 544615200,
                'time': '1987-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          25:
              {
                'ts': 562150800,
                'time': '1987-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          26:
              {
                'ts': 576064800,
                'time': '1988-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          27:
              {
                'ts': 594205200,
                'time': '1988-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          28:
              {
                'ts': 607514400,
                'time': '1989-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          29:
              {
                'ts': 625654800,
                'time': '1989-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          30:
              {
                'ts': 638964000,
                'time': '1990-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          31:
              {
                'ts': 657104400,
                'time': '1990-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          32:
              {
                'ts': 671018400,
                'time': '1991-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          33:
              {
                'ts': 688554000,
                'time': '1991-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          34:
              {
                'ts': 702468000,
                'time': '1992-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          35:
              {
                'ts': 720003600,
                'time': '1992-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          36:
              {
                'ts': 733917600,
                'time': '1993-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          37:
              {
                'ts': 752058000,
                'time': '1993-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          38:
              {
                'ts': 765367200,
                'time': '1994-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          39:
              {
                'ts': 783507600,
                'time': '1994-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          40:
              {
                'ts': 796816800,
                'time': '1995-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          41:
              {
                'ts': 814957200,
                'time': '1995-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          42:
              {
                'ts': 828871200,
                'time': '1996-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          43:
              {
                'ts': 846406800,
                'time': '1996-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          44:
              {
                'ts': 860320800,
                'time': '1997-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          45:
              {
                'ts': 877856400,
                'time': '1997-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          46:
              {
                'ts': 891770400,
                'time': '1998-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          47:
              {
                'ts': 909306000,
                'time': '1998-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          48:
              {
                'ts': 923220000,
                'time': '1999-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          49:
              {
                'ts': 941360400,
                'time': '1999-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          50:
              {
                'ts': 954669600,
                'time': '2000-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          51:
              {
                'ts': 972810000,
                'time': '2000-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          52:
              {
                'ts': 986119200,
                'time': '2001-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          53:
              {
                'ts': 1004259600,
                'time': '2001-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          54:
              {
                'ts': 1018173600,
                'time': '2002-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          55:
              {
                'ts': 1035709200,
                'time': '2002-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          56:
              {
                'ts': 1049623200,
                'time': '2003-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          57:
              {
                'ts': 1067158800,
                'time': '2003-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          58:
              {
                'ts': 1081072800,
                'time': '2004-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          59:
              {
                'ts': 1099213200,
                'time': '2004-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          60:
              {
                'ts': 1112522400,
                'time': '2005-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          61:
              {
                'ts': 1130662800,
                'time': '2005-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          62:
              {
                'ts': 1143972000,
                'time': '2006-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          63:
              {
                'ts': 1162112400,
                'time': '2006-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          64:
              {
                'ts': 1173607200,
                'time': '2007-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          65:
              {
                'ts': 1194166800,
                'time': '2007-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          66:
              {
                'ts': 1205056800,
                'time': '2008-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          67:
              {
                'ts': 1225616400,
                'time': '2008-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          68:
              {
                'ts': 1236506400,
                'time': '2009-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          69:
              {
                'ts': 1257066000,
                'time': '2009-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          70:
              {
                'ts': 1268560800,
                'time': '2010-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          71:
              {
                'ts': 1289120400,
                'time': '2010-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          72:
              {
                'ts': 1300010400,
                'time': '2011-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          73:
              {
                'ts': 1320570000,
                'time': '2011-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          74:
              {
                'ts': 1331460000,
                'time': '2012-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          75:
              {
                'ts': 1352019600,
                'time': '2012-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          76:
              {
                'ts': 1362909600,
                'time': '2013-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          77:
              {
                'ts': 1383469200,
                'time': '2013-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          78:
              {
                'ts': 1394359200,
                'time': '2014-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          79:
              {
                'ts': 1414918800,
                'time': '2014-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          80:
              {
                'ts': 1425808800,
                'time': '2015-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          81:
              {
                'ts': 1446368400,
                'time': '2015-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          82:
              {
                'ts': 1457863200,
                'time': '2016-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          83:
              {
                'ts': 1478422800,
                'time': '2016-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          84:
              {
                'ts': 1489312800,
                'time': '2017-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          85:
              {
                'ts': 1509872400,
                'time': '2017-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          86:
              {
                'ts': 1520762400,
                'time': '2018-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          87:
              {
                'ts': 1541322000,
                'time': '2018-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          88:
              {
                'ts': 1552212000,
                'time': '2019-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          89:
              {
                'ts': 1572771600,
                'time': '2019-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          90:
              {
                'ts': 1583661600,
                'time': '2020-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          91:
              {
                'ts': 1604221200,
                'time': '2020-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          92:
              {
                'ts': 1615716000,
                'time': '2021-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          93:
              {
                'ts': 1636275600,
                'time': '2021-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          94:
              {
                'ts': 1647165600,
                'time': '2022-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          95:
              {
                'ts': 1667725200,
                'time': '2022-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          96:
              {
                'ts': 1678615200,
                'time': '2023-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          97:
              {
                'ts': 1699174800,
                'time': '2023-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          98:
              {
                'ts': 1710064800,
                'time': '2024-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          99:
              {
                'ts': 1730624400,
                'time': '2024-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          100:
              {
                'ts': 1741514400,
                'time': '2025-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          101:
              {
                'ts': 1762074000,
                'time': '2025-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          102:
              {
                'ts': 1772964000,
                'time': '2026-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          103:
              {
                'ts': 1793523600,
                'time': '2026-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          104:
              {
                'ts': 1805018400,
                'time': '2027-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          105:
              {
                'ts': 1825578000,
                'time': '2027-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          106:
              {
                'ts': 1836468000,
                'time': '2028-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          107:
              {
                'ts': 1857027600,
                'time': '2028-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          108:
              {
                'ts': 1867917600,
                'time': '2029-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          109:
              {
                'ts': 1888477200,
                'time': '2029-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          110:
              {
                'ts': 1899367200,
                'time': '2030-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          111:
              {
                'ts': 1919926800,
                'time': '2030-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          112:
              {
                'ts': 1930816800,
                'time': '2031-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          113:
              {
                'ts': 1951376400,
                'time': '2031-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          114:
              {
                'ts': 1962871200,
                'time': '2032-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          115:
              {
                'ts': 1983430800,
                'time': '2032-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          116:
              {
                'ts': 1994320800,
                'time': '2033-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          117:
              {
                'ts': 2014880400,
                'time': '2033-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          118:
              {
                'ts': 2025770400,
                'time': '2034-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          119:
              {
                'ts': 2046330000,
                'time': '2034-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          120:
              {
                'ts': 2057220000,
                'time': '2035-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          121:
              {
                'ts': 2077779600,
                'time': '2035-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          122:
              {
                'ts': 2088669600,
                'time': '2036-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          123:
              {
                'ts': 2109229200,
                'time': '2036-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          124:
              {
                'ts': 2120119200,
                'time': '2037-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          125:
              {
                'ts': 2140678800,
                'time': '2037-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'CET':
        {
          0:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -1663455600,
                'time': '1917-04-16T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -1650150000,
                'time': '1917-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -1632006000,
                'time': '1918-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -1618700400,
                'time': '1918-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -938905200,
                'time': '1940-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -776563200,
                'time': '1945-05-24T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CEMT'
              },
          14:
              {
                'ts': -765936000,
                'time': '1945-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -761180400,
                'time': '1945-11-18T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': -748479600,
                'time': '1946-04-14T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          17:
              {
                'ts': -733273200,
                'time': '1946-10-07T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': -717634800,
                'time': '1947-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': -714610800,
                'time': '1947-05-11T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CEMT'
              },
          20:
              {
                'ts': -710380800,
                'time': '1947-06-29T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          21:
              {
                'ts': -701910000,
                'time': '1947-10-05T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': -684975600,
                'time': '1948-04-18T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          23:
              {
                'ts': -670460400,
                'time': '1948-10-03T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          24:
              {
                'ts': -654130800,
                'time': '1949-04-10T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          25:
              {
                'ts': -639010800,
                'time': '1949-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          26:
              {
                'ts': 315529200,
                'time': '1979-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          141:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          142:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Chile/Continental':
        {
          0:
              {
                'ts': -1893439034,
                'time': '1910-01-01T04:42:46+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          1:
              {
                'ts': -1688410800,
                'time': '1916-07-01T05:00:00+0000',
                'offset': -16966,
                'isdst': false,
                'abbr': 'SMT'
              },
          2:
              {
                'ts': -1619983034,
                'time': '1918-09-01T04:42:46+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          3:
              {
                'ts': -1593806400,
                'time': '1919-07-01T04:00:00+0000',
                'offset': -16966,
                'isdst': false,
                'abbr': 'SMT'
              },
          4:
              {
                'ts': -1335986234,
                'time': '1927-09-01T04:42:46+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          5:
              {
                'ts': -1317585600,
                'time': '1928-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          6:
              {
                'ts': -1304362800,
                'time': '1928-09-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          7:
              {
                'ts': -1286049600,
                'time': '1929-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          8:
              {
                'ts': -1272826800,
                'time': '1929-09-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          9:
              {
                'ts': -1254513600,
                'time': '1930-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          10:
              {
                'ts': -1241290800,
                'time': '1930-09-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          11:
              {
                'ts': -1222977600,
                'time': '1931-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          12:
              {
                'ts': -1209754800,
                'time': '1931-09-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          13:
              {
                'ts': -1191355200,
                'time': '1932-04-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          14:
              {
                'ts': -1178132400,
                'time': '1932-09-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          15:
              {
                'ts': -870552000,
                'time': '1942-06-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          16:
              {
                'ts': -865278000,
                'time': '1942-08-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CLST'
              },
          17:
              {
                'ts': -736376400,
                'time': '1946-09-01T03:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CLT'
              },
          18:
              {
                'ts': -713646000,
                'time': '1947-05-22T05:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          19:
              {
                'ts': -36619200,
                'time': '1968-11-03T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          20:
              {
                'ts': -23922000,
                'time': '1969-03-30T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          21:
              {
                'ts': -3355200,
                'time': '1969-11-23T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          22:
              {
                'ts': 7527600,
                'time': '1970-03-29T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          23:
              {
                'ts': 24465600,
                'time': '1970-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          24:
              {
                'ts': 37767600,
                'time': '1971-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          25:
              {
                'ts': 55915200,
                'time': '1971-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          26:
              {
                'ts': 69217200,
                'time': '1972-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          27:
              {
                'ts': 87969600,
                'time': '1972-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          28:
              {
                'ts': 100666800,
                'time': '1973-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          29:
              {
                'ts': 118209600,
                'time': '1973-09-30T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          30:
              {
                'ts': 132116400,
                'time': '1974-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          31:
              {
                'ts': 150868800,
                'time': '1974-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          32:
              {
                'ts': 163566000,
                'time': '1975-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          33:
              {
                'ts': 182318400,
                'time': '1975-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          34:
              {
                'ts': 195620400,
                'time': '1976-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          35:
              {
                'ts': 213768000,
                'time': '1976-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          36:
              {
                'ts': 227070000,
                'time': '1977-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          37:
              {
                'ts': 245217600,
                'time': '1977-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          38:
              {
                'ts': 258519600,
                'time': '1978-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          39:
              {
                'ts': 277272000,
                'time': '1978-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          40:
              {
                'ts': 289969200,
                'time': '1979-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          41:
              {
                'ts': 308721600,
                'time': '1979-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          42:
              {
                'ts': 321418800,
                'time': '1980-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          43:
              {
                'ts': 340171200,
                'time': '1980-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          44:
              {
                'ts': 353473200,
                'time': '1981-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          45:
              {
                'ts': 371620800,
                'time': '1981-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          46:
              {
                'ts': 384922800,
                'time': '1982-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          47:
              {
                'ts': 403070400,
                'time': '1982-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          48:
              {
                'ts': 416372400,
                'time': '1983-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          49:
              {
                'ts': 434520000,
                'time': '1983-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          50:
              {
                'ts': 447822000,
                'time': '1984-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          51:
              {
                'ts': 466574400,
                'time': '1984-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          52:
              {
                'ts': 479271600,
                'time': '1985-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          53:
              {
                'ts': 498024000,
                'time': '1985-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          54:
              {
                'ts': 510721200,
                'time': '1986-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          55:
              {
                'ts': 529473600,
                'time': '1986-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          56:
              {
                'ts': 545194800,
                'time': '1987-04-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          57:
              {
                'ts': 560923200,
                'time': '1987-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          58:
              {
                'ts': 574225200,
                'time': '1988-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          59:
              {
                'ts': 591768000,
                'time': '1988-10-02T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          60:
              {
                'ts': 605674800,
                'time': '1989-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          61:
              {
                'ts': 624427200,
                'time': '1989-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          62:
              {
                'ts': 637729200,
                'time': '1990-03-18T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          63:
              {
                'ts': 653457600,
                'time': '1990-09-16T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          64:
              {
                'ts': 668574000,
                'time': '1991-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          65:
              {
                'ts': 687326400,
                'time': '1991-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          66:
              {
                'ts': 700628400,
                'time': '1992-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          67:
              {
                'ts': 718776000,
                'time': '1992-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          68:
              {
                'ts': 732078000,
                'time': '1993-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          69:
              {
                'ts': 750225600,
                'time': '1993-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          70:
              {
                'ts': 763527600,
                'time': '1994-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          71:
              {
                'ts': 781675200,
                'time': '1994-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          72:
              {
                'ts': 794977200,
                'time': '1995-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          73:
              {
                'ts': 813729600,
                'time': '1995-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          74:
              {
                'ts': 826426800,
                'time': '1996-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          75:
              {
                'ts': 845179200,
                'time': '1996-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          76:
              {
                'ts': 859690800,
                'time': '1997-03-30T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          77:
              {
                'ts': 876628800,
                'time': '1997-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          78:
              {
                'ts': 889930800,
                'time': '1998-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          79:
              {
                'ts': 906868800,
                'time': '1998-09-27T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          80:
              {
                'ts': 923194800,
                'time': '1999-04-04T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          81:
              {
                'ts': 939528000,
                'time': '1999-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          82:
              {
                'ts': 952830000,
                'time': '2000-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          83:
              {
                'ts': 971582400,
                'time': '2000-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          84:
              {
                'ts': 984279600,
                'time': '2001-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          85:
              {
                'ts': 1003032000,
                'time': '2001-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          86:
              {
                'ts': 1015729200,
                'time': '2002-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          87:
              {
                'ts': 1034481600,
                'time': '2002-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          88:
              {
                'ts': 1047178800,
                'time': '2003-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          89:
              {
                'ts': 1065931200,
                'time': '2003-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          90:
              {
                'ts': 1079233200,
                'time': '2004-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          91:
              {
                'ts': 1097380800,
                'time': '2004-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          92:
              {
                'ts': 1110682800,
                'time': '2005-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          93:
              {
                'ts': 1128830400,
                'time': '2005-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          94:
              {
                'ts': 1142132400,
                'time': '2006-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          95:
              {
                'ts': 1160884800,
                'time': '2006-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          96:
              {
                'ts': 1173582000,
                'time': '2007-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          97:
              {
                'ts': 1192334400,
                'time': '2007-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          98:
              {
                'ts': 1206846000,
                'time': '2008-03-30T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          99:
              {
                'ts': 1223784000,
                'time': '2008-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          100:
              {
                'ts': 1237086000,
                'time': '2009-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          101:
              {
                'ts': 1255233600,
                'time': '2009-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          102:
              {
                'ts': 1268535600,
                'time': '2010-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          103:
              {
                'ts': 1286683200,
                'time': '2010-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          104:
              {
                'ts': 1299985200,
                'time': '2011-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          105:
              {
                'ts': 1318132800,
                'time': '2011-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          106:
              {
                'ts': 1331434800,
                'time': '2012-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          107:
              {
                'ts': 1350187200,
                'time': '2012-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          108:
              {
                'ts': 1362884400,
                'time': '2013-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          109:
              {
                'ts': 1381636800,
                'time': '2013-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          110:
              {
                'ts': 1394334000,
                'time': '2014-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          111:
              {
                'ts': 1413086400,
                'time': '2014-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          112:
              {
                'ts': 1426388400,
                'time': '2015-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          113:
              {
                'ts': 1444536000,
                'time': '2015-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          114:
              {
                'ts': 1457838000,
                'time': '2016-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          115:
              {
                'ts': 1475985600,
                'time': '2016-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          116:
              {
                'ts': 1489287600,
                'time': '2017-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          117:
              {
                'ts': 1508040000,
                'time': '2017-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          118:
              {
                'ts': 1520737200,
                'time': '2018-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          119:
              {
                'ts': 1539489600,
                'time': '2018-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          120:
              {
                'ts': 1552186800,
                'time': '2019-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          121:
              {
                'ts': 1570939200,
                'time': '2019-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          122:
              {
                'ts': 1584241200,
                'time': '2020-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          123:
              {
                'ts': 1602388800,
                'time': '2020-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          124:
              {
                'ts': 1615690800,
                'time': '2021-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          125:
              {
                'ts': 1633838400,
                'time': '2021-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          126:
              {
                'ts': 1647140400,
                'time': '2022-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          127:
              {
                'ts': 1665288000,
                'time': '2022-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          128:
              {
                'ts': 1678590000,
                'time': '2023-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          129:
              {
                'ts': 1697342400,
                'time': '2023-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          130:
              {
                'ts': 1710039600,
                'time': '2024-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          131:
              {
                'ts': 1728792000,
                'time': '2024-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          132:
              {
                'ts': 1741489200,
                'time': '2025-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          133:
              {
                'ts': 1760241600,
                'time': '2025-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          134:
              {
                'ts': 1773543600,
                'time': '2026-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          135:
              {
                'ts': 1791691200,
                'time': '2026-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          136:
              {
                'ts': 1804993200,
                'time': '2027-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          137:
              {
                'ts': 1823140800,
                'time': '2027-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          138:
              {
                'ts': 1836442800,
                'time': '2028-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          139:
              {
                'ts': 1855195200,
                'time': '2028-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          140:
              {
                'ts': 1867892400,
                'time': '2029-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          141:
              {
                'ts': 1886644800,
                'time': '2029-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          142:
              {
                'ts': 1899342000,
                'time': '2030-03-10T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          143:
              {
                'ts': 1918094400,
                'time': '2030-10-13T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          144:
              {
                'ts': 1930791600,
                'time': '2031-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          145:
              {
                'ts': 1949544000,
                'time': '2031-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          146:
              {
                'ts': 1962846000,
                'time': '2032-03-14T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          147:
              {
                'ts': 1980993600,
                'time': '2032-10-10T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          148:
              {
                'ts': 1994295600,
                'time': '2033-03-13T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          149:
              {
                'ts': 2012443200,
                'time': '2033-10-09T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          150:
              {
                'ts': 2025745200,
                'time': '2034-03-12T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          151:
              {
                'ts': 2044497600,
                'time': '2034-10-15T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          152:
              {
                'ts': 2057194800,
                'time': '2035-03-11T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          153:
              {
                'ts': 2075947200,
                'time': '2035-10-14T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          154:
              {
                'ts': 2088644400,
                'time': '2036-03-09T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          155:
              {
                'ts': 2107396800,
                'time': '2036-10-12T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              },
          156:
              {
                'ts': 2120698800,
                'time': '2037-03-15T03:00:00+0000',
                'offset': -14400,
                'isdst': false,
                'abbr': 'CLT'
              },
          157:
              {
                'ts': 2138846400,
                'time': '2037-10-11T04:00:00+0000',
                'offset': -10800,
                'isdst': true,
                'abbr': 'CLST'
              }
        },
    'Chile/EasterIsland':
        {
          0:
              {
                'ts': -1178124152,
                'time': '1932-09-01T07:17:28+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          1:
              {
                'ts': -870552000,
                'time': '1942-06-01T04:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          2:
              {
                'ts': -865278000,
                'time': '1942-08-01T05:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          3:
              {
                'ts': -736376400,
                'time': '1946-09-01T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          4:
              {
                'ts': -36619200,
                'time': '1968-11-03T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          5:
              {
                'ts': -23922000,
                'time': '1969-03-30T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          6:
              {
                'ts': -3355200,
                'time': '1969-11-23T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          7:
              {
                'ts': 7527600,
                'time': '1970-03-29T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          8:
              {
                'ts': 24465600,
                'time': '1970-10-11T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          9:
              {
                'ts': 37767600,
                'time': '1971-03-14T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          10:
              {
                'ts': 55915200,
                'time': '1971-10-10T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          11:
              {
                'ts': 69217200,
                'time': '1972-03-12T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          12:
              {
                'ts': 87969600,
                'time': '1972-10-15T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          13:
              {
                'ts': 100666800,
                'time': '1973-03-11T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          14:
              {
                'ts': 118209600,
                'time': '1973-09-30T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          15:
              {
                'ts': 132116400,
                'time': '1974-03-10T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          16:
              {
                'ts': 150868800,
                'time': '1974-10-13T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          17:
              {
                'ts': 163566000,
                'time': '1975-03-09T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          18:
              {
                'ts': 182318400,
                'time': '1975-10-12T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          19:
              {
                'ts': 195620400,
                'time': '1976-03-14T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          20:
              {
                'ts': 213768000,
                'time': '1976-10-10T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          21:
              {
                'ts': 227070000,
                'time': '1977-03-13T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          22:
              {
                'ts': 245217600,
                'time': '1977-10-09T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          23:
              {
                'ts': 258519600,
                'time': '1978-03-12T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          24:
              {
                'ts': 277272000,
                'time': '1978-10-15T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          25:
              {
                'ts': 289969200,
                'time': '1979-03-11T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          26:
              {
                'ts': 308721600,
                'time': '1979-10-14T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          27:
              {
                'ts': 321418800,
                'time': '1980-03-09T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          28:
              {
                'ts': 340171200,
                'time': '1980-10-12T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          29:
              {
                'ts': 353473200,
                'time': '1981-03-15T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          30:
              {
                'ts': 371620800,
                'time': '1981-10-11T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          31:
              {
                'ts': 384922800,
                'time': '1982-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          32:
              {
                'ts': 403070400,
                'time': '1982-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          33:
              {
                'ts': 416372400,
                'time': '1983-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          34:
              {
                'ts': 434520000,
                'time': '1983-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          35:
              {
                'ts': 447822000,
                'time': '1984-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          36:
              {
                'ts': 466574400,
                'time': '1984-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          37:
              {
                'ts': 479271600,
                'time': '1985-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          38:
              {
                'ts': 498024000,
                'time': '1985-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          39:
              {
                'ts': 510721200,
                'time': '1986-03-09T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          40:
              {
                'ts': 529473600,
                'time': '1986-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          41:
              {
                'ts': 545194800,
                'time': '1987-04-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          42:
              {
                'ts': 560923200,
                'time': '1987-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          43:
              {
                'ts': 574225200,
                'time': '1988-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          44:
              {
                'ts': 591768000,
                'time': '1988-10-02T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          45:
              {
                'ts': 605674800,
                'time': '1989-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          46:
              {
                'ts': 624427200,
                'time': '1989-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          47:
              {
                'ts': 637729200,
                'time': '1990-03-18T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          48:
              {
                'ts': 653457600,
                'time': '1990-09-16T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          49:
              {
                'ts': 668574000,
                'time': '1991-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          50:
              {
                'ts': 687326400,
                'time': '1991-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          51:
              {
                'ts': 700628400,
                'time': '1992-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          52:
              {
                'ts': 718776000,
                'time': '1992-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          53:
              {
                'ts': 732078000,
                'time': '1993-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          54:
              {
                'ts': 750225600,
                'time': '1993-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          55:
              {
                'ts': 763527600,
                'time': '1994-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          56:
              {
                'ts': 781675200,
                'time': '1994-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          57:
              {
                'ts': 794977200,
                'time': '1995-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          58:
              {
                'ts': 813729600,
                'time': '1995-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          59:
              {
                'ts': 826426800,
                'time': '1996-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          60:
              {
                'ts': 845179200,
                'time': '1996-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          61:
              {
                'ts': 859690800,
                'time': '1997-03-30T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          62:
              {
                'ts': 876628800,
                'time': '1997-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          63:
              {
                'ts': 889930800,
                'time': '1998-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          64:
              {
                'ts': 906868800,
                'time': '1998-09-27T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          65:
              {
                'ts': 923194800,
                'time': '1999-04-04T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          66:
              {
                'ts': 939528000,
                'time': '1999-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          67:
              {
                'ts': 952830000,
                'time': '2000-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          68:
              {
                'ts': 971582400,
                'time': '2000-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          69:
              {
                'ts': 984279600,
                'time': '2001-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          70:
              {
                'ts': 1003032000,
                'time': '2001-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          71:
              {
                'ts': 1015729200,
                'time': '2002-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          72:
              {
                'ts': 1034481600,
                'time': '2002-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          73:
              {
                'ts': 1047178800,
                'time': '2003-03-09T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          74:
              {
                'ts': 1065931200,
                'time': '2003-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          75:
              {
                'ts': 1079233200,
                'time': '2004-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          76:
              {
                'ts': 1097380800,
                'time': '2004-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          77:
              {
                'ts': 1110682800,
                'time': '2005-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          78:
              {
                'ts': 1128830400,
                'time': '2005-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          79:
              {
                'ts': 1142132400,
                'time': '2006-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          80:
              {
                'ts': 1160884800,
                'time': '2006-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          81:
              {
                'ts': 1173582000,
                'time': '2007-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          82:
              {
                'ts': 1192334400,
                'time': '2007-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          83:
              {
                'ts': 1206846000,
                'time': '2008-03-30T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          84:
              {
                'ts': 1223784000,
                'time': '2008-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          85:
              {
                'ts': 1237086000,
                'time': '2009-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          86:
              {
                'ts': 1255233600,
                'time': '2009-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          87:
              {
                'ts': 1268535600,
                'time': '2010-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          88:
              {
                'ts': 1286683200,
                'time': '2010-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          89:
              {
                'ts': 1299985200,
                'time': '2011-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          90:
              {
                'ts': 1318132800,
                'time': '2011-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          91:
              {
                'ts': 1331434800,
                'time': '2012-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          92:
              {
                'ts': 1350187200,
                'time': '2012-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          93:
              {
                'ts': 1362884400,
                'time': '2013-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          94:
              {
                'ts': 1381636800,
                'time': '2013-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          95:
              {
                'ts': 1394334000,
                'time': '2014-03-09T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          96:
              {
                'ts': 1413086400,
                'time': '2014-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          97:
              {
                'ts': 1426388400,
                'time': '2015-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          98:
              {
                'ts': 1444536000,
                'time': '2015-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          99:
              {
                'ts': 1457838000,
                'time': '2016-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          100:
              {
                'ts': 1475985600,
                'time': '2016-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          101:
              {
                'ts': 1489287600,
                'time': '2017-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          102:
              {
                'ts': 1508040000,
                'time': '2017-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          103:
              {
                'ts': 1520737200,
                'time': '2018-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          104:
              {
                'ts': 1539489600,
                'time': '2018-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          105:
              {
                'ts': 1552186800,
                'time': '2019-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          106:
              {
                'ts': 1570939200,
                'time': '2019-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          107:
              {
                'ts': 1584241200,
                'time': '2020-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          108:
              {
                'ts': 1602388800,
                'time': '2020-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          109:
              {
                'ts': 1615690800,
                'time': '2021-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          110:
              {
                'ts': 1633838400,
                'time': '2021-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          111:
              {
                'ts': 1647140400,
                'time': '2022-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          112:
              {
                'ts': 1665288000,
                'time': '2022-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          113:
              {
                'ts': 1678590000,
                'time': '2023-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          114:
              {
                'ts': 1697342400,
                'time': '2023-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          115:
              {
                'ts': 1710039600,
                'time': '2024-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          116:
              {
                'ts': 1728792000,
                'time': '2024-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          117:
              {
                'ts': 1741489200,
                'time': '2025-03-09T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          118:
              {
                'ts': 1760241600,
                'time': '2025-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          119:
              {
                'ts': 1773543600,
                'time': '2026-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          120:
              {
                'ts': 1791691200,
                'time': '2026-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          121:
              {
                'ts': 1804993200,
                'time': '2027-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          122:
              {
                'ts': 1823140800,
                'time': '2027-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          123:
              {
                'ts': 1836442800,
                'time': '2028-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          124:
              {
                'ts': 1855195200,
                'time': '2028-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          125:
              {
                'ts': 1867892400,
                'time': '2029-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          126:
              {
                'ts': 1886644800,
                'time': '2029-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          127:
              {
                'ts': 1899342000,
                'time': '2030-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          128:
              {
                'ts': 1918094400,
                'time': '2030-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          129:
              {
                'ts': 1930791600,
                'time': '2031-03-09T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          130:
              {
                'ts': 1949544000,
                'time': '2031-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          131:
              {
                'ts': 1962846000,
                'time': '2032-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          132:
              {
                'ts': 1980993600,
                'time': '2032-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          133:
              {
                'ts': 1994295600,
                'time': '2033-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          134:
              {
                'ts': 2012443200,
                'time': '2033-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          135:
              {
                'ts': 2025745200,
                'time': '2034-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          136:
              {
                'ts': 2044497600,
                'time': '2034-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          137:
              {
                'ts': 2057194800,
                'time': '2035-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          138:
              {
                'ts': 2075947200,
                'time': '2035-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          139:
              {
                'ts': 2088644400,
                'time': '2036-03-09T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          140:
              {
                'ts': 2107396800,
                'time': '2036-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          141:
              {
                'ts': 2120698800,
                'time': '2037-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          142:
              {
                'ts': 2138846400,
                'time': '2037-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              }
        },
    'CST6CDT':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          6:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -84384000,
                'time': '1967-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -68662800,
                'time': '1967-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -52934400,
                'time': '1968-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -37213200,
                'time': '1968-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -21484800,
                'time': '1969-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -5763600,
                'time': '1969-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 9964800,
                'time': '1970-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': 25686000,
                'time': '1970-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 41414400,
                'time': '1971-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': 57740400,
                'time': '1971-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': 73468800,
                'time': '1972-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': 89190000,
                'time': '1972-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': 104918400,
                'time': '1973-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': 120639600,
                'time': '1973-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': 126691200,
                'time': '1974-01-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 162374400,
                'time': '1975-02-23T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': 183538800,
                'time': '1975-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 199267200,
                'time': '1976-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': 215593200,
                'time': '1976-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 230716800,
                'time': '1977-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': 247042800,
                'time': '1977-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 262771200,
                'time': '1978-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': 278492400,
                'time': '1978-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 294220800,
                'time': '1979-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': 309942000,
                'time': '1979-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': 341391600,
                'time': '1980-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': 372841200,
                'time': '1981-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          38:
              {
                'ts': 404895600,
                'time': '1982-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': 436345200,
                'time': '1983-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': 467794800,
                'time': '1984-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': 499244400,
                'time': '1985-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 530694000,
                'time': '1986-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 562143600,
                'time': '1987-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 594198000,
                'time': '1988-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 625647600,
                'time': '1989-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 657097200,
                'time': '1990-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 688546800,
                'time': '1991-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 702460800,
                'time': '1992-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 719996400,
                'time': '1992-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 733910400,
                'time': '1993-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 752050800,
                'time': '1993-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 765360000,
                'time': '1994-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 783500400,
                'time': '1994-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 796809600,
                'time': '1995-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 814950000,
                'time': '1995-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 986112000,
                'time': '2001-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 1004252400,
                'time': '2001-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          89:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          120:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          122:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          124:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          126:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          128:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          130:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          132:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          134:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          136:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          138:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          140:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          141:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          142:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          143:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          144:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          145:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          146:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          147:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          148:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'Cuba':
        {
          0:
              {
                'ts': -1402813824,
                'time': '1925-07-19T17:29:36+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -1311534000,
                'time': '1928-06-10T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          2:
              {
                'ts': -1300996800,
                'time': '1928-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': -933534000,
                'time': '1940-06-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': -925675200,
                'time': '1940-09-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': -902084400,
                'time': '1941-06-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': -893620800,
                'time': '1941-09-07T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -870030000,
                'time': '1942-06-07T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -862171200,
                'time': '1942-09-06T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -775681200,
                'time': '1945-06-03T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -767822400,
                'time': '1945-09-02T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -744231600,
                'time': '1946-06-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -736372800,
                'time': '1946-09-01T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -144702000,
                'time': '1965-06-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -134251200,
                'time': '1965-09-30T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -113425200,
                'time': '1966-05-29T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -102542400,
                'time': '1966-10-02T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -86295600,
                'time': '1967-04-08T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -72907200,
                'time': '1967-09-10T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -54154800,
                'time': '1968-04-14T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -41457600,
                'time': '1968-09-08T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -21495600,
                'time': '1969-04-27T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -5774400,
                'time': '1969-10-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': 9954000,
                'time': '1970-04-26T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': 25675200,
                'time': '1970-10-25T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': 41403600,
                'time': '1971-04-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': 57729600,
                'time': '1971-10-31T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': 73458000,
                'time': '1972-04-30T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': 87364800,
                'time': '1972-10-08T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': 104907600,
                'time': '1973-04-29T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': 118900800,
                'time': '1973-10-08T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': 136357200,
                'time': '1974-04-28T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': 150436800,
                'time': '1974-10-08T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': 167806800,
                'time': '1975-04-27T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': 183528000,
                'time': '1975-10-26T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': 199256400,
                'time': '1976-04-25T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': 215582400,
                'time': '1976-10-31T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': 230706000,
                'time': '1977-04-24T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          38:
              {
                'ts': 247032000,
                'time': '1977-10-30T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': 263365200,
                'time': '1978-05-07T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': 276667200,
                'time': '1978-10-08T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': 290581200,
                'time': '1979-03-18T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': 308721600,
                'time': '1979-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': 322030800,
                'time': '1980-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': 340171200,
                'time': '1980-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 358318800,
                'time': '1981-05-10T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 371620800,
                'time': '1981-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 389768400,
                'time': '1982-05-09T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 403070400,
                'time': '1982-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 421218000,
                'time': '1983-05-08T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 434520000,
                'time': '1983-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 452667600,
                'time': '1984-05-06T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 466574400,
                'time': '1984-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 484117200,
                'time': '1985-05-05T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 498024000,
                'time': '1985-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 511333200,
                'time': '1986-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 529473600,
                'time': '1986-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 542782800,
                'time': '1987-03-15T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 560923200,
                'time': '1987-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 574837200,
                'time': '1988-03-20T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 592372800,
                'time': '1988-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 606286800,
                'time': '1989-03-19T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 623822400,
                'time': '1989-10-08T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 638946000,
                'time': '1990-04-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 655876800,
                'time': '1990-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 671000400,
                'time': '1991-04-07T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 687330000,
                'time': '1991-10-13T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 702450000,
                'time': '1992-04-05T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 718779600,
                'time': '1992-10-11T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 733899600,
                'time': '1993-04-04T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 750229200,
                'time': '1993-10-10T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 765349200,
                'time': '1994-04-03T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 781678800,
                'time': '1994-10-09T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 796798800,
                'time': '1995-04-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 813128400,
                'time': '1995-10-08T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 828853200,
                'time': '1996-04-07T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 844578000,
                'time': '1996-10-06T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 860302800,
                'time': '1997-04-06T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 876632400,
                'time': '1997-10-12T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 891147600,
                'time': '1998-03-29T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 909291600,
                'time': '1998-10-25T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 922597200,
                'time': '1999-03-28T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 941346000,
                'time': '1999-10-31T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 954651600,
                'time': '2000-04-02T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 972795600,
                'time': '2000-10-29T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 986101200,
                'time': '2001-04-01T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 1004245200,
                'time': '2001-10-28T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 1018155600,
                'time': '2002-04-07T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': 1035694800,
                'time': '2002-10-27T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          89:
              {
                'ts': 1049605200,
                'time': '2003-04-06T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': 1067144400,
                'time': '2003-10-26T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1081054800,
                'time': '2004-04-04T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': 1162098000,
                'time': '2006-10-29T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1173589200,
                'time': '2007-03-11T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': 1193547600,
                'time': '2007-10-28T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1205643600,
                'time': '2008-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': 1224997200,
                'time': '2008-10-26T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1237093200,
                'time': '2009-03-15T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': 1256446800,
                'time': '2009-10-25T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1269147600,
                'time': '2010-03-21T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 1288501200,
                'time': '2010-10-31T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1300597200,
                'time': '2011-03-20T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 1319950800,
                'time': '2011-10-30T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1332046800,
                'time': '2012-03-18T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 1351400400,
                'time': '2012-10-28T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1363496400,
                'time': '2013-03-17T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 1382850000,
                'time': '2013-10-27T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1394946000,
                'time': '2014-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 1414299600,
                'time': '2014-10-26T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1426395600,
                'time': '2015-03-15T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 1445749200,
                'time': '2015-10-25T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 1458450000,
                'time': '2016-03-20T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 1477803600,
                'time': '2016-10-30T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1489899600,
                'time': '2017-03-19T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 1509253200,
                'time': '2017-10-29T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1521349200,
                'time': '2018-03-18T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 1540702800,
                'time': '2018-10-28T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1552798800,
                'time': '2019-03-17T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 1572152400,
                'time': '2019-10-27T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1584248400,
                'time': '2020-03-15T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          120:
              {
                'ts': 1603602000,
                'time': '2020-10-25T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1616302800,
                'time': '2021-03-21T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          122:
              {
                'ts': 1635656400,
                'time': '2021-10-31T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 1647752400,
                'time': '2022-03-20T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          124:
              {
                'ts': 1667106000,
                'time': '2022-10-30T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 1679202000,
                'time': '2023-03-19T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          126:
              {
                'ts': 1698555600,
                'time': '2023-10-29T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 1710651600,
                'time': '2024-03-17T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          128:
              {
                'ts': 1730005200,
                'time': '2024-10-27T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 1742101200,
                'time': '2025-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          130:
              {
                'ts': 1761454800,
                'time': '2025-10-26T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 1773550800,
                'time': '2026-03-15T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          132:
              {
                'ts': 1792904400,
                'time': '2026-10-25T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 1805605200,
                'time': '2027-03-21T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          134:
              {
                'ts': 1824958800,
                'time': '2027-10-31T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 1837054800,
                'time': '2028-03-19T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          136:
              {
                'ts': 1856408400,
                'time': '2028-10-29T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 1868504400,
                'time': '2029-03-18T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          138:
              {
                'ts': 1887858000,
                'time': '2029-10-28T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 1899954000,
                'time': '2030-03-17T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          140:
              {
                'ts': 1919307600,
                'time': '2030-10-27T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          141:
              {
                'ts': 1931403600,
                'time': '2031-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          142:
              {
                'ts': 1950757200,
                'time': '2031-10-26T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          143:
              {
                'ts': 1963458000,
                'time': '2032-03-21T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          144:
              {
                'ts': 1982811600,
                'time': '2032-10-31T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          145:
              {
                'ts': 1994907600,
                'time': '2033-03-20T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          146:
              {
                'ts': 2014261200,
                'time': '2033-10-30T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          147:
              {
                'ts': 2026357200,
                'time': '2034-03-19T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          148:
              {
                'ts': 2045710800,
                'time': '2034-10-29T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          149:
              {
                'ts': 2057806800,
                'time': '2035-03-18T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          150:
              {
                'ts': 2077160400,
                'time': '2035-10-28T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          151:
              {
                'ts': 2089256400,
                'time': '2036-03-16T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          152:
              {
                'ts': 2108610000,
                'time': '2036-10-26T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              },
          153:
              {
                'ts': 2120706000,
                'time': '2037-03-15T05:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'CDT'
              },
          154:
              {
                'ts': 2140059600,
                'time': '2037-10-25T05:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'EET':
        {
          0:
              {
                'ts': -1535938792,
                'time': '1921-04-30T22:20:08+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -875671200,
                'time': '1942-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          2:
              {
                'ts': -859863600,
                'time': '1942-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          4:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          6:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          10:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          11:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          12:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          14:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          15:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          16:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          17:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          18:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          19:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          20:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          21:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          22:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          23:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          24:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          25:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          26:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Egypt':
        {
          0:
              {
                'ts': -929844000,
                'time': '1940-07-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          1:
              {
                'ts': -923108400,
                'time': '1940-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          2:
              {
                'ts': -906170400,
                'time': '1941-04-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          3:
              {
                'ts': -892868400,
                'time': '1941-09-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          4:
              {
                'ts': -875844000,
                'time': '1942-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          5:
              {
                'ts': -857790000,
                'time': '1942-10-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          6:
              {
                'ts': -844308000,
                'time': '1943-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          7:
              {
                'ts': -825822000,
                'time': '1943-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          8:
              {
                'ts': -812685600,
                'time': '1944-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          9:
              {
                'ts': -794199600,
                'time': '1944-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          10:
              {
                'ts': -779853600,
                'time': '1945-04-15T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          11:
              {
                'ts': -762663600,
                'time': '1945-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          12:
              {
                'ts': -399088800,
                'time': '1957-05-09T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          13:
              {
                'ts': -386650800,
                'time': '1957-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          14:
              {
                'ts': -368330400,
                'time': '1958-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          15:
              {
                'ts': -355114800,
                'time': '1958-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          16:
              {
                'ts': -336790800,
                'time': '1959-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          17:
              {
                'ts': -323654400,
                'time': '1959-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          18:
              {
                'ts': -305168400,
                'time': '1960-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          19:
              {
                'ts': -292032000,
                'time': '1960-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          20:
              {
                'ts': -273632400,
                'time': '1961-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          21:
              {
                'ts': -260496000,
                'time': '1961-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          22:
              {
                'ts': -242096400,
                'time': '1962-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          23:
              {
                'ts': -228960000,
                'time': '1962-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          24:
              {
                'ts': -210560400,
                'time': '1963-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          25:
              {
                'ts': -197424000,
                'time': '1963-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          26:
              {
                'ts': -178938000,
                'time': '1964-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          27:
              {
                'ts': -165801600,
                'time': '1964-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          28:
              {
                'ts': -147402000,
                'time': '1965-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          29:
              {
                'ts': -134265600,
                'time': '1965-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          30:
              {
                'ts': -115866000,
                'time': '1966-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          31:
              {
                'ts': -102643200,
                'time': '1966-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          32:
              {
                'ts': -84330000,
                'time': '1967-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          33:
              {
                'ts': -71107200,
                'time': '1967-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          34:
              {
                'ts': -52707600,
                'time': '1968-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          35:
              {
                'ts': -39484800,
                'time': '1968-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          36:
              {
                'ts': -21171600,
                'time': '1969-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          37:
              {
                'ts': -7948800,
                'time': '1969-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          38:
              {
                'ts': 10364400,
                'time': '1970-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          39:
              {
                'ts': 23587200,
                'time': '1970-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          40:
              {
                'ts': 41900400,
                'time': '1971-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          41:
              {
                'ts': 55123200,
                'time': '1971-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          42:
              {
                'ts': 73522800,
                'time': '1972-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          43:
              {
                'ts': 86745600,
                'time': '1972-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          44:
              {
                'ts': 105058800,
                'time': '1973-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          45:
              {
                'ts': 118281600,
                'time': '1973-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          46:
              {
                'ts': 136594800,
                'time': '1974-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          47:
              {
                'ts': 149817600,
                'time': '1974-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          48:
              {
                'ts': 168130800,
                'time': '1975-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          49:
              {
                'ts': 181353600,
                'time': '1975-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          50:
              {
                'ts': 199753200,
                'time': '1976-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          51:
              {
                'ts': 212976000,
                'time': '1976-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          52:
              {
                'ts': 231289200,
                'time': '1977-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          53:
              {
                'ts': 244512000,
                'time': '1977-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          54:
              {
                'ts': 262825200,
                'time': '1978-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          55:
              {
                'ts': 276048000,
                'time': '1978-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          56:
              {
                'ts': 294361200,
                'time': '1979-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          57:
              {
                'ts': 307584000,
                'time': '1979-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          58:
              {
                'ts': 325983600,
                'time': '1980-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          59:
              {
                'ts': 339206400,
                'time': '1980-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          60:
              {
                'ts': 357519600,
                'time': '1981-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          61:
              {
                'ts': 370742400,
                'time': '1981-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          62:
              {
                'ts': 396399600,
                'time': '1982-07-24T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          63:
              {
                'ts': 402278400,
                'time': '1982-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          64:
              {
                'ts': 426812400,
                'time': '1983-07-11T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          65:
              {
                'ts': 433814400,
                'time': '1983-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          66:
              {
                'ts': 452214000,
                'time': '1984-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          67:
              {
                'ts': 465436800,
                'time': '1984-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          68:
              {
                'ts': 483750000,
                'time': '1985-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          69:
              {
                'ts': 496972800,
                'time': '1985-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          70:
              {
                'ts': 515286000,
                'time': '1986-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          71:
              {
                'ts': 528508800,
                'time': '1986-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          72:
              {
                'ts': 546822000,
                'time': '1987-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          73:
              {
                'ts': 560044800,
                'time': '1987-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          74:
              {
                'ts': 578444400,
                'time': '1988-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          75:
              {
                'ts': 591667200,
                'time': '1988-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          76:
              {
                'ts': 610412400,
                'time': '1989-05-05T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          77:
              {
                'ts': 623203200,
                'time': '1989-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          78:
              {
                'ts': 641516400,
                'time': '1990-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          79:
              {
                'ts': 654739200,
                'time': '1990-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          80:
              {
                'ts': 673052400,
                'time': '1991-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          81:
              {
                'ts': 686275200,
                'time': '1991-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          82:
              {
                'ts': 704674800,
                'time': '1992-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          83:
              {
                'ts': 717897600,
                'time': '1992-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          84:
              {
                'ts': 736210800,
                'time': '1993-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          85:
              {
                'ts': 749433600,
                'time': '1993-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          86:
              {
                'ts': 767746800,
                'time': '1994-04-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          87:
              {
                'ts': 780969600,
                'time': '1994-10-01T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          88:
              {
                'ts': 799020000,
                'time': '1995-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'

              },
          89:
              {
                'ts': 812322000,
                'time': '1995-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          90:
              {
                'ts': 830469600,
                'time': '1996-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          91:
              {
                'ts': 843771600,
                'time': '1996-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          92:
              {
                'ts': 861919200,
                'time': '1997-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          93:
              {
                'ts': 875221200,
                'time': '1997-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          94:
              {
                'ts': 893368800,
                'time': '1998-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          95:
              {
                'ts': 906670800,
                'time': '1998-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          96:
              {
                'ts': 925423200,
                'time': '1999-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          97:
              {
                'ts': 938725200,
                'time': '1999-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          98:
              {
                'ts': 956872800,
                'time': '2000-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          99:
              {
                'ts': 970174800,
                'time': '2000-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          100:
              {
                'ts': 988322400,
                'time': '2001-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          101:
              {
                'ts': 1001624400,
                'time': '2001-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          102:
              {
                'ts': 1019772000,
                'time': '2002-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          103:
              {
                'ts': 1033074000,
                'time': '2002-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          104:
              {
                'ts': 1051221600,
                'time': '2003-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          105:
              {
                'ts': 1064523600,
                'time': '2003-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          106:
              {
                'ts': 1083276000,
                'time': '2004-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          107:
              {
                'ts': 1096578000,
                'time': '2004-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          108:
              {
                'ts': 1114725600,
                'time': '2005-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          109:
              {
                'ts': 1128027600,
                'time': '2005-09-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          110:
              {
                'ts': 1146175200,
                'time': '2006-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          111:
              {
                'ts': 1158872400,
                'time': '2006-09-21T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          112:
              {
                'ts': 1177624800,
                'time': '2007-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          113:
              {
                'ts': 1189112400,
                'time': '2007-09-06T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          114:
              {
                'ts': 1209074400,
                'time': '2008-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          115:
              {
                'ts': 1219957200,
                'time': '2008-08-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          116:
              {
                'ts': 1240524000,
                'time': '2009-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          117:
              {
                'ts': 1251406800,
                'time': '2009-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          118:
              {
                'ts': 1272578400,
                'time': '2010-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          119:
              {
                'ts': 1282856400,
                'time': '2010-08-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          120:
              {
                'ts': 1304028000,
                'time': '2011-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          121:
              {
                'ts': 1314306000,
                'time': '2011-08-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          122:
              {
                'ts': 1335477600,
                'time': '2012-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          123:
              {
                'ts': 1346360400,
                'time': '2012-08-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          124:
              {
                'ts': 1366927200,
                'time': '2013-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          125:
              {
                'ts': 1377810000,
                'time': '2013-08-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          126:
              {
                'ts': 1398376800,
                'time': '2014-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          127:
              {
                'ts': 1409259600,
                'time': '2014-08-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          128:
              {
                'ts': 1429826400,
                'time': '2015-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          129:
              {
                'ts': 1440709200,
                'time': '2015-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          130:
              {
                'ts': 1461880800,
                'time': '2016-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          131:
              {
                'ts': 1472158800,
                'time': '2016-08-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          132:
              {
                'ts': 1493330400,
                'time': '2017-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          133:
              {
                'ts': 1504213200,
                'time': '2017-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          134:
              {
                'ts': 1524780000,
                'time': '2018-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          135:
              {
                'ts': 1535662800,
                'time': '2018-08-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          136:
              {
                'ts': 1556229600,
                'time': '2019-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          137:
              {
                'ts': 1567112400,
                'time': '2019-08-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          138:
              {
                'ts': 1587679200,
                'time': '2020-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          139:
              {
                'ts': 1598562000,
                'time': '2020-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          140:
              {
                'ts': 1619733600,
                'time': '2021-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          141:
              {
                'ts': 1630011600,
                'time': '2021-08-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          142:
              {
                'ts': 1651183200,
                'time': '2022-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          143:
              {
                'ts': 1661461200,
                'time': '2022-08-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          144:
              {
                'ts': 1682632800,
                'time': '2023-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          145:
              {
                'ts': 1693515600,
                'time': '2023-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          146:
              {
                'ts': 1714082400,
                'time': '2024-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          147:
              {
                'ts': 1724965200,
                'time': '2024-08-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          148:
              {
                'ts': 1745532000,
                'time': '2025-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          149:
              {
                'ts': 1756414800,
                'time': '2025-08-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          150:
              {
                'ts': 1776981600,
                'time': '2026-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          151:
              {
                'ts': 1787864400,
                'time': '2026-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          152:
              {
                'ts': 1809036000,
                'time': '2027-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          153:
              {
                'ts': 1819314000,
                'time': '2027-08-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          154:
              {
                'ts': 1840485600,
                'time': '2028-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          155:
              {
                'ts': 1851368400,
                'time': '2028-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          156:
              {
                'ts': 1871935200,
                'time': '2029-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          157:
              {
                'ts': 1882818000,
                'time': '2029-08-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          158:
              {
                'ts': 1903384800,
                'time': '2030-04-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          159:
              {
                'ts': 1914267600,
                'time': '2030-08-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          160:
              {
                'ts': 1934834400,
                'time': '2031-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          161:
              {
                'ts': 1945717200,
                'time': '2031-08-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          162:
              {
                'ts': 1966888800,
                'time': '2032-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          163:
              {
                'ts': 1977166800,
                'time': '2032-08-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          164:
              {
                'ts': 1998338400,
                'time': '2033-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          165:
              {
                'ts': 2008616400,
                'time': '2033-08-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          166:
              {
                'ts': 2029788000,
                'time': '2034-04-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          167:
              {
                'ts': 2040670800,
                'time': '2034-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          168:
              {
                'ts': 2061237600,
                'time': '2035-04-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          169:
              {
                'ts': 2072120400,
                'time': '2035-08-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          170:
              {
                'ts': 2092687200,
                'time': '2036-04-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          171:
              {
                'ts': 2103570000,
                'time': '2036-08-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          172:
              {
                'ts': 2124136800,
                'time': '2037-04-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          173:
              {
                'ts': 2135019600,
                'time': '2037-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Eire':
        {
          0:
              {
                'ts': -1691962479,
                'time': '1916-05-21T02:25:21+0000',
                'offset': 2079,
                'isdst': true,
                'abbr': 'IST'
              },
          1:
              {
                'ts': -1680471279,
                'time': '1916-10-01T02:25:21+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          2:
              {
                'ts': -1664143200,
                'time': '1917-04-08T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          3:
              {
                'ts': -1650146400,
                'time': '1917-09-17T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          4:
              {
                'ts': -1633903200,
                'time': '1918-03-24T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          5:
              {
                'ts': -1617487200,
                'time': '1918-09-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          6:
              {
                'ts': -1601848800,
                'time': '1919-03-30T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          7:
              {
                'ts': -1586037600,
                'time': '1919-09-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          8:
              {
                'ts': -1570399200,
                'time': '1920-03-28T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          9:
              {
                'ts': -1552168800,
                'time': '1920-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          10:
              {
                'ts': -1538344800,
                'time': '1921-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          11:
              {
                'ts': -1522533600,
                'time': '1921-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          12:
              {
                'ts': -1517011200,
                'time': '1921-12-06T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          13:
              {
                'ts': -1507500000,
                'time': '1922-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          14:
              {
                'ts': -1490565600,
                'time': '1922-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          15:
              {
                'ts': -1473631200,
                'time': '1923-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          16:
              {
                'ts': -1460930400,
                'time': '1923-09-16T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          17:
              {
                'ts': -1442786400,
                'time': '1924-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          18:
              {
                'ts': -1428876000,
                'time': '1924-09-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          19:
              {
                'ts': -1410732000,
                'time': '1925-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          20:
              {
                'ts': -1396216800,
                'time': '1925-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          21:
              {
                'ts': -1379282400,
                'time': '1926-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          22:
              {
                'ts': -1364767200,
                'time': '1926-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          23:
              {
                'ts': -1348437600,
                'time': '1927-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          24:
              {
                'ts': -1333317600,
                'time': '1927-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          25:
              {
                'ts': -1315778400,
                'time': '1928-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          26:
              {
                'ts': -1301263200,
                'time': '1928-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          27:
              {
                'ts': -1284328800,
                'time': '1929-04-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          28:
              {
                'ts': -1269813600,
                'time': '1929-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          29:
              {
                'ts': -1253484000,
                'time': '1930-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          30:
              {
                'ts': -1238364000,
                'time': '1930-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          31:
              {
                'ts': -1221429600,
                'time': '1931-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          32:
              {
                'ts': -1206914400,
                'time': '1931-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          33:
              {
                'ts': -1189980000,
                'time': '1932-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          34:
              {
                'ts': -1175464800,
                'time': '1932-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          35:
              {
                'ts': -1159135200,
                'time': '1933-04-09T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          36:
              {
                'ts': -1143410400,
                'time': '1933-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          37:
              {
                'ts': -1126476000,
                'time': '1934-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          38:
              {
                'ts': -1111960800,
                'time': '1934-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          39:
              {
                'ts': -1095631200,
                'time': '1935-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          40:
              {
                'ts': -1080511200,
                'time': '1935-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          41:
              {
                'ts': -1063576800,
                'time': '1936-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          42:
              {
                'ts': -1049061600,
                'time': '1936-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          43:
              {
                'ts': -1032127200,
                'time': '1937-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          44:
              {
                'ts': -1017612000,
                'time': '1937-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          45:
              {
                'ts': -1001282400,
                'time': '1938-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          46:
              {
                'ts': -986162400,
                'time': '1938-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          47:
              {
                'ts': -969228000,
                'time': '1939-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          48:
              {
                'ts': -950479200,
                'time': '1939-11-19T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          49:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          50:
              {
                'ts': -733359600,
                'time': '1946-10-06T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          51:
              {
                'ts': -719445600,
                'time': '1947-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          52:
              {
                'ts': -699490800,
                'time': '1947-11-02T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          53:
              {
                'ts': -684972000,
                'time': '1948-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          54:
              {
                'ts': -668037600,
                'time': '1948-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          55:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          56:
              {
                'ts': -636588000,
                'time': '1949-10-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          57:
              {
                'ts': -622072800,
                'time': '1950-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          58:
              {
                'ts': -605743200,
                'time': '1950-10-22T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          59:
              {
                'ts': -590623200,
                'time': '1951-04-15T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          60:
              {
                'ts': -574293600,
                'time': '1951-10-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          61:
              {
                'ts': -558568800,
                'time': '1952-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          62:
              {
                'ts': -542239200,
                'time': '1952-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          63:
              {
                'ts': -527119200,
                'time': '1953-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          64:
              {
                'ts': -512604000,
                'time': '1953-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          65:
              {
                'ts': -496274400,
                'time': '1954-04-11T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          66:
              {
                'ts': -481154400,
                'time': '1954-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          67:
              {
                'ts': -464220000,
                'time': '1955-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          68:
              {
                'ts': -449704800,
                'time': '1955-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          69:
              {
                'ts': -432165600,
                'time': '1956-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          70:
              {
                'ts': -417650400,
                'time': '1956-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          71:
              {
                'ts': -401320800,
                'time': '1957-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          72:
              {
                'ts': -386200800,
                'time': '1957-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          73:
              {
                'ts': -369266400,
                'time': '1958-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          74:
              {
                'ts': -354751200,
                'time': '1958-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          75:
              {
                'ts': -337816800,
                'time': '1959-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          76:
              {
                'ts': -323301600,
                'time': '1959-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          77:
              {
                'ts': -306972000,
                'time': '1960-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          78:
              {
                'ts': -291852000,
                'time': '1960-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          79:
              {
                'ts': -276732000,
                'time': '1961-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          80:
              {
                'ts': -257983200,
                'time': '1961-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          81:
              {
                'ts': -245282400,
                'time': '1962-03-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          82:
              {
                'ts': -226533600,
                'time': '1962-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          83:
              {
                'ts': -213228000,
                'time': '1963-03-31T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          84:
              {
                'ts': -195084000,
                'time': '1963-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          85:
              {
                'ts': -182383200,
                'time': '1964-03-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          86:
              {
                'ts': -163634400,
                'time': '1964-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          87:
              {
                'ts': -150933600,
                'time': '1965-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          88:
              {
                'ts': -132184800,
                'time': '1965-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          89:
              {
                'ts': -119484000,
                'time': '1966-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          90:
              {
                'ts': -100735200,
                'time': '1966-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          91:
              {
                'ts': -88034400,
                'time': '1967-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          92:
              {
                'ts': -68680800,
                'time': '1967-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          93:
              {
                'ts': -59004000,
                'time': '1968-02-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          94:
              {
                'ts': -37242000,
                'time': '1968-10-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'IST'
              },
          95:
              {
                'ts': 57722400,
                'time': '1971-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          96:
              {
                'ts': 69818400,
                'time': '1972-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          97:
              {
                'ts': 89172000,
                'time': '1972-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          98:
              {
                'ts': 101268000,
                'time': '1973-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          99:
              {
                'ts': 120621600,
                'time': '1973-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          100:
              {
                'ts': 132717600,
                'time': '1974-03-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          101:
              {
                'ts': 152071200,
                'time': '1974-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          102:
              {
                'ts': 164167200,
                'time': '1975-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          103:
              {
                'ts': 183520800,
                'time': '1975-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          104:
              {
                'ts': 196221600,
                'time': '1976-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          105:
              {
                'ts': 214970400,
                'time': '1976-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          106:
              {
                'ts': 227671200,
                'time': '1977-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          107:
              {
                'ts': 246420000,
                'time': '1977-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          108:
              {
                'ts': 259120800,
                'time': '1978-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          109:
              {
                'ts': 278474400,
                'time': '1978-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          110:
              {
                'ts': 290570400,
                'time': '1979-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          111:
              {
                'ts': 309924000,
                'time': '1979-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          112:
              {
                'ts': 322020000,
                'time': '1980-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          113:
              {
                'ts': 341373600,
                'time': '1980-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          114:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          115:
              {
                'ts': 372819600,
                'time': '1981-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          116:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          117:
              {
                'ts': 404269200,
                'time': '1982-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          118:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          119:
              {
                'ts': 435718800,
                'time': '1983-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          120:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          121:
              {
                'ts': 467773200,
                'time': '1984-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          122:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          123:
              {
                'ts': 499222800,
                'time': '1985-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          124:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          125:
              {
                'ts': 530672400,
                'time': '1986-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          126:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          127:
              {
                'ts': 562122000,
                'time': '1987-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          128:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          129:
              {
                'ts': 593571600,
                'time': '1988-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          130:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          131:
              {
                'ts': 625626000,
                'time': '1989-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          132:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          133:
              {
                'ts': 657075600,
                'time': '1990-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          134:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          135:
              {
                'ts': 688525200,
                'time': '1991-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          136:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          137:
              {
                'ts': 719974800,
                'time': '1992-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          138:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          139:
              {
                'ts': 751424400,
                'time': '1993-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          140:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          141:
              {
                'ts': 782874000,
                'time': '1994-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          142:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          143:
              {
                'ts': 814323600,
                'time': '1995-10-22T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          144:
              {
                'ts': 820454400,
                'time': '1996-01-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          145:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          146:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          147:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          148:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          149:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          150:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          151:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          152:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          153:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          154:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          155:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          156:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          157:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          158:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          159:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          160:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          161:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          162:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          163:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          164:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          165:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          166:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          167:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          168:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          169:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          170:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          171:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          172:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          173:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          174:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          175:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          176:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          177:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          178:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          179:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          180:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          181:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          182:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          183:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          184:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          185:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          186:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          187:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          188:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          189:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          190:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          191:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          192:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          193:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          194:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          195:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          196:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          197:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          198:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          199:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          200:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          201:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          202:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          203:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          204:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          205:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          206:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          207:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          208:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          209:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          210:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          211:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          212:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          213:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          214:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          215:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          216:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          217:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          218:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          219:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          220:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          221:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          222:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          223:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          224:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          225:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          226:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          227:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          228:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'EST':
        {
          0:
              {
                'ts': -1633280400,
                'time': '1918-03-31T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          1:
              {
                'ts': -1615140000,
                'time': '1918-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -1601830800,
                'time': '1919-03-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          3:
              {
                'ts': -1583690400,
                'time': '1919-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -1570381200,
                'time': '1920-03-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          5:
              {
                'ts': -1551636000,
                'time': '1920-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -1536512400,
                'time': '1921-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          7:
              {
                'ts': -1523210400,
                'time': '1921-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': -1504458000,
                'time': '1922-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          9:
              {
                'ts': -1491760800,
                'time': '1922-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': -1473008400,
                'time': '1923-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          11:
              {
                'ts': -1459706400,
                'time': '1923-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': -1441558800,
                'time': '1924-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          13:
              {
                'ts': -1428256800,
                'time': '1924-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': -1410109200,
                'time': '1925-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          15:
              {
                'ts': -1396807200,
                'time': '1925-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': -1378659600,
                'time': '1926-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          17:
              {
                'ts': -1365357600,
                'time': '1926-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': -1347210000,
                'time': '1927-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          19:
              {
                'ts': -1333908000,
                'time': '1927-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': -1315155600,
                'time': '1928-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          21:
              {
                'ts': -1301853600,
                'time': '1928-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': -1283706000,
                'time': '1929-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          23:
              {
                'ts': -1270404000,
                'time': '1929-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': -1252256400,
                'time': '1930-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          25:
              {
                'ts': -1238954400,
                'time': '1930-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': -1220806800,
                'time': '1931-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          27:
              {
                'ts': -1207504800,
                'time': '1931-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': -1189357200,
                'time': '1932-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          29:
              {
                'ts': -1176055200,
                'time': '1932-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': -1157302800,
                'time': '1933-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': -1144605600,
                'time': '1933-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': -1125853200,
                'time': '1934-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': -1112551200,
                'time': '1934-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': -1094403600,
                'time': '1935-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': -1081101600,
                'time': '1935-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': -1062954000,
                'time': '1936-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': -1049652000,
                'time': '1936-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': -1031504400,
                'time': '1937-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': -1018202400,
                'time': '1937-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': -1000054800,
                'time': '1938-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': -986752800,
                'time': '1938-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': -968000400,
                'time': '1939-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': -955303200,
                'time': '1939-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': -936550800,
                'time': '1940-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': -923248800,
                'time': '1940-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': -905101200,
                'time': '1941-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': -891799200,
                'time': '1941-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': -880218000,
                'time': '1942-02-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EWT'
              },
          49:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EPT'
              },
          50:
              {
                'ts': -765396000,
                'time': '1945-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          51:
              {
                'ts': -747248400,
                'time': '1946-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          52:
              {
                'ts': -733946400,
                'time': '1946-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          53:
              {
                'ts': -715798800,
                'time': '1947-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          54:
              {
                'ts': -702496800,
                'time': '1947-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          55:
              {
                'ts': -684349200,
                'time': '1948-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          56:
              {
                'ts': -671047200,
                'time': '1948-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          57:
              {
                'ts': -652899600,
                'time': '1949-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          58:
              {
                'ts': -639597600,
                'time': '1949-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          59:
              {
                'ts': -620845200,
                'time': '1950-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          60:
              {
                'ts': -608148000,
                'time': '1950-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          61:
              {
                'ts': -589395600,
                'time': '1951-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          62:
              {
                'ts': -576093600,
                'time': '1951-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          63:
              {
                'ts': -557946000,
                'time': '1952-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          64:
              {
                'ts': -544644000,
                'time': '1952-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          65:
              {
                'ts': -526496400,
                'time': '1953-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          66:
              {
                'ts': -513194400,
                'time': '1953-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          67:
              {
                'ts': -495046800,
                'time': '1954-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          68:
              {
                'ts': -481744800,
                'time': '1954-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          69:
              {
                'ts': -463597200,
                'time': '1955-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          70:
              {
                'ts': -447271200,
                'time': '1955-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          71:
              {
                'ts': -431542800,
                'time': '1956-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          72:
              {
                'ts': -415821600,
                'time': '1956-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': -400093200,
                'time': '1957-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': -384372000,
                'time': '1957-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': -368643600,
                'time': '1958-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': -352922400,
                'time': '1958-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': -337194000,
                'time': '1959-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': -321472800,
                'time': '1959-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': -305744400,
                'time': '1960-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': -289418400,
                'time': '1960-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': -273690000,
                'time': '1961-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': -257968800,
                'time': '1961-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': -242240400,
                'time': '1962-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': -226519200,
                'time': '1962-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': -210790800,
                'time': '1963-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': -195069600,
                'time': '1963-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': -179341200,
                'time': '1964-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': -163620000,
                'time': '1964-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': -147891600,
                'time': '1965-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': -131565600,
                'time': '1965-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': -116442000,
                'time': '1966-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': -100116000,
                'time': '1966-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': -84387600,
                'time': '1967-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': -68666400,
                'time': '1967-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': -52938000,
                'time': '1968-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': -37216800,
                'time': '1968-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 126687600,
                'time': '1974-01-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 162370800,
                'time': '1975-02-23T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          116:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          118:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          120:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          122:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          124:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          126:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          128:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          130:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          132:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          134:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          136:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          138:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          140:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          141:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          142:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          143:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          144:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          145:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          146:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          147:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          148:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          149:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          150:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          151:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          152:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          153:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          154:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          155:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          156:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          157:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          158:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          159:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          160:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          161:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          162:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          163:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          164:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          165:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          166:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          167:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          168:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          169:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          170:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          171:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          172:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          173:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          174:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          175:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          176:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          177:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          178:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          179:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          180:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          181:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          182:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          183:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          184:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          185:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          186:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          187:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          188:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          189:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          190:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          191:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          192:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          193:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          194:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          195:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          196:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          197:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          198:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          199:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          200:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          201:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          202:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          203:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          204:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          205:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          206:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          207:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          208:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          209:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          210:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          211:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          212:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          213:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          214:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          215:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          216:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          217:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          218:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          219:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          220:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          221:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          222:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          223:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          224:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          225:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          226:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          227:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          228:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          229:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          230:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          231:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          232:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          233:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          234:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'EST5EDT':
        {
          0:
              {
                'ts': -1633280400,
                'time': '1918-03-31T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          1:
              {
                'ts': -1615140000,
                'time': '1918-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -1601830800,
                'time': '1919-03-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          3:
              {
                'ts': -1583690400,
                'time': '1919-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -880218000,
                'time': '1942-02-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EPT'
              },
          6:
              {
                'ts': -765396000,
                'time': '1945-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -84387600,
                'time': '1967-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          8:
              {
                'ts': -68666400,
                'time': '1967-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          9:
              {
                'ts': -52938000,
                'time': '1968-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          10:
              {
                'ts': -37216800,
                'time': '1968-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          11:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          12:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          14:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          16:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          18:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          20:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 126687600,
                'time': '1974-01-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          22:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 162370800,
                'time': '1975-02-23T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          24:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          26:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          28:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          30:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          32:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          34:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          36:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          38:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          40:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          42:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          44:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          46:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          48:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          50:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          52:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          54:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          56:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          58:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          60:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          62:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          64:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          66:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          68:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          70:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          72:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          116:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          118:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          120:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          122:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          124:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          126:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          128:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          130:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          132:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          134:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          136:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          138:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          140:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          141:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          142:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          143:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          144:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          145:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          146:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          147:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          148:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'Etc/GMT':
        {
        },
    'Etc/GMT+0':
        {
        },
    'Etc/GMT+1':
        {
        },
    'Etc/GMT+10':
        {
        },
    'Etc/GMT+11':
        {
        },
    'Etc/GMT+12':
        {
        },
    'Etc/GMT+2':
        {
        },
    'Etc/GMT+3':
        {
        },
    'Etc/GMT+4':
        {
        },
    'Etc/GMT+5':
        {
        },
    'Etc/GMT+6':
        {
        },
    'Etc/GMT+7':
        {
        },
    'Etc/GMT+8':
        {
        },
    'Etc/GMT+9':
        {
        },
    'Etc/GMT-0':
        {
        },
    'Etc/GMT-1':
        {
        },
    'Etc/GMT-10':
        {
        },
    'Etc/GMT-11':
        {
        },
    'Etc/GMT-12':
        {
        },
    'Etc/GMT-13':
        {
        },
    'Etc/GMT-14':
        {
        },
    'Etc/GMT-2':
        {
        },
    'Etc/GMT-3':
        {
        },
    'Etc/GMT-4':
        {
        },
    'Etc/GMT-5':
        {
        },
    'Etc/GMT-6':
        {
        },
    'Etc/GMT-7':
        {
        },
    'Etc/GMT-8':
        {
        },
    'Etc/GMT-9':
        {
        },
    'Etc/GMT0':
        {
        },
    'Etc/Greenwich':
        {
        },
    'Etc/UCT':
        {
        },
    'Etc/Universal':
        {
        },
    'Etc/UTC':
        {
        },
    'Etc/Zulu':
        {
        },
    'Europe/Amsterdam':
        {
          0:
              {
                'ts': -1693700372,
                'time': '1916-04-30T23:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          1:
              {
                'ts': -1680484772,
                'time': '1916-09-30T22:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          2:
              {
                'ts': -1663453172,
                'time': '1917-04-16T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          3:
              {
                'ts': -1650147572,
                'time': '1917-09-17T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          4:
              {
                'ts': -1633213172,
                'time': '1918-04-01T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          5:
              {
                'ts': -1617488372,
                'time': '1918-09-30T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          6:
              {
                'ts': -1601158772,
                'time': '1919-04-07T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          7:
              {
                'ts': -1586038772,
                'time': '1919-09-29T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          8:
              {
                'ts': -1569709172,
                'time': '1920-04-05T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          9:
              {
                'ts': -1554589172,
                'time': '1920-09-27T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          10:
              {
                'ts': -1538259572,
                'time': '1921-04-04T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          11:
              {
                'ts': -1523139572,
                'time': '1921-09-26T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          12:
              {
                'ts': -1507501172,
                'time': '1922-03-26T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          13:
              {
                'ts': -1490566772,
                'time': '1922-10-08T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          14:
              {
                'ts': -1470176372,
                'time': '1923-06-01T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          15:
              {
                'ts': -1459117172,
                'time': '1923-10-07T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          16:
              {
                'ts': -1443997172,
                'time': '1924-03-30T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          17:
              {
                'ts': -1427667572,
                'time': '1924-10-05T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          18:
              {
                'ts': -1406672372,
                'time': '1925-06-05T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          19:
              {
                'ts': -1396217972,
                'time': '1925-10-04T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          20:
              {
                'ts': -1376950772,
                'time': '1926-05-15T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          21:
              {
                'ts': -1364768372,
                'time': '1926-10-03T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          22:
              {
                'ts': -1345414772,
                'time': '1927-05-15T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          23:
              {
                'ts': -1333318772,
                'time': '1927-10-02T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          24:
              {
                'ts': -1313792372,
                'time': '1928-05-15T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          25:
              {
                'ts': -1301264372,
                'time': '1928-10-07T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          26:
              {
                'ts': -1282256372,
                'time': '1929-05-15T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          27:
              {
                'ts': -1269814772,
                'time': '1929-10-06T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          28:
              {
                'ts': -1250720372,
                'time': '1930-05-15T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          29:
              {
                'ts': -1238365172,
                'time': '1930-10-05T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          30:
              {
                'ts': -1219184372,
                'time': '1931-05-15T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          31:
              {
                'ts': -1206915572,
                'time': '1931-10-04T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          32:
              {
                'ts': -1186957172,
                'time': '1932-05-22T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          33:
              {
                'ts': -1175465972,
                'time': '1932-10-02T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          34:
              {
                'ts': -1156025972,
                'time': '1933-05-15T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          35:
              {
                'ts': -1143411572,
                'time': '1933-10-08T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          36:
              {
                'ts': -1124489972,
                'time': '1934-05-15T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          37:
              {
                'ts': -1111961972,
                'time': '1934-10-07T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          38:
              {
                'ts': -1092953972,
                'time': '1935-05-15T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          39:
              {
                'ts': -1080512372,
                'time': '1935-10-06T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          40:
              {
                'ts': -1061331572,
                'time': '1936-05-15T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          41:
              {
                'ts': -1049062772,
                'time': '1936-10-04T01:40:28+0000',
                'offset': 1172,
                'isdst': false,
                'abbr': 'AMT'
              },
          42:
              {
                'ts': -1029190772,
                'time': '1937-05-22T01:40:28+0000',
                'offset': 4772,
                'isdst': true,
                'abbr': 'NST'
              },
          43:
              {
                'ts': -1025745572,
                'time': '1937-06-30T22:40:28+0000',
                'offset': 4800,
                'isdst': true,
                'abbr': 'NEST'
              },
          44:
              {
                'ts': -1017613200,
                'time': '1937-10-03T01:40:00+0000',
                'offset': 1200,
                'isdst': false,
                'abbr': 'NET'
              },
          45:
              {
                'ts': -998259600,
                'time': '1938-05-15T01:40:00+0000',
                'offset': 4800,
                'isdst': true,
                'abbr': 'NEST'
              },
          46:
              {
                'ts': -986163600,
                'time': '1938-10-02T01:40:00+0000',
                'offset': 1200,
                'isdst': false,
                'abbr': 'NET'
              },
          47:
              {
                'ts': -966723600,
                'time': '1939-05-15T01:40:00+0000',
                'offset': 4800,
                'isdst': true,
                'abbr': 'NEST'
              },
          48:
              {
                'ts': -954109200,
                'time': '1939-10-08T01:40:00+0000',
                'offset': 1200,
                'isdst': false,
                'abbr': 'NET'
              },
          49:
              {
                'ts': -935022000,
                'time': '1940-05-15T23:40:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': -766623600,
                'time': '1945-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 220921200,
                'time': '1976-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': 228877200,
                'time': '1977-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': 243997200,
                'time': '1977-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 260326800,
                'time': '1978-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 276051600,
                'time': '1978-10-01T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 291776400,
                'time': '1979-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          67:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          68:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          69:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          70:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          71:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          72:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          73:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          74:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          75:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          76:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          77:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          78:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          79:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          80:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          81:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          82:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          83:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          84:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          85:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          86:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          87:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          88:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          89:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          90:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          91:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          92:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          93:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          94:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          95:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          96:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          97:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          99:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          100:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          101:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          102:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          103:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          104:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          105:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          106:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          107:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          108:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          109:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          110:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          111:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          112:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          113:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          114:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          115:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          116:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          117:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          118:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          119:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          120:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          121:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          122:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          123:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          124:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          125:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          126:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          127:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          128:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          129:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          130:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          131:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          132:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          133:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          134:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          135:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          136:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          137:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          138:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          139:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          140:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          141:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          142:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          143:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          144:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          145:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          146:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          147:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          148:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          149:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          150:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          151:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          152:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          153:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          154:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          155:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          156:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          157:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          158:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          159:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          160:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          161:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          162:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          163:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          164:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          165:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          166:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          167:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          168:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          169:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          170:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          171:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          172:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          173:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          174:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          175:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          176:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          177:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          178:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          179:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Andorra':
        {
          0:
              {
                'ts': -733881600,
                'time': '1946-09-30T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          1:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          2:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          3:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          4:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          5:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          6:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          7:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          8:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Athens':
        {
          0:
              {
                'ts': -1686101632,
                'time': '1916-07-27T22:26:08+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -1182996000,
                'time': '1932-07-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          2:
              {
                'ts': -1178161200,
                'time': '1932-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': -906861600,
                'time': '1941-04-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          4:
              {
                'ts': -904878000,
                'time': '1941-04-29T21:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -844477200,
                'time': '1943-03-29T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -828237600,
                'time': '1943-10-03T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -812422800,
                'time': '1944-04-03T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': -552362400,
                'time': '1952-06-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          10:
              {
                'ts': -541652400,
                'time': '1952-11-01T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          11:
              {
                'ts': 166485600,
                'time': '1975-04-11T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          12:
              {
                'ts': 186184800,
                'time': '1975-11-25T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': 198028800,
                'time': '1976-04-11T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          14:
              {
                'ts': 213753600,
                'time': '1976-10-10T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          15:
              {
                'ts': 228873600,
                'time': '1977-04-03T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          16:
              {
                'ts': 244080000,
                'time': '1977-09-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          17:
              {
                'ts': 260323200,
                'time': '1978-04-02T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          18:
              {
                'ts': 275446800,
                'time': '1978-09-24T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          19:
              {
                'ts': 291798000,
                'time': '1979-04-01T07:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          20:
              {
                'ts': 307407600,
                'time': '1979-09-28T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          21:
              {
                'ts': 323388000,
                'time': '1980-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          22:
              {
                'ts': 338936400,
                'time': '1980-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          23:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          24:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          25:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          26:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          121:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          122:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          123:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          124:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          125:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          126:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          127:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          128:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          129:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          130:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          131:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          132:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          133:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          134:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          135:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          136:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Belfast':
        {
          0:
              {
                'ts': -1691964000,
                'time': '1916-05-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          1:
              {
                'ts': -1680472800,
                'time': '1916-10-01T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          2:
              {
                'ts': -1664143200,
                'time': '1917-04-08T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          3:
              {
                'ts': -1650146400,
                'time': '1917-09-17T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          4:
              {
                'ts': -1633903200,
                'time': '1918-03-24T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          5:
              {
                'ts': -1617487200,
                'time': '1918-09-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          6:
              {
                'ts': -1601848800,
                'time': '1919-03-30T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          7:
              {
                'ts': -1586037600,
                'time': '1919-09-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          8:
              {
                'ts': -1570399200,
                'time': '1920-03-28T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          9:
              {
                'ts': -1552168800,
                'time': '1920-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          10:
              {
                'ts': -1538344800,
                'time': '1921-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          11:
              {
                'ts': -1522533600,
                'time': '1921-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          12:
              {
                'ts': -1507500000,
                'time': '1922-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          13:
              {
                'ts': -1490565600,
                'time': '1922-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          14:
              {
                'ts': -1473631200,
                'time': '1923-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          15:
              {
                'ts': -1460930400,
                'time': '1923-09-16T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          16:
              {
                'ts': -1442786400,
                'time': '1924-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          17:
              {
                'ts': -1428876000,
                'time': '1924-09-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          18:
              {
                'ts': -1410732000,
                'time': '1925-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          19:
              {
                'ts': -1396216800,
                'time': '1925-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          20:
              {
                'ts': -1379282400,
                'time': '1926-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          21:
              {
                'ts': -1364767200,
                'time': '1926-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          22:
              {
                'ts': -1348437600,
                'time': '1927-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          23:
              {
                'ts': -1333317600,
                'time': '1927-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          24:
              {
                'ts': -1315778400,
                'time': '1928-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          25:
              {
                'ts': -1301263200,
                'time': '1928-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          26:
              {
                'ts': -1284328800,
                'time': '1929-04-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          27:
              {
                'ts': -1269813600,
                'time': '1929-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          28:
              {
                'ts': -1253484000,
                'time': '1930-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          29:
              {
                'ts': -1238364000,
                'time': '1930-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          30:
              {
                'ts': -1221429600,
                'time': '1931-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          31:
              {
                'ts': -1206914400,
                'time': '1931-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          32:
              {
                'ts': -1189980000,
                'time': '1932-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          33:
              {
                'ts': -1175464800,
                'time': '1932-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          34:
              {
                'ts': -1159135200,
                'time': '1933-04-09T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          35:
              {
                'ts': -1143410400,
                'time': '1933-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          36:
              {
                'ts': -1126476000,
                'time': '1934-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          37:
              {
                'ts': -1111960800,
                'time': '1934-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          38:
              {
                'ts': -1095631200,
                'time': '1935-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          39:
              {
                'ts': -1080511200,
                'time': '1935-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          40:
              {
                'ts': -1063576800,
                'time': '1936-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          41:
              {
                'ts': -1049061600,
                'time': '1936-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          42:
              {
                'ts': -1032127200,
                'time': '1937-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          43:
              {
                'ts': -1017612000,
                'time': '1937-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          44:
              {
                'ts': -1001282400,
                'time': '1938-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          45:
              {
                'ts': -986162400,
                'time': '1938-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          46:
              {
                'ts': -969228000,
                'time': '1939-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          47:
              {
                'ts': -950479200,
                'time': '1939-11-19T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          48:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          49:
              {
                'ts': -904518000,
                'time': '1941-05-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          50:
              {
                'ts': -896050800,
                'time': '1941-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          51:
              {
                'ts': -875487600,
                'time': '1942-04-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          52:
              {
                'ts': -864601200,
                'time': '1942-08-09T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          53:
              {
                'ts': -844038000,
                'time': '1943-04-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          54:
              {
                'ts': -832546800,
                'time': '1943-08-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          55:
              {
                'ts': -812588400,
                'time': '1944-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          56:
              {
                'ts': -798073200,
                'time': '1944-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          57:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          58:
              {
                'ts': -772066800,
                'time': '1945-07-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          59:
              {
                'ts': -764805600,
                'time': '1945-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          60:
              {
                'ts': -748476000,
                'time': '1946-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          61:
              {
                'ts': -733356000,
                'time': '1946-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          62:
              {
                'ts': -719445600,
                'time': '1947-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          63:
              {
                'ts': -717030000,
                'time': '1947-04-13T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          64:
              {
                'ts': -706748400,
                'time': '1947-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          65:
              {
                'ts': -699487200,
                'time': '1947-11-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          66:
              {
                'ts': -687996000,
                'time': '1948-03-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          67:
              {
                'ts': -668037600,
                'time': '1948-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          68:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          69:
              {
                'ts': -636588000,
                'time': '1949-10-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          70:
              {
                'ts': -622072800,
                'time': '1950-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          71:
              {
                'ts': -605743200,
                'time': '1950-10-22T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          72:
              {
                'ts': -590623200,
                'time': '1951-04-15T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          73:
              {
                'ts': -574293600,
                'time': '1951-10-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          74:
              {
                'ts': -558568800,
                'time': '1952-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          75:
              {
                'ts': -542239200,
                'time': '1952-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          76:
              {
                'ts': -527119200,
                'time': '1953-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          77:
              {
                'ts': -512604000,
                'time': '1953-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          78:
              {
                'ts': -496274400,
                'time': '1954-04-11T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          79:
              {
                'ts': -481154400,
                'time': '1954-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          80:
              {
                'ts': -464220000,
                'time': '1955-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          81:
              {
                'ts': -449704800,
                'time': '1955-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          82:
              {
                'ts': -432165600,
                'time': '1956-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          83:
              {
                'ts': -417650400,
                'time': '1956-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          84:
              {
                'ts': -401320800,
                'time': '1957-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          85:
              {
                'ts': -386200800,
                'time': '1957-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          86:
              {
                'ts': -369266400,
                'time': '1958-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          87:
              {
                'ts': -354751200,
                'time': '1958-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          88:
              {
                'ts': -337816800,
                'time': '1959-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          89:
              {
                'ts': -323301600,
                'time': '1959-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          90:
              {
                'ts': -306972000,
                'time': '1960-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          91:
              {
                'ts': -291852000,
                'time': '1960-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          92:
              {
                'ts': -276732000,
                'time': '1961-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          93:
              {
                'ts': -257983200,
                'time': '1961-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          94:
              {
                'ts': -245282400,
                'time': '1962-03-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          95:
              {
                'ts': -226533600,
                'time': '1962-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          96:
              {
                'ts': -213228000,
                'time': '1963-03-31T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          97:
              {
                'ts': -195084000,
                'time': '1963-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          98:
              {
                'ts': -182383200,
                'time': '1964-03-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          99:
              {
                'ts': -163634400,
                'time': '1964-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          100:
              {
                'ts': -150933600,
                'time': '1965-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          101:
              {
                'ts': -132184800,
                'time': '1965-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          102:
              {
                'ts': -119484000,
                'time': '1966-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          103:
              {
                'ts': -100735200,
                'time': '1966-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          104:
              {
                'ts': -88034400,
                'time': '1967-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          105:
              {
                'ts': -68680800,
                'time': '1967-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          106:
              {
                'ts': -59004000,
                'time': '1968-02-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          107:
              {
                'ts': -37242000,
                'time': '1968-10-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'BST'
              },
          108:
              {
                'ts': 57722400,
                'time': '1971-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          109:
              {
                'ts': 69818400,
                'time': '1972-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          110:
              {
                'ts': 89172000,
                'time': '1972-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          111:
              {
                'ts': 101268000,
                'time': '1973-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          112:
              {
                'ts': 120621600,
                'time': '1973-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          113:
              {
                'ts': 132717600,
                'time': '1974-03-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          114:
              {
                'ts': 152071200,
                'time': '1974-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          115:
              {
                'ts': 164167200,
                'time': '1975-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          116:
              {
                'ts': 183520800,
                'time': '1975-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          117:
              {
                'ts': 196221600,
                'time': '1976-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          118:
              {
                'ts': 214970400,
                'time': '1976-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          119:
              {
                'ts': 227671200,
                'time': '1977-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          120:
              {
                'ts': 246420000,
                'time': '1977-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          121:
              {
                'ts': 259120800,
                'time': '1978-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          122:
              {
                'ts': 278474400,
                'time': '1978-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          123:
              {
                'ts': 290570400,
                'time': '1979-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          124:
              {
                'ts': 309924000,
                'time': '1979-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          125:
              {
                'ts': 322020000,
                'time': '1980-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          126:
              {
                'ts': 341373600,
                'time': '1980-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          127:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          128:
              {
                'ts': 372819600,
                'time': '1981-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          129:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          130:
              {
                'ts': 404269200,
                'time': '1982-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          131:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          132:
              {
                'ts': 435718800,
                'time': '1983-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          133:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          134:
              {
                'ts': 467773200,
                'time': '1984-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          135:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          136:
              {
                'ts': 499222800,
                'time': '1985-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          137:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          138:
              {
                'ts': 530672400,
                'time': '1986-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          139:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          140:
              {
                'ts': 562122000,
                'time': '1987-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          141:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          142:
              {
                'ts': 593571600,
                'time': '1988-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          143:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          144:
              {
                'ts': 625626000,
                'time': '1989-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          145:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          146:
              {
                'ts': 657075600,
                'time': '1990-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          147:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          148:
              {
                'ts': 688525200,
                'time': '1991-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          149:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          150:
              {
                'ts': 719974800,
                'time': '1992-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          151:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          152:
              {
                'ts': 751424400,
                'time': '1993-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          153:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          154:
              {
                'ts': 782874000,
                'time': '1994-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          155:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          156:
              {
                'ts': 814323600,
                'time': '1995-10-22T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          157:
              {
                'ts': 820454400,
                'time': '1996-01-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          158:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          159:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          160:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          161:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          162:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          163:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          164:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          165:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          166:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          167:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          168:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          169:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          170:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          171:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          172:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          173:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          174:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          175:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          176:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          177:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          178:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          179:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          180:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          181:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          182:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          183:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          184:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          185:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          186:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          187:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          188:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          189:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          190:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          191:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          192:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          193:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          194:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          195:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          196:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          197:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          198:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          199:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          200:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          201:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          202:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          203:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          204:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          205:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          206:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          207:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          208:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          209:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          210:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          211:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          212:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          213:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          214:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          215:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          216:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          217:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          218:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          219:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          220:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          221:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          222:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          223:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          224:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          225:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          226:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          227:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          228:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          229:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          230:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          231:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          232:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          233:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          234:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          235:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          236:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          237:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          238:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          239:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          240:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          241:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Europe/Belgrade':
        {
          0:
              {
                'ts': -905824800,
                'time': '1941-04-18T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -777942000,
                'time': '1945-05-08T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -766623600,
                'time': '1945-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': 407199600,
                'time': '1982-11-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Berlin':
        {
          0:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -1663455600,
                'time': '1917-04-16T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -1650150000,
                'time': '1917-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -1632006000,
                'time': '1918-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -1618700400,
                'time': '1918-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -938905200,
                'time': '1940-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -776563200,
                'time': '1945-05-24T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CEMT'
              },
          14:
              {
                'ts': -765936000,
                'time': '1945-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -761180400,
                'time': '1945-11-18T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': -748479600,
                'time': '1946-04-14T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          17:
              {
                'ts': -733273200,
                'time': '1946-10-07T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': -717634800,
                'time': '1947-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': -714610800,
                'time': '1947-05-11T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CEMT'
              },
          20:
              {
                'ts': -710380800,
                'time': '1947-06-29T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          21:
              {
                'ts': -701910000,
                'time': '1947-10-05T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': -684975600,
                'time': '1948-04-18T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          23:
              {
                'ts': -670460400,
                'time': '1948-10-03T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          24:
              {
                'ts': -654130800,
                'time': '1949-04-10T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          25:
              {
                'ts': -639010800,
                'time': '1949-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          26:
              {
                'ts': 315529200,
                'time': '1979-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          141:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          142:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Bratislava':
        {
          0:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -1663455600,
                'time': '1917-04-16T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -1650150000,
                'time': '1917-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -1632006000,
                'time': '1918-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -1618700400,
                'time': '1918-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -938905200,
                'time': '1940-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -798073200,
                'time': '1944-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -780534000,
                'time': '1945-04-08T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -761180400,
                'time': '1945-11-18T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': -746578800,
                'time': '1946-05-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -733359600,
                'time': '1946-10-06T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': -716425200,
                'time': '1947-04-20T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          17:
              {
                'ts': -701910000,
                'time': '1947-10-05T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': -684975600,
                'time': '1948-04-18T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': -670460400,
                'time': '1948-10-03T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          20:
              {
                'ts': -654217200,
                'time': '1949-04-09T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          21:
              {
                'ts': -639010800,
                'time': '1949-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': 283993200,
                'time': '1978-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 291776400,
                'time': '1979-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Brussels':
        {
          0:
              {
                'ts': -1740355200,
                'time': '1914-11-08T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          1:
              {
                'ts': -1693702800,
                'time': '1916-04-30T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          2:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          3:
              {
                'ts': -1663455600,
                'time': '1917-04-16T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          4:
              {
                'ts': -1650150000,
                'time': '1917-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          5:
              {
                'ts': -1632006000,
                'time': '1918-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          6:
              {
                'ts': -1618700400,
                'time': '1918-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          7:
              {
                'ts': -1613826000,
                'time': '1918-11-11T11:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          8:
              {
                'ts': -1604278800,
                'time': '1919-03-01T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          9:
              {
                'ts': -1585530000,
                'time': '1919-10-04T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          10:
              {
                'ts': -1574038800,
                'time': '1920-02-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          11:
              {
                'ts': -1552266000,
                'time': '1920-10-23T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          12:
              {
                'ts': -1539997200,
                'time': '1921-03-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          13:
              {
                'ts': -1520557200,
                'time': '1921-10-25T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          14:
              {
                'ts': -1507510800,
                'time': '1922-03-25T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          15:
              {
                'ts': -1490576400,
                'time': '1922-10-07T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          16:
              {
                'ts': -1473642000,
                'time': '1923-04-21T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          17:
              {
                'ts': -1459126800,
                'time': '1923-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          18:
              {
                'ts': -1444006800,
                'time': '1924-03-29T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          19:
              {
                'ts': -1427677200,
                'time': '1924-10-04T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          20:
              {
                'ts': -1411952400,
                'time': '1925-04-04T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          21:
              {
                'ts': -1396227600,
                'time': '1925-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          22:
              {
                'ts': -1379293200,
                'time': '1926-04-17T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          23:
              {
                'ts': -1364778000,
                'time': '1926-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          24:
              {
                'ts': -1348448400,
                'time': '1927-04-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          25:
              {
                'ts': -1333328400,
                'time': '1927-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          26:
              {
                'ts': -1316394000,
                'time': '1928-04-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          27:
              {
                'ts': -1301263200,
                'time': '1928-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          28:
              {
                'ts': -1284328800,
                'time': '1929-04-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          29:
              {
                'ts': -1269813600,
                'time': '1929-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          30:
              {
                'ts': -1253484000,
                'time': '1930-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          31:
              {
                'ts': -1238364000,
                'time': '1930-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          32:
              {
                'ts': -1221429600,
                'time': '1931-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          33:
              {
                'ts': -1206914400,
                'time': '1931-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          34:
              {
                'ts': -1191189600,
                'time': '1932-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          35:
              {
                'ts': -1175464800,
                'time': '1932-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          36:
              {
                'ts': -1160344800,
                'time': '1933-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          37:
              {
                'ts': -1143410400,
                'time': '1933-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          38:
              {
                'ts': -1127685600,
                'time': '1934-04-08T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          39:
              {
                'ts': -1111960800,
                'time': '1934-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          40:
              {
                'ts': -1096840800,
                'time': '1935-03-31T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          41:
              {
                'ts': -1080511200,
                'time': '1935-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          42:
              {
                'ts': -1063576800,
                'time': '1936-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          43:
              {
                'ts': -1049061600,
                'time': '1936-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          44:
              {
                'ts': -1033336800,
                'time': '1937-04-04T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          45:
              {
                'ts': -1017612000,
                'time': '1937-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          46:
              {
                'ts': -1002492000,
                'time': '1938-03-27T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          47:
              {
                'ts': -986162400,
                'time': '1938-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          48:
              {
                'ts': -969228000,
                'time': '1939-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          49:
              {
                'ts': -950479200,
                'time': '1939-11-19T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          50:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          51:
              {
                'ts': -934668000,
                'time': '1940-05-20T02:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': -799293600,
                'time': '1944-09-02T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          57:
              {
                'ts': -798073200,
                'time': '1944-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': -766623600,
                'time': '1945-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': -745455600,
                'time': '1946-05-19T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': -733273200,
                'time': '1946-10-07T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 220921200,
                'time': '1976-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 228877200,
                'time': '1977-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 243997200,
                'time': '1977-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 260326800,
                'time': '1978-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 276051600,
                'time': '1978-10-01T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 291776400,
                'time': '1979-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          141:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          142:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          143:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          144:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          145:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          146:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          147:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          148:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          149:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          150:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          151:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          152:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          153:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          154:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          155:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          156:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          157:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          158:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          159:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          160:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          161:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          162:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          163:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          164:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          165:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          166:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          167:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          168:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          169:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          170:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          171:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          172:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          173:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          174:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          175:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          176:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          177:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          178:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          179:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          180:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          181:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          182:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          183:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          184:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Bucharest':
        {
          0:
              {
                'ts': -1213148664,
                'time': '1931-07-23T22:15:36+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -1187056800,
                'time': '1932-05-20T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          2:
              {
                'ts': -1175479200,
                'time': '1932-10-01T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': -1159754400,
                'time': '1933-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          4:
              {
                'ts': -1144029600,
                'time': '1933-09-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': -1127700000,
                'time': '1934-04-07T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          6:
              {
                'ts': -1111975200,
                'time': '1934-10-06T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': -1096250400,
                'time': '1935-04-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': -1080525600,
                'time': '1935-10-05T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': -1064800800,
                'time': '1936-04-04T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          10:
              {
                'ts': -1049076000,
                'time': '1936-10-03T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          11:
              {
                'ts': -1033351200,
                'time': '1937-04-03T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          12:
              {
                'ts': -1017626400,
                'time': '1937-10-02T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': -1001901600,
                'time': '1938-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          14:
              {
                'ts': -986176800,
                'time': '1938-10-01T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          15:
              {
                'ts': -970452000,
                'time': '1939-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          16:
              {
                'ts': -954727200,
                'time': '1939-09-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          17:
              {
                'ts': 296604000,
                'time': '1979-05-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          18:
              {
                'ts': 307486800,
                'time': '1979-09-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          19:
              {
                'ts': 323816400,
                'time': '1980-04-05T21:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          20:
              {
                'ts': 338940000,
                'time': '1980-09-27T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          21:
              {
                'ts': 354672000,
                'time': '1981-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          22:
              {
                'ts': 370396800,
                'time': '1981-09-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          23:
              {
                'ts': 386121600,
                'time': '1982-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          24:
              {
                'ts': 401846400,
                'time': '1982-09-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          25:
              {
                'ts': 417571200,
                'time': '1983-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          26:
              {
                'ts': 433296000,
                'time': '1983-09-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': 449020800,
                'time': '1984-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': 465350400,
                'time': '1984-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 481075200,
                'time': '1985-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 496800000,
                'time': '1985-09-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 512524800,
                'time': '1986-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 528249600,
                'time': '1986-09-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 543974400,
                'time': '1987-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 559699200,
                'time': '1987-09-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 575424000,
                'time': '1988-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 591148800,
                'time': '1988-09-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 606873600,
                'time': '1989-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 622598400,
                'time': '1989-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 638323200,
                'time': '1990-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 654652800,
                'time': '1990-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 662680800,
                'time': '1990-12-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          42:
              {
                'ts': 670370400,
                'time': '1991-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          43:
              {
                'ts': 686095200,
                'time': '1991-09-28T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          44:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          45:
              {
                'ts': 717544800,
                'time': '1992-09-26T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          46:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          47:
              {
                'ts': 748994400,
                'time': '1993-09-25T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          48:
              {
                'ts': 757375200,
                'time': '1993-12-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 796168800,
                'time': '1995-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 811890000,
                'time': '1995-09-23T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 828223200,
                'time': '1996-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 846363600,
                'time': '1996-10-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          121:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          122:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          123:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          124:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          125:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          126:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          127:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          128:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          129:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          130:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          131:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          132:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          133:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          134:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          135:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          136:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Budapest':
        {
          0:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -1663455600,
                'time': '1917-04-16T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -1650150000,
                'time': '1917-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -1640998800,
                'time': '1917-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          5:
              {
                'ts': -1633212000,
                'time': '1918-04-01T02:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          6:
              {
                'ts': -1617577200,
                'time': '1918-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          7:
              {
                'ts': -1600466400,
                'time': '1919-04-15T02:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          8:
              {
                'ts': -1587250800,
                'time': '1919-09-15T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': -1569708000,
                'time': '1920-04-05T02:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': -1554332400,
                'time': '1920-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': -906937200,
                'time': '1941-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': -778471200,
                'time': '1945-05-01T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': -762487200,
                'time': '1945-11-02T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': -749689200,
                'time': '1946-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': -733359600,
                'time': '1946-10-06T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': -717634800,
                'time': '1947-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': -701910000,
                'time': '1947-10-05T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': -686185200,
                'time': '1948-04-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': -670460400,
                'time': '1948-10-03T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': -654130800,
                'time': '1949-04-10T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': -639010800,
                'time': '1949-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': -621990000,
                'time': '1950-04-17T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': -605660400,
                'time': '1950-10-23T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': -492656400,
                'time': '1954-05-22T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': -481168800,
                'time': '1954-10-02T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': -461120400,
                'time': '1955-05-22T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': -449632800,
                'time': '1955-10-02T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': -428547600,
                'time': '1956-06-02T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': -418269600,
                'time': '1956-09-29T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': -397094400,
                'time': '1957-06-02T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': -386809200,
                'time': '1957-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 323827200,
                'time': '1980-04-06T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          141:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          142:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          143:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          144:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          145:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          146:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          147:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          148:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          149:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          150:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          151:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          152:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Chisinau':
        {
          0:
              {
                'ts': -1637114100,
                'time': '1918-02-14T22:05:00+0000',
                'offset': 6264,
                'isdst': false,
                'abbr': 'BMT'
              },
          1:
              {
                'ts': -1213148664,
                'time': '1931-07-23T22:15:36+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          2:
              {
                'ts': -1187056800,
                'time': '1932-05-20T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          3:
              {
                'ts': -1175479200,
                'time': '1932-10-01T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          4:
              {
                'ts': -1159754400,
                'time': '1933-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          5:
              {
                'ts': -1144029600,
                'time': '1933-09-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          6:
              {
                'ts': -1127700000,
                'time': '1934-04-07T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          7:
              {
                'ts': -1111975200,
                'time': '1934-10-06T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          8:
              {
                'ts': -1096250400,
                'time': '1935-04-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          9:
              {
                'ts': -1080525600,
                'time': '1935-10-05T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          10:
              {
                'ts': -1064800800,
                'time': '1936-04-04T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          11:
              {
                'ts': -1049076000,
                'time': '1936-10-03T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          12:
              {
                'ts': -1033351200,
                'time': '1937-04-03T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          13:
              {
                'ts': -1017626400,
                'time': '1937-10-02T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          14:
              {
                'ts': -1001901600,
                'time': '1938-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          15:
              {
                'ts': -986176800,
                'time': '1938-10-01T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          16:
              {
                'ts': -970452000,
                'time': '1939-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          17:
              {
                'ts': -954727200,
                'time': '1939-09-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          18:
              {
                'ts': -927165600,
                'time': '1940-08-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          19:
              {
                'ts': -898138800,
                'time': '1941-07-16T21:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': -800157600,
                'time': '1944-08-23T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          25:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          26:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          27:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          28:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          29:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          30:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          31:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          32:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          33:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          34:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          35:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          36:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          37:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          38:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          39:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          40:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          41:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          42:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          43:
              {
                'ts': 631141200,
                'time': '1989-12-31T21:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          44:
              {
                'ts': 641941200,
                'time': '1990-05-05T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 670377600,
                'time': '1991-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 686102400,
                'time': '1991-09-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 694216800,
                'time': '1991-12-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          48:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          49:
              {
                'ts': 717541200,
                'time': '1992-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          50:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          51:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          52:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          53:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          54:
              {
                'ts': 796168800,
                'time': '1995-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          55:
              {
                'ts': 811890000,
                'time': '1995-09-23T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          56:
              {
                'ts': 828223200,
                'time': '1996-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          57:
              {
                'ts': 846363600,
                'time': '1996-10-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          58:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          59:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          60:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          61:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          62:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          63:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          64:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          65:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          66:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          67:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          68:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          69:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          70:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          71:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          72:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          73:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          74:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          75:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          76:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          77:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          78:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          79:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          80:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          81:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          82:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          83:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          84:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          85:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          86:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          87:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          88:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          89:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          90:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          91:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          92:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          93:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          94:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          95:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          96:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          97:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          98:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          99:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          100:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          101:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          102:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          103:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          104:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          105:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          106:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          107:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          108:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          109:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          110:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          111:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          112:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          113:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          114:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          115:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          116:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          117:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          118:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          119:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          120:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          121:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          122:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          123:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          124:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          125:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          126:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          127:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          128:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          129:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          130:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          131:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          132:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          133:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          134:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          135:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          136:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          137:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          138:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          139:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Copenhagen':
        {
          0:
              {
                'ts': -1692496800,
                'time': '1916-05-14T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680490800,
                'time': '1916-09-30T21:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -935110800,
                'time': '1940-05-14T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -769388400,
                'time': '1945-08-15T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -747010800,
                'time': '1946-05-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -736383600,
                'time': '1946-09-01T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -715215600,
                'time': '1947-05-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -706748400,
                'time': '1947-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': -683161200,
                'time': '1948-05-09T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -675298800,
                'time': '1948-08-08T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': 315529200,
                'time': '1979-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Dublin':
        {
          0:
              {
                'ts': -1691962479,
                'time': '1916-05-21T02:25:21+0000',
                'offset': 2079,
                'isdst': true,
                'abbr': 'IST'
              },
          1:
              {
                'ts': -1680471279,
                'time': '1916-10-01T02:25:21+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          2:
              {
                'ts': -1664143200,
                'time': '1917-04-08T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          3:
              {
                'ts': -1650146400,
                'time': '1917-09-17T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          4:
              {
                'ts': -1633903200,
                'time': '1918-03-24T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          5:
              {
                'ts': -1617487200,
                'time': '1918-09-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          6:
              {
                'ts': -1601848800,
                'time': '1919-03-30T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          7:
              {
                'ts': -1586037600,
                'time': '1919-09-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          8:
              {
                'ts': -1570399200,
                'time': '1920-03-28T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          9:
              {
                'ts': -1552168800,
                'time': '1920-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          10:
              {
                'ts': -1538344800,
                'time': '1921-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          11:
              {
                'ts': -1522533600,
                'time': '1921-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          12:
              {
                'ts': -1517011200,
                'time': '1921-12-06T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          13:
              {
                'ts': -1507500000,
                'time': '1922-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          14:
              {
                'ts': -1490565600,
                'time': '1922-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          15:
              {
                'ts': -1473631200,
                'time': '1923-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          16:
              {
                'ts': -1460930400,
                'time': '1923-09-16T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          17:
              {
                'ts': -1442786400,
                'time': '1924-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          18:
              {
                'ts': -1428876000,
                'time': '1924-09-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          19:
              {
                'ts': -1410732000,
                'time': '1925-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          20:
              {
                'ts': -1396216800,
                'time': '1925-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          21:
              {
                'ts': -1379282400,
                'time': '1926-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          22:
              {
                'ts': -1364767200,
                'time': '1926-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          23:
              {
                'ts': -1348437600,
                'time': '1927-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          24:
              {
                'ts': -1333317600,
                'time': '1927-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          25:
              {
                'ts': -1315778400,
                'time': '1928-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          26:
              {
                'ts': -1301263200,
                'time': '1928-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          27:
              {
                'ts': -1284328800,
                'time': '1929-04-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          28:
              {
                'ts': -1269813600,
                'time': '1929-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          29:
              {
                'ts': -1253484000,
                'time': '1930-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          30:
              {
                'ts': -1238364000,
                'time': '1930-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          31:
              {
                'ts': -1221429600,
                'time': '1931-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          32:
              {
                'ts': -1206914400,
                'time': '1931-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          33:
              {
                'ts': -1189980000,
                'time': '1932-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          34:
              {
                'ts': -1175464800,
                'time': '1932-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          35:
              {
                'ts': -1159135200,
                'time': '1933-04-09T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          36:
              {
                'ts': -1143410400,
                'time': '1933-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          37:
              {
                'ts': -1126476000,
                'time': '1934-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          38:
              {
                'ts': -1111960800,
                'time': '1934-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          39:
              {
                'ts': -1095631200,
                'time': '1935-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          40:
              {
                'ts': -1080511200,
                'time': '1935-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          41:
              {
                'ts': -1063576800,
                'time': '1936-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          42:
              {
                'ts': -1049061600,
                'time': '1936-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          43:
              {
                'ts': -1032127200,
                'time': '1937-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          44:
              {
                'ts': -1017612000,
                'time': '1937-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          45:
              {
                'ts': -1001282400,
                'time': '1938-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          46:
              {
                'ts': -986162400,
                'time': '1938-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          47:
              {
                'ts': -969228000,
                'time': '1939-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          48:
              {
                'ts': -950479200,
                'time': '1939-11-19T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          49:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          50:
              {
                'ts': -733359600,
                'time': '1946-10-06T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          51:
              {
                'ts': -719445600,
                'time': '1947-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          52:
              {
                'ts': -699490800,
                'time': '1947-11-02T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          53:
              {
                'ts': -684972000,
                'time': '1948-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          54:
              {
                'ts': -668037600,
                'time': '1948-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          55:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          56:
              {
                'ts': -636588000,
                'time': '1949-10-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          57:
              {
                'ts': -622072800,
                'time': '1950-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          58:
              {
                'ts': -605743200,
                'time': '1950-10-22T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          59:
              {
                'ts': -590623200,
                'time': '1951-04-15T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          60:
              {
                'ts': -574293600,
                'time': '1951-10-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          61:
              {
                'ts': -558568800,
                'time': '1952-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          62:
              {
                'ts': -542239200,
                'time': '1952-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          63:
              {
                'ts': -527119200,
                'time': '1953-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          64:
              {
                'ts': -512604000,
                'time': '1953-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          65:
              {
                'ts': -496274400,
                'time': '1954-04-11T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          66:
              {
                'ts': -481154400,
                'time': '1954-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          67:
              {
                'ts': -464220000,
                'time': '1955-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          68:
              {
                'ts': -449704800,
                'time': '1955-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          69:
              {
                'ts': -432165600,
                'time': '1956-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          70:
              {
                'ts': -417650400,
                'time': '1956-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          71:
              {
                'ts': -401320800,
                'time': '1957-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          72:
              {
                'ts': -386200800,
                'time': '1957-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          73:
              {
                'ts': -369266400,
                'time': '1958-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          74:
              {
                'ts': -354751200,
                'time': '1958-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          75:
              {
                'ts': -337816800,
                'time': '1959-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          76:
              {
                'ts': -323301600,
                'time': '1959-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          77:
              {
                'ts': -306972000,
                'time': '1960-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          78:
              {
                'ts': -291852000,
                'time': '1960-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          79:
              {
                'ts': -276732000,
                'time': '1961-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          80:
              {
                'ts': -257983200,
                'time': '1961-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          81:
              {
                'ts': -245282400,
                'time': '1962-03-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          82:
              {
                'ts': -226533600,
                'time': '1962-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          83:
              {
                'ts': -213228000,
                'time': '1963-03-31T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          84:
              {
                'ts': -195084000,
                'time': '1963-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          85:
              {
                'ts': -182383200,
                'time': '1964-03-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          86:
              {
                'ts': -163634400,
                'time': '1964-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          87:
              {
                'ts': -150933600,
                'time': '1965-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          88:
              {
                'ts': -132184800,
                'time': '1965-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          89:
              {
                'ts': -119484000,
                'time': '1966-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          90:
              {
                'ts': -100735200,
                'time': '1966-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          91:
              {
                'ts': -88034400,
                'time': '1967-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          92:
              {
                'ts': -68680800,
                'time': '1967-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          93:
              {
                'ts': -59004000,
                'time': '1968-02-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          94:
              {
                'ts': -37242000,
                'time': '1968-10-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'IST'
              },
          95:
              {
                'ts': 57722400,
                'time': '1971-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          96:
              {
                'ts': 69818400,
                'time': '1972-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          97:
              {
                'ts': 89172000,
                'time': '1972-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          98:
              {
                'ts': 101268000,
                'time': '1973-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          99:
              {
                'ts': 120621600,
                'time': '1973-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          100:
              {
                'ts': 132717600,
                'time': '1974-03-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          101:
              {
                'ts': 152071200,
                'time': '1974-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          102:
              {
                'ts': 164167200,
                'time': '1975-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          103:
              {
                'ts': 183520800,
                'time': '1975-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          104:
              {
                'ts': 196221600,
                'time': '1976-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          105:
              {
                'ts': 214970400,
                'time': '1976-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          106:
              {
                'ts': 227671200,
                'time': '1977-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          107:
              {
                'ts': 246420000,
                'time': '1977-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          108:
              {
                'ts': 259120800,
                'time': '1978-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          109:
              {
                'ts': 278474400,
                'time': '1978-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          110:
              {
                'ts': 290570400,
                'time': '1979-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          111:
              {
                'ts': 309924000,
                'time': '1979-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          112:
              {
                'ts': 322020000,
                'time': '1980-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          113:
              {
                'ts': 341373600,
                'time': '1980-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          114:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          115:
              {
                'ts': 372819600,
                'time': '1981-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          116:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          117:
              {
                'ts': 404269200,
                'time': '1982-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          118:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          119:
              {
                'ts': 435718800,
                'time': '1983-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          120:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          121:
              {
                'ts': 467773200,
                'time': '1984-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          122:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          123:
              {
                'ts': 499222800,
                'time': '1985-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          124:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          125:
              {
                'ts': 530672400,
                'time': '1986-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          126:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          127:
              {
                'ts': 562122000,
                'time': '1987-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          128:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          129:
              {
                'ts': 593571600,
                'time': '1988-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          130:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          131:
              {
                'ts': 625626000,
                'time': '1989-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          132:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          133:
              {
                'ts': 657075600,
                'time': '1990-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          134:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          135:
              {
                'ts': 688525200,
                'time': '1991-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          136:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          137:
              {
                'ts': 719974800,
                'time': '1992-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          138:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          139:
              {
                'ts': 751424400,
                'time': '1993-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          140:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          141:
              {
                'ts': 782874000,
                'time': '1994-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          142:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          143:
              {
                'ts': 814323600,
                'time': '1995-10-22T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          144:
              {
                'ts': 820454400,
                'time': '1996-01-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          145:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          146:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          147:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          148:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          149:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          150:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          151:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          152:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          153:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          154:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          155:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          156:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          157:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          158:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          159:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          160:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          161:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          162:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          163:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          164:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          165:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          166:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          167:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          168:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          169:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          170:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          171:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          172:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          173:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          174:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          175:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          176:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          177:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          178:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          179:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          180:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          181:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          182:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          183:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          184:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          185:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          186:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          187:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          188:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          189:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          190:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          191:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          192:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          193:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          194:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          195:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          196:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          197:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          198:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          199:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          200:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          201:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          202:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          203:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          204:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          205:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          206:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          207:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          208:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          209:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          210:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          211:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          212:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          213:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          214:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          215:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          216:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          217:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          218:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          219:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          220:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          221:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          222:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          223:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          224:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          225:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          226:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          227:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'IST'
              },
          228:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Europe/Gibraltar':
        {
          0:
              {
                'ts': -1691964000,
                'time': '1916-05-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          1:
              {
                'ts': -1680472800,
                'time': '1916-10-01T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          2:
              {
                'ts': -1664143200,
                'time': '1917-04-08T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          3:
              {
                'ts': -1650146400,
                'time': '1917-09-17T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          4:
              {
                'ts': -1633903200,
                'time': '1918-03-24T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          5:
              {
                'ts': -1617487200,
                'time': '1918-09-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          6:
              {
                'ts': -1601848800,
                'time': '1919-03-30T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          7:
              {
                'ts': -1586037600,
                'time': '1919-09-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          8:
              {
                'ts': -1570399200,
                'time': '1920-03-28T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          9:
              {
                'ts': -1552168800,
                'time': '1920-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          10:
              {
                'ts': -1538344800,
                'time': '1921-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          11:
              {
                'ts': -1522533600,
                'time': '1921-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          12:
              {
                'ts': -1507500000,
                'time': '1922-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          13:
              {
                'ts': -1490565600,
                'time': '1922-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          14:
              {
                'ts': -1473631200,
                'time': '1923-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          15:
              {
                'ts': -1460930400,
                'time': '1923-09-16T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          16:
              {
                'ts': -1442786400,
                'time': '1924-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          17:
              {
                'ts': -1428876000,
                'time': '1924-09-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          18:
              {
                'ts': -1410732000,
                'time': '1925-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          19:
              {
                'ts': -1396216800,
                'time': '1925-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          20:
              {
                'ts': -1379282400,
                'time': '1926-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          21:
              {
                'ts': -1364767200,
                'time': '1926-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          22:
              {
                'ts': -1348437600,
                'time': '1927-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          23:
              {
                'ts': -1333317600,
                'time': '1927-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          24:
              {
                'ts': -1315778400,
                'time': '1928-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          25:
              {
                'ts': -1301263200,
                'time': '1928-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          26:
              {
                'ts': -1284328800,
                'time': '1929-04-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          27:
              {
                'ts': -1269813600,
                'time': '1929-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          28:
              {
                'ts': -1253484000,
                'time': '1930-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          29:
              {
                'ts': -1238364000,
                'time': '1930-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          30:
              {
                'ts': -1221429600,
                'time': '1931-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          31:
              {
                'ts': -1206914400,
                'time': '1931-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          32:
              {
                'ts': -1189980000,
                'time': '1932-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          33:
              {
                'ts': -1175464800,
                'time': '1932-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          34:
              {
                'ts': -1159135200,
                'time': '1933-04-09T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          35:
              {
                'ts': -1143410400,
                'time': '1933-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          36:
              {
                'ts': -1126476000,
                'time': '1934-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          37:
              {
                'ts': -1111960800,
                'time': '1934-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          38:
              {
                'ts': -1095631200,
                'time': '1935-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          39:
              {
                'ts': -1080511200,
                'time': '1935-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          40:
              {
                'ts': -1063576800,
                'time': '1936-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          41:
              {
                'ts': -1049061600,
                'time': '1936-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          42:
              {
                'ts': -1032127200,
                'time': '1937-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          43:
              {
                'ts': -1017612000,
                'time': '1937-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          44:
              {
                'ts': -1001282400,
                'time': '1938-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          45:
              {
                'ts': -986162400,
                'time': '1938-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          46:
              {
                'ts': -969228000,
                'time': '1939-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          47:
              {
                'ts': -950479200,
                'time': '1939-11-19T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          48:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          49:
              {
                'ts': -904518000,
                'time': '1941-05-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          50:
              {
                'ts': -896050800,
                'time': '1941-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          51:
              {
                'ts': -875487600,
                'time': '1942-04-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          52:
              {
                'ts': -864601200,
                'time': '1942-08-09T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          53:
              {
                'ts': -844038000,
                'time': '1943-04-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          54:
              {
                'ts': -832546800,
                'time': '1943-08-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          55:
              {
                'ts': -812588400,
                'time': '1944-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          56:
              {
                'ts': -798073200,
                'time': '1944-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          57:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          58:
              {
                'ts': -772066800,
                'time': '1945-07-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          59:
              {
                'ts': -764805600,
                'time': '1945-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          60:
              {
                'ts': -748476000,
                'time': '1946-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          61:
              {
                'ts': -733356000,
                'time': '1946-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          62:
              {
                'ts': -719445600,
                'time': '1947-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          63:
              {
                'ts': -717030000,
                'time': '1947-04-13T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          64:
              {
                'ts': -706748400,
                'time': '1947-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          65:
              {
                'ts': -699487200,
                'time': '1947-11-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          66:
              {
                'ts': -687996000,
                'time': '1948-03-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          67:
              {
                'ts': -668037600,
                'time': '1948-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          68:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          69:
              {
                'ts': -636588000,
                'time': '1949-10-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          70:
              {
                'ts': -622072800,
                'time': '1950-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          71:
              {
                'ts': -605743200,
                'time': '1950-10-22T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          72:
              {
                'ts': -590623200,
                'time': '1951-04-15T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          73:
              {
                'ts': -574293600,
                'time': '1951-10-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          74:
              {
                'ts': -558568800,
                'time': '1952-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          75:
              {
                'ts': -542239200,
                'time': '1952-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          76:
              {
                'ts': -527119200,
                'time': '1953-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          77:
              {
                'ts': -512604000,
                'time': '1953-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          78:
              {
                'ts': -496274400,
                'time': '1954-04-11T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          79:
              {
                'ts': -481154400,
                'time': '1954-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          80:
              {
                'ts': -464220000,
                'time': '1955-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          81:
              {
                'ts': -449704800,
                'time': '1955-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          82:
              {
                'ts': -432165600,
                'time': '1956-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          83:
              {
                'ts': -417650400,
                'time': '1956-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          84:
              {
                'ts': -401320800,
                'time': '1957-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          141:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          142:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          143:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          144:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          145:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          146:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          147:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          148:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          149:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          150:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          151:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          152:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          153:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          154:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          155:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          156:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          157:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          158:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          159:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          160:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          161:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          162:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          163:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          164:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          165:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          166:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          167:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          168:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          169:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          170:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          171:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          172:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          173:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          174:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          175:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          176:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          177:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          178:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          179:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          180:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          181:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          182:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          183:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          184:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          185:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          186:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          187:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          188:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          189:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          190:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          191:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          192:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          193:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          194:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          195:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          196:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Guernsey':
        {
          0:
              {
                'ts': -1691964000,
                'time': '1916-05-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          1:
              {
                'ts': -1680472800,
                'time': '1916-10-01T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          2:
              {
                'ts': -1664143200,
                'time': '1917-04-08T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          3:
              {
                'ts': -1650146400,
                'time': '1917-09-17T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          4:
              {
                'ts': -1633903200,
                'time': '1918-03-24T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          5:
              {
                'ts': -1617487200,
                'time': '1918-09-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          6:
              {
                'ts': -1601848800,
                'time': '1919-03-30T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          7:
              {
                'ts': -1586037600,
                'time': '1919-09-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          8:
              {
                'ts': -1570399200,
                'time': '1920-03-28T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          9:
              {
                'ts': -1552168800,
                'time': '1920-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          10:
              {
                'ts': -1538344800,
                'time': '1921-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          11:
              {
                'ts': -1522533600,
                'time': '1921-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          12:
              {
                'ts': -1507500000,
                'time': '1922-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          13:
              {
                'ts': -1490565600,
                'time': '1922-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          14:
              {
                'ts': -1473631200,
                'time': '1923-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          15:
              {
                'ts': -1460930400,
                'time': '1923-09-16T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          16:
              {
                'ts': -1442786400,
                'time': '1924-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          17:
              {
                'ts': -1428876000,
                'time': '1924-09-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          18:
              {
                'ts': -1410732000,
                'time': '1925-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          19:
              {
                'ts': -1396216800,
                'time': '1925-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          20:
              {
                'ts': -1379282400,
                'time': '1926-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          21:
              {
                'ts': -1364767200,
                'time': '1926-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          22:
              {
                'ts': -1348437600,
                'time': '1927-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          23:
              {
                'ts': -1333317600,
                'time': '1927-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          24:
              {
                'ts': -1315778400,
                'time': '1928-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          25:
              {
                'ts': -1301263200,
                'time': '1928-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          26:
              {
                'ts': -1284328800,
                'time': '1929-04-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          27:
              {
                'ts': -1269813600,
                'time': '1929-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          28:
              {
                'ts': -1253484000,
                'time': '1930-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          29:
              {
                'ts': -1238364000,
                'time': '1930-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          30:
              {
                'ts': -1221429600,
                'time': '1931-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          31:
              {
                'ts': -1206914400,
                'time': '1931-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          32:
              {
                'ts': -1189980000,
                'time': '1932-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          33:
              {
                'ts': -1175464800,
                'time': '1932-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          34:
              {
                'ts': -1159135200,
                'time': '1933-04-09T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          35:
              {
                'ts': -1143410400,
                'time': '1933-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          36:
              {
                'ts': -1126476000,
                'time': '1934-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          37:
              {
                'ts': -1111960800,
                'time': '1934-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          38:
              {
                'ts': -1095631200,
                'time': '1935-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          39:
              {
                'ts': -1080511200,
                'time': '1935-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          40:
              {
                'ts': -1063576800,
                'time': '1936-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          41:
              {
                'ts': -1049061600,
                'time': '1936-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          42:
              {
                'ts': -1032127200,
                'time': '1937-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          43:
              {
                'ts': -1017612000,
                'time': '1937-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          44:
              {
                'ts': -1001282400,
                'time': '1938-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          45:
              {
                'ts': -986162400,
                'time': '1938-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          46:
              {
                'ts': -969228000,
                'time': '1939-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          47:
              {
                'ts': -950479200,
                'time': '1939-11-19T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          48:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          49:
              {
                'ts': -904518000,
                'time': '1941-05-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          50:
              {
                'ts': -896050800,
                'time': '1941-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          51:
              {
                'ts': -875487600,
                'time': '1942-04-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          52:
              {
                'ts': -864601200,
                'time': '1942-08-09T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          53:
              {
                'ts': -844038000,
                'time': '1943-04-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          54:
              {
                'ts': -832546800,
                'time': '1943-08-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          55:
              {
                'ts': -812588400,
                'time': '1944-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          56:
              {
                'ts': -798073200,
                'time': '1944-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          57:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          58:
              {
                'ts': -772066800,
                'time': '1945-07-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          59:
              {
                'ts': -764805600,
                'time': '1945-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          60:
              {
                'ts': -748476000,
                'time': '1946-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          61:
              {
                'ts': -733356000,
                'time': '1946-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          62:
              {
                'ts': -719445600,
                'time': '1947-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          63:
              {
                'ts': -717030000,
                'time': '1947-04-13T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          64:
              {
                'ts': -706748400,
                'time': '1947-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          65:
              {
                'ts': -699487200,
                'time': '1947-11-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          66:
              {
                'ts': -687996000,
                'time': '1948-03-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          67:
              {
                'ts': -668037600,
                'time': '1948-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          68:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          69:
              {
                'ts': -636588000,
                'time': '1949-10-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          70:
              {
                'ts': -622072800,
                'time': '1950-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          71:
              {
                'ts': -605743200,
                'time': '1950-10-22T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          72:
              {
                'ts': -590623200,
                'time': '1951-04-15T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          73:
              {
                'ts': -574293600,
                'time': '1951-10-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          74:
              {
                'ts': -558568800,
                'time': '1952-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          75:
              {
                'ts': -542239200,
                'time': '1952-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          76:
              {
                'ts': -527119200,
                'time': '1953-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          77:
              {
                'ts': -512604000,
                'time': '1953-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          78:
              {
                'ts': -496274400,
                'time': '1954-04-11T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          79:
              {
                'ts': -481154400,
                'time': '1954-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          80:
              {
                'ts': -464220000,
                'time': '1955-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          81:
              {
                'ts': -449704800,
                'time': '1955-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          82:
              {
                'ts': -432165600,
                'time': '1956-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          83:
              {
                'ts': -417650400,
                'time': '1956-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          84:
              {
                'ts': -401320800,
                'time': '1957-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          85:
              {
                'ts': -386200800,
                'time': '1957-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          86:
              {
                'ts': -369266400,
                'time': '1958-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          87:
              {
                'ts': -354751200,
                'time': '1958-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          88:
              {
                'ts': -337816800,
                'time': '1959-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          89:
              {
                'ts': -323301600,
                'time': '1959-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          90:
              {
                'ts': -306972000,
                'time': '1960-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          91:
              {
                'ts': -291852000,
                'time': '1960-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          92:
              {
                'ts': -276732000,
                'time': '1961-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          93:
              {
                'ts': -257983200,
                'time': '1961-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          94:
              {
                'ts': -245282400,
                'time': '1962-03-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          95:
              {
                'ts': -226533600,
                'time': '1962-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          96:
              {
                'ts': -213228000,
                'time': '1963-03-31T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          97:
              {
                'ts': -195084000,
                'time': '1963-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          98:
              {
                'ts': -182383200,
                'time': '1964-03-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          99:
              {
                'ts': -163634400,
                'time': '1964-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          100:
              {
                'ts': -150933600,
                'time': '1965-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          101:
              {
                'ts': -132184800,
                'time': '1965-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          102:
              {
                'ts': -119484000,
                'time': '1966-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          103:
              {
                'ts': -100735200,
                'time': '1966-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          104:
              {
                'ts': -88034400,
                'time': '1967-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          105:
              {
                'ts': -68680800,
                'time': '1967-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          106:
              {
                'ts': -59004000,
                'time': '1968-02-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          107:
              {
                'ts': -37242000,
                'time': '1968-10-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'BST'
              },
          108:
              {
                'ts': 57722400,
                'time': '1971-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          109:
              {
                'ts': 69818400,
                'time': '1972-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          110:
              {
                'ts': 89172000,
                'time': '1972-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          111:
              {
                'ts': 101268000,
                'time': '1973-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          112:
              {
                'ts': 120621600,
                'time': '1973-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          113:
              {
                'ts': 132717600,
                'time': '1974-03-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          114:
              {
                'ts': 152071200,
                'time': '1974-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          115:
              {
                'ts': 164167200,
                'time': '1975-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          116:
              {
                'ts': 183520800,
                'time': '1975-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          117:
              {
                'ts': 196221600,
                'time': '1976-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          118:
              {
                'ts': 214970400,
                'time': '1976-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          119:
              {
                'ts': 227671200,
                'time': '1977-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          120:
              {
                'ts': 246420000,
                'time': '1977-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          121:
              {
                'ts': 259120800,
                'time': '1978-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          122:
              {
                'ts': 278474400,
                'time': '1978-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          123:
              {
                'ts': 290570400,
                'time': '1979-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          124:
              {
                'ts': 309924000,
                'time': '1979-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          125:
              {
                'ts': 322020000,
                'time': '1980-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          126:
              {
                'ts': 341373600,
                'time': '1980-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          127:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          128:
              {
                'ts': 372819600,
                'time': '1981-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          129:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          130:
              {
                'ts': 404269200,
                'time': '1982-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          131:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          132:
              {
                'ts': 435718800,
                'time': '1983-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          133:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          134:
              {
                'ts': 467773200,
                'time': '1984-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          135:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          136:
              {
                'ts': 499222800,
                'time': '1985-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          137:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          138:
              {
                'ts': 530672400,
                'time': '1986-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          139:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          140:
              {
                'ts': 562122000,
                'time': '1987-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          141:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          142:
              {
                'ts': 593571600,
                'time': '1988-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          143:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          144:
              {
                'ts': 625626000,
                'time': '1989-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          145:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          146:
              {
                'ts': 657075600,
                'time': '1990-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          147:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          148:
              {
                'ts': 688525200,
                'time': '1991-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          149:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          150:
              {
                'ts': 719974800,
                'time': '1992-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          151:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          152:
              {
                'ts': 751424400,
                'time': '1993-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          153:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          154:
              {
                'ts': 782874000,
                'time': '1994-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          155:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          156:
              {
                'ts': 814323600,
                'time': '1995-10-22T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          157:
              {
                'ts': 820454400,
                'time': '1996-01-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          158:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          159:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          160:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          161:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          162:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          163:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          164:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          165:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          166:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          167:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          168:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          169:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          170:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          171:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          172:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          173:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          174:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          175:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          176:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          177:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          178:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          179:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          180:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          181:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          182:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          183:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          184:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          185:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          186:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          187:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          188:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          189:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          190:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          191:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          192:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          193:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          194:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          195:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          196:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          197:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          198:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          199:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          200:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          201:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          202:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          203:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          204:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          205:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          206:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          207:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          208:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          209:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          210:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          211:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          212:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          213:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          214:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          215:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          216:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          217:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          218:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          219:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          220:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          221:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          222:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          223:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          224:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          225:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          226:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          227:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          228:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          229:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          230:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          231:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          232:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          233:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          234:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          235:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          236:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          237:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          238:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          239:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          240:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          241:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Europe/Helsinki':
        {
          0:
              {
                'ts': -1535938792,
                'time': '1921-04-30T22:20:08+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -875671200,
                'time': '1942-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          2:
              {
                'ts': -859863600,
                'time': '1942-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          4:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          6:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          10:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          11:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          12:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          14:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          15:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          16:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          17:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          18:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          19:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          20:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          21:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          22:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          23:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          24:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          25:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          26:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Isle_of_Man':
        {
          0:
              {
                'ts': -1691964000,
                'time': '1916-05-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          1:
              {
                'ts': -1680472800,
                'time': '1916-10-01T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          2:
              {
                'ts': -1664143200,
                'time': '1917-04-08T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          3:
              {
                'ts': -1650146400,
                'time': '1917-09-17T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          4:
              {
                'ts': -1633903200,
                'time': '1918-03-24T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          5:
              {
                'ts': -1617487200,
                'time': '1918-09-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          6:
              {
                'ts': -1601848800,
                'time': '1919-03-30T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          7:
              {
                'ts': -1586037600,
                'time': '1919-09-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          8:
              {
                'ts': -1570399200,
                'time': '1920-03-28T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          9:
              {
                'ts': -1552168800,
                'time': '1920-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          10:
              {
                'ts': -1538344800,
                'time': '1921-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          11:
              {
                'ts': -1522533600,
                'time': '1921-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          12:
              {
                'ts': -1507500000,
                'time': '1922-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          13:
              {
                'ts': -1490565600,
                'time': '1922-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          14:
              {
                'ts': -1473631200,
                'time': '1923-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          15:
              {
                'ts': -1460930400,
                'time': '1923-09-16T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          16:
              {
                'ts': -1442786400,
                'time': '1924-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          17:
              {
                'ts': -1428876000,
                'time': '1924-09-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          18:
              {
                'ts': -1410732000,
                'time': '1925-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          19:
              {
                'ts': -1396216800,
                'time': '1925-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          20:
              {
                'ts': -1379282400,
                'time': '1926-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          21:
              {
                'ts': -1364767200,
                'time': '1926-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          22:
              {
                'ts': -1348437600,
                'time': '1927-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          23:
              {
                'ts': -1333317600,
                'time': '1927-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          24:
              {
                'ts': -1315778400,
                'time': '1928-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          25:
              {
                'ts': -1301263200,
                'time': '1928-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          26:
              {
                'ts': -1284328800,
                'time': '1929-04-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          27:
              {
                'ts': -1269813600,
                'time': '1929-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          28:
              {
                'ts': -1253484000,
                'time': '1930-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          29:
              {
                'ts': -1238364000,
                'time': '1930-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          30:
              {
                'ts': -1221429600,
                'time': '1931-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          31:
              {
                'ts': -1206914400,
                'time': '1931-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          32:
              {
                'ts': -1189980000,
                'time': '1932-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          33:
              {
                'ts': -1175464800,
                'time': '1932-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          34:
              {
                'ts': -1159135200,
                'time': '1933-04-09T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          35:
              {
                'ts': -1143410400,
                'time': '1933-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          36:
              {
                'ts': -1126476000,
                'time': '1934-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          37:
              {
                'ts': -1111960800,
                'time': '1934-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          38:
              {
                'ts': -1095631200,
                'time': '1935-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          39:
              {
                'ts': -1080511200,
                'time': '1935-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          40:
              {
                'ts': -1063576800,
                'time': '1936-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          41:
              {
                'ts': -1049061600,
                'time': '1936-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          42:
              {
                'ts': -1032127200,
                'time': '1937-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          43:
              {
                'ts': -1017612000,
                'time': '1937-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          44:
              {
                'ts': -1001282400,
                'time': '1938-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          45:
              {
                'ts': -986162400,
                'time': '1938-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          46:
              {
                'ts': -969228000,
                'time': '1939-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          47:
              {
                'ts': -950479200,
                'time': '1939-11-19T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          48:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          49:
              {
                'ts': -904518000,
                'time': '1941-05-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          50:
              {
                'ts': -896050800,
                'time': '1941-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          51:
              {
                'ts': -875487600,
                'time': '1942-04-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          52:
              {
                'ts': -864601200,
                'time': '1942-08-09T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          53:
              {
                'ts': -844038000,
                'time': '1943-04-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          54:
              {
                'ts': -832546800,
                'time': '1943-08-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          55:
              {
                'ts': -812588400,
                'time': '1944-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          56:
              {
                'ts': -798073200,
                'time': '1944-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          57:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          58:
              {
                'ts': -772066800,
                'time': '1945-07-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          59:
              {
                'ts': -764805600,
                'time': '1945-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          60:
              {
                'ts': -748476000,
                'time': '1946-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          61:
              {
                'ts': -733356000,
                'time': '1946-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          62:
              {
                'ts': -719445600,
                'time': '1947-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          63:
              {
                'ts': -717030000,
                'time': '1947-04-13T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          64:
              {
                'ts': -706748400,
                'time': '1947-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          65:
              {
                'ts': -699487200,
                'time': '1947-11-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          66:
              {
                'ts': -687996000,
                'time': '1948-03-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          67:
              {
                'ts': -668037600,
                'time': '1948-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          68:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          69:
              {
                'ts': -636588000,
                'time': '1949-10-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          70:
              {
                'ts': -622072800,
                'time': '1950-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          71:
              {
                'ts': -605743200,
                'time': '1950-10-22T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          72:
              {
                'ts': -590623200,
                'time': '1951-04-15T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          73:
              {
                'ts': -574293600,
                'time': '1951-10-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          74:
              {
                'ts': -558568800,
                'time': '1952-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          75:
              {
                'ts': -542239200,
                'time': '1952-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          76:
              {
                'ts': -527119200,
                'time': '1953-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          77:
              {
                'ts': -512604000,
                'time': '1953-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          78:
              {
                'ts': -496274400,
                'time': '1954-04-11T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          79:
              {
                'ts': -481154400,
                'time': '1954-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          80:
              {
                'ts': -464220000,
                'time': '1955-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          81:
              {
                'ts': -449704800,
                'time': '1955-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          82:
              {
                'ts': -432165600,
                'time': '1956-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          83:
              {
                'ts': -417650400,
                'time': '1956-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          84:
              {
                'ts': -401320800,
                'time': '1957-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          85:
              {
                'ts': -386200800,
                'time': '1957-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          86:
              {
                'ts': -369266400,
                'time': '1958-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          87:
              {
                'ts': -354751200,
                'time': '1958-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          88:
              {
                'ts': -337816800,
                'time': '1959-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          89:
              {
                'ts': -323301600,
                'time': '1959-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          90:
              {
                'ts': -306972000,
                'time': '1960-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          91:
              {
                'ts': -291852000,
                'time': '1960-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          92:
              {
                'ts': -276732000,
                'time': '1961-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          93:
              {
                'ts': -257983200,
                'time': '1961-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          94:
              {
                'ts': -245282400,
                'time': '1962-03-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          95:
              {
                'ts': -226533600,
                'time': '1962-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          96:
              {
                'ts': -213228000,
                'time': '1963-03-31T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          97:
              {
                'ts': -195084000,
                'time': '1963-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          98:
              {
                'ts': -182383200,
                'time': '1964-03-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          99:
              {
                'ts': -163634400,
                'time': '1964-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          100:
              {
                'ts': -150933600,
                'time': '1965-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          101:
              {
                'ts': -132184800,
                'time': '1965-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          102:
              {
                'ts': -119484000,
                'time': '1966-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          103:
              {
                'ts': -100735200,
                'time': '1966-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          104:
              {
                'ts': -88034400,
                'time': '1967-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          105:
              {
                'ts': -68680800,
                'time': '1967-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          106:
              {
                'ts': -59004000,
                'time': '1968-02-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          107:
              {
                'ts': -37242000,
                'time': '1968-10-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'BST'
              },
          108:
              {
                'ts': 57722400,
                'time': '1971-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          109:
              {
                'ts': 69818400,
                'time': '1972-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          110:
              {
                'ts': 89172000,
                'time': '1972-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          111:
              {
                'ts': 101268000,
                'time': '1973-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          112:
              {
                'ts': 120621600,
                'time': '1973-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          113:
              {
                'ts': 132717600,
                'time': '1974-03-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          114:
              {
                'ts': 152071200,
                'time': '1974-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          115:
              {
                'ts': 164167200,
                'time': '1975-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          116:
              {
                'ts': 183520800,
                'time': '1975-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          117:
              {
                'ts': 196221600,
                'time': '1976-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          118:
              {
                'ts': 214970400,
                'time': '1976-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          119:
              {
                'ts': 227671200,
                'time': '1977-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          120:
              {
                'ts': 246420000,
                'time': '1977-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          121:
              {
                'ts': 259120800,
                'time': '1978-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          122:
              {
                'ts': 278474400,
                'time': '1978-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          123:
              {
                'ts': 290570400,
                'time': '1979-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          124:
              {
                'ts': 309924000,
                'time': '1979-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          125:
              {
                'ts': 322020000,
                'time': '1980-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          126:
              {
                'ts': 341373600,
                'time': '1980-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          127:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          128:
              {
                'ts': 372819600,
                'time': '1981-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          129:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          130:
              {
                'ts': 404269200,
                'time': '1982-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          131:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          132:
              {
                'ts': 435718800,
                'time': '1983-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          133:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          134:
              {
                'ts': 467773200,
                'time': '1984-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          135:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          136:
              {
                'ts': 499222800,
                'time': '1985-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          137:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          138:
              {
                'ts': 530672400,
                'time': '1986-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          139:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          140:
              {
                'ts': 562122000,
                'time': '1987-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          141:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          142:
              {
                'ts': 593571600,
                'time': '1988-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          143:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          144:
              {
                'ts': 625626000,
                'time': '1989-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          145:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          146:
              {
                'ts': 657075600,
                'time': '1990-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          147:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          148:
              {
                'ts': 688525200,
                'time': '1991-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          149:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          150:
              {
                'ts': 719974800,
                'time': '1992-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          151:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          152:
              {
                'ts': 751424400,
                'time': '1993-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          153:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          154:
              {
                'ts': 782874000,
                'time': '1994-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          155:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          156:
              {
                'ts': 814323600,
                'time': '1995-10-22T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          157:
              {
                'ts': 820454400,
                'time': '1996-01-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          158:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          159:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          160:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          161:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          162:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          163:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          164:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          165:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          166:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          167:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          168:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          169:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          170:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          171:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          172:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          173:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          174:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          175:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          176:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          177:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          178:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          179:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          180:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          181:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          182:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          183:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          184:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          185:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          186:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          187:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          188:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          189:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          190:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          191:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          192:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          193:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          194:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          195:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          196:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          197:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          198:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          199:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          200:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          201:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          202:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          203:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          204:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          205:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          206:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          207:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          208:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          209:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          210:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          211:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          212:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          213:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          214:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          215:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          216:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          217:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          218:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          219:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          220:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          221:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          222:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          223:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          224:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          225:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          226:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          227:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          228:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          229:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          230:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          231:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          232:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          233:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          234:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          235:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          236:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          237:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          238:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          239:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          240:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          241:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Europe/Istanbul':
        {
          0:
              {
                'ts': -1869875816,
                'time': '1910-09-30T22:03:04+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          2:
              {
                'ts': -1680490800,
                'time': '1916-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': -1570413600,
                'time': '1920-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          4:
              {
                'ts': -1552186800,
                'time': '1920-10-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': -1538359200,
                'time': '1921-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          6:
              {
                'ts': -1522551600,
                'time': '1921-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': -1507514400,
                'time': '1922-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': -1490583600,
                'time': '1922-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': -1440208800,
                'time': '1924-05-12T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          10:
              {
                'ts': -1428030000,
                'time': '1924-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          11:
              {
                'ts': -1409709600,
                'time': '1925-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          12:
              {
                'ts': -1396494000,
                'time': '1925-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': -931140000,
                'time': '1940-06-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          14:
              {
                'ts': -922762800,
                'time': '1940-10-04T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          15:
              {
                'ts': -917834400,
                'time': '1940-11-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          16:
              {
                'ts': -892436400,
                'time': '1941-09-20T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          17:
              {
                'ts': -875844000,
                'time': '1942-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          18:
              {
                'ts': -857358000,
                'time': '1942-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          19:
              {
                'ts': -781063200,
                'time': '1945-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          20:
              {
                'ts': -764737200,
                'time': '1945-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          21:
              {
                'ts': -744343200,
                'time': '1946-05-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          22:
              {
                'ts': -733806000,
                'time': '1946-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          23:
              {
                'ts': -716436000,
                'time': '1947-04-19T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          24:
              {
                'ts': -701924400,
                'time': '1947-10-04T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          25:
              {
                'ts': -684986400,
                'time': '1948-04-17T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          26:
              {
                'ts': -670474800,
                'time': '1948-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': -654141600,
                'time': '1949-04-09T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': -639025200,
                'time': '1949-10-01T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': -621828000,
                'time': '1950-04-18T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': -606970800,
                'time': '1950-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': -590032800,
                'time': '1951-04-21T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': -575434800,
                'time': '1951-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': -235620000,
                'time': '1962-07-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': -228279600,
                'time': '1962-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': -177732000,
                'time': '1964-05-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': -165726000,
                'time': '1964-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 10533600,
                'time': '1970-05-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 23835600,
                'time': '1970-10-03T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 41983200,
                'time': '1971-05-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 55285200,
                'time': '1971-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 74037600,
                'time': '1972-05-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 87339600,
                'time': '1972-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 107910000,
                'time': '1973-06-02T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 121219200,
                'time': '1973-11-04T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 133920000,
                'time': '1974-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 152676000,
                'time': '1974-11-03T02:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 165362400,
                'time': '1975-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 183502800,
                'time': '1975-10-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 202428000,
                'time': '1976-05-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 215557200,
                'time': '1976-10-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 228866400,
                'time': '1977-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 245797200,
                'time': '1977-10-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 260316000,
                'time': '1978-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 277246800,
                'time': '1978-10-14T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          55:
              {
                'ts': 308779200,
                'time': '1979-10-14T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          56:
              {
                'ts': 323827200,
                'time': '1980-04-06T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          57:
              {
                'ts': 340228800,
                'time': '1980-10-12T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          58:
              {
                'ts': 354672000,
                'time': '1981-03-29T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          59:
              {
                'ts': 371678400,
                'time': '1981-10-11T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          60:
              {
                'ts': 386121600,
                'time': '1982-03-28T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          61:
              {
                'ts': 403128000,
                'time': '1982-10-10T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          62:
              {
                'ts': 428446800,
                'time': '1983-07-30T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          63:
              {
                'ts': 433886400,
                'time': '1983-10-01T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          64:
              {
                'ts': 482792400,
                'time': '1985-04-19T21:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          65:
              {
                'ts': 496702800,
                'time': '1985-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          66:
              {
                'ts': 512524800,
                'time': '1986-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          67:
              {
                'ts': 528249600,
                'time': '1986-09-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          68:
              {
                'ts': 543974400,
                'time': '1987-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          69:
              {
                'ts': 559699200,
                'time': '1987-09-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          70:
              {
                'ts': 575424000,
                'time': '1988-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          71:
              {
                'ts': 591148800,
                'time': '1988-09-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          72:
              {
                'ts': 606873600,
                'time': '1989-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          73:
              {
                'ts': 622598400,
                'time': '1989-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          74:
              {
                'ts': 638323200,
                'time': '1990-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          75:
              {
                'ts': 654652800,
                'time': '1990-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          76:
              {
                'ts': 670374000,
                'time': '1991-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          77:
              {
                'ts': 686098800,
                'time': '1991-09-28T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          78:
              {
                'ts': 701823600,
                'time': '1992-03-28T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          79:
              {
                'ts': 717548400,
                'time': '1992-09-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          80:
              {
                'ts': 733273200,
                'time': '1993-03-27T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          81:
              {
                'ts': 748998000,
                'time': '1993-09-25T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          82:
              {
                'ts': 764722800,
                'time': '1994-03-26T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          83:
              {
                'ts': 780447600,
                'time': '1994-09-24T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          84:
              {
                'ts': 796172400,
                'time': '1995-03-25T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          85:
              {
                'ts': 811897200,
                'time': '1995-09-23T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          86:
              {
                'ts': 828226800,
                'time': '1996-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          87:
              {
                'ts': 846370800,
                'time': '1996-10-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          88:
              {
                'ts': 859676400,
                'time': '1997-03-29T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          89:
              {
                'ts': 877820400,
                'time': '1997-10-25T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          90:
              {
                'ts': 891126000,
                'time': '1998-03-28T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          91:
              {
                'ts': 909270000,
                'time': '1998-10-24T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          92:
              {
                'ts': 922575600,
                'time': '1999-03-27T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          93:
              {
                'ts': 941324400,
                'time': '1999-10-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          94:
              {
                'ts': 954025200,
                'time': '2000-03-25T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          95:
              {
                'ts': 972774000,
                'time': '2000-10-28T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          96:
              {
                'ts': 985474800,
                'time': '2001-03-24T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          97:
              {
                'ts': 1004223600,
                'time': '2001-10-27T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          98:
              {
                'ts': 1017529200,
                'time': '2002-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          99:
              {
                'ts': 1035673200,
                'time': '2002-10-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          100:
              {
                'ts': 1048978800,
                'time': '2003-03-29T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          101:
              {
                'ts': 1067122800,
                'time': '2003-10-25T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          102:
              {
                'ts': 1080428400,
                'time': '2004-03-27T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          103:
              {
                'ts': 1099177200,
                'time': '2004-10-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          104:
              {
                'ts': 1111878000,
                'time': '2005-03-26T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          105:
              {
                'ts': 1130626800,
                'time': '2005-10-29T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          106:
              {
                'ts': 1143327600,
                'time': '2006-03-25T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          107:
              {
                'ts': 1162076400,
                'time': '2006-10-28T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          108:
              {
                'ts': 1167602400,
                'time': '2006-12-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          121:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          122:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          123:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          124:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          125:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          126:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          127:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          128:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          129:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          130:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          131:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          132:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          133:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          134:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          135:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          136:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          137:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          138:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          139:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          140:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          141:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          142:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          143:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          144:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          145:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          146:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          147:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          148:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          149:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          150:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          151:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          152:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          153:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          154:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          155:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          156:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          157:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          158:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          159:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          160:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          161:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          162:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          163:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          164:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          165:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          166:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          167:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          168:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          169:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          170:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Jersey':
        {
          0:
              {
                'ts': -1691964000,
                'time': '1916-05-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          1:
              {
                'ts': -1680472800,
                'time': '1916-10-01T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          2:
              {
                'ts': -1664143200,
                'time': '1917-04-08T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          3:
              {
                'ts': -1650146400,
                'time': '1917-09-17T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          4:
              {
                'ts': -1633903200,
                'time': '1918-03-24T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          5:
              {
                'ts': -1617487200,
                'time': '1918-09-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          6:
              {
                'ts': -1601848800,
                'time': '1919-03-30T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          7:
              {
                'ts': -1586037600,
                'time': '1919-09-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          8:
              {
                'ts': -1570399200,
                'time': '1920-03-28T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          9:
              {
                'ts': -1552168800,
                'time': '1920-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          10:
              {
                'ts': -1538344800,
                'time': '1921-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          11:
              {
                'ts': -1522533600,
                'time': '1921-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          12:
              {
                'ts': -1507500000,
                'time': '1922-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          13:
              {
                'ts': -1490565600,
                'time': '1922-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          14:
              {
                'ts': -1473631200,
                'time': '1923-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          15:
              {
                'ts': -1460930400,
                'time': '1923-09-16T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          16:
              {
                'ts': -1442786400,
                'time': '1924-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          17:
              {
                'ts': -1428876000,
                'time': '1924-09-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          18:
              {
                'ts': -1410732000,
                'time': '1925-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          19:
              {
                'ts': -1396216800,
                'time': '1925-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          20:
              {
                'ts': -1379282400,
                'time': '1926-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          21:
              {
                'ts': -1364767200,
                'time': '1926-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          22:
              {
                'ts': -1348437600,
                'time': '1927-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          23:
              {
                'ts': -1333317600,
                'time': '1927-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          24:
              {
                'ts': -1315778400,
                'time': '1928-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          25:
              {
                'ts': -1301263200,
                'time': '1928-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          26:
              {
                'ts': -1284328800,
                'time': '1929-04-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          27:
              {
                'ts': -1269813600,
                'time': '1929-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          28:
              {
                'ts': -1253484000,
                'time': '1930-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          29:
              {
                'ts': -1238364000,
                'time': '1930-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          30:
              {
                'ts': -1221429600,
                'time': '1931-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          31:
              {
                'ts': -1206914400,
                'time': '1931-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          32:
              {
                'ts': -1189980000,
                'time': '1932-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          33:
              {
                'ts': -1175464800,
                'time': '1932-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          34:
              {
                'ts': -1159135200,
                'time': '1933-04-09T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          35:
              {
                'ts': -1143410400,
                'time': '1933-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          36:
              {
                'ts': -1126476000,
                'time': '1934-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          37:
              {
                'ts': -1111960800,
                'time': '1934-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          38:
              {
                'ts': -1095631200,
                'time': '1935-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          39:
              {
                'ts': -1080511200,
                'time': '1935-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          40:
              {
                'ts': -1063576800,
                'time': '1936-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          41:
              {
                'ts': -1049061600,
                'time': '1936-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          42:
              {
                'ts': -1032127200,
                'time': '1937-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          43:
              {
                'ts': -1017612000,
                'time': '1937-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          44:
              {
                'ts': -1001282400,
                'time': '1938-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          45:
              {
                'ts': -986162400,
                'time': '1938-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          46:
              {
                'ts': -969228000,
                'time': '1939-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          47:
              {
                'ts': -950479200,
                'time': '1939-11-19T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          48:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          49:
              {
                'ts': -904518000,
                'time': '1941-05-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          50:
              {
                'ts': -896050800,
                'time': '1941-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          51:
              {
                'ts': -875487600,
                'time': '1942-04-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          52:
              {
                'ts': -864601200,
                'time': '1942-08-09T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          53:
              {
                'ts': -844038000,
                'time': '1943-04-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          54:
              {
                'ts': -832546800,
                'time': '1943-08-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          55:
              {
                'ts': -812588400,
                'time': '1944-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          56:
              {
                'ts': -798073200,
                'time': '1944-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          57:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          58:
              {
                'ts': -772066800,
                'time': '1945-07-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          59:
              {
                'ts': -764805600,
                'time': '1945-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          60:
              {
                'ts': -748476000,
                'time': '1946-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          61:
              {
                'ts': -733356000,
                'time': '1946-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          62:
              {
                'ts': -719445600,
                'time': '1947-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          63:
              {
                'ts': -717030000,
                'time': '1947-04-13T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          64:
              {
                'ts': -706748400,
                'time': '1947-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          65:
              {
                'ts': -699487200,
                'time': '1947-11-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          66:
              {
                'ts': -687996000,
                'time': '1948-03-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          67:
              {
                'ts': -668037600,
                'time': '1948-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          68:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          69:
              {
                'ts': -636588000,
                'time': '1949-10-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          70:
              {
                'ts': -622072800,
                'time': '1950-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          71:
              {
                'ts': -605743200,
                'time': '1950-10-22T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          72:
              {
                'ts': -590623200,
                'time': '1951-04-15T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          73:
              {
                'ts': -574293600,
                'time': '1951-10-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          74:
              {
                'ts': -558568800,
                'time': '1952-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          75:
              {
                'ts': -542239200,
                'time': '1952-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          76:
              {
                'ts': -527119200,
                'time': '1953-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          77:
              {
                'ts': -512604000,
                'time': '1953-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          78:
              {
                'ts': -496274400,
                'time': '1954-04-11T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          79:
              {
                'ts': -481154400,
                'time': '1954-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          80:
              {
                'ts': -464220000,
                'time': '1955-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          81:
              {
                'ts': -449704800,
                'time': '1955-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          82:
              {
                'ts': -432165600,
                'time': '1956-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          83:
              {
                'ts': -417650400,
                'time': '1956-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          84:
              {
                'ts': -401320800,
                'time': '1957-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          85:
              {
                'ts': -386200800,
                'time': '1957-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          86:
              {
                'ts': -369266400,
                'time': '1958-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          87:
              {
                'ts': -354751200,
                'time': '1958-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          88:
              {
                'ts': -337816800,
                'time': '1959-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          89:
              {
                'ts': -323301600,
                'time': '1959-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          90:
              {
                'ts': -306972000,
                'time': '1960-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          91:
              {
                'ts': -291852000,
                'time': '1960-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          92:
              {
                'ts': -276732000,
                'time': '1961-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          93:
              {
                'ts': -257983200,
                'time': '1961-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          94:
              {
                'ts': -245282400,
                'time': '1962-03-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          95:
              {
                'ts': -226533600,
                'time': '1962-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          96:
              {
                'ts': -213228000,
                'time': '1963-03-31T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          97:
              {
                'ts': -195084000,
                'time': '1963-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          98:
              {
                'ts': -182383200,
                'time': '1964-03-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          99:
              {
                'ts': -163634400,
                'time': '1964-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          100:
              {
                'ts': -150933600,
                'time': '1965-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          101:
              {
                'ts': -132184800,
                'time': '1965-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          102:
              {
                'ts': -119484000,
                'time': '1966-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          103:
              {
                'ts': -100735200,
                'time': '1966-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          104:
              {
                'ts': -88034400,
                'time': '1967-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          105:
              {
                'ts': -68680800,
                'time': '1967-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          106:
              {
                'ts': -59004000,
                'time': '1968-02-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          107:
              {
                'ts': -37242000,
                'time': '1968-10-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'BST'
              },
          108:
              {
                'ts': 57722400,
                'time': '1971-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          109:
              {
                'ts': 69818400,
                'time': '1972-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          110:
              {
                'ts': 89172000,
                'time': '1972-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          111:
              {
                'ts': 101268000,
                'time': '1973-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          112:
              {
                'ts': 120621600,
                'time': '1973-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          113:
              {
                'ts': 132717600,
                'time': '1974-03-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,

                'abbr': 'BST'
              },
          114:
              {
                'ts': 152071200,
                'time': '1974-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          115:
              {
                'ts': 164167200,
                'time': '1975-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          116:
              {
                'ts': 183520800,
                'time': '1975-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          117:
              {
                'ts': 196221600,
                'time': '1976-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          118:
              {
                'ts': 214970400,
                'time': '1976-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          119:
              {
                'ts': 227671200,
                'time': '1977-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          120:
              {
                'ts': 246420000,
                'time': '1977-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          121:
              {
                'ts': 259120800,
                'time': '1978-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          122:
              {
                'ts': 278474400,
                'time': '1978-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          123:
              {
                'ts': 290570400,
                'time': '1979-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          124:
              {
                'ts': 309924000,
                'time': '1979-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          125:
              {
                'ts': 322020000,
                'time': '1980-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          126:
              {
                'ts': 341373600,
                'time': '1980-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          127:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          128:
              {
                'ts': 372819600,
                'time': '1981-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          129:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          130:
              {
                'ts': 404269200,
                'time': '1982-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          131:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          132:
              {
                'ts': 435718800,
                'time': '1983-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          133:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          134:
              {
                'ts': 467773200,
                'time': '1984-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          135:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          136:
              {
                'ts': 499222800,
                'time': '1985-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          137:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          138:
              {
                'ts': 530672400,
                'time': '1986-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          139:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          140:
              {
                'ts': 562122000,
                'time': '1987-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          141:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          142:
              {
                'ts': 593571600,
                'time': '1988-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          143:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          144:
              {
                'ts': 625626000,
                'time': '1989-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          145:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          146:
              {
                'ts': 657075600,
                'time': '1990-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          147:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          148:
              {
                'ts': 688525200,
                'time': '1991-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          149:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          150:
              {
                'ts': 719974800,
                'time': '1992-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          151:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          152:
              {
                'ts': 751424400,
                'time': '1993-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          153:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          154:
              {
                'ts': 782874000,
                'time': '1994-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          155:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          156:
              {
                'ts': 814323600,
                'time': '1995-10-22T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          157:
              {
                'ts': 820454400,
                'time': '1996-01-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          158:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          159:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          160:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          161:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          162:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          163:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          164:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          165:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          166:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          167:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          168:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          169:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          170:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          171:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          172:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          173:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          174:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          175:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          176:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          177:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          178:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          179:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          180:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          181:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          182:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          183:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          184:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          185:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          186:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          187:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          188:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          189:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          190:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          191:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          192:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          193:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          194:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          195:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          196:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          197:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          198:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          199:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          200:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          201:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          202:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          203:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          204:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          205:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          206:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          207:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          208:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          209:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          210:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          211:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          212:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          213:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          214:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          215:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          216:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          217:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          218:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          219:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          220:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          221:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          222:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          223:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          224:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          225:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          226:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          227:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          228:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          229:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          230:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          231:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          232:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          233:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          234:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          235:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          236:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          237:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          238:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          239:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          240:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          241:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Europe/Kaliningrad':
        {
          0:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -1663455600,
                'time': '1917-04-16T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -1650150000,
                'time': '1917-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -1632006000,
                'time': '1918-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -1618700400,
                'time': '1918-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -938905200,
                'time': '1940-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -788922000,
                'time': '1944-12-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': -778730400,
                'time': '1945-04-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': -762663600,
                'time': '1945-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': -757389600,
                'time': '1945-12-31T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          16:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          17:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          18:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          19:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          20:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          21:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          22:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          23:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          24:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          25:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          26:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          27:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          28:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          29:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          30:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          31:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          32:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          33:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          34:
              {
                'ts': 638319600,
                'time': '1990-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          35:
              {
                'ts': 654649200,
                'time': '1990-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          36:
              {
                'ts': 670374000,
                'time': '1991-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          37:
              {
                'ts': 686102400,
                'time': '1991-09-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          38:
              {
                'ts': 701816400,
                'time': '1992-03-28T21:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          39:
              {
                'ts': 717537600,
                'time': '1992-09-26T20:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          40:
              {
                'ts': 733276800,
                'time': '1993-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          41:
              {
                'ts': 749001600,
                'time': '1993-09-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          42:
              {
                'ts': 764726400,
                'time': '1994-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          43:
              {
                'ts': 780451200,
                'time': '1994-09-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          44:
              {
                'ts': 796176000,
                'time': '1995-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          45:
              {
                'ts': 811900800,
                'time': '1995-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          46:
              {
                'ts': 828230400,
                'time': '1996-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          47:
              {
                'ts': 846374400,
                'time': '1996-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          48:
              {
                'ts': 859680000,
                'time': '1997-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          49:
              {
                'ts': 877824000,
                'time': '1997-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          50:
              {
                'ts': 891129600,
                'time': '1998-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          51:
              {
                'ts': 909273600,
                'time': '1998-10-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          52:
              {
                'ts': 922579200,
                'time': '1999-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          53:
              {
                'ts': 941328000,
                'time': '1999-10-31T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          54:
              {
                'ts': 954028800,
                'time': '2000-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          55:
              {
                'ts': 972777600,
                'time': '2000-10-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          56:
              {
                'ts': 985478400,
                'time': '2001-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          57:
              {
                'ts': 1004227200,
                'time': '2001-10-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          58:
              {
                'ts': 1017532800,
                'time': '2002-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          59:
              {
                'ts': 1035676800,
                'time': '2002-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          60:
              {
                'ts': 1048982400,
                'time': '2003-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          61:
              {
                'ts': 1067126400,
                'time': '2003-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          62:
              {
                'ts': 1080432000,
                'time': '2004-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          63:
              {
                'ts': 1099180800,
                'time': '2004-10-31T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          64:
              {
                'ts': 1111881600,
                'time': '2005-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          65:
              {
                'ts': 1130630400,
                'time': '2005-10-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          66:
              {
                'ts': 1143331200,
                'time': '2006-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          67:
              {
                'ts': 1162080000,
                'time': '2006-10-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          68:
              {
                'ts': 1174780800,
                'time': '2007-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          69:
              {
                'ts': 1193529600,
                'time': '2007-10-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          70:
              {
                'ts': 1206835200,
                'time': '2008-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          71:
              {
                'ts': 1224979200,
                'time': '2008-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          72:
              {
                'ts': 1238284800,
                'time': '2009-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          73:
              {
                'ts': 1256428800,
                'time': '2009-10-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          74:
              {
                'ts': 1269734400,
                'time': '2010-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          75:
              {
                'ts': 1288483200,
                'time': '2010-10-31T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          76:
              {
                'ts': 1301184000,
                'time': '2011-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          77:
              {
                'ts': 1319932800,
                'time': '2011-10-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          78:
              {
                'ts': 1332633600,
                'time': '2012-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          79:
              {
                'ts': 1351382400,
                'time': '2012-10-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          80:
              {
                'ts': 1364688000,
                'time': '2013-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          81:
              {
                'ts': 1382832000,
                'time': '2013-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          82:
              {
                'ts': 1396137600,
                'time': '2014-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          83:
              {
                'ts': 1414281600,
                'time': '2014-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          84:
              {
                'ts': 1427587200,
                'time': '2015-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          85:
              {
                'ts': 1445731200,
                'time': '2015-10-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          86:
              {
                'ts': 1459036800,
                'time': '2016-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          87:
              {
                'ts': 1477785600,
                'time': '2016-10-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          88:
              {
                'ts': 1490486400,
                'time': '2017-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          89:
              {
                'ts': 1509235200,
                'time': '2017-10-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          90:
              {
                'ts': 1521936000,
                'time': '2018-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          91:
              {
                'ts': 1540684800,
                'time': '2018-10-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          92:
              {
                'ts': 1553990400,
                'time': '2019-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          93:
              {
                'ts': 1572134400,
                'time': '2019-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          94:
              {
                'ts': 1585440000,
                'time': '2020-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          95:
              {
                'ts': 1603584000,
                'time': '2020-10-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          96:
              {
                'ts': 1616889600,
                'time': '2021-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          97:
              {
                'ts': 1635638400,
                'time': '2021-10-31T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          98:
              {
                'ts': 1648339200,
                'time': '2022-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          99:
              {
                'ts': 1667088000,
                'time': '2022-10-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          100:
              {
                'ts': 1679788800,
                'time': '2023-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          101:
              {
                'ts': 1698537600,
                'time': '2023-10-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          102:
              {
                'ts': 1711843200,
                'time': '2024-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          103:
              {
                'ts': 1729987200,
                'time': '2024-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          104:
              {
                'ts': 1743292800,
                'time': '2025-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          105:
              {
                'ts': 1761436800,
                'time': '2025-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          106:
              {
                'ts': 1774742400,
                'time': '2026-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          107:
              {
                'ts': 1792886400,
                'time': '2026-10-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          108:
              {
                'ts': 1806192000,
                'time': '2027-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          109:
              {
                'ts': 1824940800,
                'time': '2027-10-31T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          110:
              {
                'ts': 1837641600,
                'time': '2028-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          111:
              {
                'ts': 1856390400,
                'time': '2028-10-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          112:
              {
                'ts': 1869091200,
                'time': '2029-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          113:
              {
                'ts': 1887840000,
                'time': '2029-10-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          114:
              {
                'ts': 1901145600,
                'time': '2030-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          115:
              {
                'ts': 1919289600,
                'time': '2030-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          116:
              {
                'ts': 1932595200,
                'time': '2031-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          117:
              {
                'ts': 1950739200,
                'time': '2031-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          118:
              {
                'ts': 1964044800,
                'time': '2032-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          119:
              {
                'ts': 1982793600,
                'time': '2032-10-31T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          120:
              {
                'ts': 1995494400,
                'time': '2033-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          121:
              {
                'ts': 2014243200,
                'time': '2033-10-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          122:
              {
                'ts': 2026944000,
                'time': '2034-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          123:
              {
                'ts': 2045692800,
                'time': '2034-10-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          124:
              {
                'ts': 2058393600,
                'time': '2035-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          125:
              {
                'ts': 2077142400,
                'time': '2035-10-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          126:
              {
                'ts': 2090448000,
                'time': '2036-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          127:
              {
                'ts': 2108592000,
                'time': '2036-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          128:
              {
                'ts': 2121897600,
                'time': '2037-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          129:
              {
                'ts': 2140041600,
                'time': '2037-10-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Kiev':
        {
          0:
              {
                'ts': -1441159324,
                'time': '1924-05-01T21:57:56+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -1247536800,
                'time': '1930-06-20T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          2:
              {
                'ts': -892522800,
                'time': '1941-09-19T21:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -825382800,
                'time': '1943-11-05T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          7:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          8:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          9:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          10:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          11:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          12:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          13:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          14:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          15:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          16:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          17:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          18:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          19:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          20:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          21:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          22:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          23:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          24:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          25:
              {
                'ts': 631141200,
                'time': '1989-12-31T21:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          26:
              {
                'ts': 646786800,
                'time': '1990-06-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': 717541200,
                'time': '1992-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Lisbon':
        {
          0:
              {
                'ts': -1830381808,
                'time': '1912-01-01T00:36:32+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          1:
              {
                'ts': -1689555600,
                'time': '1916-06-17T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          2:
              {
                'ts': -1677801600,
                'time': '1916-11-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          3:
              {
                'ts': -1667437200,
                'time': '1917-02-28T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          4:
              {
                'ts': -1647738000,
                'time': '1917-10-14T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          5:
              {
                'ts': -1635814800,
                'time': '1918-03-01T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          6:
              {
                'ts': -1616202000,
                'time': '1918-10-14T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          7:
              {
                'ts': -1604365200,
                'time': '1919-02-28T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          8:
              {
                'ts': -1584666000,
                'time': '1919-10-14T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          9:
              {
                'ts': -1572742800,
                'time': '1920-02-29T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          10:
              {
                'ts': -1553043600,
                'time': '1920-10-14T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          11:
              {
                'ts': -1541206800,
                'time': '1921-02-28T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          12:
              {
                'ts': -1521507600,
                'time': '1921-10-14T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          13:
              {
                'ts': -1442451600,
                'time': '1924-04-16T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          14:
              {
                'ts': -1426813200,
                'time': '1924-10-14T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          15:
              {
                'ts': -1379293200,
                'time': '1926-04-17T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          16:
              {
                'ts': -1364778000,
                'time': '1926-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          17:
              {
                'ts': -1348448400,
                'time': '1927-04-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          18:
              {
                'ts': -1333328400,
                'time': '1927-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          19:
              {
                'ts': -1316394000,
                'time': '1928-04-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          20:
              {
                'ts': -1301274000,
                'time': '1928-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          21:
              {
                'ts': -1284339600,
                'time': '1929-04-20T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          22:
              {
                'ts': -1269824400,
                'time': '1929-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          23:
              {
                'ts': -1221440400,
                'time': '1931-04-18T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          24:
              {
                'ts': -1206925200,
                'time': '1931-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          25:
              {
                'ts': -1191200400,
                'time': '1932-04-02T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          26:
              {
                'ts': -1175475600,
                'time': '1932-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          27:
              {
                'ts': -1127696400,
                'time': '1934-04-07T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          28:
              {
                'ts': -1111971600,
                'time': '1934-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          29:
              {
                'ts': -1096851600,
                'time': '1935-03-30T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          30:
              {
                'ts': -1080522000,
                'time': '1935-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          31:
              {
                'ts': -1063587600,
                'time': '1936-04-18T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          32:
              {
                'ts': -1049072400,
                'time': '1936-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          33:
              {
                'ts': -1033347600,
                'time': '1937-04-03T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          34:
              {
                'ts': -1017622800,
                'time': '1937-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          35:
              {
                'ts': -1002502800,
                'time': '1938-03-26T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          36:
              {
                'ts': -986173200,
                'time': '1938-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          37:
              {
                'ts': -969238800,
                'time': '1939-04-15T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          38:
              {
                'ts': -950490000,
                'time': '1939-11-18T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          39:
              {
                'ts': -942022800,
                'time': '1940-02-24T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          40:
              {
                'ts': -922669200,
                'time': '1940-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          41:
              {
                'ts': -906944400,
                'time': '1941-04-05T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          42:
              {
                'ts': -891133200,
                'time': '1941-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          43:
              {
                'ts': -877309200,
                'time': '1942-03-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          44:
              {
                'ts': -873684000,
                'time': '1942-04-25T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          45:
              {
                'ts': -864007200,
                'time': '1942-08-15T22:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          46:
              {
                'ts': -857955600,
                'time': '1942-10-24T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          47:
              {
                'ts': -845859600,
                'time': '1943-03-13T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          48:
              {
                'ts': -842839200,
                'time': '1943-04-17T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          49:
              {
                'ts': -831348000,
                'time': '1943-08-28T22:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          50:
              {
                'ts': -825901200,
                'time': '1943-10-30T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          51:
              {
                'ts': -814410000,
                'time': '1944-03-11T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          52:
              {
                'ts': -810784800,
                'time': '1944-04-22T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          53:
              {
                'ts': -799898400,
                'time': '1944-08-26T22:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          54:
              {
                'ts': -794451600,
                'time': '1944-10-28T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          55:
              {
                'ts': -782960400,
                'time': '1945-03-10T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          56:
              {
                'ts': -779335200,
                'time': '1945-04-21T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          57:
              {
                'ts': -768448800,
                'time': '1945-08-25T22:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          58:
              {
                'ts': -763002000,
                'time': '1945-10-27T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          59:
              {
                'ts': -749091600,
                'time': '1946-04-06T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          60:
              {
                'ts': -733366800,
                'time': '1946-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          61:
              {
                'ts': -717631200,
                'time': '1947-04-06T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          62:
              {
                'ts': -701906400,
                'time': '1947-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          63:
              {
                'ts': -686181600,
                'time': '1948-04-04T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          64:
              {
                'ts': -670456800,
                'time': '1948-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          65:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          66:
              {
                'ts': -639007200,
                'time': '1949-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          67:
              {
                'ts': -591832800,
                'time': '1951-04-01T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          68:
              {
                'ts': -575503200,
                'time': '1951-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          69:
              {
                'ts': -559778400,
                'time': '1952-04-06T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          70:
              {
                'ts': -544053600,
                'time': '1952-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          71:
              {
                'ts': -528328800,
                'time': '1953-04-05T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          72:
              {
                'ts': -512604000,
                'time': '1953-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          73:
              {
                'ts': -496879200,
                'time': '1954-04-04T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          74:
              {
                'ts': -481154400,
                'time': '1954-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          75:
              {
                'ts': -465429600,
                'time': '1955-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          76:
              {
                'ts': -449704800,
                'time': '1955-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          77:
              {
                'ts': -433980000,
                'time': '1956-04-01T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          78:
              {
                'ts': -417650400,
                'time': '1956-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          79:
              {
                'ts': -401925600,
                'time': '1957-04-07T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          80:
              {
                'ts': -386200800,
                'time': '1957-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          81:
              {
                'ts': -370476000,
                'time': '1958-04-06T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          82:
              {
                'ts': -354751200,
                'time': '1958-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          83:
              {
                'ts': -339026400,
                'time': '1959-04-05T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          84:
              {
                'ts': -323301600,
                'time': '1959-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          85:
              {
                'ts': -307576800,
                'time': '1960-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          86:
              {
                'ts': -291852000,
                'time': '1960-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          87:
              {
                'ts': -276127200,
                'time': '1961-04-02T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          88:
              {
                'ts': -260402400,
                'time': '1961-10-01T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          89:
              {
                'ts': -244677600,
                'time': '1962-04-01T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          90:
              {
                'ts': -228348000,
                'time': '1962-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          91:
              {
                'ts': -212623200,
                'time': '1963-04-07T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          92:
              {
                'ts': -196898400,
                'time': '1963-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          93:
              {
                'ts': -181173600,
                'time': '1964-04-05T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          94:
              {
                'ts': -165448800,
                'time': '1964-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          95:
              {
                'ts': -149724000,
                'time': '1965-04-04T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          96:
              {
                'ts': -133999200,
                'time': '1965-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          97:
              {
                'ts': -118274400,
                'time': '1966-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 212544000,
                'time': '1976-09-26T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          99:
              {
                'ts': 228268800,
                'time': '1977-03-27T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          100:
              {
                'ts': 243993600,
                'time': '1977-09-25T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          101:
              {
                'ts': 260323200,
                'time': '1978-04-02T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          102:
              {
                'ts': 276048000,
                'time': '1978-10-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          103:
              {
                'ts': 291772800,
                'time': '1979-04-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          104:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          105:
              {
                'ts': 323222400,
                'time': '1980-03-30T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          106:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          107:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          108:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          109:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          110:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          111:
              {
                'ts': 417578400,
                'time': '1983-03-27T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          112:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          113:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          114:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          115:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          116:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          117:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          118:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          119:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          120:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          121:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          122:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          123:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          124:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          125:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          126:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          127:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          128:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          129:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          130:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          138:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          139:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          140:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          141:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          142:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          143:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          144:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          145:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          146:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          147:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          148:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          149:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          150:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          151:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          152:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          153:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          154:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          155:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          156:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          157:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          158:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          159:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          160:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          161:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          162:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          163:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          164:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          165:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          166:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          167:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          168:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          169:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          170:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          171:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          172:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          173:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          174:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          175:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          176:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          177:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          178:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          179:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          180:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          181:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          182:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          183:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          184:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          185:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          186:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          187:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          188:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          189:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          190:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          191:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          192:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          193:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          194:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          195:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          196:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          197:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          198:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          199:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          200:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          201:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          202:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          203:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          204:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          205:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          206:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          207:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          208:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          209:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          210:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          211:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          212:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          213:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          214:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          215:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          216:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          217:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          218:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          219:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          220:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              }
        },
    'Europe/Ljubljana':
        {
          0:
              {
                'ts': -905824800,
                'time': '1941-04-18T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -777942000,
                'time': '1945-05-08T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -766623600,
                'time': '1945-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': 407199600,
                'time': '1982-11-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/London':
        {
          0:
              {
                'ts': -1691964000,
                'time': '1916-05-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          1:
              {
                'ts': -1680472800,
                'time': '1916-10-01T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          2:
              {
                'ts': -1664143200,
                'time': '1917-04-08T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          3:
              {
                'ts': -1650146400,
                'time': '1917-09-17T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          4:
              {
                'ts': -1633903200,
                'time': '1918-03-24T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          5:
              {
                'ts': -1617487200,
                'time': '1918-09-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          6:
              {
                'ts': -1601848800,
                'time': '1919-03-30T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          7:
              {
                'ts': -1586037600,
                'time': '1919-09-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          8:
              {
                'ts': -1570399200,
                'time': '1920-03-28T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          9:
              {
                'ts': -1552168800,
                'time': '1920-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          10:
              {
                'ts': -1538344800,
                'time': '1921-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          11:
              {
                'ts': -1522533600,
                'time': '1921-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          12:
              {
                'ts': -1507500000,
                'time': '1922-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          13:
              {
                'ts': -1490565600,
                'time': '1922-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          14:
              {
                'ts': -1473631200,
                'time': '1923-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          15:
              {
                'ts': -1460930400,
                'time': '1923-09-16T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          16:
              {
                'ts': -1442786400,
                'time': '1924-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          17:
              {
                'ts': -1428876000,
                'time': '1924-09-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          18:
              {
                'ts': -1410732000,
                'time': '1925-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          19:
              {
                'ts': -1396216800,
                'time': '1925-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          20:
              {
                'ts': -1379282400,
                'time': '1926-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          21:
              {
                'ts': -1364767200,
                'time': '1926-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          22:
              {
                'ts': -1348437600,
                'time': '1927-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          23:
              {
                'ts': -1333317600,
                'time': '1927-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          24:
              {
                'ts': -1315778400,
                'time': '1928-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          25:
              {
                'ts': -1301263200,
                'time': '1928-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          26:
              {
                'ts': -1284328800,
                'time': '1929-04-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          27:
              {
                'ts': -1269813600,
                'time': '1929-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          28:
              {
                'ts': -1253484000,
                'time': '1930-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          29:
              {
                'ts': -1238364000,
                'time': '1930-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          30:
              {
                'ts': -1221429600,
                'time': '1931-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          31:
              {
                'ts': -1206914400,
                'time': '1931-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          32:
              {
                'ts': -1189980000,
                'time': '1932-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          33:
              {
                'ts': -1175464800,
                'time': '1932-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          34:
              {
                'ts': -1159135200,
                'time': '1933-04-09T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          35:
              {
                'ts': -1143410400,
                'time': '1933-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          36:
              {
                'ts': -1126476000,
                'time': '1934-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          37:
              {
                'ts': -1111960800,
                'time': '1934-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          38:
              {
                'ts': -1095631200,
                'time': '1935-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          39:
              {
                'ts': -1080511200,
                'time': '1935-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          40:
              {
                'ts': -1063576800,
                'time': '1936-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          41:
              {
                'ts': -1049061600,
                'time': '1936-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          42:
              {
                'ts': -1032127200,
                'time': '1937-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          43:
              {
                'ts': -1017612000,
                'time': '1937-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          44:
              {
                'ts': -1001282400,
                'time': '1938-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          45:
              {
                'ts': -986162400,
                'time': '1938-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          46:
              {
                'ts': -969228000,
                'time': '1939-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          47:
              {
                'ts': -950479200,
                'time': '1939-11-19T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          48:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          49:
              {
                'ts': -904518000,
                'time': '1941-05-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          50:
              {
                'ts': -896050800,
                'time': '1941-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          51:
              {
                'ts': -875487600,
                'time': '1942-04-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          52:
              {
                'ts': -864601200,
                'time': '1942-08-09T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          53:
              {
                'ts': -844038000,
                'time': '1943-04-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          54:
              {
                'ts': -832546800,
                'time': '1943-08-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          55:
              {
                'ts': -812588400,
                'time': '1944-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          56:
              {
                'ts': -798073200,
                'time': '1944-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          57:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          58:
              {
                'ts': -772066800,
                'time': '1945-07-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          59:
              {
                'ts': -764805600,
                'time': '1945-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          60:
              {
                'ts': -748476000,
                'time': '1946-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          61:
              {
                'ts': -733356000,
                'time': '1946-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          62:
              {
                'ts': -719445600,
                'time': '1947-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          63:
              {
                'ts': -717030000,
                'time': '1947-04-13T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          64:
              {
                'ts': -706748400,
                'time': '1947-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          65:
              {
                'ts': -699487200,
                'time': '1947-11-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          66:
              {
                'ts': -687996000,
                'time': '1948-03-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          67:
              {
                'ts': -668037600,
                'time': '1948-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          68:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          69:
              {
                'ts': -636588000,
                'time': '1949-10-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          70:
              {
                'ts': -622072800,
                'time': '1950-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          71:
              {
                'ts': -605743200,
                'time': '1950-10-22T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          72:
              {
                'ts': -590623200,
                'time': '1951-04-15T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          73:
              {
                'ts': -574293600,
                'time': '1951-10-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          74:
              {
                'ts': -558568800,
                'time': '1952-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          75:
              {
                'ts': -542239200,
                'time': '1952-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          76:
              {
                'ts': -527119200,
                'time': '1953-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          77:
              {
                'ts': -512604000,
                'time': '1953-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          78:
              {
                'ts': -496274400,
                'time': '1954-04-11T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          79:
              {
                'ts': -481154400,
                'time': '1954-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          80:
              {
                'ts': -464220000,
                'time': '1955-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          81:
              {
                'ts': -449704800,
                'time': '1955-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          82:
              {
                'ts': -432165600,
                'time': '1956-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          83:
              {
                'ts': -417650400,
                'time': '1956-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          84:
              {
                'ts': -401320800,
                'time': '1957-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          85:
              {
                'ts': -386200800,
                'time': '1957-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          86:
              {
                'ts': -369266400,
                'time': '1958-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          87:
              {
                'ts': -354751200,
                'time': '1958-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          88:
              {
                'ts': -337816800,
                'time': '1959-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          89:
              {
                'ts': -323301600,
                'time': '1959-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          90:
              {
                'ts': -306972000,
                'time': '1960-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          91:
              {
                'ts': -291852000,
                'time': '1960-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          92:
              {
                'ts': -276732000,
                'time': '1961-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          93:
              {
                'ts': -257983200,
                'time': '1961-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          94:
              {
                'ts': -245282400,
                'time': '1962-03-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          95:
              {
                'ts': -226533600,
                'time': '1962-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          96:
              {
                'ts': -213228000,
                'time': '1963-03-31T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          97:
              {
                'ts': -195084000,
                'time': '1963-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          98:
              {
                'ts': -182383200,
                'time': '1964-03-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          99:
              {
                'ts': -163634400,
                'time': '1964-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          100:
              {
                'ts': -150933600,
                'time': '1965-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          101:
              {
                'ts': -132184800,
                'time': '1965-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          102:
              {
                'ts': -119484000,
                'time': '1966-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          103:
              {
                'ts': -100735200,
                'time': '1966-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          104:
              {
                'ts': -88034400,
                'time': '1967-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          105:
              {
                'ts': -68680800,
                'time': '1967-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          106:
              {
                'ts': -59004000,
                'time': '1968-02-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          107:
              {
                'ts': -37242000,
                'time': '1968-10-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'BST'
              },
          108:
              {
                'ts': 57722400,
                'time': '1971-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          109:
              {
                'ts': 69818400,
                'time': '1972-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          110:
              {
                'ts': 89172000,
                'time': '1972-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          111:
              {
                'ts': 101268000,
                'time': '1973-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          112:
              {
                'ts': 120621600,
                'time': '1973-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          113:
              {
                'ts': 132717600,
                'time': '1974-03-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          114:
              {
                'ts': 152071200,
                'time': '1974-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          115:
              {
                'ts': 164167200,
                'time': '1975-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          116:
              {
                'ts': 183520800,
                'time': '1975-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          117:
              {
                'ts': 196221600,
                'time': '1976-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          118:
              {
                'ts': 214970400,
                'time': '1976-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          119:
              {
                'ts': 227671200,
                'time': '1977-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          120:
              {
                'ts': 246420000,
                'time': '1977-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          121:
              {
                'ts': 259120800,
                'time': '1978-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          122:
              {
                'ts': 278474400,
                'time': '1978-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          123:
              {
                'ts': 290570400,
                'time': '1979-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          124:
              {
                'ts': 309924000,
                'time': '1979-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          125:
              {
                'ts': 322020000,
                'time': '1980-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          126:
              {
                'ts': 341373600,
                'time': '1980-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          127:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          128:
              {
                'ts': 372819600,
                'time': '1981-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          129:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          130:
              {
                'ts': 404269200,
                'time': '1982-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          131:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          132:
              {
                'ts': 435718800,
                'time': '1983-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          133:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          134:
              {
                'ts': 467773200,
                'time': '1984-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          135:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          136:
              {
                'ts': 499222800,
                'time': '1985-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          137:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          138:
              {
                'ts': 530672400,
                'time': '1986-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          139:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          140:
              {
                'ts': 562122000,
                'time': '1987-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          141:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          142:
              {
                'ts': 593571600,
                'time': '1988-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          143:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          144:
              {
                'ts': 625626000,
                'time': '1989-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          145:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          146:
              {
                'ts': 657075600,
                'time': '1990-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          147:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          148:
              {
                'ts': 688525200,
                'time': '1991-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          149:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          150:
              {
                'ts': 719974800,
                'time': '1992-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          151:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          152:
              {
                'ts': 751424400,
                'time': '1993-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          153:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          154:
              {
                'ts': 782874000,
                'time': '1994-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          155:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          156:
              {
                'ts': 814323600,
                'time': '1995-10-22T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          157:
              {
                'ts': 820454400,
                'time': '1996-01-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          158:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          159:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          160:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          161:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          162:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          163:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          164:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          165:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          166:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          167:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          168:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          169:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          170:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          171:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          172:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          173:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          174:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          175:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          176:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          177:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          178:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          179:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          180:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          181:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          182:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          183:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          184:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          185:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          186:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          187:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          188:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          189:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          190:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          191:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          192:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          193:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          194:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          195:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          196:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          197:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          198:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          199:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          200:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          201:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          202:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          203:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          204:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          205:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          206:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          207:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          208:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          209:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          210:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          211:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          212:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          213:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          214:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          215:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          216:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          217:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          218:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          219:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          220:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          221:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          222:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          223:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          224:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          225:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          226:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          227:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          228:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          229:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          230:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          231:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          232:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          233:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          234:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          235:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          236:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          237:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          238:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          239:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          240:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          241:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Europe/Luxembourg':
        {
          0:
              {
                'ts': -2069713476,
                'time': '1904-05-31T23:35:24+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          1:
              {
                'ts': -1692496800,
                'time': '1916-05-14T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          2:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          3:
              {
                'ts': -1662343200,
                'time': '1917-04-28T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          4:
              {
                'ts': -1650157200,
                'time': '1917-09-16T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          5:
              {
                'ts': -1632006000,
                'time': '1918-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          6:
              {
                'ts': -1618700400,
                'time': '1918-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          7:
              {
                'ts': -1612659600,
                'time': '1918-11-24T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          8:
              {
                'ts': -1604278800,
                'time': '1919-03-01T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          9:
              {
                'ts': -1585519200,
                'time': '1919-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          10:
              {
                'ts': -1574038800,
                'time': '1920-02-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          11:
              {
                'ts': -1552258800,
                'time': '1920-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          12:
              {
                'ts': -1539997200,
                'time': '1921-03-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          13:
              {
                'ts': -1520550000,
                'time': '1921-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          14:
              {
                'ts': -1507510800,
                'time': '1922-03-25T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          15:
              {
                'ts': -1490572800,
                'time': '1922-10-08T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          16:
              {
                'ts': -1473642000,
                'time': '1923-04-21T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          17:
              {
                'ts': -1459119600,
                'time': '1923-10-07T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          18:
              {
                'ts': -1444006800,
                'time': '1924-03-29T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          19:
              {
                'ts': -1427673600,
                'time': '1924-10-05T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          20:
              {
                'ts': -1411866000,
                'time': '1925-04-05T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          21:
              {
                'ts': -1396224000,
                'time': '1925-10-04T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          22:
              {
                'ts': -1379293200,
                'time': '1926-04-17T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          23:
              {
                'ts': -1364774400,
                'time': '1926-10-03T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          24:
              {
                'ts': -1348448400,
                'time': '1927-04-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          25:
              {
                'ts': -1333324800,
                'time': '1927-10-02T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          26:
              {
                'ts': -1316394000,
                'time': '1928-04-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          27:
              {
                'ts': -1301270400,
                'time': '1928-10-07T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          28:
              {
                'ts': -1284339600,
                'time': '1929-04-20T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          29:
              {
                'ts': -1269813600,
                'time': '1929-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          30:
              {
                'ts': -1253484000,
                'time': '1930-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          31:
              {
                'ts': -1238364000,
                'time': '1930-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          32:
              {
                'ts': -1221429600,
                'time': '1931-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          33:
              {
                'ts': -1206914400,
                'time': '1931-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          34:
              {
                'ts': -1191189600,
                'time': '1932-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          35:
              {
                'ts': -1175464800,
                'time': '1932-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          36:
              {
                'ts': -1160344800,
                'time': '1933-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          37:
              {
                'ts': -1143410400,
                'time': '1933-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          38:
              {
                'ts': -1127685600,
                'time': '1934-04-08T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          39:
              {
                'ts': -1111960800,
                'time': '1934-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          40:
              {
                'ts': -1096840800,
                'time': '1935-03-31T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          41:
              {
                'ts': -1080511200,
                'time': '1935-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          42:
              {
                'ts': -1063576800,
                'time': '1936-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          43:
              {
                'ts': -1049061600,
                'time': '1936-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          44:
              {
                'ts': -1033336800,
                'time': '1937-04-04T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          45:
              {
                'ts': -1017612000,
                'time': '1937-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          46:
              {
                'ts': -1002492000,
                'time': '1938-03-27T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          47:
              {
                'ts': -986162400,
                'time': '1938-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          48:
              {
                'ts': -969228000,
                'time': '1939-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          49:
              {
                'ts': -950479200,
                'time': '1939-11-19T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          50:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          51:
              {
                'ts': -935186400,
                'time': '1940-05-14T02:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEST'
              },
          52:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WET'
              },
          53:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEST'
              },
          54:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'WET'
              },
          55:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEST'
              },
          56:
              {
                'ts': -797986800,
                'time': '1944-09-18T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': -766623600,
                'time': '1945-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': -745455600,
                'time': '1946-05-19T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': -733273200,
                'time': '1946-10-07T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 220921200,
                'time': '1976-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 228877200,
                'time': '1977-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 243997200,
                'time': '1977-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 260326800,
                'time': '1978-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 276051600,
                'time': '1978-10-01T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 291776400,
                'time': '1979-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          67:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          68:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          69:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          70:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          71:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          72:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          73:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          74:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          75:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          76:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          77:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          78:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          79:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          80:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          81:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          82:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          83:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          84:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          85:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          86:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          87:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          88:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          89:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          90:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          91:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          92:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          93:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          94:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          95:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          96:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          97:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          99:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          100:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          101:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          102:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          103:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          104:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          105:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          106:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          107:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          108:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          109:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          110:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          111:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          112:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          113:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          114:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          115:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          116:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          117:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          118:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          119:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          120:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          121:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          122:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          123:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          124:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          125:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          126:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          127:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          128:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          129:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          130:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          131:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          132:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          133:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          134:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          135:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          136:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          137:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          138:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          139:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          140:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          141:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          142:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          143:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          144:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          145:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          146:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          147:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          148:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          149:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          150:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          151:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          152:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          153:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          154:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          155:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          156:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          157:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          158:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          159:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          160:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          161:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          162:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          163:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          164:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          165:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          166:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          167:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          168:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          169:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          170:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          171:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          172:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          173:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          174:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          175:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          176:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          177:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          178:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          179:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          180:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          181:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          182:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          183:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Madrid':
        {
          0:
              {
                'ts': -1661734800,
                'time': '1917-05-05T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          1:
              {
                'ts': -1648429200,
                'time': '1917-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          2:
              {
                'ts': -1631926800,
                'time': '1918-04-15T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          3:
              {
                'ts': -1616893200,
                'time': '1918-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          4:
              {
                'ts': -1601254800,
                'time': '1919-04-05T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          5:
              {
                'ts': -1585357200,
                'time': '1919-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          6:
              {
                'ts': -1442451600,
                'time': '1924-04-16T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          7:
              {
                'ts': -1427677200,
                'time': '1924-10-04T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          8:
              {
                'ts': -1379293200,
                'time': '1926-04-17T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          9:
              {
                'ts': -1364778000,
                'time': '1926-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          10:
              {
                'ts': -1348448400,
                'time': '1927-04-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          11:
              {
                'ts': -1333328400,
                'time': '1927-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          12:
              {
                'ts': -1316394000,
                'time': '1928-04-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          13:
              {
                'ts': -1301274000,
                'time': '1928-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          14:
              {
                'ts': -1284339600,
                'time': '1929-04-20T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          15:
              {
                'ts': -1269824400,
                'time': '1929-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          16:
              {
                'ts': -1029114000,
                'time': '1937-05-22T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          17:
              {
                'ts': -1017622800,
                'time': '1937-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          18:
              {
                'ts': -1002848400,
                'time': '1938-03-22T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          19:
              {
                'ts': -986173200,
                'time': '1938-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          20:
              {
                'ts': -969238800,
                'time': '1939-04-15T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          21:
              {
                'ts': -954118800,
                'time': '1939-10-07T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          22:
              {
                'ts': -940208400,
                'time': '1940-03-16T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          23:
              {
                'ts': -873079200,
                'time': '1942-05-02T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          24:
              {
                'ts': -862538400,
                'time': '1942-09-01T22:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          25:
              {
                'ts': -842839200,
                'time': '1943-04-17T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          26:
              {
                'ts': -828237600,
                'time': '1943-10-03T22:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          27:
              {
                'ts': -811389600,
                'time': '1944-04-15T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          28:
              {
                'ts': -796010400,
                'time': '1944-10-10T22:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          29:
              {
                'ts': -779940000,
                'time': '1945-04-14T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          30:
              {
                'ts': -765421200,
                'time': '1945-09-29T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          31:
              {
                'ts': -748490400,
                'time': '1946-04-13T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          32:
              {
                'ts': -733888800,
                'time': '1946-09-29T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': -652327200,
                'time': '1949-04-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': -639190800,
                'time': '1949-09-29T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 135122400,
                'time': '1974-04-13T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 150246000,
                'time': '1974-10-05T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 167176800,
                'time': '1975-04-19T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 181695600,
                'time': '1975-10-04T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 196812000,
                'time': '1976-03-27T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 212540400,
                'time': '1976-09-25T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 228866400,
                'time': '1977-04-02T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 243990000,
                'time': '1977-09-24T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 260402400,
                'time': '1978-04-02T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 276044400,
                'time': '1978-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 291776400,
                'time': '1979-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          141:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          142:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          143:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          144:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          145:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          146:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          147:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          148:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          149:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          150:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          151:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          152:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          153:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          154:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          155:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          156:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          157:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          158:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          159:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          160:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          161:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          162:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Malta':
        {
          0:
              {
                'ts': -1690851600,
                'time': '1916-06-02T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -1664758800,
                'time': '1917-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -1649034000,
                'time': '1917-09-29T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -1635123600,
                'time': '1918-03-09T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -1616979600,
                'time': '1918-10-05T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -1604278800,
                'time': '1919-03-01T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -1585530000,
                'time': '1919-10-04T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -1571014800,
                'time': '1920-03-20T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -1555290000,
                'time': '1920-09-18T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -932432400,
                'time': '1940-06-14T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          17:
              {
                'ts': -766717200,
                'time': '1945-09-14T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': -750898800,
                'time': '1946-03-17T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': -733359600,
                'time': '1946-10-06T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          20:
              {
                'ts': -719456400,
                'time': '1947-03-15T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          21:
              {
                'ts': -701917200,
                'time': '1947-10-04T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': -689209200,
                'time': '1948-02-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          23:
              {
                'ts': -670460400,
                'time': '1948-10-03T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          24:
              {
                'ts': -114051600,
                'time': '1966-05-21T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          25:
              {
                'ts': -103168800,
                'time': '1966-09-24T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          26:
              {
                'ts': -81997200,
                'time': '1967-05-27T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          27:
              {
                'ts': -71719200,
                'time': '1967-09-23T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          28:
              {
                'ts': -50547600,
                'time': '1968-05-25T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          29:
              {
                'ts': -40269600,
                'time': '1968-09-21T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          30:
              {
                'ts': -18493200,
                'time': '1969-05-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          31:
              {
                'ts': -8215200,
                'time': '1969-09-27T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          32:
              {
                'ts': 12956400,
                'time': '1970-05-30T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          33:
              {
                'ts': 23234400,
                'time': '1970-09-26T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          34:
              {
                'ts': 43801200,
                'time': '1971-05-22T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          35:
              {
                'ts': 54687600,
                'time': '1971-09-25T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          36:
              {
                'ts': 75855600,
                'time': '1972-05-27T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          37:
              {
                'ts': 86738400,
                'time': '1972-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          38:
              {
                'ts': 102380400,
                'time': '1973-03-30T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          39:
              {
                'ts': 118105200,
                'time': '1973-09-28T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          40:
              {
                'ts': 135730800,
                'time': '1974-04-20T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          41:
              {
                'ts': 148518000,
                'time': '1974-09-15T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          42:
              {
                'ts': 167187600,
                'time': '1975-04-20T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          43:
              {
                'ts': 180489600,
                'time': '1975-09-21T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          44:
              {
                'ts': 198637200,
                'time': '1976-04-18T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          45:
              {
                'ts': 211939200,
                'time': '1976-09-19T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          46:
              {
                'ts': 230086800,
                'time': '1977-04-17T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          47:
              {
                'ts': 243388800,
                'time': '1977-09-18T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          48:
              {
                'ts': 261536400,
                'time': '1978-04-16T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          49:
              {
                'ts': 274838400,
                'time': '1978-09-17T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          50:
              {
                'ts': 292986000,
                'time': '1979-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          51:
              {
                'ts': 306288000,
                'time': '1979-09-16T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          52:
              {
                'ts': 323312400,
                'time': '1980-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          53:
              {
                'ts': 338342400,
                'time': '1980-09-21T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          56:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          57:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          67:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          68:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          69:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          70:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          71:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          72:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          73:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          74:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          75:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          76:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          77:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          78:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          79:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          80:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          81:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          82:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          83:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          84:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          85:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          86:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          87:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          88:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          89:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          90:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          91:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          92:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          93:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          94:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          95:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          96:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          97:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          99:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          100:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          101:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          102:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          103:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          104:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          105:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          106:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          107:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          108:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          109:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          110:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          111:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          112:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          113:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          114:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          115:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          116:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          117:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          118:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          119:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          120:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          121:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          122:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          123:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          124:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          125:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          126:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          127:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          128:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          129:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          130:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          131:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          132:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          133:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          134:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          135:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          136:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          137:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          138:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          139:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          140:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          141:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          142:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          143:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          144:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          145:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          146:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          147:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          148:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          149:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          150:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          151:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          152:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          153:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          154:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          155:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          156:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          157:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          158:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          159:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          160:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          161:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          162:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          163:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          164:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          165:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          166:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          167:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Mariehamn':
        {
          0:
              {
                'ts': -1535938792,
                'time': '1921-04-30T22:20:08+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -875671200,
                'time': '1942-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          2:
              {
                'ts': -859863600,
                'time': '1942-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          4:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          6:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          10:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          11:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          12:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          14:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          15:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          16:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          17:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          18:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          19:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          20:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          21:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          22:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          23:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          24:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          25:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          26:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Minsk':
        {
          0:
              {
                'ts': -1441158600,
                'time': '1924-05-01T22:10:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -1247536800,
                'time': '1930-06-20T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          2:
              {
                'ts': -899780400,
                'time': '1941-06-27T21:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -804650400,
                'time': '1944-07-02T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          8:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          9:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          10:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          11:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          12:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          13:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          14:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          15:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          16:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          17:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          18:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          19:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          20:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          21:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          22:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          23:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          24:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          25:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          26:
              {
                'ts': 631141200,
                'time': '1989-12-31T21:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          27:
              {
                'ts': 670374000,
                'time': '1991-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': 686102400,
                'time': '1991-09-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 717544800,
                'time': '1992-09-26T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 733276800,
                'time': '1993-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 749001600,
                'time': '1993-09-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 764726400,
                'time': '1994-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 780451200,
                'time': '1994-09-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 796176000,
                'time': '1995-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 811900800,
                'time': '1995-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 828230400,
                'time': '1996-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 846374400,
                'time': '1996-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 859680000,
                'time': '1997-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 877824000,
                'time': '1997-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 891129600,
                'time': '1998-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 909273600,
                'time': '1998-10-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 922579200,
                'time': '1999-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 941328000,
                'time': '1999-10-31T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 954028800,
                'time': '2000-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 972777600,
                'time': '2000-10-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 985478400,
                'time': '2001-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 1004227200,
                'time': '2001-10-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 1017532800,
                'time': '2002-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 1035676800,
                'time': '2002-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 1048982400,
                'time': '2003-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 1067126400,
                'time': '2003-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 1080432000,
                'time': '2004-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1099180800,
                'time': '2004-10-31T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1111881600,
                'time': '2005-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1130630400,
                'time': '2005-10-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1143331200,
                'time': '2006-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1162080000,
                'time': '2006-10-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1174780800,
                'time': '2007-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1193529600,
                'time': '2007-10-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1206835200,
                'time': '2008-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1224979200,
                'time': '2008-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1238284800,
                'time': '2009-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1256428800,
                'time': '2009-10-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1269734400,
                'time': '2010-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1288483200,
                'time': '2010-10-31T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1301184000,
                'time': '2011-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1319932800,
                'time': '2011-10-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1332633600,
                'time': '2012-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1351382400,
                'time': '2012-10-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1364688000,
                'time': '2013-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1382832000,
                'time': '2013-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1396137600,
                'time': '2014-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1414281600,
                'time': '2014-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1427587200,
                'time': '2015-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1445731200,
                'time': '2015-10-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1459036800,
                'time': '2016-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1477785600,
                'time': '2016-10-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1490486400,
                'time': '2017-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1509235200,
                'time': '2017-10-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1521936000,
                'time': '2018-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1540684800,
                'time': '2018-10-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1553990400,
                'time': '2019-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1572134400,
                'time': '2019-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1585440000,
                'time': '2020-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1603584000,
                'time': '2020-10-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1616889600,
                'time': '2021-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1635638400,
                'time': '2021-10-31T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1648339200,
                'time': '2022-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1667088000,
                'time': '2022-10-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1679788800,
                'time': '2023-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1698537600,
                'time': '2023-10-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1711843200,
                'time': '2024-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1729987200,
                'time': '2024-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1743292800,
                'time': '2025-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1761436800,
                'time': '2025-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1774742400,
                'time': '2026-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1792886400,
                'time': '2026-10-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1806192000,
                'time': '2027-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1824940800,
                'time': '2027-10-31T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1837641600,
                'time': '2028-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1856390400,
                'time': '2028-10-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1869091200,
                'time': '2029-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1887840000,
                'time': '2029-10-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1901145600,
                'time': '2030-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1919289600,
                'time': '2030-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1932595200,
                'time': '2031-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1950739200,
                'time': '2031-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1964044800,
                'time': '2032-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1982793600,
                'time': '2032-10-31T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1995494400,
                'time': '2033-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 2014243200,
                'time': '2033-10-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 2026944000,
                'time': '2034-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 2045692800,
                'time': '2034-10-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 2058393600,
                'time': '2035-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 2077142400,
                'time': '2035-10-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 2090448000,
                'time': '2036-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 2108592000,
                'time': '2036-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 2121897600,
                'time': '2037-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 2140041600,
                'time': '2037-10-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Monaco':
        {
          0:
              {
                'ts': -1855958961,
                'time': '1911-03-10T23:50:39+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          1:
              {
                'ts': -1689814800,
                'time': '1916-06-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          2:
              {
                'ts': -1680397200,
                'time': '1916-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          3:
              {
                'ts': -1665363600,
                'time': '1917-03-24T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          4:
              {
                'ts': -1648342800,
                'time': '1917-10-07T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          5:
              {
                'ts': -1635123600,
                'time': '1918-03-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          6:
              {
                'ts': -1616893200,
                'time': '1918-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          7:
              {
                'ts': -1604278800,
                'time': '1919-03-01T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          8:
              {
                'ts': -1585443600,
                'time': '1919-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          9:
              {
                'ts': -1574038800,
                'time': '1920-02-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          10:
              {
                'ts': -1552266000,
                'time': '1920-10-23T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          11:
              {
                'ts': -1539997200,
                'time': '1921-03-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          12:
              {
                'ts': -1520557200,
                'time': '1921-10-25T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          13:
              {
                'ts': -1507510800,
                'time': '1922-03-25T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          14:
              {
                'ts': -1490576400,
                'time': '1922-10-07T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          15:
              {
                'ts': -1470618000,
                'time': '1923-05-26T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          16:
              {
                'ts': -1459126800,
                'time': '1923-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          17:
              {
                'ts': -1444006800,
                'time': '1924-03-29T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          18:
              {
                'ts': -1427677200,
                'time': '1924-10-04T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          19:
              {
                'ts': -1411952400,
                'time': '1925-04-04T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          20:
              {
                'ts': -1396227600,
                'time': '1925-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          21:
              {
                'ts': -1379293200,
                'time': '1926-04-17T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          22:
              {
                'ts': -1364778000,
                'time': '1926-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          23:
              {
                'ts': -1348448400,
                'time': '1927-04-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          24:
              {
                'ts': -1333328400,
                'time': '1927-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          25:
              {
                'ts': -1316394000,
                'time': '1928-04-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          26:
              {
                'ts': -1301274000,
                'time': '1928-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          27:
              {
                'ts': -1284339600,
                'time': '1929-04-20T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          28:
              {
                'ts': -1269824400,
                'time': '1929-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          29:
              {
                'ts': -1253494800,
                'time': '1930-04-12T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          30:
              {
                'ts': -1238374800,
                'time': '1930-10-04T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          31:
              {
                'ts': -1221440400,
                'time': '1931-04-18T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          32:
              {
                'ts': -1206925200,
                'time': '1931-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          33:
              {
                'ts': -1191200400,
                'time': '1932-04-02T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          34:
              {
                'ts': -1175475600,
                'time': '1932-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          35:
              {
                'ts': -1160355600,
                'time': '1933-03-25T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          36:
              {
                'ts': -1143421200,
                'time': '1933-10-07T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          37:
              {
                'ts': -1127696400,
                'time': '1934-04-07T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          38:
              {
                'ts': -1111971600,
                'time': '1934-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          39:
              {
                'ts': -1096851600,
                'time': '1935-03-30T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          40:
              {
                'ts': -1080522000,
                'time': '1935-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          41:
              {
                'ts': -1063587600,
                'time': '1936-04-18T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          42:
              {
                'ts': -1049072400,
                'time': '1936-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          43:
              {
                'ts': -1033347600,
                'time': '1937-04-03T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          44:
              {
                'ts': -1017622800,
                'time': '1937-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          45:
              {
                'ts': -1002502800,
                'time': '1938-03-26T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          46:
              {
                'ts': -986173200,
                'time': '1938-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          47:
              {
                'ts': -969238800,
                'time': '1939-04-15T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          48:
              {
                'ts': -950490000,
                'time': '1939-11-18T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          49:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          50:
              {
                'ts': -904438800,
                'time': '1941-05-04T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          51:
              {
                'ts': -891136800,
                'time': '1941-10-05T22:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          52:
              {
                'ts': -877827600,
                'time': '1942-03-08T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          53:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          54:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          55:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          56:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          57:
              {
                'ts': -796266000,
                'time': '1944-10-07T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          58:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          59:
              {
                'ts': -766623600,
                'time': '1945-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 196819200,
                'time': '1976-03-28T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 212540400,
                'time': '1976-09-25T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 228877200,
                'time': '1977-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 243997200,
                'time': '1977-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 260326800,
                'time': '1978-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 276051600,
                'time': '1978-10-01T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 291776400,
                'time': '1979-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          67:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          68:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          69:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          70:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          71:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          72:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          73:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          74:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          75:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          76:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          77:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          78:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          79:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          80:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          81:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          82:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          83:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          84:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          85:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          86:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          87:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          88:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          89:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          90:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          91:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          92:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          93:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          94:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          95:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          96:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          97:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          99:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          100:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          101:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          102:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          103:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          104:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          105:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          106:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          107:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          108:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          109:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          110:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          111:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          112:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          113:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          114:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          115:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          116:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          117:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          118:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          119:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          120:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          121:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          122:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          123:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          124:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          125:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          126:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          127:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          128:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          129:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          130:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          131:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          132:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          133:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          134:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          135:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          136:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          137:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          138:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          139:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          140:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          141:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          142:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          143:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          144:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          145:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          146:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          147:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          148:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          149:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          150:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          151:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          152:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          153:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          154:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          155:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          156:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          157:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          158:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          159:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          160:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          161:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          162:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          163:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          164:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          165:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          166:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          167:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          168:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          169:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          170:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          171:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          172:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          173:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          174:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          175:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          176:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          177:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          178:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          179:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          180:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          181:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          182:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          183:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Moscow':
        {
          0:
              {
                'ts': -1688265000,
                'time': '1916-07-02T21:30:00+0000',
                'offset': 9048,
                'isdst': false,
                'abbr': 'MMT'
              },
          1:
              {
                'ts': -1656819048,
                'time': '1917-07-01T20:29:12+0000',
                'offset': 12648,
                'isdst': true,
                'abbr': 'MST'
              },
          2:
              {
                'ts': -1641353448,
                'time': '1917-12-27T20:29:12+0000',
                'offset': 9048,
                'isdst': false,
                'abbr': 'MMT'
              },
          3:
              {
                'ts': -1627965048,
                'time': '1918-05-31T19:29:12+0000',
                'offset': 16248,
                'isdst': true,
                'abbr': 'MDST'
              },
          4:
              {
                'ts': -1618716648,
                'time': '1918-09-15T20:29:12+0000',
                'offset': 12648,
                'isdst': true,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1596429048,
                'time': '1919-05-31T19:29:12+0000',
                'offset': 16248,
                'isdst': true,
                'abbr': 'MDST'
              },
          6:
              {
                'ts': -1593829848,
                'time': '1919-06-30T21:29:12+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          7:
              {
                'ts': -1589860800,
                'time': '1919-08-15T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          8:
              {
                'ts': -1542427200,
                'time': '1921-02-14T20:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          9:
              {
                'ts': -1539493200,
                'time': '1921-03-20T19:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'MSD'
              },
          10:
              {
                'ts': -1525323600,
                'time': '1921-08-31T19:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          11:
              {
                'ts': -1522728000,
                'time': '1921-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          12:
              {
                'ts': -1491188400,
                'time': '1922-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': -1247536800,
                'time': '1930-06-20T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          14:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          15:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          16:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          17:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          18:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          19:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          20:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          21:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          22:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          23:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          24:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          25:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          26:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          27:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          28:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          29:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          30:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          31:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          32:
              {
                'ts': 638319600,
                'time': '1990-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          33:
              {
                'ts': 654649200,
                'time': '1990-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          34:
              {
                'ts': 670374000,
                'time': '1991-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          35:
              {
                'ts': 686102400,
                'time': '1991-09-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          36:
              {
                'ts': 695779200,
                'time': '1992-01-19T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          37:
              {
                'ts': 701812800,
                'time': '1992-03-28T20:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          38:
              {
                'ts': 717534000,
                'time': '1992-09-26T19:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          39:
              {
                'ts': 733273200,
                'time': '1993-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          40:
              {
                'ts': 748998000,
                'time': '1993-09-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          41:
              {
                'ts': 764722800,
                'time': '1994-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          42:
              {
                'ts': 780447600,
                'time': '1994-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          43:
              {
                'ts': 796172400,
                'time': '1995-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          44:
              {
                'ts': 811897200,
                'time': '1995-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          45:
              {
                'ts': 828226800,
                'time': '1996-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          46:
              {
                'ts': 846370800,
                'time': '1996-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          47:
              {
                'ts': 859676400,
                'time': '1997-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          48:
              {
                'ts': 877820400,
                'time': '1997-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          49:
              {
                'ts': 891126000,
                'time': '1998-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          50:
              {
                'ts': 909270000,
                'time': '1998-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          51:
              {
                'ts': 922575600,
                'time': '1999-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          52:
              {
                'ts': 941324400,
                'time': '1999-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          53:
              {
                'ts': 954025200,
                'time': '2000-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          54:
              {
                'ts': 972774000,
                'time': '2000-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          55:
              {
                'ts': 985474800,
                'time': '2001-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          56:
              {
                'ts': 1004223600,
                'time': '2001-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          57:
              {
                'ts': 1017529200,
                'time': '2002-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          58:
              {
                'ts': 1035673200,
                'time': '2002-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          59:
              {
                'ts': 1048978800,
                'time': '2003-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          60:
              {
                'ts': 1067122800,
                'time': '2003-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          61:
              {
                'ts': 1080428400,
                'time': '2004-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          62:
              {
                'ts': 1099177200,
                'time': '2004-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          63:
              {
                'ts': 1111878000,
                'time': '2005-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          64:
              {
                'ts': 1130626800,
                'time': '2005-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          65:
              {
                'ts': 1143327600,
                'time': '2006-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          66:
              {
                'ts': 1162076400,
                'time': '2006-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          67:
              {
                'ts': 1174777200,
                'time': '2007-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          68:
              {
                'ts': 1193526000,
                'time': '2007-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          69:
              {
                'ts': 1206831600,
                'time': '2008-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          70:
              {
                'ts': 1224975600,
                'time': '2008-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          71:
              {
                'ts': 1238281200,
                'time': '2009-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          72:
              {
                'ts': 1256425200,
                'time': '2009-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          73:
              {
                'ts': 1269730800,
                'time': '2010-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          74:
              {
                'ts': 1288479600,
                'time': '2010-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          75:
              {
                'ts': 1301180400,
                'time': '2011-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          76:
              {
                'ts': 1319929200,
                'time': '2011-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          77:
              {
                'ts': 1332630000,
                'time': '2012-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          78:
              {
                'ts': 1351378800,
                'time': '2012-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          79:
              {
                'ts': 1364684400,
                'time': '2013-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          80:
              {
                'ts': 1382828400,
                'time': '2013-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          81:
              {
                'ts': 1396134000,
                'time': '2014-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          82:
              {
                'ts': 1414278000,
                'time': '2014-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          83:
              {
                'ts': 1427583600,
                'time': '2015-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          84:
              {
                'ts': 1445727600,
                'time': '2015-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          85:
              {
                'ts': 1459033200,
                'time': '2016-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          86:
              {
                'ts': 1477782000,
                'time': '2016-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          87:
              {
                'ts': 1490482800,
                'time': '2017-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          88:
              {
                'ts': 1509231600,
                'time': '2017-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          89:
              {
                'ts': 1521932400,
                'time': '2018-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          90:
              {
                'ts': 1540681200,
                'time': '2018-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          91:
              {
                'ts': 1553986800,
                'time': '2019-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          92:
              {
                'ts': 1572130800,
                'time': '2019-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          93:
              {
                'ts': 1585436400,
                'time': '2020-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          94:
              {
                'ts': 1603580400,
                'time': '2020-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          95:
              {
                'ts': 1616886000,
                'time': '2021-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          96:
              {
                'ts': 1635634800,
                'time': '2021-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          97:
              {
                'ts': 1648335600,
                'time': '2022-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          98:
              {
                'ts': 1667084400,
                'time': '2022-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          99:
              {
                'ts': 1679785200,
                'time': '2023-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          100:
              {
                'ts': 1698534000,
                'time': '2023-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          101:
              {
                'ts': 1711839600,
                'time': '2024-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          102:
              {
                'ts': 1729983600,
                'time': '2024-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          103:
              {
                'ts': 1743289200,
                'time': '2025-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          104:
              {
                'ts': 1761433200,
                'time': '2025-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          105:
              {
                'ts': 1774738800,
                'time': '2026-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          106:
              {
                'ts': 1792882800,
                'time': '2026-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          107:
              {
                'ts': 1806188400,
                'time': '2027-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          108:
              {
                'ts': 1824937200,
                'time': '2027-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          109:
              {
                'ts': 1837638000,
                'time': '2028-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          110:
              {
                'ts': 1856386800,
                'time': '2028-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          111:
              {
                'ts': 1869087600,
                'time': '2029-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          112:
              {
                'ts': 1887836400,
                'time': '2029-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          113:
              {
                'ts': 1901142000,
                'time': '2030-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          114:
              {
                'ts': 1919286000,
                'time': '2030-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          115:
              {
                'ts': 1932591600,
                'time': '2031-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          116:
              {
                'ts': 1950735600,
                'time': '2031-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          117:
              {
                'ts': 1964041200,
                'time': '2032-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          118:
              {
                'ts': 1982790000,
                'time': '2032-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          119:
              {
                'ts': 1995490800,
                'time': '2033-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          120:
              {
                'ts': 2014239600,
                'time': '2033-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          121:
              {
                'ts': 2026940400,
                'time': '2034-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          122:
              {
                'ts': 2045689200,
                'time': '2034-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          123:
              {
                'ts': 2058390000,
                'time': '2035-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          124:
              {
                'ts': 2077138800,
                'time': '2035-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          125:
              {
                'ts': 2090444400,
                'time': '2036-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          126:
              {
                'ts': 2108588400,
                'time': '2036-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          127:
              {
                'ts': 2121894000,
                'time': '2037-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          128:
              {
                'ts': 2140038000,
                'time': '2037-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              }
        },
    'Europe/Nicosia':
        {
          0:
              {
                'ts': -1518920008,
                'time': '1921-11-13T21:46:32+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': 166572000,
                'time': '1975-04-12T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          2:
              {
                'ts': 182293200,
                'time': '1975-10-11T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': 200959200,
                'time': '1976-05-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          4:
              {
                'ts': 213829200,
                'time': '1976-10-10T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': 228866400,
                'time': '1977-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          6:
              {
                'ts': 243982800,
                'time': '1977-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': 260316000,
                'time': '1978-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': 276123600,
                'time': '1978-10-01T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': 291765600,
                'time': '1979-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          10:
              {
                'ts': 307486800,
                'time': '1979-09-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          11:
              {
                'ts': 323820000,
                'time': '1980-04-05T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          12:
              {
                'ts': 338936400,
                'time': '1980-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': 354664800,
                'time': '1981-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          14:
              {
                'ts': 370386000,
                'time': '1981-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          15:
              {
                'ts': 386114400,
                'time': '1982-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          16:
              {
                'ts': 401835600,
                'time': '1982-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          17:
              {
                'ts': 417564000,
                'time': '1983-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          18:
              {
                'ts': 433285200,
                'time': '1983-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          19:
              {
                'ts': 449013600,
                'time': '1984-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          20:
              {
                'ts': 465339600,
                'time': '1984-09-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          21:
              {
                'ts': 481068000,
                'time': '1985-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          22:
              {
                'ts': 496789200,
                'time': '1985-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          23:
              {
                'ts': 512517600,
                'time': '1986-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          24:
              {
                'ts': 528238800,
                'time': '1986-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          25:
              {
                'ts': 543967200,
                'time': '1987-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          26:
              {
                'ts': 559688400,
                'time': '1987-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': 575416800,
                'time': '1988-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': 591138000,
                'time': '1988-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 606866400,
                'time': '1989-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 622587600,
                'time': '1989-09-23T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 638316000,
                'time': '1990-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 654642000,
                'time': '1990-09-29T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 670370400,
                'time': '1991-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 686091600,
                'time': '1991-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 717541200,
                'time': '1992-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 796168800,
                'time': '1995-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 811890000,
                'time': '1995-09-23T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 828223200,
                'time': '1996-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 843944400,
                'time': '1996-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 859672800,
                'time': '1997-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 875394000,
                'time': '1997-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 891122400,
                'time': '1998-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          121:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          122:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          123:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          124:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          125:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          126:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Oslo':
        {
          0:
              {
                'ts': -1691884800,
                'time': '1916-05-22T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680573600,
                'time': '1916-09-29T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -927511200,
                'time': '1940-08-10T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -765327600,
                'time': '1945-10-01T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -340844400,
                'time': '1959-03-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -324514800,
                'time': '1959-09-20T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -308790000,
                'time': '1960-03-20T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -293065200,
                'time': '1960-09-18T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': -277340400,
                'time': '1961-03-19T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -261615600,
                'time': '1961-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': -245890800,
                'time': '1962-03-18T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          17:
              {
                'ts': -230166000,
                'time': '1962-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': -214441200,
                'time': '1963-03-17T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': -198716400,
                'time': '1963-09-15T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          20:
              {
                'ts': -182991600,
                'time': '1964-03-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          21:
              {
                'ts': -166662000,
                'time': '1964-09-20T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': -147913200,
                'time': '1965-04-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          23:
              {
                'ts': -135212400,
                'time': '1965-09-19T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          24:
              {
                'ts': 315529200,
                'time': '1979-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Paris':
        {
          0:
              {
                'ts': -1855958901,
                'time': '1911-03-10T23:51:39+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          1:
              {
                'ts': -1689814800,
                'time': '1916-06-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          2:
              {
                'ts': -1680397200,
                'time': '1916-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          3:
              {
                'ts': -1665363600,
                'time': '1917-03-24T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          4:
              {
                'ts': -1648342800,
                'time': '1917-10-07T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          5:
              {
                'ts': -1635123600,
                'time': '1918-03-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          6:
              {
                'ts': -1616893200,
                'time': '1918-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          7:
              {
                'ts': -1604278800,
                'time': '1919-03-01T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          8:
              {
                'ts': -1585443600,
                'time': '1919-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          9:
              {
                'ts': -1574038800,
                'time': '1920-02-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          10:
              {
                'ts': -1552266000,
                'time': '1920-10-23T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          11:
              {
                'ts': -1539997200,
                'time': '1921-03-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          12:
              {
                'ts': -1520557200,
                'time': '1921-10-25T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          13:
              {
                'ts': -1507510800,
                'time': '1922-03-25T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          14:
              {
                'ts': -1490576400,
                'time': '1922-10-07T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          15:
              {
                'ts': -1470618000,
                'time': '1923-05-26T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          16:
              {
                'ts': -1459126800,
                'time': '1923-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          17:
              {
                'ts': -1444006800,
                'time': '1924-03-29T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          18:
              {
                'ts': -1427677200,
                'time': '1924-10-04T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          19:
              {
                'ts': -1411952400,
                'time': '1925-04-04T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          20:
              {
                'ts': -1396227600,
                'time': '1925-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          21:
              {
                'ts': -1379293200,
                'time': '1926-04-17T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          22:
              {
                'ts': -1364778000,
                'time': '1926-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          23:
              {
                'ts': -1348448400,
                'time': '1927-04-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          24:
              {
                'ts': -1333328400,
                'time': '1927-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          25:
              {
                'ts': -1316394000,
                'time': '1928-04-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          26:
              {
                'ts': -1301274000,
                'time': '1928-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          27:
              {
                'ts': -1284339600,
                'time': '1929-04-20T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          28:
              {
                'ts': -1269824400,
                'time': '1929-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          29:
              {
                'ts': -1253494800,
                'time': '1930-04-12T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          30:
              {
                'ts': -1238374800,
                'time': '1930-10-04T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          31:
              {
                'ts': -1221440400,
                'time': '1931-04-18T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          32:
              {
                'ts': -1206925200,
                'time': '1931-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          33:
              {
                'ts': -1191200400,
                'time': '1932-04-02T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          34:
              {
                'ts': -1175475600,
                'time': '1932-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          35:
              {
                'ts': -1160355600,
                'time': '1933-03-25T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          36:
              {
                'ts': -1143421200,
                'time': '1933-10-07T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          37:
              {
                'ts': -1127696400,
                'time': '1934-04-07T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          38:
              {
                'ts': -1111971600,
                'time': '1934-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          39:
              {
                'ts': -1096851600,
                'time': '1935-03-30T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          40:
              {
                'ts': -1080522000,
                'time': '1935-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          41:
              {
                'ts': -1063587600,
                'time': '1936-04-18T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          42:
              {
                'ts': -1049072400,
                'time': '1936-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          43:
              {
                'ts': -1033347600,
                'time': '1937-04-03T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          44:
              {
                'ts': -1017622800,
                'time': '1937-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          45:
              {
                'ts': -1002502800,
                'time': '1938-03-26T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          46:
              {
                'ts': -986173200,
                'time': '1938-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          47:
              {
                'ts': -969238800,
                'time': '1939-04-15T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          48:
              {
                'ts': -950490000,
                'time': '1939-11-18T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          49:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          50:
              {
                'ts': -932436000,
                'time': '1940-06-14T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          51:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          52:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          53:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': -800071200,
                'time': '1944-08-24T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          56:
              {
                'ts': -796266000,
                'time': '1944-10-07T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          57:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          58:
              {
                'ts': -766623600,
                'time': '1945-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 196819200,
                'time': '1976-03-28T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 212540400,
                'time': '1976-09-25T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 228877200,
                'time': '1977-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 243997200,
                'time': '1977-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 260326800,
                'time': '1978-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 276051600,
                'time': '1978-10-01T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 291776400,
                'time': '1979-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          141:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          142:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          143:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          144:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          145:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          146:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          147:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          148:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          149:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          150:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          151:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          152:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          153:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          154:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          155:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          156:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          157:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          158:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          159:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          160:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          161:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          162:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          163:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          164:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          165:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          166:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          167:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          168:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          169:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          170:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          171:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          172:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          173:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          174:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          175:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          176:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          177:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          178:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          179:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          180:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          181:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          182:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Podgorica':
        {
          0:
              {
                'ts': -905824800,
                'time': '1941-04-18T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -777942000,
                'time': '1945-05-08T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -766623600,
                'time': '1945-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': 407199600,
                'time': '1982-11-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Prague':
        {
          0:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -1663455600,
                'time': '1917-04-16T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -1650150000,
                'time': '1917-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -1632006000,
                'time': '1918-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -1618700400,
                'time': '1918-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -938905200,
                'time': '1940-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -798073200,
                'time': '1944-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -780534000,
                'time': '1945-04-08T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -761180400,
                'time': '1945-11-18T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': -746578800,
                'time': '1946-05-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -733359600,
                'time': '1946-10-06T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': -716425200,
                'time': '1947-04-20T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          17:
              {
                'ts': -701910000,
                'time': '1947-10-05T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': -684975600,
                'time': '1948-04-18T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': -670460400,
                'time': '1948-10-03T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          20:
              {
                'ts': -654217200,
                'time': '1949-04-09T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          21:
              {
                'ts': -639010800,
                'time': '1949-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': 283993200,
                'time': '1978-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 291776400,
                'time': '1979-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Riga':
        {
          0:
              {
                'ts': -1632008184,
                'time': '1918-04-15T00:23:36+0000',
                'offset': 9384,
                'isdst': true,
                'abbr': 'LST'
              },
          1:
              {
                'ts': -1618702584,
                'time': '1918-09-16T00:23:36+0000',
                'offset': 5784,
                'isdst': false,
                'abbr': 'RMT'
              },
          2:
              {
                'ts': -1601681784,
                'time': '1919-04-01T00:23:36+0000',
                'offset': 9384,
                'isdst': true,
                'abbr': 'LST'
              },
          3:
              {
                'ts': -1597275384,
                'time': '1919-05-22T00:23:36+0000',
                'offset': 5784,
                'isdst': false,
                'abbr': 'RMT'
              },
          4:
              {
                'ts': -1377308184,
                'time': '1926-05-10T22:23:36+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': -928029600,
                'time': '1940-08-04T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          6:
              {
                'ts': -899521200,
                'time': '1941-06-30T21:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -795834000,
                'time': '1944-10-12T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          13:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          14:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          15:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          16:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          17:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          18:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          19:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          20:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          21:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          22:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          23:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          24:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          25:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          26:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          27:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          28:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          29:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 622598400,
                'time': '1989-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 638323200,
                'time': '1990-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 654652800,
                'time': '1990-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 670377600,
                'time': '1991-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 686102400,
                'time': '1991-09-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 701827200,
                'time': '1992-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 717552000,
                'time': '1992-09-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 733276800,
                'time': '1993-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 749001600,
                'time': '1993-09-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 764726400,
                'time': '1994-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 780451200,
                'time': '1994-09-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 796176000,
                'time': '1995-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 811900800,
                'time': '1995-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 828230400,
                'time': '1996-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 843955200,
                'time': '1996-09-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 853797600,
                'time': '1997-01-20T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          46:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          47:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          48:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          49:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          50:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          51:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          52:
              {
                'ts': 951775200,
                'time': '2000-02-28T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          121:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          122:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          123:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          124:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          125:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          126:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Rome':
        {
          0:
              {
                'ts': -1690851600,
                'time': '1916-06-02T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -1664758800,
                'time': '1917-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -1649034000,
                'time': '1917-09-29T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -1635123600,
                'time': '1918-03-09T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -1616979600,
                'time': '1918-10-05T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -1604278800,
                'time': '1919-03-01T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -1585530000,
                'time': '1919-10-04T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -1571014800,
                'time': '1920-03-20T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -1555290000,
                'time': '1920-09-18T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -932432400,
                'time': '1940-06-14T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -804823200,
                'time': '1944-06-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': -798080400,
                'time': '1944-09-16T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': -766717200,
                'time': '1945-09-14T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': -750898800,
                'time': '1946-03-17T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': -733359600,
                'time': '1946-10-06T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': -719456400,
                'time': '1947-03-15T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': -701917200,
                'time': '1947-10-04T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': -689209200,
                'time': '1948-02-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': -670460400,
                'time': '1948-10-03T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': -114051600,
                'time': '1966-05-21T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': -103168800,
                'time': '1966-09-24T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': -81997200,
                'time': '1967-05-27T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': -71719200,
                'time': '1967-09-23T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': -50547600,
                'time': '1968-05-25T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': -40269600,
                'time': '1968-09-21T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': -18493200,
                'time': '1969-05-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': -8215200,
                'time': '1969-09-27T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 12956400,
                'time': '1970-05-30T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 23234400,
                'time': '1970-09-26T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 43801200,
                'time': '1971-05-22T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 54687600,
                'time': '1971-09-25T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 75855600,
                'time': '1972-05-27T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 86738400,
                'time': '1972-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 107910000,
                'time': '1973-06-02T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 118188000,
                'time': '1973-09-29T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 138754800,
                'time': '1974-05-25T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 149637600,
                'time': '1974-09-28T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 170809200,
                'time': '1975-05-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 181090800,
                'time': '1975-09-27T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 202258800,
                'time': '1976-05-29T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 212540400,
                'time': '1976-09-25T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 233103600,
                'time': '1977-05-21T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 243990000,
                'time': '1977-09-24T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 265158000,
                'time': '1978-05-27T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 276044400,
                'time': '1978-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 296607600,
                'time': '1979-05-26T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 307494000,
                'time': '1979-09-29T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 315529200,
                'time': '1979-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          56:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          57:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          67:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          68:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          69:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          70:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          71:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          72:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          73:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          74:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          75:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          76:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          77:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          78:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          79:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          80:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          81:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          82:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          83:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          84:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          85:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          86:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          87:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          88:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          89:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          90:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          91:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          92:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          93:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          94:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          95:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          96:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          97:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          99:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          100:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          101:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          102:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          103:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          104:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          105:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          106:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          107:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          108:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          109:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          110:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          111:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          112:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          113:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          114:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          115:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          116:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          117:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          118:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          119:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          120:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          121:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          122:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          123:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          124:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          125:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          126:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          127:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          128:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          129:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          130:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          131:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          132:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          133:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          134:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          135:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          136:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          137:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          138:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          139:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          140:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          141:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          142:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          143:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          144:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          145:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          146:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          147:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          148:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          149:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          150:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          151:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          152:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          153:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          154:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          155:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          156:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          157:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          158:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          159:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          160:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          161:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          162:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          163:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          164:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          165:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          166:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          167:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          168:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          169:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Samara':
        {
          0:
              {
                'ts': -1593825636,
                'time': '1919-06-30T22:39:24+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'SAMT'
              },
          1:
              {
                'ts': -1247540400,
                'time': '1930-06-20T21:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          2:
              {
                'ts': -1102305600,
                'time': '1935-01-26T20:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'KUYT'
              },
          3:
              {
                'ts': 354916800,
                'time': '1981-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'KUYST'
              },
          4:
              {
                'ts': 370724400,
                'time': '1981-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'KUYT'
              },
          5:
              {
                'ts': 386452800,
                'time': '1982-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'KUYST'
              },
          6:
              {
                'ts': 402260400,
                'time': '1982-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'KUYT'
              },
          7:
              {
                'ts': 417988800,
                'time': '1983-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'KUYST'
              },
          8:
              {
                'ts': 433796400,
                'time': '1983-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'KUYT'
              },
          9:
              {
                'ts': 449611200,
                'time': '1984-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'KUYST'
              },
          10:
              {
                'ts': 465343200,
                'time': '1984-09-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'KUYT'
              },
          11:
              {
                'ts': 481068000,
                'time': '1985-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'KUYST'
              },
          12:
              {
                'ts': 496792800,
                'time': '1985-09-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'KUYT'
              },
          13:
              {
                'ts': 512517600,
                'time': '1986-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'KUYST'
              },
          14:
              {
                'ts': 528242400,
                'time': '1986-09-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'KUYT'
              },
          15:
              {
                'ts': 543967200,
                'time': '1987-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'KUYST'
              },
          16:
              {
                'ts': 559692000,
                'time': '1987-09-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'KUYT'
              },
          17:
              {
                'ts': 575416800,
                'time': '1988-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'KUYST'
              },
          18:
              {
                'ts': 591141600,
                'time': '1988-09-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'KUYT'
              },
          19:
              {
                'ts': 606866400,
                'time': '1989-03-25T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'KUYST'
              },
          20:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'KUYT'
              },
          21:
              {
                'ts': 638319600,
                'time': '1990-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'KUYST'
              },
          22:
              {
                'ts': 654649200,
                'time': '1990-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'KUYT'
              },
          23:
              {
                'ts': 670374000,
                'time': '1991-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'KUYST'
              },
          24:
              {
                'ts': 686102400,
                'time': '1991-09-29T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'KUYT'
              },
          25:
              {
                'ts': 687916800,
                'time': '1991-10-20T00:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          26:
              {
                'ts': 701809200,
                'time': '1992-03-28T19:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          27:
              {
                'ts': 717530400,
                'time': '1992-09-26T18:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          28:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          29:
              {
                'ts': 748994400,
                'time': '1993-09-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          30:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          31:
              {
                'ts': 780444000,
                'time': '1994-09-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          32:
              {
                'ts': 796168800,
                'time': '1995-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          33:
              {
                'ts': 811893600,
                'time': '1995-09-23T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          34:
              {
                'ts': 828223200,
                'time': '1996-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          35:
              {
                'ts': 846367200,
                'time': '1996-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          36:
              {
                'ts': 859672800,
                'time': '1997-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          37:
              {
                'ts': 877816800,
                'time': '1997-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          38:
              {
                'ts': 891122400,
                'time': '1998-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          39:
              {
                'ts': 909266400,
                'time': '1998-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          40:
              {
                'ts': 922572000,
                'time': '1999-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          41:
              {
                'ts': 941320800,
                'time': '1999-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          42:
              {
                'ts': 954021600,
                'time': '2000-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          43:
              {
                'ts': 972770400,
                'time': '2000-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          44:
              {
                'ts': 985471200,
                'time': '2001-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          45:
              {
                'ts': 1004220000,
                'time': '2001-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          46:
              {
                'ts': 1017525600,
                'time': '2002-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          47:
              {
                'ts': 1035669600,
                'time': '2002-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          48:
              {
                'ts': 1048975200,
                'time': '2003-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          49:
              {
                'ts': 1067119200,
                'time': '2003-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          50:
              {
                'ts': 1080424800,
                'time': '2004-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          51:
              {
                'ts': 1099173600,
                'time': '2004-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          52:
              {
                'ts': 1111874400,
                'time': '2005-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          53:
              {
                'ts': 1130623200,
                'time': '2005-10-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          54:
              {
                'ts': 1143324000,
                'time': '2006-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          55:
              {
                'ts': 1162072800,
                'time': '2006-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          56:
              {
                'ts': 1174773600,
                'time': '2007-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          57:
              {
                'ts': 1193522400,
                'time': '2007-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          58:
              {
                'ts': 1206828000,
                'time': '2008-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          59:
              {
                'ts': 1224972000,
                'time': '2008-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          60:
              {
                'ts': 1238277600,
                'time': '2009-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          61:
              {
                'ts': 1256421600,
                'time': '2009-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          62:
              {
                'ts': 1269727200,
                'time': '2010-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          63:
              {
                'ts': 1288476000,
                'time': '2010-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          64:
              {
                'ts': 1301176800,
                'time': '2011-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          65:
              {
                'ts': 1319925600,
                'time': '2011-10-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          66:
              {
                'ts': 1332626400,
                'time': '2012-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          67:
              {
                'ts': 1351375200,
                'time': '2012-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          68:
              {
                'ts': 1364680800,
                'time': '2013-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          69:
              {
                'ts': 1382824800,
                'time': '2013-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          70:
              {
                'ts': 1396130400,
                'time': '2014-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          71:
              {
                'ts': 1414274400,
                'time': '2014-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          72:
              {
                'ts': 1427580000,
                'time': '2015-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          73:
              {
                'ts': 1445724000,
                'time': '2015-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          74:
              {
                'ts': 1459029600,
                'time': '2016-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          75:
              {
                'ts': 1477778400,
                'time': '2016-10-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          76:
              {
                'ts': 1490479200,
                'time': '2017-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          77:
              {
                'ts': 1509228000,
                'time': '2017-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          78:
              {
                'ts': 1521928800,
                'time': '2018-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          79:
              {
                'ts': 1540677600,
                'time': '2018-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          80:
              {
                'ts': 1553983200,
                'time': '2019-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          81:
              {
                'ts': 1572127200,
                'time': '2019-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          82:
              {
                'ts': 1585432800,
                'time': '2020-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          83:
              {
                'ts': 1603576800,
                'time': '2020-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          84:
              {
                'ts': 1616882400,
                'time': '2021-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          85:
              {
                'ts': 1635631200,
                'time': '2021-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          86:
              {
                'ts': 1648332000,
                'time': '2022-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          87:
              {
                'ts': 1667080800,
                'time': '2022-10-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          88:
              {
                'ts': 1679781600,
                'time': '2023-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          89:
              {
                'ts': 1698530400,
                'time': '2023-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          90:
              {
                'ts': 1711836000,
                'time': '2024-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          91:
              {
                'ts': 1729980000,
                'time': '2024-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          92:
              {
                'ts': 1743285600,
                'time': '2025-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          93:
              {
                'ts': 1761429600,
                'time': '2025-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          94:
              {
                'ts': 1774735200,
                'time': '2026-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          95:
              {
                'ts': 1792879200,
                'time': '2026-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          96:
              {
                'ts': 1806184800,
                'time': '2027-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          97:
              {
                'ts': 1824933600,
                'time': '2027-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          98:
              {
                'ts': 1837634400,
                'time': '2028-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          99:
              {
                'ts': 1856383200,
                'time': '2028-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          100:
              {
                'ts': 1869084000,
                'time': '2029-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          101:
              {
                'ts': 1887832800,
                'time': '2029-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          102:
              {
                'ts': 1901138400,
                'time': '2030-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          103:
              {
                'ts': 1919282400,
                'time': '2030-10-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          104:
              {
                'ts': 1932588000,
                'time': '2031-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          105:
              {
                'ts': 1950732000,
                'time': '2031-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          106:
              {
                'ts': 1964037600,
                'time': '2032-03-27T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          107:
              {
                'ts': 1982786400,
                'time': '2032-10-30T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          108:
              {
                'ts': 1995487200,
                'time': '2033-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          109:
              {
                'ts': 2014236000,
                'time': '2033-10-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          110:
              {
                'ts': 2026936800,
                'time': '2034-03-25T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          111:
              {
                'ts': 2045685600,
                'time': '2034-10-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          112:
              {
                'ts': 2058386400,
                'time': '2035-03-24T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          113:
              {
                'ts': 2077135200,
                'time': '2035-10-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          114:
              {
                'ts': 2090440800,
                'time': '2036-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          115:
              {
                'ts': 2108584800,
                'time': '2036-10-25T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          116:
              {
                'ts': 2121890400,
                'time': '2037-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'SAMST'
              },
          117:
              {
                'ts': 2140034400,
                'time': '2037-10-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SAMT'
              }
        },
    'Europe/San_Marino':
        {
          0:
              {
                'ts': -1690851600,
                'time': '1916-06-02T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -1664758800,
                'time': '1917-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -1649034000,
                'time': '1917-09-29T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -1635123600,
                'time': '1918-03-09T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -1616979600,
                'time': '1918-10-05T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -1604278800,
                'time': '1919-03-01T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -1585530000,
                'time': '1919-10-04T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -1571014800,
                'time': '1920-03-20T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -1555290000,
                'time': '1920-09-18T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -932432400,
                'time': '1940-06-14T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -804823200,
                'time': '1944-06-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': -798080400,
                'time': '1944-09-16T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': -766717200,
                'time': '1945-09-14T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': -750898800,
                'time': '1946-03-17T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': -733359600,
                'time': '1946-10-06T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': -719456400,
                'time': '1947-03-15T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': -701917200,
                'time': '1947-10-04T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': -689209200,
                'time': '1948-02-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': -670460400,
                'time': '1948-10-03T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': -114051600,
                'time': '1966-05-21T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': -103168800,
                'time': '1966-09-24T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': -81997200,
                'time': '1967-05-27T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': -71719200,
                'time': '1967-09-23T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': -50547600,
                'time': '1968-05-25T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': -40269600,
                'time': '1968-09-21T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': -18493200,
                'time': '1969-05-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': -8215200,
                'time': '1969-09-27T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 12956400,
                'time': '1970-05-30T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 23234400,
                'time': '1970-09-26T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 43801200,
                'time': '1971-05-22T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 54687600,
                'time': '1971-09-25T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 75855600,
                'time': '1972-05-27T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 86738400,
                'time': '1972-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 107910000,
                'time': '1973-06-02T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 118188000,
                'time': '1973-09-29T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 138754800,
                'time': '1974-05-25T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 149637600,
                'time': '1974-09-28T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 170809200,
                'time': '1975-05-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 181090800,
                'time': '1975-09-27T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 202258800,
                'time': '1976-05-29T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 212540400,
                'time': '1976-09-25T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 233103600,
                'time': '1977-05-21T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 243990000,
                'time': '1977-09-24T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 265158000,
                'time': '1978-05-27T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 276044400,
                'time': '1978-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 296607600,
                'time': '1979-05-26T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 307494000,
                'time': '1979-09-29T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 315529200,
                'time': '1979-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          56:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          57:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          67:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          68:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          69:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          70:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          71:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          72:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          73:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          74:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          75:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          76:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          77:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          78:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          79:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          80:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          81:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          82:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          83:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          84:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          85:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          86:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          87:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          88:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          89:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          90:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          91:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          92:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          93:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          94:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          95:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          96:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          97:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          99:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          100:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          101:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          102:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          103:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          104:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          105:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          106:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          107:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          108:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          109:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          110:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          111:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          112:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          113:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          114:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          115:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          116:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          117:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          118:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          119:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          120:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          121:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          122:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          123:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          124:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          125:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          126:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          127:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          128:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          129:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          130:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          131:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          132:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          133:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          134:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          135:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          136:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          137:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          138:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          139:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          140:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          141:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          142:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          143:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          144:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          145:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          146:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          147:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          148:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          149:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          150:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          151:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          152:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          153:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          154:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          155:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          156:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          157:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          158:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          159:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          160:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          161:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          162:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          163:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          164:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          165:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          166:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          167:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          168:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          169:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Sarajevo':
        {
          0:
              {
                'ts': -905824800,
                'time': '1941-04-18T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -777942000,
                'time': '1945-05-08T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -766623600,
                'time': '1945-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': 407199600,
                'time': '1982-11-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Simferopol':
        {
          0:
              {
                'ts': -1441160160,
                'time': '1924-05-01T21:44:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -1247536800,
                'time': '1930-06-20T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          2:
              {
                'ts': -888894000,
                'time': '1941-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -811648800,
                'time': '1944-04-12T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          8:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          9:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          10:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          11:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          12:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          13:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          14:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          15:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          16:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          17:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          18:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          19:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          20:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          21:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          22:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          23:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          24:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          25:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          26:
              {
                'ts': 631141200,
                'time': '1989-12-31T21:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          27:
              {
                'ts': 646786800,
                'time': '1990-06-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          28:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          29:
              {
                'ts': 717541200,
                'time': '1992-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          30:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          31:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          32:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          33:
              {
                'ts': 767739600,
                'time': '1994-04-30T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          34:
              {
                'ts': 780436800,
                'time': '1994-09-24T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          35:
              {
                'ts': 796165200,
                'time': '1995-03-25T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          36:
              {
                'ts': 811886400,
                'time': '1995-09-23T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          37:
              {
                'ts': 828219600,
                'time': '1996-03-30T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          38:
              {
                'ts': 828230400,
                'time': '1996-03-31T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          39:
              {
                'ts': 846374400,
                'time': '1996-10-27T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          40:
              {
                'ts': 852066000,
                'time': '1996-12-31T21:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          41:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          121:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          122:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Skopje':
        {
          0:
              {
                'ts': -905824800,
                'time': '1941-04-18T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -777942000,
                'time': '1945-05-08T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -766623600,
                'time': '1945-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': 407199600,
                'time': '1982-11-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Sofia':
        {
          0:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          1:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          2:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          3:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          4:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          5:
              {
                'ts': -781048800,
                'time': '1945-04-02T02:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          6:
              {
                'ts': 291762000,
                'time': '1979-03-31T21:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          7:
              {
                'ts': 307576800,
                'time': '1979-09-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          8:
              {
                'ts': 323816400,
                'time': '1980-04-05T21:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          9:
              {
                'ts': 339026400,
                'time': '1980-09-28T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          10:
              {
                'ts': 355266000,
                'time': '1981-04-04T21:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          11:
              {
                'ts': 370393200,
                'time': '1981-09-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          12:
              {
                'ts': 386715600,
                'time': '1982-04-03T21:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          13:
              {
                'ts': 401846400,
                'time': '1982-09-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          14:
              {
                'ts': 417571200,
                'time': '1983-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          15:
              {
                'ts': 433296000,
                'time': '1983-09-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          16:
              {
                'ts': 449020800,
                'time': '1984-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          17:
              {
                'ts': 465350400,
                'time': '1984-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          18:
              {
                'ts': 481075200,
                'time': '1985-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          19:
              {
                'ts': 496800000,
                'time': '1985-09-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          20:
              {
                'ts': 512524800,
                'time': '1986-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          21:
              {
                'ts': 528249600,
                'time': '1986-09-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          22:
              {
                'ts': 543974400,
                'time': '1987-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          23:
              {
                'ts': 559699200,
                'time': '1987-09-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          24:
              {
                'ts': 575424000,
                'time': '1988-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          25:
              {
                'ts': 591148800,
                'time': '1988-09-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          26:
              {
                'ts': 606873600,
                'time': '1989-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          27:
              {
                'ts': 622598400,
                'time': '1989-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          28:
              {
                'ts': 638323200,
                'time': '1990-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          29:
              {
                'ts': 654652800,
                'time': '1990-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          30:
              {
                'ts': 662680800,
                'time': '1990-12-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 670370400,
                'time': '1991-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 686091600,
                'time': '1991-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 717541200,
                'time': '1992-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 796168800,
                'time': '1995-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 811890000,
                'time': '1995-09-23T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 828223200,
                'time': '1996-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 846363600,
                'time': '1996-10-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          121:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          122:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          123:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          124:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Stockholm':
        {
          0:
              {
                'ts': -1692496800,
                'time': '1916-05-14T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          17:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          20:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          21:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          23:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          24:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          25:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          26:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          27:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          28:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          29:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          30:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          31:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          32:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          33:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          34:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          35:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          36:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          37:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          38:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          39:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          40:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          41:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          42:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          43:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          44:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          45:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          46:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          47:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          48:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          49:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          50:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          51:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          52:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          53:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          56:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          57:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          67:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          68:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          69:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          70:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          71:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          72:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          73:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          74:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          75:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          76:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          77:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          78:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          79:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          80:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          81:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          82:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          83:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          84:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          85:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          86:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          87:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          88:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          89:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          90:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          91:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          92:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          93:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          94:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          95:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          96:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          97:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          99:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          100:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          101:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          102:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          103:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          104:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          105:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          106:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          107:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          108:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          109:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          110:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          111:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          112:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          113:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          114:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          115:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          116:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          117:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Tallinn':
        {
          0:
              {
                'ts': -1638322740,
                'time': '1918-01-31T22:21:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          1:
              {
                'ts': -1632006000,
                'time': '1918-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          2:
              {
                'ts': -1618700400,
                'time': '1918-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          3:
              {
                'ts': -1593824400,
                'time': '1919-06-30T23:00:00+0000',
                'offset': 5940,
                'isdst': false,
                'abbr': 'TMT'
              },
          4:
              {
                'ts': -1535938740,
                'time': '1921-04-30T22:21:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': -927943200,
                'time': '1940-08-05T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          6:
              {
                'ts': -892954800,
                'time': '1941-09-14T21:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -797652000,
                'time': '1944-09-21T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          12:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          13:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          14:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          15:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          16:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          17:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          18:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          19:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          20:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          21:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          22:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          23:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          24:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          25:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          26:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          27:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          28:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          29:
              {
                'ts': 622598400,
                'time': '1989-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          30:
              {
                'ts': 638323200,
                'time': '1990-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          31:
              {
                'ts': 654652800,
                'time': '1990-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          32:
              {
                'ts': 670377600,
                'time': '1991-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          33:
              {
                'ts': 686102400,
                'time': '1991-09-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          34:
              {
                'ts': 701827200,
                'time': '1992-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          35:
              {
                'ts': 717552000,
                'time': '1992-09-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          36:
              {
                'ts': 733276800,
                'time': '1993-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          37:
              {
                'ts': 749001600,
                'time': '1993-09-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          38:
              {
                'ts': 764726400,
                'time': '1994-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          39:
              {
                'ts': 780451200,
                'time': '1994-09-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          40:
              {
                'ts': 796176000,
                'time': '1995-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          41:
              {
                'ts': 811900800,
                'time': '1995-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          42:
              {
                'ts': 828230400,
                'time': '1996-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          43:
              {
                'ts': 846374400,
                'time': '1996-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          44:
              {
                'ts': 859680000,
                'time': '1997-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          45:
              {
                'ts': 877824000,
                'time': '1997-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          46:
              {
                'ts': 891129600,
                'time': '1998-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          47:
              {
                'ts': 906411600,
                'time': '1998-09-21T21:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 941407200,
                'time': '1999-10-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          52:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          53:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          54:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          55:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          56:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          57:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          58:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          59:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          60:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          61:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          62:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          63:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          64:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          65:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          66:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          67:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          68:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          69:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          70:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          71:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          72:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          73:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          74:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          75:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          76:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          77:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          78:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          79:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          80:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          81:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          82:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          83:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          84:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          85:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          86:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          87:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          88:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          89:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          90:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          91:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          92:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          93:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          94:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          95:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          96:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          97:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          98:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          99:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          100:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          101:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          102:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          103:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          104:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          105:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          106:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          107:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          108:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          109:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          110:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          111:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          112:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          113:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          114:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          115:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          116:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          117:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          118:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          119:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          120:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          121:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          122:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          123:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Tirane':
        {
          0:
              {
                'ts': -1767230360,
                'time': '1913-12-31T22:40:40+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          1:
              {
                'ts': -932346000,
                'time': '1940-06-15T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          2:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          3:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          4:
              {
                'ts': -843519600,
                'time': '1943-04-10T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          5:
              {
                'ts': 136854000,
                'time': '1974-05-03T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          6:
              {
                'ts': 149896800,
                'time': '1974-10-01T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          7:
              {
                'ts': 168130800,
                'time': '1975-04-30T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          8:
              {
                'ts': 181432800,
                'time': '1975-10-01T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': 199839600,
                'time': '1976-05-01T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': 213141600,
                'time': '1976-10-02T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': 231894000,
                'time': '1977-05-07T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': 244591200,
                'time': '1977-10-01T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': 263257200,
                'time': '1978-05-05T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': 276040800,
                'time': '1978-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': 294706800,
                'time': '1979-05-04T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': 307490400,
                'time': '1979-09-29T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': 326156400,
                'time': '1980-05-02T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': 339458400,
                'time': '1980-10-03T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': 357087600,
                'time': '1981-04-25T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': 370389600,
                'time': '1981-09-26T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': 389142000,
                'time': '1982-05-01T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': 402444000,
                'time': '1982-10-02T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 419468400,
                'time': '1983-04-17T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 433807200,
                'time': '1983-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 449622000,
                'time': '1984-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Tiraspol':
        {
          0:
              {
                'ts': -1637114100,
                'time': '1918-02-14T22:05:00+0000',
                'offset': 6264,
                'isdst': false,
                'abbr': 'BMT'
              },
          1:
              {
                'ts': -1213148664,
                'time': '1931-07-23T22:15:36+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          2:
              {
                'ts': -1187056800,
                'time': '1932-05-20T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          3:
              {
                'ts': -1175479200,
                'time': '1932-10-01T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          4:
              {
                'ts': -1159754400,
                'time': '1933-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          5:
              {
                'ts': -1144029600,
                'time': '1933-09-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          6:
              {
                'ts': -1127700000,
                'time': '1934-04-07T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          7:
              {
                'ts': -1111975200,
                'time': '1934-10-06T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          8:
              {
                'ts': -1096250400,
                'time': '1935-04-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          9:
              {
                'ts': -1080525600,
                'time': '1935-10-05T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          10:
              {
                'ts': -1064800800,
                'time': '1936-04-04T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          11:
              {
                'ts': -1049076000,
                'time': '1936-10-03T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          12:
              {
                'ts': -1033351200,
                'time': '1937-04-03T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          13:
              {
                'ts': -1017626400,
                'time': '1937-10-02T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          14:
              {
                'ts': -1001901600,
                'time': '1938-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          15:
              {
                'ts': -986176800,
                'time': '1938-10-01T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          16:
              {
                'ts': -970452000,
                'time': '1939-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          17:
              {
                'ts': -954727200,
                'time': '1939-09-30T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          18:
              {
                'ts': -927165600,
                'time': '1940-08-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          19:
              {
                'ts': -898138800,
                'time': '1941-07-16T21:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': -800157600,
                'time': '1944-08-23T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          25:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          26:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          27:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          28:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          29:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          30:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          31:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          32:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          33:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          34:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          35:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          36:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          37:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          38:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          39:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          40:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          41:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          42:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          43:
              {
                'ts': 631141200,
                'time': '1989-12-31T21:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          44:
              {
                'ts': 641941200,
                'time': '1990-05-05T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 670377600,
                'time': '1991-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 686102400,
                'time': '1991-09-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 694216800,
                'time': '1991-12-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          48:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          49:
              {
                'ts': 717541200,
                'time': '1992-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          50:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          51:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          52:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          53:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          54:
              {
                'ts': 796168800,
                'time': '1995-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          55:
              {
                'ts': 811890000,
                'time': '1995-09-23T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          56:
              {
                'ts': 828223200,
                'time': '1996-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          57:
              {
                'ts': 846363600,
                'time': '1996-10-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          58:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          59:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          60:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          61:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          62:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          63:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          64:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          65:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          66:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          67:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          68:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          69:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          70:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          71:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          72:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          73:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          74:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          75:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          76:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          77:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          78:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          79:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          80:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          81:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          82:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          83:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          84:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          85:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          86:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          87:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          88:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          89:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          90:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          91:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          92:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          93:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          94:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          95:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          96:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          97:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          98:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          99:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          100:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          101:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          102:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          103:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          104:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          105:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          106:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          107:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          108:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          109:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          110:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          111:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          112:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          113:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          114:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          115:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          116:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          117:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          118:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          119:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          120:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          121:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          122:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          123:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          124:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          125:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          126:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          127:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          128:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          129:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          130:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          131:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          132:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          133:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          134:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          135:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          136:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          137:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          138:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          139:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Uzhgorod':
        {
          0:
              {
                'ts': -938905200,
                'time': '1940-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -796874400,
                'time': '1944-09-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          6:
              {
                'ts': -794714400,
                'time': '1944-10-25T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          7:
              {
                'ts': -773456400,
                'time': '1945-06-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          8:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          9:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          10:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          11:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          12:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          13:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          14:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          15:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          16:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          17:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          18:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          19:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          20:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          21:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          22:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          23:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          24:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          25:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          26:
              {
                'ts': 631141200,
                'time': '1989-12-31T21:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          27:
              {
                'ts': 646786800,
                'time': '1990-06-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          28:
              {
                'ts': 670384800,
                'time': '1991-03-31T02:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 717541200,
                'time': '1992-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Vaduz':
        {
          0:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          17:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          20:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          21:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          23:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          24:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          25:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          26:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          27:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          28:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          29:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          30:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          31:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          32:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          33:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          34:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          35:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          36:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          37:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          38:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          39:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          40:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          41:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          42:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          43:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          44:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          45:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          46:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          47:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          48:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          49:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          50:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          51:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          52:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          53:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          56:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          57:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          67:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          68:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          69:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          70:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          71:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          72:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          73:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          74:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          75:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          76:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          77:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          78:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          79:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          80:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          81:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          82:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          83:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          84:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          85:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          86:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          87:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          88:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          89:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          90:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          91:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          92:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          93:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          94:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          95:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          96:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          97:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          99:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          100:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          101:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          102:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          103:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          104:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          105:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          106:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          107:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          108:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          109:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          110:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          111:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          112:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          113:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Vatican':
        {
          0:
              {
                'ts': -1690851600,
                'time': '1916-06-02T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -1664758800,
                'time': '1917-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -1649034000,
                'time': '1917-09-29T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -1635123600,
                'time': '1918-03-09T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -1616979600,
                'time': '1918-10-05T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -1604278800,
                'time': '1919-03-01T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -1585530000,
                'time': '1919-10-04T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': -1571014800,
                'time': '1920-03-20T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': -1555290000,
                'time': '1920-09-18T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -932432400,
                'time': '1940-06-14T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -804823200,
                'time': '1944-06-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': -798080400,
                'time': '1944-09-16T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': -766717200,
                'time': '1945-09-14T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': -750898800,
                'time': '1946-03-17T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': -733359600,
                'time': '1946-10-06T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': -719456400,
                'time': '1947-03-15T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': -701917200,
                'time': '1947-10-04T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': -689209200,
                'time': '1948-02-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': -670460400,
                'time': '1948-10-03T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': -114051600,
                'time': '1966-05-21T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': -103168800,
                'time': '1966-09-24T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': -81997200,
                'time': '1967-05-27T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': -71719200,
                'time': '1967-09-23T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': -50547600,
                'time': '1968-05-25T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': -40269600,
                'time': '1968-09-21T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': -18493200,
                'time': '1969-05-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': -8215200,
                'time': '1969-09-27T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 12956400,
                'time': '1970-05-30T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 23234400,
                'time': '1970-09-26T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 43801200,
                'time': '1971-05-22T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 54687600,
                'time': '1971-09-25T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 75855600,
                'time': '1972-05-27T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 86738400,
                'time': '1972-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 107910000,
                'time': '1973-06-02T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 118188000,
                'time': '1973-09-29T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 138754800,
                'time': '1974-05-25T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 149637600,
                'time': '1974-09-28T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 170809200,
                'time': '1975-05-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 181090800,
                'time': '1975-09-27T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 202258800,
                'time': '1976-05-29T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 212540400,
                'time': '1976-09-25T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 233103600,
                'time': '1977-05-21T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 243990000,
                'time': '1977-09-24T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 265158000,
                'time': '1978-05-27T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 276044400,
                'time': '1978-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 296607600,
                'time': '1979-05-26T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 307494000,
                'time': '1979-09-29T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 315529200,
                'time': '1979-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          56:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          57:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          67:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          68:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          69:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          70:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          71:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          72:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          73:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          74:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          75:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          76:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          77:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          78:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          79:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          80:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          81:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          82:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          83:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          84:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          85:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          86:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          87:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          88:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          89:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          90:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          91:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          92:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          93:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          94:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          95:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          96:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          97:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          99:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          100:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          101:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          102:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          103:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          104:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          105:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          106:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          107:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          108:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          109:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          110:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          111:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          112:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          113:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          114:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          115:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          116:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          117:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          118:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          119:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          120:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          121:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          122:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          123:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          124:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          125:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          126:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          127:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          128:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          129:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          130:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          131:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          132:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          133:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          134:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          135:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          136:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          137:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          138:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          139:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          140:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          141:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          142:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          143:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          144:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          145:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          146:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          147:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          148:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          149:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          150:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          151:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          152:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          153:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          154:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          155:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          156:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          157:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          158:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          159:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          160:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          161:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          162:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          163:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          164:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          165:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          166:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          167:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          168:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          169:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Vienna':
        {
          0:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -1663455600,
                'time': '1917-04-16T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -1650150000,
                'time': '1917-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -1632006000,
                'time': '1918-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -1618700400,
                'time': '1918-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -1577926800,
                'time': '1919-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          7:
              {
                'ts': -1569711600,
                'time': '1920-04-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          8:
              {
                'ts': -1555801200,
                'time': '1920-09-13T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': -938905200,
                'time': '1940-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': -780188400,
                'time': '1945-04-12T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': -757386000,
                'time': '1945-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': -748479600,
                'time': '1946-04-14T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': -733359600,
                'time': '1946-10-06T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          20:
              {
                'ts': -717634800,
                'time': '1947-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          21:
              {
                'ts': -701910000,
                'time': '1947-10-05T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': -684975600,
                'time': '1948-04-18T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          23:
              {
                'ts': -670460400,
                'time': '1948-10-03T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          24:
              {
                'ts': 323823600,
                'time': '1980-04-05T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          25:
              {
                'ts': 338940000,
                'time': '1980-09-27T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          26:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          27:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          28:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          29:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          30:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          31:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          32:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          33:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          34:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          35:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          36:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          37:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          38:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          39:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          40:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          41:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          42:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          43:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          44:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          45:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          46:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          47:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          48:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          49:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          50:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          51:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          52:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          53:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          56:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          57:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          67:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          68:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          69:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          70:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          71:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          72:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          73:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          74:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          75:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          76:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          77:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          78:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          79:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          80:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          81:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          82:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          83:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          84:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          85:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          86:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          87:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          88:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          89:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          90:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          91:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          92:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          93:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          94:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          95:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          96:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          97:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          99:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          100:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          101:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          102:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          103:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          104:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          105:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          106:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          107:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          108:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          109:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          110:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          111:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          112:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          113:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          114:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          115:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          116:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          117:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          118:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          119:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          120:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          121:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          122:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          123:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          124:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          125:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          126:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          127:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          128:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          129:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          130:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          131:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          132:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          133:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          134:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          135:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          136:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          137:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          138:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          139:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Vilnius':
        {
          0:
              {
                'ts': -1672536240,
                'time': '1916-12-31T22:36:00+0000',
                'offset': 5736,
                'isdst': false,
                'abbr': 'KMT'
              },
          1:
              {
                'ts': -1585100136,
                'time': '1919-10-09T22:24:24+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -1561251600,
                'time': '1920-07-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': -1553565600,
                'time': '1920-10-08T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -928198800,
                'time': '1940-08-02T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          5:
              {
                'ts': -900126000,
                'time': '1941-06-23T21:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          6:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          7:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          8:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': -802144800,
                'time': '1944-07-31T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          11:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          12:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          13:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          14:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          15:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          16:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          17:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          18:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          19:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          20:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          21:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          22:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          23:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          24:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          25:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          26:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          27:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          28:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          29:
              {
                'ts': 638319600,
                'time': '1990-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          30:
              {
                'ts': 654649200,
                'time': '1990-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          31:
              {
                'ts': 670374000,
                'time': '1991-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 686102400,
                'time': '1991-09-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 701827200,
                'time': '1992-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 717552000,
                'time': '1992-09-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 733276800,
                'time': '1993-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 749001600,
                'time': '1993-09-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 764726400,
                'time': '1994-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 780451200,
                'time': '1994-09-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 796176000,
                'time': '1995-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 811900800,
                'time': '1995-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 828230400,
                'time': '1996-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 846374400,
                'time': '1996-10-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 859680000,
                'time': '1997-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 877824000,
                'time': '1997-10-26T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 883605600,
                'time': '1997-12-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          46:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          47:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          48:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          49:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          50:
              {
                'ts': 1041372000,
                'time': '2002-12-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,

                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Volgograd':
        {
          0:
              {
                'ts': -1577761060,
                'time': '1920-01-02T21:02:20+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TSAT'
              },
          1:
              {
                'ts': -1411873200,
                'time': '1925-04-05T21:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'STAT'
              },
          2:
              {
                'ts': -1247540400,
                'time': '1930-06-20T21:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'STAT'
              },
          3:
              {
                'ts': -256881600,
                'time': '1961-11-10T20:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'VOLT'
              },
          4:
              {
                'ts': 354916800,
                'time': '1981-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'VOLST'
              },
          5:
              {
                'ts': 370724400,
                'time': '1981-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'VOLT'
              },
          6:
              {
                'ts': 386452800,
                'time': '1982-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'VOLST'
              },
          7:
              {
                'ts': 402260400,
                'time': '1982-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'VOLT'
              },
          8:
              {
                'ts': 417988800,
                'time': '1983-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'VOLST'
              },
          9:
              {
                'ts': 433796400,
                'time': '1983-09-30T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'VOLT'
              },
          10:
              {
                'ts': 449611200,
                'time': '1984-03-31T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'VOLST'
              },
          11:
              {
                'ts': 465343200,
                'time': '1984-09-29T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'VOLT'
              },
          12:
              {
                'ts': 481068000,
                'time': '1985-03-30T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'VOLST'
              },
          13:
              {
                'ts': 496792800,
                'time': '1985-09-28T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'VOLT'
              },
          14:
              {
                'ts': 512517600,
                'time': '1986-03-29T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'VOLST'
              },
          15:
              {
                'ts': 528242400,
                'time': '1986-09-27T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'VOLT'
              },
          16:
              {
                'ts': 543967200,
                'time': '1987-03-28T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'VOLST'
              },
          17:
              {
                'ts': 559692000,
                'time': '1987-09-26T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'VOLT'
              },
          18:
              {
                'ts': 575416800,
                'time': '1988-03-26T22:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'VOLST'
              },
          19:
              {
                'ts': 591141600,
                'time': '1988-09-24T22:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'VOLT'
              },
          20:
              {
                'ts': 606866400,
                'time': '1989-03-25T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          21:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          22:
              {
                'ts': 638319600,
                'time': '1990-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          23:
              {
                'ts': 654649200,
                'time': '1990-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          24:
              {
                'ts': 670374000,
                'time': '1991-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'VOLT'
              },
          25:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          26:
              {
                'ts': 717534000,
                'time': '1992-09-26T19:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          27:
              {
                'ts': 733273200,
                'time': '1993-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          28:
              {
                'ts': 748998000,
                'time': '1993-09-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          29:
              {
                'ts': 764722800,
                'time': '1994-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          30:
              {
                'ts': 780447600,
                'time': '1994-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          31:
              {
                'ts': 796172400,
                'time': '1995-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          32:
              {
                'ts': 811897200,
                'time': '1995-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          33:
              {
                'ts': 828226800,
                'time': '1996-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          34:
              {
                'ts': 846370800,
                'time': '1996-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          35:
              {
                'ts': 859676400,
                'time': '1997-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          36:
              {
                'ts': 877820400,
                'time': '1997-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          37:
              {
                'ts': 891126000,
                'time': '1998-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          38:
              {
                'ts': 909270000,
                'time': '1998-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          39:
              {
                'ts': 922575600,
                'time': '1999-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          40:
              {
                'ts': 941324400,
                'time': '1999-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          41:
              {
                'ts': 954025200,
                'time': '2000-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          42:
              {
                'ts': 972774000,
                'time': '2000-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          43:
              {
                'ts': 985474800,
                'time': '2001-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          44:
              {
                'ts': 1004223600,
                'time': '2001-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          45:
              {
                'ts': 1017529200,
                'time': '2002-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          46:
              {
                'ts': 1035673200,
                'time': '2002-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          47:
              {
                'ts': 1048978800,
                'time': '2003-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          48:
              {
                'ts': 1067122800,
                'time': '2003-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          49:
              {
                'ts': 1080428400,
                'time': '2004-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          50:
              {
                'ts': 1099177200,
                'time': '2004-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          51:
              {
                'ts': 1111878000,
                'time': '2005-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          52:
              {
                'ts': 1130626800,
                'time': '2005-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          53:
              {
                'ts': 1143327600,
                'time': '2006-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          54:
              {
                'ts': 1162076400,
                'time': '2006-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          55:
              {
                'ts': 1174777200,
                'time': '2007-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          56:
              {
                'ts': 1193526000,
                'time': '2007-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          57:
              {
                'ts': 1206831600,
                'time': '2008-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          58:
              {
                'ts': 1224975600,
                'time': '2008-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          59:
              {
                'ts': 1238281200,
                'time': '2009-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          60:
              {
                'ts': 1256425200,
                'time': '2009-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          61:
              {
                'ts': 1269730800,
                'time': '2010-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          62:
              {
                'ts': 1288479600,
                'time': '2010-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          63:
              {
                'ts': 1301180400,
                'time': '2011-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          64:
              {
                'ts': 1319929200,
                'time': '2011-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          65:
              {
                'ts': 1332630000,
                'time': '2012-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          66:
              {
                'ts': 1351378800,
                'time': '2012-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          67:
              {
                'ts': 1364684400,
                'time': '2013-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          68:
              {
                'ts': 1382828400,
                'time': '2013-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          69:
              {
                'ts': 1396134000,
                'time': '2014-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          70:
              {
                'ts': 1414278000,
                'time': '2014-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          71:
              {
                'ts': 1427583600,
                'time': '2015-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          72:
              {
                'ts': 1445727600,
                'time': '2015-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          73:
              {
                'ts': 1459033200,
                'time': '2016-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          74:
              {
                'ts': 1477782000,
                'time': '2016-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          75:
              {
                'ts': 1490482800,
                'time': '2017-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          76:
              {
                'ts': 1509231600,
                'time': '2017-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          77:
              {
                'ts': 1521932400,
                'time': '2018-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          78:
              {
                'ts': 1540681200,
                'time': '2018-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          79:
              {
                'ts': 1553986800,
                'time': '2019-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          80:
              {
                'ts': 1572130800,
                'time': '2019-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          81:
              {
                'ts': 1585436400,
                'time': '2020-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          82:
              {
                'ts': 1603580400,
                'time': '2020-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          83:
              {
                'ts': 1616886000,
                'time': '2021-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          84:
              {
                'ts': 1635634800,
                'time': '2021-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          85:
              {
                'ts': 1648335600,
                'time': '2022-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          86:
              {
                'ts': 1667084400,
                'time': '2022-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          87:
              {
                'ts': 1679785200,
                'time': '2023-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          88:
              {
                'ts': 1698534000,
                'time': '2023-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          89:
              {
                'ts': 1711839600,
                'time': '2024-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          90:
              {
                'ts': 1729983600,
                'time': '2024-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          91:
              {
                'ts': 1743289200,
                'time': '2025-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          92:
              {
                'ts': 1761433200,
                'time': '2025-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          93:
              {
                'ts': 1774738800,
                'time': '2026-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          94:
              {
                'ts': 1792882800,
                'time': '2026-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          95:
              {
                'ts': 1806188400,
                'time': '2027-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          96:
              {
                'ts': 1824937200,
                'time': '2027-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          97:
              {
                'ts': 1837638000,
                'time': '2028-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          98:
              {
                'ts': 1856386800,
                'time': '2028-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          99:
              {
                'ts': 1869087600,
                'time': '2029-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          100:
              {
                'ts': 1887836400,
                'time': '2029-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          101:
              {
                'ts': 1901142000,
                'time': '2030-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          102:
              {
                'ts': 1919286000,
                'time': '2030-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          103:
              {
                'ts': 1932591600,
                'time': '2031-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          104:
              {
                'ts': 1950735600,
                'time': '2031-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          105:
              {
                'ts': 1964041200,
                'time': '2032-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          106:
              {
                'ts': 1982790000,
                'time': '2032-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          107:
              {
                'ts': 1995490800,
                'time': '2033-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          108:
              {
                'ts': 2014239600,
                'time': '2033-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          109:
              {
                'ts': 2026940400,
                'time': '2034-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          110:
              {
                'ts': 2045689200,
                'time': '2034-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          111:
              {
                'ts': 2058390000,
                'time': '2035-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          112:
              {
                'ts': 2077138800,
                'time': '2035-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          113:
              {
                'ts': 2090444400,
                'time': '2036-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          114:
              {
                'ts': 2108588400,
                'time': '2036-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              },
          115:
              {
                'ts': 2121894000,
                'time': '2037-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'VOLST'
              },
          116:
              {
                'ts': 2140038000,
                'time': '2037-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'VOLT'
              }
        },
    'Europe/Warsaw':
        {
          0:
              {
                'ts': -1717032240,
                'time': '1915-08-04T22:36:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          1:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          2:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          3:
              {
                'ts': -1663455600,
                'time': '1917-04-16T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          4:
              {
                'ts': -1650150000,
                'time': '1917-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          5:
              {
                'ts': -1632006000,
                'time': '1918-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          6:
              {
                'ts': -1618700400,
                'time': '1918-09-16T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': -1600473600,
                'time': '1919-04-15T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': -1587168000,
                'time': '1919-09-16T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': -1501725600,
                'time': '1922-05-31T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -931734000,
                'time': '1940-06-23T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -796874400,
                'time': '1944-09-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': -796608000,
                'time': '1944-10-04T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': -778726800,
                'time': '1945-04-28T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': -762660000,
                'time': '1945-10-31T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': -748486800,
                'time': '1946-04-13T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': -733273200,
                'time': '1946-10-07T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': -715215600,
                'time': '1947-05-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': -701910000,
                'time': '1947-10-05T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': -684975600,
                'time': '1948-04-18T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': -670460400,
                'time': '1948-10-03T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': -654130800,
                'time': '1949-04-10T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': -639010800,
                'time': '1949-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': -397094400,
                'time': '1957-06-02T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': -386812800,
                'time': '1957-09-29T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': -371088000,
                'time': '1958-03-30T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': -355363200,
                'time': '1958-09-28T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': -334195200,
                'time': '1959-05-31T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': -323308800,
                'time': '1959-10-04T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': -307584000,
                'time': '1960-04-03T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': -291859200,
                'time': '1960-10-02T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': -271296000,
                'time': '1961-05-28T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': -260409600,
                'time': '1961-10-01T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': -239846400,
                'time': '1962-05-27T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': -228960000,
                'time': '1962-09-30T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': -208396800,
                'time': '1963-05-26T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': -197510400,
                'time': '1963-09-29T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': -176342400,
                'time': '1964-05-31T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': -166060800,
                'time': '1964-09-27T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 220921200,
                'time': '1976-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          44:
              {
                'ts': 228873600,
                'time': '1977-04-03T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          45:
              {
                'ts': 243993600,
                'time': '1977-09-25T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          46:
              {
                'ts': 260323200,
                'time': '1978-04-02T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          47:
              {
                'ts': 276048000,
                'time': '1978-10-01T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          48:
              {
                'ts': 291772800,
                'time': '1979-04-01T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          49:
              {
                'ts': 307497600,
                'time': '1979-09-30T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          50:
              {
                'ts': 323827200,
                'time': '1980-04-06T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          51:
              {
                'ts': 338947200,
                'time': '1980-09-28T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          52:
              {
                'ts': 354672000,
                'time': '1981-03-29T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          53:
              {
                'ts': 370396800,
                'time': '1981-09-27T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': 386121600,
                'time': '1982-03-28T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': 401846400,
                'time': '1982-09-26T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          56:
              {
                'ts': 417571200,
                'time': '1983-03-27T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          57:
              {
                'ts': 433296000,
                'time': '1983-09-25T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': 449020800,
                'time': '1984-03-25T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': 465350400,
                'time': '1984-09-30T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 481075200,
                'time': '1985-03-31T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 496800000,
                'time': '1985-09-29T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 512524800,
                'time': '1986-03-30T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 528249600,
                'time': '1986-09-28T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 543974400,
                'time': '1987-03-29T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 559699200,
                'time': '1987-09-27T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 567990000,
                'time': '1987-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          141:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          142:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          143:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          144:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          145:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          146:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          147:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          148:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          149:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          150:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          151:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          152:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          153:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          154:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          155:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          156:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          157:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          158:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          159:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          160:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          161:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          162:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          163:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          164:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          165:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          166:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Zagreb':
        {
          0:
              {
                'ts': -905824800,
                'time': '1941-04-18T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -777942000,
                'time': '1945-05-08T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': -766623600,
                'time': '1945-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': 407199600,
                'time': '1982-11-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          44:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          45:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          46:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          47:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          48:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          49:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          50:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          51:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          52:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          53:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          54:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          55:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          56:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          57:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          58:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Europe/Zaporozhye':
        {
          0:
              {
                'ts': -1441160400,
                'time': '1924-05-01T21:40:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -1247536800,
                'time': '1930-06-20T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          2:
              {
                'ts': -894769200,
                'time': '1941-08-24T21:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': -826419600,
                'time': '1943-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          7:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          8:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          9:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          10:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          11:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          12:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          13:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          14:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          15:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          16:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          17:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          18:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          19:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          20:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          21:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          22:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          23:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          24:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          25:
              {
                'ts': 638319600,
                'time': '1990-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          26:
              {
                'ts': 654649200,
                'time': '1990-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          27:
              {
                'ts': 670374000,
                'time': '1991-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': 686091600,
                'time': '1991-09-28T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': 717541200,
                'time': '1992-09-26T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': 733269600,
                'time': '1993-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': 748990800,
                'time': '1993-09-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': 764719200,
                'time': '1994-03-26T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': 780440400,
                'time': '1994-09-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          55:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          56:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          57:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          58:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          59:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          60:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          61:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          62:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          63:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          64:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          65:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          66:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          67:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          68:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          69:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          70:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          71:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          72:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          73:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          74:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          75:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          76:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          77:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          78:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          79:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          80:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          81:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          82:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          83:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          84:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          85:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          86:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          87:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          88:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          89:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          90:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          91:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          92:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          93:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          94:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          95:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          96:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          97:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          98:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          99:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          100:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          101:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          102:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          103:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          104:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          105:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          106:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          107:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          108:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'Europe/Zurich':
        {
          0:
              {
                'ts': -920336400,
                'time': '1940-11-01T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          1:
              {
                'ts': -915242400,
                'time': '1940-12-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          2:
              {
                'ts': -904518000,
                'time': '1941-05-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          3:
              {
                'ts': -891223200,
                'time': '1941-10-04T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          4:
              {
                'ts': -873068400,
                'time': '1942-05-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          5:
              {
                'ts': -859773600,
                'time': '1942-10-03T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          6:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          7:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          8:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          9:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          16:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          17:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          18:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          19:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          20:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          21:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          22:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          23:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          24:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          25:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          26:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          27:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          28:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          29:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          30:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          31:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          32:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          33:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          34:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          35:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          36:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          37:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          38:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          39:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          40:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          41:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          42:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          43:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          44:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          45:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          46:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          47:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          48:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          49:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          50:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          51:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          52:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          53:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          56:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          57:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          67:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          68:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          69:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          70:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          71:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          72:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          73:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          74:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          75:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          76:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          77:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          78:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          79:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          80:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          81:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          82:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          83:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          84:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          85:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          86:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          87:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          88:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          89:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          90:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          91:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          92:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          93:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          94:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          95:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          96:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          97:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          99:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          100:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          101:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          102:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          103:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          104:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          105:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          106:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          107:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          108:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          109:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          110:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          111:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          112:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          113:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          114:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          115:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          116:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          117:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          118:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          119:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Factory':
        {
        },
    'GB':
        {
          0:
              {
                'ts': -1691964000,
                'time': '1916-05-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          1:
              {
                'ts': -1680472800,
                'time': '1916-10-01T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          2:
              {
                'ts': -1664143200,
                'time': '1917-04-08T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          3:
              {
                'ts': -1650146400,
                'time': '1917-09-17T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          4:
              {
                'ts': -1633903200,
                'time': '1918-03-24T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          5:
              {
                'ts': -1617487200,
                'time': '1918-09-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          6:
              {
                'ts': -1601848800,
                'time': '1919-03-30T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          7:
              {
                'ts': -1586037600,
                'time': '1919-09-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          8:
              {
                'ts': -1570399200,
                'time': '1920-03-28T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          9:
              {
                'ts': -1552168800,
                'time': '1920-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          10:
              {
                'ts': -1538344800,
                'time': '1921-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          11:
              {
                'ts': -1522533600,
                'time': '1921-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          12:
              {
                'ts': -1507500000,
                'time': '1922-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          13:
              {
                'ts': -1490565600,
                'time': '1922-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          14:
              {
                'ts': -1473631200,
                'time': '1923-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          15:
              {
                'ts': -1460930400,
                'time': '1923-09-16T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          16:
              {
                'ts': -1442786400,
                'time': '1924-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          17:
              {
                'ts': -1428876000,
                'time': '1924-09-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          18:
              {
                'ts': -1410732000,
                'time': '1925-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          19:
              {
                'ts': -1396216800,
                'time': '1925-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          20:
              {
                'ts': -1379282400,
                'time': '1926-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          21:
              {
                'ts': -1364767200,
                'time': '1926-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          22:
              {
                'ts': -1348437600,
                'time': '1927-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          23:
              {
                'ts': -1333317600,
                'time': '1927-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          24:
              {
                'ts': -1315778400,
                'time': '1928-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          25:
              {
                'ts': -1301263200,
                'time': '1928-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          26:
              {
                'ts': -1284328800,
                'time': '1929-04-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          27:
              {
                'ts': -1269813600,
                'time': '1929-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          28:
              {
                'ts': -1253484000,
                'time': '1930-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          29:
              {
                'ts': -1238364000,
                'time': '1930-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          30:
              {
                'ts': -1221429600,
                'time': '1931-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          31:
              {
                'ts': -1206914400,
                'time': '1931-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          32:
              {
                'ts': -1189980000,
                'time': '1932-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          33:
              {
                'ts': -1175464800,
                'time': '1932-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          34:
              {
                'ts': -1159135200,
                'time': '1933-04-09T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          35:
              {
                'ts': -1143410400,
                'time': '1933-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          36:
              {
                'ts': -1126476000,
                'time': '1934-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          37:
              {
                'ts': -1111960800,
                'time': '1934-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          38:
              {
                'ts': -1095631200,
                'time': '1935-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          39:
              {
                'ts': -1080511200,
                'time': '1935-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          40:
              {
                'ts': -1063576800,
                'time': '1936-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          41:
              {
                'ts': -1049061600,
                'time': '1936-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          42:
              {
                'ts': -1032127200,
                'time': '1937-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          43:
              {
                'ts': -1017612000,
                'time': '1937-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          44:
              {
                'ts': -1001282400,
                'time': '1938-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          45:
              {
                'ts': -986162400,
                'time': '1938-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          46:
              {
                'ts': -969228000,
                'time': '1939-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          47:
              {
                'ts': -950479200,
                'time': '1939-11-19T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          48:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          49:
              {
                'ts': -904518000,
                'time': '1941-05-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          50:
              {
                'ts': -896050800,
                'time': '1941-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          51:
              {
                'ts': -875487600,
                'time': '1942-04-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          52:
              {
                'ts': -864601200,
                'time': '1942-08-09T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          53:
              {
                'ts': -844038000,
                'time': '1943-04-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          54:
              {
                'ts': -832546800,
                'time': '1943-08-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          55:
              {
                'ts': -812588400,
                'time': '1944-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          56:
              {
                'ts': -798073200,
                'time': '1944-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          57:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          58:
              {
                'ts': -772066800,
                'time': '1945-07-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          59:
              {
                'ts': -764805600,
                'time': '1945-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          60:
              {
                'ts': -748476000,
                'time': '1946-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          61:
              {
                'ts': -733356000,
                'time': '1946-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          62:
              {
                'ts': -719445600,
                'time': '1947-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          63:
              {
                'ts': -717030000,
                'time': '1947-04-13T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          64:
              {
                'ts': -706748400,
                'time': '1947-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          65:
              {
                'ts': -699487200,
                'time': '1947-11-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          66:
              {
                'ts': -687996000,
                'time': '1948-03-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          67:
              {
                'ts': -668037600,
                'time': '1948-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          68:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          69:
              {
                'ts': -636588000,
                'time': '1949-10-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          70:
              {
                'ts': -622072800,
                'time': '1950-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          71:
              {
                'ts': -605743200,
                'time': '1950-10-22T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          72:
              {
                'ts': -590623200,
                'time': '1951-04-15T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          73:
              {
                'ts': -574293600,
                'time': '1951-10-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          74:
              {
                'ts': -558568800,
                'time': '1952-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          75:
              {
                'ts': -542239200,
                'time': '1952-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          76:
              {
                'ts': -527119200,
                'time': '1953-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          77:
              {
                'ts': -512604000,
                'time': '1953-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          78:
              {
                'ts': -496274400,
                'time': '1954-04-11T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          79:
              {
                'ts': -481154400,
                'time': '1954-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          80:
              {
                'ts': -464220000,
                'time': '1955-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          81:
              {
                'ts': -449704800,
                'time': '1955-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          82:
              {
                'ts': -432165600,
                'time': '1956-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          83:
              {
                'ts': -417650400,
                'time': '1956-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          84:
              {
                'ts': -401320800,
                'time': '1957-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          85:
              {
                'ts': -386200800,
                'time': '1957-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          86:
              {
                'ts': -369266400,
                'time': '1958-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          87:
              {
                'ts': -354751200,
                'time': '1958-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          88:
              {
                'ts': -337816800,
                'time': '1959-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          89:
              {
                'ts': -323301600,
                'time': '1959-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          90:
              {
                'ts': -306972000,
                'time': '1960-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          91:
              {
                'ts': -291852000,
                'time': '1960-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          92:
              {
                'ts': -276732000,
                'time': '1961-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          93:
              {
                'ts': -257983200,
                'time': '1961-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          94:
              {
                'ts': -245282400,
                'time': '1962-03-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          95:
              {
                'ts': -226533600,
                'time': '1962-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          96:
              {
                'ts': -213228000,
                'time': '1963-03-31T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          97:
              {
                'ts': -195084000,
                'time': '1963-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          98:
              {
                'ts': -182383200,
                'time': '1964-03-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          99:
              {
                'ts': -163634400,
                'time': '1964-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          100:
              {
                'ts': -150933600,
                'time': '1965-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          101:
              {
                'ts': -132184800,
                'time': '1965-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          102:
              {
                'ts': -119484000,
                'time': '1966-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          103:
              {
                'ts': -100735200,
                'time': '1966-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          104:
              {
                'ts': -88034400,
                'time': '1967-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          105:
              {
                'ts': -68680800,
                'time': '1967-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          106:
              {
                'ts': -59004000,
                'time': '1968-02-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          107:
              {
                'ts': -37242000,
                'time': '1968-10-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'BST'
              },
          108:
              {
                'ts': 57722400,
                'time': '1971-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          109:
              {
                'ts': 69818400,
                'time': '1972-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          110:
              {
                'ts': 89172000,
                'time': '1972-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          111:
              {
                'ts': 101268000,
                'time': '1973-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          112:
              {
                'ts': 120621600,
                'time': '1973-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          113:
              {
                'ts': 132717600,
                'time': '1974-03-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          114:
              {
                'ts': 152071200,
                'time': '1974-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          115:
              {
                'ts': 164167200,
                'time': '1975-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          116:
              {
                'ts': 183520800,
                'time': '1975-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          117:
              {
                'ts': 196221600,
                'time': '1976-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          118:
              {
                'ts': 214970400,
                'time': '1976-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          119:
              {
                'ts': 227671200,
                'time': '1977-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          120:
              {
                'ts': 246420000,
                'time': '1977-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          121:
              {
                'ts': 259120800,
                'time': '1978-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          122:
              {
                'ts': 278474400,
                'time': '1978-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          123:
              {
                'ts': 290570400,
                'time': '1979-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          124:
              {
                'ts': 309924000,
                'time': '1979-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          125:
              {
                'ts': 322020000,
                'time': '1980-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          126:
              {
                'ts': 341373600,
                'time': '1980-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          127:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          128:
              {
                'ts': 372819600,
                'time': '1981-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          129:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          130:
              {
                'ts': 404269200,
                'time': '1982-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          131:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          132:
              {
                'ts': 435718800,
                'time': '1983-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          133:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          134:
              {
                'ts': 467773200,
                'time': '1984-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          135:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          136:
              {
                'ts': 499222800,
                'time': '1985-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          137:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          138:
              {
                'ts': 530672400,
                'time': '1986-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          139:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          140:
              {
                'ts': 562122000,
                'time': '1987-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          141:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          142:
              {
                'ts': 593571600,
                'time': '1988-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          143:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          144:
              {
                'ts': 625626000,
                'time': '1989-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          145:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          146:
              {
                'ts': 657075600,
                'time': '1990-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          147:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          148:
              {
                'ts': 688525200,
                'time': '1991-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          149:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          150:
              {
                'ts': 719974800,
                'time': '1992-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          151:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          152:
              {
                'ts': 751424400,
                'time': '1993-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          153:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          154:
              {
                'ts': 782874000,
                'time': '1994-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          155:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          156:
              {
                'ts': 814323600,
                'time': '1995-10-22T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          157:
              {
                'ts': 820454400,
                'time': '1996-01-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          158:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          159:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          160:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          161:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          162:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          163:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          164:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          165:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          166:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          167:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          168:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          169:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          170:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          171:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          172:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          173:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          174:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          175:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          176:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          177:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          178:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          179:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          180:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          181:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          182:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          183:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          184:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          185:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          186:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          187:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          188:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          189:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          190:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          191:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          192:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          193:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          194:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          195:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          196:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          197:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          198:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          199:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          200:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          201:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          202:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          203:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          204:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          205:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          206:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          207:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          208:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          209:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          210:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          211:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          212:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          213:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          214:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          215:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          216:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          217:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          218:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          219:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          220:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          221:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          222:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          223:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          224:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          225:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          226:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          227:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          228:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          229:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          230:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          231:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          232:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          233:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          234:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          235:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          236:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          237:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          238:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          239:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          240:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          241:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'GB-Eire':
        {
          0:
              {
                'ts': -1691964000,
                'time': '1916-05-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          1:
              {
                'ts': -1680472800,
                'time': '1916-10-01T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          2:
              {
                'ts': -1664143200,
                'time': '1917-04-08T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          3:
              {
                'ts': -1650146400,
                'time': '1917-09-17T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          4:
              {
                'ts': -1633903200,
                'time': '1918-03-24T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          5:
              {
                'ts': -1617487200,
                'time': '1918-09-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          6:
              {
                'ts': -1601848800,
                'time': '1919-03-30T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          7:
              {
                'ts': -1586037600,
                'time': '1919-09-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          8:
              {
                'ts': -1570399200,
                'time': '1920-03-28T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          9:
              {
                'ts': -1552168800,
                'time': '1920-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          10:
              {
                'ts': -1538344800,
                'time': '1921-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          11:
              {
                'ts': -1522533600,
                'time': '1921-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          12:
              {
                'ts': -1507500000,
                'time': '1922-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          13:
              {
                'ts': -1490565600,
                'time': '1922-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          14:
              {
                'ts': -1473631200,
                'time': '1923-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          15:
              {
                'ts': -1460930400,
                'time': '1923-09-16T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          16:
              {
                'ts': -1442786400,
                'time': '1924-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          17:
              {
                'ts': -1428876000,
                'time': '1924-09-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          18:
              {
                'ts': -1410732000,
                'time': '1925-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          19:
              {
                'ts': -1396216800,
                'time': '1925-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          20:
              {
                'ts': -1379282400,
                'time': '1926-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          21:
              {
                'ts': -1364767200,
                'time': '1926-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          22:
              {
                'ts': -1348437600,
                'time': '1927-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          23:
              {
                'ts': -1333317600,
                'time': '1927-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          24:
              {
                'ts': -1315778400,
                'time': '1928-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          25:
              {
                'ts': -1301263200,
                'time': '1928-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          26:
              {
                'ts': -1284328800,
                'time': '1929-04-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          27:
              {
                'ts': -1269813600,
                'time': '1929-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          28:
              {
                'ts': -1253484000,
                'time': '1930-04-13T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          29:
              {
                'ts': -1238364000,
                'time': '1930-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          30:
              {
                'ts': -1221429600,
                'time': '1931-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          31:
              {
                'ts': -1206914400,
                'time': '1931-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          32:
              {
                'ts': -1189980000,
                'time': '1932-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          33:
              {
                'ts': -1175464800,
                'time': '1932-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          34:
              {
                'ts': -1159135200,
                'time': '1933-04-09T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          35:
              {
                'ts': -1143410400,
                'time': '1933-10-08T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          36:
              {
                'ts': -1126476000,
                'time': '1934-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          37:
              {
                'ts': -1111960800,
                'time': '1934-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          38:
              {
                'ts': -1095631200,
                'time': '1935-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          39:
              {
                'ts': -1080511200,
                'time': '1935-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          40:
              {
                'ts': -1063576800,
                'time': '1936-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          41:
              {
                'ts': -1049061600,
                'time': '1936-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          42:
              {
                'ts': -1032127200,
                'time': '1937-04-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          43:
              {
                'ts': -1017612000,
                'time': '1937-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          44:
              {
                'ts': -1001282400,
                'time': '1938-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          45:
              {
                'ts': -986162400,
                'time': '1938-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          46:
              {
                'ts': -969228000,
                'time': '1939-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          47:
              {
                'ts': -950479200,
                'time': '1939-11-19T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          48:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          49:
              {
                'ts': -904518000,
                'time': '1941-05-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          50:
              {
                'ts': -896050800,
                'time': '1941-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          51:
              {
                'ts': -875487600,
                'time': '1942-04-05T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          52:
              {
                'ts': -864601200,
                'time': '1942-08-09T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          53:
              {
                'ts': -844038000,
                'time': '1943-04-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          54:
              {
                'ts': -832546800,
                'time': '1943-08-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          55:
              {
                'ts': -812588400,
                'time': '1944-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          56:
              {
                'ts': -798073200,
                'time': '1944-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          57:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          58:
              {
                'ts': -772066800,
                'time': '1945-07-15T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          59:
              {
                'ts': -764805600,
                'time': '1945-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          60:
              {
                'ts': -748476000,
                'time': '1946-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          61:
              {
                'ts': -733356000,
                'time': '1946-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          62:
              {
                'ts': -719445600,
                'time': '1947-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          63:
              {
                'ts': -717030000,
                'time': '1947-04-13T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'BDST'
              },
          64:
              {
                'ts': -706748400,
                'time': '1947-08-10T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          65:
              {
                'ts': -699487200,
                'time': '1947-11-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          66:
              {
                'ts': -687996000,
                'time': '1948-03-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          67:
              {
                'ts': -668037600,
                'time': '1948-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          68:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          69:
              {
                'ts': -636588000,
                'time': '1949-10-30T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          70:
              {
                'ts': -622072800,
                'time': '1950-04-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          71:
              {
                'ts': -605743200,
                'time': '1950-10-22T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          72:
              {
                'ts': -590623200,
                'time': '1951-04-15T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          73:
              {
                'ts': -574293600,
                'time': '1951-10-21T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          74:
              {
                'ts': -558568800,
                'time': '1952-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          75:
              {
                'ts': -542239200,
                'time': '1952-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          76:
              {
                'ts': -527119200,
                'time': '1953-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          77:
              {
                'ts': -512604000,
                'time': '1953-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          78:
              {
                'ts': -496274400,
                'time': '1954-04-11T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          79:
              {
                'ts': -481154400,
                'time': '1954-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          80:
              {
                'ts': -464220000,
                'time': '1955-04-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          81:
              {
                'ts': -449704800,
                'time': '1955-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          82:
              {
                'ts': -432165600,
                'time': '1956-04-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          83:
              {
                'ts': -417650400,
                'time': '1956-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          84:
              {
                'ts': -401320800,
                'time': '1957-04-14T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          85:
              {
                'ts': -386200800,
                'time': '1957-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          86:
              {
                'ts': -369266400,
                'time': '1958-04-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          87:
              {
                'ts': -354751200,
                'time': '1958-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          88:
              {
                'ts': -337816800,
                'time': '1959-04-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          89:
              {
                'ts': -323301600,
                'time': '1959-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          90:
              {
                'ts': -306972000,
                'time': '1960-04-10T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          91:
              {
                'ts': -291852000,
                'time': '1960-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          92:
              {
                'ts': -276732000,
                'time': '1961-03-26T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          93:
              {
                'ts': -257983200,
                'time': '1961-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          94:
              {
                'ts': -245282400,
                'time': '1962-03-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          95:
              {
                'ts': -226533600,
                'time': '1962-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          96:
              {
                'ts': -213228000,
                'time': '1963-03-31T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          97:
              {
                'ts': -195084000,
                'time': '1963-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          98:
              {
                'ts': -182383200,
                'time': '1964-03-22T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          99:
              {
                'ts': -163634400,
                'time': '1964-10-25T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          100:
              {
                'ts': -150933600,
                'time': '1965-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          101:
              {
                'ts': -132184800,
                'time': '1965-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          102:
              {
                'ts': -119484000,
                'time': '1966-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          103:
              {
                'ts': -100735200,
                'time': '1966-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          104:
              {
                'ts': -88034400,
                'time': '1967-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          105:
              {
                'ts': -68680800,
                'time': '1967-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          106:
              {
                'ts': -59004000,
                'time': '1968-02-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          107:
              {
                'ts': -37242000,
                'time': '1968-10-26T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'BST'
              },
          108:
              {
                'ts': 57722400,
                'time': '1971-10-31T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          109:
              {
                'ts': 69818400,
                'time': '1972-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          110:
              {
                'ts': 89172000,
                'time': '1972-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          111:
              {
                'ts': 101268000,
                'time': '1973-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          112:
              {
                'ts': 120621600,
                'time': '1973-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          113:
              {
                'ts': 132717600,
                'time': '1974-03-17T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          114:
              {
                'ts': 152071200,
                'time': '1974-10-27T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          115:
              {
                'ts': 164167200,
                'time': '1975-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          116:
              {
                'ts': 183520800,
                'time': '1975-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          117:
              {
                'ts': 196221600,
                'time': '1976-03-21T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          118:
              {
                'ts': 214970400,
                'time': '1976-10-24T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          119:
              {
                'ts': 227671200,
                'time': '1977-03-20T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          120:
              {
                'ts': 246420000,
                'time': '1977-10-23T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          121:
              {
                'ts': 259120800,
                'time': '1978-03-19T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          122:
              {
                'ts': 278474400,
                'time': '1978-10-29T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          123:
              {
                'ts': 290570400,
                'time': '1979-03-18T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          124:
              {
                'ts': 309924000,
                'time': '1979-10-28T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          125:
              {
                'ts': 322020000,
                'time': '1980-03-16T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          126:
              {
                'ts': 341373600,
                'time': '1980-10-26T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          127:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          128:
              {
                'ts': 372819600,
                'time': '1981-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          129:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          130:
              {
                'ts': 404269200,
                'time': '1982-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          131:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          132:
              {
                'ts': 435718800,
                'time': '1983-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          133:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          134:
              {
                'ts': 467773200,
                'time': '1984-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          135:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          136:
              {
                'ts': 499222800,
                'time': '1985-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          137:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          138:
              {
                'ts': 530672400,
                'time': '1986-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          139:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          140:
              {
                'ts': 562122000,
                'time': '1987-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          141:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          142:
              {
                'ts': 593571600,
                'time': '1988-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          143:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          144:
              {
                'ts': 625626000,
                'time': '1989-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          145:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          146:
              {
                'ts': 657075600,
                'time': '1990-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          147:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          148:
              {
                'ts': 688525200,
                'time': '1991-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          149:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          150:
              {
                'ts': 719974800,
                'time': '1992-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          151:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          152:
              {
                'ts': 751424400,
                'time': '1993-10-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          153:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          154:
              {
                'ts': 782874000,
                'time': '1994-10-23T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          155:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          156:
              {
                'ts': 814323600,
                'time': '1995-10-22T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          157:
              {
                'ts': 820454400,
                'time': '1996-01-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          158:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          159:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          160:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          161:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          162:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          163:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          164:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          165:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          166:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          167:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          168:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          169:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          170:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          171:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          172:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          173:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          174:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          175:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          176:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          177:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          178:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          179:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          180:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          181:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          182:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          183:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          184:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          185:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          186:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          187:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          188:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          189:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          190:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          191:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          192:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          193:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          194:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          195:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          196:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          197:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          198:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          199:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          200:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          201:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          202:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          203:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          204:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          205:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          206:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          207:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          208:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          209:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          210:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          211:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          212:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          213:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          214:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          215:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          216:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          217:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          218:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          219:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          220:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          221:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          222:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          223:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          224:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          225:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          226:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          227:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          228:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          229:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          230:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          231:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          232:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          233:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          234:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          235:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          236:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          237:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          238:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          239:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              },
          240:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'BST'
              },
          241:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'GMT':
        {
        },
    'GMT+0':
        {
        },
    'GMT-0':
        {
        },
    'GMT0':
        {
        },
    'Greenwich':
        {
        },
    'Hongkong':
        {
          0:
              {
                'ts': -2056692996,
                'time': '1904-10-29T16:23:24+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          1:
              {
                'ts': -747981000,
                'time': '1946-04-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          2:
              {
                'ts': -728544600,
                'time': '1946-11-30T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          3:
              {
                'ts': -717049800,
                'time': '1947-04-12T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          4:
              {
                'ts': -694503000,
                'time': '1947-12-29T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          5:
              {
                'ts': -683785800,
                'time': '1948-05-01T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          6:
              {
                'ts': -668064600,
                'time': '1948-10-30T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          7:
              {
                'ts': -654755400,
                'time': '1949-04-02T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          8:
              {
                'ts': -636615000,
                'time': '1949-10-29T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          9:
              {
                'ts': -623305800,
                'time': '1950-04-01T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          10:
              {
                'ts': -605165400,
                'time': '1950-10-28T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          11:
              {
                'ts': -591856200,
                'time': '1951-03-31T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          12:
              {
                'ts': -573715800,
                'time': '1951-10-27T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          13:
              {
                'ts': -559801800,
                'time': '1952-04-05T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          14:
              {
                'ts': -542266200,
                'time': '1952-10-25T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          15:
              {
                'ts': -528352200,
                'time': '1953-04-04T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          16:
              {
                'ts': -510211800,
                'time': '1953-10-31T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          17:
              {
                'ts': -498112200,
                'time': '1954-03-20T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          18:
              {
                'ts': -478762200,
                'time': '1954-10-30T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          19:
              {
                'ts': -466662600,
                'time': '1955-03-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          20:
              {
                'ts': -446707800,
                'time': '1955-11-05T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          21:
              {
                'ts': -435213000,
                'time': '1956-03-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          22:
              {
                'ts': -415258200,
                'time': '1956-11-03T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          23:
              {
                'ts': -403158600,
                'time': '1957-03-23T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          24:
              {
                'ts': -383808600,
                'time': '1957-11-02T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          25:
              {
                'ts': -371709000,
                'time': '1958-03-22T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          26:
              {
                'ts': -352359000,
                'time': '1958-11-01T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          27:
              {
                'ts': -340259400,
                'time': '1959-03-21T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          28:
              {
                'ts': -320909400,
                'time': '1959-10-31T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          29:
              {
                'ts': -308809800,
                'time': '1960-03-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          30:
              {
                'ts': -288855000,
                'time': '1960-11-05T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          31:
              {
                'ts': -277360200,
                'time': '1961-03-18T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          32:
              {
                'ts': -257405400,
                'time': '1961-11-04T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          33:
              {
                'ts': -245910600,
                'time': '1962-03-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          34:
              {
                'ts': -225955800,
                'time': '1962-11-03T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          35:
              {
                'ts': -213856200,
                'time': '1963-03-23T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          36:
              {
                'ts': -194506200,
                'time': '1963-11-02T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          37:
              {
                'ts': -182406600,
                'time': '1964-03-21T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          38:
              {
                'ts': -163056600,
                'time': '1964-10-31T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          39:
              {
                'ts': -148537800,
                'time': '1965-04-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          40:
              {
                'ts': -132816600,
                'time': '1965-10-16T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          41:
              {
                'ts': -117088200,
                'time': '1966-04-16T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          42:
              {
                'ts': -101367000,
                'time': '1966-10-15T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          43:
              {
                'ts': -85638600,
                'time': '1967-04-15T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          44:
              {
                'ts': -69312600,
                'time': '1967-10-21T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          45:
              {
                'ts': -53584200,
                'time': '1968-04-20T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          46:
              {
                'ts': -37863000,
                'time': '1968-10-19T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          47:
              {
                'ts': -22134600,
                'time': '1969-04-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          48:
              {
                'ts': -6413400,
                'time': '1969-10-18T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          49:
              {
                'ts': 9315000,
                'time': '1970-04-18T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          50:
              {
                'ts': 25036200,
                'time': '1970-10-17T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          51:
              {
                'ts': 40764600,
                'time': '1971-04-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          52:
              {
                'ts': 56485800,
                'time': '1971-10-16T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          53:
              {
                'ts': 72214200,
                'time': '1972-04-15T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          54:
              {
                'ts': 88540200,
                'time': '1972-10-21T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          55:
              {
                'ts': 104268600,
                'time': '1973-04-21T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          56:
              {
                'ts': 119989800,
                'time': '1973-10-20T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          57:
              {
                'ts': 135718200,
                'time': '1974-04-20T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          58:
              {
                'ts': 151439400,
                'time': '1974-10-19T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          59:
              {
                'ts': 167167800,
                'time': '1975-04-19T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          60:
              {
                'ts': 182889000,
                'time': '1975-10-18T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          61:
              {
                'ts': 198617400,
                'time': '1976-04-17T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          62:
              {
                'ts': 214338600,
                'time': '1976-10-16T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          63:
              {
                'ts': 230067000,
                'time': '1977-04-16T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          64:
              {
                'ts': 245788200,
                'time': '1977-10-15T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          65:
              {
                'ts': 295385400,
                'time': '1979-05-12T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          66:
              {
                'ts': 309292200,
                'time': '1979-10-20T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              },
          67:
              {
                'ts': 326835000,
                'time': '1980-05-10T19:30:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'HKST'
              },
          68:
              {
                'ts': 340741800,
                'time': '1980-10-18T18:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'HKT'
              }
        },
    'HST':
        {
          0:
              {
                'ts': -1157283000,
                'time': '1933-04-30T12:30:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'HDT'
              },
          1:
              {
                'ts': -1155472200,
                'time': '1933-05-21T11:30:00+0000',
                'offset': -37800,
                'isdst': false,
                'abbr': 'HST'
              },
          2:
              {
                'ts': -880198200,
                'time': '1942-02-09T12:30:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'HWT'
              },
          3:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'HPT'
              },
          4:
              {
                'ts': -765376200,
                'time': '1945-09-30T11:30:00+0000',
                'offset': -37800,
                'isdst': false,
                'abbr': 'HST'
              },
          5:
              {
                'ts': -712150200,
                'time': '1947-06-08T12:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HST'
              }
        },
    'Iceland':
        {
          0:
              {
                'ts': -1956609132,
                'time': '1908-01-01T01:27:48+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          1:
              {
                'ts': -1668211200,
                'time': '1917-02-20T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          2:
              {
                'ts': -1647212400,
                'time': '1917-10-21T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          3:
              {
                'ts': -1636675200,
                'time': '1918-02-20T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          4:
              {
                'ts': -1613430000,
                'time': '1918-11-16T01:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          5:
              {
                'ts': -968025600,
                'time': '1939-04-30T00:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          6:
              {
                'ts': -949615200,
                'time': '1939-11-29T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          7:
              {
                'ts': -942008400,
                'time': '1940-02-25T03:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          8:
              {
                'ts': -920239200,
                'time': '1940-11-03T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          9:
              {
                'ts': -909957600,
                'time': '1941-03-02T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          10:
              {
                'ts': -888789600,
                'time': '1941-11-02T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          11:
              {
                'ts': -877903200,
                'time': '1942-03-08T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          12:
              {
                'ts': -857944800,
                'time': '1942-10-25T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          13:
              {
                'ts': -846453600,
                'time': '1943-03-07T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          14:
              {
                'ts': -826495200,
                'time': '1943-10-24T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          15:
              {
                'ts': -815004000,
                'time': '1944-03-05T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          16:
              {
                'ts': -795045600,
                'time': '1944-10-22T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          17:
              {
                'ts': -783554400,
                'time': '1945-03-04T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          18:
              {
                'ts': -762991200,
                'time': '1945-10-28T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          19:
              {
                'ts': -752104800,
                'time': '1946-03-03T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          20:
              {
                'ts': -731541600,
                'time': '1946-10-27T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          21:
              {
                'ts': -717631200,
                'time': '1947-04-06T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          22:
              {
                'ts': -700092000,
                'time': '1947-10-26T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          23:
              {
                'ts': -686181600,
                'time': '1948-04-04T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          24:
              {
                'ts': -668642400,
                'time': '1948-10-24T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          25:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          26:
              {
                'ts': -636588000,
                'time': '1949-10-30T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          27:
              {
                'ts': -623282400,
                'time': '1950-04-02T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          28:
              {
                'ts': -605743200,
                'time': '1950-10-22T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          29:
              {
                'ts': -591832800,
                'time': '1951-04-01T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          30:
              {
                'ts': -573688800,
                'time': '1951-10-28T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          31:
              {
                'ts': -559778400,
                'time': '1952-04-06T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          32:
              {
                'ts': -542239200,
                'time': '1952-10-26T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          33:
              {
                'ts': -528328800,
                'time': '1953-04-05T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          34:
              {
                'ts': -510789600,
                'time': '1953-10-25T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          35:
              {
                'ts': -496879200,
                'time': '1954-04-04T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          36:
              {
                'ts': -479340000,
                'time': '1954-10-24T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          37:
              {
                'ts': -465429600,
                'time': '1955-04-03T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          38:
              {
                'ts': -447890400,
                'time': '1955-10-23T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          39:
              {
                'ts': -433980000,
                'time': '1956-04-01T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          40:
              {
                'ts': -415836000,
                'time': '1956-10-28T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          41:
              {
                'ts': -401925600,
                'time': '1957-04-07T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          42:
              {
                'ts': -384386400,
                'time': '1957-10-27T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          43:
              {
                'ts': -370476000,
                'time': '1958-04-06T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          44:
              {
                'ts': -352936800,
                'time': '1958-10-26T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          45:
              {
                'ts': -339026400,
                'time': '1959-04-05T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          46:
              {
                'ts': -321487200,
                'time': '1959-10-25T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          47:
              {
                'ts': -307576800,
                'time': '1960-04-03T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          48:
              {
                'ts': -290037600,
                'time': '1960-10-23T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          49:
              {
                'ts': -276127200,
                'time': '1961-04-02T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          50:
              {
                'ts': -258588000,
                'time': '1961-10-22T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          51:
              {
                'ts': -244677600,
                'time': '1962-04-01T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          52:
              {
                'ts': -226533600,
                'time': '1962-10-28T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          53:
              {
                'ts': -212623200,
                'time': '1963-04-07T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          54:
              {
                'ts': -195084000,
                'time': '1963-10-27T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          55:
              {
                'ts': -181173600,
                'time': '1964-04-05T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          56:
              {
                'ts': -163634400,
                'time': '1964-10-25T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          57:
              {
                'ts': -149724000,
                'time': '1965-04-04T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          58:
              {
                'ts': -132184800,
                'time': '1965-10-24T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          59:
              {
                'ts': -118274400,
                'time': '1966-04-03T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          60:
              {
                'ts': -100735200,
                'time': '1966-10-23T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          61:
              {
                'ts': -86824800,
                'time': '1967-04-02T02:00:00+0000',
                'offset': 0,
                'isdst': true,
                'abbr': 'ISST'
              },
          62:
              {
                'ts': -68680800,
                'time': '1967-10-29T02:00:00+0000',
                'offset': -3600,
                'isdst': false,
                'abbr': 'IST'
              },
          63:
              {
                'ts': -54770400,
                'time': '1968-04-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'GMT'
              }
        },
    'Indian/Antananarivo':
        {
          0:
              {
                'ts': -1846293004,
                'time': '1911-06-30T20:49:56+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              },
          1:
              {
                'ts': -499924800,
                'time': '1954-02-27T20:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'EAST'
              },
          2:
              {
                'ts': -492062400,
                'time': '1954-05-29T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              }
        },
    'Indian/Chagos':
        {
          0:
              {
                'ts': -1988167780,
                'time': '1906-12-31T19:10:20+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'IOT'
              },
          1:
              {
                'ts': 820436400,
                'time': '1995-12-31T19:00:00+0000',
                'offset': 21600,
                'isdst': false,
                'abbr': 'IOT'
              }
        },
    'Indian/Christmas':
        {
        },
    'Indian/Cocos':
        {
        },
    'Indian/Comoro':
        {
          0:
              {
                'ts': -1846291984,
                'time': '1911-06-30T21:06:56+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              }
        },
    'Indian/Kerguelen':
        {
          0:
              {
                'ts': -631152000,
                'time': '1950-01-01T00:00:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'TFT'
              }
        },
    'Indian/Mahe':
        {
          0:
              {
                'ts': -2006653308,
                'time': '1906-05-31T20:18:12+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'SCT'
              }
        },
    'Indian/Maldives':
        {
          0:
              {
                'ts': -315636840,
                'time': '1959-12-31T19:06:00+0000',
                'offset': 18000,
                'isdst': false,
                'abbr': 'MVT'
              }
        },
    'Indian/Mauritius':
        {
          0:
              {
                'ts': -1988164200,
                'time': '1906-12-31T20:10:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'MUT'
              }
        },
    'Indian/Mayotte':
        {
          0:
              {
                'ts': -1846292456,
                'time': '1911-06-30T20:59:04+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'EAT'
              }
        },
    'Indian/Reunion':
        {
          0:
              {
                'ts': -1848886912,
                'time': '1911-05-31T20:18:08+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'RET'
              }
        },
    'Iran':
        {
          0:
              {
                'ts': -1704165944,
                'time': '1915-12-31T20:34:16+0000',
                'offset': 12344,
                'isdst': false,
                'abbr': 'TMT'
              },
          1:
              {
                'ts': -757394744,
                'time': '1945-12-31T20:34:16+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          2:
              {
                'ts': 247177800,
                'time': '1977-10-31T20:30:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'IRST'
              },
          3:
              {
                'ts': 259272000,
                'time': '1978-03-20T20:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'IRDT'
              },
          4:
              {
                'ts': 277758000,
                'time': '1978-10-20T19:00:00+0000',
                'offset': 14400,
                'isdst': false,
                'abbr': 'IRST'
              },
          5:
              {
                'ts': 283982400,
                'time': '1978-12-31T20:00:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          6:
              {
                'ts': 290809800,
                'time': '1979-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          7:
              {
                'ts': 306531000,
                'time': '1979-09-18T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          8:
              {
                'ts': 322432200,
                'time': '1980-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          9:
              {
                'ts': 338499000,
                'time': '1980-09-22T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          10:
              {
                'ts': 673216200,
                'time': '1991-05-02T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          11:
              {
                'ts': 685481400,
                'time': '1991-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          12:
              {
                'ts': 701209800,
                'time': '1992-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          13:
              {
                'ts': 717103800,
                'time': '1992-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          14:
              {
                'ts': 732745800,
                'time': '1993-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          15:
              {
                'ts': 748639800,
                'time': '1993-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          16:
              {
                'ts': 764281800,
                'time': '1994-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          17:
              {
                'ts': 780175800,
                'time': '1994-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          18:
              {
                'ts': 795817800,
                'time': '1995-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          19:
              {
                'ts': 811711800,
                'time': '1995-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          20:
              {
                'ts': 827353800,
                'time': '1996-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          21:
              {
                'ts': 843247800,
                'time': '1996-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          22:
              {
                'ts': 858976200,
                'time': '1997-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          23:
              {
                'ts': 874870200,
                'time': '1997-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          24:
              {
                'ts': 890512200,
                'time': '1998-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          25:
              {
                'ts': 906406200,
                'time': '1998-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          26:
              {
                'ts': 922048200,
                'time': '1999-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          27:
              {
                'ts': 937942200,
                'time': '1999-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          28:
              {
                'ts': 953584200,
                'time': '2000-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          29:
              {
                'ts': 969478200,
                'time': '2000-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          30:
              {
                'ts': 985206600,
                'time': '2001-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          31:
              {
                'ts': 1001100600,
                'time': '2001-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          32:
              {
                'ts': 1016742600,
                'time': '2002-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          33:
              {
                'ts': 1032636600,
                'time': '2002-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          34:
              {
                'ts': 1048278600,
                'time': '2003-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          35:
              {
                'ts': 1064172600,
                'time': '2003-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          36:
              {
                'ts': 1079814600,
                'time': '2004-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          37:
              {
                'ts': 1095708600,
                'time': '2004-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          38:
              {
                'ts': 1111437000,
                'time': '2005-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          39:
              {
                'ts': 1127331000,
                'time': '2005-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          40:
              {
                'ts': 1206045000,
                'time': '2008-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          41:
              {
                'ts': 1221939000,
                'time': '2008-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          42:
              {
                'ts': 1237667400,
                'time': '2009-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          43:
              {
                'ts': 1253561400,
                'time': '2009-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          44:
              {
                'ts': 1269203400,
                'time': '2010-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          45:
              {
                'ts': 1285097400,
                'time': '2010-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          46:
              {
                'ts': 1300739400,
                'time': '2011-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          47:
              {
                'ts': 1316633400,
                'time': '2011-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          48:
              {
                'ts': 1332275400,
                'time': '2012-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          49:
              {
                'ts': 1348169400,
                'time': '2012-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          50:
              {
                'ts': 1363897800,
                'time': '2013-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          51:
              {
                'ts': 1379791800,
                'time': '2013-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          52:
              {
                'ts': 1395433800,
                'time': '2014-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          53:
              {
                'ts': 1411327800,
                'time': '2014-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          54:
              {
                'ts': 1426969800,
                'time': '2015-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          55:
              {
                'ts': 1442863800,
                'time': '2015-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          56:
              {
                'ts': 1458505800,
                'time': '2016-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          57:
              {
                'ts': 1474399800,
                'time': '2016-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          58:
              {
                'ts': 1490128200,
                'time': '2017-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          59:
              {
                'ts': 1506022200,
                'time': '2017-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          60:
              {
                'ts': 1521664200,
                'time': '2018-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          61:
              {
                'ts': 1537558200,
                'time': '2018-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          62:
              {
                'ts': 1553200200,
                'time': '2019-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          63:
              {
                'ts': 1569094200,
                'time': '2019-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          64:
              {
                'ts': 1584736200,
                'time': '2020-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          65:
              {
                'ts': 1600630200,
                'time': '2020-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          66:
              {
                'ts': 1616358600,
                'time': '2021-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          67:
              {
                'ts': 1632252600,
                'time': '2021-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          68:
              {
                'ts': 1647894600,
                'time': '2022-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          69:
              {
                'ts': 1663788600,
                'time': '2022-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          70:
              {
                'ts': 1679430600,
                'time': '2023-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          71:
              {
                'ts': 1695324600,
                'time': '2023-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          72:
              {
                'ts': 1710966600,
                'time': '2024-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          73:
              {
                'ts': 1726860600,
                'time': '2024-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          74:
              {
                'ts': 1742589000,
                'time': '2025-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          75:
              {
                'ts': 1758483000,
                'time': '2025-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          76:
              {
                'ts': 1774125000,
                'time': '2026-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          77:
              {
                'ts': 1790019000,
                'time': '2026-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          78:
              {
                'ts': 1805661000,
                'time': '2027-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          79:
              {
                'ts': 1821555000,
                'time': '2027-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          80:
              {
                'ts': 1837197000,
                'time': '2028-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          81:
              {
                'ts': 1853091000,
                'time': '2028-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          82:
              {
                'ts': 1868733000,
                'time': '2029-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          83:
              {
                'ts': 1884627000,
                'time': '2029-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          84:
              {
                'ts': 1900355400,
                'time': '2030-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          85:
              {
                'ts': 1916249400,
                'time': '2030-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          86:
              {
                'ts': 1931891400,
                'time': '2031-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          87:
              {
                'ts': 1947785400,
                'time': '2031-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          88:
              {
                'ts': 1963427400,
                'time': '2032-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          89:
              {
                'ts': 1979321400,
                'time': '2032-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          90:
              {
                'ts': 1994963400,
                'time': '2033-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          91:
              {
                'ts': 2010857400,
                'time': '2033-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          92:
              {
                'ts': 2026585800,
                'time': '2034-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          93:
              {
                'ts': 2042479800,
                'time': '2034-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          94:
              {
                'ts': 2058121800,
                'time': '2035-03-21T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          95:
              {
                'ts': 2074015800,
                'time': '2035-09-21T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          96:
              {
                'ts': 2089657800,
                'time': '2036-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          97:
              {
                'ts': 2105551800,
                'time': '2036-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              },
          98:
              {
                'ts': 2121193800,
                'time': '2037-03-20T20:30:00+0000',
                'offset': 16200,
                'isdst': true,
                'abbr': 'IRDT'
              },
          99:
              {
                'ts': 2137087800,
                'time': '2037-09-20T19:30:00+0000',
                'offset': 12600,
                'isdst': false,
                'abbr': 'IRST'
              }
        },
    'Israel':
        {
          0:
              {
                'ts': -1641003640,
                'time': '1917-12-31T21:39:20+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          1:
              {
                'ts': -933645600,
                'time': '1940-05-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          2:
              {
                'ts': -857358000,
                'time': '1942-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          3:
              {
                'ts': -844300800,
                'time': '1943-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          4:
              {
                'ts': -825822000,
                'time': '1943-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          5:
              {
                'ts': -812685600,
                'time': '1944-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          6:
              {
                'ts': -794199600,
                'time': '1944-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          7:
              {
                'ts': -779853600,
                'time': '1945-04-15T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          8:
              {
                'ts': -762656400,
                'time': '1945-10-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          9:
              {
                'ts': -748310400,
                'time': '1946-04-16T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          10:
              {
                'ts': -731127600,
                'time': '1946-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          11:
              {
                'ts': -681962400,
                'time': '1948-05-22T22:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'IDDT'
              },
          12:
              {
                'ts': -673243200,
                'time': '1948-08-31T20:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          13:
              {
                'ts': -667962000,
                'time': '1948-10-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          14:
              {
                'ts': -652327200,
                'time': '1949-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          15:
              {
                'ts': -636426000,
                'time': '1949-10-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          16:
              {
                'ts': -622087200,
                'time': '1950-04-15T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          17:
              {
                'ts': -608947200,
                'time': '1950-09-15T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          18:
              {
                'ts': -591847200,
                'time': '1951-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          19:
              {
                'ts': -572486400,
                'time': '1951-11-11T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          20:
              {
                'ts': -558576000,
                'time': '1952-04-20T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          21:
              {
                'ts': -542851200,
                'time': '1952-10-19T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          22:
              {
                'ts': -527731200,
                'time': '1953-04-12T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          23:
              {
                'ts': -514425600,
                'time': '1953-09-13T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          24:
              {
                'ts': -490845600,
                'time': '1954-06-12T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          25:
              {
                'ts': -482986800,
                'time': '1954-09-11T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          26:
              {
                'ts': -459475200,
                'time': '1955-06-11T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          27:
              {
                'ts': -451537200,
                'time': '1955-09-10T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          28:
              {
                'ts': -428551200,
                'time': '1956-06-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          29:
              {
                'ts': -418262400,
                'time': '1956-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          30:
              {
                'ts': -400032000,
                'time': '1957-04-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          31:
              {
                'ts': -387428400,
                'time': '1957-09-21T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          32:
              {
                'ts': 142380000,
                'time': '1974-07-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          33:
              {
                'ts': 150843600,
                'time': '1974-10-12T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          34:
              {
                'ts': 167176800,
                'time': '1975-04-19T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          35:
              {
                'ts': 178664400,
                'time': '1975-08-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          36:
              {
                'ts': 482277600,
                'time': '1985-04-13T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          37:
              {
                'ts': 495579600,
                'time': '1985-09-14T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          38:
              {
                'ts': 516751200,
                'time': '1986-05-17T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          39:
              {
                'ts': 526424400,
                'time': '1986-09-06T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          40:
              {
                'ts': 545436000,
                'time': '1987-04-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          41:
              {
                'ts': 558478800,
                'time': '1987-09-12T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          42:
              {
                'ts': 576540000,
                'time': '1988-04-08T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          43:
              {
                'ts': 589237200,
                'time': '1988-09-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          44:
              {
                'ts': 609890400,
                'time': '1989-04-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          45:
              {
                'ts': 620773200,
                'time': '1989-09-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          46:
              {
                'ts': 638316000,
                'time': '1990-03-24T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          47:
              {
                'ts': 651618000,
                'time': '1990-08-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          48:
              {
                'ts': 669765600,
                'time': '1991-03-23T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          49:
              {
                'ts': 683672400,
                'time': '1991-08-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          50:
              {
                'ts': 701820000,
                'time': '1992-03-28T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          51:
              {
                'ts': 715726800,
                'time': '1992-09-05T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          52:
              {
                'ts': 733701600,
                'time': '1993-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          53:
              {
                'ts': 747176400,
                'time': '1993-09-04T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          54:
              {
                'ts': 765151200,
                'time': '1994-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          55:
              {
                'ts': 778021200,
                'time': '1994-08-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          56:
              {
                'ts': 796600800,
                'time': '1995-03-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          57:
              {
                'ts': 810075600,
                'time': '1995-09-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          58:
              {
                'ts': 826840800,
                'time': '1996-03-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          59:
              {
                'ts': 842821200,
                'time': '1996-09-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          60:
              {
                'ts': 858895200,
                'time': '1997-03-20T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          61:
              {
                'ts': 874184400,
                'time': '1997-09-13T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          62:
              {
                'ts': 890344800,
                'time': '1998-03-19T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          63:
              {
                'ts': 905029200,
                'time': '1998-09-05T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          64:
              {
                'ts': 923011200,
                'time': '1999-04-02T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          65:
              {
                'ts': 936313200,
                'time': '1999-09-02T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          66:
              {
                'ts': 955670400,
                'time': '2000-04-14T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          67:
              {
                'ts': 970783200,
                'time': '2000-10-05T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          68:
              {
                'ts': 986770800,
                'time': '2001-04-08T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          69:
              {
                'ts': 1001282400,
                'time': '2001-09-23T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          70:
              {
                'ts': 1017356400,
                'time': '2002-03-28T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          71:
              {
                'ts': 1033941600,
                'time': '2002-10-06T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          72:
              {
                'ts': 1048806000,
                'time': '2003-03-27T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          73:
              {
                'ts': 1065132000,
                'time': '2003-10-02T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          74:
              {
                'ts': 1081292400,
                'time': '2004-04-06T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          75:
              {
                'ts': 1095804000,
                'time': '2004-09-21T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          76:
              {
                'ts': 1112313600,
                'time': '2005-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          77:
              {
                'ts': 1128812400,
                'time': '2005-10-08T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          78:
              {
                'ts': 1143763200,
                'time': '2006-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          79:
              {
                'ts': 1159657200,
                'time': '2006-09-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          80:
              {
                'ts': 1175212800,
                'time': '2007-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          81:
              {
                'ts': 1189897200,
                'time': '2007-09-15T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          82:
              {
                'ts': 1206662400,
                'time': '2008-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          83:
              {
                'ts': 1223161200,
                'time': '2008-10-04T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          84:
              {
                'ts': 1238112000,
                'time': '2009-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          85:
              {
                'ts': 1254006000,
                'time': '2009-09-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          86:
              {
                'ts': 1269561600,
                'time': '2010-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          87:
              {
                'ts': 1284246000,
                'time': '2010-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          88:
              {
                'ts': 1301616000,
                'time': '2011-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          89:
              {
                'ts': 1317510000,
                'time': '2011-10-01T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          90:
              {
                'ts': 1333065600,
                'time': '2012-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          91:
              {
                'ts': 1348354800,
                'time': '2012-09-22T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          92:
              {
                'ts': 1364515200,
                'time': '2013-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          93:
              {
                'ts': 1378594800,
                'time': '2013-09-07T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          94:
              {
                'ts': 1395964800,
                'time': '2014-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          95:
              {
                'ts': 1411858800,
                'time': '2014-09-27T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          96:
              {
                'ts': 1427414400,
                'time': '2015-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          97:
              {
                'ts': 1442703600,
                'time': '2015-09-19T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          98:
              {
                'ts': 1459468800,
                'time': '2016-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          99:
              {
                'ts': 1475967600,
                'time': '2016-10-08T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          100:
              {
                'ts': 1490918400,
                'time': '2017-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          101:
              {
                'ts': 1506207600,
                'time': '2017-09-23T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          102:
              {
                'ts': 1522368000,
                'time': '2018-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          103:
              {
                'ts': 1537052400,
                'time': '2018-09-15T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          104:
              {
                'ts': 1553817600,
                'time': '2019-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          105:
              {
                'ts': 1570316400,
                'time': '2019-10-05T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          106:
              {
                'ts': 1585267200,
                'time': '2020-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          107:
              {
                'ts': 1601161200,
                'time': '2020-09-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          108:
              {
                'ts': 1616716800,
                'time': '2021-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          109:
              {
                'ts': 1631401200,
                'time': '2021-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          110:
              {
                'ts': 1648771200,
                'time': '2022-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          111:
              {
                'ts': 1664665200,
                'time': '2022-10-01T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          112:
              {
                'ts': 1680220800,
                'time': '2023-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          113:
              {
                'ts': 1695510000,
                'time': '2023-09-23T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          114:
              {
                'ts': 1711670400,
                'time': '2024-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          115:
              {
                'ts': 1728169200,
                'time': '2024-10-05T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          116:
              {
                'ts': 1743120000,
                'time': '2025-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          117:
              {
                'ts': 1759014000,
                'time': '2025-09-27T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          118:
              {
                'ts': 1774569600,
                'time': '2026-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          119:
              {
                'ts': 1789858800,
                'time': '2026-09-19T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          120:
              {
                'ts': 1806019200,
                'time': '2027-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          121:
              {
                'ts': 1823122800,
                'time': '2027-10-09T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          122:
              {
                'ts': 1838073600,
                'time': '2028-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          123:
              {
                'ts': 1853362800,
                'time': '2028-09-23T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          124:
              {
                'ts': 1869523200,
                'time': '2029-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          125:
              {
                'ts': 1884207600,
                'time': '2029-09-15T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          126:
              {
                'ts': 1900972800,
                'time': '2030-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          127:
              {
                'ts': 1917471600,
                'time': '2030-10-05T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          128:
              {
                'ts': 1932422400,
                'time': '2031-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          129:
              {
                'ts': 1947711600,
                'time': '2031-09-20T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          130:
              {
                'ts': 1963872000,
                'time': '2032-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          131:
              {
                'ts': 1978556400,
                'time': '2032-09-11T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          132:
              {
                'ts': 1995926400,
                'time': '2033-04-01T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          133:
              {
                'ts': 2011820400,
                'time': '2033-10-01T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          134:
              {
                'ts': 2027376000,
                'time': '2034-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          135:
              {
                'ts': 2042060400,
                'time': '2034-09-16T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          136:
              {
                'ts': 2058825600,
                'time': '2035-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          137:
              {
                'ts': 2075324400,
                'time': '2035-10-06T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          138:
              {
                'ts': 2090275200,
                'time': '2036-03-28T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          139:
              {
                'ts': 2106169200,
                'time': '2036-09-27T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              },
          140:
              {
                'ts': 2121724800,
                'time': '2037-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'IDT'
              },
          141:
              {
                'ts': 2136409200,
                'time': '2037-09-12T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'IST'
              }
        },
    'Jamaica':
        {
          0:
              {
                'ts': -1827687168,
                'time': '1912-02-01T05:07:12+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          1:
              {
                'ts': 136364400,
                'time': '1974-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          2:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          3:
              {
                'ts': 162370800,
                'time': '1975-02-23T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          4:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          5:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          6:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          7:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          8:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          10:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          12:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          14:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          16:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          18:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          20:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'Japan':
        {
          0:
              {
                'ts': -1009875600,
                'time': '1937-12-31T15:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          1:
              {
                'ts': -683794800,
                'time': '1948-05-01T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'JDT'
              },
          2:
              {
                'ts': -672393600,
                'time': '1948-09-10T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          3:
              {
                'ts': -654764400,
                'time': '1949-04-02T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'JDT'
              },
          4:
              {
                'ts': -640944000,
                'time': '1949-09-09T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          5:
              {
                'ts': -620290800,
                'time': '1950-05-06T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'JDT'
              },
          6:
              {
                'ts': -609494400,
                'time': '1950-09-08T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          7:
              {
                'ts': -588841200,
                'time': '1951-05-05T17:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'JDT'
              },
          8:
              {
                'ts': -578044800,
                'time': '1951-09-07T16:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              }
        },
    'Kwajalein':
        {
          0:
              {
                'ts': -7988400,
                'time': '1969-09-30T13:00:00+0000',
                'offset': -43200,
                'isdst': false,
                'abbr': 'KWAT'
              },
          1:
              {
                'ts': 745848000,
                'time': '1993-08-20T12:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'MHT'
              }
        },
    'Libya':
        {
          0:
              {
                'ts': -1577926364,
                'time': '1919-12-31T23:07:16+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          1:
              {
                'ts': -574902000,
                'time': '1951-10-14T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          2:
              {
                'ts': -568087200,
                'time': '1951-12-31T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          3:
              {
                'ts': -512175600,
                'time': '1953-10-09T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          4:
              {
                'ts': -504928800,
                'time': '1953-12-31T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          5:
              {
                'ts': -449888400,
                'time': '1955-09-29T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          6:
              {
                'ts': -441856800,
                'time': '1955-12-31T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          7:
              {
                'ts': -347158800,
                'time': '1958-12-31T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          8:
              {
                'ts': 378684000,
                'time': '1981-12-31T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          9:
              {
                'ts': 386463600,
                'time': '1982-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          10:
              {
                'ts': 402271200,
                'time': '1982-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          11:
              {
                'ts': 417999600,
                'time': '1983-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          12:
              {
                'ts': 433807200,
                'time': '1983-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          13:
              {
                'ts': 449622000,
                'time': '1984-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          14:
              {
                'ts': 465429600,
                'time': '1984-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          15:
              {
                'ts': 481590000,
                'time': '1985-04-05T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': 496965600,
                'time': '1985-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': 512953200,
                'time': '1986-04-03T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': 528674400,
                'time': '1986-10-02T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': 544230000,
                'time': '1987-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': 560037600,
                'time': '1987-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': 575852400,
                'time': '1988-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': 591660000,
                'time': '1988-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': 607388400,
                'time': '1989-03-31T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': 623196000,
                'time': '1989-09-30T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': 641775600,
                'time': '1990-05-03T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          26:
              {
                'ts': 844034400,
                'time': '1996-09-29T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': 860108400,
                'time': '1997-04-03T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': 875916000,
                'time': '1997-10-03T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'MET':
        {
          0:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          1:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          2:
              {
                'ts': -1663455600,
                'time': '1917-04-16T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          3:
              {
                'ts': -1650150000,
                'time': '1917-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          4:
              {
                'ts': -1632006000,
                'time': '1918-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          5:
              {
                'ts': -1618700400,
                'time': '1918-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          6:
              {
                'ts': -938905200,
                'time': '1940-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          7:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          8:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          9:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          10:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          11:
              {
                'ts': -796777200,
                'time': '1944-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          12:
              {
                'ts': 228877200,
                'time': '1977-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          13:
              {
                'ts': 243997200,
                'time': '1977-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          14:
              {
                'ts': 260326800,
                'time': '1978-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          15:
              {
                'ts': 276051600,
                'time': '1978-10-01T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          16:
              {
                'ts': 291776400,
                'time': '1979-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          17:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          18:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          19:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          20:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          21:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          22:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          23:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          24:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          25:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          26:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          27:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          28:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          29:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          30:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          31:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          32:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          33:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          34:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          35:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          36:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          37:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          38:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          39:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          40:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          41:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          42:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          43:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          44:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          45:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          46:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          47:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          48:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          49:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          50:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          51:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          52:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          53:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          54:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          55:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          56:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          57:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          58:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          59:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          60:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          61:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          62:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          63:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          64:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          65:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          66:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          67:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          68:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          69:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          70:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          71:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          72:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          73:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          74:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          75:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          76:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          77:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          78:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          79:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          80:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          81:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          82:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          83:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          84:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          85:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          86:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          87:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          88:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          89:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          90:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          91:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          92:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          93:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          94:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          95:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          96:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          97:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          98:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          99:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          100:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          101:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          102:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          103:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          104:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          105:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          106:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          107:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          108:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          109:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          110:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          111:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          112:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          113:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          114:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          115:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          116:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          117:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          118:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          119:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          120:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          121:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          122:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          123:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          124:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          125:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          126:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          127:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          128:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          129:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          130:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          131:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              },
          132:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'MEST'
              },
          133:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'MET'
              }
        },
    'Mexico/BajaNorte':
        {
          0:
              {
                'ts': -1514736000,
                'time': '1922-01-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1451667600,
                'time': '1924-01-01T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          2:
              {
                'ts': -1343062800,
                'time': '1927-06-11T07:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1234803600,
                'time': '1930-11-15T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          4:
              {
                'ts': -1222963200,
                'time': '1931-04-01T08:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          5:
              {
                'ts': -1207242000,
                'time': '1931-09-30T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          6:
              {
                'ts': -873820800,
                'time': '1942-04-24T08:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PWT'
              },
          7:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PPT'
              },
          8:
              {
                'ts': -761677200,
                'time': '1945-11-12T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          9:
              {
                'ts': -686073600,
                'time': '1948-04-05T08:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          10:
              {
                'ts': -661539600,
                'time': '1949-01-14T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          11:
              {
                'ts': -495036000,
                'time': '1954-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          12:
              {
                'ts': -481734000,
                'time': '1954-09-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          13:
              {
                'ts': -463586400,
                'time': '1955-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          14:
              {
                'ts': -450284400,
                'time': '1955-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          15:
              {
                'ts': -431532000,
                'time': '1956-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          16:
              {
                'ts': -418230000,
                'time': '1956-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          17:
              {
                'ts': -400082400,
                'time': '1957-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          18:
              {
                'ts': -386780400,
                'time': '1957-09-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          19:
              {
                'ts': -368632800,
                'time': '1958-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          20:
              {
                'ts': -355330800,
                'time': '1958-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          21:
              {
                'ts': -337183200,
                'time': '1959-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          22:
              {
                'ts': -323881200,
                'time': '1959-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          23:
              {
                'ts': -305733600,
                'time': '1960-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          24:
              {
                'ts': -292431600,
                'time': '1960-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          25:
              {
                'ts': 199274400,
                'time': '1976-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          26:
              {
                'ts': 215600400,
                'time': '1976-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          27:
              {
                'ts': 230724000,
                'time': '1977-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          28:
              {
                'ts': 247050000,
                'time': '1977-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          29:
              {
                'ts': 262778400,
                'time': '1978-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          30:
              {
                'ts': 278499600,
                'time': '1978-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          31:
              {
                'ts': 294228000,
                'time': '1979-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          32:
              {
                'ts': 309949200,
                'time': '1979-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          33:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          34:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          35:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          36:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          37:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          38:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          39:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          40:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          41:
              {
                'ts': 452080800,
                'time': '1984-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          42:
              {
                'ts': 467802000,
                'time': '1984-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          43:
              {
                'ts': 483530400,
                'time': '1985-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          44:
              {
                'ts': 499251600,
                'time': '1985-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          45:
              {
                'ts': 514980000,
                'time': '1986-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          46:
              {
                'ts': 530701200,
                'time': '1986-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          47:
              {
                'ts': 544615200,
                'time': '1987-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          48:
              {
                'ts': 562150800,
                'time': '1987-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          49:
              {
                'ts': 576064800,
                'time': '1988-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          50:
              {
                'ts': 594205200,
                'time': '1988-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          51:
              {
                'ts': 607514400,
                'time': '1989-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          52:
              {
                'ts': 625654800,
                'time': '1989-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          53:
              {
                'ts': 638964000,
                'time': '1990-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          54:
              {
                'ts': 657104400,
                'time': '1990-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          55:
              {
                'ts': 671018400,
                'time': '1991-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          56:
              {
                'ts': 688554000,
                'time': '1991-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          57:
              {
                'ts': 702468000,
                'time': '1992-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          58:
              {
                'ts': 720003600,
                'time': '1992-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          59:
              {
                'ts': 733917600,
                'time': '1993-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          60:
              {
                'ts': 752058000,
                'time': '1993-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          61:
              {
                'ts': 765367200,
                'time': '1994-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          62:
              {
                'ts': 783507600,
                'time': '1994-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          63:
              {
                'ts': 796816800,
                'time': '1995-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          64:
              {
                'ts': 814957200,
                'time': '1995-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          65:
              {
                'ts': 828871200,
                'time': '1996-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          66:
              {
                'ts': 846406800,
                'time': '1996-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          67:
              {
                'ts': 860320800,
                'time': '1997-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          68:
              {
                'ts': 877856400,
                'time': '1997-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          69:
              {
                'ts': 891770400,
                'time': '1998-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          70:
              {
                'ts': 909306000,
                'time': '1998-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          71:
              {
                'ts': 923220000,
                'time': '1999-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          72:
              {
                'ts': 941360400,
                'time': '1999-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          73:
              {
                'ts': 954669600,
                'time': '2000-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          74:
              {
                'ts': 972810000,
                'time': '2000-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          75:
              {
                'ts': 986119200,
                'time': '2001-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          76:
              {
                'ts': 1004259600,
                'time': '2001-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          77:
              {
                'ts': 1018173600,
                'time': '2002-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          78:
              {
                'ts': 1035709200,
                'time': '2002-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          79:
              {
                'ts': 1049623200,
                'time': '2003-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          80:
              {
                'ts': 1067158800,
                'time': '2003-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          81:
              {
                'ts': 1081072800,
                'time': '2004-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          82:
              {
                'ts': 1099213200,
                'time': '2004-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          83:
              {
                'ts': 1112522400,
                'time': '2005-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          84:
              {
                'ts': 1130662800,
                'time': '2005-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          85:
              {
                'ts': 1143972000,
                'time': '2006-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          86:
              {
                'ts': 1162112400,
                'time': '2006-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          87:
              {
                'ts': 1175421600,
                'time': '2007-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          88:
              {
                'ts': 1193562000,
                'time': '2007-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          89:
              {
                'ts': 1207476000,
                'time': '2008-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          90:
              {
                'ts': 1225011600,
                'time': '2008-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          91:
              {
                'ts': 1238925600,
                'time': '2009-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          92:
              {
                'ts': 1256461200,
                'time': '2009-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          93:
              {
                'ts': 1270375200,
                'time': '2010-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          94:
              {
                'ts': 1288515600,
                'time': '2010-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          95:
              {
                'ts': 1301824800,
                'time': '2011-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          96:
              {
                'ts': 1319965200,
                'time': '2011-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          97:
              {
                'ts': 1333274400,
                'time': '2012-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          98:
              {
                'ts': 1351414800,
                'time': '2012-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          99:
              {
                'ts': 1365328800,
                'time': '2013-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          100:
              {
                'ts': 1382864400,
                'time': '2013-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          101:
              {
                'ts': 1396778400,
                'time': '2014-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          102:
              {
                'ts': 1414314000,
                'time': '2014-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          103:
              {
                'ts': 1428228000,
                'time': '2015-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          104:
              {
                'ts': 1445763600,
                'time': '2015-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          105:
              {
                'ts': 1459677600,
                'time': '2016-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          106:
              {
                'ts': 1477818000,
                'time': '2016-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          107:
              {
                'ts': 1491127200,
                'time': '2017-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          108:
              {
                'ts': 1509267600,
                'time': '2017-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          109:
              {
                'ts': 1522576800,
                'time': '2018-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          110:
              {
                'ts': 1540717200,
                'time': '2018-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          111:
              {
                'ts': 1554631200,
                'time': '2019-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          112:
              {
                'ts': 1572166800,
                'time': '2019-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          113:
              {
                'ts': 1586080800,
                'time': '2020-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          114:
              {
                'ts': 1603616400,
                'time': '2020-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          115:
              {
                'ts': 1617530400,
                'time': '2021-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          116:
              {
                'ts': 1635670800,
                'time': '2021-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          117:
              {
                'ts': 1648980000,
                'time': '2022-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          118:
              {
                'ts': 1667120400,
                'time': '2022-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          119:
              {
                'ts': 1680429600,
                'time': '2023-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          120:
              {
                'ts': 1698570000,
                'time': '2023-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          121:
              {
                'ts': 1712484000,
                'time': '2024-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          122:
              {
                'ts': 1730019600,
                'time': '2024-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          123:
              {
                'ts': 1743933600,
                'time': '2025-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          124:
              {
                'ts': 1761469200,
                'time': '2025-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          125:
              {
                'ts': 1775383200,
                'time': '2026-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          126:
              {
                'ts': 1792918800,
                'time': '2026-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          127:
              {
                'ts': 1806832800,
                'time': '2027-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          128:
              {
                'ts': 1824973200,
                'time': '2027-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          129:
              {
                'ts': 1838282400,
                'time': '2028-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          130:
              {
                'ts': 1856422800,
                'time': '2028-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          131:
              {
                'ts': 1869732000,
                'time': '2029-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          132:
              {
                'ts': 1887872400,
                'time': '2029-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          133:
              {
                'ts': 1901786400,
                'time': '2030-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          134:
              {
                'ts': 1919322000,
                'time': '2030-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          135:
              {
                'ts': 1933236000,
                'time': '2031-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          136:
              {
                'ts': 1950771600,
                'time': '2031-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          137:
              {
                'ts': 1964685600,
                'time': '2032-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          138:
              {
                'ts': 1982826000,
                'time': '2032-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          139:
              {
                'ts': 1996135200,
                'time': '2033-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          140:
              {
                'ts': 2014275600,
                'time': '2033-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          141:
              {
                'ts': 2027584800,
                'time': '2034-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          142:
              {
                'ts': 2045725200,
                'time': '2034-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          143:
              {
                'ts': 2059034400,
                'time': '2035-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          144:
              {
                'ts': 2077174800,
                'time': '2035-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          145:
              {
                'ts': 2091088800,
                'time': '2036-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          146:
              {
                'ts': 2108624400,
                'time': '2036-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          147:
              {
                'ts': 2122538400,
                'time': '2037-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          148:
              {
                'ts': 2140074000,
                'time': '2037-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'Mexico/BajaSur':
        {
          0:
              {
                'ts': -1514739600,
                'time': '1922-01-01T07:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1343066400,
                'time': '1927-06-11T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1234807200,
                'time': '1930-11-15T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1220292000,
                'time': '1931-05-02T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -1207159200,
                'time': '1931-10-01T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1191344400,
                'time': '1932-04-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -873828000,
                'time': '1942-04-24T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          7:
              {
                'ts': -661539600,
                'time': '1949-01-14T07:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          8:
              {
                'ts': 28800,
                'time': '1970-01-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          9:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          10:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': 989139600,
                'time': '2001-05-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': 1001836800,
                'time': '2001-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          24:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          25:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          26:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          27:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          28:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          29:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          30:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          31:
              {
                'ts': 1175418000,
                'time': '2007-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          32:
              {
                'ts': 1193558400,
                'time': '2007-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          33:
              {
                'ts': 1207472400,
                'time': '2008-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          34:
              {
                'ts': 1225008000,
                'time': '2008-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          35:
              {
                'ts': 1238922000,
                'time': '2009-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          36:
              {
                'ts': 1256457600,
                'time': '2009-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          37:
              {
                'ts': 1270371600,
                'time': '2010-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          38:
              {
                'ts': 1288512000,
                'time': '2010-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          39:
              {
                'ts': 1301821200,
                'time': '2011-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          40:
              {
                'ts': 1319961600,
                'time': '2011-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          41:
              {
                'ts': 1333270800,
                'time': '2012-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          42:
              {
                'ts': 1351411200,
                'time': '2012-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          43:
              {
                'ts': 1365325200,
                'time': '2013-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          44:
              {
                'ts': 1382860800,
                'time': '2013-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          45:
              {
                'ts': 1396774800,
                'time': '2014-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          46:
              {
                'ts': 1414310400,
                'time': '2014-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          47:
              {
                'ts': 1428224400,
                'time': '2015-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          48:
              {
                'ts': 1445760000,
                'time': '2015-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          49:
              {
                'ts': 1459674000,
                'time': '2016-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          50:
              {
                'ts': 1477814400,
                'time': '2016-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          51:
              {
                'ts': 1491123600,
                'time': '2017-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          52:
              {
                'ts': 1509264000,
                'time': '2017-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          53:
              {
                'ts': 1522573200,
                'time': '2018-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          54:
              {
                'ts': 1540713600,
                'time': '2018-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          55:
              {
                'ts': 1554627600,
                'time': '2019-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          56:
              {
                'ts': 1572163200,
                'time': '2019-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          57:
              {
                'ts': 1586077200,
                'time': '2020-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          58:
              {
                'ts': 1603612800,
                'time': '2020-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          59:
              {
                'ts': 1617526800,
                'time': '2021-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          60:
              {
                'ts': 1635667200,
                'time': '2021-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          61:
              {
                'ts': 1648976400,
                'time': '2022-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          62:
              {
                'ts': 1667116800,
                'time': '2022-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          63:
              {
                'ts': 1680426000,
                'time': '2023-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          64:
              {
                'ts': 1698566400,
                'time': '2023-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          65:
              {
                'ts': 1712480400,
                'time': '2024-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          66:
              {
                'ts': 1730016000,
                'time': '2024-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          67:
              {
                'ts': 1743930000,
                'time': '2025-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          68:
              {
                'ts': 1761465600,
                'time': '2025-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          69:
              {
                'ts': 1775379600,
                'time': '2026-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          70:
              {
                'ts': 1792915200,
                'time': '2026-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          71:
              {
                'ts': 1806829200,
                'time': '2027-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          72:
              {
                'ts': 1824969600,
                'time': '2027-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          73:
              {
                'ts': 1838278800,
                'time': '2028-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          74:
              {
                'ts': 1856419200,
                'time': '2028-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          75:
              {
                'ts': 1869728400,
                'time': '2029-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          76:
              {
                'ts': 1887868800,
                'time': '2029-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          77:
              {
                'ts': 1901782800,
                'time': '2030-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          78:
              {
                'ts': 1919318400,
                'time': '2030-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          79:
              {
                'ts': 1933232400,
                'time': '2031-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          80:
              {
                'ts': 1950768000,
                'time': '2031-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          81:
              {
                'ts': 1964682000,
                'time': '2032-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          82:
              {
                'ts': 1982822400,
                'time': '2032-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          83:
              {
                'ts': 1996131600,
                'time': '2033-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          84:
              {
                'ts': 2014272000,
                'time': '2033-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          85:
              {
                'ts': 2027581200,
                'time': '2034-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          86:
              {
                'ts': 2045721600,
                'time': '2034-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          87:
              {
                'ts': 2059030800,
                'time': '2035-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          88:
              {
                'ts': 2077171200,
                'time': '2035-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          89:
              {
                'ts': 2091085200,
                'time': '2036-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          90:
              {
                'ts': 2108620800,
                'time': '2036-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          91:
              {
                'ts': 2122534800,
                'time': '2037-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          92:
              {
                'ts': 2140070400,
                'time': '2037-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'Mexico/General':
        {
          0:
              {
                'ts': -1514739600,
                'time': '1922-01-01T07:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          1:
              {
                'ts': -1343066400,
                'time': '1927-06-11T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1234807200,
                'time': '1930-11-15T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          3:
              {
                'ts': -1220292000,
                'time': '1931-05-02T06:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -1207159200,
                'time': '1931-10-01T06:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1191344400,
                'time': '1932-04-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -975261600,
                'time': '1939-02-05T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': -963169200,
                'time': '1939-06-25T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': -917114400,
                'time': '1940-12-09T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          9:
              {
                'ts': -907354800,
                'time': '1941-04-01T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': -821901600,
                'time': '1943-12-16T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          11:
              {
                'ts': -810068400,
                'time': '1944-05-01T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': -627501600,
                'time': '1950-02-12T06:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          13:
              {
                'ts': -612990000,
                'time': '1950-07-30T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          14:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          15:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          16:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          17:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          18:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          19:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          20:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          21:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          22:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          23:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          24:
              {
                'ts': 989136000,
                'time': '2001-05-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          25:
              {
                'ts': 1001833200,
                'time': '2001-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          26:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          27:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          28:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          29:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          30:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          31:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          32:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          33:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          34:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          35:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          36:
              {
                'ts': 1175414400,
                'time': '2007-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          37:
              {
                'ts': 1193554800,
                'time': '2007-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': 1207468800,
                'time': '2008-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          39:
              {
                'ts': 1225004400,
                'time': '2008-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          40:
              {
                'ts': 1238918400,
                'time': '2009-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          41:
              {
                'ts': 1256454000,
                'time': '2009-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          42:
              {
                'ts': 1270368000,
                'time': '2010-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          43:
              {
                'ts': 1288508400,
                'time': '2010-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          44:
              {
                'ts': 1301817600,
                'time': '2011-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          45:
              {
                'ts': 1319958000,
                'time': '2011-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': 1333267200,
                'time': '2012-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          47:
              {
                'ts': 1351407600,
                'time': '2012-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          48:
              {
                'ts': 1365321600,
                'time': '2013-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          49:
              {
                'ts': 1382857200,
                'time': '2013-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          50:
              {
                'ts': 1396771200,
                'time': '2014-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          51:
              {
                'ts': 1414306800,
                'time': '2014-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          52:
              {
                'ts': 1428220800,
                'time': '2015-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          53:
              {
                'ts': 1445756400,
                'time': '2015-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          54:
              {
                'ts': 1459670400,
                'time': '2016-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          55:
              {
                'ts': 1477810800,
                'time': '2016-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          56:
              {
                'ts': 1491120000,
                'time': '2017-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          57:
              {
                'ts': 1509260400,
                'time': '2017-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          58:
              {
                'ts': 1522569600,
                'time': '2018-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          59:
              {
                'ts': 1540710000,
                'time': '2018-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          60:
              {
                'ts': 1554624000,
                'time': '2019-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          61:
              {
                'ts': 1572159600,
                'time': '2019-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          62:
              {
                'ts': 1586073600,
                'time': '2020-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          63:
              {
                'ts': 1603609200,
                'time': '2020-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          64:
              {
                'ts': 1617523200,
                'time': '2021-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          65:
              {
                'ts': 1635663600,
                'time': '2021-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          66:
              {
                'ts': 1648972800,
                'time': '2022-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          67:
              {
                'ts': 1667113200,
                'time': '2022-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          68:
              {
                'ts': 1680422400,
                'time': '2023-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          69:
              {
                'ts': 1698562800,
                'time': '2023-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          70:
              {
                'ts': 1712476800,
                'time': '2024-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          71:
              {
                'ts': 1730012400,
                'time': '2024-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          72:
              {
                'ts': 1743926400,
                'time': '2025-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          73:
              {
                'ts': 1761462000,
                'time': '2025-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          74:
              {
                'ts': 1775376000,
                'time': '2026-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          75:
              {
                'ts': 1792911600,
                'time': '2026-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          76:
              {
                'ts': 1806825600,
                'time': '2027-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          77:
              {
                'ts': 1824966000,
                'time': '2027-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          78:
              {
                'ts': 1838275200,
                'time': '2028-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          79:
              {
                'ts': 1856415600,
                'time': '2028-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          80:
              {
                'ts': 1869724800,
                'time': '2029-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          81:
              {
                'ts': 1887865200,
                'time': '2029-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          82:
              {
                'ts': 1901779200,
                'time': '2030-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          83:
              {
                'ts': 1919314800,
                'time': '2030-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          84:
              {
                'ts': 1933228800,
                'time': '2031-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          85:
              {
                'ts': 1950764400,
                'time': '2031-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          86:
              {
                'ts': 1964678400,
                'time': '2032-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          87:
              {
                'ts': 1982818800,
                'time': '2032-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          88:
              {
                'ts': 1996128000,
                'time': '2033-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          89:
              {
                'ts': 2014268400,
                'time': '2033-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          90:
              {
                'ts': 2027577600,
                'time': '2034-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          91:
              {
                'ts': 2045718000,
                'time': '2034-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          92:
              {
                'ts': 2059027200,
                'time': '2035-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          93:
              {
                'ts': 2077167600,
                'time': '2035-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          94:
              {
                'ts': 2091081600,
                'time': '2036-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          95:
              {
                'ts': 2108617200,
                'time': '2036-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          96:
              {
                'ts': 2122531200,
                'time': '2037-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          97:
              {
                'ts': 2140066800,
                'time': '2037-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'MST':
        {
          0:
              {
                'ts': -1633273200,
                'time': '1918-03-31T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          1:
              {
                'ts': -1615132800,
                'time': '1918-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          2:
              {
                'ts': -1601823600,
                'time': '1919-03-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          3:
              {
                'ts': -1583683200,
                'time': '1919-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': -1570374000,
                'time': '1920-03-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          5:
              {
                'ts': -1551628800,
                'time': '1920-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          6:
              {
                'ts': -1538924400,
                'time': '1921-03-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          7:
              {
                'ts': -1534089600,
                'time': '1921-05-22T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          8:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          9:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          10:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -147884400,
                'time': '1965-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -131558400,
                'time': '1965-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': -116434800,
                'time': '1966-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': -100108800,
                'time': '1966-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': -52930800,
                'time': '1968-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': -37209600,
                'time': '1968-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': -21481200,
                'time': '1969-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': 9968400,
                'time': '1970-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': 25689600,
                'time': '1970-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': 41418000,
                'time': '1971-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          24:
              {
                'ts': 57744000,
                'time': '1971-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          25:
              {
                'ts': 73472400,
                'time': '1972-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          26:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          27:
              {
                'ts': 104922000,
                'time': '1973-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          28:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          29:
              {
                'ts': 126694800,
                'time': '1974-01-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          30:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          31:
              {
                'ts': 162378000,
                'time': '1975-02-23T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          32:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          33:
              {
                'ts': 199270800,
                'time': '1976-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          34:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          35:
              {
                'ts': 230720400,
                'time': '1977-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          36:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          37:
              {
                'ts': 262774800,
                'time': '1978-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          38:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          39:
              {
                'ts': 294224400,
                'time': '1979-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          40:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          41:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          42:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          43:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          44:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          45:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          46:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          47:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          48:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          49:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          50:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          51:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          52:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          53:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          54:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          55:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          56:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          57:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          58:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          59:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          60:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          61:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          62:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          63:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          64:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          65:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          66:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          67:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          68:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          69:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          70:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          71:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          72:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          73:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          74:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          75:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          76:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          77:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          78:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          79:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          80:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          81:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          82:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          83:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          84:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          85:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          86:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          87:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          88:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          89:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          90:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          91:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          92:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          93:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          94:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          95:
              {
                'ts': 1173603600,
                'time': '2007-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          96:
              {
                'ts': 1194163200,
                'time': '2007-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          97:
              {
                'ts': 1205053200,
                'time': '2008-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          98:
              {
                'ts': 1225612800,
                'time': '2008-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          99:
              {
                'ts': 1236502800,
                'time': '2009-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          100:
              {
                'ts': 1257062400,
                'time': '2009-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          101:
              {
                'ts': 1268557200,
                'time': '2010-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          102:
              {
                'ts': 1289116800,
                'time': '2010-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          103:
              {
                'ts': 1300006800,
                'time': '2011-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          104:
              {
                'ts': 1320566400,
                'time': '2011-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          105:
              {
                'ts': 1331456400,
                'time': '2012-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          106:
              {
                'ts': 1352016000,
                'time': '2012-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          107:
              {
                'ts': 1362906000,
                'time': '2013-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          108:
              {
                'ts': 1383465600,
                'time': '2013-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          109:
              {
                'ts': 1394355600,
                'time': '2014-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          110:
              {
                'ts': 1414915200,
                'time': '2014-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          111:
              {
                'ts': 1425805200,
                'time': '2015-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          112:
              {
                'ts': 1446364800,
                'time': '2015-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          113:
              {
                'ts': 1457859600,
                'time': '2016-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          114:
              {
                'ts': 1478419200,
                'time': '2016-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          115:
              {
                'ts': 1489309200,
                'time': '2017-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          116:
              {
                'ts': 1509868800,
                'time': '2017-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          117:
              {
                'ts': 1520758800,
                'time': '2018-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          118:
              {
                'ts': 1541318400,
                'time': '2018-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          119:
              {
                'ts': 1552208400,
                'time': '2019-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          120:
              {
                'ts': 1572768000,
                'time': '2019-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          121:
              {
                'ts': 1583658000,
                'time': '2020-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          122:
              {
                'ts': 1604217600,
                'time': '2020-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          123:
              {
                'ts': 1615712400,
                'time': '2021-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          124:
              {
                'ts': 1636272000,
                'time': '2021-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          125:
              {
                'ts': 1647162000,
                'time': '2022-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          126:
              {
                'ts': 1667721600,
                'time': '2022-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          127:
              {
                'ts': 1678611600,
                'time': '2023-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          128:
              {
                'ts': 1699171200,
                'time': '2023-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          129:
              {
                'ts': 1710061200,
                'time': '2024-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          130:
              {
                'ts': 1730620800,
                'time': '2024-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          131:
              {
                'ts': 1741510800,
                'time': '2025-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          132:
              {
                'ts': 1762070400,
                'time': '2025-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          133:
              {
                'ts': 1772960400,
                'time': '2026-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          134:
              {
                'ts': 1793520000,
                'time': '2026-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          135:
              {
                'ts': 1805014800,
                'time': '2027-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          136:
              {
                'ts': 1825574400,
                'time': '2027-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          137:
              {
                'ts': 1836464400,
                'time': '2028-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          138:
              {
                'ts': 1857024000,
                'time': '2028-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          139:
              {
                'ts': 1867914000,
                'time': '2029-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          140:
              {
                'ts': 1888473600,
                'time': '2029-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          141:
              {
                'ts': 1899363600,
                'time': '2030-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          142:
              {
                'ts': 1919923200,
                'time': '2030-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          143:
              {
                'ts': 1930813200,
                'time': '2031-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          144:
              {
                'ts': 1951372800,
                'time': '2031-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          145:
              {
                'ts': 1962867600,
                'time': '2032-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          146:
              {
                'ts': 1983427200,
                'time': '2032-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          147:
              {
                'ts': 1994317200,
                'time': '2033-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          148:
              {
                'ts': 2014876800,
                'time': '2033-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          149:
              {
                'ts': 2025766800,
                'time': '2034-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          150:
              {
                'ts': 2046326400,
                'time': '2034-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          151:
              {
                'ts': 2057216400,
                'time': '2035-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          152:
              {
                'ts': 2077776000,
                'time': '2035-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          153:
              {
                'ts': 2088666000,
                'time': '2036-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          154:
              {
                'ts': 2109225600,
                'time': '2036-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          155:
              {
                'ts': 2120115600,
                'time': '2037-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          156:
              {
                'ts': 2140675200,
                'time': '2037-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'MST7MDT':
        {
          0:
              {
                'ts': -1633273200,
                'time': '1918-03-31T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          1:
              {
                'ts': -1615132800,
                'time': '1918-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          2:
              {
                'ts': -1601823600,
                'time': '1919-03-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          3:
              {
                'ts': -1583683200,
                'time': '1919-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          6:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          7:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          8:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          9:
              {
                'ts': -52930800,
                'time': '1968-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          10:
              {
                'ts': -37209600,
                'time': '1968-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -21481200,
                'time': '1969-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': 9968400,
                'time': '1970-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': 25689600,
                'time': '1970-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': 41418000,
                'time': '1971-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': 57744000,
                'time': '1971-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': 73472400,
                'time': '1972-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': 104922000,
                'time': '1973-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': 126694800,
                'time': '1974-01-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': 162378000,
                'time': '1975-02-23T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          24:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          25:
              {
                'ts': 199270800,
                'time': '1976-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          26:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          27:
              {
                'ts': 230720400,
                'time': '1977-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          28:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          29:
              {
                'ts': 262774800,
                'time': '1978-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          30:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          31:
              {
                'ts': 294224400,
                'time': '1979-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          32:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          33:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          34:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          35:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          36:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          37:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          38:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          39:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          40:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          41:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          42:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          43:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          44:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          45:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          46:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          47:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          48:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          49:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          50:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          51:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          52:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          53:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          54:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          55:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          56:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          57:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          58:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          59:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          60:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          61:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          62:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          63:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          64:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          65:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          66:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          67:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          68:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          69:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          70:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          71:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          72:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          73:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          74:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          75:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          76:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          77:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          78:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          79:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          80:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          81:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          82:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          83:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          84:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          85:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          86:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          87:
              {
                'ts': 1173603600,
                'time': '2007-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          88:
              {
                'ts': 1194163200,
                'time': '2007-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          89:
              {
                'ts': 1205053200,
                'time': '2008-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          90:
              {
                'ts': 1225612800,
                'time': '2008-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          91:
              {
                'ts': 1236502800,
                'time': '2009-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          92:
              {
                'ts': 1257062400,
                'time': '2009-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          93:
              {
                'ts': 1268557200,
                'time': '2010-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          94:
              {
                'ts': 1289116800,
                'time': '2010-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          95:
              {
                'ts': 1300006800,
                'time': '2011-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          96:
              {
                'ts': 1320566400,
                'time': '2011-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          97:
              {
                'ts': 1331456400,
                'time': '2012-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          98:
              {
                'ts': 1352016000,
                'time': '2012-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          99:
              {
                'ts': 1362906000,
                'time': '2013-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          100:
              {
                'ts': 1383465600,
                'time': '2013-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          101:
              {
                'ts': 1394355600,
                'time': '2014-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          102:
              {
                'ts': 1414915200,
                'time': '2014-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          103:
              {
                'ts': 1425805200,
                'time': '2015-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          104:
              {
                'ts': 1446364800,
                'time': '2015-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          105:
              {
                'ts': 1457859600,
                'time': '2016-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          106:
              {
                'ts': 1478419200,
                'time': '2016-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          107:
              {
                'ts': 1489309200,
                'time': '2017-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          108:
              {
                'ts': 1509868800,
                'time': '2017-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          109:
              {
                'ts': 1520758800,
                'time': '2018-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          110:
              {
                'ts': 1541318400,
                'time': '2018-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          111:
              {
                'ts': 1552208400,
                'time': '2019-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          112:
              {
                'ts': 1572768000,
                'time': '2019-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          113:
              {
                'ts': 1583658000,
                'time': '2020-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          114:
              {
                'ts': 1604217600,
                'time': '2020-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          115:
              {
                'ts': 1615712400,
                'time': '2021-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          116:
              {
                'ts': 1636272000,
                'time': '2021-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          117:
              {
                'ts': 1647162000,
                'time': '2022-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          118:
              {
                'ts': 1667721600,
                'time': '2022-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          119:
              {
                'ts': 1678611600,
                'time': '2023-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          120:
              {
                'ts': 1699171200,
                'time': '2023-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          121:
              {
                'ts': 1710061200,
                'time': '2024-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          122:
              {
                'ts': 1730620800,
                'time': '2024-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          123:
              {
                'ts': 1741510800,
                'time': '2025-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          124:
              {
                'ts': 1762070400,
                'time': '2025-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          125:
              {
                'ts': 1772960400,
                'time': '2026-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          126:
              {
                'ts': 1793520000,
                'time': '2026-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          127:
              {
                'ts': 1805014800,
                'time': '2027-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          128:
              {
                'ts': 1825574400,
                'time': '2027-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          129:
              {
                'ts': 1836464400,
                'time': '2028-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          130:
              {
                'ts': 1857024000,
                'time': '2028-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          131:
              {
                'ts': 1867914000,
                'time': '2029-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          132:
              {
                'ts': 1888473600,
                'time': '2029-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          133:
              {
                'ts': 1899363600,
                'time': '2030-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          134:
              {
                'ts': 1919923200,
                'time': '2030-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          135:
              {
                'ts': 1930813200,
                'time': '2031-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          136:
              {
                'ts': 1951372800,
                'time': '2031-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          137:
              {
                'ts': 1962867600,
                'time': '2032-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          138:
              {
                'ts': 1983427200,
                'time': '2032-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          139:
              {
                'ts': 1994317200,
                'time': '2033-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          140:
              {
                'ts': 2014876800,
                'time': '2033-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          141:
              {
                'ts': 2025766800,
                'time': '2034-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          142:
              {
                'ts': 2046326400,
                'time': '2034-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          143:
              {
                'ts': 2057216400,
                'time': '2035-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          144:
              {
                'ts': 2077776000,
                'time': '2035-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          145:
              {
                'ts': 2088666000,
                'time': '2036-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          146:
              {
                'ts': 2109225600,
                'time': '2036-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          147:
              {
                'ts': 2120115600,
                'time': '2037-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          148:
              {
                'ts': 2140675200,
                'time': '2037-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'Navajo':
        {
          0:
              {
                'ts': -1633273200,
                'time': '1918-03-31T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          1:
              {
                'ts': -1615132800,
                'time': '1918-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          2:
              {
                'ts': -1601823600,
                'time': '1919-03-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          3:
              {
                'ts': -1583683200,
                'time': '1919-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': -1570374000,
                'time': '1920-03-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          5:
              {
                'ts': -1551628800,
                'time': '1920-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          6:
              {
                'ts': -1538924400,
                'time': '1921-03-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          7:
              {
                'ts': -1534089600,
                'time': '1921-05-22T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          8:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          9:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          10:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -147884400,
                'time': '1965-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -131558400,
                'time': '1965-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': -116434800,
                'time': '1966-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': -100108800,
                'time': '1966-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': -52930800,
                'time': '1968-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': -37209600,
                'time': '1968-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': -21481200,
                'time': '1969-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': 9968400,
                'time': '1970-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': 25689600,
                'time': '1970-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': 41418000,
                'time': '1971-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          24:
              {
                'ts': 57744000,
                'time': '1971-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          25:
              {
                'ts': 73472400,
                'time': '1972-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          26:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          27:
              {
                'ts': 104922000,
                'time': '1973-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          28:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          29:
              {
                'ts': 126694800,
                'time': '1974-01-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          30:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          31:
              {
                'ts': 162378000,
                'time': '1975-02-23T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          32:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          33:
              {
                'ts': 199270800,
                'time': '1976-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          34:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          35:
              {
                'ts': 230720400,
                'time': '1977-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          36:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          37:
              {
                'ts': 262774800,
                'time': '1978-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          38:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          39:
              {
                'ts': 294224400,
                'time': '1979-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          40:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          41:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          42:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          43:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          44:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          45:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          46:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          47:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          48:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          49:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          50:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          51:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          52:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          53:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          54:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          55:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          56:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          57:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          58:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          59:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          60:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          61:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          62:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          63:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          64:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          65:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          66:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          67:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          68:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          69:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          70:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          71:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          72:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          73:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          74:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          75:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          76:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          77:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          78:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          79:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          80:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          81:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          82:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          83:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          84:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          85:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          86:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          87:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          88:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          89:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          90:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          91:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          92:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          93:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          94:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          95:
              {
                'ts': 1173603600,
                'time': '2007-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          96:
              {
                'ts': 1194163200,
                'time': '2007-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          97:
              {
                'ts': 1205053200,
                'time': '2008-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          98:
              {
                'ts': 1225612800,
                'time': '2008-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          99:
              {
                'ts': 1236502800,
                'time': '2009-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          100:
              {
                'ts': 1257062400,
                'time': '2009-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          101:
              {
                'ts': 1268557200,
                'time': '2010-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          102:
              {
                'ts': 1289116800,
                'time': '2010-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          103:
              {
                'ts': 1300006800,
                'time': '2011-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          104:
              {
                'ts': 1320566400,
                'time': '2011-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          105:
              {
                'ts': 1331456400,
                'time': '2012-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          106:
              {
                'ts': 1352016000,
                'time': '2012-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          107:
              {
                'ts': 1362906000,
                'time': '2013-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          108:
              {
                'ts': 1383465600,
                'time': '2013-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          109:
              {
                'ts': 1394355600,
                'time': '2014-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          110:
              {
                'ts': 1414915200,
                'time': '2014-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          111:
              {
                'ts': 1425805200,
                'time': '2015-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          112:
              {
                'ts': 1446364800,
                'time': '2015-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          113:
              {
                'ts': 1457859600,
                'time': '2016-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          114:
              {
                'ts': 1478419200,
                'time': '2016-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          115:
              {
                'ts': 1489309200,
                'time': '2017-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          116:
              {
                'ts': 1509868800,
                'time': '2017-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          117:
              {
                'ts': 1520758800,
                'time': '2018-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          118:
              {
                'ts': 1541318400,
                'time': '2018-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          119:
              {
                'ts': 1552208400,
                'time': '2019-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          120:
              {
                'ts': 1572768000,
                'time': '2019-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          121:
              {
                'ts': 1583658000,
                'time': '2020-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          122:
              {
                'ts': 1604217600,
                'time': '2020-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          123:
              {
                'ts': 1615712400,
                'time': '2021-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          124:
              {
                'ts': 1636272000,
                'time': '2021-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          125:
              {
                'ts': 1647162000,
                'time': '2022-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          126:
              {
                'ts': 1667721600,
                'time': '2022-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          127:
              {
                'ts': 1678611600,
                'time': '2023-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          128:
              {
                'ts': 1699171200,
                'time': '2023-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          129:
              {
                'ts': 1710061200,
                'time': '2024-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          130:
              {
                'ts': 1730620800,
                'time': '2024-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          131:
              {
                'ts': 1741510800,
                'time': '2025-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          132:
              {
                'ts': 1762070400,
                'time': '2025-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          133:
              {
                'ts': 1772960400,
                'time': '2026-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          134:
              {
                'ts': 1793520000,
                'time': '2026-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          135:
              {
                'ts': 1805014800,
                'time': '2027-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          136:
              {
                'ts': 1825574400,
                'time': '2027-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          137:
              {
                'ts': 1836464400,
                'time': '2028-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          138:
              {
                'ts': 1857024000,
                'time': '2028-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          139:
              {
                'ts': 1867914000,
                'time': '2029-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          140:
              {
                'ts': 1888473600,
                'time': '2029-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          141:
              {
                'ts': 1899363600,
                'time': '2030-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          142:
              {
                'ts': 1919923200,
                'time': '2030-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          143:
              {
                'ts': 1930813200,
                'time': '2031-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          144:
              {
                'ts': 1951372800,
                'time': '2031-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          145:
              {
                'ts': 1962867600,
                'time': '2032-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          146:
              {
                'ts': 1983427200,
                'time': '2032-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          147:
              {
                'ts': 1994317200,
                'time': '2033-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          148:
              {
                'ts': 2014876800,
                'time': '2033-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          149:
              {
                'ts': 2025766800,
                'time': '2034-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          150:
              {
                'ts': 2046326400,
                'time': '2034-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          151:
              {
                'ts': 2057216400,
                'time': '2035-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          152:
              {
                'ts': 2077776000,
                'time': '2035-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          153:
              {
                'ts': 2088666000,
                'time': '2036-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          154:
              {
                'ts': 2109225600,
                'time': '2036-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          155:
              {
                'ts': 2120115600,
                'time': '2037-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          156:
              {
                'ts': 2140675200,
                'time': '2037-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'NZ':
        {
          0:
              {
                'ts': -1330335000,
                'time': '1927-11-05T14:30:00+0000',
                'offset': 45000,
                'isdst': true,
                'abbr': 'NZST'
              },
          1:
              {
                'ts': -1320057000,
                'time': '1928-03-03T13:30:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          2:
              {
                'ts': -1300699800,
                'time': '1928-10-13T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          3:
              {
                'ts': -1287396000,
                'time': '1929-03-16T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          4:
              {
                'ts': -1269250200,
                'time': '1929-10-12T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          5:
              {
                'ts': -1255946400,
                'time': '1930-03-15T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          6:
              {
                'ts': -1237800600,
                'time': '1930-10-11T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          7:
              {
                'ts': -1224496800,
                'time': '1931-03-14T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          8:
              {
                'ts': -1206351000,
                'time': '1931-10-10T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          9:
              {
                'ts': -1192442400,
                'time': '1932-03-19T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          10:
              {
                'ts': -1174901400,
                'time': '1932-10-08T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          11:
              {
                'ts': -1160992800,
                'time': '1933-03-18T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          12:
              {
                'ts': -1143451800,
                'time': '1933-10-07T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          13:
              {
                'ts': -1125914400,
                'time': '1934-04-28T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          14:
              {
                'ts': -1112607000,
                'time': '1934-09-29T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          15:
              {
                'ts': -1094464800,
                'time': '1935-04-27T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          16:
              {
                'ts': -1081157400,
                'time': '1935-09-28T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          17:
              {
                'ts': -1063015200,
                'time': '1936-04-25T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          18:
              {
                'ts': -1049707800,
                'time': '1936-09-26T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          19:
              {
                'ts': -1031565600,
                'time': '1937-04-24T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          20:
              {
                'ts': -1018258200,
                'time': '1937-09-25T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          21:
              {
                'ts': -1000116000,
                'time': '1938-04-23T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          22:
              {
                'ts': -986808600,
                'time': '1938-09-24T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          23:
              {
                'ts': -968061600,
                'time': '1939-04-29T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          24:
              {
                'ts': -955359000,
                'time': '1939-09-23T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          25:
              {
                'ts': -936612000,
                'time': '1940-04-27T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          26:
              {
                'ts': -923304600,
                'time': '1940-09-28T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          27:
              {
                'ts': -757425600,
                'time': '1945-12-31T12:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          28:
              {
                'ts': 152632800,
                'time': '1974-11-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          29:
              {
                'ts': 162309600,
                'time': '1975-02-22T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          30:
              {
                'ts': 183477600,
                'time': '1975-10-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          31:
              {
                'ts': 194968800,
                'time': '1976-03-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          32:
              {
                'ts': 215532000,
                'time': '1976-10-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          33:
              {
                'ts': 226418400,
                'time': '1977-03-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          34:
              {
                'ts': 246981600,
                'time': '1977-10-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          35:
              {
                'ts': 257868000,
                'time': '1978-03-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          36:
              {
                'ts': 278431200,
                'time': '1978-10-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          37:
              {
                'ts': 289317600,
                'time': '1979-03-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          38:
              {
                'ts': 309880800,
                'time': '1979-10-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          39:
              {
                'ts': 320767200,
                'time': '1980-03-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          40:
              {
                'ts': 341330400,
                'time': '1980-10-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          41:
              {
                'ts': 352216800,
                'time': '1981-02-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          42:
              {
                'ts': 372780000,
                'time': '1981-10-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          43:
              {
                'ts': 384271200,
                'time': '1982-03-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          44:
              {
                'ts': 404834400,
                'time': '1982-10-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          45:
              {
                'ts': 415720800,
                'time': '1983-03-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          46:
              {
                'ts': 436284000,
                'time': '1983-10-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          47:
              {
                'ts': 447170400,
                'time': '1984-03-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          48:
              {
                'ts': 467733600,
                'time': '1984-10-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          49:
              {
                'ts': 478620000,
                'time': '1985-03-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          50:
              {
                'ts': 499183200,
                'time': '1985-10-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          51:
              {
                'ts': 510069600,
                'time': '1986-03-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          52:
              {
                'ts': 530632800,
                'time': '1986-10-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          53:
              {
                'ts': 541519200,
                'time': '1987-02-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          54:
              {
                'ts': 562082400,
                'time': '1987-10-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          55:
              {
                'ts': 573573600,
                'time': '1988-03-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          56:
              {
                'ts': 594136800,
                'time': '1988-10-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          57:
              {
                'ts': 605023200,
                'time': '1989-03-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          58:
              {
                'ts': 623772000,
                'time': '1989-10-07T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          59:
              {
                'ts': 637682400,
                'time': '1990-03-17T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          60:
              {
                'ts': 655221600,
                'time': '1990-10-06T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          61:
              {
                'ts': 669132000,
                'time': '1991-03-16T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          62:
              {
                'ts': 686671200,
                'time': '1991-10-05T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          63:
              {
                'ts': 700581600,
                'time': '1992-03-14T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          64:
              {
                'ts': 718120800,
                'time': '1992-10-03T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          65:
              {
                'ts': 732636000,
                'time': '1993-03-20T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          66:
              {
                'ts': 749570400,
                'time': '1993-10-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          67:
              {
                'ts': 764085600,
                'time': '1994-03-19T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          68:
              {
                'ts': 781020000,
                'time': '1994-10-01T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          69:
              {
                'ts': 795535200,
                'time': '1995-03-18T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          70:
              {
                'ts': 812469600,
                'time': '1995-09-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          71:
              {
                'ts': 826984800,
                'time': '1996-03-16T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          72:
              {
                'ts': 844524000,
                'time': '1996-10-05T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          73:
              {
                'ts': 858434400,
                'time': '1997-03-15T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          74:
              {
                'ts': 875973600,
                'time': '1997-10-04T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          75:
              {
                'ts': 889884000,
                'time': '1998-03-14T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          76:
              {
                'ts': 907423200,
                'time': '1998-10-03T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          77:
              {
                'ts': 921938400,
                'time': '1999-03-20T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          78:
              {
                'ts': 938872800,
                'time': '1999-10-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          79:
              {
                'ts': 953388000,
                'time': '2000-03-18T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          80:
              {
                'ts': 970322400,
                'time': '2000-09-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          81:
              {
                'ts': 984837600,
                'time': '2001-03-17T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          82:
              {
                'ts': 1002376800,
                'time': '2001-10-06T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          83:
              {
                'ts': 1016287200,
                'time': '2002-03-16T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          84:
              {
                'ts': 1033826400,
                'time': '2002-10-05T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          85:
              {
                'ts': 1047736800,
                'time': '2003-03-15T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          86:
              {
                'ts': 1065276000,
                'time': '2003-10-04T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          87:
              {
                'ts': 1079791200,
                'time': '2004-03-20T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          88:
              {
                'ts': 1096725600,
                'time': '2004-10-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          89:
              {
                'ts': 1111240800,
                'time': '2005-03-19T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          90:
              {
                'ts': 1128175200,
                'time': '2005-10-01T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          91:
              {
                'ts': 1142690400,
                'time': '2006-03-18T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          92:
              {
                'ts': 1159624800,
                'time': '2006-09-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          93:
              {
                'ts': 1174140000,
                'time': '2007-03-17T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          94:
              {
                'ts': 1191074400,
                'time': '2007-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          95:
              {
                'ts': 1207404000,
                'time': '2008-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          96:
              {
                'ts': 1222524000,
                'time': '2008-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          97:
              {
                'ts': 1238853600,
                'time': '2009-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          98:
              {
                'ts': 1253973600,
                'time': '2009-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          99:
              {
                'ts': 1270303200,
                'time': '2010-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          100:
              {
                'ts': 1285423200,
                'time': '2010-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          101:
              {
                'ts': 1301752800,
                'time': '2011-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          102:
              {
                'ts': 1316872800,
                'time': '2011-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          103:
              {
                'ts': 1333202400,
                'time': '2012-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          104:
              {
                'ts': 1348927200,
                'time': '2012-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          105:
              {
                'ts': 1365256800,
                'time': '2013-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          106:
              {
                'ts': 1380376800,
                'time': '2013-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          107:
              {
                'ts': 1396706400,
                'time': '2014-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          108:
              {
                'ts': 1411826400,
                'time': '2014-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          109:
              {
                'ts': 1428156000,
                'time': '2015-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          110:
              {
                'ts': 1443276000,
                'time': '2015-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          111:
              {
                'ts': 1459605600,
                'time': '2016-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          112:
              {
                'ts': 1474725600,
                'time': '2016-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          113:
              {
                'ts': 1491055200,
                'time': '2017-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          114:
              {
                'ts': 1506175200,
                'time': '2017-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          115:
              {
                'ts': 1522504800,
                'time': '2018-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          116:
              {
                'ts': 1538229600,
                'time': '2018-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          117:
              {
                'ts': 1554559200,
                'time': '2019-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          118:
              {
                'ts': 1569679200,
                'time': '2019-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          119:
              {
                'ts': 1586008800,
                'time': '2020-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          120:
              {
                'ts': 1601128800,
                'time': '2020-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          121:
              {
                'ts': 1617458400,
                'time': '2021-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          122:
              {
                'ts': 1632578400,
                'time': '2021-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          123:
              {
                'ts': 1648908000,
                'time': '2022-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          124:
              {
                'ts': 1664028000,
                'time': '2022-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          125:
              {
                'ts': 1680357600,
                'time': '2023-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          126:
              {
                'ts': 1695477600,
                'time': '2023-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          127:
              {
                'ts': 1712412000,
                'time': '2024-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          128:
              {
                'ts': 1727532000,
                'time': '2024-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          129:
              {
                'ts': 1743861600,
                'time': '2025-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          130:
              {
                'ts': 1758981600,
                'time': '2025-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          131:
              {
                'ts': 1775311200,
                'time': '2026-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          132:
              {
                'ts': 1790431200,
                'time': '2026-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          133:
              {
                'ts': 1806760800,
                'time': '2027-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          134:
              {
                'ts': 1821880800,
                'time': '2027-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          135:
              {
                'ts': 1838210400,
                'time': '2028-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          136:
              {
                'ts': 1853330400,
                'time': '2028-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          137:
              {
                'ts': 1869660000,
                'time': '2029-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          138:
              {
                'ts': 1885384800,
                'time': '2029-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          139:
              {
                'ts': 1901714400,
                'time': '2030-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          140:
              {
                'ts': 1916834400,
                'time': '2030-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          141:
              {
                'ts': 1933164000,
                'time': '2031-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          142:
              {
                'ts': 1948284000,
                'time': '2031-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          143:
              {
                'ts': 1964613600,
                'time': '2032-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          144:
              {
                'ts': 1979733600,
                'time': '2032-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          145:
              {
                'ts': 1996063200,
                'time': '2033-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          146:
              {
                'ts': 2011183200,
                'time': '2033-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          147:
              {
                'ts': 2027512800,
                'time': '2034-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          148:
              {
                'ts': 2042632800,
                'time': '2034-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          149:
              {
                'ts': 2058962400,
                'time': '2035-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          150:
              {
                'ts': 2074687200,
                'time': '2035-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          151:
              {
                'ts': 2091016800,
                'time': '2036-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          152:
              {
                'ts': 2106136800,
                'time': '2036-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          153:
              {
                'ts': 2122466400,
                'time': '2037-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          154:
              {
                'ts': 2137586400,
                'time': '2037-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              }
        },
    'NZ-CHAT':
        {
          0:
              {
                'ts': -410271228,
                'time': '1956-12-31T11:46:12+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          1:
              {
                'ts': 152632800,
                'time': '1974-11-02T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          2:
              {
                'ts': 162309600,
                'time': '1975-02-22T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          3:
              {
                'ts': 183477600,
                'time': '1975-10-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          4:
              {
                'ts': 194968800,
                'time': '1976-03-06T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          5:
              {
                'ts': 215532000,
                'time': '1976-10-30T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          6:
              {
                'ts': 226418400,
                'time': '1977-03-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          7:
              {
                'ts': 246981600,
                'time': '1977-10-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          8:
              {
                'ts': 257868000,
                'time': '1978-03-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          9:
              {
                'ts': 278431200,
                'time': '1978-10-28T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          10:
              {
                'ts': 289317600,
                'time': '1979-03-03T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          11:
              {
                'ts': 309880800,
                'time': '1979-10-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          12:
              {
                'ts': 320767200,
                'time': '1980-03-01T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          13:
              {
                'ts': 341330400,
                'time': '1980-10-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          14:
              {
                'ts': 352216800,
                'time': '1981-02-28T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          15:
              {
                'ts': 372780000,
                'time': '1981-10-24T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          16:
              {
                'ts': 384271200,
                'time': '1982-03-06T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          17:
              {
                'ts': 404834400,
                'time': '1982-10-30T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          18:
              {
                'ts': 415720800,
                'time': '1983-03-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          19:
              {
                'ts': 436284000,
                'time': '1983-10-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          20:
              {
                'ts': 447170400,
                'time': '1984-03-03T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          21:
              {
                'ts': 467733600,
                'time': '1984-10-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          22:
              {
                'ts': 478620000,
                'time': '1985-03-02T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          23:
              {
                'ts': 499183200,
                'time': '1985-10-26T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          24:
              {
                'ts': 510069600,
                'time': '1986-03-01T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          25:
              {
                'ts': 530632800,
                'time': '1986-10-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          26:
              {
                'ts': 541519200,
                'time': '1987-02-28T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          27:
              {
                'ts': 562082400,
                'time': '1987-10-24T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          28:
              {
                'ts': 573573600,
                'time': '1988-03-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          29:
              {
                'ts': 594136800,
                'time': '1988-10-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          30:
              {
                'ts': 605023200,
                'time': '1989-03-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          31:
              {
                'ts': 623772000,
                'time': '1989-10-07T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          32:
              {
                'ts': 637682400,
                'time': '1990-03-17T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          33:
              {
                'ts': 655221600,
                'time': '1990-10-06T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          34:
              {
                'ts': 669132000,
                'time': '1991-03-16T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          35:
              {
                'ts': 686671200,
                'time': '1991-10-05T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          36:
              {
                'ts': 700581600,
                'time': '1992-03-14T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          37:
              {
                'ts': 718120800,
                'time': '1992-10-03T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          38:
              {
                'ts': 732636000,
                'time': '1993-03-20T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          39:
              {
                'ts': 749570400,
                'time': '1993-10-02T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          40:
              {
                'ts': 764085600,
                'time': '1994-03-19T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          41:
              {
                'ts': 781020000,
                'time': '1994-10-01T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          42:
              {
                'ts': 795535200,
                'time': '1995-03-18T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          43:
              {
                'ts': 812469600,
                'time': '1995-09-30T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          44:
              {
                'ts': 826984800,
                'time': '1996-03-16T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          45:
              {
                'ts': 844524000,
                'time': '1996-10-05T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          46:
              {
                'ts': 858434400,
                'time': '1997-03-15T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          47:
              {
                'ts': 875973600,
                'time': '1997-10-04T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          48:
              {
                'ts': 889884000,
                'time': '1998-03-14T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          49:
              {
                'ts': 907423200,
                'time': '1998-10-03T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          50:
              {
                'ts': 921938400,
                'time': '1999-03-20T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          51:
              {
                'ts': 938872800,
                'time': '1999-10-02T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          52:
              {
                'ts': 953388000,
                'time': '2000-03-18T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          53:
              {
                'ts': 970322400,
                'time': '2000-09-30T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          54:
              {
                'ts': 984837600,
                'time': '2001-03-17T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          55:
              {
                'ts': 1002376800,
                'time': '2001-10-06T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          56:
              {
                'ts': 1016287200,
                'time': '2002-03-16T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          57:
              {
                'ts': 1033826400,
                'time': '2002-10-05T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          58:
              {
                'ts': 1047736800,
                'time': '2003-03-15T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          59:
              {
                'ts': 1065276000,
                'time': '2003-10-04T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          60:
              {
                'ts': 1079791200,
                'time': '2004-03-20T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          61:
              {
                'ts': 1096725600,
                'time': '2004-10-02T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          62:
              {
                'ts': 1111240800,
                'time': '2005-03-19T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          63:
              {
                'ts': 1128175200,
                'time': '2005-10-01T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          64:
              {
                'ts': 1142690400,
                'time': '2006-03-18T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          65:
              {
                'ts': 1159624800,
                'time': '2006-09-30T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          66:
              {
                'ts': 1174140000,
                'time': '2007-03-17T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          67:
              {
                'ts': 1191074400,
                'time': '2007-09-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          68:
              {
                'ts': 1207404000,
                'time': '2008-04-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          69:
              {
                'ts': 1222524000,
                'time': '2008-09-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          70:
              {
                'ts': 1238853600,
                'time': '2009-04-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          71:
              {
                'ts': 1253973600,
                'time': '2009-09-26T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          72:
              {
                'ts': 1270303200,
                'time': '2010-04-03T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          73:
              {
                'ts': 1285423200,
                'time': '2010-09-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          74:
              {
                'ts': 1301752800,
                'time': '2011-04-02T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          75:
              {
                'ts': 1316872800,
                'time': '2011-09-24T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          76:
              {
                'ts': 1333202400,
                'time': '2012-03-31T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          77:
              {
                'ts': 1348927200,
                'time': '2012-09-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          78:
              {
                'ts': 1365256800,
                'time': '2013-04-06T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          79:
              {
                'ts': 1380376800,
                'time': '2013-09-28T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          80:
              {
                'ts': 1396706400,
                'time': '2014-04-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          81:
              {
                'ts': 1411826400,
                'time': '2014-09-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          82:
              {
                'ts': 1428156000,
                'time': '2015-04-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          83:
              {
                'ts': 1443276000,
                'time': '2015-09-26T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          84:
              {
                'ts': 1459605600,
                'time': '2016-04-02T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          85:
              {
                'ts': 1474725600,
                'time': '2016-09-24T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          86:
              {
                'ts': 1491055200,
                'time': '2017-04-01T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          87:
              {
                'ts': 1506175200,
                'time': '2017-09-23T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          88:
              {
                'ts': 1522504800,
                'time': '2018-03-31T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          89:
              {
                'ts': 1538229600,
                'time': '2018-09-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          90:
              {
                'ts': 1554559200,
                'time': '2019-04-06T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          91:
              {
                'ts': 1569679200,
                'time': '2019-09-28T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          92:
              {
                'ts': 1586008800,
                'time': '2020-04-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          93:
              {
                'ts': 1601128800,
                'time': '2020-09-26T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          94:
              {
                'ts': 1617458400,
                'time': '2021-04-03T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          95:
              {
                'ts': 1632578400,
                'time': '2021-09-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          96:
              {
                'ts': 1648908000,
                'time': '2022-04-02T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          97:
              {
                'ts': 1664028000,
                'time': '2022-09-24T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          98:
              {
                'ts': 1680357600,
                'time': '2023-04-01T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          99:
              {
                'ts': 1695477600,
                'time': '2023-09-23T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          100:
              {
                'ts': 1712412000,
                'time': '2024-04-06T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          101:
              {
                'ts': 1727532000,
                'time': '2024-09-28T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          102:
              {
                'ts': 1743861600,
                'time': '2025-04-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          103:
              {
                'ts': 1758981600,
                'time': '2025-09-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          104:
              {
                'ts': 1775311200,
                'time': '2026-04-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          105:
              {
                'ts': 1790431200,
                'time': '2026-09-26T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          106:
              {
                'ts': 1806760800,
                'time': '2027-04-03T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          107:
              {
                'ts': 1821880800,
                'time': '2027-09-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          108:
              {
                'ts': 1838210400,
                'time': '2028-04-01T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          109:
              {
                'ts': 1853330400,
                'time': '2028-09-23T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          110:
              {
                'ts': 1869660000,
                'time': '2029-03-31T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          111:
              {
                'ts': 1885384800,
                'time': '2029-09-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          112:
              {
                'ts': 1901714400,
                'time': '2030-04-06T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          113:
              {
                'ts': 1916834400,
                'time': '2030-09-28T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          114:
              {
                'ts': 1933164000,
                'time': '2031-04-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          115:
              {
                'ts': 1948284000,
                'time': '2031-09-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          116:
              {
                'ts': 1964613600,
                'time': '2032-04-03T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          117:
              {
                'ts': 1979733600,
                'time': '2032-09-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          118:
              {
                'ts': 1996063200,
                'time': '2033-04-02T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          119:
              {
                'ts': 2011183200,
                'time': '2033-09-24T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          120:
              {
                'ts': 2027512800,
                'time': '2034-04-01T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          121:
              {
                'ts': 2042632800,
                'time': '2034-09-23T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          122:
              {
                'ts': 2058962400,
                'time': '2035-03-31T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          123:
              {
                'ts': 2074687200,
                'time': '2035-09-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          124:
              {
                'ts': 2091016800,
                'time': '2036-04-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          125:
              {
                'ts': 2106136800,
                'time': '2036-09-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          126:
              {
                'ts': 2122466400,
                'time': '2037-04-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          127:
              {
                'ts': 2137586400,
                'time': '2037-09-26T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              }
        },
    'Pacific/Apia':
        {
          0:
              {
                'ts': -1861878784,
                'time': '1911-01-01T11:26:56+0000',
                'offset': -41400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          1:
              {
                'ts': -631110600,
                'time': '1950-01-01T11:30:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'WST'
              }
        },
    'Pacific/Auckland':
        {
          0:
              {
                'ts': -1330335000,
                'time': '1927-11-05T14:30:00+0000',
                'offset': 45000,
                'isdst': true,
                'abbr': 'NZST'
              },
          1:
              {
                'ts': -1320057000,
                'time': '1928-03-03T13:30:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          2:
              {
                'ts': -1300699800,
                'time': '1928-10-13T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          3:
              {
                'ts': -1287396000,
                'time': '1929-03-16T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          4:
              {
                'ts': -1269250200,
                'time': '1929-10-12T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          5:
              {
                'ts': -1255946400,
                'time': '1930-03-15T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          6:
              {
                'ts': -1237800600,
                'time': '1930-10-11T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          7:
              {
                'ts': -1224496800,
                'time': '1931-03-14T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          8:
              {
                'ts': -1206351000,
                'time': '1931-10-10T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          9:
              {
                'ts': -1192442400,
                'time': '1932-03-19T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          10:
              {
                'ts': -1174901400,
                'time': '1932-10-08T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          11:
              {
                'ts': -1160992800,
                'time': '1933-03-18T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          12:
              {
                'ts': -1143451800,
                'time': '1933-10-07T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          13:
              {
                'ts': -1125914400,
                'time': '1934-04-28T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          14:
              {
                'ts': -1112607000,
                'time': '1934-09-29T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          15:
              {
                'ts': -1094464800,
                'time': '1935-04-27T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          16:
              {
                'ts': -1081157400,
                'time': '1935-09-28T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          17:
              {
                'ts': -1063015200,
                'time': '1936-04-25T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          18:
              {
                'ts': -1049707800,
                'time': '1936-09-26T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          19:
              {
                'ts': -1031565600,
                'time': '1937-04-24T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          20:
              {
                'ts': -1018258200,
                'time': '1937-09-25T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          21:
              {
                'ts': -1000116000,
                'time': '1938-04-23T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          22:
              {
                'ts': -986808600,
                'time': '1938-09-24T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          23:
              {
                'ts': -968061600,
                'time': '1939-04-29T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          24:
              {
                'ts': -955359000,
                'time': '1939-09-23T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          25:
              {
                'ts': -936612000,
                'time': '1940-04-27T14:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NZMT'
              },
          26:
              {
                'ts': -923304600,
                'time': '1940-09-28T14:30:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NZST'
              },
          27:
              {
                'ts': -757425600,
                'time': '1945-12-31T12:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          28:
              {
                'ts': 152632800,
                'time': '1974-11-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          29:
              {
                'ts': 162309600,
                'time': '1975-02-22T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          30:
              {
                'ts': 183477600,
                'time': '1975-10-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          31:
              {
                'ts': 194968800,
                'time': '1976-03-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          32:
              {
                'ts': 215532000,
                'time': '1976-10-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          33:
              {
                'ts': 226418400,
                'time': '1977-03-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          34:
              {
                'ts': 246981600,
                'time': '1977-10-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          35:
              {
                'ts': 257868000,
                'time': '1978-03-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          36:
              {
                'ts': 278431200,
                'time': '1978-10-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          37:
              {
                'ts': 289317600,
                'time': '1979-03-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          38:
              {
                'ts': 309880800,
                'time': '1979-10-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          39:
              {
                'ts': 320767200,
                'time': '1980-03-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          40:
              {
                'ts': 341330400,
                'time': '1980-10-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          41:
              {
                'ts': 352216800,
                'time': '1981-02-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          42:
              {
                'ts': 372780000,
                'time': '1981-10-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          43:
              {
                'ts': 384271200,
                'time': '1982-03-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          44:
              {
                'ts': 404834400,
                'time': '1982-10-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          45:
              {
                'ts': 415720800,
                'time': '1983-03-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          46:
              {
                'ts': 436284000,
                'time': '1983-10-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          47:
              {
                'ts': 447170400,
                'time': '1984-03-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          48:
              {
                'ts': 467733600,
                'time': '1984-10-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          49:
              {
                'ts': 478620000,
                'time': '1985-03-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          50:
              {
                'ts': 499183200,
                'time': '1985-10-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          51:
              {
                'ts': 510069600,
                'time': '1986-03-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          52:
              {
                'ts': 530632800,
                'time': '1986-10-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          53:
              {
                'ts': 541519200,
                'time': '1987-02-28T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          54:
              {
                'ts': 562082400,
                'time': '1987-10-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          55:
              {
                'ts': 573573600,
                'time': '1988-03-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          56:
              {
                'ts': 594136800,
                'time': '1988-10-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          57:
              {
                'ts': 605023200,
                'time': '1989-03-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          58:
              {
                'ts': 623772000,
                'time': '1989-10-07T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          59:
              {
                'ts': 637682400,
                'time': '1990-03-17T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          60:
              {
                'ts': 655221600,
                'time': '1990-10-06T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          61:
              {
                'ts': 669132000,
                'time': '1991-03-16T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          62:
              {
                'ts': 686671200,
                'time': '1991-10-05T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          63:
              {
                'ts': 700581600,
                'time': '1992-03-14T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          64:
              {
                'ts': 718120800,
                'time': '1992-10-03T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          65:
              {
                'ts': 732636000,
                'time': '1993-03-20T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          66:
              {
                'ts': 749570400,
                'time': '1993-10-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          67:
              {
                'ts': 764085600,
                'time': '1994-03-19T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          68:
              {
                'ts': 781020000,
                'time': '1994-10-01T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          69:
              {
                'ts': 795535200,
                'time': '1995-03-18T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          70:
              {
                'ts': 812469600,
                'time': '1995-09-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          71:
              {
                'ts': 826984800,
                'time': '1996-03-16T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          72:
              {
                'ts': 844524000,
                'time': '1996-10-05T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          73:
              {
                'ts': 858434400,
                'time': '1997-03-15T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          74:
              {
                'ts': 875973600,
                'time': '1997-10-04T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          75:
              {
                'ts': 889884000,
                'time': '1998-03-14T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          76:
              {
                'ts': 907423200,
                'time': '1998-10-03T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          77:
              {
                'ts': 921938400,
                'time': '1999-03-20T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          78:
              {
                'ts': 938872800,
                'time': '1999-10-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          79:
              {
                'ts': 953388000,
                'time': '2000-03-18T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          80:
              {
                'ts': 970322400,
                'time': '2000-09-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          81:
              {
                'ts': 984837600,
                'time': '2001-03-17T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          82:
              {
                'ts': 1002376800,
                'time': '2001-10-06T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          83:
              {
                'ts': 1016287200,
                'time': '2002-03-16T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          84:
              {
                'ts': 1033826400,
                'time': '2002-10-05T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          85:
              {
                'ts': 1047736800,
                'time': '2003-03-15T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          86:
              {
                'ts': 1065276000,
                'time': '2003-10-04T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          87:
              {
                'ts': 1079791200,
                'time': '2004-03-20T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          88:
              {
                'ts': 1096725600,
                'time': '2004-10-02T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          89:
              {
                'ts': 1111240800,
                'time': '2005-03-19T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          90:
              {
                'ts': 1128175200,
                'time': '2005-10-01T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          91:
              {
                'ts': 1142690400,
                'time': '2006-03-18T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          92:
              {
                'ts': 1159624800,
                'time': '2006-09-30T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          93:
              {
                'ts': 1174140000,
                'time': '2007-03-17T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          94:
              {
                'ts': 1191074400,
                'time': '2007-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          95:
              {
                'ts': 1207404000,
                'time': '2008-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          96:
              {
                'ts': 1222524000,
                'time': '2008-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          97:
              {
                'ts': 1238853600,
                'time': '2009-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          98:
              {
                'ts': 1253973600,
                'time': '2009-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          99:
              {
                'ts': 1270303200,
                'time': '2010-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          100:
              {
                'ts': 1285423200,
                'time': '2010-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          101:
              {
                'ts': 1301752800,
                'time': '2011-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          102:
              {
                'ts': 1316872800,
                'time': '2011-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          103:
              {
                'ts': 1333202400,
                'time': '2012-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          104:
              {
                'ts': 1348927200,
                'time': '2012-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          105:
              {
                'ts': 1365256800,
                'time': '2013-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          106:
              {
                'ts': 1380376800,
                'time': '2013-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          107:
              {
                'ts': 1396706400,
                'time': '2014-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          108:
              {
                'ts': 1411826400,
                'time': '2014-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          109:
              {
                'ts': 1428156000,
                'time': '2015-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          110:
              {
                'ts': 1443276000,
                'time': '2015-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          111:
              {
                'ts': 1459605600,
                'time': '2016-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          112:
              {
                'ts': 1474725600,
                'time': '2016-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          113:
              {
                'ts': 1491055200,
                'time': '2017-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          114:
              {
                'ts': 1506175200,
                'time': '2017-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          115:
              {
                'ts': 1522504800,
                'time': '2018-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          116:
              {
                'ts': 1538229600,
                'time': '2018-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          117:
              {
                'ts': 1554559200,
                'time': '2019-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          118:
              {
                'ts': 1569679200,
                'time': '2019-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          119:
              {
                'ts': 1586008800,
                'time': '2020-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          120:
              {
                'ts': 1601128800,
                'time': '2020-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          121:
              {
                'ts': 1617458400,
                'time': '2021-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          122:
              {
                'ts': 1632578400,
                'time': '2021-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          123:
              {
                'ts': 1648908000,
                'time': '2022-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          124:
              {
                'ts': 1664028000,
                'time': '2022-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          125:
              {
                'ts': 1680357600,
                'time': '2023-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          126:
              {
                'ts': 1695477600,
                'time': '2023-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          127:
              {
                'ts': 1712412000,
                'time': '2024-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          128:
              {
                'ts': 1727532000,
                'time': '2024-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          129:
              {
                'ts': 1743861600,
                'time': '2025-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          130:
              {
                'ts': 1758981600,
                'time': '2025-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          131:
              {
                'ts': 1775311200,
                'time': '2026-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          132:
              {
                'ts': 1790431200,
                'time': '2026-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          133:
              {
                'ts': 1806760800,
                'time': '2027-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          134:
              {
                'ts': 1821880800,
                'time': '2027-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          135:
              {
                'ts': 1838210400,
                'time': '2028-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          136:
              {
                'ts': 1853330400,
                'time': '2028-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          137:
              {
                'ts': 1869660000,
                'time': '2029-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          138:
              {
                'ts': 1885384800,
                'time': '2029-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          139:
              {
                'ts': 1901714400,
                'time': '2030-04-06T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          140:
              {
                'ts': 1916834400,
                'time': '2030-09-28T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          141:
              {
                'ts': 1933164000,
                'time': '2031-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          142:
              {
                'ts': 1948284000,
                'time': '2031-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          143:
              {
                'ts': 1964613600,
                'time': '2032-04-03T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          144:
              {
                'ts': 1979733600,
                'time': '2032-09-25T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          145:
              {
                'ts': 1996063200,
                'time': '2033-04-02T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          146:
              {
                'ts': 2011183200,
                'time': '2033-09-24T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          147:
              {
                'ts': 2027512800,
                'time': '2034-04-01T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          148:
              {
                'ts': 2042632800,
                'time': '2034-09-23T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          149:
              {
                'ts': 2058962400,
                'time': '2035-03-31T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          150:
              {
                'ts': 2074687200,
                'time': '2035-09-29T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          151:
              {
                'ts': 2091016800,
                'time': '2036-04-05T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          152:
              {
                'ts': 2106136800,
                'time': '2036-09-27T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              },
          153:
              {
                'ts': 2122466400,
                'time': '2037-04-04T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NZST'
              },
          154:
              {
                'ts': 2137586400,
                'time': '2037-09-26T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'NZDT'
              }
        },
    'Pacific/Chatham':
        {
          0:
              {
                'ts': -410271228,
                'time': '1956-12-31T11:46:12+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          1:
              {
                'ts': 152632800,
                'time': '1974-11-02T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          2:
              {
                'ts': 162309600,
                'time': '1975-02-22T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          3:
              {
                'ts': 183477600,
                'time': '1975-10-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          4:
              {
                'ts': 194968800,
                'time': '1976-03-06T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          5:
              {
                'ts': 215532000,
                'time': '1976-10-30T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          6:
              {
                'ts': 226418400,
                'time': '1977-03-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          7:
              {
                'ts': 246981600,
                'time': '1977-10-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          8:
              {
                'ts': 257868000,
                'time': '1978-03-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          9:
              {
                'ts': 278431200,
                'time': '1978-10-28T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          10:
              {
                'ts': 289317600,
                'time': '1979-03-03T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          11:
              {
                'ts': 309880800,
                'time': '1979-10-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          12:
              {
                'ts': 320767200,
                'time': '1980-03-01T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          13:
              {
                'ts': 341330400,
                'time': '1980-10-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          14:
              {
                'ts': 352216800,
                'time': '1981-02-28T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          15:
              {
                'ts': 372780000,
                'time': '1981-10-24T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          16:
              {
                'ts': 384271200,
                'time': '1982-03-06T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          17:
              {
                'ts': 404834400,
                'time': '1982-10-30T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          18:
              {
                'ts': 415720800,
                'time': '1983-03-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          19:
              {
                'ts': 436284000,
                'time': '1983-10-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          20:
              {
                'ts': 447170400,
                'time': '1984-03-03T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          21:
              {
                'ts': 467733600,
                'time': '1984-10-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          22:
              {
                'ts': 478620000,
                'time': '1985-03-02T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          23:
              {
                'ts': 499183200,
                'time': '1985-10-26T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          24:
              {
                'ts': 510069600,
                'time': '1986-03-01T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          25:
              {
                'ts': 530632800,
                'time': '1986-10-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          26:
              {
                'ts': 541519200,
                'time': '1987-02-28T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          27:
              {
                'ts': 562082400,
                'time': '1987-10-24T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          28:
              {
                'ts': 573573600,
                'time': '1988-03-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          29:
              {
                'ts': 594136800,
                'time': '1988-10-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          30:
              {
                'ts': 605023200,
                'time': '1989-03-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          31:
              {
                'ts': 623772000,
                'time': '1989-10-07T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          32:
              {
                'ts': 637682400,
                'time': '1990-03-17T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          33:
              {
                'ts': 655221600,
                'time': '1990-10-06T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          34:
              {
                'ts': 669132000,
                'time': '1991-03-16T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          35:
              {
                'ts': 686671200,
                'time': '1991-10-05T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          36:
              {
                'ts': 700581600,
                'time': '1992-03-14T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          37:
              {
                'ts': 718120800,
                'time': '1992-10-03T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          38:
              {
                'ts': 732636000,
                'time': '1993-03-20T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          39:
              {
                'ts': 749570400,
                'time': '1993-10-02T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          40:
              {
                'ts': 764085600,
                'time': '1994-03-19T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          41:
              {
                'ts': 781020000,
                'time': '1994-10-01T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          42:
              {
                'ts': 795535200,
                'time': '1995-03-18T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          43:
              {
                'ts': 812469600,
                'time': '1995-09-30T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          44:
              {
                'ts': 826984800,
                'time': '1996-03-16T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          45:
              {
                'ts': 844524000,
                'time': '1996-10-05T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          46:
              {
                'ts': 858434400,
                'time': '1997-03-15T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          47:
              {
                'ts': 875973600,
                'time': '1997-10-04T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          48:
              {
                'ts': 889884000,
                'time': '1998-03-14T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          49:
              {
                'ts': 907423200,
                'time': '1998-10-03T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          50:
              {
                'ts': 921938400,
                'time': '1999-03-20T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          51:
              {
                'ts': 938872800,
                'time': '1999-10-02T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          52:
              {
                'ts': 953388000,
                'time': '2000-03-18T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          53:
              {
                'ts': 970322400,
                'time': '2000-09-30T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          54:
              {
                'ts': 984837600,
                'time': '2001-03-17T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          55:
              {
                'ts': 1002376800,
                'time': '2001-10-06T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          56:
              {
                'ts': 1016287200,
                'time': '2002-03-16T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          57:
              {
                'ts': 1033826400,
                'time': '2002-10-05T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          58:
              {
                'ts': 1047736800,
                'time': '2003-03-15T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          59:
              {
                'ts': 1065276000,
                'time': '2003-10-04T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          60:
              {
                'ts': 1079791200,
                'time': '2004-03-20T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          61:
              {
                'ts': 1096725600,
                'time': '2004-10-02T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          62:
              {
                'ts': 1111240800,
                'time': '2005-03-19T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          63:
              {
                'ts': 1128175200,
                'time': '2005-10-01T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          64:
              {
                'ts': 1142690400,
                'time': '2006-03-18T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          65:
              {
                'ts': 1159624800,
                'time': '2006-09-30T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          66:
              {
                'ts': 1174140000,
                'time': '2007-03-17T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          67:
              {
                'ts': 1191074400,
                'time': '2007-09-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          68:
              {
                'ts': 1207404000,
                'time': '2008-04-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          69:
              {
                'ts': 1222524000,
                'time': '2008-09-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          70:
              {
                'ts': 1238853600,
                'time': '2009-04-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          71:
              {
                'ts': 1253973600,
                'time': '2009-09-26T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          72:
              {
                'ts': 1270303200,
                'time': '2010-04-03T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          73:
              {
                'ts': 1285423200,
                'time': '2010-09-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          74:
              {
                'ts': 1301752800,
                'time': '2011-04-02T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          75:
              {
                'ts': 1316872800,
                'time': '2011-09-24T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          76:
              {
                'ts': 1333202400,
                'time': '2012-03-31T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          77:
              {
                'ts': 1348927200,
                'time': '2012-09-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          78:
              {
                'ts': 1365256800,
                'time': '2013-04-06T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          79:
              {
                'ts': 1380376800,
                'time': '2013-09-28T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          80:
              {
                'ts': 1396706400,
                'time': '2014-04-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          81:
              {
                'ts': 1411826400,
                'time': '2014-09-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          82:
              {
                'ts': 1428156000,
                'time': '2015-04-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          83:
              {
                'ts': 1443276000,
                'time': '2015-09-26T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          84:
              {
                'ts': 1459605600,
                'time': '2016-04-02T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          85:
              {
                'ts': 1474725600,
                'time': '2016-09-24T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          86:
              {
                'ts': 1491055200,
                'time': '2017-04-01T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          87:
              {
                'ts': 1506175200,
                'time': '2017-09-23T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          88:
              {
                'ts': 1522504800,
                'time': '2018-03-31T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          89:
              {
                'ts': 1538229600,
                'time': '2018-09-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          90:
              {
                'ts': 1554559200,
                'time': '2019-04-06T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          91:
              {
                'ts': 1569679200,
                'time': '2019-09-28T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          92:
              {
                'ts': 1586008800,
                'time': '2020-04-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          93:
              {
                'ts': 1601128800,
                'time': '2020-09-26T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          94:
              {
                'ts': 1617458400,
                'time': '2021-04-03T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          95:
              {
                'ts': 1632578400,
                'time': '2021-09-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          96:
              {
                'ts': 1648908000,
                'time': '2022-04-02T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          97:
              {
                'ts': 1664028000,
                'time': '2022-09-24T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          98:
              {
                'ts': 1680357600,
                'time': '2023-04-01T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          99:
              {
                'ts': 1695477600,
                'time': '2023-09-23T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          100:
              {
                'ts': 1712412000,
                'time': '2024-04-06T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          101:
              {
                'ts': 1727532000,
                'time': '2024-09-28T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          102:
              {
                'ts': 1743861600,
                'time': '2025-04-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          103:
              {
                'ts': 1758981600,
                'time': '2025-09-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          104:
              {
                'ts': 1775311200,
                'time': '2026-04-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          105:
              {
                'ts': 1790431200,
                'time': '2026-09-26T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          106:
              {
                'ts': 1806760800,
                'time': '2027-04-03T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          107:
              {
                'ts': 1821880800,
                'time': '2027-09-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          108:
              {
                'ts': 1838210400,
                'time': '2028-04-01T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          109:
              {
                'ts': 1853330400,
                'time': '2028-09-23T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          110:
              {
                'ts': 1869660000,
                'time': '2029-03-31T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          111:
              {
                'ts': 1885384800,
                'time': '2029-09-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          112:
              {
                'ts': 1901714400,
                'time': '2030-04-06T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          113:
              {
                'ts': 1916834400,
                'time': '2030-09-28T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          114:
              {
                'ts': 1933164000,
                'time': '2031-04-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          115:
              {
                'ts': 1948284000,
                'time': '2031-09-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          116:
              {
                'ts': 1964613600,
                'time': '2032-04-03T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          117:
              {
                'ts': 1979733600,
                'time': '2032-09-25T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          118:
              {
                'ts': 1996063200,
                'time': '2033-04-02T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          119:
              {
                'ts': 2011183200,
                'time': '2033-09-24T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          120:
              {
                'ts': 2027512800,
                'time': '2034-04-01T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          121:
              {
                'ts': 2042632800,
                'time': '2034-09-23T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          122:
              {
                'ts': 2058962400,
                'time': '2035-03-31T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          123:
              {
                'ts': 2074687200,
                'time': '2035-09-29T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          124:
              {
                'ts': 2091016800,
                'time': '2036-04-05T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          125:
              {
                'ts': 2106136800,
                'time': '2036-09-27T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              },
          126:
              {
                'ts': 2122466400,
                'time': '2037-04-04T14:00:00+0000',
                'offset': 45900,
                'isdst': false,
                'abbr': 'CHAST'
              },
          127:
              {
                'ts': 2137586400,
                'time': '2037-09-26T14:00:00+0000',
                'offset': 49500,
                'isdst': true,
                'abbr': 'CHADT'
              }
        },
    'Pacific/Easter':
        {
          0:
              {
                'ts': -1178124152,
                'time': '1932-09-01T07:17:28+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          1:
              {
                'ts': -870552000,
                'time': '1942-06-01T04:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          2:
              {
                'ts': -865278000,
                'time': '1942-08-01T05:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          3:
              {
                'ts': -736376400,
                'time': '1946-09-01T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          4:
              {
                'ts': -36619200,
                'time': '1968-11-03T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          5:
              {
                'ts': -23922000,
                'time': '1969-03-30T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          6:
              {
                'ts': -3355200,
                'time': '1969-11-23T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          7:
              {
                'ts': 7527600,
                'time': '1970-03-29T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          8:
              {
                'ts': 24465600,
                'time': '1970-10-11T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          9:
              {
                'ts': 37767600,
                'time': '1971-03-14T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          10:
              {
                'ts': 55915200,
                'time': '1971-10-10T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          11:
              {
                'ts': 69217200,
                'time': '1972-03-12T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          12:
              {
                'ts': 87969600,
                'time': '1972-10-15T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          13:
              {
                'ts': 100666800,
                'time': '1973-03-11T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          14:
              {
                'ts': 118209600,
                'time': '1973-09-30T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          15:
              {
                'ts': 132116400,
                'time': '1974-03-10T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          16:
              {
                'ts': 150868800,
                'time': '1974-10-13T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          17:
              {
                'ts': 163566000,
                'time': '1975-03-09T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          18:
              {
                'ts': 182318400,
                'time': '1975-10-12T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          19:
              {
                'ts': 195620400,
                'time': '1976-03-14T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          20:
              {
                'ts': 213768000,
                'time': '1976-10-10T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          21:
              {
                'ts': 227070000,
                'time': '1977-03-13T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          22:
              {
                'ts': 245217600,
                'time': '1977-10-09T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          23:
              {
                'ts': 258519600,
                'time': '1978-03-12T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          24:
              {
                'ts': 277272000,
                'time': '1978-10-15T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          25:
              {
                'ts': 289969200,
                'time': '1979-03-11T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          26:
              {
                'ts': 308721600,
                'time': '1979-10-14T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          27:
              {
                'ts': 321418800,
                'time': '1980-03-09T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          28:
              {
                'ts': 340171200,
                'time': '1980-10-12T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          29:
              {
                'ts': 353473200,
                'time': '1981-03-15T03:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'EAST'
              },
          30:
              {
                'ts': 371620800,
                'time': '1981-10-11T04:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'EASST'
              },
          31:
              {
                'ts': 384922800,
                'time': '1982-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          32:
              {
                'ts': 403070400,
                'time': '1982-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          33:
              {
                'ts': 416372400,
                'time': '1983-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          34:
              {
                'ts': 434520000,
                'time': '1983-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          35:
              {
                'ts': 447822000,
                'time': '1984-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          36:
              {
                'ts': 466574400,
                'time': '1984-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          37:
              {
                'ts': 479271600,
                'time': '1985-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          38:
              {
                'ts': 498024000,
                'time': '1985-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          39:
              {
                'ts': 510721200,
                'time': '1986-03-09T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          40:
              {
                'ts': 529473600,
                'time': '1986-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          41:
              {
                'ts': 545194800,
                'time': '1987-04-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          42:
              {
                'ts': 560923200,
                'time': '1987-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          43:
              {
                'ts': 574225200,
                'time': '1988-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          44:
              {
                'ts': 591768000,
                'time': '1988-10-02T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          45:
              {
                'ts': 605674800,
                'time': '1989-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          46:
              {
                'ts': 624427200,
                'time': '1989-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          47:
              {
                'ts': 637729200,
                'time': '1990-03-18T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          48:
              {
                'ts': 653457600,
                'time': '1990-09-16T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          49:
              {
                'ts': 668574000,
                'time': '1991-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          50:
              {
                'ts': 687326400,
                'time': '1991-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          51:
              {
                'ts': 700628400,
                'time': '1992-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          52:
              {
                'ts': 718776000,
                'time': '1992-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          53:
              {
                'ts': 732078000,
                'time': '1993-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          54:
              {
                'ts': 750225600,
                'time': '1993-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          55:
              {
                'ts': 763527600,
                'time': '1994-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          56:
              {
                'ts': 781675200,
                'time': '1994-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          57:
              {
                'ts': 794977200,
                'time': '1995-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          58:
              {
                'ts': 813729600,
                'time': '1995-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          59:
              {
                'ts': 826426800,
                'time': '1996-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          60:
              {
                'ts': 845179200,
                'time': '1996-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          61:
              {
                'ts': 859690800,
                'time': '1997-03-30T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          62:
              {
                'ts': 876628800,
                'time': '1997-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          63:
              {
                'ts': 889930800,
                'time': '1998-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          64:
              {
                'ts': 906868800,
                'time': '1998-09-27T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          65:
              {
                'ts': 923194800,
                'time': '1999-04-04T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          66:
              {
                'ts': 939528000,
                'time': '1999-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          67:
              {
                'ts': 952830000,
                'time': '2000-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          68:
              {
                'ts': 971582400,
                'time': '2000-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          69:
              {
                'ts': 984279600,
                'time': '2001-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          70:
              {
                'ts': 1003032000,
                'time': '2001-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          71:
              {
                'ts': 1015729200,
                'time': '2002-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          72:
              {
                'ts': 1034481600,
                'time': '2002-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          73:
              {
                'ts': 1047178800,
                'time': '2003-03-09T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          74:
              {
                'ts': 1065931200,
                'time': '2003-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          75:
              {
                'ts': 1079233200,
                'time': '2004-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          76:
              {
                'ts': 1097380800,
                'time': '2004-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          77:
              {
                'ts': 1110682800,
                'time': '2005-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          78:
              {
                'ts': 1128830400,
                'time': '2005-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          79:
              {
                'ts': 1142132400,
                'time': '2006-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          80:
              {
                'ts': 1160884800,
                'time': '2006-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          81:
              {
                'ts': 1173582000,
                'time': '2007-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          82:
              {
                'ts': 1192334400,
                'time': '2007-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          83:
              {
                'ts': 1206846000,
                'time': '2008-03-30T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          84:
              {
                'ts': 1223784000,
                'time': '2008-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          85:
              {
                'ts': 1237086000,
                'time': '2009-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          86:
              {
                'ts': 1255233600,
                'time': '2009-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          87:
              {
                'ts': 1268535600,
                'time': '2010-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          88:
              {
                'ts': 1286683200,
                'time': '2010-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          89:
              {
                'ts': 1299985200,
                'time': '2011-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          90:
              {
                'ts': 1318132800,
                'time': '2011-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          91:
              {
                'ts': 1331434800,
                'time': '2012-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          92:
              {
                'ts': 1350187200,
                'time': '2012-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          93:
              {
                'ts': 1362884400,
                'time': '2013-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          94:
              {
                'ts': 1381636800,
                'time': '2013-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          95:
              {
                'ts': 1394334000,
                'time': '2014-03-09T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          96:
              {
                'ts': 1413086400,
                'time': '2014-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          97:
              {
                'ts': 1426388400,
                'time': '2015-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          98:
              {
                'ts': 1444536000,
                'time': '2015-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          99:
              {
                'ts': 1457838000,
                'time': '2016-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          100:
              {
                'ts': 1475985600,
                'time': '2016-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          101:
              {
                'ts': 1489287600,
                'time': '2017-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          102:
              {
                'ts': 1508040000,
                'time': '2017-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          103:
              {
                'ts': 1520737200,
                'time': '2018-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          104:
              {
                'ts': 1539489600,
                'time': '2018-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          105:
              {
                'ts': 1552186800,
                'time': '2019-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          106:
              {
                'ts': 1570939200,
                'time': '2019-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          107:
              {
                'ts': 1584241200,
                'time': '2020-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          108:
              {
                'ts': 1602388800,
                'time': '2020-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          109:
              {
                'ts': 1615690800,
                'time': '2021-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          110:
              {
                'ts': 1633838400,
                'time': '2021-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          111:
              {
                'ts': 1647140400,
                'time': '2022-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          112:
              {
                'ts': 1665288000,
                'time': '2022-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          113:
              {
                'ts': 1678590000,
                'time': '2023-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          114:
              {
                'ts': 1697342400,
                'time': '2023-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          115:
              {
                'ts': 1710039600,
                'time': '2024-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          116:
              {
                'ts': 1728792000,
                'time': '2024-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          117:
              {
                'ts': 1741489200,
                'time': '2025-03-09T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          118:
              {
                'ts': 1760241600,
                'time': '2025-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          119:
              {
                'ts': 1773543600,
                'time': '2026-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          120:
              {
                'ts': 1791691200,
                'time': '2026-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          121:
              {
                'ts': 1804993200,
                'time': '2027-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          122:
              {
                'ts': 1823140800,
                'time': '2027-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          123:
              {
                'ts': 1836442800,
                'time': '2028-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          124:
              {
                'ts': 1855195200,
                'time': '2028-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          125:
              {
                'ts': 1867892400,
                'time': '2029-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          126:
              {
                'ts': 1886644800,
                'time': '2029-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          127:
              {
                'ts': 1899342000,
                'time': '2030-03-10T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          128:
              {
                'ts': 1918094400,
                'time': '2030-10-13T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          129:
              {
                'ts': 1930791600,
                'time': '2031-03-09T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          130:
              {
                'ts': 1949544000,
                'time': '2031-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          131:
              {
                'ts': 1962846000,
                'time': '2032-03-14T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          132:
              {
                'ts': 1980993600,
                'time': '2032-10-10T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          133:
              {
                'ts': 1994295600,
                'time': '2033-03-13T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          134:
              {
                'ts': 2012443200,
                'time': '2033-10-09T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          135:
              {
                'ts': 2025745200,
                'time': '2034-03-12T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          136:
              {
                'ts': 2044497600,
                'time': '2034-10-15T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          137:
              {
                'ts': 2057194800,
                'time': '2035-03-11T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          138:
              {
                'ts': 2075947200,
                'time': '2035-10-14T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          139:
              {
                'ts': 2088644400,
                'time': '2036-03-09T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          140:
              {
                'ts': 2107396800,
                'time': '2036-10-12T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              },
          141:
              {
                'ts': 2120698800,
                'time': '2037-03-15T03:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'EAST'
              },
          142:
              {
                'ts': 2138846400,
                'time': '2037-10-11T04:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'EASST'
              }
        },
    'Pacific/Efate':
        {
          0:
              {
                'ts': -1829387596,
                'time': '1912-01-12T12:46:44+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'VUT'
              },
          1:
              {
                'ts': 433256400,
                'time': '1983-09-24T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'VUST'
              },
          2:
              {
                'ts': 448977600,
                'time': '1984-03-24T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'VUT'
              },
          3:
              {
                'ts': 467298000,
                'time': '1984-10-22T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'VUST'
              },
          4:
              {
                'ts': 480427200,
                'time': '1985-03-23T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'VUT'
              },
          5:
              {
                'ts': 496760400,
                'time': '1985-09-28T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'VUST'
              },
          6:
              {
                'ts': 511876800,
                'time': '1986-03-22T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'VUT'
              },
          7:
              {
                'ts': 528210000,
                'time': '1986-09-27T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'VUST'
              },
          8:
              {
                'ts': 543931200,
                'time': '1987-03-28T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'VUT'
              },
          9:
              {
                'ts': 559659600,
                'time': '1987-09-26T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'VUST'
              },
          10:
              {
                'ts': 575380800,
                'time': '1988-03-26T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'VUT'
              },
          11:
              {
                'ts': 591109200,
                'time': '1988-09-24T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'VUST'
              },
          12:
              {
                'ts': 606830400,
                'time': '1989-03-25T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'VUT'
              },
          13:
              {
                'ts': 622558800,
                'time': '1989-09-23T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'VUST'
              },
          14:
              {
                'ts': 638280000,
                'time': '1990-03-24T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'VUT'
              },
          15:
              {
                'ts': 654008400,
                'time': '1990-09-22T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'VUST'
              },
          16:
              {
                'ts': 669729600,
                'time': '1991-03-23T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'VUT'
              },
          17:
              {
                'ts': 686062800,
                'time': '1991-09-28T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'VUST'
              },
          18:
              {
                'ts': 696340800,
                'time': '1992-01-25T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'VUT'
              },
          19:
              {
                'ts': 719931600,
                'time': '1992-10-24T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'VUST'
              },
          20:
              {
                'ts': 727790400,
                'time': '1993-01-23T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'VUT'
              }
        },
    'Pacific/Enderbury':
        {
          0:
              {
                'ts': 307627200,
                'time': '1979-10-01T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'PHOT'
              },
          1:
              {
                'ts': 788958000,
                'time': '1995-01-01T11:00:00+0000',
                'offset': 46800,
                'isdst': false,
                'abbr': 'PHOT'
              }
        },
    'Pacific/Fakaofo':
        {
        },
    'Pacific/Fiji':
        {
          0:
              {
                'ts': -1709985220,
                'time': '1915-10-25T12:06:20+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'FJT'
              },
          1:
              {
                'ts': 909842400,
                'time': '1998-10-31T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'FJST'
              },
          2:
              {
                'ts': 920124000,
                'time': '1999-02-27T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'FJT'
              },
          3:
              {
                'ts': 941896800,
                'time': '1999-11-06T14:00:00+0000',
                'offset': 46800,
                'isdst': true,
                'abbr': 'FJST'
              },
          4:
              {
                'ts': 951573600,
                'time': '2000-02-26T14:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'FJT'
              }
        },
    'Pacific/Funafuti':
        {
        },
    'Pacific/Galapagos':
        {
          0:
              {
                'ts': -1230746496,
                'time': '1931-01-01T05:58:24+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'ECT'
              },
          1:
              {
                'ts': 504939600,
                'time': '1986-01-01T05:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'GALT'
              }
        },
    'Pacific/Gambier':
        {
          0:
              {
                'ts': -1806678012,
                'time': '1912-10-01T08:59:48+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'GAMT'
              }
        },
    'Pacific/Guadalcanal':
        {
          0:
              {
                'ts': -1806748788,
                'time': '1912-09-30T13:20:12+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'SBT'
              }
        },
    'Pacific/Guam':
        {
          0:
              {
                'ts': 977493600,
                'time': '2000-12-22T14:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'ChST'
              }
        },
    'Pacific/Honolulu':
        {
          0:
              {
                'ts': -1157283000,
                'time': '1933-04-30T12:30:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'HDT'
              },
          1:
              {
                'ts': -1155472200,
                'time': '1933-05-21T11:30:00+0000',
                'offset': -37800,
                'isdst': false,
                'abbr': 'HST'
              },
          2:
              {
                'ts': -880198200,
                'time': '1942-02-09T12:30:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'HWT'
              },
          3:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'HPT'
              },
          4:
              {
                'ts': -765376200,
                'time': '1945-09-30T11:30:00+0000',
                'offset': -37800,
                'isdst': false,
                'abbr': 'HST'
              },
          5:
              {
                'ts': -712150200,
                'time': '1947-06-08T12:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HST'
              }
        },
    'Pacific/Johnston':
        {
        },
    'Pacific/Kiritimati':
        {
          0:
              {
                'ts': 307622400,
                'time': '1979-10-01T10:40:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'LINT'
              },
          1:
              {
                'ts': 788954400,
                'time': '1995-01-01T10:00:00+0000',
                'offset': 50400,
                'isdst': false,
                'abbr': 'LINT'
              }
        },
    'Pacific/Kosrae':
        {
          0:
              {
                'ts': -7988400,
                'time': '1969-09-30T13:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'KOST'
              },
          1:
              {
                'ts': 915105600,
                'time': '1998-12-31T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'KOST'
              }
        },
    'Pacific/Kwajalein':
        {
          0:
              {
                'ts': -7988400,
                'time': '1969-09-30T13:00:00+0000',
                'offset': -43200,
                'isdst': false,
                'abbr': 'KWAT'
              },
          1:
              {
                'ts': 745848000,
                'time': '1993-08-20T12:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'MHT'
              }
        },
    'Pacific/Majuro':
        {
          0:
              {
                'ts': -7988400,
                'time': '1969-09-30T13:00:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'MHT'
              }
        },
    'Pacific/Marquesas':
        {
          0:
              {
                'ts': -1806676920,
                'time': '1912-10-01T09:18:00+0000',
                'offset': -34200,
                'isdst': false,
                'abbr': 'MART'
              }
        },
    'Pacific/Midway':
        {
          0:
              {
                'ts': -428504400,
                'time': '1956-06-03T11:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'NDT'
              },
          1:
              {
                'ts': -420645600,
                'time': '1956-09-02T10:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'NST'
              },
          2:
              {
                'ts': -86878800,
                'time': '1967-04-01T11:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          3:
              {
                'ts': 439038000,
                'time': '1983-11-30T11:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'SST'
              }
        },
    'Pacific/Nauru':
        {
          0:
              {
                'ts': -1545131260,
                'time': '1921-01-14T12:52:20+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NRT'
              },
          1:
              {
                'ts': -877347000,
                'time': '1942-03-14T12:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          2:
              {
                'ts': -800960400,
                'time': '1944-08-14T15:00:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NRT'
              },
          3:
              {
                'ts': 294323400,
                'time': '1979-04-30T12:30:00+0000',
                'offset': 43200,
                'isdst': false,
                'abbr': 'NRT'
              }
        },
    'Pacific/Niue':
        {
          0:
              {
                'ts': -599575200,
                'time': '1951-01-01T11:20:00+0000',
                'offset': -41400,
                'isdst': false,
                'abbr': 'NUT'
              },
          1:
              {
                'ts': 276089400,
                'time': '1978-10-01T11:30:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'NUT'
              }
        },
    'Pacific/Norfolk':
        {
          0:
              {
                'ts': -599656320,
                'time': '1950-12-31T12:48:00+0000',
                'offset': 41400,
                'isdst': false,
                'abbr': 'NFT'
              }
        },
    'Pacific/Noumea':
        {
          0:
              {
                'ts': -1829387148,
                'time': '1912-01-12T12:54:12+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'NCT'
              },
          1:
              {
                'ts': 250002000,
                'time': '1977-12-03T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NCST'
              },
          2:
              {
                'ts': 257342400,
                'time': '1978-02-26T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'NCT'
              },
          3:
              {
                'ts': 281451600,
                'time': '1978-12-02T13:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NCST'
              },
          4:
              {
                'ts': 288878400,
                'time': '1979-02-26T12:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'NCT'
              },
          5:
              {
                'ts': 849366000,
                'time': '1996-11-30T15:00:00+0000',
                'offset': 43200,
                'isdst': true,
                'abbr': 'NCST'
              },
          6:
              {
                'ts': 857228400,
                'time': '1997-03-01T15:00:00+0000',
                'offset': 39600,
                'isdst': false,
                'abbr': 'NCT'
              }
        },
    'Pacific/Pago_Pago':
        {
          0:
              {
                'ts': -1861879032,
                'time': '1911-01-01T11:22:48+0000',
                'offset': -41400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          1:
              {
                'ts': -631110600,
                'time': '1950-01-01T11:30:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'NST'
              },
          2:
              {
                'ts': -86878800,
                'time': '1967-04-01T11:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          3:
              {
                'ts': 439038000,
                'time': '1983-11-30T11:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'SST'
              }
        },
    'Pacific/Palau':
        {
        },
    'Pacific/Pitcairn':
        {
          0:
              {
                'ts': 893665800,
                'time': '1998-04-27T08:30:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'Pacific/Ponape':
        {
        },
    'Pacific/Port_Moresby':
        {
        },
    'Pacific/Rarotonga':
        {
          0:
              {
                'ts': 279714600,
                'time': '1978-11-12T10:30:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          1:
              {
                'ts': 289387800,
                'time': '1979-03-04T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              },
          2:
              {
                'ts': 309952800,
                'time': '1979-10-28T10:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          3:
              {
                'ts': 320837400,
                'time': '1980-03-02T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              },
          4:
              {
                'ts': 341402400,
                'time': '1980-10-26T10:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          5:
              {
                'ts': 352287000,
                'time': '1981-03-01T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              },
          6:
              {
                'ts': 372852000,
                'time': '1981-10-25T10:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          7:
              {
                'ts': 384341400,
                'time': '1982-03-07T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              },
          8:
              {
                'ts': 404906400,
                'time': '1982-10-31T10:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          9:
              {
                'ts': 415791000,
                'time': '1983-03-06T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              },
          10:
              {
                'ts': 436356000,
                'time': '1983-10-30T10:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          11:
              {
                'ts': 447240600,
                'time': '1984-03-04T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              },
          12:
              {
                'ts': 467805600,
                'time': '1984-10-28T10:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          13:
              {
                'ts': 478690200,
                'time': '1985-03-03T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              },
          14:
              {
                'ts': 499255200,
                'time': '1985-10-27T10:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          15:
              {
                'ts': 510139800,
                'time': '1986-03-02T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              },
          16:
              {
                'ts': 530704800,
                'time': '1986-10-26T10:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          17:
              {
                'ts': 541589400,
                'time': '1987-03-01T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              },
          18:
              {
                'ts': 562154400,
                'time': '1987-10-25T10:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          19:
              {
                'ts': 573643800,
                'time': '1988-03-06T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              },
          20:
              {
                'ts': 594208800,
                'time': '1988-10-30T10:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          21:
              {
                'ts': 605093400,
                'time': '1989-03-05T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              },
          22:
              {
                'ts': 625658400,
                'time': '1989-10-29T10:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          23:
              {
                'ts': 636543000,
                'time': '1990-03-04T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              },
          24:
              {
                'ts': 657108000,
                'time': '1990-10-28T10:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'CKHST'
              },
          25:
              {
                'ts': 667992600,
                'time': '1991-03-03T09:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CKT'
              }
        },
    'Pacific/Saipan':
        {
          0:
              {
                'ts': -7981200,
                'time': '1969-09-30T15:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'MPT'
              },
          1:
              {
                'ts': 977493600,
                'time': '2000-12-22T14:00:00+0000',
                'offset': 36000,
                'isdst': false,
                'abbr': 'ChST'
              }
        },
    'Pacific/Samoa':
        {
          0:
              {
                'ts': -1861879032,
                'time': '1911-01-01T11:22:48+0000',
                'offset': -41400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          1:
              {
                'ts': -631110600,
                'time': '1950-01-01T11:30:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'NST'
              },
          2:
              {
                'ts': -86878800,
                'time': '1967-04-01T11:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          3:
              {
                'ts': 439038000,
                'time': '1983-11-30T11:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'SST'
              }
        },
    'Pacific/Tahiti':
        {
          0:
              {
                'ts': -1806674504,
                'time': '1912-10-01T09:58:16+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'TAHT'
              }
        },
    'Pacific/Tarawa':
        {
        },
    'Pacific/Tongatapu':
        {
          0:
              {
                'ts': -915193200,
                'time': '1940-12-31T11:40:00+0000',
                'offset': 46800,
                'isdst': false,
                'abbr': 'TOT'
              },
          1:
              {
                'ts': 939214800,
                'time': '1999-10-06T13:00:00+0000',
                'offset': 50400,
                'isdst': true,
                'abbr': 'TOST'
              },
          2:
              {
                'ts': 953384400,
                'time': '2000-03-18T13:00:00+0000',
                'offset': 46800,
                'isdst': false,
                'abbr': 'TOT'
              },
          3:
              {
                'ts': 973342800,
                'time': '2000-11-04T13:00:00+0000',
                'offset': 50400,
                'isdst': true,
                'abbr': 'TOST'
              },
          4:
              {
                'ts': 980596800,
                'time': '2001-01-27T12:00:00+0000',
                'offset': 46800,
                'isdst': false,
                'abbr': 'TOT'
              },
          5:
              {
                'ts': 1004792400,
                'time': '2001-11-03T13:00:00+0000',
                'offset': 50400,
                'isdst': true,
                'abbr': 'TOST'
              },
          6:
              {
                'ts': 1012046400,
                'time': '2002-01-26T12:00:00+0000',
                'offset': 46800,
                'isdst': false,
                'abbr': 'TOT'
              }
        },
    'Pacific/Truk':
        {
        },
    'Pacific/Wake':
        {
        },
    'Pacific/Wallis':
        {
        },
    'Pacific/Yap':
        {
        },
    'Poland':
        {
          0:
              {
                'ts': -1717032240,
                'time': '1915-08-04T22:36:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          1:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          2:
              {
                'ts': -1680483600,
                'time': '1916-09-30T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          3:
              {
                'ts': -1663455600,
                'time': '1917-04-16T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          4:
              {
                'ts': -1650150000,
                'time': '1917-09-17T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          5:
              {
                'ts': -1632006000,
                'time': '1918-04-15T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          6:
              {
                'ts': -1618700400,
                'time': '1918-09-16T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': -1600473600,
                'time': '1919-04-15T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': -1587168000,
                'time': '1919-09-16T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': -1501725600,
                'time': '1922-05-31T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          10:
              {
                'ts': -931734000,
                'time': '1940-06-23T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          11:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          12:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          13:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          14:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          15:
              {
                'ts': -796874400,
                'time': '1944-09-30T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          16:
              {
                'ts': -796608000,
                'time': '1944-10-04T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          17:
              {
                'ts': -778726800,
                'time': '1945-04-28T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          18:
              {
                'ts': -762660000,
                'time': '1945-10-31T22:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          19:
              {
                'ts': -748486800,
                'time': '1946-04-13T23:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          20:
              {
                'ts': -733273200,
                'time': '1946-10-07T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          21:
              {
                'ts': -715215600,
                'time': '1947-05-04T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          22:
              {
                'ts': -701910000,
                'time': '1947-10-05T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          23:
              {
                'ts': -684975600,
                'time': '1948-04-18T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          24:
              {
                'ts': -670460400,
                'time': '1948-10-03T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          25:
              {
                'ts': -654130800,
                'time': '1949-04-10T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          26:
              {
                'ts': -639010800,
                'time': '1949-10-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          27:
              {
                'ts': -397094400,
                'time': '1957-06-02T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          28:
              {
                'ts': -386812800,
                'time': '1957-09-29T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          29:
              {
                'ts': -371088000,
                'time': '1958-03-30T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          30:
              {
                'ts': -355363200,
                'time': '1958-09-28T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          31:
              {
                'ts': -334195200,
                'time': '1959-05-31T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          32:
              {
                'ts': -323308800,
                'time': '1959-10-04T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          33:
              {
                'ts': -307584000,
                'time': '1960-04-03T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          34:
              {
                'ts': -291859200,
                'time': '1960-10-02T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          35:
              {
                'ts': -271296000,
                'time': '1961-05-28T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          36:
              {
                'ts': -260409600,
                'time': '1961-10-01T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          37:
              {
                'ts': -239846400,
                'time': '1962-05-27T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          38:
              {
                'ts': -228960000,
                'time': '1962-09-30T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          39:
              {
                'ts': -208396800,
                'time': '1963-05-26T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          40:
              {
                'ts': -197510400,
                'time': '1963-09-29T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          41:
              {
                'ts': -176342400,
                'time': '1964-05-31T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          42:
              {
                'ts': -166060800,
                'time': '1964-09-27T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          43:
              {
                'ts': 220921200,
                'time': '1976-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          44:
              {
                'ts': 228873600,
                'time': '1977-04-03T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          45:
              {
                'ts': 243993600,
                'time': '1977-09-25T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          46:
              {
                'ts': 260323200,
                'time': '1978-04-02T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          47:
              {
                'ts': 276048000,
                'time': '1978-10-01T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          48:
              {
                'ts': 291772800,
                'time': '1979-04-01T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          49:
              {
                'ts': 307497600,
                'time': '1979-09-30T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          50:
              {
                'ts': 323827200,
                'time': '1980-04-06T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          51:
              {
                'ts': 338947200,
                'time': '1980-09-28T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          52:
              {
                'ts': 354672000,
                'time': '1981-03-29T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          53:
              {
                'ts': 370396800,
                'time': '1981-09-27T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': 386121600,
                'time': '1982-03-28T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': 401846400,
                'time': '1982-09-26T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          56:
              {
                'ts': 417571200,
                'time': '1983-03-27T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          57:
              {
                'ts': 433296000,
                'time': '1983-09-25T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          58:
              {
                'ts': 449020800,
                'time': '1984-03-25T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          59:
              {
                'ts': 465350400,
                'time': '1984-09-30T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          60:
              {
                'ts': 481075200,
                'time': '1985-03-31T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          61:
              {
                'ts': 496800000,
                'time': '1985-09-29T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          62:
              {
                'ts': 512524800,
                'time': '1986-03-30T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          63:
              {
                'ts': 528249600,
                'time': '1986-09-28T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          64:
              {
                'ts': 543974400,
                'time': '1987-03-29T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          65:
              {
                'ts': 559699200,
                'time': '1987-09-27T00:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          66:
              {
                'ts': 567990000,
                'time': '1987-12-31T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          141:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          142:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          143:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          144:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          145:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          146:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          147:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          148:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          149:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          150:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          151:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          152:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          153:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          154:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          155:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          156:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          157:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          158:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          159:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          160:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          161:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          162:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          163:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          164:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          165:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          166:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Portugal':
        {
          0:
              {
                'ts': -1830381808,
                'time': '1912-01-01T00:36:32+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          1:
              {
                'ts': -1689555600,
                'time': '1916-06-17T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          2:
              {
                'ts': -1677801600,
                'time': '1916-11-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          3:
              {
                'ts': -1667437200,
                'time': '1917-02-28T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          4:
              {
                'ts': -1647738000,
                'time': '1917-10-14T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          5:
              {
                'ts': -1635814800,
                'time': '1918-03-01T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          6:
              {
                'ts': -1616202000,
                'time': '1918-10-14T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          7:
              {
                'ts': -1604365200,
                'time': '1919-02-28T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          8:
              {
                'ts': -1584666000,
                'time': '1919-10-14T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          9:
              {
                'ts': -1572742800,
                'time': '1920-02-29T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          10:
              {
                'ts': -1553043600,
                'time': '1920-10-14T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          11:
              {
                'ts': -1541206800,
                'time': '1921-02-28T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          12:
              {
                'ts': -1521507600,
                'time': '1921-10-14T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          13:
              {
                'ts': -1442451600,
                'time': '1924-04-16T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          14:
              {
                'ts': -1426813200,
                'time': '1924-10-14T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          15:
              {
                'ts': -1379293200,
                'time': '1926-04-17T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          16:
              {
                'ts': -1364778000,
                'time': '1926-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          17:
              {
                'ts': -1348448400,
                'time': '1927-04-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          18:
              {
                'ts': -1333328400,
                'time': '1927-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          19:
              {
                'ts': -1316394000,
                'time': '1928-04-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          20:
              {
                'ts': -1301274000,
                'time': '1928-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          21:
              {
                'ts': -1284339600,
                'time': '1929-04-20T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          22:
              {
                'ts': -1269824400,
                'time': '1929-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          23:
              {
                'ts': -1221440400,
                'time': '1931-04-18T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          24:
              {
                'ts': -1206925200,
                'time': '1931-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          25:
              {
                'ts': -1191200400,
                'time': '1932-04-02T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          26:
              {
                'ts': -1175475600,
                'time': '1932-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          27:
              {
                'ts': -1127696400,
                'time': '1934-04-07T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          28:
              {
                'ts': -1111971600,
                'time': '1934-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          29:
              {
                'ts': -1096851600,
                'time': '1935-03-30T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          30:
              {
                'ts': -1080522000,
                'time': '1935-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          31:
              {
                'ts': -1063587600,
                'time': '1936-04-18T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          32:
              {
                'ts': -1049072400,
                'time': '1936-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          33:
              {
                'ts': -1033347600,
                'time': '1937-04-03T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          34:
              {
                'ts': -1017622800,
                'time': '1937-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          35:
              {
                'ts': -1002502800,
                'time': '1938-03-26T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          36:
              {
                'ts': -986173200,
                'time': '1938-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          37:
              {
                'ts': -969238800,
                'time': '1939-04-15T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          38:
              {
                'ts': -950490000,
                'time': '1939-11-18T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          39:
              {
                'ts': -942022800,
                'time': '1940-02-24T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          40:
              {
                'ts': -922669200,
                'time': '1940-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          41:
              {
                'ts': -906944400,
                'time': '1941-04-05T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          42:
              {
                'ts': -891133200,
                'time': '1941-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          43:
              {
                'ts': -877309200,
                'time': '1942-03-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          44:
              {
                'ts': -873684000,
                'time': '1942-04-25T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          45:
              {
                'ts': -864007200,
                'time': '1942-08-15T22:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          46:
              {
                'ts': -857955600,
                'time': '1942-10-24T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          47:
              {
                'ts': -845859600,
                'time': '1943-03-13T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          48:
              {
                'ts': -842839200,
                'time': '1943-04-17T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          49:
              {
                'ts': -831348000,
                'time': '1943-08-28T22:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          50:
              {
                'ts': -825901200,
                'time': '1943-10-30T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          51:
              {
                'ts': -814410000,
                'time': '1944-03-11T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          52:
              {
                'ts': -810784800,
                'time': '1944-04-22T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          53:
              {
                'ts': -799898400,
                'time': '1944-08-26T22:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          54:
              {
                'ts': -794451600,
                'time': '1944-10-28T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          55:
              {
                'ts': -782960400,
                'time': '1945-03-10T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          56:
              {
                'ts': -779335200,
                'time': '1945-04-21T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          57:
              {
                'ts': -768448800,
                'time': '1945-08-25T22:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          58:
              {
                'ts': -763002000,
                'time': '1945-10-27T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          59:
              {
                'ts': -749091600,
                'time': '1946-04-06T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          60:
              {
                'ts': -733366800,
                'time': '1946-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          61:
              {
                'ts': -717631200,
                'time': '1947-04-06T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          62:
              {
                'ts': -701906400,
                'time': '1947-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          63:
              {
                'ts': -686181600,
                'time': '1948-04-04T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          64:
              {
                'ts': -670456800,
                'time': '1948-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          65:
              {
                'ts': -654732000,
                'time': '1949-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          66:
              {
                'ts': -639007200,
                'time': '1949-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          67:
              {
                'ts': -591832800,
                'time': '1951-04-01T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          68:
              {
                'ts': -575503200,
                'time': '1951-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          69:
              {
                'ts': -559778400,
                'time': '1952-04-06T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          70:
              {
                'ts': -544053600,
                'time': '1952-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          71:
              {
                'ts': -528328800,
                'time': '1953-04-05T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          72:
              {
                'ts': -512604000,
                'time': '1953-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          73:
              {
                'ts': -496879200,
                'time': '1954-04-04T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          74:
              {
                'ts': -481154400,
                'time': '1954-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          75:
              {
                'ts': -465429600,
                'time': '1955-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          76:
              {
                'ts': -449704800,
                'time': '1955-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          77:
              {
                'ts': -433980000,
                'time': '1956-04-01T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          78:
              {
                'ts': -417650400,
                'time': '1956-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          79:
              {
                'ts': -401925600,
                'time': '1957-04-07T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          80:
              {
                'ts': -386200800,
                'time': '1957-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          81:
              {
                'ts': -370476000,
                'time': '1958-04-06T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          82:
              {
                'ts': -354751200,
                'time': '1958-10-05T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          83:
              {
                'ts': -339026400,
                'time': '1959-04-05T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          84:
              {
                'ts': -323301600,
                'time': '1959-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          85:
              {
                'ts': -307576800,
                'time': '1960-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          86:
              {
                'ts': -291852000,
                'time': '1960-10-02T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          87:
              {
                'ts': -276127200,
                'time': '1961-04-02T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          88:
              {
                'ts': -260402400,
                'time': '1961-10-01T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          89:
              {
                'ts': -244677600,
                'time': '1962-04-01T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          90:
              {
                'ts': -228348000,
                'time': '1962-10-07T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          91:
              {
                'ts': -212623200,
                'time': '1963-04-07T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          92:
              {
                'ts': -196898400,
                'time': '1963-10-06T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          93:
              {
                'ts': -181173600,
                'time': '1964-04-05T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          94:
              {
                'ts': -165448800,
                'time': '1964-10-04T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          95:
              {
                'ts': -149724000,
                'time': '1965-04-04T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          96:
              {
                'ts': -133999200,
                'time': '1965-10-03T02:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          97:
              {
                'ts': -118274400,
                'time': '1966-04-03T02:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          98:
              {
                'ts': 212544000,
                'time': '1976-09-26T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          99:
              {
                'ts': 228268800,
                'time': '1977-03-27T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          100:
              {
                'ts': 243993600,
                'time': '1977-09-25T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          101:
              {
                'ts': 260323200,
                'time': '1978-04-02T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          102:
              {
                'ts': 276048000,
                'time': '1978-10-01T00:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          103:
              {
                'ts': 291772800,
                'time': '1979-04-01T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          104:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          105:
              {
                'ts': 323222400,
                'time': '1980-03-30T00:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          106:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          107:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          108:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          109:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          110:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          111:
              {
                'ts': 417578400,
                'time': '1983-03-27T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          112:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          113:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          114:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          115:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          116:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          117:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          118:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          119:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          120:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          121:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          122:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          123:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          124:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          125:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          126:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          127:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          128:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          129:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          130:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          138:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          139:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          140:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          141:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          142:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          143:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          144:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          145:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          146:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          147:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          148:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          149:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          150:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          151:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          152:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          153:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          154:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          155:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          156:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          157:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          158:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          159:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          160:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          161:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          162:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          163:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          164:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          165:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          166:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          167:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          168:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          169:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          170:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          171:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          172:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          173:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          174:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          175:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          176:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          177:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          178:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          179:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          180:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          181:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          182:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          183:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          184:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          185:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          186:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          187:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          188:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          189:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          190:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          191:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          192:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          193:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          194:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          195:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          196:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          197:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          198:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          199:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          200:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          201:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          202:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          203:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          204:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          205:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          206:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          207:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          208:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          209:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          210:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          211:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          212:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          213:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          214:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          215:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          216:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          217:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          218:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          219:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          220:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              }
        },
    'PRC':
        {
          0:
              {
                'ts': -1325491552,
                'time': '1927-12-31T15:54:08+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -933494400,
                'time': '1940-06-02T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          2:
              {
                'ts': -923130000,
                'time': '1940-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          3:
              {
                'ts': -908784000,
                'time': '1941-03-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          4:
              {
                'ts': -891594000,
                'time': '1941-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          5:
              {
                'ts': 515520000,
                'time': '1986-05-03T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          6:
              {
                'ts': 527007600,
                'time': '1986-09-13T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': 545155200,
                'time': '1987-04-11T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': 558457200,
                'time': '1987-09-12T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': 576604800,
                'time': '1988-04-09T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': 589906800,
                'time': '1988-09-10T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': 608659200,
                'time': '1989-04-15T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': 621961200,
                'time': '1989-09-16T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': 640108800,
                'time': '1990-04-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': 653410800,
                'time': '1990-09-15T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': 671558400,
                'time': '1991-04-13T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': 684860400,
                'time': '1991-09-14T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'PST8PDT':
        {
          0:
              {
                'ts': -1633269600,
                'time': '1918-03-31T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          1:
              {
                'ts': -1615129200,
                'time': '1918-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          2:
              {
                'ts': -1601820000,
                'time': '1919-03-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          3:
              {
                'ts': -1583679600,
                'time': '1919-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          4:
              {
                'ts': -880207200,
                'time': '1942-02-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PPT'
              },
          6:
              {
                'ts': -765385200,
                'time': '1945-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          7:
              {
                'ts': -84376800,
                'time': '1967-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          8:
              {
                'ts': -68655600,
                'time': '1967-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          9:
              {
                'ts': -52927200,
                'time': '1968-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          10:
              {
                'ts': -37206000,
                'time': '1968-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          11:
              {
                'ts': -21477600,
                'time': '1969-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          12:
              {
                'ts': -5756400,
                'time': '1969-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          13:
              {
                'ts': 9972000,
                'time': '1970-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          14:
              {
                'ts': 25693200,
                'time': '1970-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          15:
              {
                'ts': 41421600,
                'time': '1971-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          16:
              {
                'ts': 57747600,
                'time': '1971-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          17:
              {
                'ts': 73476000,
                'time': '1972-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          18:
              {
                'ts': 89197200,
                'time': '1972-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          19:
              {
                'ts': 104925600,
                'time': '1973-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          20:
              {
                'ts': 120646800,
                'time': '1973-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          21:
              {
                'ts': 126698400,
                'time': '1974-01-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          22:
              {
                'ts': 152096400,
                'time': '1974-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          23:
              {
                'ts': 162381600,
                'time': '1975-02-23T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          24:
              {
                'ts': 183546000,
                'time': '1975-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          25:
              {
                'ts': 199274400,
                'time': '1976-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          26:
              {
                'ts': 215600400,
                'time': '1976-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          27:
              {
                'ts': 230724000,
                'time': '1977-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          28:
              {
                'ts': 247050000,
                'time': '1977-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          29:
              {
                'ts': 262778400,
                'time': '1978-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          30:
              {
                'ts': 278499600,
                'time': '1978-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          31:
              {
                'ts': 294228000,
                'time': '1979-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          32:
              {
                'ts': 309949200,
                'time': '1979-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          33:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          34:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          35:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          36:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          37:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          38:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          39:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          40:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          41:
              {
                'ts': 452080800,
                'time': '1984-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          42:
              {
                'ts': 467802000,
                'time': '1984-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          43:
              {
                'ts': 483530400,
                'time': '1985-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          44:
              {
                'ts': 499251600,
                'time': '1985-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          45:
              {
                'ts': 514980000,
                'time': '1986-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          46:
              {
                'ts': 530701200,
                'time': '1986-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          47:
              {
                'ts': 544615200,
                'time': '1987-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          48:
              {
                'ts': 562150800,
                'time': '1987-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          49:
              {
                'ts': 576064800,
                'time': '1988-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          50:
              {
                'ts': 594205200,
                'time': '1988-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          51:
              {
                'ts': 607514400,
                'time': '1989-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          52:
              {
                'ts': 625654800,
                'time': '1989-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          53:
              {
                'ts': 638964000,
                'time': '1990-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          54:
              {
                'ts': 657104400,
                'time': '1990-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          55:
              {
                'ts': 671018400,
                'time': '1991-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          56:
              {
                'ts': 688554000,
                'time': '1991-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          57:
              {
                'ts': 702468000,
                'time': '1992-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          58:
              {
                'ts': 720003600,
                'time': '1992-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          59:
              {
                'ts': 733917600,
                'time': '1993-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          60:
              {
                'ts': 752058000,
                'time': '1993-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          61:
              {
                'ts': 765367200,
                'time': '1994-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          62:
              {
                'ts': 783507600,
                'time': '1994-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          63:
              {
                'ts': 796816800,
                'time': '1995-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          64:
              {
                'ts': 814957200,
                'time': '1995-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          65:
              {
                'ts': 828871200,
                'time': '1996-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          66:
              {
                'ts': 846406800,
                'time': '1996-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          67:
              {
                'ts': 860320800,
                'time': '1997-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          68:
              {
                'ts': 877856400,
                'time': '1997-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          69:
              {
                'ts': 891770400,
                'time': '1998-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          70:
              {
                'ts': 909306000,
                'time': '1998-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          71:
              {
                'ts': 923220000,
                'time': '1999-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          72:
              {
                'ts': 941360400,
                'time': '1999-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          73:
              {
                'ts': 954669600,
                'time': '2000-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          74:
              {
                'ts': 972810000,
                'time': '2000-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          75:
              {
                'ts': 986119200,
                'time': '2001-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          76:
              {
                'ts': 1004259600,
                'time': '2001-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          77:
              {
                'ts': 1018173600,
                'time': '2002-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          78:
              {
                'ts': 1035709200,
                'time': '2002-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          79:
              {
                'ts': 1049623200,
                'time': '2003-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          80:
              {
                'ts': 1067158800,
                'time': '2003-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          81:
              {
                'ts': 1081072800,
                'time': '2004-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          82:
              {
                'ts': 1099213200,
                'time': '2004-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          83:
              {
                'ts': 1112522400,
                'time': '2005-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          84:
              {
                'ts': 1130662800,
                'time': '2005-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          85:
              {
                'ts': 1143972000,
                'time': '2006-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          86:
              {
                'ts': 1162112400,
                'time': '2006-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          87:
              {
                'ts': 1173607200,
                'time': '2007-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          88:
              {
                'ts': 1194166800,
                'time': '2007-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          89:
              {
                'ts': 1205056800,
                'time': '2008-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          90:
              {
                'ts': 1225616400,
                'time': '2008-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          91:
              {
                'ts': 1236506400,
                'time': '2009-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          92:
              {
                'ts': 1257066000,
                'time': '2009-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          93:
              {
                'ts': 1268560800,
                'time': '2010-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          94:
              {
                'ts': 1289120400,
                'time': '2010-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          95:
              {
                'ts': 1300010400,
                'time': '2011-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          96:
              {
                'ts': 1320570000,
                'time': '2011-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          97:
              {
                'ts': 1331460000,
                'time': '2012-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          98:
              {
                'ts': 1352019600,
                'time': '2012-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          99:
              {
                'ts': 1362909600,
                'time': '2013-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          100:
              {
                'ts': 1383469200,
                'time': '2013-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          101:
              {
                'ts': 1394359200,
                'time': '2014-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          102:
              {
                'ts': 1414918800,
                'time': '2014-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          103:
              {
                'ts': 1425808800,
                'time': '2015-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          104:
              {
                'ts': 1446368400,
                'time': '2015-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          105:
              {
                'ts': 1457863200,
                'time': '2016-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          106:
              {
                'ts': 1478422800,
                'time': '2016-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          107:
              {
                'ts': 1489312800,
                'time': '2017-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          108:
              {
                'ts': 1509872400,
                'time': '2017-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          109:
              {
                'ts': 1520762400,
                'time': '2018-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          110:
              {
                'ts': 1541322000,
                'time': '2018-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          111:
              {
                'ts': 1552212000,
                'time': '2019-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          112:
              {
                'ts': 1572771600,
                'time': '2019-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          113:
              {
                'ts': 1583661600,
                'time': '2020-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          114:
              {
                'ts': 1604221200,
                'time': '2020-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          115:
              {
                'ts': 1615716000,
                'time': '2021-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          116:
              {
                'ts': 1636275600,
                'time': '2021-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          117:
              {
                'ts': 1647165600,
                'time': '2022-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          118:
              {
                'ts': 1667725200,
                'time': '2022-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          119:
              {
                'ts': 1678615200,
                'time': '2023-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          120:
              {
                'ts': 1699174800,
                'time': '2023-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          121:
              {
                'ts': 1710064800,
                'time': '2024-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          122:
              {
                'ts': 1730624400,
                'time': '2024-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          123:
              {
                'ts': 1741514400,
                'time': '2025-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          124:
              {
                'ts': 1762074000,
                'time': '2025-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          125:
              {
                'ts': 1772964000,
                'time': '2026-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          126:
              {
                'ts': 1793523600,
                'time': '2026-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          127:
              {
                'ts': 1805018400,
                'time': '2027-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          128:
              {
                'ts': 1825578000,
                'time': '2027-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          129:
              {
                'ts': 1836468000,
                'time': '2028-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          130:
              {
                'ts': 1857027600,
                'time': '2028-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          131:
              {
                'ts': 1867917600,
                'time': '2029-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          132:
              {
                'ts': 1888477200,
                'time': '2029-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          133:
              {
                'ts': 1899367200,
                'time': '2030-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          134:
              {
                'ts': 1919926800,
                'time': '2030-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          135:
              {
                'ts': 1930816800,
                'time': '2031-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          136:
              {
                'ts': 1951376400,
                'time': '2031-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          137:
              {
                'ts': 1962871200,
                'time': '2032-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          138:
              {
                'ts': 1983430800,
                'time': '2032-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          139:
              {
                'ts': 1994320800,
                'time': '2033-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          140:
              {
                'ts': 2014880400,
                'time': '2033-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          141:
              {
                'ts': 2025770400,
                'time': '2034-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          142:
              {
                'ts': 2046330000,
                'time': '2034-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          143:
              {
                'ts': 2057220000,
                'time': '2035-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          144:
              {
                'ts': 2077779600,
                'time': '2035-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          145:
              {
                'ts': 2088669600,
                'time': '2036-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          146:
              {
                'ts': 2109229200,
                'time': '2036-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          147:
              {
                'ts': 2120119200,
                'time': '2037-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          148:
              {
                'ts': 2140678800,
                'time': '2037-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'ROC':
        {
          0:
              {
                'ts': -778579200,
                'time': '1945-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -765363600,
                'time': '1945-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -747043200,
                'time': '1946-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -733827600,
                'time': '1946-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -715507200,
                'time': '1947-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': -702291600,
                'time': '1947-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -683884800,
                'time': '1948-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': -670669200,
                'time': '1948-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': -652348800,
                'time': '1949-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          9:
              {
                'ts': -639133200,
                'time': '1949-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': -620812800,
                'time': '1950-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          11:
              {
                'ts': -607597200,
                'time': '1950-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': -589276800,
                'time': '1951-04-30T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          13:
              {
                'ts': -576061200,
                'time': '1951-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          14:
              {
                'ts': -562924800,
                'time': '1952-02-29T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          15:
              {
                'ts': -541760400,
                'time': '1952-10-31T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          16:
              {
                'ts': -528710400,
                'time': '1953-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          17:
              {
                'ts': -510224400,
                'time': '1953-10-31T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          18:
              {
                'ts': -497174400,
                'time': '1954-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          19:
              {
                'ts': -478688400,
                'time': '1954-10-31T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          20:
              {
                'ts': -465638400,
                'time': '1955-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          21:
              {
                'ts': -449830800,
                'time': '1955-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          22:
              {
                'ts': -434016000,
                'time': '1956-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          23:
              {
                'ts': -418208400,
                'time': '1956-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          24:
              {
                'ts': -402480000,
                'time': '1957-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          25:
              {
                'ts': -386672400,
                'time': '1957-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          26:
              {
                'ts': -370944000,
                'time': '1958-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          27:
              {
                'ts': -355136400,
                'time': '1958-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          28:
              {
                'ts': -339408000,
                'time': '1959-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          29:
              {
                'ts': -323600400,
                'time': '1959-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          30:
              {
                'ts': -302515200,
                'time': '1960-05-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          31:
              {
                'ts': -291978000,
                'time': '1960-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          32:
              {
                'ts': -270979200,
                'time': '1961-05-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          33:
              {
                'ts': -260442000,
                'time': '1961-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          34:
              {
                'ts': 133977600,
                'time': '1974-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          35:
              {
                'ts': 149785200,
                'time': '1974-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          36:
              {
                'ts': 165513600,
                'time': '1975-03-31T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          37:
              {
                'ts': 181321200,
                'time': '1975-09-30T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': 331142400,
                'time': '1980-06-29T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'CDT'
              },
          39:
              {
                'ts': 339087600,
                'time': '1980-09-29T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'ROK':
        {
          0:
              {
                'ts': -2053931400,
                'time': '1904-11-30T15:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              },
          1:
              {
                'ts': -1325494800,
                'time': '1927-12-31T15:00:00+0000',
                'offset': 30600,
                'isdst': false,
                'abbr': 'KST'
              },
          2:
              {
                'ts': -1199262600,
                'time': '1931-12-31T15:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              },
          3:
              {
                'ts': -498128400,
                'time': '1954-03-20T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'KST'
              },
          4:
              {
                'ts': -303984000,
                'time': '1960-05-14T16:00:00+0000',
                'offset': 32400,
                'isdst': true,
                'abbr': 'KDT'
              },
          5:
              {
                'ts': -293533200,
                'time': '1960-09-12T15:00:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'KST'
              },
          6:
              {
                'ts': -264931200,
                'time': '1961-08-09T16:00:00+0000',
                'offset': 30600,
                'isdst': false,
                'abbr': 'KST'
              },
          7:
              {
                'ts': -39515400,
                'time': '1968-09-30T15:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              },
          8:
              {
                'ts': 547570800,
                'time': '1987-05-09T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'KDT'
              },
          9:
              {
                'ts': 560872800,
                'time': '1987-10-10T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              },
          10:
              {
                'ts': 579020400,
                'time': '1988-05-07T15:00:00+0000',
                'offset': 36000,
                'isdst': true,
                'abbr': 'KDT'
              },
          11:
              {
                'ts': 592322400,
                'time': '1988-10-08T14:00:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'KST'
              }
        },
    'Singapore':
        {
          0:
              {
                'ts': -2038200925,
                'time': '1905-05-31T17:04:35+0000',
                'offset': 25200,
                'isdst': false,
                'abbr': 'MALT'
              },
          1:
              {
                'ts': -1167634800,
                'time': '1932-12-31T17:00:00+0000',
                'offset': 26400,
                'isdst': true,
                'abbr': 'MALST'
              },
          2:
              {
                'ts': -1073028000,
                'time': '1935-12-31T16:40:00+0000',
                'offset': 26400,
                'isdst': false,
                'abbr': 'MALT'
              },
          3:
              {
                'ts': -894180000,
                'time': '1941-08-31T16:40:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'MALT'
              },
          4:
              {
                'ts': -879665400,
                'time': '1942-02-15T16:30:00+0000',
                'offset': 32400,
                'isdst': false,
                'abbr': 'JST'
              },
          5:
              {
                'ts': -767005200,
                'time': '1945-09-11T15:00:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'MALT'
              },
          6:
              {
                'ts': -138785400,
                'time': '1965-08-08T16:30:00+0000',
                'offset': 27000,
                'isdst': false,
                'abbr': 'SGT'
              },
          7:
              {
                'ts': 378664200,
                'time': '1981-12-31T16:30:00+0000',
                'offset': 28800,
                'isdst': false,
                'abbr': 'SGT'
              }
        },
    'Turkey':
        {
          0:
              {
                'ts': -1869875816,
                'time': '1910-09-30T22:03:04+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          1:
              {
                'ts': -1693706400,
                'time': '1916-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          2:
              {
                'ts': -1680490800,
                'time': '1916-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          3:
              {
                'ts': -1570413600,
                'time': '1920-03-27T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          4:
              {
                'ts': -1552186800,
                'time': '1920-10-24T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          5:
              {
                'ts': -1538359200,
                'time': '1921-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          6:
              {
                'ts': -1522551600,
                'time': '1921-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          7:
              {
                'ts': -1507514400,
                'time': '1922-03-25T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          8:
              {
                'ts': -1490583600,
                'time': '1922-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          9:
              {
                'ts': -1440208800,
                'time': '1924-05-12T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          10:
              {
                'ts': -1428030000,
                'time': '1924-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          11:
              {
                'ts': -1409709600,
                'time': '1925-04-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          12:
              {
                'ts': -1396494000,
                'time': '1925-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': -931140000,
                'time': '1940-06-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          14:
              {
                'ts': -922762800,
                'time': '1940-10-04T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          15:
              {
                'ts': -917834400,
                'time': '1940-11-30T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          16:
              {
                'ts': -892436400,
                'time': '1941-09-20T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          17:
              {
                'ts': -875844000,
                'time': '1942-03-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          18:
              {
                'ts': -857358000,
                'time': '1942-10-31T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          19:
              {
                'ts': -781063200,
                'time': '1945-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          20:
              {
                'ts': -764737200,
                'time': '1945-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          21:
              {
                'ts': -744343200,
                'time': '1946-05-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          22:
              {
                'ts': -733806000,
                'time': '1946-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          23:
              {
                'ts': -716436000,
                'time': '1947-04-19T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          24:
              {
                'ts': -701924400,
                'time': '1947-10-04T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          25:
              {
                'ts': -684986400,
                'time': '1948-04-17T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          26:
              {
                'ts': -670474800,
                'time': '1948-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          27:
              {
                'ts': -654141600,
                'time': '1949-04-09T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          28:
              {
                'ts': -639025200,
                'time': '1949-10-01T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          29:
              {
                'ts': -621828000,
                'time': '1950-04-18T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          30:
              {
                'ts': -606970800,
                'time': '1950-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          31:
              {
                'ts': -590032800,
                'time': '1951-04-21T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          32:
              {
                'ts': -575434800,
                'time': '1951-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          33:
              {
                'ts': -235620000,
                'time': '1962-07-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          34:
              {
                'ts': -228279600,
                'time': '1962-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          35:
              {
                'ts': -177732000,
                'time': '1964-05-14T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          36:
              {
                'ts': -165726000,
                'time': '1964-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          37:
              {
                'ts': 10533600,
                'time': '1970-05-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          38:
              {
                'ts': 23835600,
                'time': '1970-10-03T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          39:
              {
                'ts': 41983200,
                'time': '1971-05-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          40:
              {
                'ts': 55285200,
                'time': '1971-10-02T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          41:
              {
                'ts': 74037600,
                'time': '1972-05-06T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          42:
              {
                'ts': 87339600,
                'time': '1972-10-07T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          43:
              {
                'ts': 107910000,
                'time': '1973-06-02T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          44:
              {
                'ts': 121219200,
                'time': '1973-11-04T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          45:
              {
                'ts': 133920000,
                'time': '1974-03-31T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          46:
              {
                'ts': 152676000,
                'time': '1974-11-03T02:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          47:
              {
                'ts': 165362400,
                'time': '1975-03-29T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          48:
              {
                'ts': 183502800,
                'time': '1975-10-25T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          49:
              {
                'ts': 202428000,
                'time': '1976-05-31T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          50:
              {
                'ts': 215557200,
                'time': '1976-10-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          51:
              {
                'ts': 228866400,
                'time': '1977-04-02T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          52:
              {
                'ts': 245797200,
                'time': '1977-10-15T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          53:
              {
                'ts': 260316000,
                'time': '1978-04-01T22:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          54:
              {
                'ts': 277246800,
                'time': '1978-10-14T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          55:
              {
                'ts': 308779200,
                'time': '1979-10-14T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          56:
              {
                'ts': 323827200,
                'time': '1980-04-06T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          57:
              {
                'ts': 340228800,
                'time': '1980-10-12T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          58:
              {
                'ts': 354672000,
                'time': '1981-03-29T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          59:
              {
                'ts': 371678400,
                'time': '1981-10-11T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          60:
              {
                'ts': 386121600,
                'time': '1982-03-28T00:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          61:
              {
                'ts': 403128000,
                'time': '1982-10-10T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          62:
              {
                'ts': 428446800,
                'time': '1983-07-30T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'TRST'
              },
          63:
              {
                'ts': 433886400,
                'time': '1983-10-01T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'TRT'
              },
          64:
              {
                'ts': 482792400,
                'time': '1985-04-19T21:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          65:
              {
                'ts': 496702800,
                'time': '1985-09-27T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          66:
              {
                'ts': 512524800,
                'time': '1986-03-30T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          67:
              {
                'ts': 528249600,
                'time': '1986-09-28T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          68:
              {
                'ts': 543974400,
                'time': '1987-03-29T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          69:
              {
                'ts': 559699200,
                'time': '1987-09-27T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          70:
              {
                'ts': 575424000,
                'time': '1988-03-27T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          71:
              {
                'ts': 591148800,
                'time': '1988-09-25T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          72:
              {
                'ts': 606873600,
                'time': '1989-03-26T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          73:
              {
                'ts': 622598400,
                'time': '1989-09-24T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          74:
              {
                'ts': 638323200,
                'time': '1990-03-25T00:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          75:
              {
                'ts': 654652800,
                'time': '1990-09-30T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          76:
              {
                'ts': 670374000,
                'time': '1991-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          77:
              {
                'ts': 686098800,
                'time': '1991-09-28T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          78:
              {
                'ts': 701823600,
                'time': '1992-03-28T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          79:
              {
                'ts': 717548400,
                'time': '1992-09-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          80:
              {
                'ts': 733273200,
                'time': '1993-03-27T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          81:
              {
                'ts': 748998000,
                'time': '1993-09-25T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          82:
              {
                'ts': 764722800,
                'time': '1994-03-26T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          83:
              {
                'ts': 780447600,
                'time': '1994-09-24T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          84:
              {
                'ts': 796172400,
                'time': '1995-03-25T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          85:
              {
                'ts': 811897200,
                'time': '1995-09-23T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          86:
              {
                'ts': 828226800,
                'time': '1996-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          87:
              {
                'ts': 846370800,
                'time': '1996-10-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          88:
              {
                'ts': 859676400,
                'time': '1997-03-29T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          89:
              {
                'ts': 877820400,
                'time': '1997-10-25T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          90:
              {
                'ts': 891126000,
                'time': '1998-03-28T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          91:
              {
                'ts': 909270000,
                'time': '1998-10-24T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          92:
              {
                'ts': 922575600,
                'time': '1999-03-27T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          93:
              {
                'ts': 941324400,
                'time': '1999-10-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          94:
              {
                'ts': 954025200,
                'time': '2000-03-25T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          95:
              {
                'ts': 972774000,
                'time': '2000-10-28T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          96:
              {
                'ts': 985474800,
                'time': '2001-03-24T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          97:
              {
                'ts': 1004223600,
                'time': '2001-10-27T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          98:
              {
                'ts': 1017529200,
                'time': '2002-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          99:
              {
                'ts': 1035673200,
                'time': '2002-10-26T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          100:
              {
                'ts': 1048978800,
                'time': '2003-03-29T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          101:
              {
                'ts': 1067122800,
                'time': '2003-10-25T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          102:
              {
                'ts': 1080428400,
                'time': '2004-03-27T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          103:
              {
                'ts': 1099177200,
                'time': '2004-10-30T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          104:
              {
                'ts': 1111878000,
                'time': '2005-03-26T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          105:
              {
                'ts': 1130626800,
                'time': '2005-10-29T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          106:
              {
                'ts': 1143327600,
                'time': '2006-03-25T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          107:
              {
                'ts': 1162076400,
                'time': '2006-10-28T23:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          108:
              {
                'ts': 1167602400,
                'time': '2006-12-31T22:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          109:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          110:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          111:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          112:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          113:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          114:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          115:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          116:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          117:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          118:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          119:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          120:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          121:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          122:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          123:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          124:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          125:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          126:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          127:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          128:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          129:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          130:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          131:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          132:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          133:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          134:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          135:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          136:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          137:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          138:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          139:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          140:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          141:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          142:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          143:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          144:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          145:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          146:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          147:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          148:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          149:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          150:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          151:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          152:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          153:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          154:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          155:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          156:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          157:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          158:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          159:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          160:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          161:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          162:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          163:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          164:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          165:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          166:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          167:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          168:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          169:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          170:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              }
        },
    'UCT':
        {
        },
    'Universal':
        {
        },
    'US/Alaska':
        {
          0:
              {
                'ts': -880200000,
                'time': '1942-02-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'CAWT'
              },
          1:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'CAPT'
              },
          2:
              {
                'ts': -765378000,
                'time': '1945-09-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'CAT'
              },
          3:
              {
                'ts': -86882400,
                'time': '1967-04-01T10:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          4:
              {
                'ts': -21470400,
                'time': '1969-04-27T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          5:
              {
                'ts': -5749200,
                'time': '1969-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          6:
              {
                'ts': 9979200,
                'time': '1970-04-26T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          7:
              {
                'ts': 25700400,
                'time': '1970-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          8:
              {
                'ts': 41428800,
                'time': '1971-04-25T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          9:
              {
                'ts': 57754800,
                'time': '1971-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          10:
              {
                'ts': 73483200,
                'time': '1972-04-30T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          11:
              {
                'ts': 89204400,
                'time': '1972-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          12:
              {
                'ts': 104932800,
                'time': '1973-04-29T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          13:
              {
                'ts': 120654000,
                'time': '1973-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          14:
              {
                'ts': 126705600,
                'time': '1974-01-06T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          15:
              {
                'ts': 152103600,
                'time': '1974-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          16:
              {
                'ts': 162388800,
                'time': '1975-02-23T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          17:
              {
                'ts': 183553200,
                'time': '1975-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          18:
              {
                'ts': 199281600,
                'time': '1976-04-25T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          19:
              {
                'ts': 215607600,
                'time': '1976-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          20:
              {
                'ts': 230731200,
                'time': '1977-04-24T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          21:
              {
                'ts': 247057200,
                'time': '1977-10-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          22:
              {
                'ts': 262785600,
                'time': '1978-04-30T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          23:
              {
                'ts': 278506800,
                'time': '1978-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          24:
              {
                'ts': 294235200,
                'time': '1979-04-29T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          25:
              {
                'ts': 309956400,
                'time': '1979-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          26:
              {
                'ts': 325684800,
                'time': '1980-04-27T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          27:
              {
                'ts': 341406000,
                'time': '1980-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          28:
              {
                'ts': 357134400,
                'time': '1981-04-26T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          29:
              {
                'ts': 372855600,
                'time': '1981-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          30:
              {
                'ts': 388584000,
                'time': '1982-04-25T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          31:
              {
                'ts': 404910000,
                'time': '1982-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          32:
              {
                'ts': 420033600,
                'time': '1983-04-24T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'AHDT'
              },
          33:
              {
                'ts': 436359600,
                'time': '1983-10-30T11:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'YST'
              },
          34:
              {
                'ts': 439030800,
                'time': '1983-11-30T09:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          35:
              {
                'ts': 452084400,
                'time': '1984-04-29T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          36:
              {
                'ts': 467805600,
                'time': '1984-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          37:
              {
                'ts': 483534000,
                'time': '1985-04-28T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          38:
              {
                'ts': 499255200,
                'time': '1985-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          39:
              {
                'ts': 514983600,
                'time': '1986-04-27T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          40:
              {
                'ts': 530704800,
                'time': '1986-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          41:
              {
                'ts': 544618800,
                'time': '1987-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          42:
              {
                'ts': 562154400,
                'time': '1987-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          43:
              {
                'ts': 576068400,
                'time': '1988-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          44:
              {
                'ts': 594208800,
                'time': '1988-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          45:
              {
                'ts': 607518000,
                'time': '1989-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          46:
              {
                'ts': 625658400,
                'time': '1989-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          47:
              {
                'ts': 638967600,
                'time': '1990-04-01T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          48:
              {
                'ts': 657108000,
                'time': '1990-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          49:
              {
                'ts': 671022000,
                'time': '1991-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          50:
              {
                'ts': 688557600,
                'time': '1991-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          51:
              {
                'ts': 702471600,
                'time': '1992-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          52:
              {
                'ts': 720007200,
                'time': '1992-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          53:
              {
                'ts': 733921200,
                'time': '1993-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          54:
              {
                'ts': 752061600,
                'time': '1993-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          55:
              {
                'ts': 765370800,
                'time': '1994-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          56:
              {
                'ts': 783511200,
                'time': '1994-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          57:
              {
                'ts': 796820400,
                'time': '1995-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          58:
              {
                'ts': 814960800,
                'time': '1995-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          59:
              {
                'ts': 828874800,
                'time': '1996-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          60:
              {
                'ts': 846410400,
                'time': '1996-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          61:
              {
                'ts': 860324400,
                'time': '1997-04-06T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          62:
              {
                'ts': 877860000,
                'time': '1997-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          63:
              {
                'ts': 891774000,
                'time': '1998-04-05T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          64:
              {
                'ts': 909309600,
                'time': '1998-10-25T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          65:
              {
                'ts': 923223600,
                'time': '1999-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          66:
              {
                'ts': 941364000,
                'time': '1999-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          67:
              {
                'ts': 954673200,
                'time': '2000-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          68:
              {
                'ts': 972813600,
                'time': '2000-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          69:
              {
                'ts': 986122800,
                'time': '2001-04-01T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          70:
              {
                'ts': 1004263200,
                'time': '2001-10-28T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          71:
              {
                'ts': 1018177200,
                'time': '2002-04-07T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          72:
              {
                'ts': 1035712800,
                'time': '2002-10-27T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          73:
              {
                'ts': 1049626800,
                'time': '2003-04-06T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          74:
              {
                'ts': 1067162400,
                'time': '2003-10-26T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          75:
              {
                'ts': 1081076400,
                'time': '2004-04-04T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          76:
              {
                'ts': 1099216800,
                'time': '2004-10-31T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          77:
              {
                'ts': 1112526000,
                'time': '2005-04-03T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          78:
              {
                'ts': 1130666400,
                'time': '2005-10-30T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          79:
              {
                'ts': 1143975600,
                'time': '2006-04-02T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          80:
              {
                'ts': 1162116000,
                'time': '2006-10-29T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          81:
              {
                'ts': 1173610800,
                'time': '2007-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          82:
              {
                'ts': 1194170400,
                'time': '2007-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          83:
              {
                'ts': 1205060400,
                'time': '2008-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          84:
              {
                'ts': 1225620000,
                'time': '2008-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          85:
              {
                'ts': 1236510000,
                'time': '2009-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          86:
              {
                'ts': 1257069600,
                'time': '2009-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          87:
              {
                'ts': 1268564400,
                'time': '2010-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          88:
              {
                'ts': 1289124000,
                'time': '2010-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          89:
              {
                'ts': 1300014000,
                'time': '2011-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          90:
              {
                'ts': 1320573600,
                'time': '2011-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          91:
              {
                'ts': 1331463600,
                'time': '2012-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          92:
              {
                'ts': 1352023200,
                'time': '2012-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          93:
              {
                'ts': 1362913200,
                'time': '2013-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          94:
              {
                'ts': 1383472800,
                'time': '2013-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          95:
              {
                'ts': 1394362800,
                'time': '2014-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          96:
              {
                'ts': 1414922400,
                'time': '2014-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          97:
              {
                'ts': 1425812400,
                'time': '2015-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          98:
              {
                'ts': 1446372000,
                'time': '2015-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          99:
              {
                'ts': 1457866800,
                'time': '2016-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          100:
              {
                'ts': 1478426400,
                'time': '2016-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          101:
              {
                'ts': 1489316400,
                'time': '2017-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          102:
              {
                'ts': 1509876000,
                'time': '2017-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          103:
              {
                'ts': 1520766000,
                'time': '2018-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          104:
              {
                'ts': 1541325600,
                'time': '2018-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          105:
              {
                'ts': 1552215600,
                'time': '2019-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          106:
              {
                'ts': 1572775200,
                'time': '2019-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          107:
              {
                'ts': 1583665200,
                'time': '2020-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          108:
              {
                'ts': 1604224800,
                'time': '2020-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          109:
              {
                'ts': 1615719600,
                'time': '2021-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          110:
              {
                'ts': 1636279200,
                'time': '2021-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          111:
              {
                'ts': 1647169200,
                'time': '2022-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          112:
              {
                'ts': 1667728800,
                'time': '2022-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          113:
              {
                'ts': 1678618800,
                'time': '2023-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          114:
              {
                'ts': 1699178400,
                'time': '2023-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          115:
              {
                'ts': 1710068400,
                'time': '2024-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          116:
              {
                'ts': 1730628000,
                'time': '2024-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          117:
              {
                'ts': 1741518000,
                'time': '2025-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          118:
              {
                'ts': 1762077600,
                'time': '2025-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          119:
              {
                'ts': 1772967600,
                'time': '2026-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          120:
              {
                'ts': 1793527200,
                'time': '2026-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          121:
              {
                'ts': 1805022000,
                'time': '2027-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          122:
              {
                'ts': 1825581600,
                'time': '2027-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          123:
              {
                'ts': 1836471600,
                'time': '2028-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          124:
              {
                'ts': 1857031200,
                'time': '2028-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          125:
              {
                'ts': 1867921200,
                'time': '2029-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          126:
              {
                'ts': 1888480800,
                'time': '2029-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          127:
              {
                'ts': 1899370800,
                'time': '2030-03-10T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          128:
              {
                'ts': 1919930400,
                'time': '2030-11-03T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          129:
              {
                'ts': 1930820400,
                'time': '2031-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          130:
              {
                'ts': 1951380000,
                'time': '2031-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          131:
              {
                'ts': 1962874800,
                'time': '2032-03-14T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          132:
              {
                'ts': 1983434400,
                'time': '2032-11-07T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          133:
              {
                'ts': 1994324400,
                'time': '2033-03-13T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          134:
              {
                'ts': 2014884000,
                'time': '2033-11-06T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          135:
              {
                'ts': 2025774000,
                'time': '2034-03-12T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          136:
              {
                'ts': 2046333600,
                'time': '2034-11-05T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          137:
              {
                'ts': 2057223600,
                'time': '2035-03-11T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          138:
              {
                'ts': 2077783200,
                'time': '2035-11-04T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          139:
              {
                'ts': 2088673200,
                'time': '2036-03-09T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          140:
              {
                'ts': 2109232800,
                'time': '2036-11-02T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              },
          141:
              {
                'ts': 2120122800,
                'time': '2037-03-08T11:00:00+0000',
                'offset': -28800,
                'isdst': true,
                'abbr': 'AKDT'
              },
          142:
              {
                'ts': 2140682400,
                'time': '2037-11-01T10:00:00+0000',
                'offset': -32400,
                'isdst': false,
                'abbr': 'AKST'
              }
        },
    'US/Aleutian':
        {
          0:
              {
                'ts': -880196400,
                'time': '1942-02-09T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'NWT'
              },
          1:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'NPT'
              },
          2:
              {
                'ts': -765374400,
                'time': '1945-09-30T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'NST'
              },
          3:
              {
                'ts': -86878800,
                'time': '1967-04-01T11:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          4:
              {
                'ts': -21466800,
                'time': '1969-04-27T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          5:
              {
                'ts': -5745600,
                'time': '1969-10-26T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          6:
              {
                'ts': 9982800,
                'time': '1970-04-26T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          7:
              {
                'ts': 25704000,
                'time': '1970-10-25T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          8:
              {
                'ts': 41432400,
                'time': '1971-04-25T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          9:
              {
                'ts': 57758400,
                'time': '1971-10-31T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          10:
              {
                'ts': 73486800,
                'time': '1972-04-30T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          11:
              {
                'ts': 89208000,
                'time': '1972-10-29T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          12:
              {
                'ts': 104936400,
                'time': '1973-04-29T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          13:
              {
                'ts': 120657600,
                'time': '1973-10-28T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          14:
              {
                'ts': 126709200,
                'time': '1974-01-06T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          15:
              {
                'ts': 152107200,
                'time': '1974-10-27T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          16:
              {
                'ts': 162392400,
                'time': '1975-02-23T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          17:
              {
                'ts': 183556800,
                'time': '1975-10-26T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          18:
              {
                'ts': 199285200,
                'time': '1976-04-25T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          19:
              {
                'ts': 215611200,
                'time': '1976-10-31T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          20:
              {
                'ts': 230734800,
                'time': '1977-04-24T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          21:
              {
                'ts': 247060800,
                'time': '1977-10-30T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          22:
              {
                'ts': 262789200,
                'time': '1978-04-30T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          23:
              {
                'ts': 278510400,
                'time': '1978-10-29T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          24:
              {
                'ts': 294238800,
                'time': '1979-04-29T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          25:
              {
                'ts': 309960000,
                'time': '1979-10-28T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          26:
              {
                'ts': 325688400,
                'time': '1980-04-27T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          27:
              {
                'ts': 341409600,
                'time': '1980-10-26T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          28:
              {
                'ts': 357138000,
                'time': '1981-04-26T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          29:
              {
                'ts': 372859200,
                'time': '1981-10-25T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          30:
              {
                'ts': 388587600,
                'time': '1982-04-25T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          31:
              {
                'ts': 404913600,
                'time': '1982-10-31T12:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          32:
              {
                'ts': 420037200,
                'time': '1983-04-24T13:00:00+0000',
                'offset': -36000,
                'isdst': true,
                'abbr': 'BDT'
              },
          33:
              {
                'ts': 436363200,
                'time': '1983-10-30T12:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'AHST'
              },
          34:
              {
                'ts': 439034400,
                'time': '1983-11-30T10:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          35:
              {
                'ts': 452088000,
                'time': '1984-04-29T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          36:
              {
                'ts': 467809200,
                'time': '1984-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          37:
              {
                'ts': 483537600,
                'time': '1985-04-28T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          38:
              {
                'ts': 499258800,
                'time': '1985-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          39:
              {
                'ts': 514987200,
                'time': '1986-04-27T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          40:
              {
                'ts': 530708400,
                'time': '1986-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          41:
              {
                'ts': 544622400,
                'time': '1987-04-05T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          42:
              {
                'ts': 562158000,
                'time': '1987-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          43:
              {
                'ts': 576072000,
                'time': '1988-04-03T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          44:
              {
                'ts': 594212400,
                'time': '1988-10-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          45:
              {
                'ts': 607521600,
                'time': '1989-04-02T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          46:
              {
                'ts': 625662000,
                'time': '1989-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          47:
              {
                'ts': 638971200,
                'time': '1990-04-01T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          48:
              {
                'ts': 657111600,
                'time': '1990-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          49:
              {
                'ts': 671025600,
                'time': '1991-04-07T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          50:
              {
                'ts': 688561200,
                'time': '1991-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          51:
              {
                'ts': 702475200,
                'time': '1992-04-05T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          52:
              {
                'ts': 720010800,
                'time': '1992-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          53:
              {
                'ts': 733924800,
                'time': '1993-04-04T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          54:
              {
                'ts': 752065200,
                'time': '1993-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          55:
              {
                'ts': 765374400,
                'time': '1994-04-03T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          56:
              {
                'ts': 783514800,
                'time': '1994-10-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          57:
              {
                'ts': 796824000,
                'time': '1995-04-02T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          58:
              {
                'ts': 814964400,
                'time': '1995-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          59:
              {
                'ts': 828878400,
                'time': '1996-04-07T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          60:
              {
                'ts': 846414000,
                'time': '1996-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          61:
              {
                'ts': 860328000,
                'time': '1997-04-06T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          62:
              {
                'ts': 877863600,
                'time': '1997-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          63:
              {
                'ts': 891777600,
                'time': '1998-04-05T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          64:
              {
                'ts': 909313200,
                'time': '1998-10-25T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          65:
              {
                'ts': 923227200,
                'time': '1999-04-04T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          66:
              {
                'ts': 941367600,
                'time': '1999-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          67:
              {
                'ts': 954676800,
                'time': '2000-04-02T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          68:
              {
                'ts': 972817200,
                'time': '2000-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          69:
              {
                'ts': 986126400,
                'time': '2001-04-01T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          70:
              {
                'ts': 1004266800,
                'time': '2001-10-28T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          71:
              {
                'ts': 1018180800,
                'time': '2002-04-07T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          72:
              {
                'ts': 1035716400,
                'time': '2002-10-27T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          73:
              {
                'ts': 1049630400,
                'time': '2003-04-06T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          74:
              {
                'ts': 1067166000,
                'time': '2003-10-26T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          75:
              {
                'ts': 1081080000,
                'time': '2004-04-04T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          76:
              {
                'ts': 1099220400,
                'time': '2004-10-31T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          77:
              {
                'ts': 1112529600,
                'time': '2005-04-03T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          78:
              {
                'ts': 1130670000,
                'time': '2005-10-30T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          79:
              {
                'ts': 1143979200,
                'time': '2006-04-02T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          80:
              {
                'ts': 1162119600,
                'time': '2006-10-29T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          81:
              {
                'ts': 1173614400,
                'time': '2007-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          82:
              {
                'ts': 1194174000,
                'time': '2007-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          83:
              {
                'ts': 1205064000,
                'time': '2008-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          84:
              {
                'ts': 1225623600,
                'time': '2008-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          85:
              {
                'ts': 1236513600,
                'time': '2009-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          86:
              {
                'ts': 1257073200,
                'time': '2009-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          87:
              {
                'ts': 1268568000,
                'time': '2010-03-14T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          88:
              {
                'ts': 1289127600,
                'time': '2010-11-07T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          89:
              {
                'ts': 1300017600,
                'time': '2011-03-13T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          90:
              {
                'ts': 1320577200,
                'time': '2011-11-06T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          91:
              {
                'ts': 1331467200,
                'time': '2012-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          92:
              {
                'ts': 1352026800,
                'time': '2012-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          93:
              {
                'ts': 1362916800,
                'time': '2013-03-10T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          94:
              {
                'ts': 1383476400,
                'time': '2013-11-03T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          95:
              {
                'ts': 1394366400,
                'time': '2014-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          96:
              {
                'ts': 1414926000,
                'time': '2014-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          97:
              {
                'ts': 1425816000,
                'time': '2015-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          98:
              {
                'ts': 1446375600,
                'time': '2015-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          99:
              {
                'ts': 1457870400,
                'time': '2016-03-13T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          100:
              {
                'ts': 1478430000,
                'time': '2016-11-06T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          101:
              {
                'ts': 1489320000,
                'time': '2017-03-12T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          102:
              {
                'ts': 1509879600,
                'time': '2017-11-05T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          103:
              {
                'ts': 1520769600,
                'time': '2018-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          104:
              {
                'ts': 1541329200,
                'time': '2018-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          105:
              {
                'ts': 1552219200,
                'time': '2019-03-10T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          106:
              {
                'ts': 1572778800,
                'time': '2019-11-03T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          107:
              {
                'ts': 1583668800,
                'time': '2020-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          108:
              {
                'ts': 1604228400,
                'time': '2020-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          109:
              {
                'ts': 1615723200,
                'time': '2021-03-14T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          110:
              {
                'ts': 1636282800,
                'time': '2021-11-07T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          111:
              {
                'ts': 1647172800,
                'time': '2022-03-13T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          112:
              {
                'ts': 1667732400,
                'time': '2022-11-06T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          113:
              {
                'ts': 1678622400,
                'time': '2023-03-12T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          114:
              {
                'ts': 1699182000,
                'time': '2023-11-05T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          115:
              {
                'ts': 1710072000,
                'time': '2024-03-10T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          116:
              {
                'ts': 1730631600,
                'time': '2024-11-03T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          117:
              {
                'ts': 1741521600,
                'time': '2025-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          118:
              {
                'ts': 1762081200,
                'time': '2025-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          119:
              {
                'ts': 1772971200,
                'time': '2026-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          120:
              {
                'ts': 1793530800,
                'time': '2026-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          121:
              {
                'ts': 1805025600,
                'time': '2027-03-14T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          122:
              {
                'ts': 1825585200,
                'time': '2027-11-07T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          123:
              {
                'ts': 1836475200,
                'time': '2028-03-12T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          124:
              {
                'ts': 1857034800,
                'time': '2028-11-05T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          125:
              {
                'ts': 1867924800,
                'time': '2029-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          126:
              {
                'ts': 1888484400,
                'time': '2029-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          127:
              {
                'ts': 1899374400,
                'time': '2030-03-10T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          128:
              {
                'ts': 1919934000,
                'time': '2030-11-03T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          129:
              {
                'ts': 1930824000,
                'time': '2031-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          130:
              {
                'ts': 1951383600,
                'time': '2031-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          131:
              {
                'ts': 1962878400,
                'time': '2032-03-14T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          132:
              {
                'ts': 1983438000,
                'time': '2032-11-07T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          133:
              {
                'ts': 1994328000,
                'time': '2033-03-13T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          134:
              {
                'ts': 2014887600,
                'time': '2033-11-06T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          135:
              {
                'ts': 2025777600,
                'time': '2034-03-12T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          136:
              {
                'ts': 2046337200,
                'time': '2034-11-05T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          137:
              {
                'ts': 2057227200,
                'time': '2035-03-11T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          138:
              {
                'ts': 2077786800,
                'time': '2035-11-04T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          139:
              {
                'ts': 2088676800,
                'time': '2036-03-09T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          140:
              {
                'ts': 2109236400,
                'time': '2036-11-02T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              },
          141:
              {
                'ts': 2120126400,
                'time': '2037-03-08T12:00:00+0000',
                'offset': -32400,
                'isdst': true,
                'abbr': 'HADT'
              },
          142:
              {
                'ts': 2140686000,
                'time': '2037-11-01T11:00:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HAST'
              }
        },
    'US/Arizona':
        {
          0:
              {
                'ts': -1633273200,
                'time': '1918-03-31T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          1:
              {
                'ts': -1615132800,
                'time': '1918-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          2:
              {
                'ts': -1601823600,
                'time': '1919-03-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          3:
              {
                'ts': -1583683200,
                'time': '1919-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          5:
              {
                'ts': -820519140,
                'time': '1944-01-01T06:01:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          6:
              {
                'ts': -812653140,
                'time': '1944-04-01T07:01:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          7:
              {
                'ts': -796845540,
                'time': '1944-10-01T06:01:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          8:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          9:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'US/Central':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -1563724800,
                'time': '1920-06-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': -1551632400,
                'time': '1920-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -1538928000,
                'time': '1921-03-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          7:
              {
                'ts': -1520182800,
                'time': '1921-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          8:
              {
                'ts': -1504454400,
                'time': '1922-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          9:
              {
                'ts': -1491757200,
                'time': '1922-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          10:
              {
                'ts': -1473004800,
                'time': '1923-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          11:
              {
                'ts': -1459702800,
                'time': '1923-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          12:
              {
                'ts': -1441555200,
                'time': '1924-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          13:
              {
                'ts': -1428253200,
                'time': '1924-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          14:
              {
                'ts': -1410105600,
                'time': '1925-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          15:
              {
                'ts': -1396803600,
                'time': '1925-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          16:
              {
                'ts': -1378656000,
                'time': '1926-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          17:
              {
                'ts': -1365354000,
                'time': '1926-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          18:
              {
                'ts': -1347206400,
                'time': '1927-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          19:
              {
                'ts': -1333904400,
                'time': '1927-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          20:
              {
                'ts': -1315152000,
                'time': '1928-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          21:
              {
                'ts': -1301850000,
                'time': '1928-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          22:
              {
                'ts': -1283702400,
                'time': '1929-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          23:
              {
                'ts': -1270400400,
                'time': '1929-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          24:
              {
                'ts': -1252252800,
                'time': '1930-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          25:
              {
                'ts': -1238950800,
                'time': '1930-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          26:
              {
                'ts': -1220803200,
                'time': '1931-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          27:
              {
                'ts': -1207501200,
                'time': '1931-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          28:
              {
                'ts': -1189353600,
                'time': '1932-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          29:
              {
                'ts': -1176051600,
                'time': '1932-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          30:
              {
                'ts': -1157299200,
                'time': '1933-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          31:
              {
                'ts': -1144602000,
                'time': '1933-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          32:
              {
                'ts': -1125849600,
                'time': '1934-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          33:
              {
                'ts': -1112547600,
                'time': '1934-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          34:
              {
                'ts': -1094400000,
                'time': '1935-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          35:
              {
                'ts': -1081098000,
                'time': '1935-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          36:
              {
                'ts': -1067788800,
                'time': '1936-03-01T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          37:
              {
                'ts': -1045414800,
                'time': '1936-11-15T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          38:
              {
                'ts': -1031500800,
                'time': '1937-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          39:
              {
                'ts': -1018198800,
                'time': '1937-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          40:
              {
                'ts': -1000051200,
                'time': '1938-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          41:
              {
                'ts': -986749200,
                'time': '1938-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          42:
              {
                'ts': -967996800,
                'time': '1939-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          43:
              {
                'ts': -955299600,
                'time': '1939-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          44:
              {
                'ts': -936547200,
                'time': '1940-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          45:
              {
                'ts': -923245200,
                'time': '1940-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          46:
              {
                'ts': -905097600,
                'time': '1941-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          47:
              {
                'ts': -891795600,
                'time': '1941-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          48:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          49:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          50:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': -747244800,
                'time': '1946-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': -733942800,
                'time': '1946-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': -702493200,
                'time': '1947-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': -684345600,
                'time': '1948-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': -671043600,
                'time': '1948-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': -652896000,
                'time': '1949-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': -639594000,
                'time': '1949-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': -620841600,
                'time': '1950-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': -608144400,
                'time': '1950-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': -447267600,
                'time': '1955-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': -415818000,
                'time': '1956-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': -384368400,
                'time': '1957-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': -352918800,
                'time': '1958-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': -321469200,
                'time': '1959-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': -289414800,
                'time': '1960-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': -273686400,
                'time': '1961-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': -257965200,
                'time': '1961-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': -242236800,
                'time': '1962-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': -226515600,
                'time': '1962-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': -210787200,
                'time': '1963-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': -195066000,
                'time': '1963-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': -179337600,
                'time': '1964-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': -163616400,
                'time': '1964-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          89:
              {
                'ts': -147888000,
                'time': '1965-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': -131562000,
                'time': '1965-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': -116438400,
                'time': '1966-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': -100112400,
                'time': '1966-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': -84384000,
                'time': '1967-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': -68662800,
                'time': '1967-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': -52934400,
                'time': '1968-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': -37213200,
                'time': '1968-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': -21484800,
                'time': '1969-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': -5763600,
                'time': '1969-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 9964800,
                'time': '1970-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 25686000,
                'time': '1970-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 41414400,
                'time': '1971-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 57740400,
                'time': '1971-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 73468800,
                'time': '1972-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 89190000,
                'time': '1972-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 104918400,
                'time': '1973-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 120639600,
                'time': '1973-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 126691200,
                'time': '1974-01-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 162374400,
                'time': '1975-02-23T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 183538800,
                'time': '1975-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 199267200,
                'time': '1976-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 215593200,
                'time': '1976-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 230716800,
                'time': '1977-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 247042800,
                'time': '1977-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 262771200,
                'time': '1978-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 278492400,
                'time': '1978-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 294220800,
                'time': '1979-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 309942000,
                'time': '1979-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          120:
              {
                'ts': 341391600,
                'time': '1980-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          122:
              {
                'ts': 372841200,
                'time': '1981-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          124:
              {
                'ts': 404895600,
                'time': '1982-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          126:
              {
                'ts': 436345200,
                'time': '1983-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          128:
              {
                'ts': 467794800,
                'time': '1984-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          130:
              {
                'ts': 499244400,
                'time': '1985-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          132:
              {
                'ts': 530694000,
                'time': '1986-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          134:
              {
                'ts': 562143600,
                'time': '1987-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          136:
              {
                'ts': 594198000,
                'time': '1988-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          138:
              {
                'ts': 625647600,
                'time': '1989-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          140:
              {
                'ts': 657097200,
                'time': '1990-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          141:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          142:
              {
                'ts': 688546800,
                'time': '1991-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          143:
              {
                'ts': 702460800,
                'time': '1992-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          144:
              {
                'ts': 719996400,
                'time': '1992-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          145:
              {
                'ts': 733910400,
                'time': '1993-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          146:
              {
                'ts': 752050800,
                'time': '1993-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          147:
              {
                'ts': 765360000,
                'time': '1994-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          148:
              {
                'ts': 783500400,
                'time': '1994-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          149:
              {
                'ts': 796809600,
                'time': '1995-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          150:
              {
                'ts': 814950000,
                'time': '1995-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          151:
              {
                'ts': 828864000,
                'time': '1996-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          152:
              {
                'ts': 846399600,
                'time': '1996-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          153:
              {
                'ts': 860313600,
                'time': '1997-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          154:
              {
                'ts': 877849200,
                'time': '1997-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          155:
              {
                'ts': 891763200,
                'time': '1998-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          156:
              {
                'ts': 909298800,
                'time': '1998-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          157:
              {
                'ts': 923212800,
                'time': '1999-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          158:
              {
                'ts': 941353200,
                'time': '1999-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          159:
              {
                'ts': 954662400,
                'time': '2000-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          160:
              {
                'ts': 972802800,
                'time': '2000-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          161:
              {
                'ts': 986112000,
                'time': '2001-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          162:
              {
                'ts': 1004252400,
                'time': '2001-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          163:
              {
                'ts': 1018166400,
                'time': '2002-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          164:
              {
                'ts': 1035702000,
                'time': '2002-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          165:
              {
                'ts': 1049616000,
                'time': '2003-04-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          166:
              {
                'ts': 1067151600,
                'time': '2003-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          167:
              {
                'ts': 1081065600,
                'time': '2004-04-04T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          168:
              {
                'ts': 1099206000,
                'time': '2004-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          169:
              {
                'ts': 1112515200,
                'time': '2005-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          170:
              {
                'ts': 1130655600,
                'time': '2005-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          171:
              {
                'ts': 1143964800,
                'time': '2006-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          172:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          173:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          174:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          175:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          176:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          177:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          178:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          179:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          180:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          181:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          182:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          183:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          184:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          185:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          186:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          187:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          188:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          189:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          190:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          191:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          192:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          193:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          194:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          195:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          196:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          197:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          198:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          199:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          200:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          201:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          202:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          203:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          204:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          205:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          206:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          207:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          208:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          209:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          210:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          211:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          212:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          213:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          214:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          215:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          216:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          217:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          218:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          219:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          220:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          221:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          222:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          223:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          224:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          225:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          226:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          227:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          228:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          229:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          230:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          231:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          232:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          233:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          234:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'US/East-Indiana':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -900259200,
                'time': '1941-06-22T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          5:
              {
                'ts': -891795600,
                'time': '1941-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          6:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          7:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          8:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -747244800,
                'time': '1946-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -733942800,
                'time': '1946-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -702493200,
                'time': '1947-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -684345600,
                'time': '1948-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -671043600,
                'time': '1948-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -652896000,
                'time': '1949-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -639594000,
                'time': '1949-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -620841600,
                'time': '1950-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -608144400,
                'time': '1950-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          49:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          50:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          51:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          52:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          53:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          54:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          55:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          56:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          57:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          58:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          59:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          60:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          61:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          62:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          63:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          64:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          65:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          66:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          67:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          68:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          69:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          70:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          71:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          72:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          73:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          74:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          75:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          76:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          77:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          78:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          79:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          80:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          81:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          82:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          83:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          84:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          85:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          86:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          87:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          88:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          89:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          90:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          91:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          92:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          93:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          94:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          95:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          96:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          97:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'US/Eastern':
        {
          0:
              {
                'ts': -1633280400,
                'time': '1918-03-31T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          1:
              {
                'ts': -1615140000,
                'time': '1918-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -1601830800,
                'time': '1919-03-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          3:
              {
                'ts': -1583690400,
                'time': '1919-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          4:
              {
                'ts': -1570381200,
                'time': '1920-03-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          5:
              {
                'ts': -1551636000,
                'time': '1920-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          6:
              {
                'ts': -1536512400,
                'time': '1921-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          7:
              {
                'ts': -1523210400,
                'time': '1921-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          8:
              {
                'ts': -1504458000,
                'time': '1922-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          9:
              {
                'ts': -1491760800,
                'time': '1922-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          10:
              {
                'ts': -1473008400,
                'time': '1923-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          11:
              {
                'ts': -1459706400,
                'time': '1923-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          12:
              {
                'ts': -1441558800,
                'time': '1924-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          13:
              {
                'ts': -1428256800,
                'time': '1924-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          14:
              {
                'ts': -1410109200,
                'time': '1925-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          15:
              {
                'ts': -1396807200,
                'time': '1925-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          16:
              {
                'ts': -1378659600,
                'time': '1926-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          17:
              {
                'ts': -1365357600,
                'time': '1926-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          18:
              {
                'ts': -1347210000,
                'time': '1927-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          19:
              {
                'ts': -1333908000,
                'time': '1927-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          20:
              {
                'ts': -1315155600,
                'time': '1928-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          21:
              {
                'ts': -1301853600,
                'time': '1928-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          22:
              {
                'ts': -1283706000,
                'time': '1929-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          23:
              {
                'ts': -1270404000,
                'time': '1929-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          24:
              {
                'ts': -1252256400,
                'time': '1930-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          25:
              {
                'ts': -1238954400,
                'time': '1930-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          26:
              {
                'ts': -1220806800,
                'time': '1931-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          27:
              {
                'ts': -1207504800,
                'time': '1931-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          28:
              {
                'ts': -1189357200,
                'time': '1932-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          29:
              {
                'ts': -1176055200,
                'time': '1932-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          30:
              {
                'ts': -1157302800,
                'time': '1933-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          31:
              {
                'ts': -1144605600,
                'time': '1933-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          32:
              {
                'ts': -1125853200,
                'time': '1934-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          33:
              {
                'ts': -1112551200,
                'time': '1934-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          34:
              {
                'ts': -1094403600,
                'time': '1935-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          35:
              {
                'ts': -1081101600,
                'time': '1935-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          36:
              {
                'ts': -1062954000,
                'time': '1936-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          37:
              {
                'ts': -1049652000,
                'time': '1936-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': -1031504400,
                'time': '1937-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          39:
              {
                'ts': -1018202400,
                'time': '1937-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          40:
              {
                'ts': -1000054800,
                'time': '1938-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          41:
              {
                'ts': -986752800,
                'time': '1938-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          42:
              {
                'ts': -968000400,
                'time': '1939-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          43:
              {
                'ts': -955303200,
                'time': '1939-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          44:
              {
                'ts': -936550800,
                'time': '1940-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          45:
              {
                'ts': -923248800,
                'time': '1940-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          46:
              {
                'ts': -905101200,
                'time': '1941-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          47:
              {
                'ts': -891799200,
                'time': '1941-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          48:
              {
                'ts': -880218000,
                'time': '1942-02-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EWT'
              },
          49:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EPT'
              },
          50:
              {
                'ts': -765396000,
                'time': '1945-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          51:
              {
                'ts': -747248400,
                'time': '1946-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          52:
              {
                'ts': -733946400,
                'time': '1946-09-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          53:
              {
                'ts': -715798800,
                'time': '1947-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          54:
              {
                'ts': -702496800,
                'time': '1947-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          55:
              {
                'ts': -684349200,
                'time': '1948-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          56:
              {
                'ts': -671047200,
                'time': '1948-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          57:
              {
                'ts': -652899600,
                'time': '1949-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          58:
              {
                'ts': -639597600,
                'time': '1949-09-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          59:
              {
                'ts': -620845200,
                'time': '1950-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          60:
              {
                'ts': -608148000,
                'time': '1950-09-24T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          61:
              {
                'ts': -589395600,
                'time': '1951-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          62:
              {
                'ts': -576093600,
                'time': '1951-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          63:
              {
                'ts': -557946000,
                'time': '1952-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          64:
              {
                'ts': -544644000,
                'time': '1952-09-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          65:
              {
                'ts': -526496400,
                'time': '1953-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          66:
              {
                'ts': -513194400,
                'time': '1953-09-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          67:
              {
                'ts': -495046800,
                'time': '1954-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          68:
              {
                'ts': -481744800,
                'time': '1954-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          69:
              {
                'ts': -463597200,
                'time': '1955-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          70:
              {
                'ts': -447271200,
                'time': '1955-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          71:
              {
                'ts': -431542800,
                'time': '1956-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          72:
              {
                'ts': -415821600,
                'time': '1956-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': -400093200,
                'time': '1957-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': -384372000,
                'time': '1957-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': -368643600,
                'time': '1958-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': -352922400,
                'time': '1958-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': -337194000,
                'time': '1959-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': -321472800,
                'time': '1959-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': -305744400,
                'time': '1960-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': -289418400,
                'time': '1960-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': -273690000,
                'time': '1961-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': -257968800,
                'time': '1961-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': -242240400,
                'time': '1962-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': -226519200,
                'time': '1962-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': -210790800,
                'time': '1963-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': -195069600,
                'time': '1963-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': -179341200,
                'time': '1964-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': -163620000,
                'time': '1964-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': -147891600,
                'time': '1965-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': -131565600,
                'time': '1965-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': -116442000,
                'time': '1966-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': -100116000,
                'time': '1966-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': -84387600,
                'time': '1967-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': -68666400,
                'time': '1967-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': -52938000,
                'time': '1968-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': -37216800,
                'time': '1968-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': -21488400,
                'time': '1969-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': -5767200,
                'time': '1969-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 9961200,
                'time': '1970-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 25682400,
                'time': '1970-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 41410800,
                'time': '1971-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 57736800,
                'time': '1971-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 73465200,
                'time': '1972-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 89186400,
                'time': '1972-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 126687600,
                'time': '1974-01-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 162370800,
                'time': '1975-02-23T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          116:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          118:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          120:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          122:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          124:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          126:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          128:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          130:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          132:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          134:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          136:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          138:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          139:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          140:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          141:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          142:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          143:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          144:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          145:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          146:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          147:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          148:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          149:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          150:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          151:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          152:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          153:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          154:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          155:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          156:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          157:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          158:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          159:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          160:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          161:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          162:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          163:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          164:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          165:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          166:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          167:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          168:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          169:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          170:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          171:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          172:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          173:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          174:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          175:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          176:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          177:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          178:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          179:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          180:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          181:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          182:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          183:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          184:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          185:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          186:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          187:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          188:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          189:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          190:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          191:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          192:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          193:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          194:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          195:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          196:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          197:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          198:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          199:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          200:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          201:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          202:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          203:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          204:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          205:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          206:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          207:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          208:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          209:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          210:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          211:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          212:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          213:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          214:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          215:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          216:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          217:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          218:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          219:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          220:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          221:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          222:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          223:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          224:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          225:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          226:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          227:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          228:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          229:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          230:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          231:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          232:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          233:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          234:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'US/Hawaii':
        {
          0:
              {
                'ts': -1157283000,
                'time': '1933-04-30T12:30:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'HDT'
              },
          1:
              {
                'ts': -1155472200,
                'time': '1933-05-21T11:30:00+0000',
                'offset': -37800,
                'isdst': false,
                'abbr': 'HST'
              },
          2:
              {
                'ts': -880198200,
                'time': '1942-02-09T12:30:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'HWT'
              },
          3:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -34200,
                'isdst': true,
                'abbr': 'HPT'
              },
          4:
              {
                'ts': -765376200,
                'time': '1945-09-30T11:30:00+0000',
                'offset': -37800,
                'isdst': false,
                'abbr': 'HST'
              },
          5:
              {
                'ts': -712150200,
                'time': '1947-06-08T12:30:00+0000',
                'offset': -36000,
                'isdst': false,
                'abbr': 'HST'
              }
        },
    'US/Indiana-Starke':
        {
          0:
              {
                'ts': -1633276800,
                'time': '1918-03-31T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          1:
              {
                'ts': -1615136400,
                'time': '1918-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          2:
              {
                'ts': -1601827200,
                'time': '1919-03-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          3:
              {
                'ts': -1583686800,
                'time': '1919-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          4:
              {
                'ts': -880214400,
                'time': '1942-02-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CPT'
              },
          6:
              {
                'ts': -765392400,
                'time': '1945-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          7:
              {
                'ts': -715795200,
                'time': '1947-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          8:
              {
                'ts': -702493200,
                'time': '1947-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          9:
              {
                'ts': -684345600,
                'time': '1948-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          10:
              {
                'ts': -671043600,
                'time': '1948-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          11:
              {
                'ts': -652896000,
                'time': '1949-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          12:
              {
                'ts': -639594000,
                'time': '1949-09-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          13:
              {
                'ts': -620841600,
                'time': '1950-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          14:
              {
                'ts': -608144400,
                'time': '1950-09-24T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          15:
              {
                'ts': -589392000,
                'time': '1951-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          16:
              {
                'ts': -576090000,
                'time': '1951-09-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          17:
              {
                'ts': -557942400,
                'time': '1952-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          18:
              {
                'ts': -544640400,
                'time': '1952-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          19:
              {
                'ts': -526492800,
                'time': '1953-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          20:
              {
                'ts': -513190800,
                'time': '1953-09-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          21:
              {
                'ts': -495043200,
                'time': '1954-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          22:
              {
                'ts': -481741200,
                'time': '1954-09-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          23:
              {
                'ts': -463593600,
                'time': '1955-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          24:
              {
                'ts': -447267600,
                'time': '1955-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          25:
              {
                'ts': -431539200,
                'time': '1956-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          26:
              {
                'ts': -415818000,
                'time': '1956-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          27:
              {
                'ts': -400089600,
                'time': '1957-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          28:
              {
                'ts': -386787600,
                'time': '1957-09-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          29:
              {
                'ts': -368640000,
                'time': '1958-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          30:
              {
                'ts': -355338000,
                'time': '1958-09-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          31:
              {
                'ts': -337190400,
                'time': '1959-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          32:
              {
                'ts': -321469200,
                'time': '1959-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          33:
              {
                'ts': -305740800,
                'time': '1960-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          34:
              {
                'ts': -289414800,
                'time': '1960-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          35:
              {
                'ts': -273686400,
                'time': '1961-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          36:
              {
                'ts': -257965200,
                'time': '1961-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          37:
              {
                'ts': -242236800,
                'time': '1962-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          38:
              {
                'ts': -195066000,
                'time': '1963-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          39:
              {
                'ts': -84384000,
                'time': '1967-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          40:
              {
                'ts': -68662800,
                'time': '1967-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          41:
              {
                'ts': -52934400,
                'time': '1968-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          42:
              {
                'ts': -37213200,
                'time': '1968-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          43:
              {
                'ts': -21484800,
                'time': '1969-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          44:
              {
                'ts': -5763600,
                'time': '1969-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          45:
              {
                'ts': 9964800,
                'time': '1970-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          46:
              {
                'ts': 25686000,
                'time': '1970-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          47:
              {
                'ts': 41414400,
                'time': '1971-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          48:
              {
                'ts': 57740400,
                'time': '1971-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          49:
              {
                'ts': 73468800,
                'time': '1972-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          50:
              {
                'ts': 89190000,
                'time': '1972-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          51:
              {
                'ts': 104918400,
                'time': '1973-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          52:
              {
                'ts': 120639600,
                'time': '1973-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          53:
              {
                'ts': 126691200,
                'time': '1974-01-06T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          54:
              {
                'ts': 152089200,
                'time': '1974-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          55:
              {
                'ts': 162374400,
                'time': '1975-02-23T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          56:
              {
                'ts': 183538800,
                'time': '1975-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          57:
              {
                'ts': 199267200,
                'time': '1976-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          58:
              {
                'ts': 215593200,
                'time': '1976-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          59:
              {
                'ts': 230716800,
                'time': '1977-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          60:
              {
                'ts': 247042800,
                'time': '1977-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          61:
              {
                'ts': 262771200,
                'time': '1978-04-30T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          62:
              {
                'ts': 278492400,
                'time': '1978-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          63:
              {
                'ts': 294220800,
                'time': '1979-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          64:
              {
                'ts': 309942000,
                'time': '1979-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          65:
              {
                'ts': 325670400,
                'time': '1980-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          66:
              {
                'ts': 341391600,
                'time': '1980-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          67:
              {
                'ts': 357120000,
                'time': '1981-04-26T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          68:
              {
                'ts': 372841200,
                'time': '1981-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          69:
              {
                'ts': 388569600,
                'time': '1982-04-25T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          70:
              {
                'ts': 404895600,
                'time': '1982-10-31T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          71:
              {
                'ts': 420019200,
                'time': '1983-04-24T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          72:
              {
                'ts': 436345200,
                'time': '1983-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          73:
              {
                'ts': 452073600,
                'time': '1984-04-29T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          74:
              {
                'ts': 467794800,
                'time': '1984-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          75:
              {
                'ts': 483523200,
                'time': '1985-04-28T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          76:
              {
                'ts': 499244400,
                'time': '1985-10-27T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          77:
              {
                'ts': 514972800,
                'time': '1986-04-27T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          78:
              {
                'ts': 530694000,
                'time': '1986-10-26T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          79:
              {
                'ts': 544608000,
                'time': '1987-04-05T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          80:
              {
                'ts': 562143600,
                'time': '1987-10-25T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          81:
              {
                'ts': 576057600,
                'time': '1988-04-03T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          82:
              {
                'ts': 594198000,
                'time': '1988-10-30T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          83:
              {
                'ts': 607507200,
                'time': '1989-04-02T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          84:
              {
                'ts': 625647600,
                'time': '1989-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          85:
              {
                'ts': 638956800,
                'time': '1990-04-01T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          86:
              {
                'ts': 657097200,
                'time': '1990-10-28T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          87:
              {
                'ts': 671011200,
                'time': '1991-04-07T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          88:
              {
                'ts': 688546800,
                'time': '1991-10-27T07:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          90:
              {
                'ts': 1162105200,
                'time': '2006-10-29T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          91:
              {
                'ts': 1173600000,
                'time': '2007-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          92:
              {
                'ts': 1194159600,
                'time': '2007-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          93:
              {
                'ts': 1205049600,
                'time': '2008-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          94:
              {
                'ts': 1225609200,
                'time': '2008-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          95:
              {
                'ts': 1236499200,
                'time': '2009-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          96:
              {
                'ts': 1257058800,
                'time': '2009-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          97:
              {
                'ts': 1268553600,
                'time': '2010-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          98:
              {
                'ts': 1289113200,
                'time': '2010-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          99:
              {
                'ts': 1300003200,
                'time': '2011-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          100:
              {
                'ts': 1320562800,
                'time': '2011-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          101:
              {
                'ts': 1331452800,
                'time': '2012-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          102:
              {
                'ts': 1352012400,
                'time': '2012-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          103:
              {
                'ts': 1362902400,
                'time': '2013-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          104:
              {
                'ts': 1383462000,
                'time': '2013-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          105:
              {
                'ts': 1394352000,
                'time': '2014-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          106:
              {
                'ts': 1414911600,
                'time': '2014-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          107:
              {
                'ts': 1425801600,
                'time': '2015-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          108:
              {
                'ts': 1446361200,
                'time': '2015-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          109:
              {
                'ts': 1457856000,
                'time': '2016-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          110:
              {
                'ts': 1478415600,
                'time': '2016-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          111:
              {
                'ts': 1489305600,
                'time': '2017-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          112:
              {
                'ts': 1509865200,
                'time': '2017-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          113:
              {
                'ts': 1520755200,
                'time': '2018-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          114:
              {
                'ts': 1541314800,
                'time': '2018-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          115:
              {
                'ts': 1552204800,
                'time': '2019-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          116:
              {
                'ts': 1572764400,
                'time': '2019-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          117:
              {
                'ts': 1583654400,
                'time': '2020-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          118:
              {
                'ts': 1604214000,
                'time': '2020-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          119:
              {
                'ts': 1615708800,
                'time': '2021-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          120:
              {
                'ts': 1636268400,
                'time': '2021-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          121:
              {
                'ts': 1647158400,
                'time': '2022-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          122:
              {
                'ts': 1667718000,
                'time': '2022-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          123:
              {
                'ts': 1678608000,
                'time': '2023-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          124:
              {
                'ts': 1699167600,
                'time': '2023-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          125:
              {
                'ts': 1710057600,
                'time': '2024-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          126:
              {
                'ts': 1730617200,
                'time': '2024-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          127:
              {
                'ts': 1741507200,
                'time': '2025-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          128:
              {
                'ts': 1762066800,
                'time': '2025-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          129:
              {
                'ts': 1772956800,
                'time': '2026-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          130:
              {
                'ts': 1793516400,
                'time': '2026-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          131:
              {
                'ts': 1805011200,
                'time': '2027-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          132:
              {
                'ts': 1825570800,
                'time': '2027-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          133:
              {
                'ts': 1836460800,
                'time': '2028-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          134:
              {
                'ts': 1857020400,
                'time': '2028-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          135:
              {
                'ts': 1867910400,
                'time': '2029-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          136:
              {
                'ts': 1888470000,
                'time': '2029-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          137:
              {
                'ts': 1899360000,
                'time': '2030-03-10T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          138:
              {
                'ts': 1919919600,
                'time': '2030-11-03T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          139:
              {
                'ts': 1930809600,
                'time': '2031-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          140:
              {
                'ts': 1951369200,
                'time': '2031-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          141:
              {
                'ts': 1962864000,
                'time': '2032-03-14T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          142:
              {
                'ts': 1983423600,
                'time': '2032-11-07T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          143:
              {
                'ts': 1994313600,
                'time': '2033-03-13T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          144:
              {
                'ts': 2014873200,
                'time': '2033-11-06T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          145:
              {
                'ts': 2025763200,
                'time': '2034-03-12T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          146:
              {
                'ts': 2046322800,
                'time': '2034-11-05T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          147:
              {
                'ts': 2057212800,
                'time': '2035-03-11T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          148:
              {
                'ts': 2077772400,
                'time': '2035-11-04T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          149:
              {
                'ts': 2088662400,
                'time': '2036-03-09T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          150:
              {
                'ts': 2109222000,
                'time': '2036-11-02T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          151:
              {
                'ts': 2120112000,
                'time': '2037-03-08T08:00:00+0000',
                'offset': -18000,
                'isdst': true,
                'abbr': 'CDT'
              },
          152:
              {
                'ts': 2140671600,
                'time': '2037-11-01T07:00:00+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              }
        },
    'US/Michigan':
        {
          0:
              {
                'ts': -2051202469,
                'time': '1905-01-01T05:32:11+0000',
                'offset': -21600,
                'isdst': false,
                'abbr': 'CST'
              },
          1:
              {
                'ts': -1724083200,
                'time': '1915-05-15T08:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          2:
              {
                'ts': -880218000,
                'time': '1942-02-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EWT'
              },
          3:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EPT'
              },
          4:
              {
                'ts': -765396000,
                'time': '1945-09-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          5:
              {
                'ts': -684349200,
                'time': '1948-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          6:
              {
                'ts': -671047200,
                'time': '1948-09-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          7:
              {
                'ts': -80499600,
                'time': '1967-06-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          8:
              {
                'ts': -68666400,
                'time': '1967-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          9:
              {
                'ts': 104914800,
                'time': '1973-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          10:
              {
                'ts': 120636000,
                'time': '1973-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          11:
              {
                'ts': 126687600,
                'time': '1974-01-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          12:
              {
                'ts': 152085600,
                'time': '1974-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          13:
              {
                'ts': 167814000,
                'time': '1975-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          14:
              {
                'ts': 183535200,
                'time': '1975-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          15:
              {
                'ts': 199263600,
                'time': '1976-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          16:
              {
                'ts': 215589600,
                'time': '1976-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          17:
              {
                'ts': 230713200,
                'time': '1977-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          18:
              {
                'ts': 247039200,
                'time': '1977-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          19:
              {
                'ts': 262767600,
                'time': '1978-04-30T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          20:
              {
                'ts': 278488800,
                'time': '1978-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          21:
              {
                'ts': 294217200,
                'time': '1979-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          22:
              {
                'ts': 309938400,
                'time': '1979-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          23:
              {
                'ts': 325666800,
                'time': '1980-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          24:
              {
                'ts': 341388000,
                'time': '1980-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          25:
              {
                'ts': 357116400,
                'time': '1981-04-26T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          26:
              {
                'ts': 372837600,
                'time': '1981-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          27:
              {
                'ts': 388566000,
                'time': '1982-04-25T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          28:
              {
                'ts': 404892000,
                'time': '1982-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          29:
              {
                'ts': 420015600,
                'time': '1983-04-24T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          30:
              {
                'ts': 436341600,
                'time': '1983-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          31:
              {
                'ts': 452070000,
                'time': '1984-04-29T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          32:
              {
                'ts': 467791200,
                'time': '1984-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          33:
              {
                'ts': 483519600,
                'time': '1985-04-28T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          34:
              {
                'ts': 499240800,
                'time': '1985-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          35:
              {
                'ts': 514969200,
                'time': '1986-04-27T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          36:
              {
                'ts': 530690400,
                'time': '1986-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          37:
              {
                'ts': 544604400,
                'time': '1987-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          38:
              {
                'ts': 562140000,
                'time': '1987-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          39:
              {
                'ts': 576054000,
                'time': '1988-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          40:
              {
                'ts': 594194400,
                'time': '1988-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          41:
              {
                'ts': 607503600,
                'time': '1989-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          42:
              {
                'ts': 625644000,
                'time': '1989-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          43:
              {
                'ts': 638953200,
                'time': '1990-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          44:
              {
                'ts': 657093600,
                'time': '1990-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          45:
              {
                'ts': 671007600,
                'time': '1991-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          46:
              {
                'ts': 688543200,
                'time': '1991-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          47:
              {
                'ts': 702457200,
                'time': '1992-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          48:
              {
                'ts': 719992800,
                'time': '1992-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          49:
              {
                'ts': 733906800,
                'time': '1993-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          50:
              {
                'ts': 752047200,
                'time': '1993-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          51:
              {
                'ts': 765356400,
                'time': '1994-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          52:
              {
                'ts': 783496800,
                'time': '1994-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          53:
              {
                'ts': 796806000,
                'time': '1995-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          54:
              {
                'ts': 814946400,
                'time': '1995-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          55:
              {
                'ts': 828860400,
                'time': '1996-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          56:
              {
                'ts': 846396000,
                'time': '1996-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          57:
              {
                'ts': 860310000,
                'time': '1997-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          58:
              {
                'ts': 877845600,
                'time': '1997-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          59:
              {
                'ts': 891759600,
                'time': '1998-04-05T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          60:
              {
                'ts': 909295200,
                'time': '1998-10-25T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          61:
              {
                'ts': 923209200,
                'time': '1999-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          62:
              {
                'ts': 941349600,
                'time': '1999-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          63:
              {
                'ts': 954658800,
                'time': '2000-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          64:
              {
                'ts': 972799200,
                'time': '2000-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          65:
              {
                'ts': 986108400,
                'time': '2001-04-01T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          66:
              {
                'ts': 1004248800,
                'time': '2001-10-28T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          67:
              {
                'ts': 1018162800,
                'time': '2002-04-07T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          68:
              {
                'ts': 1035698400,
                'time': '2002-10-27T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          69:
              {
                'ts': 1049612400,
                'time': '2003-04-06T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          70:
              {
                'ts': 1067148000,
                'time': '2003-10-26T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          71:
              {
                'ts': 1081062000,
                'time': '2004-04-04T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          72:
              {
                'ts': 1099202400,
                'time': '2004-10-31T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          73:
              {
                'ts': 1112511600,
                'time': '2005-04-03T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          74:
              {
                'ts': 1130652000,
                'time': '2005-10-30T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          75:
              {
                'ts': 1143961200,
                'time': '2006-04-02T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          76:
              {
                'ts': 1162101600,
                'time': '2006-10-29T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          77:
              {
                'ts': 1173596400,
                'time': '2007-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          78:
              {
                'ts': 1194156000,
                'time': '2007-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          79:
              {
                'ts': 1205046000,
                'time': '2008-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          80:
              {
                'ts': 1225605600,
                'time': '2008-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          81:
              {
                'ts': 1236495600,
                'time': '2009-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          82:
              {
                'ts': 1257055200,
                'time': '2009-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          83:
              {
                'ts': 1268550000,
                'time': '2010-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          84:
              {
                'ts': 1289109600,
                'time': '2010-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          85:
              {
                'ts': 1299999600,
                'time': '2011-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          86:
              {
                'ts': 1320559200,
                'time': '2011-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          87:
              {
                'ts': 1331449200,
                'time': '2012-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          88:
              {
                'ts': 1352008800,
                'time': '2012-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          89:
              {
                'ts': 1362898800,
                'time': '2013-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          90:
              {
                'ts': 1383458400,
                'time': '2013-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          91:
              {
                'ts': 1394348400,
                'time': '2014-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          92:
              {
                'ts': 1414908000,
                'time': '2014-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          93:
              {
                'ts': 1425798000,
                'time': '2015-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          94:
              {
                'ts': 1446357600,
                'time': '2015-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          95:
              {
                'ts': 1457852400,
                'time': '2016-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          96:
              {
                'ts': 1478412000,
                'time': '2016-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          97:
              {
                'ts': 1489302000,
                'time': '2017-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          98:
              {
                'ts': 1509861600,
                'time': '2017-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          99:
              {
                'ts': 1520751600,
                'time': '2018-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          100:
              {
                'ts': 1541311200,
                'time': '2018-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          101:
              {
                'ts': 1552201200,
                'time': '2019-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          102:
              {
                'ts': 1572760800,
                'time': '2019-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          103:
              {
                'ts': 1583650800,
                'time': '2020-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          104:
              {
                'ts': 1604210400,
                'time': '2020-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          105:
              {
                'ts': 1615705200,
                'time': '2021-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          106:
              {
                'ts': 1636264800,
                'time': '2021-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          107:
              {
                'ts': 1647154800,
                'time': '2022-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          108:
              {
                'ts': 1667714400,
                'time': '2022-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          109:
              {
                'ts': 1678604400,
                'time': '2023-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          110:
              {
                'ts': 1699164000,
                'time': '2023-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          111:
              {
                'ts': 1710054000,
                'time': '2024-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          112:
              {
                'ts': 1730613600,
                'time': '2024-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          113:
              {
                'ts': 1741503600,
                'time': '2025-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          114:
              {
                'ts': 1762063200,
                'time': '2025-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          115:
              {
                'ts': 1772953200,
                'time': '2026-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          116:
              {
                'ts': 1793512800,
                'time': '2026-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          117:
              {
                'ts': 1805007600,
                'time': '2027-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          118:
              {
                'ts': 1825567200,
                'time': '2027-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          119:
              {
                'ts': 1836457200,
                'time': '2028-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          120:
              {
                'ts': 1857016800,
                'time': '2028-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          121:
              {
                'ts': 1867906800,
                'time': '2029-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          122:
              {
                'ts': 1888466400,
                'time': '2029-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          123:
              {
                'ts': 1899356400,
                'time': '2030-03-10T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          124:
              {
                'ts': 1919916000,
                'time': '2030-11-03T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          125:
              {
                'ts': 1930806000,
                'time': '2031-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          126:
              {
                'ts': 1951365600,
                'time': '2031-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          127:
              {
                'ts': 1962860400,
                'time': '2032-03-14T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          128:
              {
                'ts': 1983420000,
                'time': '2032-11-07T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          129:
              {
                'ts': 1994310000,
                'time': '2033-03-13T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          130:
              {
                'ts': 2014869600,
                'time': '2033-11-06T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          131:
              {
                'ts': 2025759600,
                'time': '2034-03-12T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          132:
              {
                'ts': 2046319200,
                'time': '2034-11-05T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          133:
              {
                'ts': 2057209200,
                'time': '2035-03-11T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          134:
              {
                'ts': 2077768800,
                'time': '2035-11-04T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          135:
              {
                'ts': 2088658800,
                'time': '2036-03-09T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          136:
              {
                'ts': 2109218400,
                'time': '2036-11-02T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              },
          137:
              {
                'ts': 2120108400,
                'time': '2037-03-08T07:00:00+0000',
                'offset': -14400,
                'isdst': true,
                'abbr': 'EDT'
              },
          138:
              {
                'ts': 2140668000,
                'time': '2037-11-01T06:00:00+0000',
                'offset': -18000,
                'isdst': false,
                'abbr': 'EST'
              }
        },
    'US/Mountain':
        {
          0:
              {
                'ts': -1633273200,
                'time': '1918-03-31T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          1:
              {
                'ts': -1615132800,
                'time': '1918-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          2:
              {
                'ts': -1601823600,
                'time': '1919-03-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          3:
              {
                'ts': -1583683200,
                'time': '1919-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          4:
              {
                'ts': -1570374000,
                'time': '1920-03-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          5:
              {
                'ts': -1551628800,
                'time': '1920-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          6:
              {
                'ts': -1538924400,
                'time': '1921-03-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          7:
              {
                'ts': -1534089600,
                'time': '1921-05-22T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          8:
              {
                'ts': -880210800,
                'time': '1942-02-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MWT'
              },
          9:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MPT'
              },
          10:
              {
                'ts': -765388800,
                'time': '1945-09-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          11:
              {
                'ts': -147884400,
                'time': '1965-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          12:
              {
                'ts': -131558400,
                'time': '1965-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          13:
              {
                'ts': -116434800,
                'time': '1966-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          14:
              {
                'ts': -100108800,
                'time': '1966-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          15:
              {
                'ts': -84380400,
                'time': '1967-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          16:
              {
                'ts': -68659200,
                'time': '1967-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          17:
              {
                'ts': -52930800,
                'time': '1968-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          18:
              {
                'ts': -37209600,
                'time': '1968-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          19:
              {
                'ts': -21481200,
                'time': '1969-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          20:
              {
                'ts': -5760000,
                'time': '1969-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          21:
              {
                'ts': 9968400,
                'time': '1970-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          22:
              {
                'ts': 25689600,
                'time': '1970-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          23:
              {
                'ts': 41418000,
                'time': '1971-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          24:
              {
                'ts': 57744000,
                'time': '1971-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          25:
              {
                'ts': 73472400,
                'time': '1972-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          26:
              {
                'ts': 89193600,
                'time': '1972-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          27:
              {
                'ts': 104922000,
                'time': '1973-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          28:
              {
                'ts': 120643200,
                'time': '1973-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          29:
              {
                'ts': 126694800,
                'time': '1974-01-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          30:
              {
                'ts': 152092800,
                'time': '1974-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          31:
              {
                'ts': 162378000,
                'time': '1975-02-23T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          32:
              {
                'ts': 183542400,
                'time': '1975-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          33:
              {
                'ts': 199270800,
                'time': '1976-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          34:
              {
                'ts': 215596800,
                'time': '1976-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          35:
              {
                'ts': 230720400,
                'time': '1977-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          36:
              {
                'ts': 247046400,
                'time': '1977-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          37:
              {
                'ts': 262774800,
                'time': '1978-04-30T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          38:
              {
                'ts': 278496000,
                'time': '1978-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          39:
              {
                'ts': 294224400,
                'time': '1979-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          40:
              {
                'ts': 309945600,
                'time': '1979-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          41:
              {
                'ts': 325674000,
                'time': '1980-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          42:
              {
                'ts': 341395200,
                'time': '1980-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          43:
              {
                'ts': 357123600,
                'time': '1981-04-26T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          44:
              {
                'ts': 372844800,
                'time': '1981-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          45:
              {
                'ts': 388573200,
                'time': '1982-04-25T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          46:
              {
                'ts': 404899200,
                'time': '1982-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          47:
              {
                'ts': 420022800,
                'time': '1983-04-24T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          48:
              {
                'ts': 436348800,
                'time': '1983-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          49:
              {
                'ts': 452077200,
                'time': '1984-04-29T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          50:
              {
                'ts': 467798400,
                'time': '1984-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          51:
              {
                'ts': 483526800,
                'time': '1985-04-28T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          52:
              {
                'ts': 499248000,
                'time': '1985-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          53:
              {
                'ts': 514976400,
                'time': '1986-04-27T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          54:
              {
                'ts': 530697600,
                'time': '1986-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          55:
              {
                'ts': 544611600,
                'time': '1987-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          56:
              {
                'ts': 562147200,
                'time': '1987-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          57:
              {
                'ts': 576061200,
                'time': '1988-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          58:
              {
                'ts': 594201600,
                'time': '1988-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          59:
              {
                'ts': 607510800,
                'time': '1989-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          60:
              {
                'ts': 625651200,
                'time': '1989-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          61:
              {
                'ts': 638960400,
                'time': '1990-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          62:
              {
                'ts': 657100800,
                'time': '1990-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          63:
              {
                'ts': 671014800,
                'time': '1991-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          64:
              {
                'ts': 688550400,
                'time': '1991-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          65:
              {
                'ts': 702464400,
                'time': '1992-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          66:
              {
                'ts': 720000000,
                'time': '1992-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          67:
              {
                'ts': 733914000,
                'time': '1993-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          68:
              {
                'ts': 752054400,
                'time': '1993-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          69:
              {
                'ts': 765363600,
                'time': '1994-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          70:
              {
                'ts': 783504000,
                'time': '1994-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          71:
              {
                'ts': 796813200,
                'time': '1995-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          72:
              {
                'ts': 814953600,
                'time': '1995-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          73:
              {
                'ts': 828867600,
                'time': '1996-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          74:
              {
                'ts': 846403200,
                'time': '1996-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          75:
              {
                'ts': 860317200,
                'time': '1997-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          76:
              {
                'ts': 877852800,
                'time': '1997-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          77:
              {
                'ts': 891766800,
                'time': '1998-04-05T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          78:
              {
                'ts': 909302400,
                'time': '1998-10-25T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          79:
              {
                'ts': 923216400,
                'time': '1999-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          80:
              {
                'ts': 941356800,
                'time': '1999-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          81:
              {
                'ts': 954666000,
                'time': '2000-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          82:
              {
                'ts': 972806400,
                'time': '2000-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          83:
              {
                'ts': 986115600,
                'time': '2001-04-01T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          84:
              {
                'ts': 1004256000,
                'time': '2001-10-28T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          85:
              {
                'ts': 1018170000,
                'time': '2002-04-07T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          86:
              {
                'ts': 1035705600,
                'time': '2002-10-27T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          87:
              {
                'ts': 1049619600,
                'time': '2003-04-06T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          88:
              {
                'ts': 1067155200,
                'time': '2003-10-26T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          89:
              {
                'ts': 1081069200,
                'time': '2004-04-04T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          90:
              {
                'ts': 1099209600,
                'time': '2004-10-31T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          91:
              {
                'ts': 1112518800,
                'time': '2005-04-03T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          92:
              {
                'ts': 1130659200,
                'time': '2005-10-30T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          93:
              {
                'ts': 1143968400,
                'time': '2006-04-02T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          94:
              {
                'ts': 1162108800,
                'time': '2006-10-29T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          95:
              {
                'ts': 1173603600,
                'time': '2007-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          96:
              {
                'ts': 1194163200,
                'time': '2007-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          97:
              {
                'ts': 1205053200,
                'time': '2008-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          98:
              {
                'ts': 1225612800,
                'time': '2008-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          99:
              {
                'ts': 1236502800,
                'time': '2009-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          100:
              {
                'ts': 1257062400,
                'time': '2009-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          101:
              {
                'ts': 1268557200,
                'time': '2010-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          102:
              {
                'ts': 1289116800,
                'time': '2010-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          103:
              {
                'ts': 1300006800,
                'time': '2011-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          104:
              {
                'ts': 1320566400,
                'time': '2011-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          105:
              {
                'ts': 1331456400,
                'time': '2012-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          106:
              {
                'ts': 1352016000,
                'time': '2012-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          107:
              {
                'ts': 1362906000,
                'time': '2013-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          108:
              {
                'ts': 1383465600,
                'time': '2013-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          109:
              {
                'ts': 1394355600,
                'time': '2014-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          110:
              {
                'ts': 1414915200,
                'time': '2014-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          111:
              {
                'ts': 1425805200,
                'time': '2015-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          112:
              {
                'ts': 1446364800,
                'time': '2015-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          113:
              {
                'ts': 1457859600,
                'time': '2016-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          114:
              {
                'ts': 1478419200,
                'time': '2016-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          115:
              {
                'ts': 1489309200,
                'time': '2017-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          116:
              {
                'ts': 1509868800,
                'time': '2017-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          117:
              {
                'ts': 1520758800,
                'time': '2018-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          118:
              {
                'ts': 1541318400,
                'time': '2018-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          119:
              {
                'ts': 1552208400,
                'time': '2019-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          120:
              {
                'ts': 1572768000,
                'time': '2019-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          121:
              {
                'ts': 1583658000,
                'time': '2020-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          122:
              {
                'ts': 1604217600,
                'time': '2020-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          123:
              {
                'ts': 1615712400,
                'time': '2021-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          124:
              {
                'ts': 1636272000,
                'time': '2021-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          125:
              {
                'ts': 1647162000,
                'time': '2022-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          126:
              {
                'ts': 1667721600,
                'time': '2022-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          127:
              {
                'ts': 1678611600,
                'time': '2023-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          128:
              {
                'ts': 1699171200,
                'time': '2023-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          129:
              {
                'ts': 1710061200,
                'time': '2024-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          130:
              {
                'ts': 1730620800,
                'time': '2024-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          131:
              {
                'ts': 1741510800,
                'time': '2025-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          132:
              {
                'ts': 1762070400,
                'time': '2025-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          133:
              {
                'ts': 1772960400,
                'time': '2026-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          134:
              {
                'ts': 1793520000,
                'time': '2026-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          135:
              {
                'ts': 1805014800,
                'time': '2027-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          136:
              {
                'ts': 1825574400,
                'time': '2027-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          137:
              {
                'ts': 1836464400,
                'time': '2028-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          138:
              {
                'ts': 1857024000,
                'time': '2028-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          139:
              {
                'ts': 1867914000,
                'time': '2029-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          140:
              {
                'ts': 1888473600,
                'time': '2029-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          141:
              {
                'ts': 1899363600,
                'time': '2030-03-10T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          142:
              {
                'ts': 1919923200,
                'time': '2030-11-03T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          143:
              {
                'ts': 1930813200,
                'time': '2031-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          144:
              {
                'ts': 1951372800,
                'time': '2031-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          145:
              {
                'ts': 1962867600,
                'time': '2032-03-14T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          146:
              {
                'ts': 1983427200,
                'time': '2032-11-07T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          147:
              {
                'ts': 1994317200,
                'time': '2033-03-13T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          148:
              {
                'ts': 2014876800,
                'time': '2033-11-06T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          149:
              {
                'ts': 2025766800,
                'time': '2034-03-12T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          150:
              {
                'ts': 2046326400,
                'time': '2034-11-05T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          151:
              {
                'ts': 2057216400,
                'time': '2035-03-11T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          152:
              {
                'ts': 2077776000,
                'time': '2035-11-04T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          153:
              {
                'ts': 2088666000,
                'time': '2036-03-09T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          154:
              {
                'ts': 2109225600,
                'time': '2036-11-02T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              },
          155:
              {
                'ts': 2120115600,
                'time': '2037-03-08T09:00:00+0000',
                'offset': -21600,
                'isdst': true,
                'abbr': 'MDT'
              },
          156:
              {
                'ts': 2140675200,
                'time': '2037-11-01T08:00:00+0000',
                'offset': -25200,
                'isdst': false,
                'abbr': 'MST'
              }
        },
    'US/Pacific':
        {
          0:
              {
                'ts': -1633269600,
                'time': '1918-03-31T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          1:
              {
                'ts': -1615129200,
                'time': '1918-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          2:
              {
                'ts': -1601820000,
                'time': '1919-03-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          3:
              {
                'ts': -1583679600,
                'time': '1919-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          4:
              {
                'ts': -880207200,
                'time': '1942-02-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PPT'
              },
          6:
              {
                'ts': -765385200,
                'time': '1945-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          7:
              {
                'ts': -687967200,
                'time': '1948-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          8:
              {
                'ts': -662655600,
                'time': '1949-01-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          9:
              {
                'ts': -620834400,
                'time': '1950-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          10:
              {
                'ts': -608137200,
                'time': '1950-09-24T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          11:
              {
                'ts': -589384800,
                'time': '1951-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          12:
              {
                'ts': -576082800,
                'time': '1951-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          13:
              {
                'ts': -557935200,
                'time': '1952-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          14:
              {
                'ts': -544633200,
                'time': '1952-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          15:
              {
                'ts': -526485600,
                'time': '1953-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          16:
              {
                'ts': -513183600,
                'time': '1953-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          17:
              {
                'ts': -495036000,
                'time': '1954-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          18:
              {
                'ts': -481734000,
                'time': '1954-09-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          19:
              {
                'ts': -463586400,
                'time': '1955-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          20:
              {
                'ts': -450284400,
                'time': '1955-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          21:
              {
                'ts': -431532000,
                'time': '1956-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          22:
              {
                'ts': -418230000,
                'time': '1956-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          23:
              {
                'ts': -400082400,
                'time': '1957-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          24:
              {
                'ts': -386780400,
                'time': '1957-09-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          25:
              {
                'ts': -368632800,
                'time': '1958-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          26:
              {
                'ts': -355330800,
                'time': '1958-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          27:
              {
                'ts': -337183200,
                'time': '1959-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          28:
              {
                'ts': -323881200,
                'time': '1959-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          29:
              {
                'ts': -305733600,
                'time': '1960-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          30:
              {
                'ts': -292431600,
                'time': '1960-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          31:
              {
                'ts': -273679200,
                'time': '1961-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          32:
              {
                'ts': -260982000,
                'time': '1961-09-24T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          33:
              {
                'ts': -242229600,
                'time': '1962-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          34:
              {
                'ts': -226508400,
                'time': '1962-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          35:
              {
                'ts': -210780000,
                'time': '1963-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          36:
              {
                'ts': -195058800,
                'time': '1963-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          37:
              {
                'ts': -179330400,
                'time': '1964-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          38:
              {
                'ts': -163609200,
                'time': '1964-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          39:
              {
                'ts': -147880800,
                'time': '1965-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          40:
              {
                'ts': -131554800,
                'time': '1965-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          41:
              {
                'ts': -116431200,
                'time': '1966-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          42:
              {
                'ts': -100105200,
                'time': '1966-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          43:
              {
                'ts': -84376800,
                'time': '1967-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          44:
              {
                'ts': -68655600,
                'time': '1967-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          45:
              {
                'ts': -52927200,
                'time': '1968-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          46:
              {
                'ts': -37206000,
                'time': '1968-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          47:
              {
                'ts': -21477600,
                'time': '1969-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          48:
              {
                'ts': -5756400,
                'time': '1969-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          49:
              {
                'ts': 9972000,
                'time': '1970-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          50:
              {
                'ts': 25693200,
                'time': '1970-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          51:
              {
                'ts': 41421600,
                'time': '1971-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          52:
              {
                'ts': 57747600,
                'time': '1971-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          53:
              {
                'ts': 73476000,
                'time': '1972-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          54:
              {
                'ts': 89197200,
                'time': '1972-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          55:
              {
                'ts': 104925600,
                'time': '1973-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          56:
              {
                'ts': 120646800,
                'time': '1973-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          57:
              {
                'ts': 126698400,
                'time': '1974-01-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          58:
              {
                'ts': 152096400,
                'time': '1974-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          59:
              {
                'ts': 162381600,
                'time': '1975-02-23T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          60:
              {
                'ts': 183546000,
                'time': '1975-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          61:
              {
                'ts': 199274400,
                'time': '1976-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          62:
              {
                'ts': 215600400,
                'time': '1976-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          63:
              {
                'ts': 230724000,
                'time': '1977-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          64:
              {
                'ts': 247050000,
                'time': '1977-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          65:
              {
                'ts': 262778400,
                'time': '1978-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          66:
              {
                'ts': 278499600,
                'time': '1978-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          67:
              {
                'ts': 294228000,
                'time': '1979-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          68:
              {
                'ts': 309949200,
                'time': '1979-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          69:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          70:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          71:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          72:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          73:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          74:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          75:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          76:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          77:
              {
                'ts': 452080800,
                'time': '1984-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          78:
              {
                'ts': 467802000,
                'time': '1984-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          79:
              {
                'ts': 483530400,
                'time': '1985-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          80:
              {
                'ts': 499251600,
                'time': '1985-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          81:
              {
                'ts': 514980000,
                'time': '1986-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          82:
              {
                'ts': 530701200,
                'time': '1986-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          83:
              {
                'ts': 544615200,
                'time': '1987-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          84:
              {
                'ts': 562150800,
                'time': '1987-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          85:
              {
                'ts': 576064800,
                'time': '1988-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          86:
              {
                'ts': 594205200,
                'time': '1988-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          87:
              {
                'ts': 607514400,
                'time': '1989-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          88:
              {
                'ts': 625654800,
                'time': '1989-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          89:
              {
                'ts': 638964000,
                'time': '1990-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          90:
              {
                'ts': 657104400,
                'time': '1990-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          91:
              {
                'ts': 671018400,
                'time': '1991-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          92:
              {
                'ts': 688554000,
                'time': '1991-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          93:
              {
                'ts': 702468000,
                'time': '1992-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          94:
              {
                'ts': 720003600,
                'time': '1992-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          95:
              {
                'ts': 733917600,
                'time': '1993-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          96:
              {
                'ts': 752058000,
                'time': '1993-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          97:
              {
                'ts': 765367200,
                'time': '1994-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          98:
              {
                'ts': 783507600,
                'time': '1994-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          99:
              {
                'ts': 796816800,
                'time': '1995-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          100:
              {
                'ts': 814957200,
                'time': '1995-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          101:
              {
                'ts': 828871200,
                'time': '1996-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          102:
              {
                'ts': 846406800,
                'time': '1996-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          103:
              {
                'ts': 860320800,
                'time': '1997-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          104:
              {
                'ts': 877856400,
                'time': '1997-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          105:
              {
                'ts': 891770400,
                'time': '1998-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          106:
              {
                'ts': 909306000,
                'time': '1998-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          107:
              {
                'ts': 923220000,
                'time': '1999-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          108:
              {
                'ts': 941360400,
                'time': '1999-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          109:
              {
                'ts': 954669600,
                'time': '2000-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          110:
              {
                'ts': 972810000,
                'time': '2000-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          111:
              {
                'ts': 986119200,
                'time': '2001-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          112:
              {
                'ts': 1004259600,
                'time': '2001-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          113:
              {
                'ts': 1018173600,
                'time': '2002-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          114:
              {
                'ts': 1035709200,
                'time': '2002-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          115:
              {
                'ts': 1049623200,
                'time': '2003-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          116:
              {
                'ts': 1067158800,
                'time': '2003-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          117:
              {
                'ts': 1081072800,
                'time': '2004-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          118:
              {
                'ts': 1099213200,
                'time': '2004-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          119:
              {
                'ts': 1112522400,
                'time': '2005-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          120:
              {
                'ts': 1130662800,
                'time': '2005-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          121:
              {
                'ts': 1143972000,
                'time': '2006-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          122:
              {
                'ts': 1162112400,
                'time': '2006-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          123:
              {
                'ts': 1173607200,
                'time': '2007-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          124:
              {
                'ts': 1194166800,
                'time': '2007-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          125:
              {
                'ts': 1205056800,
                'time': '2008-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          126:
              {
                'ts': 1225616400,
                'time': '2008-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          127:
              {
                'ts': 1236506400,
                'time': '2009-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          128:
              {
                'ts': 1257066000,
                'time': '2009-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          129:
              {
                'ts': 1268560800,
                'time': '2010-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          130:
              {
                'ts': 1289120400,
                'time': '2010-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          131:
              {
                'ts': 1300010400,
                'time': '2011-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          132:
              {
                'ts': 1320570000,
                'time': '2011-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          133:
              {
                'ts': 1331460000,
                'time': '2012-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          134:
              {
                'ts': 1352019600,
                'time': '2012-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          135:
              {
                'ts': 1362909600,
                'time': '2013-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          136:
              {
                'ts': 1383469200,
                'time': '2013-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          137:
              {
                'ts': 1394359200,
                'time': '2014-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          138:
              {
                'ts': 1414918800,
                'time': '2014-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          139:
              {
                'ts': 1425808800,
                'time': '2015-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          140:
              {
                'ts': 1446368400,
                'time': '2015-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          141:
              {
                'ts': 1457863200,
                'time': '2016-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          142:
              {
                'ts': 1478422800,
                'time': '2016-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          143:
              {
                'ts': 1489312800,
                'time': '2017-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          144:
              {
                'ts': 1509872400,
                'time': '2017-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          145:
              {
                'ts': 1520762400,
                'time': '2018-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          146:
              {
                'ts': 1541322000,
                'time': '2018-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          147:
              {
                'ts': 1552212000,
                'time': '2019-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          148:
              {
                'ts': 1572771600,
                'time': '2019-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          149:
              {
                'ts': 1583661600,
                'time': '2020-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          150:
              {
                'ts': 1604221200,
                'time': '2020-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          151:
              {
                'ts': 1615716000,
                'time': '2021-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          152:
              {
                'ts': 1636275600,
                'time': '2021-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          153:
              {
                'ts': 1647165600,
                'time': '2022-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          154:
              {
                'ts': 1667725200,
                'time': '2022-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          155:
              {
                'ts': 1678615200,
                'time': '2023-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          156:
              {
                'ts': 1699174800,
                'time': '2023-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          157:
              {
                'ts': 1710064800,
                'time': '2024-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          158:
              {
                'ts': 1730624400,
                'time': '2024-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          159:
              {
                'ts': 1741514400,
                'time': '2025-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          160:
              {
                'ts': 1762074000,
                'time': '2025-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          161:
              {
                'ts': 1772964000,
                'time': '2026-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          162:
              {
                'ts': 1793523600,
                'time': '2026-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          163:
              {
                'ts': 1805018400,
                'time': '2027-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          164:
              {
                'ts': 1825578000,
                'time': '2027-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          165:
              {
                'ts': 1836468000,
                'time': '2028-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          166:
              {
                'ts': 1857027600,
                'time': '2028-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          167:
              {
                'ts': 1867917600,
                'time': '2029-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          168:
              {
                'ts': 1888477200,
                'time': '2029-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          169:
              {
                'ts': 1899367200,
                'time': '2030-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          170:
              {
                'ts': 1919926800,
                'time': '2030-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          171:
              {
                'ts': 1930816800,
                'time': '2031-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          172:
              {
                'ts': 1951376400,
                'time': '2031-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          173:
              {
                'ts': 1962871200,
                'time': '2032-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          174:
              {
                'ts': 1983430800,
                'time': '2032-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          175:
              {
                'ts': 1994320800,
                'time': '2033-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          176:
              {
                'ts': 2014880400,
                'time': '2033-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          177:
              {
                'ts': 2025770400,
                'time': '2034-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          178:
              {
                'ts': 2046330000,
                'time': '2034-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          179:
              {
                'ts': 2057220000,
                'time': '2035-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          180:
              {
                'ts': 2077779600,
                'time': '2035-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          181:
              {
                'ts': 2088669600,
                'time': '2036-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          182:
              {
                'ts': 2109229200,
                'time': '2036-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          183:
              {
                'ts': 2120119200,
                'time': '2037-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          184:
              {
                'ts': 2140678800,
                'time': '2037-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'US/Pacific-New':
        {
          0:
              {
                'ts': -1633269600,
                'time': '1918-03-31T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          1:
              {
                'ts': -1615129200,
                'time': '1918-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          2:
              {
                'ts': -1601820000,
                'time': '1919-03-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          3:
              {
                'ts': -1583679600,
                'time': '1919-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          4:
              {
                'ts': -880207200,
                'time': '1942-02-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PWT'
              },
          5:
              {
                'ts': -769395600,
                'time': '1945-08-14T23:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PPT'
              },
          6:
              {
                'ts': -765385200,
                'time': '1945-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          7:
              {
                'ts': -687967200,
                'time': '1948-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          8:
              {
                'ts': -662655600,
                'time': '1949-01-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          9:
              {
                'ts': -620834400,
                'time': '1950-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          10:
              {
                'ts': -608137200,
                'time': '1950-09-24T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          11:
              {
                'ts': -589384800,
                'time': '1951-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          12:
              {
                'ts': -576082800,
                'time': '1951-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          13:
              {
                'ts': -557935200,
                'time': '1952-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          14:
              {
                'ts': -544633200,
                'time': '1952-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          15:
              {
                'ts': -526485600,
                'time': '1953-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          16:
              {
                'ts': -513183600,
                'time': '1953-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          17:
              {
                'ts': -495036000,
                'time': '1954-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          18:
              {
                'ts': -481734000,
                'time': '1954-09-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          19:
              {
                'ts': -463586400,
                'time': '1955-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          20:
              {
                'ts': -450284400,
                'time': '1955-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          21:
              {
                'ts': -431532000,
                'time': '1956-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          22:
              {
                'ts': -418230000,
                'time': '1956-09-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          23:
              {
                'ts': -400082400,
                'time': '1957-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          24:
              {
                'ts': -386780400,
                'time': '1957-09-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          25:
              {
                'ts': -368632800,
                'time': '1958-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          26:
              {
                'ts': -355330800,
                'time': '1958-09-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          27:
              {
                'ts': -337183200,
                'time': '1959-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          28:
              {
                'ts': -323881200,
                'time': '1959-09-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          29:
              {
                'ts': -305733600,
                'time': '1960-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          30:
              {
                'ts': -292431600,
                'time': '1960-09-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          31:
              {
                'ts': -273679200,
                'time': '1961-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          32:
              {
                'ts': -260982000,
                'time': '1961-09-24T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          33:
              {
                'ts': -242229600,
                'time': '1962-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          34:
              {
                'ts': -226508400,
                'time': '1962-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          35:
              {
                'ts': -210780000,
                'time': '1963-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          36:
              {
                'ts': -195058800,
                'time': '1963-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          37:
              {
                'ts': -179330400,
                'time': '1964-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          38:
              {
                'ts': -163609200,
                'time': '1964-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          39:
              {
                'ts': -147880800,
                'time': '1965-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          40:
              {
                'ts': -131554800,
                'time': '1965-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          41:
              {
                'ts': -116431200,
                'time': '1966-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          42:
              {
                'ts': -100105200,
                'time': '1966-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          43:
              {
                'ts': -84376800,
                'time': '1967-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          44:
              {
                'ts': -68655600,
                'time': '1967-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          45:
              {
                'ts': -52927200,
                'time': '1968-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          46:
              {
                'ts': -37206000,
                'time': '1968-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          47:
              {
                'ts': -21477600,
                'time': '1969-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          48:
              {
                'ts': -5756400,
                'time': '1969-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          49:
              {
                'ts': 9972000,
                'time': '1970-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          50:
              {
                'ts': 25693200,
                'time': '1970-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          51:
              {
                'ts': 41421600,
                'time': '1971-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          52:
              {
                'ts': 57747600,
                'time': '1971-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          53:
              {
                'ts': 73476000,
                'time': '1972-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          54:
              {
                'ts': 89197200,
                'time': '1972-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          55:
              {
                'ts': 104925600,
                'time': '1973-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          56:
              {
                'ts': 120646800,
                'time': '1973-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          57:
              {
                'ts': 126698400,
                'time': '1974-01-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          58:
              {
                'ts': 152096400,
                'time': '1974-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          59:
              {
                'ts': 162381600,
                'time': '1975-02-23T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          60:
              {
                'ts': 183546000,
                'time': '1975-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          61:
              {
                'ts': 199274400,
                'time': '1976-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          62:
              {
                'ts': 215600400,
                'time': '1976-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          63:
              {
                'ts': 230724000,
                'time': '1977-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          64:
              {
                'ts': 247050000,
                'time': '1977-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          65:
              {
                'ts': 262778400,
                'time': '1978-04-30T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          66:
              {
                'ts': 278499600,
                'time': '1978-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          67:
              {
                'ts': 294228000,
                'time': '1979-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          68:
              {
                'ts': 309949200,
                'time': '1979-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          69:
              {
                'ts': 325677600,
                'time': '1980-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          70:
              {
                'ts': 341398800,
                'time': '1980-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          71:
              {
                'ts': 357127200,
                'time': '1981-04-26T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          72:
              {
                'ts': 372848400,
                'time': '1981-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          73:
              {
                'ts': 388576800,
                'time': '1982-04-25T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          74:
              {
                'ts': 404902800,
                'time': '1982-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          75:
              {
                'ts': 420026400,
                'time': '1983-04-24T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          76:
              {
                'ts': 436352400,
                'time': '1983-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          77:
              {
                'ts': 452080800,
                'time': '1984-04-29T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          78:
              {
                'ts': 467802000,
                'time': '1984-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          79:
              {
                'ts': 483530400,
                'time': '1985-04-28T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          80:
              {
                'ts': 499251600,
                'time': '1985-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          81:
              {
                'ts': 514980000,
                'time': '1986-04-27T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          82:
              {
                'ts': 530701200,
                'time': '1986-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          83:
              {
                'ts': 544615200,
                'time': '1987-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          84:
              {
                'ts': 562150800,
                'time': '1987-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          85:
              {
                'ts': 576064800,
                'time': '1988-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          86:
              {
                'ts': 594205200,
                'time': '1988-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          87:
              {
                'ts': 607514400,
                'time': '1989-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          88:
              {
                'ts': 625654800,
                'time': '1989-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          89:
              {
                'ts': 638964000,
                'time': '1990-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          90:
              {
                'ts': 657104400,
                'time': '1990-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          91:
              {
                'ts': 671018400,
                'time': '1991-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          92:
              {
                'ts': 688554000,
                'time': '1991-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          93:
              {
                'ts': 702468000,
                'time': '1992-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          94:
              {
                'ts': 720003600,
                'time': '1992-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          95:
              {
                'ts': 733917600,
                'time': '1993-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          96:
              {
                'ts': 752058000,
                'time': '1993-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          97:
              {
                'ts': 765367200,
                'time': '1994-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          98:
              {
                'ts': 783507600,
                'time': '1994-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          99:
              {
                'ts': 796816800,
                'time': '1995-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          100:
              {
                'ts': 814957200,
                'time': '1995-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          101:
              {
                'ts': 828871200,
                'time': '1996-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          102:
              {
                'ts': 846406800,
                'time': '1996-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          103:
              {
                'ts': 860320800,
                'time': '1997-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          104:
              {
                'ts': 877856400,
                'time': '1997-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          105:
              {
                'ts': 891770400,
                'time': '1998-04-05T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          106:
              {
                'ts': 909306000,
                'time': '1998-10-25T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          107:
              {
                'ts': 923220000,
                'time': '1999-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          108:
              {
                'ts': 941360400,
                'time': '1999-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          109:
              {
                'ts': 954669600,
                'time': '2000-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          110:
              {
                'ts': 972810000,
                'time': '2000-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          111:
              {
                'ts': 986119200,
                'time': '2001-04-01T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          112:
              {
                'ts': 1004259600,
                'time': '2001-10-28T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          113:
              {
                'ts': 1018173600,
                'time': '2002-04-07T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          114:
              {
                'ts': 1035709200,
                'time': '2002-10-27T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          115:
              {
                'ts': 1049623200,
                'time': '2003-04-06T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          116:
              {
                'ts': 1067158800,
                'time': '2003-10-26T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          117:
              {
                'ts': 1081072800,
                'time': '2004-04-04T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          118:
              {
                'ts': 1099213200,
                'time': '2004-10-31T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          119:
              {
                'ts': 1112522400,
                'time': '2005-04-03T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          120:
              {
                'ts': 1130662800,
                'time': '2005-10-30T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          121:
              {
                'ts': 1143972000,
                'time': '2006-04-02T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          122:
              {
                'ts': 1162112400,
                'time': '2006-10-29T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          123:
              {
                'ts': 1173607200,
                'time': '2007-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          124:
              {
                'ts': 1194166800,
                'time': '2007-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          125:
              {
                'ts': 1205056800,
                'time': '2008-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          126:
              {
                'ts': 1225616400,
                'time': '2008-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          127:
              {
                'ts': 1236506400,
                'time': '2009-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          128:
              {
                'ts': 1257066000,
                'time': '2009-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          129:
              {
                'ts': 1268560800,
                'time': '2010-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          130:
              {
                'ts': 1289120400,
                'time': '2010-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          131:
              {
                'ts': 1300010400,
                'time': '2011-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          132:
              {
                'ts': 1320570000,
                'time': '2011-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          133:
              {
                'ts': 1331460000,
                'time': '2012-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          134:
              {
                'ts': 1352019600,
                'time': '2012-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          135:
              {
                'ts': 1362909600,
                'time': '2013-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          136:
              {
                'ts': 1383469200,
                'time': '2013-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          137:
              {
                'ts': 1394359200,
                'time': '2014-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          138:
              {
                'ts': 1414918800,
                'time': '2014-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          139:
              {
                'ts': 1425808800,
                'time': '2015-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          140:
              {
                'ts': 1446368400,
                'time': '2015-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          141:
              {
                'ts': 1457863200,
                'time': '2016-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          142:
              {
                'ts': 1478422800,
                'time': '2016-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          143:
              {
                'ts': 1489312800,
                'time': '2017-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          144:
              {
                'ts': 1509872400,
                'time': '2017-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          145:
              {
                'ts': 1520762400,
                'time': '2018-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          146:
              {
                'ts': 1541322000,
                'time': '2018-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          147:
              {
                'ts': 1552212000,
                'time': '2019-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          148:
              {
                'ts': 1572771600,
                'time': '2019-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          149:
              {
                'ts': 1583661600,
                'time': '2020-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          150:
              {
                'ts': 1604221200,
                'time': '2020-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          151:
              {
                'ts': 1615716000,
                'time': '2021-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          152:
              {
                'ts': 1636275600,
                'time': '2021-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          153:
              {
                'ts': 1647165600,
                'time': '2022-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          154:
              {
                'ts': 1667725200,
                'time': '2022-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          155:
              {
                'ts': 1678615200,
                'time': '2023-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          156:
              {
                'ts': 1699174800,
                'time': '2023-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          157:
              {
                'ts': 1710064800,
                'time': '2024-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          158:
              {
                'ts': 1730624400,
                'time': '2024-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          159:
              {
                'ts': 1741514400,
                'time': '2025-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          160:
              {
                'ts': 1762074000,
                'time': '2025-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          161:
              {
                'ts': 1772964000,
                'time': '2026-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          162:
              {
                'ts': 1793523600,
                'time': '2026-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          163:
              {
                'ts': 1805018400,
                'time': '2027-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          164:
              {
                'ts': 1825578000,
                'time': '2027-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          165:
              {
                'ts': 1836468000,
                'time': '2028-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          166:
              {
                'ts': 1857027600,
                'time': '2028-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          167:
              {
                'ts': 1867917600,
                'time': '2029-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          168:
              {
                'ts': 1888477200,
                'time': '2029-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          169:
              {
                'ts': 1899367200,
                'time': '2030-03-10T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          170:
              {
                'ts': 1919926800,
                'time': '2030-11-03T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          171:
              {
                'ts': 1930816800,
                'time': '2031-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          172:
              {
                'ts': 1951376400,
                'time': '2031-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          173:
              {
                'ts': 1962871200,
                'time': '2032-03-14T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          174:
              {
                'ts': 1983430800,
                'time': '2032-11-07T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          175:
              {
                'ts': 1994320800,
                'time': '2033-03-13T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          176:
              {
                'ts': 2014880400,
                'time': '2033-11-06T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          177:
              {
                'ts': 2025770400,
                'time': '2034-03-12T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          178:
              {
                'ts': 2046330000,
                'time': '2034-11-05T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          179:
              {
                'ts': 2057220000,
                'time': '2035-03-11T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          180:
              {
                'ts': 2077779600,
                'time': '2035-11-04T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          181:
              {
                'ts': 2088669600,
                'time': '2036-03-09T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          182:
              {
                'ts': 2109229200,
                'time': '2036-11-02T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              },
          183:
              {
                'ts': 2120119200,
                'time': '2037-03-08T10:00:00+0000',
                'offset': -25200,
                'isdst': true,
                'abbr': 'PDT'
              },
          184:
              {
                'ts': 2140678800,
                'time': '2037-11-01T09:00:00+0000',
                'offset': -28800,
                'isdst': false,
                'abbr': 'PST'
              }
        },
    'US/Samoa':
        {
          0:
              {
                'ts': -1861879032,
                'time': '1911-01-01T11:22:48+0000',
                'offset': -41400,
                'isdst': false,
                'abbr': 'SAMT'
              },
          1:
              {
                'ts': -631110600,
                'time': '1950-01-01T11:30:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'NST'
              },
          2:
              {
                'ts': -86878800,
                'time': '1967-04-01T11:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'BST'
              },
          3:
              {
                'ts': 439038000,
                'time': '1983-11-30T11:00:00+0000',
                'offset': -39600,
                'isdst': false,
                'abbr': 'SST'
              }
        },
    'UTC':
        {
        },
    'W-SU':
        {
          0:
              {
                'ts': -1688265000,
                'time': '1916-07-02T21:30:00+0000',
                'offset': 9048,
                'isdst': false,
                'abbr': 'MMT'
              },
          1:
              {
                'ts': -1656819048,
                'time': '1917-07-01T20:29:12+0000',
                'offset': 12648,
                'isdst': true,
                'abbr': 'MST'
              },
          2:
              {
                'ts': -1641353448,
                'time': '1917-12-27T20:29:12+0000',
                'offset': 9048,
                'isdst': false,
                'abbr': 'MMT'
              },
          3:
              {
                'ts': -1627965048,
                'time': '1918-05-31T19:29:12+0000',
                'offset': 16248,
                'isdst': true,
                'abbr': 'MDST'
              },
          4:
              {
                'ts': -1618716648,
                'time': '1918-09-15T20:29:12+0000',
                'offset': 12648,
                'isdst': true,
                'abbr': 'MST'
              },
          5:
              {
                'ts': -1596429048,
                'time': '1919-05-31T19:29:12+0000',
                'offset': 16248,
                'isdst': true,
                'abbr': 'MDST'
              },
          6:
              {
                'ts': -1593829848,
                'time': '1919-06-30T21:29:12+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          7:
              {
                'ts': -1589860800,
                'time': '1919-08-15T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          8:
              {
                'ts': -1542427200,
                'time': '1921-02-14T20:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          9:
              {
                'ts': -1539493200,
                'time': '1921-03-20T19:00:00+0000',
                'offset': 18000,
                'isdst': true,
                'abbr': 'MSD'
              },
          10:
              {
                'ts': -1525323600,
                'time': '1921-08-31T19:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          11:
              {
                'ts': -1522728000,
                'time': '1921-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          12:
              {
                'ts': -1491188400,
                'time': '1922-09-30T21:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          13:
              {
                'ts': -1247536800,
                'time': '1930-06-20T22:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          14:
              {
                'ts': 354920400,
                'time': '1981-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          15:
              {
                'ts': 370728000,
                'time': '1981-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          16:
              {
                'ts': 386456400,
                'time': '1982-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          17:
              {
                'ts': 402264000,
                'time': '1982-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          18:
              {
                'ts': 417992400,
                'time': '1983-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          19:
              {
                'ts': 433800000,
                'time': '1983-09-30T20:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          20:
              {
                'ts': 449614800,
                'time': '1984-03-31T21:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          21:
              {
                'ts': 465346800,
                'time': '1984-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          22:
              {
                'ts': 481071600,
                'time': '1985-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          23:
              {
                'ts': 496796400,
                'time': '1985-09-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          24:
              {
                'ts': 512521200,
                'time': '1986-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          25:
              {
                'ts': 528246000,
                'time': '1986-09-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          26:
              {
                'ts': 543970800,
                'time': '1987-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          27:
              {
                'ts': 559695600,
                'time': '1987-09-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          28:
              {
                'ts': 575420400,
                'time': '1988-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          29:
              {
                'ts': 591145200,
                'time': '1988-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          30:
              {
                'ts': 606870000,
                'time': '1989-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          31:
              {
                'ts': 622594800,
                'time': '1989-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          32:
              {
                'ts': 638319600,
                'time': '1990-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          33:
              {
                'ts': 654649200,
                'time': '1990-09-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          34:
              {
                'ts': 670374000,
                'time': '1991-03-30T23:00:00+0000',
                'offset': 10800,
                'isdst': true,
                'abbr': 'EEST'
              },
          35:
              {
                'ts': 686102400,
                'time': '1991-09-29T00:00:00+0000',
                'offset': 7200,
                'isdst': false,
                'abbr': 'EET'
              },
          36:
              {
                'ts': 695779200,
                'time': '1992-01-19T00:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          37:
              {
                'ts': 701812800,
                'time': '1992-03-28T20:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          38:
              {
                'ts': 717534000,
                'time': '1992-09-26T19:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          39:
              {
                'ts': 733273200,
                'time': '1993-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          40:
              {
                'ts': 748998000,
                'time': '1993-09-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          41:
              {
                'ts': 764722800,
                'time': '1994-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          42:
              {
                'ts': 780447600,
                'time': '1994-09-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          43:
              {
                'ts': 796172400,
                'time': '1995-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          44:
              {
                'ts': 811897200,
                'time': '1995-09-23T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          45:
              {
                'ts': 828226800,
                'time': '1996-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          46:
              {
                'ts': 846370800,
                'time': '1996-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          47:
              {
                'ts': 859676400,
                'time': '1997-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          48:
              {
                'ts': 877820400,
                'time': '1997-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          49:
              {
                'ts': 891126000,
                'time': '1998-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          50:
              {
                'ts': 909270000,
                'time': '1998-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          51:
              {
                'ts': 922575600,
                'time': '1999-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          52:
              {
                'ts': 941324400,
                'time': '1999-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          53:
              {
                'ts': 954025200,
                'time': '2000-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          54:
              {
                'ts': 972774000,
                'time': '2000-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          55:
              {
                'ts': 985474800,
                'time': '2001-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          56:
              {
                'ts': 1004223600,
                'time': '2001-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          57:
              {
                'ts': 1017529200,
                'time': '2002-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          58:
              {
                'ts': 1035673200,
                'time': '2002-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          59:
              {
                'ts': 1048978800,
                'time': '2003-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          60:
              {
                'ts': 1067122800,
                'time': '2003-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          61:
              {
                'ts': 1080428400,
                'time': '2004-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          62:
              {
                'ts': 1099177200,
                'time': '2004-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          63:
              {
                'ts': 1111878000,
                'time': '2005-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          64:
              {
                'ts': 1130626800,
                'time': '2005-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          65:
              {
                'ts': 1143327600,
                'time': '2006-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          66:
              {
                'ts': 1162076400,
                'time': '2006-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          67:
              {
                'ts': 1174777200,
                'time': '2007-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          68:
              {
                'ts': 1193526000,
                'time': '2007-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          69:
              {
                'ts': 1206831600,
                'time': '2008-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          70:
              {
                'ts': 1224975600,
                'time': '2008-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          71:
              {
                'ts': 1238281200,
                'time': '2009-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          72:
              {
                'ts': 1256425200,
                'time': '2009-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          73:
              {
                'ts': 1269730800,
                'time': '2010-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          74:
              {
                'ts': 1288479600,
                'time': '2010-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          75:
              {
                'ts': 1301180400,
                'time': '2011-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          76:
              {
                'ts': 1319929200,
                'time': '2011-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          77:
              {
                'ts': 1332630000,
                'time': '2012-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          78:
              {
                'ts': 1351378800,
                'time': '2012-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          79:
              {
                'ts': 1364684400,
                'time': '2013-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          80:
              {
                'ts': 1382828400,
                'time': '2013-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          81:
              {
                'ts': 1396134000,
                'time': '2014-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          82:
              {
                'ts': 1414278000,
                'time': '2014-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          83:
              {
                'ts': 1427583600,
                'time': '2015-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          84:
              {
                'ts': 1445727600,
                'time': '2015-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          85:
              {
                'ts': 1459033200,
                'time': '2016-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          86:
              {
                'ts': 1477782000,
                'time': '2016-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          87:
              {
                'ts': 1490482800,
                'time': '2017-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          88:
              {
                'ts': 1509231600,
                'time': '2017-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          89:
              {
                'ts': 1521932400,
                'time': '2018-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          90:
              {
                'ts': 1540681200,
                'time': '2018-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          91:
              {
                'ts': 1553986800,
                'time': '2019-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          92:
              {
                'ts': 1572130800,
                'time': '2019-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          93:
              {
                'ts': 1585436400,
                'time': '2020-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          94:
              {
                'ts': 1603580400,
                'time': '2020-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          95:
              {
                'ts': 1616886000,
                'time': '2021-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          96:
              {
                'ts': 1635634800,
                'time': '2021-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          97:
              {
                'ts': 1648335600,
                'time': '2022-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          98:
              {
                'ts': 1667084400,
                'time': '2022-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          99:
              {
                'ts': 1679785200,
                'time': '2023-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          100:
              {
                'ts': 1698534000,
                'time': '2023-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          101:
              {
                'ts': 1711839600,
                'time': '2024-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          102:
              {
                'ts': 1729983600,
                'time': '2024-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          103:
              {
                'ts': 1743289200,
                'time': '2025-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          104:
              {
                'ts': 1761433200,
                'time': '2025-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          105:
              {
                'ts': 1774738800,
                'time': '2026-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          106:
              {
                'ts': 1792882800,
                'time': '2026-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          107:
              {
                'ts': 1806188400,
                'time': '2027-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          108:
              {
                'ts': 1824937200,
                'time': '2027-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          109:
              {
                'ts': 1837638000,
                'time': '2028-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          110:
              {
                'ts': 1856386800,
                'time': '2028-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          111:
              {
                'ts': 1869087600,
                'time': '2029-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          112:
              {
                'ts': 1887836400,
                'time': '2029-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          113:
              {
                'ts': 1901142000,
                'time': '2030-03-30T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          114:
              {
                'ts': 1919286000,
                'time': '2030-10-26T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          115:
              {
                'ts': 1932591600,
                'time': '2031-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          116:
              {
                'ts': 1950735600,
                'time': '2031-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          117:
              {
                'ts': 1964041200,
                'time': '2032-03-27T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          118:
              {
                'ts': 1982790000,
                'time': '2032-10-30T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          119:
              {
                'ts': 1995490800,
                'time': '2033-03-26T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          120:
              {
                'ts': 2014239600,
                'time': '2033-10-29T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          121:
              {
                'ts': 2026940400,
                'time': '2034-03-25T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          122:
              {
                'ts': 2045689200,
                'time': '2034-10-28T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          123:
              {
                'ts': 2058390000,
                'time': '2035-03-24T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          124:
              {
                'ts': 2077138800,
                'time': '2035-10-27T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          125:
              {
                'ts': 2090444400,
                'time': '2036-03-29T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          126:
              {
                'ts': 2108588400,
                'time': '2036-10-25T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              },
          127:
              {
                'ts': 2121894000,
                'time': '2037-03-28T23:00:00+0000',
                'offset': 14400,
                'isdst': true,
                'abbr': 'MSD'
              },
          128:
              {
                'ts': 2140038000,
                'time': '2037-10-24T23:00:00+0000',
                'offset': 10800,
                'isdst': false,
                'abbr': 'MSK'
              }
        },
    'WET':
        {
          0:
              {
                'ts': -1855958901,
                'time': '1911-03-10T23:51:39+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          1:
              {
                'ts': -1689814800,
                'time': '1916-06-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          2:
              {
                'ts': -1680397200,
                'time': '1916-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          3:
              {
                'ts': -1665363600,
                'time': '1917-03-24T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          4:
              {
                'ts': -1648342800,
                'time': '1917-10-07T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          5:
              {
                'ts': -1635123600,
                'time': '1918-03-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          6:
              {
                'ts': -1616893200,
                'time': '1918-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          7:
              {
                'ts': -1604278800,
                'time': '1919-03-01T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          8:
              {
                'ts': -1585443600,
                'time': '1919-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          9:
              {
                'ts': -1574038800,
                'time': '1920-02-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          10:
              {
                'ts': -1552266000,
                'time': '1920-10-23T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          11:
              {
                'ts': -1539997200,
                'time': '1921-03-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          12:
              {
                'ts': -1520557200,
                'time': '1921-10-25T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          13:
              {
                'ts': -1507510800,
                'time': '1922-03-25T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          14:
              {
                'ts': -1490576400,
                'time': '1922-10-07T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          15:
              {
                'ts': -1470618000,
                'time': '1923-05-26T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          16:
              {
                'ts': -1459126800,
                'time': '1923-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          17:
              {
                'ts': -1444006800,
                'time': '1924-03-29T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          18:
              {
                'ts': -1427677200,
                'time': '1924-10-04T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          19:
              {
                'ts': -1411952400,
                'time': '1925-04-04T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          20:
              {
                'ts': -1396227600,
                'time': '1925-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          21:
              {
                'ts': -1379293200,
                'time': '1926-04-17T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          22:
              {
                'ts': -1364778000,
                'time': '1926-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          23:
              {
                'ts': -1348448400,
                'time': '1927-04-09T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          24:
              {
                'ts': -1333328400,
                'time': '1927-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          25:
              {
                'ts': -1316394000,
                'time': '1928-04-14T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          26:
              {
                'ts': -1301274000,
                'time': '1928-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          27:
              {
                'ts': -1284339600,
                'time': '1929-04-20T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          28:
              {
                'ts': -1269824400,
                'time': '1929-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          29:
              {
                'ts': -1253494800,
                'time': '1930-04-12T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          30:
              {
                'ts': -1238374800,
                'time': '1930-10-04T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          31:
              {
                'ts': -1221440400,
                'time': '1931-04-18T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          32:
              {
                'ts': -1206925200,
                'time': '1931-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          33:
              {
                'ts': -1191200400,
                'time': '1932-04-02T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          34:
              {
                'ts': -1175475600,
                'time': '1932-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          35:
              {
                'ts': -1160355600,
                'time': '1933-03-25T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          36:
              {
                'ts': -1143421200,
                'time': '1933-10-07T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          37:
              {
                'ts': -1127696400,
                'time': '1934-04-07T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          38:
              {
                'ts': -1111971600,
                'time': '1934-10-06T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          39:
              {
                'ts': -1096851600,
                'time': '1935-03-30T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          40:
              {
                'ts': -1080522000,
                'time': '1935-10-05T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          41:
              {
                'ts': -1063587600,
                'time': '1936-04-18T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          42:
              {
                'ts': -1049072400,
                'time': '1936-10-03T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          43:
              {
                'ts': -1033347600,
                'time': '1937-04-03T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          44:
              {
                'ts': -1017622800,
                'time': '1937-10-02T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          45:
              {
                'ts': -1002502800,
                'time': '1938-03-26T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          46:
              {
                'ts': -986173200,
                'time': '1938-10-01T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          47:
              {
                'ts': -969238800,
                'time': '1939-04-15T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          48:
              {
                'ts': -950490000,
                'time': '1939-11-18T23:00:00+0000',
                'offset': 0,
                'isdst': false,
                'abbr': 'WET'
              },
          49:
              {
                'ts': -942012000,
                'time': '1940-02-25T02:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          50:
              {
                'ts': -932436000,
                'time': '1940-06-14T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          51:
              {
                'ts': -857257200,
                'time': '1942-11-02T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          52:
              {
                'ts': -844556400,
                'time': '1943-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          53:
              {
                'ts': -828226800,
                'time': '1943-10-04T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          54:
              {
                'ts': -812502000,
                'time': '1944-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          55:
              {
                'ts': -800071200,
                'time': '1944-08-24T22:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          56:
              {
                'ts': -796266000,
                'time': '1944-10-07T23:00:00+0000',
                'offset': 3600,
                'isdst': true,
                'abbr': 'WEST'
              },
          57:
              {
                'ts': -781052400,
                'time': '1945-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'WEMT'
              },
          58:
              {
                'ts': -766623600,
                'time': '1945-09-16T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          59:
              {
                'ts': 196819200,
                'time': '1976-03-28T00:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          60:
              {
                'ts': 212540400,
                'time': '1976-09-25T23:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          61:
              {
                'ts': 228877200,
                'time': '1977-04-03T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          62:
              {
                'ts': 243997200,
                'time': '1977-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          63:
              {
                'ts': 260326800,
                'time': '1978-04-02T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          64:
              {
                'ts': 276051600,
                'time': '1978-10-01T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          65:
              {
                'ts': 291776400,
                'time': '1979-04-01T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          66:
              {
                'ts': 307501200,
                'time': '1979-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          67:
              {
                'ts': 323830800,
                'time': '1980-04-06T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          68:
              {
                'ts': 338950800,
                'time': '1980-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          69:
              {
                'ts': 354675600,
                'time': '1981-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          70:
              {
                'ts': 370400400,
                'time': '1981-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          71:
              {
                'ts': 386125200,
                'time': '1982-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          72:
              {
                'ts': 401850000,
                'time': '1982-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          73:
              {
                'ts': 417574800,
                'time': '1983-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          74:
              {
                'ts': 433299600,
                'time': '1983-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          75:
              {
                'ts': 449024400,
                'time': '1984-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          76:
              {
                'ts': 465354000,
                'time': '1984-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          77:
              {
                'ts': 481078800,
                'time': '1985-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          78:
              {
                'ts': 496803600,
                'time': '1985-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          79:
              {
                'ts': 512528400,
                'time': '1986-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          80:
              {
                'ts': 528253200,
                'time': '1986-09-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          81:
              {
                'ts': 543978000,
                'time': '1987-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          82:
              {
                'ts': 559702800,
                'time': '1987-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          83:
              {
                'ts': 575427600,
                'time': '1988-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          84:
              {
                'ts': 591152400,
                'time': '1988-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          85:
              {
                'ts': 606877200,
                'time': '1989-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          86:
              {
                'ts': 622602000,
                'time': '1989-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          87:
              {
                'ts': 638326800,
                'time': '1990-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          88:
              {
                'ts': 654656400,
                'time': '1990-09-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          89:
              {
                'ts': 670381200,
                'time': '1991-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          90:
              {
                'ts': 686106000,
                'time': '1991-09-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          91:
              {
                'ts': 701830800,
                'time': '1992-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          92:
              {
                'ts': 717555600,
                'time': '1992-09-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          93:
              {
                'ts': 733280400,
                'time': '1993-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          94:
              {
                'ts': 749005200,
                'time': '1993-09-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          95:
              {
                'ts': 764730000,
                'time': '1994-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          96:
              {
                'ts': 780454800,
                'time': '1994-09-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          97:
              {
                'ts': 796179600,
                'time': '1995-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          98:
              {
                'ts': 811904400,
                'time': '1995-09-24T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          99:
              {
                'ts': 828234000,
                'time': '1996-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          100:
              {
                'ts': 846378000,
                'time': '1996-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          101:
              {
                'ts': 859683600,
                'time': '1997-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          102:
              {
                'ts': 877827600,
                'time': '1997-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          103:
              {
                'ts': 891133200,
                'time': '1998-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          104:
              {
                'ts': 909277200,
                'time': '1998-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          105:
              {
                'ts': 922582800,
                'time': '1999-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          106:
              {
                'ts': 941331600,
                'time': '1999-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          107:
              {
                'ts': 954032400,
                'time': '2000-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          108:
              {
                'ts': 972781200,
                'time': '2000-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          109:
              {
                'ts': 985482000,
                'time': '2001-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          110:
              {
                'ts': 1004230800,
                'time': '2001-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          111:
              {
                'ts': 1017536400,
                'time': '2002-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          112:
              {
                'ts': 1035680400,
                'time': '2002-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          113:
              {
                'ts': 1048986000,
                'time': '2003-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          114:
              {
                'ts': 1067130000,
                'time': '2003-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          115:
              {
                'ts': 1080435600,
                'time': '2004-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          116:
              {
                'ts': 1099184400,
                'time': '2004-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          117:
              {
                'ts': 1111885200,
                'time': '2005-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          118:
              {
                'ts': 1130634000,
                'time': '2005-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          119:
              {
                'ts': 1143334800,
                'time': '2006-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          120:
              {
                'ts': 1162083600,
                'time': '2006-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          121:
              {
                'ts': 1174784400,
                'time': '2007-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          122:
              {
                'ts': 1193533200,
                'time': '2007-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          123:
              {
                'ts': 1206838800,
                'time': '2008-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          124:
              {
                'ts': 1224982800,
                'time': '2008-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          125:
              {
                'ts': 1238288400,
                'time': '2009-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          126:
              {
                'ts': 1256432400,
                'time': '2009-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          127:
              {
                'ts': 1269738000,
                'time': '2010-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          128:
              {
                'ts': 1288486800,
                'time': '2010-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          129:
              {
                'ts': 1301187600,
                'time': '2011-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          130:
              {
                'ts': 1319936400,
                'time': '2011-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          131:
              {
                'ts': 1332637200,
                'time': '2012-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          132:
              {
                'ts': 1351386000,
                'time': '2012-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          133:
              {
                'ts': 1364691600,
                'time': '2013-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          134:
              {
                'ts': 1382835600,
                'time': '2013-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          135:
              {
                'ts': 1396141200,
                'time': '2014-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          136:
              {
                'ts': 1414285200,
                'time': '2014-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          137:
              {
                'ts': 1427590800,
                'time': '2015-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          138:
              {
                'ts': 1445734800,
                'time': '2015-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          139:
              {
                'ts': 1459040400,
                'time': '2016-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          140:
              {
                'ts': 1477789200,
                'time': '2016-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          141:
              {
                'ts': 1490490000,
                'time': '2017-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          142:
              {
                'ts': 1509238800,
                'time': '2017-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          143:
              {
                'ts': 1521939600,
                'time': '2018-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          144:
              {
                'ts': 1540688400,
                'time': '2018-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          145:
              {
                'ts': 1553994000,
                'time': '2019-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          146:
              {
                'ts': 1572138000,
                'time': '2019-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          147:
              {
                'ts': 1585443600,
                'time': '2020-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          148:
              {
                'ts': 1603587600,
                'time': '2020-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          149:
              {
                'ts': 1616893200,
                'time': '2021-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          150:
              {
                'ts': 1635642000,
                'time': '2021-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          151:
              {
                'ts': 1648342800,
                'time': '2022-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          152:
              {
                'ts': 1667091600,
                'time': '2022-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          153:
              {
                'ts': 1679792400,
                'time': '2023-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          154:
              {
                'ts': 1698541200,
                'time': '2023-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          155:
              {
                'ts': 1711846800,
                'time': '2024-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          156:
              {
                'ts': 1729990800,
                'time': '2024-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          157:
              {
                'ts': 1743296400,
                'time': '2025-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          158:
              {
                'ts': 1761440400,
                'time': '2025-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          159:
              {
                'ts': 1774746000,
                'time': '2026-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          160:
              {
                'ts': 1792890000,
                'time': '2026-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          161:
              {
                'ts': 1806195600,
                'time': '2027-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          162:
              {
                'ts': 1824944400,
                'time': '2027-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          163:
              {
                'ts': 1837645200,
                'time': '2028-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          164:
              {
                'ts': 1856394000,
                'time': '2028-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          165:
              {
                'ts': 1869094800,
                'time': '2029-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          166:
              {
                'ts': 1887843600,
                'time': '2029-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          167:
              {
                'ts': 1901149200,
                'time': '2030-03-31T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          168:
              {
                'ts': 1919293200,
                'time': '2030-10-27T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          169:
              {
                'ts': 1932598800,
                'time': '2031-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          170:
              {
                'ts': 1950742800,
                'time': '2031-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          171:
              {
                'ts': 1964048400,
                'time': '2032-03-28T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          172:
              {
                'ts': 1982797200,
                'time': '2032-10-31T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          173:
              {
                'ts': 1995498000,
                'time': '2033-03-27T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          174:
              {
                'ts': 2014246800,
                'time': '2033-10-30T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          175:
              {
                'ts': 2026947600,
                'time': '2034-03-26T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          176:
              {
                'ts': 2045696400,
                'time': '2034-10-29T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          177:
              {
                'ts': 2058397200,
                'time': '2035-03-25T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          178:
              {
                'ts': 2077146000,
                'time': '2035-10-28T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          179:
              {
                'ts': 2090451600,
                'time': '2036-03-30T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          180:
              {
                'ts': 2108595600,
                'time': '2036-10-26T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              },
          181:
              {
                'ts': 2121901200,
                'time': '2037-03-29T01:00:00+0000',
                'offset': 7200,
                'isdst': true,
                'abbr': 'CEST'
              },
          182:
              {
                'ts': 2140045200,
                'time': '2037-10-25T01:00:00+0000',
                'offset': 3600,
                'isdst': false,
                'abbr': 'CET'
              }
        },
    'Zulu':
        {
        }

  };
  return obj[dtzObj.getName()];
}
